/* Copyright (C) 2009 Mobile Sorcery AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

/**
* Returns the hyperbolic sine of x.
* \param x An angle in radians.
*/
double sinh(in double x);
/**
* Returns the hyperbolic cosine of x.
* \param x An angle in radians.
*/
double cosh(in double x);
/**
* Returns the hyperbolic tangent of x.
* \param x An angle in radians.
*/
double tanh(in double x);
/**
* Returns the arc cosine of x.
* \param x A value in the range [-1,1].
*/
double acos(in double x);
/**
* Returns the arc sine of x.
* \param x A value in the range [-1,1].
*/
double asin(in double x);
/**
* Returns the arc tangent of x.
*/
double atan(in double x);
/**
* Returns the arc tangent of y/x in the correct quadrant.
*/
double atan2(in double y, in double x);
/**
* Returns the hyperbolic arctangent of x.
*/
double atanh(in double x);
/**
* Returns x to the y:th power.
*/
double pow(in double x, in double y);
/**
* Returns the natural logarithm of x.
*/
double log(in double x);
