
DROP TABLE IF EXISTS `vendor`;
CREATE TABLE `vendor` (`id` int unsigned NOT NULL,`name` varchar(50) NOT NULL,PRIMARY KEY (`id`));

DROP TABLE IF EXISTS `platform`;
CREATE TABLE `platform` (`id` int unsigned NOT NULL,`name` varchar(50) NOT NULL,PRIMARY KEY (`id`));

DROP TABLE IF EXISTS `platformversion`;
CREATE TABLE `platformversion` (`id` int unsigned NOT NULL,`name` varchar(50) NOT NULL,`platform` int unsigned NOT NULL,PRIMARY KEY (`id`),FOREIGN KEY(platform) REFERENCES platform(id));

DROP TABLE IF EXISTS `device`;
CREATE TABLE `device` (`id` int unsigned NOT NULL,`name` varchar(50) NOT NULL,`vendor` int unsigned NOT NULL,`platformversion` int unsigned NOT NULL,PRIMARY KEY (`id`),FOREIGN KEY(vendor) REFERENCES vendor(id),FOREIGN KEY(platformversion) REFERENCES platformversion(id));


DROP TABLE IF EXISTS `cap`;
CREATE TABLE `cap` (`id` int unsigned NOT NULL,`name` varchar(50) NOT NULL,`platform` int unsigned NOT NULL,PRIMARY KEY (`id`),FOREIGN KEY(platform) REFERENCES platform(id));

DROP TABLE IF EXISTS `capvalue`;
CREATE TABLE `capvalue` (`id` int unsigned NOT NULL,`value` varchar(200) NOT NULL,PRIMARY KEY (`id`));


DROP TABLE IF EXISTS `mosynccap`;
CREATE TABLE `mosynccap` (`id` int unsigned NOT NULL,`name` varchar(50) NOT NULL,PRIMARY KEY (`id`));

DROP TABLE IF EXISTS `mosynccapcap`;
CREATE TABLE `mosynccapcap` (`id` int unsigned NOT NULL,`mosynccap` int unsigned NOT NULL,`cap` int unsigned NOT NULL,PRIMARY KEY (`id`),FOREIGN KEY(mosynccap) REFERENCES mosynccap(id),FOREIGN KEY(cap) REFERENCES cap(id));

DROP TABLE IF EXISTS `devicecapvalue`;
CREATE TABLE `devicecapvalue` (`id` int unsigned NOT NULL,`device` int unsigned NOT NULL,`cap` int unsigned NOT NULL,`capvalue` int unsigned NOT NULL,PRIMARY KEY (`id`),FOREIGN KEY(device) REFERENCES device(id),FOREIGN KEY(cap) REFERENCES cap(id),FOREIGN KEY(capvalue) REFERENCES capvalue(id));
BEGIN;
INSERT INTO 'vendor' VALUES (1, 'Acer');
INSERT INTO 'vendor' VALUES (2, 'Alcatel');
INSERT INTO 'vendor' VALUES (3, 'BenQ');
INSERT INTO 'vendor' VALUES (4, 'BlackBerry');
INSERT INTO 'vendor' VALUES (5, 'Dell');
INSERT INTO 'vendor' VALUES (6, 'Generic');
INSERT INTO 'vendor' VALUES (7, 'Gigabyte');
INSERT INTO 'vendor' VALUES (8, 'Google');
INSERT INTO 'vendor' VALUES (9, 'HTC');
INSERT INTO 'vendor' VALUES (10, 'Huawei');
INSERT INTO 'vendor' VALUES (11, 'Imate');
INSERT INTO 'vendor' VALUES (12, 'LG');
INSERT INTO 'vendor' VALUES (13, 'MicroEmulator');
INSERT INTO 'vendor' VALUES (14, 'Mio');
INSERT INTO 'vendor' VALUES (15, 'MobileSorcery');
INSERT INTO 'vendor' VALUES (16, 'Moblin');
INSERT INTO 'vendor' VALUES (17, 'Motorola');
INSERT INTO 'vendor' VALUES (18, 'NEC');
INSERT INTO 'vendor' VALUES (19, 'Native');
INSERT INTO 'vendor' VALUES (20, 'Nokia');
INSERT INTO 'vendor' VALUES (21, 'O2');
INSERT INTO 'vendor' VALUES (22, 'Palm');
INSERT INTO 'vendor' VALUES (23, 'Qtek');
INSERT INTO 'vendor' VALUES (24, 'Sagem');
INSERT INTO 'vendor' VALUES (25, 'Samsung');
INSERT INTO 'vendor' VALUES (26, 'Sharp');
INSERT INTO 'vendor' VALUES (27, 'Siemens');
INSERT INTO 'vendor' VALUES (28, 'Sony-Ericsson');
INSERT INTO 'vendor' VALUES (29, 'T-Mobile');
INSERT INTO 'vendor' VALUES (30, 'Verizon');
INSERT INTO 'vendor' VALUES (31, 'Vertu');
INSERT INTO 'vendor' VALUES (32, 'Vobis');
INSERT INTO 'vendor' VALUES (33, 'Vodafone');
COMMIT;
BEGIN;
INSERT INTO 'platform' VALUES (1, 'wm6pro');
INSERT INTO 'platformversion' VALUES (1, 'wm6pro', 1);
INSERT INTO 'device' VALUES (1, 'E101', 1, 1);
INSERT INTO 'platform' VALUES (2, 'android');
INSERT INTO 'platformversion' VALUES (2, '1.6', 2);
INSERT INTO 'device' VALUES (2, 'Liquid A1 S100', 1, 2);
INSERT INTO 'platform' VALUES (3, 'JavaME');
INSERT INTO 'platformversion' VALUES (3, '', 3);
INSERT INTO 'device' VALUES (3, 'OT-800A', 2, 3);
INSERT INTO 'device' VALUES (4, 'One Touch 735i', 2, 3);
INSERT INTO 'device' VALUES (5, 'One Touch 756', 2, 3);
INSERT INTO 'device' VALUES (6, 'C81', 3, 3);
INSERT INTO 'device' VALUES (7, 'T80', 3, 3);
INSERT INTO 'device' VALUES (8, '4.0', 4, 3);
INSERT INTO 'device' VALUES (9, '4.1', 4, 3);
INSERT INTO 'device' VALUES (10, '4.2', 4, 3);
INSERT INTO 'device' VALUES (11, '4.2TrackBall', 4, 3);
INSERT INTO 'device' VALUES (12, '4.3', 4, 3);
INSERT INTO 'device' VALUES (13, '4.5', 4, 3);
INSERT INTO 'device' VALUES (14, '4.6', 4, 3);
INSERT INTO 'device' VALUES (15, '4.7', 4, 3);
INSERT INTO 'device' VALUES (16, '5.0', 4, 3);
INSERT INTO 'device' VALUES (17, '7100t', 4, 3);
INSERT INTO 'device' VALUES (18, '7130g', 4, 3);
INSERT INTO 'device' VALUES (19, '7290', 4, 3);
INSERT INTO 'device' VALUES (20, '7520', 4, 3);
INSERT INTO 'device' VALUES (21, '8100', 4, 3);
INSERT INTO 'device' VALUES (22, '8120', 4, 3);
INSERT INTO 'device' VALUES (23, '8130', 4, 3);
INSERT INTO 'device' VALUES (24, '8300', 4, 3);
INSERT INTO 'device' VALUES (25, '8310', 4, 3);
INSERT INTO 'device' VALUES (26, '8350', 4, 3);
INSERT INTO 'device' VALUES (27, '8700', 4, 3);
INSERT INTO 'device' VALUES (28, '8707', 4, 3);
INSERT INTO 'device' VALUES (29, '8800', 4, 3);
INSERT INTO 'device' VALUES (30, '8830', 4, 3);
INSERT INTO 'device' VALUES (31, '8900', 4, 3);
INSERT INTO 'device' VALUES (32, '9000', 4, 3);
INSERT INTO 'device' VALUES (33, '9500', 4, 3);
INSERT INTO 'device' VALUES (34, 'Bold', 4, 3);
INSERT INTO 'device' VALUES (35, 'Curve', 4, 3);
INSERT INTO 'device' VALUES (36, 'Pearl', 4, 3);
INSERT INTO 'device' VALUES (37, 'Storm', 4, 3);
INSERT INTO 'platformversion' VALUES (4, '1.5', 2);
INSERT INTO 'device' VALUES (38, 'Mini 5', 5, 4);
INSERT INTO 'device' VALUES (39, 'AnyMsaBasicPhone', 6, 3);
INSERT INTO 'device' VALUES (40, 'AnyMsaBasicPhone_240x320', 6, 3);
INSERT INTO 'device' VALUES (41, 'AnyMsaBasicPhone_320x240', 6, 3);
INSERT INTO 'device' VALUES (42, 'AnyMsaBasicPhone_352x416', 6, 3);
INSERT INTO 'device' VALUES (43, 'AnyMsaPhone', 6, 3);
INSERT INTO 'device' VALUES (44, 'AnyMsaPhone_240x320', 6, 3);
INSERT INTO 'device' VALUES (45, 'AnyMsaPhone_320x240', 6, 3);
INSERT INTO 'device' VALUES (46, 'AnyMsaPhone_352x416', 6, 3);
INSERT INTO 'device' VALUES (47, 'AnyPhone', 6, 3);
INSERT INTO 'device' VALUES (48, 'AnyPhone_128x128', 6, 3);
INSERT INTO 'device' VALUES (49, 'AnyPhone_128x128_CLDC10', 6, 3);
INSERT INTO 'device' VALUES (50, 'AnyPhone_128x160', 6, 3);
INSERT INTO 'device' VALUES (51, 'AnyPhone_128x160_CLDC10', 6, 3);
INSERT INTO 'device' VALUES (52, 'AnyPhone_176x208', 6, 3);
INSERT INTO 'device' VALUES (53, 'AnyPhone_176x208_CLDC10', 6, 3);
INSERT INTO 'device' VALUES (54, 'AnyPhone_176x220', 6, 3);
INSERT INTO 'device' VALUES (55, 'AnyPhone_208x208', 6, 3);
INSERT INTO 'device' VALUES (56, 'AnyPhone_240x320', 6, 3);
INSERT INTO 'device' VALUES (57, 'AnyPhone_320x240', 6, 3);
INSERT INTO 'device' VALUES (58, 'AnyPhone_352x416', 6, 3);
INSERT INTO 'device' VALUES (59, 'DefaultColorPhone', 6, 3);
INSERT INTO 'device' VALUES (60, 'DefaultGrayPhone', 6, 3);
INSERT INTO 'platform' VALUES (4, 'wm5');
INSERT INTO 'platformversion' VALUES (5, '', 4);
INSERT INTO 'device' VALUES (61, 'DotNetCF1.1', 6, 5);
INSERT INTO 'device' VALUES (62, 'Java', 6, 3);
INSERT INTO 'device' VALUES (63, 'JtwiCldc11', 6, 3);
INSERT INTO 'device' VALUES (64, 'MediaControlSkin', 6, 3);
INSERT INTO 'device' VALUES (65, 'Midp2Cldc11', 6, 3);
INSERT INTO 'device' VALUES (66, 'Midp2Cldc11Pointer', 6, 3);
INSERT INTO 'device' VALUES (67, 'MppPhone', 6, 3);
INSERT INTO 'device' VALUES (68, 'PlainMidp2', 6, 3);
INSERT INTO 'device' VALUES (69, 'PlainMidp2Cldc11', 6, 3);
INSERT INTO 'device' VALUES (70, 'QwertyDevice', 6, 3);
INSERT INTO 'device' VALUES (71, 'SoftKeyPhone', 6, 3);
INSERT INTO 'device' VALUES (72, 'android', 6, 4);
INSERT INTO 'platformversion' VALUES (6, '1.1', 2);
INSERT INTO 'device' VALUES (73, 'android1.1', 6, 6);
INSERT INTO 'device' VALUES (74, 'android1.1_HVGA', 6, 6);
INSERT INTO 'device' VALUES (75, 'android1.1_HVGA_L', 6, 6);
INSERT INTO 'device' VALUES (76, 'android1.1_HVGA_P', 6, 6);
INSERT INTO 'device' VALUES (77, 'android1.1_QVGA_L', 6, 6);
INSERT INTO 'device' VALUES (78, 'android1.1_QVGA_P', 6, 6);
INSERT INTO 'device' VALUES (79, 'android1.5', 6, 4);
INSERT INTO 'device' VALUES (80, 'android1.5_HVGA', 6, 4);
INSERT INTO 'device' VALUES (81, 'android1.5_HVGA_L', 6, 4);
INSERT INTO 'device' VALUES (82, 'android1.5_HVGA_P', 6, 4);
INSERT INTO 'device' VALUES (83, 'android1.5_QVGA_L', 6, 4);
INSERT INTO 'device' VALUES (84, 'android1.5_QVGA_P', 6, 4);
INSERT INTO 'device' VALUES (85, 'android_HVGA', 6, 4);
INSERT INTO 'device' VALUES (86, 'android_HVGA_L', 6, 4);
INSERT INTO 'device' VALUES (87, 'android_HVGA_P', 6, 4);
INSERT INTO 'device' VALUES (88, 'android_QVGA_L', 6, 4);
INSERT INTO 'device' VALUES (89, 'android_QVGA_P', 6, 4);
INSERT INTO 'device' VALUES (90, 'jsr185', 6, 3);
INSERT INTO 'device' VALUES (91, 'jtwi', 6, 3);
INSERT INTO 'device' VALUES (92, 'midp2', 6, 3);
INSERT INTO 'device' VALUES (93, 'multi', 6, 3);
INSERT INTO 'device' VALUES (94, 'pda', 6, 3);
INSERT INTO 'device' VALUES (95, 'wmapi20', 6, 3);
INSERT INTO 'device' VALUES (96, 'wtk', 6, 3);
INSERT INTO 'device' VALUES (97, 'g-Smart', 7, 1);
INSERT INTO 'device' VALUES (98, 'NexusOne', 8, 4);
INSERT INTO 'device' VALUES (99, 'Bravo', 9, 4);
INSERT INTO 'device' VALUES (100, 'Diamond', 9, 1);
INSERT INTO 'device' VALUES (101, 'Dream', 9, 4);
INSERT INTO 'device' VALUES (102, 'Droid Eris', 9, 4);
INSERT INTO 'platform' VALUES (5, 'sp2003');
INSERT INTO 'platformversion' VALUES (7, '', 5);
INSERT INTO 'device' VALUES (103, 'Excalibur', 9, 7);
INSERT INTO 'device' VALUES (104, 'G1', 9, 4);
INSERT INTO 'device' VALUES (105, 'G1_1.1', 9, 6);
INSERT INTO 'device' VALUES (106, 'HD2 T8585', 9, 1);
INSERT INTO 'device' VALUES (107, 'Hermes', 9, 5);
INSERT INTO 'device' VALUES (108, 'Hero', 9, 4);
INSERT INTO 'device' VALUES (109, 'Himalaya', 9, 7);
INSERT INTO 'device' VALUES (110, 'Magic', 9, 4);
INSERT INTO 'device' VALUES (111, 'Mega', 9, 1);
INSERT INTO 'device' VALUES (112, 'P3600', 9, 5);
INSERT INTO 'device' VALUES (113, 'P3650', 9, 1);
INSERT INTO 'device' VALUES (114, 'P3700', 9, 1);
INSERT INTO 'device' VALUES (115, 'P4550', 9, 3);
INSERT INTO 'device' VALUES (116, 'Polaris', 9, 1);
INSERT INTO 'device' VALUES (117, 'S620', 9, 7);
INSERT INTO 'device' VALUES (118, 'S621', 9, 7);
INSERT INTO 'platform' VALUES (6, 'wm6');
INSERT INTO 'platformversion' VALUES (8, 'wm6', 6);
INSERT INTO 'device' VALUES (119, 'S720', 9, 8);
INSERT INTO 'device' VALUES (120, 'ST7377', 9, 1);
INSERT INTO 'device' VALUES (121, 'Salsa', 9, 4);
INSERT INTO 'device' VALUES (122, 'Snap', 9, 5);
INSERT INTO 'device' VALUES (123, 'StarTrek', 9, 3);
INSERT INTO 'device' VALUES (124, 'T7272', 9, 3);
INSERT INTO 'device' VALUES (125, 'T8282', 9, 1);
INSERT INTO 'device' VALUES (126, 'Tattoo', 9, 4);
INSERT INTO 'device' VALUES (127, 'Tide', 9, 4);
INSERT INTO 'device' VALUES (128, 'Tilt', 9, 1);
INSERT INTO 'device' VALUES (129, 'Titan', 9, 1);
INSERT INTO 'device' VALUES (130, 'Tornado', 9, 5);
INSERT INTO 'device' VALUES (131, 'Touch2', 9, 1);
INSERT INTO 'device' VALUES (132, 'TouchCruise', 9, 3);
INSERT INTO 'device' VALUES (133, 'TouchPro', 9, 3);
INSERT INTO 'device' VALUES (134, 'Trinity', 9, 5);
INSERT INTO 'device' VALUES (135, 'TyTN', 9, 5);
INSERT INTO 'device' VALUES (136, 'Universal', 9, 3);
INSERT INTO 'device' VALUES (137, 'Vox', 9, 8);
INSERT INTO 'device' VALUES (138, 'Wizard', 9, 5);
INSERT INTO 'device' VALUES (139, 'U8220', 10, 4);
INSERT INTO 'device' VALUES (140, 'Jam', 11, 7);
INSERT INTO 'device' VALUES (141, 'Jamin', 11, 5);
INSERT INTO 'device' VALUES (142, 'JasJar', 11, 5);
INSERT INTO 'device' VALUES (143, 'K-Jam', 11, 5);
INSERT INTO 'device' VALUES (144, 'SP3', 11, 7);
INSERT INTO 'device' VALUES (145, 'SP3K', 11, 7);
INSERT INTO 'device' VALUES (146, 'SP5', 11, 5);
INSERT INTO 'device' VALUES (147, 'CU400', 12, 3);
INSERT INTO 'device' VALUES (148, 'CU500', 12, 3);
INSERT INTO 'device' VALUES (149, 'CU500v', 12, 3);
INSERT INTO 'device' VALUES (150, 'CU515', 12, 3);
INSERT INTO 'device' VALUES (151, 'GM750 Layla', 12, 1);
INSERT INTO 'device' VALUES (152, 'GW620', 12, 4);
INSERT INTO 'device' VALUES (153, 'GW825', 12, 1);
INSERT INTO 'device' VALUES (154, 'HB620T', 12, 3);
INSERT INTO 'device' VALUES (155, 'KC910', 12, 3);
INSERT INTO 'device' VALUES (156, 'KE970', 12, 3);
INSERT INTO 'device' VALUES (157, 'KF300', 12, 3);
INSERT INTO 'device' VALUES (158, 'KG800', 12, 3);
INSERT INTO 'device' VALUES (159, 'KS360', 12, 3);
INSERT INTO 'device' VALUES (160, 'KT520', 12, 3);
INSERT INTO 'device' VALUES (161, 'KU250', 12, 3);
INSERT INTO 'device' VALUES (162, 'KU990', 12, 3);
INSERT INTO 'device' VALUES (163, 'KU990i', 12, 3);
INSERT INTO 'device' VALUES (164, 'LX265', 12, 3);
INSERT INTO 'device' VALUES (165, 'Shiny', 12, 3);
INSERT INTO 'device' VALUES (166, 'TU500', 12, 3);
INSERT INTO 'device' VALUES (167, 'U450', 12, 3);
INSERT INTO 'device' VALUES (168, 'U8138', 12, 3);
INSERT INTO 'device' VALUES (169, 'Emulator', 13, 3);
INSERT INTO 'device' VALUES (170, '8390', 14, 7);
INSERT INTO 'device' VALUES (171, 'Emulator', 15, 3);
INSERT INTO 'platform' VALUES (7, 'moblin');
INSERT INTO 'platformversion' VALUES (9, 'v2', 7);
INSERT INTO 'device' VALUES (172, 'v2 deb', 16, 9);
INSERT INTO 'device' VALUES (173, 'v2 rpm', 16, 9);
INSERT INTO 'device' VALUES (174, 'A1000', 17, 3);
INSERT INTO 'device' VALUES (175, 'A1200', 17, 3);
INSERT INTO 'device' VALUES (176, 'A3100', 17, 3);
INSERT INTO 'device' VALUES (177, 'A630', 17, 3);
INSERT INTO 'device' VALUES (178, 'A728', 17, 3);
INSERT INTO 'device' VALUES (179, 'A760', 17, 3);
INSERT INTO 'device' VALUES (180, 'A780', 17, 3);
INSERT INTO 'device' VALUES (181, 'A845', 17, 3);
INSERT INTO 'device' VALUES (182, 'A910', 17, 3);
INSERT INTO 'device' VALUES (183, 'C261', 17, 3);
INSERT INTO 'device' VALUES (184, 'C380', 17, 3);
INSERT INTO 'device' VALUES (185, 'C650', 17, 3);
INSERT INTO 'device' VALUES (186, 'C975', 17, 3);
INSERT INTO 'device' VALUES (187, 'C980', 17, 3);
INSERT INTO 'device' VALUES (188, 'Devour', 17, 4);
INSERT INTO 'device' VALUES (189, 'E1', 17, 3);
INSERT INTO 'device' VALUES (190, 'E1000', 17, 3);
INSERT INTO 'device' VALUES (191, 'E1070', 17, 3);
INSERT INTO 'device' VALUES (192, 'E2', 17, 3);
INSERT INTO 'device' VALUES (193, 'E398', 17, 3);
INSERT INTO 'device' VALUES (194, 'E398Emulator', 17, 3);
INSERT INTO 'device' VALUES (195, 'E550', 17, 3);
INSERT INTO 'device' VALUES (196, 'E6', 17, 3);
INSERT INTO 'device' VALUES (197, 'E680', 17, 3);
INSERT INTO 'device' VALUES (198, 'E680i', 17, 3);
INSERT INTO 'device' VALUES (199, 'E770', 17, 3);
INSERT INTO 'device' VALUES (200, 'E8', 17, 3);
INSERT INTO 'device' VALUES (201, 'E815', 17, 3);
INSERT INTO 'device' VALUES (202, 'E816', 17, 3);
INSERT INTO 'device' VALUES (203, 'FOMA_M1000', 17, 3);
INSERT INTO 'device' VALUES (204, 'I870', 17, 3);
INSERT INTO 'device' VALUES (205, 'K1', 17, 3);
INSERT INTO 'device' VALUES (206, 'L2', 17, 3);
INSERT INTO 'device' VALUES (207, 'L6', 17, 3);
INSERT INTO 'device' VALUES (208, 'L6i', 17, 3);
INSERT INTO 'device' VALUES (209, 'L7', 17, 3);
INSERT INTO 'device' VALUES (210, 'L7e', 17, 3);
INSERT INTO 'device' VALUES (211, 'L7i', 17, 3);
INSERT INTO 'device' VALUES (212, 'M710', 17, 3);
INSERT INTO 'device' VALUES (213, 'MPx200', 17, 3);
INSERT INTO 'device' VALUES (214, 'MaxxVe', 17, 3);
INSERT INTO 'device' VALUES (215, 'Ming', 17, 3);
INSERT INTO 'device' VALUES (216, 'MotoRazr2V8', 17, 3);
INSERT INTO 'device' VALUES (217, 'Motokrzr_K1', 17, 3);
INSERT INTO 'device' VALUES (218, 'Motorazr-maxx-V6', 17, 3);
INSERT INTO 'device' VALUES (219, 'Motorazr2v8', 17, 3);
INSERT INTO 'device' VALUES (220, 'Motorazr2v9', 17, 3);
INSERT INTO 'device' VALUES (221, 'Motorazr_V3-CLDC1.1', 17, 3);
INSERT INTO 'device' VALUES (222, 'Motorazr_V3e', 17, 3);
INSERT INTO 'device' VALUES (223, 'Motorazr_V3i', 17, 3);
INSERT INTO 'device' VALUES (224, 'Motorazr_V3t', 17, 3);
INSERT INTO 'device' VALUES (225, 'Motorazr_V3x', 17, 3);
INSERT INTO 'device' VALUES (226, 'Motorazr_V3xx', 17, 3);
INSERT INTO 'device' VALUES (227, 'Motorazr_Z8', 17, 3);
INSERT INTO 'device' VALUES (228, 'Motorizr_Z3', 17, 3);
INSERT INTO 'device' VALUES (229, 'MotorokrU9', 17, 3);
INSERT INTO 'device' VALUES (230, 'MotorokrZ6', 17, 3);
INSERT INTO 'device' VALUES (231, 'MotorokrZ6m', 17, 3);
INSERT INTO 'device' VALUES (232, 'Motorokr_E1', 17, 3);
INSERT INTO 'device' VALUES (233, 'Motorokr_E2', 17, 3);
INSERT INTO 'device' VALUES (234, 'Motorokr_E6', 17, 3);
INSERT INTO 'device' VALUES (235, 'Motorokr_E8', 17, 3);
INSERT INTO 'device' VALUES (236, 'Motorokr_W5', 17, 3);
INSERT INTO 'device' VALUES (237, 'Motorokr_Z6', 17, 3);
INSERT INTO 'device' VALUES (238, 'Motoslvr L7e', 17, 3);
INSERT INTO 'device' VALUES (239, 'Motoslvr L7i', 17, 3);
INSERT INTO 'device' VALUES (240, 'Motoslvr L9', 17, 3);
INSERT INTO 'device' VALUES (241, 'Motoslvr_L7', 17, 3);
INSERT INTO 'device' VALUES (242, 'Motoslvr_L7e', 17, 3);
INSERT INTO 'device' VALUES (243, 'Motoslvr_L7i', 17, 3);
INSERT INTO 'device' VALUES (244, 'PEBL-U6', 17, 3);
INSERT INTO 'device' VALUES (245, 'Q', 17, 5);
INSERT INTO 'device' VALUES (246, 'Q8', 17, 3);
INSERT INTO 'device' VALUES (247, 'Q9', 17, 8);
INSERT INTO 'device' VALUES (248, 'Q9c', 17, 3);
INSERT INTO 'device' VALUES (249, 'Q9h', 17, 3);
INSERT INTO 'device' VALUES (250, 'Q9m', 17, 3);
INSERT INTO 'device' VALUES (251, 'ROKR Z6', 17, 3);
INSERT INTO 'device' VALUES (252, 'Razr2V8', 17, 3);
INSERT INTO 'device' VALUES (253, 'Razr2V9', 17, 3);
INSERT INTO 'device' VALUES (254, 'SLVR', 17, 3);
INSERT INTO 'device' VALUES (255, 'T725', 17, 3);
INSERT INTO 'device' VALUES (256, 'V1050', 17, 3);
INSERT INTO 'device' VALUES (257, 'V1100', 17, 3);
INSERT INTO 'device' VALUES (258, 'V180', 17, 3);
INSERT INTO 'device' VALUES (259, 'V195', 17, 3);
INSERT INTO 'device' VALUES (260, 'V197', 17, 3);
INSERT INTO 'device' VALUES (261, 'V220', 17, 3);
INSERT INTO 'device' VALUES (262, 'V3', 17, 3);
INSERT INTO 'device' VALUES (263, 'V3-CLDC1.0', 17, 3);
INSERT INTO 'device' VALUES (264, 'V3-CLDC1.1', 17, 3);
INSERT INTO 'device' VALUES (265, 'V300', 17, 3);
INSERT INTO 'device' VALUES (266, 'V325', 17, 3);
INSERT INTO 'device' VALUES (267, 'V360', 17, 3);
INSERT INTO 'device' VALUES (268, 'V365', 17, 3);
INSERT INTO 'device' VALUES (269, 'V3c', 17, 3);
INSERT INTO 'device' VALUES (270, 'V3e', 17, 3);
INSERT INTO 'device' VALUES (271, 'V3i', 17, 3);
INSERT INTO 'device' VALUES (272, 'V3t', 17, 3);
INSERT INTO 'device' VALUES (273, 'V3x', 17, 3);
INSERT INTO 'device' VALUES (274, 'V3xx', 17, 3);
INSERT INTO 'device' VALUES (275, 'V400', 17, 3);
INSERT INTO 'device' VALUES (276, 'V500', 17, 3);
INSERT INTO 'device' VALUES (277, 'V550', 17, 3);
INSERT INTO 'device' VALUES (278, 'V551', 17, 3);
INSERT INTO 'device' VALUES (279, 'V6', 17, 3);
INSERT INTO 'device' VALUES (280, 'V600', 17, 3);
INSERT INTO 'device' VALUES (281, 'V620', 17, 3);
INSERT INTO 'device' VALUES (282, 'V635', 17, 3);
INSERT INTO 'device' VALUES (283, 'V710', 17, 3);
INSERT INTO 'device' VALUES (284, 'V8', 17, 3);
INSERT INTO 'device' VALUES (285, 'V80', 17, 3);
INSERT INTO 'device' VALUES (286, 'V975', 17, 3);
INSERT INTO 'device' VALUES (287, 'V980', 17, 3);
INSERT INTO 'device' VALUES (288, 'W210', 17, 3);
INSERT INTO 'device' VALUES (289, 'W315', 17, 3);
INSERT INTO 'device' VALUES (290, 'W355', 17, 3);
INSERT INTO 'device' VALUES (291, 'W385', 17, 3);
INSERT INTO 'device' VALUES (292, 'W490', 17, 3);
INSERT INTO 'device' VALUES (293, 'W510', 17, 3);
INSERT INTO 'device' VALUES (294, 'Z3', 17, 3);
INSERT INTO 'device' VALUES (295, 'Z6', 17, 3);
INSERT INTO 'device' VALUES (296, 'Z8', 17, 3);
INSERT INTO 'device' VALUES (297, 'i256', 17, 3);
INSERT INTO 'device' VALUES (298, 'i275', 17, 3);
INSERT INTO 'device' VALUES (299, 'i285', 17, 3);
INSERT INTO 'device' VALUES (300, 'i325', 17, 3);
INSERT INTO 'device' VALUES (301, 'i325is', 17, 3);
INSERT INTO 'device' VALUES (302, 'i355', 17, 3);
INSERT INTO 'device' VALUES (303, 'i560', 17, 3);
INSERT INTO 'device' VALUES (304, 'i580', 17, 3);
INSERT INTO 'device' VALUES (305, 'i605', 17, 3);
INSERT INTO 'device' VALUES (306, 'i615', 17, 3);
INSERT INTO 'device' VALUES (307, 'i670', 17, 3);
INSERT INTO 'device' VALUES (308, 'i710', 17, 3);
INSERT INTO 'device' VALUES (309, 'i730', 17, 3);
INSERT INTO 'device' VALUES (310, 'i760', 17, 3);
INSERT INTO 'device' VALUES (311, 'i830', 17, 3);
INSERT INTO 'device' VALUES (312, 'i833', 17, 3);
INSERT INTO 'device' VALUES (313, 'i850', 17, 3);
INSERT INTO 'device' VALUES (314, 'i855', 17, 3);
INSERT INTO 'device' VALUES (315, 'i860', 17, 3);
INSERT INTO 'device' VALUES (316, 'i875', 17, 3);
INSERT INTO 'device' VALUES (317, 'i930', 17, 3);
INSERT INTO 'device' VALUES (318, 'ic402', 17, 3);
INSERT INTO 'device' VALUES (319, 'ic502', 17, 3);
INSERT INTO 'device' VALUES (320, 'ic602', 17, 3);
INSERT INTO 'device' VALUES (321, 'ic902', 17, 3);
INSERT INTO 'device' VALUES (322, 'E616', 18, 3);
INSERT INTO 'device' VALUES (323, 'WindowsMobile', 19, 3);
INSERT INTO 'device' VALUES (324, 'iPhone', 19, 3);
INSERT INTO 'device' VALUES (325, '1680_classic', 20, 3);
INSERT INTO 'platformversion' VALUES (10, 'Series40DP2', 3);
INSERT INTO 'device' VALUES (326, '2610', 20, 10);
INSERT INTO 'device' VALUES (327, '2626', 20, 10);
INSERT INTO 'device' VALUES (328, '2630', 20, 3);
INSERT INTO 'device' VALUES (329, '2700_classic', 20, 3);
INSERT INTO 'device' VALUES (330, '2760', 20, 3);
INSERT INTO 'device' VALUES (331, '2855', 20, 10);
INSERT INTO 'platformversion' VALUES (11, 'Series40E3', 3);
INSERT INTO 'device' VALUES (332, '2865', 20, 11);
INSERT INTO 'device' VALUES (333, '2865i', 20, 11);
INSERT INTO 'device' VALUES (334, '3110_classic', 20, 3);
INSERT INTO 'device' VALUES (335, '3110c', 20, 3);
INSERT INTO 'platformversion' VALUES (12, 'Series40E5FP1', 3);
INSERT INTO 'device' VALUES (336, '3120c', 20, 12);
INSERT INTO 'device' VALUES (337, '3120classic', 20, 12);
INSERT INTO 'device' VALUES (338, '3152', 20, 10);
INSERT INTO 'device' VALUES (339, '3155', 20, 10);
INSERT INTO 'device' VALUES (340, '3155i', 20, 10);
INSERT INTO 'platformversion' VALUES (13, 'Series40', 3);
INSERT INTO 'device' VALUES (341, '3220', 20, 13);
INSERT INTO 'platform' VALUES (8, 's60v2');
INSERT INTO 'platformversion' VALUES (14, 'Series60E2FP1', 8);
INSERT INTO 'device' VALUES (342, '3230', 20, 14);
INSERT INTO 'device' VALUES (343, '3500_classic', 20, 3);
INSERT INTO 'device' VALUES (344, '3600slide', 20, 12);
INSERT INTO 'device' VALUES (345, '3720_classic', 20, 3);
INSERT INTO 'device' VALUES (346, '5000', 20, 3);
INSERT INTO 'device' VALUES (347, '5070', 20, 10);
INSERT INTO 'device' VALUES (348, '5130_classic', 20, 3);
INSERT INTO 'device' VALUES (349, '5140', 20, 13);
INSERT INTO 'device' VALUES (350, '5140i', 20, 10);
INSERT INTO 'platformversion' VALUES (15, 'Series40E3FP1', 3);
INSERT INTO 'device' VALUES (351, '5200', 20, 15);
INSERT INTO 'device' VALUES (352, '5220_XpressMusic', 20, 3);
INSERT INTO 'platform' VALUES (9, 's60v5');
INSERT INTO 'platformversion' VALUES (16, 'Series60E5', 9);
INSERT INTO 'device' VALUES (353, '5230', 20, 16);
INSERT INTO 'device' VALUES (354, '5235', 20, 16);
INSERT INTO 'platformversion' VALUES (17, 'Series40E3FP2', 3);
INSERT INTO 'device' VALUES (355, '5300', 20, 17);
INSERT INTO 'device' VALUES (356, '5310', 20, 12);
INSERT INTO 'device' VALUES (357, '5310_XpressMusic', 20, 12);
INSERT INTO 'platform' VALUES (10, 's60v3');
INSERT INTO 'platformversion' VALUES (18, 'Series60E3', 10);
INSERT INTO 'device' VALUES (358, '5500', 20, 18);
INSERT INTO 'device' VALUES (359, '5530 XpressMusic', 20, 16);
INSERT INTO 'device' VALUES (360, '5610', 20, 12);
INSERT INTO 'device' VALUES (361, '5610_XpressMusic', 20, 12);
INSERT INTO 'device' VALUES (362, '5630 XpressMusic', 20, 18);
INSERT INTO 'platformversion' VALUES (19, 'Series60E3FP1', 10);
INSERT INTO 'device' VALUES (363, '5700', 20, 19);
INSERT INTO 'device' VALUES (364, '5700_XpressMusic', 20, 19);
INSERT INTO 'device' VALUES (365, '5800', 20, 16);
INSERT INTO 'device' VALUES (366, '6020', 20, 13);
INSERT INTO 'device' VALUES (367, '6021', 20, 10);
INSERT INTO 'device' VALUES (368, '6030', 20, 10);
INSERT INTO 'device' VALUES (369, '6060', 20, 10);
INSERT INTO 'device' VALUES (370, '6070', 20, 10);
INSERT INTO 'device' VALUES (371, '6080', 20, 10);
INSERT INTO 'device' VALUES (372, '6085', 20, 15);
INSERT INTO 'device' VALUES (373, '6086', 20, 15);
INSERT INTO 'device' VALUES (374, '6101', 20, 10);
INSERT INTO 'device' VALUES (375, '6102', 20, 10);
INSERT INTO 'device' VALUES (376, '6102i', 20, 10);
INSERT INTO 'device' VALUES (377, '6103', 20, 10);
INSERT INTO 'device' VALUES (378, '6110', 20, 19);
INSERT INTO 'device' VALUES (379, '6110_Navigator', 20, 19);
INSERT INTO 'device' VALUES (380, '6111', 20, 11);
INSERT INTO 'device' VALUES (381, '6120', 20, 19);
INSERT INTO 'device' VALUES (382, '6120_classic', 20, 19);
INSERT INTO 'device' VALUES (383, '6125', 20, 15);
INSERT INTO 'device' VALUES (384, '6126', 20, 15);
INSERT INTO 'device' VALUES (385, '6131', 20, 15);
INSERT INTO 'device' VALUES (386, '6131_NFC', 20, 15);
INSERT INTO 'device' VALUES (387, '6133', 20, 15);
INSERT INTO 'device' VALUES (388, '6136', 20, 15);
INSERT INTO 'device' VALUES (389, '6151', 20, 15);
INSERT INTO 'device' VALUES (390, '6152', 20, 10);
INSERT INTO 'device' VALUES (391, '6155', 20, 10);
INSERT INTO 'device' VALUES (392, '6155i', 20, 10);
INSERT INTO 'device' VALUES (393, '6165', 20, 11);
INSERT INTO 'device' VALUES (394, '6170', 20, 13);
INSERT INTO 'platformversion' VALUES (20, 'Series60E3FP2', 10);
INSERT INTO 'device' VALUES (395, '6210', 20, 20);
INSERT INTO 'device' VALUES (396, '6210_Navigator', 20, 20);
INSERT INTO 'device' VALUES (397, '6212_classic', 20, 3);
INSERT INTO 'device' VALUES (398, '6230', 20, 13);
INSERT INTO 'device' VALUES (399, '6230i', 20, 10);
INSERT INTO 'device' VALUES (400, '6233', 20, 15);
INSERT INTO 'device' VALUES (401, '6234', 20, 15);
INSERT INTO 'device' VALUES (402, '6235', 20, 13);
INSERT INTO 'device' VALUES (403, '6235i', 20, 13);
INSERT INTO 'device' VALUES (404, '6255', 20, 13);
INSERT INTO 'device' VALUES (405, '6260', 20, 14);
INSERT INTO 'device' VALUES (406, '6265', 20, 11);
INSERT INTO 'device' VALUES (407, '6265i', 20, 11);
INSERT INTO 'device' VALUES (408, '6267', 20, 3);
INSERT INTO 'device' VALUES (409, '6270', 20, 11);
INSERT INTO 'device' VALUES (410, '6275', 20, 11);
INSERT INTO 'device' VALUES (411, '6275i', 20, 11);
INSERT INTO 'device' VALUES (412, '6280', 20, 11);
INSERT INTO 'device' VALUES (413, '6282', 20, 11);
INSERT INTO 'device' VALUES (414, '6288', 20, 11);
INSERT INTO 'device' VALUES (415, '6290', 20, 19);
INSERT INTO 'device' VALUES (416, '6300', 20, 15);
INSERT INTO 'device' VALUES (417, '6301', 20, 3);
INSERT INTO 'device' VALUES (418, '6303_classic', 20, 3);
INSERT INTO 'device' VALUES (419, '6500_classic', 20, 12);
INSERT INTO 'device' VALUES (420, '6500_slide', 20, 12);
INSERT INTO 'device' VALUES (421, '6555', 20, 12);
INSERT INTO 'platformversion' VALUES (21, 'Series60', 3);
INSERT INTO 'device' VALUES (422, '6600', 20, 21);
INSERT INTO 'device' VALUES (423, '6600_fold', 20, 3);
INSERT INTO 'device' VALUES (424, '6600_slide', 20, 3);
INSERT INTO 'device' VALUES (425, '6600i', 20, 3);
INSERT INTO 'device' VALUES (426, '6620', 20, 14);
INSERT INTO 'platformversion' VALUES (22, 'Series60E2FP2', 8);
INSERT INTO 'device' VALUES (427, '6630', 20, 22);
INSERT INTO 'device' VALUES (428, '6670', 20, 14);
INSERT INTO 'device' VALUES (429, '6680', 20, 22);
INSERT INTO 'device' VALUES (430, '6681', 20, 22);
INSERT INTO 'device' VALUES (431, '6682', 20, 22);
INSERT INTO 'device' VALUES (432, '6700_classic', 20, 3);
INSERT INTO 'device' VALUES (433, '6730 classic', 20, 18);
INSERT INTO 'device' VALUES (434, '6760 slide', 20, 18);
INSERT INTO 'device' VALUES (435, '6822', 20, 13);
INSERT INTO 'device' VALUES (436, '7260', 20, 13);
INSERT INTO 'device' VALUES (437, '7270', 20, 13);
INSERT INTO 'device' VALUES (438, '7360', 20, 10);
INSERT INTO 'device' VALUES (439, '7370', 20, 11);
INSERT INTO 'device' VALUES (440, '7373', 20, 17);
INSERT INTO 'device' VALUES (441, '7390', 20, 17);
INSERT INTO 'device' VALUES (442, '7500', 20, 3);
INSERT INTO 'device' VALUES (443, '7510', 20, 3);
INSERT INTO 'device' VALUES (444, '7510_Supernova', 20, 3);
INSERT INTO 'platformversion' VALUES (23, 'Series60E2', 8);
INSERT INTO 'device' VALUES (445, '7610', 20, 23);
INSERT INTO 'platformversion' VALUES (24, 'Series90', 3);
INSERT INTO 'device' VALUES (446, '7700', 20, 24);
INSERT INTO 'device' VALUES (447, '7710', 20, 3);
INSERT INTO 'device' VALUES (448, '7900', 20, 3);
INSERT INTO 'device' VALUES (449, '8800', 20, 10);
INSERT INTO 'device' VALUES (450, '8800_Sirocco_Edition', 20, 15);
INSERT INTO 'device' VALUES (451, '8801', 20, 3);
INSERT INTO 'platformversion' VALUES (25, 'Series80E2', 3);
INSERT INTO 'device' VALUES (452, '9300', 20, 25);
INSERT INTO 'device' VALUES (453, '9300i', 20, 25);
INSERT INTO 'device' VALUES (454, '9500', 20, 25);
INSERT INTO 'device' VALUES (455, 'E50', 20, 18);
INSERT INTO 'device' VALUES (456, 'E51', 20, 19);
INSERT INTO 'device' VALUES (457, 'E55', 20, 3);
INSERT INTO 'device' VALUES (458, 'E60', 20, 18);
INSERT INTO 'device' VALUES (459, 'E61', 20, 18);
INSERT INTO 'device' VALUES (460, 'E61i', 20, 18);
INSERT INTO 'device' VALUES (461, 'E62', 20, 18);
INSERT INTO 'device' VALUES (462, 'E63', 20, 3);
INSERT INTO 'device' VALUES (463, 'E65', 20, 18);
INSERT INTO 'device' VALUES (464, 'E66', 20, 19);
INSERT INTO 'device' VALUES (465, 'E70', 20, 18);
INSERT INTO 'device' VALUES (466, 'E71', 20, 19);
INSERT INTO 'device' VALUES (467, 'E72', 20, 18);
INSERT INTO 'device' VALUES (468, 'E75', 20, 3);
INSERT INTO 'device' VALUES (469, 'E90', 20, 19);
INSERT INTO 'device' VALUES (470, 'E90_Communicator', 20, 19);
INSERT INTO 'platformversion' VALUES (26, 'Nokia-UI', 3);
INSERT INTO 'device' VALUES (471, 'Midp2Cldc11', 20, 26);
INSERT INTO 'device' VALUES (472, 'N3250', 20, 18);
INSERT INTO 'platformversion' VALUES (27, 'Series60E2FP3', 8);
INSERT INTO 'device' VALUES (473, 'N70', 20, 27);
INSERT INTO 'device' VALUES (474, 'N71', 20, 18);
INSERT INTO 'device' VALUES (475, 'N72', 20, 18);
INSERT INTO 'device' VALUES (476, 'N73', 20, 18);
INSERT INTO 'device' VALUES (477, 'N75', 20, 18);
INSERT INTO 'device' VALUES (478, 'N76', 20, 19);
INSERT INTO 'device' VALUES (479, 'N77', 20, 18);
INSERT INTO 'device' VALUES (480, 'N78', 20, 20);
INSERT INTO 'device' VALUES (481, 'N80', 20, 18);
INSERT INTO 'device' VALUES (482, 'N81', 20, 18);
INSERT INTO 'device' VALUES (483, 'N81_8GB', 20, 18);
INSERT INTO 'device' VALUES (484, 'N82', 20, 18);
INSERT INTO 'device' VALUES (485, 'N85', 20, 3);
INSERT INTO 'device' VALUES (486, 'N86 8MP', 20, 18);
INSERT INTO 'device' VALUES (487, 'N90', 20, 27);
INSERT INTO 'device' VALUES (488, 'N91', 20, 18);
INSERT INTO 'device' VALUES (489, 'N91_8GB', 20, 18);
INSERT INTO 'device' VALUES (490, 'N92', 20, 18);
INSERT INTO 'device' VALUES (491, 'N93', 20, 18);
INSERT INTO 'device' VALUES (492, 'N93i', 20, 18);
INSERT INTO 'device' VALUES (493, 'N95', 20, 19);
INSERT INTO 'device' VALUES (494, 'N95_8GB', 20, 19);
INSERT INTO 'device' VALUES (495, 'N97', 20, 16);
INSERT INTO 'device' VALUES (496, 'Series60E2', 20, 23);
INSERT INTO 'device' VALUES (497, 'Series60E2FP1', 20, 23);
INSERT INTO 'device' VALUES (498, 'Series60E2FP2', 20, 22);
INSERT INTO 'device' VALUES (499, 'Series60E2FP3', 20, 27);
INSERT INTO 'device' VALUES (500, 'Series60E3', 20, 18);
INSERT INTO 'device' VALUES (501, 'Series60E3FP1', 20, 19);
INSERT INTO 'device' VALUES (502, 'Series60E3FP2', 20, 20);
INSERT INTO 'device' VALUES (503, 'Series60E5', 20, 16);
INSERT INTO 'device' VALUES (504, 'Series60Midp2', 20, 23);
INSERT INTO 'device' VALUES (505, 'X6', 20, 16);
INSERT INTO 'device' VALUES (506, 'XDAII', 21, 7);
INSERT INTO 'device' VALUES (507, 'XDA_Flame', 21, 3);
INSERT INTO 'device' VALUES (508, 'TX', 22, 3);
INSERT INTO 'device' VALUES (509, 'Treo650', 22, 3);
INSERT INTO 'device' VALUES (510, 'Treo680', 22, 3);
INSERT INTO 'device' VALUES (511, 'Treo700p', 22, 3);
INSERT INTO 'device' VALUES (512, 'Treo700w', 22, 5);
INSERT INTO 'device' VALUES (513, 'Treo700wx', 22, 5);
INSERT INTO 'device' VALUES (514, 'Treo750', 22, 5);
INSERT INTO 'device' VALUES (515, 'Treo755p', 22, 3);
INSERT INTO 'device' VALUES (516, 'TreoPro', 22, 3);
INSERT INTO 'device' VALUES (517, 'TungstenC', 22, 3);
INSERT INTO 'device' VALUES (518, 'TungstenE2', 22, 3);
INSERT INTO 'device' VALUES (519, '8310', 23, 5);
INSERT INTO 'device' VALUES (520, '8500', 23, 3);
INSERT INTO 'device' VALUES (521, '9100', 23, 5);
INSERT INTO 'device' VALUES (522, 'XDAII', 23, 7);
INSERT INTO 'device' VALUES (523, 'My300x', 24, 3);
INSERT INTO 'device' VALUES (524, 'My400x', 24, 3);
INSERT INTO 'device' VALUES (525, 'My700x', 24, 3);
INSERT INTO 'device' VALUES (526, 'MyC4', 24, 3);
INSERT INTO 'device' VALUES (527, 'MyC5-2', 24, 3);
INSERT INTO 'device' VALUES (528, 'MyV-55', 24, 3);
INSERT INTO 'device' VALUES (529, 'MyV-65', 24, 3);
INSERT INTO 'device' VALUES (530, 'MyV-75', 24, 3);
INSERT INTO 'device' VALUES (531, 'MyW-7', 24, 3);
INSERT INTO 'device' VALUES (532, 'MyX-4', 24, 3);
INSERT INTO 'device' VALUES (533, 'MyX-8', 24, 3);
INSERT INTO 'device' VALUES (534, 'MyX5-2', 24, 7);
INSERT INTO 'device' VALUES (535, 'MyX6', 24, 3);
INSERT INTO 'device' VALUES (536, 'MyX6-2', 24, 3);
INSERT INTO 'device' VALUES (537, 'MyX7', 24, 3);
INSERT INTO 'device' VALUES (538, 'MyZ-5', 24, 3);
INSERT INTO 'device' VALUES (539, 'B2100', 25, 3);
INSERT INTO 'device' VALUES (540, 'B2700', 25, 3);
INSERT INTO 'device' VALUES (541, 'Behold', 25, 4);
INSERT INTO 'device' VALUES (542, 'Blackjack', 25, 5);
INSERT INTO 'device' VALUES (543, 'Corby', 25, 3);
INSERT INTO 'device' VALUES (544, 'D410', 25, 3);
INSERT INTO 'device' VALUES (545, 'D415', 25, 3);
INSERT INTO 'device' VALUES (546, 'D418', 25, 3);
INSERT INTO 'device' VALUES (547, 'E105', 25, 3);
INSERT INTO 'device' VALUES (548, 'E300', 25, 3);
INSERT INTO 'device' VALUES (549, 'E310', 25, 3);
INSERT INTO 'device' VALUES (550, 'E370', 25, 3);
INSERT INTO 'device' VALUES (551, 'E380', 25, 3);
INSERT INTO 'device' VALUES (552, 'E600', 25, 3);
INSERT INTO 'device' VALUES (553, 'E710', 25, 3);
INSERT INTO 'device' VALUES (554, 'E715', 25, 3);
INSERT INTO 'device' VALUES (555, 'E810', 25, 3);
INSERT INTO 'device' VALUES (556, 'F330', 25, 3);
INSERT INTO 'device' VALUES (557, 'F400', 25, 3);
INSERT INTO 'device' VALUES (558, 'GT i8000 Omnia ii', 25, 1);
INSERT INTO 'device' VALUES (559, 'GT-S5233S', 25, 3);
INSERT INTO 'device' VALUES (560, 'GT-i7500', 25, 4);
INSERT INTO 'device' VALUES (561, 'GT-i8910 Omnia HD', 25, 16);
INSERT INTO 'device' VALUES (562, 'L760', 25, 3);
INSERT INTO 'device' VALUES (563, 'Moment', 25, 4);
INSERT INTO 'device' VALUES (564, 'P400', 25, 3);
INSERT INTO 'device' VALUES (565, 'P730', 25, 3);
INSERT INTO 'device' VALUES (566, 'P735', 25, 3);
INSERT INTO 'device' VALUES (567, 'S3650', 25, 3);
INSERT INTO 'device' VALUES (568, 'S5230', 25, 3);
INSERT INTO 'device' VALUES (569, 'S8000', 25, 3);
INSERT INTO 'device' VALUES (570, 'S8300', 25, 3);
INSERT INTO 'device' VALUES (571, 'SGH-A700', 25, 3);
INSERT INTO 'device' VALUES (572, 'SGH-B2700', 25, 3);
INSERT INTO 'device' VALUES (573, 'SGH-C130', 25, 3);
INSERT INTO 'device' VALUES (574, 'SGH-D500', 25, 3);
INSERT INTO 'device' VALUES (575, 'SGH-D520', 25, 3);
INSERT INTO 'device' VALUES (576, 'SGH-D600', 25, 3);
INSERT INTO 'device' VALUES (577, 'SGH-D608', 25, 3);
INSERT INTO 'device' VALUES (578, 'SGH-D800', 25, 3);
INSERT INTO 'device' VALUES (579, 'SGH-D820', 25, 3);
INSERT INTO 'device' VALUES (580, 'SGH-D828', 25, 3);
INSERT INTO 'device' VALUES (581, 'SGH-D900', 25, 3);
INSERT INTO 'device' VALUES (582, 'SGH-D908', 25, 3);
INSERT INTO 'device' VALUES (583, 'SGH-E250', 25, 3);
INSERT INTO 'device' VALUES (584, 'SGH-E380', 25, 3);
INSERT INTO 'device' VALUES (585, 'SGH-E388', 25, 3);
INSERT INTO 'device' VALUES (586, 'SGH-E390', 25, 3);
INSERT INTO 'device' VALUES (587, 'SGH-E490', 25, 3);
INSERT INTO 'device' VALUES (588, 'SGH-E500', 25, 3);
INSERT INTO 'device' VALUES (589, 'SGH-E530', 25, 3);
INSERT INTO 'device' VALUES (590, 'SGH-E570', 25, 3);
INSERT INTO 'device' VALUES (591, 'SGH-E600', 25, 3);
INSERT INTO 'device' VALUES (592, 'SGH-E720', 25, 3);
INSERT INTO 'device' VALUES (593, 'SGH-E730', 25, 3);
INSERT INTO 'device' VALUES (594, 'SGH-E760', 25, 3);
INSERT INTO 'device' VALUES (595, 'SGH-E770', 25, 3);
INSERT INTO 'device' VALUES (596, 'SGH-E780', 25, 3);
INSERT INTO 'device' VALUES (597, 'SGH-E788', 25, 3);
INSERT INTO 'device' VALUES (598, 'SGH-E810', 25, 3);
INSERT INTO 'device' VALUES (599, 'SGH-E870', 25, 3);
INSERT INTO 'device' VALUES (600, 'SGH-E898', 25, 3);
INSERT INTO 'device' VALUES (601, 'SGH-E900', 25, 3);
INSERT INTO 'device' VALUES (602, 'SGH-F480', 25, 3);
INSERT INTO 'device' VALUES (603, 'SGH-F700', 25, 3);
INSERT INTO 'device' VALUES (604, 'SGH-F700V', 25, 3);
INSERT INTO 'device' VALUES (605, 'SGH-G800', 25, 3);
INSERT INTO 'device' VALUES (606, 'SGH-G810', 25, 3);
INSERT INTO 'device' VALUES (607, 'SGH-I900', 25, 3);
INSERT INTO 'device' VALUES (608, 'SGH-J200', 25, 3);
INSERT INTO 'device' VALUES (609, 'SGH-J750', 25, 3);
INSERT INTO 'device' VALUES (610, 'SGH-L700', 25, 3);
INSERT INTO 'device' VALUES (611, 'SGH-L760', 25, 3);
INSERT INTO 'device' VALUES (612, 'SGH-M310', 25, 3);
INSERT INTO 'device' VALUES (613, 'SGH-P300', 25, 3);
INSERT INTO 'device' VALUES (614, 'SGH-P310', 25, 3);
INSERT INTO 'device' VALUES (615, 'SGH-P858', 25, 3);
INSERT INTO 'device' VALUES (616, 'SGH-T509', 25, 3);
INSERT INTO 'device' VALUES (617, 'SGH-T609', 25, 3);
INSERT INTO 'device' VALUES (618, 'SGH-T619', 25, 3);
INSERT INTO 'device' VALUES (619, 'SGH-T629', 25, 3);
INSERT INTO 'device' VALUES (620, 'SGH-T709', 25, 3);
INSERT INTO 'device' VALUES (621, 'SGH-T809', 25, 3);
INSERT INTO 'device' VALUES (622, 'SGH-U600', 25, 3);
INSERT INTO 'device' VALUES (623, 'SGH-U700', 25, 3);
INSERT INTO 'device' VALUES (624, 'SGH-U900', 25, 3);
INSERT INTO 'device' VALUES (625, 'SGH-X700', 25, 3);
INSERT INTO 'device' VALUES (626, 'SGH-X708', 25, 3);
INSERT INTO 'device' VALUES (627, 'SGH-X820', 25, 3);
INSERT INTO 'device' VALUES (628, 'SGH-X830', 25, 3);
INSERT INTO 'device' VALUES (629, 'SGH-Z400', 25, 3);
INSERT INTO 'device' VALUES (630, 'SGH-Z500', 25, 3);
INSERT INTO 'device' VALUES (631, 'SGH-Z540', 25, 3);
INSERT INTO 'device' VALUES (632, 'SGH-Z560', 25, 3);
INSERT INTO 'device' VALUES (633, 'SGH-Z630', 25, 3);
INSERT INTO 'device' VALUES (634, 'SGH-Z720', 25, 3);
INSERT INTO 'device' VALUES (635, 'SGH-ZM60', 25, 3);
INSERT INTO 'device' VALUES (636, 'SGH-i560', 25, 3);
INSERT INTO 'device' VALUES (637, 'SPH-A900', 25, 3);
INSERT INTO 'device' VALUES (638, 'SPH-I600', 25, 3);
INSERT INTO 'device' VALUES (639, 'Star', 25, 3);
INSERT INTO 'device' VALUES (640, 'X105', 25, 3);
INSERT INTO 'device' VALUES (641, 'X430', 25, 3);
INSERT INTO 'device' VALUES (642, 'X450', 25, 3);
INSERT INTO 'device' VALUES (643, 'X458', 25, 3);
INSERT INTO 'device' VALUES (644, 'Z100', 25, 3);
INSERT INTO 'device' VALUES (645, 'Z105', 25, 3);
INSERT INTO 'device' VALUES (646, 'i718', 25, 3);
INSERT INTO 'device' VALUES (647, '902', 26, 3);
INSERT INTO 'device' VALUES (648, 'GX15', 26, 3);
INSERT INTO 'device' VALUES (649, 'GX25', 26, 3);
INSERT INTO 'device' VALUES (650, 'SGH-902', 26, 3);
INSERT INTO 'device' VALUES (651, 'TM200', 26, 3);
INSERT INTO 'device' VALUES (652, 'C65', 27, 3);
INSERT INTO 'device' VALUES (653, 'CX65', 27, 3);
INSERT INTO 'device' VALUES (654, 'EF81', 27, 3);
INSERT INTO 'device' VALUES (655, 'EL71', 27, 3);
INSERT INTO 'platformversion' VALUES (28, 'x65', 3);
INSERT INTO 'device' VALUES (656, 'M65', 27, 28);
INSERT INTO 'device' VALUES (657, 'S65', 27, 28);
INSERT INTO 'device' VALUES (658, 'SK65', 27, 28);
INSERT INTO 'platformversion' VALUES (29, 'x75', 3);
INSERT INTO 'device' VALUES (659, 'SL75', 27, 29);
INSERT INTO 'device' VALUES (660, 'ST60', 27, 3);
INSERT INTO 'device' VALUES (661, 'midp2', 27, 3);
INSERT INTO 'device' VALUES (662, 'Aino', 28, 3);
INSERT INTO 'device' VALUES (663, 'C510', 28, 3);
INSERT INTO 'platformversion' VALUES (30, 'SE-JavaPlatform8', 3);
INSERT INTO 'device' VALUES (664, 'C702', 28, 30);
INSERT INTO 'device' VALUES (665, 'C901', 28, 3);
INSERT INTO 'device' VALUES (666, 'C902', 28, 30);
INSERT INTO 'device' VALUES (667, 'C903', 28, 3);
INSERT INTO 'device' VALUES (668, 'C905', 28, 30);
INSERT INTO 'platformversion' VALUES (31, 'SE-JavaPlatform5', 3);
INSERT INTO 'device' VALUES (669, 'D750', 28, 31);
INSERT INTO 'platformversion' VALUES (32, 'SE-JavaPlatform3', 3);
INSERT INTO 'device' VALUES (670, 'F500', 28, 32);
INSERT INTO 'device' VALUES (671, 'F500i', 28, 32);
INSERT INTO 'device' VALUES (672, 'G502', 28, 3);
INSERT INTO 'device' VALUES (673, 'G700', 28, 3);
INSERT INTO 'device' VALUES (674, 'G705', 28, 3);
INSERT INTO 'device' VALUES (675, 'J300', 28, 32);
INSERT INTO 'device' VALUES (676, 'K300', 28, 32);
INSERT INTO 'device' VALUES (677, 'K300i', 28, 32);
INSERT INTO 'platformversion' VALUES (33, 'SE-JavaPlatform6', 3);
INSERT INTO 'device' VALUES (678, 'K310', 28, 33);
INSERT INTO 'device' VALUES (679, 'K310i', 28, 33);
INSERT INTO 'device' VALUES (680, 'K320', 28, 33);
INSERT INTO 'device' VALUES (681, 'K320i', 28, 33);
INSERT INTO 'device' VALUES (682, 'K500', 28, 32);
INSERT INTO 'device' VALUES (683, 'K500c', 28, 32);
INSERT INTO 'device' VALUES (684, 'K500i', 28, 32);
INSERT INTO 'device' VALUES (685, 'K510', 28, 33);
INSERT INTO 'platformversion' VALUES (34, 'SE-JavaPlatform7', 3);
INSERT INTO 'device' VALUES (686, 'K530', 28, 34);
INSERT INTO 'device' VALUES (687, 'K550', 28, 34);
INSERT INTO 'device' VALUES (688, 'K550im', 28, 3);
INSERT INTO 'device' VALUES (689, 'K600', 28, 31);
INSERT INTO 'device' VALUES (690, 'K608', 28, 31);
INSERT INTO 'device' VALUES (691, 'K610i', 28, 34);
INSERT INTO 'device' VALUES (692, 'K618', 28, 34);
INSERT INTO 'device' VALUES (693, 'K630', 28, 30);
INSERT INTO 'device' VALUES (694, 'K660', 28, 30);
INSERT INTO 'platformversion' VALUES (35, 'Nokia-UI, SE-JavaPlatform3', 3);
INSERT INTO 'device' VALUES (695, 'K700', 28, 35);
INSERT INTO 'device' VALUES (696, 'K700c', 28, 35);
INSERT INTO 'device' VALUES (697, 'K700i', 28, 35);
INSERT INTO 'device' VALUES (698, 'K750', 28, 31);
INSERT INTO 'device' VALUES (699, 'K750i', 28, 31);
INSERT INTO 'device' VALUES (700, 'K770', 28, 34);
INSERT INTO 'device' VALUES (701, 'K770i', 28, 34);
INSERT INTO 'device' VALUES (702, 'K790', 28, 34);
INSERT INTO 'device' VALUES (703, 'K800', 28, 34);
INSERT INTO 'device' VALUES (704, 'K800i', 28, 34);
INSERT INTO 'device' VALUES (705, 'K810i', 28, 34);
INSERT INTO 'device' VALUES (706, 'K850', 28, 30);
INSERT INTO 'device' VALUES (707, 'K850i', 28, 30);
INSERT INTO 'device' VALUES (708, 'M600', 28, 3);
INSERT INTO 'device' VALUES (709, 'Mylo', 28, 34);
INSERT INTO 'device' VALUES (710, 'Naite', 28, 3);
INSERT INTO 'device' VALUES (711, 'P1', 28, 3);
INSERT INTO 'device' VALUES (712, 'P1i', 28, 3);
INSERT INTO 'device' VALUES (713, 'P900', 28, 3);
INSERT INTO 'device' VALUES (714, 'P908', 28, 3);
INSERT INTO 'device' VALUES (715, 'P910', 28, 3);
INSERT INTO 'device' VALUES (716, 'P910a', 28, 3);
INSERT INTO 'device' VALUES (717, 'P910c', 28, 3);
INSERT INTO 'device' VALUES (718, 'P910i', 28, 3);
INSERT INTO 'device' VALUES (719, 'P990i', 28, 3);
INSERT INTO 'device' VALUES (720, 'S500', 28, 34);
INSERT INTO 'device' VALUES (721, 'S500i', 28, 34);
INSERT INTO 'device' VALUES (722, 'S700', 28, 32);
INSERT INTO 'device' VALUES (723, 'S700c', 28, 32);
INSERT INTO 'device' VALUES (724, 'S700i', 28, 32);
INSERT INTO 'device' VALUES (725, 'Satio', 28, 16);
INSERT INTO 'device' VALUES (726, 'T303', 28, 3);
INSERT INTO 'device' VALUES (727, 'T650', 28, 34);
INSERT INTO 'device' VALUES (728, 'T715', 28, 3);
INSERT INTO 'device' VALUES (729, 'U5i', 28, 16);
INSERT INTO 'device' VALUES (730, 'V600', 28, 31);
INSERT INTO 'device' VALUES (731, 'V630', 28, 34);
INSERT INTO 'device' VALUES (732, 'V640', 28, 30);
INSERT INTO 'device' VALUES (733, 'V640i', 28, 30);
INSERT INTO 'platformversion' VALUES (36, 'SE-JavaPlatform4', 3);
INSERT INTO 'device' VALUES (734, 'V800', 28, 36);
INSERT INTO 'device' VALUES (735, 'V802', 28, 36);
INSERT INTO 'device' VALUES (736, 'W200', 28, 3);
INSERT INTO 'device' VALUES (737, 'W200i', 28, 3);
INSERT INTO 'device' VALUES (738, 'W300', 28, 33);
INSERT INTO 'device' VALUES (739, 'W300i', 28, 33);
INSERT INTO 'device' VALUES (740, 'W350', 28, 3);
INSERT INTO 'device' VALUES (741, 'W380', 28, 3);
INSERT INTO 'device' VALUES (742, 'W380c', 28, 3);
INSERT INTO 'device' VALUES (743, 'W550', 28, 33);
INSERT INTO 'device' VALUES (744, 'W580', 28, 34);
INSERT INTO 'device' VALUES (745, 'W580i', 28, 34);
INSERT INTO 'device' VALUES (746, 'W595', 28, 3);
INSERT INTO 'device' VALUES (747, 'W600', 28, 33);
INSERT INTO 'device' VALUES (748, 'W610i', 28, 34);
INSERT INTO 'device' VALUES (749, 'W700', 28, 31);
INSERT INTO 'device' VALUES (750, 'W710', 28, 34);
INSERT INTO 'device' VALUES (751, 'W710i', 28, 34);
INSERT INTO 'device' VALUES (752, 'W715', 28, 3);
INSERT INTO 'device' VALUES (753, 'W760', 28, 30);
INSERT INTO 'device' VALUES (754, 'W760i', 28, 30);
INSERT INTO 'device' VALUES (755, 'W800', 28, 31);
INSERT INTO 'device' VALUES (756, 'W800i', 28, 31);
INSERT INTO 'device' VALUES (757, 'W810', 28, 33);
INSERT INTO 'device' VALUES (758, 'W810i', 28, 33);
INSERT INTO 'device' VALUES (759, 'W830', 28, 34);
INSERT INTO 'device' VALUES (760, 'W830i', 28, 34);
INSERT INTO 'device' VALUES (761, 'W850', 28, 34);
INSERT INTO 'device' VALUES (762, 'W850i', 28, 34);
INSERT INTO 'device' VALUES (763, 'W880', 28, 34);
INSERT INTO 'device' VALUES (764, 'W880i', 28, 34);
INSERT INTO 'device' VALUES (765, 'W900', 28, 33);
INSERT INTO 'device' VALUES (766, 'W900i', 28, 33);
INSERT INTO 'device' VALUES (767, 'W908c', 28, 3);
INSERT INTO 'device' VALUES (768, 'W910', 28, 30);
INSERT INTO 'device' VALUES (769, 'W910i', 28, 30);
INSERT INTO 'device' VALUES (770, 'W950i', 28, 33);
INSERT INTO 'device' VALUES (771, 'W960', 28, 3);
INSERT INTO 'device' VALUES (772, 'W995', 28, 3);
INSERT INTO 'device' VALUES (773, 'X1', 28, 1);
INSERT INTO 'device' VALUES (774, 'X10', 28, 4);
INSERT INTO 'device' VALUES (775, 'X2', 28, 1);
INSERT INTO 'device' VALUES (776, 'Yari', 28, 3);
INSERT INTO 'platformversion' VALUES (37, 'SE-JavaPlatform2', 3);
INSERT INTO 'device' VALUES (777, 'Z1010', 28, 37);
INSERT INTO 'device' VALUES (778, 'Z250', 28, 3);
INSERT INTO 'device' VALUES (779, 'Z300', 28, 32);
INSERT INTO 'device' VALUES (780, 'Z300a', 28, 32);
INSERT INTO 'device' VALUES (781, 'Z310', 28, 3);
INSERT INTO 'device' VALUES (782, 'Z320', 28, 3);
INSERT INTO 'device' VALUES (783, 'Z500', 28, 32);
INSERT INTO 'device' VALUES (784, 'Z500a', 28, 32);
INSERT INTO 'device' VALUES (785, 'Z500i', 28, 32);
INSERT INTO 'device' VALUES (786, 'Z520', 28, 31);
INSERT INTO 'device' VALUES (787, 'Z525', 28, 31);
INSERT INTO 'device' VALUES (788, 'Z530', 28, 33);
INSERT INTO 'device' VALUES (789, 'Z550', 28, 33);
INSERT INTO 'device' VALUES (790, 'Z550i', 28, 33);
INSERT INTO 'device' VALUES (791, 'Z555', 28, 3);
INSERT INTO 'device' VALUES (792, 'Z558', 28, 3);
INSERT INTO 'device' VALUES (793, 'Z610', 28, 3);
INSERT INTO 'device' VALUES (794, 'Z710', 28, 34);
INSERT INTO 'device' VALUES (795, 'Z750', 28, 30);
INSERT INTO 'device' VALUES (796, 'Z750i', 28, 3);
INSERT INTO 'device' VALUES (797, 'Z770', 28, 30);
INSERT INTO 'device' VALUES (798, 'Z800', 28, 36);
INSERT INTO 'device' VALUES (799, 'Dash', 29, 7);
INSERT INTO 'device' VALUES (800, 'MDA', 29, 5);
INSERT INTO 'device' VALUES (801, 'MDAII', 29, 7);
INSERT INTO 'device' VALUES (802, 'MDAcompact', 29, 7);
INSERT INTO 'device' VALUES (803, 'SDA', 29, 7);
INSERT INTO 'device' VALUES (804, 'XV8600', 30, 8);
INSERT INTO 'platformversion' VALUES (38, 'Series40E2', 3);
INSERT INTO 'device' VALUES (805, 'Constellation', 31, 38);
INSERT INTO 'device' VALUES (806, 'Highscreen PP5420', 32, 4);
INSERT INTO 'device' VALUES (807, 'Highscreen Zeus', 32, 4);
INSERT INTO 'device' VALUES (808, 'Samsung-SGH-F700', 33, 3);
INSERT INTO 'device' VALUES (809, 'Sony-Ericsson-F500i', 33, 32);
INSERT INTO 'device' VALUES (810, 'Sony-Ericsson-V600', 33, 31);
COMMIT;
BEGIN;
INSERT INTO 'mosynccap' VALUES (1, 'BitsPerPixel');
INSERT INTO 'mosynccap' VALUES (2, 'ScreenSize');
INSERT INTO 'mosynccap' VALUES (3, 'Features');
COMMIT;
BEGIN;
INSERT INTO 'cap' VALUES (1, 'BitsPerPixel', 1);
INSERT INTO 'mosynccapcap' VALUES (1, 1, 1);
INSERT INTO 'capvalue' VALUES (1, '16');
INSERT INTO 'devicecapvalue' VALUES (1, 1, 1, 1);
INSERT INTO 'cap' VALUES (2, 'Features', 1);
INSERT INTO 'mosynccapcap' VALUES (2, 3, 2);
INSERT INTO 'capvalue' VALUES (2, 'hasPointerEvents');
INSERT INTO 'devicecapvalue' VALUES (2, 1, 2, 2);
INSERT INTO 'cap' VALUES (3, 'OS', 1);
INSERT INTO 'capvalue' VALUES (3, 'Windows Mobile 6');
INSERT INTO 'devicecapvalue' VALUES (3, 1, 3, 3);
INSERT INTO 'cap' VALUES (4, 'ScreenSize_x', 1);
INSERT INTO 'cap' VALUES (5, 'ScreenSize_y', 1);
INSERT INTO 'mosynccapcap' VALUES (3, 2, 4);
INSERT INTO 'mosynccapcap' VALUES (4, 2, 5);
INSERT INTO 'capvalue' VALUES (4, '400');
INSERT INTO 'devicecapvalue' VALUES (4, 1, 4, 4);
INSERT INTO 'capvalue' VALUES (5, '240');
INSERT INTO 'devicecapvalue' VALUES (5, 1, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (6, 2, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (7, 2, 2, 2);
INSERT INTO 'cap' VALUES (6, 'JavaPlatform', 1);
INSERT INTO 'capvalue' VALUES (6, 'Android/1.6');
INSERT INTO 'devicecapvalue' VALUES (8, 2, 6, 6);
INSERT INTO 'capvalue' VALUES (7, '480');
INSERT INTO 'devicecapvalue' VALUES (9, 2, 4, 7);
INSERT INTO 'capvalue' VALUES (8, '800');
INSERT INTO 'devicecapvalue' VALUES (10, 2, 5, 8);
INSERT INTO 'cap' VALUES (7, 'CanvasSize', 1);
INSERT INTO 'capvalue' VALUES (9, '320x194');
INSERT INTO 'devicecapvalue' VALUES (11, 3, 7, 9);
INSERT INTO 'cap' VALUES (8, 'colors', 1);
INSERT INTO 'capvalue' VALUES (10, '65536');
INSERT INTO 'devicecapvalue' VALUES (12, 3, 8, 10);
INSERT INTO 'capvalue' VALUES (11, 'isDoubleBuffered');
INSERT INTO 'devicecapvalue' VALUES (13, 3, 2, 11);
INSERT INTO 'cap' VALUES (9, 'Font.default', 1);
INSERT INTO 'devicecapvalue' VALUES (14, 3, 9, 1);
INSERT INTO 'cap' VALUES (10, 'Font.large', 1);
INSERT INTO 'capvalue' VALUES (12, '22');
INSERT INTO 'devicecapvalue' VALUES (15, 3, 10, 12);
INSERT INTO 'cap' VALUES (11, 'Font.medium', 1);
INSERT INTO 'devicecapvalue' VALUES (16, 3, 11, 1);
INSERT INTO 'cap' VALUES (12, 'Font.small', 1);
INSERT INTO 'capvalue' VALUES (13, '12');
INSERT INTO 'devicecapvalue' VALUES (17, 3, 12, 13);
INSERT INTO 'cap' VALUES (13, 'FullCanvasSize', 1);
INSERT INTO 'capvalue' VALUES (14, '320x240');
INSERT INTO 'devicecapvalue' VALUES (18, 3, 13, 14);
INSERT INTO 'cap' VALUES (14, 'hasRepeatEvents', 1);
INSERT INTO 'capvalue' VALUES (15, 'true');
INSERT INTO 'devicecapvalue' VALUES (19, 3, 14, 15);
INSERT INTO 'cap' VALUES (15, 'ImageFormat', 1);
INSERT INTO 'capvalue' VALUES (16, 'bmp');
INSERT INTO 'devicecapvalue' VALUES (20, 3, 15, 16);
INSERT INTO 'capvalue' VALUES (17, 'gif');
INSERT INTO 'devicecapvalue' VALUES (21, 3, 15, 17);
INSERT INTO 'capvalue' VALUES (18, 'jpeg');
INSERT INTO 'devicecapvalue' VALUES (22, 3, 15, 18);
INSERT INTO 'capvalue' VALUES (19, 'wbmp');
INSERT INTO 'devicecapvalue' VALUES (23, 3, 15, 19);
INSERT INTO 'cap' VALUES (16, 'JavaConfiguration', 1);
INSERT INTO 'capvalue' VALUES (20, 'CLDC/1.1');
INSERT INTO 'devicecapvalue' VALUES (24, 3, 16, 20);
INSERT INTO 'cap' VALUES (17, 'JavaPackage', 1);
INSERT INTO 'mosynccapcap' VALUES (5, 3, 17);
INSERT INTO 'capvalue' VALUES (21, 'fileconnection');
INSERT INTO 'devicecapvalue' VALUES (25, 3, 17, 21);
INSERT INTO 'capvalue' VALUES (22, 'mmapi');
INSERT INTO 'devicecapvalue' VALUES (26, 3, 17, 22);
INSERT INTO 'capvalue' VALUES (23, 'nokia-ui');
INSERT INTO 'devicecapvalue' VALUES (27, 3, 17, 23);
INSERT INTO 'capvalue' VALUES (24, 'pimapi');
INSERT INTO 'devicecapvalue' VALUES (28, 3, 17, 24);
INSERT INTO 'capvalue' VALUES (25, 'wmapi');
INSERT INTO 'devicecapvalue' VALUES (29, 3, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (30, 3, 17, 25);
INSERT INTO 'capvalue' VALUES (26, 'JTWI/1.0');
INSERT INTO 'devicecapvalue' VALUES (31, 3, 6, 26);
INSERT INTO 'capvalue' VALUES (27, 'MIDP/2.0');
INSERT INTO 'devicecapvalue' VALUES (32, 3, 6, 27);
INSERT INTO 'cap' VALUES (18, 'key.ClearKey', 1);
INSERT INTO 'capvalue' VALUES (28, '-8');
INSERT INTO 'devicecapvalue' VALUES (33, 3, 18, 28);
INSERT INTO 'cap' VALUES (19, 'key.down', 1);
INSERT INTO 'capvalue' VALUES (29, '-2');
INSERT INTO 'devicecapvalue' VALUES (34, 3, 19, 29);
INSERT INTO 'cap' VALUES (20, 'key.fire', 1);
INSERT INTO 'capvalue' VALUES (30, '-5');
INSERT INTO 'devicecapvalue' VALUES (35, 3, 20, 30);
INSERT INTO 'cap' VALUES (21, 'key.gamea', 1);
INSERT INTO 'capvalue' VALUES (31, '49');
INSERT INTO 'devicecapvalue' VALUES (36, 3, 21, 31);
INSERT INTO 'cap' VALUES (22, 'key.gameb', 1);
INSERT INTO 'capvalue' VALUES (32, '51');
INSERT INTO 'devicecapvalue' VALUES (37, 3, 22, 32);
INSERT INTO 'cap' VALUES (23, 'key.gamec', 1);
INSERT INTO 'capvalue' VALUES (33, '55');
INSERT INTO 'devicecapvalue' VALUES (38, 3, 23, 33);
INSERT INTO 'cap' VALUES (24, 'key.gamed', 1);
INSERT INTO 'capvalue' VALUES (34, '57');
INSERT INTO 'devicecapvalue' VALUES (39, 3, 24, 34);
INSERT INTO 'cap' VALUES (25, 'key.left', 1);
INSERT INTO 'capvalue' VALUES (35, '-3');
INSERT INTO 'devicecapvalue' VALUES (40, 3, 25, 35);
INSERT INTO 'cap' VALUES (26, 'key.LeftSoftKey', 1);
INSERT INTO 'capvalue' VALUES (36, '-6');
INSERT INTO 'devicecapvalue' VALUES (41, 3, 26, 36);
INSERT INTO 'cap' VALUES (27, 'key.MiddleSoftKey', 1);
INSERT INTO 'capvalue' VALUES (37, '-34');
INSERT INTO 'devicecapvalue' VALUES (42, 3, 27, 37);
INSERT INTO 'cap' VALUES (28, 'key.ReturnKey', 1);
INSERT INTO 'capvalue' VALUES (38, '-41');
INSERT INTO 'devicecapvalue' VALUES (43, 3, 28, 38);
INSERT INTO 'cap' VALUES (29, 'key.right', 1);
INSERT INTO 'capvalue' VALUES (39, '-4');
INSERT INTO 'devicecapvalue' VALUES (44, 3, 29, 39);
INSERT INTO 'cap' VALUES (30, 'key.RightSoftKey', 1);
INSERT INTO 'capvalue' VALUES (40, '-7');
INSERT INTO 'devicecapvalue' VALUES (45, 3, 30, 40);
INSERT INTO 'cap' VALUES (31, 'key.up', 1);
INSERT INTO 'capvalue' VALUES (41, '-1');
INSERT INTO 'devicecapvalue' VALUES (46, 3, 31, 41);
INSERT INTO 'cap' VALUES (32, 'microedition.commports', 1);
INSERT INTO 'capvalue' VALUES (42, '0');
INSERT INTO 'devicecapvalue' VALUES (47, 3, 32, 42);
INSERT INTO 'cap' VALUES (33, 'microedition.configuration', 1);
INSERT INTO 'capvalue' VALUES (43, 'CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (48, 3, 33, 43);
INSERT INTO 'cap' VALUES (34, 'microedition.encoding', 1);
INSERT INTO 'capvalue' VALUES (44, 'ISO8859_1');
INSERT INTO 'devicecapvalue' VALUES (49, 3, 34, 44);
INSERT INTO 'cap' VALUES (35, 'microedition.jtwi.version', 1);
INSERT INTO 'capvalue' VALUES (45, '1.0');
INSERT INTO 'devicecapvalue' VALUES (50, 3, 35, 45);
INSERT INTO 'cap' VALUES (36, 'microedition.platform', 1);
INSERT INTO 'capvalue' VALUES (46, 'Alcatel-OT-800A/1.0');
INSERT INTO 'devicecapvalue' VALUES (51, 3, 36, 46);
INSERT INTO 'cap' VALUES (37, 'microedition.profiles', 1);
INSERT INTO 'capvalue' VALUES (47, 'MIDP-2.0');
INSERT INTO 'devicecapvalue' VALUES (52, 3, 37, 47);
INSERT INTO 'cap' VALUES (38, 'mmapi.audio.encodings', 1);
INSERT INTO 'capvalue' VALUES (48, 'encoding=audio/wav encoding=audio/amr encoding=audio/amr-wb');
INSERT INTO 'devicecapvalue' VALUES (53, 3, 38, 48);
INSERT INTO 'cap' VALUES (39, 'mmapi.protocol.capture', 1);
INSERT INTO 'capvalue' VALUES (49, 'audio/amr');
INSERT INTO 'devicecapvalue' VALUES (54, 3, 39, 49);
INSERT INTO 'capvalue' VALUES (50, 'audio/amr-wb');
INSERT INTO 'devicecapvalue' VALUES (55, 3, 39, 50);
INSERT INTO 'capvalue' VALUES (51, 'audio/x-wav');
INSERT INTO 'devicecapvalue' VALUES (56, 3, 39, 51);
INSERT INTO 'capvalue' VALUES (52, 'image/jpeg');
INSERT INTO 'devicecapvalue' VALUES (57, 3, 39, 52);
INSERT INTO 'capvalue' VALUES (53, 'video/3gpp');
INSERT INTO 'devicecapvalue' VALUES (58, 3, 39, 53);
INSERT INTO 'cap' VALUES (40, 'mmapi.protocol.device', 1);
INSERT INTO 'capvalue' VALUES (54, 'audio/midi');
INSERT INTO 'devicecapvalue' VALUES (59, 3, 40, 54);
INSERT INTO 'capvalue' VALUES (55, 'audio/x-tone-seq');
INSERT INTO 'devicecapvalue' VALUES (60, 3, 40, 55);
INSERT INTO 'cap' VALUES (41, 'mmapi.protocol.file', 1);
INSERT INTO 'capvalue' VALUES (56, 'application/sdp');
INSERT INTO 'devicecapvalue' VALUES (61, 3, 41, 56);
INSERT INTO 'capvalue' VALUES (57, 'audio/3gpp');
INSERT INTO 'devicecapvalue' VALUES (62, 3, 41, 57);
INSERT INTO 'capvalue' VALUES (58, 'audio/aac');
INSERT INTO 'devicecapvalue' VALUES (63, 3, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (64, 3, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (65, 3, 41, 50);
INSERT INTO 'capvalue' VALUES (59, 'audio/imelody');
INSERT INTO 'devicecapvalue' VALUES (66, 3, 41, 59);
INSERT INTO 'capvalue' VALUES (60, 'audio/m4a');
INSERT INTO 'devicecapvalue' VALUES (67, 3, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (68, 3, 41, 54);
INSERT INTO 'capvalue' VALUES (61, 'audio/mp2');
INSERT INTO 'devicecapvalue' VALUES (69, 3, 41, 61);
INSERT INTO 'capvalue' VALUES (62, 'audio/mp4');
INSERT INTO 'devicecapvalue' VALUES (70, 3, 41, 62);
INSERT INTO 'capvalue' VALUES (63, 'audio/mpeg');
INSERT INTO 'devicecapvalue' VALUES (71, 3, 41, 63);
INSERT INTO 'capvalue' VALUES (64, 'audio/sp-midi');
INSERT INTO 'devicecapvalue' VALUES (72, 3, 41, 64);
INSERT INTO 'capvalue' VALUES (65, 'audio/wma');
INSERT INTO 'devicecapvalue' VALUES (73, 3, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (74, 3, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (75, 3, 41, 51);
INSERT INTO 'capvalue' VALUES (66, 'image/gif');
INSERT INTO 'devicecapvalue' VALUES (76, 3, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (77, 3, 41, 53);
INSERT INTO 'capvalue' VALUES (67, 'video/mp4');
INSERT INTO 'devicecapvalue' VALUES (78, 3, 41, 67);
INSERT INTO 'cap' VALUES (42, 'mmapi.protocol.http', 1);
INSERT INTO 'devicecapvalue' VALUES (79, 3, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (80, 3, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (81, 3, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (82, 3, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (83, 3, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (84, 3, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (85, 3, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (86, 3, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (87, 3, 42, 61);
INSERT INTO 'devicecapvalue' VALUES (88, 3, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (89, 3, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (90, 3, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (91, 3, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (92, 3, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (93, 3, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (94, 3, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (95, 3, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (96, 3, 42, 67);
INSERT INTO 'cap' VALUES (43, 'mmapi.supportsaudiocapture', 1);
INSERT INTO 'devicecapvalue' VALUES (97, 3, 43, 15);
INSERT INTO 'cap' VALUES (44, 'mmapi.supportsvideocapture', 1);
INSERT INTO 'devicecapvalue' VALUES (98, 3, 44, 15);
INSERT INTO 'cap' VALUES (45, 'mmapi.video.encodings', 1);
INSERT INTO 'capvalue' VALUES (68, 'encoding=video/3gpp');
INSERT INTO 'devicecapvalue' VALUES (99, 3, 45, 68);
INSERT INTO 'cap' VALUES (46, 'properties', 1);
INSERT INTO 'capvalue' VALUES (69, 'audio.encodings');
INSERT INTO 'devicecapvalue' VALUES (100, 3, 46, 69);
INSERT INTO 'capvalue' VALUES (70, 'file.separator');
INSERT INTO 'devicecapvalue' VALUES (101, 3, 46, 70);
INSERT INTO 'capvalue' VALUES (71, 'fileconn.dir.memorycard');
INSERT INTO 'devicecapvalue' VALUES (102, 3, 46, 71);
INSERT INTO 'capvalue' VALUES (72, 'fileconn.dir.photos');
INSERT INTO 'devicecapvalue' VALUES (103, 3, 46, 72);
INSERT INTO 'capvalue' VALUES (73, 'microedition.commports');
INSERT INTO 'devicecapvalue' VALUES (104, 3, 46, 73);
INSERT INTO 'capvalue' VALUES (74, 'microedition.configuration');
INSERT INTO 'devicecapvalue' VALUES (105, 3, 46, 74);
INSERT INTO 'capvalue' VALUES (75, 'microedition.encoding');
INSERT INTO 'devicecapvalue' VALUES (106, 3, 46, 75);
INSERT INTO 'capvalue' VALUES (76, 'microedition.io.file.FileConnection.version');
INSERT INTO 'devicecapvalue' VALUES (107, 3, 46, 76);
INSERT INTO 'capvalue' VALUES (77, 'microedition.jtwi.version');
INSERT INTO 'devicecapvalue' VALUES (108, 3, 46, 77);
INSERT INTO 'capvalue' VALUES (78, 'microedition.locale');
INSERT INTO 'devicecapvalue' VALUES (109, 3, 46, 78);
INSERT INTO 'capvalue' VALUES (79, 'microedition.m3g.version');
INSERT INTO 'devicecapvalue' VALUES (110, 3, 46, 79);
INSERT INTO 'capvalue' VALUES (80, 'microedition.media.version');
INSERT INTO 'devicecapvalue' VALUES (111, 3, 46, 80);
INSERT INTO 'capvalue' VALUES (81, 'microedition.pim.version');
INSERT INTO 'devicecapvalue' VALUES (112, 3, 46, 81);
INSERT INTO 'capvalue' VALUES (82, 'microedition.platform');
INSERT INTO 'devicecapvalue' VALUES (113, 3, 46, 82);
INSERT INTO 'capvalue' VALUES (83, 'microedition.profiles');
INSERT INTO 'devicecapvalue' VALUES (114, 3, 46, 83);
INSERT INTO 'capvalue' VALUES (84, 'supports.audio.capture');
INSERT INTO 'devicecapvalue' VALUES (115, 3, 46, 84);
INSERT INTO 'capvalue' VALUES (85, 'supports.mixing');
INSERT INTO 'devicecapvalue' VALUES (116, 3, 46, 85);
INSERT INTO 'capvalue' VALUES (86, 'supports.recording');
INSERT INTO 'devicecapvalue' VALUES (117, 3, 46, 86);
INSERT INTO 'capvalue' VALUES (87, 'supports.video.capture');
INSERT INTO 'devicecapvalue' VALUES (118, 3, 46, 87);
INSERT INTO 'capvalue' VALUES (88, 'video.encodings');
INSERT INTO 'devicecapvalue' VALUES (119, 3, 46, 88);
INSERT INTO 'capvalue' VALUES (89, 'video.snapshot.encodings');
INSERT INTO 'devicecapvalue' VALUES (120, 3, 46, 89);
INSERT INTO 'cap' VALUES (47, 'protocol.rtsp', 1);
INSERT INTO 'devicecapvalue' VALUES (121, 3, 47, 56);
INSERT INTO 'devicecapvalue' VALUES (122, 3, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (123, 3, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (124, 3, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (125, 3, 47, 67);
INSERT INTO 'cap' VALUES (48, 'timezones', 1);
INSERT INTO 'capvalue' VALUES (90, 'GMT');
INSERT INTO 'devicecapvalue' VALUES (126, 3, 48, 90);
INSERT INTO 'capvalue' VALUES (91, 'San Juan');
INSERT INTO 'devicecapvalue' VALUES (127, 3, 48, 91);
INSERT INTO 'capvalue' VALUES (92, 'UTC');
INSERT INTO 'devicecapvalue' VALUES (128, 3, 48, 92);
INSERT INTO 'cap' VALUES (49, 'totalmemory', 1);
INSERT INTO 'capvalue' VALUES (93, '5242880');
INSERT INTO 'devicecapvalue' VALUES (129, 3, 49, 93);
INSERT INTO 'devicecapvalue' VALUES (130, 4, 1, 13);
INSERT INTO 'capvalue' VALUES (94, 'agif');
INSERT INTO 'devicecapvalue' VALUES (131, 4, 15, 94);
INSERT INTO 'devicecapvalue' VALUES (132, 4, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (133, 4, 15, 17);
INSERT INTO 'capvalue' VALUES (95, 'jpg');
INSERT INTO 'devicecapvalue' VALUES (134, 4, 15, 95);
INSERT INTO 'capvalue' VALUES (96, 'png');
INSERT INTO 'devicecapvalue' VALUES (135, 4, 15, 96);
INSERT INTO 'capvalue' VALUES (97, 'CLDC/1.0');
INSERT INTO 'devicecapvalue' VALUES (136, 4, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (137, 4, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (138, 4, 6, 27);
INSERT INTO 'cap' VALUES (50, 'MaxJarSize', 1);
INSERT INTO 'capvalue' VALUES (98, '131072');
INSERT INTO 'devicecapvalue' VALUES (139, 4, 50, 98);
INSERT INTO 'capvalue' VALUES (99, '128');
INSERT INTO 'devicecapvalue' VALUES (140, 4, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (141, 4, 5, 99);
INSERT INTO 'cap' VALUES (51, 'SoundFormat', 1);
INSERT INTO 'capvalue' VALUES (100, 'amr');
INSERT INTO 'devicecapvalue' VALUES (142, 4, 51, 100);
INSERT INTO 'capvalue' VALUES (101, 'iMelody');
INSERT INTO 'devicecapvalue' VALUES (143, 4, 51, 101);
INSERT INTO 'capvalue' VALUES (102, 'midi');
INSERT INTO 'devicecapvalue' VALUES (144, 4, 51, 102);
INSERT INTO 'capvalue' VALUES (103, 'sp-midi');
INSERT INTO 'devicecapvalue' VALUES (145, 4, 51, 103);
INSERT INTO 'cap' VALUES (52, 'StorageSize', 1);
INSERT INTO 'capvalue' VALUES (104, '1572864');
INSERT INTO 'devicecapvalue' VALUES (146, 4, 52, 104);
INSERT INTO 'cap' VALUES (53, 'wap.userAgent', 1);
INSERT INTO 'capvalue' VALUES (105, 'Alcatel-BH4R/1.0 UP.Browser/6.2.ALCATELMMP/1.0');
INSERT INTO 'devicecapvalue' VALUES (147, 4, 53, 105);
INSERT INTO 'capvalue' VALUES (106, '18');
INSERT INTO 'devicecapvalue' VALUES (148, 5, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (149, 5, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (150, 5, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (151, 5, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (152, 5, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (153, 5, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (154, 5, 4, 99);
INSERT INTO 'capvalue' VALUES (107, '160');
INSERT INTO 'devicecapvalue' VALUES (155, 5, 5, 107);
INSERT INTO 'capvalue' VALUES (108, '132x176');
INSERT INTO 'devicecapvalue' VALUES (156, 6, 7, 108);
INSERT INTO 'devicecapvalue' VALUES (157, 6, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (158, 6, 2, 11);
INSERT INTO 'capvalue' VALUES (109, '15');
INSERT INTO 'devicecapvalue' VALUES (159, 6, 9, 109);
INSERT INTO 'capvalue' VALUES (110, '23');
INSERT INTO 'devicecapvalue' VALUES (160, 6, 10, 110);
INSERT INTO 'devicecapvalue' VALUES (161, 6, 11, 109);
INSERT INTO 'devicecapvalue' VALUES (162, 6, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (163, 6, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (164, 6, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (165, 6, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (166, 6, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (167, 6, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (168, 6, 16, 20);
INSERT INTO 'capvalue' VALUES (111, '3dapi');
INSERT INTO 'devicecapvalue' VALUES (169, 6, 17, 111);
INSERT INTO 'capvalue' VALUES (112, 'bluetooth');
INSERT INTO 'devicecapvalue' VALUES (170, 6, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (171, 6, 17, 21);
INSERT INTO 'capvalue' VALUES (113, 'locationapi');
INSERT INTO 'devicecapvalue' VALUES (172, 6, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (173, 6, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (174, 6, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (175, 6, 17, 24);
INSERT INTO 'capvalue' VALUES (114, 'siemens-extension-api');
INSERT INTO 'devicecapvalue' VALUES (176, 6, 17, 114);
INSERT INTO 'capvalue' VALUES (115, 'webservice');
INSERT INTO 'devicecapvalue' VALUES (177, 6, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (178, 6, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (179, 6, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (180, 6, 6, 27);
INSERT INTO 'capvalue' VALUES (116, '-60');
INSERT INTO 'devicecapvalue' VALUES (181, 6, 19, 116);
INSERT INTO 'capvalue' VALUES (117, '-26');
INSERT INTO 'devicecapvalue' VALUES (182, 6, 20, 117);
INSERT INTO 'devicecapvalue' VALUES (183, 6, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (184, 6, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (185, 6, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (186, 6, 24, 34);
INSERT INTO 'capvalue' VALUES (118, '-61');
INSERT INTO 'devicecapvalue' VALUES (187, 6, 25, 118);
INSERT INTO 'devicecapvalue' VALUES (188, 6, 26, 41);
INSERT INTO 'capvalue' VALUES (119, '-62');
INSERT INTO 'devicecapvalue' VALUES (189, 6, 29, 119);
INSERT INTO 'devicecapvalue' VALUES (190, 6, 30, 39);
INSERT INTO 'cap' VALUES (54, 'key.SelectSoftKey', 1);
INSERT INTO 'devicecapvalue' VALUES (191, 6, 54, 117);
INSERT INTO 'capvalue' VALUES (120, '-59');
INSERT INTO 'devicecapvalue' VALUES (192, 6, 31, 120);
INSERT INTO 'capvalue' VALUES (121, 'encoding=AMR');
INSERT INTO 'devicecapvalue' VALUES (193, 6, 38, 121);
INSERT INTO 'devicecapvalue' VALUES (194, 6, 39, 49);
INSERT INTO 'capvalue' VALUES (122, 'video/3gp');
INSERT INTO 'devicecapvalue' VALUES (195, 6, 39, 122);
INSERT INTO 'devicecapvalue' VALUES (196, 6, 39, 53);
INSERT INTO 'capvalue' VALUES (123, 'video/h263-2000');
INSERT INTO 'devicecapvalue' VALUES (197, 6, 39, 123);
INSERT INTO 'devicecapvalue' VALUES (198, 6, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (199, 6, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (200, 6, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (201, 6, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (202, 6, 41, 59);
INSERT INTO 'capvalue' VALUES (124, 'audio/mid');
INSERT INTO 'devicecapvalue' VALUES (203, 6, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (204, 6, 41, 54);
INSERT INTO 'capvalue' VALUES (125, 'audio/mobile-xmf');
INSERT INTO 'devicecapvalue' VALUES (205, 6, 41, 125);
INSERT INTO 'capvalue' VALUES (126, 'audio/mp3');
INSERT INTO 'devicecapvalue' VALUES (206, 6, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (207, 6, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (208, 6, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (209, 6, 41, 64);
INSERT INTO 'capvalue' VALUES (127, 'audio/x-aac');
INSERT INTO 'devicecapvalue' VALUES (210, 6, 41, 127);
INSERT INTO 'capvalue' VALUES (128, 'audio/x-imelody');
INSERT INTO 'devicecapvalue' VALUES (211, 6, 41, 128);
INSERT INTO 'capvalue' VALUES (129, 'audio/x-m4a');
INSERT INTO 'devicecapvalue' VALUES (212, 6, 41, 129);
INSERT INTO 'capvalue' VALUES (130, 'audio/x-mfi');
INSERT INTO 'devicecapvalue' VALUES (213, 6, 41, 130);
INSERT INTO 'capvalue' VALUES (131, 'audio/x-mid');
INSERT INTO 'devicecapvalue' VALUES (214, 6, 41, 131);
INSERT INTO 'capvalue' VALUES (132, 'audio/x-midi');
INSERT INTO 'devicecapvalue' VALUES (215, 6, 41, 132);
INSERT INTO 'capvalue' VALUES (133, 'audio/x-siemens-audio');
INSERT INTO 'devicecapvalue' VALUES (216, 6, 41, 133);
INSERT INTO 'capvalue' VALUES (134, 'audio/x-siemens-tone');
INSERT INTO 'devicecapvalue' VALUES (217, 6, 41, 134);
INSERT INTO 'devicecapvalue' VALUES (218, 6, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (219, 6, 41, 51);
INSERT INTO 'capvalue' VALUES (135, 'audio/xmf');
INSERT INTO 'devicecapvalue' VALUES (220, 6, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (221, 6, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (222, 6, 41, 53);
INSERT INTO 'capvalue' VALUES (136, 'video/h263');
INSERT INTO 'devicecapvalue' VALUES (223, 6, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (224, 6, 41, 123);
INSERT INTO 'devicecapvalue' VALUES (225, 6, 41, 67);
INSERT INTO 'capvalue' VALUES (137, 'video/mpeg4-generic');
INSERT INTO 'devicecapvalue' VALUES (226, 6, 41, 137);
INSERT INTO 'capvalue' VALUES (138, 'video/x-pv-pvx');
INSERT INTO 'devicecapvalue' VALUES (227, 6, 41, 138);
INSERT INTO 'capvalue' VALUES (139, 'video/x-siemens-mjpeg');
INSERT INTO 'devicecapvalue' VALUES (228, 6, 41, 139);
INSERT INTO 'devicecapvalue' VALUES (229, 6, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (230, 6, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (231, 6, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (232, 6, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (233, 6, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (234, 6, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (235, 6, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (236, 6, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (237, 6, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (238, 6, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (239, 6, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (240, 6, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (241, 6, 42, 128);
INSERT INTO 'devicecapvalue' VALUES (242, 6, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (243, 6, 42, 130);
INSERT INTO 'devicecapvalue' VALUES (244, 6, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (245, 6, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (246, 6, 42, 133);
INSERT INTO 'devicecapvalue' VALUES (247, 6, 42, 134);
INSERT INTO 'devicecapvalue' VALUES (248, 6, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (249, 6, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (250, 6, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (251, 6, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (252, 6, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (253, 6, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (254, 6, 42, 123);
INSERT INTO 'devicecapvalue' VALUES (255, 6, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (256, 6, 42, 137);
INSERT INTO 'devicecapvalue' VALUES (257, 6, 42, 138);
INSERT INTO 'devicecapvalue' VALUES (258, 6, 42, 139);
INSERT INTO 'devicecapvalue' VALUES (259, 6, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (260, 6, 44, 15);
INSERT INTO 'capvalue' VALUES (140, 'encoding=3gpp encoding=h263-2000 encoding=3gp');
INSERT INTO 'devicecapvalue' VALUES (261, 6, 45, 140);
INSERT INTO 'devicecapvalue' VALUES (262, 6, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (263, 6, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (264, 6, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (265, 6, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (266, 6, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (267, 6, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (268, 6, 46, 78);
INSERT INTO 'capvalue' VALUES (141, 'microedition.location.version');
INSERT INTO 'devicecapvalue' VALUES (269, 6, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (270, 6, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (271, 6, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (272, 6, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (273, 6, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (274, 6, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (275, 6, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (276, 6, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (277, 6, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (278, 6, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (279, 6, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (280, 6, 46, 89);
INSERT INTO 'capvalue' VALUES (142, 'wireless.messaging.sms.smsc');
INSERT INTO 'devicecapvalue' VALUES (281, 6, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (282, 6, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (283, 6, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (284, 6, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (285, 6, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (286, 6, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (287, 6, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (288, 6, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (289, 6, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (290, 6, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (291, 6, 47, 123);
INSERT INTO 'devicecapvalue' VALUES (292, 6, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (293, 6, 47, 137);
INSERT INTO 'devicecapvalue' VALUES (294, 6, 47, 138);
INSERT INTO 'cap' VALUES (55, 'siemens-colorgame-api', 1);
INSERT INTO 'capvalue' VALUES (143, 'no');
INSERT INTO 'devicecapvalue' VALUES (295, 6, 55, 143);
INSERT INTO 'capvalue' VALUES (144, 'GMT+01:00');
INSERT INTO 'devicecapvalue' VALUES (296, 6, 48, 144);
INSERT INTO 'capvalue' VALUES (145, 'GMT+01:00#1');
INSERT INTO 'devicecapvalue' VALUES (297, 6, 48, 145);
INSERT INTO 'capvalue' VALUES (146, 'GMT+01:00#2');
INSERT INTO 'devicecapvalue' VALUES (298, 6, 48, 146);
INSERT INTO 'capvalue' VALUES (147, 'GMT+02:00');
INSERT INTO 'devicecapvalue' VALUES (299, 6, 48, 147);
INSERT INTO 'capvalue' VALUES (148, 'GMT+02:00#1');
INSERT INTO 'devicecapvalue' VALUES (300, 6, 48, 148);
INSERT INTO 'capvalue' VALUES (149, 'GMT+02:00#2');
INSERT INTO 'devicecapvalue' VALUES (301, 6, 48, 149);
INSERT INTO 'capvalue' VALUES (150, 'GMT+02:00#3');
INSERT INTO 'devicecapvalue' VALUES (302, 6, 48, 150);
INSERT INTO 'capvalue' VALUES (151, 'GMT+02:00#4');
INSERT INTO 'devicecapvalue' VALUES (303, 6, 48, 151);
INSERT INTO 'capvalue' VALUES (152, 'GMT+02:00#5');
INSERT INTO 'devicecapvalue' VALUES (304, 6, 48, 152);
INSERT INTO 'capvalue' VALUES (153, 'GMT+02:00#6');
INSERT INTO 'devicecapvalue' VALUES (305, 6, 48, 153);
INSERT INTO 'capvalue' VALUES (154, 'GMT+02:00#7');
INSERT INTO 'devicecapvalue' VALUES (306, 6, 48, 154);
INSERT INTO 'capvalue' VALUES (155, 'GMT+03:00');
INSERT INTO 'devicecapvalue' VALUES (307, 6, 48, 155);
INSERT INTO 'capvalue' VALUES (156, 'GMT+03:00#1');
INSERT INTO 'devicecapvalue' VALUES (308, 6, 48, 156);
INSERT INTO 'capvalue' VALUES (157, 'GMT+03:00#2');
INSERT INTO 'devicecapvalue' VALUES (309, 6, 48, 157);
INSERT INTO 'capvalue' VALUES (158, 'GMT+03:30');
INSERT INTO 'devicecapvalue' VALUES (310, 6, 48, 158);
INSERT INTO 'capvalue' VALUES (159, 'GMT+03:30#1');
INSERT INTO 'devicecapvalue' VALUES (311, 6, 48, 159);
INSERT INTO 'capvalue' VALUES (160, 'GMT+04:00');
INSERT INTO 'devicecapvalue' VALUES (312, 6, 48, 160);
INSERT INTO 'capvalue' VALUES (161, 'GMT+04:00#1');
INSERT INTO 'devicecapvalue' VALUES (313, 6, 48, 161);
INSERT INTO 'capvalue' VALUES (162, 'GMT+04:00#2');
INSERT INTO 'devicecapvalue' VALUES (314, 6, 48, 162);
INSERT INTO 'capvalue' VALUES (163, 'GMT+04:30');
INSERT INTO 'devicecapvalue' VALUES (315, 6, 48, 163);
INSERT INTO 'capvalue' VALUES (164, 'GMT+05:00');
INSERT INTO 'devicecapvalue' VALUES (316, 6, 48, 164);
INSERT INTO 'capvalue' VALUES (165, 'GMT+05:00#1');
INSERT INTO 'devicecapvalue' VALUES (317, 6, 48, 165);
INSERT INTO 'capvalue' VALUES (166, 'GMT+05:00#2');
INSERT INTO 'devicecapvalue' VALUES (318, 6, 48, 166);
INSERT INTO 'capvalue' VALUES (167, 'GMT+05:30');
INSERT INTO 'devicecapvalue' VALUES (319, 6, 48, 167);
INSERT INTO 'capvalue' VALUES (168, 'GMT+05:45');
INSERT INTO 'devicecapvalue' VALUES (320, 6, 48, 168);
INSERT INTO 'capvalue' VALUES (169, 'GMT+06:00');
INSERT INTO 'devicecapvalue' VALUES (321, 6, 48, 169);
INSERT INTO 'capvalue' VALUES (170, 'GMT+06:00#1');
INSERT INTO 'devicecapvalue' VALUES (322, 6, 48, 170);
INSERT INTO 'capvalue' VALUES (171, 'GMT+06:30');
INSERT INTO 'devicecapvalue' VALUES (323, 6, 48, 171);
INSERT INTO 'capvalue' VALUES (172, 'GMT+07:00');
INSERT INTO 'devicecapvalue' VALUES (324, 6, 48, 172);
INSERT INTO 'capvalue' VALUES (173, 'GMT+07:00#1');
INSERT INTO 'devicecapvalue' VALUES (325, 6, 48, 173);
INSERT INTO 'capvalue' VALUES (174, 'GMT+08:00');
INSERT INTO 'devicecapvalue' VALUES (326, 6, 48, 174);
INSERT INTO 'capvalue' VALUES (175, 'GMT+08:00#1');
INSERT INTO 'devicecapvalue' VALUES (327, 6, 48, 175);
INSERT INTO 'capvalue' VALUES (176, 'GMT+09:00');
INSERT INTO 'devicecapvalue' VALUES (328, 6, 48, 176);
INSERT INTO 'capvalue' VALUES (177, 'GMT+09:30');
INSERT INTO 'devicecapvalue' VALUES (329, 6, 48, 177);
INSERT INTO 'capvalue' VALUES (178, 'GMT+09:30#1');
INSERT INTO 'devicecapvalue' VALUES (330, 6, 48, 178);
INSERT INTO 'capvalue' VALUES (179, 'GMT+10:00');
INSERT INTO 'devicecapvalue' VALUES (331, 6, 48, 179);
INSERT INTO 'capvalue' VALUES (180, 'GMT+10:00#1');
INSERT INTO 'devicecapvalue' VALUES (332, 6, 48, 180);
INSERT INTO 'capvalue' VALUES (181, 'GMT+10:00#2');
INSERT INTO 'devicecapvalue' VALUES (333, 6, 48, 181);
INSERT INTO 'capvalue' VALUES (182, 'GMT+10:00#3');
INSERT INTO 'devicecapvalue' VALUES (334, 6, 48, 182);
INSERT INTO 'capvalue' VALUES (183, 'GMT+10:30');
INSERT INTO 'devicecapvalue' VALUES (335, 6, 48, 183);
INSERT INTO 'capvalue' VALUES (184, 'GMT+10:30#1');
INSERT INTO 'devicecapvalue' VALUES (336, 6, 48, 184);
INSERT INTO 'capvalue' VALUES (185, 'GMT+11:00');
INSERT INTO 'devicecapvalue' VALUES (337, 6, 48, 185);
INSERT INTO 'capvalue' VALUES (186, 'GMT+11:00#1');
INSERT INTO 'devicecapvalue' VALUES (338, 6, 48, 186);
INSERT INTO 'capvalue' VALUES (187, 'GMT+11:30');
INSERT INTO 'devicecapvalue' VALUES (339, 6, 48, 187);
INSERT INTO 'capvalue' VALUES (188, 'GMT+12:00');
INSERT INTO 'devicecapvalue' VALUES (340, 6, 48, 188);
INSERT INTO 'capvalue' VALUES (189, 'GMT+12:00#1');
INSERT INTO 'devicecapvalue' VALUES (341, 6, 48, 189);
INSERT INTO 'capvalue' VALUES (190, 'GMT+12:00#2');
INSERT INTO 'devicecapvalue' VALUES (342, 6, 48, 190);
INSERT INTO 'capvalue' VALUES (191, 'GMT+12:45');
INSERT INTO 'devicecapvalue' VALUES (343, 6, 48, 191);
INSERT INTO 'capvalue' VALUES (192, 'GMT+12:45#1');
INSERT INTO 'devicecapvalue' VALUES (344, 6, 48, 192);
INSERT INTO 'capvalue' VALUES (193, 'GMT+13:00');
INSERT INTO 'devicecapvalue' VALUES (345, 6, 48, 193);
INSERT INTO 'capvalue' VALUES (194, 'GMT+13:00#1');
INSERT INTO 'devicecapvalue' VALUES (346, 6, 48, 194);
INSERT INTO 'capvalue' VALUES (195, 'GMT+14:00');
INSERT INTO 'devicecapvalue' VALUES (347, 6, 48, 195);
INSERT INTO 'capvalue' VALUES (196, 'GMT-00:00');
INSERT INTO 'devicecapvalue' VALUES (348, 6, 48, 196);
INSERT INTO 'capvalue' VALUES (197, 'GMT-00:00#1');
INSERT INTO 'devicecapvalue' VALUES (349, 6, 48, 197);
INSERT INTO 'capvalue' VALUES (198, 'GMT-01:00');
INSERT INTO 'devicecapvalue' VALUES (350, 6, 48, 198);
INSERT INTO 'capvalue' VALUES (199, 'GMT-01:00#1');
INSERT INTO 'devicecapvalue' VALUES (351, 6, 48, 199);
INSERT INTO 'capvalue' VALUES (200, 'GMT-02:00');
INSERT INTO 'devicecapvalue' VALUES (352, 6, 48, 200);
INSERT INTO 'capvalue' VALUES (201, 'GMT-03:00');
INSERT INTO 'devicecapvalue' VALUES (353, 6, 48, 201);
INSERT INTO 'capvalue' VALUES (202, 'GMT-03:00#1');
INSERT INTO 'devicecapvalue' VALUES (354, 6, 48, 202);
INSERT INTO 'capvalue' VALUES (203, 'GMT-03:00#2');
INSERT INTO 'devicecapvalue' VALUES (355, 6, 48, 203);
INSERT INTO 'capvalue' VALUES (204, 'GMT-03:30');
INSERT INTO 'devicecapvalue' VALUES (356, 6, 48, 204);
INSERT INTO 'capvalue' VALUES (205, 'GMT-03:30#1');
INSERT INTO 'devicecapvalue' VALUES (357, 6, 48, 205);
INSERT INTO 'capvalue' VALUES (206, 'GMT-04:00');
INSERT INTO 'devicecapvalue' VALUES (358, 6, 48, 206);
INSERT INTO 'capvalue' VALUES (207, 'GMT-04:00#1');
INSERT INTO 'devicecapvalue' VALUES (359, 6, 48, 207);
INSERT INTO 'capvalue' VALUES (208, 'GMT-04:00#2');
INSERT INTO 'devicecapvalue' VALUES (360, 6, 48, 208);
INSERT INTO 'capvalue' VALUES (209, 'GMT-04:00#3');
INSERT INTO 'devicecapvalue' VALUES (361, 6, 48, 209);
INSERT INTO 'capvalue' VALUES (210, 'GMT-04:00#4');
INSERT INTO 'devicecapvalue' VALUES (362, 6, 48, 210);
INSERT INTO 'capvalue' VALUES (211, 'GMT-04:00#5');
INSERT INTO 'devicecapvalue' VALUES (363, 6, 48, 211);
INSERT INTO 'capvalue' VALUES (212, 'GMT-05:00');
INSERT INTO 'devicecapvalue' VALUES (364, 6, 48, 212);
INSERT INTO 'capvalue' VALUES (213, 'GMT-05:00#1');
INSERT INTO 'devicecapvalue' VALUES (365, 6, 48, 213);
INSERT INTO 'capvalue' VALUES (214, 'GMT-05:00#2');
INSERT INTO 'devicecapvalue' VALUES (366, 6, 48, 214);
INSERT INTO 'capvalue' VALUES (215, 'GMT-05:00#3');
INSERT INTO 'devicecapvalue' VALUES (367, 6, 48, 215);
INSERT INTO 'capvalue' VALUES (216, 'GMT-06:00');
INSERT INTO 'devicecapvalue' VALUES (368, 6, 48, 216);
INSERT INTO 'capvalue' VALUES (217, 'GMT-06:00#1');
INSERT INTO 'devicecapvalue' VALUES (369, 6, 48, 217);
INSERT INTO 'capvalue' VALUES (218, 'GMT-06:00#2');
INSERT INTO 'devicecapvalue' VALUES (370, 6, 48, 218);
INSERT INTO 'capvalue' VALUES (219, 'GMT-06:00#3');
INSERT INTO 'devicecapvalue' VALUES (371, 6, 48, 219);
INSERT INTO 'capvalue' VALUES (220, 'GMT-07:00');
INSERT INTO 'devicecapvalue' VALUES (372, 6, 48, 220);
INSERT INTO 'capvalue' VALUES (221, 'GMT-07:00#1');
INSERT INTO 'devicecapvalue' VALUES (373, 6, 48, 221);
INSERT INTO 'capvalue' VALUES (222, 'GMT-08:00');
INSERT INTO 'devicecapvalue' VALUES (374, 6, 48, 222);
INSERT INTO 'capvalue' VALUES (223, 'GMT-08:00#1');
INSERT INTO 'devicecapvalue' VALUES (375, 6, 48, 223);
INSERT INTO 'capvalue' VALUES (224, 'GMT-09:00');
INSERT INTO 'devicecapvalue' VALUES (376, 6, 48, 224);
INSERT INTO 'capvalue' VALUES (225, 'GMT-09:00#1');
INSERT INTO 'devicecapvalue' VALUES (377, 6, 48, 225);
INSERT INTO 'capvalue' VALUES (226, 'GMT-09:30');
INSERT INTO 'devicecapvalue' VALUES (378, 6, 48, 226);
INSERT INTO 'capvalue' VALUES (227, 'GMT-10:00');
INSERT INTO 'devicecapvalue' VALUES (379, 6, 48, 227);
INSERT INTO 'capvalue' VALUES (228, 'GMT-10:00#1');
INSERT INTO 'devicecapvalue' VALUES (380, 6, 48, 228);
INSERT INTO 'capvalue' VALUES (229, 'GMT-11:00');
INSERT INTO 'devicecapvalue' VALUES (381, 6, 48, 229);
INSERT INTO 'capvalue' VALUES (230, 'NITZ');
INSERT INTO 'devicecapvalue' VALUES (382, 6, 48, 230);
INSERT INTO 'capvalue' VALUES (231, '3670016');
INSERT INTO 'devicecapvalue' VALUES (383, 6, 49, 231);
INSERT INTO 'capvalue' VALUES (232, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; pl; rv:1.9.0.11) Gecko/2009060215 Firefox/3.0.11 (.NET CLR 3.5.30729)');
INSERT INTO 'devicecapvalue' VALUES (384, 6, 53, 232);
INSERT INTO 'cap' VALUES (56, 'alphalevels', 1);
INSERT INTO 'capvalue' VALUES (233, '2');
INSERT INTO 'devicecapvalue' VALUES (385, 7, 56, 233);
INSERT INTO 'capvalue' VALUES (234, '240x266');
INSERT INTO 'devicecapvalue' VALUES (386, 7, 7, 234);
INSERT INTO 'capvalue' VALUES (235, '32768');
INSERT INTO 'devicecapvalue' VALUES (387, 7, 8, 235);
INSERT INTO 'capvalue' VALUES (236, 'doubleBuffering');
INSERT INTO 'devicecapvalue' VALUES (388, 7, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (389, 7, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (390, 7, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (391, 7, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (392, 7, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (393, 7, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (394, 7, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (395, 7, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (396, 7, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (397, 7, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (398, 7, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (399, 7, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (400, 7, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (401, 7, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (402, 7, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (403, 7, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (404, 7, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (405, 7, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (406, 7, 6, 27);
INSERT INTO 'capvalue' VALUES (237, '35');
INSERT INTO 'devicecapvalue' VALUES (407, 7, 18, 237);
INSERT INTO 'devicecapvalue' VALUES (408, 7, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (409, 7, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (410, 7, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (411, 7, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (412, 7, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (413, 7, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (414, 7, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (415, 7, 26, 237);
INSERT INTO 'devicecapvalue' VALUES (416, 7, 27, 237);
INSERT INTO 'cap' VALUES (57, 'key.returnsoftkey', 1);
INSERT INTO 'devicecapvalue' VALUES (417, 7, 57, 237);
INSERT INTO 'devicecapvalue' VALUES (418, 7, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (419, 7, 30, 237);
INSERT INTO 'devicecapvalue' VALUES (420, 7, 54, 237);
INSERT INTO 'devicecapvalue' VALUES (421, 7, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (422, 7, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (423, 7, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (424, 7, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (425, 7, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (426, 7, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (427, 7, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (428, 7, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (429, 7, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (430, 7, 44, 15);
INSERT INTO 'cap' VALUES (58, 'objectmemory', 1);
INSERT INTO 'capvalue' VALUES (238, '4');
INSERT INTO 'devicecapvalue' VALUES (431, 7, 58, 238);
INSERT INTO 'devicecapvalue' VALUES (432, 7, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (433, 7, 46, 74);
INSERT INTO 'capvalue' VALUES (239, 'microedition.contactless.version');
INSERT INTO 'devicecapvalue' VALUES (434, 7, 46, 239);
INSERT INTO 'devicecapvalue' VALUES (435, 7, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (436, 7, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (437, 7, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (438, 7, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (439, 7, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (440, 7, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (441, 7, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (442, 7, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (443, 7, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (444, 7, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (445, 7, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (446, 7, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (447, 7, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (448, 7, 46, 142);
INSERT INTO 'cap' VALUES (59, 'property.file.separator', 1);
INSERT INTO 'capvalue' VALUES (240, '\');
INSERT INTO 'devicecapvalue' VALUES (449, 7, 59, 240);
INSERT INTO 'cap' VALUES (60, 'property.microedition.configuration', 1);
INSERT INTO 'devicecapvalue' VALUES (450, 7, 60, 43);
INSERT INTO 'cap' VALUES (61, 'property.microedition.contactless.version', 1);
INSERT INTO 'devicecapvalue' VALUES (451, 7, 61, 45);
INSERT INTO 'cap' VALUES (62, 'property.microedition.encoding', 1);
INSERT INTO 'capvalue' VALUES (241, 'ISO-8859-1');
INSERT INTO 'devicecapvalue' VALUES (452, 7, 62, 241);
INSERT INTO 'cap' VALUES (63, 'property.microedition.io.file.fileconnection.version', 1);
INSERT INTO 'devicecapvalue' VALUES (453, 7, 63, 45);
INSERT INTO 'cap' VALUES (64, 'property.microedition.jtwi.version', 1);
INSERT INTO 'devicecapvalue' VALUES (454, 7, 64, 45);
INSERT INTO 'cap' VALUES (65, 'property.microedition.m3g.version', 1);
INSERT INTO 'capvalue' VALUES (242, '1.1');
INSERT INTO 'devicecapvalue' VALUES (455, 7, 65, 242);
INSERT INTO 'cap' VALUES (66, 'property.microedition.media.version', 1);
INSERT INTO 'devicecapvalue' VALUES (456, 7, 66, 242);
INSERT INTO 'cap' VALUES (67, 'property.microedition.pim.version', 1);
INSERT INTO 'devicecapvalue' VALUES (457, 7, 67, 45);
INSERT INTO 'cap' VALUES (68, 'property.microedition.platform', 1);
INSERT INTO 'capvalue' VALUES (243, 'j2me');
INSERT INTO 'devicecapvalue' VALUES (458, 7, 68, 243);
INSERT INTO 'cap' VALUES (69, 'property.microedition.profiles', 1);
INSERT INTO 'devicecapvalue' VALUES (459, 7, 69, 47);
INSERT INTO 'cap' VALUES (70, 'property.supports.mixing', 1);
INSERT INTO 'devicecapvalue' VALUES (460, 7, 70, 15);
INSERT INTO 'cap' VALUES (71, 'property.supports.recording', 1);
INSERT INTO 'capvalue' VALUES (244, 'false');
INSERT INTO 'devicecapvalue' VALUES (461, 7, 71, 244);
INSERT INTO 'cap' VALUES (72, 'property.wireless.messaging.sms.smsc', 1);
INSERT INTO 'devicecapvalue' VALUES (462, 7, 72, 242);
INSERT INTO 'cap' VALUES (73, 'protocol.resource', 1);
INSERT INTO 'devicecapvalue' VALUES (463, 7, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (464, 7, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (465, 7, 73, 51);
INSERT INTO 'capvalue' VALUES (245, 'ACT');
INSERT INTO 'devicecapvalue' VALUES (466, 7, 48, 245);
INSERT INTO 'capvalue' VALUES (246, 'AET');
INSERT INTO 'devicecapvalue' VALUES (467, 7, 48, 246);
INSERT INTO 'capvalue' VALUES (247, 'AGT');
INSERT INTO 'devicecapvalue' VALUES (468, 7, 48, 247);
INSERT INTO 'capvalue' VALUES (248, 'ART');
INSERT INTO 'devicecapvalue' VALUES (469, 7, 48, 248);
INSERT INTO 'capvalue' VALUES (249, 'AST');
INSERT INTO 'devicecapvalue' VALUES (470, 7, 48, 249);
INSERT INTO 'capvalue' VALUES (250, 'Africa/Abidjan');
INSERT INTO 'devicecapvalue' VALUES (471, 7, 48, 250);
INSERT INTO 'capvalue' VALUES (251, 'Africa/Accra');
INSERT INTO 'devicecapvalue' VALUES (472, 7, 48, 251);
INSERT INTO 'capvalue' VALUES (252, 'Africa/Addis_Ababa');
INSERT INTO 'devicecapvalue' VALUES (473, 7, 48, 252);
INSERT INTO 'capvalue' VALUES (253, 'Africa/Algiers');
INSERT INTO 'devicecapvalue' VALUES (474, 7, 48, 253);
INSERT INTO 'capvalue' VALUES (254, 'Africa/Asmera');
INSERT INTO 'devicecapvalue' VALUES (475, 7, 48, 254);
INSERT INTO 'capvalue' VALUES (255, 'Africa/Bangui');
INSERT INTO 'devicecapvalue' VALUES (476, 7, 48, 255);
INSERT INTO 'capvalue' VALUES (256, 'Africa/Banjul');
INSERT INTO 'devicecapvalue' VALUES (477, 7, 48, 256);
INSERT INTO 'capvalue' VALUES (257, 'Africa/Bissau');
INSERT INTO 'devicecapvalue' VALUES (478, 7, 48, 257);
INSERT INTO 'capvalue' VALUES (258, 'Africa/Blantyre');
INSERT INTO 'devicecapvalue' VALUES (479, 7, 48, 258);
INSERT INTO 'capvalue' VALUES (259, 'Africa/Bujumbura');
INSERT INTO 'devicecapvalue' VALUES (480, 7, 48, 259);
INSERT INTO 'capvalue' VALUES (260, 'Africa/Cairo');
INSERT INTO 'devicecapvalue' VALUES (481, 7, 48, 260);
INSERT INTO 'capvalue' VALUES (261, 'Africa/Casablanca');
INSERT INTO 'devicecapvalue' VALUES (482, 7, 48, 261);
INSERT INTO 'capvalue' VALUES (262, 'Africa/Conakry');
INSERT INTO 'devicecapvalue' VALUES (483, 7, 48, 262);
INSERT INTO 'capvalue' VALUES (263, 'Africa/Dakar');
INSERT INTO 'devicecapvalue' VALUES (484, 7, 48, 263);
INSERT INTO 'capvalue' VALUES (264, 'Africa/Dar_es_Salaam');
INSERT INTO 'devicecapvalue' VALUES (485, 7, 48, 264);
INSERT INTO 'capvalue' VALUES (265, 'Africa/Djibouti');
INSERT INTO 'devicecapvalue' VALUES (486, 7, 48, 265);
INSERT INTO 'capvalue' VALUES (266, 'Africa/Douala');
INSERT INTO 'devicecapvalue' VALUES (487, 7, 48, 266);
INSERT INTO 'capvalue' VALUES (267, 'Africa/Freetown');
INSERT INTO 'devicecapvalue' VALUES (488, 7, 48, 267);
INSERT INTO 'capvalue' VALUES (268, 'Africa/Gaborone');
INSERT INTO 'devicecapvalue' VALUES (489, 7, 48, 268);
INSERT INTO 'capvalue' VALUES (269, 'Africa/Harare');
INSERT INTO 'devicecapvalue' VALUES (490, 7, 48, 269);
INSERT INTO 'capvalue' VALUES (270, 'Africa/Johannesburg');
INSERT INTO 'devicecapvalue' VALUES (491, 7, 48, 270);
INSERT INTO 'capvalue' VALUES (271, 'Africa/Kampala');
INSERT INTO 'devicecapvalue' VALUES (492, 7, 48, 271);
INSERT INTO 'capvalue' VALUES (272, 'Africa/Khartoum');
INSERT INTO 'devicecapvalue' VALUES (493, 7, 48, 272);
INSERT INTO 'capvalue' VALUES (273, 'Africa/Kigali');
INSERT INTO 'devicecapvalue' VALUES (494, 7, 48, 273);
INSERT INTO 'capvalue' VALUES (274, 'Africa/Kinshasa');
INSERT INTO 'devicecapvalue' VALUES (495, 7, 48, 274);
INSERT INTO 'capvalue' VALUES (275, 'Africa/Lagos');
INSERT INTO 'devicecapvalue' VALUES (496, 7, 48, 275);
INSERT INTO 'capvalue' VALUES (276, 'Africa/Libreville');
INSERT INTO 'devicecapvalue' VALUES (497, 7, 48, 276);
INSERT INTO 'capvalue' VALUES (277, 'Africa/Lome');
INSERT INTO 'devicecapvalue' VALUES (498, 7, 48, 277);
INSERT INTO 'capvalue' VALUES (278, 'Africa/Luanda');
INSERT INTO 'devicecapvalue' VALUES (499, 7, 48, 278);
INSERT INTO 'capvalue' VALUES (279, 'Africa/Lubumbashi');
INSERT INTO 'devicecapvalue' VALUES (500, 7, 48, 279);
INSERT INTO 'capvalue' VALUES (280, 'Africa/Lusaka');
INSERT INTO 'devicecapvalue' VALUES (501, 7, 48, 280);
INSERT INTO 'capvalue' VALUES (281, 'Africa/Malabo');
INSERT INTO 'devicecapvalue' VALUES (502, 7, 48, 281);
INSERT INTO 'capvalue' VALUES (282, 'Africa/Maputo');
INSERT INTO 'devicecapvalue' VALUES (503, 7, 48, 282);
INSERT INTO 'capvalue' VALUES (283, 'Africa/Maseru');
INSERT INTO 'devicecapvalue' VALUES (504, 7, 48, 283);
INSERT INTO 'capvalue' VALUES (284, 'Africa/Mbabane');
INSERT INTO 'devicecapvalue' VALUES (505, 7, 48, 284);
INSERT INTO 'capvalue' VALUES (285, 'Africa/Mogadishu');
INSERT INTO 'devicecapvalue' VALUES (506, 7, 48, 285);
INSERT INTO 'capvalue' VALUES (286, 'Africa/Monrovia');
INSERT INTO 'devicecapvalue' VALUES (507, 7, 48, 286);
INSERT INTO 'capvalue' VALUES (287, 'Africa/Nairobi');
INSERT INTO 'devicecapvalue' VALUES (508, 7, 48, 287);
INSERT INTO 'capvalue' VALUES (288, 'Africa/Ndjamena');
INSERT INTO 'devicecapvalue' VALUES (509, 7, 48, 288);
INSERT INTO 'capvalue' VALUES (289, 'Africa/Niamey');
INSERT INTO 'devicecapvalue' VALUES (510, 7, 48, 289);
INSERT INTO 'capvalue' VALUES (290, 'Africa/Nouakchott');
INSERT INTO 'devicecapvalue' VALUES (511, 7, 48, 290);
INSERT INTO 'capvalue' VALUES (291, 'Africa/Ouagadougou');
INSERT INTO 'devicecapvalue' VALUES (512, 7, 48, 291);
INSERT INTO 'capvalue' VALUES (292, 'Africa/Porto-Novo');
INSERT INTO 'devicecapvalue' VALUES (513, 7, 48, 292);
INSERT INTO 'capvalue' VALUES (293, 'Africa/Sao_Tome');
INSERT INTO 'devicecapvalue' VALUES (514, 7, 48, 293);
INSERT INTO 'capvalue' VALUES (294, 'Africa/Timbuktu');
INSERT INTO 'devicecapvalue' VALUES (515, 7, 48, 294);
INSERT INTO 'capvalue' VALUES (295, 'Africa/Tripoli');
INSERT INTO 'devicecapvalue' VALUES (516, 7, 48, 295);
INSERT INTO 'capvalue' VALUES (296, 'Africa/Tunis');
INSERT INTO 'devicecapvalue' VALUES (517, 7, 48, 296);
INSERT INTO 'capvalue' VALUES (297, 'Africa/Windhoek');
INSERT INTO 'devicecapvalue' VALUES (518, 7, 48, 297);
INSERT INTO 'capvalue' VALUES (298, 'America/Adak');
INSERT INTO 'devicecapvalue' VALUES (519, 7, 48, 298);
INSERT INTO 'capvalue' VALUES (299, 'America/Anchorage');
INSERT INTO 'devicecapvalue' VALUES (520, 7, 48, 299);
INSERT INTO 'capvalue' VALUES (300, 'America/Anguilla');
INSERT INTO 'devicecapvalue' VALUES (521, 7, 48, 300);
INSERT INTO 'capvalue' VALUES (301, 'America/Antigua');
INSERT INTO 'devicecapvalue' VALUES (522, 7, 48, 301);
INSERT INTO 'capvalue' VALUES (302, 'America/Aruba');
INSERT INTO 'devicecapvalue' VALUES (523, 7, 48, 302);
INSERT INTO 'capvalue' VALUES (303, 'America/Asuncion');
INSERT INTO 'devicecapvalue' VALUES (524, 7, 48, 303);
INSERT INTO 'capvalue' VALUES (304, 'America/Barbados');
INSERT INTO 'devicecapvalue' VALUES (525, 7, 48, 304);
INSERT INTO 'capvalue' VALUES (305, 'America/Belize');
INSERT INTO 'devicecapvalue' VALUES (526, 7, 48, 305);
INSERT INTO 'capvalue' VALUES (306, 'America/Bogota');
INSERT INTO 'devicecapvalue' VALUES (527, 7, 48, 306);
INSERT INTO 'capvalue' VALUES (307, 'America/Buenos_Aires');
INSERT INTO 'devicecapvalue' VALUES (528, 7, 48, 307);
INSERT INTO 'capvalue' VALUES (308, 'America/Caracas');
INSERT INTO 'devicecapvalue' VALUES (529, 7, 48, 308);
INSERT INTO 'capvalue' VALUES (309, 'America/Cayenne');
INSERT INTO 'devicecapvalue' VALUES (530, 7, 48, 309);
INSERT INTO 'capvalue' VALUES (310, 'America/Cayman');
INSERT INTO 'devicecapvalue' VALUES (531, 7, 48, 310);
INSERT INTO 'capvalue' VALUES (311, 'America/Chicago');
INSERT INTO 'devicecapvalue' VALUES (532, 7, 48, 311);
INSERT INTO 'capvalue' VALUES (312, 'America/Costa_Rica');
INSERT INTO 'devicecapvalue' VALUES (533, 7, 48, 312);
INSERT INTO 'capvalue' VALUES (313, 'America/Cuiaba');
INSERT INTO 'devicecapvalue' VALUES (534, 7, 48, 313);
INSERT INTO 'capvalue' VALUES (314, 'America/Curacao');
INSERT INTO 'devicecapvalue' VALUES (535, 7, 48, 314);
INSERT INTO 'capvalue' VALUES (315, 'America/Dawson_Creek');
INSERT INTO 'devicecapvalue' VALUES (536, 7, 48, 315);
INSERT INTO 'capvalue' VALUES (316, 'America/Denver');
INSERT INTO 'devicecapvalue' VALUES (537, 7, 48, 316);
INSERT INTO 'capvalue' VALUES (317, 'America/Dominica');
INSERT INTO 'devicecapvalue' VALUES (538, 7, 48, 317);
INSERT INTO 'capvalue' VALUES (318, 'America/Edmonton');
INSERT INTO 'devicecapvalue' VALUES (539, 7, 48, 318);
INSERT INTO 'capvalue' VALUES (319, 'America/El_Salvador');
INSERT INTO 'devicecapvalue' VALUES (540, 7, 48, 319);
INSERT INTO 'capvalue' VALUES (320, 'America/Fortaleza');
INSERT INTO 'devicecapvalue' VALUES (541, 7, 48, 320);
INSERT INTO 'capvalue' VALUES (321, 'America/Godthab');
INSERT INTO 'devicecapvalue' VALUES (542, 7, 48, 321);
INSERT INTO 'capvalue' VALUES (322, 'America/Grand_Turk');
INSERT INTO 'devicecapvalue' VALUES (543, 7, 48, 322);
INSERT INTO 'capvalue' VALUES (323, 'America/Grenada');
INSERT INTO 'devicecapvalue' VALUES (544, 7, 48, 323);
INSERT INTO 'capvalue' VALUES (324, 'America/Guadeloupe');
INSERT INTO 'devicecapvalue' VALUES (545, 7, 48, 324);
INSERT INTO 'capvalue' VALUES (325, 'America/Guatemala');
INSERT INTO 'devicecapvalue' VALUES (546, 7, 48, 325);
INSERT INTO 'capvalue' VALUES (326, 'America/Guayaquil');
INSERT INTO 'devicecapvalue' VALUES (547, 7, 48, 326);
INSERT INTO 'capvalue' VALUES (327, 'America/Guyana');
INSERT INTO 'devicecapvalue' VALUES (548, 7, 48, 327);
INSERT INTO 'capvalue' VALUES (328, 'America/Halifax');
INSERT INTO 'devicecapvalue' VALUES (549, 7, 48, 328);
INSERT INTO 'capvalue' VALUES (329, 'America/Havana');
INSERT INTO 'devicecapvalue' VALUES (550, 7, 48, 329);
INSERT INTO 'capvalue' VALUES (330, 'America/Indianapolis');
INSERT INTO 'devicecapvalue' VALUES (551, 7, 48, 330);
INSERT INTO 'capvalue' VALUES (331, 'America/Jamaica');
INSERT INTO 'devicecapvalue' VALUES (552, 7, 48, 331);
INSERT INTO 'capvalue' VALUES (332, 'America/La_Paz');
INSERT INTO 'devicecapvalue' VALUES (553, 7, 48, 332);
INSERT INTO 'capvalue' VALUES (333, 'America/Lima');
INSERT INTO 'devicecapvalue' VALUES (554, 7, 48, 333);
INSERT INTO 'capvalue' VALUES (334, 'America/Los_Angeles');
INSERT INTO 'devicecapvalue' VALUES (555, 7, 48, 334);
INSERT INTO 'capvalue' VALUES (335, 'America/Managua');
INSERT INTO 'devicecapvalue' VALUES (556, 7, 48, 335);
INSERT INTO 'capvalue' VALUES (336, 'America/Manaus');
INSERT INTO 'devicecapvalue' VALUES (557, 7, 48, 336);
INSERT INTO 'capvalue' VALUES (337, 'America/Martinique');
INSERT INTO 'devicecapvalue' VALUES (558, 7, 48, 337);
INSERT INTO 'capvalue' VALUES (338, 'America/Mazatlan');
INSERT INTO 'devicecapvalue' VALUES (559, 7, 48, 338);
INSERT INTO 'capvalue' VALUES (339, 'America/Mexico_City');
INSERT INTO 'devicecapvalue' VALUES (560, 7, 48, 339);
INSERT INTO 'capvalue' VALUES (340, 'America/Miquelon');
INSERT INTO 'devicecapvalue' VALUES (561, 7, 48, 340);
INSERT INTO 'capvalue' VALUES (341, 'America/Montevideo');
INSERT INTO 'devicecapvalue' VALUES (562, 7, 48, 341);
INSERT INTO 'capvalue' VALUES (342, 'America/Montreal');
INSERT INTO 'devicecapvalue' VALUES (563, 7, 48, 342);
INSERT INTO 'capvalue' VALUES (343, 'America/Montserrat');
INSERT INTO 'devicecapvalue' VALUES (564, 7, 48, 343);
INSERT INTO 'capvalue' VALUES (344, 'America/Nassau');
INSERT INTO 'devicecapvalue' VALUES (565, 7, 48, 344);
INSERT INTO 'capvalue' VALUES (345, 'America/New_York');
INSERT INTO 'devicecapvalue' VALUES (566, 7, 48, 345);
INSERT INTO 'capvalue' VALUES (346, 'America/Noronha');
INSERT INTO 'devicecapvalue' VALUES (567, 7, 48, 346);
INSERT INTO 'capvalue' VALUES (347, 'America/Panama');
INSERT INTO 'devicecapvalue' VALUES (568, 7, 48, 347);
INSERT INTO 'capvalue' VALUES (348, 'America/Paramaribo');
INSERT INTO 'devicecapvalue' VALUES (569, 7, 48, 348);
INSERT INTO 'capvalue' VALUES (349, 'America/Phoenix');
INSERT INTO 'devicecapvalue' VALUES (570, 7, 48, 349);
INSERT INTO 'capvalue' VALUES (350, 'America/Port-au-Prince');
INSERT INTO 'devicecapvalue' VALUES (571, 7, 48, 350);
INSERT INTO 'capvalue' VALUES (351, 'America/Port_of_Spain');
INSERT INTO 'devicecapvalue' VALUES (572, 7, 48, 351);
INSERT INTO 'capvalue' VALUES (352, 'America/Porto_Acre');
INSERT INTO 'devicecapvalue' VALUES (573, 7, 48, 352);
INSERT INTO 'capvalue' VALUES (353, 'America/Puerto_Rico');
INSERT INTO 'devicecapvalue' VALUES (574, 7, 48, 353);
INSERT INTO 'capvalue' VALUES (354, 'America/Regina');
INSERT INTO 'devicecapvalue' VALUES (575, 7, 48, 354);
INSERT INTO 'capvalue' VALUES (355, 'America/Santiago');
INSERT INTO 'devicecapvalue' VALUES (576, 7, 48, 355);
INSERT INTO 'capvalue' VALUES (356, 'America/Santo_Domingo');
INSERT INTO 'devicecapvalue' VALUES (577, 7, 48, 356);
INSERT INTO 'capvalue' VALUES (357, 'America/Sao_Paulo');
INSERT INTO 'devicecapvalue' VALUES (578, 7, 48, 357);
INSERT INTO 'capvalue' VALUES (358, 'America/Scoresbysund');
INSERT INTO 'devicecapvalue' VALUES (579, 7, 48, 358);
INSERT INTO 'capvalue' VALUES (359, 'America/St_Johns');
INSERT INTO 'devicecapvalue' VALUES (580, 7, 48, 359);
INSERT INTO 'capvalue' VALUES (360, 'America/St_Kitts');
INSERT INTO 'devicecapvalue' VALUES (581, 7, 48, 360);
INSERT INTO 'capvalue' VALUES (361, 'America/St_Lucia');
INSERT INTO 'devicecapvalue' VALUES (582, 7, 48, 361);
INSERT INTO 'capvalue' VALUES (362, 'America/St_Thomas');
INSERT INTO 'devicecapvalue' VALUES (583, 7, 48, 362);
INSERT INTO 'capvalue' VALUES (363, 'America/St_Vincent');
INSERT INTO 'devicecapvalue' VALUES (584, 7, 48, 363);
INSERT INTO 'capvalue' VALUES (364, 'America/Tegucigalpa');
INSERT INTO 'devicecapvalue' VALUES (585, 7, 48, 364);
INSERT INTO 'capvalue' VALUES (365, 'America/Thule');
INSERT INTO 'devicecapvalue' VALUES (586, 7, 48, 365);
INSERT INTO 'capvalue' VALUES (366, 'America/Tijuana');
INSERT INTO 'devicecapvalue' VALUES (587, 7, 48, 366);
INSERT INTO 'capvalue' VALUES (367, 'America/Tortola');
INSERT INTO 'devicecapvalue' VALUES (588, 7, 48, 367);
INSERT INTO 'capvalue' VALUES (368, 'America/Vancouver');
INSERT INTO 'devicecapvalue' VALUES (589, 7, 48, 368);
INSERT INTO 'capvalue' VALUES (369, 'America/Winnipeg');
INSERT INTO 'devicecapvalue' VALUES (590, 7, 48, 369);
INSERT INTO 'capvalue' VALUES (370, 'Antarctica/Casey');
INSERT INTO 'devicecapvalue' VALUES (591, 7, 48, 370);
INSERT INTO 'capvalue' VALUES (371, 'Antarctica/DumontDUrville');
INSERT INTO 'devicecapvalue' VALUES (592, 7, 48, 371);
INSERT INTO 'capvalue' VALUES (372, 'Antarctica/Mawson');
INSERT INTO 'devicecapvalue' VALUES (593, 7, 48, 372);
INSERT INTO 'capvalue' VALUES (373, 'Antarctica/McMurdo');
INSERT INTO 'devicecapvalue' VALUES (594, 7, 48, 373);
INSERT INTO 'capvalue' VALUES (374, 'Antarctica/Palmer');
INSERT INTO 'devicecapvalue' VALUES (595, 7, 48, 374);
INSERT INTO 'capvalue' VALUES (375, 'Asia/Aden');
INSERT INTO 'devicecapvalue' VALUES (596, 7, 48, 375);
INSERT INTO 'capvalue' VALUES (376, 'Asia/Alma-Ata');
INSERT INTO 'devicecapvalue' VALUES (597, 7, 48, 376);
INSERT INTO 'capvalue' VALUES (377, 'Asia/Amman');
INSERT INTO 'devicecapvalue' VALUES (598, 7, 48, 377);
INSERT INTO 'capvalue' VALUES (378, 'Asia/Anadyr');
INSERT INTO 'devicecapvalue' VALUES (599, 7, 48, 378);
INSERT INTO 'capvalue' VALUES (379, 'Asia/Aqtau');
INSERT INTO 'devicecapvalue' VALUES (600, 7, 48, 379);
INSERT INTO 'capvalue' VALUES (380, 'Asia/Aqtobe');
INSERT INTO 'devicecapvalue' VALUES (601, 7, 48, 380);
INSERT INTO 'capvalue' VALUES (381, 'Asia/Ashkhabad');
INSERT INTO 'devicecapvalue' VALUES (602, 7, 48, 381);
INSERT INTO 'capvalue' VALUES (382, 'Asia/Baghdad');
INSERT INTO 'devicecapvalue' VALUES (603, 7, 48, 382);
INSERT INTO 'capvalue' VALUES (383, 'Asia/Bahrain');
INSERT INTO 'devicecapvalue' VALUES (604, 7, 48, 383);
INSERT INTO 'capvalue' VALUES (384, 'Asia/Baku');
INSERT INTO 'devicecapvalue' VALUES (605, 7, 48, 384);
INSERT INTO 'capvalue' VALUES (385, 'Asia/Bangkok');
INSERT INTO 'devicecapvalue' VALUES (606, 7, 48, 385);
INSERT INTO 'capvalue' VALUES (386, 'Asia/Beirut');
INSERT INTO 'devicecapvalue' VALUES (607, 7, 48, 386);
INSERT INTO 'capvalue' VALUES (387, 'Asia/Bishkek');
INSERT INTO 'devicecapvalue' VALUES (608, 7, 48, 387);
INSERT INTO 'capvalue' VALUES (388, 'Asia/Brunei');
INSERT INTO 'devicecapvalue' VALUES (609, 7, 48, 388);
INSERT INTO 'capvalue' VALUES (389, 'Asia/Calcutta');
INSERT INTO 'devicecapvalue' VALUES (610, 7, 48, 389);
INSERT INTO 'capvalue' VALUES (390, 'Asia/Colombo');
INSERT INTO 'devicecapvalue' VALUES (611, 7, 48, 390);
INSERT INTO 'capvalue' VALUES (391, 'Asia/Dacca');
INSERT INTO 'devicecapvalue' VALUES (612, 7, 48, 391);
INSERT INTO 'capvalue' VALUES (392, 'Asia/Damascus');
INSERT INTO 'devicecapvalue' VALUES (613, 7, 48, 392);
INSERT INTO 'capvalue' VALUES (393, 'Asia/Dubai');
INSERT INTO 'devicecapvalue' VALUES (614, 7, 48, 393);
INSERT INTO 'capvalue' VALUES (394, 'Asia/Dushanbe');
INSERT INTO 'devicecapvalue' VALUES (615, 7, 48, 394);
INSERT INTO 'capvalue' VALUES (395, 'Asia/Hong_Kong');
INSERT INTO 'devicecapvalue' VALUES (616, 7, 48, 395);
INSERT INTO 'capvalue' VALUES (396, 'Asia/Irkutsk');
INSERT INTO 'devicecapvalue' VALUES (617, 7, 48, 396);
INSERT INTO 'capvalue' VALUES (397, 'Asia/Ishigaki');
INSERT INTO 'devicecapvalue' VALUES (618, 7, 48, 397);
INSERT INTO 'capvalue' VALUES (398, 'Asia/Jakarta');
INSERT INTO 'devicecapvalue' VALUES (619, 7, 48, 398);
INSERT INTO 'capvalue' VALUES (399, 'Asia/Jayapura');
INSERT INTO 'devicecapvalue' VALUES (620, 7, 48, 399);
INSERT INTO 'capvalue' VALUES (400, 'Asia/Jerusalem');
INSERT INTO 'devicecapvalue' VALUES (621, 7, 48, 400);
INSERT INTO 'capvalue' VALUES (401, 'Asia/Kabul');
INSERT INTO 'devicecapvalue' VALUES (622, 7, 48, 401);
INSERT INTO 'capvalue' VALUES (402, 'Asia/Kamchatka');
INSERT INTO 'devicecapvalue' VALUES (623, 7, 48, 402);
INSERT INTO 'capvalue' VALUES (403, 'Asia/Karachi');
INSERT INTO 'devicecapvalue' VALUES (624, 7, 48, 403);
INSERT INTO 'capvalue' VALUES (404, 'Asia/Katmandu');
INSERT INTO 'devicecapvalue' VALUES (625, 7, 48, 404);
INSERT INTO 'capvalue' VALUES (405, 'Asia/Krasnoyarsk');
INSERT INTO 'devicecapvalue' VALUES (626, 7, 48, 405);
INSERT INTO 'capvalue' VALUES (406, 'Asia/Kuala_Lumpur');
INSERT INTO 'devicecapvalue' VALUES (627, 7, 48, 406);
INSERT INTO 'capvalue' VALUES (407, 'Asia/Kuwait');
INSERT INTO 'devicecapvalue' VALUES (628, 7, 48, 407);
INSERT INTO 'capvalue' VALUES (408, 'Asia/Macao');
INSERT INTO 'devicecapvalue' VALUES (629, 7, 48, 408);
INSERT INTO 'capvalue' VALUES (409, 'Asia/Magadan');
INSERT INTO 'devicecapvalue' VALUES (630, 7, 48, 409);
INSERT INTO 'capvalue' VALUES (410, 'Asia/Manila');
INSERT INTO 'devicecapvalue' VALUES (631, 7, 48, 410);
INSERT INTO 'capvalue' VALUES (411, 'Asia/Muscat');
INSERT INTO 'devicecapvalue' VALUES (632, 7, 48, 411);
INSERT INTO 'capvalue' VALUES (412, 'Asia/Nicosia');
INSERT INTO 'devicecapvalue' VALUES (633, 7, 48, 412);
INSERT INTO 'capvalue' VALUES (413, 'Asia/Novosibirsk');
INSERT INTO 'devicecapvalue' VALUES (634, 7, 48, 413);
INSERT INTO 'capvalue' VALUES (414, 'Asia/Phnom_Penh');
INSERT INTO 'devicecapvalue' VALUES (635, 7, 48, 414);
INSERT INTO 'capvalue' VALUES (415, 'Asia/Pyongyang');
INSERT INTO 'devicecapvalue' VALUES (636, 7, 48, 415);
INSERT INTO 'capvalue' VALUES (416, 'Asia/Qatar');
INSERT INTO 'devicecapvalue' VALUES (637, 7, 48, 416);
INSERT INTO 'capvalue' VALUES (417, 'Asia/Rangoon');
INSERT INTO 'devicecapvalue' VALUES (638, 7, 48, 417);
INSERT INTO 'capvalue' VALUES (418, 'Asia/Riyadh');
INSERT INTO 'devicecapvalue' VALUES (639, 7, 48, 418);
INSERT INTO 'capvalue' VALUES (419, 'Asia/Saigon');
INSERT INTO 'devicecapvalue' VALUES (640, 7, 48, 419);
INSERT INTO 'capvalue' VALUES (420, 'Asia/Seoul');
INSERT INTO 'devicecapvalue' VALUES (641, 7, 48, 420);
INSERT INTO 'capvalue' VALUES (421, 'Asia/Shanghai');
INSERT INTO 'devicecapvalue' VALUES (642, 7, 48, 421);
INSERT INTO 'capvalue' VALUES (422, 'Asia/Singapore');
INSERT INTO 'devicecapvalue' VALUES (643, 7, 48, 422);
INSERT INTO 'capvalue' VALUES (423, 'Asia/Taipei');
INSERT INTO 'devicecapvalue' VALUES (644, 7, 48, 423);
INSERT INTO 'capvalue' VALUES (424, 'Asia/Tashkent');
INSERT INTO 'devicecapvalue' VALUES (645, 7, 48, 424);
INSERT INTO 'capvalue' VALUES (425, 'Asia/Tbilisi');
INSERT INTO 'devicecapvalue' VALUES (646, 7, 48, 425);
INSERT INTO 'capvalue' VALUES (426, 'Asia/Tehran');
INSERT INTO 'devicecapvalue' VALUES (647, 7, 48, 426);
INSERT INTO 'capvalue' VALUES (427, 'Asia/Thimbu');
INSERT INTO 'devicecapvalue' VALUES (648, 7, 48, 427);
INSERT INTO 'capvalue' VALUES (428, 'Asia/Tokyo');
INSERT INTO 'devicecapvalue' VALUES (649, 7, 48, 428);
INSERT INTO 'capvalue' VALUES (429, 'Asia/Ujung_Pandang');
INSERT INTO 'devicecapvalue' VALUES (650, 7, 48, 429);
INSERT INTO 'capvalue' VALUES (430, 'Asia/Ulan_Bator');
INSERT INTO 'devicecapvalue' VALUES (651, 7, 48, 430);
INSERT INTO 'capvalue' VALUES (431, 'Asia/Vientiane');
INSERT INTO 'devicecapvalue' VALUES (652, 7, 48, 431);
INSERT INTO 'capvalue' VALUES (432, 'Asia/Vladivostok');
INSERT INTO 'devicecapvalue' VALUES (653, 7, 48, 432);
INSERT INTO 'capvalue' VALUES (433, 'Asia/Yakutsk');
INSERT INTO 'devicecapvalue' VALUES (654, 7, 48, 433);
INSERT INTO 'capvalue' VALUES (434, 'Asia/Yekaterinburg');
INSERT INTO 'devicecapvalue' VALUES (655, 7, 48, 434);
INSERT INTO 'capvalue' VALUES (435, 'Asia/Yerevan');
INSERT INTO 'devicecapvalue' VALUES (656, 7, 48, 435);
INSERT INTO 'capvalue' VALUES (436, 'Atlantic/Azores');
INSERT INTO 'devicecapvalue' VALUES (657, 7, 48, 436);
INSERT INTO 'capvalue' VALUES (437, 'Atlantic/Bermuda');
INSERT INTO 'devicecapvalue' VALUES (658, 7, 48, 437);
INSERT INTO 'capvalue' VALUES (438, 'Atlantic/Canary');
INSERT INTO 'devicecapvalue' VALUES (659, 7, 48, 438);
INSERT INTO 'capvalue' VALUES (439, 'Atlantic/Cape_Verde');
INSERT INTO 'devicecapvalue' VALUES (660, 7, 48, 439);
INSERT INTO 'capvalue' VALUES (440, 'Atlantic/Faeroe');
INSERT INTO 'devicecapvalue' VALUES (661, 7, 48, 440);
INSERT INTO 'capvalue' VALUES (441, 'Atlantic/Jan_Mayen');
INSERT INTO 'devicecapvalue' VALUES (662, 7, 48, 441);
INSERT INTO 'capvalue' VALUES (442, 'Atlantic/Reykjavik');
INSERT INTO 'devicecapvalue' VALUES (663, 7, 48, 442);
INSERT INTO 'capvalue' VALUES (443, 'Atlantic/South_Georgia');
INSERT INTO 'devicecapvalue' VALUES (664, 7, 48, 443);
INSERT INTO 'capvalue' VALUES (444, 'Atlantic/St_Helena');
INSERT INTO 'devicecapvalue' VALUES (665, 7, 48, 444);
INSERT INTO 'capvalue' VALUES (445, 'Atlantic/Stanley');
INSERT INTO 'devicecapvalue' VALUES (666, 7, 48, 445);
INSERT INTO 'capvalue' VALUES (446, 'Australia/Adelaide');
INSERT INTO 'devicecapvalue' VALUES (667, 7, 48, 446);
INSERT INTO 'capvalue' VALUES (447, 'Australia/Brisbane');
INSERT INTO 'devicecapvalue' VALUES (668, 7, 48, 447);
INSERT INTO 'capvalue' VALUES (448, 'Australia/Darwin');
INSERT INTO 'devicecapvalue' VALUES (669, 7, 48, 448);
INSERT INTO 'capvalue' VALUES (449, 'Australia/Lord_Howe');
INSERT INTO 'devicecapvalue' VALUES (670, 7, 48, 449);
INSERT INTO 'capvalue' VALUES (450, 'Australia/Perth');
INSERT INTO 'devicecapvalue' VALUES (671, 7, 48, 450);
INSERT INTO 'capvalue' VALUES (451, 'Australia/Sydney');
INSERT INTO 'devicecapvalue' VALUES (672, 7, 48, 451);
INSERT INTO 'capvalue' VALUES (452, 'BET');
INSERT INTO 'devicecapvalue' VALUES (673, 7, 48, 452);
INSERT INTO 'capvalue' VALUES (453, 'BST');
INSERT INTO 'devicecapvalue' VALUES (674, 7, 48, 453);
INSERT INTO 'capvalue' VALUES (454, 'CAT');
INSERT INTO 'devicecapvalue' VALUES (675, 7, 48, 454);
INSERT INTO 'capvalue' VALUES (455, 'CNT');
INSERT INTO 'devicecapvalue' VALUES (676, 7, 48, 455);
INSERT INTO 'capvalue' VALUES (456, 'CST');
INSERT INTO 'devicecapvalue' VALUES (677, 7, 48, 456);
INSERT INTO 'capvalue' VALUES (457, 'CTT');
INSERT INTO 'devicecapvalue' VALUES (678, 7, 48, 457);
INSERT INTO 'capvalue' VALUES (458, 'EAT');
INSERT INTO 'devicecapvalue' VALUES (679, 7, 48, 458);
INSERT INTO 'capvalue' VALUES (459, 'ECT');
INSERT INTO 'devicecapvalue' VALUES (680, 7, 48, 459);
INSERT INTO 'capvalue' VALUES (460, 'EET');
INSERT INTO 'devicecapvalue' VALUES (681, 7, 48, 460);
INSERT INTO 'capvalue' VALUES (461, 'EST');
INSERT INTO 'devicecapvalue' VALUES (682, 7, 48, 461);
INSERT INTO 'capvalue' VALUES (462, 'Europe/Amsterdam');
INSERT INTO 'devicecapvalue' VALUES (683, 7, 48, 462);
INSERT INTO 'capvalue' VALUES (463, 'Europe/Andorra');
INSERT INTO 'devicecapvalue' VALUES (684, 7, 48, 463);
INSERT INTO 'capvalue' VALUES (464, 'Europe/Athens');
INSERT INTO 'devicecapvalue' VALUES (685, 7, 48, 464);
INSERT INTO 'capvalue' VALUES (465, 'Europe/Belgrade');
INSERT INTO 'devicecapvalue' VALUES (686, 7, 48, 465);
INSERT INTO 'capvalue' VALUES (466, 'Europe/Berlin');
INSERT INTO 'devicecapvalue' VALUES (687, 7, 48, 466);
INSERT INTO 'capvalue' VALUES (467, 'Europe/Brussels');
INSERT INTO 'devicecapvalue' VALUES (688, 7, 48, 467);
INSERT INTO 'capvalue' VALUES (468, 'Europe/Bucharest');
INSERT INTO 'devicecapvalue' VALUES (689, 7, 48, 468);
INSERT INTO 'capvalue' VALUES (469, 'Europe/Budapest');
INSERT INTO 'devicecapvalue' VALUES (690, 7, 48, 469);
INSERT INTO 'capvalue' VALUES (470, 'Europe/Chisinau');
INSERT INTO 'devicecapvalue' VALUES (691, 7, 48, 470);
INSERT INTO 'capvalue' VALUES (471, 'Europe/Copenhagen');
INSERT INTO 'devicecapvalue' VALUES (692, 7, 48, 471);
INSERT INTO 'capvalue' VALUES (472, 'Europe/Dublin');
INSERT INTO 'devicecapvalue' VALUES (693, 7, 48, 472);
INSERT INTO 'capvalue' VALUES (473, 'Europe/Gibraltar');
INSERT INTO 'devicecapvalue' VALUES (694, 7, 48, 473);
INSERT INTO 'capvalue' VALUES (474, 'Europe/Helsinki');
INSERT INTO 'devicecapvalue' VALUES (695, 7, 48, 474);
INSERT INTO 'capvalue' VALUES (475, 'Europe/Istanbul');
INSERT INTO 'devicecapvalue' VALUES (696, 7, 48, 475);
INSERT INTO 'capvalue' VALUES (476, 'Europe/Kaliningrad');
INSERT INTO 'devicecapvalue' VALUES (697, 7, 48, 476);
INSERT INTO 'capvalue' VALUES (477, 'Europe/Kiev');
INSERT INTO 'devicecapvalue' VALUES (698, 7, 48, 477);
INSERT INTO 'capvalue' VALUES (478, 'Europe/Lisbon');
INSERT INTO 'devicecapvalue' VALUES (699, 7, 48, 478);
INSERT INTO 'capvalue' VALUES (479, 'Europe/London');
INSERT INTO 'devicecapvalue' VALUES (700, 7, 48, 479);
INSERT INTO 'capvalue' VALUES (480, 'Europe/Luxembourg');
INSERT INTO 'devicecapvalue' VALUES (701, 7, 48, 480);
INSERT INTO 'capvalue' VALUES (481, 'Europe/Madrid');
INSERT INTO 'devicecapvalue' VALUES (702, 7, 48, 481);
INSERT INTO 'capvalue' VALUES (482, 'Europe/Malta');
INSERT INTO 'devicecapvalue' VALUES (703, 7, 48, 482);
INSERT INTO 'capvalue' VALUES (483, 'Europe/Minsk');
INSERT INTO 'devicecapvalue' VALUES (704, 7, 48, 483);
INSERT INTO 'capvalue' VALUES (484, 'Europe/Monaco');
INSERT INTO 'devicecapvalue' VALUES (705, 7, 48, 484);
INSERT INTO 'capvalue' VALUES (485, 'Europe/Moscow');
INSERT INTO 'devicecapvalue' VALUES (706, 7, 48, 485);
INSERT INTO 'capvalue' VALUES (486, 'Europe/Oslo');
INSERT INTO 'devicecapvalue' VALUES (707, 7, 48, 486);
INSERT INTO 'capvalue' VALUES (487, 'Europe/Paris');
INSERT INTO 'devicecapvalue' VALUES (708, 7, 48, 487);
INSERT INTO 'capvalue' VALUES (488, 'Europe/Prague');
INSERT INTO 'devicecapvalue' VALUES (709, 7, 48, 488);
INSERT INTO 'capvalue' VALUES (489, 'Europe/Riga');
INSERT INTO 'devicecapvalue' VALUES (710, 7, 48, 489);
INSERT INTO 'capvalue' VALUES (490, 'Europe/Rome');
INSERT INTO 'devicecapvalue' VALUES (711, 7, 48, 490);
INSERT INTO 'capvalue' VALUES (491, 'Europe/Samara');
INSERT INTO 'devicecapvalue' VALUES (712, 7, 48, 491);
INSERT INTO 'capvalue' VALUES (492, 'Europe/Simferopol');
INSERT INTO 'devicecapvalue' VALUES (713, 7, 48, 492);
INSERT INTO 'capvalue' VALUES (493, 'Europe/Sofia');
INSERT INTO 'devicecapvalue' VALUES (714, 7, 48, 493);
INSERT INTO 'capvalue' VALUES (494, 'Europe/Stockholm');
INSERT INTO 'devicecapvalue' VALUES (715, 7, 48, 494);
INSERT INTO 'capvalue' VALUES (495, 'Europe/Tallinn');
INSERT INTO 'devicecapvalue' VALUES (716, 7, 48, 495);
INSERT INTO 'capvalue' VALUES (496, 'Europe/Tirane');
INSERT INTO 'devicecapvalue' VALUES (717, 7, 48, 496);
INSERT INTO 'capvalue' VALUES (497, 'Europe/Vaduz');
INSERT INTO 'devicecapvalue' VALUES (718, 7, 48, 497);
INSERT INTO 'capvalue' VALUES (498, 'Europe/Vienna');
INSERT INTO 'devicecapvalue' VALUES (719, 7, 48, 498);
INSERT INTO 'capvalue' VALUES (499, 'Europe/Vilnius');
INSERT INTO 'devicecapvalue' VALUES (720, 7, 48, 499);
INSERT INTO 'capvalue' VALUES (500, 'Europe/Warsaw');
INSERT INTO 'devicecapvalue' VALUES (721, 7, 48, 500);
INSERT INTO 'capvalue' VALUES (501, 'Europe/Zurich');
INSERT INTO 'devicecapvalue' VALUES (722, 7, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (723, 7, 48, 90);
INSERT INTO 'capvalue' VALUES (502, 'HST');
INSERT INTO 'devicecapvalue' VALUES (724, 7, 48, 502);
INSERT INTO 'capvalue' VALUES (503, 'IET');
INSERT INTO 'devicecapvalue' VALUES (725, 7, 48, 503);
INSERT INTO 'capvalue' VALUES (504, 'IST');
INSERT INTO 'devicecapvalue' VALUES (726, 7, 48, 504);
INSERT INTO 'capvalue' VALUES (505, 'Indian/Antananarivo');
INSERT INTO 'devicecapvalue' VALUES (727, 7, 48, 505);
INSERT INTO 'capvalue' VALUES (506, 'Indian/Chagos');
INSERT INTO 'devicecapvalue' VALUES (728, 7, 48, 506);
INSERT INTO 'capvalue' VALUES (507, 'Indian/Christmas');
INSERT INTO 'devicecapvalue' VALUES (729, 7, 48, 507);
INSERT INTO 'capvalue' VALUES (508, 'Indian/Cocos');
INSERT INTO 'devicecapvalue' VALUES (730, 7, 48, 508);
INSERT INTO 'capvalue' VALUES (509, 'Indian/Comoro');
INSERT INTO 'devicecapvalue' VALUES (731, 7, 48, 509);
INSERT INTO 'capvalue' VALUES (510, 'Indian/Kerguelen');
INSERT INTO 'devicecapvalue' VALUES (732, 7, 48, 510);
INSERT INTO 'capvalue' VALUES (511, 'Indian/Mahe');
INSERT INTO 'devicecapvalue' VALUES (733, 7, 48, 511);
INSERT INTO 'capvalue' VALUES (512, 'Indian/Maldives');
INSERT INTO 'devicecapvalue' VALUES (734, 7, 48, 512);
INSERT INTO 'capvalue' VALUES (513, 'Indian/Mauritius');
INSERT INTO 'devicecapvalue' VALUES (735, 7, 48, 513);
INSERT INTO 'capvalue' VALUES (514, 'Indian/Mayotte');
INSERT INTO 'devicecapvalue' VALUES (736, 7, 48, 514);
INSERT INTO 'capvalue' VALUES (515, 'Indian/Reunion');
INSERT INTO 'devicecapvalue' VALUES (737, 7, 48, 515);
INSERT INTO 'capvalue' VALUES (516, 'JST');
INSERT INTO 'devicecapvalue' VALUES (738, 7, 48, 516);
INSERT INTO 'capvalue' VALUES (517, 'MET');
INSERT INTO 'devicecapvalue' VALUES (739, 7, 48, 517);
INSERT INTO 'capvalue' VALUES (518, 'MIT');
INSERT INTO 'devicecapvalue' VALUES (740, 7, 48, 518);
INSERT INTO 'capvalue' VALUES (519, 'MST');
INSERT INTO 'devicecapvalue' VALUES (741, 7, 48, 519);
INSERT INTO 'capvalue' VALUES (520, 'NET');
INSERT INTO 'devicecapvalue' VALUES (742, 7, 48, 520);
INSERT INTO 'capvalue' VALUES (521, 'NST');
INSERT INTO 'devicecapvalue' VALUES (743, 7, 48, 521);
INSERT INTO 'capvalue' VALUES (522, 'PLT');
INSERT INTO 'devicecapvalue' VALUES (744, 7, 48, 522);
INSERT INTO 'capvalue' VALUES (523, 'PNT');
INSERT INTO 'devicecapvalue' VALUES (745, 7, 48, 523);
INSERT INTO 'capvalue' VALUES (524, 'PRT');
INSERT INTO 'devicecapvalue' VALUES (746, 7, 48, 524);
INSERT INTO 'capvalue' VALUES (525, 'PST');
INSERT INTO 'devicecapvalue' VALUES (747, 7, 48, 525);
INSERT INTO 'capvalue' VALUES (526, 'Pacific/Apia');
INSERT INTO 'devicecapvalue' VALUES (748, 7, 48, 526);
INSERT INTO 'capvalue' VALUES (527, 'Pacific/Auckland');
INSERT INTO 'devicecapvalue' VALUES (749, 7, 48, 527);
INSERT INTO 'capvalue' VALUES (528, 'Pacific/Chatham');
INSERT INTO 'devicecapvalue' VALUES (750, 7, 48, 528);
INSERT INTO 'capvalue' VALUES (529, 'Pacific/Easter');
INSERT INTO 'devicecapvalue' VALUES (751, 7, 48, 529);
INSERT INTO 'capvalue' VALUES (530, 'Pacific/Efate');
INSERT INTO 'devicecapvalue' VALUES (752, 7, 48, 530);
INSERT INTO 'capvalue' VALUES (531, 'Pacific/Enderbury');
INSERT INTO 'devicecapvalue' VALUES (753, 7, 48, 531);
INSERT INTO 'capvalue' VALUES (532, 'Pacific/Fakaofo');
INSERT INTO 'devicecapvalue' VALUES (754, 7, 48, 532);
INSERT INTO 'capvalue' VALUES (533, 'Pacific/Fiji');
INSERT INTO 'devicecapvalue' VALUES (755, 7, 48, 533);
INSERT INTO 'capvalue' VALUES (534, 'Pacific/Funafuti');
INSERT INTO 'devicecapvalue' VALUES (756, 7, 48, 534);
INSERT INTO 'capvalue' VALUES (535, 'Pacific/Galapagos');
INSERT INTO 'devicecapvalue' VALUES (757, 7, 48, 535);
INSERT INTO 'capvalue' VALUES (536, 'Pacific/Gambier');
INSERT INTO 'devicecapvalue' VALUES (758, 7, 48, 536);
INSERT INTO 'capvalue' VALUES (537, 'Pacific/Guadalcanal');
INSERT INTO 'devicecapvalue' VALUES (759, 7, 48, 537);
INSERT INTO 'capvalue' VALUES (538, 'Pacific/Guam');
INSERT INTO 'devicecapvalue' VALUES (760, 7, 48, 538);
INSERT INTO 'capvalue' VALUES (539, 'Pacific/Honolulu');
INSERT INTO 'devicecapvalue' VALUES (761, 7, 48, 539);
INSERT INTO 'capvalue' VALUES (540, 'Pacific/Kiritimati');
INSERT INTO 'devicecapvalue' VALUES (762, 7, 48, 540);
INSERT INTO 'capvalue' VALUES (541, 'Pacific/Kosrae');
INSERT INTO 'devicecapvalue' VALUES (763, 7, 48, 541);
INSERT INTO 'capvalue' VALUES (542, 'Pacific/Majuro');
INSERT INTO 'devicecapvalue' VALUES (764, 7, 48, 542);
INSERT INTO 'capvalue' VALUES (543, 'Pacific/Marquesas');
INSERT INTO 'devicecapvalue' VALUES (765, 7, 48, 543);
INSERT INTO 'capvalue' VALUES (544, 'Pacific/Nauru');
INSERT INTO 'devicecapvalue' VALUES (766, 7, 48, 544);
INSERT INTO 'capvalue' VALUES (545, 'Pacific/Niue');
INSERT INTO 'devicecapvalue' VALUES (767, 7, 48, 545);
INSERT INTO 'capvalue' VALUES (546, 'Pacific/Norfolk');
INSERT INTO 'devicecapvalue' VALUES (768, 7, 48, 546);
INSERT INTO 'capvalue' VALUES (547, 'Pacific/Noumea');
INSERT INTO 'devicecapvalue' VALUES (769, 7, 48, 547);
INSERT INTO 'capvalue' VALUES (548, 'Pacific/Pago_Pago');
INSERT INTO 'devicecapvalue' VALUES (770, 7, 48, 548);
INSERT INTO 'capvalue' VALUES (549, 'Pacific/Palau');
INSERT INTO 'devicecapvalue' VALUES (771, 7, 48, 549);
INSERT INTO 'capvalue' VALUES (550, 'Pacific/Pitcairn');
INSERT INTO 'devicecapvalue' VALUES (772, 7, 48, 550);
INSERT INTO 'capvalue' VALUES (551, 'Pacific/Ponape');
INSERT INTO 'devicecapvalue' VALUES (773, 7, 48, 551);
INSERT INTO 'capvalue' VALUES (552, 'Pacific/Port_Moresby');
INSERT INTO 'devicecapvalue' VALUES (774, 7, 48, 552);
INSERT INTO 'capvalue' VALUES (553, 'Pacific/Rarotonga');
INSERT INTO 'devicecapvalue' VALUES (775, 7, 48, 553);
INSERT INTO 'capvalue' VALUES (554, 'Pacific/Saipan');
INSERT INTO 'devicecapvalue' VALUES (776, 7, 48, 554);
INSERT INTO 'capvalue' VALUES (555, 'Pacific/Tahiti');
INSERT INTO 'devicecapvalue' VALUES (777, 7, 48, 555);
INSERT INTO 'capvalue' VALUES (556, 'Pacific/Tarawa');
INSERT INTO 'devicecapvalue' VALUES (778, 7, 48, 556);
INSERT INTO 'capvalue' VALUES (557, 'Pacific/Tongatapu');
INSERT INTO 'devicecapvalue' VALUES (779, 7, 48, 557);
INSERT INTO 'capvalue' VALUES (558, 'Pacific/Truk');
INSERT INTO 'devicecapvalue' VALUES (780, 7, 48, 558);
INSERT INTO 'capvalue' VALUES (559, 'Pacific/Wake');
INSERT INTO 'devicecapvalue' VALUES (781, 7, 48, 559);
INSERT INTO 'capvalue' VALUES (560, 'Pacific/Wallis');
INSERT INTO 'devicecapvalue' VALUES (782, 7, 48, 560);
INSERT INTO 'capvalue' VALUES (561, 'SST');
INSERT INTO 'devicecapvalue' VALUES (783, 7, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (784, 7, 48, 92);
INSERT INTO 'capvalue' VALUES (562, 'VST');
INSERT INTO 'devicecapvalue' VALUES (785, 7, 48, 562);
INSERT INTO 'capvalue' VALUES (563, '3550208');
INSERT INTO 'devicecapvalue' VALUES (786, 7, 49, 563);
INSERT INTO 'capvalue' VALUES (564, 'Mozilla/4.0 (compatible; MSIE 6.0; Windows CE; IEMobile 7.6) /BenQ-T80');
INSERT INTO 'devicecapvalue' VALUES (787, 7, 53, 564);
INSERT INTO 'cap' VALUES (74, 'Bugs', 1);
INSERT INTO 'capvalue' VALUES (565, 'ItemStateListenerCalledTooEarly');
INSERT INTO 'devicecapvalue' VALUES (788, 8, 74, 565);
INSERT INTO 'cap' VALUES (75, 'Emulator.Skin', 1);
INSERT INTO 'capvalue' VALUES (566, '7100t');
INSERT INTO 'devicecapvalue' VALUES (789, 8, 75, 566);
INSERT INTO 'capvalue' VALUES (567, 'isVirtual');
INSERT INTO 'devicecapvalue' VALUES (790, 8, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (791, 8, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (792, 8, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (793, 8, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (794, 8, 17, 25);
INSERT INTO 'capvalue' VALUES (568, 'BlackBerry/4.0');
INSERT INTO 'devicecapvalue' VALUES (795, 8, 6, 568);
INSERT INTO 'devicecapvalue' VALUES (796, 8, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (797, 8, 51, 100);
INSERT INTO 'capvalue' VALUES (569, 'nb-amr');
INSERT INTO 'devicecapvalue' VALUES (798, 8, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (799, 9, 74, 565);
INSERT INTO 'capvalue' VALUES (570, '8700r');
INSERT INTO 'devicecapvalue' VALUES (800, 9, 75, 570);
INSERT INTO 'devicecapvalue' VALUES (801, 9, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (802, 9, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (803, 9, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (804, 9, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (805, 9, 17, 25);
INSERT INTO 'capvalue' VALUES (571, 'BlackBerry/4.1');
INSERT INTO 'devicecapvalue' VALUES (806, 9, 6, 571);
INSERT INTO 'devicecapvalue' VALUES (807, 9, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (808, 9, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (809, 9, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (810, 10, 74, 565);
INSERT INTO 'capvalue' VALUES (572, '8100');
INSERT INTO 'devicecapvalue' VALUES (811, 10, 75, 572);
INSERT INTO 'devicecapvalue' VALUES (812, 10, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (813, 10, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (814, 10, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (815, 10, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (816, 10, 17, 25);
INSERT INTO 'capvalue' VALUES (573, 'BlackBerry/4.2');
INSERT INTO 'devicecapvalue' VALUES (817, 10, 6, 573);
INSERT INTO 'devicecapvalue' VALUES (818, 10, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (819, 10, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (820, 10, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (821, 11, 74, 565);
INSERT INTO 'devicecapvalue' VALUES (822, 11, 75, 572);
INSERT INTO 'capvalue' VALUES (574, 'hasTrackballEvents');
INSERT INTO 'devicecapvalue' VALUES (823, 11, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (824, 11, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (825, 11, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (826, 11, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (827, 11, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (828, 11, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (829, 11, 6, 573);
INSERT INTO 'devicecapvalue' VALUES (830, 11, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (831, 11, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (832, 11, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (833, 12, 74, 565);
INSERT INTO 'capvalue' VALUES (575, '8130');
INSERT INTO 'devicecapvalue' VALUES (834, 12, 75, 575);
INSERT INTO 'devicecapvalue' VALUES (835, 12, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (836, 12, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (837, 12, 16, 20);
INSERT INTO 'capvalue' VALUES (576, 'contenthandler');
INSERT INTO 'devicecapvalue' VALUES (838, 12, 17, 576);
INSERT INTO 'capvalue' VALUES (577, 'javacard');
INSERT INTO 'devicecapvalue' VALUES (839, 12, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (840, 12, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (841, 12, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (842, 12, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (843, 12, 17, 25);
INSERT INTO 'capvalue' VALUES (578, 'BlackBerry/4.3');
INSERT INTO 'devicecapvalue' VALUES (844, 12, 6, 578);
INSERT INTO 'devicecapvalue' VALUES (845, 12, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (846, 12, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (847, 12, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (848, 13, 74, 565);
INSERT INTO 'capvalue' VALUES (579, '8300');
INSERT INTO 'devicecapvalue' VALUES (849, 13, 75, 579);
INSERT INTO 'devicecapvalue' VALUES (850, 13, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (851, 13, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (852, 13, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (853, 13, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (854, 13, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (855, 13, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (856, 13, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (857, 13, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (858, 13, 17, 25);
INSERT INTO 'capvalue' VALUES (580, 'BlackBerry/4.5');
INSERT INTO 'devicecapvalue' VALUES (859, 13, 6, 580);
INSERT INTO 'devicecapvalue' VALUES (860, 13, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (861, 13, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (862, 13, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (863, 14, 74, 565);
INSERT INTO 'capvalue' VALUES (581, '9000');
INSERT INTO 'devicecapvalue' VALUES (864, 14, 75, 581);
INSERT INTO 'devicecapvalue' VALUES (865, 14, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (866, 14, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (867, 14, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (868, 14, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (869, 14, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (870, 14, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (871, 14, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (872, 14, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (873, 14, 17, 25);
INSERT INTO 'capvalue' VALUES (582, 'BlackBerry/4.6');
INSERT INTO 'devicecapvalue' VALUES (874, 14, 6, 582);
INSERT INTO 'devicecapvalue' VALUES (875, 14, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (876, 14, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (877, 14, 51, 569);
INSERT INTO 'capvalue' VALUES (583, 'ReservedKeywordSerializable');
INSERT INTO 'devicecapvalue' VALUES (878, 15, 74, 583);
INSERT INTO 'capvalue' VALUES (584, '9500');
INSERT INTO 'devicecapvalue' VALUES (879, 15, 75, 584);
INSERT INTO 'devicecapvalue' VALUES (880, 15, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (881, 15, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (882, 15, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (883, 15, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (884, 15, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (885, 15, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (886, 15, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (887, 15, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (888, 15, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (889, 15, 17, 25);
INSERT INTO 'capvalue' VALUES (585, 'BlackBerry/4.7');
INSERT INTO 'devicecapvalue' VALUES (890, 15, 6, 585);
INSERT INTO 'devicecapvalue' VALUES (891, 15, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (892, 15, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (893, 15, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (894, 16, 74, 565);
INSERT INTO 'devicecapvalue' VALUES (895, 16, 75, 584);
INSERT INTO 'devicecapvalue' VALUES (896, 16, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (897, 16, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (898, 16, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (899, 16, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (900, 16, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (901, 16, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (902, 16, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (903, 16, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (904, 16, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (905, 16, 17, 25);
INSERT INTO 'capvalue' VALUES (586, 'BlackBerry/5.0');
INSERT INTO 'devicecapvalue' VALUES (906, 16, 6, 586);
INSERT INTO 'devicecapvalue' VALUES (907, 16, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (908, 16, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (909, 16, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (910, 17, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (911, 17, 74, 583);
INSERT INTO 'capvalue' VALUES (587, '240x260');
INSERT INTO 'devicecapvalue' VALUES (912, 17, 13, 587);
INSERT INTO 'devicecapvalue' VALUES (913, 17, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (914, 17, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (915, 17, 6, 571);
INSERT INTO 'devicecapvalue' VALUES (916, 17, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (917, 17, 4, 5);
INSERT INTO 'capvalue' VALUES (588, '260');
INSERT INTO 'devicecapvalue' VALUES (918, 17, 5, 588);
INSERT INTO 'devicecapvalue' VALUES (919, 18, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (920, 18, 74, 583);
INSERT INTO 'devicecapvalue' VALUES (921, 18, 7, 587);
INSERT INTO 'devicecapvalue' VALUES (922, 18, 13, 587);
INSERT INTO 'devicecapvalue' VALUES (923, 18, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (924, 18, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (925, 18, 6, 571);
INSERT INTO 'devicecapvalue' VALUES (926, 18, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (927, 18, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (928, 18, 5, 588);
INSERT INTO 'devicecapvalue' VALUES (929, 19, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (930, 19, 74, 583);
INSERT INTO 'capvalue' VALUES (589, '240x160');
INSERT INTO 'devicecapvalue' VALUES (931, 19, 13, 589);
INSERT INTO 'devicecapvalue' VALUES (932, 19, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (933, 19, 6, 571);
INSERT INTO 'devicecapvalue' VALUES (934, 19, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (935, 19, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (936, 19, 5, 107);
INSERT INTO 'capvalue' VALUES (590, 'Mozilla/4.8 [en] (Windows NT 5.0; U) BlackBerry7290/3.8.0');
INSERT INTO 'devicecapvalue' VALUES (937, 19, 53, 590);
INSERT INTO 'devicecapvalue' VALUES (938, 20, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (939, 20, 74, 583);
INSERT INTO 'devicecapvalue' VALUES (940, 20, 13, 589);
INSERT INTO 'devicecapvalue' VALUES (941, 20, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (942, 20, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (943, 20, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (944, 20, 6, 571);
INSERT INTO 'devicecapvalue' VALUES (945, 20, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (946, 20, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (947, 20, 5, 107);
INSERT INTO 'capvalue' VALUES (591, 'vnf');
INSERT INTO 'devicecapvalue' VALUES (948, 20, 51, 591);
INSERT INTO 'capvalue' VALUES (592, 'BlackBerry7520/4.0.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (949, 20, 53, 592);
INSERT INTO 'devicecapvalue' VALUES (950, 21, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (951, 21, 74, 565);
INSERT INTO 'devicecapvalue' VALUES (952, 21, 75, 572);
INSERT INTO 'devicecapvalue' VALUES (953, 21, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (954, 21, 13, 587);
INSERT INTO 'cap' VALUES (76, 'HeapSize', 1);
INSERT INTO 'capvalue' VALUES (593, 'dynamic');
INSERT INTO 'devicecapvalue' VALUES (955, 21, 76, 593);
INSERT INTO 'cap' VALUES (77, 'IconSize_x', 1);
INSERT INTO 'cap' VALUES (78, 'IconSize_y', 1);
INSERT INTO 'capvalue' VALUES (594, '48');
INSERT INTO 'devicecapvalue' VALUES (956, 21, 77, 594);
INSERT INTO 'capvalue' VALUES (595, '36');
INSERT INTO 'devicecapvalue' VALUES (957, 21, 78, 595);
INSERT INTO 'capvalue' VALUES (596, '60');
INSERT INTO 'devicecapvalue' VALUES (958, 21, 77, 596);
INSERT INTO 'devicecapvalue' VALUES (959, 21, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (960, 21, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (961, 21, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (962, 21, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (963, 21, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (964, 21, 6, 573);
INSERT INTO 'devicecapvalue' VALUES (965, 21, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (966, 21, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (967, 21, 5, 588);
INSERT INTO 'devicecapvalue' VALUES (968, 21, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (969, 21, 51, 569);
INSERT INTO 'capvalue' VALUES (597, 'Mozilla/4.0 BlackBerry8100');
INSERT INTO 'devicecapvalue' VALUES (970, 21, 53, 597);
INSERT INTO 'devicecapvalue' VALUES (971, 22, 74, 565);
INSERT INTO 'capvalue' VALUES (598, '8120');
INSERT INTO 'devicecapvalue' VALUES (972, 22, 75, 598);
INSERT INTO 'devicecapvalue' VALUES (973, 22, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (974, 22, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (975, 22, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (976, 22, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (977, 22, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (978, 22, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (979, 22, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (980, 22, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (981, 22, 6, 578);
INSERT INTO 'devicecapvalue' VALUES (982, 22, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (983, 22, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (984, 22, 51, 569);
INSERT INTO 'capvalue' VALUES (599, 'BlackBerry8120/4.3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 VendorID/1');
INSERT INTO 'devicecapvalue' VALUES (985, 22, 53, 599);
INSERT INTO 'devicecapvalue' VALUES (986, 23, 74, 565);
INSERT INTO 'devicecapvalue' VALUES (987, 23, 75, 575);
INSERT INTO 'devicecapvalue' VALUES (988, 23, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (989, 23, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (990, 23, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (991, 23, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (992, 23, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (993, 23, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (994, 23, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (995, 23, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (996, 23, 6, 578);
INSERT INTO 'devicecapvalue' VALUES (997, 23, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (998, 23, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (999, 23, 51, 569);
INSERT INTO 'capvalue' VALUES (600, 'BlackBerry8130/4.3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 VendorID/109');
INSERT INTO 'devicecapvalue' VALUES (1000, 23, 53, 600);
INSERT INTO 'devicecapvalue' VALUES (1001, 24, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (1002, 24, 74, 565);
INSERT INTO 'devicecapvalue' VALUES (1003, 24, 7, 14);
INSERT INTO 'devicecapvalue' VALUES (1004, 24, 75, 579);
INSERT INTO 'devicecapvalue' VALUES (1005, 24, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (1006, 24, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (1007, 24, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (1008, 24, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1009, 24, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1010, 24, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1011, 24, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1012, 24, 6, 580);
INSERT INTO 'devicecapvalue' VALUES (1013, 24, 6, 27);
INSERT INTO 'capvalue' VALUES (601, '320');
INSERT INTO 'devicecapvalue' VALUES (1014, 24, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (1015, 24, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (1016, 24, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1017, 24, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (1018, 25, 56, 1);
INSERT INTO 'cap' VALUES (79, 'canvas.isdoublebuffered', 1);
INSERT INTO 'devicecapvalue' VALUES (1019, 25, 79, 15);
INSERT INTO 'devicecapvalue' VALUES (1020, 25, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (1021, 25, 2, 574);
INSERT INTO 'cap' VALUES (80, 'file.separator', 1);
INSERT INTO 'capvalue' VALUES (602, '/');
INSERT INTO 'devicecapvalue' VALUES (1022, 25, 80, 602);
INSERT INTO 'capvalue' VALUES (603, '20');
INSERT INTO 'devicecapvalue' VALUES (1023, 25, 9, 603);
INSERT INTO 'capvalue' VALUES (604, '27');
INSERT INTO 'devicecapvalue' VALUES (1024, 25, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (1025, 25, 11, 110);
INSERT INTO 'devicecapvalue' VALUES (1026, 25, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (1027, 25, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (1028, 25, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (1029, 25, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (1030, 25, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (1031, 25, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1032, 25, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (1033, 25, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (1034, 25, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (1035, 25, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1036, 25, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1037, 25, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1038, 25, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1039, 25, 6, 580);
INSERT INTO 'devicecapvalue' VALUES (1040, 25, 6, 27);
INSERT INTO 'capvalue' VALUES (605, '6');
INSERT INTO 'devicecapvalue' VALUES (1041, 25, 18, 605);
INSERT INTO 'devicecapvalue' VALUES (1042, 25, 19, 605);
INSERT INTO 'capvalue' VALUES (606, '32');
INSERT INTO 'devicecapvalue' VALUES (1043, 25, 20, 606);
INSERT INTO 'capvalue' VALUES (607, '113');
INSERT INTO 'devicecapvalue' VALUES (1044, 25, 21, 607);
INSERT INTO 'capvalue' VALUES (608, '119');
INSERT INTO 'devicecapvalue' VALUES (1045, 25, 22, 608);
INSERT INTO 'capvalue' VALUES (609, '111');
INSERT INTO 'devicecapvalue' VALUES (1046, 25, 23, 609);
INSERT INTO 'capvalue' VALUES (610, '112');
INSERT INTO 'devicecapvalue' VALUES (1047, 25, 24, 610);
INSERT INTO 'devicecapvalue' VALUES (1048, 25, 25, 233);
INSERT INTO 'devicecapvalue' VALUES (1049, 25, 26, 28);
INSERT INTO 'devicecapvalue' VALUES (1050, 25, 27, 605);
INSERT INTO 'devicecapvalue' VALUES (1051, 25, 28, 605);
INSERT INTO 'capvalue' VALUES (611, '5');
INSERT INTO 'devicecapvalue' VALUES (1052, 25, 29, 611);
INSERT INTO 'devicecapvalue' VALUES (1053, 25, 30, 605);
INSERT INTO 'devicecapvalue' VALUES (1054, 25, 54, 605);
INSERT INTO 'capvalue' VALUES (612, '1');
INSERT INTO 'devicecapvalue' VALUES (1055, 25, 31, 612);
INSERT INTO 'devicecapvalue' VALUES (1056, 25, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (1057, 25, 34, 44);
INSERT INTO 'cap' VALUES (81, 'microedition.io.file.fileconnection.version', 1);
INSERT INTO 'devicecapvalue' VALUES (1058, 25, 81, 45);
INSERT INTO 'devicecapvalue' VALUES (1059, 25, 35, 45);
INSERT INTO 'cap' VALUES (82, 'microedition.location.version', 1);
INSERT INTO 'capvalue' VALUES (613, '1.0.1');
INSERT INTO 'devicecapvalue' VALUES (1060, 25, 82, 613);
INSERT INTO 'cap' VALUES (83, 'microedition.media.version', 1);
INSERT INTO 'devicecapvalue' VALUES (1061, 25, 83, 242);
INSERT INTO 'cap' VALUES (84, 'microedition.pim.version', 1);
INSERT INTO 'devicecapvalue' VALUES (1062, 25, 84, 45);
INSERT INTO 'capvalue' VALUES (614, 'RIM Wireless Handheld');
INSERT INTO 'devicecapvalue' VALUES (1063, 25, 36, 614);
INSERT INTO 'devicecapvalue' VALUES (1064, 25, 37, 47);
INSERT INTO 'cap' VALUES (85, 'microedition.smartcardslots', 1);
INSERT INTO 'capvalue' VALUES (615, '0C');
INSERT INTO 'devicecapvalue' VALUES (1065, 25, 85, 615);
INSERT INTO 'devicecapvalue' VALUES (1066, 25, 39, 49);
INSERT INTO 'capvalue' VALUES (616, 'audio/basic');
INSERT INTO 'devicecapvalue' VALUES (1067, 25, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (1068, 25, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (1069, 25, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (1070, 25, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (1071, 25, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (1072, 25, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (1073, 25, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (1074, 25, 41, 63);
INSERT INTO 'capvalue' VALUES (617, 'audio/x-gsm');
INSERT INTO 'devicecapvalue' VALUES (1075, 25, 41, 617);
INSERT INTO 'capvalue' VALUES (618, 'audio/x-ms-wma');
INSERT INTO 'devicecapvalue' VALUES (1076, 25, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (1077, 25, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (1078, 25, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (1079, 25, 41, 67);
INSERT INTO 'capvalue' VALUES (619, 'video/quicktime');
INSERT INTO 'devicecapvalue' VALUES (1080, 25, 41, 619);
INSERT INTO 'capvalue' VALUES (620, 'video/x-ms-asf');
INSERT INTO 'devicecapvalue' VALUES (1081, 25, 41, 620);
INSERT INTO 'capvalue' VALUES (621, 'video/x-ms-wm');
INSERT INTO 'devicecapvalue' VALUES (1082, 25, 41, 621);
INSERT INTO 'capvalue' VALUES (622, 'video/x-ms-wmv');
INSERT INTO 'devicecapvalue' VALUES (1083, 25, 41, 622);
INSERT INTO 'capvalue' VALUES (623, 'video/x-ms-wmx');
INSERT INTO 'devicecapvalue' VALUES (1084, 25, 41, 623);
INSERT INTO 'capvalue' VALUES (624, 'video/x-msvideo');
INSERT INTO 'devicecapvalue' VALUES (1085, 25, 41, 624);
INSERT INTO 'devicecapvalue' VALUES (1086, 25, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (1087, 25, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (1088, 25, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (1089, 25, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (1090, 25, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (1091, 25, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (1092, 25, 42, 617);
INSERT INTO 'devicecapvalue' VALUES (1093, 25, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (1094, 25, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (1095, 25, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (1096, 25, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (1097, 25, 42, 619);
INSERT INTO 'devicecapvalue' VALUES (1098, 25, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (1099, 25, 42, 621);
INSERT INTO 'devicecapvalue' VALUES (1100, 25, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (1101, 25, 42, 623);
INSERT INTO 'devicecapvalue' VALUES (1102, 25, 42, 624);
INSERT INTO 'capvalue' VALUES (625, '8');
INSERT INTO 'devicecapvalue' VALUES (1103, 25, 58, 625);
INSERT INTO 'cap' VALUES (86, 'property.supports.audio.capture', 1);
INSERT INTO 'devicecapvalue' VALUES (1104, 25, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (1105, 25, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (1106, 25, 5, 5);
INSERT INTO 'cap' VALUES (87, 'supports.recording', 1);
INSERT INTO 'devicecapvalue' VALUES (1107, 25, 87, 15);
INSERT INTO 'devicecapvalue' VALUES (1108, 25, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (1109, 25, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (1110, 25, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (1111, 25, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (1112, 25, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (1113, 25, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (1114, 25, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (1115, 25, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (1116, 25, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (1117, 25, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (1118, 25, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (1119, 25, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (1120, 25, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (1121, 25, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (1122, 25, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (1123, 25, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (1124, 25, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (1125, 25, 48, 339);
INSERT INTO 'capvalue' VALUES (626, 'America/Mexico_City_2');
INSERT INTO 'devicecapvalue' VALUES (1126, 25, 48, 626);
INSERT INTO 'devicecapvalue' VALUES (1127, 25, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (1128, 25, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (1129, 25, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (1130, 25, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (1131, 25, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (1132, 25, 48, 357);
INSERT INTO 'capvalue' VALUES (627, 'America/South_Georgia');
INSERT INTO 'devicecapvalue' VALUES (1133, 25, 48, 627);
INSERT INTO 'devicecapvalue' VALUES (1134, 25, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (1135, 25, 48, 364);
INSERT INTO 'capvalue' VALUES (628, 'America/Tegucigalpa_2');
INSERT INTO 'devicecapvalue' VALUES (1136, 25, 48, 628);
INSERT INTO 'devicecapvalue' VALUES (1137, 25, 48, 366);
INSERT INTO 'capvalue' VALUES (629, 'Asia/Almaty');
INSERT INTO 'devicecapvalue' VALUES (1138, 25, 48, 629);
INSERT INTO 'devicecapvalue' VALUES (1139, 25, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (1140, 25, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (1141, 25, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (1142, 25, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (1143, 25, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (1144, 25, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (1145, 25, 48, 390);
INSERT INTO 'capvalue' VALUES (630, 'Asia/Dhaka');
INSERT INTO 'devicecapvalue' VALUES (1146, 25, 48, 630);
INSERT INTO 'devicecapvalue' VALUES (1147, 25, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (1148, 25, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (1149, 25, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (1150, 25, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (1151, 25, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (1152, 25, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (1153, 25, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (1154, 25, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (1155, 25, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (1156, 25, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (1157, 25, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (1158, 25, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (1159, 25, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (1160, 25, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (1161, 25, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (1162, 25, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (1163, 25, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (1164, 25, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (1165, 25, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (1166, 25, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (1167, 25, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (1168, 25, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (1169, 25, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (1170, 25, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (1171, 25, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (1172, 25, 48, 448);
INSERT INTO 'capvalue' VALUES (631, 'Australia/Hobart');
INSERT INTO 'devicecapvalue' VALUES (1173, 25, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (1174, 25, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (1175, 25, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (1176, 25, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (1177, 25, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (1178, 25, 48, 465);
INSERT INTO 'capvalue' VALUES (632, 'Europe/Belgrade Yugoslavia(YU)');
INSERT INTO 'devicecapvalue' VALUES (1179, 25, 48, 632);
INSERT INTO 'devicecapvalue' VALUES (1180, 25, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (1181, 25, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (1182, 25, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (1183, 25, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (1184, 25, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (1185, 25, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (1186, 25, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (1187, 25, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (1188, 25, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (1189, 25, 48, 539);
INSERT INTO 'capvalue' VALUES (633, 'Pacific/Kwajalein');
INSERT INTO 'devicecapvalue' VALUES (1190, 25, 48, 633);
INSERT INTO 'capvalue' VALUES (634, 'Pacific/Midway');
INSERT INTO 'devicecapvalue' VALUES (1191, 25, 48, 634);
INSERT INTO 'devicecapvalue' VALUES (1192, 25, 48, 557);
INSERT INTO 'capvalue' VALUES (635, '43667488');
INSERT INTO 'devicecapvalue' VALUES (1193, 25, 49, 635);
INSERT INTO 'capvalue' VALUES (636, 'BlackBerry8310/4.2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1 VendorID/121');
INSERT INTO 'devicecapvalue' VALUES (1194, 25, 53, 636);
INSERT INTO 'devicecapvalue' VALUES (1195, 26, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (1196, 26, 74, 565);
INSERT INTO 'devicecapvalue' VALUES (1197, 26, 7, 14);
INSERT INTO 'capvalue' VALUES (637, '8350');
INSERT INTO 'devicecapvalue' VALUES (1198, 26, 75, 637);
INSERT INTO 'devicecapvalue' VALUES (1199, 26, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (1200, 26, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (1201, 26, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (1202, 26, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1203, 26, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1204, 26, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1205, 26, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1206, 26, 6, 580);
INSERT INTO 'devicecapvalue' VALUES (1207, 26, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1208, 26, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (1209, 26, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (1210, 26, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1211, 26, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (1212, 27, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (1213, 27, 74, 583);
INSERT INTO 'devicecapvalue' VALUES (1214, 27, 75, 570);
INSERT INTO 'devicecapvalue' VALUES (1215, 27, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (1216, 27, 77, 594);
INSERT INTO 'devicecapvalue' VALUES (1217, 27, 78, 595);
INSERT INTO 'capvalue' VALUES (638, '53');
INSERT INTO 'devicecapvalue' VALUES (1218, 27, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (1219, 27, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (1220, 27, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1221, 27, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1222, 27, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1223, 27, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1224, 27, 6, 571);
INSERT INTO 'devicecapvalue' VALUES (1225, 27, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1226, 27, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (1227, 27, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (1228, 27, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1229, 27, 51, 569);
INSERT INTO 'capvalue' VALUES (639, 'Mozilla/2.0 (compatible; MSIE 3.02; Windows CE; PPC; 240x320) BlackBerry8700/4.1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 VendorID/154');
INSERT INTO 'devicecapvalue' VALUES (1230, 27, 53, 639);
INSERT INTO 'devicecapvalue' VALUES (1231, 28, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (1232, 28, 74, 583);
INSERT INTO 'devicecapvalue' VALUES (1233, 28, 75, 570);
INSERT INTO 'devicecapvalue' VALUES (1234, 28, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (1235, 28, 77, 594);
INSERT INTO 'devicecapvalue' VALUES (1236, 28, 78, 595);
INSERT INTO 'devicecapvalue' VALUES (1237, 28, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (1238, 28, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (1239, 28, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1240, 28, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1241, 28, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1242, 28, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1243, 28, 6, 571);
INSERT INTO 'devicecapvalue' VALUES (1244, 28, 6, 27);
INSERT INTO 'cap' VALUES (88, 'Network', 1);
INSERT INTO 'capvalue' VALUES (640, 'UMTS');
INSERT INTO 'devicecapvalue' VALUES (1245, 28, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (1246, 28, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (1247, 28, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (1248, 28, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1249, 28, 51, 569);
INSERT INTO 'capvalue' VALUES (641, 'BlackBerry8707/4.1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 VendorID/153');
INSERT INTO 'devicecapvalue' VALUES (1250, 28, 53, 641);
INSERT INTO 'devicecapvalue' VALUES (1251, 29, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (1252, 29, 74, 583);
INSERT INTO 'devicecapvalue' VALUES (1253, 29, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (1254, 29, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (1255, 29, 77, 594);
INSERT INTO 'devicecapvalue' VALUES (1256, 29, 78, 595);
INSERT INTO 'devicecapvalue' VALUES (1257, 29, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (1258, 29, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (1259, 29, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1260, 29, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1261, 29, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1262, 29, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1263, 29, 6, 573);
INSERT INTO 'devicecapvalue' VALUES (1264, 29, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1265, 29, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (1266, 29, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (1267, 29, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1268, 29, 51, 569);
INSERT INTO 'capvalue' VALUES (642, 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0) BlackBerry8800');
INSERT INTO 'devicecapvalue' VALUES (1269, 29, 53, 642);
INSERT INTO 'devicecapvalue' VALUES (1270, 30, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (1271, 30, 74, 583);
INSERT INTO 'devicecapvalue' VALUES (1272, 30, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (1273, 30, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (1274, 30, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1275, 30, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1276, 30, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1277, 30, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1278, 30, 6, 573);
INSERT INTO 'devicecapvalue' VALUES (1279, 30, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1280, 30, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (1281, 30, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (1282, 30, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1283, 30, 51, 569);
INSERT INTO 'capvalue' VALUES (643, 'BlackBerry8830/4.2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1 VendorID/105');
INSERT INTO 'devicecapvalue' VALUES (1284, 30, 53, 643);
INSERT INTO 'devicecapvalue' VALUES (1285, 31, 74, 583);
INSERT INTO 'capvalue' VALUES (644, '8900');
INSERT INTO 'devicecapvalue' VALUES (1286, 31, 75, 644);
INSERT INTO 'devicecapvalue' VALUES (1287, 31, 2, 574);
INSERT INTO 'capvalue' VALUES (645, '80');
INSERT INTO 'devicecapvalue' VALUES (1288, 31, 77, 645);
INSERT INTO 'devicecapvalue' VALUES (1289, 31, 78, 645);
INSERT INTO 'devicecapvalue' VALUES (1290, 31, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1291, 31, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (1292, 31, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (1293, 31, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (1294, 31, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1295, 31, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1296, 31, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1297, 31, 6, 582);
INSERT INTO 'devicecapvalue' VALUES (1298, 31, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1299, 31, 4, 7);
INSERT INTO 'capvalue' VALUES (646, '360');
INSERT INTO 'devicecapvalue' VALUES (1300, 31, 5, 646);
INSERT INTO 'devicecapvalue' VALUES (1301, 31, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1302, 31, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (1303, 32, 74, 583);
INSERT INTO 'devicecapvalue' VALUES (1304, 32, 75, 581);
INSERT INTO 'devicecapvalue' VALUES (1305, 32, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (1306, 32, 77, 645);
INSERT INTO 'devicecapvalue' VALUES (1307, 32, 78, 645);
INSERT INTO 'devicecapvalue' VALUES (1308, 32, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1309, 32, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (1310, 32, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (1311, 32, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (1312, 32, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1313, 32, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1314, 32, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1315, 32, 6, 582);
INSERT INTO 'devicecapvalue' VALUES (1316, 32, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1317, 32, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (1318, 32, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (1319, 32, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1320, 32, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (1321, 33, 74, 583);
INSERT INTO 'devicecapvalue' VALUES (1322, 33, 75, 584);
INSERT INTO 'devicecapvalue' VALUES (1323, 33, 2, 2);
INSERT INTO 'capvalue' VALUES (647, 'hasTouchEvents');
INSERT INTO 'devicecapvalue' VALUES (1324, 33, 2, 647);
INSERT INTO 'capvalue' VALUES (648, '73');
INSERT INTO 'devicecapvalue' VALUES (1325, 33, 77, 648);
INSERT INTO 'devicecapvalue' VALUES (1326, 33, 78, 648);
INSERT INTO 'devicecapvalue' VALUES (1327, 33, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1328, 33, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (1329, 33, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (1330, 33, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (1331, 33, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1332, 33, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1333, 33, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1334, 33, 6, 585);
INSERT INTO 'devicecapvalue' VALUES (1335, 33, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1336, 33, 4, 646);
INSERT INTO 'devicecapvalue' VALUES (1337, 33, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (1338, 33, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1339, 33, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (1340, 34, 74, 583);
INSERT INTO 'devicecapvalue' VALUES (1341, 34, 75, 581);
INSERT INTO 'devicecapvalue' VALUES (1342, 34, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (1343, 34, 77, 645);
INSERT INTO 'devicecapvalue' VALUES (1344, 34, 78, 645);
INSERT INTO 'devicecapvalue' VALUES (1345, 34, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1346, 34, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (1347, 34, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (1348, 34, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (1349, 34, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1350, 34, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1351, 34, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1352, 34, 6, 582);
INSERT INTO 'devicecapvalue' VALUES (1353, 34, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1354, 34, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (1355, 34, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (1356, 34, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1357, 34, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (1358, 35, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (1359, 35, 74, 565);
INSERT INTO 'devicecapvalue' VALUES (1360, 35, 7, 14);
INSERT INTO 'devicecapvalue' VALUES (1361, 35, 75, 579);
INSERT INTO 'devicecapvalue' VALUES (1362, 35, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (1363, 35, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (1364, 35, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (1365, 35, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1366, 35, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1367, 35, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1368, 35, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1369, 35, 6, 580);
INSERT INTO 'devicecapvalue' VALUES (1370, 35, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1371, 35, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (1372, 35, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (1373, 35, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1374, 35, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (1375, 36, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (1376, 36, 74, 565);
INSERT INTO 'devicecapvalue' VALUES (1377, 36, 75, 572);
INSERT INTO 'devicecapvalue' VALUES (1378, 36, 2, 574);
INSERT INTO 'devicecapvalue' VALUES (1379, 36, 13, 587);
INSERT INTO 'devicecapvalue' VALUES (1380, 36, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (1381, 36, 77, 594);
INSERT INTO 'devicecapvalue' VALUES (1382, 36, 78, 595);
INSERT INTO 'devicecapvalue' VALUES (1383, 36, 77, 596);
INSERT INTO 'devicecapvalue' VALUES (1384, 36, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (1385, 36, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1386, 36, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1387, 36, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1388, 36, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1389, 36, 6, 573);
INSERT INTO 'devicecapvalue' VALUES (1390, 36, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1391, 36, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (1392, 36, 5, 588);
INSERT INTO 'devicecapvalue' VALUES (1393, 36, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1394, 36, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (1395, 36, 53, 597);
INSERT INTO 'devicecapvalue' VALUES (1396, 37, 74, 583);
INSERT INTO 'devicecapvalue' VALUES (1397, 37, 75, 584);
INSERT INTO 'devicecapvalue' VALUES (1398, 37, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1399, 37, 2, 647);
INSERT INTO 'devicecapvalue' VALUES (1400, 37, 77, 648);
INSERT INTO 'devicecapvalue' VALUES (1401, 37, 78, 648);
INSERT INTO 'devicecapvalue' VALUES (1402, 37, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1403, 37, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (1404, 37, 17, 577);
INSERT INTO 'devicecapvalue' VALUES (1405, 37, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (1406, 37, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1407, 37, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (1408, 37, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1409, 37, 6, 585);
INSERT INTO 'devicecapvalue' VALUES (1410, 37, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1411, 37, 4, 646);
INSERT INTO 'devicecapvalue' VALUES (1412, 37, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (1413, 37, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1414, 37, 51, 569);
INSERT INTO 'capvalue' VALUES (649, '24');
INSERT INTO 'devicecapvalue' VALUES (1415, 38, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (1416, 38, 2, 2);
INSERT INTO 'capvalue' VALUES (650, 'Android/1.5');
INSERT INTO 'devicecapvalue' VALUES (1417, 38, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (1418, 38, 4, 7);
INSERT INTO 'capvalue' VALUES (651, '854');
INSERT INTO 'devicecapvalue' VALUES (1419, 38, 5, 651);
INSERT INTO 'capvalue' VALUES (652, 'BacklightRequiresLightOff');
INSERT INTO 'devicecapvalue' VALUES (1420, 39, 74, 652);
INSERT INTO 'capvalue' VALUES (653, 'SoftKeyMappedToFire');
INSERT INTO 'devicecapvalue' VALUES (1421, 39, 74, 653);
INSERT INTO 'capvalue' VALUES (654, 'displaySetCurrentFlickers');
INSERT INTO 'devicecapvalue' VALUES (1422, 39, 74, 654);
INSERT INTO 'capvalue' VALUES (655, 'needsBottomOrientiationForStringDrawing');
INSERT INTO 'devicecapvalue' VALUES (1423, 39, 74, 655);
INSERT INTO 'capvalue' VALUES (656, 'noSoftKeyReleasedEvents');
INSERT INTO 'devicecapvalue' VALUES (1424, 39, 74, 656);
INSERT INTO 'capvalue' VALUES (657, 'hasCommandKeyEvents');
INSERT INTO 'devicecapvalue' VALUES (1425, 39, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1426, 39, 2, 2);
INSERT INTO 'capvalue' VALUES (658, 'isDynamic');
INSERT INTO 'devicecapvalue' VALUES (1427, 39, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1428, 39, 2, 567);
INSERT INTO 'capvalue' VALUES (659, '1048576');
INSERT INTO 'devicecapvalue' VALUES (1429, 39, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1430, 39, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1431, 39, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1432, 39, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1433, 39, 6, 27);
INSERT INTO 'capvalue' VALUES (660, 'MSA/1.0');
INSERT INTO 'devicecapvalue' VALUES (1434, 39, 6, 660);
INSERT INTO 'cap' VALUES (89, 'key.LeftSoftKeys', 1);
INSERT INTO 'devicecapvalue' VALUES (1435, 39, 89, 41);
INSERT INTO 'capvalue' VALUES (661, '-202');
INSERT INTO 'devicecapvalue' VALUES (1436, 39, 89, 661);
INSERT INTO 'capvalue' VALUES (662, '-21');
INSERT INTO 'devicecapvalue' VALUES (1437, 39, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1438, 39, 89, 36);
INSERT INTO 'capvalue' VALUES (663, '21');
INSERT INTO 'devicecapvalue' VALUES (1439, 39, 89, 663);
INSERT INTO 'capvalue' VALUES (664, '57345');
INSERT INTO 'devicecapvalue' VALUES (1440, 39, 89, 664);
INSERT INTO 'cap' VALUES (90, 'key.maybeSupportsAsciiKeyMap', 1);
INSERT INTO 'devicecapvalue' VALUES (1441, 39, 90, 15);
INSERT INTO 'cap' VALUES (91, 'key.RightSoftKeys', 1);
INSERT INTO 'capvalue' VALUES (665, '-203');
INSERT INTO 'devicecapvalue' VALUES (1442, 39, 91, 665);
INSERT INTO 'capvalue' VALUES (666, '-22');
INSERT INTO 'devicecapvalue' VALUES (1443, 39, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1444, 39, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1445, 39, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1446, 39, 91, 12);
INSERT INTO 'capvalue' VALUES (667, '57346');
INSERT INTO 'devicecapvalue' VALUES (1447, 39, 91, 667);
INSERT INTO 'cap' VALUES (92, 'MenuBar.OptionsPosition', 1);
INSERT INTO 'capvalue' VALUES (668, 'left');
INSERT INTO 'devicecapvalue' VALUES (1448, 39, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1449, 39, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1450, 39, 51, 102);
INSERT INTO 'capvalue' VALUES (669, 'wav');
INSERT INTO 'devicecapvalue' VALUES (1451, 39, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1452, 40, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1453, 40, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1454, 40, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1455, 40, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1456, 40, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1457, 40, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1458, 40, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1459, 40, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1460, 40, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1461, 40, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1462, 40, 77, 606);
INSERT INTO 'devicecapvalue' VALUES (1463, 40, 78, 606);
INSERT INTO 'devicecapvalue' VALUES (1464, 40, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1465, 40, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1466, 40, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1467, 40, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1468, 40, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (1469, 40, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1470, 40, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1471, 40, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1472, 40, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1473, 40, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1474, 40, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1475, 40, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1476, 40, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1477, 40, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1478, 40, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1479, 40, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1480, 40, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1481, 40, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1482, 40, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1483, 40, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (1484, 40, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (1485, 40, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1486, 40, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1487, 40, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1488, 41, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1489, 41, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1490, 41, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1491, 41, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1492, 41, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1493, 41, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1494, 41, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1495, 41, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1496, 41, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1497, 41, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1498, 41, 77, 606);
INSERT INTO 'devicecapvalue' VALUES (1499, 41, 78, 606);
INSERT INTO 'devicecapvalue' VALUES (1500, 41, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1501, 41, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1502, 41, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1503, 41, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1504, 41, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (1505, 41, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1506, 41, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1507, 41, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1508, 41, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1509, 41, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1510, 41, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1511, 41, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1512, 41, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1513, 41, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1514, 41, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1515, 41, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1516, 41, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1517, 41, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1518, 41, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1519, 41, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (1520, 41, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (1521, 41, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1522, 41, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1523, 41, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1524, 42, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1525, 42, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1526, 42, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1527, 42, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1528, 42, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1529, 42, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1530, 42, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1531, 42, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1532, 42, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1533, 42, 76, 659);
INSERT INTO 'capvalue' VALUES (670, '44');
INSERT INTO 'devicecapvalue' VALUES (1534, 42, 77, 670);
INSERT INTO 'devicecapvalue' VALUES (1535, 42, 78, 670);
INSERT INTO 'devicecapvalue' VALUES (1536, 42, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1537, 42, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1538, 42, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1539, 42, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1540, 42, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (1541, 42, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1542, 42, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1543, 42, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1544, 42, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1545, 42, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1546, 42, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1547, 42, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1548, 42, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1549, 42, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1550, 42, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1551, 42, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1552, 42, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1553, 42, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1554, 42, 92, 668);
INSERT INTO 'capvalue' VALUES (671, '352');
INSERT INTO 'devicecapvalue' VALUES (1555, 42, 4, 671);
INSERT INTO 'capvalue' VALUES (672, '416');
INSERT INTO 'devicecapvalue' VALUES (1556, 42, 5, 672);
INSERT INTO 'devicecapvalue' VALUES (1557, 42, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1558, 42, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1559, 42, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1560, 43, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1561, 43, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1562, 43, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1563, 43, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1564, 43, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1565, 43, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1566, 43, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1567, 43, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1568, 43, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1569, 43, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1570, 43, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1571, 43, 17, 115);
INSERT INTO 'capvalue' VALUES (673, 'security');
INSERT INTO 'devicecapvalue' VALUES (1572, 43, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (1573, 43, 17, 113);
INSERT INTO 'capvalue' VALUES (674, 'sip');
INSERT INTO 'devicecapvalue' VALUES (1574, 43, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (1575, 43, 17, 576);
INSERT INTO 'capvalue' VALUES (675, 'advancedmultimedia');
INSERT INTO 'devicecapvalue' VALUES (1576, 43, 17, 675);
INSERT INTO 'capvalue' VALUES (676, 'i18n');
INSERT INTO 'devicecapvalue' VALUES (1577, 43, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (1578, 43, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1579, 43, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (1580, 43, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1581, 43, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1582, 43, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1583, 43, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1584, 43, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1585, 43, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1586, 43, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1587, 43, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1588, 43, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1589, 43, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1590, 43, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1591, 43, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1592, 43, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1593, 43, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1594, 43, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1595, 43, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1596, 43, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1597, 44, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1598, 44, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1599, 44, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1600, 44, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1601, 44, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1602, 44, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1603, 44, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1604, 44, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1605, 44, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1606, 44, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1607, 44, 77, 606);
INSERT INTO 'devicecapvalue' VALUES (1608, 44, 78, 606);
INSERT INTO 'devicecapvalue' VALUES (1609, 44, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1610, 44, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (1611, 44, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (1612, 44, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (1613, 44, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (1614, 44, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (1615, 44, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (1616, 44, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (1617, 44, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1618, 44, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (1619, 44, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1620, 44, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1621, 44, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1622, 44, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1623, 44, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1624, 44, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1625, 44, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1626, 44, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1627, 44, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1628, 44, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1629, 44, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1630, 44, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1631, 44, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1632, 44, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1633, 44, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (1634, 44, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (1635, 44, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1636, 44, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1637, 44, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1638, 45, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1639, 45, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1640, 45, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1641, 45, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1642, 45, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1643, 45, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1644, 45, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1645, 45, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1646, 45, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1647, 45, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1648, 45, 77, 606);
INSERT INTO 'devicecapvalue' VALUES (1649, 45, 78, 606);
INSERT INTO 'devicecapvalue' VALUES (1650, 45, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1651, 45, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (1652, 45, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (1653, 45, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (1654, 45, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (1655, 45, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (1656, 45, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (1657, 45, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (1658, 45, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1659, 45, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (1660, 45, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1661, 45, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1662, 45, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1663, 45, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1664, 45, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1665, 45, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1666, 45, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1667, 45, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1668, 45, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1669, 45, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1670, 45, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1671, 45, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1672, 45, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1673, 45, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1674, 45, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (1675, 45, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (1676, 45, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1677, 45, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1678, 45, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1679, 46, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1680, 46, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1681, 46, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1682, 46, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1683, 46, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1684, 46, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1685, 46, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1686, 46, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1687, 46, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1688, 46, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1689, 46, 77, 670);
INSERT INTO 'devicecapvalue' VALUES (1690, 46, 78, 670);
INSERT INTO 'devicecapvalue' VALUES (1691, 46, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1692, 46, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (1693, 46, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (1694, 46, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (1695, 46, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (1696, 46, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (1697, 46, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (1698, 46, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (1699, 46, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1700, 46, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (1701, 46, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1702, 46, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1703, 46, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1704, 46, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1705, 46, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1706, 46, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1707, 46, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1708, 46, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1709, 46, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1710, 46, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1711, 46, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1712, 46, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1713, 46, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1714, 46, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1715, 46, 4, 671);
INSERT INTO 'devicecapvalue' VALUES (1716, 46, 5, 672);
INSERT INTO 'devicecapvalue' VALUES (1717, 46, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1718, 46, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1719, 46, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1720, 47, 74, 652);
INSERT INTO 'capvalue' VALUES (677, 'SnapshotRequiresScreenChange');
INSERT INTO 'devicecapvalue' VALUES (1721, 47, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (1722, 47, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1723, 47, 74, 654);
INSERT INTO 'capvalue' VALUES (678, 'keyRepeatOverload');
INSERT INTO 'devicecapvalue' VALUES (1724, 47, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (1725, 47, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1726, 47, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1727, 47, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1728, 47, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1729, 47, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1730, 47, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1731, 47, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1732, 47, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1733, 47, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (1734, 47, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (1735, 47, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1736, 47, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1737, 47, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (1738, 47, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1739, 47, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1740, 47, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1741, 47, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1742, 47, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1743, 47, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1744, 47, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1745, 47, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1746, 47, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1747, 47, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1748, 47, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1749, 47, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1750, 47, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1751, 47, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1752, 47, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1753, 47, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1754, 47, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1755, 47, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1756, 48, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1757, 48, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (1758, 48, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1759, 48, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1760, 48, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (1761, 48, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1762, 48, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1763, 48, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1764, 48, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1765, 48, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1766, 48, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1767, 48, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1768, 48, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1769, 48, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (1770, 48, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (1771, 48, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1772, 48, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1773, 48, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (1774, 48, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1775, 48, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1776, 48, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1777, 48, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1778, 48, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1779, 48, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1780, 48, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1781, 48, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1782, 48, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1783, 48, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1784, 48, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1785, 48, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1786, 48, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1787, 48, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1788, 48, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1789, 48, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (1790, 48, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (1791, 48, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1792, 48, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1793, 48, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1794, 49, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1795, 49, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (1796, 49, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1797, 49, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1798, 49, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (1799, 49, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1800, 49, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1801, 49, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1802, 49, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1803, 49, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1804, 49, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1805, 49, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1806, 49, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (1807, 49, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (1808, 49, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (1809, 49, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1810, 49, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1811, 49, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (1812, 49, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1813, 49, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1814, 49, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1815, 49, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1816, 49, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1817, 49, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1818, 49, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1819, 49, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1820, 49, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1821, 49, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1822, 49, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1823, 49, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1824, 49, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1825, 49, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1826, 49, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1827, 49, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (1828, 49, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (1829, 49, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1830, 49, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1831, 49, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1832, 50, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1833, 50, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (1834, 50, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1835, 50, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1836, 50, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (1837, 50, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1838, 50, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1839, 50, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1840, 50, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1841, 50, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1842, 50, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1843, 50, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1844, 50, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1845, 50, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (1846, 50, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (1847, 50, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1848, 50, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1849, 50, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (1850, 50, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1851, 50, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1852, 50, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1853, 50, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1854, 50, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1855, 50, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1856, 50, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1857, 50, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1858, 50, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1859, 50, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1860, 50, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1861, 50, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1862, 50, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1863, 50, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1864, 50, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1865, 50, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (1866, 50, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (1867, 50, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1868, 50, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1869, 50, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1870, 51, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1871, 51, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (1872, 51, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1873, 51, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1874, 51, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (1875, 51, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1876, 51, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1877, 51, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1878, 51, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1879, 51, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1880, 51, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1881, 51, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1882, 51, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (1883, 51, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (1884, 51, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (1885, 51, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1886, 51, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1887, 51, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (1888, 51, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1889, 51, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1890, 51, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1891, 51, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1892, 51, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1893, 51, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1894, 51, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1895, 51, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1896, 51, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1897, 51, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1898, 51, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1899, 51, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1900, 51, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1901, 51, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1902, 51, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1903, 51, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (1904, 51, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (1905, 51, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1906, 51, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1907, 51, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1908, 52, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1909, 52, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (1910, 52, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1911, 52, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1912, 52, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (1913, 52, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1914, 52, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1915, 52, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1916, 52, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1917, 52, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1918, 52, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1919, 52, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1920, 52, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (1921, 52, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (1922, 52, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (1923, 52, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (1924, 52, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (1925, 52, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1926, 52, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1927, 52, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (1928, 52, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1929, 52, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1930, 52, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1931, 52, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1932, 52, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1933, 52, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1934, 52, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1935, 52, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1936, 52, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1937, 52, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1938, 52, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1939, 52, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1940, 52, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1941, 52, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1942, 52, 92, 668);
INSERT INTO 'capvalue' VALUES (679, '176');
INSERT INTO 'devicecapvalue' VALUES (1943, 52, 4, 679);
INSERT INTO 'capvalue' VALUES (680, '208');
INSERT INTO 'devicecapvalue' VALUES (1944, 52, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (1945, 52, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1946, 52, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1947, 52, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1948, 53, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1949, 53, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (1950, 53, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1951, 53, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1952, 53, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (1953, 53, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1954, 53, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1955, 53, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1956, 53, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1957, 53, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1958, 53, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1959, 53, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (1960, 53, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (1961, 53, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (1962, 53, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (1963, 53, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (1964, 53, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (1965, 53, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (1966, 53, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (1967, 53, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (1968, 53, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (1969, 53, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (1970, 53, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (1971, 53, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (1972, 53, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (1973, 53, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (1974, 53, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (1975, 53, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (1976, 53, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (1977, 53, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (1978, 53, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (1979, 53, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (1980, 53, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (1981, 53, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (1982, 53, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (1983, 53, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (1984, 53, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (1985, 53, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (1986, 53, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (1987, 53, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (1988, 54, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (1989, 54, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (1990, 54, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (1991, 54, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (1992, 54, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (1993, 54, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (1994, 54, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (1995, 54, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (1996, 54, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (1997, 54, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (1998, 54, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (1999, 54, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (2000, 54, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (2001, 54, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (2002, 54, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2003, 54, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (2004, 54, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (2005, 54, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2006, 54, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2007, 54, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2008, 54, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2009, 54, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (2010, 54, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (2011, 54, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (2012, 54, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (2013, 54, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (2014, 54, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (2015, 54, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (2016, 54, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (2017, 54, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (2018, 54, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (2019, 54, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (2020, 54, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (2021, 54, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (2022, 54, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (2023, 54, 4, 679);
INSERT INTO 'capvalue' VALUES (681, '220');
INSERT INTO 'devicecapvalue' VALUES (2024, 54, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (2025, 54, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2026, 54, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2027, 54, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (2028, 55, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (2029, 55, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (2030, 55, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (2031, 55, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (2032, 55, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (2033, 55, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (2034, 55, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (2035, 55, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (2036, 55, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2037, 55, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (2038, 55, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2039, 55, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (2040, 55, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (2041, 55, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (2042, 55, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2043, 55, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (2044, 55, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (2045, 55, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2046, 55, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2047, 55, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2048, 55, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2049, 55, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (2050, 55, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (2051, 55, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (2052, 55, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (2053, 55, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (2054, 55, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (2055, 55, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (2056, 55, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (2057, 55, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (2058, 55, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (2059, 55, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (2060, 55, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (2061, 55, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (2062, 55, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (2063, 55, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (2064, 55, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (2065, 55, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2066, 55, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2067, 55, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (2068, 56, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (2069, 56, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (2070, 56, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (2071, 56, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (2072, 56, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (2073, 56, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (2074, 56, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (2075, 56, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (2076, 56, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2077, 56, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (2078, 56, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2079, 56, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (2080, 56, 77, 606);
INSERT INTO 'devicecapvalue' VALUES (2081, 56, 78, 606);
INSERT INTO 'devicecapvalue' VALUES (2082, 56, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2083, 56, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (2084, 56, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (2085, 56, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2086, 56, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2087, 56, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2088, 56, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2089, 56, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (2090, 56, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (2091, 56, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (2092, 56, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (2093, 56, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (2094, 56, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (2095, 56, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (2096, 56, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (2097, 56, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (2098, 56, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (2099, 56, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (2100, 56, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (2101, 56, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (2102, 56, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (2103, 56, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (2104, 56, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2105, 56, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2106, 56, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2107, 56, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (2108, 57, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (2109, 57, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (2110, 57, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (2111, 57, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (2112, 57, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (2113, 57, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (2114, 57, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (2115, 57, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (2116, 57, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2117, 57, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (2118, 57, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2119, 57, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (2120, 57, 77, 606);
INSERT INTO 'devicecapvalue' VALUES (2121, 57, 78, 606);
INSERT INTO 'devicecapvalue' VALUES (2122, 57, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2123, 57, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (2124, 57, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (2125, 57, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2126, 57, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2127, 57, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2128, 57, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2129, 57, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (2130, 57, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (2131, 57, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (2132, 57, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (2133, 57, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (2134, 57, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (2135, 57, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (2136, 57, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (2137, 57, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (2138, 57, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (2139, 57, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (2140, 57, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (2141, 57, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (2142, 57, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (2143, 57, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2144, 57, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (2145, 57, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2146, 57, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2147, 57, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (2148, 58, 74, 652);
INSERT INTO 'devicecapvalue' VALUES (2149, 58, 74, 677);
INSERT INTO 'devicecapvalue' VALUES (2150, 58, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (2151, 58, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (2152, 58, 74, 678);
INSERT INTO 'devicecapvalue' VALUES (2153, 58, 74, 655);
INSERT INTO 'devicecapvalue' VALUES (2154, 58, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (2155, 58, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (2156, 58, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2157, 58, 2, 658);
INSERT INTO 'devicecapvalue' VALUES (2158, 58, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2159, 58, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (2160, 58, 77, 670);
INSERT INTO 'devicecapvalue' VALUES (2161, 58, 78, 670);
INSERT INTO 'devicecapvalue' VALUES (2162, 58, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2163, 58, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (2164, 58, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (2165, 58, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2166, 58, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2167, 58, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2168, 58, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2169, 58, 89, 41);
INSERT INTO 'devicecapvalue' VALUES (2170, 58, 89, 661);
INSERT INTO 'devicecapvalue' VALUES (2171, 58, 89, 662);
INSERT INTO 'devicecapvalue' VALUES (2172, 58, 89, 36);
INSERT INTO 'devicecapvalue' VALUES (2173, 58, 89, 663);
INSERT INTO 'devicecapvalue' VALUES (2174, 58, 89, 664);
INSERT INTO 'devicecapvalue' VALUES (2175, 58, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (2176, 58, 91, 665);
INSERT INTO 'devicecapvalue' VALUES (2177, 58, 91, 666);
INSERT INTO 'devicecapvalue' VALUES (2178, 58, 91, 39);
INSERT INTO 'devicecapvalue' VALUES (2179, 58, 91, 40);
INSERT INTO 'devicecapvalue' VALUES (2180, 58, 91, 12);
INSERT INTO 'devicecapvalue' VALUES (2181, 58, 91, 667);
INSERT INTO 'devicecapvalue' VALUES (2182, 58, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (2183, 58, 4, 671);
INSERT INTO 'devicecapvalue' VALUES (2184, 58, 5, 672);
INSERT INTO 'devicecapvalue' VALUES (2185, 58, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2186, 58, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2187, 58, 51, 669);
INSERT INTO 'capvalue' VALUES (682, 'DefaultColorPhone');
INSERT INTO 'devicecapvalue' VALUES (2188, 59, 75, 682);
INSERT INTO 'devicecapvalue' VALUES (2189, 59, 2, 567);
INSERT INTO 'capvalue' VALUES (683, '20971520');
INSERT INTO 'devicecapvalue' VALUES (2190, 59, 76, 683);
INSERT INTO 'devicecapvalue' VALUES (2191, 59, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2192, 59, 17, 22);
INSERT INTO 'capvalue' VALUES (684, 'pdaapi');
INSERT INTO 'devicecapvalue' VALUES (2193, 59, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (2194, 59, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2195, 59, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2196, 59, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2197, 59, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2198, 59, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2199, 59, 51, 669);
INSERT INTO 'capvalue' VALUES (685, 'DefaultGrayPhone');
INSERT INTO 'devicecapvalue' VALUES (2200, 60, 75, 685);
INSERT INTO 'devicecapvalue' VALUES (2201, 60, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2202, 60, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2203, 60, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2204, 60, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2205, 60, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2206, 60, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2207, 60, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2208, 60, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2209, 60, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (2210, 61, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2211, 61, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2212, 61, 76, 683);
INSERT INTO 'capvalue' VALUES (686, 'right');
INSERT INTO 'devicecapvalue' VALUES (2213, 61, 92, 686);
INSERT INTO 'capvalue' VALUES (687, 'Windows Mobile 5.0');
INSERT INTO 'devicecapvalue' VALUES (2214, 61, 3, 687);
INSERT INTO 'devicecapvalue' VALUES (2215, 61, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2216, 61, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2217, 61, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (2218, 62, 1, 106);
INSERT INTO 'capvalue' VALUES (688, '240x320');
INSERT INTO 'devicecapvalue' VALUES (2219, 62, 7, 688);
INSERT INTO 'capvalue' VALUES (689, 'Series60');
INSERT INTO 'devicecapvalue' VALUES (2220, 62, 75, 689);
INSERT INTO 'devicecapvalue' VALUES (2221, 62, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (2222, 62, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2223, 62, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2224, 62, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (2225, 62, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2226, 62, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (2227, 62, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2228, 62, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (2229, 62, 17, 25);
INSERT INTO 'capvalue' VALUES (690, 'JavaSE/1.0');
INSERT INTO 'devicecapvalue' VALUES (2230, 62, 6, 690);
INSERT INTO 'devicecapvalue' VALUES (2231, 62, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2232, 62, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (2233, 62, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2234, 63, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2235, 63, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2236, 63, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2237, 63, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2238, 63, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2239, 63, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2240, 63, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2241, 63, 51, 102);
INSERT INTO 'capvalue' VALUES (691, 'MediaControlSkin');
INSERT INTO 'devicecapvalue' VALUES (2242, 64, 75, 691);
INSERT INTO 'devicecapvalue' VALUES (2243, 64, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2244, 64, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2245, 64, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2246, 64, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (2247, 64, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2248, 64, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2249, 64, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2250, 64, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2251, 64, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2252, 64, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (2253, 65, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2254, 65, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2255, 65, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2256, 66, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2257, 66, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2258, 66, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2259, 66, 6, 27);
INSERT INTO 'cap' VALUES (93, 'Emulator.Class', 1);
INSERT INTO 'capvalue' VALUES (692, 'MppEmulator');
INSERT INTO 'devicecapvalue' VALUES (2260, 67, 93, 692);
INSERT INTO 'devicecapvalue' VALUES (2261, 67, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (2262, 67, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2263, 67, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2264, 67, 76, 683);
INSERT INTO 'devicecapvalue' VALUES (2265, 67, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2266, 67, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2267, 67, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2268, 67, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2269, 67, 6, 27);
INSERT INTO 'cap' VALUES (94, 'key.backspace', 1);
INSERT INTO 'devicecapvalue' VALUES (2270, 67, 94, 625);
INSERT INTO 'cap' VALUES (95, 'key.enter', 1);
INSERT INTO 'capvalue' VALUES (693, '10');
INSERT INTO 'devicecapvalue' VALUES (2271, 67, 95, 693);
INSERT INTO 'devicecapvalue' VALUES (2272, 67, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (2273, 67, 30, 40);
INSERT INTO 'cap' VALUES (96, 'key.shift', 1);
INSERT INTO 'capvalue' VALUES (694, '-50');
INSERT INTO 'devicecapvalue' VALUES (2274, 67, 96, 694);
INSERT INTO 'cap' VALUES (97, 'key.supportsAsciiKeyMap', 1);
INSERT INTO 'devicecapvalue' VALUES (2275, 67, 97, 15);
INSERT INTO 'cap' VALUES (98, 'MenuBar.OkPosition', 1);
INSERT INTO 'devicecapvalue' VALUES (2276, 67, 98, 668);
INSERT INTO 'devicecapvalue' VALUES (2277, 67, 92, 686);
INSERT INTO 'cap' VALUES (99, 'polish.debug.commandline', 1);
INSERT INTO 'capvalue' VALUES (695, '-Xdebug;;-Xrunjdwp:transport=dt_socket');
INSERT INTO 'devicecapvalue' VALUES (2278, 67, 99, 695);
INSERT INTO 'capvalue' VALUES (696, 'address=${polish.debug.port}');
INSERT INTO 'devicecapvalue' VALUES (2279, 67, 99, 696);
INSERT INTO 'capvalue' VALUES (697, 'server=y');
INSERT INTO 'devicecapvalue' VALUES (2280, 67, 99, 697);
INSERT INTO 'capvalue' VALUES (698, 'suspend=n');
INSERT INTO 'devicecapvalue' VALUES (2281, 67, 99, 698);
INSERT INTO 'devicecapvalue' VALUES (2282, 67, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2283, 67, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2284, 67, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (2285, 68, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2286, 68, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (2287, 68, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2288, 69, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2289, 69, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2290, 69, 6, 27);
INSERT INTO 'capvalue' VALUES (699, 'QwertyDevice');
INSERT INTO 'devicecapvalue' VALUES (2291, 70, 75, 699);
INSERT INTO 'devicecapvalue' VALUES (2292, 70, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2293, 70, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2294, 70, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2295, 70, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (2296, 70, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2297, 70, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2298, 70, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2299, 70, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2300, 70, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2301, 70, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (2302, 71, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (2303, 71, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2304, 71, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2305, 71, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (2306, 71, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2307, 71, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2308, 71, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2309, 71, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2310, 71, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2311, 71, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (2312, 71, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (2313, 71, 98, 668);
INSERT INTO 'devicecapvalue' VALUES (2314, 71, 92, 686);
INSERT INTO 'devicecapvalue' VALUES (2315, 71, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2316, 71, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2317, 71, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (2318, 72, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2319, 72, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2320, 72, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2321, 73, 2, 567);
INSERT INTO 'capvalue' VALUES (700, 'Android/1.1');
INSERT INTO 'devicecapvalue' VALUES (2322, 73, 16, 700);
INSERT INTO 'devicecapvalue' VALUES (2323, 73, 6, 700);
INSERT INTO 'capvalue' VALUES (701, 'HVGA');
INSERT INTO 'devicecapvalue' VALUES (2324, 74, 75, 701);
INSERT INTO 'devicecapvalue' VALUES (2325, 74, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2326, 74, 16, 700);
INSERT INTO 'devicecapvalue' VALUES (2327, 74, 6, 700);
INSERT INTO 'devicecapvalue' VALUES (2328, 74, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2329, 74, 5, 7);
INSERT INTO 'capvalue' VALUES (702, 'HVGA-L');
INSERT INTO 'devicecapvalue' VALUES (2330, 75, 75, 702);
INSERT INTO 'devicecapvalue' VALUES (2331, 75, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2332, 75, 16, 700);
INSERT INTO 'devicecapvalue' VALUES (2333, 75, 6, 700);
INSERT INTO 'devicecapvalue' VALUES (2334, 75, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (2335, 75, 5, 601);
INSERT INTO 'capvalue' VALUES (703, 'HVGA-P');
INSERT INTO 'devicecapvalue' VALUES (2336, 76, 75, 703);
INSERT INTO 'devicecapvalue' VALUES (2337, 76, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2338, 76, 16, 700);
INSERT INTO 'devicecapvalue' VALUES (2339, 76, 6, 700);
INSERT INTO 'devicecapvalue' VALUES (2340, 76, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2341, 76, 5, 7);
INSERT INTO 'capvalue' VALUES (704, 'QVGA-L');
INSERT INTO 'devicecapvalue' VALUES (2342, 77, 75, 704);
INSERT INTO 'devicecapvalue' VALUES (2343, 77, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2344, 77, 16, 700);
INSERT INTO 'devicecapvalue' VALUES (2345, 77, 6, 700);
INSERT INTO 'devicecapvalue' VALUES (2346, 77, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2347, 77, 5, 5);
INSERT INTO 'capvalue' VALUES (705, 'QVGA-P');
INSERT INTO 'devicecapvalue' VALUES (2348, 78, 75, 705);
INSERT INTO 'devicecapvalue' VALUES (2349, 78, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2350, 78, 16, 700);
INSERT INTO 'devicecapvalue' VALUES (2351, 78, 6, 700);
INSERT INTO 'devicecapvalue' VALUES (2352, 78, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (2353, 78, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2354, 79, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2355, 79, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2356, 79, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2357, 80, 75, 701);
INSERT INTO 'devicecapvalue' VALUES (2358, 80, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2359, 80, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2360, 80, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2361, 80, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2362, 80, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (2363, 81, 75, 702);
INSERT INTO 'devicecapvalue' VALUES (2364, 81, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2365, 81, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2366, 81, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2367, 81, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (2368, 81, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2369, 82, 75, 703);
INSERT INTO 'devicecapvalue' VALUES (2370, 82, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2371, 82, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2372, 82, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2373, 82, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2374, 82, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (2375, 83, 75, 704);
INSERT INTO 'devicecapvalue' VALUES (2376, 83, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2377, 83, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2378, 83, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2379, 83, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2380, 83, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (2381, 84, 75, 705);
INSERT INTO 'devicecapvalue' VALUES (2382, 84, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2383, 84, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2384, 84, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2385, 84, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (2386, 84, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2387, 85, 75, 701);
INSERT INTO 'devicecapvalue' VALUES (2388, 85, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2389, 85, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2390, 85, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2391, 85, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2392, 85, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (2393, 86, 75, 702);
INSERT INTO 'devicecapvalue' VALUES (2394, 86, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2395, 86, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2396, 86, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2397, 86, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (2398, 86, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2399, 87, 75, 703);
INSERT INTO 'devicecapvalue' VALUES (2400, 87, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2401, 87, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2402, 87, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2403, 87, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2404, 87, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (2405, 88, 75, 704);
INSERT INTO 'devicecapvalue' VALUES (2406, 88, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2407, 88, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2408, 88, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2409, 88, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2410, 88, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (2411, 89, 75, 705);
INSERT INTO 'devicecapvalue' VALUES (2412, 89, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2413, 89, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2414, 89, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2415, 89, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (2416, 89, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2417, 90, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2418, 90, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (2419, 90, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2420, 90, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2421, 90, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2422, 90, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2423, 90, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2424, 91, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2425, 91, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (2426, 91, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2427, 91, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2428, 91, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2429, 91, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2430, 91, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2431, 91, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2432, 92, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2433, 92, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (2434, 92, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2435, 93, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2436, 93, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2437, 93, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (2438, 93, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (2439, 93, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2440, 93, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (2441, 93, 17, 684);
INSERT INTO 'capvalue' VALUES (706, 'svg');
INSERT INTO 'devicecapvalue' VALUES (2442, 93, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (2443, 93, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2444, 93, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2445, 94, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2446, 94, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2447, 94, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (2448, 94, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2449, 94, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (2450, 94, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2451, 94, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2452, 95, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2453, 95, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (2454, 95, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2455, 95, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2456, 95, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2457, 95, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2458, 95, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (2459, 95, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (2460, 96, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (2461, 96, 76, 683);
INSERT INTO 'devicecapvalue' VALUES (2462, 96, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2463, 96, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2464, 96, 94, 1);
INSERT INTO 'devicecapvalue' VALUES (2465, 96, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (2466, 96, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (2467, 96, 98, 668);
INSERT INTO 'devicecapvalue' VALUES (2468, 96, 92, 686);
INSERT INTO 'devicecapvalue' VALUES (2469, 96, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (2470, 96, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2471, 97, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (2472, 97, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2473, 97, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (2474, 97, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2475, 97, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (2476, 98, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (2477, 98, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2478, 98, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2479, 98, 4, 8);
INSERT INTO 'devicecapvalue' VALUES (2480, 98, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (2481, 99, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (2482, 99, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2483, 99, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2484, 99, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (2485, 99, 5, 8);
INSERT INTO 'capvalue' VALUES (707, '256');
INSERT INTO 'devicecapvalue' VALUES (2486, 100, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (2487, 100, 79, 15);
INSERT INTO 'capvalue' VALUES (708, '480x536');
INSERT INTO 'devicecapvalue' VALUES (2488, 100, 7, 708);
INSERT INTO 'devicecapvalue' VALUES (2489, 100, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (2490, 100, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (2491, 100, 2, 2);
INSERT INTO 'capvalue' VALUES (709, '17');
INSERT INTO 'devicecapvalue' VALUES (2492, 100, 9, 709);
INSERT INTO 'capvalue' VALUES (710, '19');
INSERT INTO 'devicecapvalue' VALUES (2493, 100, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (2494, 100, 11, 709);
INSERT INTO 'capvalue' VALUES (711, '13');
INSERT INTO 'devicecapvalue' VALUES (2495, 100, 12, 711);
INSERT INTO 'capvalue' VALUES (712, '480x640');
INSERT INTO 'devicecapvalue' VALUES (2496, 100, 13, 712);
INSERT INTO 'devicecapvalue' VALUES (2497, 100, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (2498, 100, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (2499, 100, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (2500, 100, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (2501, 100, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2502, 100, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (2503, 100, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2504, 100, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (2505, 100, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (2506, 100, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2507, 100, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2508, 100, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2509, 100, 18, 30);
INSERT INTO 'devicecapvalue' VALUES (2510, 100, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (2511, 100, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (2512, 100, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (2513, 100, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (2514, 100, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (2515, 100, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (2516, 100, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (2517, 100, 26, 30);
INSERT INTO 'devicecapvalue' VALUES (2518, 100, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (2519, 100, 57, 30);
INSERT INTO 'devicecapvalue' VALUES (2520, 100, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (2521, 100, 30, 30);
INSERT INTO 'devicecapvalue' VALUES (2522, 100, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (2523, 100, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (2524, 100, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (2525, 100, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (2526, 100, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (2527, 100, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (2528, 100, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (2529, 100, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (2530, 100, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (2531, 100, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (2532, 100, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (2533, 100, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (2534, 100, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (2535, 100, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (2536, 100, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (2537, 100, 44, 15);
INSERT INTO 'cap' VALUES (100, 'nokiasound', 1);
INSERT INTO 'devicecapvalue' VALUES (2538, 100, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (2539, 100, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (2540, 100, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (2541, 100, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (2542, 100, 46, 71);
INSERT INTO 'capvalue' VALUES (713, 'fileconn.dir.memorycard.name');
INSERT INTO 'devicecapvalue' VALUES (2543, 100, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (2544, 100, 46, 72);
INSERT INTO 'capvalue' VALUES (714, 'fileconn.dir.photos.name');
INSERT INTO 'devicecapvalue' VALUES (2545, 100, 46, 714);
INSERT INTO 'capvalue' VALUES (715, 'fileconn.dir.private');
INSERT INTO 'devicecapvalue' VALUES (2546, 100, 46, 715);
INSERT INTO 'capvalue' VALUES (716, 'fileconn.dir.tones');
INSERT INTO 'devicecapvalue' VALUES (2547, 100, 46, 716);
INSERT INTO 'capvalue' VALUES (717, 'fileconn.dir.tones.name');
INSERT INTO 'devicecapvalue' VALUES (2548, 100, 46, 717);
INSERT INTO 'capvalue' VALUES (718, 'fileconn.dir.videos');
INSERT INTO 'devicecapvalue' VALUES (2549, 100, 46, 718);
INSERT INTO 'capvalue' VALUES (719, 'fileconn.dir.videos.name');
INSERT INTO 'devicecapvalue' VALUES (2550, 100, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (2551, 100, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (2552, 100, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (2553, 100, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (2554, 100, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (2555, 100, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (2556, 100, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (2557, 100, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (2558, 100, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (2559, 100, 46, 83);
INSERT INTO 'capvalue' VALUES (720, 'microedition.smartcardslots');
INSERT INTO 'devicecapvalue' VALUES (2560, 100, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (2561, 100, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (2562, 100, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (2563, 100, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (2564, 100, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (2565, 100, 46, 142);
INSERT INTO 'capvalue' VALUES (721, 'wireless.messaging.version');
INSERT INTO 'devicecapvalue' VALUES (2566, 100, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (2567, 100, 59, 240);
INSERT INTO 'cap' VALUES (101, 'property.fileconn.dir.memorycard', 1);
INSERT INTO 'capvalue' VALUES (722, 'file:///MemoryCard/');
INSERT INTO 'devicecapvalue' VALUES (2568, 100, 101, 722);
INSERT INTO 'cap' VALUES (102, 'property.fileconn.dir.memorycard.name', 1);
INSERT INTO 'capvalue' VALUES (723, 'MemoryCard');
INSERT INTO 'devicecapvalue' VALUES (2569, 100, 102, 723);
INSERT INTO 'cap' VALUES (103, 'property.fileconn.dir.photos', 1);
INSERT INTO 'capvalue' VALUES (724, 'file:///MyPictures/');
INSERT INTO 'devicecapvalue' VALUES (2570, 100, 103, 724);
INSERT INTO 'cap' VALUES (104, 'property.fileconn.dir.photos.name', 1);
INSERT INTO 'capvalue' VALUES (725, 'MyPictures');
INSERT INTO 'devicecapvalue' VALUES (2571, 100, 104, 725);
INSERT INTO 'cap' VALUES (105, 'property.fileconn.dir.private', 1);
INSERT INTO 'capvalue' VALUES (726, 'file:///Root/');
INSERT INTO 'devicecapvalue' VALUES (2572, 100, 105, 726);
INSERT INTO 'cap' VALUES (106, 'property.fileconn.dir.tones', 1);
INSERT INTO 'capvalue' VALUES (727, 'file:///Tones/');
INSERT INTO 'devicecapvalue' VALUES (2573, 100, 106, 727);
INSERT INTO 'cap' VALUES (107, 'property.fileconn.dir.tones.name', 1);
INSERT INTO 'capvalue' VALUES (728, 'Tones');
INSERT INTO 'devicecapvalue' VALUES (2574, 100, 107, 728);
INSERT INTO 'cap' VALUES (108, 'property.fileconn.dir.videos', 1);
INSERT INTO 'capvalue' VALUES (729, 'file:///MyVideos/');
INSERT INTO 'devicecapvalue' VALUES (2575, 100, 108, 729);
INSERT INTO 'cap' VALUES (109, 'property.fileconn.dir.videos.name', 1);
INSERT INTO 'capvalue' VALUES (730, 'MyVideos');
INSERT INTO 'devicecapvalue' VALUES (2576, 100, 109, 730);
INSERT INTO 'devicecapvalue' VALUES (2577, 100, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (2578, 100, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (2579, 100, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (2580, 100, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (2581, 100, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (2582, 100, 67, 45);
INSERT INTO 'capvalue' VALUES (731, 'HTC Touch Diamond P3700');
INSERT INTO 'devicecapvalue' VALUES (2583, 100, 68, 731);
INSERT INTO 'devicecapvalue' VALUES (2584, 100, 69, 47);
INSERT INTO 'cap' VALUES (110, 'property.microedition.smartcardslots', 1);
INSERT INTO 'devicecapvalue' VALUES (2585, 100, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (2586, 100, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (2587, 100, 71, 244);
INSERT INTO 'capvalue' VALUES (732, '+48602951111');
INSERT INTO 'devicecapvalue' VALUES (2588, 100, 72, 732);
INSERT INTO 'cap' VALUES (111, 'property.wireless.messaging.version', 1);
INSERT INTO 'devicecapvalue' VALUES (2589, 100, 111, 242);
INSERT INTO 'devicecapvalue' VALUES (2590, 100, 48, 90);
INSERT INTO 'capvalue' VALUES (733, '4194240');
INSERT INTO 'devicecapvalue' VALUES (2591, 100, 49, 733);
INSERT INTO 'capvalue' VALUES (734, 'Opera/9.50 (Windows NT 5.1; MDA_compact_IV/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1; U; pl)');
INSERT INTO 'devicecapvalue' VALUES (2592, 100, 53, 734);
INSERT INTO 'devicecapvalue' VALUES (2593, 101, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (2594, 101, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2595, 101, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2596, 101, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (2597, 101, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2598, 102, 1, 625);
INSERT INTO 'devicecapvalue' VALUES (2599, 102, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2600, 102, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2601, 102, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (2602, 102, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2603, 103, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (2604, 103, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (2605, 103, 2, 2);
INSERT INTO 'capvalue' VALUES (735, '320x213');
INSERT INTO 'devicecapvalue' VALUES (2606, 103, 13, 735);
INSERT INTO 'devicecapvalue' VALUES (2607, 103, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2608, 103, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (2609, 103, 6, 27);
INSERT INTO 'capvalue' VALUES (736, 'Windows Mobile 2003');
INSERT INTO 'devicecapvalue' VALUES (2610, 103, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (2611, 103, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2612, 103, 5, 5);
INSERT INTO 'capvalue' VALUES (737, 'HTC-S621');
INSERT INTO 'devicecapvalue' VALUES (2613, 103, 53, 737);
INSERT INTO 'capvalue' VALUES (738, '320x453');
INSERT INTO 'devicecapvalue' VALUES (2614, 104, 7, 738);
INSERT INTO 'devicecapvalue' VALUES (2615, 104, 16, 650);
INSERT INTO 'devicecapvalue' VALUES (2616, 104, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2617, 104, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2618, 104, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (2619, 105, 7, 738);
INSERT INTO 'devicecapvalue' VALUES (2620, 105, 16, 700);
INSERT INTO 'devicecapvalue' VALUES (2621, 105, 6, 700);
INSERT INTO 'devicecapvalue' VALUES (2622, 105, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2623, 105, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (2624, 106, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (2625, 106, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2626, 106, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (2627, 106, 4, 8);
INSERT INTO 'devicecapvalue' VALUES (2628, 106, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (2629, 107, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (2630, 107, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (2631, 107, 2, 2);
INSERT INTO 'capvalue' VALUES (739, '134217728');
INSERT INTO 'devicecapvalue' VALUES (2632, 107, 76, 739);
INSERT INTO 'devicecapvalue' VALUES (2633, 107, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (2634, 107, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (2635, 107, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2636, 107, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2637, 107, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2638, 107, 6, 27);
INSERT INTO 'capvalue' VALUES (740, 'Windows Mobile 5');
INSERT INTO 'devicecapvalue' VALUES (2639, 107, 3, 740);
INSERT INTO 'devicecapvalue' VALUES (2640, 107, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (2641, 107, 5, 601);
INSERT INTO 'capvalue' VALUES (741, 'HTC_TyTN_II Mozilla/4.0 (compatible; MSIE 6.0; Windows CE; IEMobile 7.6)');
INSERT INTO 'devicecapvalue' VALUES (2642, 107, 53, 741);
INSERT INTO 'devicecapvalue' VALUES (2643, 108, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (2644, 108, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2645, 108, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2646, 108, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (2647, 108, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2648, 109, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (2649, 109, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (2650, 109, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2651, 109, 76, 739);
INSERT INTO 'devicecapvalue' VALUES (2652, 109, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (2653, 109, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (2654, 109, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (2655, 109, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (2656, 109, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (2657, 109, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (2658, 109, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (2659, 109, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (2660, 109, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2661, 110, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (2662, 110, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2663, 110, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (2664, 110, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (2665, 110, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (2666, 111, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (2667, 111, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2668, 111, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (2669, 111, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (2670, 111, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (2671, 112, 56, 707);
INSERT INTO 'capvalue' VALUES (742, '240x268');
INSERT INTO 'devicecapvalue' VALUES (2672, 112, 7, 742);
INSERT INTO 'devicecapvalue' VALUES (2673, 112, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (2674, 112, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (2675, 112, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (2676, 112, 9, 1);
INSERT INTO 'devicecapvalue' VALUES (2677, 112, 10, 663);
INSERT INTO 'devicecapvalue' VALUES (2678, 112, 11, 1);
INSERT INTO 'capvalue' VALUES (743, '11');
INSERT INTO 'devicecapvalue' VALUES (2679, 112, 12, 743);
INSERT INTO 'devicecapvalue' VALUES (2680, 112, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (2681, 112, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (2682, 112, 6, 27);
INSERT INTO 'capvalue' VALUES (744, '-57378');
INSERT INTO 'devicecapvalue' VALUES (2683, 112, 19, 744);
INSERT INTO 'devicecapvalue' VALUES (2684, 112, 20, 711);
INSERT INTO 'devicecapvalue' VALUES (2685, 112, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (2686, 112, 22, 34);
INSERT INTO 'capvalue' VALUES (745, '42');
INSERT INTO 'devicecapvalue' VALUES (2687, 112, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (2688, 112, 24, 237);
INSERT INTO 'capvalue' VALUES (746, '-57379');
INSERT INTO 'devicecapvalue' VALUES (2689, 112, 25, 746);
INSERT INTO 'devicecapvalue' VALUES (2690, 112, 26, 664);
INSERT INTO 'devicecapvalue' VALUES (2691, 112, 27, 711);
INSERT INTO 'capvalue' VALUES (747, '-57380');
INSERT INTO 'devicecapvalue' VALUES (2692, 112, 29, 747);
INSERT INTO 'devicecapvalue' VALUES (2693, 112, 30, 667);
INSERT INTO 'devicecapvalue' VALUES (2694, 112, 54, 711);
INSERT INTO 'capvalue' VALUES (748, '-57377');
INSERT INTO 'devicecapvalue' VALUES (2695, 112, 31, 748);
INSERT INTO 'devicecapvalue' VALUES (2696, 112, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (2697, 112, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (2698, 112, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (2699, 112, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (2700, 112, 58, 42);
INSERT INTO 'devicecapvalue' VALUES (2701, 112, 3, 740);
INSERT INTO 'devicecapvalue' VALUES (2702, 112, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (2703, 112, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (2704, 112, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (2705, 112, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (2706, 112, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (2707, 112, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (2708, 112, 62, 44);
INSERT INTO 'capvalue' VALUES (749, 'intent JTE');
INSERT INTO 'devicecapvalue' VALUES (2709, 112, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (2710, 112, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (2711, 112, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (2712, 112, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (2713, 112, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (2714, 112, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (2715, 112, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (2716, 112, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (2717, 112, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (2718, 112, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (2719, 112, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (2720, 112, 48, 254);
INSERT INTO 'capvalue' VALUES (750, 'Africa/Bamako');
INSERT INTO 'devicecapvalue' VALUES (2721, 112, 48, 750);
INSERT INTO 'devicecapvalue' VALUES (2722, 112, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (2723, 112, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (2724, 112, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (2725, 112, 48, 258);
INSERT INTO 'capvalue' VALUES (751, 'Africa/Brazzaville');
INSERT INTO 'devicecapvalue' VALUES (2726, 112, 48, 751);
INSERT INTO 'devicecapvalue' VALUES (2727, 112, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (2728, 112, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (2729, 112, 48, 261);
INSERT INTO 'capvalue' VALUES (752, 'Africa/Ceuta');
INSERT INTO 'devicecapvalue' VALUES (2730, 112, 48, 752);
INSERT INTO 'devicecapvalue' VALUES (2731, 112, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (2732, 112, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (2733, 112, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (2734, 112, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (2735, 112, 48, 266);
INSERT INTO 'capvalue' VALUES (753, 'Africa/El_Aaiun');
INSERT INTO 'devicecapvalue' VALUES (2736, 112, 48, 753);
INSERT INTO 'devicecapvalue' VALUES (2737, 112, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (2738, 112, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (2739, 112, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (2740, 112, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (2741, 112, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (2742, 112, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (2743, 112, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (2744, 112, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (2745, 112, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (2746, 112, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (2747, 112, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (2748, 112, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (2749, 112, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (2750, 112, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (2751, 112, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (2752, 112, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (2753, 112, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (2754, 112, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (2755, 112, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (2756, 112, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (2757, 112, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (2758, 112, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (2759, 112, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (2760, 112, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (2761, 112, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (2762, 112, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (2763, 112, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (2764, 112, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (2765, 112, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (2766, 112, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (2767, 112, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (2768, 112, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (2769, 112, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (2770, 112, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (2771, 112, 48, 301);
INSERT INTO 'capvalue' VALUES (754, 'America/Araguaina');
INSERT INTO 'devicecapvalue' VALUES (2772, 112, 48, 754);
INSERT INTO 'devicecapvalue' VALUES (2773, 112, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (2774, 112, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (2775, 112, 48, 304);
INSERT INTO 'capvalue' VALUES (755, 'America/Belem');
INSERT INTO 'devicecapvalue' VALUES (2776, 112, 48, 755);
INSERT INTO 'devicecapvalue' VALUES (2777, 112, 48, 305);
INSERT INTO 'capvalue' VALUES (756, 'America/Boa_Vista');
INSERT INTO 'devicecapvalue' VALUES (2778, 112, 48, 756);
INSERT INTO 'devicecapvalue' VALUES (2779, 112, 48, 306);
INSERT INTO 'capvalue' VALUES (757, 'America/Boise');
INSERT INTO 'devicecapvalue' VALUES (2780, 112, 48, 757);
INSERT INTO 'devicecapvalue' VALUES (2781, 112, 48, 307);
INSERT INTO 'capvalue' VALUES (758, 'America/Cambridge_Bay');
INSERT INTO 'devicecapvalue' VALUES (2782, 112, 48, 758);
INSERT INTO 'capvalue' VALUES (759, 'America/Cancun');
INSERT INTO 'devicecapvalue' VALUES (2783, 112, 48, 759);
INSERT INTO 'devicecapvalue' VALUES (2784, 112, 48, 308);
INSERT INTO 'capvalue' VALUES (760, 'America/Catamarca');
INSERT INTO 'devicecapvalue' VALUES (2785, 112, 48, 760);
INSERT INTO 'devicecapvalue' VALUES (2786, 112, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (2787, 112, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (2788, 112, 48, 311);
INSERT INTO 'capvalue' VALUES (761, 'America/Chihuahua');
INSERT INTO 'devicecapvalue' VALUES (2789, 112, 48, 761);
INSERT INTO 'capvalue' VALUES (762, 'America/Cordoba');
INSERT INTO 'devicecapvalue' VALUES (2790, 112, 48, 762);
INSERT INTO 'devicecapvalue' VALUES (2791, 112, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (2792, 112, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (2793, 112, 48, 314);
INSERT INTO 'capvalue' VALUES (763, 'America/Danmarkshavn');
INSERT INTO 'devicecapvalue' VALUES (2794, 112, 48, 763);
INSERT INTO 'capvalue' VALUES (764, 'America/Dawson');
INSERT INTO 'devicecapvalue' VALUES (2795, 112, 48, 764);
INSERT INTO 'devicecapvalue' VALUES (2796, 112, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (2797, 112, 48, 316);
INSERT INTO 'capvalue' VALUES (765, 'America/Detroit');
INSERT INTO 'devicecapvalue' VALUES (2798, 112, 48, 765);
INSERT INTO 'devicecapvalue' VALUES (2799, 112, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (2800, 112, 48, 318);
INSERT INTO 'capvalue' VALUES (766, 'America/Eirunepe');
INSERT INTO 'devicecapvalue' VALUES (2801, 112, 48, 766);
INSERT INTO 'devicecapvalue' VALUES (2802, 112, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (2803, 112, 48, 320);
INSERT INTO 'capvalue' VALUES (767, 'America/Glace_Bay');
INSERT INTO 'devicecapvalue' VALUES (2804, 112, 48, 767);
INSERT INTO 'devicecapvalue' VALUES (2805, 112, 48, 321);
INSERT INTO 'capvalue' VALUES (768, 'America/Goose_Bay');
INSERT INTO 'devicecapvalue' VALUES (2806, 112, 48, 768);
INSERT INTO 'devicecapvalue' VALUES (2807, 112, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (2808, 112, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (2809, 112, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (2810, 112, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (2811, 112, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (2812, 112, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (2813, 112, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (2814, 112, 48, 329);
INSERT INTO 'capvalue' VALUES (769, 'America/Hermosillo');
INSERT INTO 'devicecapvalue' VALUES (2815, 112, 48, 769);
INSERT INTO 'capvalue' VALUES (770, 'America/Indiana/Knox');
INSERT INTO 'devicecapvalue' VALUES (2816, 112, 48, 770);
INSERT INTO 'capvalue' VALUES (771, 'America/Indiana/Marengo');
INSERT INTO 'devicecapvalue' VALUES (2817, 112, 48, 771);
INSERT INTO 'capvalue' VALUES (772, 'America/Indiana/Vevay');
INSERT INTO 'devicecapvalue' VALUES (2818, 112, 48, 772);
INSERT INTO 'devicecapvalue' VALUES (2819, 112, 48, 330);
INSERT INTO 'capvalue' VALUES (773, 'America/Inuvik');
INSERT INTO 'devicecapvalue' VALUES (2820, 112, 48, 773);
INSERT INTO 'capvalue' VALUES (774, 'America/Iqaluit');
INSERT INTO 'devicecapvalue' VALUES (2821, 112, 48, 774);
INSERT INTO 'devicecapvalue' VALUES (2822, 112, 48, 331);
INSERT INTO 'capvalue' VALUES (775, 'America/Jujuy');
INSERT INTO 'devicecapvalue' VALUES (2823, 112, 48, 775);
INSERT INTO 'capvalue' VALUES (776, 'America/Juneau');
INSERT INTO 'devicecapvalue' VALUES (2824, 112, 48, 776);
INSERT INTO 'capvalue' VALUES (777, 'America/Kentucky/Monticello');
INSERT INTO 'devicecapvalue' VALUES (2825, 112, 48, 777);
INSERT INTO 'devicecapvalue' VALUES (2826, 112, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (2827, 112, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (2828, 112, 48, 334);
INSERT INTO 'capvalue' VALUES (778, 'America/Louisville');
INSERT INTO 'devicecapvalue' VALUES (2829, 112, 48, 778);
INSERT INTO 'capvalue' VALUES (779, 'America/Maceio');
INSERT INTO 'devicecapvalue' VALUES (2830, 112, 48, 779);
INSERT INTO 'devicecapvalue' VALUES (2831, 112, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (2832, 112, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (2833, 112, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (2834, 112, 48, 338);
INSERT INTO 'capvalue' VALUES (780, 'America/Mendoza');
INSERT INTO 'devicecapvalue' VALUES (2835, 112, 48, 780);
INSERT INTO 'capvalue' VALUES (781, 'America/Menominee');
INSERT INTO 'devicecapvalue' VALUES (2836, 112, 48, 781);
INSERT INTO 'capvalue' VALUES (782, 'America/Merida');
INSERT INTO 'devicecapvalue' VALUES (2837, 112, 48, 782);
INSERT INTO 'devicecapvalue' VALUES (2838, 112, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (2839, 112, 48, 340);
INSERT INTO 'capvalue' VALUES (783, 'America/Monterrey');
INSERT INTO 'devicecapvalue' VALUES (2840, 112, 48, 783);
INSERT INTO 'devicecapvalue' VALUES (2841, 112, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (2842, 112, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (2843, 112, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (2844, 112, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (2845, 112, 48, 345);
INSERT INTO 'capvalue' VALUES (784, 'America/Nipigon');
INSERT INTO 'devicecapvalue' VALUES (2846, 112, 48, 784);
INSERT INTO 'capvalue' VALUES (785, 'America/Nome');
INSERT INTO 'devicecapvalue' VALUES (2847, 112, 48, 785);
INSERT INTO 'devicecapvalue' VALUES (2848, 112, 48, 346);
INSERT INTO 'capvalue' VALUES (786, 'America/North_Dakota/Center');
INSERT INTO 'devicecapvalue' VALUES (2849, 112, 48, 786);
INSERT INTO 'devicecapvalue' VALUES (2850, 112, 48, 347);
INSERT INTO 'capvalue' VALUES (787, 'America/Pangnirtung');
INSERT INTO 'devicecapvalue' VALUES (2851, 112, 48, 787);
INSERT INTO 'devicecapvalue' VALUES (2852, 112, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (2853, 112, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (2854, 112, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (2855, 112, 48, 351);
INSERT INTO 'capvalue' VALUES (788, 'America/Porto_Velho');
INSERT INTO 'devicecapvalue' VALUES (2856, 112, 48, 788);
INSERT INTO 'devicecapvalue' VALUES (2857, 112, 48, 353);
INSERT INTO 'capvalue' VALUES (789, 'America/Rainy_River');
INSERT INTO 'devicecapvalue' VALUES (2858, 112, 48, 789);
INSERT INTO 'capvalue' VALUES (790, 'America/Rankin_Inlet');
INSERT INTO 'devicecapvalue' VALUES (2859, 112, 48, 790);
INSERT INTO 'capvalue' VALUES (791, 'America/Recife');
INSERT INTO 'devicecapvalue' VALUES (2860, 112, 48, 791);
INSERT INTO 'devicecapvalue' VALUES (2861, 112, 48, 354);
INSERT INTO 'capvalue' VALUES (792, 'America/Rio_Branco');
INSERT INTO 'devicecapvalue' VALUES (2862, 112, 48, 792);
INSERT INTO 'devicecapvalue' VALUES (2863, 112, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (2864, 112, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (2865, 112, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (2866, 112, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (2867, 112, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (2868, 112, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (2869, 112, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (2870, 112, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (2871, 112, 48, 363);
INSERT INTO 'capvalue' VALUES (793, 'America/Swift_Current');
INSERT INTO 'devicecapvalue' VALUES (2872, 112, 48, 793);
INSERT INTO 'devicecapvalue' VALUES (2873, 112, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (2874, 112, 48, 365);
INSERT INTO 'capvalue' VALUES (794, 'America/Thunder_Bay');
INSERT INTO 'devicecapvalue' VALUES (2875, 112, 48, 794);
INSERT INTO 'devicecapvalue' VALUES (2876, 112, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (2877, 112, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (2878, 112, 48, 368);
INSERT INTO 'capvalue' VALUES (795, 'America/Whitehorse');
INSERT INTO 'devicecapvalue' VALUES (2879, 112, 48, 795);
INSERT INTO 'devicecapvalue' VALUES (2880, 112, 48, 369);
INSERT INTO 'capvalue' VALUES (796, 'America/Yakutat');
INSERT INTO 'devicecapvalue' VALUES (2881, 112, 48, 796);
INSERT INTO 'capvalue' VALUES (797, 'America/Yellowknife');
INSERT INTO 'devicecapvalue' VALUES (2882, 112, 48, 797);
INSERT INTO 'devicecapvalue' VALUES (2883, 112, 48, 370);
INSERT INTO 'capvalue' VALUES (798, 'Antarctica/Davis');
INSERT INTO 'devicecapvalue' VALUES (2884, 112, 48, 798);
INSERT INTO 'devicecapvalue' VALUES (2885, 112, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (2886, 112, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (2887, 112, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (2888, 112, 48, 374);
INSERT INTO 'capvalue' VALUES (799, 'Antarctica/Syowa');
INSERT INTO 'devicecapvalue' VALUES (2889, 112, 48, 799);
INSERT INTO 'capvalue' VALUES (800, 'Antarctica/Vostok');
INSERT INTO 'devicecapvalue' VALUES (2890, 112, 48, 800);
INSERT INTO 'devicecapvalue' VALUES (2891, 112, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (2892, 112, 48, 629);
INSERT INTO 'devicecapvalue' VALUES (2893, 112, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (2894, 112, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (2895, 112, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (2896, 112, 48, 380);
INSERT INTO 'capvalue' VALUES (801, 'Asia/Ashgabat');
INSERT INTO 'devicecapvalue' VALUES (2897, 112, 48, 801);
INSERT INTO 'devicecapvalue' VALUES (2898, 112, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (2899, 112, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (2900, 112, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (2901, 112, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (2902, 112, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (2903, 112, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (2904, 112, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (2905, 112, 48, 389);
INSERT INTO 'capvalue' VALUES (802, 'Asia/Choibalsan');
INSERT INTO 'devicecapvalue' VALUES (2906, 112, 48, 802);
INSERT INTO 'capvalue' VALUES (803, 'Asia/Chongqing');
INSERT INTO 'devicecapvalue' VALUES (2907, 112, 48, 803);
INSERT INTO 'devicecapvalue' VALUES (2908, 112, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (2909, 112, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (2910, 112, 48, 630);
INSERT INTO 'capvalue' VALUES (804, 'Asia/Dili');
INSERT INTO 'devicecapvalue' VALUES (2911, 112, 48, 804);
INSERT INTO 'devicecapvalue' VALUES (2912, 112, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (2913, 112, 48, 394);
INSERT INTO 'capvalue' VALUES (805, 'Asia/Gaza');
INSERT INTO 'devicecapvalue' VALUES (2914, 112, 48, 805);
INSERT INTO 'capvalue' VALUES (806, 'Asia/Harbin');
INSERT INTO 'devicecapvalue' VALUES (2915, 112, 48, 806);
INSERT INTO 'devicecapvalue' VALUES (2916, 112, 48, 395);
INSERT INTO 'capvalue' VALUES (807, 'Asia/Hovd');
INSERT INTO 'devicecapvalue' VALUES (2917, 112, 48, 807);
INSERT INTO 'devicecapvalue' VALUES (2918, 112, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (2919, 112, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (2920, 112, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (2921, 112, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (2922, 112, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (2923, 112, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (2924, 112, 48, 403);
INSERT INTO 'capvalue' VALUES (808, 'Asia/Kashgar');
INSERT INTO 'devicecapvalue' VALUES (2925, 112, 48, 808);
INSERT INTO 'devicecapvalue' VALUES (2926, 112, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (2927, 112, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (2928, 112, 48, 406);
INSERT INTO 'capvalue' VALUES (809, 'Asia/Kuching');
INSERT INTO 'devicecapvalue' VALUES (2929, 112, 48, 809);
INSERT INTO 'devicecapvalue' VALUES (2930, 112, 48, 407);
INSERT INTO 'capvalue' VALUES (810, 'Asia/Macau');
INSERT INTO 'devicecapvalue' VALUES (2931, 112, 48, 810);
INSERT INTO 'devicecapvalue' VALUES (2932, 112, 48, 409);
INSERT INTO 'capvalue' VALUES (811, 'Asia/Makassar');
INSERT INTO 'devicecapvalue' VALUES (2933, 112, 48, 811);
INSERT INTO 'devicecapvalue' VALUES (2934, 112, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (2935, 112, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (2936, 112, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (2937, 112, 48, 413);
INSERT INTO 'capvalue' VALUES (812, 'Asia/Omsk');
INSERT INTO 'devicecapvalue' VALUES (2938, 112, 48, 812);
INSERT INTO 'capvalue' VALUES (813, 'Asia/Oral');
INSERT INTO 'devicecapvalue' VALUES (2939, 112, 48, 813);
INSERT INTO 'devicecapvalue' VALUES (2940, 112, 48, 414);
INSERT INTO 'capvalue' VALUES (814, 'Asia/Pontianak');
INSERT INTO 'devicecapvalue' VALUES (2941, 112, 48, 814);
INSERT INTO 'devicecapvalue' VALUES (2942, 112, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (2943, 112, 48, 416);
INSERT INTO 'capvalue' VALUES (815, 'Asia/Qyzylorda');
INSERT INTO 'devicecapvalue' VALUES (2944, 112, 48, 815);
INSERT INTO 'devicecapvalue' VALUES (2945, 112, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (2946, 112, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (2947, 112, 48, 419);
INSERT INTO 'capvalue' VALUES (816, 'Asia/Sakhalin');
INSERT INTO 'devicecapvalue' VALUES (2948, 112, 48, 816);
INSERT INTO 'capvalue' VALUES (817, 'Asia/Samarkand');
INSERT INTO 'devicecapvalue' VALUES (2949, 112, 48, 817);
INSERT INTO 'devicecapvalue' VALUES (2950, 112, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (2951, 112, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (2952, 112, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (2953, 112, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (2954, 112, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (2955, 112, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (2956, 112, 48, 426);
INSERT INTO 'capvalue' VALUES (818, 'Asia/Thimphu');
INSERT INTO 'devicecapvalue' VALUES (2957, 112, 48, 818);
INSERT INTO 'devicecapvalue' VALUES (2958, 112, 48, 428);
INSERT INTO 'capvalue' VALUES (819, 'Asia/Ulaanbaatar');
INSERT INTO 'devicecapvalue' VALUES (2959, 112, 48, 819);
INSERT INTO 'capvalue' VALUES (820, 'Asia/Urumqi');
INSERT INTO 'devicecapvalue' VALUES (2960, 112, 48, 820);
INSERT INTO 'devicecapvalue' VALUES (2961, 112, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (2962, 112, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (2963, 112, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (2964, 112, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (2965, 112, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (2966, 112, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (2967, 112, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (2968, 112, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (2969, 112, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (2970, 112, 48, 440);
INSERT INTO 'capvalue' VALUES (821, 'Atlantic/Madeira');
INSERT INTO 'devicecapvalue' VALUES (2971, 112, 48, 821);
INSERT INTO 'devicecapvalue' VALUES (2972, 112, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (2973, 112, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (2974, 112, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (2975, 112, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (2976, 112, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (2977, 112, 48, 447);
INSERT INTO 'capvalue' VALUES (822, 'Australia/Broken_Hill');
INSERT INTO 'devicecapvalue' VALUES (2978, 112, 48, 822);
INSERT INTO 'devicecapvalue' VALUES (2979, 112, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (2980, 112, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (2981, 112, 48, 449);
INSERT INTO 'capvalue' VALUES (823, 'Australia/Melbourne');
INSERT INTO 'devicecapvalue' VALUES (2982, 112, 48, 823);
INSERT INTO 'devicecapvalue' VALUES (2983, 112, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (2984, 112, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (2985, 112, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (2986, 112, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (2987, 112, 48, 454);
INSERT INTO 'capvalue' VALUES (824, 'CET');
INSERT INTO 'devicecapvalue' VALUES (2988, 112, 48, 824);
INSERT INTO 'devicecapvalue' VALUES (2989, 112, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (2990, 112, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (2991, 112, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (2992, 112, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (2993, 112, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (2994, 112, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (2995, 112, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (2996, 112, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (2997, 112, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (2998, 112, 48, 464);
INSERT INTO 'capvalue' VALUES (825, 'Europe/Belfast');
INSERT INTO 'devicecapvalue' VALUES (2999, 112, 48, 825);
INSERT INTO 'devicecapvalue' VALUES (3000, 112, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (3001, 112, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (3002, 112, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (3003, 112, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (3004, 112, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (3005, 112, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (3006, 112, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (3007, 112, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (3008, 112, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (3009, 112, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (3010, 112, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (3011, 112, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (3012, 112, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (3013, 112, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (3014, 112, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (3015, 112, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (3016, 112, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (3017, 112, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (3018, 112, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (3019, 112, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (3020, 112, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (3021, 112, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (3022, 112, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (3023, 112, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (3024, 112, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (3025, 112, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (3026, 112, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (3027, 112, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (3028, 112, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (3029, 112, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (3030, 112, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (3031, 112, 48, 496);
INSERT INTO 'capvalue' VALUES (826, 'Europe/Uzhgorod');
INSERT INTO 'devicecapvalue' VALUES (3032, 112, 48, 826);
INSERT INTO 'devicecapvalue' VALUES (3033, 112, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (3034, 112, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (3035, 112, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (3036, 112, 48, 500);
INSERT INTO 'capvalue' VALUES (827, 'Europe/Zaporozhye');
INSERT INTO 'devicecapvalue' VALUES (3037, 112, 48, 827);
INSERT INTO 'devicecapvalue' VALUES (3038, 112, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (3039, 112, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (3040, 112, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (3041, 112, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (3042, 112, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (3043, 112, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (3044, 112, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (3045, 112, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (3046, 112, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (3047, 112, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (3048, 112, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (3049, 112, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (3050, 112, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (3051, 112, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (3052, 112, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (3053, 112, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (3054, 112, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (3055, 112, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (3056, 112, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (3057, 112, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (3058, 112, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (3059, 112, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (3060, 112, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (3061, 112, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (3062, 112, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (3063, 112, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (3064, 112, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (3065, 112, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (3066, 112, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (3067, 112, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (3068, 112, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (3069, 112, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (3070, 112, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (3071, 112, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (3072, 112, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (3073, 112, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (3074, 112, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (3075, 112, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (3076, 112, 48, 539);
INSERT INTO 'capvalue' VALUES (828, 'Pacific/Johnston');
INSERT INTO 'devicecapvalue' VALUES (3077, 112, 48, 828);
INSERT INTO 'devicecapvalue' VALUES (3078, 112, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (3079, 112, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (3080, 112, 48, 633);
INSERT INTO 'devicecapvalue' VALUES (3081, 112, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (3082, 112, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (3083, 112, 48, 634);
INSERT INTO 'devicecapvalue' VALUES (3084, 112, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (3085, 112, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (3086, 112, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (3087, 112, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (3088, 112, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (3089, 112, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (3090, 112, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (3091, 112, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (3092, 112, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (3093, 112, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (3094, 112, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (3095, 112, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (3096, 112, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (3097, 112, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (3098, 112, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (3099, 112, 48, 560);
INSERT INTO 'capvalue' VALUES (829, 'Pacific/Yap');
INSERT INTO 'devicecapvalue' VALUES (3100, 112, 48, 829);
INSERT INTO 'devicecapvalue' VALUES (3101, 112, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (3102, 112, 48, 562);
INSERT INTO 'capvalue' VALUES (830, 'WET');
INSERT INTO 'devicecapvalue' VALUES (3103, 112, 48, 830);
INSERT INTO 'devicecapvalue' VALUES (3104, 112, 49, 739);
INSERT INTO 'capvalue' VALUES (831, 'HTCP3600-Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)');
INSERT INTO 'devicecapvalue' VALUES (3105, 112, 53, 831);
INSERT INTO 'devicecapvalue' VALUES (3106, 113, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (3107, 113, 7, 742);
INSERT INTO 'devicecapvalue' VALUES (3108, 113, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (3109, 113, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (3110, 113, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (3111, 113, 9, 709);
INSERT INTO 'devicecapvalue' VALUES (3112, 113, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (3113, 113, 11, 709);
INSERT INTO 'devicecapvalue' VALUES (3114, 113, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (3115, 113, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (3116, 113, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (3117, 113, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (3118, 113, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (3119, 113, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (3120, 113, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (3121, 113, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (3122, 113, 18, 29);
INSERT INTO 'devicecapvalue' VALUES (3123, 113, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (3124, 113, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (3125, 113, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (3126, 113, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (3127, 113, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (3128, 113, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (3129, 113, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (3130, 113, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (3131, 113, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (3132, 113, 57, 41);
INSERT INTO 'devicecapvalue' VALUES (3133, 113, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (3134, 113, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (3135, 113, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (3136, 113, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (3137, 113, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (3138, 113, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (3139, 113, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (3140, 113, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (3141, 113, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (3142, 113, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (3143, 113, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (3144, 113, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (3145, 113, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (3146, 113, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (3147, 113, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (3148, 113, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (3149, 113, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (3150, 113, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (3151, 113, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (3152, 113, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (3153, 113, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (3154, 113, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (3155, 113, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (3156, 113, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (3157, 113, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (3158, 113, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (3159, 113, 60, 43);
INSERT INTO 'capvalue' VALUES (832, 'ISO8859-1');
INSERT INTO 'devicecapvalue' VALUES (3160, 113, 62, 832);
INSERT INTO 'devicecapvalue' VALUES (3161, 113, 66, 242);
INSERT INTO 'capvalue' VALUES (833, 'Polaris');
INSERT INTO 'devicecapvalue' VALUES (3162, 113, 68, 833);
INSERT INTO 'devicecapvalue' VALUES (3163, 113, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (3164, 113, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (3165, 113, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (3166, 113, 71, 244);
INSERT INTO 'devicecapvalue' VALUES (3167, 113, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (3168, 113, 49, 733);
INSERT INTO 'capvalue' VALUES (834, 'HTC_P3650 Mozilla/4.0 (compatible; MSIE 6.0; Windows CE; IEMobile 7.6)');
INSERT INTO 'devicecapvalue' VALUES (3169, 113, 53, 834);
INSERT INTO 'devicecapvalue' VALUES (3170, 114, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (3171, 114, 7, 708);
INSERT INTO 'devicecapvalue' VALUES (3172, 114, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (3173, 114, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (3174, 114, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (3175, 114, 9, 709);
INSERT INTO 'devicecapvalue' VALUES (3176, 114, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (3177, 114, 11, 709);
INSERT INTO 'devicecapvalue' VALUES (3178, 114, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (3179, 114, 13, 712);
INSERT INTO 'devicecapvalue' VALUES (3180, 114, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (3181, 114, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (3182, 114, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (3183, 114, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (3184, 114, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (3185, 114, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (3186, 114, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (3187, 114, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (3188, 114, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (3189, 114, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (3190, 114, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (3191, 114, 6, 27);
INSERT INTO 'cap' VALUES (112, 'key.clearsoftkey', 1);
INSERT INTO 'devicecapvalue' VALUES (3192, 114, 112, 29);
INSERT INTO 'devicecapvalue' VALUES (3193, 114, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (3194, 114, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (3195, 114, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (3196, 114, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (3197, 114, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (3198, 114, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (3199, 114, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (3200, 114, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (3201, 114, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (3202, 114, 57, 41);
INSERT INTO 'devicecapvalue' VALUES (3203, 114, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (3204, 114, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (3205, 114, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (3206, 114, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (3207, 114, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (3208, 114, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (3209, 114, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (3210, 114, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (3211, 114, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (3212, 114, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (3213, 114, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (3214, 114, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (3215, 114, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (3216, 114, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (3217, 114, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (3218, 114, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (3219, 114, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (3220, 114, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (3221, 114, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (3222, 114, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (3223, 114, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (3224, 114, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (3225, 114, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (3226, 114, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (3227, 114, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (3228, 114, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (3229, 114, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (3230, 114, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (3231, 114, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (3232, 114, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (3233, 114, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (3234, 114, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (3235, 114, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (3236, 114, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (3237, 114, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (3238, 114, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (3239, 114, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (3240, 114, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (3241, 114, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (3242, 114, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (3243, 114, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (3244, 114, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (3245, 114, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (3246, 114, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (3247, 114, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (3248, 114, 59, 240);
INSERT INTO 'devicecapvalue' VALUES (3249, 114, 101, 722);
INSERT INTO 'devicecapvalue' VALUES (3250, 114, 102, 723);
INSERT INTO 'devicecapvalue' VALUES (3251, 114, 103, 724);
INSERT INTO 'devicecapvalue' VALUES (3252, 114, 104, 725);
INSERT INTO 'devicecapvalue' VALUES (3253, 114, 105, 726);
INSERT INTO 'devicecapvalue' VALUES (3254, 114, 106, 727);
INSERT INTO 'devicecapvalue' VALUES (3255, 114, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (3256, 114, 108, 729);
INSERT INTO 'devicecapvalue' VALUES (3257, 114, 109, 730);
INSERT INTO 'devicecapvalue' VALUES (3258, 114, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (3259, 114, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (3260, 114, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (3261, 114, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (3262, 114, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (3263, 114, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (3264, 114, 68, 731);
INSERT INTO 'devicecapvalue' VALUES (3265, 114, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (3266, 114, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (3267, 114, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (3268, 114, 71, 244);
INSERT INTO 'capvalue' VALUES (835, '+919845087001');
INSERT INTO 'devicecapvalue' VALUES (3269, 114, 72, 835);
INSERT INTO 'devicecapvalue' VALUES (3270, 114, 111, 242);
INSERT INTO 'devicecapvalue' VALUES (3271, 114, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (3272, 114, 49, 733);
INSERT INTO 'capvalue' VALUES (836, 'HTC_P3700 Opera/9.50 (Windows NT 5.1; U; en-GB)');
INSERT INTO 'devicecapvalue' VALUES (3273, 114, 53, 836);
INSERT INTO 'capvalue' VALUES (837, '320x188');
INSERT INTO 'devicecapvalue' VALUES (3274, 115, 7, 837);
INSERT INTO 'devicecapvalue' VALUES (3275, 115, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (3276, 115, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (3277, 115, 9, 709);
INSERT INTO 'devicecapvalue' VALUES (3278, 115, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (3279, 115, 11, 709);
INSERT INTO 'devicecapvalue' VALUES (3280, 115, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (3281, 115, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (3282, 115, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (3283, 115, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (3284, 115, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (3285, 115, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (3286, 115, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (3287, 115, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (3288, 115, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (3289, 115, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (3290, 115, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (3291, 115, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (3292, 115, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (3293, 115, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (3294, 115, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (3295, 115, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (3296, 115, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (3297, 115, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (3298, 115, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (3299, 115, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (3300, 115, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (3301, 115, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (3302, 115, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (3303, 115, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (3304, 115, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (3305, 115, 28, 30);
INSERT INTO 'devicecapvalue' VALUES (3306, 115, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (3307, 115, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (3308, 115, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (3309, 115, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (3310, 115, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (3311, 115, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (3312, 115, 35, 45);
INSERT INTO 'capvalue' VALUES (838, 'Jbed');
INSERT INTO 'devicecapvalue' VALUES (3313, 115, 36, 838);
INSERT INTO 'devicecapvalue' VALUES (3314, 115, 37, 47);
INSERT INTO 'devicecapvalue' VALUES (3315, 115, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (3316, 115, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (3317, 115, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (3318, 115, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (3319, 115, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (3320, 115, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (3321, 115, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (3322, 115, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (3323, 115, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (3324, 115, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (3325, 115, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (3326, 115, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (3327, 115, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (3328, 115, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (3329, 115, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (3330, 115, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (3331, 115, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (3332, 115, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (3333, 115, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (3334, 115, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (3335, 115, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (3336, 115, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (3337, 115, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (3338, 115, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (3339, 115, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (3340, 115, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (3341, 115, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (3342, 115, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (3343, 115, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (3344, 115, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (3345, 115, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (3346, 115, 59, 240);
INSERT INTO 'devicecapvalue' VALUES (3347, 115, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (3348, 115, 49, 733);
INSERT INTO 'capvalue' VALUES (839, 'Mozilla/4.0 (compatible; MSIE 6.0; Windows CE; IEMobile 7.6) Vodafone/1.0/SFR_v1615/1.56.163.8');
INSERT INTO 'devicecapvalue' VALUES (3349, 115, 53, 839);
INSERT INTO 'devicecapvalue' VALUES (3350, 116, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (3351, 116, 7, 742);
INSERT INTO 'devicecapvalue' VALUES (3352, 116, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (3353, 116, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (3354, 116, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (3355, 116, 9, 709);
INSERT INTO 'devicecapvalue' VALUES (3356, 116, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (3357, 116, 11, 709);
INSERT INTO 'devicecapvalue' VALUES (3358, 116, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (3359, 116, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (3360, 116, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (3361, 116, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (3362, 116, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (3363, 116, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (3364, 116, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (3365, 116, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (3366, 116, 18, 29);
INSERT INTO 'devicecapvalue' VALUES (3367, 116, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (3368, 116, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (3369, 116, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (3370, 116, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (3371, 116, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (3372, 116, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (3373, 116, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (3374, 116, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (3375, 116, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (3376, 116, 57, 41);
INSERT INTO 'devicecapvalue' VALUES (3377, 116, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (3378, 116, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (3379, 116, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (3380, 116, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (3381, 116, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (3382, 116, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (3383, 116, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (3384, 116, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (3385, 116, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (3386, 116, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (3387, 116, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (3388, 116, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (3389, 116, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (3390, 116, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (3391, 116, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (3392, 116, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (3393, 116, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (3394, 116, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (3395, 116, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (3396, 116, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (3397, 116, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (3398, 116, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (3399, 116, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (3400, 116, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (3401, 116, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (3402, 116, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (3403, 116, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (3404, 116, 62, 832);
INSERT INTO 'devicecapvalue' VALUES (3405, 116, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (3406, 116, 68, 833);
INSERT INTO 'devicecapvalue' VALUES (3407, 116, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (3408, 116, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (3409, 116, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (3410, 116, 71, 244);
INSERT INTO 'devicecapvalue' VALUES (3411, 116, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (3412, 116, 49, 733);
INSERT INTO 'devicecapvalue' VALUES (3413, 116, 53, 834);
INSERT INTO 'devicecapvalue' VALUES (3414, 117, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (3415, 117, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (3416, 117, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (3417, 117, 13, 735);
INSERT INTO 'devicecapvalue' VALUES (3418, 117, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (3419, 117, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (3420, 117, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (3421, 117, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (3422, 117, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (3423, 117, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (3424, 117, 53, 737);
INSERT INTO 'devicecapvalue' VALUES (3425, 118, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (3426, 118, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (3427, 118, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (3428, 118, 13, 735);
INSERT INTO 'devicecapvalue' VALUES (3429, 118, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (3430, 118, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (3431, 118, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (3432, 118, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (3433, 118, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (3434, 118, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (3435, 118, 53, 737);
INSERT INTO 'devicecapvalue' VALUES (3436, 119, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (3437, 119, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (3438, 119, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (3439, 119, 10, 110);
INSERT INTO 'devicecapvalue' VALUES (3440, 119, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (3441, 119, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (3442, 119, 13, 234);
INSERT INTO 'devicecapvalue' VALUES (3443, 119, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (3444, 119, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (3445, 119, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (3446, 119, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (3447, 119, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (3448, 119, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (3449, 120, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (3450, 120, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (3451, 120, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (3452, 120, 4, 8);
INSERT INTO 'devicecapvalue' VALUES (3453, 120, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (3454, 121, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (3455, 121, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (3456, 121, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (3457, 121, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (3458, 121, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (3459, 122, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (3460, 122, 3, 740);
INSERT INTO 'devicecapvalue' VALUES (3461, 122, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (3462, 122, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (3463, 123, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (3464, 123, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (3465, 123, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (3466, 123, 9, 1);
INSERT INTO 'devicecapvalue' VALUES (3467, 123, 10, 663);
INSERT INTO 'devicecapvalue' VALUES (3468, 123, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (3469, 123, 12, 743);
INSERT INTO 'devicecapvalue' VALUES (3470, 123, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (3471, 123, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (3472, 123, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (3473, 123, 19, 744);
INSERT INTO 'devicecapvalue' VALUES (3474, 123, 20, 711);
INSERT INTO 'devicecapvalue' VALUES (3475, 123, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (3476, 123, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (3477, 123, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (3478, 123, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (3479, 123, 25, 746);
INSERT INTO 'devicecapvalue' VALUES (3480, 123, 29, 747);
INSERT INTO 'devicecapvalue' VALUES (3481, 123, 31, 748);
INSERT INTO 'devicecapvalue' VALUES (3482, 123, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (3483, 123, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (3484, 123, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (3485, 123, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (3486, 123, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (3487, 123, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (3488, 123, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (3489, 123, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (3490, 123, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (3491, 123, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (3492, 123, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (3493, 123, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (3494, 123, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (3495, 123, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (3496, 123, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (3497, 123, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (3498, 123, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (3499, 123, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (3500, 123, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (3501, 123, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (3502, 123, 48, 750);
INSERT INTO 'devicecapvalue' VALUES (3503, 123, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (3504, 123, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (3505, 123, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (3506, 123, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (3507, 123, 48, 751);
INSERT INTO 'devicecapvalue' VALUES (3508, 123, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (3509, 123, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (3510, 123, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (3511, 123, 48, 752);
INSERT INTO 'devicecapvalue' VALUES (3512, 123, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (3513, 123, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (3514, 123, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (3515, 123, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (3516, 123, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (3517, 123, 48, 753);
INSERT INTO 'devicecapvalue' VALUES (3518, 123, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (3519, 123, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (3520, 123, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (3521, 123, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (3522, 123, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (3523, 123, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (3524, 123, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (3525, 123, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (3526, 123, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (3527, 123, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (3528, 123, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (3529, 123, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (3530, 123, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (3531, 123, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (3532, 123, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (3533, 123, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (3534, 123, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (3535, 123, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (3536, 123, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (3537, 123, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (3538, 123, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (3539, 123, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (3540, 123, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (3541, 123, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (3542, 123, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (3543, 123, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (3544, 123, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (3545, 123, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (3546, 123, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (3547, 123, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (3548, 123, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (3549, 123, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (3550, 123, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (3551, 123, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (3552, 123, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (3553, 123, 48, 754);
INSERT INTO 'devicecapvalue' VALUES (3554, 123, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (3555, 123, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (3556, 123, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (3557, 123, 48, 755);
INSERT INTO 'devicecapvalue' VALUES (3558, 123, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (3559, 123, 48, 756);
INSERT INTO 'devicecapvalue' VALUES (3560, 123, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (3561, 123, 48, 757);
INSERT INTO 'devicecapvalue' VALUES (3562, 123, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (3563, 123, 48, 758);
INSERT INTO 'devicecapvalue' VALUES (3564, 123, 48, 759);
INSERT INTO 'devicecapvalue' VALUES (3565, 123, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (3566, 123, 48, 760);
INSERT INTO 'devicecapvalue' VALUES (3567, 123, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (3568, 123, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (3569, 123, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (3570, 123, 48, 761);
INSERT INTO 'devicecapvalue' VALUES (3571, 123, 48, 762);
INSERT INTO 'devicecapvalue' VALUES (3572, 123, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (3573, 123, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (3574, 123, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (3575, 123, 48, 763);
INSERT INTO 'devicecapvalue' VALUES (3576, 123, 48, 764);
INSERT INTO 'devicecapvalue' VALUES (3577, 123, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (3578, 123, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (3579, 123, 48, 765);
INSERT INTO 'devicecapvalue' VALUES (3580, 123, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (3581, 123, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (3582, 123, 48, 766);
INSERT INTO 'devicecapvalue' VALUES (3583, 123, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (3584, 123, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (3585, 123, 48, 767);
INSERT INTO 'devicecapvalue' VALUES (3586, 123, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (3587, 123, 48, 768);
INSERT INTO 'devicecapvalue' VALUES (3588, 123, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (3589, 123, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (3590, 123, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (3591, 123, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (3592, 123, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (3593, 123, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (3594, 123, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (3595, 123, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (3596, 123, 48, 769);
INSERT INTO 'devicecapvalue' VALUES (3597, 123, 48, 770);
INSERT INTO 'devicecapvalue' VALUES (3598, 123, 48, 771);
INSERT INTO 'devicecapvalue' VALUES (3599, 123, 48, 772);
INSERT INTO 'devicecapvalue' VALUES (3600, 123, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (3601, 123, 48, 773);
INSERT INTO 'devicecapvalue' VALUES (3602, 123, 48, 774);
INSERT INTO 'devicecapvalue' VALUES (3603, 123, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (3604, 123, 48, 775);
INSERT INTO 'devicecapvalue' VALUES (3605, 123, 48, 776);
INSERT INTO 'devicecapvalue' VALUES (3606, 123, 48, 777);
INSERT INTO 'devicecapvalue' VALUES (3607, 123, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (3608, 123, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (3609, 123, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (3610, 123, 48, 778);
INSERT INTO 'devicecapvalue' VALUES (3611, 123, 48, 779);
INSERT INTO 'devicecapvalue' VALUES (3612, 123, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (3613, 123, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (3614, 123, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (3615, 123, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (3616, 123, 48, 780);
INSERT INTO 'devicecapvalue' VALUES (3617, 123, 48, 781);
INSERT INTO 'devicecapvalue' VALUES (3618, 123, 48, 782);
INSERT INTO 'devicecapvalue' VALUES (3619, 123, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (3620, 123, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (3621, 123, 48, 783);
INSERT INTO 'devicecapvalue' VALUES (3622, 123, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (3623, 123, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (3624, 123, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (3625, 123, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (3626, 123, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (3627, 123, 48, 784);
INSERT INTO 'devicecapvalue' VALUES (3628, 123, 48, 785);
INSERT INTO 'devicecapvalue' VALUES (3629, 123, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (3630, 123, 48, 786);
INSERT INTO 'devicecapvalue' VALUES (3631, 123, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (3632, 123, 48, 787);
INSERT INTO 'devicecapvalue' VALUES (3633, 123, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (3634, 123, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (3635, 123, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (3636, 123, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (3637, 123, 48, 788);
INSERT INTO 'devicecapvalue' VALUES (3638, 123, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (3639, 123, 48, 789);
INSERT INTO 'devicecapvalue' VALUES (3640, 123, 48, 790);
INSERT INTO 'devicecapvalue' VALUES (3641, 123, 48, 791);
INSERT INTO 'devicecapvalue' VALUES (3642, 123, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (3643, 123, 48, 792);
INSERT INTO 'devicecapvalue' VALUES (3644, 123, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (3645, 123, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (3646, 123, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (3647, 123, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (3648, 123, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (3649, 123, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (3650, 123, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (3651, 123, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (3652, 123, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (3653, 123, 48, 793);
INSERT INTO 'devicecapvalue' VALUES (3654, 123, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (3655, 123, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (3656, 123, 48, 794);
INSERT INTO 'devicecapvalue' VALUES (3657, 123, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (3658, 123, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (3659, 123, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (3660, 123, 48, 795);
INSERT INTO 'devicecapvalue' VALUES (3661, 123, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (3662, 123, 48, 796);
INSERT INTO 'devicecapvalue' VALUES (3663, 123, 48, 797);
INSERT INTO 'devicecapvalue' VALUES (3664, 123, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (3665, 123, 48, 798);
INSERT INTO 'devicecapvalue' VALUES (3666, 123, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (3667, 123, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (3668, 123, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (3669, 123, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (3670, 123, 48, 799);
INSERT INTO 'devicecapvalue' VALUES (3671, 123, 48, 800);
INSERT INTO 'devicecapvalue' VALUES (3672, 123, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (3673, 123, 48, 629);
INSERT INTO 'devicecapvalue' VALUES (3674, 123, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (3675, 123, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (3676, 123, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (3677, 123, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (3678, 123, 48, 801);
INSERT INTO 'devicecapvalue' VALUES (3679, 123, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (3680, 123, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (3681, 123, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (3682, 123, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (3683, 123, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (3684, 123, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (3685, 123, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (3686, 123, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (3687, 123, 48, 802);
INSERT INTO 'devicecapvalue' VALUES (3688, 123, 48, 803);
INSERT INTO 'devicecapvalue' VALUES (3689, 123, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (3690, 123, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (3691, 123, 48, 630);
INSERT INTO 'devicecapvalue' VALUES (3692, 123, 48, 804);
INSERT INTO 'devicecapvalue' VALUES (3693, 123, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (3694, 123, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (3695, 123, 48, 805);
INSERT INTO 'devicecapvalue' VALUES (3696, 123, 48, 806);
INSERT INTO 'devicecapvalue' VALUES (3697, 123, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (3698, 123, 48, 807);
INSERT INTO 'devicecapvalue' VALUES (3699, 123, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (3700, 123, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (3701, 123, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (3702, 123, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (3703, 123, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (3704, 123, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (3705, 123, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (3706, 123, 48, 808);
INSERT INTO 'devicecapvalue' VALUES (3707, 123, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (3708, 123, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (3709, 123, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (3710, 123, 48, 809);
INSERT INTO 'devicecapvalue' VALUES (3711, 123, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (3712, 123, 48, 810);
INSERT INTO 'devicecapvalue' VALUES (3713, 123, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (3714, 123, 48, 811);
INSERT INTO 'devicecapvalue' VALUES (3715, 123, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (3716, 123, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (3717, 123, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (3718, 123, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (3719, 123, 48, 812);
INSERT INTO 'devicecapvalue' VALUES (3720, 123, 48, 813);
INSERT INTO 'devicecapvalue' VALUES (3721, 123, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (3722, 123, 48, 814);
INSERT INTO 'devicecapvalue' VALUES (3723, 123, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (3724, 123, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (3725, 123, 48, 815);
INSERT INTO 'devicecapvalue' VALUES (3726, 123, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (3727, 123, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (3728, 123, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (3729, 123, 48, 816);
INSERT INTO 'devicecapvalue' VALUES (3730, 123, 48, 817);
INSERT INTO 'devicecapvalue' VALUES (3731, 123, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (3732, 123, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (3733, 123, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (3734, 123, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (3735, 123, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (3736, 123, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (3737, 123, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (3738, 123, 48, 818);
INSERT INTO 'devicecapvalue' VALUES (3739, 123, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (3740, 123, 48, 819);
INSERT INTO 'devicecapvalue' VALUES (3741, 123, 48, 820);
INSERT INTO 'devicecapvalue' VALUES (3742, 123, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (3743, 123, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (3744, 123, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (3745, 123, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (3746, 123, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (3747, 123, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (3748, 123, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (3749, 123, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (3750, 123, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (3751, 123, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (3752, 123, 48, 821);
INSERT INTO 'devicecapvalue' VALUES (3753, 123, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (3754, 123, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (3755, 123, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (3756, 123, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (3757, 123, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (3758, 123, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (3759, 123, 48, 822);
INSERT INTO 'devicecapvalue' VALUES (3760, 123, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (3761, 123, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (3762, 123, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (3763, 123, 48, 823);
INSERT INTO 'devicecapvalue' VALUES (3764, 123, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (3765, 123, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (3766, 123, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (3767, 123, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (3768, 123, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (3769, 123, 48, 824);
INSERT INTO 'devicecapvalue' VALUES (3770, 123, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (3771, 123, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (3772, 123, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (3773, 123, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (3774, 123, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (3775, 123, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (3776, 123, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (3777, 123, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (3778, 123, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (3779, 123, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (3780, 123, 48, 825);
INSERT INTO 'devicecapvalue' VALUES (3781, 123, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (3782, 123, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (3783, 123, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (3784, 123, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (3785, 123, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (3786, 123, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (3787, 123, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (3788, 123, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (3789, 123, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (3790, 123, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (3791, 123, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (3792, 123, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (3793, 123, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (3794, 123, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (3795, 123, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (3796, 123, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (3797, 123, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (3798, 123, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (3799, 123, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (3800, 123, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (3801, 123, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (3802, 123, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (3803, 123, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (3804, 123, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (3805, 123, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (3806, 123, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (3807, 123, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (3808, 123, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (3809, 123, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (3810, 123, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (3811, 123, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (3812, 123, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (3813, 123, 48, 826);
INSERT INTO 'devicecapvalue' VALUES (3814, 123, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (3815, 123, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (3816, 123, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (3817, 123, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (3818, 123, 48, 827);
INSERT INTO 'devicecapvalue' VALUES (3819, 123, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (3820, 123, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (3821, 123, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (3822, 123, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (3823, 123, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (3824, 123, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (3825, 123, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (3826, 123, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (3827, 123, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (3828, 123, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (3829, 123, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (3830, 123, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (3831, 123, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (3832, 123, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (3833, 123, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (3834, 123, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (3835, 123, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (3836, 123, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (3837, 123, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (3838, 123, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (3839, 123, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (3840, 123, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (3841, 123, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (3842, 123, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (3843, 123, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (3844, 123, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (3845, 123, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (3846, 123, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (3847, 123, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (3848, 123, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (3849, 123, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (3850, 123, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (3851, 123, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (3852, 123, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (3853, 123, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (3854, 123, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (3855, 123, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (3856, 123, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (3857, 123, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (3858, 123, 48, 828);
INSERT INTO 'devicecapvalue' VALUES (3859, 123, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (3860, 123, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (3861, 123, 48, 633);
INSERT INTO 'devicecapvalue' VALUES (3862, 123, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (3863, 123, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (3864, 123, 48, 634);
INSERT INTO 'devicecapvalue' VALUES (3865, 123, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (3866, 123, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (3867, 123, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (3868, 123, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (3869, 123, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (3870, 123, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (3871, 123, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (3872, 123, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (3873, 123, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (3874, 123, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (3875, 123, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (3876, 123, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (3877, 123, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (3878, 123, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (3879, 123, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (3880, 123, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (3881, 123, 48, 829);
INSERT INTO 'devicecapvalue' VALUES (3882, 123, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (3883, 123, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (3884, 123, 48, 830);
INSERT INTO 'devicecapvalue' VALUES (3885, 123, 49, 739);
INSERT INTO 'capvalue' VALUES (840, 'Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; Smartphone; 240x320)');
INSERT INTO 'devicecapvalue' VALUES (3886, 123, 53, 840);
INSERT INTO 'capvalue' VALUES (841, '480x280');
INSERT INTO 'devicecapvalue' VALUES (3887, 124, 7, 841);
INSERT INTO 'devicecapvalue' VALUES (3888, 124, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (3889, 124, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (3890, 124, 9, 649);
INSERT INTO 'capvalue' VALUES (842, '31');
INSERT INTO 'devicecapvalue' VALUES (3891, 124, 10, 842);
INSERT INTO 'devicecapvalue' VALUES (3892, 124, 11, 649);
INSERT INTO 'devicecapvalue' VALUES (3893, 124, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (3894, 124, 13, 712);
INSERT INTO 'devicecapvalue' VALUES (3895, 124, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (3896, 124, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (3897, 124, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (3898, 124, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (3899, 124, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (3900, 124, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (3901, 124, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (3902, 124, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (3903, 124, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (3904, 124, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (3905, 124, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (3906, 124, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (3907, 124, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (3908, 124, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (3909, 124, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (3910, 124, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (3911, 124, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (3912, 124, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (3913, 124, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (3914, 124, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (3915, 124, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (3916, 124, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (3917, 124, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (3918, 124, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (3919, 124, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (3920, 124, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (3921, 124, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (3922, 124, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (3923, 124, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (3924, 124, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (3925, 124, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (3926, 124, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (3927, 124, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (3928, 124, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (3929, 124, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (3930, 124, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (3931, 124, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (3932, 124, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (3933, 124, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (3934, 124, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (3935, 124, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (3936, 124, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (3937, 124, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (3938, 124, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (3939, 124, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (3940, 124, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (3941, 124, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (3942, 124, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (3943, 124, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (3944, 124, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (3945, 124, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (3946, 124, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (3947, 124, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (3948, 124, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (3949, 124, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (3950, 124, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (3951, 124, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (3952, 124, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (3953, 124, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (3954, 124, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (3955, 124, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (3956, 124, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (3957, 124, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (3958, 124, 49, 733);
INSERT INTO 'capvalue' VALUES (843, 'HTC_Touch_Pro_T7272 Opera/9.50 (Windows NT 5.1; U; de)');
INSERT INTO 'devicecapvalue' VALUES (3959, 124, 53, 843);
INSERT INTO 'devicecapvalue' VALUES (3960, 125, 56, 707);
INSERT INTO 'capvalue' VALUES (844, '480x696');
INSERT INTO 'devicecapvalue' VALUES (3961, 125, 7, 844);
INSERT INTO 'devicecapvalue' VALUES (3962, 125, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (3963, 125, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (3964, 125, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (3965, 125, 9, 709);
INSERT INTO 'devicecapvalue' VALUES (3966, 125, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (3967, 125, 11, 709);
INSERT INTO 'devicecapvalue' VALUES (3968, 125, 12, 711);
INSERT INTO 'capvalue' VALUES (845, '480x800');
INSERT INTO 'devicecapvalue' VALUES (3969, 125, 13, 845);
INSERT INTO 'devicecapvalue' VALUES (3970, 125, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (3971, 125, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (3972, 125, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (3973, 125, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (3974, 125, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (3975, 125, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (3976, 125, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (3977, 125, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (3978, 125, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (3979, 125, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (3980, 125, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (3981, 125, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (3982, 125, 112, 41);
INSERT INTO 'devicecapvalue' VALUES (3983, 125, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (3984, 125, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (3985, 125, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (3986, 125, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (3987, 125, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (3988, 125, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (3989, 125, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (3990, 125, 26, 41);
INSERT INTO 'devicecapvalue' VALUES (3991, 125, 27, 41);
INSERT INTO 'devicecapvalue' VALUES (3992, 125, 57, 41);
INSERT INTO 'devicecapvalue' VALUES (3993, 125, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (3994, 125, 30, 29);
INSERT INTO 'devicecapvalue' VALUES (3995, 125, 54, 41);
INSERT INTO 'devicecapvalue' VALUES (3996, 125, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (3997, 125, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (3998, 125, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (3999, 125, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (4000, 125, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (4001, 125, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (4002, 125, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (4003, 125, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (4004, 125, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (4005, 125, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (4006, 125, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (4007, 125, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (4008, 125, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (4009, 125, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (4010, 125, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (4011, 125, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (4012, 125, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (4013, 125, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (4014, 125, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (4015, 125, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (4016, 125, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (4017, 125, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (4018, 125, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (4019, 125, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (4020, 125, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (4021, 125, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (4022, 125, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (4023, 125, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (4024, 125, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (4025, 125, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (4026, 125, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (4027, 125, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (4028, 125, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (4029, 125, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (4030, 125, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (4031, 125, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (4032, 125, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (4033, 125, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (4034, 125, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (4035, 125, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (4036, 125, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (4037, 125, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (4038, 125, 59, 240);
INSERT INTO 'devicecapvalue' VALUES (4039, 125, 101, 722);
INSERT INTO 'devicecapvalue' VALUES (4040, 125, 102, 723);
INSERT INTO 'devicecapvalue' VALUES (4041, 125, 103, 724);
INSERT INTO 'devicecapvalue' VALUES (4042, 125, 104, 725);
INSERT INTO 'devicecapvalue' VALUES (4043, 125, 105, 726);
INSERT INTO 'devicecapvalue' VALUES (4044, 125, 106, 727);
INSERT INTO 'devicecapvalue' VALUES (4045, 125, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (4046, 125, 108, 729);
INSERT INTO 'devicecapvalue' VALUES (4047, 125, 109, 730);
INSERT INTO 'devicecapvalue' VALUES (4048, 125, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (4049, 125, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (4050, 125, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (4051, 125, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (4052, 125, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (4053, 125, 67, 45);
INSERT INTO 'capvalue' VALUES (846, 'HTC Touch HD T8282');
INSERT INTO 'devicecapvalue' VALUES (4054, 125, 68, 846);
INSERT INTO 'devicecapvalue' VALUES (4055, 125, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (4056, 125, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (4057, 125, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (4058, 125, 71, 244);
INSERT INTO 'capvalue' VALUES (847, '+393492000200');
INSERT INTO 'devicecapvalue' VALUES (4059, 125, 72, 847);
INSERT INTO 'devicecapvalue' VALUES (4060, 125, 111, 242);
INSERT INTO 'devicecapvalue' VALUES (4061, 125, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (4062, 125, 49, 733);
INSERT INTO 'capvalue' VALUES (848, 'HTC_Touch_HD_T8282 Opera/9.50 (Windows NT 5.1; U; it)');
INSERT INTO 'devicecapvalue' VALUES (4063, 125, 53, 848);
INSERT INTO 'devicecapvalue' VALUES (4064, 126, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (4065, 126, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (4066, 126, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (4067, 126, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (4068, 126, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (4069, 127, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (4070, 127, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (4071, 127, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (4072, 127, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (4073, 127, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (4074, 128, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (4075, 128, 7, 837);
INSERT INTO 'devicecapvalue' VALUES (4076, 128, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (4077, 128, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (4078, 128, 9, 709);
INSERT INTO 'devicecapvalue' VALUES (4079, 128, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (4080, 128, 11, 709);
INSERT INTO 'devicecapvalue' VALUES (4081, 128, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (4082, 128, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (4083, 128, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (4084, 128, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (4085, 128, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (4086, 128, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (4087, 128, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (4088, 128, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (4089, 128, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (4090, 128, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (4091, 128, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (4092, 128, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (4093, 128, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (4094, 128, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (4095, 128, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (4096, 128, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (4097, 128, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (4098, 128, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (4099, 128, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (4100, 128, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (4101, 128, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (4102, 128, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (4103, 128, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (4104, 128, 27, 29);
INSERT INTO 'devicecapvalue' VALUES (4105, 128, 57, 28);
INSERT INTO 'devicecapvalue' VALUES (4106, 128, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (4107, 128, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (4108, 128, 54, 40);
INSERT INTO 'devicecapvalue' VALUES (4109, 128, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (4110, 128, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (4111, 128, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (4112, 128, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (4113, 128, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (4114, 128, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (4115, 128, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (4116, 128, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (4117, 128, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (4118, 128, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (4119, 128, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (4120, 128, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (4121, 128, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (4122, 128, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (4123, 128, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (4124, 128, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (4125, 128, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (4126, 128, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (4127, 128, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (4128, 128, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (4129, 128, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (4130, 128, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (4131, 128, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (4132, 128, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (4133, 128, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (4134, 128, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (4135, 128, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (4136, 128, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (4137, 128, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (4138, 128, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (4139, 128, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (4140, 128, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (4141, 128, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (4142, 128, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (4143, 128, 59, 240);
INSERT INTO 'devicecapvalue' VALUES (4144, 128, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (4145, 128, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (4146, 128, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (4147, 128, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (4148, 128, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (4149, 128, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (4150, 128, 68, 838);
INSERT INTO 'devicecapvalue' VALUES (4151, 128, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (4152, 128, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (4153, 128, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (4154, 128, 71, 244);
INSERT INTO 'devicecapvalue' VALUES (4155, 128, 111, 242);
INSERT INTO 'devicecapvalue' VALUES (4156, 128, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (4157, 128, 49, 733);
INSERT INTO 'capvalue' VALUES (849, '8900b/MR2 Mozilla/4.0 (compatible; MSIE 6.0; Windows CE; IEMobile 7.11) UP.Link/6.3.1.17.0');
INSERT INTO 'devicecapvalue' VALUES (4158, 128, 53, 849);
INSERT INTO 'devicecapvalue' VALUES (4159, 129, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (4160, 129, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (4161, 129, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (4162, 129, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (4163, 129, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (4164, 129, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (4165, 129, 13, 234);
INSERT INTO 'devicecapvalue' VALUES (4166, 129, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (4167, 129, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (4168, 129, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (4169, 129, 26, 664);
INSERT INTO 'devicecapvalue' VALUES (4170, 129, 30, 667);
INSERT INTO 'devicecapvalue' VALUES (4171, 129, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (4172, 129, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (4173, 129, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (4174, 129, 42, 51);
INSERT INTO 'cap' VALUES (113, 'mmapi.protocol.https', 1);
INSERT INTO 'devicecapvalue' VALUES (4175, 129, 113, 616);
INSERT INTO 'devicecapvalue' VALUES (4176, 129, 113, 54);
INSERT INTO 'devicecapvalue' VALUES (4177, 129, 113, 51);
INSERT INTO 'devicecapvalue' VALUES (4178, 129, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (4179, 129, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (4180, 129, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (4181, 129, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (4182, 130, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (4183, 130, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (4184, 130, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (4185, 130, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (4186, 130, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (4187, 130, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (4188, 130, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (4189, 130, 13, 234);
INSERT INTO 'devicecapvalue' VALUES (4190, 130, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (4191, 130, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (4192, 130, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (4193, 130, 18, 604);
INSERT INTO 'devicecapvalue' VALUES (4194, 130, 26, 664);
INSERT INTO 'devicecapvalue' VALUES (4195, 130, 30, 667);
INSERT INTO 'devicecapvalue' VALUES (4196, 130, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (4197, 130, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (4198, 130, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (4199, 130, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (4200, 130, 113, 616);
INSERT INTO 'devicecapvalue' VALUES (4201, 130, 113, 54);
INSERT INTO 'devicecapvalue' VALUES (4202, 130, 113, 51);
INSERT INTO 'capvalue' VALUES (850, 'Windows Mobile 2005');
INSERT INTO 'devicecapvalue' VALUES (4203, 130, 3, 850);
INSERT INTO 'devicecapvalue' VALUES (4204, 130, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (4205, 130, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (4206, 130, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (4207, 131, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (4208, 131, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (4209, 131, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (4210, 131, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (4211, 131, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (4212, 132, 7, 742);
INSERT INTO 'devicecapvalue' VALUES (4213, 132, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (4214, 132, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (4215, 132, 9, 709);
INSERT INTO 'devicecapvalue' VALUES (4216, 132, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (4217, 132, 11, 709);
INSERT INTO 'devicecapvalue' VALUES (4218, 132, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (4219, 132, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (4220, 132, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (4221, 132, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (4222, 132, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (4223, 132, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (4224, 132, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (4225, 132, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (4226, 132, 18, 30);
INSERT INTO 'devicecapvalue' VALUES (4227, 132, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (4228, 132, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (4229, 132, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (4230, 132, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (4231, 132, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (4232, 132, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (4233, 132, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (4234, 132, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (4235, 132, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (4236, 132, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (4237, 132, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (4238, 132, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (4239, 132, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (4240, 132, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (4241, 132, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (4242, 132, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (4243, 132, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (4244, 132, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (4245, 132, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (4246, 132, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (4247, 132, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (4248, 132, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (4249, 132, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (4250, 132, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (4251, 132, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (4252, 132, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (4253, 132, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (4254, 132, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (4255, 132, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (4256, 132, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (4257, 132, 49, 733);
INSERT INTO 'capvalue' VALUES (851, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; es-ES; rv:1.9.0.10) Gecko/2009042316 Firefox/3.0.10');
INSERT INTO 'devicecapvalue' VALUES (4258, 132, 53, 851);
INSERT INTO 'devicecapvalue' VALUES (4259, 133, 7, 841);
INSERT INTO 'devicecapvalue' VALUES (4260, 133, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (4261, 133, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (4262, 133, 9, 649);
INSERT INTO 'devicecapvalue' VALUES (4263, 133, 10, 842);
INSERT INTO 'devicecapvalue' VALUES (4264, 133, 11, 649);
INSERT INTO 'devicecapvalue' VALUES (4265, 133, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (4266, 133, 13, 712);
INSERT INTO 'devicecapvalue' VALUES (4267, 133, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (4268, 133, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (4269, 133, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (4270, 133, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (4271, 133, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (4272, 133, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (4273, 133, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (4274, 133, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (4275, 133, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (4276, 133, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (4277, 133, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (4278, 133, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (4279, 133, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (4280, 133, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (4281, 133, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (4282, 133, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (4283, 133, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (4284, 133, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (4285, 133, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (4286, 133, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (4287, 133, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (4288, 133, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (4289, 133, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (4290, 133, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (4291, 133, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (4292, 133, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (4293, 133, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (4294, 133, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (4295, 133, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (4296, 133, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (4297, 133, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (4298, 133, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (4299, 133, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (4300, 133, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (4301, 133, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (4302, 133, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (4303, 133, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (4304, 133, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (4305, 133, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (4306, 133, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (4307, 133, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (4308, 133, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (4309, 133, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (4310, 133, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (4311, 133, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (4312, 133, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (4313, 133, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (4314, 133, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (4315, 133, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (4316, 133, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (4317, 133, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (4318, 133, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (4319, 133, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (4320, 133, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (4321, 133, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (4322, 133, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (4323, 133, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (4324, 133, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (4325, 133, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (4326, 133, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (4327, 133, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (4328, 133, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (4329, 133, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (4330, 133, 49, 733);
INSERT INTO 'devicecapvalue' VALUES (4331, 133, 53, 843);
INSERT INTO 'devicecapvalue' VALUES (4332, 134, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (4333, 134, 7, 742);
INSERT INTO 'devicecapvalue' VALUES (4334, 134, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (4335, 134, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (4336, 134, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (4337, 134, 9, 1);
INSERT INTO 'devicecapvalue' VALUES (4338, 134, 10, 663);
INSERT INTO 'devicecapvalue' VALUES (4339, 134, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (4340, 134, 12, 743);
INSERT INTO 'devicecapvalue' VALUES (4341, 134, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (4342, 134, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (4343, 134, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (4344, 134, 19, 744);
INSERT INTO 'devicecapvalue' VALUES (4345, 134, 20, 711);
INSERT INTO 'devicecapvalue' VALUES (4346, 134, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (4347, 134, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (4348, 134, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (4349, 134, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (4350, 134, 25, 746);
INSERT INTO 'devicecapvalue' VALUES (4351, 134, 26, 664);
INSERT INTO 'devicecapvalue' VALUES (4352, 134, 27, 711);
INSERT INTO 'devicecapvalue' VALUES (4353, 134, 29, 747);
INSERT INTO 'devicecapvalue' VALUES (4354, 134, 30, 667);
INSERT INTO 'devicecapvalue' VALUES (4355, 134, 54, 711);
INSERT INTO 'devicecapvalue' VALUES (4356, 134, 31, 748);
INSERT INTO 'devicecapvalue' VALUES (4357, 134, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (4358, 134, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (4359, 134, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (4360, 134, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (4361, 134, 58, 42);
INSERT INTO 'devicecapvalue' VALUES (4362, 134, 3, 740);
INSERT INTO 'devicecapvalue' VALUES (4363, 134, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (4364, 134, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (4365, 134, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (4366, 134, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (4367, 134, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (4368, 134, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (4369, 134, 62, 44);
INSERT INTO 'devicecapvalue' VALUES (4370, 134, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (4371, 134, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (4372, 134, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (4373, 134, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (4374, 134, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (4375, 134, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (4376, 134, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (4377, 134, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (4378, 134, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (4379, 134, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (4380, 134, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (4381, 134, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (4382, 134, 48, 750);
INSERT INTO 'devicecapvalue' VALUES (4383, 134, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (4384, 134, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (4385, 134, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (4386, 134, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (4387, 134, 48, 751);
INSERT INTO 'devicecapvalue' VALUES (4388, 134, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (4389, 134, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (4390, 134, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (4391, 134, 48, 752);
INSERT INTO 'devicecapvalue' VALUES (4392, 134, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (4393, 134, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (4394, 134, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (4395, 134, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (4396, 134, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (4397, 134, 48, 753);
INSERT INTO 'devicecapvalue' VALUES (4398, 134, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (4399, 134, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (4400, 134, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (4401, 134, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (4402, 134, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (4403, 134, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (4404, 134, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (4405, 134, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (4406, 134, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (4407, 134, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (4408, 134, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (4409, 134, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (4410, 134, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (4411, 134, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (4412, 134, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (4413, 134, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (4414, 134, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (4415, 134, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (4416, 134, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (4417, 134, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (4418, 134, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (4419, 134, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (4420, 134, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (4421, 134, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (4422, 134, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (4423, 134, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (4424, 134, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (4425, 134, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (4426, 134, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (4427, 134, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (4428, 134, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (4429, 134, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (4430, 134, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (4431, 134, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (4432, 134, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (4433, 134, 48, 754);
INSERT INTO 'devicecapvalue' VALUES (4434, 134, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (4435, 134, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (4436, 134, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (4437, 134, 48, 755);
INSERT INTO 'devicecapvalue' VALUES (4438, 134, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (4439, 134, 48, 756);
INSERT INTO 'devicecapvalue' VALUES (4440, 134, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (4441, 134, 48, 757);
INSERT INTO 'devicecapvalue' VALUES (4442, 134, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (4443, 134, 48, 758);
INSERT INTO 'devicecapvalue' VALUES (4444, 134, 48, 759);
INSERT INTO 'devicecapvalue' VALUES (4445, 134, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (4446, 134, 48, 760);
INSERT INTO 'devicecapvalue' VALUES (4447, 134, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (4448, 134, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (4449, 134, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (4450, 134, 48, 761);
INSERT INTO 'devicecapvalue' VALUES (4451, 134, 48, 762);
INSERT INTO 'devicecapvalue' VALUES (4452, 134, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (4453, 134, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (4454, 134, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (4455, 134, 48, 763);
INSERT INTO 'devicecapvalue' VALUES (4456, 134, 48, 764);
INSERT INTO 'devicecapvalue' VALUES (4457, 134, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (4458, 134, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (4459, 134, 48, 765);
INSERT INTO 'devicecapvalue' VALUES (4460, 134, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (4461, 134, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (4462, 134, 48, 766);
INSERT INTO 'devicecapvalue' VALUES (4463, 134, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (4464, 134, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (4465, 134, 48, 767);
INSERT INTO 'devicecapvalue' VALUES (4466, 134, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (4467, 134, 48, 768);
INSERT INTO 'devicecapvalue' VALUES (4468, 134, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (4469, 134, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (4470, 134, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (4471, 134, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (4472, 134, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (4473, 134, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (4474, 134, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (4475, 134, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (4476, 134, 48, 769);
INSERT INTO 'devicecapvalue' VALUES (4477, 134, 48, 770);
INSERT INTO 'devicecapvalue' VALUES (4478, 134, 48, 771);
INSERT INTO 'devicecapvalue' VALUES (4479, 134, 48, 772);
INSERT INTO 'devicecapvalue' VALUES (4480, 134, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (4481, 134, 48, 773);
INSERT INTO 'devicecapvalue' VALUES (4482, 134, 48, 774);
INSERT INTO 'devicecapvalue' VALUES (4483, 134, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (4484, 134, 48, 775);
INSERT INTO 'devicecapvalue' VALUES (4485, 134, 48, 776);
INSERT INTO 'devicecapvalue' VALUES (4486, 134, 48, 777);
INSERT INTO 'devicecapvalue' VALUES (4487, 134, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (4488, 134, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (4489, 134, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (4490, 134, 48, 778);
INSERT INTO 'devicecapvalue' VALUES (4491, 134, 48, 779);
INSERT INTO 'devicecapvalue' VALUES (4492, 134, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (4493, 134, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (4494, 134, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (4495, 134, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (4496, 134, 48, 780);
INSERT INTO 'devicecapvalue' VALUES (4497, 134, 48, 781);
INSERT INTO 'devicecapvalue' VALUES (4498, 134, 48, 782);
INSERT INTO 'devicecapvalue' VALUES (4499, 134, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (4500, 134, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (4501, 134, 48, 783);
INSERT INTO 'devicecapvalue' VALUES (4502, 134, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (4503, 134, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (4504, 134, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (4505, 134, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (4506, 134, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (4507, 134, 48, 784);
INSERT INTO 'devicecapvalue' VALUES (4508, 134, 48, 785);
INSERT INTO 'devicecapvalue' VALUES (4509, 134, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (4510, 134, 48, 786);
INSERT INTO 'devicecapvalue' VALUES (4511, 134, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (4512, 134, 48, 787);
INSERT INTO 'devicecapvalue' VALUES (4513, 134, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (4514, 134, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (4515, 134, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (4516, 134, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (4517, 134, 48, 788);
INSERT INTO 'devicecapvalue' VALUES (4518, 134, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (4519, 134, 48, 789);
INSERT INTO 'devicecapvalue' VALUES (4520, 134, 48, 790);
INSERT INTO 'devicecapvalue' VALUES (4521, 134, 48, 791);
INSERT INTO 'devicecapvalue' VALUES (4522, 134, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (4523, 134, 48, 792);
INSERT INTO 'devicecapvalue' VALUES (4524, 134, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (4525, 134, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (4526, 134, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (4527, 134, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (4528, 134, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (4529, 134, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (4530, 134, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (4531, 134, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (4532, 134, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (4533, 134, 48, 793);
INSERT INTO 'devicecapvalue' VALUES (4534, 134, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (4535, 134, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (4536, 134, 48, 794);
INSERT INTO 'devicecapvalue' VALUES (4537, 134, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (4538, 134, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (4539, 134, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (4540, 134, 48, 795);
INSERT INTO 'devicecapvalue' VALUES (4541, 134, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (4542, 134, 48, 796);
INSERT INTO 'devicecapvalue' VALUES (4543, 134, 48, 797);
INSERT INTO 'devicecapvalue' VALUES (4544, 134, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (4545, 134, 48, 798);
INSERT INTO 'devicecapvalue' VALUES (4546, 134, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (4547, 134, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (4548, 134, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (4549, 134, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (4550, 134, 48, 799);
INSERT INTO 'devicecapvalue' VALUES (4551, 134, 48, 800);
INSERT INTO 'devicecapvalue' VALUES (4552, 134, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (4553, 134, 48, 629);
INSERT INTO 'devicecapvalue' VALUES (4554, 134, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (4555, 134, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (4556, 134, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (4557, 134, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (4558, 134, 48, 801);
INSERT INTO 'devicecapvalue' VALUES (4559, 134, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (4560, 134, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (4561, 134, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (4562, 134, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (4563, 134, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (4564, 134, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (4565, 134, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (4566, 134, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (4567, 134, 48, 802);
INSERT INTO 'devicecapvalue' VALUES (4568, 134, 48, 803);
INSERT INTO 'devicecapvalue' VALUES (4569, 134, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (4570, 134, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (4571, 134, 48, 630);
INSERT INTO 'devicecapvalue' VALUES (4572, 134, 48, 804);
INSERT INTO 'devicecapvalue' VALUES (4573, 134, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (4574, 134, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (4575, 134, 48, 805);
INSERT INTO 'devicecapvalue' VALUES (4576, 134, 48, 806);
INSERT INTO 'devicecapvalue' VALUES (4577, 134, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (4578, 134, 48, 807);
INSERT INTO 'devicecapvalue' VALUES (4579, 134, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (4580, 134, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (4581, 134, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (4582, 134, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (4583, 134, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (4584, 134, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (4585, 134, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (4586, 134, 48, 808);
INSERT INTO 'devicecapvalue' VALUES (4587, 134, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (4588, 134, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (4589, 134, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (4590, 134, 48, 809);
INSERT INTO 'devicecapvalue' VALUES (4591, 134, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (4592, 134, 48, 810);
INSERT INTO 'devicecapvalue' VALUES (4593, 134, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (4594, 134, 48, 811);
INSERT INTO 'devicecapvalue' VALUES (4595, 134, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (4596, 134, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (4597, 134, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (4598, 134, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (4599, 134, 48, 812);
INSERT INTO 'devicecapvalue' VALUES (4600, 134, 48, 813);
INSERT INTO 'devicecapvalue' VALUES (4601, 134, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (4602, 134, 48, 814);
INSERT INTO 'devicecapvalue' VALUES (4603, 134, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (4604, 134, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (4605, 134, 48, 815);
INSERT INTO 'devicecapvalue' VALUES (4606, 134, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (4607, 134, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (4608, 134, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (4609, 134, 48, 816);
INSERT INTO 'devicecapvalue' VALUES (4610, 134, 48, 817);
INSERT INTO 'devicecapvalue' VALUES (4611, 134, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (4612, 134, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (4613, 134, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (4614, 134, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (4615, 134, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (4616, 134, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (4617, 134, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (4618, 134, 48, 818);
INSERT INTO 'devicecapvalue' VALUES (4619, 134, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (4620, 134, 48, 819);
INSERT INTO 'devicecapvalue' VALUES (4621, 134, 48, 820);
INSERT INTO 'devicecapvalue' VALUES (4622, 134, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (4623, 134, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (4624, 134, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (4625, 134, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (4626, 134, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (4627, 134, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (4628, 134, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (4629, 134, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (4630, 134, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (4631, 134, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (4632, 134, 48, 821);
INSERT INTO 'devicecapvalue' VALUES (4633, 134, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (4634, 134, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (4635, 134, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (4636, 134, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (4637, 134, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (4638, 134, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (4639, 134, 48, 822);
INSERT INTO 'devicecapvalue' VALUES (4640, 134, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (4641, 134, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (4642, 134, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (4643, 134, 48, 823);
INSERT INTO 'devicecapvalue' VALUES (4644, 134, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (4645, 134, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (4646, 134, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (4647, 134, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (4648, 134, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (4649, 134, 48, 824);
INSERT INTO 'devicecapvalue' VALUES (4650, 134, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (4651, 134, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (4652, 134, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (4653, 134, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (4654, 134, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (4655, 134, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (4656, 134, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (4657, 134, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (4658, 134, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (4659, 134, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (4660, 134, 48, 825);
INSERT INTO 'devicecapvalue' VALUES (4661, 134, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (4662, 134, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (4663, 134, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (4664, 134, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (4665, 134, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (4666, 134, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (4667, 134, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (4668, 134, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (4669, 134, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (4670, 134, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (4671, 134, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (4672, 134, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (4673, 134, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (4674, 134, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (4675, 134, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (4676, 134, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (4677, 134, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (4678, 134, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (4679, 134, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (4680, 134, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (4681, 134, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (4682, 134, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (4683, 134, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (4684, 134, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (4685, 134, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (4686, 134, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (4687, 134, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (4688, 134, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (4689, 134, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (4690, 134, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (4691, 134, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (4692, 134, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (4693, 134, 48, 826);
INSERT INTO 'devicecapvalue' VALUES (4694, 134, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (4695, 134, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (4696, 134, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (4697, 134, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (4698, 134, 48, 827);
INSERT INTO 'devicecapvalue' VALUES (4699, 134, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (4700, 134, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (4701, 134, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (4702, 134, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (4703, 134, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (4704, 134, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (4705, 134, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (4706, 134, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (4707, 134, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (4708, 134, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (4709, 134, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (4710, 134, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (4711, 134, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (4712, 134, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (4713, 134, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (4714, 134, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (4715, 134, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (4716, 134, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (4717, 134, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (4718, 134, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (4719, 134, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (4720, 134, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (4721, 134, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (4722, 134, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (4723, 134, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (4724, 134, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (4725, 134, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (4726, 134, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (4727, 134, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (4728, 134, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (4729, 134, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (4730, 134, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (4731, 134, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (4732, 134, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (4733, 134, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (4734, 134, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (4735, 134, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (4736, 134, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (4737, 134, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (4738, 134, 48, 828);
INSERT INTO 'devicecapvalue' VALUES (4739, 134, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (4740, 134, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (4741, 134, 48, 633);
INSERT INTO 'devicecapvalue' VALUES (4742, 134, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (4743, 134, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (4744, 134, 48, 634);
INSERT INTO 'devicecapvalue' VALUES (4745, 134, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (4746, 134, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (4747, 134, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (4748, 134, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (4749, 134, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (4750, 134, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (4751, 134, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (4752, 134, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (4753, 134, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (4754, 134, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (4755, 134, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (4756, 134, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (4757, 134, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (4758, 134, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (4759, 134, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (4760, 134, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (4761, 134, 48, 829);
INSERT INTO 'devicecapvalue' VALUES (4762, 134, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (4763, 134, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (4764, 134, 48, 830);
INSERT INTO 'devicecapvalue' VALUES (4765, 134, 49, 739);
INSERT INTO 'devicecapvalue' VALUES (4766, 134, 53, 831);
INSERT INTO 'devicecapvalue' VALUES (4767, 135, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (4768, 135, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (4769, 135, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (4770, 135, 76, 739);
INSERT INTO 'devicecapvalue' VALUES (4771, 135, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (4772, 135, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (4773, 135, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (4774, 135, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (4775, 135, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (4776, 135, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (4777, 135, 3, 740);
INSERT INTO 'devicecapvalue' VALUES (4778, 135, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (4779, 135, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (4780, 135, 53, 741);
INSERT INTO 'devicecapvalue' VALUES (4781, 136, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (4782, 136, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (4783, 136, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (4784, 136, 9, 1);
INSERT INTO 'devicecapvalue' VALUES (4785, 136, 10, 663);
INSERT INTO 'devicecapvalue' VALUES (4786, 136, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (4787, 136, 12, 743);
INSERT INTO 'devicecapvalue' VALUES (4788, 136, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (4789, 136, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (4790, 136, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (4791, 136, 19, 744);
INSERT INTO 'devicecapvalue' VALUES (4792, 136, 20, 711);
INSERT INTO 'devicecapvalue' VALUES (4793, 136, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (4794, 136, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (4795, 136, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (4796, 136, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (4797, 136, 25, 746);
INSERT INTO 'devicecapvalue' VALUES (4798, 136, 26, 746);
INSERT INTO 'devicecapvalue' VALUES (4799, 136, 27, 711);
INSERT INTO 'devicecapvalue' VALUES (4800, 136, 29, 747);
INSERT INTO 'devicecapvalue' VALUES (4801, 136, 30, 747);
INSERT INTO 'devicecapvalue' VALUES (4802, 136, 31, 748);
INSERT INTO 'capvalue' VALUES (852, 'COM1');
INSERT INTO 'devicecapvalue' VALUES (4803, 136, 32, 852);
INSERT INTO 'devicecapvalue' VALUES (4804, 136, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (4805, 136, 34, 44);
INSERT INTO 'devicecapvalue' VALUES (4806, 136, 36, 749);
INSERT INTO 'devicecapvalue' VALUES (4807, 136, 37, 47);
INSERT INTO 'devicecapvalue' VALUES (4808, 136, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (4809, 136, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (4810, 136, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (4811, 136, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (4812, 136, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (4813, 136, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (4814, 136, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (4815, 136, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (4816, 136, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (4817, 136, 46, 83);
INSERT INTO 'cap' VALUES (114, 'property.microedition.commports', 1);
INSERT INTO 'devicecapvalue' VALUES (4818, 136, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (4819, 136, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (4820, 136, 62, 44);
INSERT INTO 'devicecapvalue' VALUES (4821, 136, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (4822, 136, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (4823, 136, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (4824, 136, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (4825, 136, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (4826, 136, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (4827, 136, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (4828, 136, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (4829, 136, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (4830, 136, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (4831, 136, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (4832, 136, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (4833, 136, 48, 750);
INSERT INTO 'devicecapvalue' VALUES (4834, 136, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (4835, 136, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (4836, 136, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (4837, 136, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (4838, 136, 48, 751);
INSERT INTO 'devicecapvalue' VALUES (4839, 136, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (4840, 136, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (4841, 136, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (4842, 136, 48, 752);
INSERT INTO 'devicecapvalue' VALUES (4843, 136, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (4844, 136, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (4845, 136, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (4846, 136, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (4847, 136, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (4848, 136, 48, 753);
INSERT INTO 'devicecapvalue' VALUES (4849, 136, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (4850, 136, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (4851, 136, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (4852, 136, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (4853, 136, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (4854, 136, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (4855, 136, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (4856, 136, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (4857, 136, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (4858, 136, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (4859, 136, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (4860, 136, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (4861, 136, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (4862, 136, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (4863, 136, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (4864, 136, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (4865, 136, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (4866, 136, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (4867, 136, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (4868, 136, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (4869, 136, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (4870, 136, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (4871, 136, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (4872, 136, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (4873, 136, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (4874, 136, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (4875, 136, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (4876, 136, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (4877, 136, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (4878, 136, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (4879, 136, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (4880, 136, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (4881, 136, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (4882, 136, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (4883, 136, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (4884, 136, 48, 754);
INSERT INTO 'devicecapvalue' VALUES (4885, 136, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (4886, 136, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (4887, 136, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (4888, 136, 48, 755);
INSERT INTO 'devicecapvalue' VALUES (4889, 136, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (4890, 136, 48, 756);
INSERT INTO 'devicecapvalue' VALUES (4891, 136, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (4892, 136, 48, 757);
INSERT INTO 'devicecapvalue' VALUES (4893, 136, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (4894, 136, 48, 758);
INSERT INTO 'devicecapvalue' VALUES (4895, 136, 48, 759);
INSERT INTO 'devicecapvalue' VALUES (4896, 136, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (4897, 136, 48, 760);
INSERT INTO 'devicecapvalue' VALUES (4898, 136, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (4899, 136, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (4900, 136, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (4901, 136, 48, 761);
INSERT INTO 'devicecapvalue' VALUES (4902, 136, 48, 762);
INSERT INTO 'devicecapvalue' VALUES (4903, 136, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (4904, 136, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (4905, 136, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (4906, 136, 48, 763);
INSERT INTO 'devicecapvalue' VALUES (4907, 136, 48, 764);
INSERT INTO 'devicecapvalue' VALUES (4908, 136, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (4909, 136, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (4910, 136, 48, 765);
INSERT INTO 'devicecapvalue' VALUES (4911, 136, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (4912, 136, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (4913, 136, 48, 766);
INSERT INTO 'devicecapvalue' VALUES (4914, 136, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (4915, 136, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (4916, 136, 48, 767);
INSERT INTO 'devicecapvalue' VALUES (4917, 136, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (4918, 136, 48, 768);
INSERT INTO 'devicecapvalue' VALUES (4919, 136, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (4920, 136, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (4921, 136, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (4922, 136, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (4923, 136, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (4924, 136, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (4925, 136, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (4926, 136, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (4927, 136, 48, 769);
INSERT INTO 'devicecapvalue' VALUES (4928, 136, 48, 770);
INSERT INTO 'devicecapvalue' VALUES (4929, 136, 48, 771);
INSERT INTO 'devicecapvalue' VALUES (4930, 136, 48, 772);
INSERT INTO 'devicecapvalue' VALUES (4931, 136, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (4932, 136, 48, 773);
INSERT INTO 'devicecapvalue' VALUES (4933, 136, 48, 774);
INSERT INTO 'devicecapvalue' VALUES (4934, 136, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (4935, 136, 48, 775);
INSERT INTO 'devicecapvalue' VALUES (4936, 136, 48, 776);
INSERT INTO 'devicecapvalue' VALUES (4937, 136, 48, 777);
INSERT INTO 'devicecapvalue' VALUES (4938, 136, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (4939, 136, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (4940, 136, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (4941, 136, 48, 778);
INSERT INTO 'devicecapvalue' VALUES (4942, 136, 48, 779);
INSERT INTO 'devicecapvalue' VALUES (4943, 136, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (4944, 136, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (4945, 136, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (4946, 136, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (4947, 136, 48, 780);
INSERT INTO 'devicecapvalue' VALUES (4948, 136, 48, 781);
INSERT INTO 'devicecapvalue' VALUES (4949, 136, 48, 782);
INSERT INTO 'devicecapvalue' VALUES (4950, 136, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (4951, 136, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (4952, 136, 48, 783);
INSERT INTO 'devicecapvalue' VALUES (4953, 136, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (4954, 136, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (4955, 136, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (4956, 136, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (4957, 136, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (4958, 136, 48, 784);
INSERT INTO 'devicecapvalue' VALUES (4959, 136, 48, 785);
INSERT INTO 'devicecapvalue' VALUES (4960, 136, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (4961, 136, 48, 786);
INSERT INTO 'devicecapvalue' VALUES (4962, 136, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (4963, 136, 48, 787);
INSERT INTO 'devicecapvalue' VALUES (4964, 136, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (4965, 136, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (4966, 136, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (4967, 136, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (4968, 136, 48, 788);
INSERT INTO 'devicecapvalue' VALUES (4969, 136, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (4970, 136, 48, 789);
INSERT INTO 'devicecapvalue' VALUES (4971, 136, 48, 790);
INSERT INTO 'devicecapvalue' VALUES (4972, 136, 48, 791);
INSERT INTO 'devicecapvalue' VALUES (4973, 136, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (4974, 136, 48, 792);
INSERT INTO 'devicecapvalue' VALUES (4975, 136, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (4976, 136, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (4977, 136, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (4978, 136, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (4979, 136, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (4980, 136, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (4981, 136, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (4982, 136, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (4983, 136, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (4984, 136, 48, 793);
INSERT INTO 'devicecapvalue' VALUES (4985, 136, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (4986, 136, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (4987, 136, 48, 794);
INSERT INTO 'devicecapvalue' VALUES (4988, 136, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (4989, 136, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (4990, 136, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (4991, 136, 48, 795);
INSERT INTO 'devicecapvalue' VALUES (4992, 136, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (4993, 136, 48, 796);
INSERT INTO 'devicecapvalue' VALUES (4994, 136, 48, 797);
INSERT INTO 'devicecapvalue' VALUES (4995, 136, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (4996, 136, 48, 798);
INSERT INTO 'devicecapvalue' VALUES (4997, 136, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (4998, 136, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (4999, 136, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (5000, 136, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (5001, 136, 48, 799);
INSERT INTO 'devicecapvalue' VALUES (5002, 136, 48, 800);
INSERT INTO 'devicecapvalue' VALUES (5003, 136, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (5004, 136, 48, 629);
INSERT INTO 'devicecapvalue' VALUES (5005, 136, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (5006, 136, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (5007, 136, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (5008, 136, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (5009, 136, 48, 801);
INSERT INTO 'devicecapvalue' VALUES (5010, 136, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (5011, 136, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (5012, 136, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (5013, 136, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (5014, 136, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (5015, 136, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (5016, 136, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (5017, 136, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (5018, 136, 48, 802);
INSERT INTO 'devicecapvalue' VALUES (5019, 136, 48, 803);
INSERT INTO 'devicecapvalue' VALUES (5020, 136, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (5021, 136, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (5022, 136, 48, 630);
INSERT INTO 'devicecapvalue' VALUES (5023, 136, 48, 804);
INSERT INTO 'devicecapvalue' VALUES (5024, 136, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (5025, 136, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (5026, 136, 48, 805);
INSERT INTO 'devicecapvalue' VALUES (5027, 136, 48, 806);
INSERT INTO 'devicecapvalue' VALUES (5028, 136, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (5029, 136, 48, 807);
INSERT INTO 'devicecapvalue' VALUES (5030, 136, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (5031, 136, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (5032, 136, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (5033, 136, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (5034, 136, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (5035, 136, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (5036, 136, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (5037, 136, 48, 808);
INSERT INTO 'devicecapvalue' VALUES (5038, 136, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (5039, 136, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (5040, 136, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (5041, 136, 48, 809);
INSERT INTO 'devicecapvalue' VALUES (5042, 136, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (5043, 136, 48, 810);
INSERT INTO 'devicecapvalue' VALUES (5044, 136, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (5045, 136, 48, 811);
INSERT INTO 'devicecapvalue' VALUES (5046, 136, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (5047, 136, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (5048, 136, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (5049, 136, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (5050, 136, 48, 812);
INSERT INTO 'devicecapvalue' VALUES (5051, 136, 48, 813);
INSERT INTO 'devicecapvalue' VALUES (5052, 136, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (5053, 136, 48, 814);
INSERT INTO 'devicecapvalue' VALUES (5054, 136, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (5055, 136, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (5056, 136, 48, 815);
INSERT INTO 'devicecapvalue' VALUES (5057, 136, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (5058, 136, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (5059, 136, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (5060, 136, 48, 816);
INSERT INTO 'devicecapvalue' VALUES (5061, 136, 48, 817);
INSERT INTO 'devicecapvalue' VALUES (5062, 136, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (5063, 136, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (5064, 136, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (5065, 136, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (5066, 136, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (5067, 136, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (5068, 136, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (5069, 136, 48, 818);
INSERT INTO 'devicecapvalue' VALUES (5070, 136, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (5071, 136, 48, 819);
INSERT INTO 'devicecapvalue' VALUES (5072, 136, 48, 820);
INSERT INTO 'devicecapvalue' VALUES (5073, 136, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (5074, 136, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (5075, 136, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (5076, 136, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (5077, 136, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (5078, 136, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (5079, 136, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (5080, 136, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (5081, 136, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (5082, 136, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (5083, 136, 48, 821);
INSERT INTO 'devicecapvalue' VALUES (5084, 136, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (5085, 136, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (5086, 136, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (5087, 136, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (5088, 136, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (5089, 136, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (5090, 136, 48, 822);
INSERT INTO 'devicecapvalue' VALUES (5091, 136, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (5092, 136, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (5093, 136, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (5094, 136, 48, 823);
INSERT INTO 'devicecapvalue' VALUES (5095, 136, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (5096, 136, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (5097, 136, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (5098, 136, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (5099, 136, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (5100, 136, 48, 824);
INSERT INTO 'devicecapvalue' VALUES (5101, 136, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (5102, 136, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (5103, 136, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (5104, 136, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (5105, 136, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (5106, 136, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (5107, 136, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (5108, 136, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (5109, 136, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (5110, 136, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (5111, 136, 48, 825);
INSERT INTO 'devicecapvalue' VALUES (5112, 136, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (5113, 136, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (5114, 136, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (5115, 136, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (5116, 136, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (5117, 136, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (5118, 136, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (5119, 136, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (5120, 136, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (5121, 136, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (5122, 136, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (5123, 136, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (5124, 136, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (5125, 136, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (5126, 136, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (5127, 136, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (5128, 136, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (5129, 136, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (5130, 136, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (5131, 136, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (5132, 136, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (5133, 136, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (5134, 136, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (5135, 136, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (5136, 136, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (5137, 136, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (5138, 136, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (5139, 136, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (5140, 136, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (5141, 136, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (5142, 136, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (5143, 136, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (5144, 136, 48, 826);
INSERT INTO 'devicecapvalue' VALUES (5145, 136, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (5146, 136, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (5147, 136, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (5148, 136, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (5149, 136, 48, 827);
INSERT INTO 'devicecapvalue' VALUES (5150, 136, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (5151, 136, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (5152, 136, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (5153, 136, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (5154, 136, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (5155, 136, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (5156, 136, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (5157, 136, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (5158, 136, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (5159, 136, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (5160, 136, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (5161, 136, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (5162, 136, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (5163, 136, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (5164, 136, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (5165, 136, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (5166, 136, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (5167, 136, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (5168, 136, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (5169, 136, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (5170, 136, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (5171, 136, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (5172, 136, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (5173, 136, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (5174, 136, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (5175, 136, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (5176, 136, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (5177, 136, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (5178, 136, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (5179, 136, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (5180, 136, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (5181, 136, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (5182, 136, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (5183, 136, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (5184, 136, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (5185, 136, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (5186, 136, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (5187, 136, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (5188, 136, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (5189, 136, 48, 828);
INSERT INTO 'devicecapvalue' VALUES (5190, 136, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (5191, 136, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (5192, 136, 48, 633);
INSERT INTO 'devicecapvalue' VALUES (5193, 136, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (5194, 136, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (5195, 136, 48, 634);
INSERT INTO 'devicecapvalue' VALUES (5196, 136, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (5197, 136, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (5198, 136, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (5199, 136, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (5200, 136, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (5201, 136, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (5202, 136, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (5203, 136, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (5204, 136, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (5205, 136, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (5206, 136, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (5207, 136, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (5208, 136, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (5209, 136, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (5210, 136, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (5211, 136, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (5212, 136, 48, 829);
INSERT INTO 'devicecapvalue' VALUES (5213, 136, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (5214, 136, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (5215, 136, 48, 830);
INSERT INTO 'devicecapvalue' VALUES (5216, 136, 49, 739);
INSERT INTO 'devicecapvalue' VALUES (5217, 137, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5218, 137, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (5219, 137, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (5220, 137, 10, 110);
INSERT INTO 'devicecapvalue' VALUES (5221, 137, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (5222, 137, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (5223, 137, 13, 234);
INSERT INTO 'devicecapvalue' VALUES (5224, 137, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (5225, 137, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (5226, 137, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5227, 137, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (5228, 137, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (5229, 137, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (5230, 138, 1, 1);
INSERT INTO 'capvalue' VALUES (853, 'inversedGameActions');
INSERT INTO 'devicecapvalue' VALUES (5231, 138, 74, 853);
INSERT INTO 'devicecapvalue' VALUES (5232, 138, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (5233, 138, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (5234, 138, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (5235, 138, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (5236, 138, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (5237, 138, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (5238, 138, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (5239, 138, 13, 234);
INSERT INTO 'devicecapvalue' VALUES (5240, 138, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (5241, 138, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (5242, 138, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5243, 138, 26, 664);
INSERT INTO 'devicecapvalue' VALUES (5244, 138, 30, 667);
INSERT INTO 'devicecapvalue' VALUES (5245, 138, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (5246, 138, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (5247, 138, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (5248, 138, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (5249, 138, 113, 616);
INSERT INTO 'devicecapvalue' VALUES (5250, 138, 113, 54);
INSERT INTO 'devicecapvalue' VALUES (5251, 138, 113, 51);
INSERT INTO 'devicecapvalue' VALUES (5252, 138, 3, 850);
INSERT INTO 'devicecapvalue' VALUES (5253, 138, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (5254, 138, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (5255, 138, 5, 601);
INSERT INTO 'capvalue' VALUES (854, 'Mozilla/4.0 (compatible; MSIE 6.0; Windows CE; IEMobile 6.8)');
INSERT INTO 'devicecapvalue' VALUES (5256, 138, 53, 854);
INSERT INTO 'devicecapvalue' VALUES (5257, 139, 1, 625);
INSERT INTO 'devicecapvalue' VALUES (5258, 139, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (5259, 139, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (5260, 139, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (5261, 139, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (5262, 140, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5263, 140, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (5264, 140, 2, 2);
INSERT INTO 'capvalue' VALUES (855, '240x247');
INSERT INTO 'devicecapvalue' VALUES (5265, 140, 13, 855);
INSERT INTO 'devicecapvalue' VALUES (5266, 140, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (5267, 140, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5268, 140, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (5269, 140, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (5270, 140, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (5271, 141, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5272, 141, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (5273, 141, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (5274, 141, 13, 855);
INSERT INTO 'devicecapvalue' VALUES (5275, 141, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (5276, 141, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5277, 141, 3, 740);
INSERT INTO 'devicecapvalue' VALUES (5278, 141, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (5279, 141, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (5280, 142, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5281, 142, 2, 2);
INSERT INTO 'capvalue' VALUES (856, '640x480');
INSERT INTO 'devicecapvalue' VALUES (5282, 142, 13, 856);
INSERT INTO 'devicecapvalue' VALUES (5283, 142, 76, 739);
INSERT INTO 'devicecapvalue' VALUES (5284, 142, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (5285, 142, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (5286, 142, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (5287, 142, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (5288, 142, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (5289, 142, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5290, 142, 3, 740);
INSERT INTO 'capvalue' VALUES (857, '640');
INSERT INTO 'devicecapvalue' VALUES (5291, 142, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (5292, 142, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (5293, 143, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5294, 143, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (5295, 143, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (5296, 143, 13, 742);
INSERT INTO 'devicecapvalue' VALUES (5297, 143, 76, 739);
INSERT INTO 'devicecapvalue' VALUES (5298, 143, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (5299, 143, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (5300, 143, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (5301, 143, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (5302, 143, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (5303, 143, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5304, 143, 3, 740);
INSERT INTO 'devicecapvalue' VALUES (5305, 143, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (5306, 143, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (5307, 144, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5308, 144, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (5309, 144, 2, 2);
INSERT INTO 'capvalue' VALUES (858, '176x180');
INSERT INTO 'devicecapvalue' VALUES (5310, 144, 13, 858);
INSERT INTO 'devicecapvalue' VALUES (5311, 144, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (5312, 144, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5313, 144, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (5314, 144, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (5315, 144, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (5316, 145, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5317, 145, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (5318, 145, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (5319, 145, 13, 858);
INSERT INTO 'devicecapvalue' VALUES (5320, 145, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (5321, 145, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5322, 145, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (5323, 145, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (5324, 145, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (5325, 146, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5326, 146, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (5327, 146, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (5328, 146, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (5329, 146, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (5330, 146, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (5331, 146, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (5332, 146, 13, 234);
INSERT INTO 'devicecapvalue' VALUES (5333, 146, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (5334, 146, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5335, 146, 18, 604);
INSERT INTO 'devicecapvalue' VALUES (5336, 146, 26, 664);
INSERT INTO 'devicecapvalue' VALUES (5337, 146, 30, 667);
INSERT INTO 'devicecapvalue' VALUES (5338, 146, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (5339, 146, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (5340, 146, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (5341, 146, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (5342, 146, 113, 616);
INSERT INTO 'devicecapvalue' VALUES (5343, 146, 113, 54);
INSERT INTO 'devicecapvalue' VALUES (5344, 146, 113, 51);
INSERT INTO 'devicecapvalue' VALUES (5345, 146, 3, 850);
INSERT INTO 'devicecapvalue' VALUES (5346, 146, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (5347, 146, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (5348, 146, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (5349, 147, 1, 1);
INSERT INTO 'capvalue' VALUES (859, '176x220');
INSERT INTO 'devicecapvalue' VALUES (5350, 147, 7, 859);
INSERT INTO 'devicecapvalue' VALUES (5351, 147, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (5352, 147, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (5353, 147, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (5354, 147, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (5355, 147, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (5356, 147, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (5357, 147, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (5358, 147, 6, 27);
INSERT INTO 'capvalue' VALUES (860, '-16');
INSERT INTO 'devicecapvalue' VALUES (5359, 147, 18, 860);
INSERT INTO 'devicecapvalue' VALUES (5360, 147, 28, 860);
INSERT INTO 'devicecapvalue' VALUES (5361, 147, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (5362, 147, 5, 681);
INSERT INTO 'capvalue' VALUES (861, 'LG-CU400/V1.0 Obigo/Q04C Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (5363, 147, 53, 861);
INSERT INTO 'devicecapvalue' VALUES (5364, 148, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5365, 148, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (5366, 148, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5367, 148, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (5368, 148, 5, 681);
INSERT INTO 'capvalue' VALUES (862, 'LG-TU500');
INSERT INTO 'devicecapvalue' VALUES (5369, 148, 53, 862);
INSERT INTO 'devicecapvalue' VALUES (5370, 149, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5371, 149, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (5372, 149, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5373, 149, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (5374, 149, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (5375, 149, 53, 862);
INSERT INTO 'devicecapvalue' VALUES (5376, 150, 56, 707);
INSERT INTO 'capvalue' VALUES (863, '176x189');
INSERT INTO 'devicecapvalue' VALUES (5377, 150, 7, 863);
INSERT INTO 'devicecapvalue' VALUES (5378, 150, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (5379, 150, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (5380, 150, 9, 1);
INSERT INTO 'devicecapvalue' VALUES (5381, 150, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (5382, 150, 11, 1);
INSERT INTO 'capvalue' VALUES (864, '14');
INSERT INTO 'devicecapvalue' VALUES (5383, 150, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (5384, 150, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (5385, 150, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (5386, 150, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (5387, 150, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (5388, 150, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (5389, 150, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (5390, 150, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (5391, 150, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (5392, 150, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (5393, 150, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (5394, 150, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (5395, 150, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (5396, 150, 18, 860);
INSERT INTO 'devicecapvalue' VALUES (5397, 150, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (5398, 150, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (5399, 150, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (5400, 150, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (5401, 150, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (5402, 150, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (5403, 150, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (5404, 150, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (5405, 150, 57, 860);
INSERT INTO 'devicecapvalue' VALUES (5406, 150, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (5407, 150, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (5408, 150, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (5409, 150, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (5410, 150, 38, 49);
INSERT INTO 'capvalue' VALUES (865, 'pcm');
INSERT INTO 'devicecapvalue' VALUES (5411, 150, 38, 865);
INSERT INTO 'capvalue' VALUES (866, 'audio');
INSERT INTO 'devicecapvalue' VALUES (5412, 150, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (5413, 150, 39, 616);
INSERT INTO 'capvalue' VALUES (867, 'audio/wav');
INSERT INTO 'devicecapvalue' VALUES (5414, 150, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (5415, 150, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (5416, 150, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (5417, 150, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (5418, 150, 40, 131);
INSERT INTO 'devicecapvalue' VALUES (5419, 150, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (5420, 150, 41, 56);
INSERT INTO 'capvalue' VALUES (868, 'application/vnd.rn-realmedia');
INSERT INTO 'devicecapvalue' VALUES (5421, 150, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (5422, 150, 41, 866);
INSERT INTO 'devicecapvalue' VALUES (5423, 150, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (5424, 150, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (5425, 150, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (5426, 150, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (5427, 150, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (5428, 150, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (5429, 150, 41, 63);
INSERT INTO 'capvalue' VALUES (869, 'audio/mpeg3');
INSERT INTO 'devicecapvalue' VALUES (5430, 150, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (5431, 150, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (5432, 150, 41, 131);
INSERT INTO 'capvalue' VALUES (870, 'audio/x-mp3');
INSERT INTO 'devicecapvalue' VALUES (5433, 150, 41, 870);
INSERT INTO 'capvalue' VALUES (871, 'audio/x-mpeg3');
INSERT INTO 'devicecapvalue' VALUES (5434, 150, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (5435, 150, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (5436, 150, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (5437, 150, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (5438, 150, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (5439, 150, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (5440, 150, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (5441, 150, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (5442, 150, 42, 866);
INSERT INTO 'devicecapvalue' VALUES (5443, 150, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (5444, 150, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (5445, 150, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (5446, 150, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (5447, 150, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (5448, 150, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (5449, 150, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (5450, 150, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (5451, 150, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (5452, 150, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (5453, 150, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (5454, 150, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (5455, 150, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (5456, 150, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (5457, 150, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (5458, 150, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (5459, 150, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (5460, 150, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (5461, 150, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (5462, 150, 58, 42);
INSERT INTO 'devicecapvalue' VALUES (5463, 150, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (5464, 150, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (5465, 150, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (5466, 150, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (5467, 150, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (5468, 150, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (5469, 150, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (5470, 150, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (5471, 150, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (5472, 150, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (5473, 150, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (5474, 150, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (5475, 150, 46, 83);
INSERT INTO 'capvalue' VALUES (872, 'streamable.contents');
INSERT INTO 'devicecapvalue' VALUES (5476, 150, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (5477, 150, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (5478, 150, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (5479, 150, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (5480, 150, 46, 87);
INSERT INTO 'cap' VALUES (115, 'property.audio.encodings', 1);
INSERT INTO 'capvalue' VALUES (873, 'encoding=audio/amr encoding=pcm');
INSERT INTO 'devicecapvalue' VALUES (5481, 150, 115, 873);
INSERT INTO 'devicecapvalue' VALUES (5482, 150, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (5483, 150, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (5484, 150, 60, 43);
INSERT INTO 'capvalue' VALUES (874, 'UTF_8');
INSERT INTO 'devicecapvalue' VALUES (5485, 150, 62, 874);
INSERT INTO 'devicecapvalue' VALUES (5486, 150, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (5487, 150, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (5488, 150, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (5489, 150, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (5490, 150, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (5491, 150, 68, 243);
INSERT INTO 'devicecapvalue' VALUES (5492, 150, 69, 47);
INSERT INTO 'cap' VALUES (116, 'property.streamable.contents', 1);
INSERT INTO 'devicecapvalue' VALUES (5493, 150, 116, 53);
INSERT INTO 'devicecapvalue' VALUES (5494, 150, 116, 67);
INSERT INTO 'devicecapvalue' VALUES (5495, 150, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (5496, 150, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (5497, 150, 47, 56);
INSERT INTO 'devicecapvalue' VALUES (5498, 150, 47, 868);
INSERT INTO 'devicecapvalue' VALUES (5499, 150, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (5500, 150, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (5501, 150, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (5502, 150, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (5503, 150, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (5504, 150, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (5505, 150, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (5506, 150, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (5507, 150, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (5508, 150, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (5509, 150, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (5510, 150, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (5511, 150, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (5512, 150, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (5513, 150, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (5514, 150, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (5515, 150, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (5516, 150, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (5517, 150, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (5518, 150, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (5519, 150, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (5520, 150, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (5521, 150, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (5522, 150, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (5523, 150, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (5524, 150, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (5525, 150, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (5526, 150, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (5527, 150, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (5528, 150, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (5529, 150, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (5530, 150, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (5531, 150, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (5532, 150, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (5533, 150, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (5534, 150, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (5535, 150, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (5536, 150, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (5537, 150, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (5538, 150, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (5539, 150, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (5540, 150, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (5541, 150, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (5542, 150, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (5543, 150, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (5544, 150, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (5545, 150, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (5546, 150, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (5547, 150, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (5548, 150, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (5549, 150, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (5550, 150, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (5551, 150, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (5552, 150, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (5553, 150, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (5554, 150, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (5555, 150, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (5556, 150, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (5557, 150, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (5558, 150, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (5559, 150, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (5560, 150, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (5561, 150, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (5562, 150, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (5563, 150, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (5564, 150, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (5565, 150, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (5566, 150, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (5567, 150, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (5568, 150, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (5569, 150, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (5570, 150, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (5571, 150, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (5572, 150, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (5573, 150, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (5574, 150, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (5575, 150, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (5576, 150, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (5577, 150, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (5578, 150, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (5579, 150, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (5580, 150, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (5581, 150, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (5582, 150, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (5583, 150, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (5584, 150, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (5585, 150, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (5586, 150, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (5587, 150, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (5588, 150, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (5589, 150, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (5590, 150, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (5591, 150, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (5592, 150, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (5593, 150, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (5594, 150, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (5595, 150, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (5596, 150, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (5597, 150, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (5598, 150, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (5599, 150, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (5600, 150, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (5601, 150, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (5602, 150, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (5603, 150, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (5604, 150, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (5605, 150, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (5606, 150, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (5607, 150, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (5608, 150, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (5609, 150, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (5610, 150, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (5611, 150, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (5612, 150, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (5613, 150, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (5614, 150, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (5615, 150, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (5616, 150, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (5617, 150, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (5618, 150, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (5619, 150, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (5620, 150, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (5621, 150, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (5622, 150, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (5623, 150, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (5624, 150, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (5625, 150, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (5626, 150, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (5627, 150, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (5628, 150, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (5629, 150, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (5630, 150, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (5631, 150, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (5632, 150, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (5633, 150, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (5634, 150, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (5635, 150, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (5636, 150, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (5637, 150, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (5638, 150, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (5639, 150, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (5640, 150, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (5641, 150, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (5642, 150, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (5643, 150, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (5644, 150, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (5645, 150, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (5646, 150, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (5647, 150, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (5648, 150, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (5649, 150, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (5650, 150, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (5651, 150, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (5652, 150, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (5653, 150, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (5654, 150, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (5655, 150, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (5656, 150, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (5657, 150, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (5658, 150, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (5659, 150, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (5660, 150, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (5661, 150, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (5662, 150, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (5663, 150, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (5664, 150, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (5665, 150, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (5666, 150, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (5667, 150, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (5668, 150, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (5669, 150, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (5670, 150, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (5671, 150, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (5672, 150, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (5673, 150, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (5674, 150, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (5675, 150, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (5676, 150, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (5677, 150, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (5678, 150, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (5679, 150, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (5680, 150, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (5681, 150, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (5682, 150, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (5683, 150, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (5684, 150, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (5685, 150, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (5686, 150, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (5687, 150, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (5688, 150, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (5689, 150, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (5690, 150, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (5691, 150, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (5692, 150, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (5693, 150, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (5694, 150, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (5695, 150, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (5696, 150, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (5697, 150, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (5698, 150, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (5699, 150, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (5700, 150, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (5701, 150, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (5702, 150, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (5703, 150, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (5704, 150, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (5705, 150, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (5706, 150, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (5707, 150, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (5708, 150, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (5709, 150, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (5710, 150, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (5711, 150, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (5712, 150, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (5713, 150, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (5714, 150, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (5715, 150, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (5716, 150, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (5717, 150, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (5718, 150, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (5719, 150, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (5720, 150, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (5721, 150, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (5722, 150, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (5723, 150, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (5724, 150, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (5725, 150, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (5726, 150, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (5727, 150, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (5728, 150, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (5729, 150, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (5730, 150, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (5731, 150, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (5732, 150, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (5733, 150, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (5734, 150, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (5735, 150, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (5736, 150, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (5737, 150, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (5738, 150, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (5739, 150, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (5740, 150, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (5741, 150, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (5742, 150, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (5743, 150, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (5744, 150, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (5745, 150, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (5746, 150, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (5747, 150, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (5748, 150, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (5749, 150, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (5750, 150, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (5751, 150, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (5752, 150, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (5753, 150, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (5754, 150, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (5755, 150, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (5756, 150, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (5757, 150, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (5758, 150, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (5759, 150, 48, 90);
INSERT INTO 'capvalue' VALUES (875, 'GMT:0');
INSERT INTO 'devicecapvalue' VALUES (5760, 150, 48, 875);
INSERT INTO 'devicecapvalue' VALUES (5761, 150, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (5762, 150, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (5763, 150, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (5764, 150, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (5765, 150, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (5766, 150, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (5767, 150, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (5768, 150, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (5769, 150, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (5770, 150, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (5771, 150, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (5772, 150, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (5773, 150, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (5774, 150, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (5775, 150, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (5776, 150, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (5777, 150, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (5778, 150, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (5779, 150, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (5780, 150, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (5781, 150, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (5782, 150, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (5783, 150, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (5784, 150, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (5785, 150, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (5786, 150, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (5787, 150, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (5788, 150, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (5789, 150, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (5790, 150, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (5791, 150, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (5792, 150, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (5793, 150, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (5794, 150, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (5795, 150, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (5796, 150, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (5797, 150, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (5798, 150, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (5799, 150, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (5800, 150, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (5801, 150, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (5802, 150, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (5803, 150, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (5804, 150, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (5805, 150, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (5806, 150, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (5807, 150, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (5808, 150, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (5809, 150, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (5810, 150, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (5811, 150, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (5812, 150, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (5813, 150, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (5814, 150, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (5815, 150, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (5816, 150, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (5817, 150, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (5818, 150, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (5819, 150, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (5820, 150, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (5821, 150, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (5822, 150, 48, 562);
INSERT INTO 'capvalue' VALUES (876, '2097144');
INSERT INTO 'devicecapvalue' VALUES (5823, 150, 49, 876);
INSERT INTO 'capvalue' VALUES (877, 'LG-CU515/V1.0g Obigo/Q05A Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Link/6.3.1.20.06.3.1.20.0');
INSERT INTO 'devicecapvalue' VALUES (5824, 150, 53, 877);
INSERT INTO 'devicecapvalue' VALUES (5825, 151, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5826, 151, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (5827, 151, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (5828, 151, 4, 4);
INSERT INTO 'devicecapvalue' VALUES (5829, 151, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (5830, 152, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (5831, 152, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (5832, 152, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (5833, 152, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (5834, 152, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (5835, 153, 1, 13);
INSERT INTO 'devicecapvalue' VALUES (5836, 153, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (5837, 153, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (5838, 153, 4, 8);
INSERT INTO 'devicecapvalue' VALUES (5839, 153, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (5840, 154, 56, 707);
INSERT INTO 'capvalue' VALUES (878, '320x200');
INSERT INTO 'devicecapvalue' VALUES (5841, 154, 7, 878);
INSERT INTO 'devicecapvalue' VALUES (5842, 154, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (5843, 154, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (5844, 154, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (5845, 154, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (5846, 154, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (5847, 154, 12, 603);
INSERT INTO 'devicecapvalue' VALUES (5848, 154, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (5849, 154, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (5850, 154, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (5851, 154, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (5852, 154, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (5853, 154, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (5854, 154, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (5855, 154, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (5856, 154, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (5857, 154, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (5858, 154, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (5859, 154, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (5860, 154, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (5861, 154, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (5862, 154, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (5863, 154, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (5864, 154, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (5865, 154, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (5866, 154, 6, 26);
INSERT INTO 'capvalue' VALUES (879, 'MIDP/2.1');
INSERT INTO 'devicecapvalue' VALUES (5867, 154, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (5868, 154, 112, 860);
INSERT INTO 'devicecapvalue' VALUES (5869, 154, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (5870, 154, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (5871, 154, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (5872, 154, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (5873, 154, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (5874, 154, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (5875, 154, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (5876, 154, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (5877, 154, 57, 40);
INSERT INTO 'devicecapvalue' VALUES (5878, 154, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (5879, 154, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (5880, 154, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (5881, 154, 31, 41);
INSERT INTO 'capvalue' VALUES (880, 'amr-nb');
INSERT INTO 'devicecapvalue' VALUES (5882, 154, 38, 880);
INSERT INTO 'devicecapvalue' VALUES (5883, 154, 39, 49);
INSERT INTO 'capvalue' VALUES (881, 'audio/cfm');
INSERT INTO 'devicecapvalue' VALUES (5884, 154, 39, 881);
INSERT INTO 'devicecapvalue' VALUES (5885, 154, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (5886, 154, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (5887, 154, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (5888, 154, 40, 55);
INSERT INTO 'capvalue' VALUES (882, 'audio/3ga');
INSERT INTO 'devicecapvalue' VALUES (5889, 154, 41, 882);
INSERT INTO 'capvalue' VALUES (883, 'audio/3gp');
INSERT INTO 'devicecapvalue' VALUES (5890, 154, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (5891, 154, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (5892, 154, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (5893, 154, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (5894, 154, 41, 881);
INSERT INTO 'devicecapvalue' VALUES (5895, 154, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (5896, 154, 41, 54);
INSERT INTO 'capvalue' VALUES (884, 'audio/mmf');
INSERT INTO 'devicecapvalue' VALUES (5897, 154, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (5898, 154, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (5899, 154, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (5900, 154, 41, 62);
INSERT INTO 'capvalue' VALUES (885, 'audio/mpa');
INSERT INTO 'devicecapvalue' VALUES (5901, 154, 41, 885);
INSERT INTO 'devicecapvalue' VALUES (5902, 154, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (5903, 154, 41, 869);
INSERT INTO 'capvalue' VALUES (886, 'audio/mpeg4');
INSERT INTO 'devicecapvalue' VALUES (5904, 154, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (5905, 154, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (5906, 154, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (5907, 154, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (5908, 154, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (5909, 154, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (5910, 154, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (5911, 154, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (5912, 154, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (5913, 154, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (5914, 154, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (5915, 154, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (5916, 154, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (5917, 154, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (5918, 154, 41, 53);
INSERT INTO 'capvalue' VALUES (887, 'video/asf');
INSERT INTO 'devicecapvalue' VALUES (5919, 154, 41, 887);
INSERT INTO 'devicecapvalue' VALUES (5920, 154, 41, 67);
INSERT INTO 'capvalue' VALUES (888, 'video/mpeg4');
INSERT INTO 'devicecapvalue' VALUES (5921, 154, 41, 888);
INSERT INTO 'capvalue' VALUES (889, 'video/wmv');
INSERT INTO 'devicecapvalue' VALUES (5922, 154, 41, 889);
INSERT INTO 'devicecapvalue' VALUES (5923, 154, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (5924, 154, 41, 622);
INSERT INTO 'capvalue' VALUES (890, 'video/x-ms-wmv-streaming');
INSERT INTO 'devicecapvalue' VALUES (5925, 154, 41, 890);
INSERT INTO 'devicecapvalue' VALUES (5926, 154, 42, 882);
INSERT INTO 'devicecapvalue' VALUES (5927, 154, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (5928, 154, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (5929, 154, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (5930, 154, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (5931, 154, 42, 881);
INSERT INTO 'devicecapvalue' VALUES (5932, 154, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (5933, 154, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (5934, 154, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (5935, 154, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (5936, 154, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (5937, 154, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (5938, 154, 42, 885);
INSERT INTO 'devicecapvalue' VALUES (5939, 154, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (5940, 154, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (5941, 154, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (5942, 154, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (5943, 154, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (5944, 154, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (5945, 154, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (5946, 154, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (5947, 154, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (5948, 154, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (5949, 154, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (5950, 154, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (5951, 154, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (5952, 154, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (5953, 154, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (5954, 154, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (5955, 154, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (5956, 154, 42, 887);
INSERT INTO 'devicecapvalue' VALUES (5957, 154, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (5958, 154, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (5959, 154, 42, 889);
INSERT INTO 'devicecapvalue' VALUES (5960, 154, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (5961, 154, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (5962, 154, 42, 890);
INSERT INTO 'devicecapvalue' VALUES (5963, 154, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (5964, 154, 44, 15);
INSERT INTO 'capvalue' VALUES (891, 'encoding=3gp');
INSERT INTO 'devicecapvalue' VALUES (5965, 154, 45, 891);
INSERT INTO 'devicecapvalue' VALUES (5966, 154, 46, 69);
INSERT INTO 'capvalue' VALUES (892, 'bluetooth.api.version');
INSERT INTO 'devicecapvalue' VALUES (5967, 154, 46, 892);
INSERT INTO 'capvalue' VALUES (893, 'bluetooth.connected.devices.max');
INSERT INTO 'devicecapvalue' VALUES (5968, 154, 46, 893);
INSERT INTO 'capvalue' VALUES (894, 'bluetooth.connected.inquiry');
INSERT INTO 'devicecapvalue' VALUES (5969, 154, 46, 894);
INSERT INTO 'capvalue' VALUES (895, 'bluetooth.connected.inquiry.scan');
INSERT INTO 'devicecapvalue' VALUES (5970, 154, 46, 895);
INSERT INTO 'capvalue' VALUES (896, 'bluetooth.connected.page');
INSERT INTO 'devicecapvalue' VALUES (5971, 154, 46, 896);
INSERT INTO 'capvalue' VALUES (897, 'bluetooth.connected.page.scan');
INSERT INTO 'devicecapvalue' VALUES (5972, 154, 46, 897);
INSERT INTO 'capvalue' VALUES (898, 'bluetooth.l2cap.receiveMTU.max');
INSERT INTO 'devicecapvalue' VALUES (5973, 154, 46, 898);
INSERT INTO 'capvalue' VALUES (899, 'bluetooth.master.switch');
INSERT INTO 'devicecapvalue' VALUES (5974, 154, 46, 899);
INSERT INTO 'capvalue' VALUES (900, 'bluetooth.sd.attr.retrievable.max');
INSERT INTO 'devicecapvalue' VALUES (5975, 154, 46, 900);
INSERT INTO 'capvalue' VALUES (901, 'bluetooth.sd.trans.max');
INSERT INTO 'devicecapvalue' VALUES (5976, 154, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (5977, 154, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (5978, 154, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (5979, 154, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (5980, 154, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (5981, 154, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (5982, 154, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (5983, 154, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (5984, 154, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (5985, 154, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (5986, 154, 46, 719);
INSERT INTO 'capvalue' VALUES (902, 'microedition.chapi.version');
INSERT INTO 'devicecapvalue' VALUES (5987, 154, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (5988, 154, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (5989, 154, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (5990, 154, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (5991, 154, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (5992, 154, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (5993, 154, 46, 78);
INSERT INTO 'capvalue' VALUES (903, 'microedition.m2g.svg.baseProfile');
INSERT INTO 'devicecapvalue' VALUES (5994, 154, 46, 903);
INSERT INTO 'capvalue' VALUES (904, 'microedition.m2g.svg.version');
INSERT INTO 'devicecapvalue' VALUES (5995, 154, 46, 904);
INSERT INTO 'capvalue' VALUES (905, 'microedition.m2g.version');
INSERT INTO 'devicecapvalue' VALUES (5996, 154, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (5997, 154, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (5998, 154, 46, 80);
INSERT INTO 'capvalue' VALUES (906, 'microedition.msa.version');
INSERT INTO 'devicecapvalue' VALUES (5999, 154, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (6000, 154, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (6001, 154, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (6002, 154, 46, 83);
INSERT INTO 'capvalue' VALUES (907, 'obex.api.version');
INSERT INTO 'devicecapvalue' VALUES (6003, 154, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (6004, 154, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (6005, 154, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (6006, 154, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (6007, 154, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (6008, 154, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (6009, 154, 46, 89);
INSERT INTO 'capvalue' VALUES (908, 'wireless.messaging.mms.mmsc');
INSERT INTO 'devicecapvalue' VALUES (6010, 154, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (6011, 154, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (6012, 154, 46, 721);
INSERT INTO 'capvalue' VALUES (909, 'xml.jaxp.subset.version');
INSERT INTO 'devicecapvalue' VALUES (6013, 154, 46, 909);
INSERT INTO 'capvalue' VALUES (910, 'xml.rpc.subset.version');
INSERT INTO 'devicecapvalue' VALUES (6014, 154, 46, 910);
INSERT INTO 'capvalue' VALUES (911, 'encoding=amr-nb');
INSERT INTO 'devicecapvalue' VALUES (6015, 154, 115, 911);
INSERT INTO 'cap' VALUES (117, 'property.bluetooth.api.version', 1);
INSERT INTO 'devicecapvalue' VALUES (6016, 154, 117, 242);
INSERT INTO 'cap' VALUES (118, 'property.bluetooth.connected.devices.max', 1);
INSERT INTO 'devicecapvalue' VALUES (6017, 154, 118, 612);
INSERT INTO 'cap' VALUES (119, 'property.bluetooth.connected.inquiry', 1);
INSERT INTO 'devicecapvalue' VALUES (6018, 154, 119, 244);
INSERT INTO 'cap' VALUES (120, 'property.bluetooth.connected.inquiry.scan', 1);
INSERT INTO 'devicecapvalue' VALUES (6019, 154, 120, 244);
INSERT INTO 'cap' VALUES (121, 'property.bluetooth.connected.page', 1);
INSERT INTO 'devicecapvalue' VALUES (6020, 154, 121, 244);
INSERT INTO 'cap' VALUES (122, 'property.bluetooth.connected.page.scan', 1);
INSERT INTO 'devicecapvalue' VALUES (6021, 154, 122, 244);
INSERT INTO 'cap' VALUES (123, 'property.bluetooth.l2cap.receivemtu.max', 1);
INSERT INTO 'capvalue' VALUES (912, '672');
INSERT INTO 'devicecapvalue' VALUES (6022, 154, 123, 912);
INSERT INTO 'cap' VALUES (124, 'property.bluetooth.master.switch', 1);
INSERT INTO 'devicecapvalue' VALUES (6023, 154, 124, 244);
INSERT INTO 'cap' VALUES (125, 'property.bluetooth.sd.attr.retrievable.max', 1);
INSERT INTO 'devicecapvalue' VALUES (6024, 154, 125, 13);
INSERT INTO 'cap' VALUES (126, 'property.bluetooth.sd.trans.max', 1);
INSERT INTO 'devicecapvalue' VALUES (6025, 154, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (6026, 154, 59, 602);
INSERT INTO 'capvalue' VALUES (913, 'file:///Card/');
INSERT INTO 'devicecapvalue' VALUES (6027, 154, 101, 913);
INSERT INTO 'capvalue' VALUES (914, 'Scheda');
INSERT INTO 'devicecapvalue' VALUES (6028, 154, 102, 914);
INSERT INTO 'capvalue' VALUES (915, 'file:///Images/');
INSERT INTO 'devicecapvalue' VALUES (6029, 154, 103, 915);
INSERT INTO 'capvalue' VALUES (916, 'Immagini');
INSERT INTO 'devicecapvalue' VALUES (6030, 154, 104, 916);
INSERT INTO 'capvalue' VALUES (917, 'file:///Private/');
INSERT INTO 'devicecapvalue' VALUES (6031, 154, 105, 917);
INSERT INTO 'capvalue' VALUES (918, 'file:///Sounds/');
INSERT INTO 'devicecapvalue' VALUES (6032, 154, 106, 918);
INSERT INTO 'devicecapvalue' VALUES (6033, 154, 107, 866);
INSERT INTO 'capvalue' VALUES (919, 'file:///Videos/');
INSERT INTO 'devicecapvalue' VALUES (6034, 154, 108, 919);
INSERT INTO 'capvalue' VALUES (920, 'Video');
INSERT INTO 'devicecapvalue' VALUES (6035, 154, 109, 920);
INSERT INTO 'cap' VALUES (127, 'property.microedition.chapi.version', 1);
INSERT INTO 'devicecapvalue' VALUES (6036, 154, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (6037, 154, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (6038, 154, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (6039, 154, 62, 874);
INSERT INTO 'devicecapvalue' VALUES (6040, 154, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (6041, 154, 64, 45);
INSERT INTO 'cap' VALUES (128, 'property.microedition.m2g.svg.baseprofile', 1);
INSERT INTO 'capvalue' VALUES (921, 'tiny');
INSERT INTO 'devicecapvalue' VALUES (6042, 154, 128, 921);
INSERT INTO 'cap' VALUES (129, 'property.microedition.m2g.svg.version', 1);
INSERT INTO 'devicecapvalue' VALUES (6043, 154, 129, 242);
INSERT INTO 'cap' VALUES (130, 'property.microedition.m2g.version', 1);
INSERT INTO 'devicecapvalue' VALUES (6044, 154, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (6045, 154, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (6046, 154, 66, 242);
INSERT INTO 'cap' VALUES (131, 'property.microedition.msa.version', 1);
INSERT INTO 'capvalue' VALUES (922, '1.0-SUBSET');
INSERT INTO 'devicecapvalue' VALUES (6047, 154, 131, 922);
INSERT INTO 'devicecapvalue' VALUES (6048, 154, 67, 45);
INSERT INTO 'capvalue' VALUES (923, 'LG/U960/v1.0 Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (6049, 154, 68, 923);
INSERT INTO 'capvalue' VALUES (924, 'MIDP-2.1');
INSERT INTO 'devicecapvalue' VALUES (6050, 154, 69, 924);
INSERT INTO 'cap' VALUES (132, 'property.mmapi.audio.encodings', 1);
INSERT INTO 'devicecapvalue' VALUES (6051, 154, 132, 911);
INSERT INTO 'cap' VALUES (133, 'property.mmapi.video.encodings', 1);
INSERT INTO 'devicecapvalue' VALUES (6052, 154, 133, 891);
INSERT INTO 'cap' VALUES (134, 'property.obex.api.version', 1);
INSERT INTO 'devicecapvalue' VALUES (6053, 154, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (6054, 154, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (6055, 154, 71, 15);
INSERT INTO 'cap' VALUES (135, 'property.supports.video.capture', 1);
INSERT INTO 'devicecapvalue' VALUES (6056, 154, 135, 15);
INSERT INTO 'cap' VALUES (136, 'property.video.encodings', 1);
INSERT INTO 'devicecapvalue' VALUES (6057, 154, 136, 891);
INSERT INTO 'cap' VALUES (137, 'property.video.snapshot.encodings', 1);
INSERT INTO 'devicecapvalue' VALUES (6058, 154, 137, 18);
INSERT INTO 'cap' VALUES (138, 'property.wireless.messaging.mms.mmsc', 1);
INSERT INTO 'capvalue' VALUES (925, 'http://10.216.59.240:10021/mmsc');
INSERT INTO 'devicecapvalue' VALUES (6059, 154, 138, 925);
INSERT INTO 'capvalue' VALUES (926, '+393916263333');
INSERT INTO 'devicecapvalue' VALUES (6060, 154, 72, 926);
INSERT INTO 'capvalue' VALUES (927, '2.0');
INSERT INTO 'devicecapvalue' VALUES (6061, 154, 111, 927);
INSERT INTO 'cap' VALUES (139, 'property.xml.jaxp.subset.version', 1);
INSERT INTO 'devicecapvalue' VALUES (6062, 154, 139, 45);
INSERT INTO 'cap' VALUES (140, 'property.xml.rpc.subset.version', 1);
INSERT INTO 'devicecapvalue' VALUES (6063, 154, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (6064, 154, 47, 882);
INSERT INTO 'devicecapvalue' VALUES (6065, 154, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (6066, 154, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (6067, 154, 47, 881);
INSERT INTO 'devicecapvalue' VALUES (6068, 154, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (6069, 154, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (6070, 154, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (6071, 154, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (6072, 154, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (6073, 154, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (6074, 154, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (6075, 154, 47, 887);
INSERT INTO 'devicecapvalue' VALUES (6076, 154, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (6077, 154, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (6078, 154, 47, 889);
INSERT INTO 'devicecapvalue' VALUES (6079, 154, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (6080, 154, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (6081, 154, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (6082, 154, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (6083, 154, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (6084, 154, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (6085, 154, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (6086, 154, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (6087, 154, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (6088, 154, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (6089, 154, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (6090, 154, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (6091, 154, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (6092, 154, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (6093, 154, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (6094, 154, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (6095, 154, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (6096, 154, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (6097, 154, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (6098, 154, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (6099, 154, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (6100, 154, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (6101, 154, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (6102, 154, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (6103, 154, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (6104, 154, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (6105, 154, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (6106, 154, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (6107, 154, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (6108, 154, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (6109, 154, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (6110, 154, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (6111, 154, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (6112, 154, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (6113, 154, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (6114, 154, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (6115, 154, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (6116, 154, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (6117, 154, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (6118, 154, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (6119, 154, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (6120, 154, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (6121, 154, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (6122, 154, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (6123, 154, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (6124, 154, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (6125, 154, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (6126, 154, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (6127, 154, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (6128, 154, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (6129, 154, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (6130, 154, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (6131, 154, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (6132, 154, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (6133, 154, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (6134, 154, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (6135, 154, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (6136, 154, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (6137, 154, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (6138, 154, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (6139, 154, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (6140, 154, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (6141, 154, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (6142, 154, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (6143, 154, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (6144, 154, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (6145, 154, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (6146, 154, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (6147, 154, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (6148, 154, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (6149, 154, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (6150, 154, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (6151, 154, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (6152, 154, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (6153, 154, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (6154, 154, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (6155, 154, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (6156, 154, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (6157, 154, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (6158, 154, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (6159, 154, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (6160, 154, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (6161, 154, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (6162, 154, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (6163, 154, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (6164, 154, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (6165, 154, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (6166, 154, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (6167, 154, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (6168, 154, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (6169, 154, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (6170, 154, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (6171, 154, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (6172, 154, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (6173, 154, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (6174, 154, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (6175, 154, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (6176, 154, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (6177, 154, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (6178, 154, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (6179, 154, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (6180, 154, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (6181, 154, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (6182, 154, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (6183, 154, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (6184, 154, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (6185, 154, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (6186, 154, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (6187, 154, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (6188, 154, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (6189, 154, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (6190, 154, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (6191, 154, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (6192, 154, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (6193, 154, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (6194, 154, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (6195, 154, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (6196, 154, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (6197, 154, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (6198, 154, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (6199, 154, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (6200, 154, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (6201, 154, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (6202, 154, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (6203, 154, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (6204, 154, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (6205, 154, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (6206, 154, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (6207, 154, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (6208, 154, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (6209, 154, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (6210, 154, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (6211, 154, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (6212, 154, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (6213, 154, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (6214, 154, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (6215, 154, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (6216, 154, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (6217, 154, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (6218, 154, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (6219, 154, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (6220, 154, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (6221, 154, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (6222, 154, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (6223, 154, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (6224, 154, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (6225, 154, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (6226, 154, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (6227, 154, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (6228, 154, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (6229, 154, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (6230, 154, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (6231, 154, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (6232, 154, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (6233, 154, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (6234, 154, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (6235, 154, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (6236, 154, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (6237, 154, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (6238, 154, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (6239, 154, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (6240, 154, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (6241, 154, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (6242, 154, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (6243, 154, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (6244, 154, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (6245, 154, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (6246, 154, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (6247, 154, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (6248, 154, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (6249, 154, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (6250, 154, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (6251, 154, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (6252, 154, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (6253, 154, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (6254, 154, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (6255, 154, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (6256, 154, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (6257, 154, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (6258, 154, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (6259, 154, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (6260, 154, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (6261, 154, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (6262, 154, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (6263, 154, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (6264, 154, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (6265, 154, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (6266, 154, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (6267, 154, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (6268, 154, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (6269, 154, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (6270, 154, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (6271, 154, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (6272, 154, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (6273, 154, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (6274, 154, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (6275, 154, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (6276, 154, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (6277, 154, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (6278, 154, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (6279, 154, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (6280, 154, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (6281, 154, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (6282, 154, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (6283, 154, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (6284, 154, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (6285, 154, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (6286, 154, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (6287, 154, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (6288, 154, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (6289, 154, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (6290, 154, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (6291, 154, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (6292, 154, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (6293, 154, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (6294, 154, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (6295, 154, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (6296, 154, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (6297, 154, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (6298, 154, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (6299, 154, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (6300, 154, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (6301, 154, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (6302, 154, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (6303, 154, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (6304, 154, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (6305, 154, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (6306, 154, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (6307, 154, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (6308, 154, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (6309, 154, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (6310, 154, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (6311, 154, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (6312, 154, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (6313, 154, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (6314, 154, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (6315, 154, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (6316, 154, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (6317, 154, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (6318, 154, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (6319, 154, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (6320, 154, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (6321, 154, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (6322, 154, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (6323, 154, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (6324, 154, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (6325, 154, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (6326, 154, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (6327, 154, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (6328, 154, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (6329, 154, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (6330, 154, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (6331, 154, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (6332, 154, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (6333, 154, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (6334, 154, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (6335, 154, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (6336, 154, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (6337, 154, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (6338, 154, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (6339, 154, 48, 144);
INSERT INTO 'devicecapvalue' VALUES (6340, 154, 48, 875);
INSERT INTO 'devicecapvalue' VALUES (6341, 154, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (6342, 154, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (6343, 154, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (6344, 154, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (6345, 154, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (6346, 154, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (6347, 154, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (6348, 154, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (6349, 154, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (6350, 154, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (6351, 154, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (6352, 154, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (6353, 154, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (6354, 154, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (6355, 154, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (6356, 154, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (6357, 154, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (6358, 154, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (6359, 154, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (6360, 154, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (6361, 154, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (6362, 154, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (6363, 154, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (6364, 154, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (6365, 154, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (6366, 154, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (6367, 154, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (6368, 154, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (6369, 154, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (6370, 154, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (6371, 154, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (6372, 154, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (6373, 154, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (6374, 154, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (6375, 154, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (6376, 154, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (6377, 154, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (6378, 154, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (6379, 154, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (6380, 154, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (6381, 154, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (6382, 154, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (6383, 154, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (6384, 154, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (6385, 154, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (6386, 154, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (6387, 154, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (6388, 154, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (6389, 154, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (6390, 154, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (6391, 154, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (6392, 154, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (6393, 154, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (6394, 154, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (6395, 154, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (6396, 154, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (6397, 154, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (6398, 154, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (6399, 154, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (6400, 154, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (6401, 154, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (6402, 154, 48, 562);
INSERT INTO 'capvalue' VALUES (928, '6291452');
INSERT INTO 'devicecapvalue' VALUES (6403, 154, 49, 928);
INSERT INTO 'capvalue' VALUES (929, 'LG/U960/v1.0');
INSERT INTO 'devicecapvalue' VALUES (6404, 154, 53, 929);
INSERT INTO 'devicecapvalue' VALUES (6405, 155, 56, 707);
INSERT INTO 'capvalue' VALUES (930, '240x273');
INSERT INTO 'devicecapvalue' VALUES (6406, 155, 7, 930);
INSERT INTO 'devicecapvalue' VALUES (6407, 155, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (6408, 155, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (6409, 155, 9, 603);
INSERT INTO 'devicecapvalue' VALUES (6410, 155, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (6411, 155, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (6412, 155, 12, 106);
INSERT INTO 'capvalue' VALUES (931, '240x298');
INSERT INTO 'devicecapvalue' VALUES (6413, 155, 13, 931);
INSERT INTO 'devicecapvalue' VALUES (6414, 155, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (6415, 155, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (6416, 155, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (6417, 155, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (6418, 155, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (6419, 155, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (6420, 155, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (6421, 155, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (6422, 155, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (6423, 155, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (6424, 155, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (6425, 155, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (6426, 155, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (6427, 155, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (6428, 155, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (6429, 155, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (6430, 155, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (6431, 155, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (6432, 155, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (6433, 155, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (6434, 155, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (6435, 155, 112, 31);
INSERT INTO 'devicecapvalue' VALUES (6436, 155, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (6437, 155, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (6438, 155, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (6439, 155, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (6440, 155, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (6441, 155, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (6442, 155, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (6443, 155, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (6444, 155, 27, 30);
INSERT INTO 'capvalue' VALUES (932, '50');
INSERT INTO 'devicecapvalue' VALUES (6445, 155, 57, 932);
INSERT INTO 'devicecapvalue' VALUES (6446, 155, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (6447, 155, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (6448, 155, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (6449, 155, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (6450, 155, 38, 880);
INSERT INTO 'devicecapvalue' VALUES (6451, 155, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (6452, 155, 39, 881);
INSERT INTO 'devicecapvalue' VALUES (6453, 155, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (6454, 155, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (6455, 155, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (6456, 155, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (6457, 155, 41, 882);
INSERT INTO 'devicecapvalue' VALUES (6458, 155, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (6459, 155, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (6460, 155, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (6461, 155, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (6462, 155, 41, 881);
INSERT INTO 'devicecapvalue' VALUES (6463, 155, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (6464, 155, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (6465, 155, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (6466, 155, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (6467, 155, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (6468, 155, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (6469, 155, 41, 885);
INSERT INTO 'devicecapvalue' VALUES (6470, 155, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (6471, 155, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (6472, 155, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (6473, 155, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (6474, 155, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (6475, 155, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (6476, 155, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (6477, 155, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (6478, 155, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (6479, 155, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (6480, 155, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (6481, 155, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (6482, 155, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (6483, 155, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (6484, 155, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (6485, 155, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (6486, 155, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (6487, 155, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (6488, 155, 41, 887);
INSERT INTO 'devicecapvalue' VALUES (6489, 155, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (6490, 155, 41, 889);
INSERT INTO 'devicecapvalue' VALUES (6491, 155, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (6492, 155, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (6493, 155, 41, 890);
INSERT INTO 'devicecapvalue' VALUES (6494, 155, 42, 882);
INSERT INTO 'devicecapvalue' VALUES (6495, 155, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (6496, 155, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (6497, 155, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (6498, 155, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (6499, 155, 42, 881);
INSERT INTO 'devicecapvalue' VALUES (6500, 155, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (6501, 155, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (6502, 155, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (6503, 155, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (6504, 155, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (6505, 155, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (6506, 155, 42, 885);
INSERT INTO 'devicecapvalue' VALUES (6507, 155, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (6508, 155, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (6509, 155, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (6510, 155, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (6511, 155, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (6512, 155, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (6513, 155, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (6514, 155, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (6515, 155, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (6516, 155, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (6517, 155, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (6518, 155, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (6519, 155, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (6520, 155, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (6521, 155, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (6522, 155, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (6523, 155, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (6524, 155, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (6525, 155, 42, 887);
INSERT INTO 'devicecapvalue' VALUES (6526, 155, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (6527, 155, 42, 889);
INSERT INTO 'devicecapvalue' VALUES (6528, 155, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (6529, 155, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (6530, 155, 42, 890);
INSERT INTO 'devicecapvalue' VALUES (6531, 155, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (6532, 155, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (6533, 155, 45, 891);
INSERT INTO 'devicecapvalue' VALUES (6534, 155, 46, 69);
INSERT INTO 'capvalue' VALUES (933, 'audio3d.simultaneouslocations');
INSERT INTO 'devicecapvalue' VALUES (6535, 155, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (6536, 155, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (6537, 155, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (6538, 155, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (6539, 155, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (6540, 155, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (6541, 155, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (6542, 155, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (6543, 155, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (6544, 155, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (6545, 155, 46, 901);
INSERT INTO 'capvalue' VALUES (934, 'camera.orientations');
INSERT INTO 'devicecapvalue' VALUES (6546, 155, 46, 934);
INSERT INTO 'capvalue' VALUES (935, 'camera.resolutions');
INSERT INTO 'devicecapvalue' VALUES (6547, 155, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (6548, 155, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (6549, 155, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (6550, 155, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (6551, 155, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (6552, 155, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (6553, 155, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (6554, 155, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (6555, 155, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (6556, 155, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (6557, 155, 46, 719);
INSERT INTO 'capvalue' VALUES (936, 'microedition.amms.version');
INSERT INTO 'devicecapvalue' VALUES (6558, 155, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (6559, 155, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (6560, 155, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (6561, 155, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (6562, 155, 46, 75);
INSERT INTO 'capvalue' VALUES (937, 'microedition.global.version');
INSERT INTO 'devicecapvalue' VALUES (6563, 155, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (6564, 155, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (6565, 155, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (6566, 155, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (6567, 155, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (6568, 155, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (6569, 155, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (6570, 155, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (6571, 155, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (6572, 155, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (6573, 155, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (6574, 155, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (6575, 155, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (6576, 155, 46, 83);
INSERT INTO 'capvalue' VALUES (938, 'microedition.sensor.version');
INSERT INTO 'devicecapvalue' VALUES (6577, 155, 46, 938);
INSERT INTO 'capvalue' VALUES (939, 'microedition.sip.version');
INSERT INTO 'devicecapvalue' VALUES (6578, 155, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (6579, 155, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (6580, 155, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (6581, 155, 46, 84);
INSERT INTO 'capvalue' VALUES (940, 'supports.mediacapabilities');
INSERT INTO 'devicecapvalue' VALUES (6582, 155, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (6583, 155, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (6584, 155, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (6585, 155, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (6586, 155, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (6587, 155, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (6588, 155, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (6589, 155, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (6590, 155, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (6591, 155, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (6592, 155, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (6593, 155, 115, 911);
INSERT INTO 'cap' VALUES (141, 'property.audio3d.simultaneouslocations', 1);
INSERT INTO 'devicecapvalue' VALUES (6594, 155, 141, 42);
INSERT INTO 'devicecapvalue' VALUES (6595, 155, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (6596, 155, 118, 612);
INSERT INTO 'devicecapvalue' VALUES (6597, 155, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (6598, 155, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (6599, 155, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (6600, 155, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (6601, 155, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (6602, 155, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (6603, 155, 125, 13);
INSERT INTO 'devicecapvalue' VALUES (6604, 155, 126, 612);
INSERT INTO 'cap' VALUES (142, 'property.camera.orientations', 1);
INSERT INTO 'capvalue' VALUES (941, 'devcam1:inwards');
INSERT INTO 'devicecapvalue' VALUES (6605, 155, 142, 941);
INSERT INTO 'cap' VALUES (143, 'property.camera.resolutions', 1);
INSERT INTO 'capvalue' VALUES (942, 'devcam1:176x144');
INSERT INTO 'devicecapvalue' VALUES (6606, 155, 143, 942);
INSERT INTO 'devicecapvalue' VALUES (6607, 155, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (6608, 155, 101, 913);
INSERT INTO 'capvalue' VALUES (943, 'Card');
INSERT INTO 'devicecapvalue' VALUES (6609, 155, 102, 943);
INSERT INTO 'devicecapvalue' VALUES (6610, 155, 103, 915);
INSERT INTO 'capvalue' VALUES (944, 'Images');
INSERT INTO 'devicecapvalue' VALUES (6611, 155, 104, 944);
INSERT INTO 'devicecapvalue' VALUES (6612, 155, 105, 917);
INSERT INTO 'devicecapvalue' VALUES (6613, 155, 106, 918);
INSERT INTO 'capvalue' VALUES (945, 'Sounds');
INSERT INTO 'devicecapvalue' VALUES (6614, 155, 107, 945);
INSERT INTO 'devicecapvalue' VALUES (6615, 155, 108, 919);
INSERT INTO 'capvalue' VALUES (946, 'Videos');
INSERT INTO 'devicecapvalue' VALUES (6616, 155, 109, 946);
INSERT INTO 'cap' VALUES (144, 'property.microedition.amms.version', 1);
INSERT INTO 'devicecapvalue' VALUES (6617, 155, 144, 242);
INSERT INTO 'devicecapvalue' VALUES (6618, 155, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (6619, 155, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (6620, 155, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (6621, 155, 62, 874);
INSERT INTO 'cap' VALUES (145, 'property.microedition.global.version', 1);
INSERT INTO 'devicecapvalue' VALUES (6622, 155, 145, 45);
INSERT INTO 'devicecapvalue' VALUES (6623, 155, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (6624, 155, 64, 45);
INSERT INTO 'cap' VALUES (146, 'property.microedition.location.version', 1);
INSERT INTO 'devicecapvalue' VALUES (6625, 155, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (6626, 155, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (6627, 155, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (6628, 155, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (6629, 155, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (6630, 155, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (6631, 155, 131, 45);
INSERT INTO 'devicecapvalue' VALUES (6632, 155, 67, 45);
INSERT INTO 'capvalue' VALUES (947, 'LG/KC910/V10a');
INSERT INTO 'devicecapvalue' VALUES (6633, 155, 68, 947);
INSERT INTO 'devicecapvalue' VALUES (6634, 155, 69, 924);
INSERT INTO 'cap' VALUES (147, 'property.microedition.sensor.version', 1);
INSERT INTO 'devicecapvalue' VALUES (6635, 155, 147, 242);
INSERT INTO 'cap' VALUES (148, 'property.microedition.sip.version', 1);
INSERT INTO 'capvalue' VALUES (948, '1.1.0');
INSERT INTO 'devicecapvalue' VALUES (6636, 155, 148, 948);
INSERT INTO 'devicecapvalue' VALUES (6637, 155, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (6638, 155, 132, 911);
INSERT INTO 'devicecapvalue' VALUES (6639, 155, 133, 891);
INSERT INTO 'devicecapvalue' VALUES (6640, 155, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (6641, 155, 86, 15);
INSERT INTO 'cap' VALUES (149, 'property.supports.mediacapabilities', 1);
INSERT INTO 'capvalue' VALUES (949, 'camera');
INSERT INTO 'devicecapvalue' VALUES (6642, 155, 149, 949);
INSERT INTO 'devicecapvalue' VALUES (6643, 155, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (6644, 155, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (6645, 155, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (6646, 155, 136, 891);
INSERT INTO 'devicecapvalue' VALUES (6647, 155, 137, 18);
INSERT INTO 'capvalue' VALUES (950, 'http://mmsc.mms.vodafone.nl');
INSERT INTO 'devicecapvalue' VALUES (6648, 155, 138, 950);
INSERT INTO 'capvalue' VALUES (951, '+316540881000');
INSERT INTO 'devicecapvalue' VALUES (6649, 155, 72, 951);
INSERT INTO 'devicecapvalue' VALUES (6650, 155, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (6651, 155, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (6652, 155, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (6653, 155, 47, 882);
INSERT INTO 'devicecapvalue' VALUES (6654, 155, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (6655, 155, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (6656, 155, 47, 881);
INSERT INTO 'devicecapvalue' VALUES (6657, 155, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (6658, 155, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (6659, 155, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (6660, 155, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (6661, 155, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (6662, 155, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (6663, 155, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (6664, 155, 47, 887);
INSERT INTO 'devicecapvalue' VALUES (6665, 155, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (6666, 155, 47, 889);
INSERT INTO 'devicecapvalue' VALUES (6667, 155, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (6668, 155, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (6669, 155, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (6670, 155, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (6671, 155, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (6672, 155, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (6673, 155, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (6674, 155, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (6675, 155, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (6676, 155, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (6677, 155, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (6678, 155, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (6679, 155, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (6680, 155, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (6681, 155, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (6682, 155, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (6683, 155, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (6684, 155, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (6685, 155, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (6686, 155, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (6687, 155, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (6688, 155, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (6689, 155, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (6690, 155, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (6691, 155, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (6692, 155, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (6693, 155, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (6694, 155, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (6695, 155, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (6696, 155, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (6697, 155, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (6698, 155, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (6699, 155, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (6700, 155, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (6701, 155, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (6702, 155, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (6703, 155, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (6704, 155, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (6705, 155, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (6706, 155, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (6707, 155, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (6708, 155, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (6709, 155, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (6710, 155, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (6711, 155, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (6712, 155, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (6713, 155, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (6714, 155, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (6715, 155, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (6716, 155, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (6717, 155, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (6718, 155, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (6719, 155, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (6720, 155, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (6721, 155, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (6722, 155, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (6723, 155, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (6724, 155, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (6725, 155, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (6726, 155, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (6727, 155, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (6728, 155, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (6729, 155, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (6730, 155, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (6731, 155, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (6732, 155, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (6733, 155, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (6734, 155, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (6735, 155, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (6736, 155, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (6737, 155, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (6738, 155, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (6739, 155, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (6740, 155, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (6741, 155, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (6742, 155, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (6743, 155, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (6744, 155, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (6745, 155, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (6746, 155, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (6747, 155, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (6748, 155, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (6749, 155, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (6750, 155, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (6751, 155, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (6752, 155, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (6753, 155, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (6754, 155, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (6755, 155, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (6756, 155, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (6757, 155, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (6758, 155, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (6759, 155, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (6760, 155, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (6761, 155, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (6762, 155, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (6763, 155, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (6764, 155, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (6765, 155, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (6766, 155, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (6767, 155, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (6768, 155, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (6769, 155, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (6770, 155, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (6771, 155, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (6772, 155, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (6773, 155, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (6774, 155, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (6775, 155, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (6776, 155, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (6777, 155, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (6778, 155, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (6779, 155, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (6780, 155, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (6781, 155, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (6782, 155, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (6783, 155, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (6784, 155, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (6785, 155, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (6786, 155, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (6787, 155, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (6788, 155, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (6789, 155, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (6790, 155, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (6791, 155, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (6792, 155, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (6793, 155, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (6794, 155, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (6795, 155, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (6796, 155, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (6797, 155, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (6798, 155, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (6799, 155, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (6800, 155, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (6801, 155, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (6802, 155, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (6803, 155, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (6804, 155, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (6805, 155, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (6806, 155, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (6807, 155, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (6808, 155, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (6809, 155, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (6810, 155, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (6811, 155, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (6812, 155, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (6813, 155, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (6814, 155, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (6815, 155, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (6816, 155, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (6817, 155, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (6818, 155, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (6819, 155, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (6820, 155, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (6821, 155, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (6822, 155, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (6823, 155, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (6824, 155, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (6825, 155, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (6826, 155, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (6827, 155, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (6828, 155, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (6829, 155, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (6830, 155, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (6831, 155, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (6832, 155, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (6833, 155, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (6834, 155, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (6835, 155, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (6836, 155, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (6837, 155, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (6838, 155, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (6839, 155, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (6840, 155, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (6841, 155, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (6842, 155, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (6843, 155, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (6844, 155, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (6845, 155, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (6846, 155, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (6847, 155, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (6848, 155, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (6849, 155, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (6850, 155, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (6851, 155, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (6852, 155, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (6853, 155, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (6854, 155, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (6855, 155, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (6856, 155, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (6857, 155, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (6858, 155, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (6859, 155, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (6860, 155, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (6861, 155, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (6862, 155, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (6863, 155, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (6864, 155, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (6865, 155, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (6866, 155, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (6867, 155, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (6868, 155, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (6869, 155, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (6870, 155, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (6871, 155, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (6872, 155, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (6873, 155, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (6874, 155, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (6875, 155, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (6876, 155, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (6877, 155, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (6878, 155, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (6879, 155, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (6880, 155, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (6881, 155, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (6882, 155, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (6883, 155, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (6884, 155, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (6885, 155, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (6886, 155, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (6887, 155, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (6888, 155, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (6889, 155, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (6890, 155, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (6891, 155, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (6892, 155, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (6893, 155, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (6894, 155, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (6895, 155, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (6896, 155, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (6897, 155, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (6898, 155, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (6899, 155, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (6900, 155, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (6901, 155, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (6902, 155, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (6903, 155, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (6904, 155, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (6905, 155, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (6906, 155, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (6907, 155, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (6908, 155, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (6909, 155, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (6910, 155, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (6911, 155, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (6912, 155, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (6913, 155, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (6914, 155, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (6915, 155, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (6916, 155, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (6917, 155, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (6918, 155, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (6919, 155, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (6920, 155, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (6921, 155, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (6922, 155, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (6923, 155, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (6924, 155, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (6925, 155, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (6926, 155, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (6927, 155, 48, 875);
INSERT INTO 'devicecapvalue' VALUES (6928, 155, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (6929, 155, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (6930, 155, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (6931, 155, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (6932, 155, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (6933, 155, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (6934, 155, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (6935, 155, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (6936, 155, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (6937, 155, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (6938, 155, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (6939, 155, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (6940, 155, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (6941, 155, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (6942, 155, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (6943, 155, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (6944, 155, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (6945, 155, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (6946, 155, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (6947, 155, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (6948, 155, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (6949, 155, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (6950, 155, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (6951, 155, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (6952, 155, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (6953, 155, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (6954, 155, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (6955, 155, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (6956, 155, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (6957, 155, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (6958, 155, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (6959, 155, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (6960, 155, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (6961, 155, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (6962, 155, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (6963, 155, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (6964, 155, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (6965, 155, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (6966, 155, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (6967, 155, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (6968, 155, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (6969, 155, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (6970, 155, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (6971, 155, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (6972, 155, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (6973, 155, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (6974, 155, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (6975, 155, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (6976, 155, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (6977, 155, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (6978, 155, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (6979, 155, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (6980, 155, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (6981, 155, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (6982, 155, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (6983, 155, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (6984, 155, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (6985, 155, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (6986, 155, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (6987, 155, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (6988, 155, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (6989, 155, 48, 562);
INSERT INTO 'capvalue' VALUES (952, '6291444');
INSERT INTO 'devicecapvalue' VALUES (6990, 155, 49, 952);
INSERT INTO 'devicecapvalue' VALUES (6991, 156, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (6992, 156, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (6993, 156, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (6994, 156, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (6995, 156, 5, 601);
INSERT INTO 'capvalue' VALUES (953, 'LG-KE970 MIC/1.1.14 MIDP-2.0/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (6996, 156, 53, 953);
INSERT INTO 'devicecapvalue' VALUES (6997, 157, 56, 707);
INSERT INTO 'capvalue' VALUES (954, '240x278');
INSERT INTO 'devicecapvalue' VALUES (6998, 157, 7, 954);
INSERT INTO 'devicecapvalue' VALUES (6999, 157, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (7000, 157, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (7001, 157, 9, 12);
INSERT INTO 'capvalue' VALUES (955, '25');
INSERT INTO 'devicecapvalue' VALUES (7002, 157, 10, 955);
INSERT INTO 'devicecapvalue' VALUES (7003, 157, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (7004, 157, 12, 109);
INSERT INTO 'cap' VALUES (150, 'Frequency', 1);
INSERT INTO 'capvalue' VALUES (956, '1800');
INSERT INTO 'devicecapvalue' VALUES (7005, 157, 150, 956);
INSERT INTO 'capvalue' VALUES (957, '1900');
INSERT INTO 'devicecapvalue' VALUES (7006, 157, 150, 957);
INSERT INTO 'capvalue' VALUES (958, '850');
INSERT INTO 'devicecapvalue' VALUES (7007, 157, 150, 958);
INSERT INTO 'capvalue' VALUES (959, '900');
INSERT INTO 'devicecapvalue' VALUES (7008, 157, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (7009, 157, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (7010, 157, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (7011, 157, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (7012, 157, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (7013, 157, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (7014, 157, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (7015, 157, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (7016, 157, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (7017, 157, 21, 36);
INSERT INTO 'devicecapvalue' VALUES (7018, 157, 22, 40);
INSERT INTO 'devicecapvalue' VALUES (7019, 157, 23, 28);
INSERT INTO 'devicecapvalue' VALUES (7020, 157, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (7021, 157, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (7022, 157, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (7023, 157, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (7024, 157, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (7025, 157, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (7026, 157, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (7027, 157, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (7028, 157, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (7029, 157, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (7030, 157, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (7031, 157, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (7032, 157, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (7033, 157, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (7034, 157, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (7035, 157, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (7036, 157, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (7037, 157, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (7038, 157, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (7039, 157, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (7040, 157, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (7041, 157, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (7042, 157, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (7043, 157, 64, 45);
INSERT INTO 'capvalue' VALUES (960, 'Jbed-FastBCC');
INSERT INTO 'devicecapvalue' VALUES (7044, 157, 68, 960);
INSERT INTO 'devicecapvalue' VALUES (7045, 157, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (7046, 157, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (7047, 157, 48, 90);
INSERT INTO 'capvalue' VALUES (961, '2097088');
INSERT INTO 'devicecapvalue' VALUES (7048, 157, 49, 961);
INSERT INTO 'capvalue' VALUES (962, 'LG-KF300 Obigo/WAP2.0 MIDP-2.0/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (7049, 157, 53, 962);
INSERT INTO 'devicecapvalue' VALUES (7050, 158, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (7051, 158, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (7052, 158, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (7053, 158, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (7054, 158, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (7055, 159, 7, 954);
INSERT INTO 'devicecapvalue' VALUES (7056, 159, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (7057, 159, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (7058, 159, 9, 12);
INSERT INTO 'capvalue' VALUES (963, '26');
INSERT INTO 'devicecapvalue' VALUES (7059, 159, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (7060, 159, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (7061, 159, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (7062, 159, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (7063, 159, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (7064, 159, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (7065, 159, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (7066, 159, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (7067, 159, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (7068, 159, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (7069, 159, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (7070, 159, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (7071, 159, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (7072, 159, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (7073, 159, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (7074, 159, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (7075, 159, 23, 34);
INSERT INTO 'devicecapvalue' VALUES (7076, 159, 24, 33);
INSERT INTO 'devicecapvalue' VALUES (7077, 159, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (7078, 159, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (7079, 159, 28, 28);
INSERT INTO 'devicecapvalue' VALUES (7080, 159, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (7081, 159, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (7082, 159, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (7083, 159, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (7084, 159, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (7085, 159, 40, 55);
INSERT INTO 'capvalue' VALUES (964, 'application/vnd.smaf');
INSERT INTO 'devicecapvalue' VALUES (7086, 159, 41, 964);
INSERT INTO 'capvalue' VALUES (965, 'application/x-smaf');
INSERT INTO 'devicecapvalue' VALUES (7087, 159, 41, 965);
INSERT INTO 'devicecapvalue' VALUES (7088, 159, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (7089, 159, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (7090, 159, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (7091, 159, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (7092, 159, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (7093, 159, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (7094, 159, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (7095, 159, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (7096, 159, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (7097, 159, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (7098, 159, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (7099, 159, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (7100, 159, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (7101, 159, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (7102, 159, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (7103, 159, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (7104, 159, 42, 964);
INSERT INTO 'devicecapvalue' VALUES (7105, 159, 42, 965);
INSERT INTO 'devicecapvalue' VALUES (7106, 159, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (7107, 159, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (7108, 159, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (7109, 159, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (7110, 159, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (7111, 159, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (7112, 159, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (7113, 159, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (7114, 159, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (7115, 159, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (7116, 159, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (7117, 159, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (7118, 159, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (7119, 159, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (7120, 159, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (7121, 159, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (7122, 159, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (7123, 159, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (7124, 159, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (7125, 159, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (7126, 159, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (7127, 159, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (7128, 159, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (7129, 159, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (7130, 159, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (7131, 159, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (7132, 159, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (7133, 159, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (7134, 159, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (7135, 159, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (7136, 159, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (7137, 159, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (7138, 159, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (7139, 159, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (7140, 159, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (7141, 159, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (7142, 159, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (7143, 159, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (7144, 159, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (7145, 159, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (7146, 159, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (7147, 159, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (7148, 159, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (7149, 159, 49, 733);
INSERT INTO 'devicecapvalue' VALUES (7150, 159, 53, 232);
INSERT INTO 'devicecapvalue' VALUES (7151, 160, 7, 954);
INSERT INTO 'devicecapvalue' VALUES (7152, 160, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (7153, 160, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (7154, 160, 9, 603);
INSERT INTO 'devicecapvalue' VALUES (7155, 160, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (7156, 160, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (7157, 160, 12, 106);
INSERT INTO 'capvalue' VALUES (966, '240x302');
INSERT INTO 'devicecapvalue' VALUES (7158, 160, 13, 966);
INSERT INTO 'devicecapvalue' VALUES (7159, 160, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (7160, 160, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (7161, 160, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (7162, 160, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (7163, 160, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (7164, 160, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (7165, 160, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (7166, 160, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (7167, 160, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (7168, 160, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (7169, 160, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (7170, 160, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (7171, 160, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (7172, 160, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (7173, 160, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (7174, 160, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (7175, 160, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (7176, 160, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (7177, 160, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (7178, 160, 18, 860);
INSERT INTO 'devicecapvalue' VALUES (7179, 160, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (7180, 160, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (7181, 160, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (7182, 160, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (7183, 160, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (7184, 160, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (7185, 160, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (7186, 160, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (7187, 160, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (7188, 160, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (7189, 160, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (7190, 160, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (7191, 160, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (7192, 160, 32, 852);
INSERT INTO 'devicecapvalue' VALUES (7193, 160, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (7194, 160, 34, 874);
INSERT INTO 'devicecapvalue' VALUES (7195, 160, 35, 45);
INSERT INTO 'capvalue' VALUES (967, 'LG-KT520/v10a Browser/Obigo-Q05A/3.11 MMS/LG-MMS-V1.0/1.2 Java/ASVM/1.1 Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (7196, 160, 36, 967);
INSERT INTO 'devicecapvalue' VALUES (7197, 160, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (7198, 160, 38, 911);
INSERT INTO 'devicecapvalue' VALUES (7199, 160, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (7200, 160, 39, 50);
INSERT INTO 'devicecapvalue' VALUES (7201, 160, 39, 881);
INSERT INTO 'devicecapvalue' VALUES (7202, 160, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (7203, 160, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (7204, 160, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (7205, 160, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (7206, 160, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (7207, 160, 41, 882);
INSERT INTO 'devicecapvalue' VALUES (7208, 160, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (7209, 160, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (7210, 160, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (7211, 160, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (7212, 160, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (7213, 160, 41, 881);
INSERT INTO 'devicecapvalue' VALUES (7214, 160, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (7215, 160, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (7216, 160, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (7217, 160, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (7218, 160, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (7219, 160, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (7220, 160, 41, 885);
INSERT INTO 'devicecapvalue' VALUES (7221, 160, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (7222, 160, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (7223, 160, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (7224, 160, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (7225, 160, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (7226, 160, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (7227, 160, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (7228, 160, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (7229, 160, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (7230, 160, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (7231, 160, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (7232, 160, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (7233, 160, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (7234, 160, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (7235, 160, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (7236, 160, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (7237, 160, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (7238, 160, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (7239, 160, 41, 887);
INSERT INTO 'devicecapvalue' VALUES (7240, 160, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (7241, 160, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (7242, 160, 41, 889);
INSERT INTO 'devicecapvalue' VALUES (7243, 160, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (7244, 160, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (7245, 160, 42, 882);
INSERT INTO 'devicecapvalue' VALUES (7246, 160, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (7247, 160, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (7248, 160, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (7249, 160, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (7250, 160, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (7251, 160, 42, 881);
INSERT INTO 'devicecapvalue' VALUES (7252, 160, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (7253, 160, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (7254, 160, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (7255, 160, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (7256, 160, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (7257, 160, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (7258, 160, 42, 885);
INSERT INTO 'devicecapvalue' VALUES (7259, 160, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (7260, 160, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (7261, 160, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (7262, 160, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (7263, 160, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (7264, 160, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (7265, 160, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (7266, 160, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (7267, 160, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (7268, 160, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (7269, 160, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (7270, 160, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (7271, 160, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (7272, 160, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (7273, 160, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (7274, 160, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (7275, 160, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (7276, 160, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (7277, 160, 42, 887);
INSERT INTO 'devicecapvalue' VALUES (7278, 160, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (7279, 160, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (7280, 160, 42, 889);
INSERT INTO 'devicecapvalue' VALUES (7281, 160, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (7282, 160, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (7283, 160, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (7284, 160, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (7285, 160, 45, 891);
INSERT INTO 'devicecapvalue' VALUES (7286, 160, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (7287, 160, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (7288, 160, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (7289, 160, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (7290, 160, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (7291, 160, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (7292, 160, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (7293, 160, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (7294, 160, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (7295, 160, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (7296, 160, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (7297, 160, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (7298, 160, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (7299, 160, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (7300, 160, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (7301, 160, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (7302, 160, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (7303, 160, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (7304, 160, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (7305, 160, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (7306, 160, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (7307, 160, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (7308, 160, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (7309, 160, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (7310, 160, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (7311, 160, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (7312, 160, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (7313, 160, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (7314, 160, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (7315, 160, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (7316, 160, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (7317, 160, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (7318, 160, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (7319, 160, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (7320, 160, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (7321, 160, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (7322, 160, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (7323, 160, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (7324, 160, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (7325, 160, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (7326, 160, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (7327, 160, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (7328, 160, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (7329, 160, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (7330, 160, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (7331, 160, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (7332, 160, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (7333, 160, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (7334, 160, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (7335, 160, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (7336, 160, 47, 882);
INSERT INTO 'devicecapvalue' VALUES (7337, 160, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (7338, 160, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (7339, 160, 47, 881);
INSERT INTO 'devicecapvalue' VALUES (7340, 160, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (7341, 160, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (7342, 160, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (7343, 160, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (7344, 160, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (7345, 160, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (7346, 160, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (7347, 160, 47, 887);
INSERT INTO 'devicecapvalue' VALUES (7348, 160, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (7349, 160, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (7350, 160, 47, 889);
INSERT INTO 'devicecapvalue' VALUES (7351, 160, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (7352, 160, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (7353, 160, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (7354, 160, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (7355, 160, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (7356, 160, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (7357, 160, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (7358, 160, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (7359, 160, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (7360, 160, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (7361, 160, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (7362, 160, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (7363, 160, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (7364, 160, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (7365, 160, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (7366, 160, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (7367, 160, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (7368, 160, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (7369, 160, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (7370, 160, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (7371, 160, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (7372, 160, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (7373, 160, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (7374, 160, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (7375, 160, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (7376, 160, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (7377, 160, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (7378, 160, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (7379, 160, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (7380, 160, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (7381, 160, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (7382, 160, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (7383, 160, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (7384, 160, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (7385, 160, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (7386, 160, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (7387, 160, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (7388, 160, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (7389, 160, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (7390, 160, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (7391, 160, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (7392, 160, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (7393, 160, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (7394, 160, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (7395, 160, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (7396, 160, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (7397, 160, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (7398, 160, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (7399, 160, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (7400, 160, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (7401, 160, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (7402, 160, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (7403, 160, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (7404, 160, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (7405, 160, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (7406, 160, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (7407, 160, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (7408, 160, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (7409, 160, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (7410, 160, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (7411, 160, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (7412, 160, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (7413, 160, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (7414, 160, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (7415, 160, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (7416, 160, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (7417, 160, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (7418, 160, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (7419, 160, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (7420, 160, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (7421, 160, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (7422, 160, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (7423, 160, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (7424, 160, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (7425, 160, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (7426, 160, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (7427, 160, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (7428, 160, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (7429, 160, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (7430, 160, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (7431, 160, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (7432, 160, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (7433, 160, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (7434, 160, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (7435, 160, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (7436, 160, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (7437, 160, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (7438, 160, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (7439, 160, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (7440, 160, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (7441, 160, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (7442, 160, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (7443, 160, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (7444, 160, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (7445, 160, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (7446, 160, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (7447, 160, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (7448, 160, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (7449, 160, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (7450, 160, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (7451, 160, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (7452, 160, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (7453, 160, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (7454, 160, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (7455, 160, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (7456, 160, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (7457, 160, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (7458, 160, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (7459, 160, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (7460, 160, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (7461, 160, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (7462, 160, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (7463, 160, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (7464, 160, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (7465, 160, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (7466, 160, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (7467, 160, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (7468, 160, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (7469, 160, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (7470, 160, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (7471, 160, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (7472, 160, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (7473, 160, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (7474, 160, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (7475, 160, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (7476, 160, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (7477, 160, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (7478, 160, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (7479, 160, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (7480, 160, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (7481, 160, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (7482, 160, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (7483, 160, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (7484, 160, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (7485, 160, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (7486, 160, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (7487, 160, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (7488, 160, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (7489, 160, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (7490, 160, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (7491, 160, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (7492, 160, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (7493, 160, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (7494, 160, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (7495, 160, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (7496, 160, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (7497, 160, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (7498, 160, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (7499, 160, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (7500, 160, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (7501, 160, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (7502, 160, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (7503, 160, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (7504, 160, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (7505, 160, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (7506, 160, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (7507, 160, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (7508, 160, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (7509, 160, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (7510, 160, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (7511, 160, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (7512, 160, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (7513, 160, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (7514, 160, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (7515, 160, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (7516, 160, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (7517, 160, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (7518, 160, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (7519, 160, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (7520, 160, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (7521, 160, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (7522, 160, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (7523, 160, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (7524, 160, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (7525, 160, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (7526, 160, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (7527, 160, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (7528, 160, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (7529, 160, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (7530, 160, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (7531, 160, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (7532, 160, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (7533, 160, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (7534, 160, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (7535, 160, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (7536, 160, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (7537, 160, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (7538, 160, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (7539, 160, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (7540, 160, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (7541, 160, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (7542, 160, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (7543, 160, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (7544, 160, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (7545, 160, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (7546, 160, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (7547, 160, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (7548, 160, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (7549, 160, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (7550, 160, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (7551, 160, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (7552, 160, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (7553, 160, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (7554, 160, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (7555, 160, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (7556, 160, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (7557, 160, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (7558, 160, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (7559, 160, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (7560, 160, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (7561, 160, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (7562, 160, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (7563, 160, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (7564, 160, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (7565, 160, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (7566, 160, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (7567, 160, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (7568, 160, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (7569, 160, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (7570, 160, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (7571, 160, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (7572, 160, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (7573, 160, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (7574, 160, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (7575, 160, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (7576, 160, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (7577, 160, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (7578, 160, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (7579, 160, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (7580, 160, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (7581, 160, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (7582, 160, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (7583, 160, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (7584, 160, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (7585, 160, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (7586, 160, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (7587, 160, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (7588, 160, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (7589, 160, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (7590, 160, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (7591, 160, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (7592, 160, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (7593, 160, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (7594, 160, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (7595, 160, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (7596, 160, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (7597, 160, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (7598, 160, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (7599, 160, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (7600, 160, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (7601, 160, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (7602, 160, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (7603, 160, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (7604, 160, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (7605, 160, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (7606, 160, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (7607, 160, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (7608, 160, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (7609, 160, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (7610, 160, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (7611, 160, 48, 875);
INSERT INTO 'devicecapvalue' VALUES (7612, 160, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (7613, 160, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (7614, 160, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (7615, 160, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (7616, 160, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (7617, 160, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (7618, 160, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (7619, 160, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (7620, 160, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (7621, 160, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (7622, 160, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (7623, 160, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (7624, 160, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (7625, 160, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (7626, 160, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (7627, 160, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (7628, 160, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (7629, 160, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (7630, 160, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (7631, 160, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (7632, 160, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (7633, 160, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (7634, 160, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (7635, 160, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (7636, 160, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (7637, 160, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (7638, 160, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (7639, 160, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (7640, 160, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (7641, 160, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (7642, 160, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (7643, 160, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (7644, 160, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (7645, 160, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (7646, 160, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (7647, 160, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (7648, 160, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (7649, 160, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (7650, 160, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (7651, 160, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (7652, 160, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (7653, 160, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (7654, 160, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (7655, 160, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (7656, 160, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (7657, 160, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (7658, 160, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (7659, 160, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (7660, 160, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (7661, 160, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (7662, 160, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (7663, 160, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (7664, 160, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (7665, 160, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (7666, 160, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (7667, 160, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (7668, 160, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (7669, 160, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (7670, 160, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (7671, 160, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (7672, 160, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (7673, 160, 48, 562);
INSERT INTO 'capvalue' VALUES (968, '3094528');
INSERT INTO 'devicecapvalue' VALUES (7674, 160, 49, 968);
INSERT INTO 'devicecapvalue' VALUES (7675, 160, 53, 967);
INSERT INTO 'devicecapvalue' VALUES (7676, 161, 56, 707);
INSERT INTO 'capvalue' VALUES (969, '176x188');
INSERT INTO 'devicecapvalue' VALUES (7677, 161, 7, 969);
INSERT INTO 'devicecapvalue' VALUES (7678, 161, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (7679, 161, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (7680, 161, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (7681, 161, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (7682, 161, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (7683, 161, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (7684, 161, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (7685, 161, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (7686, 161, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (7687, 161, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (7688, 161, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (7689, 161, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (7690, 161, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (7691, 161, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (7692, 161, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (7693, 161, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (7694, 161, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (7695, 161, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (7696, 161, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (7697, 161, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (7698, 161, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (7699, 161, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (7700, 161, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (7701, 161, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (7702, 161, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (7703, 161, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (7704, 161, 27, 745);
INSERT INTO 'devicecapvalue' VALUES (7705, 161, 57, 237);
INSERT INTO 'devicecapvalue' VALUES (7706, 161, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (7707, 161, 30, 745);
INSERT INTO 'devicecapvalue' VALUES (7708, 161, 54, 237);
INSERT INTO 'devicecapvalue' VALUES (7709, 161, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (7710, 161, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (7711, 161, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (7712, 161, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (7713, 161, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (7714, 161, 41, 882);
INSERT INTO 'devicecapvalue' VALUES (7715, 161, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (7716, 161, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (7717, 161, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (7718, 161, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (7719, 161, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (7720, 161, 41, 881);
INSERT INTO 'devicecapvalue' VALUES (7721, 161, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (7722, 161, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (7723, 161, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (7724, 161, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (7725, 161, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (7726, 161, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (7727, 161, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (7728, 161, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (7729, 161, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (7730, 161, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (7731, 161, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (7732, 161, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (7733, 161, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (7734, 161, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (7735, 161, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (7736, 161, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (7737, 161, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (7738, 161, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (7739, 161, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (7740, 161, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (7741, 161, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (7742, 161, 41, 889);
INSERT INTO 'devicecapvalue' VALUES (7743, 161, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (7744, 161, 42, 882);
INSERT INTO 'devicecapvalue' VALUES (7745, 161, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (7746, 161, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (7747, 161, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (7748, 161, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (7749, 161, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (7750, 161, 42, 881);
INSERT INTO 'devicecapvalue' VALUES (7751, 161, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (7752, 161, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (7753, 161, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (7754, 161, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (7755, 161, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (7756, 161, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (7757, 161, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (7758, 161, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (7759, 161, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (7760, 161, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (7761, 161, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (7762, 161, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (7763, 161, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (7764, 161, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (7765, 161, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (7766, 161, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (7767, 161, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (7768, 161, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (7769, 161, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (7770, 161, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (7771, 161, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (7772, 161, 42, 889);
INSERT INTO 'devicecapvalue' VALUES (7773, 161, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (7774, 161, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (7775, 161, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (7776, 161, 45, 891);
INSERT INTO 'devicecapvalue' VALUES (7777, 161, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (7778, 161, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (7779, 161, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (7780, 161, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (7781, 161, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (7782, 161, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (7783, 161, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (7784, 161, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (7785, 161, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (7786, 161, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (7787, 161, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (7788, 161, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (7789, 161, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (7790, 161, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (7791, 161, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (7792, 161, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (7793, 161, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (7794, 161, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (7795, 161, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (7796, 161, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (7797, 161, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (7798, 161, 62, 874);
INSERT INTO 'devicecapvalue' VALUES (7799, 161, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (7800, 161, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (7801, 161, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (7802, 161, 67, 45);
INSERT INTO 'capvalue' VALUES (970, 'LG/KU830/v1.0');
INSERT INTO 'devicecapvalue' VALUES (7803, 161, 68, 970);
INSERT INTO 'devicecapvalue' VALUES (7804, 161, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (7805, 161, 133, 891);
INSERT INTO 'devicecapvalue' VALUES (7806, 161, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (7807, 161, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (7808, 161, 136, 891);
INSERT INTO 'devicecapvalue' VALUES (7809, 161, 137, 18);
INSERT INTO 'capvalue' VALUES (971, '+6281100000');
INSERT INTO 'devicecapvalue' VALUES (7810, 161, 72, 971);
INSERT INTO 'devicecapvalue' VALUES (7811, 161, 47, 882);
INSERT INTO 'devicecapvalue' VALUES (7812, 161, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (7813, 161, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (7814, 161, 47, 881);
INSERT INTO 'devicecapvalue' VALUES (7815, 161, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (7816, 161, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (7817, 161, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (7818, 161, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (7819, 161, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (7820, 161, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (7821, 161, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (7822, 161, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (7823, 161, 47, 889);
INSERT INTO 'devicecapvalue' VALUES (7824, 161, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (7825, 161, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (7826, 161, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (7827, 161, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (7828, 161, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (7829, 161, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (7830, 161, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (7831, 161, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (7832, 161, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (7833, 161, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (7834, 161, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (7835, 161, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (7836, 161, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (7837, 161, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (7838, 161, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (7839, 161, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (7840, 161, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (7841, 161, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (7842, 161, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (7843, 161, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (7844, 161, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (7845, 161, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (7846, 161, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (7847, 161, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (7848, 161, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (7849, 161, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (7850, 161, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (7851, 161, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (7852, 161, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (7853, 161, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (7854, 161, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (7855, 161, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (7856, 161, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (7857, 161, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (7858, 161, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (7859, 161, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (7860, 161, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (7861, 161, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (7862, 161, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (7863, 161, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (7864, 161, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (7865, 161, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (7866, 161, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (7867, 161, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (7868, 161, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (7869, 161, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (7870, 161, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (7871, 161, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (7872, 161, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (7873, 161, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (7874, 161, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (7875, 161, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (7876, 161, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (7877, 161, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (7878, 161, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (7879, 161, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (7880, 161, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (7881, 161, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (7882, 161, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (7883, 161, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (7884, 161, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (7885, 161, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (7886, 161, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (7887, 161, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (7888, 161, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (7889, 161, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (7890, 161, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (7891, 161, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (7892, 161, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (7893, 161, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (7894, 161, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (7895, 161, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (7896, 161, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (7897, 161, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (7898, 161, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (7899, 161, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (7900, 161, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (7901, 161, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (7902, 161, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (7903, 161, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (7904, 161, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (7905, 161, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (7906, 161, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (7907, 161, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (7908, 161, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (7909, 161, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (7910, 161, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (7911, 161, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (7912, 161, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (7913, 161, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (7914, 161, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (7915, 161, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (7916, 161, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (7917, 161, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (7918, 161, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (7919, 161, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (7920, 161, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (7921, 161, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (7922, 161, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (7923, 161, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (7924, 161, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (7925, 161, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (7926, 161, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (7927, 161, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (7928, 161, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (7929, 161, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (7930, 161, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (7931, 161, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (7932, 161, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (7933, 161, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (7934, 161, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (7935, 161, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (7936, 161, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (7937, 161, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (7938, 161, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (7939, 161, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (7940, 161, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (7941, 161, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (7942, 161, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (7943, 161, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (7944, 161, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (7945, 161, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (7946, 161, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (7947, 161, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (7948, 161, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (7949, 161, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (7950, 161, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (7951, 161, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (7952, 161, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (7953, 161, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (7954, 161, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (7955, 161, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (7956, 161, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (7957, 161, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (7958, 161, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (7959, 161, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (7960, 161, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (7961, 161, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (7962, 161, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (7963, 161, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (7964, 161, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (7965, 161, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (7966, 161, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (7967, 161, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (7968, 161, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (7969, 161, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (7970, 161, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (7971, 161, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (7972, 161, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (7973, 161, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (7974, 161, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (7975, 161, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (7976, 161, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (7977, 161, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (7978, 161, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (7979, 161, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (7980, 161, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (7981, 161, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (7982, 161, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (7983, 161, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (7984, 161, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (7985, 161, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (7986, 161, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (7987, 161, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (7988, 161, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (7989, 161, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (7990, 161, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (7991, 161, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (7992, 161, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (7993, 161, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (7994, 161, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (7995, 161, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (7996, 161, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (7997, 161, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (7998, 161, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (7999, 161, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (8000, 161, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (8001, 161, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (8002, 161, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (8003, 161, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (8004, 161, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (8005, 161, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (8006, 161, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (8007, 161, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (8008, 161, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (8009, 161, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (8010, 161, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (8011, 161, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (8012, 161, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (8013, 161, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (8014, 161, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (8015, 161, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (8016, 161, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (8017, 161, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (8018, 161, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (8019, 161, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (8020, 161, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (8021, 161, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (8022, 161, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (8023, 161, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (8024, 161, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (8025, 161, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (8026, 161, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (8027, 161, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (8028, 161, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (8029, 161, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (8030, 161, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (8031, 161, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (8032, 161, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (8033, 161, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (8034, 161, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (8035, 161, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (8036, 161, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (8037, 161, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (8038, 161, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (8039, 161, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (8040, 161, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (8041, 161, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (8042, 161, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (8043, 161, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (8044, 161, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (8045, 161, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (8046, 161, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (8047, 161, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (8048, 161, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (8049, 161, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (8050, 161, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (8051, 161, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (8052, 161, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (8053, 161, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (8054, 161, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (8055, 161, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (8056, 161, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (8057, 161, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (8058, 161, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (8059, 161, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (8060, 161, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (8061, 161, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (8062, 161, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (8063, 161, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (8064, 161, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (8065, 161, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (8066, 161, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (8067, 161, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (8068, 161, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (8069, 161, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (8070, 161, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (8071, 161, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (8072, 161, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (8073, 161, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (8074, 161, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (8075, 161, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (8076, 161, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (8077, 161, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (8078, 161, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (8079, 161, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (8080, 161, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (8081, 161, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (8082, 161, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (8083, 161, 48, 875);
INSERT INTO 'devicecapvalue' VALUES (8084, 161, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (8085, 161, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (8086, 161, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (8087, 161, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (8088, 161, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (8089, 161, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (8090, 161, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (8091, 161, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (8092, 161, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (8093, 161, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (8094, 161, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (8095, 161, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (8096, 161, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (8097, 161, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (8098, 161, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (8099, 161, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (8100, 161, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (8101, 161, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (8102, 161, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (8103, 161, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (8104, 161, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (8105, 161, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (8106, 161, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (8107, 161, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (8108, 161, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (8109, 161, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (8110, 161, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (8111, 161, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (8112, 161, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (8113, 161, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (8114, 161, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (8115, 161, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (8116, 161, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (8117, 161, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (8118, 161, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (8119, 161, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (8120, 161, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (8121, 161, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (8122, 161, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (8123, 161, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (8124, 161, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (8125, 161, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (8126, 161, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (8127, 161, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (8128, 161, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (8129, 161, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (8130, 161, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (8131, 161, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (8132, 161, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (8133, 161, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (8134, 161, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (8135, 161, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (8136, 161, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (8137, 161, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (8138, 161, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (8139, 161, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (8140, 161, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (8141, 161, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (8142, 161, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (8143, 161, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (8144, 161, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (8145, 161, 48, 562);
INSERT INTO 'capvalue' VALUES (972, '2621432');
INSERT INTO 'devicecapvalue' VALUES (8146, 161, 49, 972);
INSERT INTO 'capvalue' VALUES (973, 'LG/KU250/v1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (8147, 161, 53, 973);
INSERT INTO 'devicecapvalue' VALUES (8148, 162, 56, 707);
INSERT INTO 'capvalue' VALUES (974, '240x258');
INSERT INTO 'devicecapvalue' VALUES (8149, 162, 7, 974);
INSERT INTO 'devicecapvalue' VALUES (8150, 162, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (8151, 162, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (8152, 162, 9, 603);
INSERT INTO 'devicecapvalue' VALUES (8153, 162, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (8154, 162, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (8155, 162, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (8156, 162, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (8157, 162, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (8158, 162, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (8159, 162, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (8160, 162, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (8161, 162, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (8162, 162, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (8163, 162, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (8164, 162, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (8165, 162, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (8166, 162, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (8167, 162, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (8168, 162, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (8169, 162, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (8170, 162, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (8171, 162, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (8172, 162, 18, 860);
INSERT INTO 'devicecapvalue' VALUES (8173, 162, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (8174, 162, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (8175, 162, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (8176, 162, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (8177, 162, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (8178, 162, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (8179, 162, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (8180, 162, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (8181, 162, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (8182, 162, 57, 36);
INSERT INTO 'devicecapvalue' VALUES (8183, 162, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (8184, 162, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (8185, 162, 54, 40);
INSERT INTO 'devicecapvalue' VALUES (8186, 162, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (8187, 162, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (8188, 162, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (8189, 162, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (8190, 162, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (8191, 162, 41, 882);
INSERT INTO 'devicecapvalue' VALUES (8192, 162, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (8193, 162, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (8194, 162, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (8195, 162, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (8196, 162, 41, 881);
INSERT INTO 'devicecapvalue' VALUES (8197, 162, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (8198, 162, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (8199, 162, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (8200, 162, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (8201, 162, 41, 885);
INSERT INTO 'devicecapvalue' VALUES (8202, 162, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (8203, 162, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (8204, 162, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (8205, 162, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (8206, 162, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (8207, 162, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (8208, 162, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (8209, 162, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (8210, 162, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (8211, 162, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (8212, 162, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (8213, 162, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (8214, 162, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (8215, 162, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (8216, 162, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (8217, 162, 41, 887);
INSERT INTO 'devicecapvalue' VALUES (8218, 162, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (8219, 162, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (8220, 162, 41, 889);
INSERT INTO 'devicecapvalue' VALUES (8221, 162, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (8222, 162, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (8223, 162, 41, 890);
INSERT INTO 'devicecapvalue' VALUES (8224, 162, 42, 882);
INSERT INTO 'devicecapvalue' VALUES (8225, 162, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (8226, 162, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (8227, 162, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (8228, 162, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (8229, 162, 42, 881);
INSERT INTO 'devicecapvalue' VALUES (8230, 162, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (8231, 162, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (8232, 162, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (8233, 162, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (8234, 162, 42, 885);
INSERT INTO 'devicecapvalue' VALUES (8235, 162, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (8236, 162, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (8237, 162, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (8238, 162, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (8239, 162, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (8240, 162, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (8241, 162, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (8242, 162, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (8243, 162, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (8244, 162, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (8245, 162, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (8246, 162, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (8247, 162, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (8248, 162, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (8249, 162, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (8250, 162, 42, 887);
INSERT INTO 'devicecapvalue' VALUES (8251, 162, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (8252, 162, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (8253, 162, 42, 889);
INSERT INTO 'devicecapvalue' VALUES (8254, 162, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (8255, 162, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (8256, 162, 42, 890);
INSERT INTO 'devicecapvalue' VALUES (8257, 162, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (8258, 162, 44, 15);
INSERT INTO 'capvalue' VALUES (975, '3gp');
INSERT INTO 'devicecapvalue' VALUES (8259, 162, 45, 975);
INSERT INTO 'devicecapvalue' VALUES (8260, 162, 58, 42);
INSERT INTO 'devicecapvalue' VALUES (8261, 162, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (8262, 162, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (8263, 162, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (8264, 162, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (8265, 162, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (8266, 162, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (8267, 162, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (8268, 162, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (8269, 162, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (8270, 162, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (8271, 162, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (8272, 162, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (8273, 162, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (8274, 162, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (8275, 162, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (8276, 162, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (8277, 162, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (8278, 162, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (8279, 162, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (8280, 162, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (8281, 162, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (8282, 162, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (8283, 162, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (8284, 162, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (8285, 162, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (8286, 162, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (8287, 162, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (8288, 162, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (8289, 162, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (8290, 162, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (8291, 162, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (8292, 162, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (8293, 162, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (8294, 162, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (8295, 162, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (8296, 162, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (8297, 162, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (8298, 162, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (8299, 162, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (8300, 162, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (8301, 162, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (8302, 162, 118, 612);
INSERT INTO 'devicecapvalue' VALUES (8303, 162, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (8304, 162, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (8305, 162, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (8306, 162, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (8307, 162, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (8308, 162, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (8309, 162, 125, 13);
INSERT INTO 'devicecapvalue' VALUES (8310, 162, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (8311, 162, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (8312, 162, 101, 913);
INSERT INTO 'devicecapvalue' VALUES (8313, 162, 102, 943);
INSERT INTO 'devicecapvalue' VALUES (8314, 162, 103, 915);
INSERT INTO 'devicecapvalue' VALUES (8315, 162, 104, 944);
INSERT INTO 'devicecapvalue' VALUES (8316, 162, 105, 913);
INSERT INTO 'devicecapvalue' VALUES (8317, 162, 106, 918);
INSERT INTO 'devicecapvalue' VALUES (8318, 162, 107, 945);
INSERT INTO 'devicecapvalue' VALUES (8319, 162, 108, 919);
INSERT INTO 'devicecapvalue' VALUES (8320, 162, 109, 946);
INSERT INTO 'devicecapvalue' VALUES (8321, 162, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (8322, 162, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (8323, 162, 62, 874);
INSERT INTO 'devicecapvalue' VALUES (8324, 162, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (8325, 162, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (8326, 162, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (8327, 162, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (8328, 162, 67, 45);
INSERT INTO 'capvalue' VALUES (976, 'Vodafone/1.0/LG-KU990/V10i SP Java/ASVM/1.0 SP Profile/MIDP-2.0 SP Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (8329, 162, 68, 976);
INSERT INTO 'devicecapvalue' VALUES (8330, 162, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (8331, 162, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (8332, 162, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (8333, 162, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (8334, 162, 136, 891);
INSERT INTO 'devicecapvalue' VALUES (8335, 162, 137, 18);
INSERT INTO 'capvalue' VALUES (977, 'http://mmsc.vodafone.es/servlets/mms');
INSERT INTO 'devicecapvalue' VALUES (8336, 162, 138, 977);
INSERT INTO 'capvalue' VALUES (978, '+34607003110');
INSERT INTO 'devicecapvalue' VALUES (8337, 162, 72, 978);
INSERT INTO 'devicecapvalue' VALUES (8338, 162, 47, 882);
INSERT INTO 'devicecapvalue' VALUES (8339, 162, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (8340, 162, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (8341, 162, 47, 881);
INSERT INTO 'devicecapvalue' VALUES (8342, 162, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (8343, 162, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (8344, 162, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (8345, 162, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (8346, 162, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (8347, 162, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (8348, 162, 47, 887);
INSERT INTO 'devicecapvalue' VALUES (8349, 162, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (8350, 162, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (8351, 162, 47, 889);
INSERT INTO 'devicecapvalue' VALUES (8352, 162, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (8353, 162, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (8354, 162, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (8355, 162, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (8356, 162, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (8357, 162, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (8358, 162, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (8359, 162, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (8360, 162, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (8361, 162, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (8362, 162, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (8363, 162, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (8364, 162, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (8365, 162, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (8366, 162, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (8367, 162, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (8368, 162, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (8369, 162, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (8370, 162, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (8371, 162, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (8372, 162, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (8373, 162, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (8374, 162, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (8375, 162, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (8376, 162, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (8377, 162, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (8378, 162, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (8379, 162, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (8380, 162, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (8381, 162, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (8382, 162, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (8383, 162, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (8384, 162, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (8385, 162, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (8386, 162, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (8387, 162, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (8388, 162, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (8389, 162, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (8390, 162, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (8391, 162, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (8392, 162, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (8393, 162, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (8394, 162, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (8395, 162, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (8396, 162, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (8397, 162, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (8398, 162, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (8399, 162, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (8400, 162, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (8401, 162, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (8402, 162, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (8403, 162, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (8404, 162, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (8405, 162, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (8406, 162, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (8407, 162, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (8408, 162, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (8409, 162, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (8410, 162, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (8411, 162, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (8412, 162, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (8413, 162, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (8414, 162, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (8415, 162, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (8416, 162, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (8417, 162, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (8418, 162, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (8419, 162, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (8420, 162, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (8421, 162, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (8422, 162, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (8423, 162, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (8424, 162, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (8425, 162, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (8426, 162, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (8427, 162, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (8428, 162, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (8429, 162, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (8430, 162, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (8431, 162, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (8432, 162, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (8433, 162, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (8434, 162, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (8435, 162, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (8436, 162, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (8437, 162, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (8438, 162, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (8439, 162, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (8440, 162, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (8441, 162, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (8442, 162, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (8443, 162, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (8444, 162, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (8445, 162, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (8446, 162, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (8447, 162, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (8448, 162, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (8449, 162, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (8450, 162, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (8451, 162, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (8452, 162, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (8453, 162, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (8454, 162, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (8455, 162, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (8456, 162, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (8457, 162, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (8458, 162, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (8459, 162, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (8460, 162, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (8461, 162, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (8462, 162, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (8463, 162, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (8464, 162, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (8465, 162, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (8466, 162, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (8467, 162, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (8468, 162, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (8469, 162, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (8470, 162, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (8471, 162, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (8472, 162, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (8473, 162, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (8474, 162, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (8475, 162, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (8476, 162, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (8477, 162, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (8478, 162, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (8479, 162, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (8480, 162, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (8481, 162, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (8482, 162, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (8483, 162, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (8484, 162, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (8485, 162, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (8486, 162, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (8487, 162, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (8488, 162, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (8489, 162, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (8490, 162, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (8491, 162, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (8492, 162, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (8493, 162, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (8494, 162, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (8495, 162, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (8496, 162, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (8497, 162, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (8498, 162, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (8499, 162, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (8500, 162, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (8501, 162, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (8502, 162, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (8503, 162, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (8504, 162, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (8505, 162, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (8506, 162, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (8507, 162, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (8508, 162, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (8509, 162, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (8510, 162, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (8511, 162, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (8512, 162, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (8513, 162, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (8514, 162, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (8515, 162, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (8516, 162, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (8517, 162, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (8518, 162, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (8519, 162, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (8520, 162, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (8521, 162, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (8522, 162, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (8523, 162, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (8524, 162, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (8525, 162, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (8526, 162, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (8527, 162, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (8528, 162, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (8529, 162, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (8530, 162, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (8531, 162, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (8532, 162, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (8533, 162, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (8534, 162, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (8535, 162, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (8536, 162, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (8537, 162, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (8538, 162, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (8539, 162, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (8540, 162, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (8541, 162, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (8542, 162, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (8543, 162, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (8544, 162, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (8545, 162, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (8546, 162, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (8547, 162, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (8548, 162, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (8549, 162, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (8550, 162, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (8551, 162, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (8552, 162, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (8553, 162, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (8554, 162, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (8555, 162, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (8556, 162, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (8557, 162, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (8558, 162, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (8559, 162, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (8560, 162, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (8561, 162, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (8562, 162, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (8563, 162, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (8564, 162, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (8565, 162, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (8566, 162, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (8567, 162, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (8568, 162, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (8569, 162, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (8570, 162, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (8571, 162, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (8572, 162, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (8573, 162, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (8574, 162, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (8575, 162, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (8576, 162, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (8577, 162, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (8578, 162, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (8579, 162, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (8580, 162, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (8581, 162, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (8582, 162, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (8583, 162, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (8584, 162, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (8585, 162, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (8586, 162, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (8587, 162, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (8588, 162, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (8589, 162, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (8590, 162, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (8591, 162, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (8592, 162, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (8593, 162, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (8594, 162, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (8595, 162, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (8596, 162, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (8597, 162, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (8598, 162, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (8599, 162, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (8600, 162, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (8601, 162, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (8602, 162, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (8603, 162, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (8604, 162, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (8605, 162, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (8606, 162, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (8607, 162, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (8608, 162, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (8609, 162, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (8610, 162, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (8611, 162, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (8612, 162, 48, 875);
INSERT INTO 'devicecapvalue' VALUES (8613, 162, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (8614, 162, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (8615, 162, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (8616, 162, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (8617, 162, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (8618, 162, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (8619, 162, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (8620, 162, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (8621, 162, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (8622, 162, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (8623, 162, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (8624, 162, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (8625, 162, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (8626, 162, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (8627, 162, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (8628, 162, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (8629, 162, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (8630, 162, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (8631, 162, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (8632, 162, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (8633, 162, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (8634, 162, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (8635, 162, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (8636, 162, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (8637, 162, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (8638, 162, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (8639, 162, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (8640, 162, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (8641, 162, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (8642, 162, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (8643, 162, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (8644, 162, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (8645, 162, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (8646, 162, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (8647, 162, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (8648, 162, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (8649, 162, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (8650, 162, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (8651, 162, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (8652, 162, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (8653, 162, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (8654, 162, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (8655, 162, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (8656, 162, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (8657, 162, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (8658, 162, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (8659, 162, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (8660, 162, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (8661, 162, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (8662, 162, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (8663, 162, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (8664, 162, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (8665, 162, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (8666, 162, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (8667, 162, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (8668, 162, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (8669, 162, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (8670, 162, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (8671, 162, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (8672, 162, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (8673, 162, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (8674, 162, 48, 562);
INSERT INTO 'capvalue' VALUES (979, '5242868');
INSERT INTO 'devicecapvalue' VALUES (8675, 162, 49, 979);
INSERT INTO 'capvalue' VALUES (980, 'Mozilla/5.0 (Windows; U; Windows NT 6.0; es-ES; rv:1.9.0.4) Gecko/2008102920 Firefox/3.0.4');
INSERT INTO 'devicecapvalue' VALUES (8676, 162, 53, 980);
INSERT INTO 'devicecapvalue' VALUES (8677, 163, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (8678, 163, 7, 974);
INSERT INTO 'devicecapvalue' VALUES (8679, 163, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (8680, 163, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (8681, 163, 9, 603);
INSERT INTO 'devicecapvalue' VALUES (8682, 163, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (8683, 163, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (8684, 163, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (8685, 163, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (8686, 163, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (8687, 163, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (8688, 163, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (8689, 163, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (8690, 163, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (8691, 163, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (8692, 163, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (8693, 163, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (8694, 163, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (8695, 163, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (8696, 163, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (8697, 163, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (8698, 163, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (8699, 163, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (8700, 163, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (8701, 163, 18, 860);
INSERT INTO 'devicecapvalue' VALUES (8702, 163, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (8703, 163, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (8704, 163, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (8705, 163, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (8706, 163, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (8707, 163, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (8708, 163, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (8709, 163, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (8710, 163, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (8711, 163, 57, 36);
INSERT INTO 'devicecapvalue' VALUES (8712, 163, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (8713, 163, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (8714, 163, 54, 40);
INSERT INTO 'devicecapvalue' VALUES (8715, 163, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (8716, 163, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (8717, 163, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (8718, 163, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (8719, 163, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (8720, 163, 41, 882);
INSERT INTO 'devicecapvalue' VALUES (8721, 163, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (8722, 163, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (8723, 163, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (8724, 163, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (8725, 163, 41, 881);
INSERT INTO 'devicecapvalue' VALUES (8726, 163, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (8727, 163, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (8728, 163, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (8729, 163, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (8730, 163, 41, 885);
INSERT INTO 'devicecapvalue' VALUES (8731, 163, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (8732, 163, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (8733, 163, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (8734, 163, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (8735, 163, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (8736, 163, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (8737, 163, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (8738, 163, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (8739, 163, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (8740, 163, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (8741, 163, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (8742, 163, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (8743, 163, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (8744, 163, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (8745, 163, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (8746, 163, 41, 887);
INSERT INTO 'devicecapvalue' VALUES (8747, 163, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (8748, 163, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (8749, 163, 41, 889);
INSERT INTO 'devicecapvalue' VALUES (8750, 163, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (8751, 163, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (8752, 163, 41, 890);
INSERT INTO 'devicecapvalue' VALUES (8753, 163, 42, 882);
INSERT INTO 'devicecapvalue' VALUES (8754, 163, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (8755, 163, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (8756, 163, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (8757, 163, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (8758, 163, 42, 881);
INSERT INTO 'devicecapvalue' VALUES (8759, 163, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (8760, 163, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (8761, 163, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (8762, 163, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (8763, 163, 42, 885);
INSERT INTO 'devicecapvalue' VALUES (8764, 163, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (8765, 163, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (8766, 163, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (8767, 163, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (8768, 163, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (8769, 163, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (8770, 163, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (8771, 163, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (8772, 163, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (8773, 163, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (8774, 163, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (8775, 163, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (8776, 163, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (8777, 163, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (8778, 163, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (8779, 163, 42, 887);
INSERT INTO 'devicecapvalue' VALUES (8780, 163, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (8781, 163, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (8782, 163, 42, 889);
INSERT INTO 'devicecapvalue' VALUES (8783, 163, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (8784, 163, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (8785, 163, 42, 890);
INSERT INTO 'devicecapvalue' VALUES (8786, 163, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (8787, 163, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (8788, 163, 45, 975);
INSERT INTO 'devicecapvalue' VALUES (8789, 163, 58, 42);
INSERT INTO 'devicecapvalue' VALUES (8790, 163, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (8791, 163, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (8792, 163, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (8793, 163, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (8794, 163, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (8795, 163, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (8796, 163, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (8797, 163, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (8798, 163, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (8799, 163, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (8800, 163, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (8801, 163, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (8802, 163, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (8803, 163, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (8804, 163, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (8805, 163, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (8806, 163, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (8807, 163, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (8808, 163, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (8809, 163, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (8810, 163, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (8811, 163, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (8812, 163, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (8813, 163, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (8814, 163, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (8815, 163, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (8816, 163, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (8817, 163, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (8818, 163, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (8819, 163, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (8820, 163, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (8821, 163, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (8822, 163, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (8823, 163, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (8824, 163, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (8825, 163, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (8826, 163, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (8827, 163, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (8828, 163, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (8829, 163, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (8830, 163, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (8831, 163, 118, 612);
INSERT INTO 'devicecapvalue' VALUES (8832, 163, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (8833, 163, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (8834, 163, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (8835, 163, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (8836, 163, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (8837, 163, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (8838, 163, 125, 13);
INSERT INTO 'devicecapvalue' VALUES (8839, 163, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (8840, 163, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (8841, 163, 101, 913);
INSERT INTO 'devicecapvalue' VALUES (8842, 163, 102, 943);
INSERT INTO 'devicecapvalue' VALUES (8843, 163, 103, 915);
INSERT INTO 'devicecapvalue' VALUES (8844, 163, 104, 944);
INSERT INTO 'devicecapvalue' VALUES (8845, 163, 105, 913);
INSERT INTO 'devicecapvalue' VALUES (8846, 163, 106, 918);
INSERT INTO 'devicecapvalue' VALUES (8847, 163, 107, 945);
INSERT INTO 'devicecapvalue' VALUES (8848, 163, 108, 919);
INSERT INTO 'devicecapvalue' VALUES (8849, 163, 109, 946);
INSERT INTO 'devicecapvalue' VALUES (8850, 163, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (8851, 163, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (8852, 163, 62, 874);
INSERT INTO 'devicecapvalue' VALUES (8853, 163, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (8854, 163, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (8855, 163, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (8856, 163, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (8857, 163, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (8858, 163, 68, 976);
INSERT INTO 'devicecapvalue' VALUES (8859, 163, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (8860, 163, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (8861, 163, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (8862, 163, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (8863, 163, 136, 891);
INSERT INTO 'devicecapvalue' VALUES (8864, 163, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (8865, 163, 138, 977);
INSERT INTO 'devicecapvalue' VALUES (8866, 163, 72, 978);
INSERT INTO 'devicecapvalue' VALUES (8867, 163, 47, 882);
INSERT INTO 'devicecapvalue' VALUES (8868, 163, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (8869, 163, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (8870, 163, 47, 881);
INSERT INTO 'devicecapvalue' VALUES (8871, 163, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (8872, 163, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (8873, 163, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (8874, 163, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (8875, 163, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (8876, 163, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (8877, 163, 47, 887);
INSERT INTO 'devicecapvalue' VALUES (8878, 163, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (8879, 163, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (8880, 163, 47, 889);
INSERT INTO 'devicecapvalue' VALUES (8881, 163, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (8882, 163, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (8883, 163, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (8884, 163, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (8885, 163, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (8886, 163, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (8887, 163, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (8888, 163, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (8889, 163, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (8890, 163, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (8891, 163, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (8892, 163, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (8893, 163, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (8894, 163, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (8895, 163, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (8896, 163, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (8897, 163, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (8898, 163, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (8899, 163, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (8900, 163, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (8901, 163, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (8902, 163, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (8903, 163, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (8904, 163, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (8905, 163, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (8906, 163, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (8907, 163, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (8908, 163, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (8909, 163, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (8910, 163, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (8911, 163, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (8912, 163, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (8913, 163, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (8914, 163, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (8915, 163, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (8916, 163, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (8917, 163, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (8918, 163, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (8919, 163, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (8920, 163, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (8921, 163, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (8922, 163, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (8923, 163, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (8924, 163, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (8925, 163, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (8926, 163, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (8927, 163, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (8928, 163, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (8929, 163, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (8930, 163, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (8931, 163, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (8932, 163, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (8933, 163, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (8934, 163, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (8935, 163, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (8936, 163, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (8937, 163, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (8938, 163, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (8939, 163, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (8940, 163, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (8941, 163, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (8942, 163, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (8943, 163, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (8944, 163, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (8945, 163, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (8946, 163, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (8947, 163, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (8948, 163, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (8949, 163, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (8950, 163, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (8951, 163, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (8952, 163, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (8953, 163, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (8954, 163, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (8955, 163, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (8956, 163, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (8957, 163, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (8958, 163, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (8959, 163, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (8960, 163, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (8961, 163, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (8962, 163, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (8963, 163, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (8964, 163, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (8965, 163, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (8966, 163, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (8967, 163, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (8968, 163, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (8969, 163, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (8970, 163, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (8971, 163, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (8972, 163, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (8973, 163, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (8974, 163, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (8975, 163, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (8976, 163, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (8977, 163, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (8978, 163, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (8979, 163, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (8980, 163, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (8981, 163, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (8982, 163, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (8983, 163, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (8984, 163, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (8985, 163, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (8986, 163, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (8987, 163, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (8988, 163, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (8989, 163, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (8990, 163, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (8991, 163, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (8992, 163, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (8993, 163, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (8994, 163, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (8995, 163, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (8996, 163, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (8997, 163, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (8998, 163, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (8999, 163, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (9000, 163, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (9001, 163, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (9002, 163, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (9003, 163, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (9004, 163, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (9005, 163, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (9006, 163, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (9007, 163, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (9008, 163, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (9009, 163, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (9010, 163, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (9011, 163, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (9012, 163, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (9013, 163, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (9014, 163, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (9015, 163, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (9016, 163, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (9017, 163, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (9018, 163, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (9019, 163, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (9020, 163, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (9021, 163, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (9022, 163, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (9023, 163, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (9024, 163, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (9025, 163, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (9026, 163, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (9027, 163, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (9028, 163, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (9029, 163, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (9030, 163, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (9031, 163, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (9032, 163, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (9033, 163, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (9034, 163, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (9035, 163, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (9036, 163, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (9037, 163, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (9038, 163, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (9039, 163, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (9040, 163, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (9041, 163, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (9042, 163, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (9043, 163, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (9044, 163, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (9045, 163, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (9046, 163, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (9047, 163, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (9048, 163, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (9049, 163, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (9050, 163, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (9051, 163, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (9052, 163, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (9053, 163, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (9054, 163, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (9055, 163, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (9056, 163, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (9057, 163, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (9058, 163, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (9059, 163, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (9060, 163, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (9061, 163, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (9062, 163, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (9063, 163, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (9064, 163, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (9065, 163, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (9066, 163, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (9067, 163, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (9068, 163, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (9069, 163, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (9070, 163, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (9071, 163, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (9072, 163, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (9073, 163, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (9074, 163, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (9075, 163, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (9076, 163, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (9077, 163, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (9078, 163, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (9079, 163, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (9080, 163, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (9081, 163, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (9082, 163, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (9083, 163, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (9084, 163, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (9085, 163, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (9086, 163, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (9087, 163, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (9088, 163, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (9089, 163, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (9090, 163, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (9091, 163, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (9092, 163, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (9093, 163, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (9094, 163, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (9095, 163, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (9096, 163, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (9097, 163, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (9098, 163, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (9099, 163, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (9100, 163, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (9101, 163, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (9102, 163, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (9103, 163, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (9104, 163, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (9105, 163, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (9106, 163, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (9107, 163, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (9108, 163, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (9109, 163, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (9110, 163, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (9111, 163, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (9112, 163, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (9113, 163, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (9114, 163, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (9115, 163, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (9116, 163, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (9117, 163, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (9118, 163, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (9119, 163, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (9120, 163, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (9121, 163, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (9122, 163, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (9123, 163, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (9124, 163, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (9125, 163, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (9126, 163, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (9127, 163, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (9128, 163, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (9129, 163, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (9130, 163, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (9131, 163, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (9132, 163, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (9133, 163, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (9134, 163, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (9135, 163, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (9136, 163, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (9137, 163, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (9138, 163, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (9139, 163, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (9140, 163, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (9141, 163, 48, 875);
INSERT INTO 'devicecapvalue' VALUES (9142, 163, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (9143, 163, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (9144, 163, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (9145, 163, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (9146, 163, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (9147, 163, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (9148, 163, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (9149, 163, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (9150, 163, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (9151, 163, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (9152, 163, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (9153, 163, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (9154, 163, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (9155, 163, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (9156, 163, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (9157, 163, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (9158, 163, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (9159, 163, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (9160, 163, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (9161, 163, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (9162, 163, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (9163, 163, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (9164, 163, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (9165, 163, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (9166, 163, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (9167, 163, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (9168, 163, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (9169, 163, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (9170, 163, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (9171, 163, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (9172, 163, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (9173, 163, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (9174, 163, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (9175, 163, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (9176, 163, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (9177, 163, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (9178, 163, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (9179, 163, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (9180, 163, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (9181, 163, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (9182, 163, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (9183, 163, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (9184, 163, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (9185, 163, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (9186, 163, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (9187, 163, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (9188, 163, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (9189, 163, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (9190, 163, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (9191, 163, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (9192, 163, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (9193, 163, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (9194, 163, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (9195, 163, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (9196, 163, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (9197, 163, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (9198, 163, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (9199, 163, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (9200, 163, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (9201, 163, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (9202, 163, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (9203, 163, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (9204, 163, 49, 979);
INSERT INTO 'devicecapvalue' VALUES (9205, 163, 53, 980);
INSERT INTO 'devicecapvalue' VALUES (9206, 164, 7, 837);
INSERT INTO 'devicecapvalue' VALUES (9207, 164, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (9208, 164, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (9209, 164, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (9210, 164, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (9211, 164, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (9212, 164, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (9213, 164, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (9214, 164, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (9215, 164, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (9216, 164, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (9217, 164, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (9218, 164, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (9219, 164, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (9220, 164, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (9221, 164, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (9222, 164, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (9223, 164, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (9224, 164, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (9225, 164, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (9226, 164, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (9227, 164, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (9228, 164, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (9229, 164, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (9230, 164, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (9231, 164, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (9232, 164, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (9233, 164, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (9234, 164, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (9235, 164, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (9236, 164, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (9237, 164, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (9238, 164, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (9239, 164, 26, 117);
INSERT INTO 'capvalue' VALUES (981, '-25');
INSERT INTO 'devicecapvalue' VALUES (9240, 164, 27, 981);
INSERT INTO 'devicecapvalue' VALUES (9241, 164, 28, 30);
INSERT INTO 'devicecapvalue' VALUES (9242, 164, 29, 39);
INSERT INTO 'capvalue' VALUES (982, '-27');
INSERT INTO 'devicecapvalue' VALUES (9243, 164, 30, 982);
INSERT INTO 'devicecapvalue' VALUES (9244, 164, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (9245, 164, 31, 41);
INSERT INTO 'capvalue' VALUES (983, 'USB1');
INSERT INTO 'devicecapvalue' VALUES (9246, 164, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (9247, 164, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (9248, 164, 34, 44);
INSERT INTO 'devicecapvalue' VALUES (9249, 164, 35, 45);
INSERT INTO 'capvalue' VALUES (984, 'Qualcomm0001');
INSERT INTO 'devicecapvalue' VALUES (9250, 164, 36, 984);
INSERT INTO 'devicecapvalue' VALUES (9251, 164, 37, 924);
INSERT INTO 'capvalue' VALUES (985, 'encoding=qcelp');
INSERT INTO 'devicecapvalue' VALUES (9252, 164, 38, 985);
INSERT INTO 'capvalue' VALUES (986, 'audio/qcelp');
INSERT INTO 'devicecapvalue' VALUES (9253, 164, 39, 986);
INSERT INTO 'devicecapvalue' VALUES (9254, 164, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (9255, 164, 41, 56);
INSERT INTO 'capvalue' VALUES (987, 'application/x-pmd');
INSERT INTO 'devicecapvalue' VALUES (9256, 164, 41, 987);
INSERT INTO 'devicecapvalue' VALUES (9257, 164, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (9258, 164, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (9259, 164, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (9260, 164, 41, 986);
INSERT INTO 'devicecapvalue' VALUES (9261, 164, 41, 64);
INSERT INTO 'capvalue' VALUES (988, 'audio/vnd.qcelp');
INSERT INTO 'devicecapvalue' VALUES (9262, 164, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (9263, 164, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (9264, 164, 41, 51);
INSERT INTO 'capvalue' VALUES (989, 'video/x-pmd');
INSERT INTO 'devicecapvalue' VALUES (9265, 164, 41, 989);
INSERT INTO 'devicecapvalue' VALUES (9266, 164, 42, 987);
INSERT INTO 'devicecapvalue' VALUES (9267, 164, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (9268, 164, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (9269, 164, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (9270, 164, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (9271, 164, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (9272, 164, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (9273, 164, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (9274, 164, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (9275, 164, 42, 989);
INSERT INTO 'devicecapvalue' VALUES (9276, 164, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (9277, 164, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (9278, 164, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (9279, 164, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (9280, 164, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (9281, 164, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (9282, 164, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (9283, 164, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (9284, 164, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (9285, 164, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (9286, 164, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (9287, 164, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (9288, 164, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (9289, 164, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (9290, 164, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (9291, 164, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (9292, 164, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (9293, 164, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (9294, 164, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (9295, 164, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (9296, 164, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (9297, 164, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (9298, 164, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (9299, 164, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (9300, 164, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (9301, 164, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (9302, 164, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (9303, 164, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (9304, 164, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (9305, 164, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (9306, 164, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (9307, 164, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (9308, 164, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (9309, 164, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (9310, 164, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (9311, 164, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (9312, 164, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (9313, 164, 46, 83);
INSERT INTO 'capvalue' VALUES (990, 'microedition.satsa.crypto.version');
INSERT INTO 'devicecapvalue' VALUES (9314, 164, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (9315, 164, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (9316, 164, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (9317, 164, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (9318, 164, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (9319, 164, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (9320, 164, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (9321, 164, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (9322, 164, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (9323, 164, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (9324, 164, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (9325, 164, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (9326, 164, 49, 93);
INSERT INTO 'capvalue' VALUES (991, 'POLARIS/6.01 (BREW 3.1.5; U; en-us; LG; LX265; POLARIS/6.01/');
INSERT INTO 'devicecapvalue' VALUES (9327, 164, 53, 991);
INSERT INTO 'devicecapvalue' VALUES (9328, 165, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (9329, 165, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (9330, 165, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (9331, 165, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (9332, 165, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (9333, 165, 53, 953);
INSERT INTO 'devicecapvalue' VALUES (9334, 166, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (9335, 166, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (9336, 166, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (9337, 166, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (9338, 166, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (9339, 166, 53, 862);
INSERT INTO 'capvalue' VALUES (992, 'de.enough.polish.interactivedevicedb.server.persistence.SysinfoCapability@a1e414xde.enough.polish.interactivedevicedb.server.persistence.SysinfoCapability@c92a41');
INSERT INTO 'devicecapvalue' VALUES (9340, 167, 7, 992);
INSERT INTO 'devicecapvalue' VALUES (9341, 167, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (9342, 167, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (9343, 167, 80, 602);
INSERT INTO 'devicecapvalue' VALUES (9344, 167, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (9345, 167, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (9346, 167, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (9347, 167, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (9348, 167, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (9349, 167, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (9350, 167, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (9351, 167, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (9352, 167, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (9353, 167, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (9354, 167, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (9355, 167, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (9356, 167, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (9357, 167, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (9358, 167, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (9359, 167, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (9360, 167, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (9361, 167, 18, 860);
INSERT INTO 'devicecapvalue' VALUES (9362, 167, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (9363, 167, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (9364, 167, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (9365, 167, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (9366, 167, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (9367, 167, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (9368, 167, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (9369, 167, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (9370, 167, 27, 30);
INSERT INTO 'capvalue' VALUES (993, '-19');
INSERT INTO 'devicecapvalue' VALUES (9371, 167, 28, 993);
INSERT INTO 'devicecapvalue' VALUES (9372, 167, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (9373, 167, 30, 40);
INSERT INTO 'cap' VALUES (151, 'key.softkeyselect', 1);
INSERT INTO 'devicecapvalue' VALUES (9374, 167, 151, 30);
INSERT INTO 'devicecapvalue' VALUES (9375, 167, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (9376, 167, 32, 852);
INSERT INTO 'devicecapvalue' VALUES (9377, 167, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (9378, 167, 34, 874);
INSERT INTO 'devicecapvalue' VALUES (9379, 167, 81, 45);
INSERT INTO 'devicecapvalue' VALUES (9380, 167, 35, 45);
INSERT INTO 'cap' VALUES (152, 'microedition.m3g.version', 1);
INSERT INTO 'devicecapvalue' VALUES (9381, 167, 152, 242);
INSERT INTO 'devicecapvalue' VALUES (9382, 167, 83, 242);
INSERT INTO 'devicecapvalue' VALUES (9383, 167, 84, 45);
INSERT INTO 'capvalue' VALUES (994, 'LG/U310/v1.0');
INSERT INTO 'devicecapvalue' VALUES (9384, 167, 36, 994);
INSERT INTO 'devicecapvalue' VALUES (9385, 167, 37, 47);
INSERT INTO 'devicecapvalue' VALUES (9386, 167, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (9387, 167, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (9388, 167, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (9389, 167, 40, 55);
INSERT INTO 'capvalue' VALUES (995, 'application/x-h3g-drm-mma');
INSERT INTO 'devicecapvalue' VALUES (9390, 167, 41, 995);
INSERT INTO 'capvalue' VALUES (996, 'application/x-h3g-drm-mmv');
INSERT INTO 'devicecapvalue' VALUES (9391, 167, 41, 996);
INSERT INTO 'devicecapvalue' VALUES (9392, 167, 41, 882);
INSERT INTO 'devicecapvalue' VALUES (9393, 167, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (9394, 167, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (9395, 167, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (9396, 167, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (9397, 167, 41, 881);
INSERT INTO 'devicecapvalue' VALUES (9398, 167, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (9399, 167, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (9400, 167, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (9401, 167, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (9402, 167, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (9403, 167, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (9404, 167, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (9405, 167, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (9406, 167, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (9407, 167, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (9408, 167, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (9409, 167, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (9410, 167, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (9411, 167, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (9412, 167, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (9413, 167, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (9414, 167, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (9415, 167, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (9416, 167, 42, 995);
INSERT INTO 'devicecapvalue' VALUES (9417, 167, 42, 996);
INSERT INTO 'devicecapvalue' VALUES (9418, 167, 42, 882);
INSERT INTO 'devicecapvalue' VALUES (9419, 167, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (9420, 167, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (9421, 167, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (9422, 167, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (9423, 167, 42, 881);
INSERT INTO 'devicecapvalue' VALUES (9424, 167, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (9425, 167, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (9426, 167, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (9427, 167, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (9428, 167, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (9429, 167, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (9430, 167, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (9431, 167, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (9432, 167, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (9433, 167, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (9434, 167, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (9435, 167, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (9436, 167, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (9437, 167, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (9438, 167, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (9439, 167, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (9440, 167, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (9441, 167, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (9442, 167, 45, 975);
INSERT INTO 'devicecapvalue' VALUES (9443, 167, 47, 996);
INSERT INTO 'devicecapvalue' VALUES (9444, 167, 47, 882);
INSERT INTO 'devicecapvalue' VALUES (9445, 167, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (9446, 167, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (9447, 167, 47, 881);
INSERT INTO 'devicecapvalue' VALUES (9448, 167, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (9449, 167, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (9450, 167, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (9451, 167, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (9452, 167, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (9453, 167, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (9454, 167, 87, 244);
INSERT INTO 'devicecapvalue' VALUES (9455, 167, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (9456, 167, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (9457, 167, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (9458, 167, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (9459, 167, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (9460, 167, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (9461, 167, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (9462, 167, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (9463, 167, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (9464, 167, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (9465, 167, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (9466, 167, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (9467, 167, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (9468, 167, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (9469, 167, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (9470, 167, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (9471, 167, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (9472, 167, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (9473, 167, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (9474, 167, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (9475, 167, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (9476, 167, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (9477, 167, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (9478, 167, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (9479, 167, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (9480, 167, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (9481, 167, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (9482, 167, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (9483, 167, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (9484, 167, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (9485, 167, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (9486, 167, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (9487, 167, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (9488, 167, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (9489, 167, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (9490, 167, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (9491, 167, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (9492, 167, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (9493, 167, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (9494, 167, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (9495, 167, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (9496, 167, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (9497, 167, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (9498, 167, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (9499, 167, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (9500, 167, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (9501, 167, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (9502, 167, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (9503, 167, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (9504, 167, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (9505, 167, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (9506, 167, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (9507, 167, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (9508, 167, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (9509, 167, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (9510, 167, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (9511, 167, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (9512, 167, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (9513, 167, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (9514, 167, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (9515, 167, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (9516, 167, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (9517, 167, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (9518, 167, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (9519, 167, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (9520, 167, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (9521, 167, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (9522, 167, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (9523, 167, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (9524, 167, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (9525, 167, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (9526, 167, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (9527, 167, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (9528, 167, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (9529, 167, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (9530, 167, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (9531, 167, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (9532, 167, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (9533, 167, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (9534, 167, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (9535, 167, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (9536, 167, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (9537, 167, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (9538, 167, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (9539, 167, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (9540, 167, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (9541, 167, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (9542, 167, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (9543, 167, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (9544, 167, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (9545, 167, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (9546, 167, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (9547, 167, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (9548, 167, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (9549, 167, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (9550, 167, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (9551, 167, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (9552, 167, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (9553, 167, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (9554, 167, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (9555, 167, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (9556, 167, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (9557, 167, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (9558, 167, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (9559, 167, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (9560, 167, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (9561, 167, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (9562, 167, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (9563, 167, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (9564, 167, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (9565, 167, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (9566, 167, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (9567, 167, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (9568, 167, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (9569, 167, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (9570, 167, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (9571, 167, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (9572, 167, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (9573, 167, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (9574, 167, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (9575, 167, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (9576, 167, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (9577, 167, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (9578, 167, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (9579, 167, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (9580, 167, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (9581, 167, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (9582, 167, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (9583, 167, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (9584, 167, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (9585, 167, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (9586, 167, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (9587, 167, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (9588, 167, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (9589, 167, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (9590, 167, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (9591, 167, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (9592, 167, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (9593, 167, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (9594, 167, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (9595, 167, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (9596, 167, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (9597, 167, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (9598, 167, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (9599, 167, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (9600, 167, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (9601, 167, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (9602, 167, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (9603, 167, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (9604, 167, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (9605, 167, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (9606, 167, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (9607, 167, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (9608, 167, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (9609, 167, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (9610, 167, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (9611, 167, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (9612, 167, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (9613, 167, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (9614, 167, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (9615, 167, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (9616, 167, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (9617, 167, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (9618, 167, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (9619, 167, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (9620, 167, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (9621, 167, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (9622, 167, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (9623, 167, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (9624, 167, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (9625, 167, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (9626, 167, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (9627, 167, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (9628, 167, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (9629, 167, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (9630, 167, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (9631, 167, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (9632, 167, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (9633, 167, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (9634, 167, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (9635, 167, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (9636, 167, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (9637, 167, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (9638, 167, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (9639, 167, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (9640, 167, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (9641, 167, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (9642, 167, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (9643, 167, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (9644, 167, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (9645, 167, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (9646, 167, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (9647, 167, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (9648, 167, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (9649, 167, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (9650, 167, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (9651, 167, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (9652, 167, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (9653, 167, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (9654, 167, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (9655, 167, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (9656, 167, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (9657, 167, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (9658, 167, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (9659, 167, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (9660, 167, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (9661, 167, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (9662, 167, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (9663, 167, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (9664, 167, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (9665, 167, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (9666, 167, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (9667, 167, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (9668, 167, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (9669, 167, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (9670, 167, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (9671, 167, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (9672, 167, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (9673, 167, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (9674, 167, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (9675, 167, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (9676, 167, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (9677, 167, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (9678, 167, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (9679, 167, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (9680, 167, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (9681, 167, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (9682, 167, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (9683, 167, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (9684, 167, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (9685, 167, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (9686, 167, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (9687, 167, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (9688, 167, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (9689, 167, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (9690, 167, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (9691, 167, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (9692, 167, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (9693, 167, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (9694, 167, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (9695, 167, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (9696, 167, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (9697, 167, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (9698, 167, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (9699, 167, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (9700, 167, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (9701, 167, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (9702, 167, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (9703, 167, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (9704, 167, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (9705, 167, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (9706, 167, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (9707, 167, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (9708, 167, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (9709, 167, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (9710, 167, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (9711, 167, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (9712, 167, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (9713, 167, 48, 875);
INSERT INTO 'devicecapvalue' VALUES (9714, 167, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (9715, 167, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (9716, 167, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (9717, 167, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (9718, 167, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (9719, 167, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (9720, 167, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (9721, 167, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (9722, 167, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (9723, 167, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (9724, 167, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (9725, 167, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (9726, 167, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (9727, 167, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (9728, 167, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (9729, 167, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (9730, 167, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (9731, 167, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (9732, 167, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (9733, 167, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (9734, 167, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (9735, 167, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (9736, 167, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (9737, 167, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (9738, 167, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (9739, 167, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (9740, 167, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (9741, 167, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (9742, 167, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (9743, 167, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (9744, 167, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (9745, 167, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (9746, 167, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (9747, 167, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (9748, 167, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (9749, 167, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (9750, 167, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (9751, 167, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (9752, 167, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (9753, 167, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (9754, 167, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (9755, 167, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (9756, 167, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (9757, 167, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (9758, 167, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (9759, 167, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (9760, 167, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (9761, 167, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (9762, 167, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (9763, 167, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (9764, 167, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (9765, 167, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (9766, 167, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (9767, 167, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (9768, 167, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (9769, 167, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (9770, 167, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (9771, 167, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (9772, 167, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (9773, 167, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (9774, 167, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (9775, 167, 48, 562);
INSERT INTO 'capvalue' VALUES (997, '3145720');
INSERT INTO 'devicecapvalue' VALUES (9776, 167, 49, 997);
INSERT INTO 'capvalue' VALUES (998, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; it; rv:1.8.1.12) Gecko/20080201 Firefox/2.0.0.12');
INSERT INTO 'devicecapvalue' VALUES (9777, 167, 53, 998);
INSERT INTO 'devicecapvalue' VALUES (9778, 168, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (9779, 168, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (9780, 168, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (9781, 168, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (9782, 168, 5, 681);
INSERT INTO 'capvalue' VALUES (999, 'LG-U8138/1.0 (05.02) Profile/MIDP-1.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (9783, 168, 53, 999);
INSERT INTO 'capvalue' VALUES (1000, 'microemu');
INSERT INTO 'devicecapvalue' VALUES (9784, 169, 74, 1000);
INSERT INTO 'devicecapvalue' VALUES (9785, 169, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (9786, 169, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (9787, 169, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (9788, 169, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (9789, 169, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (9790, 170, 1, 1);
INSERT INTO 'capvalue' VALUES (1001, 'hasCamera');
INSERT INTO 'devicecapvalue' VALUES (9791, 170, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (9792, 170, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (9793, 170, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (9794, 170, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (9795, 170, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (9796, 170, 6, 27);
INSERT INTO 'capvalue' VALUES (1002, 'EGSM');
INSERT INTO 'devicecapvalue' VALUES (9797, 170, 88, 1002);
INSERT INTO 'capvalue' VALUES (1003, 'GPRS');
INSERT INTO 'devicecapvalue' VALUES (9798, 170, 88, 1003);
INSERT INTO 'capvalue' VALUES (1004, 'GSM');
INSERT INTO 'devicecapvalue' VALUES (9799, 170, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (9800, 170, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (9801, 170, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (9802, 170, 5, 681);
INSERT INTO 'capvalue' VALUES (1005, '16777216');
INSERT INTO 'devicecapvalue' VALUES (9803, 170, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (9804, 171, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (9805, 171, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (9806, 171, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (9807, 171, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (9808, 171, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (9809, 171, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (9810, 171, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (9811, 172, 1, 606);
INSERT INTO 'devicecapvalue' VALUES (9812, 172, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (9813, 172, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (9814, 172, 17, 22);
INSERT INTO 'capvalue' VALUES (1006, 'moblin v2');
INSERT INTO 'devicecapvalue' VALUES (9815, 172, 3, 1006);
INSERT INTO 'cap' VALUES (153, 'Packager', 1);
INSERT INTO 'capvalue' VALUES (1007, 'deb');
INSERT INTO 'devicecapvalue' VALUES (9816, 172, 153, 1007);
INSERT INTO 'devicecapvalue' VALUES (9817, 172, 4, 4);
INSERT INTO 'capvalue' VALUES (1008, '200');
INSERT INTO 'devicecapvalue' VALUES (9818, 172, 5, 1008);
INSERT INTO 'devicecapvalue' VALUES (9819, 173, 1, 606);
INSERT INTO 'devicecapvalue' VALUES (9820, 173, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (9821, 173, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (9822, 173, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (9823, 173, 3, 1006);
INSERT INTO 'capvalue' VALUES (1009, 'rpm');
INSERT INTO 'devicecapvalue' VALUES (9824, 173, 153, 1009);
INSERT INTO 'devicecapvalue' VALUES (9825, 173, 4, 4);
INSERT INTO 'devicecapvalue' VALUES (9826, 173, 5, 1008);
INSERT INTO 'devicecapvalue' VALUES (9827, 174, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (9828, 174, 74, 654);
INSERT INTO 'capvalue' VALUES (1010, '208x180');
INSERT INTO 'devicecapvalue' VALUES (9829, 174, 7, 1010);
INSERT INTO 'devicecapvalue' VALUES (9830, 174, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (9831, 174, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (9832, 174, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (9833, 174, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (9834, 174, 11, 711);
INSERT INTO 'devicecapvalue' VALUES (9835, 174, 12, 693);
INSERT INTO 'devicecapvalue' VALUES (9836, 174, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (9837, 174, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (9838, 174, 150, 959);
INSERT INTO 'capvalue' VALUES (1011, 'WCDMA 2100');
INSERT INTO 'devicecapvalue' VALUES (9839, 174, 150, 1011);
INSERT INTO 'capvalue' VALUES (1012, '208x320');
INSERT INTO 'devicecapvalue' VALUES (9840, 174, 13, 1012);
INSERT INTO 'devicecapvalue' VALUES (9841, 174, 76, 1005);
INSERT INTO 'devicecapvalue' VALUES (9842, 174, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (9843, 174, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (9844, 174, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (9845, 174, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (9846, 174, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (9847, 174, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (9848, 174, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (9849, 174, 6, 27);
INSERT INTO 'cap' VALUES (154, 'JavaProtocol', 1);
INSERT INTO 'capvalue' VALUES (1013, 'http');
INSERT INTO 'devicecapvalue' VALUES (9850, 174, 154, 1013);
INSERT INTO 'capvalue' VALUES (1014, 'https');
INSERT INTO 'devicecapvalue' VALUES (9851, 174, 154, 1014);
INSERT INTO 'capvalue' VALUES (1015, 'server-socket');
INSERT INTO 'devicecapvalue' VALUES (9852, 174, 154, 1015);
INSERT INTO 'capvalue' VALUES (1016, 'sms');
INSERT INTO 'devicecapvalue' VALUES (9853, 174, 154, 1016);
INSERT INTO 'capvalue' VALUES (1017, 'socket');
INSERT INTO 'devicecapvalue' VALUES (9854, 174, 154, 1017);
INSERT INTO 'capvalue' VALUES (1018, 'udp');
INSERT INTO 'devicecapvalue' VALUES (9855, 174, 154, 1018);
INSERT INTO 'capvalue' VALUES (1019, '25165824');
INSERT INTO 'devicecapvalue' VALUES (9856, 174, 50, 1019);
INSERT INTO 'cap' VALUES (155, 'MaxRecordStoreSize', 1);
INSERT INTO 'capvalue' VALUES (1020, '24 MB');
INSERT INTO 'devicecapvalue' VALUES (9857, 174, 155, 1020);
INSERT INTO 'devicecapvalue' VALUES (9858, 174, 40, 49);
INSERT INTO 'devicecapvalue' VALUES (9859, 174, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (9860, 174, 40, 867);
INSERT INTO 'devicecapvalue' VALUES (9861, 174, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (9862, 174, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (9863, 174, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (9864, 174, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (9865, 174, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (9866, 174, 88, 640);
INSERT INTO 'capvalue' VALUES (1021, 'Symbian 7.0/UIQ 2.1');
INSERT INTO 'devicecapvalue' VALUES (9867, 174, 3, 1021);
INSERT INTO 'cap' VALUES (156, 'Region', 1);
INSERT INTO 'capvalue' VALUES (1022, 'Americas');
INSERT INTO 'devicecapvalue' VALUES (9868, 174, 156, 1022);
INSERT INTO 'capvalue' VALUES (1023, 'Asia-Pacific');
INSERT INTO 'devicecapvalue' VALUES (9869, 174, 156, 1023);
INSERT INTO 'capvalue' VALUES (1024, 'Europe');
INSERT INTO 'devicecapvalue' VALUES (9870, 174, 156, 1024);
INSERT INTO 'capvalue' VALUES (1025, 'Middle-East');
INSERT INTO 'devicecapvalue' VALUES (9871, 174, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (9872, 174, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (9873, 174, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (9874, 174, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (9875, 174, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (9876, 174, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (9877, 174, 52, 1019);
INSERT INTO 'cap' VALUES (157, 'VideoFormat', 1);
INSERT INTO 'capvalue' VALUES (1026, 'mpeg-4');
INSERT INTO 'devicecapvalue' VALUES (9878, 174, 157, 1026);
INSERT INTO 'capvalue' VALUES (1027, 'Mozilla/4.1 (compatible; MSIE 5.0; Symbian OS) Opera 6.0 [es]./MOT-A925./P243');
INSERT INTO 'devicecapvalue' VALUES (9879, 174, 53, 1027);
INSERT INTO 'cap' VALUES (158, 'AnnouncementDate', 1);
INSERT INTO 'capvalue' VALUES (1028, '2007');
INSERT INTO 'devicecapvalue' VALUES (9880, 175, 158, 1028);
INSERT INTO 'devicecapvalue' VALUES (9881, 175, 1, 106);
INSERT INTO 'capvalue' VALUES (1029, 'noTranslucencyWithDrawRgb');
INSERT INTO 'devicecapvalue' VALUES (9882, 175, 74, 1029);
INSERT INTO 'capvalue' VALUES (1030, '240x240');
INSERT INTO 'devicecapvalue' VALUES (9883, 175, 7, 1030);
INSERT INTO 'devicecapvalue' VALUES (9884, 175, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (9885, 175, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (9886, 175, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (9887, 175, 11, 110);
INSERT INTO 'devicecapvalue' VALUES (9888, 175, 12, 603);
INSERT INTO 'devicecapvalue' VALUES (9889, 175, 13, 688);
INSERT INTO 'capvalue' VALUES (1031, '2097152');
INSERT INTO 'devicecapvalue' VALUES (9890, 175, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (9891, 175, 15, 16);
INSERT INTO 'capvalue' VALUES (1032, 'ems');
INSERT INTO 'devicecapvalue' VALUES (9892, 175, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (9893, 175, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (9894, 175, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (9895, 175, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (9896, 175, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (9897, 175, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (9898, 175, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (9899, 175, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (9900, 175, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (9901, 175, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (9902, 175, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (9903, 175, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (9904, 175, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (9905, 175, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (9906, 175, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (9907, 175, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (9908, 175, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (9909, 175, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (9910, 175, 30, 666);
INSERT INTO 'cap' VALUES (159, 'MaxRecordStoreNumber', 1);
INSERT INTO 'devicecapvalue' VALUES (9911, 175, 159, 625);
INSERT INTO 'capvalue' VALUES (1033, '1MB');
INSERT INTO 'devicecapvalue' VALUES (9912, 175, 155, 1033);
INSERT INTO 'capvalue' VALUES (1034, 'Linux');
INSERT INTO 'devicecapvalue' VALUES (9913, 175, 3, 1034);
INSERT INTO 'capvalue' VALUES (1035, 'Global');
INSERT INTO 'devicecapvalue' VALUES (9914, 175, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (9915, 175, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (9916, 175, 5, 601);
INSERT INTO 'capvalue' VALUES (1036, 'aac');
INSERT INTO 'devicecapvalue' VALUES (9917, 175, 51, 1036);
INSERT INTO 'capvalue' VALUES (1037, 'aac+');
INSERT INTO 'devicecapvalue' VALUES (9918, 175, 51, 1037);
INSERT INTO 'capvalue' VALUES (1038, 'enh aac+');
INSERT INTO 'devicecapvalue' VALUES (9919, 175, 51, 1038);
INSERT INTO 'devicecapvalue' VALUES (9920, 175, 51, 102);
INSERT INTO 'capvalue' VALUES (1039, 'mp3');
INSERT INTO 'devicecapvalue' VALUES (9921, 175, 51, 1039);
INSERT INTO 'capvalue' VALUES (1040, 'ra8');
INSERT INTO 'devicecapvalue' VALUES (9922, 175, 51, 1040);
INSERT INTO 'capvalue' VALUES (1041, 'wma');
INSERT INTO 'devicecapvalue' VALUES (9923, 175, 51, 1041);
INSERT INTO 'capvalue' VALUES (1042, 'wma9');
INSERT INTO 'devicecapvalue' VALUES (9924, 175, 51, 1042);
INSERT INTO 'capvalue' VALUES (1043, '536870912');
INSERT INTO 'devicecapvalue' VALUES (9925, 175, 52, 1043);
INSERT INTO 'devicecapvalue' VALUES (9926, 176, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (9927, 176, 7, 742);
INSERT INTO 'devicecapvalue' VALUES (9928, 176, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (9929, 176, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (9930, 176, 9, 1);
INSERT INTO 'devicecapvalue' VALUES (9931, 176, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (9932, 176, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (9933, 176, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (9934, 176, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (9935, 176, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (9936, 176, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (9937, 176, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (9938, 176, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (9939, 176, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (9940, 176, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (9941, 176, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (9942, 176, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (9943, 176, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (9944, 176, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (9945, 176, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (9946, 176, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (9947, 176, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (9948, 176, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (9949, 176, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (9950, 176, 18, 39);
INSERT INTO 'devicecapvalue' VALUES (9951, 176, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (9952, 176, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (9953, 176, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (9954, 176, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (9955, 176, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (9956, 176, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (9957, 176, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (9958, 176, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (9959, 176, 27, 39);
INSERT INTO 'devicecapvalue' VALUES (9960, 176, 57, 39);
INSERT INTO 'devicecapvalue' VALUES (9961, 176, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (9962, 176, 30, 35);
INSERT INTO 'devicecapvalue' VALUES (9963, 176, 54, 29);
INSERT INTO 'devicecapvalue' VALUES (9964, 176, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (9965, 176, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (9966, 176, 41, 58);
INSERT INTO 'capvalue' VALUES (1044, 'audio/aiff');
INSERT INTO 'devicecapvalue' VALUES (9967, 176, 41, 1044);
INSERT INTO 'devicecapvalue' VALUES (9968, 176, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (9969, 176, 41, 50);
INSERT INTO 'capvalue' VALUES (1045, 'audio/au');
INSERT INTO 'devicecapvalue' VALUES (9970, 176, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (9971, 176, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (9972, 176, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (9973, 176, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (9974, 176, 41, 63);
INSERT INTO 'capvalue' VALUES (1046, 'audio/qcp');
INSERT INTO 'devicecapvalue' VALUES (9975, 176, 41, 1046);
INSERT INTO 'devicecapvalue' VALUES (9976, 176, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (9977, 176, 41, 867);
INSERT INTO 'capvalue' VALUES (1047, 'audio/wave');
INSERT INTO 'devicecapvalue' VALUES (9978, 176, 41, 1047);
INSERT INTO 'capvalue' VALUES (1048, 'audio/x-aiff');
INSERT INTO 'devicecapvalue' VALUES (9979, 176, 41, 1048);
INSERT INTO 'capvalue' VALUES (1049, 'audio/x-amr');
INSERT INTO 'devicecapvalue' VALUES (9980, 176, 41, 1049);
INSERT INTO 'capvalue' VALUES (1050, 'audio/x-au');
INSERT INTO 'devicecapvalue' VALUES (9981, 176, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (9982, 176, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (9983, 176, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (9984, 176, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (9985, 176, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (9986, 176, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (9987, 176, 41, 53);
INSERT INTO 'capvalue' VALUES (1051, 'video/3gpp2');
INSERT INTO 'devicecapvalue' VALUES (9988, 176, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (9989, 176, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (9990, 176, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (9991, 176, 42, 1044);
INSERT INTO 'devicecapvalue' VALUES (9992, 176, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (9993, 176, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (9994, 176, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (9995, 176, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (9996, 176, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (9997, 176, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (9998, 176, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (9999, 176, 42, 1046);
INSERT INTO 'devicecapvalue' VALUES (10000, 176, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (10001, 176, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (10002, 176, 42, 1047);
INSERT INTO 'devicecapvalue' VALUES (10003, 176, 42, 1048);
INSERT INTO 'devicecapvalue' VALUES (10004, 176, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (10005, 176, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (10006, 176, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (10007, 176, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (10008, 176, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (10009, 176, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (10010, 176, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (10011, 176, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (10012, 176, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (10013, 176, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (10014, 176, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (10015, 176, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (10016, 176, 58, 238);
INSERT INTO 'devicecapvalue' VALUES (10017, 176, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (10018, 176, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (10019, 176, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (10020, 176, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (10021, 176, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (10022, 176, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (10023, 176, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (10024, 176, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (10025, 176, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (10026, 176, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (10027, 176, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (10028, 176, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (10029, 176, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (10030, 176, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (10031, 176, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (10032, 176, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (10033, 176, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (10034, 176, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (10035, 176, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (10036, 176, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (10037, 176, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (10038, 176, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (10039, 176, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (10040, 176, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (10041, 176, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (10042, 176, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (10043, 176, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (10044, 176, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (10045, 176, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (10046, 176, 117, 242);
INSERT INTO 'capvalue' VALUES (1052, '7');
INSERT INTO 'devicecapvalue' VALUES (10047, 176, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (10048, 176, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (10049, 176, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (10050, 176, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (10051, 176, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (10052, 176, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (10053, 176, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (10054, 176, 125, 13);
INSERT INTO 'devicecapvalue' VALUES (10055, 176, 126, 693);
INSERT INTO 'devicecapvalue' VALUES (10056, 176, 59, 240);
INSERT INTO 'devicecapvalue' VALUES (10057, 176, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (10058, 176, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (10059, 176, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (10060, 176, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (10061, 176, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (10062, 176, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (10063, 176, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (10064, 176, 67, 45);
INSERT INTO 'capvalue' VALUES (1053, 'Aplix JBlend');
INSERT INTO 'devicecapvalue' VALUES (10065, 176, 68, 1053);
INSERT INTO 'devicecapvalue' VALUES (10066, 176, 69, 47);
INSERT INTO 'capvalue' VALUES (1054, '0H');
INSERT INTO 'devicecapvalue' VALUES (10067, 176, 110, 1054);
INSERT INTO 'capvalue' VALUES (1055, '1H');
INSERT INTO 'devicecapvalue' VALUES (10068, 176, 110, 1055);
INSERT INTO 'devicecapvalue' VALUES (10069, 176, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (10070, 176, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (10071, 176, 71, 244);
INSERT INTO 'devicecapvalue' VALUES (10072, 176, 72, 242);
INSERT INTO 'devicecapvalue' VALUES (10073, 176, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (10074, 176, 73, 1044);
INSERT INTO 'devicecapvalue' VALUES (10075, 176, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (10076, 176, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (10077, 176, 73, 1045);
INSERT INTO 'devicecapvalue' VALUES (10078, 176, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (10079, 176, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (10080, 176, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (10081, 176, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (10082, 176, 73, 1046);
INSERT INTO 'devicecapvalue' VALUES (10083, 176, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (10084, 176, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (10085, 176, 73, 1047);
INSERT INTO 'devicecapvalue' VALUES (10086, 176, 73, 1048);
INSERT INTO 'devicecapvalue' VALUES (10087, 176, 73, 1049);
INSERT INTO 'devicecapvalue' VALUES (10088, 176, 73, 1050);
INSERT INTO 'devicecapvalue' VALUES (10089, 176, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (10090, 176, 73, 870);
INSERT INTO 'devicecapvalue' VALUES (10091, 176, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (10092, 176, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (10093, 176, 73, 122);
INSERT INTO 'devicecapvalue' VALUES (10094, 176, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (10095, 176, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (10096, 176, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (10097, 176, 47, 55);
INSERT INTO 'devicecapvalue' VALUES (10098, 176, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (10099, 176, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (10100, 176, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (10101, 176, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (10102, 176, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (10103, 176, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (10104, 176, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (10105, 176, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (10106, 176, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (10107, 176, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (10108, 176, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (10109, 176, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (10110, 176, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (10111, 176, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (10112, 176, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (10113, 176, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (10114, 176, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (10115, 176, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (10116, 176, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (10117, 176, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (10118, 176, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (10119, 176, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (10120, 176, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (10121, 176, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (10122, 176, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (10123, 176, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (10124, 176, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (10125, 176, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (10126, 176, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (10127, 176, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (10128, 176, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (10129, 176, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (10130, 176, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (10131, 176, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (10132, 176, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (10133, 176, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (10134, 176, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (10135, 176, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (10136, 176, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (10137, 176, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (10138, 176, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (10139, 176, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (10140, 176, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (10141, 176, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (10142, 176, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (10143, 176, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (10144, 176, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (10145, 176, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (10146, 176, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (10147, 176, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (10148, 176, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (10149, 176, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (10150, 176, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (10151, 176, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (10152, 176, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (10153, 176, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (10154, 176, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (10155, 176, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (10156, 176, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (10157, 176, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (10158, 176, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (10159, 176, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (10160, 176, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (10161, 176, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (10162, 176, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (10163, 176, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (10164, 176, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (10165, 176, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (10166, 176, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (10167, 176, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (10168, 176, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (10169, 176, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (10170, 176, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (10171, 176, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (10172, 176, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (10173, 176, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (10174, 176, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (10175, 176, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (10176, 176, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (10177, 176, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (10178, 176, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (10179, 176, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (10180, 176, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (10181, 176, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (10182, 176, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (10183, 176, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (10184, 176, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (10185, 176, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (10186, 176, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (10187, 176, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (10188, 176, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (10189, 176, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (10190, 176, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (10191, 176, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (10192, 176, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (10193, 176, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (10194, 176, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (10195, 176, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (10196, 176, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (10197, 176, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (10198, 176, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (10199, 176, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (10200, 176, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (10201, 176, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (10202, 176, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (10203, 176, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (10204, 176, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (10205, 176, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (10206, 176, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (10207, 176, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (10208, 176, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (10209, 176, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (10210, 176, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (10211, 176, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (10212, 176, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (10213, 176, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (10214, 176, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (10215, 176, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (10216, 176, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (10217, 176, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (10218, 176, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (10219, 176, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (10220, 176, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (10221, 176, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (10222, 176, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (10223, 176, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (10224, 176, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (10225, 176, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (10226, 176, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (10227, 176, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (10228, 176, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (10229, 176, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (10230, 176, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (10231, 176, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (10232, 176, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (10233, 176, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (10234, 176, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (10235, 176, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (10236, 176, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (10237, 176, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (10238, 176, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (10239, 176, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (10240, 176, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (10241, 176, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (10242, 176, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (10243, 176, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (10244, 176, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (10245, 176, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (10246, 176, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (10247, 176, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (10248, 176, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (10249, 176, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (10250, 176, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (10251, 176, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (10252, 176, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (10253, 176, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (10254, 176, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (10255, 176, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (10256, 176, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (10257, 176, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (10258, 176, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (10259, 176, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (10260, 176, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (10261, 176, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (10262, 176, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (10263, 176, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (10264, 176, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (10265, 176, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (10266, 176, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (10267, 176, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (10268, 176, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (10269, 176, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (10270, 176, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (10271, 176, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (10272, 176, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (10273, 176, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (10274, 176, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (10275, 176, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (10276, 176, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (10277, 176, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (10278, 176, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (10279, 176, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (10280, 176, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (10281, 176, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (10282, 176, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (10283, 176, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (10284, 176, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (10285, 176, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (10286, 176, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (10287, 176, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (10288, 176, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (10289, 176, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (10290, 176, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (10291, 176, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (10292, 176, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (10293, 176, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (10294, 176, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (10295, 176, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (10296, 176, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (10297, 176, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (10298, 176, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (10299, 176, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (10300, 176, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (10301, 176, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (10302, 176, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (10303, 176, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (10304, 176, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (10305, 176, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (10306, 176, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (10307, 176, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (10308, 176, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (10309, 176, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (10310, 176, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (10311, 176, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (10312, 176, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (10313, 176, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (10314, 176, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (10315, 176, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (10316, 176, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (10317, 176, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (10318, 176, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (10319, 176, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (10320, 176, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (10321, 176, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (10322, 176, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (10323, 176, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (10324, 176, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (10325, 176, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (10326, 176, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (10327, 176, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (10328, 176, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (10329, 176, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (10330, 176, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (10331, 176, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (10332, 176, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (10333, 176, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (10334, 176, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (10335, 176, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (10336, 176, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (10337, 176, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (10338, 176, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (10339, 176, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (10340, 176, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (10341, 176, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (10342, 176, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (10343, 176, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (10344, 176, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (10345, 176, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (10346, 176, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (10347, 176, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (10348, 176, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (10349, 176, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (10350, 176, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (10351, 176, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (10352, 176, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (10353, 176, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (10354, 176, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (10355, 176, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (10356, 176, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (10357, 176, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (10358, 176, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (10359, 176, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (10360, 176, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (10361, 176, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (10362, 176, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (10363, 176, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (10364, 176, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (10365, 176, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (10366, 176, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (10367, 176, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (10368, 176, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (10369, 176, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (10370, 176, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (10371, 176, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (10372, 176, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (10373, 176, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (10374, 176, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (10375, 176, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (10376, 176, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (10377, 176, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (10378, 176, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (10379, 176, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (10380, 176, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (10381, 176, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (10382, 176, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (10383, 176, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (10384, 176, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (10385, 176, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (10386, 176, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (10387, 176, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (10388, 176, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (10389, 176, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (10390, 176, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (10391, 176, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (10392, 176, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (10393, 176, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (10394, 176, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (10395, 176, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (10396, 176, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (10397, 176, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (10398, 176, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (10399, 176, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (10400, 176, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (10401, 176, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (10402, 176, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (10403, 176, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (10404, 176, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (10405, 176, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (10406, 176, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (10407, 176, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (10408, 176, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (10409, 176, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (10410, 176, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (10411, 176, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (10412, 176, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (10413, 176, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (10414, 176, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (10415, 176, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (10416, 176, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (10417, 176, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (10418, 176, 48, 562);
INSERT INTO 'capvalue' VALUES (1056, '5324672');
INSERT INTO 'devicecapvalue' VALUES (10419, 176, 49, 1056);
INSERT INTO 'capvalue' VALUES (1057, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; zh-TW; rv:1.9.0.6) Gecko/2009011913 Firefox/3.0.6');
INSERT INTO 'devicecapvalue' VALUES (10420, 176, 53, 1057);
INSERT INTO 'devicecapvalue' VALUES (10421, 177, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (10422, 177, 74, 1029);
INSERT INTO 'capvalue' VALUES (1058, 'BacklightFlashes');
INSERT INTO 'devicecapvalue' VALUES (10423, 177, 74, 1058);
INSERT INTO 'cap' VALUES (160, 'CameraResolution', 1);
INSERT INTO 'devicecapvalue' VALUES (10424, 177, 160, 856);
INSERT INTO 'capvalue' VALUES (1059, '220x143');
INSERT INTO 'devicecapvalue' VALUES (10425, 177, 7, 1059);
INSERT INTO 'capvalue' VALUES (1060, 'MotorolaEmulatorA1');
INSERT INTO 'devicecapvalue' VALUES (10426, 177, 93, 1060);
INSERT INTO 'capvalue' VALUES (1061, 'A630.props');
INSERT INTO 'devicecapvalue' VALUES (10427, 177, 75, 1061);
INSERT INTO 'devicecapvalue' VALUES (10428, 177, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10429, 177, 2, 1001);
INSERT INTO 'capvalue' VALUES (1062, '220x160');
INSERT INTO 'devicecapvalue' VALUES (10430, 177, 13, 1062);
INSERT INTO 'capvalue' VALUES (1063, '819200');
INSERT INTO 'devicecapvalue' VALUES (10431, 177, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (10432, 177, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10433, 177, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10434, 177, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (10435, 177, 17, 22);
INSERT INTO 'capvalue' VALUES (1064, 'phonebook');
INSERT INTO 'devicecapvalue' VALUES (10436, 177, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (10437, 177, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10438, 177, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10439, 177, 154, 1013);
INSERT INTO 'capvalue' VALUES (1065, 'serial');
INSERT INTO 'devicecapvalue' VALUES (10440, 177, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (10441, 177, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10442, 177, 154, 1018);
INSERT INTO 'capvalue' VALUES (1066, '102400');
INSERT INTO 'devicecapvalue' VALUES (10443, 177, 50, 1066);
INSERT INTO 'capvalue' VALUES (1067, '64 kb');
INSERT INTO 'devicecapvalue' VALUES (10444, 177, 155, 1067);
INSERT INTO 'cap' VALUES (161, 'MaxSockets', 1);
INSERT INTO 'devicecapvalue' VALUES (10445, 177, 161, 238);
INSERT INTO 'capvalue' VALUES (1068, 'Motorola');
INSERT INTO 'devicecapvalue' VALUES (10446, 177, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (10447, 177, 4, 681);
INSERT INTO 'devicecapvalue' VALUES (10448, 177, 5, 679);
INSERT INTO 'devicecapvalue' VALUES (10449, 177, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (10450, 177, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (10451, 177, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (10452, 177, 52, 93);
INSERT INTO 'capvalue' VALUES (1069, 'MOT-A630/0B.83.10I MIB/2.2 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (10453, 177, 53, 1069);
INSERT INTO 'capvalue' VALUES (1070, '2006-12-27');
INSERT INTO 'devicecapvalue' VALUES (10454, 178, 158, 1070);
INSERT INTO 'devicecapvalue' VALUES (10455, 178, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (10456, 178, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (10457, 178, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (10458, 178, 7, 1030);
INSERT INTO 'capvalue' VALUES (1071, 'MotorolaEmulatorM1');
INSERT INTO 'devicecapvalue' VALUES (10459, 178, 93, 1071);
INSERT INTO 'capvalue' VALUES (1072, 'A728.props');
INSERT INTO 'devicecapvalue' VALUES (10460, 178, 75, 1072);
INSERT INTO 'devicecapvalue' VALUES (10461, 178, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10462, 178, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (10463, 178, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (10464, 178, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (10465, 178, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (10466, 178, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10467, 178, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10468, 178, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (10469, 178, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10470, 178, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10471, 178, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10472, 178, 154, 1014);
INSERT INTO 'capvalue' VALUES (1073, 'secure socket');
INSERT INTO 'devicecapvalue' VALUES (10473, 178, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (10474, 178, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (10475, 178, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10476, 178, 154, 1018);
INSERT INTO 'capvalue' VALUES (1074, '10485760');
INSERT INTO 'devicecapvalue' VALUES (10477, 178, 50, 1074);
INSERT INTO 'devicecapvalue' VALUES (10478, 178, 161, 693);
INSERT INTO 'devicecapvalue' VALUES (10479, 178, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (10480, 178, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (10481, 178, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (10482, 178, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (10483, 178, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (10484, 178, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (10485, 178, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (10486, 178, 52, 1074);
INSERT INTO 'capvalue' VALUES (1075, 'MOT-A728');
INSERT INTO 'devicecapvalue' VALUES (10487, 178, 53, 1075);
INSERT INTO 'devicecapvalue' VALUES (10488, 179, 1, 1);
INSERT INTO 'capvalue' VALUES (1076, '240x244');
INSERT INTO 'devicecapvalue' VALUES (10489, 179, 7, 1076);
INSERT INTO 'devicecapvalue' VALUES (10490, 179, 93, 1071);
INSERT INTO 'capvalue' VALUES (1077, 'A760_A760i.props');
INSERT INTO 'devicecapvalue' VALUES (10491, 179, 75, 1077);
INSERT INTO 'devicecapvalue' VALUES (10492, 179, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10493, 179, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (10494, 179, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (10495, 179, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (10496, 179, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10497, 179, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10498, 179, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (10499, 179, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10500, 179, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10501, 179, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (10502, 179, 154, 1017);
INSERT INTO 'capvalue' VALUES (1078, 'ssl');
INSERT INTO 'devicecapvalue' VALUES (10503, 179, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (10504, 179, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (10505, 179, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (10506, 179, 3, 1034);
INSERT INTO 'devicecapvalue' VALUES (10507, 179, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (10508, 179, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (10509, 179, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (10510, 179, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (10511, 179, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (10512, 179, 51, 669);
INSERT INTO 'capvalue' VALUES (1079, 'MOT-A760/EZX_G_00.56.A2R MIB/2.2 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (10513, 179, 53, 1079);
INSERT INTO 'devicecapvalue' VALUES (10514, 180, 1, 1);
INSERT INTO 'capvalue' VALUES (1080, '1.3 MP');
INSERT INTO 'devicecapvalue' VALUES (10515, 180, 160, 1080);
INSERT INTO 'cap' VALUES (162, 'CameraZoom', 1);
INSERT INTO 'devicecapvalue' VALUES (10516, 180, 162, 42);
INSERT INTO 'capvalue' VALUES (1081, 'MotorolaEmulatorM3');
INSERT INTO 'devicecapvalue' VALUES (10517, 180, 93, 1081);
INSERT INTO 'capvalue' VALUES (1082, 'A780.props');
INSERT INTO 'devicecapvalue' VALUES (10518, 180, 75, 1082);
INSERT INTO 'devicecapvalue' VALUES (10519, 180, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10520, 180, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (10521, 180, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (10522, 180, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (10523, 180, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (10524, 180, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (10525, 180, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10526, 180, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10527, 180, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (10528, 180, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (10529, 180, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (10530, 180, 17, 684);
INSERT INTO 'capvalue' VALUES (1083, 'telephony-api');
INSERT INTO 'devicecapvalue' VALUES (10531, 180, 17, 1083);
INSERT INTO 'devicecapvalue' VALUES (10532, 180, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10533, 180, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (10534, 180, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10535, 180, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10536, 180, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (10537, 180, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (10538, 180, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10539, 180, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (10540, 180, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (10541, 180, 3, 1034);
INSERT INTO 'devicecapvalue' VALUES (10542, 180, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (10543, 180, 5, 601);
INSERT INTO 'capvalue' VALUES (1084, 'Tone Sequence');
INSERT INTO 'devicecapvalue' VALUES (10544, 180, 51, 1084);
INSERT INTO 'devicecapvalue' VALUES (10545, 180, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (10546, 180, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (10547, 180, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (10548, 180, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (10549, 180, 51, 669);
INSERT INTO 'capvalue' VALUES (1085, 'wb-amr');
INSERT INTO 'devicecapvalue' VALUES (10550, 180, 51, 1085);
INSERT INTO 'capvalue' VALUES (1086, '52428800');
INSERT INTO 'devicecapvalue' VALUES (10551, 180, 52, 1086);
INSERT INTO 'capvalue' VALUES (1087, '3gpp');
INSERT INTO 'devicecapvalue' VALUES (10552, 180, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (10553, 180, 157, 1026);
INSERT INTO 'capvalue' VALUES (1088, 'Mozilla/4.0 (compatible; MSIE 6.0; Linux; Motorola A780; 780) MOT-A780/R52_G_0D.37.A2P Profile/MIDP-2.0 Configuration/CLDC-1.1 Opera 7.50 [en]');
INSERT INTO 'devicecapvalue' VALUES (10554, 180, 53, 1088);
INSERT INTO 'devicecapvalue' VALUES (10555, 181, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (10556, 181, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (10557, 181, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (10558, 181, 160, 856);
INSERT INTO 'capvalue' VALUES (1089, '176x203');
INSERT INTO 'devicecapvalue' VALUES (10559, 181, 7, 1089);
INSERT INTO 'devicecapvalue' VALUES (10560, 181, 93, 1060);
INSERT INTO 'capvalue' VALUES (1090, 'A845.props');
INSERT INTO 'devicecapvalue' VALUES (10561, 181, 75, 1090);
INSERT INTO 'devicecapvalue' VALUES (10562, 181, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10563, 181, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (10564, 181, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (10565, 181, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (10566, 181, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (10567, 181, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (10568, 181, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10569, 181, 15, 1026);
INSERT INTO 'devicecapvalue' VALUES (10570, 181, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10571, 181, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (10572, 181, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (10573, 181, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (10574, 181, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10575, 181, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10576, 181, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10577, 181, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (10578, 181, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10579, 181, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (10580, 181, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (10581, 181, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (10582, 181, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (10583, 181, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (10584, 181, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (10585, 181, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (10586, 181, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (10587, 181, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (10588, 181, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (10589, 181, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (10590, 181, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (10591, 181, 52, 93);
INSERT INTO 'capvalue' VALUES (1091, 'MOT-A845/76.05.05I MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (10592, 181, 53, 1091);
INSERT INTO 'capvalue' VALUES (1092, '2006-12-18');
INSERT INTO 'devicecapvalue' VALUES (10593, 182, 158, 1092);
INSERT INTO 'devicecapvalue' VALUES (10594, 182, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (10595, 182, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (10596, 182, 93, 1081);
INSERT INTO 'capvalue' VALUES (1093, 'A910.props');
INSERT INTO 'devicecapvalue' VALUES (10597, 182, 75, 1093);
INSERT INTO 'devicecapvalue' VALUES (10598, 182, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10599, 182, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (10600, 182, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (10601, 182, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (10602, 182, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (10603, 182, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (10604, 182, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (10605, 182, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10606, 182, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10607, 182, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (10608, 182, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (10609, 182, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (10610, 182, 17, 22);
INSERT INTO 'capvalue' VALUES (1094, 'mot-geturl');
INSERT INTO 'devicecapvalue' VALUES (10611, 182, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (10612, 182, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (10613, 182, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (10614, 182, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10615, 182, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10616, 182, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (10617, 182, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10618, 182, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10619, 182, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (10620, 182, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (10621, 182, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (10622, 182, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10623, 182, 154, 1018);
INSERT INTO 'cap' VALUES (163, 'key.FireKey', 1);
INSERT INTO 'devicecapvalue' VALUES (10624, 182, 163, 30);
INSERT INTO 'devicecapvalue' VALUES (10625, 182, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (10626, 182, 30, 666);
INSERT INTO 'capvalue' VALUES (1095, '2 MB');
INSERT INTO 'devicecapvalue' VALUES (10627, 182, 155, 1095);
INSERT INTO 'capvalue' VALUES (1096, '3');
INSERT INTO 'devicecapvalue' VALUES (10628, 182, 161, 1096);
INSERT INTO 'devicecapvalue' VALUES (10629, 182, 3, 1034);
INSERT INTO 'devicecapvalue' VALUES (10630, 182, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (10631, 182, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (10632, 182, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (10633, 182, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (10634, 182, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (10635, 182, 51, 100);
INSERT INTO 'capvalue' VALUES (1097, 'eaac+');
INSERT INTO 'devicecapvalue' VALUES (10636, 182, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (10637, 182, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (10638, 182, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (10639, 182, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (10640, 182, 51, 1040);
INSERT INTO 'capvalue' VALUES (1098, 'realaudio');
INSERT INTO 'devicecapvalue' VALUES (10641, 182, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (10642, 182, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (10643, 182, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (10644, 182, 52, 1074);
INSERT INTO 'capvalue' VALUES (1099, 'MOT-A910/R57_G_10.06.42I');
INSERT INTO 'devicecapvalue' VALUES (10645, 182, 53, 1099);
INSERT INTO 'devicecapvalue' VALUES (10646, 183, 1, 13);
INSERT INTO 'devicecapvalue' VALUES (10647, 183, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (10648, 183, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (10649, 183, 2, 236);
INSERT INTO 'capvalue' VALUES (1100, '128x160');
INSERT INTO 'devicecapvalue' VALUES (10650, 183, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (10651, 183, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (10652, 183, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10653, 183, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10654, 183, 16, 97);
INSERT INTO 'capvalue' VALUES (1101, 'Gaming');
INSERT INTO 'devicecapvalue' VALUES (10655, 183, 17, 1101);
INSERT INTO 'devicecapvalue' VALUES (10656, 183, 17, 1016);
INSERT INTO 'devicecapvalue' VALUES (10657, 183, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10658, 183, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10659, 183, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (10660, 183, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10661, 183, 154, 1018);
INSERT INTO 'capvalue' VALUES (1102, '-20');
INSERT INTO 'devicecapvalue' VALUES (10662, 183, 26, 1102);
INSERT INTO 'devicecapvalue' VALUES (10663, 183, 27, 666);
INSERT INTO 'devicecapvalue' VALUES (10664, 183, 30, 662);
INSERT INTO 'capvalue' VALUES (1103, '204800');
INSERT INTO 'devicecapvalue' VALUES (10665, 183, 50, 1103);
INSERT INTO 'devicecapvalue' VALUES (10666, 183, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (10667, 183, 161, 238);
INSERT INTO 'cap' VALUES (164, 'MaxSockets.http', 1);
INSERT INTO 'devicecapvalue' VALUES (10668, 183, 164, 238);
INSERT INTO 'cap' VALUES (165, 'MaxSockets.tcp', 1);
INSERT INTO 'devicecapvalue' VALUES (10669, 183, 165, 238);
INSERT INTO 'cap' VALUES (166, 'MaxSockets.udp', 1);
INSERT INTO 'devicecapvalue' VALUES (10670, 183, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (10671, 183, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (10672, 183, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (10673, 183, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (10674, 183, 52, 659);
INSERT INTO 'capvalue' VALUES (1104, 'MOT-C261/0.1.40 UP.Browser/6.2.3.9.c.6 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (10675, 183, 53, 1104);
INSERT INTO 'devicecapvalue' VALUES (10676, 184, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (10677, 184, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (10678, 184, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (10679, 184, 93, 1060);
INSERT INTO 'capvalue' VALUES (1105, 'C380.props');
INSERT INTO 'devicecapvalue' VALUES (10680, 184, 75, 1105);
INSERT INTO 'devicecapvalue' VALUES (10681, 184, 2, 236);
INSERT INTO 'capvalue' VALUES (1106, '128x116');
INSERT INTO 'devicecapvalue' VALUES (10682, 184, 13, 1106);
INSERT INTO 'devicecapvalue' VALUES (10683, 184, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (10684, 184, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10685, 184, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10686, 184, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (10687, 184, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (10688, 184, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (10689, 184, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10690, 184, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10691, 184, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10692, 184, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (10693, 184, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10694, 184, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (10695, 184, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (10696, 184, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (10697, 184, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (10698, 184, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (10699, 184, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (10700, 184, 5, 99);
INSERT INTO 'capvalue' VALUES (1107, '1887436');
INSERT INTO 'devicecapvalue' VALUES (10701, 184, 52, 1107);
INSERT INTO 'capvalue' VALUES (1108, 'MOT-C380/0B.D1.1AR MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (10702, 184, 53, 1108);
INSERT INTO 'devicecapvalue' VALUES (10703, 185, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (10704, 185, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (10705, 185, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (10706, 185, 93, 1060);
INSERT INTO 'capvalue' VALUES (1109, 'C650_C651.props');
INSERT INTO 'devicecapvalue' VALUES (10707, 185, 75, 1109);
INSERT INTO 'devicecapvalue' VALUES (10708, 185, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10709, 185, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (10710, 185, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10711, 185, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10712, 185, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (10713, 185, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (10714, 185, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (10715, 185, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10716, 185, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10717, 185, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10718, 185, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (10719, 185, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10720, 185, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (10721, 185, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (10722, 185, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (10723, 185, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (10724, 185, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (10725, 185, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (10726, 185, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (10727, 185, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (10728, 185, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (10729, 185, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (10730, 185, 52, 1107);
INSERT INTO 'capvalue' VALUES (1110, 'MOT- E 398/0B.D2.32R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (10731, 185, 53, 1110);
INSERT INTO 'capvalue' VALUES (1111, '2005');
INSERT INTO 'devicecapvalue' VALUES (10732, 186, 158, 1111);
INSERT INTO 'devicecapvalue' VALUES (10733, 186, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (10734, 186, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (10735, 186, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (10736, 186, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (10737, 186, 162, 238);
INSERT INTO 'capvalue' VALUES (1112, 'MotorolaEmulatorA3');
INSERT INTO 'devicecapvalue' VALUES (10738, 186, 93, 1112);
INSERT INTO 'capvalue' VALUES (1113, 'C975.props');
INSERT INTO 'devicecapvalue' VALUES (10739, 186, 75, 1113);
INSERT INTO 'devicecapvalue' VALUES (10740, 186, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10741, 186, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (10742, 186, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (10743, 186, 150, 957);
INSERT INTO 'capvalue' VALUES (1114, '2100');
INSERT INTO 'devicecapvalue' VALUES (10744, 186, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (10745, 186, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (10746, 186, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (10747, 186, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (10748, 186, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (10749, 186, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10750, 186, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10751, 186, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (10752, 186, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (10753, 186, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (10754, 186, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (10755, 186, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10756, 186, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (10757, 186, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10758, 186, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10759, 186, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (10760, 186, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10761, 186, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (10762, 186, 26, 663);
INSERT INTO 'devicecapvalue' VALUES (10763, 186, 27, 110);
INSERT INTO 'devicecapvalue' VALUES (10764, 186, 30, 12);
INSERT INTO 'devicecapvalue' VALUES (10765, 186, 50, 1103);
INSERT INTO 'devicecapvalue' VALUES (10766, 186, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (10767, 186, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (10768, 186, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (10769, 186, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (10770, 186, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (10771, 186, 40, 55);
INSERT INTO 'capvalue' VALUES (1115, 'audio/imelody audio/x-imelody audio/imy audio/x-imy audio/midi audio/x-midi audio/mid audio/x-mid audio/sp-midi audio/wav audio/x-wav audio/mp3 audio/x-mp3 audio/mpeg3 audio/x-mpeg3 audio/mpeg audio/xmpeg audio/amr audio/x-amr audio/mp4 audio/x-mp4 video/mp4');
INSERT INTO 'devicecapvalue' VALUES (10772, 186, 42, 1115);
INSERT INTO 'devicecapvalue' VALUES (10773, 186, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (10774, 186, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (10775, 186, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (10776, 186, 3, 1068);
INSERT INTO 'capvalue' VALUES (1116, 'North America');
INSERT INTO 'devicecapvalue' VALUES (10777, 186, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (10778, 186, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (10779, 186, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (10780, 186, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (10781, 186, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (10782, 186, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (10783, 186, 51, 1039);
INSERT INTO 'capvalue' VALUES (1117, 'mp4');
INSERT INTO 'devicecapvalue' VALUES (10784, 186, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (10785, 186, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (10786, 186, 52, 1019);
INSERT INTO 'capvalue' VALUES (1118, 'mpeg4');
INSERT INTO 'devicecapvalue' VALUES (10787, 186, 157, 1118);
INSERT INTO 'capvalue' VALUES (1119, 'MOT-V975/82.31.58I MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (10788, 186, 53, 1119);
INSERT INTO 'capvalue' VALUES (1120, '2006-07-13');
INSERT INTO 'devicecapvalue' VALUES (10789, 187, 158, 1120);
INSERT INTO 'devicecapvalue' VALUES (10790, 187, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (10791, 187, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (10792, 187, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (10793, 187, 93, 1112);
INSERT INTO 'capvalue' VALUES (1121, 'C980.props');
INSERT INTO 'devicecapvalue' VALUES (10794, 187, 75, 1121);
INSERT INTO 'devicecapvalue' VALUES (10795, 187, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10796, 187, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (10797, 187, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (10798, 187, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (10799, 187, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (10800, 187, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10801, 187, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10802, 187, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (10803, 187, 6, 27);
INSERT INTO 'capvalue' VALUES (1122, 'http1.1');
INSERT INTO 'devicecapvalue' VALUES (10804, 187, 154, 1122);
INSERT INTO 'capvalue' VALUES (1123, 'tcp');
INSERT INTO 'devicecapvalue' VALUES (10805, 187, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (10806, 187, 154, 1018);
INSERT INTO 'capvalue' VALUES (1124, '4194304');
INSERT INTO 'devicecapvalue' VALUES (10807, 187, 50, 1124);
INSERT INTO 'devicecapvalue' VALUES (10808, 187, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (10809, 187, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (10810, 187, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (10811, 187, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (10812, 187, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (10813, 187, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (10814, 187, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (10815, 187, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (10816, 187, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (10817, 187, 52, 1124);
INSERT INTO 'capvalue' VALUES (1125, 'MOT-C980/80.2F.12I MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (10818, 187, 53, 1125);
INSERT INTO 'devicecapvalue' VALUES (10819, 188, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (10820, 188, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (10821, 188, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (10822, 188, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (10823, 188, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (10824, 189, 158, 1070);
INSERT INTO 'devicecapvalue' VALUES (10825, 189, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (10826, 189, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (10827, 189, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (10828, 189, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (10829, 189, 162, 238);
INSERT INTO 'capvalue' VALUES (1126, 'MotorolaEmulatorA4');
INSERT INTO 'devicecapvalue' VALUES (10830, 189, 93, 1126);
INSERT INTO 'capvalue' VALUES (1127, 'ROKR_E1.props');
INSERT INTO 'devicecapvalue' VALUES (10831, 189, 75, 1127);
INSERT INTO 'devicecapvalue' VALUES (10832, 189, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10833, 189, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (10834, 189, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (10835, 189, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (10836, 189, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (10837, 189, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (10838, 189, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (10839, 189, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (10840, 189, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (10841, 189, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10842, 189, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10843, 189, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (10844, 189, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (10845, 189, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (10846, 189, 17, 1094);
INSERT INTO 'capvalue' VALUES (1128, 'mot3dapi');
INSERT INTO 'devicecapvalue' VALUES (10847, 189, 17, 1128);
INSERT INTO 'capvalue' VALUES (1129, 'motorola-funlights-api');
INSERT INTO 'devicecapvalue' VALUES (10848, 189, 17, 1129);
INSERT INTO 'devicecapvalue' VALUES (10849, 189, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (10850, 189, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10851, 189, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10852, 189, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (10853, 189, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10854, 189, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10855, 189, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10856, 189, 154, 1018);
INSERT INTO 'capvalue' VALUES (1130, '512 kb');
INSERT INTO 'devicecapvalue' VALUES (10857, 189, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (10858, 189, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (10859, 189, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (10860, 189, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (10861, 189, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (10862, 189, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (10863, 189, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (10864, 189, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (10865, 189, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (10866, 189, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (10867, 189, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (10868, 189, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (10869, 189, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (10870, 189, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (10871, 189, 52, 93);
INSERT INTO 'capvalue' VALUES (1131, 'MOT-BloodKasch/0E.30.79R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (10872, 189, 53, 1131);
INSERT INTO 'devicecapvalue' VALUES (10873, 190, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (10874, 190, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (10875, 190, 74, 1058);
INSERT INTO 'capvalue' VALUES (1132, '240x308');
INSERT INTO 'devicecapvalue' VALUES (10876, 190, 7, 1132);
INSERT INTO 'devicecapvalue' VALUES (10877, 190, 93, 1112);
INSERT INTO 'capvalue' VALUES (1133, 'E1000_E1000R.props');
INSERT INTO 'devicecapvalue' VALUES (10878, 190, 75, 1133);
INSERT INTO 'devicecapvalue' VALUES (10879, 190, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10880, 190, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (10881, 190, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (10882, 190, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (10883, 190, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (10884, 190, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (10885, 190, 150, 1011);
INSERT INTO 'devicecapvalue' VALUES (10886, 190, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (10887, 190, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (10888, 190, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (10889, 190, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (10890, 190, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10891, 190, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10892, 190, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (10893, 190, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (10894, 190, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (10895, 190, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (10896, 190, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10897, 190, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (10898, 190, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10899, 190, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10900, 190, 154, 1122);
INSERT INTO 'devicecapvalue' VALUES (10901, 190, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (10902, 190, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (10903, 190, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (10904, 190, 50, 1103);
INSERT INTO 'devicecapvalue' VALUES (10905, 190, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (10906, 190, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (10907, 190, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (10908, 190, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (10909, 190, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (10910, 190, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (10911, 190, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (10912, 190, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (10913, 190, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (10914, 190, 5, 601);
INSERT INTO 'capvalue' VALUES (1134, 'h.263');
INSERT INTO 'devicecapvalue' VALUES (10915, 190, 51, 1134);
INSERT INTO 'devicecapvalue' VALUES (10916, 190, 51, 1026);
INSERT INTO 'devicecapvalue' VALUES (10917, 190, 52, 1019);
INSERT INTO 'capvalue' VALUES (1135, 'MOT-E1K FREE STYLE/83.39.27I MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (10918, 190, 53, 1135);
INSERT INTO 'capvalue' VALUES (1136, '2006-17-06');
INSERT INTO 'devicecapvalue' VALUES (10919, 191, 158, 1136);
INSERT INTO 'devicecapvalue' VALUES (10920, 191, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (10921, 191, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (10922, 191, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (10923, 191, 93, 1126);
INSERT INTO 'capvalue' VALUES (1137, 'Pebl_U6.props');
INSERT INTO 'devicecapvalue' VALUES (10924, 191, 75, 1137);
INSERT INTO 'cap' VALUES (167, 'ExternalScreenSize', 1);
INSERT INTO 'capvalue' VALUES (1138, '96x80');
INSERT INTO 'devicecapvalue' VALUES (10925, 191, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (10926, 191, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (10927, 191, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (10928, 191, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (10929, 191, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (10930, 191, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (10931, 191, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10932, 191, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10933, 191, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (10934, 191, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (10935, 191, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (10936, 191, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (10937, 191, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (10938, 191, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (10939, 191, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10940, 191, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (10941, 191, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10942, 191, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10943, 191, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10944, 191, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (10945, 191, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (10946, 191, 27, 1102);
INSERT INTO 'devicecapvalue' VALUES (10947, 191, 30, 666);
INSERT INTO 'capvalue' VALUES (1139, '64kb');
INSERT INTO 'devicecapvalue' VALUES (10948, 191, 155, 1139);
INSERT INTO 'devicecapvalue' VALUES (10949, 191, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (10950, 191, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (10951, 191, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (10952, 191, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (10953, 191, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (10954, 191, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (10955, 191, 51, 1038);
INSERT INTO 'devicecapvalue' VALUES (10956, 191, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (10957, 191, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (10958, 191, 51, 1040);
INSERT INTO 'devicecapvalue' VALUES (10959, 191, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (10960, 191, 51, 1042);
INSERT INTO 'capvalue' VALUES (1140, '33554432');
INSERT INTO 'devicecapvalue' VALUES (10961, 191, 52, 1140);
INSERT INTO 'capvalue' VALUES (1141, 'MOT-E1070/85.63.20R MIB/BER2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (10962, 191, 53, 1141);
INSERT INTO 'capvalue' VALUES (1142, '2006-12-28');
INSERT INTO 'devicecapvalue' VALUES (10963, 192, 158, 1142);
INSERT INTO 'devicecapvalue' VALUES (10964, 192, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (10965, 192, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (10966, 192, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (10967, 192, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (10968, 192, 93, 1081);
INSERT INTO 'capvalue' VALUES (1143, 'ROKR_E2.props');
INSERT INTO 'devicecapvalue' VALUES (10969, 192, 75, 1143);
INSERT INTO 'devicecapvalue' VALUES (10970, 192, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (10971, 192, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (10972, 192, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (10973, 192, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (10974, 192, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (10975, 192, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (10976, 192, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (10977, 192, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (10978, 192, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (10979, 192, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (10980, 192, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (10981, 192, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (10982, 192, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (10983, 192, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (10984, 192, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (10985, 192, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (10986, 192, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10987, 192, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (10988, 192, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (10989, 192, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (10990, 192, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (10991, 192, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (10992, 192, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (10993, 192, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (10994, 192, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (10995, 192, 161, 693);
INSERT INTO 'devicecapvalue' VALUES (10996, 192, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (10997, 192, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (10998, 192, 3, 1034);
INSERT INTO 'devicecapvalue' VALUES (10999, 192, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11000, 192, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (11001, 192, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (11002, 192, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11003, 192, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (11004, 192, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11005, 192, 51, 569);
INSERT INTO 'capvalue' VALUES (1144, 'ra10');
INSERT INTO 'devicecapvalue' VALUES (11006, 192, 51, 1144);
INSERT INTO 'devicecapvalue' VALUES (11007, 192, 51, 1040);
INSERT INTO 'capvalue' VALUES (1145, 'rag2');
INSERT INTO 'devicecapvalue' VALUES (11008, 192, 51, 1145);
INSERT INTO 'devicecapvalue' VALUES (11009, 192, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (11010, 192, 51, 669);
INSERT INTO 'capvalue' VALUES (1146, 'wb-arm');
INSERT INTO 'devicecapvalue' VALUES (11011, 192, 51, 1146);
INSERT INTO 'devicecapvalue' VALUES (11012, 192, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (11013, 192, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (11014, 193, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11015, 193, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11016, 193, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11017, 193, 160, 856);
INSERT INTO 'capvalue' VALUES (1147, '176x187');
INSERT INTO 'devicecapvalue' VALUES (11018, 193, 7, 1147);
INSERT INTO 'devicecapvalue' VALUES (11019, 193, 93, 1060);
INSERT INTO 'capvalue' VALUES (1148, 'E398.props');
INSERT INTO 'devicecapvalue' VALUES (11020, 193, 75, 1148);
INSERT INTO 'devicecapvalue' VALUES (11021, 193, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11022, 193, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (11023, 193, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (11024, 193, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11025, 193, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11026, 193, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (11027, 193, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11028, 193, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (11029, 193, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11030, 193, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11031, 193, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11032, 193, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11033, 193, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11034, 193, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11035, 193, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (11036, 193, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (11037, 193, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (11038, 193, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11039, 193, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11040, 193, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (11041, 193, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11042, 193, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11043, 193, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11044, 193, 52, 93);
INSERT INTO 'capvalue' VALUES (1149, 'MOT-E398u/0E.30.70R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (11045, 193, 53, 1149);
INSERT INTO 'devicecapvalue' VALUES (11046, 194, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11047, 194, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11048, 194, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11049, 194, 7, 1147);
INSERT INTO 'devicecapvalue' VALUES (11050, 194, 93, 1060);
INSERT INTO 'devicecapvalue' VALUES (11051, 194, 75, 1148);
INSERT INTO 'devicecapvalue' VALUES (11052, 194, 2, 236);
INSERT INTO 'capvalue' VALUES (1150, '176x204');
INSERT INTO 'devicecapvalue' VALUES (11053, 194, 13, 1150);
INSERT INTO 'devicecapvalue' VALUES (11054, 194, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (11055, 194, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11056, 194, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11057, 194, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (11058, 194, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11059, 194, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (11060, 194, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11061, 194, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11062, 194, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11063, 194, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11064, 194, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11065, 194, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11066, 194, 26, 663);
INSERT INTO 'devicecapvalue' VALUES (11067, 194, 27, 110);
INSERT INTO 'devicecapvalue' VALUES (11068, 194, 30, 12);
INSERT INTO 'devicecapvalue' VALUES (11069, 194, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (11070, 194, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (11071, 194, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (11072, 194, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11073, 194, 4, 679);
INSERT INTO 'capvalue' VALUES (1151, '204');
INSERT INTO 'devicecapvalue' VALUES (11074, 194, 5, 1151);
INSERT INTO 'devicecapvalue' VALUES (11075, 194, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11076, 194, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11077, 194, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11078, 194, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (11079, 195, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (11080, 195, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (11081, 195, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11082, 195, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11083, 195, 5, 681);
INSERT INTO 'capvalue' VALUES (1152, 'MOT-E550/08.83.18I MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (11084, 195, 53, 1152);
INSERT INTO 'capvalue' VALUES (1153, '2006-12-11');
INSERT INTO 'devicecapvalue' VALUES (11085, 196, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (11086, 196, 1, 106);
INSERT INTO 'capvalue' VALUES (1154, '2 MP');
INSERT INTO 'devicecapvalue' VALUES (11087, 196, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (11088, 196, 93, 1081);
INSERT INTO 'capvalue' VALUES (1155, 'MOTOROKR_E6.props');
INSERT INTO 'devicecapvalue' VALUES (11089, 196, 75, 1155);
INSERT INTO 'devicecapvalue' VALUES (11090, 196, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11091, 196, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11092, 196, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (11093, 196, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11094, 196, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11095, 196, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (11096, 196, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (11097, 196, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (11098, 196, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11099, 196, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (11100, 196, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11101, 196, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11102, 196, 15, 96);
INSERT INTO 'capvalue' VALUES (1156, 'wmp');
INSERT INTO 'devicecapvalue' VALUES (11103, 196, 15, 1156);
INSERT INTO 'devicecapvalue' VALUES (11104, 196, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11105, 196, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11106, 196, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (11107, 196, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11108, 196, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (11109, 196, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (11110, 196, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11111, 196, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11112, 196, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (11113, 196, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11114, 196, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11115, 196, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (11116, 196, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (11117, 196, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11118, 196, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11119, 196, 154, 1018);
INSERT INTO 'capvalue' VALUES (1157, '1 MB');
INSERT INTO 'devicecapvalue' VALUES (11120, 196, 155, 1157);
INSERT INTO 'devicecapvalue' VALUES (11121, 196, 161, 693);
INSERT INTO 'devicecapvalue' VALUES (11122, 196, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (11123, 196, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (11124, 196, 3, 1034);
INSERT INTO 'capvalue' VALUES (1158, 'Asia');
INSERT INTO 'devicecapvalue' VALUES (11125, 196, 156, 1158);
INSERT INTO 'capvalue' VALUES (1159, 'EMEA');
INSERT INTO 'devicecapvalue' VALUES (11126, 196, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (11127, 196, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (11128, 196, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (11129, 196, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11130, 196, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (11131, 196, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (11132, 196, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11133, 196, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (11134, 196, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (11135, 196, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11136, 196, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (11137, 196, 51, 1041);
INSERT INTO 'capvalue' VALUES (1160, 'xmf');
INSERT INTO 'devicecapvalue' VALUES (11138, 196, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (11139, 196, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (11140, 197, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11141, 197, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11142, 197, 93, 1081);
INSERT INTO 'capvalue' VALUES (1161, 'E680_E680i.props');
INSERT INTO 'devicecapvalue' VALUES (11143, 197, 75, 1161);
INSERT INTO 'devicecapvalue' VALUES (11144, 197, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11145, 197, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (11146, 197, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (11147, 197, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (11148, 197, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11149, 197, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11150, 197, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11151, 197, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11152, 197, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (11153, 197, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11154, 197, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11155, 197, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11156, 197, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11157, 197, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11158, 197, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11159, 197, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11160, 197, 50, 659);
INSERT INTO 'capvalue' VALUES (1162, '100 kb');
INSERT INTO 'devicecapvalue' VALUES (11161, 197, 155, 1162);
INSERT INTO 'devicecapvalue' VALUES (11162, 197, 161, 693);
INSERT INTO 'devicecapvalue' VALUES (11163, 197, 164, 693);
INSERT INTO 'devicecapvalue' VALUES (11164, 197, 165, 693);
INSERT INTO 'devicecapvalue' VALUES (11165, 197, 166, 693);
INSERT INTO 'devicecapvalue' VALUES (11166, 197, 3, 1034);
INSERT INTO 'devicecapvalue' VALUES (11167, 197, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (11168, 197, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (11169, 197, 51, 1084);
INSERT INTO 'devicecapvalue' VALUES (11170, 197, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11171, 197, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11172, 197, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11173, 197, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11174, 197, 52, 1086);
INSERT INTO 'devicecapvalue' VALUES (11175, 197, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (11176, 197, 157, 1026);
INSERT INTO 'capvalue' VALUES (1163, 'MOT-E680/R51_G_0F.51.A1P MIB/2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (11177, 197, 53, 1163);
INSERT INTO 'capvalue' VALUES (1164, '2006-08-04');
INSERT INTO 'devicecapvalue' VALUES (11178, 198, 158, 1164);
INSERT INTO 'devicecapvalue' VALUES (11179, 198, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11180, 198, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11181, 198, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (11182, 198, 93, 1081);
INSERT INTO 'devicecapvalue' VALUES (11183, 198, 75, 1161);
INSERT INTO 'devicecapvalue' VALUES (11184, 198, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11185, 198, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11186, 198, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (11187, 198, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11188, 198, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11189, 198, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11190, 198, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11191, 198, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (11192, 198, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11193, 198, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11194, 198, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11195, 198, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11196, 198, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (11197, 198, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (11198, 198, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11199, 198, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11200, 198, 154, 1018);
INSERT INTO 'capvalue' VALUES (1165, '9437184');
INSERT INTO 'devicecapvalue' VALUES (11201, 198, 50, 1165);
INSERT INTO 'devicecapvalue' VALUES (11202, 198, 155, 1162);
INSERT INTO 'devicecapvalue' VALUES (11203, 198, 161, 693);
INSERT INTO 'devicecapvalue' VALUES (11204, 198, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11205, 198, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11206, 198, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (11207, 198, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (11208, 198, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11209, 198, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (11210, 198, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11211, 198, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (11212, 198, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11213, 198, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11214, 198, 51, 1040);
INSERT INTO 'devicecapvalue' VALUES (11215, 198, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (11216, 198, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11217, 198, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (11218, 198, 52, 1165);
INSERT INTO 'capvalue' VALUES (1166, 'MOT-E680i/E680I_G_0D.C3.A8P Mozilla/4.0 (compatible; MSIE 6.0; Linux; Motorola E680i; 1030) Profile/MIDP-2.0 Configuration/CLDC-1.1 Opera 7.50 [zh-cn]');
INSERT INTO 'devicecapvalue' VALUES (11219, 198, 53, 1166);
INSERT INTO 'devicecapvalue' VALUES (11220, 199, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11221, 199, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11222, 199, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11223, 199, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (11224, 199, 93, 1112);
INSERT INTO 'capvalue' VALUES (1167, 'E770.props');
INSERT INTO 'devicecapvalue' VALUES (11225, 199, 75, 1167);
INSERT INTO 'devicecapvalue' VALUES (11226, 199, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11227, 199, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11228, 199, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (11229, 199, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (11230, 199, 12, 709);
INSERT INTO 'devicecapvalue' VALUES (11231, 199, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (11232, 199, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11233, 199, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11234, 199, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11235, 199, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11236, 199, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (11237, 199, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11238, 199, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (11239, 199, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11240, 199, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11241, 199, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11242, 199, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11243, 199, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11244, 199, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (11245, 199, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (11246, 199, 26, 662);
INSERT INTO 'capvalue' VALUES (1168, '-23');
INSERT INTO 'devicecapvalue' VALUES (11247, 199, 27, 1168);
INSERT INTO 'devicecapvalue' VALUES (11248, 199, 30, 666);
INSERT INTO 'capvalue' VALUES (1169, '614400');
INSERT INTO 'devicecapvalue' VALUES (11249, 199, 50, 1169);
INSERT INTO 'devicecapvalue' VALUES (11250, 199, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (11251, 199, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (11252, 199, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11253, 199, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11254, 199, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (11255, 199, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11256, 199, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11257, 199, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11258, 199, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11259, 199, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11260, 199, 52, 1140);
INSERT INTO 'capvalue' VALUES (1170, 'MOT-E770/85.84.70R MIB/BER2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (11261, 199, 53, 1170);
INSERT INTO 'devicecapvalue' VALUES (11262, 200, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (11263, 200, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (11264, 200, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (11265, 200, 93, 1081);
INSERT INTO 'devicecapvalue' VALUES (11266, 200, 75, 1155);
INSERT INTO 'devicecapvalue' VALUES (11267, 200, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11268, 200, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11269, 200, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (11270, 200, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11271, 200, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11272, 200, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (11273, 200, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (11274, 200, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (11275, 200, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11276, 200, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (11277, 200, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11278, 200, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11279, 200, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11280, 200, 15, 1156);
INSERT INTO 'devicecapvalue' VALUES (11281, 200, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11282, 200, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11283, 200, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (11284, 200, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11285, 200, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (11286, 200, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (11287, 200, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11288, 200, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11289, 200, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (11290, 200, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11291, 200, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11292, 200, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (11293, 200, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (11294, 200, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11295, 200, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11296, 200, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11297, 200, 155, 1157);
INSERT INTO 'devicecapvalue' VALUES (11298, 200, 161, 693);
INSERT INTO 'devicecapvalue' VALUES (11299, 200, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (11300, 200, 88, 1004);
INSERT INTO 'capvalue' VALUES (1171, 'Motomagx');
INSERT INTO 'devicecapvalue' VALUES (11301, 200, 3, 1171);
INSERT INTO 'devicecapvalue' VALUES (11302, 200, 156, 1158);
INSERT INTO 'devicecapvalue' VALUES (11303, 200, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (11304, 200, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (11305, 200, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (11306, 200, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11307, 200, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (11308, 200, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (11309, 200, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11310, 200, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (11311, 200, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (11312, 200, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11313, 200, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (11314, 200, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (11315, 200, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (11316, 200, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (11317, 201, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (11318, 201, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (11319, 201, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11320, 201, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11321, 201, 5, 681);
INSERT INTO 'capvalue' VALUES (1172, 'MOT-8720_/00.62 UP.Browser/6.2.3.4.c.1.104 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (11322, 201, 53, 1172);
INSERT INTO 'devicecapvalue' VALUES (11323, 202, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (11324, 202, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (11325, 202, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11326, 202, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11327, 202, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (11328, 203, 158, 1111);
INSERT INTO 'devicecapvalue' VALUES (11329, 203, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11330, 203, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (11331, 203, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (11332, 203, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (11333, 203, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11334, 203, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11335, 203, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (11336, 203, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11337, 203, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11338, 203, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (11339, 203, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (11340, 203, 76, 1005);
INSERT INTO 'devicecapvalue' VALUES (11341, 203, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11342, 203, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11343, 203, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11344, 203, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11345, 203, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11346, 203, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11347, 203, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (11348, 203, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11349, 203, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11350, 203, 154, 1014);
INSERT INTO 'capvalue' VALUES (1173, 'serversocket');
INSERT INTO 'devicecapvalue' VALUES (11351, 203, 154, 1173);
INSERT INTO 'devicecapvalue' VALUES (11352, 203, 154, 1016);
INSERT INTO 'devicecapvalue' VALUES (11353, 203, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11354, 203, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11355, 203, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (11356, 203, 155, 593);
INSERT INTO 'devicecapvalue' VALUES (11357, 203, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (11358, 203, 88, 1004);
INSERT INTO 'capvalue' VALUES (1174, 'Symbian 7.0');
INSERT INTO 'devicecapvalue' VALUES (11359, 203, 3, 1174);
INSERT INTO 'capvalue' VALUES (1175, 'UIQ 2.1');
INSERT INTO 'devicecapvalue' VALUES (11360, 203, 3, 1175);
INSERT INTO 'devicecapvalue' VALUES (11361, 203, 156, 1035);
INSERT INTO 'capvalue' VALUES (1176, 'Japan');
INSERT INTO 'devicecapvalue' VALUES (11362, 203, 156, 1176);
INSERT INTO 'devicecapvalue' VALUES (11363, 203, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (11364, 203, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (11365, 203, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11366, 203, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11367, 203, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11368, 203, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11369, 203, 52, 1019);
INSERT INTO 'devicecapvalue' VALUES (11370, 203, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (11371, 204, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11372, 204, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11373, 204, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11374, 204, 7, 969);
INSERT INTO 'cap' VALUES (168, 'default-encoding', 1);
INSERT INTO 'capvalue' VALUES (1177, 'en-US');
INSERT INTO 'devicecapvalue' VALUES (11375, 204, 168, 1177);
INSERT INTO 'devicecapvalue' VALUES (11376, 204, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11377, 204, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11378, 204, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (11379, 204, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (11380, 204, 12, 864);
INSERT INTO 'capvalue' VALUES (1178, '176x206');
INSERT INTO 'devicecapvalue' VALUES (11381, 204, 13, 1178);
INSERT INTO 'devicecapvalue' VALUES (11382, 204, 76, 1124);
INSERT INTO 'capvalue' VALUES (1179, 'PNG w/ Transparency and Alpha');
INSERT INTO 'devicecapvalue' VALUES (11383, 204, 15, 1179);
INSERT INTO 'devicecapvalue' VALUES (11384, 204, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11385, 204, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11386, 204, 15, 19);
INSERT INTO 'capvalue' VALUES (1180, 'x-rgb565');
INSERT INTO 'devicecapvalue' VALUES (11387, 204, 15, 1180);
INSERT INTO 'devicecapvalue' VALUES (11388, 204, 16, 20);
INSERT INTO 'capvalue' VALUES (1181, 'M3G');
INSERT INTO 'devicecapvalue' VALUES (11389, 204, 17, 1181);
INSERT INTO 'devicecapvalue' VALUES (11390, 204, 17, 112);
INSERT INTO 'capvalue' VALUES (1182, 'bluetooth-obex-api');
INSERT INTO 'devicecapvalue' VALUES (11391, 204, 17, 1182);
INSERT INTO 'devicecapvalue' VALUES (11392, 204, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (11393, 204, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11394, 204, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (11395, 204, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (11396, 204, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11397, 204, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11398, 204, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (11399, 204, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11400, 204, 154, 112);
INSERT INTO 'devicecapvalue' VALUES (11401, 204, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11402, 204, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (11403, 204, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11404, 204, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (11405, 204, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11406, 204, 26, 1102);
INSERT INTO 'cap' VALUES (169, 'key.menu', 1);
INSERT INTO 'devicecapvalue' VALUES (11407, 204, 169, 666);
INSERT INTO 'devicecapvalue' VALUES (11408, 204, 30, 662);
INSERT INTO 'cap' VALUES (170, 'key.Select', 1);
INSERT INTO 'devicecapvalue' VALUES (11409, 204, 170, 1168);
INSERT INTO 'cap' VALUES (171, 'key.Send', 1);
INSERT INTO 'capvalue' VALUES (1183, '-14');
INSERT INTO 'devicecapvalue' VALUES (11410, 204, 171, 1183);
INSERT INTO 'cap' VALUES (172, 'microedition-Locale', 1);
INSERT INTO 'devicecapvalue' VALUES (11411, 204, 172, 44);
INSERT INTO 'devicecapvalue' VALUES (11412, 204, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11413, 204, 4, 679);
INSERT INTO 'capvalue' VALUES (1184, '188');
INSERT INTO 'devicecapvalue' VALUES (11414, 204, 5, 1184);
INSERT INTO 'devicecapvalue' VALUES (11415, 204, 51, 100);
INSERT INTO 'capvalue' VALUES (1185, 'basic');
INSERT INTO 'devicecapvalue' VALUES (11416, 204, 51, 1185);
INSERT INTO 'devicecapvalue' VALUES (11417, 204, 51, 102);
INSERT INTO 'capvalue' VALUES (1186, 'mp4v-es');
INSERT INTO 'devicecapvalue' VALUES (11418, 204, 51, 1186);
INSERT INTO 'capvalue' VALUES (1187, 'mpeg');
INSERT INTO 'devicecapvalue' VALUES (11419, 204, 51, 1187);
INSERT INTO 'capvalue' VALUES (1188, 'quicktime');
INSERT INTO 'devicecapvalue' VALUES (11420, 204, 51, 1188);
INSERT INTO 'capvalue' VALUES (1189, 'x-idenambe');
INSERT INTO 'devicecapvalue' VALUES (11421, 204, 51, 1189);
INSERT INTO 'capvalue' VALUES (1190, 'x-idenvselp');
INSERT INTO 'devicecapvalue' VALUES (11422, 204, 51, 1190);
INSERT INTO 'capvalue' VALUES (1191, 'x-tone-seq');
INSERT INTO 'devicecapvalue' VALUES (11423, 204, 51, 1191);
INSERT INTO 'capvalue' VALUES (1192, 'x-wav');
INSERT INTO 'devicecapvalue' VALUES (11424, 204, 51, 1192);
INSERT INTO 'devicecapvalue' VALUES (11425, 204, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (11426, 204, 157, 1186);
INSERT INTO 'devicecapvalue' VALUES (11427, 204, 157, 1187);
INSERT INTO 'devicecapvalue' VALUES (11428, 204, 157, 1188);
INSERT INTO 'capvalue' VALUES (1193, 'MOT-xx/nn.nn');
INSERT INTO 'devicecapvalue' VALUES (11429, 204, 53, 1193);
INSERT INTO 'devicecapvalue' VALUES (11430, 205, 158, 1092);
INSERT INTO 'devicecapvalue' VALUES (11431, 205, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (11432, 205, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11433, 205, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11434, 205, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (11435, 205, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (11436, 205, 7, 859);
INSERT INTO 'capvalue' VALUES (1194, 'MotorolaEmulatorA6');
INSERT INTO 'devicecapvalue' VALUES (11437, 205, 93, 1194);
INSERT INTO 'capvalue' VALUES (1195, 'MOTOKRZR_K1.props');
INSERT INTO 'devicecapvalue' VALUES (11438, 205, 75, 1195);
INSERT INTO 'devicecapvalue' VALUES (11439, 205, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (11440, 205, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11441, 205, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11442, 205, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11443, 205, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11444, 205, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (11445, 205, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (11446, 205, 13, 859);
INSERT INTO 'capvalue' VALUES (1196, '921600');
INSERT INTO 'devicecapvalue' VALUES (11447, 205, 76, 1196);
INSERT INTO 'devicecapvalue' VALUES (11448, 205, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11449, 205, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (11450, 205, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11451, 205, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11452, 205, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11453, 205, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (11454, 205, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11455, 205, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11456, 205, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11457, 205, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (11458, 205, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (11459, 205, 17, 684);
INSERT INTO 'capvalue' VALUES (1197, 'securityapi');
INSERT INTO 'devicecapvalue' VALUES (11460, 205, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (11461, 205, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11462, 205, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11463, 205, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (11464, 205, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11465, 205, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11466, 205, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (11467, 205, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (11468, 205, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11469, 205, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (11470, 205, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (11471, 205, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (11472, 205, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (11473, 205, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (11474, 205, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (11475, 205, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (11476, 205, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11477, 205, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11478, 205, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11479, 205, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (11480, 205, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11481, 205, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11482, 205, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (11483, 205, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (11484, 205, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11485, 205, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11486, 205, 52, 683);
INSERT INTO 'capvalue' VALUES (1198, 'MOT-K1/08.03.08R MIB/BER2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1 EGE/1.0');
INSERT INTO 'devicecapvalue' VALUES (11487, 205, 53, 1198);
INSERT INTO 'devicecapvalue' VALUES (11488, 206, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (11489, 206, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11490, 206, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11491, 206, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11492, 206, 93, 1126);
INSERT INTO 'capvalue' VALUES (1199, 'L2_L6_L6i.props');
INSERT INTO 'devicecapvalue' VALUES (11493, 206, 75, 1199);
INSERT INTO 'devicecapvalue' VALUES (11494, 206, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11495, 206, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11496, 206, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11497, 206, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (11498, 206, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (11499, 206, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (11500, 206, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11501, 206, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11502, 206, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11503, 206, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11504, 206, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (11505, 206, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11506, 206, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11507, 206, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11508, 206, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (11509, 206, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (11510, 206, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11511, 206, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11512, 206, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (11513, 206, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11514, 206, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11515, 206, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11516, 206, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11517, 206, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11518, 206, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (11519, 206, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (11520, 206, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (11521, 206, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (11522, 206, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11523, 206, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11524, 206, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (11525, 206, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (11526, 206, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11527, 206, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11528, 206, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (11529, 206, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11530, 206, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11531, 206, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11532, 206, 52, 1074);
INSERT INTO 'capvalue' VALUES (1200, 'MOT-L2/0A.52.35R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (11533, 206, 53, 1200);
INSERT INTO 'devicecapvalue' VALUES (11534, 207, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11535, 207, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11536, 207, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11537, 207, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (11538, 207, 162, 238);
INSERT INTO 'capvalue' VALUES (1201, '128x131');
INSERT INTO 'devicecapvalue' VALUES (11539, 207, 7, 1201);
INSERT INTO 'devicecapvalue' VALUES (11540, 207, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (11541, 207, 75, 1199);
INSERT INTO 'devicecapvalue' VALUES (11542, 207, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11543, 207, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11544, 207, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (11545, 207, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (11546, 207, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (11547, 207, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11548, 207, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11549, 207, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (11550, 207, 13, 1201);
INSERT INTO 'devicecapvalue' VALUES (11551, 207, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (11552, 207, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11553, 207, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11554, 207, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11555, 207, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11556, 207, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (11557, 207, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11558, 207, 17, 1182);
INSERT INTO 'devicecapvalue' VALUES (11559, 207, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11560, 207, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11561, 207, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (11562, 207, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11563, 207, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11564, 207, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11565, 207, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11566, 207, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11567, 207, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11568, 207, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11569, 207, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (11570, 207, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (11571, 207, 27, 1168);
INSERT INTO 'devicecapvalue' VALUES (11572, 207, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (11573, 207, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (11574, 207, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (11575, 207, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (11576, 207, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (11577, 207, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11578, 207, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11579, 207, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (11580, 207, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (11581, 207, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11582, 207, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11583, 207, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11584, 207, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11585, 207, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11586, 207, 52, 1074);
INSERT INTO 'capvalue' VALUES (1202, 'MOT-L6/0A.53.1AR MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (11587, 207, 53, 1202);
INSERT INTO 'capvalue' VALUES (1203, '2006-09-05');
INSERT INTO 'devicecapvalue' VALUES (11588, 208, 158, 1203);
INSERT INTO 'devicecapvalue' VALUES (11589, 208, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11590, 208, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11591, 208, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11592, 208, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (11593, 208, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (11594, 208, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (11595, 208, 75, 1199);
INSERT INTO 'devicecapvalue' VALUES (11596, 208, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11597, 208, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11598, 208, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11599, 208, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11600, 208, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (11601, 208, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (11602, 208, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (11603, 208, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11604, 208, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11605, 208, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11606, 208, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11607, 208, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (11608, 208, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11609, 208, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11610, 208, 17, 22);
INSERT INTO 'capvalue' VALUES (1204, 'mot-drm');
INSERT INTO 'devicecapvalue' VALUES (11611, 208, 17, 1204);
INSERT INTO 'devicecapvalue' VALUES (11612, 208, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (11613, 208, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11614, 208, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11615, 208, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11616, 208, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11617, 208, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11618, 208, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11619, 208, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11620, 208, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (11621, 208, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (11622, 208, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (11623, 208, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (11624, 208, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11625, 208, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11626, 208, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (11627, 208, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (11628, 208, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11629, 208, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11630, 208, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11631, 208, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11632, 208, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11633, 208, 52, 1074);
INSERT INTO 'capvalue' VALUES (1205, 'MOT-L6i/0A.65.07R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (11634, 208, 53, 1205);
INSERT INTO 'devicecapvalue' VALUES (11635, 209, 158, 1142);
INSERT INTO 'devicecapvalue' VALUES (11636, 209, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (11637, 209, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11638, 209, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11639, 209, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (11640, 209, 93, 1126);
INSERT INTO 'capvalue' VALUES (1206, 'SLVR_L7.props');
INSERT INTO 'devicecapvalue' VALUES (11641, 209, 75, 1206);
INSERT INTO 'devicecapvalue' VALUES (11642, 209, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11643, 209, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11644, 209, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11645, 209, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11646, 209, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (11647, 209, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (11648, 209, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (11649, 209, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11650, 209, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11651, 209, 15, 96);
INSERT INTO 'capvalue' VALUES (1207, 'tiff');
INSERT INTO 'devicecapvalue' VALUES (11652, 209, 15, 1207);
INSERT INTO 'devicecapvalue' VALUES (11653, 209, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (11654, 209, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11655, 209, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11656, 209, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11657, 209, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (11658, 209, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (11659, 209, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (11660, 209, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11661, 209, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11662, 209, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11663, 209, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11664, 209, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (11665, 209, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (11666, 209, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11667, 209, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11668, 209, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11669, 209, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (11670, 209, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (11671, 209, 27, 1168);
INSERT INTO 'devicecapvalue' VALUES (11672, 209, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (11673, 209, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (11674, 209, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (11675, 209, 92, 686);
INSERT INTO 'devicecapvalue' VALUES (11676, 209, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (11677, 209, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (11678, 209, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11679, 209, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11680, 209, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11681, 209, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (11682, 209, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11683, 209, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (11684, 209, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11685, 209, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11686, 209, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (11687, 209, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (11688, 210, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11689, 210, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11690, 210, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11691, 210, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (11692, 210, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (11693, 210, 93, 1194);
INSERT INTO 'devicecapvalue' VALUES (11694, 210, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11695, 210, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11696, 210, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11697, 210, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11698, 210, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (11699, 210, 150, 959);
INSERT INTO 'capvalue' VALUES (1208, '1153433');
INSERT INTO 'devicecapvalue' VALUES (11700, 210, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (11701, 210, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11702, 210, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (11703, 210, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11704, 210, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11705, 210, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11706, 210, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (11707, 210, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11708, 210, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11709, 210, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11710, 210, 17, 1204);
INSERT INTO 'devicecapvalue' VALUES (11711, 210, 17, 1128);
INSERT INTO 'capvalue' VALUES (1209, 'moto-flex');
INSERT INTO 'devicecapvalue' VALUES (11712, 210, 17, 1209);
INSERT INTO 'capvalue' VALUES (1210, 'moto-image');
INSERT INTO 'devicecapvalue' VALUES (11713, 210, 17, 1210);
INSERT INTO 'capvalue' VALUES (1211, 'moto-pim');
INSERT INTO 'devicecapvalue' VALUES (11714, 210, 17, 1211);
INSERT INTO 'devicecapvalue' VALUES (11715, 210, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (11716, 210, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (11717, 210, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11718, 210, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11719, 210, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (11720, 210, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11721, 210, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11722, 210, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11723, 210, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11724, 210, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (11725, 210, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11726, 210, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (11727, 210, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (11728, 210, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (11729, 210, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (11730, 210, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11731, 210, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11732, 210, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11733, 210, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (11734, 210, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11735, 210, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (11736, 210, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11737, 210, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (11738, 210, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11739, 210, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11740, 210, 52, 683);
INSERT INTO 'capvalue' VALUES (1212, 'MOT-L7e/AAUG2103AA 08.00.12R/10.21.2005 MIB/BER2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1 EGE/1.0');
INSERT INTO 'devicecapvalue' VALUES (11741, 210, 53, 1212);
INSERT INTO 'devicecapvalue' VALUES (11742, 211, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11743, 211, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11744, 211, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11745, 211, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (11746, 211, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (11747, 211, 93, 1194);
INSERT INTO 'devicecapvalue' VALUES (11748, 211, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11749, 211, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11750, 211, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11751, 211, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11752, 211, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (11753, 211, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (11754, 211, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (11755, 211, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11756, 211, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (11757, 211, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11758, 211, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11759, 211, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11760, 211, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (11761, 211, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11762, 211, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11763, 211, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11764, 211, 17, 1204);
INSERT INTO 'devicecapvalue' VALUES (11765, 211, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (11766, 211, 17, 1209);
INSERT INTO 'devicecapvalue' VALUES (11767, 211, 17, 1210);
INSERT INTO 'devicecapvalue' VALUES (11768, 211, 17, 1211);
INSERT INTO 'devicecapvalue' VALUES (11769, 211, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (11770, 211, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (11771, 211, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11772, 211, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11773, 211, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (11774, 211, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11775, 211, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11776, 211, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (11777, 211, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11778, 211, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (11779, 211, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11780, 211, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (11781, 211, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (11782, 211, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (11783, 211, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (11784, 211, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11785, 211, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11786, 211, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11787, 211, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (11788, 211, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11789, 211, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (11790, 211, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11791, 211, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (11792, 211, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11793, 211, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11794, 211, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (11795, 211, 53, 1212);
INSERT INTO 'devicecapvalue' VALUES (11796, 212, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11797, 212, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (11798, 212, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (11799, 212, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11800, 212, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11801, 212, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11802, 212, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11803, 212, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11804, 212, 50, 1031);
INSERT INTO 'devicecapvalue' VALUES (11805, 212, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11806, 212, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (11807, 212, 52, 1031);
INSERT INTO 'devicecapvalue' VALUES (11808, 213, 1, 1);
INSERT INTO 'capvalue' VALUES (1213, '176x179');
INSERT INTO 'devicecapvalue' VALUES (11809, 213, 7, 1213);
INSERT INTO 'devicecapvalue' VALUES (11810, 213, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11811, 213, 76, 1074);
INSERT INTO 'devicecapvalue' VALUES (11812, 213, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (11813, 213, 6, 27);
INSERT INTO 'capvalue' VALUES (1214, 'MS Smartphone 2002');
INSERT INTO 'devicecapvalue' VALUES (11814, 213, 3, 1214);
INSERT INTO 'devicecapvalue' VALUES (11815, 213, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11816, 213, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (11817, 214, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (11818, 214, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (11819, 214, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11820, 214, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11821, 214, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11822, 214, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11823, 214, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11824, 214, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11825, 214, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (11826, 215, 158, 1028);
INSERT INTO 'devicecapvalue' VALUES (11827, 215, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (11828, 215, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11829, 215, 7, 1030);
INSERT INTO 'devicecapvalue' VALUES (11830, 215, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11831, 215, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (11832, 215, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (11833, 215, 11, 110);
INSERT INTO 'devicecapvalue' VALUES (11834, 215, 12, 603);
INSERT INTO 'devicecapvalue' VALUES (11835, 215, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (11836, 215, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (11837, 215, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11838, 215, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (11839, 215, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11840, 215, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11841, 215, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11842, 215, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (11843, 215, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11844, 215, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (11845, 215, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11846, 215, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11847, 215, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (11848, 215, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (11849, 215, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11850, 215, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (11851, 215, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11852, 215, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11853, 215, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11854, 215, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11855, 215, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (11856, 215, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (11857, 215, 159, 625);
INSERT INTO 'devicecapvalue' VALUES (11858, 215, 155, 1033);
INSERT INTO 'devicecapvalue' VALUES (11859, 215, 3, 1034);
INSERT INTO 'devicecapvalue' VALUES (11860, 215, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11861, 215, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (11862, 215, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (11863, 215, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11864, 215, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (11865, 215, 51, 1038);
INSERT INTO 'devicecapvalue' VALUES (11866, 215, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11867, 215, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11868, 215, 51, 1040);
INSERT INTO 'devicecapvalue' VALUES (11869, 215, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (11870, 215, 51, 1042);
INSERT INTO 'devicecapvalue' VALUES (11871, 215, 52, 1043);
INSERT INTO 'devicecapvalue' VALUES (11872, 216, 158, 1136);
INSERT INTO 'devicecapvalue' VALUES (11873, 216, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (11874, 216, 74, 1029);
INSERT INTO 'capvalue' VALUES (1215, '240x254');
INSERT INTO 'devicecapvalue' VALUES (11875, 216, 7, 1215);
INSERT INTO 'devicecapvalue' VALUES (11876, 216, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11877, 216, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (11878, 216, 11, 110);
INSERT INTO 'devicecapvalue' VALUES (11879, 216, 12, 603);
INSERT INTO 'devicecapvalue' VALUES (11880, 216, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (11881, 216, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (11882, 216, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11883, 216, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (11884, 216, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11885, 216, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11886, 216, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11887, 216, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (11888, 216, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11889, 216, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (11890, 216, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11891, 216, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11892, 216, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (11893, 216, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (11894, 216, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11895, 216, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (11896, 216, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11897, 216, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11898, 216, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (11899, 216, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11900, 216, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (11901, 216, 27, 1102);
INSERT INTO 'devicecapvalue' VALUES (11902, 216, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (11903, 216, 159, 625);
INSERT INTO 'capvalue' VALUES (1216, '976kb');
INSERT INTO 'devicecapvalue' VALUES (11904, 216, 155, 1216);
INSERT INTO 'devicecapvalue' VALUES (11905, 216, 3, 1034);
INSERT INTO 'devicecapvalue' VALUES (11906, 216, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11907, 216, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (11908, 216, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (11909, 216, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11910, 216, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (11911, 216, 51, 1038);
INSERT INTO 'devicecapvalue' VALUES (11912, 216, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11913, 216, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11914, 216, 51, 1040);
INSERT INTO 'devicecapvalue' VALUES (11915, 216, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (11916, 216, 51, 1042);
INSERT INTO 'devicecapvalue' VALUES (11917, 216, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (11918, 217, 158, 1092);
INSERT INTO 'devicecapvalue' VALUES (11919, 217, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (11920, 217, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11921, 217, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11922, 217, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (11923, 217, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (11924, 217, 7, 859);
INSERT INTO 'devicecapvalue' VALUES (11925, 217, 93, 1194);
INSERT INTO 'devicecapvalue' VALUES (11926, 217, 75, 1195);
INSERT INTO 'devicecapvalue' VALUES (11927, 217, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (11928, 217, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11929, 217, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11930, 217, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11931, 217, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11932, 217, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (11933, 217, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (11934, 217, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (11935, 217, 76, 1196);
INSERT INTO 'devicecapvalue' VALUES (11936, 217, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11937, 217, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (11938, 217, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11939, 217, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11940, 217, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11941, 217, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (11942, 217, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11943, 217, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11944, 217, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11945, 217, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (11946, 217, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (11947, 217, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (11948, 217, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (11949, 217, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11950, 217, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (11951, 217, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (11952, 217, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (11953, 217, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (11954, 217, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (11955, 217, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (11956, 217, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (11957, 217, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (11958, 217, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (11959, 217, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (11960, 217, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (11961, 217, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (11962, 217, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (11963, 217, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (11964, 217, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (11965, 217, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (11966, 217, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (11967, 217, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (11968, 217, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (11969, 217, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (11970, 217, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (11971, 217, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (11972, 217, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (11973, 217, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (11974, 217, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (11975, 217, 53, 1198);
INSERT INTO 'devicecapvalue' VALUES (11976, 218, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (11977, 218, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (11978, 218, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (11979, 218, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (11980, 218, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (11981, 218, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (11982, 218, 162, 625);
INSERT INTO 'capvalue' VALUES (1217, 'MotorolaEmulatorA5');
INSERT INTO 'devicecapvalue' VALUES (11983, 218, 93, 1217);
INSERT INTO 'capvalue' VALUES (1218, 'MOTORAZR_maxx_V6.props');
INSERT INTO 'devicecapvalue' VALUES (11984, 218, 75, 1218);
INSERT INTO 'capvalue' VALUES (1219, '120x160');
INSERT INTO 'devicecapvalue' VALUES (11985, 218, 167, 1219);
INSERT INTO 'devicecapvalue' VALUES (11986, 218, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (11987, 218, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (11988, 218, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (11989, 218, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (11990, 218, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (11991, 218, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (11992, 218, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (11993, 218, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (11994, 218, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (11995, 218, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (11996, 218, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (11997, 218, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (11998, 218, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (11999, 218, 17, 1094);
INSERT INTO 'capvalue' VALUES (1220, 'mot-secDisplayapi');
INSERT INTO 'devicecapvalue' VALUES (12000, 218, 17, 1220);
INSERT INTO 'devicecapvalue' VALUES (12001, 218, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12002, 218, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (12003, 218, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12004, 218, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12005, 218, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12006, 218, 6, 27);
INSERT INTO 'capvalue' VALUES (1221, 'datagram');
INSERT INTO 'devicecapvalue' VALUES (12007, 218, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (12008, 218, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12009, 218, 154, 1014);
INSERT INTO 'capvalue' VALUES (1222, 'secure socketstream');
INSERT INTO 'devicecapvalue' VALUES (12010, 218, 154, 1222);
INSERT INTO 'capvalue' VALUES (1223, 'socketstream');
INSERT INTO 'devicecapvalue' VALUES (12011, 218, 154, 1223);
INSERT INTO 'devicecapvalue' VALUES (12012, 218, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (12013, 218, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (12014, 218, 92, 686);
INSERT INTO 'devicecapvalue' VALUES (12015, 218, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12016, 218, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12017, 218, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (12018, 218, 156, 1158);
INSERT INTO 'capvalue' VALUES (1224, 'Australia');
INSERT INTO 'devicecapvalue' VALUES (12019, 218, 156, 1224);
INSERT INTO 'devicecapvalue' VALUES (12020, 218, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (12021, 218, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12022, 218, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (12023, 218, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12024, 218, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (12025, 218, 51, 1097);
INSERT INTO 'capvalue' VALUES (1225, 'g723');
INSERT INTO 'devicecapvalue' VALUES (12026, 218, 51, 1225);
INSERT INTO 'devicecapvalue' VALUES (12027, 218, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (12028, 218, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (12029, 218, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (12030, 218, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (12031, 218, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (12032, 218, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (12033, 218, 51, 1160);
INSERT INTO 'capvalue' VALUES (1226, '67108864');
INSERT INTO 'devicecapvalue' VALUES (12034, 218, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (12035, 219, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (12036, 219, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (12037, 219, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12038, 219, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12039, 219, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12040, 219, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12041, 219, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12042, 219, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12043, 219, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (12044, 220, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (12045, 220, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (12046, 220, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12047, 220, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12048, 220, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12049, 220, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12050, 220, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12051, 220, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12052, 220, 5, 601);
INSERT INTO 'capvalue' VALUES (1227, '2006-07-07');
INSERT INTO 'devicecapvalue' VALUES (12053, 221, 158, 1227);
INSERT INTO 'devicecapvalue' VALUES (12054, 221, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (12055, 221, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (12056, 221, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (12057, 221, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (12058, 221, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (12059, 221, 93, 1126);
INSERT INTO 'capvalue' VALUES (1228, 'RAZR_V3.props');
INSERT INTO 'devicecapvalue' VALUES (12060, 221, 75, 1228);
INSERT INTO 'devicecapvalue' VALUES (12061, 221, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (12062, 221, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (12063, 221, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (12064, 221, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12065, 221, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12066, 221, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (12067, 221, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (12068, 221, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (12069, 221, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (12070, 221, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (12071, 221, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12072, 221, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12073, 221, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (12074, 221, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12075, 221, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12076, 221, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12077, 221, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (12078, 221, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (12079, 221, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (12080, 221, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12081, 221, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12082, 221, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12083, 221, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12084, 221, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12085, 221, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (12086, 221, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (12087, 221, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (12088, 221, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (12089, 221, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (12090, 221, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (12091, 221, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (12092, 221, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12093, 221, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12094, 221, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (12095, 221, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (12096, 221, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (12097, 221, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (12098, 221, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12099, 221, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (12100, 221, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (12101, 221, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (12102, 221, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (12103, 221, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (12104, 221, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (12105, 222, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (12106, 222, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (12107, 222, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (12108, 222, 74, 1058);
INSERT INTO 'capvalue' VALUES (1229, '1.23 MP');
INSERT INTO 'devicecapvalue' VALUES (12109, 222, 160, 1229);
INSERT INTO 'devicecapvalue' VALUES (12110, 222, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (12111, 222, 93, 1126);
INSERT INTO 'capvalue' VALUES (1230, 'V3i_V3e_V3t.props');
INSERT INTO 'devicecapvalue' VALUES (12112, 222, 75, 1230);
INSERT INTO 'devicecapvalue' VALUES (12113, 222, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (12114, 222, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (12115, 222, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12116, 222, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12117, 222, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (12118, 222, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (12119, 222, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (12120, 222, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (12121, 222, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12122, 222, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12123, 222, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12124, 222, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12125, 222, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12126, 222, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (12127, 222, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (12128, 222, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12129, 222, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (12130, 222, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12131, 222, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12132, 222, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12133, 222, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12134, 222, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (12135, 222, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12136, 222, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (12137, 222, 154, 1222);
INSERT INTO 'devicecapvalue' VALUES (12138, 222, 154, 1223);
INSERT INTO 'devicecapvalue' VALUES (12139, 222, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (12140, 222, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (12141, 222, 92, 686);
INSERT INTO 'devicecapvalue' VALUES (12142, 222, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12143, 222, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12144, 222, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (12145, 222, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (12146, 222, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (12147, 222, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (12148, 222, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12149, 222, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (12150, 222, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (12151, 222, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (12152, 222, 51, 1039);
INSERT INTO 'capvalue' VALUES (1231, '2006-11-07');
INSERT INTO 'devicecapvalue' VALUES (12153, 223, 158, 1231);
INSERT INTO 'devicecapvalue' VALUES (12154, 223, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (12155, 223, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (12156, 223, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (12157, 223, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (12158, 223, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (12159, 223, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (12160, 223, 75, 1230);
INSERT INTO 'devicecapvalue' VALUES (12161, 223, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (12162, 223, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (12163, 223, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (12164, 223, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12165, 223, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12166, 223, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (12167, 223, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (12168, 223, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (12169, 223, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (12170, 223, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12171, 223, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12172, 223, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12173, 223, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12174, 223, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12175, 223, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12176, 223, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12177, 223, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12178, 223, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12179, 223, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12180, 223, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12181, 223, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (12182, 223, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (12183, 223, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (12184, 223, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (12185, 223, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (12186, 223, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12187, 223, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12188, 223, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (12189, 223, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (12190, 223, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (12191, 223, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (12192, 223, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12193, 223, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (12194, 223, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (12195, 223, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (12196, 223, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (12197, 223, 52, 93);
INSERT INTO 'capvalue' VALUES (1232, 'MOT-V3i/04.25.02_ MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (12198, 223, 53, 1232);
INSERT INTO 'devicecapvalue' VALUES (12199, 224, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (12200, 224, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (12201, 224, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (12202, 224, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (12203, 224, 160, 1229);
INSERT INTO 'devicecapvalue' VALUES (12204, 224, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (12205, 224, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (12206, 224, 75, 1230);
INSERT INTO 'devicecapvalue' VALUES (12207, 224, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (12208, 224, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (12209, 224, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12210, 224, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12211, 224, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (12212, 224, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (12213, 224, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (12214, 224, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (12215, 224, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12216, 224, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12217, 224, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12218, 224, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12219, 224, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12220, 224, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (12221, 224, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (12222, 224, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12223, 224, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (12224, 224, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12225, 224, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12226, 224, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12227, 224, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12228, 224, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (12229, 224, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12230, 224, 154, 1014);
INSERT INTO 'capvalue' VALUES (1233, 'secure socket stream');
INSERT INTO 'devicecapvalue' VALUES (12231, 224, 154, 1233);
INSERT INTO 'devicecapvalue' VALUES (12232, 224, 154, 1223);
INSERT INTO 'devicecapvalue' VALUES (12233, 224, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (12234, 224, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (12235, 224, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (12236, 224, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12237, 224, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12238, 224, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (12239, 224, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (12240, 224, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (12241, 224, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (12242, 224, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12243, 224, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (12244, 224, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (12245, 224, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (12246, 224, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (12247, 224, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (12248, 225, 1, 106);
INSERT INTO 'capvalue' VALUES (1234, 'ReducedMessageLength');
INSERT INTO 'devicecapvalue' VALUES (12249, 225, 74, 1234);
INSERT INTO 'devicecapvalue' VALUES (12250, 225, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (12251, 225, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (12252, 225, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (12253, 225, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (12254, 225, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (12255, 225, 93, 1112);
INSERT INTO 'capvalue' VALUES (1235, 'RAZR_V3x.props');
INSERT INTO 'devicecapvalue' VALUES (12256, 225, 75, 1235);
INSERT INTO 'devicecapvalue' VALUES (12257, 225, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (12258, 225, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (12259, 225, 2, 1001);
INSERT INTO 'capvalue' VALUES (1236, '33');
INSERT INTO 'devicecapvalue' VALUES (12260, 225, 10, 1236);
INSERT INTO 'devicecapvalue' VALUES (12261, 225, 11, 604);
INSERT INTO 'devicecapvalue' VALUES (12262, 225, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (12263, 225, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12264, 225, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12265, 225, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (12266, 225, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (12267, 225, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (12268, 225, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12269, 225, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12270, 225, 16, 20);
INSERT INTO 'capvalue' VALUES (1237, 'JSR84');
INSERT INTO 'devicecapvalue' VALUES (12271, 225, 17, 1237);
INSERT INTO 'devicecapvalue' VALUES (12272, 225, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12273, 225, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12274, 225, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12275, 225, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12276, 225, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12277, 225, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12278, 225, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12279, 225, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12280, 225, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (12281, 225, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (12282, 225, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (12283, 225, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (12284, 225, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (12285, 225, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (12286, 225, 27, 1102);
INSERT INTO 'devicecapvalue' VALUES (12287, 225, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (12288, 225, 50, 1169);
INSERT INTO 'devicecapvalue' VALUES (12289, 225, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (12290, 225, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (12291, 225, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12292, 225, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12293, 225, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (12294, 225, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (12295, 225, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12296, 225, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (12297, 225, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12298, 225, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (12299, 225, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (12300, 225, 51, 1039);
INSERT INTO 'capvalue' VALUES (1238, 'ra9');
INSERT INTO 'devicecapvalue' VALUES (12301, 225, 51, 1238);
INSERT INTO 'devicecapvalue' VALUES (12302, 225, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (12303, 225, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (12304, 225, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (12305, 225, 52, 1226);
INSERT INTO 'capvalue' VALUES (1239, 'MOT-RAZRV3x/01.2D.02 MIB/BER2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (12306, 225, 53, 1239);
INSERT INTO 'devicecapvalue' VALUES (12307, 226, 158, 1092);
INSERT INTO 'devicecapvalue' VALUES (12308, 226, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (12309, 226, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (12310, 226, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (12311, 226, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (12312, 226, 162, 625);
INSERT INTO 'capvalue' VALUES (1240, '240x267');
INSERT INTO 'devicecapvalue' VALUES (12313, 226, 7, 1240);
INSERT INTO 'devicecapvalue' VALUES (12314, 226, 93, 1217);
INSERT INTO 'capvalue' VALUES (1241, 'MOTORAZR_V3xx.props');
INSERT INTO 'devicecapvalue' VALUES (12315, 226, 75, 1241);
INSERT INTO 'devicecapvalue' VALUES (12316, 226, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (12317, 226, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (12318, 226, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (12319, 226, 10, 1236);
INSERT INTO 'devicecapvalue' VALUES (12320, 226, 11, 604);
INSERT INTO 'devicecapvalue' VALUES (12321, 226, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (12322, 226, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12323, 226, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12324, 226, 150, 959);
INSERT INTO 'capvalue' VALUES (1242, '240x300');
INSERT INTO 'devicecapvalue' VALUES (12325, 226, 13, 1242);
INSERT INTO 'devicecapvalue' VALUES (12326, 226, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (12327, 226, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (12328, 226, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (12329, 226, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12330, 226, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12331, 226, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12332, 226, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12333, 226, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (12334, 226, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12335, 226, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (12336, 226, 17, 1220);
INSERT INTO 'devicecapvalue' VALUES (12337, 226, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12338, 226, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (12339, 226, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12340, 226, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12341, 226, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12342, 226, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12343, 226, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (12344, 226, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12345, 226, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (12346, 226, 154, 1073);
INSERT INTO 'capvalue' VALUES (1243, 'socket stream');
INSERT INTO 'devicecapvalue' VALUES (12347, 226, 154, 1243);
INSERT INTO 'devicecapvalue' VALUES (12348, 226, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (12349, 226, 27, 1102);
INSERT INTO 'devicecapvalue' VALUES (12350, 226, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (12351, 226, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (12352, 226, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12353, 226, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12354, 226, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (12355, 226, 156, 1158);
INSERT INTO 'devicecapvalue' VALUES (12356, 226, 156, 1224);
INSERT INTO 'devicecapvalue' VALUES (12357, 226, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (12358, 226, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12359, 226, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (12360, 226, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12361, 226, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (12362, 226, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (12363, 226, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (12364, 226, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (12365, 226, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (12366, 227, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (12367, 227, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (12368, 227, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (12369, 227, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (12370, 227, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (12371, 227, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (12372, 227, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (12373, 227, 93, 1194);
INSERT INTO 'devicecapvalue' VALUES (12374, 227, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (12375, 227, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (12376, 227, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (12377, 227, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (12378, 227, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (12379, 227, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (12380, 227, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12381, 227, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12382, 227, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (12383, 227, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (12384, 227, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (12385, 227, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12386, 227, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12387, 227, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12388, 227, 17, 1237);
INSERT INTO 'devicecapvalue' VALUES (12389, 227, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12390, 227, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12391, 227, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12392, 227, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12393, 227, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12394, 227, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12395, 227, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12396, 227, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12397, 227, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (12398, 227, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (12399, 227, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (12400, 227, 18, 625);
INSERT INTO 'devicecapvalue' VALUES (12401, 227, 163, 606);
INSERT INTO 'capvalue' VALUES (1244, '-10');
INSERT INTO 'devicecapvalue' VALUES (12402, 227, 26, 1244);
INSERT INTO 'devicecapvalue' VALUES (12403, 227, 27, 30);
INSERT INTO 'capvalue' VALUES (1245, '-11');
INSERT INTO 'devicecapvalue' VALUES (12404, 227, 30, 1245);
INSERT INTO 'devicecapvalue' VALUES (12405, 227, 50, 1169);
INSERT INTO 'devicecapvalue' VALUES (12406, 227, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (12407, 227, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (12408, 227, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12409, 227, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12410, 227, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (12411, 227, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (12412, 227, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12413, 227, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (12414, 227, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12415, 227, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (12416, 227, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (12417, 227, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (12418, 227, 51, 1238);
INSERT INTO 'devicecapvalue' VALUES (12419, 227, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (12420, 227, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (12421, 227, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (12422, 227, 52, 1226);
INSERT INTO 'capvalue' VALUES (1246, '2007-01-18');
INSERT INTO 'devicecapvalue' VALUES (12423, 228, 158, 1246);
INSERT INTO 'devicecapvalue' VALUES (12424, 228, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (12425, 228, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (12426, 228, 74, 1058);
INSERT INTO 'capvalue' VALUES (1247, '2.0 MP');
INSERT INTO 'devicecapvalue' VALUES (12427, 228, 160, 1247);
INSERT INTO 'devicecapvalue' VALUES (12428, 228, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (12429, 228, 93, 1194);
INSERT INTO 'capvalue' VALUES (1248, 'MOTORIZR_Z3.props');
INSERT INTO 'devicecapvalue' VALUES (12430, 228, 75, 1248);
INSERT INTO 'devicecapvalue' VALUES (12431, 228, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (12432, 228, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (12433, 228, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12434, 228, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12435, 228, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (12436, 228, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (12437, 228, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (12438, 228, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (12439, 228, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (12440, 228, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (12441, 228, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12442, 228, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12443, 228, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (12444, 228, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12445, 228, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12446, 228, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12447, 228, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (12448, 228, 17, 1128);
INSERT INTO 'capvalue' VALUES (1249, 'motorola-scalableImageEnhancements-api');
INSERT INTO 'devicecapvalue' VALUES (12449, 228, 17, 1249);
INSERT INTO 'devicecapvalue' VALUES (12450, 228, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12451, 228, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (12452, 228, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12453, 228, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12454, 228, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12455, 228, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12456, 228, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12457, 228, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (12458, 228, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (12459, 228, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (12460, 228, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (12461, 228, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (12462, 228, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (12463, 228, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (12464, 228, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (12465, 228, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12466, 228, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12467, 228, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (12468, 228, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (12469, 228, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (12470, 228, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (12471, 228, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12472, 228, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (12473, 228, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (12474, 228, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (12475, 228, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (12476, 228, 52, 683);
INSERT INTO 'capvalue' VALUES (1250, 'MOT-Z3/SJUG1769EA 08.01.02R/10.21.2005 MIB/BER2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1 EGE/1.0');
INSERT INTO 'devicecapvalue' VALUES (12477, 228, 53, 1250);
INSERT INTO 'devicecapvalue' VALUES (12478, 229, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (12479, 229, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (12480, 229, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12481, 229, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12482, 229, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12483, 229, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12484, 229, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12485, 229, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12486, 229, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (12487, 230, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (12488, 230, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (12489, 230, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12490, 230, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12491, 230, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12492, 230, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12493, 230, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12494, 230, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12495, 230, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (12496, 231, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (12497, 231, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (12498, 231, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12499, 231, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12500, 231, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12501, 231, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12502, 231, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12503, 231, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12504, 231, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (12505, 232, 158, 1070);
INSERT INTO 'devicecapvalue' VALUES (12506, 232, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (12507, 232, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (12508, 232, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (12509, 232, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (12510, 232, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (12511, 232, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (12512, 232, 75, 1127);
INSERT INTO 'devicecapvalue' VALUES (12513, 232, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (12514, 232, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (12515, 232, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12516, 232, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12517, 232, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (12518, 232, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (12519, 232, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (12520, 232, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (12521, 232, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (12522, 232, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12523, 232, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12524, 232, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (12525, 232, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12526, 232, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12527, 232, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (12528, 232, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (12529, 232, 17, 1129);
INSERT INTO 'devicecapvalue' VALUES (12530, 232, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12531, 232, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12532, 232, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12533, 232, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12534, 232, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12535, 232, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12536, 232, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (12537, 232, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (12538, 232, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (12539, 232, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (12540, 232, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12541, 232, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12542, 232, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (12543, 232, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (12544, 232, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (12545, 232, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (12546, 232, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12547, 232, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (12548, 232, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (12549, 232, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (12550, 232, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (12551, 232, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (12552, 232, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (12553, 232, 53, 1131);
INSERT INTO 'devicecapvalue' VALUES (12554, 233, 158, 1142);
INSERT INTO 'devicecapvalue' VALUES (12555, 233, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (12556, 233, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (12557, 233, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (12558, 233, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (12559, 233, 93, 1081);
INSERT INTO 'devicecapvalue' VALUES (12560, 233, 75, 1143);
INSERT INTO 'devicecapvalue' VALUES (12561, 233, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (12562, 233, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (12563, 233, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12564, 233, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12565, 233, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (12566, 233, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (12567, 233, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (12568, 233, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12569, 233, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12570, 233, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12571, 233, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12572, 233, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12573, 233, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (12574, 233, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (12575, 233, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12576, 233, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (12577, 233, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12578, 233, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12579, 233, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12580, 233, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12581, 233, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12582, 233, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (12583, 233, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (12584, 233, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (12585, 233, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (12586, 233, 161, 693);
INSERT INTO 'devicecapvalue' VALUES (12587, 233, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12588, 233, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12589, 233, 3, 1034);
INSERT INTO 'devicecapvalue' VALUES (12590, 233, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (12591, 233, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12592, 233, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (12593, 233, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12594, 233, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (12595, 233, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (12596, 233, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (12597, 233, 51, 1144);
INSERT INTO 'devicecapvalue' VALUES (12598, 233, 51, 1040);
INSERT INTO 'devicecapvalue' VALUES (12599, 233, 51, 1145);
INSERT INTO 'devicecapvalue' VALUES (12600, 233, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (12601, 233, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (12602, 233, 51, 1146);
INSERT INTO 'devicecapvalue' VALUES (12603, 233, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (12604, 233, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (12605, 234, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (12606, 234, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (12607, 234, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (12608, 234, 93, 1081);
INSERT INTO 'devicecapvalue' VALUES (12609, 234, 75, 1155);
INSERT INTO 'devicecapvalue' VALUES (12610, 234, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (12611, 234, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (12612, 234, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (12613, 234, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12614, 234, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12615, 234, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (12616, 234, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (12617, 234, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (12618, 234, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (12619, 234, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (12620, 234, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (12621, 234, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12622, 234, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12623, 234, 15, 1156);
INSERT INTO 'devicecapvalue' VALUES (12624, 234, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12625, 234, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12626, 234, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (12627, 234, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12628, 234, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12629, 234, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (12630, 234, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12631, 234, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12632, 234, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12633, 234, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12634, 234, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12635, 234, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (12636, 234, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (12637, 234, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (12638, 234, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (12639, 234, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (12640, 234, 155, 1157);
INSERT INTO 'devicecapvalue' VALUES (12641, 234, 161, 693);
INSERT INTO 'devicecapvalue' VALUES (12642, 234, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12643, 234, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12644, 234, 3, 1034);
INSERT INTO 'devicecapvalue' VALUES (12645, 234, 156, 1158);
INSERT INTO 'devicecapvalue' VALUES (12646, 234, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (12647, 234, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12648, 234, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (12649, 234, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12650, 234, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (12651, 234, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (12652, 234, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (12653, 234, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (12654, 234, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (12655, 234, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (12656, 234, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (12657, 234, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (12658, 234, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (12659, 234, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (12660, 235, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (12661, 235, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (12662, 235, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (12663, 235, 93, 1081);
INSERT INTO 'devicecapvalue' VALUES (12664, 235, 75, 1155);
INSERT INTO 'devicecapvalue' VALUES (12665, 235, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (12666, 235, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (12667, 235, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (12668, 235, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (12669, 235, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (12670, 235, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (12671, 235, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (12672, 235, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (12673, 235, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (12674, 235, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (12675, 235, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (12676, 235, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12677, 235, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (12678, 235, 15, 1156);
INSERT INTO 'devicecapvalue' VALUES (12679, 235, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12680, 235, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12681, 235, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (12682, 235, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12683, 235, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (12684, 235, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (12685, 235, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12686, 235, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12687, 235, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12688, 235, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12689, 235, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (12690, 235, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (12691, 235, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (12692, 235, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (12693, 235, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (12694, 235, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (12695, 235, 155, 1157);
INSERT INTO 'devicecapvalue' VALUES (12696, 235, 161, 693);
INSERT INTO 'devicecapvalue' VALUES (12697, 235, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (12698, 235, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (12699, 235, 3, 1171);
INSERT INTO 'devicecapvalue' VALUES (12700, 235, 156, 1158);
INSERT INTO 'devicecapvalue' VALUES (12701, 235, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (12702, 235, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (12703, 235, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (12704, 235, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (12705, 235, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (12706, 235, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (12707, 235, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (12708, 235, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (12709, 235, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (12710, 235, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (12711, 235, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (12712, 235, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (12713, 235, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (12714, 235, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (12715, 236, 56, 238);
INSERT INTO 'devicecapvalue' VALUES (12716, 236, 7, 1213);
INSERT INTO 'devicecapvalue' VALUES (12717, 236, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (12718, 236, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (12719, 236, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (12720, 236, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (12721, 236, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (12722, 236, 12, 709);
INSERT INTO 'devicecapvalue' VALUES (12723, 236, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (12724, 236, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (12725, 236, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (12726, 236, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (12727, 236, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (12728, 236, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (12729, 236, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (12730, 236, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (12731, 236, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (12732, 236, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (12733, 236, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (12734, 236, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12735, 236, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (12736, 236, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (12737, 236, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (12738, 236, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (12739, 236, 19, 36);
INSERT INTO 'devicecapvalue' VALUES (12740, 236, 20, 1102);
INSERT INTO 'devicecapvalue' VALUES (12741, 236, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (12742, 236, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (12743, 236, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (12744, 236, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (12745, 236, 25, 29);
INSERT INTO 'devicecapvalue' VALUES (12746, 236, 26, 29);
INSERT INTO 'devicecapvalue' VALUES (12747, 236, 27, 1102);
INSERT INTO 'devicecapvalue' VALUES (12748, 236, 57, 662);
INSERT INTO 'devicecapvalue' VALUES (12749, 236, 29, 30);
INSERT INTO 'devicecapvalue' VALUES (12750, 236, 30, 30);
INSERT INTO 'devicecapvalue' VALUES (12751, 236, 54, 666);
INSERT INTO 'devicecapvalue' VALUES (12752, 236, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (12753, 236, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (12754, 236, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (12755, 236, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (12756, 236, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (12757, 236, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (12758, 236, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (12759, 236, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (12760, 236, 41, 59);
INSERT INTO 'capvalue' VALUES (1251, 'audio/imy');
INSERT INTO 'devicecapvalue' VALUES (12761, 236, 41, 1251);
INSERT INTO 'devicecapvalue' VALUES (12762, 236, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (12763, 236, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (12764, 236, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (12765, 236, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (12766, 236, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (12767, 236, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (12768, 236, 41, 869);
INSERT INTO 'capvalue' VALUES (1252, 'audio/mpg');
INSERT INTO 'devicecapvalue' VALUES (12769, 236, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (12770, 236, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (12771, 236, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (12772, 236, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (12773, 236, 41, 128);
INSERT INTO 'capvalue' VALUES (1253, 'audio/x-imy');
INSERT INTO 'devicecapvalue' VALUES (12774, 236, 41, 1253);
INSERT INTO 'devicecapvalue' VALUES (12775, 236, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (12776, 236, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (12777, 236, 41, 870);
INSERT INTO 'capvalue' VALUES (1254, 'audio/x-mp4');
INSERT INTO 'devicecapvalue' VALUES (12778, 236, 41, 1254);
INSERT INTO 'capvalue' VALUES (1255, 'audio/x-mpeg');
INSERT INTO 'devicecapvalue' VALUES (12779, 236, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (12780, 236, 41, 871);
INSERT INTO 'capvalue' VALUES (1256, 'audio/x-mpg');
INSERT INTO 'devicecapvalue' VALUES (12781, 236, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (12782, 236, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (12783, 236, 41, 51);
INSERT INTO 'capvalue' VALUES (1257, 'text/x-imelody');
INSERT INTO 'devicecapvalue' VALUES (12784, 236, 41, 1257);
INSERT INTO 'devicecapvalue' VALUES (12785, 236, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (12786, 236, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (12787, 236, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (12788, 236, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (12789, 236, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (12790, 236, 42, 1251);
INSERT INTO 'devicecapvalue' VALUES (12791, 236, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (12792, 236, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (12793, 236, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (12794, 236, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (12795, 236, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (12796, 236, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (12797, 236, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (12798, 236, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (12799, 236, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (12800, 236, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (12801, 236, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (12802, 236, 42, 128);
INSERT INTO 'devicecapvalue' VALUES (12803, 236, 42, 1253);
INSERT INTO 'devicecapvalue' VALUES (12804, 236, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (12805, 236, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (12806, 236, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (12807, 236, 42, 1254);
INSERT INTO 'devicecapvalue' VALUES (12808, 236, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (12809, 236, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (12810, 236, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (12811, 236, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (12812, 236, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (12813, 236, 42, 1257);
INSERT INTO 'devicecapvalue' VALUES (12814, 236, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (12815, 236, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (12816, 236, 58, 1);
INSERT INTO 'devicecapvalue' VALUES (12817, 236, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (12818, 236, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (12819, 236, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (12820, 236, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (12821, 236, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (12822, 236, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (12823, 236, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (12824, 236, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (12825, 236, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (12826, 236, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (12827, 236, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (12828, 236, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (12829, 236, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (12830, 236, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (12831, 236, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (12832, 236, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (12833, 236, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (12834, 236, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (12835, 236, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (12836, 236, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (12837, 236, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (12838, 236, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (12839, 236, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (12840, 236, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (12841, 236, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (12842, 236, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (12843, 236, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (12844, 236, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (12845, 236, 46, 142);
INSERT INTO 'capvalue' VALUES (1258, 'encoding=audio/amr');
INSERT INTO 'devicecapvalue' VALUES (12846, 236, 115, 1258);
INSERT INTO 'devicecapvalue' VALUES (12847, 236, 118, 612);
INSERT INTO 'devicecapvalue' VALUES (12848, 236, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (12849, 236, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (12850, 236, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (12851, 236, 122, 244);
INSERT INTO 'capvalue' VALUES (1259, '1024');
INSERT INTO 'devicecapvalue' VALUES (12852, 236, 123, 1259);
INSERT INTO 'devicecapvalue' VALUES (12853, 236, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (12854, 236, 125, 603);
INSERT INTO 'devicecapvalue' VALUES (12855, 236, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (12856, 236, 59, 602);
INSERT INTO 'capvalue' VALUES (1260, 'COM0');
INSERT INTO 'devicecapvalue' VALUES (12857, 236, 114, 1260);
INSERT INTO 'devicecapvalue' VALUES (12858, 236, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (12859, 236, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (12860, 236, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (12861, 236, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (12862, 236, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (12863, 236, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (12864, 236, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (12865, 236, 68, 243);
INSERT INTO 'devicecapvalue' VALUES (12866, 236, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (12867, 236, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (12868, 236, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (12869, 236, 71, 15);
INSERT INTO 'capvalue' VALUES (1261, '+541151740050');
INSERT INTO 'devicecapvalue' VALUES (12870, 236, 138, 1261);
INSERT INTO 'devicecapvalue' VALUES (12871, 236, 72, 1261);
INSERT INTO 'devicecapvalue' VALUES (12872, 236, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (12873, 236, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (12874, 236, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (12875, 236, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (12876, 236, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (12877, 236, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (12878, 236, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (12879, 236, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (12880, 236, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (12881, 236, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (12882, 236, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (12883, 236, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (12884, 236, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (12885, 236, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (12886, 236, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (12887, 236, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (12888, 236, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (12889, 236, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (12890, 236, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (12891, 236, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (12892, 236, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (12893, 236, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (12894, 236, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (12895, 236, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (12896, 236, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (12897, 236, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (12898, 236, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (12899, 236, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (12900, 236, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (12901, 236, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (12902, 236, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (12903, 236, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (12904, 236, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (12905, 236, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (12906, 236, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (12907, 236, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (12908, 236, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (12909, 236, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (12910, 236, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (12911, 236, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (12912, 236, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (12913, 236, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (12914, 236, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (12915, 236, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (12916, 236, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (12917, 236, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (12918, 236, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (12919, 236, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (12920, 236, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (12921, 236, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (12922, 236, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (12923, 236, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (12924, 236, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (12925, 236, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (12926, 236, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (12927, 236, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (12928, 236, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (12929, 236, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (12930, 236, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (12931, 236, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (12932, 236, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (12933, 236, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (12934, 236, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (12935, 236, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (12936, 236, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (12937, 236, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (12938, 236, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (12939, 236, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (12940, 236, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (12941, 236, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (12942, 236, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (12943, 236, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (12944, 236, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (12945, 236, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (12946, 236, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (12947, 236, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (12948, 236, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (12949, 236, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (12950, 236, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (12951, 236, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (12952, 236, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (12953, 236, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (12954, 236, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (12955, 236, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (12956, 236, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (12957, 236, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (12958, 236, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (12959, 236, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (12960, 236, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (12961, 236, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (12962, 236, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (12963, 236, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (12964, 236, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (12965, 236, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (12966, 236, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (12967, 236, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (12968, 236, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (12969, 236, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (12970, 236, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (12971, 236, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (12972, 236, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (12973, 236, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (12974, 236, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (12975, 236, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (12976, 236, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (12977, 236, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (12978, 236, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (12979, 236, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (12980, 236, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (12981, 236, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (12982, 236, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (12983, 236, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (12984, 236, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (12985, 236, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (12986, 236, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (12987, 236, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (12988, 236, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (12989, 236, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (12990, 236, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (12991, 236, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (12992, 236, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (12993, 236, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (12994, 236, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (12995, 236, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (12996, 236, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (12997, 236, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (12998, 236, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (12999, 236, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (13000, 236, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (13001, 236, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (13002, 236, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (13003, 236, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (13004, 236, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (13005, 236, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (13006, 236, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (13007, 236, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (13008, 236, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (13009, 236, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (13010, 236, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (13011, 236, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (13012, 236, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (13013, 236, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (13014, 236, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (13015, 236, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (13016, 236, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (13017, 236, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (13018, 236, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (13019, 236, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (13020, 236, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (13021, 236, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (13022, 236, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (13023, 236, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (13024, 236, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (13025, 236, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (13026, 236, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (13027, 236, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (13028, 236, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (13029, 236, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (13030, 236, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (13031, 236, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (13032, 236, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (13033, 236, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (13034, 236, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (13035, 236, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (13036, 236, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (13037, 236, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (13038, 236, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (13039, 236, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (13040, 236, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (13041, 236, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (13042, 236, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (13043, 236, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (13044, 236, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (13045, 236, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (13046, 236, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (13047, 236, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (13048, 236, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (13049, 236, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (13050, 236, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (13051, 236, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (13052, 236, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (13053, 236, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (13054, 236, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (13055, 236, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (13056, 236, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (13057, 236, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (13058, 236, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (13059, 236, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (13060, 236, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (13061, 236, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (13062, 236, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (13063, 236, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (13064, 236, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (13065, 236, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (13066, 236, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (13067, 236, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (13068, 236, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (13069, 236, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (13070, 236, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (13071, 236, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (13072, 236, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (13073, 236, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (13074, 236, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (13075, 236, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (13076, 236, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (13077, 236, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (13078, 236, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (13079, 236, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (13080, 236, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (13081, 236, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (13082, 236, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (13083, 236, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (13084, 236, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (13085, 236, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (13086, 236, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (13087, 236, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (13088, 236, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (13089, 236, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (13090, 236, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (13091, 236, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (13092, 236, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (13093, 236, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (13094, 236, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (13095, 236, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (13096, 236, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (13097, 236, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (13098, 236, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (13099, 236, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (13100, 236, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (13101, 236, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (13102, 236, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (13103, 236, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (13104, 236, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (13105, 236, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (13106, 236, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (13107, 236, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (13108, 236, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (13109, 236, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (13110, 236, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (13111, 236, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (13112, 236, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (13113, 236, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (13114, 236, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (13115, 236, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (13116, 236, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (13117, 236, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (13118, 236, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (13119, 236, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (13120, 236, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (13121, 236, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (13122, 236, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (13123, 236, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (13124, 236, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (13125, 236, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (13126, 236, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (13127, 236, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (13128, 236, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (13129, 236, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (13130, 236, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (13131, 236, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (13132, 236, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (13133, 236, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (13134, 236, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (13135, 236, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (13136, 236, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (13137, 236, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (13138, 236, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (13139, 236, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (13140, 236, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (13141, 236, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (13142, 236, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (13143, 236, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (13144, 236, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (13145, 236, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (13146, 236, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (13147, 236, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (13148, 236, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (13149, 236, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (13150, 236, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (13151, 236, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (13152, 236, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (13153, 236, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (13154, 236, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (13155, 236, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (13156, 236, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (13157, 236, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (13158, 236, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (13159, 236, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (13160, 236, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (13161, 236, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (13162, 236, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (13163, 236, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (13164, 236, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (13165, 236, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (13166, 236, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (13167, 236, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (13168, 236, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (13169, 236, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (13170, 236, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (13171, 236, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (13172, 236, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (13173, 236, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (13174, 236, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (13175, 236, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (13176, 236, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (13177, 236, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (13178, 236, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (13179, 236, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (13180, 236, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (13181, 236, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (13182, 236, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (13183, 236, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (13184, 236, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (13185, 236, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (13186, 236, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (13187, 236, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (13188, 236, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (13189, 236, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (13190, 236, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (13191, 236, 48, 562);
INSERT INTO 'capvalue' VALUES (1262, '1042764');
INSERT INTO 'devicecapvalue' VALUES (13192, 236, 49, 1262);
INSERT INTO 'capvalue' VALUES (1263, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/525.19 (KHTML');
INSERT INTO 'devicecapvalue' VALUES (13193, 236, 53, 1263);
INSERT INTO 'capvalue' VALUES (1264, 'like Gecko) Chrome/0.3.154.9 Safari/525.19');
INSERT INTO 'devicecapvalue' VALUES (13194, 236, 53, 1264);
INSERT INTO 'devicecapvalue' VALUES (13195, 237, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13196, 237, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (13197, 237, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (13198, 237, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (13199, 237, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (13200, 237, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (13201, 237, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (13202, 237, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (13203, 237, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (13204, 237, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (13205, 237, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (13206, 237, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (13207, 237, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (13208, 237, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (13209, 237, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (13210, 237, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13211, 237, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (13212, 237, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (13213, 237, 17, 1209);
INSERT INTO 'devicecapvalue' VALUES (13214, 237, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (13215, 237, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (13216, 237, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13217, 237, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13218, 237, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (13219, 237, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13220, 237, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (13221, 237, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (13222, 237, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (13223, 237, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (13224, 237, 155, 1157);
INSERT INTO 'devicecapvalue' VALUES (13225, 237, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (13226, 237, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (13227, 237, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (13228, 237, 3, 1171);
INSERT INTO 'devicecapvalue' VALUES (13229, 237, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (13230, 237, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (13231, 237, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (13232, 237, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (13233, 237, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (13234, 237, 51, 100);
INSERT INTO 'capvalue' VALUES (1265, 'amr-mb');
INSERT INTO 'devicecapvalue' VALUES (13235, 237, 51, 1265);
INSERT INTO 'capvalue' VALUES (1266, 'amr-wb');
INSERT INTO 'devicecapvalue' VALUES (13236, 237, 51, 1266);
INSERT INTO 'devicecapvalue' VALUES (13237, 237, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (13238, 237, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (13239, 237, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (13240, 237, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (13241, 237, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (13242, 237, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (13243, 237, 52, 1226);
INSERT INTO 'capvalue' VALUES (1267, 'MOTOROKR Z6/R60_G_80.xx.yyI Mozilla/4.0 (compatible; MSIE 6.0 Linux; MOTOROKR Z6;nnn) Profile/MIDP-2.0 Configuration/CLDC-1.1 Opera 8.50[yy]');
INSERT INTO 'devicecapvalue' VALUES (13244, 237, 53, 1267);
INSERT INTO 'devicecapvalue' VALUES (13245, 238, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13246, 238, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (13247, 238, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13248, 238, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (13249, 238, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13250, 238, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13251, 238, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13252, 238, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (13253, 238, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (13254, 239, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13255, 239, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (13256, 239, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13257, 239, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (13258, 239, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13259, 239, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13260, 239, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13261, 239, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (13262, 239, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (13263, 240, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13264, 240, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (13265, 240, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13266, 240, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (13267, 240, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13268, 240, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13269, 240, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13270, 240, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (13271, 240, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (13272, 241, 158, 1142);
INSERT INTO 'devicecapvalue' VALUES (13273, 241, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (13274, 241, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (13275, 241, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (13276, 241, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (13277, 241, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (13278, 241, 75, 1206);
INSERT INTO 'devicecapvalue' VALUES (13279, 241, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (13280, 241, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (13281, 241, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (13282, 241, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (13283, 241, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (13284, 241, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (13285, 241, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (13286, 241, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (13287, 241, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (13288, 241, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (13289, 241, 15, 1207);
INSERT INTO 'devicecapvalue' VALUES (13290, 241, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (13291, 241, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13292, 241, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (13293, 241, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (13294, 241, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (13295, 241, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (13296, 241, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (13297, 241, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13298, 241, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13299, 241, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13300, 241, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (13301, 241, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (13302, 241, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (13303, 241, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (13304, 241, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (13305, 241, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (13306, 241, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (13307, 241, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (13308, 241, 27, 1168);
INSERT INTO 'devicecapvalue' VALUES (13309, 241, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (13310, 241, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (13311, 241, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (13312, 241, 92, 686);
INSERT INTO 'devicecapvalue' VALUES (13313, 241, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (13314, 241, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (13315, 241, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (13316, 241, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (13317, 241, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (13318, 241, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (13319, 241, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (13320, 241, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (13321, 241, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (13322, 241, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (13323, 241, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (13324, 241, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (13325, 242, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13326, 242, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (13327, 242, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (13328, 242, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (13329, 242, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (13330, 242, 93, 1194);
INSERT INTO 'devicecapvalue' VALUES (13331, 242, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (13332, 242, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (13333, 242, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (13334, 242, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (13335, 242, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (13336, 242, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (13337, 242, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (13338, 242, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (13339, 242, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (13340, 242, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (13341, 242, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (13342, 242, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (13343, 242, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (13344, 242, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13345, 242, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (13346, 242, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (13347, 242, 17, 1204);
INSERT INTO 'devicecapvalue' VALUES (13348, 242, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (13349, 242, 17, 1209);
INSERT INTO 'devicecapvalue' VALUES (13350, 242, 17, 1210);
INSERT INTO 'devicecapvalue' VALUES (13351, 242, 17, 1211);
INSERT INTO 'devicecapvalue' VALUES (13352, 242, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (13353, 242, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (13354, 242, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13355, 242, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13356, 242, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (13357, 242, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13358, 242, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (13359, 242, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (13360, 242, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (13361, 242, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (13362, 242, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (13363, 242, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (13364, 242, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (13365, 242, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (13366, 242, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (13367, 242, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (13368, 242, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (13369, 242, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (13370, 242, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (13371, 242, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (13372, 242, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (13373, 242, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (13374, 242, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (13375, 242, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (13376, 242, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (13377, 242, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (13378, 242, 53, 1212);
INSERT INTO 'devicecapvalue' VALUES (13379, 243, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13380, 243, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (13381, 243, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (13382, 243, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (13383, 243, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (13384, 243, 93, 1194);
INSERT INTO 'devicecapvalue' VALUES (13385, 243, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (13386, 243, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (13387, 243, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (13388, 243, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (13389, 243, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (13390, 243, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (13391, 243, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (13392, 243, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (13393, 243, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (13394, 243, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (13395, 243, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (13396, 243, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (13397, 243, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (13398, 243, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13399, 243, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (13400, 243, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (13401, 243, 17, 1204);
INSERT INTO 'devicecapvalue' VALUES (13402, 243, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (13403, 243, 17, 1209);
INSERT INTO 'devicecapvalue' VALUES (13404, 243, 17, 1210);
INSERT INTO 'devicecapvalue' VALUES (13405, 243, 17, 1211);
INSERT INTO 'devicecapvalue' VALUES (13406, 243, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (13407, 243, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (13408, 243, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13409, 243, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13410, 243, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (13411, 243, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13412, 243, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (13413, 243, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (13414, 243, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (13415, 243, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (13416, 243, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (13417, 243, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (13418, 243, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (13419, 243, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (13420, 243, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (13421, 243, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (13422, 243, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (13423, 243, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (13424, 243, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (13425, 243, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (13426, 243, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (13427, 243, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (13428, 243, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (13429, 243, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (13430, 243, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (13431, 243, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (13432, 243, 53, 1212);
INSERT INTO 'devicecapvalue' VALUES (13433, 244, 158, 1136);
INSERT INTO 'devicecapvalue' VALUES (13434, 244, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (13435, 244, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (13436, 244, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (13437, 244, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (13438, 244, 75, 1137);
INSERT INTO 'capvalue' VALUES (1268, '96x32');
INSERT INTO 'devicecapvalue' VALUES (13439, 244, 167, 1268);
INSERT INTO 'devicecapvalue' VALUES (13440, 244, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (13441, 244, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (13442, 244, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (13443, 244, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (13444, 244, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (13445, 244, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (13446, 244, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (13447, 244, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13448, 244, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (13449, 244, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (13450, 244, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13451, 244, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13452, 244, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (13453, 244, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13454, 244, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (13455, 244, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (13456, 244, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (13457, 244, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (13458, 244, 27, 1102);
INSERT INTO 'devicecapvalue' VALUES (13459, 244, 30, 666);
INSERT INTO 'capvalue' VALUES (1269, '512kb');
INSERT INTO 'devicecapvalue' VALUES (13460, 244, 155, 1269);
INSERT INTO 'devicecapvalue' VALUES (13461, 244, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (13462, 244, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (13463, 244, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (13464, 244, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (13465, 244, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (13466, 244, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (13467, 244, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (13468, 244, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (13469, 244, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (13470, 244, 52, 93);
INSERT INTO 'capvalue' VALUES (1270, '2006-04-13');
INSERT INTO 'devicecapvalue' VALUES (13471, 245, 158, 1270);
INSERT INTO 'devicecapvalue' VALUES (13472, 245, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13473, 245, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (13474, 245, 76, 1226);
INSERT INTO 'devicecapvalue' VALUES (13475, 245, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (13476, 245, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13477, 245, 3, 740);
INSERT INTO 'capvalue' VALUES (1271, 'Canada');
INSERT INTO 'devicecapvalue' VALUES (13478, 245, 156, 1271);
INSERT INTO 'capvalue' VALUES (1272, 'USA');
INSERT INTO 'devicecapvalue' VALUES (13479, 245, 156, 1272);
INSERT INTO 'devicecapvalue' VALUES (13480, 245, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (13481, 245, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (13482, 245, 52, 739);
INSERT INTO 'devicecapvalue' VALUES (13483, 246, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13484, 246, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (13485, 246, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13486, 246, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13487, 246, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (13488, 246, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (13489, 247, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13490, 247, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (13491, 247, 76, 1226);
INSERT INTO 'devicecapvalue' VALUES (13492, 247, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (13493, 247, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13494, 247, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (13495, 247, 156, 1271);
INSERT INTO 'devicecapvalue' VALUES (13496, 247, 156, 1272);
INSERT INTO 'devicecapvalue' VALUES (13497, 247, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (13498, 247, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (13499, 247, 52, 739);
INSERT INTO 'devicecapvalue' VALUES (13500, 248, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13501, 248, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (13502, 248, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13503, 248, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13504, 248, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (13505, 248, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (13506, 249, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13507, 249, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (13508, 249, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13509, 249, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13510, 249, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (13511, 249, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (13512, 250, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13513, 250, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (13514, 250, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13515, 250, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13516, 250, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (13517, 250, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (13518, 251, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (13519, 251, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13520, 251, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (13521, 251, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13522, 251, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (13523, 251, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (13524, 252, 158, 1136);
INSERT INTO 'devicecapvalue' VALUES (13525, 252, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (13526, 252, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (13527, 252, 7, 1215);
INSERT INTO 'devicecapvalue' VALUES (13528, 252, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (13529, 252, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (13530, 252, 11, 110);
INSERT INTO 'devicecapvalue' VALUES (13531, 252, 12, 603);
INSERT INTO 'devicecapvalue' VALUES (13532, 252, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (13533, 252, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (13534, 252, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (13535, 252, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (13536, 252, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (13537, 252, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (13538, 252, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (13539, 252, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (13540, 252, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13541, 252, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (13542, 252, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (13543, 252, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (13544, 252, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (13545, 252, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (13546, 252, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13547, 252, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (13548, 252, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13549, 252, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (13550, 252, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (13551, 252, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (13552, 252, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (13553, 252, 27, 1102);
INSERT INTO 'devicecapvalue' VALUES (13554, 252, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (13555, 252, 159, 625);
INSERT INTO 'devicecapvalue' VALUES (13556, 252, 155, 1216);
INSERT INTO 'devicecapvalue' VALUES (13557, 252, 3, 1034);
INSERT INTO 'devicecapvalue' VALUES (13558, 252, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (13559, 252, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (13560, 252, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (13561, 252, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (13562, 252, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (13563, 252, 51, 1038);
INSERT INTO 'devicecapvalue' VALUES (13564, 252, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (13565, 252, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (13566, 252, 51, 1040);
INSERT INTO 'devicecapvalue' VALUES (13567, 252, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (13568, 252, 51, 1042);
INSERT INTO 'devicecapvalue' VALUES (13569, 252, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (13570, 253, 7, 1240);
INSERT INTO 'devicecapvalue' VALUES (13571, 253, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (13572, 253, 2, 11);
INSERT INTO 'capvalue' VALUES (1273, '29');
INSERT INTO 'devicecapvalue' VALUES (13573, 253, 9, 1273);
INSERT INTO 'devicecapvalue' VALUES (13574, 253, 10, 1236);
INSERT INTO 'devicecapvalue' VALUES (13575, 253, 11, 604);
INSERT INTO 'devicecapvalue' VALUES (13576, 253, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (13577, 253, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (13578, 253, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (13579, 253, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (13580, 253, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (13581, 253, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (13582, 253, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (13583, 253, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (13584, 253, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (13585, 253, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (13586, 253, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (13587, 253, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (13588, 253, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (13589, 253, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (13590, 253, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13591, 253, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (13592, 253, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (13593, 253, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (13594, 253, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (13595, 253, 19, 36);
INSERT INTO 'devicecapvalue' VALUES (13596, 253, 20, 1102);
INSERT INTO 'devicecapvalue' VALUES (13597, 253, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (13598, 253, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (13599, 253, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (13600, 253, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (13601, 253, 25, 29);
INSERT INTO 'devicecapvalue' VALUES (13602, 253, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (13603, 253, 29, 30);
INSERT INTO 'devicecapvalue' VALUES (13604, 253, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (13605, 253, 54, 1102);
INSERT INTO 'devicecapvalue' VALUES (13606, 253, 31, 41);
INSERT INTO 'capvalue' VALUES (1274, 'encoding=audio/amr encoding=audio/amr-wb');
INSERT INTO 'devicecapvalue' VALUES (13607, 253, 38, 1274);
INSERT INTO 'devicecapvalue' VALUES (13608, 253, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (13609, 253, 39, 949);
INSERT INTO 'devicecapvalue' VALUES (13610, 253, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (13611, 253, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (13612, 253, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (13613, 253, 41, 868);
INSERT INTO 'capvalue' VALUES (1275, 'application/x-pn-realmedia');
INSERT INTO 'devicecapvalue' VALUES (13614, 253, 41, 1275);
INSERT INTO 'capvalue' VALUES (1276, 'application/x-rtsp');
INSERT INTO 'devicecapvalue' VALUES (13615, 253, 41, 1276);
INSERT INTO 'devicecapvalue' VALUES (13616, 253, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (13617, 253, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (13618, 253, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (13619, 253, 41, 50);
INSERT INTO 'capvalue' VALUES (1277, 'audio/asf');
INSERT INTO 'devicecapvalue' VALUES (13620, 253, 41, 1277);
INSERT INTO 'devicecapvalue' VALUES (13621, 253, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (13622, 253, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (13623, 253, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (13624, 253, 41, 1251);
INSERT INTO 'devicecapvalue' VALUES (13625, 253, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (13626, 253, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (13627, 253, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (13628, 253, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (13629, 253, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (13630, 253, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (13631, 253, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (13632, 253, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (13633, 253, 41, 64);
INSERT INTO 'capvalue' VALUES (1278, 'audio/vnd.rn-realaudio');
INSERT INTO 'devicecapvalue' VALUES (13634, 253, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (13635, 253, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (13636, 253, 41, 1049);
INSERT INTO 'capvalue' VALUES (1279, 'audio/x-amr-wb');
INSERT INTO 'devicecapvalue' VALUES (13637, 253, 41, 1279);
INSERT INTO 'devicecapvalue' VALUES (13638, 253, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (13639, 253, 41, 128);
INSERT INTO 'devicecapvalue' VALUES (13640, 253, 41, 1253);
INSERT INTO 'devicecapvalue' VALUES (13641, 253, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (13642, 253, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (13643, 253, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (13644, 253, 41, 1254);
INSERT INTO 'devicecapvalue' VALUES (13645, 253, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (13646, 253, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (13647, 253, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (13648, 253, 41, 618);
INSERT INTO 'capvalue' VALUES (1280, 'audio/x-pn-realaudio');
INSERT INTO 'devicecapvalue' VALUES (13649, 253, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (13650, 253, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (13651, 253, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (13652, 253, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (13653, 253, 41, 1257);
INSERT INTO 'devicecapvalue' VALUES (13654, 253, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (13655, 253, 41, 887);
INSERT INTO 'devicecapvalue' VALUES (13656, 253, 41, 67);
INSERT INTO 'capvalue' VALUES (1281, 'video/vnd.rn-realvideo');
INSERT INTO 'devicecapvalue' VALUES (13657, 253, 41, 1281);
INSERT INTO 'capvalue' VALUES (1282, 'video/x-mp4');
INSERT INTO 'devicecapvalue' VALUES (13658, 253, 41, 1282);
INSERT INTO 'devicecapvalue' VALUES (13659, 253, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (13660, 253, 41, 622);
INSERT INTO 'capvalue' VALUES (1283, 'video/x-pn-realvideo');
INSERT INTO 'devicecapvalue' VALUES (13661, 253, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (13662, 253, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (13663, 253, 42, 1275);
INSERT INTO 'devicecapvalue' VALUES (13664, 253, 42, 1276);
INSERT INTO 'devicecapvalue' VALUES (13665, 253, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (13666, 253, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (13667, 253, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (13668, 253, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (13669, 253, 42, 1277);
INSERT INTO 'devicecapvalue' VALUES (13670, 253, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (13671, 253, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (13672, 253, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (13673, 253, 42, 1251);
INSERT INTO 'devicecapvalue' VALUES (13674, 253, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (13675, 253, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (13676, 253, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (13677, 253, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (13678, 253, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (13679, 253, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (13680, 253, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (13681, 253, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (13682, 253, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (13683, 253, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (13684, 253, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (13685, 253, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (13686, 253, 42, 1279);
INSERT INTO 'devicecapvalue' VALUES (13687, 253, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (13688, 253, 42, 128);
INSERT INTO 'devicecapvalue' VALUES (13689, 253, 42, 1253);
INSERT INTO 'devicecapvalue' VALUES (13690, 253, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (13691, 253, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (13692, 253, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (13693, 253, 42, 1254);
INSERT INTO 'devicecapvalue' VALUES (13694, 253, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (13695, 253, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (13696, 253, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (13697, 253, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (13698, 253, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (13699, 253, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (13700, 253, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (13701, 253, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (13702, 253, 42, 1257);
INSERT INTO 'devicecapvalue' VALUES (13703, 253, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (13704, 253, 42, 887);
INSERT INTO 'devicecapvalue' VALUES (13705, 253, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (13706, 253, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (13707, 253, 42, 1282);
INSERT INTO 'devicecapvalue' VALUES (13708, 253, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (13709, 253, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (13710, 253, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (13711, 253, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (13712, 253, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (13713, 253, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (13714, 253, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (13715, 253, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (13716, 253, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (13717, 253, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (13718, 253, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (13719, 253, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (13720, 253, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (13721, 253, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (13722, 253, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (13723, 253, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (13724, 253, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (13725, 253, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (13726, 253, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (13727, 253, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (13728, 253, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (13729, 253, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (13730, 253, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (13731, 253, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (13732, 253, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (13733, 253, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (13734, 253, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (13735, 253, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (13736, 253, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (13737, 253, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (13738, 253, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (13739, 253, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (13740, 253, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (13741, 253, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (13742, 253, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (13743, 253, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (13744, 253, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (13745, 253, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (13746, 253, 47, 868);
INSERT INTO 'devicecapvalue' VALUES (13747, 253, 47, 1275);
INSERT INTO 'devicecapvalue' VALUES (13748, 253, 47, 1276);
INSERT INTO 'devicecapvalue' VALUES (13749, 253, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (13750, 253, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (13751, 253, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (13752, 253, 47, 50);
INSERT INTO 'devicecapvalue' VALUES (13753, 253, 47, 1277);
INSERT INTO 'devicecapvalue' VALUES (13754, 253, 47, 1045);
INSERT INTO 'devicecapvalue' VALUES (13755, 253, 47, 616);
INSERT INTO 'devicecapvalue' VALUES (13756, 253, 47, 59);
INSERT INTO 'devicecapvalue' VALUES (13757, 253, 47, 1251);
INSERT INTO 'devicecapvalue' VALUES (13758, 253, 47, 124);
INSERT INTO 'devicecapvalue' VALUES (13759, 253, 47, 54);
INSERT INTO 'devicecapvalue' VALUES (13760, 253, 47, 125);
INSERT INTO 'devicecapvalue' VALUES (13761, 253, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (13762, 253, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (13763, 253, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (13764, 253, 47, 869);
INSERT INTO 'devicecapvalue' VALUES (13765, 253, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (13766, 253, 47, 64);
INSERT INTO 'devicecapvalue' VALUES (13767, 253, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (13768, 253, 47, 867);
INSERT INTO 'devicecapvalue' VALUES (13769, 253, 47, 1049);
INSERT INTO 'devicecapvalue' VALUES (13770, 253, 47, 1279);
INSERT INTO 'devicecapvalue' VALUES (13771, 253, 47, 1050);
INSERT INTO 'devicecapvalue' VALUES (13772, 253, 47, 128);
INSERT INTO 'devicecapvalue' VALUES (13773, 253, 47, 1253);
INSERT INTO 'devicecapvalue' VALUES (13774, 253, 47, 131);
INSERT INTO 'devicecapvalue' VALUES (13775, 253, 47, 132);
INSERT INTO 'devicecapvalue' VALUES (13776, 253, 47, 870);
INSERT INTO 'devicecapvalue' VALUES (13777, 253, 47, 1254);
INSERT INTO 'devicecapvalue' VALUES (13778, 253, 47, 1255);
INSERT INTO 'devicecapvalue' VALUES (13779, 253, 47, 871);
INSERT INTO 'devicecapvalue' VALUES (13780, 253, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (13781, 253, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (13782, 253, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (13783, 253, 47, 55);
INSERT INTO 'devicecapvalue' VALUES (13784, 253, 47, 51);
INSERT INTO 'devicecapvalue' VALUES (13785, 253, 47, 66);
INSERT INTO 'devicecapvalue' VALUES (13786, 253, 47, 1257);
INSERT INTO 'devicecapvalue' VALUES (13787, 253, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (13788, 253, 47, 887);
INSERT INTO 'devicecapvalue' VALUES (13789, 253, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (13790, 253, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (13791, 253, 47, 1282);
INSERT INTO 'devicecapvalue' VALUES (13792, 253, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (13793, 253, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (13794, 253, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (13795, 253, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (13796, 253, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (13797, 253, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (13798, 253, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (13799, 253, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (13800, 253, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (13801, 253, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (13802, 253, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (13803, 253, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (13804, 253, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (13805, 253, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (13806, 253, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (13807, 253, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (13808, 253, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (13809, 253, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (13810, 253, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (13811, 253, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (13812, 253, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (13813, 253, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (13814, 253, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (13815, 253, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (13816, 253, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (13817, 253, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (13818, 253, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (13819, 253, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (13820, 253, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (13821, 253, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (13822, 253, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (13823, 253, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (13824, 253, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (13825, 253, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (13826, 253, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (13827, 253, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (13828, 253, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (13829, 253, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (13830, 253, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (13831, 253, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (13832, 253, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (13833, 253, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (13834, 253, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (13835, 253, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (13836, 253, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (13837, 253, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (13838, 253, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (13839, 253, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (13840, 253, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (13841, 253, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (13842, 253, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (13843, 253, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (13844, 253, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (13845, 253, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (13846, 253, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (13847, 253, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (13848, 253, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (13849, 253, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (13850, 253, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (13851, 253, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (13852, 253, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (13853, 253, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (13854, 253, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (13855, 253, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (13856, 253, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (13857, 253, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (13858, 253, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (13859, 253, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (13860, 253, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (13861, 253, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (13862, 253, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (13863, 253, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (13864, 253, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (13865, 253, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (13866, 253, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (13867, 253, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (13868, 253, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (13869, 253, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (13870, 253, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (13871, 253, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (13872, 253, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (13873, 253, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (13874, 253, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (13875, 253, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (13876, 253, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (13877, 253, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (13878, 253, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (13879, 253, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (13880, 253, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (13881, 253, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (13882, 253, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (13883, 253, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (13884, 253, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (13885, 253, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (13886, 253, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (13887, 253, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (13888, 253, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (13889, 253, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (13890, 253, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (13891, 253, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (13892, 253, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (13893, 253, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (13894, 253, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (13895, 253, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (13896, 253, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (13897, 253, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (13898, 253, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (13899, 253, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (13900, 253, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (13901, 253, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (13902, 253, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (13903, 253, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (13904, 253, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (13905, 253, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (13906, 253, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (13907, 253, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (13908, 253, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (13909, 253, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (13910, 253, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (13911, 253, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (13912, 253, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (13913, 253, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (13914, 253, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (13915, 253, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (13916, 253, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (13917, 253, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (13918, 253, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (13919, 253, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (13920, 253, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (13921, 253, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (13922, 253, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (13923, 253, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (13924, 253, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (13925, 253, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (13926, 253, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (13927, 253, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (13928, 253, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (13929, 253, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (13930, 253, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (13931, 253, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (13932, 253, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (13933, 253, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (13934, 253, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (13935, 253, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (13936, 253, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (13937, 253, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (13938, 253, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (13939, 253, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (13940, 253, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (13941, 253, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (13942, 253, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (13943, 253, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (13944, 253, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (13945, 253, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (13946, 253, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (13947, 253, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (13948, 253, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (13949, 253, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (13950, 253, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (13951, 253, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (13952, 253, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (13953, 253, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (13954, 253, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (13955, 253, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (13956, 253, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (13957, 253, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (13958, 253, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (13959, 253, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (13960, 253, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (13961, 253, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (13962, 253, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (13963, 253, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (13964, 253, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (13965, 253, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (13966, 253, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (13967, 253, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (13968, 253, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (13969, 253, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (13970, 253, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (13971, 253, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (13972, 253, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (13973, 253, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (13974, 253, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (13975, 253, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (13976, 253, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (13977, 253, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (13978, 253, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (13979, 253, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (13980, 253, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (13981, 253, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (13982, 253, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (13983, 253, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (13984, 253, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (13985, 253, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (13986, 253, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (13987, 253, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (13988, 253, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (13989, 253, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (13990, 253, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (13991, 253, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (13992, 253, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (13993, 253, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (13994, 253, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (13995, 253, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (13996, 253, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (13997, 253, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (13998, 253, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (13999, 253, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (14000, 253, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (14001, 253, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (14002, 253, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (14003, 253, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (14004, 253, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (14005, 253, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (14006, 253, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (14007, 253, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (14008, 253, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (14009, 253, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (14010, 253, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (14011, 253, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (14012, 253, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (14013, 253, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (14014, 253, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (14015, 253, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (14016, 253, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (14017, 253, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (14018, 253, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (14019, 253, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (14020, 253, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (14021, 253, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (14022, 253, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (14023, 253, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (14024, 253, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (14025, 253, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (14026, 253, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (14027, 253, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (14028, 253, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (14029, 253, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (14030, 253, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (14031, 253, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (14032, 253, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (14033, 253, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (14034, 253, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (14035, 253, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (14036, 253, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (14037, 253, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (14038, 253, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (14039, 253, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (14040, 253, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (14041, 253, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (14042, 253, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (14043, 253, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (14044, 253, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (14045, 253, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (14046, 253, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (14047, 253, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (14048, 253, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (14049, 253, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (14050, 253, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (14051, 253, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (14052, 253, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (14053, 253, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (14054, 253, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (14055, 253, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (14056, 253, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (14057, 253, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (14058, 253, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (14059, 253, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (14060, 253, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (14061, 253, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (14062, 253, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (14063, 253, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (14064, 253, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (14065, 253, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (14066, 253, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (14067, 253, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (14068, 253, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (14069, 253, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (14070, 253, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (14071, 253, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (14072, 253, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (14073, 253, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (14074, 253, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (14075, 253, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (14076, 253, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (14077, 253, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (14078, 253, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (14079, 253, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (14080, 253, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (14081, 253, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (14082, 253, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (14083, 253, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (14084, 253, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (14085, 253, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (14086, 253, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (14087, 253, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (14088, 253, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (14089, 253, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (14090, 253, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (14091, 253, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (14092, 253, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (14093, 253, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (14094, 253, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (14095, 253, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (14096, 253, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (14097, 253, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (14098, 253, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (14099, 253, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (14100, 253, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (14101, 253, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (14102, 253, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (14103, 253, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (14104, 253, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (14105, 253, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (14106, 253, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (14107, 253, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (14108, 253, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (14109, 253, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (14110, 253, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (14111, 253, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (14112, 253, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (14113, 253, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (14114, 253, 48, 562);
INSERT INTO 'capvalue' VALUES (1284, '4466680');
INSERT INTO 'devicecapvalue' VALUES (14115, 253, 49, 1284);
INSERT INTO 'capvalue' VALUES (1285, 'MOT-MOTORAZRV9x/9E.03.39R BER2.2 Mozilla/4.0 (compatible; MSIE 6.0; 13003352) Profile/MIDP-2.0 Configuration/CLDC-1.1  Opera 8.60 [en] UP.Link/6.3.1.20.0');
INSERT INTO 'devicecapvalue' VALUES (14116, 253, 53, 1285);
INSERT INTO 'devicecapvalue' VALUES (14117, 254, 158, 1111);
INSERT INTO 'devicecapvalue' VALUES (14118, 254, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (14119, 254, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14120, 254, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14121, 254, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (14122, 254, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (14123, 254, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14124, 254, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14125, 254, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (14126, 254, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (14127, 254, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (14128, 254, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (14129, 254, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (14130, 254, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14131, 254, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14132, 254, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14133, 254, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14134, 254, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14135, 254, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14136, 254, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14137, 254, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (14138, 254, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14139, 254, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14140, 254, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (14141, 254, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14142, 254, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14143, 254, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14144, 254, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (14145, 254, 27, 1168);
INSERT INTO 'devicecapvalue' VALUES (14146, 254, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (14147, 254, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (14148, 254, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (14149, 254, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (14150, 254, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (14151, 254, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14152, 254, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14153, 254, 156, 1176);
INSERT INTO 'devicecapvalue' VALUES (14154, 254, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14155, 254, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14156, 254, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (14157, 254, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14158, 254, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14159, 254, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14160, 254, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (14161, 255, 1, 13);
INSERT INTO 'devicecapvalue' VALUES (14162, 255, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14163, 255, 74, 1058);
INSERT INTO 'capvalue' VALUES (1286, '120x131');
INSERT INTO 'devicecapvalue' VALUES (14164, 255, 7, 1286);
INSERT INTO 'devicecapvalue' VALUES (14165, 255, 93, 1060);
INSERT INTO 'capvalue' VALUES (1287, 'T725.props');
INSERT INTO 'devicecapvalue' VALUES (14166, 255, 75, 1287);
INSERT INTO 'devicecapvalue' VALUES (14167, 255, 2, 236);
INSERT INTO 'capvalue' VALUES (1288, '120x148');
INSERT INTO 'devicecapvalue' VALUES (14168, 255, 13, 1288);
INSERT INTO 'devicecapvalue' VALUES (14169, 255, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14170, 255, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14171, 255, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14172, 255, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (14173, 255, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (14174, 255, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14175, 255, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14176, 255, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14177, 255, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14178, 255, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14179, 255, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14180, 255, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14181, 255, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (14182, 255, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (14183, 255, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14184, 255, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (14185, 255, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (14186, 255, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (14187, 255, 3, 1068);
INSERT INTO 'capvalue' VALUES (1289, '120');
INSERT INTO 'devicecapvalue' VALUES (14188, 255, 4, 1289);
INSERT INTO 'devicecapvalue' VALUES (14189, 255, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (14190, 255, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (14191, 255, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14192, 255, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14193, 255, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (14194, 256, 158, 1111);
INSERT INTO 'devicecapvalue' VALUES (14195, 256, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14196, 256, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14197, 256, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (14198, 256, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (14199, 256, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14200, 256, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14201, 256, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (14202, 256, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (14203, 256, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14204, 256, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14205, 256, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (14206, 256, 27, 1168);
INSERT INTO 'devicecapvalue' VALUES (14207, 256, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (14208, 256, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14209, 256, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (14210, 256, 5, 601);
INSERT INTO 'capvalue' VALUES (1290, 'MOT-V1050/83.39.01I MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (14211, 256, 53, 1290);
INSERT INTO 'capvalue' VALUES (1291, '2007-01-03');
INSERT INTO 'devicecapvalue' VALUES (14212, 257, 158, 1291);
INSERT INTO 'devicecapvalue' VALUES (14213, 257, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (14214, 257, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14215, 257, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14216, 257, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (14217, 257, 93, 1217);
INSERT INTO 'capvalue' VALUES (1292, 'V1100.props');
INSERT INTO 'devicecapvalue' VALUES (14218, 257, 75, 1292);
INSERT INTO 'devicecapvalue' VALUES (14219, 257, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (14220, 257, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14221, 257, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14222, 257, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (14223, 257, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (14224, 257, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (14225, 257, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (14226, 257, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (14227, 257, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (14228, 257, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (14229, 257, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14230, 257, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14231, 257, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (14232, 257, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14233, 257, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14234, 257, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (14235, 257, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14236, 257, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (14237, 257, 17, 1220);
INSERT INTO 'devicecapvalue' VALUES (14238, 257, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (14239, 257, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (14240, 257, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14241, 257, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14242, 257, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (14243, 257, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14244, 257, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (14245, 257, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14246, 257, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (14247, 257, 154, 1233);
INSERT INTO 'devicecapvalue' VALUES (14248, 257, 154, 1243);
INSERT INTO 'devicecapvalue' VALUES (14249, 257, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (14250, 257, 155, 1157);
INSERT INTO 'devicecapvalue' VALUES (14251, 257, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (14252, 257, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (14253, 257, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14254, 257, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14255, 257, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (14256, 257, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (14257, 257, 52, 1226);
INSERT INTO 'capvalue' VALUES (1293, 'MOT-V1100');
INSERT INTO 'devicecapvalue' VALUES (14258, 257, 53, 1293);
INSERT INTO 'devicecapvalue' VALUES (14259, 258, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (14260, 258, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14261, 258, 74, 1058);
INSERT INTO 'capvalue' VALUES (1294, '128x99');
INSERT INTO 'devicecapvalue' VALUES (14262, 258, 7, 1294);
INSERT INTO 'devicecapvalue' VALUES (14263, 258, 93, 1060);
INSERT INTO 'capvalue' VALUES (1295, 'V180_V185_V186_V188.props');
INSERT INTO 'devicecapvalue' VALUES (14264, 258, 75, 1295);
INSERT INTO 'devicecapvalue' VALUES (14265, 258, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14266, 258, 13, 1106);
INSERT INTO 'devicecapvalue' VALUES (14267, 258, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14268, 258, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14269, 258, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14270, 258, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (14271, 258, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (14272, 258, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14273, 258, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14274, 258, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14275, 258, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14276, 258, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14277, 258, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14278, 258, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14279, 258, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (14280, 258, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (14281, 258, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14282, 258, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (14283, 258, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (14284, 258, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (14285, 258, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14286, 258, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (14287, 258, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (14288, 258, 52, 1107);
INSERT INTO 'capvalue' VALUES (1296, 'MOT-V188/0B.D2.30R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (14289, 258, 53, 1296);
INSERT INTO 'devicecapvalue' VALUES (14290, 259, 158, 1092);
INSERT INTO 'devicecapvalue' VALUES (14291, 259, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (14292, 259, 93, 1126);
INSERT INTO 'capvalue' VALUES (1297, 'V195_V196_V197.props');
INSERT INTO 'devicecapvalue' VALUES (14293, 259, 75, 1297);
INSERT INTO 'devicecapvalue' VALUES (14294, 259, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14295, 259, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14296, 259, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (14297, 259, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (14298, 259, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (14299, 259, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14300, 259, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14301, 259, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (14302, 259, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14303, 259, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14304, 259, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14305, 259, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (14306, 259, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (14307, 259, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (14308, 259, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14309, 259, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14310, 259, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (14311, 259, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14312, 259, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14313, 259, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14314, 259, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14315, 259, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14316, 259, 155, 1067);
INSERT INTO 'capvalue' VALUES (1298, 'Synergy');
INSERT INTO 'devicecapvalue' VALUES (14317, 259, 3, 1298);
INSERT INTO 'devicecapvalue' VALUES (14318, 259, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14319, 259, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (14320, 259, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (14321, 259, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14322, 259, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14323, 259, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14324, 259, 52, 1074);
INSERT INTO 'capvalue' VALUES (1299, 'MOT-V195');
INSERT INTO 'devicecapvalue' VALUES (14325, 259, 53, 1299);
INSERT INTO 'devicecapvalue' VALUES (14326, 260, 158, 1092);
INSERT INTO 'devicecapvalue' VALUES (14327, 260, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (14328, 260, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (14329, 260, 75, 1297);
INSERT INTO 'devicecapvalue' VALUES (14330, 260, 167, 1268);
INSERT INTO 'devicecapvalue' VALUES (14331, 260, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14332, 260, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14333, 260, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (14334, 260, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14335, 260, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14336, 260, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14337, 260, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14338, 260, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14339, 260, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (14340, 260, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (14341, 260, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (14342, 260, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14343, 260, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14344, 260, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14345, 260, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14346, 260, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14347, 260, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14348, 260, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14349, 260, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (14350, 260, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14351, 260, 3, 1298);
INSERT INTO 'devicecapvalue' VALUES (14352, 260, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14353, 260, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (14354, 260, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (14355, 260, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14356, 260, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14357, 260, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14358, 260, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (14359, 261, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (14360, 261, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14361, 261, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14362, 261, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (14363, 261, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (14364, 261, 7, 1294);
INSERT INTO 'devicecapvalue' VALUES (14365, 261, 93, 1060);
INSERT INTO 'capvalue' VALUES (1300, 'V220_V220i_V226.props');
INSERT INTO 'devicecapvalue' VALUES (14366, 261, 75, 1300);
INSERT INTO 'devicecapvalue' VALUES (14367, 261, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14368, 261, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14369, 261, 13, 1106);
INSERT INTO 'devicecapvalue' VALUES (14370, 261, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14371, 261, 77, 109);
INSERT INTO 'devicecapvalue' VALUES (14372, 261, 78, 109);
INSERT INTO 'devicecapvalue' VALUES (14373, 261, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14374, 261, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14375, 261, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (14376, 261, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (14377, 261, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14378, 261, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14379, 261, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14380, 261, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14381, 261, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14382, 261, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14383, 261, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14384, 261, 54, 1102);
INSERT INTO 'devicecapvalue' VALUES (14385, 261, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (14386, 261, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (14387, 261, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14388, 261, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (14389, 261, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (14390, 261, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (14391, 261, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14392, 261, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (14393, 261, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (14394, 261, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (14395, 261, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14396, 261, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14397, 261, 52, 1107);
INSERT INTO 'capvalue' VALUES (1301, 'MOT-V220/0B.D2.2CR MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (14398, 261, 53, 1301);
INSERT INTO 'devicecapvalue' VALUES (14399, 262, 158, 1227);
INSERT INTO 'devicecapvalue' VALUES (14400, 262, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (14401, 262, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14402, 262, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14403, 262, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (14404, 262, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (14405, 262, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (14406, 262, 75, 1228);
INSERT INTO 'devicecapvalue' VALUES (14407, 262, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (14408, 262, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14409, 262, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14410, 262, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (14411, 262, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (14412, 262, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (14413, 262, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (14414, 262, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14415, 262, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (14416, 262, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (14417, 262, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14418, 262, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14419, 262, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (14420, 262, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14421, 262, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14422, 262, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14423, 262, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (14424, 262, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (14425, 262, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (14426, 262, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14427, 262, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14428, 262, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (14429, 262, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14430, 262, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14431, 262, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (14432, 262, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (14433, 262, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14434, 262, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14435, 262, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14436, 262, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (14437, 262, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14438, 262, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (14439, 262, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (14440, 262, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14441, 262, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14442, 262, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14443, 262, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14444, 262, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (14445, 262, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (14446, 262, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (14447, 262, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14448, 262, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14449, 262, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14450, 262, 52, 93);
INSERT INTO 'capvalue' VALUES (1302, '2004-07-27');
INSERT INTO 'devicecapvalue' VALUES (14451, 263, 158, 1302);
INSERT INTO 'devicecapvalue' VALUES (14452, 263, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (14453, 263, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14454, 263, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14455, 263, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (14456, 263, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (14457, 263, 75, 1228);
INSERT INTO 'devicecapvalue' VALUES (14458, 263, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (14459, 263, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14460, 263, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14461, 263, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (14462, 263, 11, 710);
INSERT INTO 'devicecapvalue' VALUES (14463, 263, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (14464, 263, 13, 1150);
INSERT INTO 'devicecapvalue' VALUES (14465, 263, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14466, 263, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14467, 263, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14468, 263, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (14469, 263, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14470, 263, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (14471, 263, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14472, 263, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14473, 263, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14474, 263, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14475, 263, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14476, 263, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (14477, 263, 27, 1168);
INSERT INTO 'devicecapvalue' VALUES (14478, 263, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (14479, 263, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (14480, 263, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (14481, 263, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14482, 263, 92, 686);
INSERT INTO 'devicecapvalue' VALUES (14483, 263, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14484, 263, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14485, 263, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14486, 263, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (14487, 263, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14488, 263, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14489, 263, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14490, 263, 52, 93);
INSERT INTO 'capvalue' VALUES (1303, 'MOT-RAZRV3xv/85.97.80R MIB/BER2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (14491, 263, 53, 1303);
INSERT INTO 'devicecapvalue' VALUES (14492, 264, 158, 1227);
INSERT INTO 'devicecapvalue' VALUES (14493, 264, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (14494, 264, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14495, 264, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14496, 264, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (14497, 264, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (14498, 264, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (14499, 264, 75, 1228);
INSERT INTO 'devicecapvalue' VALUES (14500, 264, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (14501, 264, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14502, 264, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14503, 264, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (14504, 264, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (14505, 264, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (14506, 264, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (14507, 264, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14508, 264, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (14509, 264, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (14510, 264, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14511, 264, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14512, 264, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (14513, 264, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14514, 264, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14515, 264, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14516, 264, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (14517, 264, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (14518, 264, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (14519, 264, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14520, 264, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14521, 264, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (14522, 264, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14523, 264, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14524, 264, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (14525, 264, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (14526, 264, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14527, 264, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14528, 264, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14529, 264, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (14530, 264, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14531, 264, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (14532, 264, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (14533, 264, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14534, 264, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14535, 264, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14536, 264, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14537, 264, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (14538, 264, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (14539, 264, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (14540, 264, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14541, 264, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14542, 264, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14543, 264, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (14544, 265, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (14545, 265, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14546, 265, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14547, 265, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (14548, 265, 162, 42);
INSERT INTO 'capvalue' VALUES (1304, '176x182');
INSERT INTO 'devicecapvalue' VALUES (14549, 265, 7, 1304);
INSERT INTO 'devicecapvalue' VALUES (14550, 265, 93, 1060);
INSERT INTO 'capvalue' VALUES (1305, 'V300_V400_V500.props');
INSERT INTO 'devicecapvalue' VALUES (14551, 265, 75, 1305);
INSERT INTO 'devicecapvalue' VALUES (14552, 265, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14553, 265, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14554, 265, 13, 1150);
INSERT INTO 'devicecapvalue' VALUES (14555, 265, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14556, 265, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14557, 265, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14558, 265, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (14559, 265, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (14560, 265, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14561, 265, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14562, 265, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14563, 265, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14564, 265, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14565, 265, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14566, 265, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14567, 265, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (14568, 265, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (14569, 265, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14570, 265, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (14571, 265, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (14572, 265, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (14573, 265, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14574, 265, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14575, 265, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14576, 265, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (14577, 265, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14578, 265, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14579, 265, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14580, 265, 52, 93);
INSERT INTO 'capvalue' VALUES (1306, 'MOT-V300/0E.40.75R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (14581, 265, 53, 1306);
INSERT INTO 'devicecapvalue' VALUES (14582, 266, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (14583, 266, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (14584, 266, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14585, 266, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14586, 266, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14587, 266, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14588, 266, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14589, 266, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14590, 266, 5, 681);
INSERT INTO 'capvalue' VALUES (1307, 'MOT-V325');
INSERT INTO 'devicecapvalue' VALUES (14591, 266, 53, 1307);
INSERT INTO 'devicecapvalue' VALUES (14592, 267, 158, 1111);
INSERT INTO 'devicecapvalue' VALUES (14593, 267, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (14594, 267, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14595, 267, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14596, 267, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (14597, 267, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (14598, 267, 93, 1126);
INSERT INTO 'capvalue' VALUES (1308, 'V360_V361.props');
INSERT INTO 'devicecapvalue' VALUES (14599, 267, 75, 1308);
INSERT INTO 'devicecapvalue' VALUES (14600, 267, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (14601, 267, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14602, 267, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14603, 267, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (14604, 267, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (14605, 267, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (14606, 267, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (14607, 267, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (14608, 267, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14609, 267, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14610, 267, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14611, 267, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14612, 267, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14613, 267, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14614, 267, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (14615, 267, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14616, 267, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14617, 267, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14618, 267, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14619, 267, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14620, 267, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14621, 267, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14622, 267, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (14623, 267, 27, 1168);
INSERT INTO 'devicecapvalue' VALUES (14624, 267, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (14625, 267, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (14626, 267, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (14627, 267, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14628, 267, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (14629, 267, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (14630, 267, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14631, 267, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14632, 267, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14633, 267, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14634, 267, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (14635, 267, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14636, 267, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14637, 267, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14638, 267, 52, 93);
INSERT INTO 'capvalue' VALUES (1309, 'MOT-V360/08.B7.86R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (14639, 267, 53, 1309);
INSERT INTO 'devicecapvalue' VALUES (14640, 268, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (14641, 268, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (14642, 268, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14643, 268, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14644, 268, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (14645, 268, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (14646, 268, 93, 1126);
INSERT INTO 'capvalue' VALUES (1310, 'V365.props');
INSERT INTO 'devicecapvalue' VALUES (14647, 268, 75, 1310);
INSERT INTO 'devicecapvalue' VALUES (14648, 268, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14649, 268, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14650, 268, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14651, 268, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (14652, 268, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14653, 268, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14654, 268, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14655, 268, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14656, 268, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14657, 268, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (14658, 268, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14659, 268, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14660, 268, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (14661, 268, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14662, 268, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (14663, 268, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14664, 268, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (14665, 268, 154, 1233);
INSERT INTO 'devicecapvalue' VALUES (14666, 268, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14667, 268, 154, 1243);
INSERT INTO 'devicecapvalue' VALUES (14668, 268, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (14669, 268, 50, 93);
INSERT INTO 'devicecapvalue' VALUES (14670, 268, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (14671, 268, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14672, 268, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14673, 268, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14674, 268, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14675, 268, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14676, 268, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (14677, 268, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (14678, 268, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14679, 268, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14680, 268, 52, 93);
INSERT INTO 'capvalue' VALUES (1311, 'MOT-V365/08.CC.13R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (14681, 268, 53, 1311);
INSERT INTO 'devicecapvalue' VALUES (14682, 269, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (14683, 269, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (14684, 269, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14685, 269, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14686, 269, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14687, 269, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14688, 269, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14689, 269, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14690, 269, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14691, 270, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (14692, 270, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (14693, 270, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14694, 270, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14695, 270, 160, 1229);
INSERT INTO 'devicecapvalue' VALUES (14696, 270, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (14697, 270, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (14698, 270, 75, 1230);
INSERT INTO 'devicecapvalue' VALUES (14699, 270, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (14700, 270, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14701, 270, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (14702, 270, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (14703, 270, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (14704, 270, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (14705, 270, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14706, 270, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (14707, 270, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14708, 270, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14709, 270, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14710, 270, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14711, 270, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14712, 270, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (14713, 270, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (14714, 270, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (14715, 270, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (14716, 270, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14717, 270, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14718, 270, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (14719, 270, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14720, 270, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (14721, 270, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14722, 270, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (14723, 270, 154, 1222);
INSERT INTO 'devicecapvalue' VALUES (14724, 270, 154, 1223);
INSERT INTO 'devicecapvalue' VALUES (14725, 270, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (14726, 270, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14727, 270, 92, 686);
INSERT INTO 'devicecapvalue' VALUES (14728, 270, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (14729, 270, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (14730, 270, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14731, 270, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14732, 270, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14733, 270, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14734, 270, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (14735, 270, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (14736, 270, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (14737, 270, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14738, 270, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14739, 271, 158, 1231);
INSERT INTO 'devicecapvalue' VALUES (14740, 271, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (14741, 271, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14742, 271, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14743, 271, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (14744, 271, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (14745, 271, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (14746, 271, 75, 1230);
INSERT INTO 'devicecapvalue' VALUES (14747, 271, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (14748, 271, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14749, 271, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14750, 271, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (14751, 271, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (14752, 271, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (14753, 271, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (14754, 271, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14755, 271, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (14756, 271, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14757, 271, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14758, 271, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14759, 271, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14760, 271, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14761, 271, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (14762, 271, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14763, 271, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14764, 271, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (14765, 271, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14766, 271, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14767, 271, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14768, 271, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14769, 271, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14770, 271, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (14771, 271, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14772, 271, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (14773, 271, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (14774, 271, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14775, 271, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14776, 271, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14777, 271, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14778, 271, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (14779, 271, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (14780, 271, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (14781, 271, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14782, 271, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14783, 271, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (14784, 271, 53, 1232);
INSERT INTO 'devicecapvalue' VALUES (14785, 272, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (14786, 272, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (14787, 272, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14788, 272, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14789, 272, 160, 1229);
INSERT INTO 'devicecapvalue' VALUES (14790, 272, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (14791, 272, 93, 1126);
INSERT INTO 'devicecapvalue' VALUES (14792, 272, 75, 1230);
INSERT INTO 'devicecapvalue' VALUES (14793, 272, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (14794, 272, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14795, 272, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (14796, 272, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (14797, 272, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (14798, 272, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (14799, 272, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14800, 272, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (14801, 272, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14802, 272, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14803, 272, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14804, 272, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14805, 272, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14806, 272, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (14807, 272, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (14808, 272, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (14809, 272, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (14810, 272, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14811, 272, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14812, 272, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (14813, 272, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14814, 272, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (14815, 272, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14816, 272, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (14817, 272, 154, 1233);
INSERT INTO 'devicecapvalue' VALUES (14818, 272, 154, 1223);
INSERT INTO 'devicecapvalue' VALUES (14819, 272, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (14820, 272, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (14821, 272, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14822, 272, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (14823, 272, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (14824, 272, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14825, 272, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14826, 272, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14827, 272, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14828, 272, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (14829, 272, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (14830, 272, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (14831, 272, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14832, 272, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14833, 272, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (14834, 273, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (14835, 273, 74, 1234);
INSERT INTO 'devicecapvalue' VALUES (14836, 273, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14837, 273, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (14838, 273, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (14839, 273, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (14840, 273, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (14841, 273, 93, 1112);
INSERT INTO 'devicecapvalue' VALUES (14842, 273, 75, 1235);
INSERT INTO 'devicecapvalue' VALUES (14843, 273, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (14844, 273, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14845, 273, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14846, 273, 10, 1236);
INSERT INTO 'devicecapvalue' VALUES (14847, 273, 11, 604);
INSERT INTO 'devicecapvalue' VALUES (14848, 273, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (14849, 273, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (14850, 273, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (14851, 273, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (14852, 273, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (14853, 273, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14854, 273, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14855, 273, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14856, 273, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14857, 273, 17, 1237);
INSERT INTO 'devicecapvalue' VALUES (14858, 273, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14859, 273, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14860, 273, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (14861, 273, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14862, 273, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14863, 273, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (14864, 273, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14865, 273, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14866, 273, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14867, 273, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14868, 273, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14869, 273, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (14870, 273, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (14871, 273, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (14872, 273, 27, 1102);
INSERT INTO 'devicecapvalue' VALUES (14873, 273, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (14874, 273, 50, 1169);
INSERT INTO 'devicecapvalue' VALUES (14875, 273, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (14876, 273, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14877, 273, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (14878, 273, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (14879, 273, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14880, 273, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (14881, 273, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (14882, 273, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (14883, 273, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (14884, 273, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (14885, 273, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14886, 273, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (14887, 273, 51, 1238);
INSERT INTO 'devicecapvalue' VALUES (14888, 273, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (14889, 273, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14890, 273, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (14891, 273, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (14892, 273, 53, 1239);
INSERT INTO 'devicecapvalue' VALUES (14893, 274, 158, 1092);
INSERT INTO 'devicecapvalue' VALUES (14894, 274, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (14895, 274, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14896, 274, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (14897, 274, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (14898, 274, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (14899, 274, 7, 1240);
INSERT INTO 'devicecapvalue' VALUES (14900, 274, 93, 1217);
INSERT INTO 'devicecapvalue' VALUES (14901, 274, 75, 1241);
INSERT INTO 'devicecapvalue' VALUES (14902, 274, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (14903, 274, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14904, 274, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14905, 274, 10, 1236);
INSERT INTO 'devicecapvalue' VALUES (14906, 274, 11, 604);
INSERT INTO 'devicecapvalue' VALUES (14907, 274, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (14908, 274, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (14909, 274, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (14910, 274, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (14911, 274, 13, 1242);
INSERT INTO 'devicecapvalue' VALUES (14912, 274, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (14913, 274, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (14914, 274, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (14915, 274, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14916, 274, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14917, 274, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (14918, 274, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (14919, 274, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (14920, 274, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14921, 274, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (14922, 274, 17, 1220);
INSERT INTO 'devicecapvalue' VALUES (14923, 274, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (14924, 274, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (14925, 274, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14926, 274, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14927, 274, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (14928, 274, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14929, 274, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (14930, 274, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14931, 274, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (14932, 274, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (14933, 274, 154, 1243);
INSERT INTO 'devicecapvalue' VALUES (14934, 274, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (14935, 274, 27, 1102);
INSERT INTO 'devicecapvalue' VALUES (14936, 274, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (14937, 274, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14938, 274, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (14939, 274, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (14940, 274, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14941, 274, 156, 1158);
INSERT INTO 'devicecapvalue' VALUES (14942, 274, 156, 1224);
INSERT INTO 'devicecapvalue' VALUES (14943, 274, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (14944, 274, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (14945, 274, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (14946, 274, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (14947, 274, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (14948, 274, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (14949, 274, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (14950, 274, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (14951, 274, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (14952, 275, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (14953, 275, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14954, 275, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14955, 275, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (14956, 275, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (14957, 275, 7, 1304);
INSERT INTO 'devicecapvalue' VALUES (14958, 275, 93, 1060);
INSERT INTO 'devicecapvalue' VALUES (14959, 275, 75, 1305);
INSERT INTO 'devicecapvalue' VALUES (14960, 275, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14961, 275, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (14962, 275, 13, 1150);
INSERT INTO 'devicecapvalue' VALUES (14963, 275, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (14964, 275, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (14965, 275, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (14966, 275, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (14967, 275, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (14968, 275, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (14969, 275, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (14970, 275, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (14971, 275, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (14972, 275, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (14973, 275, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (14974, 275, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (14975, 275, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (14976, 275, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (14977, 275, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (14978, 275, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (14979, 275, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (14980, 275, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (14981, 275, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (14982, 275, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (14983, 275, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (14984, 275, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (14985, 275, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (14986, 275, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (14987, 275, 52, 93);
INSERT INTO 'capvalue' VALUES (1312, 'MOT-V400/0B.94.09R MIB/2.2 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (14988, 275, 53, 1312);
INSERT INTO 'devicecapvalue' VALUES (14989, 276, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (14990, 276, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (14991, 276, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (14992, 276, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (14993, 276, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (14994, 276, 7, 1304);
INSERT INTO 'cap' VALUES (173, 'DRM', 1);
INSERT INTO 'capvalue' VALUES (1313, 'Forward Lock');
INSERT INTO 'devicecapvalue' VALUES (14995, 276, 173, 1313);
INSERT INTO 'devicecapvalue' VALUES (14996, 276, 93, 1060);
INSERT INTO 'devicecapvalue' VALUES (14997, 276, 75, 1305);
INSERT INTO 'devicecapvalue' VALUES (14998, 276, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (14999, 276, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15000, 276, 13, 1150);
INSERT INTO 'devicecapvalue' VALUES (15001, 276, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (15002, 276, 77, 109);
INSERT INTO 'devicecapvalue' VALUES (15003, 276, 78, 109);
INSERT INTO 'devicecapvalue' VALUES (15004, 276, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15005, 276, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15006, 276, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15007, 276, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (15008, 276, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15009, 276, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15010, 276, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15011, 276, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15012, 276, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (15013, 276, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (15014, 276, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15015, 276, 26, 663);
INSERT INTO 'devicecapvalue' VALUES (15016, 276, 30, 12);
INSERT INTO 'devicecapvalue' VALUES (15017, 276, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (15018, 276, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (15019, 276, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (15020, 276, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (15021, 276, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (15022, 276, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (15023, 276, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (15024, 276, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15025, 276, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15026, 276, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (15027, 276, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15028, 276, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15029, 276, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (15030, 276, 52, 93);
INSERT INTO 'capvalue' VALUES (1314, 'MOT-V525/0B.09.19R MIB/2.2 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (15031, 276, 53, 1314);
INSERT INTO 'devicecapvalue' VALUES (15032, 277, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15033, 277, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (15034, 277, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (15035, 277, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (15036, 277, 162, 612);
INSERT INTO 'devicecapvalue' VALUES (15037, 277, 93, 1060);
INSERT INTO 'capvalue' VALUES (1315, 'V540_V545_V550.props');
INSERT INTO 'devicecapvalue' VALUES (15038, 277, 75, 1315);
INSERT INTO 'devicecapvalue' VALUES (15039, 277, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (15040, 277, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15041, 277, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15042, 277, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (15043, 277, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15044, 277, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15045, 277, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15046, 277, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15047, 277, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (15048, 277, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15049, 277, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15050, 277, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15051, 277, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (15052, 277, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (15053, 277, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (15054, 277, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15055, 277, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (15056, 277, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (15057, 277, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (15058, 277, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (15059, 277, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (15060, 277, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (15061, 277, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (15062, 277, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (15063, 277, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15064, 277, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15065, 277, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (15066, 277, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15067, 277, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15068, 277, 51, 669);
INSERT INTO 'capvalue' VALUES (1316, 'MOT-V550/0E.66.0ER MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (15069, 277, 53, 1316);
INSERT INTO 'devicecapvalue' VALUES (15070, 278, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15071, 278, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (15072, 278, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (15073, 278, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (15074, 278, 162, 612);
INSERT INTO 'devicecapvalue' VALUES (15075, 278, 93, 1060);
INSERT INTO 'capvalue' VALUES (1317, 'V330_V547_V551_V555.props');
INSERT INTO 'devicecapvalue' VALUES (15076, 278, 75, 1317);
INSERT INTO 'devicecapvalue' VALUES (15077, 278, 167, 1268);
INSERT INTO 'devicecapvalue' VALUES (15078, 278, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15079, 278, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15080, 278, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (15081, 278, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15082, 278, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15083, 278, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15084, 278, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15085, 278, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (15086, 278, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15087, 278, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15088, 278, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15089, 278, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (15090, 278, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (15091, 278, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (15092, 278, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15093, 278, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (15094, 278, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (15095, 278, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (15096, 278, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (15097, 278, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (15098, 278, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (15099, 278, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (15100, 278, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (15101, 278, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15102, 278, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15103, 278, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (15104, 278, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15105, 278, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15106, 278, 51, 669);
INSERT INTO 'capvalue' VALUES (1318, 'MOT-V551J/08.18.30r MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (15107, 278, 53, 1318);
INSERT INTO 'devicecapvalue' VALUES (15108, 279, 158, 1153);
INSERT INTO 'devicecapvalue' VALUES (15109, 279, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (15110, 279, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (15111, 279, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (15112, 279, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (15113, 279, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (15114, 279, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (15115, 279, 93, 1217);
INSERT INTO 'devicecapvalue' VALUES (15116, 279, 75, 1218);
INSERT INTO 'devicecapvalue' VALUES (15117, 279, 167, 1219);
INSERT INTO 'devicecapvalue' VALUES (15118, 279, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15119, 279, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15120, 279, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (15121, 279, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (15122, 279, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (15123, 279, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (15124, 279, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (15125, 279, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (15126, 279, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15127, 279, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15128, 279, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15129, 279, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15130, 279, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15131, 279, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (15132, 279, 17, 1220);
INSERT INTO 'devicecapvalue' VALUES (15133, 279, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15134, 279, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (15135, 279, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15136, 279, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15137, 279, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (15138, 279, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15139, 279, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (15140, 279, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15141, 279, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (15142, 279, 154, 1222);
INSERT INTO 'devicecapvalue' VALUES (15143, 279, 154, 1223);
INSERT INTO 'devicecapvalue' VALUES (15144, 279, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (15145, 279, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (15146, 279, 92, 686);
INSERT INTO 'devicecapvalue' VALUES (15147, 279, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (15148, 279, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (15149, 279, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (15150, 279, 156, 1158);
INSERT INTO 'devicecapvalue' VALUES (15151, 279, 156, 1224);
INSERT INTO 'devicecapvalue' VALUES (15152, 279, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (15153, 279, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (15154, 279, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (15155, 279, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (15156, 279, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (15157, 279, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (15158, 279, 51, 1225);
INSERT INTO 'devicecapvalue' VALUES (15159, 279, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (15160, 279, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15161, 279, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15162, 279, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (15163, 279, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (15164, 279, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (15165, 279, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (15166, 279, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (15167, 280, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15168, 280, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (15169, 280, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (15170, 280, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (15171, 280, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (15172, 280, 7, 1304);
INSERT INTO 'devicecapvalue' VALUES (15173, 280, 173, 1313);
INSERT INTO 'devicecapvalue' VALUES (15174, 280, 93, 1060);
INSERT INTO 'capvalue' VALUES (1319, 'V600.props');
INSERT INTO 'devicecapvalue' VALUES (15175, 280, 75, 1319);
INSERT INTO 'devicecapvalue' VALUES (15176, 280, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15177, 280, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15178, 280, 13, 1150);
INSERT INTO 'devicecapvalue' VALUES (15179, 280, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (15180, 280, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15181, 280, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15182, 280, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15183, 280, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (15184, 280, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15185, 280, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15186, 280, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15187, 280, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15188, 280, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (15189, 280, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (15190, 280, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15191, 280, 26, 663);
INSERT INTO 'devicecapvalue' VALUES (15192, 280, 27, 110);
INSERT INTO 'devicecapvalue' VALUES (15193, 280, 30, 12);
INSERT INTO 'devicecapvalue' VALUES (15194, 280, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (15195, 280, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (15196, 280, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (15197, 280, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (15198, 280, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (15199, 280, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (15200, 280, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (15201, 280, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15202, 280, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15203, 280, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (15204, 280, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15205, 280, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15206, 280, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (15207, 280, 52, 93);
INSERT INTO 'capvalue' VALUES (1320, 'MotV600');
INSERT INTO 'devicecapvalue' VALUES (15208, 280, 53, 1320);
INSERT INTO 'devicecapvalue' VALUES (15209, 281, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15210, 281, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (15211, 281, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (15212, 281, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (15213, 281, 162, 612);
INSERT INTO 'devicecapvalue' VALUES (15214, 281, 93, 1060);
INSERT INTO 'capvalue' VALUES (1321, 'V620.props');
INSERT INTO 'devicecapvalue' VALUES (15215, 281, 75, 1321);
INSERT INTO 'devicecapvalue' VALUES (15216, 281, 167, 1268);
INSERT INTO 'devicecapvalue' VALUES (15217, 281, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15218, 281, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15219, 281, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (15220, 281, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15221, 281, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15222, 281, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15223, 281, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15224, 281, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (15225, 281, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15226, 281, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15227, 281, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15228, 281, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (15229, 281, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (15230, 281, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (15231, 281, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15232, 281, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (15233, 281, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (15234, 281, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (15235, 281, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (15236, 281, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (15237, 281, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (15238, 281, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (15239, 281, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (15240, 281, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15241, 281, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15242, 281, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (15243, 281, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15244, 281, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15245, 281, 51, 669);
INSERT INTO 'capvalue' VALUES (1322, 'MOT-V620/0E.66.0BR MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (15246, 281, 53, 1322);
INSERT INTO 'devicecapvalue' VALUES (15247, 282, 158, 1111);
INSERT INTO 'devicecapvalue' VALUES (15248, 282, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15249, 282, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (15250, 282, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (15251, 282, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (15252, 282, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (15253, 282, 93, 1060);
INSERT INTO 'capvalue' VALUES (1323, 'V635.props');
INSERT INTO 'devicecapvalue' VALUES (15254, 282, 75, 1323);
INSERT INTO 'devicecapvalue' VALUES (15255, 282, 167, 1268);
INSERT INTO 'devicecapvalue' VALUES (15256, 282, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15257, 282, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15258, 282, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (15259, 282, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (15260, 282, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (15261, 282, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (15262, 282, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (15263, 282, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15264, 282, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15265, 282, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15266, 282, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15267, 282, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (15268, 282, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15269, 282, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15270, 282, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15271, 282, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (15272, 282, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (15273, 282, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (15274, 282, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15275, 282, 26, 663);
INSERT INTO 'devicecapvalue' VALUES (15276, 282, 27, 110);
INSERT INTO 'devicecapvalue' VALUES (15277, 282, 30, 12);
INSERT INTO 'devicecapvalue' VALUES (15278, 282, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (15279, 282, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (15280, 282, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (15281, 282, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (15282, 282, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (15283, 282, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (15284, 282, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (15285, 282, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (15286, 282, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15287, 282, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15288, 282, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (15289, 282, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15290, 282, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15291, 282, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (15292, 282, 52, 93);
INSERT INTO 'capvalue' VALUES (1324, 'MOT-V635/83.37.43I MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (15293, 282, 53, 1324);
INSERT INTO 'devicecapvalue' VALUES (15294, 283, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15295, 283, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15296, 283, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15297, 283, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15298, 283, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15299, 283, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15300, 283, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15301, 283, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15302, 283, 5, 681);
INSERT INTO 'capvalue' VALUES (1325, 'MOT-V710/00.62 UP.Browser/6.2.3.2.f.1.104 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (15303, 283, 53, 1325);
INSERT INTO 'devicecapvalue' VALUES (15304, 284, 158, 1111);
INSERT INTO 'devicecapvalue' VALUES (15305, 284, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (15306, 284, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (15307, 284, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (15308, 284, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (15309, 284, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (15310, 284, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15311, 284, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15312, 284, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (15313, 284, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (15314, 284, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (15315, 284, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (15316, 284, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (15317, 284, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15318, 284, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15319, 284, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15320, 284, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15321, 284, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15322, 284, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (15323, 284, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15324, 284, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15325, 284, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15326, 284, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (15327, 284, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (15328, 284, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (15329, 284, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15330, 284, 26, 663);
INSERT INTO 'devicecapvalue' VALUES (15331, 284, 27, 110);
INSERT INTO 'devicecapvalue' VALUES (15332, 284, 30, 12);
INSERT INTO 'devicecapvalue' VALUES (15333, 284, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (15334, 284, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (15335, 284, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (15336, 284, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (15337, 284, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (15338, 284, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (15339, 284, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15340, 284, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15341, 284, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (15342, 284, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15343, 284, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15344, 284, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (15345, 284, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (15346, 285, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15347, 285, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (15348, 285, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (15349, 285, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (15350, 285, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (15351, 285, 7, 1147);
INSERT INTO 'devicecapvalue' VALUES (15352, 285, 93, 1060);
INSERT INTO 'capvalue' VALUES (1326, 'V80.props');
INSERT INTO 'devicecapvalue' VALUES (15353, 285, 75, 1326);
INSERT INTO 'devicecapvalue' VALUES (15354, 285, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15355, 285, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15356, 285, 13, 1150);
INSERT INTO 'devicecapvalue' VALUES (15357, 285, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (15358, 285, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15359, 285, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15360, 285, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15361, 285, 17, 1064);
INSERT INTO 'devicecapvalue' VALUES (15362, 285, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15363, 285, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15364, 285, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15365, 285, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15366, 285, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (15367, 285, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (15368, 285, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15369, 285, 54, 1102);
INSERT INTO 'devicecapvalue' VALUES (15370, 285, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (15371, 285, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (15372, 285, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (15373, 285, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (15374, 285, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (15375, 285, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (15376, 285, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (15377, 285, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15378, 285, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15379, 285, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (15380, 285, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15381, 285, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15382, 285, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (15383, 285, 52, 93);
INSERT INTO 'capvalue' VALUES (1327, 'MOT-Motorola V80/0E.03.26R MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (15384, 285, 53, 1327);
INSERT INTO 'devicecapvalue' VALUES (15385, 286, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15386, 286, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15387, 286, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15388, 286, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15389, 286, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15390, 286, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15391, 286, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15392, 286, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15393, 286, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15394, 286, 53, 1119);
INSERT INTO 'devicecapvalue' VALUES (15395, 287, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15396, 287, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (15397, 287, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (15398, 287, 93, 1112);
INSERT INTO 'capvalue' VALUES (1328, 'V980.props');
INSERT INTO 'devicecapvalue' VALUES (15399, 287, 75, 1328);
INSERT INTO 'devicecapvalue' VALUES (15400, 287, 167, 1138);
INSERT INTO 'devicecapvalue' VALUES (15401, 287, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15402, 287, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15403, 287, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15404, 287, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (15405, 287, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (15406, 287, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (15407, 287, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15408, 287, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15409, 287, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15410, 287, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15411, 287, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15412, 287, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15413, 287, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (15414, 287, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15415, 287, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15416, 287, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (15417, 287, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (15418, 287, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (15419, 287, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15420, 287, 26, 663);
INSERT INTO 'devicecapvalue' VALUES (15421, 287, 27, 110);
INSERT INTO 'devicecapvalue' VALUES (15422, 287, 30, 12);
INSERT INTO 'devicecapvalue' VALUES (15423, 287, 50, 1103);
INSERT INTO 'devicecapvalue' VALUES (15424, 287, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (15425, 287, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (15426, 287, 164, 238);
INSERT INTO 'devicecapvalue' VALUES (15427, 287, 165, 238);
INSERT INTO 'devicecapvalue' VALUES (15428, 287, 166, 238);
INSERT INTO 'devicecapvalue' VALUES (15429, 287, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (15430, 287, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15431, 287, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15432, 287, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (15433, 287, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (15434, 287, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15435, 287, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15436, 287, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (15437, 287, 51, 669);
INSERT INTO 'capvalue' VALUES (1329, 'MOT-V980M/83.28.38. MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (15438, 287, 53, 1329);
INSERT INTO 'devicecapvalue' VALUES (15439, 288, 1, 1);
INSERT INTO 'capvalue' VALUES (1330, '128x128');
INSERT INTO 'devicecapvalue' VALUES (15440, 288, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (15441, 288, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15442, 288, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15443, 288, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15444, 288, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15445, 288, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15446, 288, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (15447, 288, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (15448, 289, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15449, 289, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (15450, 289, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15451, 289, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15452, 289, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15453, 289, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15454, 289, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15455, 289, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (15456, 289, 5, 107);
INSERT INTO 'capvalue' VALUES (1331, 'MOT-W315/1.0 UP.Browser/6.2.2.6.n.1.101 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (15457, 289, 53, 1331);
INSERT INTO 'devicecapvalue' VALUES (15458, 290, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15459, 290, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (15460, 290, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15461, 290, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15462, 290, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15463, 290, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15464, 290, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15465, 290, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (15466, 290, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (15467, 291, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15468, 291, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (15469, 291, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15470, 291, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15471, 291, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15472, 291, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15473, 291, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15474, 291, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (15475, 291, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (15476, 292, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15477, 292, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15478, 292, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15479, 292, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15480, 292, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15481, 292, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15482, 292, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15483, 292, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15484, 292, 5, 681);
INSERT INTO 'capvalue' VALUES (1332, 'MOT-W490/08.24.02R MIB/BER2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1 EGE/1.0');
INSERT INTO 'devicecapvalue' VALUES (15485, 292, 53, 1332);
INSERT INTO 'devicecapvalue' VALUES (15486, 293, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15487, 293, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15488, 293, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15489, 293, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15490, 293, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15491, 293, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15492, 293, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15493, 293, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15494, 293, 5, 681);
INSERT INTO 'capvalue' VALUES (1333, 'MOT-W510/08.10.12R MIB/BER2.2 Profile/MIDP-2.0 Configuration/CLDC-1.1 EGE/1.0');
INSERT INTO 'devicecapvalue' VALUES (15495, 293, 53, 1333);
INSERT INTO 'devicecapvalue' VALUES (15496, 294, 158, 1246);
INSERT INTO 'devicecapvalue' VALUES (15497, 294, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (15498, 294, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (15499, 294, 74, 1058);
INSERT INTO 'devicecapvalue' VALUES (15500, 294, 160, 1247);
INSERT INTO 'devicecapvalue' VALUES (15501, 294, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (15502, 294, 93, 1194);
INSERT INTO 'devicecapvalue' VALUES (15503, 294, 75, 1248);
INSERT INTO 'devicecapvalue' VALUES (15504, 294, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15505, 294, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15506, 294, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (15507, 294, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (15508, 294, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (15509, 294, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (15510, 294, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (15511, 294, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (15512, 294, 15, 1032);
INSERT INTO 'devicecapvalue' VALUES (15513, 294, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (15514, 294, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15515, 294, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15516, 294, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (15517, 294, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15518, 294, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15519, 294, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15520, 294, 17, 1094);
INSERT INTO 'devicecapvalue' VALUES (15521, 294, 17, 1128);
INSERT INTO 'devicecapvalue' VALUES (15522, 294, 17, 1249);
INSERT INTO 'devicecapvalue' VALUES (15523, 294, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15524, 294, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (15525, 294, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15526, 294, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15527, 294, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (15528, 294, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15529, 294, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15530, 294, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (15531, 294, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (15532, 294, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15533, 294, 163, 1102);
INSERT INTO 'devicecapvalue' VALUES (15534, 294, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (15535, 294, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (15536, 294, 155, 1067);
INSERT INTO 'devicecapvalue' VALUES (15537, 294, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (15538, 294, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (15539, 294, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (15540, 294, 3, 1068);
INSERT INTO 'devicecapvalue' VALUES (15541, 294, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (15542, 294, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15543, 294, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15544, 294, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (15545, 294, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (15546, 294, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (15547, 294, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15548, 294, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15549, 294, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (15550, 294, 53, 1250);
INSERT INTO 'devicecapvalue' VALUES (15551, 295, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15552, 295, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (15553, 295, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (15554, 295, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15555, 295, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15556, 295, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (15557, 295, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (15558, 295, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (15559, 295, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (15560, 295, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (15561, 295, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (15562, 295, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (15563, 295, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (15564, 295, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15565, 295, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (15566, 295, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15567, 295, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15568, 295, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15569, 295, 17, 1209);
INSERT INTO 'devicecapvalue' VALUES (15570, 295, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15571, 295, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (15572, 295, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15573, 295, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15574, 295, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (15575, 295, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15576, 295, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15577, 295, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (15578, 295, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (15579, 295, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15580, 295, 155, 1157);
INSERT INTO 'devicecapvalue' VALUES (15581, 295, 161, 238);
INSERT INTO 'devicecapvalue' VALUES (15582, 295, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (15583, 295, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (15584, 295, 3, 1171);
INSERT INTO 'devicecapvalue' VALUES (15585, 295, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (15586, 295, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (15587, 295, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (15588, 295, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (15589, 295, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (15590, 295, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (15591, 295, 51, 1265);
INSERT INTO 'devicecapvalue' VALUES (15592, 295, 51, 1266);
INSERT INTO 'devicecapvalue' VALUES (15593, 295, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (15594, 295, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (15595, 295, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15596, 295, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15597, 295, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (15598, 295, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (15599, 295, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (15600, 295, 53, 1267);
INSERT INTO 'devicecapvalue' VALUES (15601, 296, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15602, 296, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (15603, 296, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15604, 296, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (15605, 296, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15606, 296, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15607, 296, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15608, 296, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15609, 296, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15610, 296, 6, 27);
INSERT INTO 'capvalue' VALUES (1334, 'Symbian 9.1');
INSERT INTO 'devicecapvalue' VALUES (15611, 296, 3, 1334);
INSERT INTO 'devicecapvalue' VALUES (15612, 296, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (15613, 296, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (15614, 297, 1, 1);
INSERT INTO 'capvalue' VALUES (1335, '130x130');
INSERT INTO 'devicecapvalue' VALUES (15615, 297, 13, 1335);
INSERT INTO 'devicecapvalue' VALUES (15616, 297, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (15617, 297, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15618, 297, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15619, 297, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15620, 297, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15621, 297, 50, 1124);
INSERT INTO 'capvalue' VALUES (1336, '130');
INSERT INTO 'devicecapvalue' VALUES (15622, 297, 4, 1336);
INSERT INTO 'devicecapvalue' VALUES (15623, 297, 5, 1336);
INSERT INTO 'capvalue' VALUES (1337, '3145728');
INSERT INTO 'devicecapvalue' VALUES (15624, 297, 52, 1337);
INSERT INTO 'devicecapvalue' VALUES (15625, 298, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15626, 298, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (15627, 298, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (15628, 298, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15629, 298, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15630, 298, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15631, 298, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15632, 298, 50, 1031);
INSERT INTO 'devicecapvalue' VALUES (15633, 298, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (15634, 298, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (15635, 298, 52, 1337);
INSERT INTO 'devicecapvalue' VALUES (15636, 299, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15637, 299, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (15638, 299, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (15639, 299, 2, 657);
INSERT INTO 'capvalue' VALUES (1338, 'hasVideo');
INSERT INTO 'devicecapvalue' VALUES (15640, 299, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (15641, 299, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (15642, 299, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15643, 299, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15644, 299, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15645, 299, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (15646, 299, 52, 659);
INSERT INTO 'capvalue' VALUES (1339, 'MOT-A-2D/00.02 UP.Browser/4.1.27a1');
INSERT INTO 'devicecapvalue' VALUES (15647, 299, 53, 1339);
INSERT INTO 'devicecapvalue' VALUES (15648, 300, 1, 13);
INSERT INTO 'capvalue' VALUES (1340, '64x94');
INSERT INTO 'devicecapvalue' VALUES (15649, 300, 13, 1340);
INSERT INTO 'devicecapvalue' VALUES (15650, 300, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (15651, 300, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15652, 300, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15653, 300, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15654, 300, 50, 659);
INSERT INTO 'capvalue' VALUES (1341, '64');
INSERT INTO 'devicecapvalue' VALUES (15655, 300, 4, 1341);
INSERT INTO 'capvalue' VALUES (1342, '94');
INSERT INTO 'devicecapvalue' VALUES (15656, 300, 5, 1342);
INSERT INTO 'devicecapvalue' VALUES (15657, 300, 52, 659);
INSERT INTO 'capvalue' VALUES (1343, 'MOT-A-1A/01.00 UP.Browser/4.1.27a1');
INSERT INTO 'devicecapvalue' VALUES (15658, 300, 53, 1343);
INSERT INTO 'devicecapvalue' VALUES (15659, 301, 1, 13);
INSERT INTO 'devicecapvalue' VALUES (15660, 301, 13, 1340);
INSERT INTO 'devicecapvalue' VALUES (15661, 301, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (15662, 301, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (15663, 301, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15664, 301, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15665, 301, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (15666, 301, 4, 1341);
INSERT INTO 'devicecapvalue' VALUES (15667, 301, 5, 1342);
INSERT INTO 'devicecapvalue' VALUES (15668, 301, 52, 659);
INSERT INTO 'devicecapvalue' VALUES (15669, 302, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15670, 302, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (15671, 302, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (15672, 302, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15673, 302, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15674, 302, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15675, 302, 50, 1124);
INSERT INTO 'devicecapvalue' VALUES (15676, 302, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (15677, 302, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (15678, 302, 52, 1337);
INSERT INTO 'capvalue' VALUES (1344, 'MOT-A-3F/00.00 UP.Browser/4.1.27a1');
INSERT INTO 'devicecapvalue' VALUES (15679, 302, 53, 1344);
INSERT INTO 'devicecapvalue' VALUES (15680, 303, 1, 1);
INSERT INTO 'capvalue' VALUES (1345, '32x96');
INSERT INTO 'devicecapvalue' VALUES (15681, 303, 13, 1345);
INSERT INTO 'devicecapvalue' VALUES (15682, 303, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (15683, 303, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15684, 303, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15685, 303, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15686, 303, 50, 1031);
INSERT INTO 'devicecapvalue' VALUES (15687, 303, 4, 606);
INSERT INTO 'capvalue' VALUES (1346, '96');
INSERT INTO 'devicecapvalue' VALUES (15688, 303, 5, 1346);
INSERT INTO 'devicecapvalue' VALUES (15689, 303, 52, 1031);
INSERT INTO 'devicecapvalue' VALUES (15690, 304, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15691, 304, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15692, 304, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (15693, 304, 15, 96);
INSERT INTO 'capvalue' VALUES (1347, 'png1.0');
INSERT INTO 'devicecapvalue' VALUES (15694, 304, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (15695, 304, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (15696, 304, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15697, 304, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15698, 304, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (15699, 304, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15700, 304, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15701, 304, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15702, 304, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (15703, 304, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (15704, 304, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15705, 304, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15706, 304, 6, 27);
INSERT INTO 'capvalue' VALUES (1348, '2306867');
INSERT INTO 'devicecapvalue' VALUES (15707, 304, 50, 1348);
INSERT INTO 'devicecapvalue' VALUES (15708, 304, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15709, 304, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15710, 304, 51, 102);
INSERT INTO 'capvalue' VALUES (1349, 'midi64');
INSERT INTO 'devicecapvalue' VALUES (15711, 304, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (15712, 304, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15713, 304, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (15714, 304, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (15715, 304, 52, 1019);
INSERT INTO 'devicecapvalue' VALUES (15716, 304, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (15717, 304, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (15718, 305, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15719, 305, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15720, 305, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (15721, 305, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15722, 305, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (15723, 305, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (15724, 305, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15725, 305, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15726, 305, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15727, 305, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15728, 305, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15729, 305, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (15730, 305, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15731, 305, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15732, 305, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15733, 305, 50, 1124);
INSERT INTO 'devicecapvalue' VALUES (15734, 305, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15735, 305, 5, 681);
INSERT INTO 'capvalue' VALUES (1350, '11534336');
INSERT INTO 'devicecapvalue' VALUES (15736, 305, 52, 1350);
INSERT INTO 'devicecapvalue' VALUES (15737, 305, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (15738, 305, 157, 1026);
INSERT INTO 'capvalue' VALUES (1351, 'MOT-A-2F/00.00 UP.Browser/7.0.0.2.c.1.104 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (15739, 305, 53, 1351);
INSERT INTO 'devicecapvalue' VALUES (15740, 306, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15741, 306, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15742, 306, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (15743, 306, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15744, 306, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (15745, 306, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (15746, 306, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15747, 306, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15748, 306, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15749, 306, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15750, 306, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15751, 306, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (15752, 306, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15753, 306, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15754, 306, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15755, 306, 50, 1124);
INSERT INTO 'devicecapvalue' VALUES (15756, 306, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15757, 306, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15758, 306, 52, 1350);
INSERT INTO 'devicecapvalue' VALUES (15759, 306, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (15760, 306, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (15761, 307, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15762, 307, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15763, 307, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (15764, 307, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15765, 307, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (15766, 307, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (15767, 307, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15768, 307, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15769, 307, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (15770, 307, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15771, 307, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15772, 307, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15773, 307, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (15774, 307, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (15775, 307, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15776, 307, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15777, 307, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15778, 307, 50, 1348);
INSERT INTO 'devicecapvalue' VALUES (15779, 307, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15780, 307, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15781, 307, 52, 1019);
INSERT INTO 'devicecapvalue' VALUES (15782, 307, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (15783, 307, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (15784, 308, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15785, 308, 13, 1335);
INSERT INTO 'devicecapvalue' VALUES (15786, 308, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (15787, 308, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15788, 308, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15789, 308, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15790, 308, 50, 1031);
INSERT INTO 'devicecapvalue' VALUES (15791, 308, 4, 1336);
INSERT INTO 'devicecapvalue' VALUES (15792, 308, 5, 1336);
INSERT INTO 'devicecapvalue' VALUES (15793, 308, 52, 1031);
INSERT INTO 'devicecapvalue' VALUES (15794, 309, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (15795, 309, 2, 1001);
INSERT INTO 'cap' VALUES (174, 'HardwarePlatform.BitsPerPixel', 1);
INSERT INTO 'devicecapvalue' VALUES (15796, 309, 174, 1);
INSERT INTO 'cap' VALUES (175, 'HardwarePlatform.CameraResolution', 1);
INSERT INTO 'capvalue' VALUES (1352, '300x200');
INSERT INTO 'devicecapvalue' VALUES (15797, 309, 175, 1352);
INSERT INTO 'cap' VALUES (176, 'HardwarePlatform.ScreenSize', 1);
INSERT INTO 'devicecapvalue' VALUES (15798, 309, 176, 1335);
INSERT INTO 'capvalue' VALUES (1353, '1205862');
INSERT INTO 'devicecapvalue' VALUES (15799, 309, 76, 1353);
INSERT INTO 'devicecapvalue' VALUES (15800, 309, 16, 20);
INSERT INTO 'capvalue' VALUES (1354, '3D');
INSERT INTO 'devicecapvalue' VALUES (15801, 309, 17, 1354);
INSERT INTO 'capvalue' VALUES (1355, 'AU');
INSERT INTO 'devicecapvalue' VALUES (15802, 309, 17, 1355);
INSERT INTO 'capvalue' VALUES (1356, 'Alpha blending');
INSERT INTO 'devicecapvalue' VALUES (15803, 309, 17, 1356);
INSERT INTO 'capvalue' VALUES (1357, 'Call Initiation');
INSERT INTO 'devicecapvalue' VALUES (15804, 309, 17, 1357);
INSERT INTO 'capvalue' VALUES (1358, 'Crypto');
INSERT INTO 'devicecapvalue' VALUES (15805, 309, 17, 1358);
INSERT INTO 'capvalue' VALUES (1359, 'Datebook');
INSERT INTO 'devicecapvalue' VALUES (15806, 309, 17, 1359);
INSERT INTO 'capvalue' VALUES (1360, 'Digital Camera');
INSERT INTO 'devicecapvalue' VALUES (15807, 309, 17, 1360);
INSERT INTO 'capvalue' VALUES (1361, 'External display');
INSERT INTO 'devicecapvalue' VALUES (15808, 309, 17, 1361);
INSERT INTO 'capvalue' VALUES (1362, 'File I/O');
INSERT INTO 'devicecapvalue' VALUES (15809, 309, 17, 1362);
INSERT INTO 'capvalue' VALUES (1363, 'Lighting');
INSERT INTO 'devicecapvalue' VALUES (15810, 309, 17, 1363);
INSERT INTO 'capvalue' VALUES (1364, 'Location API');
INSERT INTO 'devicecapvalue' VALUES (15811, 309, 17, 1364);
INSERT INTO 'devicecapvalue' VALUES (15812, 309, 17, 1064);
INSERT INTO 'capvalue' VALUES (1365, 'Polyphonic-MIDI');
INSERT INTO 'devicecapvalue' VALUES (15813, 309, 17, 1365);
INSERT INTO 'capvalue' VALUES (1366, 'RF enabling');
INSERT INTO 'devicecapvalue' VALUES (15814, 309, 17, 1366);
INSERT INTO 'capvalue' VALUES (1367, 'Recent calls');
INSERT INTO 'devicecapvalue' VALUES (15815, 309, 17, 1367);
INSERT INTO 'capvalue' VALUES (1368, 'Secure file connection');
INSERT INTO 'devicecapvalue' VALUES (15816, 309, 17, 1368);
INSERT INTO 'devicecapvalue' VALUES (15817, 309, 17, 1065);
INSERT INTO 'capvalue' VALUES (1369, 'Vibrator');
INSERT INTO 'devicecapvalue' VALUES (15818, 309, 17, 1369);
INSERT INTO 'capvalue' VALUES (1370, 'Voicenote');
INSERT INTO 'devicecapvalue' VALUES (15819, 309, 17, 1370);
INSERT INTO 'devicecapvalue' VALUES (15820, 309, 17, 669);
INSERT INTO 'devicecapvalue' VALUES (15821, 309, 17, 22);
INSERT INTO 'capvalue' VALUES (1371, 'motorola-lwt');
INSERT INTO 'devicecapvalue' VALUES (15822, 309, 17, 1371);
INSERT INTO 'devicecapvalue' VALUES (15823, 309, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15824, 309, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15825, 309, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (15826, 309, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (15827, 309, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (15828, 309, 154, 1065);
INSERT INTO 'devicecapvalue' VALUES (15829, 309, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (15830, 309, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (15831, 309, 164, 625);
INSERT INTO 'devicecapvalue' VALUES (15832, 309, 165, 1);
INSERT INTO 'devicecapvalue' VALUES (15833, 309, 166, 649);
INSERT INTO 'cap' VALUES (177, 'SoftwarePlatform.MaxJarSize', 1);
INSERT INTO 'capvalue' VALUES (1372, '500 kb');
INSERT INTO 'devicecapvalue' VALUES (15834, 309, 177, 1372);
INSERT INTO 'devicecapvalue' VALUES (15835, 309, 52, 1031);
INSERT INTO 'capvalue' VALUES (1373, 'MOT-A-0A/00.00 UP.Browser/4.1.27a1');
INSERT INTO 'devicecapvalue' VALUES (15836, 309, 53, 1373);
INSERT INTO 'devicecapvalue' VALUES (15837, 310, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15838, 310, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15839, 310, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (15840, 310, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15841, 310, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (15842, 310, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (15843, 310, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15844, 310, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15845, 310, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (15846, 310, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15847, 310, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15848, 310, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15849, 310, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (15850, 310, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (15851, 310, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15852, 310, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15853, 310, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15854, 310, 50, 1348);
INSERT INTO 'devicecapvalue' VALUES (15855, 310, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15856, 310, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15857, 310, 52, 1019);
INSERT INTO 'devicecapvalue' VALUES (15858, 310, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (15859, 310, 157, 1026);
INSERT INTO 'capvalue' VALUES (1374, 'MOT-A-3E/01.01 UP.Browser/7.0.2.2.c.1.108 (GUI) MMP/2.0 UP.Link/5.1.2.16');
INSERT INTO 'devicecapvalue' VALUES (15860, 310, 53, 1374);
INSERT INTO 'devicecapvalue' VALUES (15861, 311, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15862, 311, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (15863, 311, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15864, 311, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15865, 311, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15866, 311, 50, 1031);
INSERT INTO 'devicecapvalue' VALUES (15867, 311, 52, 1031);
INSERT INTO 'capvalue' VALUES (1375, 'MOT-A-2B/00.01 UP.Browser/4.1.27a1');
INSERT INTO 'devicecapvalue' VALUES (15868, 311, 53, 1375);
INSERT INTO 'devicecapvalue' VALUES (15869, 312, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15870, 312, 13, 1335);
INSERT INTO 'devicecapvalue' VALUES (15871, 312, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (15872, 312, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15873, 312, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15874, 312, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15875, 312, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15876, 312, 50, 1031);
INSERT INTO 'devicecapvalue' VALUES (15877, 312, 4, 1336);
INSERT INTO 'devicecapvalue' VALUES (15878, 312, 5, 1336);
INSERT INTO 'devicecapvalue' VALUES (15879, 312, 52, 1031);
INSERT INTO 'capvalue' VALUES (1376, 'MOT-i833');
INSERT INTO 'devicecapvalue' VALUES (15880, 312, 53, 1376);
INSERT INTO 'devicecapvalue' VALUES (15881, 313, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15882, 313, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15883, 313, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (15884, 313, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15885, 313, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (15886, 313, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (15887, 313, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15888, 313, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15889, 313, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (15890, 313, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15891, 313, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15892, 313, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15893, 313, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (15894, 313, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (15895, 313, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15896, 313, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15897, 313, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15898, 313, 50, 1348);
INSERT INTO 'devicecapvalue' VALUES (15899, 313, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15900, 313, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15901, 313, 51, 1355);
INSERT INTO 'devicecapvalue' VALUES (15902, 313, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15903, 313, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (15904, 313, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15905, 313, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (15906, 313, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (15907, 313, 52, 1019);
INSERT INTO 'devicecapvalue' VALUES (15908, 313, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (15909, 313, 157, 1026);
INSERT INTO 'capvalue' VALUES (1377, 'MOT-A-3D/00.03 UP.Browser/7.0.0.2.c.1.104 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (15910, 313, 53, 1377);
INSERT INTO 'devicecapvalue' VALUES (15911, 314, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15912, 314, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15913, 314, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (15914, 314, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15915, 314, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (15916, 314, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (15917, 314, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15918, 314, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15919, 314, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (15920, 314, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15921, 314, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15922, 314, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15923, 314, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (15924, 314, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (15925, 314, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15926, 314, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15927, 314, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15928, 314, 50, 1348);
INSERT INTO 'devicecapvalue' VALUES (15929, 314, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15930, 314, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15931, 314, 51, 1355);
INSERT INTO 'devicecapvalue' VALUES (15932, 314, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15933, 314, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (15934, 314, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (15935, 314, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (15936, 314, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (15937, 314, 52, 1019);
INSERT INTO 'devicecapvalue' VALUES (15938, 314, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (15939, 314, 157, 1026);
INSERT INTO 'capvalue' VALUES (1378, 'MOT-i855');
INSERT INTO 'devicecapvalue' VALUES (15940, 314, 53, 1378);
INSERT INTO 'devicecapvalue' VALUES (15941, 315, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15942, 315, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15943, 315, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (15944, 315, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15945, 315, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (15946, 315, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (15947, 315, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15948, 315, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15949, 315, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (15950, 315, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15951, 315, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15952, 315, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15953, 315, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (15954, 315, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15955, 315, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15956, 315, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15957, 315, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15958, 315, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15959, 315, 51, 1355);
INSERT INTO 'devicecapvalue' VALUES (15960, 315, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15961, 315, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (15962, 315, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (15963, 315, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (15964, 315, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (15965, 315, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (15966, 315, 157, 1026);
INSERT INTO 'capvalue' VALUES (1379, 'MOT-A-1C/00.02 UP.Browser/7.0.0.2.257 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (15967, 315, 53, 1379);
INSERT INTO 'devicecapvalue' VALUES (15968, 316, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15969, 316, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15970, 316, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (15971, 316, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (15972, 316, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (15973, 316, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (15974, 316, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (15975, 316, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (15976, 316, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (15977, 316, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (15978, 316, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (15979, 316, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (15980, 316, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (15981, 316, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (15982, 316, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15983, 316, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (15984, 316, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (15985, 316, 50, 1348);
INSERT INTO 'devicecapvalue' VALUES (15986, 316, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (15987, 316, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (15988, 316, 51, 1355);
INSERT INTO 'devicecapvalue' VALUES (15989, 316, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (15990, 316, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (15991, 316, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (15992, 316, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (15993, 316, 52, 1019);
INSERT INTO 'devicecapvalue' VALUES (15994, 316, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (15995, 316, 157, 1026);
INSERT INTO 'capvalue' VALUES (1380, 'MOT-i875');
INSERT INTO 'devicecapvalue' VALUES (15996, 316, 53, 1380);
INSERT INTO 'devicecapvalue' VALUES (15997, 317, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (15998, 317, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (15999, 317, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (16000, 317, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16001, 317, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16002, 317, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16003, 317, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16004, 317, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (16005, 317, 50, 1031);
INSERT INTO 'devicecapvalue' VALUES (16006, 317, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (16007, 317, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (16008, 317, 52, 1031);
INSERT INTO 'devicecapvalue' VALUES (16009, 318, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (16010, 318, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (16011, 318, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16012, 318, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (16013, 318, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (16014, 318, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (16015, 318, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16016, 318, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (16017, 318, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16018, 318, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16019, 318, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (16020, 318, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (16021, 318, 5, 107);
INSERT INTO 'capvalue' VALUES (1381, 'Motorola-ic402 Obigo/Q04C1-1.9 MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (16022, 318, 53, 1381);
INSERT INTO 'devicecapvalue' VALUES (16023, 319, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (16024, 319, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (16025, 319, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16026, 319, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (16027, 319, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (16028, 319, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (16029, 319, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16030, 319, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (16031, 319, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (16032, 319, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16033, 319, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16034, 319, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (16035, 319, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (16036, 319, 5, 107);
INSERT INTO 'capvalue' VALUES (1382, 'Motorola-ic502 Obigo/Q04C1-1.9 MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (16037, 319, 53, 1382);
INSERT INTO 'devicecapvalue' VALUES (16038, 320, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (16039, 320, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (16040, 320, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16041, 320, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (16042, 320, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (16043, 320, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (16044, 320, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16045, 320, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (16046, 320, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16047, 320, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16048, 320, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (16049, 320, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (16050, 320, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (16051, 321, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (16052, 321, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (16053, 321, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16054, 321, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (16055, 321, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (16056, 321, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (16057, 321, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16058, 321, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (16059, 321, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16060, 321, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16061, 321, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (16062, 321, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (16063, 321, 5, 107);
INSERT INTO 'capvalue' VALUES (1383, 'Motorola-ic902 Obigo/Q04C1 MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (16064, 321, 53, 1383);
INSERT INTO 'devicecapvalue' VALUES (16065, 322, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (16066, 322, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (16067, 322, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (16068, 322, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (16069, 322, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (16070, 323, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (16071, 323, 2, 2);
INSERT INTO 'capvalue' VALUES (1384, 'hasPointerMotionEvents');
INSERT INTO 'devicecapvalue' VALUES (16072, 323, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (16073, 323, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (16074, 323, 76, 683);
INSERT INTO 'devicecapvalue' VALUES (16075, 323, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16076, 323, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (16077, 323, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (16078, 323, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (16079, 323, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16080, 323, 17, 24);
INSERT INTO 'capvalue' VALUES (1385, 'windows');
INSERT INTO 'devicecapvalue' VALUES (16081, 323, 17, 1385);
INSERT INTO 'devicecapvalue' VALUES (16082, 323, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16083, 323, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (16084, 323, 94, 604);
INSERT INTO 'cap' VALUES (178, 'key.ChangeInputModeKey', 1);
INSERT INTO 'devicecapvalue' VALUES (16085, 323, 178, 745);
INSERT INTO 'devicecapvalue' VALUES (16086, 323, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (16087, 323, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (16088, 323, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (16089, 323, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (16090, 323, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (16091, 323, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (16092, 323, 98, 668);
INSERT INTO 'devicecapvalue' VALUES (16093, 323, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (16094, 323, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (16095, 323, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (16096, 323, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (16097, 323, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (16098, 323, 51, 669);
INSERT INTO 'cap' VALUES (179, 'TextField.charactersKeyPound', 1);
INSERT INTO 'cap' VALUES (180, 'TextField.useDirectInput', 1);
INSERT INTO 'devicecapvalue' VALUES (16099, 323, 180, 15);
INSERT INTO 'capvalue' VALUES (1386, '320x460');
INSERT INTO 'devicecapvalue' VALUES (16100, 324, 7, 1386);
INSERT INTO 'devicecapvalue' VALUES (16101, 324, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (16102, 324, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (16103, 324, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (16104, 324, 2, 567);
INSERT INTO 'cap' VALUES (181, 'FullScreenSize', 1);
INSERT INTO 'capvalue' VALUES (1387, '320x480');
INSERT INTO 'devicecapvalue' VALUES (16105, 324, 181, 1387);
INSERT INTO 'devicecapvalue' VALUES (16106, 324, 76, 683);
INSERT INTO 'devicecapvalue' VALUES (16107, 324, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16108, 324, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (16109, 324, 17, 21);
INSERT INTO 'capvalue' VALUES (1388, 'iphone');
INSERT INTO 'devicecapvalue' VALUES (16110, 324, 17, 1388);
INSERT INTO 'devicecapvalue' VALUES (16111, 324, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (16112, 324, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16113, 324, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (16114, 324, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16115, 324, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (16116, 324, 94, 604);
INSERT INTO 'devicecapvalue' VALUES (16117, 324, 178, 745);
INSERT INTO 'devicecapvalue' VALUES (16118, 324, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (16119, 324, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (16120, 324, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (16121, 324, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (16122, 324, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (16123, 324, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (16124, 324, 98, 668);
INSERT INTO 'devicecapvalue' VALUES (16125, 324, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (16126, 324, 4, 601);
INSERT INTO 'capvalue' VALUES (1389, '460');
INSERT INTO 'devicecapvalue' VALUES (16127, 324, 5, 1389);
INSERT INTO 'devicecapvalue' VALUES (16128, 324, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (16129, 324, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (16130, 324, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (16131, 324, 180, 15);
INSERT INTO 'capvalue' VALUES (1390, '128x115');
INSERT INTO 'devicecapvalue' VALUES (16132, 325, 7, 1390);
INSERT INTO 'devicecapvalue' VALUES (16133, 325, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (16134, 325, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (16135, 325, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (16136, 325, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (16137, 325, 11, 13);
INSERT INTO 'capvalue' VALUES (1391, '9');
INSERT INTO 'devicecapvalue' VALUES (16138, 325, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (16139, 325, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (16140, 325, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (16141, 325, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (16142, 325, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (16143, 325, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (16144, 325, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16145, 325, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (16146, 325, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16147, 325, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (16148, 325, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (16149, 325, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16150, 325, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16151, 325, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (16152, 325, 6, 879);
INSERT INTO 'capvalue' VALUES (1392, '56');
INSERT INTO 'devicecapvalue' VALUES (16153, 325, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (16154, 325, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (16155, 325, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (16156, 325, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (16157, 325, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (16158, 325, 24, 237);
INSERT INTO 'capvalue' VALUES (1393, '52');
INSERT INTO 'devicecapvalue' VALUES (16159, 325, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (16160, 325, 27, 30);
INSERT INTO 'capvalue' VALUES (1394, '54');
INSERT INTO 'devicecapvalue' VALUES (16161, 325, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (16162, 325, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (16163, 325, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (16164, 325, 40, 55);
INSERT INTO 'capvalue' VALUES (1395, 'application/x-midi');
INSERT INTO 'devicecapvalue' VALUES (16165, 325, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (16166, 325, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (16167, 325, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (16168, 325, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (16169, 325, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (16170, 325, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (16171, 325, 41, 55);
INSERT INTO 'capvalue' VALUES (1396, 'image/bmp');
INSERT INTO 'devicecapvalue' VALUES (16172, 325, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (16173, 325, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (16174, 325, 41, 52);
INSERT INTO 'capvalue' VALUES (1397, 'image/jpg');
INSERT INTO 'devicecapvalue' VALUES (16175, 325, 41, 1397);
INSERT INTO 'capvalue' VALUES (1398, 'image/png');
INSERT INTO 'devicecapvalue' VALUES (16176, 325, 41, 1398);
INSERT INTO 'capvalue' VALUES (1399, 'image/vnd.nokia.ota-bitmap');
INSERT INTO 'devicecapvalue' VALUES (16177, 325, 41, 1399);
INSERT INTO 'capvalue' VALUES (1400, 'image/vnd.wap.wbmp');
INSERT INTO 'devicecapvalue' VALUES (16178, 325, 41, 1400);
INSERT INTO 'capvalue' VALUES (1401, 'image/x-bmp');
INSERT INTO 'devicecapvalue' VALUES (16179, 325, 41, 1401);
INSERT INTO 'capvalue' VALUES (1402, 'image/x-ota-bitmap');
INSERT INTO 'devicecapvalue' VALUES (16180, 325, 41, 1402);
INSERT INTO 'capvalue' VALUES (1403, 'image/x-png');
INSERT INTO 'devicecapvalue' VALUES (16181, 325, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (16182, 325, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (16183, 325, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (16184, 325, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (16185, 325, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (16186, 325, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (16187, 325, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (16188, 325, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (16189, 325, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (16190, 325, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (16191, 325, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (16192, 325, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (16193, 325, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (16194, 325, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (16195, 325, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (16196, 325, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (16197, 325, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (16198, 325, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (16199, 325, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (16200, 325, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (16201, 325, 100, 15);
INSERT INTO 'capvalue' VALUES (1404, 'com.nokia.mid.dateformat');
INSERT INTO 'devicecapvalue' VALUES (16202, 325, 46, 1404);
INSERT INTO 'capvalue' VALUES (1405, 'com.nokia.mid.timeformat');
INSERT INTO 'devicecapvalue' VALUES (16203, 325, 46, 1405);
INSERT INTO 'capvalue' VALUES (1406, 'com.nokia.network.access');
INSERT INTO 'devicecapvalue' VALUES (16204, 325, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (16205, 325, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (16206, 325, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (16207, 325, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (16208, 325, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (16209, 325, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (16210, 325, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (16211, 325, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (16212, 325, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (16213, 325, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (16214, 325, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (16215, 325, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (16216, 325, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (16217, 325, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (16218, 325, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (16219, 325, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (16220, 325, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (16221, 325, 46, 83);
INSERT INTO 'capvalue' VALUES (1407, 'microedition.satsa.apdu.version');
INSERT INTO 'devicecapvalue' VALUES (16222, 325, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (16223, 325, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (16224, 325, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (16225, 325, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (16226, 325, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (16227, 325, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (16228, 325, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (16229, 325, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (16230, 325, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (16231, 325, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (16232, 325, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (16233, 325, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (16234, 325, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (16235, 325, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (16236, 325, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (16237, 325, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (16238, 325, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (16239, 325, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (16240, 325, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (16241, 325, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (16242, 325, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (16243, 325, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (16244, 325, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (16245, 325, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (16246, 325, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (16247, 325, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (16248, 325, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (16249, 325, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (16250, 325, 49, 1169);
INSERT INTO 'capvalue' VALUES (1408, 'Nokia1680c-2b/2.0 (05.61) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (16251, 325, 53, 1408);
INSERT INTO 'capvalue' VALUES (1409, '2006-03-30');
INSERT INTO 'devicecapvalue' VALUES (16252, 326, 158, 1409);
INSERT INTO 'devicecapvalue' VALUES (16253, 326, 1, 1);
INSERT INTO 'capvalue' VALUES (1410, 'OMA DRM Forward Lock');
INSERT INTO 'devicecapvalue' VALUES (16254, 326, 173, 1410);
INSERT INTO 'capvalue' VALUES (1411, 'OMA DRM v1.0');
INSERT INTO 'devicecapvalue' VALUES (16255, 326, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (16256, 326, 13, 1330);
INSERT INTO 'capvalue' VALUES (1412, '524288');
INSERT INTO 'devicecapvalue' VALUES (16257, 326, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (16258, 326, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (16259, 326, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (16260, 326, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16261, 326, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16262, 326, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (16263, 326, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16264, 326, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (16265, 326, 6, 27);
INSERT INTO 'capvalue' VALUES (1413, '153600');
INSERT INTO 'devicecapvalue' VALUES (16266, 326, 50, 1413);
INSERT INTO 'capvalue' VALUES (1414, 'Nokia OS');
INSERT INTO 'devicecapvalue' VALUES (16267, 326, 3, 1414);
INSERT INTO 'capvalue' VALUES (1415, 'Africa');
INSERT INTO 'devicecapvalue' VALUES (16268, 326, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (16269, 326, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (16270, 326, 156, 1023);
INSERT INTO 'capvalue' VALUES (1416, 'China');
INSERT INTO 'devicecapvalue' VALUES (16271, 326, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (16272, 326, 156, 1024);
INSERT INTO 'capvalue' VALUES (1417, 'Middle East');
INSERT INTO 'devicecapvalue' VALUES (16273, 326, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (16274, 326, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (16275, 326, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (16276, 326, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (16277, 326, 51, 102);
INSERT INTO 'capvalue' VALUES (1418, 'midi24');
INSERT INTO 'devicecapvalue' VALUES (16278, 326, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (16279, 326, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (16280, 326, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (16281, 326, 52, 1031);
INSERT INTO 'capvalue' VALUES (1419, 'Nokia2610/2.0 (03.75) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (16282, 326, 53, 1419);
INSERT INTO 'capvalue' VALUES (1420, '2006-11-28');
INSERT INTO 'devicecapvalue' VALUES (16283, 327, 158, 1420);
INSERT INTO 'devicecapvalue' VALUES (16284, 327, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (16285, 327, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (16286, 327, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (16287, 327, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (16288, 327, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (16289, 327, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (16290, 327, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (16291, 327, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16292, 327, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16293, 327, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (16294, 327, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16295, 327, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (16296, 327, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (16297, 327, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (16298, 327, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (16299, 327, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (16300, 327, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (16301, 327, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (16302, 327, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (16303, 327, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (16304, 327, 156, 1417);
INSERT INTO 'cap' VALUES (182, 'RootCertificates', 1);
INSERT INTO 'capvalue' VALUES (1421, 'UTI Root');
INSERT INTO 'devicecapvalue' VALUES (16305, 327, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (16306, 327, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (16307, 327, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (16308, 327, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (16309, 327, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (16310, 327, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (16311, 327, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (16312, 327, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (16313, 327, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (16314, 327, 52, 1031);
INSERT INTO 'capvalue' VALUES (1422, 'Nokia2626/2.0 (03.51) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (16315, 327, 53, 1422);
INSERT INTO 'devicecapvalue' VALUES (16316, 328, 56, 1);
INSERT INTO 'devicecapvalue' VALUES (16317, 328, 7, 1390);
INSERT INTO 'devicecapvalue' VALUES (16318, 328, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (16319, 328, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (16320, 328, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (16321, 328, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (16322, 328, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (16323, 328, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (16324, 328, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (16325, 328, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (16326, 328, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (16327, 328, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (16328, 328, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (16329, 328, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16330, 328, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (16331, 328, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (16332, 328, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16333, 328, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (16334, 328, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (16335, 328, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16336, 328, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16337, 328, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (16338, 328, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (16339, 328, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (16340, 328, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (16341, 328, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (16342, 328, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (16343, 328, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (16344, 328, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (16345, 328, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (16346, 328, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (16347, 328, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (16348, 328, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (16349, 328, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (16350, 328, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (16351, 328, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (16352, 328, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (16353, 328, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (16354, 328, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (16355, 328, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (16356, 328, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (16357, 328, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (16358, 328, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (16359, 328, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (16360, 328, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (16361, 328, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (16362, 328, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (16363, 328, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (16364, 328, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (16365, 328, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (16366, 328, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (16367, 328, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (16368, 328, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (16369, 328, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (16370, 328, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (16371, 328, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (16372, 328, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (16373, 328, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (16374, 328, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (16375, 328, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (16376, 328, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (16377, 328, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (16378, 328, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (16379, 328, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (16380, 328, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (16381, 328, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (16382, 328, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (16383, 328, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (16384, 328, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (16385, 328, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (16386, 328, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (16387, 328, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (16388, 328, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (16389, 328, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (16390, 328, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (16391, 328, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (16392, 328, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (16393, 328, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (16394, 328, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (16395, 328, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (16396, 328, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (16397, 328, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (16398, 328, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (16399, 328, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (16400, 328, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (16401, 328, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (16402, 328, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (16403, 328, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (16404, 328, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (16405, 328, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (16406, 328, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (16407, 328, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (16408, 328, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (16409, 328, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (16410, 328, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (16411, 328, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (16412, 328, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (16413, 328, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (16414, 328, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (16415, 328, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (16416, 328, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (16417, 328, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (16418, 328, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (16419, 328, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (16420, 328, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (16421, 328, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (16422, 328, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (16423, 328, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (16424, 328, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (16425, 328, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (16426, 328, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (16427, 328, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (16428, 328, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (16429, 328, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (16430, 328, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (16431, 328, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (16432, 328, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (16433, 328, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (16434, 328, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (16435, 328, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (16436, 328, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (16437, 328, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (16438, 328, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (16439, 328, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (16440, 328, 125, 711);
INSERT INTO 'devicecapvalue' VALUES (16441, 328, 126, 612);
INSERT INTO 'cap' VALUES (183, 'property.com.nokia.mid.dateformat', 1);
INSERT INTO 'capvalue' VALUES (1423, 'dd-MM-yyyy');
INSERT INTO 'devicecapvalue' VALUES (16442, 328, 183, 1423);
INSERT INTO 'cap' VALUES (184, 'property.com.nokia.mid.timeformat', 1);
INSERT INTO 'capvalue' VALUES (1424, 'HH:mm');
INSERT INTO 'devicecapvalue' VALUES (16443, 328, 184, 1424);
INSERT INTO 'cap' VALUES (185, 'property.com.nokia.network.access', 1);
INSERT INTO 'capvalue' VALUES (1425, 'pd');
INSERT INTO 'devicecapvalue' VALUES (16444, 328, 185, 1425);
INSERT INTO 'devicecapvalue' VALUES (16445, 328, 59, 602);
INSERT INTO 'capvalue' VALUES (1426, 'file:///C:/predefgallery/predefphotos/');
INSERT INTO 'devicecapvalue' VALUES (16446, 328, 103, 1426);
INSERT INTO 'capvalue' VALUES (1427, '/Gallery/Images/');
INSERT INTO 'devicecapvalue' VALUES (16447, 328, 104, 1427);
INSERT INTO 'capvalue' VALUES (1428, 'file:///C:/predefjava/predefgames/MIDPSysInfo_private/');
INSERT INTO 'devicecapvalue' VALUES (16448, 328, 105, 1428);
INSERT INTO 'capvalue' VALUES (1429, 'file:///C:/predefgallery/predeftones/');
INSERT INTO 'devicecapvalue' VALUES (16449, 328, 106, 1429);
INSERT INTO 'capvalue' VALUES (1430, '/Gallery/Tones/');
INSERT INTO 'devicecapvalue' VALUES (16450, 328, 107, 1430);
INSERT INTO 'capvalue' VALUES (1431, 'file:///C:/predefgallery/predefvideos/');
INSERT INTO 'devicecapvalue' VALUES (16451, 328, 108, 1431);
INSERT INTO 'capvalue' VALUES (1432, '/Gallery/Video clips/');
INSERT INTO 'devicecapvalue' VALUES (16452, 328, 109, 1432);
INSERT INTO 'devicecapvalue' VALUES (16453, 328, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (16454, 328, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (16455, 328, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (16456, 328, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (16457, 328, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (16458, 328, 67, 45);
INSERT INTO 'capvalue' VALUES (1433, 'Nokia2630/05.61');
INSERT INTO 'devicecapvalue' VALUES (16459, 328, 68, 1433);
INSERT INTO 'devicecapvalue' VALUES (16460, 328, 69, 924);
INSERT INTO 'cap' VALUES (186, 'property.microedition.satsa.apdu.version', 1);
INSERT INTO 'devicecapvalue' VALUES (16461, 328, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (16462, 328, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (16463, 328, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (16464, 328, 71, 244);
INSERT INTO 'capvalue' VALUES (1434, 'http://mms.movistar.com');
INSERT INTO 'devicecapvalue' VALUES (16465, 328, 138, 1434);
INSERT INTO 'capvalue' VALUES (1435, '+34609090909');
INSERT INTO 'devicecapvalue' VALUES (16466, 328, 72, 1435);
INSERT INTO 'devicecapvalue' VALUES (16467, 328, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (16468, 328, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (16469, 328, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (16470, 328, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (16471, 328, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (16472, 328, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (16473, 328, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (16474, 328, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (16475, 328, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (16476, 328, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (16477, 328, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (16478, 328, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (16479, 328, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (16480, 328, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (16481, 328, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (16482, 328, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (16483, 328, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (16484, 328, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (16485, 328, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (16486, 328, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (16487, 328, 49, 1169);
INSERT INTO 'capvalue' VALUES (1436, 'Nokia2630/2.0 (05.61) Profile/MIDP-2.1 Configuration/CLDC-1.1 UP.Link/6.3.1.15.0');
INSERT INTO 'devicecapvalue' VALUES (16488, 328, 53, 1436);
INSERT INTO 'capvalue' VALUES (1437, '240x248');
INSERT INTO 'devicecapvalue' VALUES (16489, 329, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (16490, 329, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (16491, 329, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (16492, 329, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (16493, 329, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (16494, 329, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (16495, 329, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (16496, 329, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (16497, 329, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (16498, 329, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (16499, 329, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (16500, 329, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (16501, 329, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16502, 329, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (16503, 329, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (16504, 329, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (16505, 329, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (16506, 329, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16507, 329, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (16508, 329, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (16509, 329, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (16510, 329, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (16511, 329, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16512, 329, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16513, 329, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (16514, 329, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (16515, 329, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (16516, 329, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (16517, 329, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (16518, 329, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (16519, 329, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (16520, 329, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (16521, 329, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (16522, 329, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (16523, 329, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (16524, 329, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (16525, 329, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (16526, 329, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (16527, 329, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (16528, 329, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (16529, 329, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (16530, 329, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (16531, 329, 35, 45);
INSERT INTO 'capvalue' VALUES (1438, 'Nokia2700c-2/07.15');
INSERT INTO 'devicecapvalue' VALUES (16532, 329, 36, 1438);
INSERT INTO 'devicecapvalue' VALUES (16533, 329, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (16534, 329, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (16535, 329, 39, 866);
INSERT INTO 'capvalue' VALUES (1439, 'image');
INSERT INTO 'devicecapvalue' VALUES (16536, 329, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (16537, 329, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (16538, 329, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (16539, 329, 40, 55);
INSERT INTO 'capvalue' VALUES (1440, 'application/3gp');
INSERT INTO 'devicecapvalue' VALUES (16540, 329, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (16541, 329, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (16542, 329, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (16543, 329, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (16544, 329, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (16545, 329, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (16546, 329, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (16547, 329, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (16548, 329, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (16549, 329, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (16550, 329, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (16551, 329, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (16552, 329, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (16553, 329, 41, 886);
INSERT INTO 'capvalue' VALUES (1441, 'audio/mpg3');
INSERT INTO 'devicecapvalue' VALUES (16554, 329, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (16555, 329, 41, 64);
INSERT INTO 'capvalue' VALUES (1442, 'audio/vnd.nokia.mobile-xmf');
INSERT INTO 'devicecapvalue' VALUES (16556, 329, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (16557, 329, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (16558, 329, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (16559, 329, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (16560, 329, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (16561, 329, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (16562, 329, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (16563, 329, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (16564, 329, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (16565, 329, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (16566, 329, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (16567, 329, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (16568, 329, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (16569, 329, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (16570, 329, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (16571, 329, 41, 1399);
INSERT INTO 'capvalue' VALUES (1443, 'image/vnd.nokia.wbmp');
INSERT INTO 'devicecapvalue' VALUES (16572, 329, 41, 1443);
INSERT INTO 'devicecapvalue' VALUES (16573, 329, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (16574, 329, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (16575, 329, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (16576, 329, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (16577, 329, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (16578, 329, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (16579, 329, 41, 67);
INSERT INTO 'capvalue' VALUES (1444, 'video/mpeg');
INSERT INTO 'devicecapvalue' VALUES (16580, 329, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (16581, 329, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (16582, 329, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (16583, 329, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (16584, 329, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (16585, 329, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (16586, 329, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (16587, 329, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (16588, 329, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (16589, 329, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (16590, 329, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (16591, 329, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (16592, 329, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (16593, 329, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (16594, 329, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (16595, 329, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (16596, 329, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (16597, 329, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (16598, 329, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (16599, 329, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (16600, 329, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (16601, 329, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (16602, 329, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (16603, 329, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (16604, 329, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (16605, 329, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (16606, 329, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (16607, 329, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (16608, 329, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (16609, 329, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (16610, 329, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (16611, 329, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (16612, 329, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (16613, 329, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (16614, 329, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (16615, 329, 42, 1443);
INSERT INTO 'devicecapvalue' VALUES (16616, 329, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (16617, 329, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (16618, 329, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (16619, 329, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (16620, 329, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (16621, 329, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (16622, 329, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (16623, 329, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (16624, 329, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (16625, 329, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (16626, 329, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (16627, 329, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (16628, 329, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (16629, 329, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (16630, 329, 46, 69);
INSERT INTO 'capvalue' VALUES (1445, 'audio.samplerates');
INSERT INTO 'devicecapvalue' VALUES (16631, 329, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (16632, 329, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (16633, 329, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (16634, 329, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (16635, 329, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (16636, 329, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (16637, 329, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (16638, 329, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (16639, 329, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (16640, 329, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (16641, 329, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (16642, 329, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (16643, 329, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (16644, 329, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (16645, 329, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (16646, 329, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (16647, 329, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (16648, 329, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (16649, 329, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (16650, 329, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (16651, 329, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (16652, 329, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (16653, 329, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (16654, 329, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (16655, 329, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (16656, 329, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (16657, 329, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (16658, 329, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (16659, 329, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (16660, 329, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (16661, 329, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (16662, 329, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (16663, 329, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (16664, 329, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (16665, 329, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (16666, 329, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (16667, 329, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (16668, 329, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (16669, 329, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (16670, 329, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (16671, 329, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (16672, 329, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (16673, 329, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (16674, 329, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (16675, 329, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (16676, 329, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (16677, 329, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (16678, 329, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (16679, 329, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (16680, 329, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (16681, 329, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (16682, 329, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (16683, 329, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (16684, 329, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (16685, 329, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (16686, 329, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (16687, 329, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (16688, 329, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (16689, 329, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (16690, 329, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (16691, 329, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (16692, 329, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (16693, 329, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (16694, 329, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (16695, 329, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (16696, 329, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (16697, 329, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (16698, 329, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (16699, 329, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (16700, 329, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (16701, 329, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (16702, 329, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (16703, 329, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (16704, 329, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (16705, 329, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (16706, 329, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (16707, 329, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (16708, 329, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (16709, 329, 73, 870);
INSERT INTO 'devicecapvalue' VALUES (16710, 329, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (16711, 329, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (16712, 329, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (16713, 329, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (16714, 329, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (16715, 329, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (16716, 329, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (16717, 329, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (16718, 329, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (16719, 329, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (16720, 329, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (16721, 329, 73, 1443);
INSERT INTO 'devicecapvalue' VALUES (16722, 329, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (16723, 329, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (16724, 329, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (16725, 329, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (16726, 329, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (16727, 329, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (16728, 329, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (16729, 329, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (16730, 329, 73, 620);
INSERT INTO 'devicecapvalue' VALUES (16731, 329, 73, 622);
INSERT INTO 'devicecapvalue' VALUES (16732, 329, 47, 1440);
INSERT INTO 'capvalue' VALUES (1446, 'application/octet-stream');
INSERT INTO 'devicecapvalue' VALUES (16733, 329, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (16734, 329, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (16735, 329, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (16736, 329, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (16737, 329, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (16738, 329, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (16739, 329, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (16740, 329, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (16741, 329, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (16742, 329, 49, 1031);
INSERT INTO 'capvalue' VALUES (1447, 'Nokia2700c-2/2.0 (07.15) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (16743, 329, 53, 1447);
INSERT INTO 'devicecapvalue' VALUES (16744, 330, 56, 1);
INSERT INTO 'devicecapvalue' VALUES (16745, 330, 7, 1390);
INSERT INTO 'devicecapvalue' VALUES (16746, 330, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (16747, 330, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (16748, 330, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (16749, 330, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (16750, 330, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (16751, 330, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (16752, 330, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (16753, 330, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (16754, 330, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (16755, 330, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (16756, 330, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (16757, 330, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16758, 330, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (16759, 330, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (16760, 330, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16761, 330, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (16762, 330, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (16763, 330, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16764, 330, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16765, 330, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (16766, 330, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (16767, 330, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (16768, 330, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (16769, 330, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (16770, 330, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (16771, 330, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (16772, 330, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (16773, 330, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (16774, 330, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (16775, 330, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (16776, 330, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (16777, 330, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (16778, 330, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (16779, 330, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (16780, 330, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (16781, 330, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (16782, 330, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (16783, 330, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (16784, 330, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (16785, 330, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (16786, 330, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (16787, 330, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (16788, 330, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (16789, 330, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (16790, 330, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (16791, 330, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (16792, 330, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (16793, 330, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (16794, 330, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (16795, 330, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (16796, 330, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (16797, 330, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (16798, 330, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (16799, 330, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (16800, 330, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (16801, 330, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (16802, 330, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (16803, 330, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (16804, 330, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (16805, 330, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (16806, 330, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (16807, 330, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (16808, 330, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (16809, 330, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (16810, 330, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (16811, 330, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (16812, 330, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (16813, 330, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (16814, 330, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (16815, 330, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (16816, 330, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (16817, 330, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (16818, 330, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (16819, 330, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (16820, 330, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (16821, 330, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (16822, 330, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (16823, 330, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (16824, 330, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (16825, 330, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (16826, 330, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (16827, 330, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (16828, 330, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (16829, 330, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (16830, 330, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (16831, 330, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (16832, 330, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (16833, 330, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (16834, 330, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (16835, 330, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (16836, 330, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (16837, 330, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (16838, 330, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (16839, 330, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (16840, 330, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (16841, 330, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (16842, 330, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (16843, 330, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (16844, 330, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (16845, 330, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (16846, 330, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (16847, 330, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (16848, 330, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (16849, 330, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (16850, 330, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (16851, 330, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (16852, 330, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (16853, 330, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (16854, 330, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (16855, 330, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (16856, 330, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (16857, 330, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (16858, 330, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (16859, 330, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (16860, 330, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (16861, 330, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (16862, 330, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (16863, 330, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (16864, 330, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (16865, 330, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (16866, 330, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (16867, 330, 125, 711);
INSERT INTO 'devicecapvalue' VALUES (16868, 330, 126, 612);
INSERT INTO 'capvalue' VALUES (1448, 'dd.MM.yyyy');
INSERT INTO 'devicecapvalue' VALUES (16869, 330, 183, 1448);
INSERT INTO 'devicecapvalue' VALUES (16870, 330, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (16871, 330, 185, 1425);
INSERT INTO 'devicecapvalue' VALUES (16872, 330, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (16873, 330, 103, 1426);
INSERT INTO 'capvalue' VALUES (1449, '/Galerie/Fotos/');
INSERT INTO 'devicecapvalue' VALUES (16874, 330, 104, 1449);
INSERT INTO 'devicecapvalue' VALUES (16875, 330, 105, 1428);
INSERT INTO 'devicecapvalue' VALUES (16876, 330, 106, 1429);
INSERT INTO 'capvalue' VALUES (1450, '/Galerie/T?ne/');
INSERT INTO 'devicecapvalue' VALUES (16877, 330, 107, 1450);
INSERT INTO 'devicecapvalue' VALUES (16878, 330, 108, 1431);
INSERT INTO 'capvalue' VALUES (1451, '/Galerie/Videoclips/');
INSERT INTO 'devicecapvalue' VALUES (16879, 330, 109, 1451);
INSERT INTO 'devicecapvalue' VALUES (16880, 330, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (16881, 330, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (16882, 330, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (16883, 330, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (16884, 330, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (16885, 330, 67, 45);
INSERT INTO 'capvalue' VALUES (1452, 'Nokia2760/06.82');
INSERT INTO 'devicecapvalue' VALUES (16886, 330, 68, 1452);
INSERT INTO 'devicecapvalue' VALUES (16887, 330, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (16888, 330, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (16889, 330, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (16890, 330, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (16891, 330, 71, 244);
INSERT INTO 'capvalue' VALUES (1453, 'http://mms/eplus/');
INSERT INTO 'devicecapvalue' VALUES (16892, 330, 138, 1453);
INSERT INTO 'capvalue' VALUES (1454, '+491770610000');
INSERT INTO 'devicecapvalue' VALUES (16893, 330, 72, 1454);
INSERT INTO 'devicecapvalue' VALUES (16894, 330, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (16895, 330, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (16896, 330, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (16897, 330, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (16898, 330, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (16899, 330, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (16900, 330, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (16901, 330, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (16902, 330, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (16903, 330, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (16904, 330, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (16905, 330, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (16906, 330, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (16907, 330, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (16908, 330, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (16909, 330, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (16910, 330, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (16911, 330, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (16912, 330, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (16913, 330, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (16914, 330, 49, 1169);
INSERT INTO 'capvalue' VALUES (1455, 'Nokia2760/2.0 (06.82) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (16915, 330, 53, 1455);
INSERT INTO 'capvalue' VALUES (1456, '2005-10-26');
INSERT INTO 'devicecapvalue' VALUES (16916, 331, 158, 1456);
INSERT INTO 'devicecapvalue' VALUES (16917, 331, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (16918, 331, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (16919, 331, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (16920, 331, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (16921, 331, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (16922, 331, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (16923, 331, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16924, 331, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (16925, 331, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (16926, 331, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16927, 331, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (16928, 331, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16929, 331, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (16930, 331, 6, 27);
INSERT INTO 'capvalue' VALUES (1457, '512000');
INSERT INTO 'devicecapvalue' VALUES (16931, 331, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (16932, 331, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (16933, 331, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (16934, 331, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (16935, 331, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (16936, 331, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (16937, 331, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (16938, 331, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (16939, 331, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (16940, 331, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (16941, 331, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (16942, 331, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (16943, 331, 51, 569);
INSERT INTO 'capvalue' VALUES (1458, 'qcelp');
INSERT INTO 'devicecapvalue' VALUES (16944, 331, 51, 1458);
INSERT INTO 'devicecapvalue' VALUES (16945, 331, 51, 103);
INSERT INTO 'capvalue' VALUES (1459, 'truetone');
INSERT INTO 'devicecapvalue' VALUES (16946, 331, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (16947, 331, 51, 1085);
INSERT INTO 'capvalue' VALUES (1460, '12582912');
INSERT INTO 'devicecapvalue' VALUES (16948, 331, 52, 1460);
INSERT INTO 'devicecapvalue' VALUES (16949, 331, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (16950, 331, 157, 1134);
INSERT INTO 'capvalue' VALUES (1461, 'h.264');
INSERT INTO 'devicecapvalue' VALUES (16951, 331, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (16952, 331, 157, 1026);
INSERT INTO 'capvalue' VALUES (1462, 'Nokia2855');
INSERT INTO 'devicecapvalue' VALUES (16953, 331, 53, 1462);
INSERT INTO 'capvalue' VALUES (1463, '2006-04-05');
INSERT INTO 'devicecapvalue' VALUES (16954, 332, 158, 1463);
INSERT INTO 'devicecapvalue' VALUES (16955, 332, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (16956, 332, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (16957, 332, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (16958, 332, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (16959, 332, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (16960, 332, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (16961, 332, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (16962, 332, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (16963, 332, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (16964, 332, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (16965, 332, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (16966, 332, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (16967, 332, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (16968, 332, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (16969, 332, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (16970, 332, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (16971, 332, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (16972, 332, 156, 1416);
INSERT INTO 'capvalue' VALUES (1464, 'Latin America');
INSERT INTO 'devicecapvalue' VALUES (16973, 332, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (16974, 332, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (16975, 332, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (16976, 332, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (16977, 332, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (16978, 332, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (16979, 332, 51, 100);
INSERT INTO 'capvalue' VALUES (1465, 'eaac');
INSERT INTO 'devicecapvalue' VALUES (16980, 332, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (16981, 332, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (16982, 332, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (16983, 332, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (16984, 332, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (16985, 332, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (16986, 332, 51, 1458);
INSERT INTO 'devicecapvalue' VALUES (16987, 332, 52, 1460);
INSERT INTO 'devicecapvalue' VALUES (16988, 332, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (16989, 332, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (16990, 332, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (16991, 332, 157, 1026);
INSERT INTO 'capvalue' VALUES (1466, 'Nokia2865');
INSERT INTO 'devicecapvalue' VALUES (16992, 332, 53, 1466);
INSERT INTO 'devicecapvalue' VALUES (16993, 333, 158, 1463);
INSERT INTO 'devicecapvalue' VALUES (16994, 333, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (16995, 333, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (16996, 333, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (16997, 333, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (16998, 333, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (16999, 333, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (17000, 333, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (17001, 333, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (17002, 333, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17003, 333, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (17004, 333, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (17005, 333, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17006, 333, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (17007, 333, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (17008, 333, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (17009, 333, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (17010, 333, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (17011, 333, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (17012, 333, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (17013, 333, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (17014, 333, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (17015, 333, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (17016, 333, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (17017, 333, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (17018, 333, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (17019, 333, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (17020, 333, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (17021, 333, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (17022, 333, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (17023, 333, 51, 1458);
INSERT INTO 'devicecapvalue' VALUES (17024, 333, 52, 1460);
INSERT INTO 'devicecapvalue' VALUES (17025, 333, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (17026, 333, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (17027, 333, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (17028, 333, 157, 1026);
INSERT INTO 'capvalue' VALUES (1467, 'Nokia2865i');
INSERT INTO 'devicecapvalue' VALUES (17029, 333, 53, 1467);
INSERT INTO 'devicecapvalue' VALUES (17030, 334, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (17031, 334, 79, 15);
INSERT INTO 'devicecapvalue' VALUES (17032, 334, 7, 1390);
INSERT INTO 'devicecapvalue' VALUES (17033, 334, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (17034, 334, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (17035, 334, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (17036, 334, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (17037, 334, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (17038, 334, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (17039, 334, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (17040, 334, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (17041, 334, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (17042, 334, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (17043, 334, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (17044, 334, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17045, 334, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (17046, 334, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (17047, 334, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17048, 334, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (17049, 334, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (17050, 334, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (17051, 334, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (17052, 334, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17053, 334, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17054, 334, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (17055, 334, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (17056, 334, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (17057, 334, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (17058, 334, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (17059, 334, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (17060, 334, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (17061, 334, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (17062, 334, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (17063, 334, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (17064, 334, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (17065, 334, 57, 30);
INSERT INTO 'devicecapvalue' VALUES (17066, 334, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (17067, 334, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (17068, 334, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (17069, 334, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (17070, 334, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (17071, 334, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (17072, 334, 39, 1439);
INSERT INTO 'capvalue' VALUES (1468, 'radio');
INSERT INTO 'devicecapvalue' VALUES (17073, 334, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (17074, 334, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (17075, 334, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (17076, 334, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (17077, 334, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (17078, 334, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (17079, 334, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (17080, 334, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (17081, 334, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (17082, 334, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (17083, 334, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (17084, 334, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (17085, 334, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (17086, 334, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (17087, 334, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (17088, 334, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (17089, 334, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (17090, 334, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (17091, 334, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (17092, 334, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (17093, 334, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (17094, 334, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (17095, 334, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (17096, 334, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (17097, 334, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (17098, 334, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (17099, 334, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (17100, 334, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (17101, 334, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (17102, 334, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (17103, 334, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (17104, 334, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (17105, 334, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (17106, 334, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (17107, 334, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (17108, 334, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (17109, 334, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (17110, 334, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (17111, 334, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (17112, 334, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (17113, 334, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (17114, 334, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (17115, 334, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (17116, 334, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (17117, 334, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (17118, 334, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (17119, 334, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (17120, 334, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (17121, 334, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (17122, 334, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (17123, 334, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (17124, 334, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (17125, 334, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (17126, 334, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (17127, 334, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (17128, 334, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (17129, 334, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (17130, 334, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (17131, 334, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (17132, 334, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (17133, 334, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (17134, 334, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (17135, 334, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (17136, 334, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (17137, 334, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (17138, 334, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (17139, 334, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (17140, 334, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (17141, 334, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (17142, 334, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (17143, 334, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (17144, 334, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (17145, 334, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (17146, 334, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (17147, 334, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (17148, 334, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (17149, 334, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (17150, 334, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (17151, 334, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (17152, 334, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (17153, 334, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (17154, 334, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (17155, 334, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (17156, 334, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (17157, 334, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (17158, 334, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (17159, 334, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (17160, 334, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (17161, 334, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (17162, 334, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (17163, 334, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (17164, 334, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (17165, 334, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (17166, 334, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (17167, 334, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (17168, 334, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (17169, 334, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (17170, 334, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (17171, 334, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (17172, 334, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (17173, 334, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (17174, 334, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (17175, 334, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (17176, 334, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (17177, 334, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (17178, 334, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (17179, 334, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (17180, 334, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (17181, 334, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (17182, 334, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (17183, 334, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (17184, 334, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (17185, 334, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (17186, 334, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (17187, 334, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (17188, 334, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (17189, 334, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (17190, 334, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (17191, 334, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (17192, 334, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (17193, 334, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (17194, 334, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (17195, 334, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (17196, 334, 115, 1258);
INSERT INTO 'devicecapvalue' VALUES (17197, 334, 117, 45);
INSERT INTO 'devicecapvalue' VALUES (17198, 334, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (17199, 334, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (17200, 334, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (17201, 334, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (17202, 334, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (17203, 334, 183, 1423);
INSERT INTO 'devicecapvalue' VALUES (17204, 334, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (17205, 334, 185, 1425);
INSERT INTO 'devicecapvalue' VALUES (17206, 334, 59, 602);
INSERT INTO 'capvalue' VALUES (1469, 'file:///E:/');
INSERT INTO 'devicecapvalue' VALUES (17207, 334, 101, 1469);
INSERT INTO 'capvalue' VALUES (1470, '/Gallery/Memory card/');
INSERT INTO 'devicecapvalue' VALUES (17208, 334, 102, 1470);
INSERT INTO 'devicecapvalue' VALUES (17209, 334, 103, 1426);
INSERT INTO 'devicecapvalue' VALUES (17210, 334, 104, 1427);
INSERT INTO 'devicecapvalue' VALUES (17211, 334, 106, 1429);
INSERT INTO 'devicecapvalue' VALUES (17212, 334, 107, 1430);
INSERT INTO 'devicecapvalue' VALUES (17213, 334, 108, 1431);
INSERT INTO 'devicecapvalue' VALUES (17214, 334, 109, 1432);
INSERT INTO 'devicecapvalue' VALUES (17215, 334, 114, 1260);
INSERT INTO 'capvalue' VALUES (1471, 'IR0');
INSERT INTO 'devicecapvalue' VALUES (17216, 334, 114, 1471);
INSERT INTO 'devicecapvalue' VALUES (17217, 334, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (17218, 334, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (17219, 334, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (17220, 334, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (17221, 334, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (17222, 334, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (17223, 334, 130, 45);
INSERT INTO 'devicecapvalue' VALUES (17224, 334, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (17225, 334, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (17226, 334, 67, 45);
INSERT INTO 'capvalue' VALUES (1472, 'Nokia3110c/04.91');
INSERT INTO 'devicecapvalue' VALUES (17227, 334, 68, 1472);
INSERT INTO 'devicecapvalue' VALUES (17228, 334, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (17229, 334, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (17230, 334, 132, 1258);
INSERT INTO 'devicecapvalue' VALUES (17231, 334, 133, 68);
INSERT INTO 'devicecapvalue' VALUES (17232, 334, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (17233, 334, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (17234, 334, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (17235, 334, 136, 68);
INSERT INTO 'devicecapvalue' VALUES (17236, 334, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (17237, 334, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (17238, 334, 137, 1397);
INSERT INTO 'capvalue' VALUES (1473, 'http://mms.mtn.co.za/mms/wapenc');
INSERT INTO 'devicecapvalue' VALUES (17239, 334, 138, 1473);
INSERT INTO 'capvalue' VALUES (1474, '+27829129');
INSERT INTO 'devicecapvalue' VALUES (17240, 334, 72, 1474);
INSERT INTO 'devicecapvalue' VALUES (17241, 334, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (17242, 334, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (17243, 334, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (17244, 334, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (17245, 334, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (17246, 334, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (17247, 334, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (17248, 334, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (17249, 334, 49, 1031);
INSERT INTO 'capvalue' VALUES (1475, 'Mozilla/5.0 (compatible; OpenWeb 5.7.2-10) Opera 8.54');
INSERT INTO 'devicecapvalue' VALUES (17250, 334, 53, 1475);
INSERT INTO 'devicecapvalue' VALUES (17251, 335, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (17252, 335, 79, 15);
INSERT INTO 'devicecapvalue' VALUES (17253, 335, 7, 1390);
INSERT INTO 'devicecapvalue' VALUES (17254, 335, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (17255, 335, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (17256, 335, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (17257, 335, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (17258, 335, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (17259, 335, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (17260, 335, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (17261, 335, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (17262, 335, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (17263, 335, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (17264, 335, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (17265, 335, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17266, 335, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (17267, 335, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (17268, 335, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17269, 335, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (17270, 335, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (17271, 335, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (17272, 335, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (17273, 335, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17274, 335, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17275, 335, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (17276, 335, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (17277, 335, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (17278, 335, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (17279, 335, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (17280, 335, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (17281, 335, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (17282, 335, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (17283, 335, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (17284, 335, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (17285, 335, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (17286, 335, 57, 30);
INSERT INTO 'devicecapvalue' VALUES (17287, 335, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (17288, 335, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (17289, 335, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (17290, 335, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (17291, 335, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (17292, 335, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (17293, 335, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (17294, 335, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (17295, 335, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (17296, 335, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (17297, 335, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (17298, 335, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (17299, 335, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (17300, 335, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (17301, 335, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (17302, 335, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (17303, 335, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (17304, 335, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (17305, 335, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (17306, 335, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (17307, 335, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (17308, 335, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (17309, 335, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (17310, 335, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (17311, 335, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (17312, 335, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (17313, 335, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (17314, 335, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (17315, 335, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (17316, 335, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (17317, 335, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (17318, 335, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (17319, 335, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (17320, 335, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (17321, 335, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (17322, 335, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (17323, 335, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (17324, 335, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (17325, 335, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (17326, 335, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (17327, 335, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (17328, 335, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (17329, 335, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (17330, 335, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (17331, 335, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (17332, 335, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (17333, 335, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (17334, 335, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (17335, 335, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (17336, 335, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (17337, 335, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (17338, 335, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (17339, 335, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (17340, 335, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (17341, 335, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (17342, 335, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (17343, 335, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (17344, 335, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (17345, 335, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (17346, 335, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (17347, 335, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (17348, 335, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (17349, 335, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (17350, 335, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (17351, 335, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (17352, 335, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (17353, 335, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (17354, 335, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (17355, 335, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (17356, 335, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (17357, 335, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (17358, 335, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (17359, 335, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (17360, 335, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (17361, 335, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (17362, 335, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (17363, 335, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (17364, 335, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (17365, 335, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (17366, 335, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (17367, 335, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (17368, 335, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (17369, 335, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (17370, 335, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (17371, 335, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (17372, 335, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (17373, 335, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (17374, 335, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (17375, 335, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (17376, 335, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (17377, 335, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (17378, 335, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (17379, 335, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (17380, 335, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (17381, 335, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (17382, 335, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (17383, 335, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (17384, 335, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (17385, 335, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (17386, 335, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (17387, 335, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (17388, 335, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (17389, 335, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (17390, 335, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (17391, 335, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (17392, 335, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (17393, 335, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (17394, 335, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (17395, 335, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (17396, 335, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (17397, 335, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (17398, 335, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (17399, 335, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (17400, 335, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (17401, 335, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (17402, 335, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (17403, 335, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (17404, 335, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (17405, 335, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (17406, 335, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (17407, 335, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (17408, 335, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (17409, 335, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (17410, 335, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (17411, 335, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (17412, 335, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (17413, 335, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (17414, 335, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (17415, 335, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (17416, 335, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (17417, 335, 115, 1258);
INSERT INTO 'devicecapvalue' VALUES (17418, 335, 117, 45);
INSERT INTO 'devicecapvalue' VALUES (17419, 335, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (17420, 335, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (17421, 335, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (17422, 335, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (17423, 335, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (17424, 335, 183, 1423);
INSERT INTO 'devicecapvalue' VALUES (17425, 335, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (17426, 335, 185, 1425);
INSERT INTO 'devicecapvalue' VALUES (17427, 335, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (17428, 335, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (17429, 335, 102, 1470);
INSERT INTO 'devicecapvalue' VALUES (17430, 335, 103, 1426);
INSERT INTO 'devicecapvalue' VALUES (17431, 335, 104, 1427);
INSERT INTO 'devicecapvalue' VALUES (17432, 335, 106, 1429);
INSERT INTO 'devicecapvalue' VALUES (17433, 335, 107, 1430);
INSERT INTO 'devicecapvalue' VALUES (17434, 335, 108, 1431);
INSERT INTO 'devicecapvalue' VALUES (17435, 335, 109, 1432);
INSERT INTO 'devicecapvalue' VALUES (17436, 335, 114, 1260);
INSERT INTO 'devicecapvalue' VALUES (17437, 335, 114, 1471);
INSERT INTO 'devicecapvalue' VALUES (17438, 335, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (17439, 335, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (17440, 335, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (17441, 335, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (17442, 335, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (17443, 335, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (17444, 335, 130, 45);
INSERT INTO 'devicecapvalue' VALUES (17445, 335, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (17446, 335, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (17447, 335, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (17448, 335, 68, 1472);
INSERT INTO 'devicecapvalue' VALUES (17449, 335, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (17450, 335, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (17451, 335, 132, 1258);
INSERT INTO 'devicecapvalue' VALUES (17452, 335, 133, 68);
INSERT INTO 'devicecapvalue' VALUES (17453, 335, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (17454, 335, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (17455, 335, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (17456, 335, 136, 68);
INSERT INTO 'devicecapvalue' VALUES (17457, 335, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (17458, 335, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (17459, 335, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (17460, 335, 138, 1473);
INSERT INTO 'devicecapvalue' VALUES (17461, 335, 72, 1474);
INSERT INTO 'devicecapvalue' VALUES (17462, 335, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (17463, 335, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (17464, 335, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (17465, 335, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (17466, 335, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (17467, 335, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (17468, 335, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (17469, 335, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (17470, 335, 49, 1031);
INSERT INTO 'devicecapvalue' VALUES (17471, 335, 53, 1475);
INSERT INTO 'capvalue' VALUES (1476, '2008-04-28');
INSERT INTO 'devicecapvalue' VALUES (17472, 336, 158, 1476);
INSERT INTO 'capvalue' VALUES (1477, '2048x1536');
INSERT INTO 'devicecapvalue' VALUES (17473, 336, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (17474, 336, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (17475, 336, 173, 1411);
INSERT INTO 'capvalue' VALUES (1478, 'OMA DRM v2.0');
INSERT INTO 'devicecapvalue' VALUES (17476, 336, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (17477, 336, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (17478, 336, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (17479, 336, 16, 20);
INSERT INTO 'capvalue' VALUES (1479, 'jsr120');
INSERT INTO 'devicecapvalue' VALUES (17480, 336, 17, 1479);
INSERT INTO 'capvalue' VALUES (1480, 'jsr135');
INSERT INTO 'devicecapvalue' VALUES (17481, 336, 17, 1480);
INSERT INTO 'capvalue' VALUES (1481, 'jsr172');
INSERT INTO 'devicecapvalue' VALUES (17482, 336, 17, 1481);
INSERT INTO 'capvalue' VALUES (1482, 'jsr177');
INSERT INTO 'devicecapvalue' VALUES (17483, 336, 17, 1482);
INSERT INTO 'capvalue' VALUES (1483, 'jsr184');
INSERT INTO 'devicecapvalue' VALUES (17484, 336, 17, 1483);
INSERT INTO 'capvalue' VALUES (1484, 'jsr205');
INSERT INTO 'devicecapvalue' VALUES (17485, 336, 17, 1484);
INSERT INTO 'capvalue' VALUES (1485, 'jsr211');
INSERT INTO 'devicecapvalue' VALUES (17486, 336, 17, 1485);
INSERT INTO 'capvalue' VALUES (1486, 'jsr226');
INSERT INTO 'devicecapvalue' VALUES (17487, 336, 17, 1486);
INSERT INTO 'capvalue' VALUES (1487, 'jsr234');
INSERT INTO 'devicecapvalue' VALUES (17488, 336, 17, 1487);
INSERT INTO 'capvalue' VALUES (1488, 'jsr75');
INSERT INTO 'devicecapvalue' VALUES (17489, 336, 17, 1488);
INSERT INTO 'capvalue' VALUES (1489, 'jsr82');
INSERT INTO 'devicecapvalue' VALUES (17490, 336, 17, 1489);
INSERT INTO 'devicecapvalue' VALUES (17491, 336, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (17492, 336, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (17493, 336, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (17494, 336, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (17495, 336, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (17496, 336, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (17497, 336, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (17498, 336, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (17499, 336, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (17500, 336, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (17501, 336, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (17502, 336, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (17503, 336, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (17504, 336, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (17505, 336, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (17506, 336, 52, 1019);
INSERT INTO 'devicecapvalue' VALUES (17507, 337, 158, 1476);
INSERT INTO 'devicecapvalue' VALUES (17508, 337, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (17509, 337, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (17510, 337, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (17511, 337, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (17512, 337, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (17513, 337, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (17514, 337, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (17515, 337, 17, 1479);
INSERT INTO 'devicecapvalue' VALUES (17516, 337, 17, 1480);
INSERT INTO 'devicecapvalue' VALUES (17517, 337, 17, 1481);
INSERT INTO 'devicecapvalue' VALUES (17518, 337, 17, 1482);
INSERT INTO 'devicecapvalue' VALUES (17519, 337, 17, 1483);
INSERT INTO 'devicecapvalue' VALUES (17520, 337, 17, 1484);
INSERT INTO 'devicecapvalue' VALUES (17521, 337, 17, 1485);
INSERT INTO 'devicecapvalue' VALUES (17522, 337, 17, 1486);
INSERT INTO 'devicecapvalue' VALUES (17523, 337, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (17524, 337, 17, 1488);
INSERT INTO 'devicecapvalue' VALUES (17525, 337, 17, 1489);
INSERT INTO 'devicecapvalue' VALUES (17526, 337, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (17527, 337, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (17528, 337, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (17529, 337, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (17530, 337, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (17531, 337, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (17532, 337, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (17533, 337, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (17534, 337, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (17535, 337, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (17536, 337, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (17537, 337, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (17538, 337, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (17539, 337, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (17540, 337, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (17541, 337, 52, 1019);
INSERT INTO 'capvalue' VALUES (1490, '2005-03-14');
INSERT INTO 'devicecapvalue' VALUES (17542, 338, 158, 1490);
INSERT INTO 'devicecapvalue' VALUES (17543, 338, 1, 106);
INSERT INTO 'capvalue' VALUES (1491, '1MP');
INSERT INTO 'devicecapvalue' VALUES (17544, 338, 160, 1491);
INSERT INTO 'devicecapvalue' VALUES (17545, 338, 173, 1411);
INSERT INTO 'capvalue' VALUES (1492, '\Devices\Nokia_Prototype_SDK_3_0\devices\Prototype_3_0_S40_128x160_MIDP_Emulator');
INSERT INTO 'devicecapvalue' VALUES (17546, 338, 75, 1492);
INSERT INTO 'cap' VALUES (187, 'ExternalBitsPerPixel', 1);
INSERT INTO 'devicecapvalue' VALUES (17547, 338, 187, 612);
INSERT INTO 'capvalue' VALUES (1493, '96x65');
INSERT INTO 'devicecapvalue' VALUES (17548, 338, 167, 1493);
INSERT INTO 'devicecapvalue' VALUES (17549, 338, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (17550, 338, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (17551, 338, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (17552, 338, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (17553, 338, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (17554, 338, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (17555, 338, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (17556, 338, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (17557, 338, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17558, 338, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (17559, 338, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (17560, 338, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17561, 338, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (17562, 338, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (17563, 338, 50, 1457);
INSERT INTO 'capvalue' VALUES (1494, 'CDM');
INSERT INTO 'devicecapvalue' VALUES (17564, 338, 88, 1494);
INSERT INTO 'capvalue' VALUES (1495, 'CSD');
INSERT INTO 'devicecapvalue' VALUES (17565, 338, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (17566, 338, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (17567, 338, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (17568, 338, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (17569, 338, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (17570, 338, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (17571, 338, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (17572, 338, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (17573, 338, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (17574, 338, 51, 102);
INSERT INTO 'capvalue' VALUES (1496, 'midi40');
INSERT INTO 'devicecapvalue' VALUES (17575, 338, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (17576, 338, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (17577, 338, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (17578, 338, 51, 1458);
INSERT INTO 'devicecapvalue' VALUES (17579, 338, 52, 1350);
INSERT INTO 'devicecapvalue' VALUES (17580, 338, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (17581, 338, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (17582, 338, 157, 1026);
INSERT INTO 'capvalue' VALUES (1497, 'Nokia3152/2.0 (05.24) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (17583, 338, 53, 1497);
INSERT INTO 'devicecapvalue' VALUES (17584, 339, 158, 1490);
INSERT INTO 'devicecapvalue' VALUES (17585, 339, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (17586, 339, 160, 1491);
INSERT INTO 'devicecapvalue' VALUES (17587, 339, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (17588, 339, 75, 1492);
INSERT INTO 'devicecapvalue' VALUES (17589, 339, 187, 612);
INSERT INTO 'devicecapvalue' VALUES (17590, 339, 167, 1493);
INSERT INTO 'devicecapvalue' VALUES (17591, 339, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (17592, 339, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (17593, 339, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (17594, 339, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (17595, 339, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (17596, 339, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (17597, 339, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (17598, 339, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (17599, 339, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17600, 339, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (17601, 339, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (17602, 339, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17603, 339, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (17604, 339, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (17605, 339, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (17606, 339, 88, 1494);
INSERT INTO 'devicecapvalue' VALUES (17607, 339, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (17608, 339, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (17609, 339, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (17610, 339, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (17611, 339, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (17612, 339, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (17613, 339, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (17614, 339, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (17615, 339, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (17616, 339, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (17617, 339, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (17618, 339, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (17619, 339, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (17620, 339, 51, 1458);
INSERT INTO 'devicecapvalue' VALUES (17621, 339, 52, 1350);
INSERT INTO 'devicecapvalue' VALUES (17622, 339, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (17623, 339, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (17624, 339, 157, 1026);
INSERT INTO 'capvalue' VALUES (1498, 'Nokia3155i/2.0 (Q125_04w47_11.nbr) UP.Browser/6.2.3.8.d.1.100 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (17625, 339, 53, 1498);
INSERT INTO 'devicecapvalue' VALUES (17626, 340, 158, 1490);
INSERT INTO 'devicecapvalue' VALUES (17627, 340, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (17628, 340, 160, 1491);
INSERT INTO 'devicecapvalue' VALUES (17629, 340, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (17630, 340, 75, 1492);
INSERT INTO 'devicecapvalue' VALUES (17631, 340, 187, 612);
INSERT INTO 'devicecapvalue' VALUES (17632, 340, 167, 1493);
INSERT INTO 'devicecapvalue' VALUES (17633, 340, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (17634, 340, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (17635, 340, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (17636, 340, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (17637, 340, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (17638, 340, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (17639, 340, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (17640, 340, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (17641, 340, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17642, 340, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (17643, 340, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (17644, 340, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17645, 340, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (17646, 340, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (17647, 340, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (17648, 340, 88, 1494);
INSERT INTO 'devicecapvalue' VALUES (17649, 340, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (17650, 340, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (17651, 340, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (17652, 340, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (17653, 340, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (17654, 340, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (17655, 340, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (17656, 340, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (17657, 340, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (17658, 340, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (17659, 340, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (17660, 340, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (17661, 340, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (17662, 340, 51, 1458);
INSERT INTO 'devicecapvalue' VALUES (17663, 340, 52, 1350);
INSERT INTO 'devicecapvalue' VALUES (17664, 340, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (17665, 340, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (17666, 340, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (17667, 340, 53, 1498);
INSERT INTO 'devicecapvalue' VALUES (17668, 341, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (17669, 341, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (17670, 341, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (17671, 341, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (17672, 341, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (17673, 341, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (17674, 341, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (17675, 341, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (17676, 341, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17677, 341, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (17678, 341, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (17679, 341, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (17680, 341, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (17681, 341, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (17682, 341, 157, 1087);
INSERT INTO 'capvalue' VALUES (1499, 'Nokia3220/2.0 (pp3.71) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (17683, 341, 53, 1499);
INSERT INTO 'devicecapvalue' VALUES (17684, 342, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (17685, 342, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (17686, 342, 162, 605);
INSERT INTO 'devicecapvalue' VALUES (17687, 342, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (17688, 342, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (17689, 342, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (17690, 342, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (17691, 342, 77, 745);
INSERT INTO 'devicecapvalue' VALUES (17692, 342, 78, 1273);
INSERT INTO 'devicecapvalue' VALUES (17693, 342, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (17694, 342, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (17695, 342, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (17696, 342, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17697, 342, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (17698, 342, 50, 593);
INSERT INTO 'capvalue' VALUES (1500, 'EGPRS');
INSERT INTO 'devicecapvalue' VALUES (17699, 342, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (17700, 342, 88, 1003);
INSERT INTO 'capvalue' VALUES (1501, 'Symbian OS 7.0s');
INSERT INTO 'devicecapvalue' VALUES (17701, 342, 3, 1501);
INSERT INTO 'devicecapvalue' VALUES (17702, 342, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (17703, 342, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (17704, 342, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (17705, 342, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (17706, 342, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (17707, 342, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (17708, 342, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (17709, 342, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (17710, 342, 51, 102);
INSERT INTO 'capvalue' VALUES (1502, 'midi48');
INSERT INTO 'devicecapvalue' VALUES (17711, 342, 51, 1502);
INSERT INTO 'devicecapvalue' VALUES (17712, 342, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (17713, 342, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (17714, 342, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (17715, 342, 51, 669);
INSERT INTO 'capvalue' VALUES (1503, '6291456');
INSERT INTO 'devicecapvalue' VALUES (17716, 342, 52, 1503);
INSERT INTO 'devicecapvalue' VALUES (17717, 342, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (17718, 342, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (17719, 342, 157, 1026);
INSERT INTO 'capvalue' VALUES (1504, 'realvideo');
INSERT INTO 'devicecapvalue' VALUES (17720, 342, 157, 1504);
INSERT INTO 'capvalue' VALUES (1505, 'Nokia3230/2.0 (3.0505.2) SymbianOS/7.0s Series60/2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (17721, 342, 53, 1505);
INSERT INTO 'devicecapvalue' VALUES (17722, 343, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (17723, 343, 79, 15);
INSERT INTO 'devicecapvalue' VALUES (17724, 343, 7, 1390);
INSERT INTO 'devicecapvalue' VALUES (17725, 343, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (17726, 343, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (17727, 343, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (17728, 343, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (17729, 343, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (17730, 343, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (17731, 343, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (17732, 343, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (17733, 343, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (17734, 343, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (17735, 343, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (17736, 343, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17737, 343, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (17738, 343, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (17739, 343, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17740, 343, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (17741, 343, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (17742, 343, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (17743, 343, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (17744, 343, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17745, 343, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (17746, 343, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (17747, 343, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (17748, 343, 18, 40);
INSERT INTO 'devicecapvalue' VALUES (17749, 343, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (17750, 343, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (17751, 343, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (17752, 343, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (17753, 343, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (17754, 343, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (17755, 343, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (17756, 343, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (17757, 343, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (17758, 343, 57, 36);
INSERT INTO 'devicecapvalue' VALUES (17759, 343, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (17760, 343, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (17761, 343, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (17762, 343, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (17763, 343, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (17764, 343, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (17765, 343, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (17766, 343, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (17767, 343, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (17768, 343, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (17769, 343, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (17770, 343, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (17771, 343, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (17772, 343, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (17773, 343, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (17774, 343, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (17775, 343, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (17776, 343, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (17777, 343, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (17778, 343, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (17779, 343, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (17780, 343, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (17781, 343, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (17782, 343, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (17783, 343, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (17784, 343, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (17785, 343, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (17786, 343, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (17787, 343, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (17788, 343, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (17789, 343, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (17790, 343, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (17791, 343, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (17792, 343, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (17793, 343, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (17794, 343, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (17795, 343, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (17796, 343, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (17797, 343, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (17798, 343, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (17799, 343, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (17800, 343, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (17801, 343, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (17802, 343, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (17803, 343, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (17804, 343, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (17805, 343, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (17806, 343, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (17807, 343, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (17808, 343, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (17809, 343, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (17810, 343, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (17811, 343, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (17812, 343, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (17813, 343, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (17814, 343, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (17815, 343, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (17816, 343, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (17817, 343, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (17818, 343, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (17819, 343, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (17820, 343, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (17821, 343, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (17822, 343, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (17823, 343, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (17824, 343, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (17825, 343, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (17826, 343, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (17827, 343, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (17828, 343, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (17829, 343, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (17830, 343, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (17831, 343, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (17832, 343, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (17833, 343, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (17834, 343, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (17835, 343, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (17836, 343, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (17837, 343, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (17838, 343, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (17839, 343, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (17840, 343, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (17841, 343, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (17842, 343, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (17843, 343, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (17844, 343, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (17845, 343, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (17846, 343, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (17847, 343, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (17848, 343, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (17849, 343, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (17850, 343, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (17851, 343, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (17852, 343, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (17853, 343, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (17854, 343, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (17855, 343, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (17856, 343, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (17857, 343, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (17858, 343, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (17859, 343, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (17860, 343, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (17861, 343, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (17862, 343, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (17863, 343, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (17864, 343, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (17865, 343, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (17866, 343, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (17867, 343, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (17868, 343, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (17869, 343, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (17870, 343, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (17871, 343, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (17872, 343, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (17873, 343, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (17874, 343, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (17875, 343, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (17876, 343, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (17877, 343, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (17878, 343, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (17879, 343, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (17880, 343, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (17881, 343, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (17882, 343, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (17883, 343, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (17884, 343, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (17885, 343, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (17886, 343, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (17887, 343, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (17888, 343, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (17889, 343, 115, 1258);
INSERT INTO 'devicecapvalue' VALUES (17890, 343, 117, 45);
INSERT INTO 'devicecapvalue' VALUES (17891, 343, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (17892, 343, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (17893, 343, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (17894, 343, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (17895, 343, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (17896, 343, 183, 1423);
INSERT INTO 'devicecapvalue' VALUES (17897, 343, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (17898, 343, 185, 1425);
INSERT INTO 'devicecapvalue' VALUES (17899, 343, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (17900, 343, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (17901, 343, 102, 1470);
INSERT INTO 'devicecapvalue' VALUES (17902, 343, 103, 1426);
INSERT INTO 'devicecapvalue' VALUES (17903, 343, 104, 1427);
INSERT INTO 'devicecapvalue' VALUES (17904, 343, 106, 1429);
INSERT INTO 'devicecapvalue' VALUES (17905, 343, 107, 1430);
INSERT INTO 'devicecapvalue' VALUES (17906, 343, 108, 1431);
INSERT INTO 'devicecapvalue' VALUES (17907, 343, 109, 1432);
INSERT INTO 'devicecapvalue' VALUES (17908, 343, 114, 1260);
INSERT INTO 'devicecapvalue' VALUES (17909, 343, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (17910, 343, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (17911, 343, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (17912, 343, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (17913, 343, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (17914, 343, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (17915, 343, 130, 45);
INSERT INTO 'devicecapvalue' VALUES (17916, 343, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (17917, 343, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (17918, 343, 67, 45);
INSERT INTO 'capvalue' VALUES (1506, 'Nokia3500c/07.00');
INSERT INTO 'devicecapvalue' VALUES (17919, 343, 68, 1506);
INSERT INTO 'devicecapvalue' VALUES (17920, 343, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (17921, 343, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (17922, 343, 132, 1258);
INSERT INTO 'devicecapvalue' VALUES (17923, 343, 133, 68);
INSERT INTO 'devicecapvalue' VALUES (17924, 343, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (17925, 343, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (17926, 343, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (17927, 343, 136, 68);
INSERT INTO 'devicecapvalue' VALUES (17928, 343, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (17929, 343, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (17930, 343, 137, 1397);
INSERT INTO 'capvalue' VALUES (1507, 'http://mms1.live.vodafone.in/mms/');
INSERT INTO 'devicecapvalue' VALUES (17931, 343, 138, 1507);
INSERT INTO 'capvalue' VALUES (1508, '+919820005444');
INSERT INTO 'devicecapvalue' VALUES (17932, 343, 72, 1508);
INSERT INTO 'devicecapvalue' VALUES (17933, 343, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (17934, 343, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (17935, 343, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (17936, 343, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (17937, 343, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (17938, 343, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (17939, 343, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (17940, 343, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (17941, 343, 49, 1031);
INSERT INTO 'capvalue' VALUES (1509, '2008-02-05');
INSERT INTO 'devicecapvalue' VALUES (17942, 344, 158, 1509);
INSERT INTO 'capvalue' VALUES (1510, '1600x1200');
INSERT INTO 'devicecapvalue' VALUES (17943, 344, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (17944, 344, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (17945, 344, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (17946, 344, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (17947, 344, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (17948, 344, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (17949, 344, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (17950, 344, 17, 1479);
INSERT INTO 'devicecapvalue' VALUES (17951, 344, 17, 1480);
INSERT INTO 'devicecapvalue' VALUES (17952, 344, 17, 1481);
INSERT INTO 'devicecapvalue' VALUES (17953, 344, 17, 1482);
INSERT INTO 'devicecapvalue' VALUES (17954, 344, 17, 1483);
INSERT INTO 'devicecapvalue' VALUES (17955, 344, 17, 1484);
INSERT INTO 'devicecapvalue' VALUES (17956, 344, 17, 1485);
INSERT INTO 'devicecapvalue' VALUES (17957, 344, 17, 1486);
INSERT INTO 'devicecapvalue' VALUES (17958, 344, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (17959, 344, 17, 1488);
INSERT INTO 'devicecapvalue' VALUES (17960, 344, 17, 1489);
INSERT INTO 'devicecapvalue' VALUES (17961, 344, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (17962, 344, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (17963, 344, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (17964, 344, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (17965, 344, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (17966, 344, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (17967, 344, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (17968, 344, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (17969, 344, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (17970, 344, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (17971, 344, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (17972, 344, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (17973, 344, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (17974, 344, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (17975, 344, 5, 601);
INSERT INTO 'capvalue' VALUES (1511, '31457280');
INSERT INTO 'devicecapvalue' VALUES (17976, 344, 52, 1511);
INSERT INTO 'devicecapvalue' VALUES (17977, 345, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (17978, 345, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (17979, 345, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (17980, 345, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (17981, 345, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (17982, 345, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (17983, 345, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (17984, 345, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (17985, 345, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (17986, 345, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (17987, 345, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (17988, 345, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (17989, 345, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (17990, 345, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17991, 345, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (17992, 345, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (17993, 345, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (17994, 345, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (17995, 345, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (17996, 345, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (17997, 345, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (17998, 345, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (17999, 345, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (18000, 345, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18001, 345, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18002, 345, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (18003, 345, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (18004, 345, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (18005, 345, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (18006, 345, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (18007, 345, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (18008, 345, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (18009, 345, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (18010, 345, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (18011, 345, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (18012, 345, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (18013, 345, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (18014, 345, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (18015, 345, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (18016, 345, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (18017, 345, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (18018, 345, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (18019, 345, 35, 45);
INSERT INTO 'capvalue' VALUES (1512, 'Nokia3720c/09.10');
INSERT INTO 'devicecapvalue' VALUES (18020, 345, 36, 1512);
INSERT INTO 'devicecapvalue' VALUES (18021, 345, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (18022, 345, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (18023, 345, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (18024, 345, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (18025, 345, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (18026, 345, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (18027, 345, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (18028, 345, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (18029, 345, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (18030, 345, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (18031, 345, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (18032, 345, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (18033, 345, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (18034, 345, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (18035, 345, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (18036, 345, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (18037, 345, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (18038, 345, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (18039, 345, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (18040, 345, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (18041, 345, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (18042, 345, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (18043, 345, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (18044, 345, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (18045, 345, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (18046, 345, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (18047, 345, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (18048, 345, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (18049, 345, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (18050, 345, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (18051, 345, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (18052, 345, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (18053, 345, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (18054, 345, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (18055, 345, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (18056, 345, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (18057, 345, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (18058, 345, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (18059, 345, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (18060, 345, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (18061, 345, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (18062, 345, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (18063, 345, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (18064, 345, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (18065, 345, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (18066, 345, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (18067, 345, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (18068, 345, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (18069, 345, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (18070, 345, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (18071, 345, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (18072, 345, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (18073, 345, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (18074, 345, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (18075, 345, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (18076, 345, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (18077, 345, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (18078, 345, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (18079, 345, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (18080, 345, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (18081, 345, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (18082, 345, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (18083, 345, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (18084, 345, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (18085, 345, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (18086, 345, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (18087, 345, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (18088, 345, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (18089, 345, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (18090, 345, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (18091, 345, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (18092, 345, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (18093, 345, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (18094, 345, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (18095, 345, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (18096, 345, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (18097, 345, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (18098, 345, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (18099, 345, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (18100, 345, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (18101, 345, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (18102, 345, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (18103, 345, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (18104, 345, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (18105, 345, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (18106, 345, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (18107, 345, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (18108, 345, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (18109, 345, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (18110, 345, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (18111, 345, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (18112, 345, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (18113, 345, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (18114, 345, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (18115, 345, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (18116, 345, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (18117, 345, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (18118, 345, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (18119, 345, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (18120, 345, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (18121, 345, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (18122, 345, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (18123, 345, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (18124, 345, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (18125, 345, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (18126, 345, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (18127, 345, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (18128, 345, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (18129, 345, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (18130, 345, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (18131, 345, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (18132, 345, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (18133, 345, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (18134, 345, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (18135, 345, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (18136, 345, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (18137, 345, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (18138, 345, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (18139, 345, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (18140, 345, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (18141, 345, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (18142, 345, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (18143, 345, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (18144, 345, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (18145, 345, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (18146, 345, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (18147, 345, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (18148, 345, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (18149, 345, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (18150, 345, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (18151, 345, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (18152, 345, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (18153, 345, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (18154, 345, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (18155, 345, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (18156, 345, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (18157, 345, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (18158, 345, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (18159, 345, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (18160, 345, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (18161, 345, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (18162, 345, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (18163, 345, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (18164, 345, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (18165, 345, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (18166, 345, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (18167, 345, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (18168, 345, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (18169, 345, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (18170, 345, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (18171, 345, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (18172, 345, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (18173, 345, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (18174, 345, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (18175, 345, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (18176, 345, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (18177, 345, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (18178, 345, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (18179, 345, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (18180, 345, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (18181, 345, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (18182, 345, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (18183, 345, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (18184, 345, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (18185, 345, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (18186, 345, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (18187, 345, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (18188, 345, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (18189, 345, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (18190, 345, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (18191, 345, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (18192, 345, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (18193, 345, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (18194, 345, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (18195, 345, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (18196, 345, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (18197, 345, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (18198, 345, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (18199, 345, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (18200, 345, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (18201, 345, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (18202, 345, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (18203, 345, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (18204, 345, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (18205, 345, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (18206, 345, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (18207, 345, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (18208, 345, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (18209, 345, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (18210, 345, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (18211, 345, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (18212, 345, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (18213, 345, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (18214, 345, 73, 620);
INSERT INTO 'devicecapvalue' VALUES (18215, 345, 73, 622);
INSERT INTO 'devicecapvalue' VALUES (18216, 345, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (18217, 345, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (18218, 345, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (18219, 345, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (18220, 345, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (18221, 345, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (18222, 345, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (18223, 345, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (18224, 345, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (18225, 345, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (18226, 345, 49, 1031);
INSERT INTO 'capvalue' VALUES (1513, 'Nokia3720c/2.0 (09.10) Profile/MIDP-2.1 Configuration/CLDC-1.1 Mozilla/5.0 AppleWebKit/420+ (KHTML');
INSERT INTO 'devicecapvalue' VALUES (18227, 345, 53, 1513);
INSERT INTO 'capvalue' VALUES (1514, 'like Gecko) Safari/420+');
INSERT INTO 'devicecapvalue' VALUES (18228, 345, 53, 1514);
INSERT INTO 'devicecapvalue' VALUES (18229, 346, 56, 1);
INSERT INTO 'devicecapvalue' VALUES (18230, 346, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (18231, 346, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (18232, 346, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (18233, 346, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (18234, 346, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (18235, 346, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (18236, 346, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (18237, 346, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (18238, 346, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (18239, 346, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (18240, 346, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (18241, 346, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (18242, 346, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (18243, 346, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (18244, 346, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (18245, 346, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (18246, 346, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (18247, 346, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (18248, 346, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18249, 346, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18250, 346, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (18251, 346, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (18252, 346, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (18253, 346, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (18254, 346, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (18255, 346, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (18256, 346, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (18257, 346, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (18258, 346, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (18259, 346, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (18260, 346, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (18261, 346, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (18262, 346, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (18263, 346, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (18264, 346, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (18265, 346, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (18266, 346, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (18267, 346, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (18268, 346, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (18269, 346, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (18270, 346, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (18271, 346, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (18272, 346, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (18273, 346, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (18274, 346, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (18275, 346, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (18276, 346, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (18277, 346, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (18278, 346, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (18279, 346, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (18280, 346, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (18281, 346, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (18282, 346, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (18283, 346, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (18284, 346, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (18285, 346, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (18286, 346, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (18287, 346, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (18288, 346, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (18289, 346, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (18290, 346, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (18291, 346, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (18292, 346, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (18293, 346, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (18294, 346, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (18295, 346, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (18296, 346, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (18297, 346, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (18298, 346, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (18299, 346, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (18300, 346, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (18301, 346, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (18302, 346, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (18303, 346, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (18304, 346, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (18305, 346, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (18306, 346, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (18307, 346, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (18308, 346, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (18309, 346, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (18310, 346, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (18311, 346, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (18312, 346, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (18313, 346, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (18314, 346, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (18315, 346, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (18316, 346, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (18317, 346, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (18318, 346, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (18319, 346, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (18320, 346, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (18321, 346, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (18322, 346, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (18323, 346, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (18324, 346, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (18325, 346, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (18326, 346, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (18327, 346, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (18328, 346, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (18329, 346, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (18330, 346, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (18331, 346, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (18332, 346, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (18333, 346, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (18334, 346, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (18335, 346, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (18336, 346, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (18337, 346, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (18338, 346, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (18339, 346, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (18340, 346, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (18341, 346, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (18342, 346, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (18343, 346, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (18344, 346, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (18345, 346, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (18346, 346, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (18347, 346, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (18348, 346, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (18349, 346, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (18350, 346, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (18351, 346, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (18352, 346, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (18353, 346, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (18354, 346, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (18355, 346, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (18356, 346, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (18357, 346, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (18358, 346, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (18359, 346, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (18360, 346, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (18361, 346, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (18362, 346, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (18363, 346, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (18364, 346, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (18365, 346, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (18366, 346, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (18367, 346, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (18368, 346, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (18369, 346, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (18370, 346, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (18371, 346, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (18372, 346, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (18373, 346, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (18374, 346, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (18375, 346, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (18376, 346, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (18377, 346, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (18378, 346, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (18379, 346, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (18380, 346, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (18381, 346, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (18382, 346, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (18383, 346, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (18384, 346, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (18385, 346, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (18386, 346, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (18387, 346, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (18388, 346, 125, 711);
INSERT INTO 'devicecapvalue' VALUES (18389, 346, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (18390, 346, 183, 1423);
INSERT INTO 'devicecapvalue' VALUES (18391, 346, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (18392, 346, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (18393, 346, 103, 1426);
INSERT INTO 'devicecapvalue' VALUES (18394, 346, 104, 1427);
INSERT INTO 'devicecapvalue' VALUES (18395, 346, 105, 1428);
INSERT INTO 'devicecapvalue' VALUES (18396, 346, 106, 1429);
INSERT INTO 'devicecapvalue' VALUES (18397, 346, 107, 1430);
INSERT INTO 'devicecapvalue' VALUES (18398, 346, 108, 1431);
INSERT INTO 'devicecapvalue' VALUES (18399, 346, 109, 1432);
INSERT INTO 'devicecapvalue' VALUES (18400, 346, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (18401, 346, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (18402, 346, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (18403, 346, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (18404, 346, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (18405, 346, 67, 45);
INSERT INTO 'capvalue' VALUES (1515, 'Nokia5000d-2/03.50');
INSERT INTO 'devicecapvalue' VALUES (18406, 346, 68, 1515);
INSERT INTO 'devicecapvalue' VALUES (18407, 346, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (18408, 346, 186, 45);
INSERT INTO 'cap' VALUES (188, 'property.microedition.satsa.crypto.version', 1);
INSERT INTO 'devicecapvalue' VALUES (18409, 346, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (18410, 346, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (18411, 346, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (18412, 346, 71, 244);
INSERT INTO 'capvalue' VALUES (1516, 'http://mms1.hutchworld.co.in/mms/');
INSERT INTO 'devicecapvalue' VALUES (18413, 346, 138, 1516);
INSERT INTO 'capvalue' VALUES (1517, '+919811009998');
INSERT INTO 'devicecapvalue' VALUES (18414, 346, 72, 1517);
INSERT INTO 'devicecapvalue' VALUES (18415, 346, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (18416, 346, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (18417, 346, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (18418, 346, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (18419, 346, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (18420, 346, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (18421, 346, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (18422, 346, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (18423, 346, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (18424, 346, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (18425, 346, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (18426, 346, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (18427, 346, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (18428, 346, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (18429, 346, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (18430, 346, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (18431, 346, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (18432, 346, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (18433, 346, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (18434, 346, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (18435, 346, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (18436, 346, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (18437, 346, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (18438, 346, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (18439, 346, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (18440, 346, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (18441, 346, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (18442, 346, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (18443, 346, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (18444, 346, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (18445, 346, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (18446, 346, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (18447, 346, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (18448, 346, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (18449, 346, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (18450, 346, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (18451, 346, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (18452, 346, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (18453, 346, 49, 659);
INSERT INTO 'capvalue' VALUES (1518, 'Nokia5000d-2/1.0 (03.50) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (18454, 346, 53, 1518);
INSERT INTO 'devicecapvalue' VALUES (18455, 347, 1, 1);
INSERT INTO 'capvalue' VALUES (1519, 'ImageIOStreamAutoClose');
INSERT INTO 'devicecapvalue' VALUES (18456, 347, 74, 1519);
INSERT INTO 'capvalue' VALUES (1520, 'drawRgbOrigin');
INSERT INTO 'devicecapvalue' VALUES (18457, 347, 74, 1520);
INSERT INTO 'capvalue' VALUES (1521, 'needsNokiaUiForSystemAlerts');
INSERT INTO 'devicecapvalue' VALUES (18458, 347, 74, 1521);
INSERT INTO 'devicecapvalue' VALUES (18459, 347, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (18460, 347, 7, 1100);
INSERT INTO 'cap' VALUES (189, 'CaptureImageFormat', 1);
INSERT INTO 'devicecapvalue' VALUES (18461, 347, 189, 18);
INSERT INTO 'cap' VALUES (190, 'DebugInterface', 1);
INSERT INTO 'capvalue' VALUES (1522, 'KDWP');
INSERT INTO 'devicecapvalue' VALUES (18462, 347, 190, 1522);
INSERT INTO 'capvalue' VALUES (1523, 'OMA Phase 1');
INSERT INTO 'devicecapvalue' VALUES (18463, 347, 173, 1523);
INSERT INTO 'capvalue' VALUES (1524, 'Nokia_S40_DP20_SDK_6230i');
INSERT INTO 'devicecapvalue' VALUES (18464, 347, 75, 1524);
INSERT INTO 'devicecapvalue' VALUES (18465, 347, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (18466, 347, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (18467, 347, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (18468, 347, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (18469, 347, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (18470, 347, 76, 1063);
INSERT INTO 'devicecapvalue' VALUES (18471, 347, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (18472, 347, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (18473, 347, 15, 17);
INSERT INTO 'capvalue' VALUES (1525, 'gif87a');
INSERT INTO 'devicecapvalue' VALUES (18474, 347, 15, 1525);
INSERT INTO 'capvalue' VALUES (1526, 'gif89a');
INSERT INTO 'devicecapvalue' VALUES (18475, 347, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (18476, 347, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (18477, 347, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (18478, 347, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (18479, 347, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (18480, 347, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (18481, 347, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (18482, 347, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18483, 347, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (18484, 347, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (18485, 347, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (18486, 347, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (18487, 347, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (18488, 347, 154, 1123);
INSERT INTO 'capvalue' VALUES (1527, 'tls');
INSERT INTO 'devicecapvalue' VALUES (18489, 347, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (18490, 347, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (18491, 347, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (18492, 347, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (18493, 347, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (18494, 347, 52, 1124);
INSERT INTO 'cap' VALUES (191, 'VideoHeapSize', 1);
INSERT INTO 'devicecapvalue' VALUES (18495, 347, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (18496, 348, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (18497, 348, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (18498, 348, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (18499, 348, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (18500, 348, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (18501, 348, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (18502, 348, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (18503, 348, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (18504, 348, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (18505, 348, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (18506, 348, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (18507, 348, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (18508, 348, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (18509, 348, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (18510, 348, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (18511, 348, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (18512, 348, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (18513, 348, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (18514, 348, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (18515, 348, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (18516, 348, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (18517, 348, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (18518, 348, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18519, 348, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18520, 348, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (18521, 348, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (18522, 348, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (18523, 348, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (18524, 348, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (18525, 348, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (18526, 348, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (18527, 348, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (18528, 348, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (18529, 348, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (18530, 348, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (18531, 348, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (18532, 348, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (18533, 348, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (18534, 348, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (18535, 348, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (18536, 348, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (18537, 348, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (18538, 348, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (18539, 348, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (18540, 348, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (18541, 348, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (18542, 348, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (18543, 348, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (18544, 348, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (18545, 348, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (18546, 348, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (18547, 348, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (18548, 348, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (18549, 348, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (18550, 348, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (18551, 348, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (18552, 348, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (18553, 348, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (18554, 348, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (18555, 348, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (18556, 348, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (18557, 348, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (18558, 348, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (18559, 348, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (18560, 348, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (18561, 348, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (18562, 348, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (18563, 348, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (18564, 348, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (18565, 348, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (18566, 348, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (18567, 348, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (18568, 348, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (18569, 348, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (18570, 348, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (18571, 348, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (18572, 348, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (18573, 348, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (18574, 348, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (18575, 348, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (18576, 348, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (18577, 348, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (18578, 348, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (18579, 348, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (18580, 348, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (18581, 348, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (18582, 348, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (18583, 348, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (18584, 348, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (18585, 348, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (18586, 348, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (18587, 348, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (18588, 348, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (18589, 348, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (18590, 348, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (18591, 348, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (18592, 348, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (18593, 348, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (18594, 348, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (18595, 348, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (18596, 348, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (18597, 348, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (18598, 348, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (18599, 348, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (18600, 348, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (18601, 348, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (18602, 348, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (18603, 348, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (18604, 348, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (18605, 348, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (18606, 348, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (18607, 348, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (18608, 348, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (18609, 348, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (18610, 348, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (18611, 348, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (18612, 348, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (18613, 348, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (18614, 348, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (18615, 348, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (18616, 348, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (18617, 348, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (18618, 348, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (18619, 348, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (18620, 348, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (18621, 348, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (18622, 348, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (18623, 348, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (18624, 348, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (18625, 348, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (18626, 348, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (18627, 348, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (18628, 348, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (18629, 348, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (18630, 348, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (18631, 348, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (18632, 348, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (18633, 348, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (18634, 348, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (18635, 348, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (18636, 348, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (18637, 348, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (18638, 348, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (18639, 348, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (18640, 348, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (18641, 348, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (18642, 348, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (18643, 348, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (18644, 348, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (18645, 348, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (18646, 348, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (18647, 348, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (18648, 348, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (18649, 348, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (18650, 348, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (18651, 348, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (18652, 348, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (18653, 348, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (18654, 348, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (18655, 348, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (18656, 348, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (18657, 348, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (18658, 348, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (18659, 348, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (18660, 348, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (18661, 348, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (18662, 348, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (18663, 348, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (18664, 348, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (18665, 348, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (18666, 348, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (18667, 348, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (18668, 348, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (18669, 348, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (18670, 348, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (18671, 348, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (18672, 348, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (18673, 348, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (18674, 348, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (18675, 348, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (18676, 348, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (18677, 348, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (18678, 348, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (18679, 348, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (18680, 348, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (18681, 348, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (18682, 348, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (18683, 348, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (18684, 348, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (18685, 348, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (18686, 348, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (18687, 348, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (18688, 348, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (18689, 348, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (18690, 348, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (18691, 348, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (18692, 348, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (18693, 348, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (18694, 348, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (18695, 348, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (18696, 348, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (18697, 348, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (18698, 348, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (18699, 348, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (18700, 348, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (18701, 348, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (18702, 348, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (18703, 348, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (18704, 348, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (18705, 348, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (18706, 348, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (18707, 348, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (18708, 348, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (18709, 348, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (18710, 348, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (18711, 348, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (18712, 348, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (18713, 348, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (18714, 348, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (18715, 348, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (18716, 348, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (18717, 348, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (18718, 348, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (18719, 348, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (18720, 348, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (18721, 348, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (18722, 348, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (18723, 348, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (18724, 348, 73, 620);
INSERT INTO 'devicecapvalue' VALUES (18725, 348, 73, 622);
INSERT INTO 'devicecapvalue' VALUES (18726, 348, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (18727, 348, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (18728, 348, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (18729, 348, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (18730, 348, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (18731, 348, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (18732, 348, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (18733, 348, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (18734, 348, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (18735, 348, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (18736, 348, 49, 1031);
INSERT INTO 'capvalue' VALUES (1528, 'Nokia5130c-2/2.0 (05.80) Profile/MIDP-2.1 Configuration/CLDC-1.1 UP.Link/6.5.0.0.0');
INSERT INTO 'devicecapvalue' VALUES (18737, 348, 53, 1528);
INSERT INTO 'devicecapvalue' VALUES (18738, 349, 1, 13);
INSERT INTO 'capvalue' VALUES (1529, 'ConnectorNokiaComm');
INSERT INTO 'devicecapvalue' VALUES (18739, 349, 74, 1529);
INSERT INTO 'capvalue' VALUES (1530, 'PlatformRequestHttpLaunchRequiresExit');
INSERT INTO 'devicecapvalue' VALUES (18740, 349, 74, 1530);
INSERT INTO 'devicecapvalue' VALUES (18741, 349, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (18742, 349, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (18743, 349, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (18744, 349, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (18745, 349, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (18746, 349, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (18747, 349, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (18748, 349, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (18749, 349, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18750, 349, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (18751, 349, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (18752, 349, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (18753, 349, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (18754, 349, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (18755, 349, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (18756, 349, 157, 1087);
INSERT INTO 'capvalue' VALUES (1531, 'Nokia5140i/2.0 (03.75) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (18757, 349, 53, 1531);
INSERT INTO 'capvalue' VALUES (1532, '2005-04-26');
INSERT INTO 'devicecapvalue' VALUES (18758, 350, 158, 1532);
INSERT INTO 'devicecapvalue' VALUES (18759, 350, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (18760, 350, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (18761, 350, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (18762, 350, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (18763, 350, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (18764, 350, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (18765, 350, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (18766, 350, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (18767, 350, 76, 1457);
INSERT INTO 'devicecapvalue' VALUES (18768, 350, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (18769, 350, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (18770, 350, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (18771, 350, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (18772, 350, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (18773, 350, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18774, 350, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (18775, 350, 6, 27);
INSERT INTO 'capvalue' VALUES (1533, '128000');
INSERT INTO 'devicecapvalue' VALUES (18776, 350, 50, 1533);
INSERT INTO 'devicecapvalue' VALUES (18777, 350, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (18778, 350, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (18779, 350, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (18780, 350, 88, 1004);
INSERT INTO 'capvalue' VALUES (1534, 'HSCSD');
INSERT INTO 'devicecapvalue' VALUES (18781, 350, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (18782, 350, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (18783, 350, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (18784, 350, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (18785, 350, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (18786, 350, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (18787, 350, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (18788, 350, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (18789, 350, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (18790, 350, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (18791, 350, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (18792, 350, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (18793, 350, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (18794, 350, 52, 1337);
INSERT INTO 'devicecapvalue' VALUES (18795, 350, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (18796, 350, 157, 1134);
INSERT INTO 'capvalue' VALUES (1535, 'Nokia5140i/2.0 (03.85) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (18797, 350, 53, 1535);
INSERT INTO 'capvalue' VALUES (1536, '2006-09-27');
INSERT INTO 'devicecapvalue' VALUES (18798, 351, 158, 1536);
INSERT INTO 'devicecapvalue' VALUES (18799, 351, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (18800, 351, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (18801, 351, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (18802, 351, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (18803, 351, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (18804, 351, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (18805, 351, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (18806, 351, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (18807, 351, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (18808, 351, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (18809, 351, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (18810, 351, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (18811, 351, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (18812, 351, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (18813, 351, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (18814, 351, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (18815, 351, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (18816, 351, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (18817, 351, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18818, 351, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18819, 351, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (18820, 351, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (18821, 351, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (18822, 351, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (18823, 351, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (18824, 351, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (18825, 351, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (18826, 351, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (18827, 351, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (18828, 351, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (18829, 351, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (18830, 351, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (18831, 351, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (18832, 351, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (18833, 351, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (18834, 351, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (18835, 351, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (18836, 351, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (18837, 351, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (18838, 351, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (18839, 351, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (18840, 351, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (18841, 351, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (18842, 351, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (18843, 351, 51, 1041);
INSERT INTO 'capvalue' VALUES (1537, '7340032');
INSERT INTO 'devicecapvalue' VALUES (18844, 351, 52, 1537);
INSERT INTO 'devicecapvalue' VALUES (18845, 351, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (18846, 351, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (18847, 351, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (18848, 351, 157, 1026);
INSERT INTO 'capvalue' VALUES (1538, 'Nokia5200/2.0 (03.70) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (18849, 351, 53, 1538);
INSERT INTO 'devicecapvalue' VALUES (18850, 352, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (18851, 352, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (18852, 352, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (18853, 352, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (18854, 352, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (18855, 352, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (18856, 352, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (18857, 352, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (18858, 352, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (18859, 352, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (18860, 352, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (18861, 352, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (18862, 352, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (18863, 352, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (18864, 352, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (18865, 352, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (18866, 352, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (18867, 352, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (18868, 352, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (18869, 352, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (18870, 352, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (18871, 352, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (18872, 352, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18873, 352, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (18874, 352, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (18875, 352, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (18876, 352, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (18877, 352, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (18878, 352, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (18879, 352, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (18880, 352, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (18881, 352, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (18882, 352, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (18883, 352, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (18884, 352, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (18885, 352, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (18886, 352, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (18887, 352, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (18888, 352, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (18889, 352, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (18890, 352, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (18891, 352, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (18892, 352, 35, 45);
INSERT INTO 'capvalue' VALUES (1539, 'Nokia5220XpressMusic/05');
INSERT INTO 'devicecapvalue' VALUES (18893, 352, 36, 1539);
INSERT INTO 'devicecapvalue' VALUES (18894, 352, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (18895, 352, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (18896, 352, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (18897, 352, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (18898, 352, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (18899, 352, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (18900, 352, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (18901, 352, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (18902, 352, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (18903, 352, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (18904, 352, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (18905, 352, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (18906, 352, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (18907, 352, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (18908, 352, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (18909, 352, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (18910, 352, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (18911, 352, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (18912, 352, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (18913, 352, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (18914, 352, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (18915, 352, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (18916, 352, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (18917, 352, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (18918, 352, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (18919, 352, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (18920, 352, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (18921, 352, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (18922, 352, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (18923, 352, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (18924, 352, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (18925, 352, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (18926, 352, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (18927, 352, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (18928, 352, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (18929, 352, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (18930, 352, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (18931, 352, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (18932, 352, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (18933, 352, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (18934, 352, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (18935, 352, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (18936, 352, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (18937, 352, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (18938, 352, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (18939, 352, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (18940, 352, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (18941, 352, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (18942, 352, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (18943, 352, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (18944, 352, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (18945, 352, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (18946, 352, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (18947, 352, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (18948, 352, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (18949, 352, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (18950, 352, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (18951, 352, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (18952, 352, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (18953, 352, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (18954, 352, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (18955, 352, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (18956, 352, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (18957, 352, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (18958, 352, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (18959, 352, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (18960, 352, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (18961, 352, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (18962, 352, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (18963, 352, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (18964, 352, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (18965, 352, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (18966, 352, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (18967, 352, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (18968, 352, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (18969, 352, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (18970, 352, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (18971, 352, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (18972, 352, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (18973, 352, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (18974, 352, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (18975, 352, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (18976, 352, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (18977, 352, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (18978, 352, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (18979, 352, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (18980, 352, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (18981, 352, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (18982, 352, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (18983, 352, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (18984, 352, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (18985, 352, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (18986, 352, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (18987, 352, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (18988, 352, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (18989, 352, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (18990, 352, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (18991, 352, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (18992, 352, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (18993, 352, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (18994, 352, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (18995, 352, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (18996, 352, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (18997, 352, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (18998, 352, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (18999, 352, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (19000, 352, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (19001, 352, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (19002, 352, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (19003, 352, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (19004, 352, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (19005, 352, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (19006, 352, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (19007, 352, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (19008, 352, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (19009, 352, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (19010, 352, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (19011, 352, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (19012, 352, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (19013, 352, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (19014, 352, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (19015, 352, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (19016, 352, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (19017, 352, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (19018, 352, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (19019, 352, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (19020, 352, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (19021, 352, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (19022, 352, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (19023, 352, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (19024, 352, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (19025, 352, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (19026, 352, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (19027, 352, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (19028, 352, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (19029, 352, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (19030, 352, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (19031, 352, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (19032, 352, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (19033, 352, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (19034, 352, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (19035, 352, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (19036, 352, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (19037, 352, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (19038, 352, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (19039, 352, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (19040, 352, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (19041, 352, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (19042, 352, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (19043, 352, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (19044, 352, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (19045, 352, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (19046, 352, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (19047, 352, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (19048, 352, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (19049, 352, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (19050, 352, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (19051, 352, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (19052, 352, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (19053, 352, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (19054, 352, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (19055, 352, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (19056, 352, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (19057, 352, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (19058, 352, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (19059, 352, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (19060, 352, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (19061, 352, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (19062, 352, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (19063, 352, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (19064, 352, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (19065, 352, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (19066, 352, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (19067, 352, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (19068, 352, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (19069, 352, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (19070, 352, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (19071, 352, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (19072, 352, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (19073, 352, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (19074, 352, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (19075, 352, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (19076, 352, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (19077, 352, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (19078, 352, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (19079, 352, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (19080, 352, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (19081, 352, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (19082, 352, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (19083, 352, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (19084, 352, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (19085, 352, 73, 620);
INSERT INTO 'devicecapvalue' VALUES (19086, 352, 73, 622);
INSERT INTO 'devicecapvalue' VALUES (19087, 352, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (19088, 352, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (19089, 352, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (19090, 352, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (19091, 352, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (19092, 352, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (19093, 352, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (19094, 352, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (19095, 352, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (19096, 352, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (19097, 352, 49, 1031);
INSERT INTO 'capvalue' VALUES (1540, 'Nokia5220XpressMusic/2.0 (05.20) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (19098, 352, 53, 1540);
INSERT INTO 'devicecapvalue' VALUES (19099, 353, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (19100, 353, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (19101, 353, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (19102, 353, 5, 646);
INSERT INTO 'devicecapvalue' VALUES (19103, 354, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (19104, 354, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (19105, 354, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (19106, 354, 5, 646);
INSERT INTO 'devicecapvalue' VALUES (19107, 355, 158, 1536);
INSERT INTO 'devicecapvalue' VALUES (19108, 355, 1, 106);
INSERT INTO 'capvalue' VALUES (1541, '1280x1024');
INSERT INTO 'devicecapvalue' VALUES (19109, 355, 160, 1541);
INSERT INTO 'devicecapvalue' VALUES (19110, 355, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (19111, 355, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (19112, 355, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (19113, 355, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (19114, 355, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (19115, 355, 76, 1031);
INSERT INTO 'capvalue' VALUES (1542, '46');
INSERT INTO 'devicecapvalue' VALUES (19116, 355, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (19117, 355, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (19118, 355, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (19119, 355, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (19120, 355, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (19121, 355, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (19122, 355, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (19123, 355, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (19124, 355, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (19125, 355, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (19126, 355, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19127, 355, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19128, 355, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (19129, 355, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (19130, 355, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (19131, 355, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (19132, 355, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (19133, 355, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (19134, 355, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (19135, 355, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (19136, 355, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (19137, 355, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (19138, 355, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (19139, 355, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (19140, 355, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (19141, 355, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (19142, 355, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (19143, 355, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (19144, 355, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (19145, 355, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (19146, 355, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (19147, 355, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (19148, 355, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (19149, 355, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (19150, 355, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (19151, 355, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (19152, 355, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (19153, 355, 52, 1537);
INSERT INTO 'devicecapvalue' VALUES (19154, 355, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (19155, 355, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (19156, 355, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (19157, 355, 157, 1026);
INSERT INTO 'capvalue' VALUES (1543, 'Nokia5300/2.0 (03.50) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (19158, 355, 53, 1543);
INSERT INTO 'devicecapvalue' VALUES (19159, 356, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (19160, 356, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (19161, 356, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (19162, 356, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (19163, 356, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (19164, 356, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (19165, 356, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (19166, 356, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (19167, 356, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (19168, 356, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (19169, 356, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (19170, 356, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (19171, 356, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (19172, 356, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (19173, 356, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (19174, 356, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (19175, 356, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (19176, 356, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (19177, 356, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (19178, 356, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (19179, 356, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (19180, 356, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (19181, 356, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (19182, 356, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (19183, 356, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (19184, 356, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (19185, 356, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (19186, 356, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (19187, 356, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (19188, 356, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (19189, 356, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (19190, 356, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (19191, 356, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (19192, 356, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (19193, 356, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (19194, 356, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (19195, 356, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (19196, 356, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19197, 356, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19198, 356, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (19199, 356, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (19200, 356, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (19201, 356, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (19202, 356, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (19203, 356, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (19204, 356, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (19205, 356, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (19206, 356, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (19207, 356, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (19208, 356, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (19209, 356, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (19210, 356, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (19211, 356, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (19212, 356, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (19213, 356, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (19214, 356, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (19215, 356, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (19216, 356, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (19217, 356, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (19218, 356, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (19219, 356, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (19220, 356, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (19221, 356, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (19222, 356, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (19223, 356, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (19224, 356, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (19225, 356, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (19226, 356, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (19227, 356, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (19228, 356, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (19229, 356, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (19230, 356, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (19231, 356, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (19232, 356, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (19233, 356, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (19234, 356, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (19235, 356, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (19236, 356, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (19237, 356, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (19238, 356, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (19239, 356, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (19240, 356, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (19241, 356, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (19242, 356, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (19243, 356, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (19244, 356, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (19245, 356, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (19246, 356, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (19247, 356, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (19248, 356, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (19249, 356, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (19250, 356, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (19251, 356, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (19252, 356, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (19253, 356, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (19254, 356, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (19255, 356, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (19256, 356, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (19257, 356, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (19258, 356, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (19259, 356, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (19260, 356, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (19261, 356, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (19262, 356, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (19263, 356, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (19264, 356, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (19265, 356, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (19266, 356, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (19267, 356, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (19268, 356, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (19269, 356, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (19270, 356, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (19271, 356, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (19272, 356, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (19273, 356, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (19274, 356, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (19275, 356, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (19276, 356, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (19277, 356, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (19278, 356, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (19279, 356, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (19280, 356, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (19281, 356, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (19282, 356, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (19283, 356, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (19284, 356, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (19285, 356, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (19286, 356, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (19287, 356, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (19288, 356, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (19289, 356, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (19290, 356, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (19291, 356, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (19292, 356, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (19293, 356, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (19294, 356, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (19295, 356, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (19296, 356, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (19297, 356, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (19298, 356, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (19299, 356, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (19300, 356, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (19301, 356, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (19302, 356, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (19303, 356, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (19304, 356, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (19305, 356, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (19306, 356, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (19307, 356, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (19308, 356, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (19309, 356, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (19310, 356, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (19311, 356, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (19312, 356, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (19313, 356, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (19314, 356, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (19315, 356, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (19316, 356, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (19317, 356, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (19318, 356, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (19319, 356, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (19320, 356, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (19321, 356, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (19322, 356, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (19323, 356, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (19324, 356, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (19325, 356, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (19326, 356, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (19327, 356, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (19328, 356, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (19329, 356, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (19330, 356, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (19331, 356, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (19332, 356, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (19333, 356, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (19334, 356, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (19335, 356, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (19336, 356, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (19337, 356, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (19338, 356, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (19339, 356, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (19340, 356, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (19341, 356, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (19342, 356, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (19343, 356, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (19344, 356, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (19345, 356, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (19346, 356, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (19347, 356, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (19348, 356, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (19349, 356, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (19350, 356, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (19351, 356, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (19352, 356, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (19353, 356, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (19354, 356, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (19355, 356, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (19356, 356, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (19357, 356, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (19358, 356, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (19359, 356, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (19360, 356, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (19361, 356, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (19362, 356, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (19363, 356, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (19364, 356, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (19365, 356, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (19366, 356, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (19367, 356, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (19368, 356, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (19369, 356, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (19370, 356, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (19371, 356, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (19372, 356, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (19373, 356, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (19374, 356, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (19375, 356, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (19376, 356, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (19377, 356, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (19378, 356, 52, 1511);
INSERT INTO 'devicecapvalue' VALUES (19379, 356, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (19380, 356, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (19381, 356, 49, 1031);
INSERT INTO 'devicecapvalue' VALUES (19382, 356, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (19383, 356, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (19384, 356, 157, 1026);
INSERT INTO 'capvalue' VALUES (1544, 'Nokia5310XpressMusic/2.0 (05.81) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (19385, 356, 53, 1544);
INSERT INTO 'devicecapvalue' VALUES (19386, 357, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (19387, 357, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (19388, 357, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (19389, 357, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (19390, 357, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (19391, 357, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (19392, 357, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (19393, 357, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (19394, 357, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (19395, 357, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (19396, 357, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (19397, 357, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (19398, 357, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (19399, 357, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (19400, 357, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (19401, 357, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (19402, 357, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (19403, 357, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (19404, 357, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (19405, 357, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (19406, 357, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (19407, 357, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (19408, 357, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (19409, 357, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (19410, 357, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (19411, 357, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (19412, 357, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (19413, 357, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (19414, 357, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (19415, 357, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (19416, 357, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (19417, 357, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (19418, 357, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (19419, 357, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (19420, 357, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (19421, 357, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (19422, 357, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (19423, 357, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19424, 357, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19425, 357, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (19426, 357, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (19427, 357, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (19428, 357, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (19429, 357, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (19430, 357, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (19431, 357, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (19432, 357, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (19433, 357, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (19434, 357, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (19435, 357, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (19436, 357, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (19437, 357, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (19438, 357, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (19439, 357, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (19440, 357, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (19441, 357, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (19442, 357, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (19443, 357, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (19444, 357, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (19445, 357, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (19446, 357, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (19447, 357, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (19448, 357, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (19449, 357, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (19450, 357, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (19451, 357, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (19452, 357, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (19453, 357, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (19454, 357, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (19455, 357, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (19456, 357, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (19457, 357, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (19458, 357, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (19459, 357, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (19460, 357, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (19461, 357, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (19462, 357, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (19463, 357, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (19464, 357, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (19465, 357, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (19466, 357, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (19467, 357, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (19468, 357, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (19469, 357, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (19470, 357, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (19471, 357, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (19472, 357, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (19473, 357, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (19474, 357, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (19475, 357, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (19476, 357, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (19477, 357, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (19478, 357, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (19479, 357, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (19480, 357, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (19481, 357, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (19482, 357, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (19483, 357, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (19484, 357, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (19485, 357, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (19486, 357, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (19487, 357, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (19488, 357, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (19489, 357, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (19490, 357, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (19491, 357, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (19492, 357, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (19493, 357, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (19494, 357, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (19495, 357, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (19496, 357, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (19497, 357, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (19498, 357, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (19499, 357, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (19500, 357, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (19501, 357, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (19502, 357, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (19503, 357, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (19504, 357, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (19505, 357, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (19506, 357, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (19507, 357, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (19508, 357, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (19509, 357, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (19510, 357, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (19511, 357, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (19512, 357, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (19513, 357, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (19514, 357, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (19515, 357, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (19516, 357, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (19517, 357, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (19518, 357, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (19519, 357, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (19520, 357, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (19521, 357, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (19522, 357, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (19523, 357, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (19524, 357, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (19525, 357, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (19526, 357, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (19527, 357, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (19528, 357, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (19529, 357, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (19530, 357, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (19531, 357, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (19532, 357, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (19533, 357, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (19534, 357, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (19535, 357, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (19536, 357, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (19537, 357, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (19538, 357, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (19539, 357, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (19540, 357, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (19541, 357, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (19542, 357, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (19543, 357, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (19544, 357, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (19545, 357, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (19546, 357, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (19547, 357, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (19548, 357, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (19549, 357, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (19550, 357, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (19551, 357, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (19552, 357, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (19553, 357, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (19554, 357, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (19555, 357, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (19556, 357, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (19557, 357, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (19558, 357, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (19559, 357, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (19560, 357, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (19561, 357, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (19562, 357, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (19563, 357, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (19564, 357, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (19565, 357, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (19566, 357, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (19567, 357, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (19568, 357, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (19569, 357, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (19570, 357, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (19571, 357, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (19572, 357, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (19573, 357, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (19574, 357, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (19575, 357, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (19576, 357, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (19577, 357, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (19578, 357, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (19579, 357, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (19580, 357, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (19581, 357, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (19582, 357, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (19583, 357, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (19584, 357, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (19585, 357, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (19586, 357, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (19587, 357, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (19588, 357, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (19589, 357, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (19590, 357, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (19591, 357, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (19592, 357, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (19593, 357, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (19594, 357, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (19595, 357, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (19596, 357, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (19597, 357, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (19598, 357, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (19599, 357, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (19600, 357, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (19601, 357, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (19602, 357, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (19603, 357, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (19604, 357, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (19605, 357, 52, 1511);
INSERT INTO 'devicecapvalue' VALUES (19606, 357, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (19607, 357, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (19608, 357, 49, 1031);
INSERT INTO 'devicecapvalue' VALUES (19609, 357, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (19610, 357, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (19611, 357, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (19612, 357, 53, 1544);
INSERT INTO 'capvalue' VALUES (1545, '2006-05-10');
INSERT INTO 'devicecapvalue' VALUES (19613, 358, 158, 1545);
INSERT INTO 'devicecapvalue' VALUES (19614, 358, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (19615, 358, 160, 1510);
INSERT INTO 'capvalue' VALUES (1546, '208x144');
INSERT INTO 'devicecapvalue' VALUES (19616, 358, 7, 1546);
INSERT INTO 'capvalue' VALUES (1547, 'OMA DRM Forward-Lock');
INSERT INTO 'devicecapvalue' VALUES (19617, 358, 173, 1547);
INSERT INTO 'devicecapvalue' VALUES (19618, 358, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (19619, 358, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (19620, 358, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (19621, 358, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (19622, 358, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (19623, 358, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (19624, 358, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (19625, 358, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (19626, 358, 150, 959);
INSERT INTO 'capvalue' VALUES (1548, '208x208');
INSERT INTO 'devicecapvalue' VALUES (19627, 358, 13, 1548);
INSERT INTO 'devicecapvalue' VALUES (19628, 358, 76, 593);
INSERT INTO 'capvalue' VALUES (1549, '37');
INSERT INTO 'devicecapvalue' VALUES (19629, 358, 77, 1549);
INSERT INTO 'devicecapvalue' VALUES (19630, 358, 78, 1549);
INSERT INTO 'devicecapvalue' VALUES (19631, 358, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (19632, 358, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (19633, 358, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (19634, 358, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (19635, 358, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (19636, 358, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (19637, 358, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (19638, 358, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (19639, 358, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (19640, 358, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19641, 358, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19642, 358, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (19643, 358, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (19644, 358, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (19645, 358, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (19646, 358, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (19647, 358, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (19648, 358, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (19649, 358, 88, 1534);
INSERT INTO 'capvalue' VALUES (1550, 'WCDMA');
INSERT INTO 'devicecapvalue' VALUES (19650, 358, 88, 1550);
INSERT INTO 'capvalue' VALUES (1551, 'Symbian OS 9.1');
INSERT INTO 'devicecapvalue' VALUES (19651, 358, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (19652, 358, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (19653, 358, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (19654, 358, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (19655, 358, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (19656, 358, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (19657, 358, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (19658, 358, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (19659, 358, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (19660, 358, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (19661, 358, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (19662, 358, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (19663, 358, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (19664, 358, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (19665, 358, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (19666, 358, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (19667, 358, 51, 103);
INSERT INTO 'capvalue' VALUES (1552, 'truetones');
INSERT INTO 'devicecapvalue' VALUES (19668, 358, 51, 1552);
INSERT INTO 'devicecapvalue' VALUES (19669, 358, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (19670, 358, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (19671, 358, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (19672, 358, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (19673, 358, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (19674, 358, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (19675, 358, 157, 1504);
INSERT INTO 'capvalue' VALUES (1553, 'Nokia5500d/2.0 (03.18) SymbianOS/9.1 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (19676, 358, 53, 1553);
INSERT INTO 'devicecapvalue' VALUES (19677, 359, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (19678, 359, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (19679, 359, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (19680, 359, 5, 646);
INSERT INTO 'capvalue' VALUES (1554, '2007-08-29');
INSERT INTO 'devicecapvalue' VALUES (19681, 360, 158, 1554);
INSERT INTO 'devicecapvalue' VALUES (19682, 360, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (19683, 360, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (19684, 360, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (19685, 360, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (19686, 360, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (19687, 360, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (19688, 360, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (19689, 360, 17, 1479);
INSERT INTO 'devicecapvalue' VALUES (19690, 360, 17, 1480);
INSERT INTO 'devicecapvalue' VALUES (19691, 360, 17, 1481);
INSERT INTO 'devicecapvalue' VALUES (19692, 360, 17, 1482);
INSERT INTO 'capvalue' VALUES (1555, 'jsr179');
INSERT INTO 'devicecapvalue' VALUES (19693, 360, 17, 1555);
INSERT INTO 'devicecapvalue' VALUES (19694, 360, 17, 1483);
INSERT INTO 'devicecapvalue' VALUES (19695, 360, 17, 1484);
INSERT INTO 'devicecapvalue' VALUES (19696, 360, 17, 1485);
INSERT INTO 'devicecapvalue' VALUES (19697, 360, 17, 1486);
INSERT INTO 'devicecapvalue' VALUES (19698, 360, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (19699, 360, 17, 1488);
INSERT INTO 'devicecapvalue' VALUES (19700, 360, 17, 1489);
INSERT INTO 'devicecapvalue' VALUES (19701, 360, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (19702, 360, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (19703, 360, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (19704, 360, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (19705, 360, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (19706, 360, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (19707, 360, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (19708, 360, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (19709, 360, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (19710, 360, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (19711, 360, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (19712, 360, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (19713, 360, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (19714, 360, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (19715, 360, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (19716, 360, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (19717, 361, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (19718, 361, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (19719, 361, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (19720, 361, 173, 1478);
INSERT INTO 'capvalue' VALUES (1556, 'Windows Media DRM 10');
INSERT INTO 'devicecapvalue' VALUES (19721, 361, 173, 1556);
INSERT INTO 'devicecapvalue' VALUES (19722, 361, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (19723, 361, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (19724, 361, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (19725, 361, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (19726, 361, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (19727, 361, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (19728, 361, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (19729, 361, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (19730, 361, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (19731, 361, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (19732, 361, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (19733, 361, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (19734, 361, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (19735, 361, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (19736, 361, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (19737, 361, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (19738, 361, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (19739, 361, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (19740, 361, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (19741, 361, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (19742, 361, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (19743, 361, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (19744, 361, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (19745, 361, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (19746, 361, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19747, 361, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19748, 361, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (19749, 361, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (19750, 361, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (19751, 361, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (19752, 361, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (19753, 361, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (19754, 361, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (19755, 361, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (19756, 361, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (19757, 361, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (19758, 361, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (19759, 361, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (19760, 361, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (19761, 361, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (19762, 361, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (19763, 361, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (19764, 361, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (19765, 361, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (19766, 361, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (19767, 361, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (19768, 361, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (19769, 361, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (19770, 361, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (19771, 361, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (19772, 361, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (19773, 361, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (19774, 361, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (19775, 361, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (19776, 361, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (19777, 361, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (19778, 361, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (19779, 361, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (19780, 361, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (19781, 361, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (19782, 361, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (19783, 362, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (19784, 362, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (19785, 362, 5, 5);
INSERT INTO 'capvalue' VALUES (1557, '2007-03-29');
INSERT INTO 'devicecapvalue' VALUES (19786, 363, 158, 1557);
INSERT INTO 'devicecapvalue' VALUES (19787, 363, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (19788, 363, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (19789, 363, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (19790, 363, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (19791, 363, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (19792, 363, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (19793, 363, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (19794, 363, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (19795, 363, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (19796, 363, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (19797, 363, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (19798, 363, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (19799, 363, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (19800, 363, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (19801, 363, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (19802, 363, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (19803, 363, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (19804, 363, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (19805, 363, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (19806, 363, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (19807, 363, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (19808, 363, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (19809, 363, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (19810, 363, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (19811, 363, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (19812, 363, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (19813, 363, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (19814, 363, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (19815, 363, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19816, 363, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (19817, 363, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (19818, 363, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (19819, 363, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (19820, 363, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (19821, 363, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (19822, 363, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (19823, 363, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (19824, 363, 88, 1550);
INSERT INTO 'capvalue' VALUES (1558, 'Symbian OS 9.2');
INSERT INTO 'devicecapvalue' VALUES (19825, 363, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (19826, 363, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (19827, 363, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (19828, 363, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (19829, 363, 156, 1417);
INSERT INTO 'capvalue' VALUES (1559, 'Symbian A');
INSERT INTO 'devicecapvalue' VALUES (19830, 363, 182, 1559);
INSERT INTO 'capvalue' VALUES (1560, 'Symbian B');
INSERT INTO 'devicecapvalue' VALUES (19831, 363, 182, 1560);
INSERT INTO 'capvalue' VALUES (1561, 'Symbian C');
INSERT INTO 'devicecapvalue' VALUES (19832, 363, 182, 1561);
INSERT INTO 'capvalue' VALUES (1562, 'Symbian D');
INSERT INTO 'devicecapvalue' VALUES (19833, 363, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (19834, 363, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (19835, 363, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (19836, 363, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (19837, 363, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (19838, 363, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (19839, 363, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (19840, 363, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (19841, 363, 51, 1097);
INSERT INTO 'capvalue' VALUES (1563, 'm4a');
INSERT INTO 'devicecapvalue' VALUES (19842, 363, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (19843, 363, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (19844, 363, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (19845, 363, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (19846, 363, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (19847, 363, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (19848, 363, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (19849, 363, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (19850, 363, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (19851, 363, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (19852, 363, 51, 1041);
INSERT INTO 'capvalue' VALUES (1564, '36700160');
INSERT INTO 'devicecapvalue' VALUES (19853, 363, 52, 1564);
INSERT INTO 'devicecapvalue' VALUES (19854, 363, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (19855, 363, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (19856, 363, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (19857, 363, 157, 1504);
INSERT INTO 'capvalue' VALUES (1565, 'Mozilla/5.0 (SymbianOS/9.2; U; Series60/3.1 Nokia5700');
INSERT INTO 'devicecapvalue' VALUES (19858, 363, 53, 1565);
INSERT INTO 'devicecapvalue' VALUES (19859, 364, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (19860, 364, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (19861, 364, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (19862, 364, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (19863, 364, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (19864, 364, 173, 1556);
INSERT INTO 'devicecapvalue' VALUES (19865, 364, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (19866, 364, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (19867, 364, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (19868, 364, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (19869, 364, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (19870, 364, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (19871, 364, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (19872, 364, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (19873, 364, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (19874, 364, 15, 16);
INSERT INTO 'capvalue' VALUES (1566, 'exif');
INSERT INTO 'devicecapvalue' VALUES (19875, 364, 15, 1566);
INSERT INTO 'devicecapvalue' VALUES (19876, 364, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (19877, 364, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (19878, 364, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (19879, 364, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (19880, 364, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (19881, 364, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (19882, 364, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (19883, 364, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (19884, 364, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (19885, 364, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (19886, 364, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (19887, 364, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (19888, 364, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (19889, 364, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (19890, 364, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (19891, 364, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (19892, 364, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (19893, 364, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (19894, 364, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19895, 364, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (19896, 364, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (19897, 364, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (19898, 364, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (19899, 364, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (19900, 364, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (19901, 364, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (19902, 364, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (19903, 364, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (19904, 364, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (19905, 364, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (19906, 364, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (19907, 364, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (19908, 364, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (19909, 364, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (19910, 364, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (19911, 364, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (19912, 364, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (19913, 364, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (19914, 364, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (19915, 364, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (19916, 364, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (19917, 364, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (19918, 364, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (19919, 364, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (19920, 364, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (19921, 364, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (19922, 364, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (19923, 364, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (19924, 364, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (19925, 364, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (19926, 364, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (19927, 364, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (19928, 364, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (19929, 364, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (19930, 364, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (19931, 364, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (19932, 364, 52, 1564);
INSERT INTO 'devicecapvalue' VALUES (19933, 364, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (19934, 364, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (19935, 364, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (19936, 364, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (19937, 365, 56, 707);
INSERT INTO 'cap' VALUES (192, 'api.svg', 1);
INSERT INTO 'devicecapvalue' VALUES (19938, 365, 192, 15);
INSERT INTO 'capvalue' VALUES (1567, 'FillPolygonRequiresPositiveXYInNokiaUiApi');
INSERT INTO 'devicecapvalue' VALUES (19939, 365, 74, 1567);
INSERT INTO 'cap' VALUES (193, 'build.bootclasspath', 1);
INSERT INTO 'capvalue' VALUES (1568, 'cldc-1.1.jar');
INSERT INTO 'devicecapvalue' VALUES (19940, 365, 193, 1568);
INSERT INTO 'capvalue' VALUES (1569, 'midp-2.0.jar');
INSERT INTO 'devicecapvalue' VALUES (19941, 365, 193, 1569);
INSERT INTO 'capvalue' VALUES (1570, 'midp-2.1.jar');
INSERT INTO 'devicecapvalue' VALUES (19942, 365, 193, 1570);
INSERT INTO 'cap' VALUES (194, 'build.implicitgroups', 1);
INSERT INTO 'capvalue' VALUES (1571, 'midp2');
INSERT INTO 'devicecapvalue' VALUES (19943, 365, 194, 1571);
INSERT INTO 'devicecapvalue' VALUES (19944, 365, 79, 15);
INSERT INTO 'capvalue' VALUES (1572, '360x240');
INSERT INTO 'devicecapvalue' VALUES (19945, 365, 7, 1572);
INSERT INTO 'cap' VALUES (195, 'classes.fullscreen', 1);
INSERT INTO 'capvalue' VALUES (1573, 'com.nokia.mid.ui.FullCanvas');
INSERT INTO 'devicecapvalue' VALUES (19946, 365, 195, 1573);
INSERT INTO 'devicecapvalue' VALUES (19947, 365, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (19948, 365, 2, 2);
INSERT INTO 'capvalue' VALUES (1574, 'hasVirtualKeyboard');
INSERT INTO 'devicecapvalue' VALUES (19949, 365, 2, 1574);
INSERT INTO 'devicecapvalue' VALUES (19950, 365, 9, 604);
INSERT INTO 'capvalue' VALUES (1575, '30');
INSERT INTO 'devicecapvalue' VALUES (19951, 365, 10, 1575);
INSERT INTO 'devicecapvalue' VALUES (19952, 365, 11, 604);
INSERT INTO 'devicecapvalue' VALUES (19953, 365, 12, 649);
INSERT INTO 'capvalue' VALUES (1576, '360x360');
INSERT INTO 'devicecapvalue' VALUES (19954, 365, 13, 1576);
INSERT INTO 'devicecapvalue' VALUES (19955, 365, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (19956, 365, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (19957, 365, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (19958, 365, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (19959, 365, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (19960, 365, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (19961, 365, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (19962, 365, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (19963, 365, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (19964, 365, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (19965, 365, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (19966, 365, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (19967, 365, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (19968, 365, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (19969, 365, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (19970, 365, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19971, 365, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (19972, 365, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (19973, 365, 6, 879);
INSERT INTO 'cap' VALUES (196, 'key.addsymbolkey', 1);
INSERT INTO 'devicecapvalue' VALUES (19974, 365, 196, 745);
INSERT INTO 'devicecapvalue' VALUES (19975, 365, 178, 237);
INSERT INTO 'devicecapvalue' VALUES (19976, 365, 18, 745);
INSERT INTO 'devicecapvalue' VALUES (19977, 365, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (19978, 365, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (19979, 365, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (19980, 365, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (19981, 365, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (19982, 365, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (19983, 365, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (19984, 365, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (19985, 365, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (19986, 365, 57, 745);
INSERT INTO 'devicecapvalue' VALUES (19987, 365, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (19988, 365, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (19989, 365, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (19990, 365, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (19991, 365, 92, 668);
INSERT INTO 'capvalue' VALUES (1577, 'encoding=audio/amr encoding=audio/basic encoding=audio/x-au encoding=audio/au encoding=audio/x-basic encoding=audio/wav encoding=audio/x-wav encoding=pcm encoding=ulaw encoding=gsm');
INSERT INTO 'devicecapvalue' VALUES (19992, 365, 38, 1577);
INSERT INTO 'devicecapvalue' VALUES (19993, 365, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (19994, 365, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (19995, 365, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (19996, 365, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (19997, 365, 39, 1050);
INSERT INTO 'capvalue' VALUES (1578, 'audio/x-basic');
INSERT INTO 'devicecapvalue' VALUES (19998, 365, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (19999, 365, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (20000, 365, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (20001, 365, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (20002, 365, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (20003, 365, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (20004, 365, 40, 125);
INSERT INTO 'capvalue' VALUES (1579, 'audio/rmf');
INSERT INTO 'devicecapvalue' VALUES (20005, 365, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (20006, 365, 40, 64);
INSERT INTO 'capvalue' VALUES (1580, 'audio/x-beatnik-rmf');
INSERT INTO 'devicecapvalue' VALUES (20007, 365, 40, 1580);
INSERT INTO 'capvalue' VALUES (1581, 'audio/x-rmf');
INSERT INTO 'devicecapvalue' VALUES (20008, 365, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (20009, 365, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (20010, 365, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (20011, 365, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (20012, 365, 41, 1275);
INSERT INTO 'devicecapvalue' VALUES (20013, 365, 41, 57);
INSERT INTO 'capvalue' VALUES (1582, 'audio/3gpp2');
INSERT INTO 'devicecapvalue' VALUES (20014, 365, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (20015, 365, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (20016, 365, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (20017, 365, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (20018, 365, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (20019, 365, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (20020, 365, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (20021, 365, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (20022, 365, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (20023, 365, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (20024, 365, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (20025, 365, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (20026, 365, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (20027, 365, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (20028, 365, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (20029, 365, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (20030, 365, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (20031, 365, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (20032, 365, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (20033, 365, 41, 1280);
INSERT INTO 'capvalue' VALUES (1583, 'audio/x-realaudio');
INSERT INTO 'devicecapvalue' VALUES (20034, 365, 41, 1583);
INSERT INTO 'devicecapvalue' VALUES (20035, 365, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (20036, 365, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (20037, 365, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (20038, 365, 41, 66);
INSERT INTO 'capvalue' VALUES (1584, 'text/plain');
INSERT INTO 'devicecapvalue' VALUES (20039, 365, 41, 1584);
INSERT INTO 'devicecapvalue' VALUES (20040, 365, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (20041, 365, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (20042, 365, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (20043, 365, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (20044, 365, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (20045, 365, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (20046, 365, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (20047, 365, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (20048, 365, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (20049, 365, 42, 1275);
INSERT INTO 'devicecapvalue' VALUES (20050, 365, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (20051, 365, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (20052, 365, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (20053, 365, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (20054, 365, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (20055, 365, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (20056, 365, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (20057, 365, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (20058, 365, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (20059, 365, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (20060, 365, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (20061, 365, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (20062, 365, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (20063, 365, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (20064, 365, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (20065, 365, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (20066, 365, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (20067, 365, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (20068, 365, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (20069, 365, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (20070, 365, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (20071, 365, 42, 1583);
INSERT INTO 'devicecapvalue' VALUES (20072, 365, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (20073, 365, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (20074, 365, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (20075, 365, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (20076, 365, 42, 1584);
INSERT INTO 'devicecapvalue' VALUES (20077, 365, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (20078, 365, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (20079, 365, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (20080, 365, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (20081, 365, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (20082, 365, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (20083, 365, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (20084, 365, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (20085, 365, 44, 15);
INSERT INTO 'capvalue' VALUES (1585, 'encoding=video/3gpp2 encoding=video/mp4 encoding=video/3gpp');
INSERT INTO 'devicecapvalue' VALUES (20086, 365, 45, 1585);
INSERT INTO 'devicecapvalue' VALUES (20087, 365, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (20088, 365, 58, 42);
INSERT INTO 'devicecapvalue' VALUES (20089, 365, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (20090, 365, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (20091, 365, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (20092, 365, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (20093, 365, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (20094, 365, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (20095, 365, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (20096, 365, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (20097, 365, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (20098, 365, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (20099, 365, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (20100, 365, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (20101, 365, 46, 901);
INSERT INTO 'capvalue' VALUES (1586, 'com.nokia.mid.batterylevel');
INSERT INTO 'devicecapvalue' VALUES (20102, 365, 46, 1586);
INSERT INTO 'capvalue' VALUES (1587, 'com.nokia.mid.countrycode');
INSERT INTO 'devicecapvalue' VALUES (20103, 365, 46, 1587);
INSERT INTO 'devicecapvalue' VALUES (20104, 365, 46, 1404);
INSERT INTO 'capvalue' VALUES (1588, 'com.nokia.mid.imei');
INSERT INTO 'devicecapvalue' VALUES (20105, 365, 46, 1588);
INSERT INTO 'capvalue' VALUES (1589, 'com.nokia.mid.networkavailability');
INSERT INTO 'devicecapvalue' VALUES (20106, 365, 46, 1589);
INSERT INTO 'capvalue' VALUES (1590, 'com.nokia.mid.networkid');
INSERT INTO 'devicecapvalue' VALUES (20107, 365, 46, 1590);
INSERT INTO 'capvalue' VALUES (1591, 'com.nokia.mid.networksignal');
INSERT INTO 'devicecapvalue' VALUES (20108, 365, 46, 1591);
INSERT INTO 'devicecapvalue' VALUES (20109, 365, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (20110, 365, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (20111, 365, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (20112, 365, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (20113, 365, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (20114, 365, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (20115, 365, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (20116, 365, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (20117, 365, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (20118, 365, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (20119, 365, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (20120, 365, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (20121, 365, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (20122, 365, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (20123, 365, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (20124, 365, 46, 75);
INSERT INTO 'capvalue' VALUES (1592, 'microedition.hostname');
INSERT INTO 'devicecapvalue' VALUES (20125, 365, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (20126, 365, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (20127, 365, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (20128, 365, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (20129, 365, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (20130, 365, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (20131, 365, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (20132, 365, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (20133, 365, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (20134, 365, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (20135, 365, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (20136, 365, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (20137, 365, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (20138, 365, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (20139, 365, 46, 990);
INSERT INTO 'capvalue' VALUES (1593, 'microedition.satsa.pki.version');
INSERT INTO 'devicecapvalue' VALUES (20140, 365, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (20141, 365, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (20142, 365, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (20143, 365, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (20144, 365, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (20145, 365, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (20146, 365, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (20147, 365, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (20148, 365, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (20149, 365, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (20150, 365, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (20151, 365, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (20152, 365, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (20153, 365, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (20154, 365, 115, 1577);
INSERT INTO 'cap' VALUES (197, 'property.audio.samplerates', 1);
INSERT INTO 'capvalue' VALUES (1594, '8000 16000');
INSERT INTO 'devicecapvalue' VALUES (20155, 365, 197, 1594);
INSERT INTO 'devicecapvalue' VALUES (20156, 365, 141, 238);
INSERT INTO 'devicecapvalue' VALUES (20157, 365, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (20158, 365, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (20159, 365, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (20160, 365, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (20161, 365, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (20162, 365, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (20163, 365, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (20164, 365, 124, 244);
INSERT INTO 'capvalue' VALUES (1595, '65535');
INSERT INTO 'devicecapvalue' VALUES (20165, 365, 125, 1595);
INSERT INTO 'devicecapvalue' VALUES (20166, 365, 126, 612);
INSERT INTO 'cap' VALUES (198, 'property.com.nokia.mid.batterylevel', 1);
INSERT INTO 'capvalue' VALUES (1596, '100');
INSERT INTO 'devicecapvalue' VALUES (20167, 365, 198, 1596);
INSERT INTO 'cap' VALUES (199, 'property.com.nokia.mid.countrycode', 1);
INSERT INTO 'capvalue' VALUES (1597, '262');
INSERT INTO 'devicecapvalue' VALUES (20168, 365, 199, 1597);
INSERT INTO 'devicecapvalue' VALUES (20169, 365, 183, 1448);
INSERT INTO 'cap' VALUES (200, 'property.com.nokia.mid.imei', 1);
INSERT INTO 'capvalue' VALUES (1598, '354183024517803');
INSERT INTO 'devicecapvalue' VALUES (20170, 365, 200, 1598);
INSERT INTO 'cap' VALUES (201, 'property.com.nokia.mid.networkavailability', 1);
INSERT INTO 'capvalue' VALUES (1599, 'available');
INSERT INTO 'devicecapvalue' VALUES (20171, 365, 201, 1599);
INSERT INTO 'cap' VALUES (202, 'property.com.nokia.mid.networkid', 1);
INSERT INTO 'capvalue' VALUES (1600, '02 (Vodafone.d)');
INSERT INTO 'devicecapvalue' VALUES (20172, 365, 202, 1600);
INSERT INTO 'cap' VALUES (203, 'property.com.nokia.mid.networksignal', 1);
INSERT INTO 'capvalue' VALUES (1601, '7 (85 dBm)');
INSERT INTO 'devicecapvalue' VALUES (20173, 365, 203, 1601);
INSERT INTO 'devicecapvalue' VALUES (20174, 365, 184, 1424);
INSERT INTO 'capvalue' VALUES (1602, 'na');
INSERT INTO 'devicecapvalue' VALUES (20175, 365, 185, 1602);
INSERT INTO 'devicecapvalue' VALUES (20176, 365, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (20177, 365, 101, 1469);
INSERT INTO 'capvalue' VALUES (1603, 'Speicherkarte');
INSERT INTO 'devicecapvalue' VALUES (20178, 365, 102, 1603);
INSERT INTO 'capvalue' VALUES (1604, 'file:///C:/Data/Images/');
INSERT INTO 'devicecapvalue' VALUES (20179, 365, 103, 1604);
INSERT INTO 'capvalue' VALUES (1605, 'Bilder');
INSERT INTO 'devicecapvalue' VALUES (20180, 365, 104, 1605);
INSERT INTO 'capvalue' VALUES (1606, 'file:///c:/private/102033e6/midlets/[101390f2]/scratch/');
INSERT INTO 'devicecapvalue' VALUES (20181, 365, 105, 1606);
INSERT INTO 'capvalue' VALUES (1607, 'file:///C:/Data/Sounds/');
INSERT INTO 'devicecapvalue' VALUES (20182, 365, 106, 1607);
INSERT INTO 'capvalue' VALUES (1608, 'T?ne');
INSERT INTO 'devicecapvalue' VALUES (20183, 365, 107, 1608);
INSERT INTO 'capvalue' VALUES (1609, 'file:///C:/Data/Videos/');
INSERT INTO 'devicecapvalue' VALUES (20184, 365, 108, 1609);
INSERT INTO 'capvalue' VALUES (1610, 'Videoclips');
INSERT INTO 'devicecapvalue' VALUES (20185, 365, 109, 1610);
INSERT INTO 'devicecapvalue' VALUES (20186, 365, 144, 242);
INSERT INTO 'capvalue' VALUES (1611, 'BT1');
INSERT INTO 'devicecapvalue' VALUES (20187, 365, 114, 1611);
INSERT INTO 'capvalue' VALUES (1612, 'BT10');
INSERT INTO 'devicecapvalue' VALUES (20188, 365, 114, 1612);
INSERT INTO 'capvalue' VALUES (1613, 'BT11');
INSERT INTO 'devicecapvalue' VALUES (20189, 365, 114, 1613);
INSERT INTO 'capvalue' VALUES (1614, 'BT12');
INSERT INTO 'devicecapvalue' VALUES (20190, 365, 114, 1614);
INSERT INTO 'capvalue' VALUES (1615, 'BT13');
INSERT INTO 'devicecapvalue' VALUES (20191, 365, 114, 1615);
INSERT INTO 'capvalue' VALUES (1616, 'BT14');
INSERT INTO 'devicecapvalue' VALUES (20192, 365, 114, 1616);
INSERT INTO 'capvalue' VALUES (1617, 'BT15');
INSERT INTO 'devicecapvalue' VALUES (20193, 365, 114, 1617);
INSERT INTO 'capvalue' VALUES (1618, 'BT16');
INSERT INTO 'devicecapvalue' VALUES (20194, 365, 114, 1618);
INSERT INTO 'capvalue' VALUES (1619, 'BT17');
INSERT INTO 'devicecapvalue' VALUES (20195, 365, 114, 1619);
INSERT INTO 'capvalue' VALUES (1620, 'BT18');
INSERT INTO 'devicecapvalue' VALUES (20196, 365, 114, 1620);
INSERT INTO 'capvalue' VALUES (1621, 'BT19');
INSERT INTO 'devicecapvalue' VALUES (20197, 365, 114, 1621);
INSERT INTO 'capvalue' VALUES (1622, 'BT2');
INSERT INTO 'devicecapvalue' VALUES (20198, 365, 114, 1622);
INSERT INTO 'capvalue' VALUES (1623, 'BT20');
INSERT INTO 'devicecapvalue' VALUES (20199, 365, 114, 1623);
INSERT INTO 'capvalue' VALUES (1624, 'BT21');
INSERT INTO 'devicecapvalue' VALUES (20200, 365, 114, 1624);
INSERT INTO 'capvalue' VALUES (1625, 'BT22');
INSERT INTO 'devicecapvalue' VALUES (20201, 365, 114, 1625);
INSERT INTO 'capvalue' VALUES (1626, 'BT23');
INSERT INTO 'devicecapvalue' VALUES (20202, 365, 114, 1626);
INSERT INTO 'capvalue' VALUES (1627, 'BT24');
INSERT INTO 'devicecapvalue' VALUES (20203, 365, 114, 1627);
INSERT INTO 'capvalue' VALUES (1628, 'BT25');
INSERT INTO 'devicecapvalue' VALUES (20204, 365, 114, 1628);
INSERT INTO 'capvalue' VALUES (1629, 'BT26');
INSERT INTO 'devicecapvalue' VALUES (20205, 365, 114, 1629);
INSERT INTO 'capvalue' VALUES (1630, 'BT27');
INSERT INTO 'devicecapvalue' VALUES (20206, 365, 114, 1630);
INSERT INTO 'capvalue' VALUES (1631, 'BT28');
INSERT INTO 'devicecapvalue' VALUES (20207, 365, 114, 1631);
INSERT INTO 'capvalue' VALUES (1632, 'BT29');
INSERT INTO 'devicecapvalue' VALUES (20208, 365, 114, 1632);
INSERT INTO 'capvalue' VALUES (1633, 'BT3');
INSERT INTO 'devicecapvalue' VALUES (20209, 365, 114, 1633);
INSERT INTO 'capvalue' VALUES (1634, 'BT30');
INSERT INTO 'devicecapvalue' VALUES (20210, 365, 114, 1634);
INSERT INTO 'capvalue' VALUES (1635, 'BT31');
INSERT INTO 'devicecapvalue' VALUES (20211, 365, 114, 1635);
INSERT INTO 'capvalue' VALUES (1636, 'BT32');
INSERT INTO 'devicecapvalue' VALUES (20212, 365, 114, 1636);
INSERT INTO 'capvalue' VALUES (1637, 'BT33');
INSERT INTO 'devicecapvalue' VALUES (20213, 365, 114, 1637);
INSERT INTO 'capvalue' VALUES (1638, 'BT34');
INSERT INTO 'devicecapvalue' VALUES (20214, 365, 114, 1638);
INSERT INTO 'capvalue' VALUES (1639, 'BT35');
INSERT INTO 'devicecapvalue' VALUES (20215, 365, 114, 1639);
INSERT INTO 'capvalue' VALUES (1640, 'BT36');
INSERT INTO 'devicecapvalue' VALUES (20216, 365, 114, 1640);
INSERT INTO 'capvalue' VALUES (1641, 'BT37');
INSERT INTO 'devicecapvalue' VALUES (20217, 365, 114, 1641);
INSERT INTO 'capvalue' VALUES (1642, 'BT38');
INSERT INTO 'devicecapvalue' VALUES (20218, 365, 114, 1642);
INSERT INTO 'capvalue' VALUES (1643, 'BT39');
INSERT INTO 'devicecapvalue' VALUES (20219, 365, 114, 1643);
INSERT INTO 'capvalue' VALUES (1644, 'BT4');
INSERT INTO 'devicecapvalue' VALUES (20220, 365, 114, 1644);
INSERT INTO 'capvalue' VALUES (1645, 'BT40');
INSERT INTO 'devicecapvalue' VALUES (20221, 365, 114, 1645);
INSERT INTO 'capvalue' VALUES (1646, 'BT41');
INSERT INTO 'devicecapvalue' VALUES (20222, 365, 114, 1646);
INSERT INTO 'capvalue' VALUES (1647, 'BT42');
INSERT INTO 'devicecapvalue' VALUES (20223, 365, 114, 1647);
INSERT INTO 'capvalue' VALUES (1648, 'BT43');
INSERT INTO 'devicecapvalue' VALUES (20224, 365, 114, 1648);
INSERT INTO 'capvalue' VALUES (1649, 'BT44');
INSERT INTO 'devicecapvalue' VALUES (20225, 365, 114, 1649);
INSERT INTO 'capvalue' VALUES (1650, 'BT45');
INSERT INTO 'devicecapvalue' VALUES (20226, 365, 114, 1650);
INSERT INTO 'capvalue' VALUES (1651, 'BT46');
INSERT INTO 'devicecapvalue' VALUES (20227, 365, 114, 1651);
INSERT INTO 'capvalue' VALUES (1652, 'BT47');
INSERT INTO 'devicecapvalue' VALUES (20228, 365, 114, 1652);
INSERT INTO 'capvalue' VALUES (1653, 'BT48');
INSERT INTO 'devicecapvalue' VALUES (20229, 365, 114, 1653);
INSERT INTO 'capvalue' VALUES (1654, 'BT49');
INSERT INTO 'devicecapvalue' VALUES (20230, 365, 114, 1654);
INSERT INTO 'capvalue' VALUES (1655, 'BT5');
INSERT INTO 'devicecapvalue' VALUES (20231, 365, 114, 1655);
INSERT INTO 'capvalue' VALUES (1656, 'BT50');
INSERT INTO 'devicecapvalue' VALUES (20232, 365, 114, 1656);
INSERT INTO 'capvalue' VALUES (1657, 'BT51');
INSERT INTO 'devicecapvalue' VALUES (20233, 365, 114, 1657);
INSERT INTO 'capvalue' VALUES (1658, 'BT52');
INSERT INTO 'devicecapvalue' VALUES (20234, 365, 114, 1658);
INSERT INTO 'capvalue' VALUES (1659, 'BT53');
INSERT INTO 'devicecapvalue' VALUES (20235, 365, 114, 1659);
INSERT INTO 'capvalue' VALUES (1660, 'BT54');
INSERT INTO 'devicecapvalue' VALUES (20236, 365, 114, 1660);
INSERT INTO 'capvalue' VALUES (1661, 'BT55');
INSERT INTO 'devicecapvalue' VALUES (20237, 365, 114, 1661);
INSERT INTO 'capvalue' VALUES (1662, 'BT56');
INSERT INTO 'devicecapvalue' VALUES (20238, 365, 114, 1662);
INSERT INTO 'capvalue' VALUES (1663, 'BT57');
INSERT INTO 'devicecapvalue' VALUES (20239, 365, 114, 1663);
INSERT INTO 'capvalue' VALUES (1664, 'BT58');
INSERT INTO 'devicecapvalue' VALUES (20240, 365, 114, 1664);
INSERT INTO 'capvalue' VALUES (1665, 'BT59');
INSERT INTO 'devicecapvalue' VALUES (20241, 365, 114, 1665);
INSERT INTO 'capvalue' VALUES (1666, 'BT6');
INSERT INTO 'devicecapvalue' VALUES (20242, 365, 114, 1666);
INSERT INTO 'capvalue' VALUES (1667, 'BT60');
INSERT INTO 'devicecapvalue' VALUES (20243, 365, 114, 1667);
INSERT INTO 'capvalue' VALUES (1668, 'BT61');
INSERT INTO 'devicecapvalue' VALUES (20244, 365, 114, 1668);
INSERT INTO 'capvalue' VALUES (1669, 'BT62');
INSERT INTO 'devicecapvalue' VALUES (20245, 365, 114, 1669);
INSERT INTO 'capvalue' VALUES (1670, 'BT63');
INSERT INTO 'devicecapvalue' VALUES (20246, 365, 114, 1670);
INSERT INTO 'capvalue' VALUES (1671, 'BT64');
INSERT INTO 'devicecapvalue' VALUES (20247, 365, 114, 1671);
INSERT INTO 'capvalue' VALUES (1672, 'BT7');
INSERT INTO 'devicecapvalue' VALUES (20248, 365, 114, 1672);
INSERT INTO 'capvalue' VALUES (1673, 'BT8');
INSERT INTO 'devicecapvalue' VALUES (20249, 365, 114, 1673);
INSERT INTO 'capvalue' VALUES (1674, 'BT9');
INSERT INTO 'devicecapvalue' VALUES (20250, 365, 114, 1674);
INSERT INTO 'devicecapvalue' VALUES (20251, 365, 114, 852);
INSERT INTO 'capvalue' VALUES (1675, 'IR1');
INSERT INTO 'devicecapvalue' VALUES (20252, 365, 114, 1675);
INSERT INTO 'devicecapvalue' VALUES (20253, 365, 114, 983);
INSERT INTO 'capvalue' VALUES (1676, 'USB2');
INSERT INTO 'devicecapvalue' VALUES (20254, 365, 114, 1676);
INSERT INTO 'devicecapvalue' VALUES (20255, 365, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (20256, 365, 62, 241);
INSERT INTO 'cap' VALUES (204, 'property.microedition.hostname', 1);
INSERT INTO 'capvalue' VALUES (1677, 'localhost');
INSERT INTO 'devicecapvalue' VALUES (20257, 365, 204, 1677);
INSERT INTO 'devicecapvalue' VALUES (20258, 365, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (20259, 365, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (20260, 365, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (20261, 365, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (20262, 365, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (20263, 365, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (20264, 365, 65, 242);
INSERT INTO 'capvalue' VALUES (1678, '1.2');
INSERT INTO 'devicecapvalue' VALUES (20265, 365, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (20266, 365, 131, 922);
INSERT INTO 'devicecapvalue' VALUES (20267, 365, 67, 45);
INSERT INTO 'capvalue' VALUES (1679, 'Nokia5800d-1/11.0.008/sw_platform=S60;sw_platform_version=5.0;java_build_version=1.1.2');
INSERT INTO 'devicecapvalue' VALUES (20268, 365, 68, 1679);
INSERT INTO 'devicecapvalue' VALUES (20269, 365, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (20270, 365, 188, 45);
INSERT INTO 'cap' VALUES (205, 'property.microedition.satsa.pki.version', 1);
INSERT INTO 'devicecapvalue' VALUES (20271, 365, 205, 45);
INSERT INTO 'devicecapvalue' VALUES (20272, 365, 132, 1577);
INSERT INTO 'devicecapvalue' VALUES (20273, 365, 133, 1585);
INSERT INTO 'devicecapvalue' VALUES (20274, 365, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (20275, 365, 86, 15);
INSERT INTO 'capvalue' VALUES (1680, 'music audio3d');
INSERT INTO 'devicecapvalue' VALUES (20276, 365, 149, 1680);
INSERT INTO 'devicecapvalue' VALUES (20277, 365, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (20278, 365, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (20279, 365, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (20280, 365, 136, 1585);
INSERT INTO 'devicecapvalue' VALUES (20281, 365, 137, 1396);
INSERT INTO 'devicecapvalue' VALUES (20282, 365, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (20283, 365, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (20284, 365, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (20285, 365, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (20286, 365, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (20287, 365, 137, 96);
INSERT INTO 'capvalue' VALUES (1681, 'http://139.7.24.1/servlets/mms');
INSERT INTO 'devicecapvalue' VALUES (20288, 365, 138, 1681);
INSERT INTO 'capvalue' VALUES (1682, '+491722270333');
INSERT INTO 'devicecapvalue' VALUES (20289, 365, 72, 1682);
INSERT INTO 'devicecapvalue' VALUES (20290, 365, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (20291, 365, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (20292, 365, 140, 45);
INSERT INTO 'cap' VALUES (206, 'protocol rtsp', 1);
INSERT INTO 'capvalue' VALUES (1683, 'audio/3gppaudio/3gpp2 audio/amr audio/mp4 audio/mp4-latm audio/qcelp audio/vnd.qcelp video/3gpp video/3gpp2 video/mp4 application/vnd.rn-realmedia application/x-pn-realmedia application/sdp ');
INSERT INTO 'devicecapvalue' VALUES (20293, 365, 206, 1683);
INSERT INTO 'cap' VALUES (207, 'protocolrtsp', 1);
INSERT INTO 'devicecapvalue' VALUES (20294, 365, 207, 56);
INSERT INTO 'devicecapvalue' VALUES (20295, 365, 207, 868);
INSERT INTO 'devicecapvalue' VALUES (20296, 365, 207, 1275);
INSERT INTO 'devicecapvalue' VALUES (20297, 365, 207, 57);
INSERT INTO 'devicecapvalue' VALUES (20298, 365, 207, 1582);
INSERT INTO 'devicecapvalue' VALUES (20299, 365, 207, 49);
INSERT INTO 'devicecapvalue' VALUES (20300, 365, 207, 62);
INSERT INTO 'capvalue' VALUES (1684, 'audio/mp4-latm');
INSERT INTO 'devicecapvalue' VALUES (20301, 365, 207, 1684);
INSERT INTO 'devicecapvalue' VALUES (20302, 365, 207, 986);
INSERT INTO 'devicecapvalue' VALUES (20303, 365, 207, 988);
INSERT INTO 'devicecapvalue' VALUES (20304, 365, 207, 53);
INSERT INTO 'devicecapvalue' VALUES (20305, 365, 207, 1051);
INSERT INTO 'devicecapvalue' VALUES (20306, 365, 207, 67);
INSERT INTO 'cap' VALUES (208, 'supportfloatingpoint', 1);
INSERT INTO 'devicecapvalue' VALUES (20307, 365, 208, 15);
INSERT INTO 'devicecapvalue' VALUES (20308, 365, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (20309, 365, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (20310, 365, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (20311, 365, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (20312, 365, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (20313, 365, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (20314, 365, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (20315, 365, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (20316, 365, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (20317, 365, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (20318, 365, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (20319, 365, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (20320, 365, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (20321, 365, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (20322, 365, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (20323, 365, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (20324, 365, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (20325, 365, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (20326, 365, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (20327, 365, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (20328, 365, 48, 824);
INSERT INTO 'devicecapvalue' VALUES (20329, 365, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (20330, 365, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (20331, 365, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (20332, 365, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (20333, 365, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (20334, 365, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (20335, 365, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (20336, 365, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (20337, 365, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (20338, 365, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (20339, 365, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (20340, 365, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (20341, 365, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (20342, 365, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (20343, 365, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (20344, 365, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (20345, 365, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (20346, 365, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (20347, 365, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (20348, 365, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (20349, 365, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (20350, 365, 48, 523);
INSERT INTO 'capvalue' VALUES (1685, 'PRC');
INSERT INTO 'devicecapvalue' VALUES (20351, 365, 48, 1685);
INSERT INTO 'devicecapvalue' VALUES (20352, 365, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (20353, 365, 48, 525);
INSERT INTO 'capvalue' VALUES (1686, 'ROK');
INSERT INTO 'devicecapvalue' VALUES (20354, 365, 48, 1686);
INSERT INTO 'devicecapvalue' VALUES (20355, 365, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (20356, 365, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (20357, 365, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (20358, 365, 48, 830);
INSERT INTO 'capvalue' VALUES (1687, '291072');
INSERT INTO 'devicecapvalue' VALUES (20359, 365, 49, 1687);
INSERT INTO 'devicecapvalue' VALUES (20360, 366, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (20361, 366, 160, 856);
INSERT INTO 'capvalue' VALUES (1688, 'OMA v1.0');
INSERT INTO 'devicecapvalue' VALUES (20362, 366, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (20363, 366, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20364, 366, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (20365, 366, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (20366, 366, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (20367, 366, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20368, 366, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20369, 366, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20370, 366, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (20371, 366, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20372, 366, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (20373, 366, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (20374, 366, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (20375, 366, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (20376, 366, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (20377, 366, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (20378, 366, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20379, 366, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (20380, 366, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (20381, 366, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (20382, 366, 156, 1271);
INSERT INTO 'devicecapvalue' VALUES (20383, 366, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (20384, 366, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20385, 366, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (20386, 366, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20387, 366, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (20388, 366, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20389, 366, 51, 102);
INSERT INTO 'capvalue' VALUES (1689, 'midi16');
INSERT INTO 'devicecapvalue' VALUES (20390, 366, 51, 1689);
INSERT INTO 'devicecapvalue' VALUES (20391, 366, 51, 569);
INSERT INTO 'capvalue' VALUES (1690, 'nrt');
INSERT INTO 'devicecapvalue' VALUES (20392, 366, 51, 1690);
INSERT INTO 'devicecapvalue' VALUES (20393, 366, 52, 231);
INSERT INTO 'devicecapvalue' VALUES (20394, 366, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20395, 366, 157, 1134);
INSERT INTO 'capvalue' VALUES (1691, 'Nokia6020/2.0 (03.92) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (20396, 366, 53, 1691);
INSERT INTO 'capvalue' VALUES (1692, '2005-03-01');
INSERT INTO 'devicecapvalue' VALUES (20397, 367, 158, 1692);
INSERT INTO 'devicecapvalue' VALUES (20398, 367, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (20399, 367, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (20400, 367, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (20401, 367, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (20402, 367, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (20403, 367, 76, 1457);
INSERT INTO 'devicecapvalue' VALUES (20404, 367, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (20405, 367, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (20406, 367, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20407, 367, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (20408, 367, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20409, 367, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20410, 367, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (20411, 367, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20412, 367, 50, 1533);
INSERT INTO 'devicecapvalue' VALUES (20413, 367, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (20414, 367, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (20415, 367, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (20416, 367, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (20417, 367, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (20418, 367, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20419, 367, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (20420, 367, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (20421, 367, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (20422, 367, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20423, 367, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20424, 367, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (20425, 367, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20426, 367, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20427, 367, 51, 1689);
INSERT INTO 'devicecapvalue' VALUES (20428, 367, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20429, 367, 51, 1690);
INSERT INTO 'devicecapvalue' VALUES (20430, 367, 52, 1337);
INSERT INTO 'devicecapvalue' VALUES (20431, 367, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20432, 367, 157, 1134);
INSERT INTO 'capvalue' VALUES (1693, 'Nokia6021/2.0 (pp3.79.1) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (20433, 367, 53, 1693);
INSERT INTO 'devicecapvalue' VALUES (20434, 368, 158, 1692);
INSERT INTO 'devicecapvalue' VALUES (20435, 368, 1, 1);
INSERT INTO 'capvalue' VALUES (1694, 'OMA Forward Lock');
INSERT INTO 'devicecapvalue' VALUES (20436, 368, 173, 1694);
INSERT INTO 'devicecapvalue' VALUES (20437, 368, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (20438, 368, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (20439, 368, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (20440, 368, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (20441, 368, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (20442, 368, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (20443, 368, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (20444, 368, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20445, 368, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20446, 368, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20447, 368, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (20448, 368, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (20449, 368, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (20450, 368, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20451, 368, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (20452, 368, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (20453, 368, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20454, 368, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (20455, 368, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20456, 368, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (20457, 368, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20458, 368, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20459, 368, 51, 1689);
INSERT INTO 'devicecapvalue' VALUES (20460, 368, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20461, 368, 51, 1690);
INSERT INTO 'capvalue' VALUES (1695, '519168');
INSERT INTO 'devicecapvalue' VALUES (20462, 368, 52, 1695);
INSERT INTO 'devicecapvalue' VALUES (20463, 368, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20464, 368, 157, 1134);
INSERT INTO 'capvalue' VALUES (1696, 'Nokia6030/2.0 (y3.41) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (20465, 368, 53, 1696);
INSERT INTO 'capvalue' VALUES (1697, '2005-06-14');
INSERT INTO 'devicecapvalue' VALUES (20466, 369, 158, 1697);
INSERT INTO 'devicecapvalue' VALUES (20467, 369, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (20468, 369, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (20469, 369, 75, 1492);
INSERT INTO 'devicecapvalue' VALUES (20470, 369, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (20471, 369, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (20472, 369, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (20473, 369, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (20474, 369, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (20475, 369, 76, 1457);
INSERT INTO 'devicecapvalue' VALUES (20476, 369, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (20477, 369, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (20478, 369, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20479, 369, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20480, 369, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (20481, 369, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20482, 369, 6, 27);
INSERT INTO 'capvalue' VALUES (1698, '140288');
INSERT INTO 'devicecapvalue' VALUES (20483, 369, 50, 1698);
INSERT INTO 'devicecapvalue' VALUES (20484, 369, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (20485, 369, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (20486, 369, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20487, 369, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (20488, 369, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (20489, 369, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (20490, 369, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (20491, 369, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20492, 369, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20493, 369, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (20494, 369, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20495, 369, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20496, 369, 51, 1689);
INSERT INTO 'devicecapvalue' VALUES (20497, 369, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (20498, 369, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20499, 369, 51, 1690);
INSERT INTO 'devicecapvalue' VALUES (20500, 369, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (20501, 369, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (20502, 369, 52, 1337);
INSERT INTO 'devicecapvalue' VALUES (20503, 369, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20504, 369, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (20505, 369, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (20506, 369, 157, 1504);
INSERT INTO 'capvalue' VALUES (1699, 'Nokia6060/2.0 (k3.61) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (20507, 369, 53, 1699);
INSERT INTO 'capvalue' VALUES (1700, '2006-02-13');
INSERT INTO 'devicecapvalue' VALUES (20508, 370, 158, 1700);
INSERT INTO 'devicecapvalue' VALUES (20509, 370, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (20510, 370, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (20511, 370, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20512, 370, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (20513, 370, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (20514, 370, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (20515, 370, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (20516, 370, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20517, 370, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20518, 370, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20519, 370, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20520, 370, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (20521, 370, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20522, 370, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (20523, 370, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (20524, 370, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (20525, 370, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20526, 370, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (20527, 370, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20528, 370, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (20529, 370, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20530, 370, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (20531, 370, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20532, 370, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (20533, 370, 157, 1026);
INSERT INTO 'capvalue' VALUES (1701, 'Nokia6070/2.0 (03.20) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (20534, 370, 53, 1701);
INSERT INTO 'capvalue' VALUES (1702, '2006-06-19');
INSERT INTO 'devicecapvalue' VALUES (20535, 371, 158, 1702);
INSERT INTO 'devicecapvalue' VALUES (20536, 371, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (20537, 371, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (20538, 371, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (20539, 371, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (20540, 371, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20541, 371, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (20542, 371, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (20543, 371, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (20544, 371, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (20545, 371, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20546, 371, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20547, 371, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (20548, 371, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20549, 371, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20550, 371, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (20551, 371, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20552, 371, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (20553, 371, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (20554, 371, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (20555, 371, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (20556, 371, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20557, 371, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (20558, 371, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20559, 371, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (20560, 371, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20561, 371, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20562, 371, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (20563, 371, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20564, 371, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (20565, 371, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (20566, 371, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (20567, 371, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20568, 371, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (20569, 371, 157, 1026);
INSERT INTO 'capvalue' VALUES (1703, 'Nokia6080');
INSERT INTO 'devicecapvalue' VALUES (20570, 371, 53, 1703);
INSERT INTO 'capvalue' VALUES (1704, '2006-09-13');
INSERT INTO 'devicecapvalue' VALUES (20571, 372, 158, 1704);
INSERT INTO 'devicecapvalue' VALUES (20572, 372, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (20573, 372, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (20574, 372, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (20575, 372, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (20576, 372, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20577, 372, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (20578, 372, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (20579, 372, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (20580, 372, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (20581, 372, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20582, 372, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (20583, 372, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (20584, 372, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20585, 372, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (20586, 372, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (20587, 372, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (20588, 372, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (20589, 372, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20590, 372, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20591, 372, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (20592, 372, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20593, 372, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (20594, 372, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20595, 372, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (20596, 372, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20597, 372, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (20598, 372, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (20599, 372, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20600, 372, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (20601, 372, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (20602, 372, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (20603, 372, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20604, 372, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (20605, 372, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (20606, 372, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20607, 372, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (20608, 372, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (20609, 372, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (20610, 372, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20611, 372, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (20612, 372, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (20613, 372, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (20614, 372, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (20615, 372, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (20616, 372, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20617, 372, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (20618, 372, 157, 1026);
INSERT INTO 'capvalue' VALUES (1705, 'Nokia6085/2.0 (03.70) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (20619, 372, 53, 1705);
INSERT INTO 'devicecapvalue' VALUES (20620, 373, 158, 1420);
INSERT INTO 'devicecapvalue' VALUES (20621, 373, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (20622, 373, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (20623, 373, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (20624, 373, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (20625, 373, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20626, 373, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (20627, 373, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (20628, 373, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (20629, 373, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (20630, 373, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20631, 373, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (20632, 373, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (20633, 373, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20634, 373, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (20635, 373, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (20636, 373, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (20637, 373, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (20638, 373, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20639, 373, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20640, 373, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (20641, 373, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20642, 373, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (20643, 373, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20644, 373, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (20645, 373, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20646, 373, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (20647, 373, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (20648, 373, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20649, 373, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (20650, 373, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (20651, 373, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (20652, 373, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20653, 373, 51, 1097);
INSERT INTO 'capvalue' VALUES (1706, 'eacc');
INSERT INTO 'devicecapvalue' VALUES (20654, 373, 51, 1706);
INSERT INTO 'devicecapvalue' VALUES (20655, 373, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20656, 373, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (20657, 373, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (20658, 373, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (20659, 373, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20660, 373, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (20661, 373, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (20662, 373, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (20663, 373, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (20664, 373, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (20665, 373, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20666, 373, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (20667, 373, 157, 1026);
INSERT INTO 'capvalue' VALUES (1707, 'Nokia6086/2.0 (p03.42) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (20668, 373, 53, 1707);
INSERT INTO 'capvalue' VALUES (1708, '2005-02-14');
INSERT INTO 'devicecapvalue' VALUES (20669, 374, 158, 1708);
INSERT INTO 'devicecapvalue' VALUES (20670, 374, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (20671, 374, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (20672, 374, 162, 612);
INSERT INTO 'devicecapvalue' VALUES (20673, 374, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (20674, 374, 75, 1492);
INSERT INTO 'devicecapvalue' VALUES (20675, 374, 167, 1493);
INSERT INTO 'devicecapvalue' VALUES (20676, 374, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20677, 374, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (20678, 374, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (20679, 374, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (20680, 374, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (20681, 374, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (20682, 374, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (20683, 374, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (20684, 374, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (20685, 374, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20686, 374, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20687, 374, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (20688, 374, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20689, 374, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (20690, 374, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20691, 374, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (20692, 374, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (20693, 374, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (20694, 374, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (20695, 374, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (20696, 374, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (20697, 374, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20698, 374, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (20699, 374, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (20700, 374, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (20701, 374, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20702, 374, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20703, 374, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (20704, 374, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20705, 374, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20706, 374, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (20707, 374, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (20708, 374, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20709, 374, 51, 1552);
INSERT INTO 'devicecapvalue' VALUES (20710, 374, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (20711, 374, 52, 231);
INSERT INTO 'devicecapvalue' VALUES (20712, 374, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20713, 374, 157, 1134);
INSERT INTO 'capvalue' VALUES (1709, 'Nokia6101/2.0 (04.50) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (20714, 374, 53, 1709);
INSERT INTO 'devicecapvalue' VALUES (20715, 375, 158, 1708);
INSERT INTO 'devicecapvalue' VALUES (20716, 375, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (20717, 375, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (20718, 375, 162, 612);
INSERT INTO 'devicecapvalue' VALUES (20719, 375, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (20720, 375, 75, 1492);
INSERT INTO 'devicecapvalue' VALUES (20721, 375, 167, 1493);
INSERT INTO 'devicecapvalue' VALUES (20722, 375, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20723, 375, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (20724, 375, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (20725, 375, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (20726, 375, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (20727, 375, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (20728, 375, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (20729, 375, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (20730, 375, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (20731, 375, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20732, 375, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20733, 375, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (20734, 375, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20735, 375, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (20736, 375, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20737, 375, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (20738, 375, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (20739, 375, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (20740, 375, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (20741, 375, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (20742, 375, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (20743, 375, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20744, 375, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (20745, 375, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (20746, 375, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20747, 375, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (20748, 375, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20749, 375, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20750, 375, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (20751, 375, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (20752, 375, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20753, 375, 51, 1552);
INSERT INTO 'devicecapvalue' VALUES (20754, 375, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (20755, 375, 52, 231);
INSERT INTO 'devicecapvalue' VALUES (20756, 375, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20757, 375, 157, 1134);
INSERT INTO 'capvalue' VALUES (1710, 'Nokia6102/2.0 (03.38) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (20758, 375, 53, 1710);
INSERT INTO 'capvalue' VALUES (1711, '2006-01-05');
INSERT INTO 'devicecapvalue' VALUES (20759, 376, 158, 1711);
INSERT INTO 'devicecapvalue' VALUES (20760, 376, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (20761, 376, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (20762, 376, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (20763, 376, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (20764, 376, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20765, 376, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (20766, 376, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (20767, 376, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (20768, 376, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (20769, 376, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20770, 376, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20771, 376, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (20772, 376, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20773, 376, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (20774, 376, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20775, 376, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (20776, 376, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20777, 376, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (20778, 376, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (20779, 376, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20780, 376, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (20781, 376, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20782, 376, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20783, 376, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (20784, 376, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (20785, 376, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20786, 376, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (20787, 376, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (20788, 376, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (20789, 376, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (20790, 376, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20791, 376, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (20792, 376, 157, 1026);
INSERT INTO 'capvalue' VALUES (1712, 'Nokia6102i');
INSERT INTO 'devicecapvalue' VALUES (20793, 376, 53, 1712);
INSERT INTO 'devicecapvalue' VALUES (20794, 377, 158, 1711);
INSERT INTO 'devicecapvalue' VALUES (20795, 377, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (20796, 377, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (20797, 377, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (20798, 377, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (20799, 377, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20800, 377, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (20801, 377, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (20802, 377, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (20803, 377, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (20804, 377, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20805, 377, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20806, 377, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (20807, 377, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20808, 377, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (20809, 377, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20810, 377, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (20811, 377, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20812, 377, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (20813, 377, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (20814, 377, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (20815, 377, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20816, 377, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20817, 377, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (20818, 377, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20819, 377, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20820, 377, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (20821, 377, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (20822, 377, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20823, 377, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (20824, 377, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (20825, 377, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (20826, 377, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (20827, 377, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20828, 377, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (20829, 377, 157, 1026);
INSERT INTO 'capvalue' VALUES (1713, 'Nokia6103/2.0 (04.61) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (20830, 377, 53, 1713);
INSERT INTO 'capvalue' VALUES (1714, '2007-02-12');
INSERT INTO 'devicecapvalue' VALUES (20831, 378, 158, 1714);
INSERT INTO 'devicecapvalue' VALUES (20832, 378, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (20833, 378, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (20834, 378, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (20835, 378, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (20836, 378, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (20837, 378, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20838, 378, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (20839, 378, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (20840, 378, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (20841, 378, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (20842, 378, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (20843, 378, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (20844, 378, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20845, 378, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (20846, 378, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (20847, 378, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (20848, 378, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20849, 378, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (20850, 378, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (20851, 378, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (20852, 378, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (20853, 378, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (20854, 378, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20855, 378, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (20856, 378, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20857, 378, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (20858, 378, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (20859, 378, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (20860, 378, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (20861, 378, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20862, 378, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (20863, 378, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (20864, 378, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (20865, 378, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (20866, 378, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (20867, 378, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (20868, 378, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (20869, 378, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (20870, 378, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (20871, 378, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (20872, 378, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20873, 378, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (20874, 378, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (20875, 378, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (20876, 378, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20877, 378, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (20878, 378, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (20879, 378, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (20880, 378, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20881, 378, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (20882, 378, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (20883, 378, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (20884, 378, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (20885, 378, 51, 1041);
INSERT INTO 'capvalue' VALUES (1715, '41943040');
INSERT INTO 'devicecapvalue' VALUES (20886, 378, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (20887, 378, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20888, 378, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (20889, 378, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (20890, 378, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (20891, 379, 158, 1714);
INSERT INTO 'devicecapvalue' VALUES (20892, 379, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (20893, 379, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (20894, 379, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (20895, 379, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (20896, 379, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (20897, 379, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20898, 379, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (20899, 379, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (20900, 379, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (20901, 379, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (20902, 379, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (20903, 379, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (20904, 379, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20905, 379, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (20906, 379, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (20907, 379, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (20908, 379, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20909, 379, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (20910, 379, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (20911, 379, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (20912, 379, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (20913, 379, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (20914, 379, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20915, 379, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (20916, 379, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20917, 379, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (20918, 379, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (20919, 379, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (20920, 379, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (20921, 379, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (20922, 379, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (20923, 379, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (20924, 379, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (20925, 379, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (20926, 379, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (20927, 379, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (20928, 379, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (20929, 379, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (20930, 379, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (20931, 379, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (20932, 379, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20933, 379, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (20934, 379, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (20935, 379, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (20936, 379, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20937, 379, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (20938, 379, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (20939, 379, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (20940, 379, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20941, 379, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (20942, 379, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (20943, 379, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (20944, 379, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (20945, 379, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (20946, 379, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (20947, 379, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20948, 379, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (20949, 379, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (20950, 379, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (20951, 380, 158, 1697);
INSERT INTO 'devicecapvalue' VALUES (20952, 380, 1, 106);
INSERT INTO 'capvalue' VALUES (1716, '1 MP');
INSERT INTO 'devicecapvalue' VALUES (20953, 380, 160, 1716);
INSERT INTO 'devicecapvalue' VALUES (20954, 380, 162, 233);
INSERT INTO 'devicecapvalue' VALUES (20955, 380, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (20956, 380, 75, 1492);
INSERT INTO 'devicecapvalue' VALUES (20957, 380, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (20958, 380, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (20959, 380, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (20960, 380, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (20961, 380, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (20962, 380, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (20963, 380, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (20964, 380, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (20965, 380, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (20966, 380, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (20967, 380, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (20968, 380, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (20969, 380, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (20970, 380, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (20971, 380, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (20972, 380, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (20973, 380, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (20974, 380, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (20975, 380, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (20976, 380, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (20977, 380, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (20978, 380, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (20979, 380, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (20980, 380, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (20981, 380, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (20982, 380, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (20983, 380, 156, 1024);
INSERT INTO 'capvalue' VALUES (1717, 'Latin-America');
INSERT INTO 'devicecapvalue' VALUES (20984, 380, 156, 1717);
INSERT INTO 'devicecapvalue' VALUES (20985, 380, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (20986, 380, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (20987, 380, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (20988, 380, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (20989, 380, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (20990, 380, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (20991, 380, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (20992, 380, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (20993, 380, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (20994, 380, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (20995, 380, 51, 1085);
INSERT INTO 'capvalue' VALUES (1718, '23068672');
INSERT INTO 'devicecapvalue' VALUES (20996, 380, 52, 1718);
INSERT INTO 'devicecapvalue' VALUES (20997, 380, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (20998, 380, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (20999, 380, 157, 1026);
INSERT INTO 'capvalue' VALUES (1719, 'Nokia6111/2.0 (03.58) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (21000, 380, 53, 1719);
INSERT INTO 'capvalue' VALUES (1720, '2007-04-17');
INSERT INTO 'devicecapvalue' VALUES (21001, 381, 158, 1720);
INSERT INTO 'devicecapvalue' VALUES (21002, 381, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (21003, 381, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (21004, 381, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (21005, 381, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21006, 381, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (21007, 381, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21008, 381, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (21009, 381, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (21010, 381, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (21011, 381, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (21012, 381, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (21013, 381, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (21014, 381, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (21015, 381, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (21016, 381, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (21017, 381, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (21018, 381, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (21019, 381, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21020, 381, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (21021, 381, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (21022, 381, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (21023, 381, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21024, 381, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21025, 381, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21026, 381, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (21027, 381, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (21028, 381, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21029, 381, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21030, 381, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21031, 381, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21032, 381, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21033, 381, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (21034, 381, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (21035, 381, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (21036, 381, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (21037, 381, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (21038, 381, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (21039, 381, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (21040, 381, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (21041, 381, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21042, 381, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (21043, 381, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (21044, 381, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (21045, 381, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (21046, 381, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (21047, 381, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (21048, 381, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (21049, 381, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (21050, 381, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (21051, 381, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (21052, 381, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21053, 381, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21054, 381, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21055, 381, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (21056, 381, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21057, 381, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (21058, 381, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21059, 381, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21060, 381, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21061, 381, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21062, 381, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21063, 381, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (21064, 381, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (21065, 381, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (21066, 381, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (21067, 381, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (21068, 381, 52, 1564);
INSERT INTO 'devicecapvalue' VALUES (21069, 381, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21070, 381, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (21071, 381, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (21072, 381, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (21073, 382, 158, 1720);
INSERT INTO 'devicecapvalue' VALUES (21074, 382, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (21075, 382, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (21076, 382, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (21077, 382, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21078, 382, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (21079, 382, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21080, 382, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (21081, 382, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (21082, 382, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (21083, 382, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (21084, 382, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (21085, 382, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (21086, 382, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (21087, 382, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (21088, 382, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (21089, 382, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (21090, 382, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (21091, 382, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21092, 382, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (21093, 382, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (21094, 382, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (21095, 382, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21096, 382, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21097, 382, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21098, 382, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (21099, 382, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (21100, 382, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21101, 382, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21102, 382, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21103, 382, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21104, 382, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21105, 382, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (21106, 382, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (21107, 382, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (21108, 382, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (21109, 382, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (21110, 382, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (21111, 382, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (21112, 382, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (21113, 382, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21114, 382, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (21115, 382, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (21116, 382, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (21117, 382, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (21118, 382, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (21119, 382, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (21120, 382, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (21121, 382, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (21122, 382, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (21123, 382, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (21124, 382, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21125, 382, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21126, 382, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21127, 382, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (21128, 382, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21129, 382, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (21130, 382, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21131, 382, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21132, 382, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21133, 382, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21134, 382, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21135, 382, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (21136, 382, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (21137, 382, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (21138, 382, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (21139, 382, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (21140, 382, 52, 1564);
INSERT INTO 'devicecapvalue' VALUES (21141, 382, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21142, 382, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (21143, 382, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (21144, 382, 157, 1504);
INSERT INTO 'capvalue' VALUES (1721, '2006-01-16');
INSERT INTO 'devicecapvalue' VALUES (21145, 383, 158, 1721);
INSERT INTO 'devicecapvalue' VALUES (21146, 383, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (21147, 383, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (21148, 383, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21149, 383, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21150, 383, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (21151, 383, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (21152, 383, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (21153, 383, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (21154, 383, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (21155, 383, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (21156, 383, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (21157, 383, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (21158, 383, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (21159, 383, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21160, 383, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (21161, 383, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21162, 383, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21163, 383, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21164, 383, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21165, 383, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21166, 383, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21167, 383, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21168, 383, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21169, 383, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21170, 383, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (21171, 383, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (21172, 383, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (21173, 383, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (21174, 383, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (21175, 383, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (21176, 383, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (21177, 383, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (21178, 383, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (21179, 383, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (21180, 383, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (21181, 383, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (21182, 383, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21183, 383, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21184, 383, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21185, 383, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (21186, 383, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21187, 383, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21188, 383, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21189, 383, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21190, 383, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21191, 383, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21192, 383, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (21193, 383, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (21194, 383, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (21195, 383, 52, 1350);
INSERT INTO 'devicecapvalue' VALUES (21196, 383, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21197, 383, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21198, 383, 157, 1026);
INSERT INTO 'capvalue' VALUES (1722, 'Nokia6125/2.0 (03.71) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (21199, 383, 53, 1722);
INSERT INTO 'devicecapvalue' VALUES (21200, 384, 158, 1463);
INSERT INTO 'devicecapvalue' VALUES (21201, 384, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (21202, 384, 160, 1541);
INSERT INTO 'devicecapvalue' VALUES (21203, 384, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (21204, 384, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21205, 384, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21206, 384, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (21207, 384, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (21208, 384, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (21209, 384, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (21210, 384, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21211, 384, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (21212, 384, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21213, 384, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21214, 384, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21215, 384, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21216, 384, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21217, 384, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21218, 384, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21219, 384, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21220, 384, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21221, 384, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (21222, 384, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (21223, 384, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (21224, 384, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (21225, 384, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (21226, 384, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (21227, 384, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21228, 384, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21229, 384, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21230, 384, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (21231, 384, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21232, 384, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21233, 384, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21234, 384, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21235, 384, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21236, 384, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21237, 384, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (21238, 384, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (21239, 384, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21240, 384, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21241, 384, 157, 1026);
INSERT INTO 'capvalue' VALUES (1723, 'Nokia6126/2.0 (05.61) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (21242, 384, 53, 1723);
INSERT INTO 'devicecapvalue' VALUES (21243, 385, 158, 1700);
INSERT INTO 'devicecapvalue' VALUES (21244, 385, 1, 649);
INSERT INTO 'capvalue' VALUES (1724, '1280x960');
INSERT INTO 'devicecapvalue' VALUES (21245, 385, 160, 1724);
INSERT INTO 'devicecapvalue' VALUES (21246, 385, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21247, 385, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21248, 385, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (21249, 385, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (21250, 385, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (21251, 385, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (21252, 385, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21253, 385, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (21254, 385, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21255, 385, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21256, 385, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21257, 385, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21258, 385, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21259, 385, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21260, 385, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21261, 385, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21262, 385, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21263, 385, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (21264, 385, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (21265, 385, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (21266, 385, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (21267, 385, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21268, 385, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (21269, 385, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (21270, 385, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (21271, 385, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (21272, 385, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (21273, 385, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21274, 385, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21275, 385, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21276, 385, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (21277, 385, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21278, 385, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21279, 385, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21280, 385, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21281, 385, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21282, 385, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21283, 385, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (21284, 385, 52, 1350);
INSERT INTO 'devicecapvalue' VALUES (21285, 385, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21286, 385, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21287, 385, 157, 1026);
INSERT INTO 'capvalue' VALUES (1725, '2007-01-08');
INSERT INTO 'devicecapvalue' VALUES (21288, 386, 158, 1725);
INSERT INTO 'devicecapvalue' VALUES (21289, 386, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (21290, 386, 160, 1724);
INSERT INTO 'devicecapvalue' VALUES (21291, 386, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (21292, 386, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21293, 386, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21294, 386, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (21295, 386, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (21296, 386, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (21297, 386, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (21298, 386, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21299, 386, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (21300, 386, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21301, 386, 17, 22);
INSERT INTO 'capvalue' VALUES (1726, 'nfc');
INSERT INTO 'devicecapvalue' VALUES (21302, 386, 17, 1726);
INSERT INTO 'devicecapvalue' VALUES (21303, 386, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21304, 386, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21305, 386, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21306, 386, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21307, 386, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21308, 386, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21309, 386, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21310, 386, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (21311, 386, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (21312, 386, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (21313, 386, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21314, 386, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (21315, 386, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (21316, 386, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (21317, 386, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (21318, 386, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (21319, 386, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21320, 386, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21321, 386, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21322, 386, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21323, 386, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21324, 386, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21325, 386, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21326, 386, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21327, 386, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21328, 386, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (21329, 386, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (21330, 386, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (21331, 386, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (21332, 386, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (21333, 386, 52, 1350);
INSERT INTO 'devicecapvalue' VALUES (21334, 386, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21335, 386, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21336, 386, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (21337, 386, 157, 1026);
INSERT INTO 'capvalue' VALUES (1727, 'Nokia6131NFC');
INSERT INTO 'devicecapvalue' VALUES (21338, 386, 53, 1727);
INSERT INTO 'capvalue' VALUES (1728, '2006-10-23');
INSERT INTO 'devicecapvalue' VALUES (21339, 387, 158, 1728);
INSERT INTO 'devicecapvalue' VALUES (21340, 387, 1, 649);
INSERT INTO 'capvalue' VALUES (1729, '1024x1280');
INSERT INTO 'devicecapvalue' VALUES (21341, 387, 160, 1729);
INSERT INTO 'devicecapvalue' VALUES (21342, 387, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21343, 387, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21344, 387, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (21345, 387, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (21346, 387, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (21347, 387, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (21348, 387, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21349, 387, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (21350, 387, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21351, 387, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21352, 387, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21353, 387, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21354, 387, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21355, 387, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21356, 387, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21357, 387, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21358, 387, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21359, 387, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (21360, 387, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (21361, 387, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (21362, 387, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (21363, 387, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (21364, 387, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (21365, 387, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21366, 387, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21367, 387, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21368, 387, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (21369, 387, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21370, 387, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21371, 387, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21372, 387, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21373, 387, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21374, 387, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21375, 387, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (21376, 387, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (21377, 387, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (21378, 387, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (21379, 387, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (21380, 387, 52, 1165);
INSERT INTO 'devicecapvalue' VALUES (21381, 387, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21382, 387, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21383, 387, 157, 1026);
INSERT INTO 'capvalue' VALUES (1730, 'Nokia6133/2.0 (05.20)');
INSERT INTO 'devicecapvalue' VALUES (21384, 387, 53, 1730);
INSERT INTO 'devicecapvalue' VALUES (21385, 388, 158, 1700);
INSERT INTO 'devicecapvalue' VALUES (21386, 388, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (21387, 388, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21388, 388, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (21389, 388, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (21390, 388, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (21391, 388, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (21392, 388, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21393, 388, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (21394, 388, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21395, 388, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21396, 388, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21397, 388, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21398, 388, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21399, 388, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21400, 388, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21401, 388, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21402, 388, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21403, 388, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (21404, 388, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (21405, 388, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (21406, 388, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (21407, 388, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (21408, 388, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (21409, 388, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (21410, 388, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21411, 388, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21412, 388, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21413, 388, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (21414, 388, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21415, 388, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21416, 388, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21417, 388, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21418, 388, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21419, 388, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21420, 388, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (21421, 388, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (21422, 388, 51, 1041);
INSERT INTO 'capvalue' VALUES (1731, '8388608');
INSERT INTO 'devicecapvalue' VALUES (21423, 388, 52, 1731);
INSERT INTO 'devicecapvalue' VALUES (21424, 388, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21425, 388, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21426, 388, 157, 1026);
INSERT INTO 'capvalue' VALUES (1732, 'Nokia6136/2.0 Profile/MIDP-1.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (21427, 388, 53, 1732);
INSERT INTO 'devicecapvalue' VALUES (21428, 389, 158, 1702);
INSERT INTO 'devicecapvalue' VALUES (21429, 389, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (21430, 389, 160, 1724);
INSERT INTO 'devicecapvalue' VALUES (21431, 389, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (21432, 389, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21433, 389, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21434, 389, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (21435, 389, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (21436, 389, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (21437, 389, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (21438, 389, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21439, 389, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (21440, 389, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21441, 389, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21442, 389, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21443, 389, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21444, 389, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21445, 389, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21446, 389, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21447, 389, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21448, 389, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21449, 389, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (21450, 389, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (21451, 389, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (21452, 389, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21453, 389, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (21454, 389, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (21455, 389, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (21456, 389, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (21457, 389, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (21458, 389, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21459, 389, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21460, 389, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21461, 389, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (21462, 389, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21463, 389, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21464, 389, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21465, 389, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21466, 389, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21467, 389, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21468, 389, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (21469, 389, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (21470, 389, 52, 1165);
INSERT INTO 'devicecapvalue' VALUES (21471, 389, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21472, 389, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21473, 389, 157, 1026);
INSERT INTO 'capvalue' VALUES (1733, 'Nokia6151/2.0 (03.56) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (21474, 389, 53, 1733);
INSERT INTO 'devicecapvalue' VALUES (21475, 390, 158, 1490);
INSERT INTO 'devicecapvalue' VALUES (21476, 390, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (21477, 390, 160, 1491);
INSERT INTO 'devicecapvalue' VALUES (21478, 390, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21479, 390, 75, 1492);
INSERT INTO 'devicecapvalue' VALUES (21480, 390, 187, 1);
INSERT INTO 'devicecapvalue' VALUES (21481, 390, 167, 1493);
INSERT INTO 'devicecapvalue' VALUES (21482, 390, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21483, 390, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (21484, 390, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (21485, 390, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (21486, 390, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (21487, 390, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (21488, 390, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (21489, 390, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21490, 390, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21491, 390, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21492, 390, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21493, 390, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21494, 390, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21495, 390, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21496, 390, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (21497, 390, 88, 1494);
INSERT INTO 'devicecapvalue' VALUES (21498, 390, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (21499, 390, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21500, 390, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (21501, 390, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (21502, 390, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (21503, 390, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (21504, 390, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (21505, 390, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21506, 390, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21507, 390, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21508, 390, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (21509, 390, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21510, 390, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21511, 390, 51, 1458);
INSERT INTO 'devicecapvalue' VALUES (21512, 390, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (21513, 390, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21514, 390, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21515, 390, 157, 1026);
INSERT INTO 'capvalue' VALUES (1734, 'Nokia6152/2.0 (05.24) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (21516, 390, 53, 1734);
INSERT INTO 'devicecapvalue' VALUES (21517, 391, 158, 1490);
INSERT INTO 'devicecapvalue' VALUES (21518, 391, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (21519, 391, 160, 1491);
INSERT INTO 'devicecapvalue' VALUES (21520, 391, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21521, 391, 75, 1492);
INSERT INTO 'devicecapvalue' VALUES (21522, 391, 187, 1);
INSERT INTO 'devicecapvalue' VALUES (21523, 391, 167, 1493);
INSERT INTO 'devicecapvalue' VALUES (21524, 391, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21525, 391, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (21526, 391, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (21527, 391, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (21528, 391, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (21529, 391, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (21530, 391, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (21531, 391, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21532, 391, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21533, 391, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21534, 391, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21535, 391, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21536, 391, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21537, 391, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21538, 391, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (21539, 391, 88, 1494);
INSERT INTO 'devicecapvalue' VALUES (21540, 391, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (21541, 391, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21542, 391, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (21543, 391, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (21544, 391, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (21545, 391, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (21546, 391, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (21547, 391, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21548, 391, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21549, 391, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21550, 391, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (21551, 391, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21552, 391, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21553, 391, 51, 1458);
INSERT INTO 'devicecapvalue' VALUES (21554, 391, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (21555, 391, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21556, 391, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21557, 391, 157, 1026);
INSERT INTO 'capvalue' VALUES (1735, 'Nokia6155/2.0 (05.24) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (21558, 391, 53, 1735);
INSERT INTO 'devicecapvalue' VALUES (21559, 392, 158, 1490);
INSERT INTO 'devicecapvalue' VALUES (21560, 392, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (21561, 392, 160, 1491);
INSERT INTO 'devicecapvalue' VALUES (21562, 392, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21563, 392, 75, 1492);
INSERT INTO 'devicecapvalue' VALUES (21564, 392, 187, 1);
INSERT INTO 'devicecapvalue' VALUES (21565, 392, 167, 1493);
INSERT INTO 'devicecapvalue' VALUES (21566, 392, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21567, 392, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (21568, 392, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (21569, 392, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (21570, 392, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (21571, 392, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (21572, 392, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (21573, 392, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21574, 392, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21575, 392, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21576, 392, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21577, 392, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21578, 392, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21579, 392, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21580, 392, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (21581, 392, 88, 1494);
INSERT INTO 'devicecapvalue' VALUES (21582, 392, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (21583, 392, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21584, 392, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (21585, 392, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (21586, 392, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (21587, 392, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (21588, 392, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (21589, 392, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21590, 392, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21591, 392, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21592, 392, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (21593, 392, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21594, 392, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21595, 392, 51, 1458);
INSERT INTO 'devicecapvalue' VALUES (21596, 392, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (21597, 392, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21598, 392, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21599, 392, 157, 1026);
INSERT INTO 'capvalue' VALUES (1736, 'Nokia6155i/2.0 (05.24) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (21600, 392, 53, 1736);
INSERT INTO 'devicecapvalue' VALUES (21601, 393, 158, 1456);
INSERT INTO 'devicecapvalue' VALUES (21602, 393, 1, 106);
INSERT INTO 'capvalue' VALUES (1737, '1.0 MP');
INSERT INTO 'devicecapvalue' VALUES (21603, 393, 160, 1737);
INSERT INTO 'devicecapvalue' VALUES (21604, 393, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21605, 393, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21606, 393, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (21607, 393, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (21608, 393, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (21609, 393, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (21610, 393, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21611, 393, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (21612, 393, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21613, 393, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21614, 393, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21615, 393, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21616, 393, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21617, 393, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21618, 393, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (21619, 393, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (21620, 393, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (21621, 393, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21622, 393, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (21623, 393, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (21624, 393, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21625, 393, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21626, 393, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21627, 393, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21628, 393, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (21629, 393, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21630, 393, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21631, 393, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21632, 393, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21633, 393, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21634, 393, 51, 1458);
INSERT INTO 'devicecapvalue' VALUES (21635, 393, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (21636, 393, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (21637, 393, 51, 1085);
INSERT INTO 'capvalue' VALUES (1738, '14680064');
INSERT INTO 'devicecapvalue' VALUES (21638, 393, 52, 1738);
INSERT INTO 'devicecapvalue' VALUES (21639, 393, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21640, 393, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21641, 393, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (21642, 393, 157, 1026);
INSERT INTO 'capvalue' VALUES (1739, 'Nokia6165');
INSERT INTO 'devicecapvalue' VALUES (21643, 393, 53, 1739);
INSERT INTO 'devicecapvalue' VALUES (21644, 394, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (21645, 394, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (21646, 394, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (21647, 394, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (21648, 394, 75, 1492);
INSERT INTO 'devicecapvalue' VALUES (21649, 394, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21650, 394, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (21651, 394, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (21652, 394, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (21653, 394, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21654, 394, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21655, 394, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21656, 394, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (21657, 394, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (21658, 394, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (21659, 394, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (21660, 394, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21661, 394, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (21662, 394, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (21663, 394, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (21664, 394, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21665, 394, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21666, 394, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (21667, 394, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21668, 394, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21669, 394, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (21670, 394, 157, 1026);
INSERT INTO 'capvalue' VALUES (1740, 'Nokia6170/2.0 (03.22) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (21671, 394, 53, 1740);
INSERT INTO 'capvalue' VALUES (1741, '2008-02-11');
INSERT INTO 'devicecapvalue' VALUES (21672, 395, 158, 1741);
INSERT INTO 'devicecapvalue' VALUES (21673, 395, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (21674, 395, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (21675, 395, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (21676, 395, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21677, 395, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (21678, 395, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21679, 395, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (21680, 395, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (21681, 395, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (21682, 395, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (21683, 395, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (21684, 395, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (21685, 395, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21686, 395, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (21687, 395, 17, 112);
INSERT INTO 'capvalue' VALUES (1742, 'eswt');
INSERT INTO 'devicecapvalue' VALUES (21688, 395, 17, 1742);
INSERT INTO 'capvalue' VALUES (1743, 'iap');
INSERT INTO 'devicecapvalue' VALUES (21689, 395, 17, 1743);
INSERT INTO 'devicecapvalue' VALUES (21690, 395, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (21691, 395, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21692, 395, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21693, 395, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21694, 395, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (21695, 395, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (21696, 395, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21697, 395, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21698, 395, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21699, 395, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21700, 395, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (21701, 395, 50, 593);
INSERT INTO 'capvalue' VALUES (1744, 'Symbian OS 9.3');
INSERT INTO 'devicecapvalue' VALUES (21702, 395, 3, 1744);
INSERT INTO 'devicecapvalue' VALUES (21703, 395, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21704, 395, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (21705, 395, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (21706, 395, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (21707, 395, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (21708, 395, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (21709, 395, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (21710, 395, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (21711, 395, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (21712, 395, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (21713, 395, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (21714, 395, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21715, 395, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21716, 395, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21717, 395, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (21718, 395, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21719, 395, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (21720, 395, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21721, 395, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21722, 395, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21723, 395, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21724, 395, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21725, 395, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (21726, 395, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (21727, 395, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (21728, 395, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (21729, 395, 51, 1041);
INSERT INTO 'capvalue' VALUES (1745, '125829120');
INSERT INTO 'devicecapvalue' VALUES (21730, 395, 52, 1745);
INSERT INTO 'devicecapvalue' VALUES (21731, 395, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21732, 395, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (21733, 395, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (21734, 395, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (21735, 396, 158, 1741);
INSERT INTO 'devicecapvalue' VALUES (21736, 396, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (21737, 396, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (21738, 396, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (21739, 396, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (21740, 396, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (21741, 396, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (21742, 396, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (21743, 396, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (21744, 396, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (21745, 396, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (21746, 396, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (21747, 396, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (21748, 396, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21749, 396, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (21750, 396, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (21751, 396, 17, 1742);
INSERT INTO 'devicecapvalue' VALUES (21752, 396, 17, 1743);
INSERT INTO 'devicecapvalue' VALUES (21753, 396, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (21754, 396, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21755, 396, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21756, 396, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (21757, 396, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (21758, 396, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (21759, 396, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21760, 396, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21761, 396, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21762, 396, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21763, 396, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (21764, 396, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (21765, 396, 3, 1744);
INSERT INTO 'devicecapvalue' VALUES (21766, 396, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (21767, 396, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (21768, 396, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (21769, 396, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (21770, 396, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (21771, 396, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (21772, 396, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (21773, 396, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (21774, 396, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (21775, 396, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (21776, 396, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (21777, 396, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (21778, 396, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (21779, 396, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (21780, 396, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (21781, 396, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (21782, 396, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (21783, 396, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (21784, 396, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (21785, 396, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (21786, 396, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (21787, 396, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (21788, 396, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (21789, 396, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (21790, 396, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (21791, 396, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (21792, 396, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (21793, 396, 52, 1745);
INSERT INTO 'devicecapvalue' VALUES (21794, 396, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (21795, 396, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (21796, 396, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (21797, 396, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (21798, 397, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (21799, 397, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (21800, 397, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (21801, 397, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (21802, 397, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (21803, 397, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (21804, 397, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (21805, 397, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (21806, 397, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (21807, 397, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (21808, 397, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (21809, 397, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (21810, 397, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (21811, 397, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (21812, 397, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21813, 397, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (21814, 397, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (21815, 397, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (21816, 397, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (21817, 397, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (21818, 397, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (21819, 397, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (21820, 397, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (21821, 397, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21822, 397, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (21823, 397, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (21824, 397, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (21825, 397, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (21826, 397, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (21827, 397, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (21828, 397, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (21829, 397, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (21830, 397, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (21831, 397, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (21832, 397, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (21833, 397, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (21834, 397, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (21835, 397, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (21836, 397, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (21837, 397, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (21838, 397, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (21839, 397, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (21840, 397, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (21841, 397, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (21842, 397, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (21843, 397, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (21844, 397, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (21845, 397, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (21846, 397, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (21847, 397, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (21848, 397, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (21849, 397, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (21850, 397, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (21851, 397, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (21852, 397, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (21853, 397, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (21854, 397, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (21855, 397, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (21856, 397, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (21857, 397, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (21858, 397, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (21859, 397, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (21860, 397, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (21861, 397, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (21862, 397, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (21863, 397, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (21864, 397, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (21865, 397, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (21866, 397, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (21867, 397, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (21868, 397, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (21869, 397, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (21870, 397, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (21871, 397, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (21872, 397, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (21873, 397, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (21874, 397, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (21875, 397, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (21876, 397, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (21877, 397, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (21878, 397, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (21879, 397, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (21880, 397, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (21881, 397, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (21882, 397, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (21883, 397, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (21884, 397, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (21885, 397, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (21886, 397, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (21887, 397, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (21888, 397, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (21889, 397, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (21890, 397, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (21891, 397, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (21892, 397, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (21893, 397, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (21894, 397, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (21895, 397, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (21896, 397, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (21897, 397, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (21898, 397, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (21899, 397, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (21900, 397, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (21901, 397, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (21902, 397, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (21903, 397, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (21904, 397, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (21905, 397, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (21906, 397, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (21907, 397, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (21908, 397, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (21909, 397, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (21910, 397, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (21911, 397, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (21912, 397, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (21913, 397, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (21914, 397, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (21915, 397, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (21916, 397, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (21917, 397, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (21918, 397, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (21919, 397, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (21920, 397, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (21921, 397, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (21922, 397, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (21923, 397, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (21924, 397, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (21925, 397, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (21926, 397, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (21927, 397, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (21928, 397, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (21929, 397, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (21930, 397, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (21931, 397, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (21932, 397, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (21933, 397, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (21934, 397, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (21935, 397, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (21936, 397, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (21937, 397, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (21938, 397, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (21939, 397, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (21940, 397, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (21941, 397, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (21942, 397, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (21943, 397, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (21944, 397, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (21945, 397, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (21946, 397, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (21947, 397, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (21948, 397, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (21949, 397, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (21950, 397, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (21951, 397, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (21952, 397, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (21953, 397, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (21954, 397, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (21955, 397, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (21956, 397, 46, 239);
INSERT INTO 'devicecapvalue' VALUES (21957, 397, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (21958, 397, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (21959, 397, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (21960, 397, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (21961, 397, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (21962, 397, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (21963, 397, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (21964, 397, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (21965, 397, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (21966, 397, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (21967, 397, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (21968, 397, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (21969, 397, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (21970, 397, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (21971, 397, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (21972, 397, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (21973, 397, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (21974, 397, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (21975, 397, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (21976, 397, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (21977, 397, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (21978, 397, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (21979, 397, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (21980, 397, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (21981, 397, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (21982, 397, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (21983, 397, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (21984, 397, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (21985, 397, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (21986, 397, 115, 49);
INSERT INTO 'capvalue' VALUES (1746, '16000');
INSERT INTO 'devicecapvalue' VALUES (21987, 397, 197, 1746);
INSERT INTO 'capvalue' VALUES (1747, '32000');
INSERT INTO 'devicecapvalue' VALUES (21988, 397, 197, 1747);
INSERT INTO 'capvalue' VALUES (1748, '48000');
INSERT INTO 'devicecapvalue' VALUES (21989, 397, 197, 1748);
INSERT INTO 'devicecapvalue' VALUES (21990, 397, 141, 238);
INSERT INTO 'devicecapvalue' VALUES (21991, 397, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (21992, 397, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (21993, 397, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (21994, 397, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (21995, 397, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (21996, 397, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (21997, 397, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (21998, 397, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (21999, 397, 125, 711);
INSERT INTO 'devicecapvalue' VALUES (22000, 397, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (22001, 397, 183, 1423);
INSERT INTO 'devicecapvalue' VALUES (22002, 397, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (22003, 397, 185, 1425);
INSERT INTO 'devicecapvalue' VALUES (22004, 397, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (22005, 397, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (22006, 397, 102, 1470);
INSERT INTO 'devicecapvalue' VALUES (22007, 397, 103, 1426);
INSERT INTO 'devicecapvalue' VALUES (22008, 397, 104, 1427);
INSERT INTO 'capvalue' VALUES (1749, 'file:///C:/predefjava/predefcollections/MIDPSysInfo_private/');
INSERT INTO 'devicecapvalue' VALUES (22009, 397, 105, 1749);
INSERT INTO 'devicecapvalue' VALUES (22010, 397, 106, 1429);
INSERT INTO 'devicecapvalue' VALUES (22011, 397, 107, 1430);
INSERT INTO 'devicecapvalue' VALUES (22012, 397, 108, 1431);
INSERT INTO 'devicecapvalue' VALUES (22013, 397, 109, 1432);
INSERT INTO 'devicecapvalue' VALUES (22014, 397, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (22015, 397, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (22016, 397, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (22017, 397, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (22018, 397, 61, 45);
INSERT INTO 'devicecapvalue' VALUES (22019, 397, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (22020, 397, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (22021, 397, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (22022, 397, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (22023, 397, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (22024, 397, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (22025, 397, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (22026, 397, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (22027, 397, 131, 922);
INSERT INTO 'devicecapvalue' VALUES (22028, 397, 67, 45);
INSERT INTO 'capvalue' VALUES (1750, 'Nokia6212 classic/05.16');
INSERT INTO 'devicecapvalue' VALUES (22029, 397, 68, 1750);
INSERT INTO 'devicecapvalue' VALUES (22030, 397, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (22031, 397, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (22032, 397, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (22033, 397, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (22034, 397, 132, 49);
INSERT INTO 'devicecapvalue' VALUES (22035, 397, 133, 53);
INSERT INTO 'devicecapvalue' VALUES (22036, 397, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (22037, 397, 86, 15);
INSERT INTO 'capvalue' VALUES (1751, 'audio3d');
INSERT INTO 'devicecapvalue' VALUES (22038, 397, 149, 1751);
INSERT INTO 'capvalue' VALUES (1752, 'music');
INSERT INTO 'devicecapvalue' VALUES (22039, 397, 149, 1752);
INSERT INTO 'devicecapvalue' VALUES (22040, 397, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (22041, 397, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (22042, 397, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (22043, 397, 136, 68);
INSERT INTO 'devicecapvalue' VALUES (22044, 397, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (22045, 397, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (22046, 397, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (22047, 397, 137, 1398);
INSERT INTO 'capvalue' VALUES (1753, 'http://mms.o2active.cz:8002');
INSERT INTO 'devicecapvalue' VALUES (22048, 397, 138, 1753);
INSERT INTO 'capvalue' VALUES (1754, '+420602909909');
INSERT INTO 'devicecapvalue' VALUES (22049, 397, 72, 1754);
INSERT INTO 'devicecapvalue' VALUES (22050, 397, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (22051, 397, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (22052, 397, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (22053, 397, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (22054, 397, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (22055, 397, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (22056, 397, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (22057, 397, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (22058, 397, 47, 1444);
INSERT INTO 'cap' VALUES (209, 'protocolresource', 1);
INSERT INTO 'devicecapvalue' VALUES (22059, 397, 209, 1440);
INSERT INTO 'devicecapvalue' VALUES (22060, 397, 209, 1395);
INSERT INTO 'devicecapvalue' VALUES (22061, 397, 209, 57);
INSERT INTO 'devicecapvalue' VALUES (22062, 397, 209, 58);
INSERT INTO 'devicecapvalue' VALUES (22063, 397, 209, 49);
INSERT INTO 'devicecapvalue' VALUES (22064, 397, 209, 50);
INSERT INTO 'devicecapvalue' VALUES (22065, 397, 209, 60);
INSERT INTO 'devicecapvalue' VALUES (22066, 397, 209, 124);
INSERT INTO 'devicecapvalue' VALUES (22067, 397, 209, 54);
INSERT INTO 'devicecapvalue' VALUES (22068, 397, 209, 126);
INSERT INTO 'devicecapvalue' VALUES (22069, 397, 209, 62);
INSERT INTO 'devicecapvalue' VALUES (22070, 397, 209, 63);
INSERT INTO 'devicecapvalue' VALUES (22071, 397, 209, 869);
INSERT INTO 'devicecapvalue' VALUES (22072, 397, 209, 886);
INSERT INTO 'devicecapvalue' VALUES (22073, 397, 209, 1441);
INSERT INTO 'devicecapvalue' VALUES (22074, 397, 209, 64);
INSERT INTO 'devicecapvalue' VALUES (22075, 397, 209, 1442);
INSERT INTO 'devicecapvalue' VALUES (22076, 397, 209, 867);
INSERT INTO 'devicecapvalue' VALUES (22077, 397, 209, 131);
INSERT INTO 'devicecapvalue' VALUES (22078, 397, 209, 132);
INSERT INTO 'devicecapvalue' VALUES (22079, 397, 209, 1255);
INSERT INTO 'devicecapvalue' VALUES (22080, 397, 209, 871);
INSERT INTO 'devicecapvalue' VALUES (22081, 397, 209, 618);
INSERT INTO 'devicecapvalue' VALUES (22082, 397, 209, 55);
INSERT INTO 'devicecapvalue' VALUES (22083, 397, 209, 51);
INSERT INTO 'devicecapvalue' VALUES (22084, 397, 209, 1396);
INSERT INTO 'devicecapvalue' VALUES (22085, 397, 209, 66);
INSERT INTO 'devicecapvalue' VALUES (22086, 397, 209, 52);
INSERT INTO 'devicecapvalue' VALUES (22087, 397, 209, 1397);
INSERT INTO 'devicecapvalue' VALUES (22088, 397, 209, 1398);
INSERT INTO 'devicecapvalue' VALUES (22089, 397, 209, 1399);
INSERT INTO 'devicecapvalue' VALUES (22090, 397, 209, 1400);
INSERT INTO 'devicecapvalue' VALUES (22091, 397, 209, 1401);
INSERT INTO 'devicecapvalue' VALUES (22092, 397, 209, 1402);
INSERT INTO 'devicecapvalue' VALUES (22093, 397, 209, 1403);
INSERT INTO 'devicecapvalue' VALUES (22094, 397, 209, 53);
INSERT INTO 'devicecapvalue' VALUES (22095, 397, 209, 1051);
INSERT INTO 'devicecapvalue' VALUES (22096, 397, 209, 67);
INSERT INTO 'devicecapvalue' VALUES (22097, 397, 209, 1444);
INSERT INTO 'devicecapvalue' VALUES (22098, 397, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (22099, 397, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (22100, 397, 49, 1031);
INSERT INTO 'capvalue' VALUES (1755, 'Nokia6212 classic/2.0 (05.16) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (22101, 397, 53, 1755);
INSERT INTO 'devicecapvalue' VALUES (22102, 398, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (22103, 398, 74, 1530);
INSERT INTO 'devicecapvalue' VALUES (22104, 398, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (22105, 398, 162, 42);
INSERT INTO 'capvalue' VALUES (1756, 'NokiaEmulator');
INSERT INTO 'devicecapvalue' VALUES (22106, 398, 93, 1756);
INSERT INTO 'capvalue' VALUES (1757, 'Nokia_6230_MIDP_Concept_SDK_Beta_0_2');
INSERT INTO 'devicecapvalue' VALUES (22107, 398, 75, 1757);
INSERT INTO 'devicecapvalue' VALUES (22108, 398, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22109, 398, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (22110, 398, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (22111, 398, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (22112, 398, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22113, 398, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22114, 398, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22115, 398, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22116, 398, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22117, 398, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22118, 398, 50, 1533);
INSERT INTO 'devicecapvalue' VALUES (22119, 398, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (22120, 398, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (22121, 398, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (22122, 398, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (22123, 398, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (22124, 398, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (22125, 398, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (22126, 398, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22127, 398, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22128, 398, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22129, 398, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22130, 398, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22131, 398, 157, 1134);
INSERT INTO 'capvalue' VALUES (1758, 'Opera/8.01 (J2ME/MIDP; Opera Mini/1.1.2292/hifi/nordic/int; Nokia 6230; en; U; ssr)');
INSERT INTO 'devicecapvalue' VALUES (22132, 398, 53, 1758);
INSERT INTO 'devicecapvalue' VALUES (22133, 399, 158, 1692);
INSERT INTO 'devicecapvalue' VALUES (22134, 399, 1, 1);
INSERT INTO 'capvalue' VALUES (1759, 'FontGetBaseline');
INSERT INTO 'devicecapvalue' VALUES (22135, 399, 74, 1759);
INSERT INTO 'capvalue' VALUES (1760, 'ImageCuttingFails');
INSERT INTO 'devicecapvalue' VALUES (22136, 399, 74, 1760);
INSERT INTO 'devicecapvalue' VALUES (22137, 399, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (22138, 399, 162, 1096);
INSERT INTO 'capvalue' VALUES (1761, '208x156');
INSERT INTO 'devicecapvalue' VALUES (22139, 399, 7, 1761);
INSERT INTO 'devicecapvalue' VALUES (22140, 399, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (22141, 399, 75, 1524);
INSERT INTO 'devicecapvalue' VALUES (22142, 399, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22143, 399, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (22144, 399, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (22145, 399, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (22146, 399, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (22147, 399, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (22148, 399, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (22149, 399, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (22150, 399, 13, 1548);
INSERT INTO 'devicecapvalue' VALUES (22151, 399, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (22152, 399, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (22153, 399, 78, 1542);
INSERT INTO 'devicecapvalue' VALUES (22154, 399, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22155, 399, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22156, 399, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22157, 399, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22158, 399, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22159, 399, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22160, 399, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22161, 399, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22162, 399, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (22163, 399, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (22164, 399, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (22165, 399, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (22166, 399, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (22167, 399, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (22168, 399, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22169, 399, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (22170, 399, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (22171, 399, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (22172, 399, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (22173, 399, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (22174, 399, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (22175, 399, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22176, 399, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22177, 399, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22178, 399, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (22179, 399, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22180, 399, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (22181, 399, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22182, 399, 51, 1552);
INSERT INTO 'devicecapvalue' VALUES (22183, 399, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (22184, 399, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22185, 399, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (22186, 399, 157, 1026);
INSERT INTO 'capvalue' VALUES (1762, 'Nokia6230i/2.0 (03.40) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (22187, 399, 53, 1762);
INSERT INTO 'capvalue' VALUES (1763, '2005-12-01');
INSERT INTO 'devicecapvalue' VALUES (22188, 400, 158, 1763);
INSERT INTO 'devicecapvalue' VALUES (22189, 400, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (22190, 400, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (22191, 400, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (22192, 400, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22193, 400, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (22194, 400, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (22195, 400, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (22196, 400, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (22197, 400, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (22198, 400, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (22199, 400, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (22200, 400, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22201, 400, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22202, 400, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22203, 400, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22204, 400, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22205, 400, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (22206, 400, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (22207, 400, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22208, 400, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22209, 400, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22210, 400, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22211, 400, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (22212, 400, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (22213, 400, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (22214, 400, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (22215, 400, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (22216, 400, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (22217, 400, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (22218, 400, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22219, 400, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (22220, 400, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (22221, 400, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (22222, 400, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (22223, 400, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (22224, 400, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (22225, 400, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (22226, 400, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22227, 400, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (22228, 400, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22229, 400, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (22230, 400, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (22231, 400, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22232, 400, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (22233, 400, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22234, 400, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (22235, 400, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22236, 400, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (22237, 400, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (22238, 400, 51, 1160);
INSERT INTO 'capvalue' VALUES (1764, '73400320');
INSERT INTO 'devicecapvalue' VALUES (22239, 400, 52, 1764);
INSERT INTO 'devicecapvalue' VALUES (22240, 400, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22241, 400, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (22242, 400, 157, 1026);
INSERT INTO 'capvalue' VALUES (1765, 'Nokia6233/2.0 (05.10) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (22243, 400, 53, 1765);
INSERT INTO 'devicecapvalue' VALUES (22244, 401, 158, 1763);
INSERT INTO 'devicecapvalue' VALUES (22245, 401, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (22246, 401, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (22247, 401, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (22248, 401, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22249, 401, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (22250, 401, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (22251, 401, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22252, 401, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22253, 401, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22254, 401, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22255, 401, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22256, 401, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (22257, 401, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (22258, 401, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22259, 401, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22260, 401, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22261, 401, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22262, 401, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (22263, 401, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22264, 401, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (22265, 401, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (22266, 401, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (22267, 401, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (22268, 401, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (22269, 401, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (22270, 401, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22271, 401, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (22272, 401, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22273, 401, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (22274, 401, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (22275, 401, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22276, 401, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (22277, 401, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22278, 401, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (22279, 401, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22280, 401, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (22281, 401, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (22282, 401, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (22283, 401, 52, 1764);
INSERT INTO 'devicecapvalue' VALUES (22284, 401, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22285, 401, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (22286, 401, 157, 1026);
INSERT INTO 'capvalue' VALUES (1766, 'Nokia6234/2.0 (05.43) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (22287, 401, 53, 1766);
INSERT INTO 'capvalue' VALUES (1767, '2004-11-16');
INSERT INTO 'devicecapvalue' VALUES (22288, 402, 158, 1767);
INSERT INTO 'devicecapvalue' VALUES (22289, 402, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (22290, 402, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (22291, 402, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (22292, 402, 150, 8);
INSERT INTO 'capvalue' VALUES (1768, '1468006');
INSERT INTO 'devicecapvalue' VALUES (22293, 402, 76, 1768);
INSERT INTO 'devicecapvalue' VALUES (22294, 402, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (22295, 402, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (22296, 402, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22297, 402, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22298, 402, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22299, 402, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22300, 402, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22301, 402, 6, 27);
INSERT INTO 'capvalue' VALUES (1769, 'CDMA1X');
INSERT INTO 'devicecapvalue' VALUES (22302, 402, 88, 1769);
INSERT INTO 'devicecapvalue' VALUES (22303, 402, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (22304, 402, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (22305, 402, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22306, 402, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (22307, 402, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (22308, 402, 156, 1271);
INSERT INTO 'devicecapvalue' VALUES (22309, 402, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (22310, 402, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (22311, 402, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (22312, 402, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22313, 402, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22314, 402, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22315, 402, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (22316, 402, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22317, 402, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22318, 402, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (22319, 402, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22320, 402, 157, 1134);
INSERT INTO 'capvalue' VALUES (1770, 'Nokia6235/2.0 (05.24) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (22321, 402, 53, 1770);
INSERT INTO 'devicecapvalue' VALUES (22322, 403, 158, 1767);
INSERT INTO 'devicecapvalue' VALUES (22323, 403, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (22324, 403, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (22325, 403, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (22326, 403, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (22327, 403, 76, 1768);
INSERT INTO 'devicecapvalue' VALUES (22328, 403, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (22329, 403, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (22330, 403, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22331, 403, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22332, 403, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22333, 403, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22334, 403, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22335, 403, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22336, 403, 88, 1769);
INSERT INTO 'devicecapvalue' VALUES (22337, 403, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (22338, 403, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (22339, 403, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22340, 403, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (22341, 403, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (22342, 403, 156, 1271);
INSERT INTO 'devicecapvalue' VALUES (22343, 403, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (22344, 403, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (22345, 403, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (22346, 403, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22347, 403, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22348, 403, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22349, 403, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (22350, 403, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22351, 403, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22352, 403, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (22353, 403, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22354, 403, 157, 1134);
INSERT INTO 'capvalue' VALUES (1771, 'Nokia6235i/2.0 (05.24) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (22355, 403, 53, 1771);
INSERT INTO 'devicecapvalue' VALUES (22356, 404, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (22357, 404, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (22358, 404, 162, 1096);
INSERT INTO 'devicecapvalue' VALUES (22359, 404, 75, 1492);
INSERT INTO 'devicecapvalue' VALUES (22360, 404, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22361, 404, 2, 657);
INSERT INTO 'capvalue' VALUES (1772, '1000448');
INSERT INTO 'devicecapvalue' VALUES (22362, 404, 76, 1772);
INSERT INTO 'devicecapvalue' VALUES (22363, 404, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (22364, 404, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (22365, 404, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22366, 404, 6, 27);
INSERT INTO 'capvalue' VALUES (1773, '400384');
INSERT INTO 'devicecapvalue' VALUES (22367, 404, 50, 1773);
INSERT INTO 'devicecapvalue' VALUES (22368, 404, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (22369, 404, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (22370, 404, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22371, 404, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22372, 404, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22373, 404, 157, 1087);
INSERT INTO 'capvalue' VALUES (1774, 'NOKIA-6256i UP.Browser/6.2.3.2 MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (22374, 404, 53, 1774);
INSERT INTO 'devicecapvalue' VALUES (22375, 405, 1, 1);
INSERT INTO 'capvalue' VALUES (1775, 'BluetoothRfcommInputStream');
INSERT INTO 'devicecapvalue' VALUES (22376, 405, 74, 1775);
INSERT INTO 'devicecapvalue' VALUES (22377, 405, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (22378, 405, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (22379, 405, 173, 1313);
INSERT INTO 'devicecapvalue' VALUES (22380, 405, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22381, 405, 76, 1731);
INSERT INTO 'devicecapvalue' VALUES (22382, 405, 77, 745);
INSERT INTO 'devicecapvalue' VALUES (22383, 405, 78, 1273);
INSERT INTO 'devicecapvalue' VALUES (22384, 405, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (22385, 405, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22386, 405, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22387, 405, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22388, 405, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22389, 405, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (22390, 405, 3, 1501);
INSERT INTO 'devicecapvalue' VALUES (22391, 405, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (22392, 405, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (22393, 405, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (22394, 405, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (22395, 405, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (22396, 405, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (22397, 405, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22398, 405, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22399, 405, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22400, 405, 51, 1502);
INSERT INTO 'devicecapvalue' VALUES (22401, 405, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22402, 405, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22403, 405, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (22404, 405, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (22405, 405, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (22406, 405, 51, 1085);
INSERT INTO 'capvalue' VALUES (1776, '4823449');
INSERT INTO 'devicecapvalue' VALUES (22407, 405, 52, 1776);
INSERT INTO 'devicecapvalue' VALUES (22408, 405, 157, 1087);
INSERT INTO 'capvalue' VALUES (1777, 'Real Media');
INSERT INTO 'devicecapvalue' VALUES (22409, 405, 157, 1777);
INSERT INTO 'devicecapvalue' VALUES (22410, 405, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (22411, 405, 157, 1026);
INSERT INTO 'capvalue' VALUES (1778, 'Nokia6260/2.0 (5.0536.0) SymbianOS/7.0s Series60/2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (22412, 405, 53, 1778);
INSERT INTO 'capvalue' VALUES (1779, '2005-06-17');
INSERT INTO 'devicecapvalue' VALUES (22413, 406, 158, 1779);
INSERT INTO 'devicecapvalue' VALUES (22414, 406, 1, 106);
INSERT INTO 'capvalue' VALUES (1780, '1152x864');
INSERT INTO 'devicecapvalue' VALUES (22415, 406, 160, 1780);
INSERT INTO 'devicecapvalue' VALUES (22416, 406, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (22417, 406, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (22418, 406, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22419, 406, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (22420, 406, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (22421, 406, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (22422, 406, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (22423, 406, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (22424, 406, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (22425, 406, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22426, 406, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22427, 406, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22428, 406, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22429, 406, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22430, 406, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22431, 406, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22432, 406, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22433, 406, 50, 1043);
INSERT INTO 'capvalue' VALUES (1781, 'CDMA');
INSERT INTO 'devicecapvalue' VALUES (22434, 406, 88, 1781);
INSERT INTO 'devicecapvalue' VALUES (22435, 406, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (22436, 406, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22437, 406, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (22438, 406, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (22439, 406, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (22440, 406, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (22441, 406, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (22442, 406, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22443, 406, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (22444, 406, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22445, 406, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (22446, 406, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (22447, 406, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22448, 406, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (22449, 406, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22450, 406, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (22451, 406, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22452, 406, 52, 1019);
INSERT INTO 'devicecapvalue' VALUES (22453, 406, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22454, 406, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (22455, 406, 157, 1026);
INSERT INTO 'capvalue' VALUES (1782, 'Nokia6265i/2.0 (HL100V1200.nep) UP.Browser/6.2.3.8 MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (22456, 406, 53, 1782);
INSERT INTO 'devicecapvalue' VALUES (22457, 407, 158, 1779);
INSERT INTO 'devicecapvalue' VALUES (22458, 407, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (22459, 407, 160, 1780);
INSERT INTO 'devicecapvalue' VALUES (22460, 407, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (22461, 407, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (22462, 407, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22463, 407, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (22464, 407, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (22465, 407, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (22466, 407, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (22467, 407, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (22468, 407, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (22469, 407, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22470, 407, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22471, 407, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22472, 407, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22473, 407, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22474, 407, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22475, 407, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22476, 407, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22477, 407, 50, 1043);
INSERT INTO 'devicecapvalue' VALUES (22478, 407, 88, 1781);
INSERT INTO 'devicecapvalue' VALUES (22479, 407, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (22480, 407, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22481, 407, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (22482, 407, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (22483, 407, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (22484, 407, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (22485, 407, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (22486, 407, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22487, 407, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (22488, 407, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22489, 407, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (22490, 407, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (22491, 407, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22492, 407, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (22493, 407, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22494, 407, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (22495, 407, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22496, 407, 52, 1019);
INSERT INTO 'devicecapvalue' VALUES (22497, 407, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22498, 407, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (22499, 407, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (22500, 407, 53, 1782);
INSERT INTO 'devicecapvalue' VALUES (22501, 408, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (22502, 408, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (22503, 408, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (22504, 408, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (22505, 408, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (22506, 408, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (22507, 408, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (22508, 408, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (22509, 408, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (22510, 408, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (22511, 408, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (22512, 408, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (22513, 408, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22514, 408, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22515, 408, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22516, 408, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (22517, 408, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22518, 408, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22519, 408, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (22520, 408, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (22521, 408, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (22522, 408, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (22523, 408, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22524, 408, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22525, 408, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22526, 408, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (22527, 408, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (22528, 408, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (22529, 408, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (22530, 408, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (22531, 408, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (22532, 408, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (22533, 408, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (22534, 408, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (22535, 408, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (22536, 408, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (22537, 408, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (22538, 408, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (22539, 408, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (22540, 408, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (22541, 408, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (22542, 408, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (22543, 408, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (22544, 408, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (22545, 408, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (22546, 408, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (22547, 408, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (22548, 408, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (22549, 408, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (22550, 408, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (22551, 408, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (22552, 408, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (22553, 408, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (22554, 408, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (22555, 408, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (22556, 408, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (22557, 408, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (22558, 408, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (22559, 408, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (22560, 408, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (22561, 408, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (22562, 408, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (22563, 408, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (22564, 408, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (22565, 408, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (22566, 408, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (22567, 408, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (22568, 408, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (22569, 408, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (22570, 408, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (22571, 408, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (22572, 408, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (22573, 408, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (22574, 408, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (22575, 408, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (22576, 408, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (22577, 408, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (22578, 408, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (22579, 408, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (22580, 408, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (22581, 408, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (22582, 408, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (22583, 408, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (22584, 408, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (22585, 408, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (22586, 408, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (22587, 408, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (22588, 408, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (22589, 408, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (22590, 408, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (22591, 408, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (22592, 408, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (22593, 408, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (22594, 408, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (22595, 408, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (22596, 408, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (22597, 408, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (22598, 408, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (22599, 408, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (22600, 408, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (22601, 408, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (22602, 408, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (22603, 408, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (22604, 408, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (22605, 408, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (22606, 408, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (22607, 408, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (22608, 408, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (22609, 408, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (22610, 408, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (22611, 408, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (22612, 408, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (22613, 408, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (22614, 408, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (22615, 408, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (22616, 408, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (22617, 408, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (22618, 408, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (22619, 408, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (22620, 408, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (22621, 408, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (22622, 408, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (22623, 408, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (22624, 408, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (22625, 408, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (22626, 408, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (22627, 408, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (22628, 408, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (22629, 408, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (22630, 408, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (22631, 408, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (22632, 408, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (22633, 408, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (22634, 408, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (22635, 408, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (22636, 408, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (22637, 408, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (22638, 408, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (22639, 408, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (22640, 408, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (22641, 408, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (22642, 408, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (22643, 408, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (22644, 408, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (22645, 408, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (22646, 408, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (22647, 408, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (22648, 408, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (22649, 408, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (22650, 408, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (22651, 408, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (22652, 408, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (22653, 408, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (22654, 408, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (22655, 408, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (22656, 408, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (22657, 408, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (22658, 408, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (22659, 408, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (22660, 408, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (22661, 408, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (22662, 408, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (22663, 408, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (22664, 408, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (22665, 408, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (22666, 408, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (22667, 408, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (22668, 408, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (22669, 408, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (22670, 408, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (22671, 408, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (22672, 408, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (22673, 408, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (22674, 408, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (22675, 408, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (22676, 408, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (22677, 408, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (22678, 408, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (22679, 408, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (22680, 408, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (22681, 408, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (22682, 408, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (22683, 408, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (22684, 408, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (22685, 408, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (22686, 408, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (22687, 408, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (22688, 408, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (22689, 408, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (22690, 408, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (22691, 408, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (22692, 408, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (22693, 408, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (22694, 408, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (22695, 408, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (22696, 408, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (22697, 408, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (22698, 408, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (22699, 408, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (22700, 408, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (22701, 408, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (22702, 408, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (22703, 408, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (22704, 408, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (22705, 408, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (22706, 408, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (22707, 408, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (22708, 408, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (22709, 408, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (22710, 408, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (22711, 408, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (22712, 408, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (22713, 408, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (22714, 408, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (22715, 408, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (22716, 408, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (22717, 408, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (22718, 408, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (22719, 408, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (22720, 408, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (22721, 408, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (22722, 408, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (22723, 408, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (22724, 408, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (22725, 408, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (22726, 408, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (22727, 408, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (22728, 408, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (22729, 408, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (22730, 408, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (22731, 408, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (22732, 408, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (22733, 408, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (22734, 408, 49, 1031);
INSERT INTO 'capvalue' VALUES (1783, 'Nokia6267/2.0 (03.25) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (22735, 408, 53, 1783);
INSERT INTO 'devicecapvalue' VALUES (22736, 409, 158, 1697);
INSERT INTO 'devicecapvalue' VALUES (22737, 409, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (22738, 409, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (22739, 409, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (22740, 409, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22741, 409, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (22742, 409, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (22743, 409, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (22744, 409, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (22745, 409, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (22746, 409, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (22747, 409, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (22748, 409, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (22749, 409, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (22750, 409, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (22751, 409, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (22752, 409, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (22753, 409, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22754, 409, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22755, 409, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22756, 409, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22757, 409, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22758, 409, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22759, 409, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22760, 409, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22761, 409, 18, 745);
INSERT INTO 'devicecapvalue' VALUES (22762, 409, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (22763, 409, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (22764, 409, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (22765, 409, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (22766, 409, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (22767, 409, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (22768, 409, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (22769, 409, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (22770, 409, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (22771, 409, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (22772, 409, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (22773, 409, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (22774, 409, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (22775, 409, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (22776, 409, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (22777, 409, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (22778, 409, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (22779, 409, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (22780, 409, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (22781, 409, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22782, 409, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (22783, 409, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (22784, 409, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (22785, 409, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (22786, 409, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (22787, 409, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (22788, 409, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (22789, 409, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22790, 409, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22791, 409, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22792, 409, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (22793, 409, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22794, 409, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (22795, 409, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22796, 409, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (22797, 409, 51, 1085);
INSERT INTO 'capvalue' VALUES (1784, '32505856');
INSERT INTO 'devicecapvalue' VALUES (22798, 409, 52, 1784);
INSERT INTO 'devicecapvalue' VALUES (22799, 409, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22800, 409, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (22801, 409, 157, 1026);
INSERT INTO 'capvalue' VALUES (1785, 'Nokia6270/2.0 (03.69) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (22802, 409, 53, 1785);
INSERT INTO 'capvalue' VALUES (1786, '2006-06-20');
INSERT INTO 'devicecapvalue' VALUES (22803, 410, 158, 1786);
INSERT INTO 'devicecapvalue' VALUES (22804, 410, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (22805, 410, 160, 1780);
INSERT INTO 'devicecapvalue' VALUES (22806, 410, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (22807, 410, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (22808, 410, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22809, 410, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (22810, 410, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (22811, 410, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (22812, 410, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (22813, 410, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22814, 410, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22815, 410, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22816, 410, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22817, 410, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22818, 410, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22819, 410, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22820, 410, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22821, 410, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (22822, 410, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22823, 410, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (22824, 410, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (22825, 410, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (22826, 410, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (22827, 410, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (22828, 410, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (22829, 410, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22830, 410, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (22831, 410, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22832, 410, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (22833, 410, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (22834, 410, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22835, 410, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (22836, 410, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22837, 410, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (22838, 410, 51, 569);
INSERT INTO 'capvalue' VALUES (1787, '22020096');
INSERT INTO 'devicecapvalue' VALUES (22839, 410, 52, 1787);
INSERT INTO 'devicecapvalue' VALUES (22840, 410, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22841, 410, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (22842, 410, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (22843, 410, 157, 1026);
INSERT INTO 'capvalue' VALUES (1788, 'Nokia6275/2.0 (BL100V0400.nep) UP.Browser/6.2.3.8 MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (22844, 410, 53, 1788);
INSERT INTO 'devicecapvalue' VALUES (22845, 411, 158, 1786);
INSERT INTO 'devicecapvalue' VALUES (22846, 411, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (22847, 411, 160, 1780);
INSERT INTO 'devicecapvalue' VALUES (22848, 411, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (22849, 411, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (22850, 411, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22851, 411, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (22852, 411, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (22853, 411, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (22854, 411, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (22855, 411, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22856, 411, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22857, 411, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (22858, 411, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22859, 411, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22860, 411, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22861, 411, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22862, 411, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22863, 411, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22864, 411, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (22865, 411, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22866, 411, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (22867, 411, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (22868, 411, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (22869, 411, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (22870, 411, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22871, 411, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (22872, 411, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22873, 411, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (22874, 411, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (22875, 411, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22876, 411, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (22877, 411, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22878, 411, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (22879, 411, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22880, 411, 52, 1787);
INSERT INTO 'devicecapvalue' VALUES (22881, 411, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22882, 411, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (22883, 411, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (22884, 411, 157, 1026);
INSERT INTO 'capvalue' VALUES (1789, 'Nokia6275i');
INSERT INTO 'devicecapvalue' VALUES (22885, 411, 53, 1789);
INSERT INTO 'capvalue' VALUES (1790, '2005-07-04');
INSERT INTO 'devicecapvalue' VALUES (22886, 412, 158, 1790);
INSERT INTO 'devicecapvalue' VALUES (22887, 412, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (22888, 412, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (22889, 412, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (22890, 412, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22891, 412, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (22892, 412, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (22893, 412, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (22894, 412, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (22895, 412, 150, 8);
INSERT INTO 'devicecapvalue' VALUES (22896, 412, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (22897, 412, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (22898, 412, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (22899, 412, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (22900, 412, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22901, 412, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22902, 412, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22903, 412, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22904, 412, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22905, 412, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (22906, 412, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22907, 412, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22908, 412, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22909, 412, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (22910, 412, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (22911, 412, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (22912, 412, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (22913, 412, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (22914, 412, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (22915, 412, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (22916, 412, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22917, 412, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (22918, 412, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (22919, 412, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (22920, 412, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (22921, 412, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (22922, 412, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (22923, 412, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (22924, 412, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22925, 412, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (22926, 412, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22927, 412, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (22928, 412, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22929, 412, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (22930, 412, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22931, 412, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (22932, 412, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22933, 412, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (22934, 412, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (22935, 412, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (22936, 412, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22937, 412, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (22938, 412, 157, 1026);
INSERT INTO 'capvalue' VALUES (1791, 'Nokia6280/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (22939, 412, 53, 1791);
INSERT INTO 'capvalue' VALUES (1792, '2005-12-02');
INSERT INTO 'devicecapvalue' VALUES (22940, 413, 158, 1792);
INSERT INTO 'devicecapvalue' VALUES (22941, 413, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (22942, 413, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (22943, 413, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (22944, 413, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22945, 413, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (22946, 413, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (22947, 413, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (22948, 413, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (22949, 413, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22950, 413, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22951, 413, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22952, 413, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22953, 413, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22954, 413, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (22955, 413, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22956, 413, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22957, 413, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22958, 413, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (22959, 413, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (22960, 413, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (22961, 413, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (22962, 413, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (22963, 413, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (22964, 413, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (22965, 413, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (22966, 413, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (22967, 413, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (22968, 413, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (22969, 413, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (22970, 413, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (22971, 413, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (22972, 413, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (22973, 413, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (22974, 413, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (22975, 413, 52, 1503);
INSERT INTO 'devicecapvalue' VALUES (22976, 413, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (22977, 413, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (22978, 413, 157, 1026);
INSERT INTO 'capvalue' VALUES (1793, 'Nokia6282/2.0 (03.54) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (22979, 413, 53, 1793);
INSERT INTO 'capvalue' VALUES (1794, '2006-09-20');
INSERT INTO 'devicecapvalue' VALUES (22980, 414, 158, 1794);
INSERT INTO 'devicecapvalue' VALUES (22981, 414, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (22982, 414, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (22983, 414, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (22984, 414, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (22985, 414, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (22986, 414, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (22987, 414, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (22988, 414, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (22989, 414, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (22990, 414, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (22991, 414, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (22992, 414, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (22993, 414, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (22994, 414, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (22995, 414, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (22996, 414, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (22997, 414, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (22998, 414, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (22999, 414, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (23000, 414, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (23001, 414, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (23002, 414, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (23003, 414, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (23004, 414, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (23005, 414, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (23006, 414, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (23007, 414, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (23008, 414, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (23009, 414, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (23010, 414, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (23011, 414, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (23012, 414, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (23013, 414, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (23014, 414, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (23015, 414, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (23016, 414, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (23017, 414, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (23018, 414, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (23019, 414, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (23020, 414, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (23021, 414, 51, 1160);
INSERT INTO 'capvalue' VALUES (1795, '530432');
INSERT INTO 'devicecapvalue' VALUES (23022, 414, 52, 1795);
INSERT INTO 'devicecapvalue' VALUES (23023, 414, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (23024, 414, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (23025, 414, 157, 1026);
INSERT INTO 'capvalue' VALUES (1796, 'Nokia6288/2.0 (06.10) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (23026, 414, 53, 1796);
INSERT INTO 'capvalue' VALUES (1797, '2006-11-08');
INSERT INTO 'devicecapvalue' VALUES (23027, 415, 158, 1797);
INSERT INTO 'devicecapvalue' VALUES (23028, 415, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (23029, 415, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (23030, 415, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (23031, 415, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (23032, 415, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (23033, 415, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (23034, 415, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (23035, 415, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (23036, 415, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (23037, 415, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (23038, 415, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (23039, 415, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (23040, 415, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (23041, 415, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (23042, 415, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (23043, 415, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (23044, 415, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (23045, 415, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (23046, 415, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (23047, 415, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (23048, 415, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (23049, 415, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (23050, 415, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23051, 415, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (23052, 415, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (23053, 415, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (23054, 415, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (23055, 415, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (23056, 415, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (23057, 415, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (23058, 415, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (23059, 415, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (23060, 415, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (23061, 415, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (23062, 415, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (23063, 415, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (23064, 415, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (23065, 415, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (23066, 415, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (23067, 415, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (23068, 415, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (23069, 415, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (23070, 415, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (23071, 415, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (23072, 415, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (23073, 415, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (23074, 415, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (23075, 415, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (23076, 415, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (23077, 415, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (23078, 415, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (23079, 415, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (23080, 415, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (23081, 415, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (23082, 415, 52, 1086);
INSERT INTO 'devicecapvalue' VALUES (23083, 415, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (23084, 415, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (23085, 415, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (23086, 415, 157, 1504);
INSERT INTO 'capvalue' VALUES (1798, 'Mozilla/5.0 (SymbianOS/9.2; U; Series60/3.1 Nokia6290/3.03; Profile/MIDP-2.0 Configuration/CLDC-1.1 ) AppleWebKit/413 (KHTML');
INSERT INTO 'devicecapvalue' VALUES (23087, 415, 53, 1798);
INSERT INTO 'capvalue' VALUES (1799, 'like Gecko) Safari/413');
INSERT INTO 'devicecapvalue' VALUES (23088, 415, 53, 1799);
INSERT INTO 'devicecapvalue' VALUES (23089, 416, 158, 1420);
INSERT INTO 'devicecapvalue' VALUES (23090, 416, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (23091, 416, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (23092, 416, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (23093, 416, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (23094, 416, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (23095, 416, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (23096, 416, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (23097, 416, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (23098, 416, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (23099, 416, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (23100, 416, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (23101, 416, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (23102, 416, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (23103, 416, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (23104, 416, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (23105, 416, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (23106, 416, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (23107, 416, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23108, 416, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23109, 416, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (23110, 416, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (23111, 416, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (23112, 416, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (23113, 416, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (23114, 416, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (23115, 416, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (23116, 416, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (23117, 416, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (23118, 416, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (23119, 416, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (23120, 416, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (23121, 416, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (23122, 416, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (23123, 416, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (23124, 416, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (23125, 416, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (23126, 416, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (23127, 416, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (23128, 416, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (23129, 416, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (23130, 416, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (23131, 416, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (23132, 416, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (23133, 416, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (23134, 416, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (23135, 416, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (23136, 416, 52, 1165);
INSERT INTO 'devicecapvalue' VALUES (23137, 416, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (23138, 416, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (23139, 416, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (23140, 416, 157, 1026);
INSERT INTO 'capvalue' VALUES (1800, 'Nokia6300/2.0 (04.70) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (23141, 416, 53, 1800);
INSERT INTO 'devicecapvalue' VALUES (23142, 417, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (23143, 417, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (23144, 417, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (23145, 417, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (23146, 417, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (23147, 417, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (23148, 417, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (23149, 417, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (23150, 417, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (23151, 417, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (23152, 417, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (23153, 417, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (23154, 417, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (23155, 417, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (23156, 417, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (23157, 417, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (23158, 417, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (23159, 417, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (23160, 417, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (23161, 417, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (23162, 417, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (23163, 417, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (23164, 417, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23165, 417, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23166, 417, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (23167, 417, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (23168, 417, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (23169, 417, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (23170, 417, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (23171, 417, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (23172, 417, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (23173, 417, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (23174, 417, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (23175, 417, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (23176, 417, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (23177, 417, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (23178, 417, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (23179, 417, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (23180, 417, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (23181, 417, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (23182, 417, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (23183, 417, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (23184, 417, 35, 45);
INSERT INTO 'capvalue' VALUES (1801, 'Nokia6301/04.61');
INSERT INTO 'devicecapvalue' VALUES (23185, 417, 36, 1801);
INSERT INTO 'devicecapvalue' VALUES (23186, 417, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (23187, 417, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (23188, 417, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (23189, 417, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (23190, 417, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (23191, 417, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (23192, 417, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (23193, 417, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (23194, 417, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (23195, 417, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (23196, 417, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (23197, 417, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (23198, 417, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (23199, 417, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (23200, 417, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (23201, 417, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (23202, 417, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (23203, 417, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (23204, 417, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (23205, 417, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (23206, 417, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (23207, 417, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (23208, 417, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (23209, 417, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (23210, 417, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (23211, 417, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (23212, 417, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (23213, 417, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (23214, 417, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (23215, 417, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (23216, 417, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (23217, 417, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (23218, 417, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (23219, 417, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (23220, 417, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (23221, 417, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (23222, 417, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (23223, 417, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (23224, 417, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (23225, 417, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (23226, 417, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (23227, 417, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (23228, 417, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (23229, 417, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (23230, 417, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (23231, 417, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (23232, 417, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (23233, 417, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (23234, 417, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (23235, 417, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (23236, 417, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (23237, 417, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (23238, 417, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (23239, 417, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (23240, 417, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (23241, 417, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (23242, 417, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (23243, 417, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (23244, 417, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (23245, 417, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (23246, 417, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (23247, 417, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (23248, 417, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (23249, 417, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (23250, 417, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (23251, 417, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (23252, 417, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (23253, 417, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (23254, 417, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (23255, 417, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (23256, 417, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (23257, 417, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (23258, 417, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (23259, 417, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (23260, 417, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (23261, 417, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (23262, 417, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (23263, 417, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (23264, 417, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (23265, 417, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (23266, 417, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (23267, 417, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (23268, 417, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (23269, 417, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (23270, 417, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (23271, 417, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (23272, 417, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (23273, 417, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (23274, 417, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (23275, 417, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (23276, 417, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (23277, 417, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (23278, 417, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (23279, 417, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (23280, 417, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (23281, 417, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (23282, 417, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (23283, 417, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (23284, 417, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (23285, 417, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (23286, 417, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (23287, 417, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (23288, 417, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (23289, 417, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (23290, 417, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (23291, 417, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (23292, 417, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (23293, 417, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (23294, 417, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (23295, 417, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (23296, 417, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (23297, 417, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (23298, 417, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (23299, 417, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (23300, 417, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (23301, 417, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (23302, 417, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (23303, 417, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (23304, 417, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (23305, 417, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (23306, 417, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (23307, 417, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (23308, 417, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (23309, 417, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (23310, 417, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (23311, 417, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (23312, 417, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (23313, 417, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (23314, 417, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (23315, 417, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (23316, 417, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (23317, 417, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (23318, 417, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (23319, 417, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (23320, 417, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (23321, 417, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (23322, 417, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (23323, 417, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (23324, 417, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (23325, 417, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (23326, 417, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (23327, 417, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (23328, 417, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (23329, 417, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (23330, 417, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (23331, 417, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (23332, 417, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (23333, 417, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (23334, 417, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (23335, 417, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (23336, 417, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (23337, 417, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (23338, 417, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (23339, 417, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (23340, 417, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (23341, 417, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (23342, 417, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (23343, 417, 49, 1031);
INSERT INTO 'capvalue' VALUES (1802, 'Nokia6301/2.0 (04.61) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (23344, 417, 53, 1802);
INSERT INTO 'devicecapvalue' VALUES (23345, 418, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (23346, 418, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (23347, 418, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (23348, 418, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (23349, 418, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (23350, 418, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (23351, 418, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (23352, 418, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (23353, 418, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (23354, 418, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (23355, 418, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (23356, 418, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (23357, 418, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (23358, 418, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (23359, 418, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (23360, 418, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (23361, 418, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (23362, 418, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (23363, 418, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (23364, 418, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (23365, 418, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (23366, 418, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (23367, 418, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (23368, 418, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23369, 418, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23370, 418, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (23371, 418, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (23372, 418, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (23373, 418, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (23374, 418, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (23375, 418, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (23376, 418, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (23377, 418, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (23378, 418, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (23379, 418, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (23380, 418, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (23381, 418, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (23382, 418, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (23383, 418, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (23384, 418, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (23385, 418, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (23386, 418, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (23387, 418, 35, 45);
INSERT INTO 'capvalue' VALUES (1803, 'Nokia6303c/08.90');
INSERT INTO 'devicecapvalue' VALUES (23388, 418, 36, 1803);
INSERT INTO 'devicecapvalue' VALUES (23389, 418, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (23390, 418, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (23391, 418, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (23392, 418, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (23393, 418, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (23394, 418, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (23395, 418, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (23396, 418, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (23397, 418, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (23398, 418, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (23399, 418, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (23400, 418, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (23401, 418, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (23402, 418, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (23403, 418, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (23404, 418, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (23405, 418, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (23406, 418, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (23407, 418, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (23408, 418, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (23409, 418, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (23410, 418, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (23411, 418, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (23412, 418, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (23413, 418, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (23414, 418, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (23415, 418, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (23416, 418, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (23417, 418, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (23418, 418, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (23419, 418, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (23420, 418, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (23421, 418, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (23422, 418, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (23423, 418, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (23424, 418, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (23425, 418, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (23426, 418, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (23427, 418, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (23428, 418, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (23429, 418, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (23430, 418, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (23431, 418, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (23432, 418, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (23433, 418, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (23434, 418, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (23435, 418, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (23436, 418, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (23437, 418, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (23438, 418, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (23439, 418, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (23440, 418, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (23441, 418, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (23442, 418, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (23443, 418, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (23444, 418, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (23445, 418, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (23446, 418, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (23447, 418, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (23448, 418, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (23449, 418, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (23450, 418, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (23451, 418, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (23452, 418, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (23453, 418, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (23454, 418, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (23455, 418, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (23456, 418, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (23457, 418, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (23458, 418, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (23459, 418, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (23460, 418, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (23461, 418, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (23462, 418, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (23463, 418, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (23464, 418, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (23465, 418, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (23466, 418, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (23467, 418, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (23468, 418, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (23469, 418, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (23470, 418, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (23471, 418, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (23472, 418, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (23473, 418, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (23474, 418, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (23475, 418, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (23476, 418, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (23477, 418, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (23478, 418, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (23479, 418, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (23480, 418, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (23481, 418, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (23482, 418, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (23483, 418, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (23484, 418, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (23485, 418, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (23486, 418, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (23487, 418, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (23488, 418, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (23489, 418, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (23490, 418, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (23491, 418, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (23492, 418, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (23493, 418, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (23494, 418, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (23495, 418, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (23496, 418, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (23497, 418, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (23498, 418, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (23499, 418, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (23500, 418, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (23501, 418, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (23502, 418, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (23503, 418, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (23504, 418, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (23505, 418, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (23506, 418, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (23507, 418, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (23508, 418, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (23509, 418, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (23510, 418, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (23511, 418, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (23512, 418, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (23513, 418, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (23514, 418, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (23515, 418, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (23516, 418, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (23517, 418, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (23518, 418, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (23519, 418, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (23520, 418, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (23521, 418, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (23522, 418, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (23523, 418, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (23524, 418, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (23525, 418, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (23526, 418, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (23527, 418, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (23528, 418, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (23529, 418, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (23530, 418, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (23531, 418, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (23532, 418, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (23533, 418, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (23534, 418, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (23535, 418, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (23536, 418, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (23537, 418, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (23538, 418, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (23539, 418, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (23540, 418, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (23541, 418, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (23542, 418, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (23543, 418, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (23544, 418, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (23545, 418, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (23546, 418, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (23547, 418, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (23548, 418, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (23549, 418, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (23550, 418, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (23551, 418, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (23552, 418, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (23553, 418, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (23554, 418, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (23555, 418, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (23556, 418, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (23557, 418, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (23558, 418, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (23559, 418, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (23560, 418, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (23561, 418, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (23562, 418, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (23563, 418, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (23564, 418, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (23565, 418, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (23566, 418, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (23567, 418, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (23568, 418, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (23569, 418, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (23570, 418, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (23571, 418, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (23572, 418, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (23573, 418, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (23574, 418, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (23575, 418, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (23576, 418, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (23577, 418, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (23578, 418, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (23579, 418, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (23580, 418, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (23581, 418, 73, 620);
INSERT INTO 'devicecapvalue' VALUES (23582, 418, 73, 622);
INSERT INTO 'devicecapvalue' VALUES (23583, 418, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (23584, 418, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (23585, 418, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (23586, 418, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (23587, 418, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (23588, 418, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (23589, 418, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (23590, 418, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (23591, 418, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (23592, 418, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (23593, 418, 49, 1031);
INSERT INTO 'devicecapvalue' VALUES (23594, 419, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (23595, 419, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (23596, 419, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (23597, 419, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (23598, 419, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (23599, 419, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (23600, 419, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (23601, 419, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (23602, 419, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (23603, 419, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (23604, 419, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (23605, 419, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (23606, 419, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (23607, 419, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (23608, 419, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (23609, 419, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (23610, 419, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (23611, 419, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (23612, 419, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (23613, 419, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (23614, 419, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (23615, 419, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (23616, 419, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (23617, 419, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (23618, 419, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (23619, 419, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (23620, 419, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (23621, 419, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (23622, 419, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (23623, 419, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (23624, 419, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (23625, 419, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23626, 419, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (23627, 419, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (23628, 419, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (23629, 419, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (23630, 419, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (23631, 419, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (23632, 419, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (23633, 419, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (23634, 419, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (23635, 419, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (23636, 419, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (23637, 419, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (23638, 419, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (23639, 419, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (23640, 419, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (23641, 419, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (23642, 419, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (23643, 419, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (23644, 419, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (23645, 419, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (23646, 419, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (23647, 419, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (23648, 419, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (23649, 419, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (23650, 419, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (23651, 419, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (23652, 419, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (23653, 419, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (23654, 419, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (23655, 419, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (23656, 419, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (23657, 419, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (23658, 419, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (23659, 420, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (23660, 420, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (23661, 420, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (23662, 420, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (23663, 420, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (23664, 420, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (23665, 420, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (23666, 420, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (23667, 420, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (23668, 420, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (23669, 420, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (23670, 420, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (23671, 420, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (23672, 420, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (23673, 420, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (23674, 420, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (23675, 420, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (23676, 420, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (23677, 420, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (23678, 420, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (23679, 420, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (23680, 420, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (23681, 420, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (23682, 420, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (23683, 420, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (23684, 420, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (23685, 420, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (23686, 420, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (23687, 420, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (23688, 420, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (23689, 420, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (23690, 420, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (23691, 420, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (23692, 420, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (23693, 420, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (23694, 420, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (23695, 420, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (23696, 420, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23697, 420, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (23698, 420, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (23699, 420, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (23700, 420, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (23701, 420, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (23702, 420, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (23703, 420, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (23704, 420, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (23705, 420, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (23706, 420, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (23707, 420, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (23708, 420, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (23709, 420, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (23710, 420, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (23711, 420, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (23712, 420, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (23713, 420, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (23714, 420, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (23715, 420, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (23716, 420, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (23717, 420, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (23718, 420, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (23719, 420, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (23720, 420, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (23721, 420, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (23722, 420, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (23723, 420, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (23724, 420, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (23725, 420, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (23726, 420, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (23727, 420, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (23728, 420, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (23729, 420, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (23730, 420, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (23731, 420, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (23732, 420, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (23733, 420, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (23734, 420, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (23735, 420, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (23736, 420, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (23737, 420, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (23738, 420, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (23739, 420, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (23740, 421, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (23741, 421, 160, 1724);
INSERT INTO 'devicecapvalue' VALUES (23742, 421, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (23743, 421, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (23744, 421, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (23745, 421, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (23746, 421, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (23747, 421, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (23748, 421, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (23749, 421, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (23750, 421, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (23751, 421, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (23752, 421, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (23753, 421, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (23754, 421, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (23755, 421, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (23756, 421, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (23757, 421, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (23758, 421, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (23759, 421, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (23760, 421, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (23761, 421, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (23762, 421, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (23763, 421, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (23764, 421, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (23765, 421, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (23766, 421, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (23767, 421, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (23768, 421, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (23769, 421, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (23770, 421, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (23771, 421, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23772, 421, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (23773, 421, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (23774, 421, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (23775, 421, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (23776, 421, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (23777, 421, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (23778, 421, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (23779, 421, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (23780, 421, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (23781, 421, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (23782, 421, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (23783, 421, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (23784, 421, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (23785, 421, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (23786, 421, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (23787, 421, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (23788, 421, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (23789, 421, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (23790, 421, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (23791, 421, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (23792, 421, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (23793, 421, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (23794, 421, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (23795, 421, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (23796, 421, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (23797, 421, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (23798, 421, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (23799, 421, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (23800, 421, 52, 1511);
INSERT INTO 'devicecapvalue' VALUES (23801, 421, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (23802, 421, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (23803, 421, 157, 1026);
INSERT INTO 'capvalue' VALUES (1804, 'Nokia6555b/2.0 (gr3.21) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (23804, 421, 53, 1804);
INSERT INTO 'devicecapvalue' VALUES (23805, 422, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (23806, 422, 74, 1775);
INSERT INTO 'devicecapvalue' VALUES (23807, 422, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (23808, 422, 162, 233);
INSERT INTO 'devicecapvalue' VALUES (23809, 422, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (23810, 422, 10, 663);
INSERT INTO 'devicecapvalue' VALUES (23811, 422, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (23812, 422, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (23813, 422, 76, 1337);
INSERT INTO 'devicecapvalue' VALUES (23814, 422, 77, 745);
INSERT INTO 'devicecapvalue' VALUES (23815, 422, 78, 1273);
INSERT INTO 'devicecapvalue' VALUES (23816, 422, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (23817, 422, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (23818, 422, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (23819, 422, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23820, 422, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (23821, 422, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (23822, 422, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (23823, 422, 3, 1501);
INSERT INTO 'devicecapvalue' VALUES (23824, 422, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (23825, 422, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (23826, 422, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (23827, 422, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (23828, 422, 51, 1418);
INSERT INTO 'capvalue' VALUES (1805, 'true tones');
INSERT INTO 'devicecapvalue' VALUES (23829, 422, 51, 1805);
INSERT INTO 'devicecapvalue' VALUES (23830, 422, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (23831, 422, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (23832, 422, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (23833, 422, 157, 1504);
INSERT INTO 'capvalue' VALUES (1806, 'Mozilla/4.1 (compatible; MSIE 6.0; Symbian OS; Nokia 6600; 693) Opera 7.50 [EN]');
INSERT INTO 'devicecapvalue' VALUES (23834, 422, 53, 1806);
INSERT INTO 'devicecapvalue' VALUES (23835, 423, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (23836, 423, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (23837, 423, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (23838, 423, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (23839, 423, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (23840, 423, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (23841, 423, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (23842, 423, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (23843, 423, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (23844, 423, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (23845, 423, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (23846, 423, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (23847, 423, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (23848, 423, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (23849, 423, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (23850, 423, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (23851, 423, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (23852, 423, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (23853, 423, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (23854, 423, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (23855, 423, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (23856, 423, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (23857, 423, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23858, 423, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (23859, 423, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (23860, 423, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (23861, 423, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (23862, 423, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (23863, 423, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (23864, 423, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (23865, 423, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (23866, 423, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (23867, 423, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (23868, 423, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (23869, 423, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (23870, 423, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (23871, 423, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (23872, 423, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (23873, 423, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (23874, 423, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (23875, 423, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (23876, 423, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (23877, 423, 35, 45);
INSERT INTO 'capvalue' VALUES (1807, 'Nokia6600f/05.60');
INSERT INTO 'devicecapvalue' VALUES (23878, 423, 36, 1807);
INSERT INTO 'devicecapvalue' VALUES (23879, 423, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (23880, 423, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (23881, 423, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (23882, 423, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (23883, 423, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (23884, 423, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (23885, 423, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (23886, 423, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (23887, 423, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (23888, 423, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (23889, 423, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (23890, 423, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (23891, 423, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (23892, 423, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (23893, 423, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (23894, 423, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (23895, 423, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (23896, 423, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (23897, 423, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (23898, 423, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (23899, 423, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (23900, 423, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (23901, 423, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (23902, 423, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (23903, 423, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (23904, 423, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (23905, 423, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (23906, 423, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (23907, 423, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (23908, 423, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (23909, 423, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (23910, 423, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (23911, 423, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (23912, 423, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (23913, 423, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (23914, 423, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (23915, 423, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (23916, 423, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (23917, 423, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (23918, 423, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (23919, 423, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (23920, 423, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (23921, 423, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (23922, 423, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (23923, 423, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (23924, 423, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (23925, 423, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (23926, 423, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (23927, 423, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (23928, 423, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (23929, 423, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (23930, 423, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (23931, 423, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (23932, 423, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (23933, 423, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (23934, 423, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (23935, 423, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (23936, 423, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (23937, 423, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (23938, 423, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (23939, 423, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (23940, 423, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (23941, 423, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (23942, 423, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (23943, 423, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (23944, 423, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (23945, 423, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (23946, 423, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (23947, 423, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (23948, 423, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (23949, 423, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (23950, 423, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (23951, 423, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (23952, 423, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (23953, 423, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (23954, 423, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (23955, 423, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (23956, 423, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (23957, 423, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (23958, 423, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (23959, 423, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (23960, 423, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (23961, 423, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (23962, 423, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (23963, 423, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (23964, 423, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (23965, 423, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (23966, 423, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (23967, 423, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (23968, 423, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (23969, 423, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (23970, 423, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (23971, 423, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (23972, 423, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (23973, 423, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (23974, 423, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (23975, 423, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (23976, 423, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (23977, 423, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (23978, 423, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (23979, 423, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (23980, 423, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (23981, 423, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (23982, 423, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (23983, 423, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (23984, 423, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (23985, 423, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (23986, 423, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (23987, 423, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (23988, 423, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (23989, 423, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (23990, 423, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (23991, 423, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (23992, 423, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (23993, 423, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (23994, 423, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (23995, 423, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (23996, 423, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (23997, 423, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (23998, 423, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (23999, 423, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (24000, 423, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (24001, 423, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (24002, 423, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (24003, 423, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (24004, 423, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (24005, 423, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (24006, 423, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (24007, 423, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (24008, 423, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (24009, 423, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (24010, 423, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (24011, 423, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (24012, 423, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (24013, 423, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (24014, 423, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (24015, 423, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (24016, 423, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (24017, 423, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (24018, 423, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (24019, 423, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (24020, 423, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (24021, 423, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (24022, 423, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (24023, 423, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (24024, 423, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (24025, 423, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (24026, 423, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (24027, 423, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (24028, 423, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (24029, 423, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (24030, 423, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (24031, 423, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (24032, 423, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (24033, 423, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (24034, 423, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (24035, 423, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (24036, 423, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (24037, 423, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (24038, 423, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (24039, 423, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (24040, 423, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (24041, 423, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (24042, 423, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (24043, 423, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (24044, 423, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (24045, 423, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (24046, 423, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (24047, 423, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (24048, 423, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (24049, 423, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (24050, 423, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (24051, 423, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (24052, 423, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (24053, 423, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (24054, 423, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (24055, 423, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (24056, 423, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (24057, 423, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (24058, 423, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (24059, 423, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (24060, 423, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (24061, 423, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (24062, 423, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (24063, 423, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (24064, 423, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (24065, 423, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (24066, 423, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (24067, 423, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (24068, 423, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (24069, 423, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (24070, 423, 73, 620);
INSERT INTO 'devicecapvalue' VALUES (24071, 423, 73, 622);
INSERT INTO 'devicecapvalue' VALUES (24072, 423, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (24073, 423, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (24074, 423, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (24075, 423, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (24076, 423, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (24077, 423, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (24078, 423, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (24079, 423, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (24080, 423, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (24081, 423, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (24082, 423, 49, 1031);
INSERT INTO 'capvalue' VALUES (1808, 'Nokia6600f/2.0 (05.60) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (24083, 423, 53, 1808);
INSERT INTO 'devicecapvalue' VALUES (24084, 424, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (24085, 424, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (24086, 424, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (24087, 424, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (24088, 424, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (24089, 424, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (24090, 424, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (24091, 424, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (24092, 424, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (24093, 424, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (24094, 424, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (24095, 424, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (24096, 424, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (24097, 424, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (24098, 424, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (24099, 424, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (24100, 424, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (24101, 424, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (24102, 424, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (24103, 424, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (24104, 424, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (24105, 424, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (24106, 424, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24107, 424, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24108, 424, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (24109, 424, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (24110, 424, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (24111, 424, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (24112, 424, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (24113, 424, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (24114, 424, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (24115, 424, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (24116, 424, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (24117, 424, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (24118, 424, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (24119, 424, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (24120, 424, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (24121, 424, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (24122, 424, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (24123, 424, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (24124, 424, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (24125, 424, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (24126, 424, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (24127, 424, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (24128, 424, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (24129, 424, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (24130, 424, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (24131, 424, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (24132, 424, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (24133, 424, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (24134, 424, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (24135, 424, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (24136, 424, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (24137, 424, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (24138, 424, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (24139, 424, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (24140, 424, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (24141, 424, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (24142, 424, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (24143, 424, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (24144, 424, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (24145, 424, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (24146, 424, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (24147, 424, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (24148, 424, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (24149, 424, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (24150, 424, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (24151, 424, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (24152, 424, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (24153, 424, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (24154, 424, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (24155, 424, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (24156, 424, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (24157, 424, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (24158, 424, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (24159, 424, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (24160, 424, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (24161, 424, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (24162, 424, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (24163, 424, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (24164, 424, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (24165, 424, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (24166, 424, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (24167, 424, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (24168, 424, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (24169, 424, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (24170, 424, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (24171, 424, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (24172, 424, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (24173, 424, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (24174, 424, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (24175, 424, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (24176, 424, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (24177, 424, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (24178, 424, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (24179, 424, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (24180, 424, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (24181, 424, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (24182, 424, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (24183, 424, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (24184, 424, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (24185, 424, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (24186, 424, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (24187, 424, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (24188, 424, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (24189, 424, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (24190, 424, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (24191, 424, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (24192, 424, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (24193, 424, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (24194, 424, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (24195, 424, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (24196, 424, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (24197, 424, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (24198, 424, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (24199, 424, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (24200, 424, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (24201, 424, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (24202, 424, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (24203, 424, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (24204, 424, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (24205, 424, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (24206, 424, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (24207, 424, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (24208, 424, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (24209, 424, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (24210, 424, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (24211, 424, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (24212, 424, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (24213, 424, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (24214, 424, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (24215, 424, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (24216, 424, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (24217, 424, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (24218, 424, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (24219, 424, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (24220, 424, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (24221, 424, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (24222, 424, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (24223, 424, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (24224, 424, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (24225, 424, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (24226, 424, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (24227, 424, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (24228, 424, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (24229, 424, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (24230, 424, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (24231, 424, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (24232, 424, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (24233, 424, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (24234, 424, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (24235, 424, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (24236, 424, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (24237, 424, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (24238, 424, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (24239, 424, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (24240, 424, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (24241, 424, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (24242, 424, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (24243, 424, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (24244, 424, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (24245, 424, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (24246, 424, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (24247, 424, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (24248, 424, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (24249, 424, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (24250, 424, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (24251, 424, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (24252, 424, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (24253, 424, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (24254, 424, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (24255, 424, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (24256, 424, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (24257, 424, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (24258, 424, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (24259, 424, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (24260, 424, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (24261, 424, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (24262, 424, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (24263, 424, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (24264, 424, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (24265, 424, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (24266, 424, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (24267, 424, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (24268, 424, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (24269, 424, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (24270, 424, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (24271, 424, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (24272, 424, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (24273, 424, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (24274, 424, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (24275, 424, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (24276, 424, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (24277, 424, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (24278, 424, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (24279, 424, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (24280, 424, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (24281, 424, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (24282, 424, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (24283, 424, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (24284, 424, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (24285, 424, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (24286, 424, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (24287, 424, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (24288, 424, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (24289, 424, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (24290, 424, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (24291, 424, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (24292, 424, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (24293, 424, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (24294, 424, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (24295, 424, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (24296, 424, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (24297, 424, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (24298, 424, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (24299, 424, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (24300, 424, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (24301, 424, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (24302, 424, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (24303, 424, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (24304, 424, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (24305, 424, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (24306, 424, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (24307, 424, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (24308, 424, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (24309, 424, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (24310, 424, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (24311, 424, 73, 620);
INSERT INTO 'devicecapvalue' VALUES (24312, 424, 73, 622);
INSERT INTO 'devicecapvalue' VALUES (24313, 424, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (24314, 424, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (24315, 424, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (24316, 424, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (24317, 424, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (24318, 424, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (24319, 424, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (24320, 424, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (24321, 424, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (24322, 424, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (24323, 424, 49, 1031);
INSERT INTO 'capvalue' VALUES (1809, 'Nokia6600s/2.0 (05.23) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (24324, 424, 53, 1809);
INSERT INTO 'devicecapvalue' VALUES (24325, 425, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (24326, 425, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (24327, 425, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (24328, 425, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (24329, 425, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (24330, 425, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (24331, 425, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (24332, 425, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (24333, 425, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (24334, 425, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (24335, 425, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (24336, 425, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (24337, 425, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (24338, 425, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (24339, 425, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (24340, 425, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (24341, 425, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (24342, 425, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (24343, 425, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (24344, 425, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (24345, 425, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (24346, 425, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (24347, 425, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24348, 425, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24349, 425, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (24350, 425, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (24351, 425, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (24352, 425, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (24353, 425, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (24354, 425, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (24355, 425, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (24356, 425, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (24357, 425, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (24358, 425, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (24359, 425, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (24360, 425, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (24361, 425, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (24362, 425, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (24363, 425, 35, 45);
INSERT INTO 'capvalue' VALUES (1810, 'Nokia6600i-1c/36.16');
INSERT INTO 'devicecapvalue' VALUES (24364, 425, 36, 1810);
INSERT INTO 'devicecapvalue' VALUES (24365, 425, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (24366, 425, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (24367, 425, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (24368, 425, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (24369, 425, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (24370, 425, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (24371, 425, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (24372, 425, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (24373, 425, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (24374, 425, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (24375, 425, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (24376, 425, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (24377, 425, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (24378, 425, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (24379, 425, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (24380, 425, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (24381, 425, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (24382, 425, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (24383, 425, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (24384, 425, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (24385, 425, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (24386, 425, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (24387, 425, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (24388, 425, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (24389, 425, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (24390, 425, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (24391, 425, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (24392, 425, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (24393, 425, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (24394, 425, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (24395, 425, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (24396, 425, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (24397, 425, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (24398, 425, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (24399, 425, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (24400, 425, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (24401, 425, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (24402, 425, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (24403, 425, 41, 1443);
INSERT INTO 'devicecapvalue' VALUES (24404, 425, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (24405, 425, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (24406, 425, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (24407, 425, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (24408, 425, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (24409, 425, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (24410, 425, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (24411, 425, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (24412, 425, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (24413, 425, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (24414, 425, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (24415, 425, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (24416, 425, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (24417, 425, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (24418, 425, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (24419, 425, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (24420, 425, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (24421, 425, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (24422, 425, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (24423, 425, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (24424, 425, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (24425, 425, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (24426, 425, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (24427, 425, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (24428, 425, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (24429, 425, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (24430, 425, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (24431, 425, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (24432, 425, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (24433, 425, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (24434, 425, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (24435, 425, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (24436, 425, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (24437, 425, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (24438, 425, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (24439, 425, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (24440, 425, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (24441, 425, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (24442, 425, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (24443, 425, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (24444, 425, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (24445, 425, 42, 1443);
INSERT INTO 'devicecapvalue' VALUES (24446, 425, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (24447, 425, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (24448, 425, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (24449, 425, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (24450, 425, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (24451, 425, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (24452, 425, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (24453, 425, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (24454, 425, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (24455, 425, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (24456, 425, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (24457, 425, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (24458, 425, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (24459, 425, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (24460, 425, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (24461, 425, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (24462, 425, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (24463, 425, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (24464, 425, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (24465, 425, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (24466, 425, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (24467, 425, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (24468, 425, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (24469, 425, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (24470, 425, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (24471, 425, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (24472, 425, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (24473, 425, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (24474, 425, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (24475, 425, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (24476, 425, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (24477, 425, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (24478, 425, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (24479, 425, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (24480, 425, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (24481, 425, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (24482, 425, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (24483, 425, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (24484, 425, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (24485, 425, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (24486, 425, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (24487, 425, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (24488, 425, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (24489, 425, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (24490, 425, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (24491, 425, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (24492, 425, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (24493, 425, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (24494, 425, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (24495, 425, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (24496, 425, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (24497, 425, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (24498, 425, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (24499, 425, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (24500, 425, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (24501, 425, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (24502, 425, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (24503, 425, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (24504, 425, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (24505, 425, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (24506, 425, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (24507, 425, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (24508, 425, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (24509, 425, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (24510, 425, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (24511, 425, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (24512, 425, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (24513, 425, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (24514, 425, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (24515, 425, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (24516, 425, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (24517, 425, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (24518, 425, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (24519, 425, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (24520, 425, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (24521, 425, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (24522, 425, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (24523, 425, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (24524, 425, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (24525, 425, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (24526, 425, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (24527, 425, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (24528, 425, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (24529, 425, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (24530, 425, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (24531, 425, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (24532, 425, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (24533, 425, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (24534, 425, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (24535, 425, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (24536, 425, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (24537, 425, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (24538, 425, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (24539, 425, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (24540, 425, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (24541, 425, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (24542, 425, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (24543, 425, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (24544, 425, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (24545, 425, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (24546, 425, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (24547, 425, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (24548, 425, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (24549, 425, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (24550, 425, 73, 1443);
INSERT INTO 'devicecapvalue' VALUES (24551, 425, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (24552, 425, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (24553, 425, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (24554, 425, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (24555, 425, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (24556, 425, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (24557, 425, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (24558, 425, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (24559, 425, 73, 620);
INSERT INTO 'devicecapvalue' VALUES (24560, 425, 73, 622);
INSERT INTO 'devicecapvalue' VALUES (24561, 425, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (24562, 425, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (24563, 425, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (24564, 425, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (24565, 425, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (24566, 425, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (24567, 425, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (24568, 425, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (24569, 425, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (24570, 425, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (24571, 425, 49, 1031);
INSERT INTO 'capvalue' VALUES (1811, 'Nokia6600i-1c/2.0 (36.16) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (24572, 425, 53, 1811);
INSERT INTO 'devicecapvalue' VALUES (24573, 426, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (24574, 426, 74, 1775);
INSERT INTO 'devicecapvalue' VALUES (24575, 426, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (24576, 426, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (24577, 426, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (24578, 426, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (24579, 426, 77, 745);
INSERT INTO 'devicecapvalue' VALUES (24580, 426, 78, 1273);
INSERT INTO 'devicecapvalue' VALUES (24581, 426, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (24582, 426, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (24583, 426, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (24584, 426, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24585, 426, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (24586, 426, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (24587, 426, 3, 1501);
INSERT INTO 'devicecapvalue' VALUES (24588, 426, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (24589, 426, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (24590, 426, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (24591, 426, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (24592, 426, 51, 1805);
INSERT INTO 'devicecapvalue' VALUES (24593, 426, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (24594, 426, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (24595, 426, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (24596, 426, 157, 1026);
INSERT INTO 'capvalue' VALUES (1812, 'Nokia6620/2.0 (4.22.1) SymbianOS/7.0s Series60/2.1 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (24597, 426, 53, 1812);
INSERT INTO 'devicecapvalue' VALUES (24598, 427, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (24599, 427, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (24600, 427, 162, 605);
INSERT INTO 'devicecapvalue' VALUES (24601, 427, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (24602, 427, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (24603, 427, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (24604, 427, 77, 745);
INSERT INTO 'devicecapvalue' VALUES (24605, 427, 78, 1273);
INSERT INTO 'devicecapvalue' VALUES (24606, 427, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (24607, 427, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (24608, 427, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (24609, 427, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (24610, 427, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (24611, 427, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24612, 427, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (24613, 427, 50, 593);
INSERT INTO 'capvalue' VALUES (1813, 'Symbian OS 8.0a');
INSERT INTO 'devicecapvalue' VALUES (24614, 427, 3, 1813);
INSERT INTO 'devicecapvalue' VALUES (24615, 427, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (24616, 427, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (24617, 427, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (24618, 427, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (24619, 427, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (24620, 427, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (24621, 427, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (24622, 427, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (24623, 427, 51, 1502);
INSERT INTO 'devicecapvalue' VALUES (24624, 427, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (24625, 427, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (24626, 427, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (24627, 427, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (24628, 427, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (24629, 427, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (24630, 427, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (24631, 427, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (24632, 427, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (24633, 427, 157, 1504);
INSERT INTO 'capvalue' VALUES (1814, 'Nokia6630/1.0 (6.03.40) SymbianOS/8.0 Series60/2.6 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (24634, 427, 53, 1814);
INSERT INTO 'devicecapvalue' VALUES (24635, 428, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (24636, 428, 74, 1775);
INSERT INTO 'devicecapvalue' VALUES (24637, 428, 160, 1716);
INSERT INTO 'devicecapvalue' VALUES (24638, 428, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (24639, 428, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (24640, 428, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (24641, 428, 76, 1731);
INSERT INTO 'devicecapvalue' VALUES (24642, 428, 77, 745);
INSERT INTO 'devicecapvalue' VALUES (24643, 428, 78, 1273);
INSERT INTO 'devicecapvalue' VALUES (24644, 428, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (24645, 428, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (24646, 428, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (24647, 428, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24648, 428, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (24649, 428, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (24650, 428, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (24651, 428, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (24652, 428, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (24653, 428, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (24654, 428, 3, 1501);
INSERT INTO 'devicecapvalue' VALUES (24655, 428, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (24656, 428, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (24657, 428, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (24658, 428, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (24659, 428, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (24660, 428, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (24661, 428, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (24662, 428, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (24663, 428, 51, 1502);
INSERT INTO 'devicecapvalue' VALUES (24664, 428, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (24665, 428, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (24666, 428, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (24667, 428, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (24668, 428, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (24669, 428, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (24670, 428, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (24671, 428, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (24672, 428, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (24673, 428, 157, 1504);
INSERT INTO 'capvalue' VALUES (1815, 'Mozilla/4.0 (compatible; MSIE 6.0; Symbian OS; Nokia 6670/4.0437.4; 6329) Opera 8.00 [es]');
INSERT INTO 'devicecapvalue' VALUES (24674, 428, 53, 1815);
INSERT INTO 'devicecapvalue' VALUES (24675, 429, 158, 1708);
INSERT INTO 'devicecapvalue' VALUES (24676, 429, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (24677, 429, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (24678, 429, 162, 605);
INSERT INTO 'devicecapvalue' VALUES (24679, 429, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (24680, 429, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (24681, 429, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (24682, 429, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (24683, 429, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (24684, 429, 150, 1011);
INSERT INTO 'devicecapvalue' VALUES (24685, 429, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (24686, 429, 77, 745);
INSERT INTO 'devicecapvalue' VALUES (24687, 429, 78, 1273);
INSERT INTO 'devicecapvalue' VALUES (24688, 429, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (24689, 429, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (24690, 429, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (24691, 429, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (24692, 429, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (24693, 429, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24694, 429, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (24695, 429, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (24696, 429, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (24697, 429, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (24698, 429, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (24699, 429, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (24700, 429, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (24701, 429, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (24702, 429, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (24703, 429, 3, 1813);
INSERT INTO 'devicecapvalue' VALUES (24704, 429, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (24705, 429, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (24706, 429, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (24707, 429, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (24708, 429, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (24709, 429, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (24710, 429, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (24711, 429, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (24712, 429, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (24713, 429, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (24714, 429, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (24715, 429, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (24716, 429, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (24717, 429, 51, 1552);
INSERT INTO 'devicecapvalue' VALUES (24718, 429, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (24719, 429, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (24720, 429, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (24721, 429, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (24722, 429, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (24723, 429, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (24724, 429, 157, 1504);
INSERT INTO 'capvalue' VALUES (1816, 'Mozilla/4.1 (compatible; MSIE 6.0; Symbian OS; Nokia 6680; 857) Opera 7.60 [ru]');
INSERT INTO 'devicecapvalue' VALUES (24725, 429, 53, 1816);
INSERT INTO 'devicecapvalue' VALUES (24726, 430, 158, 1708);
INSERT INTO 'devicecapvalue' VALUES (24727, 430, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (24728, 430, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (24729, 430, 162, 605);
INSERT INTO 'devicecapvalue' VALUES (24730, 430, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (24731, 430, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (24732, 430, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (24733, 430, 77, 745);
INSERT INTO 'devicecapvalue' VALUES (24734, 430, 78, 1273);
INSERT INTO 'devicecapvalue' VALUES (24735, 430, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (24736, 430, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (24737, 430, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (24738, 430, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (24739, 430, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (24740, 430, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24741, 430, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (24742, 430, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (24743, 430, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (24744, 430, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (24745, 430, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (24746, 430, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (24747, 430, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (24748, 430, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (24749, 430, 3, 1813);
INSERT INTO 'devicecapvalue' VALUES (24750, 430, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (24751, 430, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (24752, 430, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (24753, 430, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (24754, 430, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (24755, 430, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (24756, 430, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (24757, 430, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (24758, 430, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (24759, 430, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (24760, 430, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (24761, 430, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (24762, 430, 51, 1552);
INSERT INTO 'devicecapvalue' VALUES (24763, 430, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (24764, 430, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (24765, 430, 52, 1731);
INSERT INTO 'devicecapvalue' VALUES (24766, 430, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (24767, 430, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (24768, 430, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (24769, 430, 157, 1504);
INSERT INTO 'capvalue' VALUES (1817, 'Nokia6682/2.0 (2.51.5) SymbianOS/8.0 Series60/2.6 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (24770, 430, 53, 1817);
INSERT INTO 'capvalue' VALUES (1818, '2005-02-20');
INSERT INTO 'devicecapvalue' VALUES (24771, 431, 158, 1818);
INSERT INTO 'devicecapvalue' VALUES (24772, 431, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (24773, 431, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (24774, 431, 162, 605);
INSERT INTO 'devicecapvalue' VALUES (24775, 431, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (24776, 431, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (24777, 431, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (24778, 431, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (24779, 431, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (24780, 431, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (24781, 431, 77, 745);
INSERT INTO 'devicecapvalue' VALUES (24782, 431, 78, 1273);
INSERT INTO 'devicecapvalue' VALUES (24783, 431, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (24784, 431, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (24785, 431, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (24786, 431, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (24787, 431, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (24788, 431, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24789, 431, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (24790, 431, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (24791, 431, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (24792, 431, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (24793, 431, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (24794, 431, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (24795, 431, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (24796, 431, 3, 1813);
INSERT INTO 'devicecapvalue' VALUES (24797, 431, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (24798, 431, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (24799, 431, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (24800, 431, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (24801, 431, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (24802, 431, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (24803, 431, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (24804, 431, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (24805, 431, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (24806, 431, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (24807, 431, 51, 1552);
INSERT INTO 'devicecapvalue' VALUES (24808, 431, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (24809, 431, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (24810, 431, 52, 1731);
INSERT INTO 'devicecapvalue' VALUES (24811, 431, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (24812, 431, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (24813, 431, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (24814, 431, 157, 1504);
INSERT INTO 'capvalue' VALUES (1819, 'Nokia6682/1.0 (2.30.0) SymbianOS/8.0 Series60/2.6 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (24815, 431, 53, 1819);
INSERT INTO 'devicecapvalue' VALUES (24816, 432, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (24817, 432, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (24818, 432, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (24819, 432, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (24820, 432, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (24821, 432, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (24822, 432, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (24823, 432, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (24824, 432, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (24825, 432, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (24826, 432, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (24827, 432, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (24828, 432, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (24829, 432, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (24830, 432, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (24831, 432, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (24832, 432, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (24833, 432, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (24834, 432, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (24835, 432, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (24836, 432, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (24837, 432, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (24838, 432, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (24839, 432, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24840, 432, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (24841, 432, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (24842, 432, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (24843, 432, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (24844, 432, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (24845, 432, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (24846, 432, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (24847, 432, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (24848, 432, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (24849, 432, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (24850, 432, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (24851, 432, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (24852, 432, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (24853, 432, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (24854, 432, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (24855, 432, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (24856, 432, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (24857, 432, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (24858, 432, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (24859, 432, 35, 45);
INSERT INTO 'capvalue' VALUES (1820, 'Nokia6700c-1/07.60');
INSERT INTO 'devicecapvalue' VALUES (24860, 432, 36, 1820);
INSERT INTO 'devicecapvalue' VALUES (24861, 432, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (24862, 432, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (24863, 432, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (24864, 432, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (24865, 432, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (24866, 432, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (24867, 432, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (24868, 432, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (24869, 432, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (24870, 432, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (24871, 432, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (24872, 432, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (24873, 432, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (24874, 432, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (24875, 432, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (24876, 432, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (24877, 432, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (24878, 432, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (24879, 432, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (24880, 432, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (24881, 432, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (24882, 432, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (24883, 432, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (24884, 432, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (24885, 432, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (24886, 432, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (24887, 432, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (24888, 432, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (24889, 432, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (24890, 432, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (24891, 432, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (24892, 432, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (24893, 432, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (24894, 432, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (24895, 432, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (24896, 432, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (24897, 432, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (24898, 432, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (24899, 432, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (24900, 432, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (24901, 432, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (24902, 432, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (24903, 432, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (24904, 432, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (24905, 432, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (24906, 432, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (24907, 432, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (24908, 432, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (24909, 432, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (24910, 432, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (24911, 432, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (24912, 432, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (24913, 432, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (24914, 432, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (24915, 432, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (24916, 432, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (24917, 432, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (24918, 432, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (24919, 432, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (24920, 432, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (24921, 432, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (24922, 432, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (24923, 432, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (24924, 432, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (24925, 432, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (24926, 432, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (24927, 432, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (24928, 432, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (24929, 432, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (24930, 432, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (24931, 432, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (24932, 432, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (24933, 432, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (24934, 432, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (24935, 432, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (24936, 432, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (24937, 432, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (24938, 432, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (24939, 432, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (24940, 432, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (24941, 432, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (24942, 432, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (24943, 432, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (24944, 432, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (24945, 432, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (24946, 432, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (24947, 432, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (24948, 432, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (24949, 432, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (24950, 432, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (24951, 432, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (24952, 432, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (24953, 432, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (24954, 432, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (24955, 432, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (24956, 432, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (24957, 432, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (24958, 432, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (24959, 432, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (24960, 432, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (24961, 432, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (24962, 432, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (24963, 432, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (24964, 432, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (24965, 432, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (24966, 432, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (24967, 432, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (24968, 432, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (24969, 432, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (24970, 432, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (24971, 432, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (24972, 432, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (24973, 432, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (24974, 432, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (24975, 432, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (24976, 432, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (24977, 432, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (24978, 432, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (24979, 432, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (24980, 432, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (24981, 432, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (24982, 432, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (24983, 432, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (24984, 432, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (24985, 432, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (24986, 432, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (24987, 432, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (24988, 432, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (24989, 432, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (24990, 432, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (24991, 432, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (24992, 432, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (24993, 432, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (24994, 432, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (24995, 432, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (24996, 432, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (24997, 432, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (24998, 432, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (24999, 432, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (25000, 432, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (25001, 432, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (25002, 432, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (25003, 432, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (25004, 432, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (25005, 432, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (25006, 432, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (25007, 432, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (25008, 432, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (25009, 432, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (25010, 432, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (25011, 432, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (25012, 432, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (25013, 432, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (25014, 432, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (25015, 432, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (25016, 432, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (25017, 432, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (25018, 432, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (25019, 432, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (25020, 432, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (25021, 432, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (25022, 432, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (25023, 432, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (25024, 432, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (25025, 432, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (25026, 432, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (25027, 432, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (25028, 432, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (25029, 432, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (25030, 432, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (25031, 432, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (25032, 432, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (25033, 432, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (25034, 432, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (25035, 432, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (25036, 432, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (25037, 432, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (25038, 432, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (25039, 432, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (25040, 432, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (25041, 432, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (25042, 432, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (25043, 432, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (25044, 432, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (25045, 432, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (25046, 432, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (25047, 432, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (25048, 432, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (25049, 432, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (25050, 432, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (25051, 432, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (25052, 432, 73, 122);
INSERT INTO 'devicecapvalue' VALUES (25053, 432, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (25054, 432, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (25055, 432, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (25056, 432, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (25057, 432, 73, 620);
INSERT INTO 'devicecapvalue' VALUES (25058, 432, 73, 622);
INSERT INTO 'devicecapvalue' VALUES (25059, 432, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (25060, 432, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (25061, 432, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (25062, 432, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (25063, 432, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (25064, 432, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (25065, 432, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (25066, 432, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (25067, 432, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (25068, 432, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (25069, 432, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (25070, 432, 49, 1031);
INSERT INTO 'capvalue' VALUES (1821, 'Nokia6700c-1/2.0 (07.60) Profile/MIDP-2.1 Configuration/CLDC-1.1 Mozilla/5.0 AppleWebKit/420+ (KHTML');
INSERT INTO 'devicecapvalue' VALUES (25071, 432, 53, 1821);
INSERT INTO 'devicecapvalue' VALUES (25072, 432, 53, 1514);
INSERT INTO 'devicecapvalue' VALUES (25073, 433, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (25074, 433, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (25075, 433, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (25076, 434, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (25077, 434, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (25078, 434, 5, 5);
INSERT INTO 'capvalue' VALUES (1822, '2005-01-05');
INSERT INTO 'devicecapvalue' VALUES (25079, 435, 158, 1822);
INSERT INTO 'devicecapvalue' VALUES (25080, 435, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (25081, 435, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (25082, 435, 162, 612);
INSERT INTO 'devicecapvalue' VALUES (25083, 435, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (25084, 435, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (25085, 435, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (25086, 435, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (25087, 435, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (25088, 435, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (25089, 435, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (25090, 435, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (25091, 435, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (25092, 435, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (25093, 435, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (25094, 435, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (25095, 435, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25096, 435, 6, 27);
INSERT INTO 'capvalue' VALUES (1823, '143360');
INSERT INTO 'devicecapvalue' VALUES (25097, 435, 50, 1823);
INSERT INTO 'devicecapvalue' VALUES (25098, 435, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (25099, 435, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (25100, 435, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (25101, 435, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (25102, 435, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (25103, 435, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (25104, 435, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (25105, 435, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (25106, 435, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (25107, 435, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (25108, 435, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (25109, 435, 51, 1689);
INSERT INTO 'devicecapvalue' VALUES (25110, 435, 51, 569);
INSERT INTO 'capvalue' VALUES (1824, '5138022');
INSERT INTO 'devicecapvalue' VALUES (25111, 435, 52, 1824);
INSERT INTO 'devicecapvalue' VALUES (25112, 435, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (25113, 435, 157, 1134);
INSERT INTO 'capvalue' VALUES (1825, 'Nokia6822/2.0 (4.52) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (25114, 435, 53, 1825);
INSERT INTO 'devicecapvalue' VALUES (25115, 436, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (25116, 436, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (25117, 436, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (25118, 436, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (25119, 436, 167, 1493);
INSERT INTO 'devicecapvalue' VALUES (25120, 436, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (25121, 436, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (25122, 436, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (25123, 436, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (25124, 436, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (25125, 436, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25126, 436, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (25127, 436, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (25128, 436, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (25129, 436, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (25130, 436, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (25131, 436, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (25132, 436, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (25133, 436, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (25134, 436, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (25135, 436, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (25136, 436, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (25137, 436, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (25138, 436, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (25139, 436, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (25140, 436, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (25141, 436, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (25142, 436, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (25143, 436, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (25144, 436, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (25145, 436, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (25146, 436, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (25147, 436, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (25148, 436, 157, 1026);
INSERT INTO 'capvalue' VALUES (1826, 'Nokia7260/2.0 (t4.23a) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (25149, 436, 53, 1826);
INSERT INTO 'devicecapvalue' VALUES (25150, 437, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (25151, 437, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (25152, 437, 162, 42);
INSERT INTO 'capvalue' VALUES (1827, 'OMA Forward-Lock');
INSERT INTO 'devicecapvalue' VALUES (25153, 437, 173, 1827);
INSERT INTO 'devicecapvalue' VALUES (25154, 437, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (25155, 437, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (25156, 437, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (25157, 437, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (25158, 437, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (25159, 437, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (25160, 437, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25161, 437, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (25162, 437, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (25163, 437, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (25164, 437, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (25165, 437, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (25166, 437, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (25167, 437, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (25168, 437, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (25169, 437, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (25170, 437, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (25171, 437, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (25172, 437, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (25173, 437, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (25174, 437, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (25175, 437, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (25176, 437, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (25177, 437, 51, 1689);
INSERT INTO 'devicecapvalue' VALUES (25178, 437, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (25179, 437, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (25180, 437, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (25181, 437, 157, 1134);
INSERT INTO 'capvalue' VALUES (1828, 'Nokia7270/2.0 (p04W41.00) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (25182, 437, 53, 1828);
INSERT INTO 'capvalue' VALUES (1829, '2005-10-19');
INSERT INTO 'devicecapvalue' VALUES (25183, 438, 158, 1829);
INSERT INTO 'devicecapvalue' VALUES (25184, 438, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (25185, 438, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (25186, 438, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (25187, 438, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (25188, 438, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (25189, 438, 76, 1457);
INSERT INTO 'devicecapvalue' VALUES (25190, 438, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (25191, 438, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (25192, 438, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (25193, 438, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (25194, 438, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (25195, 438, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25196, 438, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (25197, 438, 6, 27);
INSERT INTO 'capvalue' VALUES (1830, '169984');
INSERT INTO 'devicecapvalue' VALUES (25198, 438, 50, 1830);
INSERT INTO 'devicecapvalue' VALUES (25199, 438, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (25200, 438, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (25201, 438, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (25202, 438, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (25203, 438, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (25204, 438, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (25205, 438, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (25206, 438, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (25207, 438, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (25208, 438, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (25209, 438, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (25210, 438, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (25211, 438, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (25212, 438, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (25213, 438, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (25214, 438, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (25215, 438, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (25216, 438, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (25217, 438, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (25218, 438, 157, 1026);
INSERT INTO 'capvalue' VALUES (1831, 'Nokia7360/2.0 (05.22) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (25219, 438, 53, 1831);
INSERT INTO 'devicecapvalue' VALUES (25220, 439, 158, 1829);
INSERT INTO 'devicecapvalue' VALUES (25221, 439, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (25222, 439, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (25223, 439, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (25224, 439, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (25225, 439, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (25226, 439, 76, 1457);
INSERT INTO 'devicecapvalue' VALUES (25227, 439, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (25228, 439, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (25229, 439, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (25230, 439, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (25231, 439, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (25232, 439, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25233, 439, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (25234, 439, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (25235, 439, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (25236, 439, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (25237, 439, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (25238, 439, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (25239, 439, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (25240, 439, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (25241, 439, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (25242, 439, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (25243, 439, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (25244, 439, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (25245, 439, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (25246, 439, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (25247, 439, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (25248, 439, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (25249, 439, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (25250, 439, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (25251, 439, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (25252, 439, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (25253, 439, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (25254, 439, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (25255, 439, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (25256, 439, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (25257, 439, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (25258, 439, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (25259, 439, 157, 1026);
INSERT INTO 'capvalue' VALUES (1832, 'Nokia7370/2.0 (03.51) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (25260, 439, 53, 1832);
INSERT INTO 'capvalue' VALUES (1833, '2006-09-04');
INSERT INTO 'devicecapvalue' VALUES (25261, 440, 158, 1833);
INSERT INTO 'devicecapvalue' VALUES (25262, 440, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (25263, 440, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (25264, 440, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (25265, 440, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (25266, 440, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (25267, 440, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (25268, 440, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (25269, 440, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (25270, 440, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (25271, 440, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (25272, 440, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (25273, 440, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (25274, 440, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (25275, 440, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (25276, 440, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (25277, 440, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (25278, 440, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (25279, 440, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25280, 440, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25281, 440, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (25282, 440, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (25283, 440, 50, 98);
INSERT INTO 'devicecapvalue' VALUES (25284, 440, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (25285, 440, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (25286, 440, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (25287, 440, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (25288, 440, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (25289, 440, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (25290, 440, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (25291, 440, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (25292, 440, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (25293, 440, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (25294, 440, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (25295, 440, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (25296, 440, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (25297, 440, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (25298, 440, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (25299, 440, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (25300, 440, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (25301, 440, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (25302, 440, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (25303, 440, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (25304, 440, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (25305, 440, 52, 1031);
INSERT INTO 'devicecapvalue' VALUES (25306, 440, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (25307, 440, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (25308, 440, 157, 1026);
INSERT INTO 'capvalue' VALUES (1834, 'Nokia7373/2.0 (04.70) Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (25309, 440, 53, 1834);
INSERT INTO 'devicecapvalue' VALUES (25310, 441, 158, 1833);
INSERT INTO 'devicecapvalue' VALUES (25311, 441, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (25312, 441, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (25313, 441, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (25314, 441, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (25315, 441, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (25316, 441, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (25317, 441, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (25318, 441, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (25319, 441, 78, 594);
INSERT INTO 'devicecapvalue' VALUES (25320, 441, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (25321, 441, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (25322, 441, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (25323, 441, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (25324, 441, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (25325, 441, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (25326, 441, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (25327, 441, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (25328, 441, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25329, 441, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25330, 441, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (25331, 441, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (25332, 441, 50, 1412);
INSERT INTO 'devicecapvalue' VALUES (25333, 441, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (25334, 441, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (25335, 441, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (25336, 441, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (25337, 441, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (25338, 441, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (25339, 441, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (25340, 441, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (25341, 441, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (25342, 441, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (25343, 441, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (25344, 441, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (25345, 441, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (25346, 441, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (25347, 441, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (25348, 441, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (25349, 441, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (25350, 441, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (25351, 441, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (25352, 441, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (25353, 441, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (25354, 441, 52, 1787);
INSERT INTO 'devicecapvalue' VALUES (25355, 441, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (25356, 441, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (25357, 441, 157, 1026);
INSERT INTO 'capvalue' VALUES (1835, 'Nokia7390/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (25358, 441, 53, 1835);
INSERT INTO 'devicecapvalue' VALUES (25359, 442, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (25360, 442, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (25361, 442, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (25362, 442, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (25363, 442, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (25364, 442, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (25365, 442, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (25366, 442, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (25367, 442, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (25368, 442, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (25369, 442, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (25370, 442, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (25371, 442, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (25372, 442, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (25373, 442, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (25374, 442, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (25375, 442, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (25376, 442, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (25377, 442, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (25378, 442, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (25379, 442, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (25380, 442, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (25381, 442, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25382, 442, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25383, 442, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (25384, 442, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (25385, 442, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (25386, 442, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (25387, 442, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (25388, 442, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (25389, 442, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (25390, 442, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (25391, 442, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (25392, 442, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (25393, 442, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (25394, 442, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (25395, 442, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (25396, 442, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (25397, 442, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (25398, 442, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (25399, 442, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (25400, 442, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (25401, 442, 35, 45);
INSERT INTO 'capvalue' VALUES (1836, 'Nokia7500/05.20');
INSERT INTO 'devicecapvalue' VALUES (25402, 442, 36, 1836);
INSERT INTO 'devicecapvalue' VALUES (25403, 442, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (25404, 442, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (25405, 442, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (25406, 442, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (25407, 442, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (25408, 442, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (25409, 442, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (25410, 442, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (25411, 442, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (25412, 442, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (25413, 442, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (25414, 442, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (25415, 442, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (25416, 442, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (25417, 442, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (25418, 442, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (25419, 442, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (25420, 442, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (25421, 442, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (25422, 442, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (25423, 442, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (25424, 442, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (25425, 442, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (25426, 442, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (25427, 442, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (25428, 442, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (25429, 442, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (25430, 442, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (25431, 442, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (25432, 442, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (25433, 442, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (25434, 442, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (25435, 442, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (25436, 442, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (25437, 442, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (25438, 442, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (25439, 442, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (25440, 442, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (25441, 442, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (25442, 442, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (25443, 442, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (25444, 442, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (25445, 442, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (25446, 442, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (25447, 442, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (25448, 442, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (25449, 442, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (25450, 442, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (25451, 442, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (25452, 442, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (25453, 442, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (25454, 442, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (25455, 442, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (25456, 442, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (25457, 442, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (25458, 442, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (25459, 442, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (25460, 442, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (25461, 442, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (25462, 442, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (25463, 442, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (25464, 442, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (25465, 442, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (25466, 442, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (25467, 442, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (25468, 442, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (25469, 442, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (25470, 442, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (25471, 442, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (25472, 442, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (25473, 442, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (25474, 442, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (25475, 442, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (25476, 442, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (25477, 442, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (25478, 442, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (25479, 442, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (25480, 442, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (25481, 442, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (25482, 442, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (25483, 442, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (25484, 442, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (25485, 442, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (25486, 442, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (25487, 442, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (25488, 442, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (25489, 442, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (25490, 442, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (25491, 442, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (25492, 442, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (25493, 442, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (25494, 442, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (25495, 442, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (25496, 442, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (25497, 442, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (25498, 442, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (25499, 442, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (25500, 442, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (25501, 442, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (25502, 442, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (25503, 442, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (25504, 442, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (25505, 442, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (25506, 442, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (25507, 442, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (25508, 442, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (25509, 442, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (25510, 442, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (25511, 442, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (25512, 442, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (25513, 442, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (25514, 442, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (25515, 442, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (25516, 442, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (25517, 442, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (25518, 442, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (25519, 442, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (25520, 442, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (25521, 442, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (25522, 442, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (25523, 442, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (25524, 442, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (25525, 442, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (25526, 442, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (25527, 442, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (25528, 442, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (25529, 442, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (25530, 442, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (25531, 442, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (25532, 442, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (25533, 442, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (25534, 442, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (25535, 442, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (25536, 442, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (25537, 442, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (25538, 442, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (25539, 442, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (25540, 442, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (25541, 442, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (25542, 442, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (25543, 442, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (25544, 442, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (25545, 442, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (25546, 442, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (25547, 442, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (25548, 442, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (25549, 442, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (25550, 442, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (25551, 442, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (25552, 442, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (25553, 442, 49, 1031);
INSERT INTO 'capvalue' VALUES (1837, 'Nokia7500/2.0 (05.20) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (25554, 442, 53, 1837);
INSERT INTO 'devicecapvalue' VALUES (25555, 443, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (25556, 443, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (25557, 443, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (25558, 443, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (25559, 443, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (25560, 443, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (25561, 443, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (25562, 443, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (25563, 443, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (25564, 443, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (25565, 443, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (25566, 443, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (25567, 443, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (25568, 443, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (25569, 443, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (25570, 443, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (25571, 443, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (25572, 443, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (25573, 443, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (25574, 443, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (25575, 443, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (25576, 443, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (25577, 443, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (25578, 443, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (25579, 443, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25580, 443, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25581, 443, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (25582, 443, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (25583, 443, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (25584, 443, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (25585, 443, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (25586, 443, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (25587, 443, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (25588, 443, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (25589, 443, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (25590, 443, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (25591, 443, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (25592, 443, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (25593, 443, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (25594, 443, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (25595, 443, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (25596, 443, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (25597, 443, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (25598, 443, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (25599, 443, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (25600, 443, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (25601, 443, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (25602, 443, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (25603, 443, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (25604, 443, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (25605, 443, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (25606, 443, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (25607, 443, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (25608, 443, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (25609, 443, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (25610, 443, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (25611, 443, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (25612, 443, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (25613, 443, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (25614, 443, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (25615, 443, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (25616, 443, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (25617, 443, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (25618, 443, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (25619, 443, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (25620, 443, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (25621, 443, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (25622, 443, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (25623, 443, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (25624, 443, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (25625, 443, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (25626, 443, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (25627, 443, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (25628, 443, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (25629, 443, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (25630, 443, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (25631, 443, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (25632, 443, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (25633, 443, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (25634, 443, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (25635, 443, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (25636, 443, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (25637, 443, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (25638, 443, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (25639, 443, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (25640, 443, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (25641, 443, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (25642, 443, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (25643, 443, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (25644, 443, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (25645, 443, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (25646, 443, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (25647, 443, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (25648, 443, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (25649, 443, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (25650, 443, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (25651, 443, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (25652, 443, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (25653, 443, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (25654, 443, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (25655, 443, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (25656, 443, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (25657, 443, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (25658, 443, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (25659, 443, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (25660, 443, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (25661, 443, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (25662, 443, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (25663, 443, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (25664, 443, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (25665, 443, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (25666, 443, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (25667, 443, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (25668, 443, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (25669, 443, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (25670, 443, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (25671, 443, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (25672, 443, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (25673, 443, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (25674, 443, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (25675, 443, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (25676, 443, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (25677, 443, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (25678, 443, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (25679, 443, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (25680, 443, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (25681, 443, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (25682, 443, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (25683, 443, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (25684, 443, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (25685, 443, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (25686, 443, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (25687, 443, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (25688, 443, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (25689, 443, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (25690, 443, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (25691, 443, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (25692, 443, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (25693, 443, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (25694, 443, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (25695, 443, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (25696, 443, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (25697, 443, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (25698, 443, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (25699, 443, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (25700, 443, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (25701, 443, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (25702, 443, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (25703, 443, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (25704, 443, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (25705, 443, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (25706, 443, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (25707, 443, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (25708, 443, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (25709, 443, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (25710, 443, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (25711, 443, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (25712, 443, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (25713, 443, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (25714, 443, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (25715, 443, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (25716, 443, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (25717, 443, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (25718, 443, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (25719, 443, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (25720, 443, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (25721, 443, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (25722, 443, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (25723, 443, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (25724, 443, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (25725, 443, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (25726, 443, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (25727, 443, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (25728, 443, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (25729, 443, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (25730, 443, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (25731, 443, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (25732, 443, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (25733, 443, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (25734, 443, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (25735, 443, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (25736, 443, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (25737, 443, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (25738, 443, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (25739, 443, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (25740, 443, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (25741, 443, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (25742, 443, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (25743, 443, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (25744, 443, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (25745, 443, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (25746, 443, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (25747, 443, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (25748, 443, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (25749, 443, 115, 1258);
INSERT INTO 'devicecapvalue' VALUES (25750, 443, 197, 1746);
INSERT INTO 'devicecapvalue' VALUES (25751, 443, 197, 1747);
INSERT INTO 'devicecapvalue' VALUES (25752, 443, 197, 1748);
INSERT INTO 'devicecapvalue' VALUES (25753, 443, 141, 238);
INSERT INTO 'devicecapvalue' VALUES (25754, 443, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (25755, 443, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (25756, 443, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (25757, 443, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (25758, 443, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (25759, 443, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (25760, 443, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (25761, 443, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (25762, 443, 125, 711);
INSERT INTO 'devicecapvalue' VALUES (25763, 443, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (25764, 443, 183, 1423);
INSERT INTO 'devicecapvalue' VALUES (25765, 443, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (25766, 443, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (25767, 443, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (25768, 443, 102, 1470);
INSERT INTO 'devicecapvalue' VALUES (25769, 443, 103, 1426);
INSERT INTO 'devicecapvalue' VALUES (25770, 443, 104, 1427);
INSERT INTO 'devicecapvalue' VALUES (25771, 443, 105, 1428);
INSERT INTO 'devicecapvalue' VALUES (25772, 443, 106, 1429);
INSERT INTO 'devicecapvalue' VALUES (25773, 443, 107, 1430);
INSERT INTO 'devicecapvalue' VALUES (25774, 443, 108, 1431);
INSERT INTO 'devicecapvalue' VALUES (25775, 443, 109, 1432);
INSERT INTO 'devicecapvalue' VALUES (25776, 443, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (25777, 443, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (25778, 443, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (25779, 443, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (25780, 443, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (25781, 443, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (25782, 443, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (25783, 443, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (25784, 443, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (25785, 443, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (25786, 443, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (25787, 443, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (25788, 443, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (25789, 443, 131, 922);
INSERT INTO 'devicecapvalue' VALUES (25790, 443, 67, 45);
INSERT INTO 'capvalue' VALUES (1838, 'Nokia7510Supernova/03.80');
INSERT INTO 'devicecapvalue' VALUES (25791, 443, 68, 1838);
INSERT INTO 'devicecapvalue' VALUES (25792, 443, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (25793, 443, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (25794, 443, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (25795, 443, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (25796, 443, 132, 49);
INSERT INTO 'devicecapvalue' VALUES (25797, 443, 133, 53);
INSERT INTO 'devicecapvalue' VALUES (25798, 443, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (25799, 443, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (25800, 443, 149, 1751);
INSERT INTO 'devicecapvalue' VALUES (25801, 443, 149, 1752);
INSERT INTO 'devicecapvalue' VALUES (25802, 443, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (25803, 443, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (25804, 443, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (25805, 443, 136, 68);
INSERT INTO 'devicecapvalue' VALUES (25806, 443, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (25807, 443, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (25808, 443, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (25809, 443, 137, 1398);
INSERT INTO 'capvalue' VALUES (1839, 'http://mms.gprs.safaricom.com');
INSERT INTO 'devicecapvalue' VALUES (25810, 443, 138, 1839);
INSERT INTO 'capvalue' VALUES (1840, '+254722500029');
INSERT INTO 'devicecapvalue' VALUES (25811, 443, 72, 1840);
INSERT INTO 'devicecapvalue' VALUES (25812, 443, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (25813, 443, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (25814, 443, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (25815, 443, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (25816, 443, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (25817, 443, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (25818, 443, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (25819, 443, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (25820, 443, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (25821, 443, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (25822, 443, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (25823, 443, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (25824, 443, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (25825, 443, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (25826, 443, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (25827, 443, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (25828, 443, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (25829, 443, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (25830, 443, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (25831, 443, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (25832, 443, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (25833, 443, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (25834, 443, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (25835, 443, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (25836, 443, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (25837, 443, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (25838, 443, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (25839, 443, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (25840, 443, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (25841, 443, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (25842, 443, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (25843, 443, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (25844, 443, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (25845, 443, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (25846, 443, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (25847, 443, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (25848, 443, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (25849, 443, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (25850, 443, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (25851, 443, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (25852, 443, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (25853, 443, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (25854, 443, 73, 620);
INSERT INTO 'devicecapvalue' VALUES (25855, 443, 73, 622);
INSERT INTO 'devicecapvalue' VALUES (25856, 443, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (25857, 443, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (25858, 443, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (25859, 443, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (25860, 443, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (25861, 443, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (25862, 443, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (25863, 443, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (25864, 443, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (25865, 443, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (25866, 443, 49, 1031);
INSERT INTO 'capvalue' VALUES (1841, 'Mozilla/5.0 ( Nokia7510Supernova/2.0 (03.80) Profile/MIDP-2.1 Configuration/CLDC-1.1) AppleWebKit/420+ (KHTML');
INSERT INTO 'devicecapvalue' VALUES (25867, 443, 53, 1841);
INSERT INTO 'devicecapvalue' VALUES (25868, 443, 53, 1514);
INSERT INTO 'devicecapvalue' VALUES (25869, 444, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (25870, 444, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (25871, 444, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (25872, 444, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (25873, 444, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (25874, 444, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (25875, 444, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (25876, 444, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (25877, 444, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (25878, 444, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (25879, 444, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (25880, 444, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (25881, 444, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (25882, 444, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (25883, 444, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (25884, 444, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (25885, 444, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (25886, 444, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (25887, 444, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (25888, 444, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (25889, 444, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (25890, 444, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (25891, 444, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (25892, 444, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (25893, 444, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25894, 444, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (25895, 444, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (25896, 444, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (25897, 444, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (25898, 444, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (25899, 444, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (25900, 444, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (25901, 444, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (25902, 444, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (25903, 444, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (25904, 444, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (25905, 444, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (25906, 444, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (25907, 444, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (25908, 444, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (25909, 444, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (25910, 444, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (25911, 444, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (25912, 444, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (25913, 444, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (25914, 444, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (25915, 444, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (25916, 444, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (25917, 444, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (25918, 444, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (25919, 444, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (25920, 444, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (25921, 444, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (25922, 444, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (25923, 444, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (25924, 444, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (25925, 444, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (25926, 444, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (25927, 444, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (25928, 444, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (25929, 444, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (25930, 444, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (25931, 444, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (25932, 444, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (25933, 444, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (25934, 444, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (25935, 444, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (25936, 444, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (25937, 444, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (25938, 444, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (25939, 444, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (25940, 444, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (25941, 444, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (25942, 444, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (25943, 444, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (25944, 444, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (25945, 444, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (25946, 444, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (25947, 444, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (25948, 444, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (25949, 444, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (25950, 444, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (25951, 444, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (25952, 444, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (25953, 444, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (25954, 444, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (25955, 444, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (25956, 444, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (25957, 444, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (25958, 444, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (25959, 444, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (25960, 444, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (25961, 444, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (25962, 444, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (25963, 444, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (25964, 444, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (25965, 444, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (25966, 444, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (25967, 444, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (25968, 444, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (25969, 444, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (25970, 444, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (25971, 444, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (25972, 444, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (25973, 444, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (25974, 444, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (25975, 444, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (25976, 444, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (25977, 444, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (25978, 444, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (25979, 444, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (25980, 444, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (25981, 444, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (25982, 444, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (25983, 444, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (25984, 444, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (25985, 444, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (25986, 444, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (25987, 444, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (25988, 444, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (25989, 444, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (25990, 444, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (25991, 444, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (25992, 444, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (25993, 444, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (25994, 444, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (25995, 444, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (25996, 444, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (25997, 444, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (25998, 444, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (25999, 444, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (26000, 444, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (26001, 444, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (26002, 444, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (26003, 444, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (26004, 444, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (26005, 444, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (26006, 444, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (26007, 444, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (26008, 444, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (26009, 444, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (26010, 444, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (26011, 444, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (26012, 444, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (26013, 444, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (26014, 444, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (26015, 444, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (26016, 444, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (26017, 444, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (26018, 444, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (26019, 444, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (26020, 444, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (26021, 444, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (26022, 444, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (26023, 444, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (26024, 444, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (26025, 444, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (26026, 444, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (26027, 444, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (26028, 444, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (26029, 444, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (26030, 444, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (26031, 444, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (26032, 444, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (26033, 444, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (26034, 444, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (26035, 444, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (26036, 444, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (26037, 444, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (26038, 444, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (26039, 444, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (26040, 444, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (26041, 444, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (26042, 444, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (26043, 444, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (26044, 444, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (26045, 444, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (26046, 444, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (26047, 444, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (26048, 444, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (26049, 444, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (26050, 444, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (26051, 444, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (26052, 444, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (26053, 444, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (26054, 444, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (26055, 444, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (26056, 444, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (26057, 444, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (26058, 444, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (26059, 444, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (26060, 444, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (26061, 444, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (26062, 444, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (26063, 444, 115, 1258);
INSERT INTO 'devicecapvalue' VALUES (26064, 444, 197, 1746);
INSERT INTO 'devicecapvalue' VALUES (26065, 444, 197, 1747);
INSERT INTO 'devicecapvalue' VALUES (26066, 444, 197, 1748);
INSERT INTO 'devicecapvalue' VALUES (26067, 444, 141, 238);
INSERT INTO 'devicecapvalue' VALUES (26068, 444, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (26069, 444, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (26070, 444, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (26071, 444, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (26072, 444, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (26073, 444, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (26074, 444, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (26075, 444, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (26076, 444, 125, 711);
INSERT INTO 'devicecapvalue' VALUES (26077, 444, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (26078, 444, 183, 1423);
INSERT INTO 'devicecapvalue' VALUES (26079, 444, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (26080, 444, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (26081, 444, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (26082, 444, 102, 1470);
INSERT INTO 'devicecapvalue' VALUES (26083, 444, 103, 1426);
INSERT INTO 'devicecapvalue' VALUES (26084, 444, 104, 1427);
INSERT INTO 'devicecapvalue' VALUES (26085, 444, 105, 1428);
INSERT INTO 'devicecapvalue' VALUES (26086, 444, 106, 1429);
INSERT INTO 'devicecapvalue' VALUES (26087, 444, 107, 1430);
INSERT INTO 'devicecapvalue' VALUES (26088, 444, 108, 1431);
INSERT INTO 'devicecapvalue' VALUES (26089, 444, 109, 1432);
INSERT INTO 'devicecapvalue' VALUES (26090, 444, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (26091, 444, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (26092, 444, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (26093, 444, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (26094, 444, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (26095, 444, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (26096, 444, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (26097, 444, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (26098, 444, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (26099, 444, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (26100, 444, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (26101, 444, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (26102, 444, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (26103, 444, 131, 922);
INSERT INTO 'devicecapvalue' VALUES (26104, 444, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (26105, 444, 68, 1838);
INSERT INTO 'devicecapvalue' VALUES (26106, 444, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (26107, 444, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (26108, 444, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (26109, 444, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (26110, 444, 132, 49);
INSERT INTO 'devicecapvalue' VALUES (26111, 444, 133, 53);
INSERT INTO 'devicecapvalue' VALUES (26112, 444, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (26113, 444, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (26114, 444, 149, 1751);
INSERT INTO 'devicecapvalue' VALUES (26115, 444, 149, 1752);
INSERT INTO 'devicecapvalue' VALUES (26116, 444, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (26117, 444, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (26118, 444, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (26119, 444, 136, 68);
INSERT INTO 'devicecapvalue' VALUES (26120, 444, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (26121, 444, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (26122, 444, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (26123, 444, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (26124, 444, 138, 1839);
INSERT INTO 'devicecapvalue' VALUES (26125, 444, 72, 1840);
INSERT INTO 'devicecapvalue' VALUES (26126, 444, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (26127, 444, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (26128, 444, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (26129, 444, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (26130, 444, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (26131, 444, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (26132, 444, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (26133, 444, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (26134, 444, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (26135, 444, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (26136, 444, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (26137, 444, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (26138, 444, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (26139, 444, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (26140, 444, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (26141, 444, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (26142, 444, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (26143, 444, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (26144, 444, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (26145, 444, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (26146, 444, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (26147, 444, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (26148, 444, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (26149, 444, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (26150, 444, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (26151, 444, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (26152, 444, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (26153, 444, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (26154, 444, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (26155, 444, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (26156, 444, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (26157, 444, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (26158, 444, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (26159, 444, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (26160, 444, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (26161, 444, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (26162, 444, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (26163, 444, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (26164, 444, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (26165, 444, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (26166, 444, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (26167, 444, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (26168, 444, 73, 620);
INSERT INTO 'devicecapvalue' VALUES (26169, 444, 73, 622);
INSERT INTO 'devicecapvalue' VALUES (26170, 444, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (26171, 444, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (26172, 444, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (26173, 444, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (26174, 444, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (26175, 444, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (26176, 444, 47, 620);
INSERT INTO 'devicecapvalue' VALUES (26177, 444, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (26178, 444, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (26179, 444, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (26180, 444, 49, 1031);
INSERT INTO 'devicecapvalue' VALUES (26181, 444, 53, 1841);
INSERT INTO 'devicecapvalue' VALUES (26182, 444, 53, 1514);
INSERT INTO 'devicecapvalue' VALUES (26183, 445, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (26184, 445, 74, 1775);
INSERT INTO 'devicecapvalue' VALUES (26185, 445, 160, 1491);
INSERT INTO 'devicecapvalue' VALUES (26186, 445, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (26187, 445, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (26188, 445, 76, 1731);
INSERT INTO 'devicecapvalue' VALUES (26189, 445, 77, 745);
INSERT INTO 'devicecapvalue' VALUES (26190, 445, 78, 1273);
INSERT INTO 'devicecapvalue' VALUES (26191, 445, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (26192, 445, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (26193, 445, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26194, 445, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (26195, 445, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (26196, 445, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26197, 445, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (26198, 445, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (26199, 445, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (26200, 445, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (26201, 445, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26202, 445, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26203, 445, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (26204, 445, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (26205, 445, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (26206, 445, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (26207, 445, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (26208, 445, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (26209, 445, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (26210, 445, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (26211, 445, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (26212, 445, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (26213, 445, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (26214, 445, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (26215, 445, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (26216, 445, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (26217, 445, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (26218, 445, 3, 1501);
INSERT INTO 'devicecapvalue' VALUES (26219, 445, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (26220, 445, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (26221, 445, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (26222, 445, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (26223, 445, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (26224, 445, 51, 1805);
INSERT INTO 'devicecapvalue' VALUES (26225, 445, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (26226, 445, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (26227, 445, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (26228, 445, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (26229, 445, 157, 1026);
INSERT INTO 'capvalue' VALUES (1842, 'Nokia7610Supernova/2.0 (04.82) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (26230, 445, 53, 1842);
INSERT INTO 'devicecapvalue' VALUES (26231, 446, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (26232, 446, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (26233, 446, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (26234, 446, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (26235, 446, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (26236, 446, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (26237, 446, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26238, 446, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26239, 446, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26240, 446, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (26241, 446, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (26242, 446, 3, 1501);
INSERT INTO 'devicecapvalue' VALUES (26243, 446, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (26244, 446, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (26245, 446, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (26246, 446, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (26247, 446, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (26248, 446, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (26249, 446, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (26250, 446, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (26251, 446, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (26252, 446, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (26253, 446, 157, 1026);
INSERT INTO 'capvalue' VALUES (1843, 'Mozilla/4.0 (compatible; MSIE 5.0; Series90/1.0 Nokia7700/2.04.0 Profile/MIDP-2.0 Configuration/CLDC-1.0)');
INSERT INTO 'devicecapvalue' VALUES (26254, 446, 53, 1843);
INSERT INTO 'capvalue' VALUES (1844, '2004-11-02');
INSERT INTO 'devicecapvalue' VALUES (26255, 447, 158, 1844);
INSERT INTO 'devicecapvalue' VALUES (26256, 447, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (26257, 447, 160, 1716);
INSERT INTO 'devicecapvalue' VALUES (26258, 447, 162, 612);
INSERT INTO 'devicecapvalue' VALUES (26259, 447, 173, 1694);
INSERT INTO 'capvalue' VALUES (1845, '\Devices\Nokia_Prototype_SDK_3_0\devices\Prototype_3_0_Nokia_7710_MIDP_Emulator');
INSERT INTO 'devicecapvalue' VALUES (26260, 447, 75, 1845);
INSERT INTO 'devicecapvalue' VALUES (26261, 447, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (26262, 447, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (26263, 447, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (26264, 447, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (26265, 447, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (26266, 447, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (26267, 447, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (26268, 447, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26269, 447, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26270, 447, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26271, 447, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (26272, 447, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (26273, 447, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (26274, 447, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (26275, 447, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (26276, 447, 88, 1534);
INSERT INTO 'capvalue' VALUES (1846, 'Symbian OS v7.0s');
INSERT INTO 'devicecapvalue' VALUES (26277, 447, 3, 1846);
INSERT INTO 'devicecapvalue' VALUES (26278, 447, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (26279, 447, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (26280, 447, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (26281, 447, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (26282, 447, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (26283, 447, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (26284, 447, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (26285, 447, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (26286, 447, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (26287, 447, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (26288, 447, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (26289, 447, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (26290, 447, 51, 669);
INSERT INTO 'capvalue' VALUES (1847, '90177536');
INSERT INTO 'devicecapvalue' VALUES (26291, 447, 52, 1847);
INSERT INTO 'devicecapvalue' VALUES (26292, 447, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (26293, 447, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (26294, 447, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (26295, 447, 157, 1504);
INSERT INTO 'capvalue' VALUES (1848, 'Mozilla/4.0 (compatible; MSIE 5.0; Series90/1.1 Nokia7710/c3.50.0 Profile/MIDP-2.0 Configuration/CLDC-1.0)');
INSERT INTO 'devicecapvalue' VALUES (26296, 447, 53, 1848);
INSERT INTO 'devicecapvalue' VALUES (26297, 448, 7, 1437);
INSERT INTO 'devicecapvalue' VALUES (26298, 448, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (26299, 448, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (26300, 448, 9, 963);
INSERT INTO 'devicecapvalue' VALUES (26301, 448, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (26302, 448, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (26303, 448, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (26304, 448, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (26305, 448, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (26306, 448, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (26307, 448, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (26308, 448, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (26309, 448, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (26310, 448, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (26311, 448, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26312, 448, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (26313, 448, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (26314, 448, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26315, 448, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (26316, 448, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (26317, 448, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (26318, 448, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (26319, 448, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26320, 448, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26321, 448, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (26322, 448, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (26323, 448, 19, 1392);
INSERT INTO 'devicecapvalue' VALUES (26324, 448, 20, 638);
INSERT INTO 'devicecapvalue' VALUES (26325, 448, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (26326, 448, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (26327, 448, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (26328, 448, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (26329, 448, 25, 1393);
INSERT INTO 'devicecapvalue' VALUES (26330, 448, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (26331, 448, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (26332, 448, 29, 1394);
INSERT INTO 'devicecapvalue' VALUES (26333, 448, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (26334, 448, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (26335, 448, 31, 932);
INSERT INTO 'devicecapvalue' VALUES (26336, 448, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (26337, 448, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (26338, 448, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (26339, 448, 35, 45);
INSERT INTO 'capvalue' VALUES (1849, 'Nokia7900/04.84');
INSERT INTO 'devicecapvalue' VALUES (26340, 448, 36, 1849);
INSERT INTO 'devicecapvalue' VALUES (26341, 448, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (26342, 448, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (26343, 448, 39, 866);
INSERT INTO 'devicecapvalue' VALUES (26344, 448, 39, 1439);
INSERT INTO 'devicecapvalue' VALUES (26345, 448, 39, 920);
INSERT INTO 'devicecapvalue' VALUES (26346, 448, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (26347, 448, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (26348, 448, 41, 1440);
INSERT INTO 'devicecapvalue' VALUES (26349, 448, 41, 1395);
INSERT INTO 'devicecapvalue' VALUES (26350, 448, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (26351, 448, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (26352, 448, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (26353, 448, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (26354, 448, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (26355, 448, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (26356, 448, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (26357, 448, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (26358, 448, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (26359, 448, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (26360, 448, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (26361, 448, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (26362, 448, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (26363, 448, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (26364, 448, 41, 1442);
INSERT INTO 'devicecapvalue' VALUES (26365, 448, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (26366, 448, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (26367, 448, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (26368, 448, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (26369, 448, 41, 871);
INSERT INTO 'devicecapvalue' VALUES (26370, 448, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (26371, 448, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (26372, 448, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (26373, 448, 41, 1396);
INSERT INTO 'devicecapvalue' VALUES (26374, 448, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (26375, 448, 41, 52);
INSERT INTO 'devicecapvalue' VALUES (26376, 448, 41, 1397);
INSERT INTO 'devicecapvalue' VALUES (26377, 448, 41, 1398);
INSERT INTO 'devicecapvalue' VALUES (26378, 448, 41, 1399);
INSERT INTO 'devicecapvalue' VALUES (26379, 448, 41, 1400);
INSERT INTO 'devicecapvalue' VALUES (26380, 448, 41, 1401);
INSERT INTO 'devicecapvalue' VALUES (26381, 448, 41, 1402);
INSERT INTO 'devicecapvalue' VALUES (26382, 448, 41, 1403);
INSERT INTO 'devicecapvalue' VALUES (26383, 448, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (26384, 448, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (26385, 448, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (26386, 448, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (26387, 448, 42, 1440);
INSERT INTO 'devicecapvalue' VALUES (26388, 448, 42, 1395);
INSERT INTO 'devicecapvalue' VALUES (26389, 448, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (26390, 448, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (26391, 448, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (26392, 448, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (26393, 448, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (26394, 448, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (26395, 448, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (26396, 448, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (26397, 448, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (26398, 448, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (26399, 448, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (26400, 448, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (26401, 448, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (26402, 448, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (26403, 448, 42, 1442);
INSERT INTO 'devicecapvalue' VALUES (26404, 448, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (26405, 448, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (26406, 448, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (26407, 448, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (26408, 448, 42, 871);
INSERT INTO 'devicecapvalue' VALUES (26409, 448, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (26410, 448, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (26411, 448, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (26412, 448, 42, 1396);
INSERT INTO 'devicecapvalue' VALUES (26413, 448, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (26414, 448, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (26415, 448, 42, 1397);
INSERT INTO 'devicecapvalue' VALUES (26416, 448, 42, 1398);
INSERT INTO 'devicecapvalue' VALUES (26417, 448, 42, 1399);
INSERT INTO 'devicecapvalue' VALUES (26418, 448, 42, 1400);
INSERT INTO 'devicecapvalue' VALUES (26419, 448, 42, 1401);
INSERT INTO 'devicecapvalue' VALUES (26420, 448, 42, 1402);
INSERT INTO 'devicecapvalue' VALUES (26421, 448, 42, 1403);
INSERT INTO 'devicecapvalue' VALUES (26422, 448, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (26423, 448, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (26424, 448, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (26425, 448, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (26426, 448, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (26427, 448, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (26428, 448, 45, 68);
INSERT INTO 'devicecapvalue' VALUES (26429, 448, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (26430, 448, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (26431, 448, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (26432, 448, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (26433, 448, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (26434, 448, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (26435, 448, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (26436, 448, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (26437, 448, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (26438, 448, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (26439, 448, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (26440, 448, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (26441, 448, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (26442, 448, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (26443, 448, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (26444, 448, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (26445, 448, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (26446, 448, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (26447, 448, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (26448, 448, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (26449, 448, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (26450, 448, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (26451, 448, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (26452, 448, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (26453, 448, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (26454, 448, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (26455, 448, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (26456, 448, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (26457, 448, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (26458, 448, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (26459, 448, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (26460, 448, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (26461, 448, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (26462, 448, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (26463, 448, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (26464, 448, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (26465, 448, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (26466, 448, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (26467, 448, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (26468, 448, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (26469, 448, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (26470, 448, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (26471, 448, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (26472, 448, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (26473, 448, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (26474, 448, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (26475, 448, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (26476, 448, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (26477, 448, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (26478, 448, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (26479, 448, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (26480, 448, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (26481, 448, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (26482, 448, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (26483, 448, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (26484, 448, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (26485, 448, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (26486, 448, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (26487, 448, 73, 1440);
INSERT INTO 'devicecapvalue' VALUES (26488, 448, 73, 1395);
INSERT INTO 'devicecapvalue' VALUES (26489, 448, 73, 57);
INSERT INTO 'devicecapvalue' VALUES (26490, 448, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (26491, 448, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (26492, 448, 73, 50);
INSERT INTO 'devicecapvalue' VALUES (26493, 448, 73, 60);
INSERT INTO 'devicecapvalue' VALUES (26494, 448, 73, 124);
INSERT INTO 'devicecapvalue' VALUES (26495, 448, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (26496, 448, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (26497, 448, 73, 62);
INSERT INTO 'devicecapvalue' VALUES (26498, 448, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (26499, 448, 73, 869);
INSERT INTO 'devicecapvalue' VALUES (26500, 448, 73, 886);
INSERT INTO 'devicecapvalue' VALUES (26501, 448, 73, 1441);
INSERT INTO 'devicecapvalue' VALUES (26502, 448, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (26503, 448, 73, 1442);
INSERT INTO 'devicecapvalue' VALUES (26504, 448, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (26505, 448, 73, 131);
INSERT INTO 'devicecapvalue' VALUES (26506, 448, 73, 132);
INSERT INTO 'devicecapvalue' VALUES (26507, 448, 73, 1255);
INSERT INTO 'devicecapvalue' VALUES (26508, 448, 73, 871);
INSERT INTO 'devicecapvalue' VALUES (26509, 448, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (26510, 448, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (26511, 448, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (26512, 448, 73, 1396);
INSERT INTO 'devicecapvalue' VALUES (26513, 448, 73, 66);
INSERT INTO 'devicecapvalue' VALUES (26514, 448, 73, 52);
INSERT INTO 'devicecapvalue' VALUES (26515, 448, 73, 1397);
INSERT INTO 'devicecapvalue' VALUES (26516, 448, 73, 1398);
INSERT INTO 'devicecapvalue' VALUES (26517, 448, 73, 1399);
INSERT INTO 'devicecapvalue' VALUES (26518, 448, 73, 1400);
INSERT INTO 'devicecapvalue' VALUES (26519, 448, 73, 1401);
INSERT INTO 'devicecapvalue' VALUES (26520, 448, 73, 1402);
INSERT INTO 'devicecapvalue' VALUES (26521, 448, 73, 1403);
INSERT INTO 'devicecapvalue' VALUES (26522, 448, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (26523, 448, 73, 1051);
INSERT INTO 'devicecapvalue' VALUES (26524, 448, 73, 67);
INSERT INTO 'devicecapvalue' VALUES (26525, 448, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (26526, 448, 47, 1440);
INSERT INTO 'devicecapvalue' VALUES (26527, 448, 47, 1446);
INSERT INTO 'devicecapvalue' VALUES (26528, 448, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (26529, 448, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (26530, 448, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (26531, 448, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (26532, 448, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (26533, 448, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (26534, 448, 49, 1031);
INSERT INTO 'capvalue' VALUES (1850, 'Nokia7900/2.0 (04.84) Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (26535, 448, 53, 1850);
INSERT INTO 'capvalue' VALUES (1851, '2005-04-07');
INSERT INTO 'devicecapvalue' VALUES (26536, 449, 158, 1851);
INSERT INTO 'devicecapvalue' VALUES (26537, 449, 1, 106);
INSERT INTO 'capvalue' VALUES (1852, 's640x480');
INSERT INTO 'devicecapvalue' VALUES (26538, 449, 160, 1852);
INSERT INTO 'devicecapvalue' VALUES (26539, 449, 7, 1761);
INSERT INTO 'devicecapvalue' VALUES (26540, 449, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (26541, 449, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (26542, 449, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (26543, 449, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (26544, 449, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (26545, 449, 13, 1548);
INSERT INTO 'devicecapvalue' VALUES (26546, 449, 76, 1772);
INSERT INTO 'devicecapvalue' VALUES (26547, 449, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (26548, 449, 78, 1542);
INSERT INTO 'devicecapvalue' VALUES (26549, 449, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (26550, 449, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26551, 449, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (26552, 449, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26553, 449, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (26554, 449, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26555, 449, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (26556, 449, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (26557, 449, 50, 1533);
INSERT INTO 'devicecapvalue' VALUES (26558, 449, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (26559, 449, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (26560, 449, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (26561, 449, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (26562, 449, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (26563, 449, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (26564, 449, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (26565, 449, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (26566, 449, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (26567, 449, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (26568, 449, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (26569, 449, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (26570, 449, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (26571, 449, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (26572, 449, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (26573, 449, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (26574, 449, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (26575, 449, 51, 1690);
INSERT INTO 'devicecapvalue' VALUES (26576, 449, 52, 1086);
INSERT INTO 'devicecapvalue' VALUES (26577, 449, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (26578, 449, 157, 1134);
INSERT INTO 'capvalue' VALUES (1853, 'Nokia8800');
INSERT INTO 'devicecapvalue' VALUES (26579, 449, 53, 1853);
INSERT INTO 'devicecapvalue' VALUES (26580, 450, 158, 1833);
INSERT INTO 'devicecapvalue' VALUES (26581, 450, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (26582, 450, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (26583, 450, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (26584, 450, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (26585, 450, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (26586, 450, 13, 1548);
INSERT INTO 'devicecapvalue' VALUES (26587, 450, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (26588, 450, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (26589, 450, 78, 1542);
INSERT INTO 'devicecapvalue' VALUES (26590, 450, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (26591, 450, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26592, 450, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (26593, 450, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26594, 450, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (26595, 450, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (26596, 450, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (26597, 450, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26598, 450, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26599, 450, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (26600, 450, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (26601, 450, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (26602, 450, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (26603, 450, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (26604, 450, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (26605, 450, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (26606, 450, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (26607, 450, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (26608, 450, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (26609, 450, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (26610, 450, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (26611, 450, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (26612, 450, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (26613, 450, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (26614, 450, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (26615, 450, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (26616, 450, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (26617, 450, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (26618, 450, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (26619, 450, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (26620, 450, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (26621, 450, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (26622, 450, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (26623, 450, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (26624, 450, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (26625, 450, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (26626, 450, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (26627, 450, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (26628, 450, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (26629, 450, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (26630, 451, 158, 1851);
INSERT INTO 'devicecapvalue' VALUES (26631, 451, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (26632, 451, 160, 1852);
INSERT INTO 'devicecapvalue' VALUES (26633, 451, 7, 1761);
INSERT INTO 'devicecapvalue' VALUES (26634, 451, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (26635, 451, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (26636, 451, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (26637, 451, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (26638, 451, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (26639, 451, 13, 1548);
INSERT INTO 'devicecapvalue' VALUES (26640, 451, 76, 1772);
INSERT INTO 'devicecapvalue' VALUES (26641, 451, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (26642, 451, 78, 1542);
INSERT INTO 'devicecapvalue' VALUES (26643, 451, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (26644, 451, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26645, 451, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (26646, 451, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26647, 451, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (26648, 451, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (26649, 451, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26650, 451, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (26651, 451, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (26652, 451, 50, 1533);
INSERT INTO 'devicecapvalue' VALUES (26653, 451, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (26654, 451, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (26655, 451, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (26656, 451, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (26657, 451, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (26658, 451, 3, 1414);
INSERT INTO 'devicecapvalue' VALUES (26659, 451, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (26660, 451, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (26661, 451, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (26662, 451, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (26663, 451, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (26664, 451, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (26665, 451, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (26666, 451, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (26667, 451, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (26668, 451, 51, 1690);
INSERT INTO 'devicecapvalue' VALUES (26669, 451, 52, 1086);
INSERT INTO 'devicecapvalue' VALUES (26670, 451, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (26671, 451, 157, 1134);
INSERT INTO 'capvalue' VALUES (1854, 'Nokia8801');
INSERT INTO 'devicecapvalue' VALUES (26672, 451, 53, 1854);
INSERT INTO 'capvalue' VALUES (1855, '2004-09-08');
INSERT INTO 'devicecapvalue' VALUES (26673, 452, 158, 1855);
INSERT INTO 'devicecapvalue' VALUES (26674, 452, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (26675, 452, 74, 1775);
INSERT INTO 'devicecapvalue' VALUES (26676, 452, 173, 1827);
INSERT INTO 'devicecapvalue' VALUES (26677, 452, 167, 1330);
INSERT INTO 'capvalue' VALUES (1856, '640x200');
INSERT INTO 'devicecapvalue' VALUES (26678, 452, 13, 1856);
INSERT INTO 'devicecapvalue' VALUES (26679, 452, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (26680, 452, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (26681, 452, 78, 1);
INSERT INTO 'capvalue' VALUES (1857, 'CDC/1.0');
INSERT INTO 'devicecapvalue' VALUES (26682, 452, 16, 1857);
INSERT INTO 'devicecapvalue' VALUES (26683, 452, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (26684, 452, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26685, 452, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26686, 452, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (26687, 452, 17, 25);
INSERT INTO 'capvalue' VALUES (1858, 'FP/1.0');
INSERT INTO 'devicecapvalue' VALUES (26688, 452, 6, 1858);
INSERT INTO 'devicecapvalue' VALUES (26689, 452, 6, 27);
INSERT INTO 'capvalue' VALUES (1859, 'PP/1.0');
INSERT INTO 'devicecapvalue' VALUES (26690, 452, 6, 1859);
INSERT INTO 'devicecapvalue' VALUES (26691, 452, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (26692, 452, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (26693, 452, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (26694, 452, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (26695, 452, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (26696, 452, 3, 1846);
INSERT INTO 'devicecapvalue' VALUES (26697, 452, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (26698, 452, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (26699, 452, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (26700, 452, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (26701, 452, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (26702, 452, 5, 1008);
INSERT INTO 'devicecapvalue' VALUES (26703, 452, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (26704, 452, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (26705, 452, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (26706, 452, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (26707, 452, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (26708, 452, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (26709, 452, 51, 669);
INSERT INTO 'capvalue' VALUES (1860, '83886080');
INSERT INTO 'devicecapvalue' VALUES (26710, 452, 52, 1860);
INSERT INTO 'devicecapvalue' VALUES (26711, 452, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (26712, 452, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (26713, 452, 157, 1026);
INSERT INTO 'capvalue' VALUES (1861, 'realmedia');
INSERT INTO 'devicecapvalue' VALUES (26714, 452, 157, 1861);
INSERT INTO 'capvalue' VALUES (1862, 'Mozilla/4.0 (compatible; MSIE 5.0; Series80/2.0 Nokia9300/05.22 Profile/MIDP-2.0 Configuration/CLDC-1.1)');
INSERT INTO 'devicecapvalue' VALUES (26715, 452, 53, 1862);
INSERT INTO 'capvalue' VALUES (1863, '2005-11-29');
INSERT INTO 'devicecapvalue' VALUES (26716, 453, 158, 1863);
INSERT INTO 'devicecapvalue' VALUES (26717, 453, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (26718, 453, 173, 1694);
INSERT INTO 'devicecapvalue' VALUES (26719, 453, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (26720, 453, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (26721, 453, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (26722, 453, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (26723, 453, 13, 1856);
INSERT INTO 'devicecapvalue' VALUES (26724, 453, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (26725, 453, 16, 1857);
INSERT INTO 'devicecapvalue' VALUES (26726, 453, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (26727, 453, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26728, 453, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (26729, 453, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26730, 453, 6, 1858);
INSERT INTO 'devicecapvalue' VALUES (26731, 453, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (26732, 453, 6, 1859);
INSERT INTO 'devicecapvalue' VALUES (26733, 453, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (26734, 453, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (26735, 453, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (26736, 453, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (26737, 453, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (26738, 453, 3, 1846);
INSERT INTO 'devicecapvalue' VALUES (26739, 453, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (26740, 453, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (26741, 453, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (26742, 453, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (26743, 453, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (26744, 453, 5, 1008);
INSERT INTO 'devicecapvalue' VALUES (26745, 453, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (26746, 453, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (26747, 453, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (26748, 453, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (26749, 453, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (26750, 453, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (26751, 453, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (26752, 453, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (26753, 453, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (26754, 453, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (26755, 453, 52, 1860);
INSERT INTO 'devicecapvalue' VALUES (26756, 453, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (26757, 453, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (26758, 453, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (26759, 453, 157, 1504);
INSERT INTO 'capvalue' VALUES (1864, 'Mozilla/4.0 (compatible; MSIE 5.0; Series80/2.0 Nokia9300i Profile/MIDP-2.0 Configuration/CLDC-1.1)');
INSERT INTO 'devicecapvalue' VALUES (26760, 453, 53, 1864);
INSERT INTO 'capvalue' VALUES (1865, '2004-02-23');
INSERT INTO 'devicecapvalue' VALUES (26761, 454, 158, 1865);
INSERT INTO 'devicecapvalue' VALUES (26762, 454, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (26763, 454, 74, 1775);
INSERT INTO 'devicecapvalue' VALUES (26764, 454, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (26765, 454, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (26766, 454, 173, 1694);
INSERT INTO 'devicecapvalue' VALUES (26767, 454, 2, 1001);
INSERT INTO 'capvalue' VALUES (1866, 'noBlueToothObex');
INSERT INTO 'devicecapvalue' VALUES (26768, 454, 2, 1866);
INSERT INTO 'devicecapvalue' VALUES (26769, 454, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (26770, 454, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (26771, 454, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (26772, 454, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (26773, 454, 16, 1857);
INSERT INTO 'devicecapvalue' VALUES (26774, 454, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (26775, 454, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26776, 454, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26777, 454, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (26778, 454, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26779, 454, 6, 1858);
INSERT INTO 'devicecapvalue' VALUES (26780, 454, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (26781, 454, 6, 1859);
INSERT INTO 'devicecapvalue' VALUES (26782, 454, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (26783, 454, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (26784, 454, 3, 1846);
INSERT INTO 'devicecapvalue' VALUES (26785, 454, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (26786, 454, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (26787, 454, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (26788, 454, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (26789, 454, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (26790, 454, 5, 1008);
INSERT INTO 'devicecapvalue' VALUES (26791, 454, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (26792, 454, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (26793, 454, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (26794, 454, 51, 1418);
INSERT INTO 'devicecapvalue' VALUES (26795, 454, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (26796, 454, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (26797, 454, 51, 669);
INSERT INTO 'capvalue' VALUES (1867, '79691776');
INSERT INTO 'devicecapvalue' VALUES (26798, 454, 52, 1867);
INSERT INTO 'devicecapvalue' VALUES (26799, 454, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (26800, 454, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (26801, 454, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (26802, 454, 157, 1504);
INSERT INTO 'capvalue' VALUES (1868, 'Mozilla/4.0 (compatible; MSIE 5.0; Series80/2.0 Nokia9500');
INSERT INTO 'devicecapvalue' VALUES (26803, 454, 53, 1868);
INSERT INTO 'capvalue' VALUES (1869, '2006-05-18');
INSERT INTO 'devicecapvalue' VALUES (26804, 455, 158, 1869);
INSERT INTO 'devicecapvalue' VALUES (26805, 455, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (26806, 455, 160, 1724);
INSERT INTO 'capvalue' VALUES (1870, '240x234');
INSERT INTO 'devicecapvalue' VALUES (26807, 455, 7, 1870);
INSERT INTO 'devicecapvalue' VALUES (26808, 455, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (26809, 455, 2, 1001);
INSERT INTO 'capvalue' VALUES (1871, '28');
INSERT INTO 'devicecapvalue' VALUES (26810, 455, 10, 1871);
INSERT INTO 'devicecapvalue' VALUES (26811, 455, 11, 963);
INSERT INTO 'devicecapvalue' VALUES (26812, 455, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (26813, 455, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (26814, 455, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (26815, 455, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (26816, 455, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (26817, 455, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (26818, 455, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (26819, 455, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (26820, 455, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (26821, 455, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (26822, 455, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (26823, 455, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (26824, 455, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26825, 455, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (26826, 455, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (26827, 455, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26828, 455, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (26829, 455, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (26830, 455, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (26831, 455, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (26832, 455, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26833, 455, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26834, 455, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (26835, 455, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (26836, 455, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (26837, 455, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (26838, 455, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (26839, 455, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (26840, 455, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (26841, 455, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (26842, 455, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (26843, 455, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (26844, 455, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (26845, 455, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (26846, 455, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (26847, 455, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (26848, 455, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (26849, 455, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (26850, 455, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (26851, 455, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (26852, 455, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (26853, 455, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (26854, 455, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (26855, 455, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (26856, 455, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (26857, 455, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (26858, 455, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (26859, 455, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (26860, 455, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (26861, 455, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (26862, 455, 51, 1502);
INSERT INTO 'devicecapvalue' VALUES (26863, 455, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (26864, 455, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (26865, 455, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (26866, 455, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (26867, 455, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (26868, 455, 51, 1552);
INSERT INTO 'capvalue' VALUES (1872, 'waf');
INSERT INTO 'devicecapvalue' VALUES (26869, 455, 51, 1872);
INSERT INTO 'devicecapvalue' VALUES (26870, 455, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (26871, 455, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (26872, 455, 52, 1764);
INSERT INTO 'devicecapvalue' VALUES (26873, 455, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (26874, 455, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (26875, 455, 157, 1504);
INSERT INTO 'capvalue' VALUES (1873, 'Mozilla/5.0(SymbianOS/9.2; U; Series60/3.1 NokiaE51/1.00.000; Profile/MIDP-2.0 Configuration/CLDC-1.1;)AppleWebKit/413(KHTML');
INSERT INTO 'devicecapvalue' VALUES (26876, 455, 53, 1873);
INSERT INTO 'capvalue' VALUES (1874, 'like Gecko)Safari/413');
INSERT INTO 'devicecapvalue' VALUES (26877, 455, 53, 1874);
INSERT INTO 'devicecapvalue' VALUES (26878, 456, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (26879, 456, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (26880, 456, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (26881, 456, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (26882, 456, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (26883, 456, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (26884, 456, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (26885, 456, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (26886, 456, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (26887, 456, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (26888, 456, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (26889, 456, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (26890, 456, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (26891, 456, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (26892, 456, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (26893, 456, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (26894, 456, 15, 1566);
INSERT INTO 'devicecapvalue' VALUES (26895, 456, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (26896, 456, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (26897, 456, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (26898, 456, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (26899, 456, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (26900, 456, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (26901, 456, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26902, 456, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (26903, 456, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (26904, 456, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (26905, 456, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (26906, 456, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26907, 456, 17, 23);
INSERT INTO 'capvalue' VALUES (1875, 'nwmapi');
INSERT INTO 'devicecapvalue' VALUES (26908, 456, 17, 1875);
INSERT INTO 'devicecapvalue' VALUES (26909, 456, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (26910, 456, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (26911, 456, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (26912, 456, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (26913, 456, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (26914, 456, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26915, 456, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (26916, 456, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (26917, 456, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (26918, 456, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (26919, 456, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (26920, 456, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (26921, 456, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (26922, 456, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (26923, 456, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (26924, 456, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (26925, 456, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (26926, 456, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (26927, 456, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (26928, 456, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (26929, 456, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (26930, 456, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (26931, 456, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (26932, 456, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (26933, 456, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (26934, 456, 51, 1036);
INSERT INTO 'capvalue' VALUES (1876, 'acc+');
INSERT INTO 'devicecapvalue' VALUES (26935, 456, 51, 1876);
INSERT INTO 'devicecapvalue' VALUES (26936, 456, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (26937, 456, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (26938, 456, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (26939, 456, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (26940, 456, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (26941, 456, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (26942, 456, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (26943, 456, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (26944, 456, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (26945, 456, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (26946, 456, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (26947, 456, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (26948, 456, 51, 1160);
INSERT INTO 'capvalue' VALUES (1877, '136314880');
INSERT INTO 'devicecapvalue' VALUES (26949, 456, 52, 1877);
INSERT INTO 'devicecapvalue' VALUES (26950, 456, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (26951, 456, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (26952, 456, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (26953, 456, 157, 1504);
INSERT INTO 'capvalue' VALUES (1878, '240x245');
INSERT INTO 'devicecapvalue' VALUES (26954, 457, 7, 1878);
INSERT INTO 'devicecapvalue' VALUES (26955, 457, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (26956, 457, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (26957, 457, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (26958, 457, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (26959, 457, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (26960, 457, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (26961, 457, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (26962, 457, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (26963, 457, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (26964, 457, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (26965, 457, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (26966, 457, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (26967, 457, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (26968, 457, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (26969, 457, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (26970, 457, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (26971, 457, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (26972, 457, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (26973, 457, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (26974, 457, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (26975, 457, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (26976, 457, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (26977, 457, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (26978, 457, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (26979, 457, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26980, 457, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (26981, 457, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (26982, 457, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (26983, 457, 18, 625);
INSERT INTO 'devicecapvalue' VALUES (26984, 457, 19, 29);
INSERT INTO 'capvalue' VALUES (1879, '97');
INSERT INTO 'devicecapvalue' VALUES (26985, 457, 20, 1879);
INSERT INTO 'devicecapvalue' VALUES (26986, 457, 21, 237);
INSERT INTO 'capvalue' VALUES (1880, '115');
INSERT INTO 'devicecapvalue' VALUES (26987, 457, 22, 1880);
INSERT INTO 'devicecapvalue' VALUES (26988, 457, 23, 607);
INSERT INTO 'capvalue' VALUES (1881, '122');
INSERT INTO 'devicecapvalue' VALUES (26989, 457, 24, 1881);
INSERT INTO 'devicecapvalue' VALUES (26990, 457, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (26991, 457, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (26992, 457, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (26993, 457, 28, 606);
INSERT INTO 'devicecapvalue' VALUES (26994, 457, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (26995, 457, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (26996, 457, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (26997, 457, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (26998, 457, 32, 1611);
INSERT INTO 'devicecapvalue' VALUES (26999, 457, 32, 1612);
INSERT INTO 'devicecapvalue' VALUES (27000, 457, 32, 1613);
INSERT INTO 'devicecapvalue' VALUES (27001, 457, 32, 1614);
INSERT INTO 'devicecapvalue' VALUES (27002, 457, 32, 1615);
INSERT INTO 'devicecapvalue' VALUES (27003, 457, 32, 1616);
INSERT INTO 'devicecapvalue' VALUES (27004, 457, 32, 1617);
INSERT INTO 'devicecapvalue' VALUES (27005, 457, 32, 1618);
INSERT INTO 'devicecapvalue' VALUES (27006, 457, 32, 1619);
INSERT INTO 'devicecapvalue' VALUES (27007, 457, 32, 1620);
INSERT INTO 'devicecapvalue' VALUES (27008, 457, 32, 1621);
INSERT INTO 'devicecapvalue' VALUES (27009, 457, 32, 1622);
INSERT INTO 'devicecapvalue' VALUES (27010, 457, 32, 1623);
INSERT INTO 'devicecapvalue' VALUES (27011, 457, 32, 1624);
INSERT INTO 'devicecapvalue' VALUES (27012, 457, 32, 1625);
INSERT INTO 'devicecapvalue' VALUES (27013, 457, 32, 1626);
INSERT INTO 'devicecapvalue' VALUES (27014, 457, 32, 1627);
INSERT INTO 'devicecapvalue' VALUES (27015, 457, 32, 1628);
INSERT INTO 'devicecapvalue' VALUES (27016, 457, 32, 1629);
INSERT INTO 'devicecapvalue' VALUES (27017, 457, 32, 1630);
INSERT INTO 'devicecapvalue' VALUES (27018, 457, 32, 1631);
INSERT INTO 'devicecapvalue' VALUES (27019, 457, 32, 1632);
INSERT INTO 'devicecapvalue' VALUES (27020, 457, 32, 1633);
INSERT INTO 'devicecapvalue' VALUES (27021, 457, 32, 1634);
INSERT INTO 'devicecapvalue' VALUES (27022, 457, 32, 1635);
INSERT INTO 'devicecapvalue' VALUES (27023, 457, 32, 1636);
INSERT INTO 'devicecapvalue' VALUES (27024, 457, 32, 1637);
INSERT INTO 'devicecapvalue' VALUES (27025, 457, 32, 1638);
INSERT INTO 'devicecapvalue' VALUES (27026, 457, 32, 1639);
INSERT INTO 'devicecapvalue' VALUES (27027, 457, 32, 1640);
INSERT INTO 'devicecapvalue' VALUES (27028, 457, 32, 1641);
INSERT INTO 'devicecapvalue' VALUES (27029, 457, 32, 1642);
INSERT INTO 'devicecapvalue' VALUES (27030, 457, 32, 1643);
INSERT INTO 'devicecapvalue' VALUES (27031, 457, 32, 1644);
INSERT INTO 'devicecapvalue' VALUES (27032, 457, 32, 1645);
INSERT INTO 'devicecapvalue' VALUES (27033, 457, 32, 1646);
INSERT INTO 'devicecapvalue' VALUES (27034, 457, 32, 1647);
INSERT INTO 'devicecapvalue' VALUES (27035, 457, 32, 1648);
INSERT INTO 'devicecapvalue' VALUES (27036, 457, 32, 1649);
INSERT INTO 'devicecapvalue' VALUES (27037, 457, 32, 1650);
INSERT INTO 'devicecapvalue' VALUES (27038, 457, 32, 1651);
INSERT INTO 'devicecapvalue' VALUES (27039, 457, 32, 1652);
INSERT INTO 'devicecapvalue' VALUES (27040, 457, 32, 1653);
INSERT INTO 'devicecapvalue' VALUES (27041, 457, 32, 1654);
INSERT INTO 'devicecapvalue' VALUES (27042, 457, 32, 1655);
INSERT INTO 'devicecapvalue' VALUES (27043, 457, 32, 1656);
INSERT INTO 'devicecapvalue' VALUES (27044, 457, 32, 1657);
INSERT INTO 'devicecapvalue' VALUES (27045, 457, 32, 1658);
INSERT INTO 'devicecapvalue' VALUES (27046, 457, 32, 1659);
INSERT INTO 'devicecapvalue' VALUES (27047, 457, 32, 1660);
INSERT INTO 'devicecapvalue' VALUES (27048, 457, 32, 1661);
INSERT INTO 'devicecapvalue' VALUES (27049, 457, 32, 1662);
INSERT INTO 'devicecapvalue' VALUES (27050, 457, 32, 1663);
INSERT INTO 'devicecapvalue' VALUES (27051, 457, 32, 1664);
INSERT INTO 'devicecapvalue' VALUES (27052, 457, 32, 1665);
INSERT INTO 'devicecapvalue' VALUES (27053, 457, 32, 1666);
INSERT INTO 'devicecapvalue' VALUES (27054, 457, 32, 1667);
INSERT INTO 'devicecapvalue' VALUES (27055, 457, 32, 1668);
INSERT INTO 'devicecapvalue' VALUES (27056, 457, 32, 1669);
INSERT INTO 'devicecapvalue' VALUES (27057, 457, 32, 1670);
INSERT INTO 'devicecapvalue' VALUES (27058, 457, 32, 1671);
INSERT INTO 'devicecapvalue' VALUES (27059, 457, 32, 1672);
INSERT INTO 'devicecapvalue' VALUES (27060, 457, 32, 1673);
INSERT INTO 'devicecapvalue' VALUES (27061, 457, 32, 1674);
INSERT INTO 'devicecapvalue' VALUES (27062, 457, 32, 852);
INSERT INTO 'devicecapvalue' VALUES (27063, 457, 32, 1675);
INSERT INTO 'devicecapvalue' VALUES (27064, 457, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (27065, 457, 32, 1676);
INSERT INTO 'devicecapvalue' VALUES (27066, 457, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (27067, 457, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (27068, 457, 35, 45);
INSERT INTO 'capvalue' VALUES (1882, 'NokiaE55-1/021.013/sw_platform=S60;sw_platform_version=3.2;java_build_version=1.0.5');
INSERT INTO 'devicecapvalue' VALUES (27069, 457, 36, 1882);
INSERT INTO 'devicecapvalue' VALUES (27070, 457, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (27071, 457, 38, 1577);
INSERT INTO 'devicecapvalue' VALUES (27072, 457, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (27073, 457, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (27074, 457, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (27075, 457, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (27076, 457, 39, 1050);
INSERT INTO 'devicecapvalue' VALUES (27077, 457, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (27078, 457, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (27079, 457, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (27080, 457, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (27081, 457, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (27082, 457, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (27083, 457, 40, 125);
INSERT INTO 'devicecapvalue' VALUES (27084, 457, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (27085, 457, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (27086, 457, 40, 1580);
INSERT INTO 'devicecapvalue' VALUES (27087, 457, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (27088, 457, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (27089, 457, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (27090, 457, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (27091, 457, 41, 1275);
INSERT INTO 'devicecapvalue' VALUES (27092, 457, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (27093, 457, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (27094, 457, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (27095, 457, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (27096, 457, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (27097, 457, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (27098, 457, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (27099, 457, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (27100, 457, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (27101, 457, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (27102, 457, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (27103, 457, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (27104, 457, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (27105, 457, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (27106, 457, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (27107, 457, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (27108, 457, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (27109, 457, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (27110, 457, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (27111, 457, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (27112, 457, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (27113, 457, 41, 1583);
INSERT INTO 'devicecapvalue' VALUES (27114, 457, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (27115, 457, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (27116, 457, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (27117, 457, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (27118, 457, 41, 1584);
INSERT INTO 'devicecapvalue' VALUES (27119, 457, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (27120, 457, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (27121, 457, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (27122, 457, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (27123, 457, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (27124, 457, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (27125, 457, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (27126, 457, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (27127, 457, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (27128, 457, 42, 1275);
INSERT INTO 'devicecapvalue' VALUES (27129, 457, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (27130, 457, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (27131, 457, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (27132, 457, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (27133, 457, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (27134, 457, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (27135, 457, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (27136, 457, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (27137, 457, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (27138, 457, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (27139, 457, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (27140, 457, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (27141, 457, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (27142, 457, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (27143, 457, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (27144, 457, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (27145, 457, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (27146, 457, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (27147, 457, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (27148, 457, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (27149, 457, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (27150, 457, 42, 1583);
INSERT INTO 'devicecapvalue' VALUES (27151, 457, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (27152, 457, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (27153, 457, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (27154, 457, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (27155, 457, 42, 1584);
INSERT INTO 'devicecapvalue' VALUES (27156, 457, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (27157, 457, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (27158, 457, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (27159, 457, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (27160, 457, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (27161, 457, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (27162, 457, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (27163, 457, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (27164, 457, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (27165, 457, 45, 1585);
INSERT INTO 'devicecapvalue' VALUES (27166, 457, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (27167, 457, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (27168, 457, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (27169, 457, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (27170, 457, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (27171, 457, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (27172, 457, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (27173, 457, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (27174, 457, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (27175, 457, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (27176, 457, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (27177, 457, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (27178, 457, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (27179, 457, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (27180, 457, 46, 1586);
INSERT INTO 'devicecapvalue' VALUES (27181, 457, 46, 1587);
INSERT INTO 'devicecapvalue' VALUES (27182, 457, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (27183, 457, 46, 1588);
INSERT INTO 'devicecapvalue' VALUES (27184, 457, 46, 1589);
INSERT INTO 'devicecapvalue' VALUES (27185, 457, 46, 1590);
INSERT INTO 'devicecapvalue' VALUES (27186, 457, 46, 1591);
INSERT INTO 'devicecapvalue' VALUES (27187, 457, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (27188, 457, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (27189, 457, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (27190, 457, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (27191, 457, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (27192, 457, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (27193, 457, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (27194, 457, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (27195, 457, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (27196, 457, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (27197, 457, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (27198, 457, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (27199, 457, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (27200, 457, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (27201, 457, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (27202, 457, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (27203, 457, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (27204, 457, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (27205, 457, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (27206, 457, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (27207, 457, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (27208, 457, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (27209, 457, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (27210, 457, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (27211, 457, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (27212, 457, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (27213, 457, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (27214, 457, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (27215, 457, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (27216, 457, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (27217, 457, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (27218, 457, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (27219, 457, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (27220, 457, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (27221, 457, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (27222, 457, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (27223, 457, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (27224, 457, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (27225, 457, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (27226, 457, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (27227, 457, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (27228, 457, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (27229, 457, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (27230, 457, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (27231, 457, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (27232, 457, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (27233, 457, 47, 56);
INSERT INTO 'devicecapvalue' VALUES (27234, 457, 47, 868);
INSERT INTO 'devicecapvalue' VALUES (27235, 457, 47, 1275);
INSERT INTO 'devicecapvalue' VALUES (27236, 457, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (27237, 457, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (27238, 457, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (27239, 457, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (27240, 457, 47, 1684);
INSERT INTO 'devicecapvalue' VALUES (27241, 457, 47, 986);
INSERT INTO 'devicecapvalue' VALUES (27242, 457, 47, 988);
INSERT INTO 'devicecapvalue' VALUES (27243, 457, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (27244, 457, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (27245, 457, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (27246, 457, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (27247, 457, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (27248, 457, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (27249, 457, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (27250, 457, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (27251, 457, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (27252, 457, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (27253, 457, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (27254, 457, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (27255, 457, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (27256, 457, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (27257, 457, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (27258, 457, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (27259, 457, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (27260, 457, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (27261, 457, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (27262, 457, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (27263, 457, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (27264, 457, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (27265, 457, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (27266, 457, 48, 824);
INSERT INTO 'devicecapvalue' VALUES (27267, 457, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (27268, 457, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (27269, 457, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (27270, 457, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (27271, 457, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (27272, 457, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (27273, 457, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (27274, 457, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (27275, 457, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (27276, 457, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (27277, 457, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (27278, 457, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (27279, 457, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (27280, 457, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (27281, 457, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (27282, 457, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (27283, 457, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (27284, 457, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (27285, 457, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (27286, 457, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (27287, 457, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (27288, 457, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (27289, 457, 48, 1685);
INSERT INTO 'devicecapvalue' VALUES (27290, 457, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (27291, 457, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (27292, 457, 48, 1686);
INSERT INTO 'devicecapvalue' VALUES (27293, 457, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (27294, 457, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (27295, 457, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (27296, 457, 48, 830);
INSERT INTO 'capvalue' VALUES (1883, '312832');
INSERT INTO 'devicecapvalue' VALUES (27297, 457, 49, 1883);
INSERT INTO 'capvalue' VALUES (1884, '2005-10-12');
INSERT INTO 'devicecapvalue' VALUES (27298, 458, 158, 1884);
INSERT INTO 'devicecapvalue' VALUES (27299, 458, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (27300, 458, 173, 1410);
INSERT INTO 'capvalue' VALUES (1885, '352x416');
INSERT INTO 'devicecapvalue' VALUES (27301, 458, 13, 1885);
INSERT INTO 'devicecapvalue' VALUES (27302, 458, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (27303, 458, 77, 1341);
INSERT INTO 'devicecapvalue' VALUES (27304, 458, 78, 1341);
INSERT INTO 'devicecapvalue' VALUES (27305, 458, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (27306, 458, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (27307, 458, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (27308, 458, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (27309, 458, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (27310, 458, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (27311, 458, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (27312, 458, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (27313, 458, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (27314, 458, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27315, 458, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27316, 458, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (27317, 458, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (27318, 458, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (27319, 458, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (27320, 458, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (27321, 458, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (27322, 458, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (27323, 458, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (27324, 458, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (27325, 458, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (27326, 458, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (27327, 458, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (27328, 458, 4, 671);
INSERT INTO 'devicecapvalue' VALUES (27329, 458, 5, 672);
INSERT INTO 'devicecapvalue' VALUES (27330, 458, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (27331, 458, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (27332, 458, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (27333, 458, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (27334, 458, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (27335, 458, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (27336, 458, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (27337, 458, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (27338, 458, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (27339, 458, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (27340, 458, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (27341, 458, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (27342, 458, 51, 1085);
INSERT INTO 'capvalue' VALUES (1886, '78643200');
INSERT INTO 'devicecapvalue' VALUES (27343, 458, 52, 1886);
INSERT INTO 'devicecapvalue' VALUES (27344, 458, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (27345, 458, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (27346, 458, 157, 1504);
INSERT INTO 'capvalue' VALUES (1887, 'Mozilla/5.0 (SymbianOS/9.1; U; en-us) AppleWebKit/413 (KHTML');
INSERT INTO 'devicecapvalue' VALUES (27347, 458, 53, 1887);
INSERT INTO 'capvalue' VALUES (1888, 'like Gecko) Safari/413 es60');
INSERT INTO 'devicecapvalue' VALUES (27348, 458, 53, 1888);
INSERT INTO 'devicecapvalue' VALUES (27349, 459, 158, 1884);
INSERT INTO 'devicecapvalue' VALUES (27350, 459, 1, 649);
INSERT INTO 'capvalue' VALUES (1889, 'NormalKeyMappedToFire');
INSERT INTO 'devicecapvalue' VALUES (27351, 459, 74, 1889);
INSERT INTO 'devicecapvalue' VALUES (27352, 459, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (27353, 459, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (27354, 459, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (27355, 459, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (27356, 459, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (27357, 459, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (27358, 459, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (27359, 459, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (27360, 459, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (27361, 459, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (27362, 459, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (27363, 459, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (27364, 459, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27365, 459, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27366, 459, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (27367, 459, 6, 27);
INSERT INTO 'cap' VALUES (210, 'key.AddSymbolKey2', 1);
INSERT INTO 'devicecapvalue' VALUES (27368, 459, 210, 1391);
INSERT INTO 'devicecapvalue' VALUES (27369, 459, 94, 625);
INSERT INTO 'devicecapvalue' VALUES (27370, 459, 95, 693);
INSERT INTO 'devicecapvalue' VALUES (27371, 459, 96, 694);
INSERT INTO 'devicecapvalue' VALUES (27372, 459, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (27373, 459, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (27374, 459, 3, 1551);
INSERT INTO 'cap' VALUES (211, 'polish.TextField.numerickeys.0', 1);
INSERT INTO 'capvalue' VALUES (1890, 'm');
INSERT INTO 'devicecapvalue' VALUES (27375, 459, 211, 1890);
INSERT INTO 'cap' VALUES (212, 'polish.TextField.numerickeys.1', 1);
INSERT INTO 'capvalue' VALUES (1891, 'r');
INSERT INTO 'devicecapvalue' VALUES (27376, 459, 212, 1891);
INSERT INTO 'cap' VALUES (213, 'polish.TextField.numerickeys.2', 1);
INSERT INTO 'capvalue' VALUES (1892, 't');
INSERT INTO 'devicecapvalue' VALUES (27377, 459, 213, 1892);
INSERT INTO 'cap' VALUES (214, 'polish.TextField.numerickeys.3', 1);
INSERT INTO 'capvalue' VALUES (1893, 'zy');
INSERT INTO 'devicecapvalue' VALUES (27378, 459, 214, 1893);
INSERT INTO 'cap' VALUES (215, 'polish.TextField.numerickeys.4', 1);
INSERT INTO 'capvalue' VALUES (1894, 'f');
INSERT INTO 'devicecapvalue' VALUES (27379, 459, 215, 1894);
INSERT INTO 'cap' VALUES (216, 'polish.TextField.numerickeys.5', 1);
INSERT INTO 'capvalue' VALUES (1895, 'g');
INSERT INTO 'devicecapvalue' VALUES (27380, 459, 216, 1895);
INSERT INTO 'cap' VALUES (217, 'polish.TextField.numerickeys.6', 1);
INSERT INTO 'capvalue' VALUES (1896, 'h');
INSERT INTO 'devicecapvalue' VALUES (27381, 459, 217, 1896);
INSERT INTO 'cap' VALUES (218, 'polish.TextField.numerickeys.7', 1);
INSERT INTO 'capvalue' VALUES (1897, 'v');
INSERT INTO 'devicecapvalue' VALUES (27382, 459, 218, 1897);
INSERT INTO 'cap' VALUES (219, 'polish.TextField.numerickeys.8', 1);
INSERT INTO 'capvalue' VALUES (1898, 'b');
INSERT INTO 'devicecapvalue' VALUES (27383, 459, 219, 1898);
INSERT INTO 'cap' VALUES (220, 'polish.TextField.numerickeys.9', 1);
INSERT INTO 'capvalue' VALUES (1899, 'n');
INSERT INTO 'devicecapvalue' VALUES (27384, 459, 220, 1899);
INSERT INTO 'devicecapvalue' VALUES (27385, 459, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (27386, 459, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (27387, 459, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (27388, 459, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (27389, 459, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (27390, 459, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (27391, 459, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (27392, 459, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (27393, 459, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (27394, 459, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (27395, 459, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (27396, 459, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (27397, 459, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (27398, 459, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (27399, 459, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (27400, 459, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (27401, 459, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (27402, 459, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (27403, 459, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (27404, 459, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (27405, 459, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (27406, 459, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (27407, 459, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (27408, 459, 52, 1886);
INSERT INTO 'devicecapvalue' VALUES (27409, 459, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (27410, 459, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (27411, 459, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (27412, 459, 53, 1887);
INSERT INTO 'capvalue' VALUES (1900, 'like Gecko) Safari/413 es61');
INSERT INTO 'devicecapvalue' VALUES (27413, 459, 53, 1900);
INSERT INTO 'devicecapvalue' VALUES (27414, 460, 158, 1714);
INSERT INTO 'devicecapvalue' VALUES (27415, 460, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (27416, 460, 74, 1889);
INSERT INTO 'devicecapvalue' VALUES (27417, 460, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (27418, 460, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (27419, 460, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (27420, 460, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (27421, 460, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (27422, 460, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (27423, 460, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (27424, 460, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (27425, 460, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (27426, 460, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (27427, 460, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (27428, 460, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (27429, 460, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (27430, 460, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (27431, 460, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (27432, 460, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (27433, 460, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (27434, 460, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27435, 460, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27436, 460, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (27437, 460, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (27438, 460, 210, 1391);
INSERT INTO 'devicecapvalue' VALUES (27439, 460, 94, 625);
INSERT INTO 'devicecapvalue' VALUES (27440, 460, 95, 693);
INSERT INTO 'devicecapvalue' VALUES (27441, 460, 96, 694);
INSERT INTO 'devicecapvalue' VALUES (27442, 460, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (27443, 460, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (27444, 460, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (27445, 460, 211, 1890);
INSERT INTO 'devicecapvalue' VALUES (27446, 460, 212, 1891);
INSERT INTO 'devicecapvalue' VALUES (27447, 460, 213, 1892);
INSERT INTO 'devicecapvalue' VALUES (27448, 460, 214, 1893);
INSERT INTO 'devicecapvalue' VALUES (27449, 460, 215, 1894);
INSERT INTO 'devicecapvalue' VALUES (27450, 460, 216, 1895);
INSERT INTO 'devicecapvalue' VALUES (27451, 460, 217, 1896);
INSERT INTO 'devicecapvalue' VALUES (27452, 460, 218, 1897);
INSERT INTO 'devicecapvalue' VALUES (27453, 460, 219, 1898);
INSERT INTO 'devicecapvalue' VALUES (27454, 460, 220, 1899);
INSERT INTO 'devicecapvalue' VALUES (27455, 460, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (27456, 460, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (27457, 460, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (27458, 460, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (27459, 460, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (27460, 460, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (27461, 460, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (27462, 460, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (27463, 460, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (27464, 460, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (27465, 460, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (27466, 460, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (27467, 460, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (27468, 460, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (27469, 460, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (27470, 460, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (27471, 460, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (27472, 460, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (27473, 460, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (27474, 460, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (27475, 460, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (27476, 460, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (27477, 460, 51, 1085);
INSERT INTO 'capvalue' VALUES (1901, '62914560');
INSERT INTO 'devicecapvalue' VALUES (27478, 460, 52, 1901);
INSERT INTO 'devicecapvalue' VALUES (27479, 460, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (27480, 460, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (27481, 460, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (27482, 460, 53, 1887);
INSERT INTO 'capvalue' VALUES (1902, 'like Gecko) Safari/413 es61i');
INSERT INTO 'devicecapvalue' VALUES (27483, 460, 53, 1902);
INSERT INTO 'capvalue' VALUES (1903, '2006-08-16');
INSERT INTO 'devicecapvalue' VALUES (27484, 461, 158, 1903);
INSERT INTO 'devicecapvalue' VALUES (27485, 461, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (27486, 461, 74, 1889);
INSERT INTO 'devicecapvalue' VALUES (27487, 461, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (27488, 461, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (27489, 461, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (27490, 461, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (27491, 461, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (27492, 461, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (27493, 461, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (27494, 461, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (27495, 461, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (27496, 461, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (27497, 461, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (27498, 461, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (27499, 461, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (27500, 461, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (27501, 461, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (27502, 461, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (27503, 461, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27504, 461, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27505, 461, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (27506, 461, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (27507, 461, 210, 1391);
INSERT INTO 'devicecapvalue' VALUES (27508, 461, 94, 625);
INSERT INTO 'devicecapvalue' VALUES (27509, 461, 95, 693);
INSERT INTO 'devicecapvalue' VALUES (27510, 461, 96, 694);
INSERT INTO 'devicecapvalue' VALUES (27511, 461, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (27512, 461, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (27513, 461, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (27514, 461, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (27515, 461, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (27516, 461, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (27517, 461, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (27518, 461, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (27519, 461, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (27520, 461, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (27521, 461, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (27522, 461, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (27523, 461, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (27524, 461, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (27525, 461, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (27526, 461, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (27527, 461, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (27528, 461, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (27529, 461, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (27530, 461, 51, 1706);
INSERT INTO 'devicecapvalue' VALUES (27531, 461, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (27532, 461, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (27533, 461, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (27534, 461, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (27535, 461, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (27536, 461, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (27537, 461, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (27538, 461, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (27539, 461, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (27540, 461, 52, 1860);
INSERT INTO 'devicecapvalue' VALUES (27541, 461, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (27542, 461, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (27543, 461, 157, 1504);
INSERT INTO 'capvalue' VALUES (1904, 'NokiaE62-1/3.0 (2.0618.06.17); SymbianOS/9.1 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1)');
INSERT INTO 'devicecapvalue' VALUES (27544, 461, 53, 1904);
INSERT INTO 'devicecapvalue' VALUES (27545, 462, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (27546, 462, 192, 15);
INSERT INTO 'devicecapvalue' VALUES (27547, 462, 74, 1889);
INSERT INTO 'capvalue' VALUES (1905, '320x198');
INSERT INTO 'devicecapvalue' VALUES (27548, 462, 7, 1905);
INSERT INTO 'devicecapvalue' VALUES (27549, 462, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (27550, 462, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (27551, 462, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (27552, 462, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (27553, 462, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (27554, 462, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (27555, 462, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (27556, 462, 14, 15);
INSERT INTO 'cap' VALUES (221, 'imagecreateformat', 1);
INSERT INTO 'devicecapvalue' VALUES (27557, 462, 221, 16);
INSERT INTO 'devicecapvalue' VALUES (27558, 462, 221, 17);
INSERT INTO 'devicecapvalue' VALUES (27559, 462, 221, 18);
INSERT INTO 'devicecapvalue' VALUES (27560, 462, 221, 19);
INSERT INTO 'devicecapvalue' VALUES (27561, 462, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (27562, 462, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (27563, 462, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (27564, 462, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (27565, 462, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (27566, 462, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (27567, 462, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (27568, 462, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (27569, 462, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (27570, 462, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (27571, 462, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (27572, 462, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27573, 462, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27574, 462, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (27575, 462, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (27576, 462, 210, 1391);
INSERT INTO 'devicecapvalue' VALUES (27577, 462, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (27578, 462, 20, 1879);
INSERT INTO 'devicecapvalue' VALUES (27579, 462, 21, 237);
INSERT INTO 'devicecapvalue' VALUES (27580, 462, 22, 1880);
INSERT INTO 'devicecapvalue' VALUES (27581, 462, 23, 607);
INSERT INTO 'devicecapvalue' VALUES (27582, 462, 24, 1881);
INSERT INTO 'devicecapvalue' VALUES (27583, 462, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (27584, 462, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (27585, 462, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (27586, 462, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (27587, 462, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (27588, 462, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (27589, 462, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (27590, 462, 38, 1577);
INSERT INTO 'devicecapvalue' VALUES (27591, 462, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (27592, 462, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (27593, 462, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (27594, 462, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (27595, 462, 39, 1050);
INSERT INTO 'devicecapvalue' VALUES (27596, 462, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (27597, 462, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (27598, 462, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (27599, 462, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (27600, 462, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (27601, 462, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (27602, 462, 40, 125);
INSERT INTO 'devicecapvalue' VALUES (27603, 462, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (27604, 462, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (27605, 462, 40, 1580);
INSERT INTO 'devicecapvalue' VALUES (27606, 462, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (27607, 462, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (27608, 462, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (27609, 462, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (27610, 462, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (27611, 462, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (27612, 462, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (27613, 462, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (27614, 462, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (27615, 462, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (27616, 462, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (27617, 462, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (27618, 462, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (27619, 462, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (27620, 462, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (27621, 462, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (27622, 462, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (27623, 462, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (27624, 462, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (27625, 462, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (27626, 462, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (27627, 462, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (27628, 462, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (27629, 462, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (27630, 462, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (27631, 462, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (27632, 462, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (27633, 462, 41, 1584);
INSERT INTO 'devicecapvalue' VALUES (27634, 462, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (27635, 462, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (27636, 462, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (27637, 462, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (27638, 462, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (27639, 462, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (27640, 462, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (27641, 462, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (27642, 462, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (27643, 462, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (27644, 462, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (27645, 462, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (27646, 462, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (27647, 462, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (27648, 462, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (27649, 462, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (27650, 462, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (27651, 462, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (27652, 462, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (27653, 462, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (27654, 462, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (27655, 462, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (27656, 462, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (27657, 462, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (27658, 462, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (27659, 462, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (27660, 462, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (27661, 462, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (27662, 462, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (27663, 462, 42, 1584);
INSERT INTO 'devicecapvalue' VALUES (27664, 462, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (27665, 462, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (27666, 462, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (27667, 462, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (27668, 462, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (27669, 462, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (27670, 462, 45, 1585);
INSERT INTO 'devicecapvalue' VALUES (27671, 462, 58, 238);
INSERT INTO 'devicecapvalue' VALUES (27672, 462, 211, 1890);
INSERT INTO 'devicecapvalue' VALUES (27673, 462, 212, 1891);
INSERT INTO 'devicecapvalue' VALUES (27674, 462, 213, 1892);
INSERT INTO 'devicecapvalue' VALUES (27675, 462, 214, 1893);
INSERT INTO 'devicecapvalue' VALUES (27676, 462, 215, 1894);
INSERT INTO 'devicecapvalue' VALUES (27677, 462, 216, 1895);
INSERT INTO 'devicecapvalue' VALUES (27678, 462, 217, 1896);
INSERT INTO 'devicecapvalue' VALUES (27679, 462, 218, 1897);
INSERT INTO 'devicecapvalue' VALUES (27680, 462, 219, 1898);
INSERT INTO 'devicecapvalue' VALUES (27681, 462, 220, 1899);
INSERT INTO 'devicecapvalue' VALUES (27682, 462, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (27683, 462, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (27684, 462, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (27685, 462, 46, 1586);
INSERT INTO 'devicecapvalue' VALUES (27686, 462, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (27687, 462, 46, 1588);
INSERT INTO 'devicecapvalue' VALUES (27688, 462, 46, 1589);
INSERT INTO 'devicecapvalue' VALUES (27689, 462, 46, 1590);
INSERT INTO 'devicecapvalue' VALUES (27690, 462, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (27691, 462, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (27692, 462, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (27693, 462, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (27694, 462, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (27695, 462, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (27696, 462, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (27697, 462, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (27698, 462, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (27699, 462, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (27700, 462, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (27701, 462, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (27702, 462, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (27703, 462, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (27704, 462, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (27705, 462, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (27706, 462, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (27707, 462, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (27708, 462, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (27709, 462, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (27710, 462, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (27711, 462, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (27712, 462, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (27713, 462, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (27714, 462, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (27715, 462, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (27716, 462, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (27717, 462, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (27718, 462, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (27719, 462, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (27720, 462, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (27721, 462, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (27722, 462, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (27723, 462, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (27724, 462, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (27725, 462, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (27726, 462, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (27727, 462, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (27728, 462, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (27729, 462, 115, 1577);
INSERT INTO 'devicecapvalue' VALUES (27730, 462, 197, 1594);
INSERT INTO 'devicecapvalue' VALUES (27731, 462, 141, 238);
INSERT INTO 'devicecapvalue' VALUES (27732, 462, 117, 45);
INSERT INTO 'devicecapvalue' VALUES (27733, 462, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (27734, 462, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (27735, 462, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (27736, 462, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (27737, 462, 122, 244);
INSERT INTO 'capvalue' VALUES (1906, '85');
INSERT INTO 'devicecapvalue' VALUES (27738, 462, 198, 1906);
INSERT INTO 'devicecapvalue' VALUES (27739, 462, 183, 1448);
INSERT INTO 'capvalue' VALUES (1907, '356836020490741');
INSERT INTO 'devicecapvalue' VALUES (27740, 462, 200, 1907);
INSERT INTO 'capvalue' VALUES (1908, 'unavailable');
INSERT INTO 'devicecapvalue' VALUES (27741, 462, 201, 1908);
INSERT INTO 'capvalue' VALUES (1909, '()');
INSERT INTO 'devicecapvalue' VALUES (27742, 462, 202, 1909);
INSERT INTO 'devicecapvalue' VALUES (27743, 462, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (27744, 462, 185, 1602);
INSERT INTO 'devicecapvalue' VALUES (27745, 462, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (27746, 462, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (27747, 462, 102, 1603);
INSERT INTO 'devicecapvalue' VALUES (27748, 462, 103, 1604);
INSERT INTO 'devicecapvalue' VALUES (27749, 462, 104, 1605);
INSERT INTO 'capvalue' VALUES (1910, 'file:///c:/private/102033e6/midlets/[1016dd73]/scratch/');
INSERT INTO 'devicecapvalue' VALUES (27750, 462, 105, 1910);
INSERT INTO 'devicecapvalue' VALUES (27751, 462, 106, 1607);
INSERT INTO 'devicecapvalue' VALUES (27752, 462, 107, 1608);
INSERT INTO 'devicecapvalue' VALUES (27753, 462, 108, 1609);
INSERT INTO 'devicecapvalue' VALUES (27754, 462, 109, 1610);
INSERT INTO 'devicecapvalue' VALUES (27755, 462, 144, 45);
INSERT INTO 'capvalue' VALUES (1911, 'BT0');
INSERT INTO 'devicecapvalue' VALUES (27756, 462, 114, 1911);
INSERT INTO 'devicecapvalue' VALUES (27757, 462, 114, 1611);
INSERT INTO 'devicecapvalue' VALUES (27758, 462, 114, 1612);
INSERT INTO 'devicecapvalue' VALUES (27759, 462, 114, 1613);
INSERT INTO 'devicecapvalue' VALUES (27760, 462, 114, 1614);
INSERT INTO 'devicecapvalue' VALUES (27761, 462, 114, 1615);
INSERT INTO 'devicecapvalue' VALUES (27762, 462, 114, 1616);
INSERT INTO 'devicecapvalue' VALUES (27763, 462, 114, 1617);
INSERT INTO 'devicecapvalue' VALUES (27764, 462, 114, 1618);
INSERT INTO 'devicecapvalue' VALUES (27765, 462, 114, 1619);
INSERT INTO 'devicecapvalue' VALUES (27766, 462, 114, 1620);
INSERT INTO 'devicecapvalue' VALUES (27767, 462, 114, 1621);
INSERT INTO 'devicecapvalue' VALUES (27768, 462, 114, 1622);
INSERT INTO 'devicecapvalue' VALUES (27769, 462, 114, 1623);
INSERT INTO 'devicecapvalue' VALUES (27770, 462, 114, 1624);
INSERT INTO 'devicecapvalue' VALUES (27771, 462, 114, 1625);
INSERT INTO 'devicecapvalue' VALUES (27772, 462, 114, 1626);
INSERT INTO 'devicecapvalue' VALUES (27773, 462, 114, 1627);
INSERT INTO 'devicecapvalue' VALUES (27774, 462, 114, 1628);
INSERT INTO 'devicecapvalue' VALUES (27775, 462, 114, 1629);
INSERT INTO 'devicecapvalue' VALUES (27776, 462, 114, 1630);
INSERT INTO 'devicecapvalue' VALUES (27777, 462, 114, 1631);
INSERT INTO 'devicecapvalue' VALUES (27778, 462, 114, 1632);
INSERT INTO 'devicecapvalue' VALUES (27779, 462, 114, 1633);
INSERT INTO 'devicecapvalue' VALUES (27780, 462, 114, 1634);
INSERT INTO 'devicecapvalue' VALUES (27781, 462, 114, 1635);
INSERT INTO 'devicecapvalue' VALUES (27782, 462, 114, 1636);
INSERT INTO 'devicecapvalue' VALUES (27783, 462, 114, 1637);
INSERT INTO 'devicecapvalue' VALUES (27784, 462, 114, 1638);
INSERT INTO 'devicecapvalue' VALUES (27785, 462, 114, 1639);
INSERT INTO 'devicecapvalue' VALUES (27786, 462, 114, 1640);
INSERT INTO 'devicecapvalue' VALUES (27787, 462, 114, 1641);
INSERT INTO 'devicecapvalue' VALUES (27788, 462, 114, 1642);
INSERT INTO 'devicecapvalue' VALUES (27789, 462, 114, 1643);
INSERT INTO 'devicecapvalue' VALUES (27790, 462, 114, 1644);
INSERT INTO 'devicecapvalue' VALUES (27791, 462, 114, 1645);
INSERT INTO 'devicecapvalue' VALUES (27792, 462, 114, 1646);
INSERT INTO 'devicecapvalue' VALUES (27793, 462, 114, 1647);
INSERT INTO 'devicecapvalue' VALUES (27794, 462, 114, 1648);
INSERT INTO 'devicecapvalue' VALUES (27795, 462, 114, 1649);
INSERT INTO 'devicecapvalue' VALUES (27796, 462, 114, 1650);
INSERT INTO 'devicecapvalue' VALUES (27797, 462, 114, 1651);
INSERT INTO 'devicecapvalue' VALUES (27798, 462, 114, 1652);
INSERT INTO 'devicecapvalue' VALUES (27799, 462, 114, 1653);
INSERT INTO 'devicecapvalue' VALUES (27800, 462, 114, 1654);
INSERT INTO 'devicecapvalue' VALUES (27801, 462, 114, 1655);
INSERT INTO 'devicecapvalue' VALUES (27802, 462, 114, 1656);
INSERT INTO 'devicecapvalue' VALUES (27803, 462, 114, 1657);
INSERT INTO 'devicecapvalue' VALUES (27804, 462, 114, 1658);
INSERT INTO 'devicecapvalue' VALUES (27805, 462, 114, 1659);
INSERT INTO 'devicecapvalue' VALUES (27806, 462, 114, 1660);
INSERT INTO 'devicecapvalue' VALUES (27807, 462, 114, 1661);
INSERT INTO 'devicecapvalue' VALUES (27808, 462, 114, 1662);
INSERT INTO 'devicecapvalue' VALUES (27809, 462, 114, 1663);
INSERT INTO 'devicecapvalue' VALUES (27810, 462, 114, 1664);
INSERT INTO 'devicecapvalue' VALUES (27811, 462, 114, 1665);
INSERT INTO 'devicecapvalue' VALUES (27812, 462, 114, 1666);
INSERT INTO 'devicecapvalue' VALUES (27813, 462, 114, 1667);
INSERT INTO 'devicecapvalue' VALUES (27814, 462, 114, 1668);
INSERT INTO 'devicecapvalue' VALUES (27815, 462, 114, 1669);
INSERT INTO 'devicecapvalue' VALUES (27816, 462, 114, 1670);
INSERT INTO 'devicecapvalue' VALUES (27817, 462, 114, 1672);
INSERT INTO 'devicecapvalue' VALUES (27818, 462, 114, 1673);
INSERT INTO 'devicecapvalue' VALUES (27819, 462, 114, 1674);
INSERT INTO 'devicecapvalue' VALUES (27820, 462, 114, 1260);
INSERT INTO 'devicecapvalue' VALUES (27821, 462, 114, 1471);
INSERT INTO 'capvalue' VALUES (1912, 'USB0');
INSERT INTO 'devicecapvalue' VALUES (27822, 462, 114, 1912);
INSERT INTO 'devicecapvalue' VALUES (27823, 462, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (27824, 462, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (27825, 462, 204, 1677);
INSERT INTO 'devicecapvalue' VALUES (27826, 462, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (27827, 462, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (27828, 462, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (27829, 462, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (27830, 462, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (27831, 462, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (27832, 462, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (27833, 462, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (27834, 462, 67, 45);
INSERT INTO 'capvalue' VALUES (1913, 'NokiaE63-1/0.21.110');
INSERT INTO 'devicecapvalue' VALUES (27835, 462, 68, 1913);
INSERT INTO 'devicecapvalue' VALUES (27836, 462, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (27837, 462, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (27838, 462, 132, 1577);
INSERT INTO 'devicecapvalue' VALUES (27839, 462, 133, 1585);
INSERT INTO 'devicecapvalue' VALUES (27840, 462, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (27841, 462, 149, 1680);
INSERT INTO 'devicecapvalue' VALUES (27842, 462, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (27843, 462, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (27844, 462, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (27845, 462, 136, 1585);
INSERT INTO 'devicecapvalue' VALUES (27846, 462, 137, 1396);
INSERT INTO 'devicecapvalue' VALUES (27847, 462, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (27848, 462, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (27849, 462, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (27850, 462, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (27851, 462, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (27852, 462, 137, 96);
INSERT INTO 'devicecapvalue' VALUES (27853, 462, 138, 1681);
INSERT INTO 'devicecapvalue' VALUES (27854, 462, 72, 1682);
INSERT INTO 'devicecapvalue' VALUES (27855, 462, 207, 56);
INSERT INTO 'devicecapvalue' VALUES (27856, 462, 207, 868);
INSERT INTO 'devicecapvalue' VALUES (27857, 462, 207, 57);
INSERT INTO 'devicecapvalue' VALUES (27858, 462, 207, 1582);
INSERT INTO 'devicecapvalue' VALUES (27859, 462, 207, 49);
INSERT INTO 'devicecapvalue' VALUES (27860, 462, 207, 62);
INSERT INTO 'devicecapvalue' VALUES (27861, 462, 207, 1684);
INSERT INTO 'devicecapvalue' VALUES (27862, 462, 207, 986);
INSERT INTO 'devicecapvalue' VALUES (27863, 462, 207, 988);
INSERT INTO 'devicecapvalue' VALUES (27864, 462, 207, 53);
INSERT INTO 'devicecapvalue' VALUES (27865, 462, 207, 1051);
INSERT INTO 'devicecapvalue' VALUES (27866, 462, 207, 67);
INSERT INTO 'devicecapvalue' VALUES (27867, 462, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (27868, 462, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (27869, 462, 49, 1457);
INSERT INTO 'devicecapvalue' VALUES (27870, 463, 158, 1714);
INSERT INTO 'devicecapvalue' VALUES (27871, 463, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (27872, 463, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (27873, 463, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (27874, 463, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (27875, 463, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (27876, 463, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (27877, 463, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (27878, 463, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (27879, 463, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (27880, 463, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (27881, 463, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (27882, 463, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (27883, 463, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (27884, 463, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (27885, 463, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (27886, 463, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (27887, 463, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (27888, 463, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (27889, 463, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27890, 463, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (27891, 463, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (27892, 463, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (27893, 463, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (27894, 463, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (27895, 463, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (27896, 463, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (27897, 463, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (27898, 463, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (27899, 463, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (27900, 463, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (27901, 463, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (27902, 463, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (27903, 463, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (27904, 463, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (27905, 463, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (27906, 463, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (27907, 463, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (27908, 463, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (27909, 463, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (27910, 463, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (27911, 463, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (27912, 463, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (27913, 463, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (27914, 463, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (27915, 463, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (27916, 463, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (27917, 463, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (27918, 463, 52, 1086);
INSERT INTO 'devicecapvalue' VALUES (27919, 463, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (27920, 463, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (27921, 463, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (27922, 463, 53, 1887);
INSERT INTO 'capvalue' VALUES (1914, 'like Gecko) Safari/413 es65');
INSERT INTO 'devicecapvalue' VALUES (27923, 463, 53, 1914);
INSERT INTO 'capvalue' VALUES (1915, '2008-06-16');
INSERT INTO 'devicecapvalue' VALUES (27924, 464, 158, 1915);
INSERT INTO 'devicecapvalue' VALUES (27925, 464, 160, 1477);
INSERT INTO 'capvalue' VALUES (1916, '240x235');
INSERT INTO 'devicecapvalue' VALUES (27926, 464, 7, 1916);
INSERT INTO 'devicecapvalue' VALUES (27927, 464, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (27928, 464, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (27929, 464, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (27930, 464, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (27931, 464, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (27932, 464, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (27933, 464, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (27934, 464, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (27935, 464, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (27936, 464, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (27937, 464, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (27938, 464, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (27939, 464, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (27940, 464, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (27941, 464, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (27942, 464, 17, 1480);
INSERT INTO 'devicecapvalue' VALUES (27943, 464, 17, 1481);
INSERT INTO 'devicecapvalue' VALUES (27944, 464, 17, 1482);
INSERT INTO 'devicecapvalue' VALUES (27945, 464, 17, 1555);
INSERT INTO 'capvalue' VALUES (1917, 'jsr180');
INSERT INTO 'devicecapvalue' VALUES (27946, 464, 17, 1917);
INSERT INTO 'devicecapvalue' VALUES (27947, 464, 17, 1483);
INSERT INTO 'devicecapvalue' VALUES (27948, 464, 17, 1484);
INSERT INTO 'devicecapvalue' VALUES (27949, 464, 17, 1486);
INSERT INTO 'devicecapvalue' VALUES (27950, 464, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (27951, 464, 17, 1488);
INSERT INTO 'devicecapvalue' VALUES (27952, 464, 17, 1489);
INSERT INTO 'devicecapvalue' VALUES (27953, 464, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (27954, 464, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (27955, 464, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (27956, 464, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (27957, 464, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (27958, 464, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (27959, 464, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (27960, 464, 20, 1244);
INSERT INTO 'devicecapvalue' VALUES (27961, 464, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (27962, 464, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (27963, 464, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (27964, 464, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (27965, 464, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (27966, 464, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (27967, 464, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (27968, 464, 57, 40);
INSERT INTO 'devicecapvalue' VALUES (27969, 464, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (27970, 464, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (27971, 464, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (27972, 464, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (27973, 464, 50, 593);
INSERT INTO 'capvalue' VALUES (1918, 'Symbian OS v9.2');
INSERT INTO 'devicecapvalue' VALUES (27974, 464, 3, 1918);
INSERT INTO 'devicecapvalue' VALUES (27975, 464, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (27976, 464, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (27977, 464, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (27978, 464, 46, 1586);
INSERT INTO 'devicecapvalue' VALUES (27979, 464, 46, 1587);
INSERT INTO 'devicecapvalue' VALUES (27980, 464, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (27981, 464, 46, 1588);
INSERT INTO 'devicecapvalue' VALUES (27982, 464, 46, 1589);
INSERT INTO 'devicecapvalue' VALUES (27983, 464, 46, 1590);
INSERT INTO 'devicecapvalue' VALUES (27984, 464, 46, 1591);
INSERT INTO 'devicecapvalue' VALUES (27985, 464, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (27986, 464, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (27987, 464, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (27988, 464, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (27989, 464, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (27990, 464, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (27991, 464, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (27992, 464, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (27993, 464, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (27994, 464, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (27995, 464, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (27996, 464, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (27997, 464, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (27998, 464, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (27999, 464, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (28000, 464, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (28001, 464, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (28002, 464, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (28003, 464, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (28004, 464, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (28005, 464, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (28006, 464, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (28007, 464, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (28008, 464, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (28009, 464, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (28010, 464, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (28011, 464, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (28012, 464, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (28013, 464, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (28014, 464, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (28015, 464, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (28016, 464, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (28017, 464, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (28018, 464, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (28019, 464, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (28020, 464, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (28021, 464, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (28022, 464, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (28023, 464, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (28024, 464, 115, 49);
INSERT INTO 'devicecapvalue' VALUES (28025, 464, 115, 1045);
INSERT INTO 'devicecapvalue' VALUES (28026, 464, 115, 616);
INSERT INTO 'devicecapvalue' VALUES (28027, 464, 115, 867);
INSERT INTO 'devicecapvalue' VALUES (28028, 464, 115, 1050);
INSERT INTO 'devicecapvalue' VALUES (28029, 464, 115, 1578);
INSERT INTO 'devicecapvalue' VALUES (28030, 464, 115, 51);
INSERT INTO 'devicecapvalue' VALUES (28031, 464, 115, 1004);
INSERT INTO 'devicecapvalue' VALUES (28032, 464, 115, 865);
INSERT INTO 'capvalue' VALUES (1919, 'ulaw');
INSERT INTO 'devicecapvalue' VALUES (28033, 464, 115, 1919);
INSERT INTO 'devicecapvalue' VALUES (28034, 464, 197, 1746);
INSERT INTO 'capvalue' VALUES (1920, '8000');
INSERT INTO 'devicecapvalue' VALUES (28035, 464, 197, 1920);
INSERT INTO 'devicecapvalue' VALUES (28036, 464, 141, 238);
INSERT INTO 'devicecapvalue' VALUES (28037, 464, 117, 45);
INSERT INTO 'devicecapvalue' VALUES (28038, 464, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (28039, 464, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (28040, 464, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (28041, 464, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (28042, 464, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (28043, 464, 198, 34);
INSERT INTO 'capvalue' VALUES (1921, '284');
INSERT INTO 'devicecapvalue' VALUES (28044, 464, 199, 1921);
INSERT INTO 'capvalue' VALUES (1922, 'dd/MM/yyyy');
INSERT INTO 'devicecapvalue' VALUES (28045, 464, 183, 1922);
INSERT INTO 'capvalue' VALUES (1923, '352943022380492');
INSERT INTO 'devicecapvalue' VALUES (28046, 464, 200, 1923);
INSERT INTO 'devicecapvalue' VALUES (28047, 464, 201, 1599);
INSERT INTO 'capvalue' VALUES (1924, '05 ()');
INSERT INTO 'devicecapvalue' VALUES (28048, 464, 202, 1924);
INSERT INTO 'capvalue' VALUES (1925, '7 (68 dBm)');
INSERT INTO 'devicecapvalue' VALUES (28049, 464, 203, 1925);
INSERT INTO 'devicecapvalue' VALUES (28050, 464, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (28051, 464, 185, 1602);
INSERT INTO 'devicecapvalue' VALUES (28052, 464, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (28053, 464, 101, 1469);
INSERT INTO 'capvalue' VALUES (1926, 'Memory card');
INSERT INTO 'devicecapvalue' VALUES (28054, 464, 102, 1926);
INSERT INTO 'devicecapvalue' VALUES (28055, 464, 103, 1604);
INSERT INTO 'devicecapvalue' VALUES (28056, 464, 104, 944);
INSERT INTO 'capvalue' VALUES (1927, 'file:///c:/private/102033e6/midlets/[10125a14]/scratch/');
INSERT INTO 'devicecapvalue' VALUES (28057, 464, 105, 1927);
INSERT INTO 'devicecapvalue' VALUES (28058, 464, 106, 1607);
INSERT INTO 'devicecapvalue' VALUES (28059, 464, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (28060, 464, 108, 1609);
INSERT INTO 'capvalue' VALUES (1928, 'Video clips');
INSERT INTO 'devicecapvalue' VALUES (28061, 464, 109, 1928);
INSERT INTO 'devicecapvalue' VALUES (28062, 464, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (28063, 464, 114, 1911);
INSERT INTO 'devicecapvalue' VALUES (28064, 464, 114, 1611);
INSERT INTO 'devicecapvalue' VALUES (28065, 464, 114, 1612);
INSERT INTO 'devicecapvalue' VALUES (28066, 464, 114, 1613);
INSERT INTO 'devicecapvalue' VALUES (28067, 464, 114, 1614);
INSERT INTO 'devicecapvalue' VALUES (28068, 464, 114, 1615);
INSERT INTO 'devicecapvalue' VALUES (28069, 464, 114, 1616);
INSERT INTO 'devicecapvalue' VALUES (28070, 464, 114, 1617);
INSERT INTO 'devicecapvalue' VALUES (28071, 464, 114, 1618);
INSERT INTO 'devicecapvalue' VALUES (28072, 464, 114, 1619);
INSERT INTO 'devicecapvalue' VALUES (28073, 464, 114, 1620);
INSERT INTO 'devicecapvalue' VALUES (28074, 464, 114, 1621);
INSERT INTO 'devicecapvalue' VALUES (28075, 464, 114, 1622);
INSERT INTO 'devicecapvalue' VALUES (28076, 464, 114, 1623);
INSERT INTO 'devicecapvalue' VALUES (28077, 464, 114, 1624);
INSERT INTO 'devicecapvalue' VALUES (28078, 464, 114, 1625);
INSERT INTO 'devicecapvalue' VALUES (28079, 464, 114, 1626);
INSERT INTO 'devicecapvalue' VALUES (28080, 464, 114, 1627);
INSERT INTO 'devicecapvalue' VALUES (28081, 464, 114, 1628);
INSERT INTO 'devicecapvalue' VALUES (28082, 464, 114, 1629);
INSERT INTO 'devicecapvalue' VALUES (28083, 464, 114, 1630);
INSERT INTO 'devicecapvalue' VALUES (28084, 464, 114, 1631);
INSERT INTO 'devicecapvalue' VALUES (28085, 464, 114, 1632);
INSERT INTO 'devicecapvalue' VALUES (28086, 464, 114, 1633);
INSERT INTO 'devicecapvalue' VALUES (28087, 464, 114, 1634);
INSERT INTO 'devicecapvalue' VALUES (28088, 464, 114, 1635);
INSERT INTO 'devicecapvalue' VALUES (28089, 464, 114, 1636);
INSERT INTO 'devicecapvalue' VALUES (28090, 464, 114, 1637);
INSERT INTO 'devicecapvalue' VALUES (28091, 464, 114, 1638);
INSERT INTO 'devicecapvalue' VALUES (28092, 464, 114, 1639);
INSERT INTO 'devicecapvalue' VALUES (28093, 464, 114, 1640);
INSERT INTO 'devicecapvalue' VALUES (28094, 464, 114, 1641);
INSERT INTO 'devicecapvalue' VALUES (28095, 464, 114, 1642);
INSERT INTO 'devicecapvalue' VALUES (28096, 464, 114, 1643);
INSERT INTO 'devicecapvalue' VALUES (28097, 464, 114, 1644);
INSERT INTO 'devicecapvalue' VALUES (28098, 464, 114, 1645);
INSERT INTO 'devicecapvalue' VALUES (28099, 464, 114, 1646);
INSERT INTO 'devicecapvalue' VALUES (28100, 464, 114, 1647);
INSERT INTO 'devicecapvalue' VALUES (28101, 464, 114, 1648);
INSERT INTO 'devicecapvalue' VALUES (28102, 464, 114, 1649);
INSERT INTO 'devicecapvalue' VALUES (28103, 464, 114, 1650);
INSERT INTO 'devicecapvalue' VALUES (28104, 464, 114, 1651);
INSERT INTO 'devicecapvalue' VALUES (28105, 464, 114, 1652);
INSERT INTO 'devicecapvalue' VALUES (28106, 464, 114, 1653);
INSERT INTO 'devicecapvalue' VALUES (28107, 464, 114, 1654);
INSERT INTO 'devicecapvalue' VALUES (28108, 464, 114, 1655);
INSERT INTO 'devicecapvalue' VALUES (28109, 464, 114, 1656);
INSERT INTO 'devicecapvalue' VALUES (28110, 464, 114, 1657);
INSERT INTO 'devicecapvalue' VALUES (28111, 464, 114, 1658);
INSERT INTO 'devicecapvalue' VALUES (28112, 464, 114, 1659);
INSERT INTO 'devicecapvalue' VALUES (28113, 464, 114, 1660);
INSERT INTO 'devicecapvalue' VALUES (28114, 464, 114, 1661);
INSERT INTO 'devicecapvalue' VALUES (28115, 464, 114, 1662);
INSERT INTO 'devicecapvalue' VALUES (28116, 464, 114, 1663);
INSERT INTO 'devicecapvalue' VALUES (28117, 464, 114, 1664);
INSERT INTO 'devicecapvalue' VALUES (28118, 464, 114, 1665);
INSERT INTO 'devicecapvalue' VALUES (28119, 464, 114, 1666);
INSERT INTO 'devicecapvalue' VALUES (28120, 464, 114, 1667);
INSERT INTO 'devicecapvalue' VALUES (28121, 464, 114, 1668);
INSERT INTO 'devicecapvalue' VALUES (28122, 464, 114, 1669);
INSERT INTO 'devicecapvalue' VALUES (28123, 464, 114, 1670);
INSERT INTO 'devicecapvalue' VALUES (28124, 464, 114, 1672);
INSERT INTO 'devicecapvalue' VALUES (28125, 464, 114, 1673);
INSERT INTO 'devicecapvalue' VALUES (28126, 464, 114, 1674);
INSERT INTO 'devicecapvalue' VALUES (28127, 464, 114, 1260);
INSERT INTO 'devicecapvalue' VALUES (28128, 464, 114, 1471);
INSERT INTO 'devicecapvalue' VALUES (28129, 464, 114, 1912);
INSERT INTO 'devicecapvalue' VALUES (28130, 464, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (28131, 464, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (28132, 464, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (28133, 464, 204, 1677);
INSERT INTO 'devicecapvalue' VALUES (28134, 464, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (28135, 464, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (28136, 464, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (28137, 464, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (28138, 464, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (28139, 464, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (28140, 464, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (28141, 464, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (28142, 464, 67, 45);
INSERT INTO 'capvalue' VALUES (1929, 'NokiaE66-1/0.07.126');
INSERT INTO 'devicecapvalue' VALUES (28143, 464, 68, 1929);
INSERT INTO 'devicecapvalue' VALUES (28144, 464, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (28145, 464, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (28146, 464, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (28147, 464, 149, 1751);
INSERT INTO 'devicecapvalue' VALUES (28148, 464, 149, 1752);
INSERT INTO 'devicecapvalue' VALUES (28149, 464, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (28150, 464, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (28151, 464, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (28152, 464, 136, 68);
INSERT INTO 'capvalue' VALUES (1930, 'encoding=video/3gpp2');
INSERT INTO 'devicecapvalue' VALUES (28153, 464, 136, 1930);
INSERT INTO 'capvalue' VALUES (1931, 'encoding=video/mp4');
INSERT INTO 'devicecapvalue' VALUES (28154, 464, 136, 1931);
INSERT INTO 'devicecapvalue' VALUES (28155, 464, 137, 1396);
INSERT INTO 'devicecapvalue' VALUES (28156, 464, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (28157, 464, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (28158, 464, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (28159, 464, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (28160, 464, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (28161, 464, 137, 96);
INSERT INTO 'capvalue' VALUES (1932, 'http://mmsc1.mms.globul.bg:8002');
INSERT INTO 'devicecapvalue' VALUES (28162, 464, 138, 1932);
INSERT INTO 'capvalue' VALUES (1933, '+35989100000');
INSERT INTO 'devicecapvalue' VALUES (28163, 464, 72, 1933);
INSERT INTO 'devicecapvalue' VALUES (28164, 464, 47, 56);
INSERT INTO 'devicecapvalue' VALUES (28165, 464, 47, 868);
INSERT INTO 'devicecapvalue' VALUES (28166, 464, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (28167, 464, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (28168, 464, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (28169, 464, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (28170, 464, 47, 1684);
INSERT INTO 'devicecapvalue' VALUES (28171, 464, 47, 986);
INSERT INTO 'devicecapvalue' VALUES (28172, 464, 47, 988);
INSERT INTO 'devicecapvalue' VALUES (28173, 464, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (28174, 464, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (28175, 464, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (28176, 464, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (28177, 464, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (28178, 464, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (28179, 464, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (28180, 464, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (28181, 464, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (28182, 464, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (28183, 464, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (28184, 464, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (28185, 464, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (28186, 464, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (28187, 464, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (28188, 464, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (28189, 464, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (28190, 464, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (28191, 464, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (28192, 464, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (28193, 464, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (28194, 464, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (28195, 464, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (28196, 464, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (28197, 464, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (28198, 464, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (28199, 464, 51, 1690);
INSERT INTO 'devicecapvalue' VALUES (28200, 464, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (28201, 464, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (28202, 464, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (28203, 464, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (28204, 464, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (28205, 464, 51, 1160);
INSERT INTO 'capvalue' VALUES (1934, '115343360');
INSERT INTO 'devicecapvalue' VALUES (28206, 464, 52, 1934);
INSERT INTO 'devicecapvalue' VALUES (28207, 464, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (28208, 464, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (28209, 464, 49, 1457);
INSERT INTO 'devicecapvalue' VALUES (28210, 464, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (28211, 464, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (28212, 464, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (28213, 464, 157, 1504);
INSERT INTO 'capvalue' VALUES (1935, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.4) Gecko/2008102920 Firefox/3.0.4');
INSERT INTO 'devicecapvalue' VALUES (28214, 464, 53, 1935);
INSERT INTO 'devicecapvalue' VALUES (28215, 465, 158, 1884);
INSERT INTO 'devicecapvalue' VALUES (28216, 465, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (28217, 465, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (28218, 465, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (28219, 465, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (28220, 465, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (28221, 465, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (28222, 465, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (28223, 465, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (28224, 465, 13, 1885);
INSERT INTO 'devicecapvalue' VALUES (28225, 465, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (28226, 465, 77, 1341);
INSERT INTO 'devicecapvalue' VALUES (28227, 465, 78, 1341);
INSERT INTO 'devicecapvalue' VALUES (28228, 465, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (28229, 465, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (28230, 465, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (28231, 465, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (28232, 465, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (28233, 465, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (28234, 465, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (28235, 465, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (28236, 465, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (28237, 465, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (28238, 465, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (28239, 465, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (28240, 465, 210, 1391);
INSERT INTO 'devicecapvalue' VALUES (28241, 465, 94, 625);
INSERT INTO 'devicecapvalue' VALUES (28242, 465, 95, 693);
INSERT INTO 'devicecapvalue' VALUES (28243, 465, 96, 694);
INSERT INTO 'devicecapvalue' VALUES (28244, 465, 97, 15);
INSERT INTO 'cap' VALUES (222, 'key.supportsAsciiKeyMap.condition', 1);
INSERT INTO 'capvalue' VALUES (1936, 'open');
INSERT INTO 'devicecapvalue' VALUES (28245, 465, 222, 1936);
INSERT INTO 'devicecapvalue' VALUES (28246, 465, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (28247, 465, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (28248, 465, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (28249, 465, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (28250, 465, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (28251, 465, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (28252, 465, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (28253, 465, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (28254, 465, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (28255, 465, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (28256, 465, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (28257, 465, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (28258, 465, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (28259, 465, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (28260, 465, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (28261, 465, 182, 1421);
INSERT INTO 'cap' VALUES (223, 'ScreenOrientationCanChange', 1);
INSERT INTO 'devicecapvalue' VALUES (28262, 465, 223, 15);
INSERT INTO 'devicecapvalue' VALUES (28263, 465, 4, 671);
INSERT INTO 'devicecapvalue' VALUES (28264, 465, 5, 672);
INSERT INTO 'devicecapvalue' VALUES (28265, 465, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (28266, 465, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (28267, 465, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (28268, 465, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (28269, 465, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (28270, 465, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (28271, 465, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (28272, 465, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (28273, 465, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (28274, 465, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (28275, 465, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (28276, 465, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (28277, 465, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (28278, 465, 52, 1886);
INSERT INTO 'devicecapvalue' VALUES (28279, 465, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (28280, 465, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (28281, 465, 157, 1504);
INSERT INTO 'capvalue' VALUES (1937, 'NokiaE70-1/3.0 (1.0610.05.06); SymbianOS/9.1 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (28282, 465, 53, 1937);
INSERT INTO 'devicecapvalue' VALUES (28283, 466, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (28284, 466, 192, 15);
INSERT INTO 'devicecapvalue' VALUES (28285, 466, 74, 1889);
INSERT INTO 'devicecapvalue' VALUES (28286, 466, 193, 1568);
INSERT INTO 'devicecapvalue' VALUES (28287, 466, 193, 1569);
INSERT INTO 'devicecapvalue' VALUES (28288, 466, 79, 15);
INSERT INTO 'devicecapvalue' VALUES (28289, 466, 7, 1905);
INSERT INTO 'devicecapvalue' VALUES (28290, 466, 195, 1573);
INSERT INTO 'devicecapvalue' VALUES (28291, 466, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (28292, 466, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (28293, 466, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (28294, 466, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (28295, 466, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (28296, 466, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (28297, 466, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (28298, 466, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (28299, 466, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (28300, 466, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (28301, 466, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (28302, 466, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (28303, 466, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (28304, 466, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (28305, 466, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (28306, 466, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (28307, 466, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (28308, 466, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (28309, 466, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (28310, 466, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (28311, 466, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (28312, 466, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (28313, 466, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (28314, 466, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (28315, 466, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (28316, 466, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (28317, 466, 196, 745);
INSERT INTO 'devicecapvalue' VALUES (28318, 466, 178, 694);
INSERT INTO 'devicecapvalue' VALUES (28319, 466, 18, 625);
INSERT INTO 'devicecapvalue' VALUES (28320, 466, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (28321, 466, 20, 1879);
INSERT INTO 'devicecapvalue' VALUES (28322, 466, 21, 237);
INSERT INTO 'devicecapvalue' VALUES (28323, 466, 22, 1880);
INSERT INTO 'devicecapvalue' VALUES (28324, 466, 23, 607);
INSERT INTO 'devicecapvalue' VALUES (28325, 466, 24, 1881);
INSERT INTO 'devicecapvalue' VALUES (28326, 466, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (28327, 466, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (28328, 466, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (28329, 466, 57, 625);
INSERT INTO 'devicecapvalue' VALUES (28330, 466, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (28331, 466, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (28332, 466, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (28333, 466, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (28334, 466, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (28335, 466, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (28336, 466, 38, 1577);
INSERT INTO 'devicecapvalue' VALUES (28337, 466, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (28338, 466, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (28339, 466, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (28340, 466, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (28341, 466, 39, 1050);
INSERT INTO 'devicecapvalue' VALUES (28342, 466, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (28343, 466, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (28344, 466, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (28345, 466, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (28346, 466, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (28347, 466, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (28348, 466, 40, 125);
INSERT INTO 'devicecapvalue' VALUES (28349, 466, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (28350, 466, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (28351, 466, 40, 1580);
INSERT INTO 'devicecapvalue' VALUES (28352, 466, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (28353, 466, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (28354, 466, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (28355, 466, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (28356, 466, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (28357, 466, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (28358, 466, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (28359, 466, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (28360, 466, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (28361, 466, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (28362, 466, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (28363, 466, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (28364, 466, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (28365, 466, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (28366, 466, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (28367, 466, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (28368, 466, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (28369, 466, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (28370, 466, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (28371, 466, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (28372, 466, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (28373, 466, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (28374, 466, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (28375, 466, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (28376, 466, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (28377, 466, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (28378, 466, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (28379, 466, 41, 1584);
INSERT INTO 'devicecapvalue' VALUES (28380, 466, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (28381, 466, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (28382, 466, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (28383, 466, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (28384, 466, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (28385, 466, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (28386, 466, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (28387, 466, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (28388, 466, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (28389, 466, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (28390, 466, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (28391, 466, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (28392, 466, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (28393, 466, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (28394, 466, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (28395, 466, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (28396, 466, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (28397, 466, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (28398, 466, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (28399, 466, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (28400, 466, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (28401, 466, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (28402, 466, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (28403, 466, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (28404, 466, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (28405, 466, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (28406, 466, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (28407, 466, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (28408, 466, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (28409, 466, 42, 1584);
INSERT INTO 'devicecapvalue' VALUES (28410, 466, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (28411, 466, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (28412, 466, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (28413, 466, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (28414, 466, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (28415, 466, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (28416, 466, 45, 1585);
INSERT INTO 'cap' VALUES (224, 'name', 1);
INSERT INTO 'capvalue' VALUES (1938, 'E71');
INSERT INTO 'devicecapvalue' VALUES (28417, 466, 224, 1938);
INSERT INTO 'devicecapvalue' VALUES (28418, 466, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (28419, 466, 58, 238);
INSERT INTO 'devicecapvalue' VALUES (28420, 466, 3, 1918);
INSERT INTO 'devicecapvalue' VALUES (28421, 466, 211, 1890);
INSERT INTO 'devicecapvalue' VALUES (28422, 466, 212, 1891);
INSERT INTO 'devicecapvalue' VALUES (28423, 466, 213, 1892);
INSERT INTO 'devicecapvalue' VALUES (28424, 466, 214, 1893);
INSERT INTO 'devicecapvalue' VALUES (28425, 466, 215, 1894);
INSERT INTO 'devicecapvalue' VALUES (28426, 466, 216, 1895);
INSERT INTO 'devicecapvalue' VALUES (28427, 466, 217, 1896);
INSERT INTO 'devicecapvalue' VALUES (28428, 466, 218, 1897);
INSERT INTO 'devicecapvalue' VALUES (28429, 466, 219, 1898);
INSERT INTO 'devicecapvalue' VALUES (28430, 466, 220, 1899);
INSERT INTO 'devicecapvalue' VALUES (28431, 466, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (28432, 466, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (28433, 466, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (28434, 466, 46, 1586);
INSERT INTO 'devicecapvalue' VALUES (28435, 466, 46, 1587);
INSERT INTO 'devicecapvalue' VALUES (28436, 466, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (28437, 466, 46, 1588);
INSERT INTO 'devicecapvalue' VALUES (28438, 466, 46, 1589);
INSERT INTO 'devicecapvalue' VALUES (28439, 466, 46, 1590);
INSERT INTO 'devicecapvalue' VALUES (28440, 466, 46, 1591);
INSERT INTO 'devicecapvalue' VALUES (28441, 466, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (28442, 466, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (28443, 466, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (28444, 466, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (28445, 466, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (28446, 466, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (28447, 466, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (28448, 466, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (28449, 466, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (28450, 466, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (28451, 466, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (28452, 466, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (28453, 466, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (28454, 466, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (28455, 466, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (28456, 466, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (28457, 466, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (28458, 466, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (28459, 466, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (28460, 466, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (28461, 466, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (28462, 466, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (28463, 466, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (28464, 466, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (28465, 466, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (28466, 466, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (28467, 466, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (28468, 466, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (28469, 466, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (28470, 466, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (28471, 466, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (28472, 466, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (28473, 466, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (28474, 466, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (28475, 466, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (28476, 466, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (28477, 466, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (28478, 466, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (28479, 466, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (28480, 466, 115, 1577);
INSERT INTO 'devicecapvalue' VALUES (28481, 466, 197, 1594);
INSERT INTO 'devicecapvalue' VALUES (28482, 466, 141, 238);
INSERT INTO 'devicecapvalue' VALUES (28483, 466, 117, 45);
INSERT INTO 'devicecapvalue' VALUES (28484, 466, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (28485, 466, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (28486, 466, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (28487, 466, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (28488, 466, 122, 244);
INSERT INTO 'capvalue' VALUES (1939, '71');
INSERT INTO 'devicecapvalue' VALUES (28489, 466, 198, 1939);
INSERT INTO 'devicecapvalue' VALUES (28490, 466, 199, 1151);
INSERT INTO 'devicecapvalue' VALUES (28491, 466, 183, 1922);
INSERT INTO 'capvalue' VALUES (1940, 'defined');
INSERT INTO 'devicecapvalue' VALUES (28492, 466, 200, 1940);
INSERT INTO 'devicecapvalue' VALUES (28493, 466, 201, 1599);
INSERT INTO 'capvalue' VALUES (1941, '04 (vodafone N)');
INSERT INTO 'devicecapvalue' VALUES (28494, 466, 202, 1941);
INSERT INTO 'capvalue' VALUES (1942, '6 (99 dBm)');
INSERT INTO 'devicecapvalue' VALUES (28495, 466, 203, 1942);
INSERT INTO 'capvalue' VALUES (1943, 'hh:mm a');
INSERT INTO 'devicecapvalue' VALUES (28496, 466, 184, 1943);
INSERT INTO 'devicecapvalue' VALUES (28497, 466, 185, 1602);
INSERT INTO 'devicecapvalue' VALUES (28498, 466, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (28499, 466, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (28500, 466, 102, 1926);
INSERT INTO 'devicecapvalue' VALUES (28501, 466, 103, 1604);
INSERT INTO 'devicecapvalue' VALUES (28502, 466, 104, 944);
INSERT INTO 'capvalue' VALUES (1944, 'file:///c:/private/102033e6/midlets/[1010e1d2]/scratch/');
INSERT INTO 'devicecapvalue' VALUES (28503, 466, 105, 1944);
INSERT INTO 'devicecapvalue' VALUES (28504, 466, 106, 1607);
INSERT INTO 'devicecapvalue' VALUES (28505, 466, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (28506, 466, 108, 1609);
INSERT INTO 'devicecapvalue' VALUES (28507, 466, 109, 1928);
INSERT INTO 'devicecapvalue' VALUES (28508, 466, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (28509, 466, 114, 1911);
INSERT INTO 'devicecapvalue' VALUES (28510, 466, 114, 1611);
INSERT INTO 'devicecapvalue' VALUES (28511, 466, 114, 1612);
INSERT INTO 'devicecapvalue' VALUES (28512, 466, 114, 1613);
INSERT INTO 'devicecapvalue' VALUES (28513, 466, 114, 1614);
INSERT INTO 'devicecapvalue' VALUES (28514, 466, 114, 1615);
INSERT INTO 'devicecapvalue' VALUES (28515, 466, 114, 1616);
INSERT INTO 'devicecapvalue' VALUES (28516, 466, 114, 1617);
INSERT INTO 'devicecapvalue' VALUES (28517, 466, 114, 1618);
INSERT INTO 'devicecapvalue' VALUES (28518, 466, 114, 1619);
INSERT INTO 'devicecapvalue' VALUES (28519, 466, 114, 1620);
INSERT INTO 'devicecapvalue' VALUES (28520, 466, 114, 1621);
INSERT INTO 'devicecapvalue' VALUES (28521, 466, 114, 1622);
INSERT INTO 'devicecapvalue' VALUES (28522, 466, 114, 1623);
INSERT INTO 'devicecapvalue' VALUES (28523, 466, 114, 1624);
INSERT INTO 'devicecapvalue' VALUES (28524, 466, 114, 1625);
INSERT INTO 'devicecapvalue' VALUES (28525, 466, 114, 1626);
INSERT INTO 'devicecapvalue' VALUES (28526, 466, 114, 1627);
INSERT INTO 'devicecapvalue' VALUES (28527, 466, 114, 1628);
INSERT INTO 'devicecapvalue' VALUES (28528, 466, 114, 1629);
INSERT INTO 'devicecapvalue' VALUES (28529, 466, 114, 1630);
INSERT INTO 'devicecapvalue' VALUES (28530, 466, 114, 1631);
INSERT INTO 'devicecapvalue' VALUES (28531, 466, 114, 1632);
INSERT INTO 'devicecapvalue' VALUES (28532, 466, 114, 1633);
INSERT INTO 'devicecapvalue' VALUES (28533, 466, 114, 1634);
INSERT INTO 'devicecapvalue' VALUES (28534, 466, 114, 1635);
INSERT INTO 'devicecapvalue' VALUES (28535, 466, 114, 1636);
INSERT INTO 'devicecapvalue' VALUES (28536, 466, 114, 1637);
INSERT INTO 'devicecapvalue' VALUES (28537, 466, 114, 1638);
INSERT INTO 'devicecapvalue' VALUES (28538, 466, 114, 1639);
INSERT INTO 'devicecapvalue' VALUES (28539, 466, 114, 1640);
INSERT INTO 'devicecapvalue' VALUES (28540, 466, 114, 1641);
INSERT INTO 'devicecapvalue' VALUES (28541, 466, 114, 1642);
INSERT INTO 'devicecapvalue' VALUES (28542, 466, 114, 1643);
INSERT INTO 'devicecapvalue' VALUES (28543, 466, 114, 1644);
INSERT INTO 'devicecapvalue' VALUES (28544, 466, 114, 1645);
INSERT INTO 'devicecapvalue' VALUES (28545, 466, 114, 1646);
INSERT INTO 'devicecapvalue' VALUES (28546, 466, 114, 1647);
INSERT INTO 'devicecapvalue' VALUES (28547, 466, 114, 1648);
INSERT INTO 'devicecapvalue' VALUES (28548, 466, 114, 1649);
INSERT INTO 'devicecapvalue' VALUES (28549, 466, 114, 1650);
INSERT INTO 'devicecapvalue' VALUES (28550, 466, 114, 1651);
INSERT INTO 'devicecapvalue' VALUES (28551, 466, 114, 1652);
INSERT INTO 'devicecapvalue' VALUES (28552, 466, 114, 1653);
INSERT INTO 'devicecapvalue' VALUES (28553, 466, 114, 1654);
INSERT INTO 'devicecapvalue' VALUES (28554, 466, 114, 1655);
INSERT INTO 'devicecapvalue' VALUES (28555, 466, 114, 1656);
INSERT INTO 'devicecapvalue' VALUES (28556, 466, 114, 1657);
INSERT INTO 'devicecapvalue' VALUES (28557, 466, 114, 1658);
INSERT INTO 'devicecapvalue' VALUES (28558, 466, 114, 1659);
INSERT INTO 'devicecapvalue' VALUES (28559, 466, 114, 1660);
INSERT INTO 'devicecapvalue' VALUES (28560, 466, 114, 1661);
INSERT INTO 'devicecapvalue' VALUES (28561, 466, 114, 1662);
INSERT INTO 'devicecapvalue' VALUES (28562, 466, 114, 1663);
INSERT INTO 'devicecapvalue' VALUES (28563, 466, 114, 1664);
INSERT INTO 'devicecapvalue' VALUES (28564, 466, 114, 1665);
INSERT INTO 'devicecapvalue' VALUES (28565, 466, 114, 1666);
INSERT INTO 'devicecapvalue' VALUES (28566, 466, 114, 1667);
INSERT INTO 'devicecapvalue' VALUES (28567, 466, 114, 1668);
INSERT INTO 'devicecapvalue' VALUES (28568, 466, 114, 1669);
INSERT INTO 'devicecapvalue' VALUES (28569, 466, 114, 1670);
INSERT INTO 'devicecapvalue' VALUES (28570, 466, 114, 1672);
INSERT INTO 'devicecapvalue' VALUES (28571, 466, 114, 1673);
INSERT INTO 'devicecapvalue' VALUES (28572, 466, 114, 1674);
INSERT INTO 'devicecapvalue' VALUES (28573, 466, 114, 1260);
INSERT INTO 'devicecapvalue' VALUES (28574, 466, 114, 1471);
INSERT INTO 'devicecapvalue' VALUES (28575, 466, 114, 1912);
INSERT INTO 'devicecapvalue' VALUES (28576, 466, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (28577, 466, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (28578, 466, 204, 1677);
INSERT INTO 'devicecapvalue' VALUES (28579, 466, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (28580, 466, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (28581, 466, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (28582, 466, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (28583, 466, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (28584, 466, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (28585, 466, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (28586, 466, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (28587, 466, 67, 45);
INSERT INTO 'capvalue' VALUES (1945, 'NokiaE71-1/0.07.76');
INSERT INTO 'devicecapvalue' VALUES (28588, 466, 68, 1945);
INSERT INTO 'devicecapvalue' VALUES (28589, 466, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (28590, 466, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (28591, 466, 132, 1577);
INSERT INTO 'devicecapvalue' VALUES (28592, 466, 133, 1585);
INSERT INTO 'devicecapvalue' VALUES (28593, 466, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (28594, 466, 149, 1680);
INSERT INTO 'devicecapvalue' VALUES (28595, 466, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (28596, 466, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (28597, 466, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (28598, 466, 136, 1585);
INSERT INTO 'devicecapvalue' VALUES (28599, 466, 137, 1396);
INSERT INTO 'devicecapvalue' VALUES (28600, 466, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (28601, 466, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (28602, 466, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (28603, 466, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (28604, 466, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (28605, 466, 137, 96);
INSERT INTO 'devicecapvalue' VALUES (28606, 466, 138, 950);
INSERT INTO 'devicecapvalue' VALUES (28607, 466, 72, 1940);
INSERT INTO 'capvalue' VALUES (1946, 'audio/3gppaudio/3gpp2 audio/amr audio/mp4 audio/mp4-latm audio/qcelp audio/vnd.qcelp video/3gpp video/3gpp2 video/mp4 application/vnd.rn-realmedia application/sdp ');
INSERT INTO 'devicecapvalue' VALUES (28608, 466, 206, 1946);
INSERT INTO 'devicecapvalue' VALUES (28609, 466, 207, 56);
INSERT INTO 'devicecapvalue' VALUES (28610, 466, 207, 868);
INSERT INTO 'devicecapvalue' VALUES (28611, 466, 207, 57);
INSERT INTO 'devicecapvalue' VALUES (28612, 466, 207, 1582);
INSERT INTO 'devicecapvalue' VALUES (28613, 466, 207, 49);
INSERT INTO 'devicecapvalue' VALUES (28614, 466, 207, 62);
INSERT INTO 'devicecapvalue' VALUES (28615, 466, 207, 1684);
INSERT INTO 'devicecapvalue' VALUES (28616, 466, 207, 986);
INSERT INTO 'devicecapvalue' VALUES (28617, 466, 207, 988);
INSERT INTO 'devicecapvalue' VALUES (28618, 466, 207, 53);
INSERT INTO 'devicecapvalue' VALUES (28619, 466, 207, 1051);
INSERT INTO 'devicecapvalue' VALUES (28620, 466, 207, 67);
INSERT INTO 'devicecapvalue' VALUES (28621, 466, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (28622, 466, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (28623, 466, 208, 15);
INSERT INTO 'devicecapvalue' VALUES (28624, 466, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (28625, 466, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (28626, 466, 49, 1457);
INSERT INTO 'devicecapvalue' VALUES (28627, 467, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (28628, 467, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (28629, 467, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (28630, 468, 7, 1878);
INSERT INTO 'devicecapvalue' VALUES (28631, 468, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (28632, 468, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (28633, 468, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (28634, 468, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (28635, 468, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (28636, 468, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (28637, 468, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (28638, 468, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (28639, 468, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (28640, 468, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (28641, 468, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (28642, 468, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (28643, 468, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (28644, 468, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (28645, 468, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (28646, 468, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (28647, 468, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (28648, 468, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (28649, 468, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (28650, 468, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (28651, 468, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (28652, 468, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (28653, 468, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (28654, 468, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (28655, 468, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (28656, 468, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (28657, 468, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (28658, 468, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (28659, 468, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (28660, 468, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (28661, 468, 20, 1244);
INSERT INTO 'devicecapvalue' VALUES (28662, 468, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (28663, 468, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (28664, 468, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (28665, 468, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (28666, 468, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (28667, 468, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (28668, 468, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (28669, 468, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (28670, 468, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (28671, 468, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (28672, 468, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (28673, 468, 32, 1611);
INSERT INTO 'devicecapvalue' VALUES (28674, 468, 32, 1612);
INSERT INTO 'devicecapvalue' VALUES (28675, 468, 32, 1613);
INSERT INTO 'devicecapvalue' VALUES (28676, 468, 32, 1614);
INSERT INTO 'devicecapvalue' VALUES (28677, 468, 32, 1615);
INSERT INTO 'devicecapvalue' VALUES (28678, 468, 32, 1616);
INSERT INTO 'devicecapvalue' VALUES (28679, 468, 32, 1617);
INSERT INTO 'devicecapvalue' VALUES (28680, 468, 32, 1618);
INSERT INTO 'devicecapvalue' VALUES (28681, 468, 32, 1619);
INSERT INTO 'devicecapvalue' VALUES (28682, 468, 32, 1620);
INSERT INTO 'devicecapvalue' VALUES (28683, 468, 32, 1621);
INSERT INTO 'devicecapvalue' VALUES (28684, 468, 32, 1622);
INSERT INTO 'devicecapvalue' VALUES (28685, 468, 32, 1623);
INSERT INTO 'devicecapvalue' VALUES (28686, 468, 32, 1624);
INSERT INTO 'devicecapvalue' VALUES (28687, 468, 32, 1625);
INSERT INTO 'devicecapvalue' VALUES (28688, 468, 32, 1626);
INSERT INTO 'devicecapvalue' VALUES (28689, 468, 32, 1627);
INSERT INTO 'devicecapvalue' VALUES (28690, 468, 32, 1628);
INSERT INTO 'devicecapvalue' VALUES (28691, 468, 32, 1629);
INSERT INTO 'devicecapvalue' VALUES (28692, 468, 32, 1630);
INSERT INTO 'devicecapvalue' VALUES (28693, 468, 32, 1631);
INSERT INTO 'devicecapvalue' VALUES (28694, 468, 32, 1632);
INSERT INTO 'devicecapvalue' VALUES (28695, 468, 32, 1633);
INSERT INTO 'devicecapvalue' VALUES (28696, 468, 32, 1634);
INSERT INTO 'devicecapvalue' VALUES (28697, 468, 32, 1635);
INSERT INTO 'devicecapvalue' VALUES (28698, 468, 32, 1636);
INSERT INTO 'devicecapvalue' VALUES (28699, 468, 32, 1637);
INSERT INTO 'devicecapvalue' VALUES (28700, 468, 32, 1638);
INSERT INTO 'devicecapvalue' VALUES (28701, 468, 32, 1639);
INSERT INTO 'devicecapvalue' VALUES (28702, 468, 32, 1640);
INSERT INTO 'devicecapvalue' VALUES (28703, 468, 32, 1641);
INSERT INTO 'devicecapvalue' VALUES (28704, 468, 32, 1642);
INSERT INTO 'devicecapvalue' VALUES (28705, 468, 32, 1643);
INSERT INTO 'devicecapvalue' VALUES (28706, 468, 32, 1644);
INSERT INTO 'devicecapvalue' VALUES (28707, 468, 32, 1645);
INSERT INTO 'devicecapvalue' VALUES (28708, 468, 32, 1646);
INSERT INTO 'devicecapvalue' VALUES (28709, 468, 32, 1647);
INSERT INTO 'devicecapvalue' VALUES (28710, 468, 32, 1648);
INSERT INTO 'devicecapvalue' VALUES (28711, 468, 32, 1649);
INSERT INTO 'devicecapvalue' VALUES (28712, 468, 32, 1650);
INSERT INTO 'devicecapvalue' VALUES (28713, 468, 32, 1651);
INSERT INTO 'devicecapvalue' VALUES (28714, 468, 32, 1652);
INSERT INTO 'devicecapvalue' VALUES (28715, 468, 32, 1653);
INSERT INTO 'devicecapvalue' VALUES (28716, 468, 32, 1654);
INSERT INTO 'devicecapvalue' VALUES (28717, 468, 32, 1655);
INSERT INTO 'devicecapvalue' VALUES (28718, 468, 32, 1656);
INSERT INTO 'devicecapvalue' VALUES (28719, 468, 32, 1657);
INSERT INTO 'devicecapvalue' VALUES (28720, 468, 32, 1658);
INSERT INTO 'devicecapvalue' VALUES (28721, 468, 32, 1659);
INSERT INTO 'devicecapvalue' VALUES (28722, 468, 32, 1660);
INSERT INTO 'devicecapvalue' VALUES (28723, 468, 32, 1661);
INSERT INTO 'devicecapvalue' VALUES (28724, 468, 32, 1662);
INSERT INTO 'devicecapvalue' VALUES (28725, 468, 32, 1663);
INSERT INTO 'devicecapvalue' VALUES (28726, 468, 32, 1664);
INSERT INTO 'devicecapvalue' VALUES (28727, 468, 32, 1665);
INSERT INTO 'devicecapvalue' VALUES (28728, 468, 32, 1666);
INSERT INTO 'devicecapvalue' VALUES (28729, 468, 32, 1667);
INSERT INTO 'devicecapvalue' VALUES (28730, 468, 32, 1668);
INSERT INTO 'devicecapvalue' VALUES (28731, 468, 32, 1669);
INSERT INTO 'devicecapvalue' VALUES (28732, 468, 32, 1670);
INSERT INTO 'devicecapvalue' VALUES (28733, 468, 32, 1671);
INSERT INTO 'devicecapvalue' VALUES (28734, 468, 32, 1672);
INSERT INTO 'devicecapvalue' VALUES (28735, 468, 32, 1673);
INSERT INTO 'devicecapvalue' VALUES (28736, 468, 32, 1674);
INSERT INTO 'devicecapvalue' VALUES (28737, 468, 32, 852);
INSERT INTO 'devicecapvalue' VALUES (28738, 468, 32, 1675);
INSERT INTO 'devicecapvalue' VALUES (28739, 468, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (28740, 468, 32, 1676);
INSERT INTO 'devicecapvalue' VALUES (28741, 468, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (28742, 468, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (28743, 468, 35, 45);
INSERT INTO 'capvalue' VALUES (1947, 'NokiaE75-1/110.48.125/sw_platform=S60;sw_platform_version=3.2;java_build_version=1.0.4');
INSERT INTO 'devicecapvalue' VALUES (28744, 468, 36, 1947);
INSERT INTO 'devicecapvalue' VALUES (28745, 468, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (28746, 468, 38, 1577);
INSERT INTO 'devicecapvalue' VALUES (28747, 468, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (28748, 468, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (28749, 468, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (28750, 468, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (28751, 468, 39, 1050);
INSERT INTO 'devicecapvalue' VALUES (28752, 468, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (28753, 468, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (28754, 468, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (28755, 468, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (28756, 468, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (28757, 468, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (28758, 468, 40, 125);
INSERT INTO 'devicecapvalue' VALUES (28759, 468, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (28760, 468, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (28761, 468, 40, 1580);
INSERT INTO 'devicecapvalue' VALUES (28762, 468, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (28763, 468, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (28764, 468, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (28765, 468, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (28766, 468, 41, 1275);
INSERT INTO 'devicecapvalue' VALUES (28767, 468, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (28768, 468, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (28769, 468, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (28770, 468, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (28771, 468, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (28772, 468, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (28773, 468, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (28774, 468, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (28775, 468, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (28776, 468, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (28777, 468, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (28778, 468, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (28779, 468, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (28780, 468, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (28781, 468, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (28782, 468, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (28783, 468, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (28784, 468, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (28785, 468, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (28786, 468, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (28787, 468, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (28788, 468, 41, 1583);
INSERT INTO 'devicecapvalue' VALUES (28789, 468, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (28790, 468, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (28791, 468, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (28792, 468, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (28793, 468, 41, 1584);
INSERT INTO 'devicecapvalue' VALUES (28794, 468, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (28795, 468, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (28796, 468, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (28797, 468, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (28798, 468, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (28799, 468, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (28800, 468, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (28801, 468, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (28802, 468, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (28803, 468, 42, 1275);
INSERT INTO 'devicecapvalue' VALUES (28804, 468, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (28805, 468, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (28806, 468, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (28807, 468, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (28808, 468, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (28809, 468, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (28810, 468, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (28811, 468, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (28812, 468, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (28813, 468, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (28814, 468, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (28815, 468, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (28816, 468, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (28817, 468, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (28818, 468, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (28819, 468, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (28820, 468, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (28821, 468, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (28822, 468, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (28823, 468, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (28824, 468, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (28825, 468, 42, 1583);
INSERT INTO 'devicecapvalue' VALUES (28826, 468, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (28827, 468, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (28828, 468, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (28829, 468, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (28830, 468, 42, 1584);
INSERT INTO 'devicecapvalue' VALUES (28831, 468, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (28832, 468, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (28833, 468, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (28834, 468, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (28835, 468, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (28836, 468, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (28837, 468, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (28838, 468, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (28839, 468, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (28840, 468, 45, 1585);
INSERT INTO 'devicecapvalue' VALUES (28841, 468, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (28842, 468, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (28843, 468, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (28844, 468, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (28845, 468, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (28846, 468, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (28847, 468, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (28848, 468, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (28849, 468, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (28850, 468, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (28851, 468, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (28852, 468, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (28853, 468, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (28854, 468, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (28855, 468, 46, 1586);
INSERT INTO 'devicecapvalue' VALUES (28856, 468, 46, 1587);
INSERT INTO 'devicecapvalue' VALUES (28857, 468, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (28858, 468, 46, 1588);
INSERT INTO 'devicecapvalue' VALUES (28859, 468, 46, 1589);
INSERT INTO 'devicecapvalue' VALUES (28860, 468, 46, 1590);
INSERT INTO 'devicecapvalue' VALUES (28861, 468, 46, 1591);
INSERT INTO 'devicecapvalue' VALUES (28862, 468, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (28863, 468, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (28864, 468, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (28865, 468, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (28866, 468, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (28867, 468, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (28868, 468, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (28869, 468, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (28870, 468, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (28871, 468, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (28872, 468, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (28873, 468, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (28874, 468, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (28875, 468, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (28876, 468, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (28877, 468, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (28878, 468, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (28879, 468, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (28880, 468, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (28881, 468, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (28882, 468, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (28883, 468, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (28884, 468, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (28885, 468, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (28886, 468, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (28887, 468, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (28888, 468, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (28889, 468, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (28890, 468, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (28891, 468, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (28892, 468, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (28893, 468, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (28894, 468, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (28895, 468, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (28896, 468, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (28897, 468, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (28898, 468, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (28899, 468, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (28900, 468, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (28901, 468, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (28902, 468, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (28903, 468, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (28904, 468, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (28905, 468, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (28906, 468, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (28907, 468, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (28908, 468, 47, 56);
INSERT INTO 'devicecapvalue' VALUES (28909, 468, 47, 868);
INSERT INTO 'devicecapvalue' VALUES (28910, 468, 47, 1275);
INSERT INTO 'devicecapvalue' VALUES (28911, 468, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (28912, 468, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (28913, 468, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (28914, 468, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (28915, 468, 47, 1684);
INSERT INTO 'devicecapvalue' VALUES (28916, 468, 47, 986);
INSERT INTO 'devicecapvalue' VALUES (28917, 468, 47, 988);
INSERT INTO 'devicecapvalue' VALUES (28918, 468, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (28919, 468, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (28920, 468, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (28921, 468, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (28922, 468, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (28923, 468, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (28924, 468, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (28925, 468, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (28926, 468, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (28927, 468, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (28928, 468, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (28929, 468, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (28930, 468, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (28931, 468, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (28932, 468, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (28933, 468, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (28934, 468, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (28935, 468, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (28936, 468, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (28937, 468, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (28938, 468, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (28939, 468, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (28940, 468, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (28941, 468, 48, 824);
INSERT INTO 'devicecapvalue' VALUES (28942, 468, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (28943, 468, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (28944, 468, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (28945, 468, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (28946, 468, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (28947, 468, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (28948, 468, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (28949, 468, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (28950, 468, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (28951, 468, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (28952, 468, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (28953, 468, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (28954, 468, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (28955, 468, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (28956, 468, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (28957, 468, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (28958, 468, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (28959, 468, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (28960, 468, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (28961, 468, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (28962, 468, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (28963, 468, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (28964, 468, 48, 1685);
INSERT INTO 'devicecapvalue' VALUES (28965, 468, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (28966, 468, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (28967, 468, 48, 1686);
INSERT INTO 'devicecapvalue' VALUES (28968, 468, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (28969, 468, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (28970, 468, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (28971, 468, 48, 830);
INSERT INTO 'capvalue' VALUES (1948, '452864');
INSERT INTO 'devicecapvalue' VALUES (28972, 468, 49, 1948);
INSERT INTO 'devicecapvalue' VALUES (28973, 469, 158, 1714);
INSERT INTO 'devicecapvalue' VALUES (28974, 469, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (28975, 469, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (28976, 469, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (28977, 469, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (28978, 469, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (28979, 469, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (28980, 469, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (28981, 469, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (28982, 469, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (28983, 469, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (28984, 469, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (28985, 469, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (28986, 469, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (28987, 469, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (28988, 469, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (28989, 469, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (28990, 469, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (28991, 469, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (28992, 469, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (28993, 469, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (28994, 469, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (28995, 469, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (28996, 469, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (28997, 469, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (28998, 469, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (28999, 469, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29000, 469, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29001, 469, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29002, 469, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (29003, 469, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (29004, 469, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (29005, 469, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (29006, 469, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (29007, 469, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (29008, 469, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (29009, 469, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (29010, 469, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29011, 469, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (29012, 469, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (29013, 469, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (29014, 469, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (29015, 469, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (29016, 469, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (29017, 469, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (29018, 469, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (29019, 469, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29020, 469, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29021, 469, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29022, 469, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (29023, 469, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29024, 469, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29025, 469, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (29026, 469, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29027, 469, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (29028, 469, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29029, 469, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29030, 469, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29031, 469, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29032, 469, 52, 739);
INSERT INTO 'devicecapvalue' VALUES (29033, 469, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29034, 469, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (29035, 469, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (29036, 470, 158, 1714);
INSERT INTO 'devicecapvalue' VALUES (29037, 470, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (29038, 470, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (29039, 470, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (29040, 470, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (29041, 470, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (29042, 470, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (29043, 470, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (29044, 470, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (29045, 470, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (29046, 470, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (29047, 470, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29048, 470, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (29049, 470, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (29050, 470, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (29051, 470, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (29052, 470, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29053, 470, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29054, 470, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (29055, 470, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29056, 470, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29057, 470, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (29058, 470, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (29059, 470, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (29060, 470, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29061, 470, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29062, 470, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29063, 470, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29064, 470, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29065, 470, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (29066, 470, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (29067, 470, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (29068, 470, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (29069, 470, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (29070, 470, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (29071, 470, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (29072, 470, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (29073, 470, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29074, 470, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (29075, 470, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (29076, 470, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (29077, 470, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (29078, 470, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (29079, 470, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (29080, 470, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (29081, 470, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (29082, 470, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29083, 470, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29084, 470, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29085, 470, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (29086, 470, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29087, 470, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29088, 470, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (29089, 470, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29090, 470, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (29091, 470, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29092, 470, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29093, 470, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29094, 470, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29095, 470, 52, 739);
INSERT INTO 'devicecapvalue' VALUES (29096, 470, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29097, 470, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (29098, 470, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (29099, 471, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (29100, 471, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29101, 471, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29102, 471, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29103, 471, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29104, 471, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29105, 471, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29106, 471, 157, 1087);
INSERT INTO 'capvalue' VALUES (1949, '2005-09-26');
INSERT INTO 'devicecapvalue' VALUES (29107, 472, 158, 1949);
INSERT INTO 'devicecapvalue' VALUES (29108, 472, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (29109, 472, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (29110, 472, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (29111, 472, 2, 1001);
INSERT INTO 'capvalue' VALUES (1950, '176x208');
INSERT INTO 'devicecapvalue' VALUES (29112, 472, 13, 1950);
INSERT INTO 'devicecapvalue' VALUES (29113, 472, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29114, 472, 77, 842);
INSERT INTO 'devicecapvalue' VALUES (29115, 472, 78, 842);
INSERT INTO 'devicecapvalue' VALUES (29116, 472, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29117, 472, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29118, 472, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (29119, 472, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29120, 472, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29121, 472, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (29122, 472, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (29123, 472, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (29124, 472, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29125, 472, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29126, 472, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29127, 472, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29128, 472, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29129, 472, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (29130, 472, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (29131, 472, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29132, 472, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (29133, 472, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (29134, 472, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (29135, 472, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (29136, 472, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (29137, 472, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29138, 472, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29139, 472, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29140, 472, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29141, 472, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (29142, 472, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29143, 472, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (29144, 472, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29145, 472, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (29146, 472, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29147, 472, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29148, 472, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (29149, 472, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29150, 472, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (29151, 472, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29152, 472, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (29153, 472, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (29154, 472, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29155, 472, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (29156, 472, 157, 1026);
INSERT INTO 'capvalue' VALUES (1951, '2005-04-27');
INSERT INTO 'devicecapvalue' VALUES (29157, 473, 158, 1951);
INSERT INTO 'devicecapvalue' VALUES (29158, 473, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (29159, 473, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (29160, 473, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (29161, 473, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (29162, 473, 10, 663);
INSERT INTO 'devicecapvalue' VALUES (29163, 473, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (29164, 473, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (29165, 473, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (29166, 473, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (29167, 473, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (29168, 473, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (29169, 473, 13, 1950);
INSERT INTO 'devicecapvalue' VALUES (29170, 473, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29171, 473, 77, 745);
INSERT INTO 'devicecapvalue' VALUES (29172, 473, 78, 1273);
INSERT INTO 'devicecapvalue' VALUES (29173, 473, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29174, 473, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29175, 473, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29176, 473, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29177, 473, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (29178, 473, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29179, 473, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29180, 473, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29181, 473, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29182, 473, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29183, 473, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (29184, 473, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (29185, 473, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (29186, 473, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (29187, 473, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (29188, 473, 88, 1550);
INSERT INTO 'capvalue' VALUES (1952, 'Symbian OS 8.1a');
INSERT INTO 'devicecapvalue' VALUES (29189, 473, 3, 1952);
INSERT INTO 'devicecapvalue' VALUES (29190, 473, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (29191, 473, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (29192, 473, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29193, 473, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (29194, 473, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (29195, 473, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (29196, 473, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (29197, 473, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (29198, 473, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (29199, 473, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29200, 473, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29201, 473, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29202, 473, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (29203, 473, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29204, 473, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29205, 473, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (29206, 473, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29207, 473, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (29208, 473, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29209, 473, 51, 1690);
INSERT INTO 'devicecapvalue' VALUES (29210, 473, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29211, 473, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29212, 473, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (29213, 473, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29214, 473, 52, 1718);
INSERT INTO 'devicecapvalue' VALUES (29215, 473, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29216, 473, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (29217, 473, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (29218, 473, 157, 1504);
INSERT INTO 'capvalue' VALUES (1953, 'Mozilla/4.0 (compatible; MSIE 6.0; Symbian OS; Opera 8.65; Nokia N70/5.0609.2.0.1; 9399) Opera 8.65 [en]');
INSERT INTO 'devicecapvalue' VALUES (29219, 473, 53, 1953);
INSERT INTO 'capvalue' VALUES (1954, '2005-11-02');
INSERT INTO 'devicecapvalue' VALUES (29220, 474, 158, 1954);
INSERT INTO 'devicecapvalue' VALUES (29221, 474, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (29222, 474, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (29223, 474, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (29224, 474, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (29225, 474, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (29226, 474, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (29227, 474, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (29228, 474, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (29229, 474, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (29230, 474, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29231, 474, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (29232, 474, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (29233, 474, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (29234, 474, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (29235, 474, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29236, 474, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29237, 474, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (29238, 474, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29239, 474, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29240, 474, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (29241, 474, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (29242, 474, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (29243, 474, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29244, 474, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29245, 474, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29246, 474, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29247, 474, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29248, 474, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (29249, 474, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (29250, 474, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (29251, 474, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (29252, 474, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (29253, 474, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (29254, 474, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (29255, 474, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (29256, 474, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29257, 474, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (29258, 474, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (29259, 474, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (29260, 474, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (29261, 474, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29262, 474, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29263, 474, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29264, 474, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29265, 474, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (29266, 474, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29267, 474, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (29268, 474, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29269, 474, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (29270, 474, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29271, 474, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29272, 474, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (29273, 474, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29274, 474, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (29275, 474, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29276, 474, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (29277, 474, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (29278, 474, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29279, 474, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (29280, 474, 157, 1504);
INSERT INTO 'capvalue' VALUES (1955, 'NokiaN71-1/2.0613 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (29281, 474, 53, 1955);
INSERT INTO 'capvalue' VALUES (1956, '2006-04-25');
INSERT INTO 'devicecapvalue' VALUES (29282, 475, 158, 1956);
INSERT INTO 'devicecapvalue' VALUES (29283, 475, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (29284, 475, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (29285, 475, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (29286, 475, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (29287, 475, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (29288, 475, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (29289, 475, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (29290, 475, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (29291, 475, 13, 1950);
INSERT INTO 'devicecapvalue' VALUES (29292, 475, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29293, 475, 77, 842);
INSERT INTO 'devicecapvalue' VALUES (29294, 475, 78, 842);
INSERT INTO 'devicecapvalue' VALUES (29295, 475, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29296, 475, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29297, 475, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29298, 475, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29299, 475, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (29300, 475, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29301, 475, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29302, 475, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29303, 475, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29304, 475, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29305, 475, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (29306, 475, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (29307, 475, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (29308, 475, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (29309, 475, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (29310, 475, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (29311, 475, 3, 1952);
INSERT INTO 'devicecapvalue' VALUES (29312, 475, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (29313, 475, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29314, 475, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (29315, 475, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (29316, 475, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29317, 475, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29318, 475, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29319, 475, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29320, 475, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29321, 475, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (29322, 475, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29323, 475, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29324, 475, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29325, 475, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29326, 475, 51, 1872);
INSERT INTO 'devicecapvalue' VALUES (29327, 475, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29328, 475, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (29329, 475, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (29330, 475, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29331, 475, 157, 1026);
INSERT INTO 'capvalue' VALUES (1957, 'NokiaN72/2.0625.2.0.2 Series60/2.8 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (29332, 475, 53, 1957);
INSERT INTO 'devicecapvalue' VALUES (29333, 476, 158, 1956);
INSERT INTO 'devicecapvalue' VALUES (29334, 476, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (29335, 476, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (29336, 476, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (29337, 476, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (29338, 476, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (29339, 476, 10, 663);
INSERT INTO 'devicecapvalue' VALUES (29340, 476, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (29341, 476, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (29342, 476, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (29343, 476, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (29344, 476, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (29345, 476, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (29346, 476, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (29347, 476, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29348, 476, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (29349, 476, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (29350, 476, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (29351, 476, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (29352, 476, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29353, 476, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29354, 476, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (29355, 476, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29356, 476, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29357, 476, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (29358, 476, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (29359, 476, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (29360, 476, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29361, 476, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29362, 476, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29363, 476, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29364, 476, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29365, 476, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (29366, 476, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (29367, 476, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (29368, 476, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (29369, 476, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (29370, 476, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (29371, 476, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (29372, 476, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (29373, 476, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (29374, 476, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29375, 476, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (29376, 476, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (29377, 476, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (29378, 476, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29379, 476, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29380, 476, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29381, 476, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29382, 476, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29383, 476, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (29384, 476, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29385, 476, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29386, 476, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29387, 476, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29388, 476, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29389, 476, 51, 1041);
INSERT INTO 'capvalue' VALUES (1958, '44040192');
INSERT INTO 'devicecapvalue' VALUES (29390, 476, 52, 1958);
INSERT INTO 'devicecapvalue' VALUES (29391, 476, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29392, 476, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (29393, 476, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (29394, 476, 157, 1504);
INSERT INTO 'capvalue' VALUES (1959, 'NokiaN73-1/3.0638.0.0.1 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (29395, 476, 53, 1959);
INSERT INTO 'capvalue' VALUES (1960, '2006-09-26');
INSERT INTO 'devicecapvalue' VALUES (29396, 477, 158, 1960);
INSERT INTO 'devicecapvalue' VALUES (29397, 477, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (29398, 477, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (29399, 477, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (29400, 477, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (29401, 477, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (29402, 477, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (29403, 477, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (29404, 477, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (29405, 477, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (29406, 477, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (29407, 477, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (29408, 477, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29409, 477, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (29410, 477, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (29411, 477, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (29412, 477, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (29413, 477, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29414, 477, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29415, 477, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (29416, 477, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29417, 477, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29418, 477, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (29419, 477, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (29420, 477, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (29421, 477, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29422, 477, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29423, 477, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29424, 477, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29425, 477, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29426, 477, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29427, 477, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (29428, 477, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (29429, 477, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (29430, 477, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (29431, 477, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (29432, 477, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (29433, 477, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (29434, 477, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (29435, 477, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (29436, 477, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (29437, 477, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (29438, 477, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (29439, 477, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (29440, 477, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (29441, 477, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (29442, 477, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29443, 477, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29444, 477, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29445, 477, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (29446, 477, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29447, 477, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (29448, 477, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29449, 477, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (29450, 477, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29451, 477, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (29452, 477, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29453, 477, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29454, 477, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (29455, 477, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29456, 477, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29457, 477, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (29458, 477, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (29459, 477, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (29460, 477, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29461, 477, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (29462, 477, 157, 1504);
INSERT INTO 'capvalue' VALUES (1961, 'NokiaN75-3/0.0630.0.0.3 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (29463, 477, 53, 1961);
INSERT INTO 'devicecapvalue' VALUES (29464, 478, 158, 1725);
INSERT INTO 'devicecapvalue' VALUES (29465, 478, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (29466, 478, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (29467, 478, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (29468, 478, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (29469, 478, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (29470, 478, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (29471, 478, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (29472, 478, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29473, 478, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (29474, 478, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (29475, 478, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (29476, 478, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (29477, 478, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29478, 478, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29479, 478, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (29480, 478, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29481, 478, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29482, 478, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (29483, 478, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (29484, 478, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (29485, 478, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (29486, 478, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29487, 478, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29488, 478, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29489, 478, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29490, 478, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29491, 478, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (29492, 478, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29493, 478, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (29494, 478, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (29495, 478, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (29496, 478, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (29497, 478, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (29498, 478, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (29499, 478, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (29500, 478, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (29501, 478, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (29502, 478, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (29503, 478, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (29504, 478, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29505, 478, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29506, 478, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29507, 478, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29508, 478, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (29509, 478, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29510, 478, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (29511, 478, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29512, 478, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (29513, 478, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29514, 478, 51, 1690);
INSERT INTO 'devicecapvalue' VALUES (29515, 478, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29516, 478, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (29517, 478, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29518, 478, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29519, 478, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (29520, 478, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (29521, 478, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (29522, 478, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29523, 478, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (29524, 478, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (29525, 478, 157, 1504);
INSERT INTO 'capvalue' VALUES (1962, 'Mozilla/5.0 (SymbianOS/9.2; U; Series60/3.1 NokiaN76-1/10.0.035 Profile/MIDP-2.0 Configuration/CLDC-1.1 ) AppleWebKit/413 (KHTML');
INSERT INTO 'devicecapvalue' VALUES (29526, 478, 53, 1962);
INSERT INTO 'devicecapvalue' VALUES (29527, 478, 53, 1799);
INSERT INTO 'devicecapvalue' VALUES (29528, 479, 158, 1714);
INSERT INTO 'devicecapvalue' VALUES (29529, 479, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (29530, 479, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (29531, 479, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (29532, 479, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (29533, 479, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (29534, 479, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (29535, 479, 10, 663);
INSERT INTO 'devicecapvalue' VALUES (29536, 479, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (29537, 479, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (29538, 479, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (29539, 479, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (29540, 479, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (29541, 479, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (29542, 479, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (29543, 479, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29544, 479, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (29545, 479, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (29546, 479, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (29547, 479, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (29548, 479, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29549, 479, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29550, 479, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (29551, 479, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29552, 479, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29553, 479, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (29554, 479, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (29555, 479, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (29556, 479, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29557, 479, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29558, 479, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29559, 479, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29560, 479, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29561, 479, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (29562, 479, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (29563, 479, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (29564, 479, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (29565, 479, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (29566, 479, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (29567, 479, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (29568, 479, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (29569, 479, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (29570, 479, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29571, 479, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (29572, 479, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (29573, 479, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (29574, 479, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29575, 479, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29576, 479, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29577, 479, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29578, 479, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29579, 479, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (29580, 479, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29581, 479, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29582, 479, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29583, 479, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29584, 479, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29585, 479, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (29586, 479, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (29587, 479, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29588, 479, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (29589, 479, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (29590, 479, 157, 1504);
INSERT INTO 'capvalue' VALUES (1963, 'NokiaN77-1/2.0720.1.0.1 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (29591, 479, 53, 1963);
INSERT INTO 'devicecapvalue' VALUES (29592, 480, 158, 1741);
INSERT INTO 'devicecapvalue' VALUES (29593, 480, 1, 649);
INSERT INTO 'capvalue' VALUES (1964, 'noSystemArrayCopy');
INSERT INTO 'devicecapvalue' VALUES (29594, 480, 74, 1964);
INSERT INTO 'devicecapvalue' VALUES (29595, 480, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (29596, 480, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (29597, 480, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (29598, 480, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (29599, 480, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (29600, 480, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (29601, 480, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29602, 480, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (29603, 480, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (29604, 480, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (29605, 480, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (29606, 480, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29607, 480, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (29608, 480, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29609, 480, 17, 1742);
INSERT INTO 'devicecapvalue' VALUES (29610, 480, 17, 1743);
INSERT INTO 'devicecapvalue' VALUES (29611, 480, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (29612, 480, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29613, 480, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29614, 480, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (29615, 480, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (29616, 480, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (29617, 480, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (29618, 480, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29619, 480, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29620, 480, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29621, 480, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (29622, 480, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (29623, 480, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29624, 480, 3, 1744);
INSERT INTO 'devicecapvalue' VALUES (29625, 480, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29626, 480, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (29627, 480, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (29628, 480, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (29629, 480, 156, 1417);
INSERT INTO 'devicecapvalue' VALUES (29630, 480, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (29631, 480, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (29632, 480, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (29633, 480, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (29634, 480, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (29635, 480, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (29636, 480, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (29637, 480, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29638, 480, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29639, 480, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29640, 480, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29641, 480, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (29642, 480, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29643, 480, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (29644, 480, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29645, 480, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (29646, 480, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29647, 480, 51, 1690);
INSERT INTO 'devicecapvalue' VALUES (29648, 480, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29649, 480, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (29650, 480, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29651, 480, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29652, 480, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (29653, 480, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (29654, 480, 52, 1764);
INSERT INTO 'devicecapvalue' VALUES (29655, 480, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29656, 480, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (29657, 480, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (29658, 480, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (29659, 481, 158, 1954);
INSERT INTO 'devicecapvalue' VALUES (29660, 481, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (29661, 481, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (29662, 481, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (29663, 481, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (29664, 481, 2, 1001);
INSERT INTO 'capvalue' VALUES (1965, '34');
INSERT INTO 'devicecapvalue' VALUES (29665, 481, 10, 1965);
INSERT INTO 'devicecapvalue' VALUES (29666, 481, 11, 963);
INSERT INTO 'devicecapvalue' VALUES (29667, 481, 12, 649);
INSERT INTO 'devicecapvalue' VALUES (29668, 481, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (29669, 481, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (29670, 481, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (29671, 481, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (29672, 481, 13, 1885);
INSERT INTO 'devicecapvalue' VALUES (29673, 481, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29674, 481, 77, 1341);
INSERT INTO 'devicecapvalue' VALUES (29675, 481, 78, 1341);
INSERT INTO 'devicecapvalue' VALUES (29676, 481, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29677, 481, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29678, 481, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (29679, 481, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29680, 481, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29681, 481, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (29682, 481, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (29683, 481, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (29684, 481, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29685, 481, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29686, 481, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29687, 481, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29688, 481, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29689, 481, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (29690, 481, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (29691, 481, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (29692, 481, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (29693, 481, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (29694, 481, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (29695, 481, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (29696, 481, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (29697, 481, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29698, 481, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (29699, 481, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (29700, 481, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (29701, 481, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (29702, 481, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (29703, 481, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (29704, 481, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (29705, 481, 4, 671);
INSERT INTO 'devicecapvalue' VALUES (29706, 481, 5, 672);
INSERT INTO 'devicecapvalue' VALUES (29707, 481, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29708, 481, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29709, 481, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29710, 481, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (29711, 481, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29712, 481, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (29713, 481, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (29714, 481, 51, 1502);
INSERT INTO 'devicecapvalue' VALUES (29715, 481, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (29716, 481, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (29717, 481, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (29718, 481, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (29719, 481, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (29720, 481, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (29721, 481, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (29722, 481, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (29723, 481, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (29724, 481, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (29725, 481, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (29726, 481, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (29727, 481, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (29728, 481, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (29729, 481, 53, 1887);
INSERT INTO 'devicecapvalue' VALUES (29730, 481, 53, 1799);
INSERT INTO 'devicecapvalue' VALUES (29731, 482, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (29732, 482, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (29733, 482, 7, 1916);
INSERT INTO 'devicecapvalue' VALUES (29734, 482, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (29735, 482, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (29736, 482, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (29737, 482, 173, 1556);
INSERT INTO 'devicecapvalue' VALUES (29738, 482, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (29739, 482, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (29740, 482, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (29741, 482, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (29742, 482, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (29743, 482, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (29744, 482, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (29745, 482, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (29746, 482, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (29747, 482, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (29748, 482, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (29749, 482, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (29750, 482, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (29751, 482, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (29752, 482, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (29753, 482, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (29754, 482, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (29755, 482, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (29756, 482, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (29757, 482, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (29758, 482, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (29759, 482, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (29760, 482, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29761, 482, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (29762, 482, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (29763, 482, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (29764, 482, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (29765, 482, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (29766, 482, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (29767, 482, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (29768, 482, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (29769, 482, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (29770, 482, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29771, 482, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (29772, 482, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (29773, 482, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (29774, 482, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (29775, 482, 32, 1911);
INSERT INTO 'devicecapvalue' VALUES (29776, 482, 32, 1611);
INSERT INTO 'devicecapvalue' VALUES (29777, 482, 32, 1612);
INSERT INTO 'devicecapvalue' VALUES (29778, 482, 32, 1613);
INSERT INTO 'devicecapvalue' VALUES (29779, 482, 32, 1614);
INSERT INTO 'devicecapvalue' VALUES (29780, 482, 32, 1615);
INSERT INTO 'devicecapvalue' VALUES (29781, 482, 32, 1616);
INSERT INTO 'devicecapvalue' VALUES (29782, 482, 32, 1617);
INSERT INTO 'devicecapvalue' VALUES (29783, 482, 32, 1618);
INSERT INTO 'devicecapvalue' VALUES (29784, 482, 32, 1619);
INSERT INTO 'devicecapvalue' VALUES (29785, 482, 32, 1620);
INSERT INTO 'devicecapvalue' VALUES (29786, 482, 32, 1621);
INSERT INTO 'devicecapvalue' VALUES (29787, 482, 32, 1622);
INSERT INTO 'devicecapvalue' VALUES (29788, 482, 32, 1623);
INSERT INTO 'devicecapvalue' VALUES (29789, 482, 32, 1624);
INSERT INTO 'devicecapvalue' VALUES (29790, 482, 32, 1625);
INSERT INTO 'devicecapvalue' VALUES (29791, 482, 32, 1626);
INSERT INTO 'devicecapvalue' VALUES (29792, 482, 32, 1627);
INSERT INTO 'devicecapvalue' VALUES (29793, 482, 32, 1628);
INSERT INTO 'devicecapvalue' VALUES (29794, 482, 32, 1629);
INSERT INTO 'devicecapvalue' VALUES (29795, 482, 32, 1630);
INSERT INTO 'devicecapvalue' VALUES (29796, 482, 32, 1631);
INSERT INTO 'devicecapvalue' VALUES (29797, 482, 32, 1632);
INSERT INTO 'devicecapvalue' VALUES (29798, 482, 32, 1633);
INSERT INTO 'devicecapvalue' VALUES (29799, 482, 32, 1634);
INSERT INTO 'devicecapvalue' VALUES (29800, 482, 32, 1635);
INSERT INTO 'devicecapvalue' VALUES (29801, 482, 32, 1636);
INSERT INTO 'devicecapvalue' VALUES (29802, 482, 32, 1637);
INSERT INTO 'devicecapvalue' VALUES (29803, 482, 32, 1638);
INSERT INTO 'devicecapvalue' VALUES (29804, 482, 32, 1639);
INSERT INTO 'devicecapvalue' VALUES (29805, 482, 32, 1640);
INSERT INTO 'devicecapvalue' VALUES (29806, 482, 32, 1641);
INSERT INTO 'devicecapvalue' VALUES (29807, 482, 32, 1642);
INSERT INTO 'devicecapvalue' VALUES (29808, 482, 32, 1643);
INSERT INTO 'devicecapvalue' VALUES (29809, 482, 32, 1644);
INSERT INTO 'devicecapvalue' VALUES (29810, 482, 32, 1645);
INSERT INTO 'devicecapvalue' VALUES (29811, 482, 32, 1646);
INSERT INTO 'devicecapvalue' VALUES (29812, 482, 32, 1647);
INSERT INTO 'devicecapvalue' VALUES (29813, 482, 32, 1648);
INSERT INTO 'devicecapvalue' VALUES (29814, 482, 32, 1649);
INSERT INTO 'devicecapvalue' VALUES (29815, 482, 32, 1650);
INSERT INTO 'devicecapvalue' VALUES (29816, 482, 32, 1651);
INSERT INTO 'devicecapvalue' VALUES (29817, 482, 32, 1652);
INSERT INTO 'devicecapvalue' VALUES (29818, 482, 32, 1653);
INSERT INTO 'devicecapvalue' VALUES (29819, 482, 32, 1654);
INSERT INTO 'devicecapvalue' VALUES (29820, 482, 32, 1655);
INSERT INTO 'devicecapvalue' VALUES (29821, 482, 32, 1656);
INSERT INTO 'devicecapvalue' VALUES (29822, 482, 32, 1657);
INSERT INTO 'devicecapvalue' VALUES (29823, 482, 32, 1658);
INSERT INTO 'devicecapvalue' VALUES (29824, 482, 32, 1659);
INSERT INTO 'devicecapvalue' VALUES (29825, 482, 32, 1660);
INSERT INTO 'devicecapvalue' VALUES (29826, 482, 32, 1661);
INSERT INTO 'devicecapvalue' VALUES (29827, 482, 32, 1662);
INSERT INTO 'devicecapvalue' VALUES (29828, 482, 32, 1663);
INSERT INTO 'devicecapvalue' VALUES (29829, 482, 32, 1664);
INSERT INTO 'devicecapvalue' VALUES (29830, 482, 32, 1665);
INSERT INTO 'devicecapvalue' VALUES (29831, 482, 32, 1666);
INSERT INTO 'devicecapvalue' VALUES (29832, 482, 32, 1667);
INSERT INTO 'devicecapvalue' VALUES (29833, 482, 32, 1668);
INSERT INTO 'devicecapvalue' VALUES (29834, 482, 32, 1669);
INSERT INTO 'devicecapvalue' VALUES (29835, 482, 32, 1670);
INSERT INTO 'devicecapvalue' VALUES (29836, 482, 32, 1672);
INSERT INTO 'devicecapvalue' VALUES (29837, 482, 32, 1673);
INSERT INTO 'devicecapvalue' VALUES (29838, 482, 32, 1674);
INSERT INTO 'devicecapvalue' VALUES (29839, 482, 32, 1260);
INSERT INTO 'devicecapvalue' VALUES (29840, 482, 32, 1471);
INSERT INTO 'devicecapvalue' VALUES (29841, 482, 32, 1912);
INSERT INTO 'devicecapvalue' VALUES (29842, 482, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (29843, 482, 33, 43);
INSERT INTO 'cap' VALUES (225, 'microedition.hostname', 1);
INSERT INTO 'devicecapvalue' VALUES (29844, 482, 225, 1677);
INSERT INTO 'devicecapvalue' VALUES (29845, 482, 81, 45);
INSERT INTO 'devicecapvalue' VALUES (29846, 482, 35, 45);
INSERT INTO 'devicecapvalue' VALUES (29847, 482, 82, 45);
INSERT INTO 'devicecapvalue' VALUES (29848, 482, 152, 242);
INSERT INTO 'devicecapvalue' VALUES (29849, 482, 83, 242);
INSERT INTO 'devicecapvalue' VALUES (29850, 482, 84, 45);
INSERT INTO 'capvalue' VALUES (1966, 'NokiaN81-3/10.0.035');
INSERT INTO 'devicecapvalue' VALUES (29851, 482, 36, 1966);
INSERT INTO 'devicecapvalue' VALUES (29852, 482, 37, 47);
INSERT INTO 'cap' VALUES (226, 'microedition.sip.version', 1);
INSERT INTO 'devicecapvalue' VALUES (29853, 482, 226, 613);
INSERT INTO 'devicecapvalue' VALUES (29854, 482, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (29855, 482, 38, 1045);
INSERT INTO 'devicecapvalue' VALUES (29856, 482, 38, 616);
INSERT INTO 'devicecapvalue' VALUES (29857, 482, 38, 867);
INSERT INTO 'devicecapvalue' VALUES (29858, 482, 38, 1050);
INSERT INTO 'devicecapvalue' VALUES (29859, 482, 38, 1578);
INSERT INTO 'devicecapvalue' VALUES (29860, 482, 38, 51);
INSERT INTO 'devicecapvalue' VALUES (29861, 482, 38, 1004);
INSERT INTO 'devicecapvalue' VALUES (29862, 482, 38, 865);
INSERT INTO 'devicecapvalue' VALUES (29863, 482, 38, 1919);
INSERT INTO 'devicecapvalue' VALUES (29864, 482, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (29865, 482, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (29866, 482, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (29867, 482, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (29868, 482, 39, 1050);
INSERT INTO 'devicecapvalue' VALUES (29869, 482, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (29870, 482, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (29871, 482, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (29872, 482, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (29873, 482, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (29874, 482, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (29875, 482, 40, 125);
INSERT INTO 'devicecapvalue' VALUES (29876, 482, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (29877, 482, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (29878, 482, 40, 1580);
INSERT INTO 'devicecapvalue' VALUES (29879, 482, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (29880, 482, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (29881, 482, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (29882, 482, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (29883, 482, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (29884, 482, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (29885, 482, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (29886, 482, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (29887, 482, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (29888, 482, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (29889, 482, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (29890, 482, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (29891, 482, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (29892, 482, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (29893, 482, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (29894, 482, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (29895, 482, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (29896, 482, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (29897, 482, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (29898, 482, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (29899, 482, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (29900, 482, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (29901, 482, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (29902, 482, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (29903, 482, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (29904, 482, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (29905, 482, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (29906, 482, 41, 1584);
INSERT INTO 'devicecapvalue' VALUES (29907, 482, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (29908, 482, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (29909, 482, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (29910, 482, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (29911, 482, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (29912, 482, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (29913, 482, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (29914, 482, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (29915, 482, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (29916, 482, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (29917, 482, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (29918, 482, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (29919, 482, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (29920, 482, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (29921, 482, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (29922, 482, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (29923, 482, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (29924, 482, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (29925, 482, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (29926, 482, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (29927, 482, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (29928, 482, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (29929, 482, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (29930, 482, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (29931, 482, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (29932, 482, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (29933, 482, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (29934, 482, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (29935, 482, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (29936, 482, 42, 1584);
INSERT INTO 'devicecapvalue' VALUES (29937, 482, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (29938, 482, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (29939, 482, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (29940, 482, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (29941, 482, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (29942, 482, 45, 1051);
INSERT INTO 'devicecapvalue' VALUES (29943, 482, 45, 67);
INSERT INTO 'devicecapvalue' VALUES (29944, 482, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (29945, 482, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (29946, 482, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (29947, 482, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (29948, 482, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (29949, 482, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (29950, 482, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (29951, 482, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (29952, 482, 103, 1604);
INSERT INTO 'devicecapvalue' VALUES (29953, 482, 104, 944);
INSERT INTO 'capvalue' VALUES (1967, 'file:///c:/private/102033e6/midlets/[1016f5cd]/scratch/');
INSERT INTO 'devicecapvalue' VALUES (29954, 482, 105, 1967);
INSERT INTO 'devicecapvalue' VALUES (29955, 482, 106, 1607);
INSERT INTO 'devicecapvalue' VALUES (29956, 482, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (29957, 482, 108, 1609);
INSERT INTO 'devicecapvalue' VALUES (29958, 482, 109, 1928);
INSERT INTO 'devicecapvalue' VALUES (29959, 482, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (29960, 482, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (29961, 482, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (29962, 482, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (29963, 482, 137, 1396);
INSERT INTO 'devicecapvalue' VALUES (29964, 482, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (29965, 482, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (29966, 482, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (29967, 482, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (29968, 482, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (29969, 482, 137, 96);
INSERT INTO 'devicecapvalue' VALUES (29970, 482, 47, 56);
INSERT INTO 'devicecapvalue' VALUES (29971, 482, 47, 868);
INSERT INTO 'devicecapvalue' VALUES (29972, 482, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (29973, 482, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (29974, 482, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (29975, 482, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (29976, 482, 47, 1684);
INSERT INTO 'devicecapvalue' VALUES (29977, 482, 47, 986);
INSERT INTO 'devicecapvalue' VALUES (29978, 482, 47, 988);
INSERT INTO 'devicecapvalue' VALUES (29979, 482, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (29980, 482, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (29981, 482, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (29982, 482, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (29983, 482, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (29984, 482, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (29985, 482, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (29986, 482, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (29987, 482, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (29988, 482, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (29989, 482, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (29990, 482, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (29991, 482, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (29992, 482, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (29993, 482, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (29994, 482, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (29995, 482, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (29996, 482, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (29997, 482, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (29998, 482, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (29999, 482, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (30000, 482, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (30001, 482, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (30002, 482, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (30003, 482, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (30004, 482, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (30005, 482, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (30006, 482, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (30007, 482, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (30008, 482, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (30009, 482, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (30010, 482, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (30011, 482, 52, 1460);
INSERT INTO 'devicecapvalue' VALUES (30012, 482, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (30013, 482, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (30014, 482, 157, 1087);
INSERT INTO 'capvalue' VALUES (1968, '3gpp2');
INSERT INTO 'devicecapvalue' VALUES (30015, 482, 157, 1968);
INSERT INTO 'devicecapvalue' VALUES (30016, 482, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (30017, 482, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (30018, 482, 157, 1117);
INSERT INTO 'devicecapvalue' VALUES (30019, 482, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (30020, 482, 157, 1504);
INSERT INTO 'capvalue' VALUES (1969, 'Mozilla/5.0 (SymbianOS/9.2; U; Series60/3.1 NokiaN81-1/1.00 Profile/MIDP-2.0 Configuration/CLDC-1.1) AppleWebKit/413 (KHTML');
INSERT INTO 'devicecapvalue' VALUES (30021, 482, 53, 1969);
INSERT INTO 'devicecapvalue' VALUES (30022, 482, 53, 1799);
INSERT INTO 'devicecapvalue' VALUES (30023, 483, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (30024, 483, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (30025, 483, 7, 1916);
INSERT INTO 'devicecapvalue' VALUES (30026, 483, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (30027, 483, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (30028, 483, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (30029, 483, 173, 1556);
INSERT INTO 'devicecapvalue' VALUES (30030, 483, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (30031, 483, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (30032, 483, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (30033, 483, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (30034, 483, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (30035, 483, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (30036, 483, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (30037, 483, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (30038, 483, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (30039, 483, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (30040, 483, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (30041, 483, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (30042, 483, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (30043, 483, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (30044, 483, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (30045, 483, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (30046, 483, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (30047, 483, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (30048, 483, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (30049, 483, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (30050, 483, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (30051, 483, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (30052, 483, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (30053, 483, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (30054, 483, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (30055, 483, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (30056, 483, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (30057, 483, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (30058, 483, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (30059, 483, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (30060, 483, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (30061, 483, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (30062, 483, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (30063, 483, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (30064, 483, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (30065, 483, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (30066, 483, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (30067, 483, 32, 1911);
INSERT INTO 'devicecapvalue' VALUES (30068, 483, 32, 1611);
INSERT INTO 'devicecapvalue' VALUES (30069, 483, 32, 1612);
INSERT INTO 'devicecapvalue' VALUES (30070, 483, 32, 1613);
INSERT INTO 'devicecapvalue' VALUES (30071, 483, 32, 1614);
INSERT INTO 'devicecapvalue' VALUES (30072, 483, 32, 1615);
INSERT INTO 'devicecapvalue' VALUES (30073, 483, 32, 1616);
INSERT INTO 'devicecapvalue' VALUES (30074, 483, 32, 1617);
INSERT INTO 'devicecapvalue' VALUES (30075, 483, 32, 1618);
INSERT INTO 'devicecapvalue' VALUES (30076, 483, 32, 1619);
INSERT INTO 'devicecapvalue' VALUES (30077, 483, 32, 1620);
INSERT INTO 'devicecapvalue' VALUES (30078, 483, 32, 1621);
INSERT INTO 'devicecapvalue' VALUES (30079, 483, 32, 1622);
INSERT INTO 'devicecapvalue' VALUES (30080, 483, 32, 1623);
INSERT INTO 'devicecapvalue' VALUES (30081, 483, 32, 1624);
INSERT INTO 'devicecapvalue' VALUES (30082, 483, 32, 1625);
INSERT INTO 'devicecapvalue' VALUES (30083, 483, 32, 1626);
INSERT INTO 'devicecapvalue' VALUES (30084, 483, 32, 1627);
INSERT INTO 'devicecapvalue' VALUES (30085, 483, 32, 1628);
INSERT INTO 'devicecapvalue' VALUES (30086, 483, 32, 1629);
INSERT INTO 'devicecapvalue' VALUES (30087, 483, 32, 1630);
INSERT INTO 'devicecapvalue' VALUES (30088, 483, 32, 1631);
INSERT INTO 'devicecapvalue' VALUES (30089, 483, 32, 1632);
INSERT INTO 'devicecapvalue' VALUES (30090, 483, 32, 1633);
INSERT INTO 'devicecapvalue' VALUES (30091, 483, 32, 1634);
INSERT INTO 'devicecapvalue' VALUES (30092, 483, 32, 1635);
INSERT INTO 'devicecapvalue' VALUES (30093, 483, 32, 1636);
INSERT INTO 'devicecapvalue' VALUES (30094, 483, 32, 1637);
INSERT INTO 'devicecapvalue' VALUES (30095, 483, 32, 1638);
INSERT INTO 'devicecapvalue' VALUES (30096, 483, 32, 1639);
INSERT INTO 'devicecapvalue' VALUES (30097, 483, 32, 1640);
INSERT INTO 'devicecapvalue' VALUES (30098, 483, 32, 1641);
INSERT INTO 'devicecapvalue' VALUES (30099, 483, 32, 1642);
INSERT INTO 'devicecapvalue' VALUES (30100, 483, 32, 1643);
INSERT INTO 'devicecapvalue' VALUES (30101, 483, 32, 1644);
INSERT INTO 'devicecapvalue' VALUES (30102, 483, 32, 1645);
INSERT INTO 'devicecapvalue' VALUES (30103, 483, 32, 1646);
INSERT INTO 'devicecapvalue' VALUES (30104, 483, 32, 1647);
INSERT INTO 'devicecapvalue' VALUES (30105, 483, 32, 1648);
INSERT INTO 'devicecapvalue' VALUES (30106, 483, 32, 1649);
INSERT INTO 'devicecapvalue' VALUES (30107, 483, 32, 1650);
INSERT INTO 'devicecapvalue' VALUES (30108, 483, 32, 1651);
INSERT INTO 'devicecapvalue' VALUES (30109, 483, 32, 1652);
INSERT INTO 'devicecapvalue' VALUES (30110, 483, 32, 1653);
INSERT INTO 'devicecapvalue' VALUES (30111, 483, 32, 1654);
INSERT INTO 'devicecapvalue' VALUES (30112, 483, 32, 1655);
INSERT INTO 'devicecapvalue' VALUES (30113, 483, 32, 1656);
INSERT INTO 'devicecapvalue' VALUES (30114, 483, 32, 1657);
INSERT INTO 'devicecapvalue' VALUES (30115, 483, 32, 1658);
INSERT INTO 'devicecapvalue' VALUES (30116, 483, 32, 1659);
INSERT INTO 'devicecapvalue' VALUES (30117, 483, 32, 1660);
INSERT INTO 'devicecapvalue' VALUES (30118, 483, 32, 1661);
INSERT INTO 'devicecapvalue' VALUES (30119, 483, 32, 1662);
INSERT INTO 'devicecapvalue' VALUES (30120, 483, 32, 1663);
INSERT INTO 'devicecapvalue' VALUES (30121, 483, 32, 1664);
INSERT INTO 'devicecapvalue' VALUES (30122, 483, 32, 1665);
INSERT INTO 'devicecapvalue' VALUES (30123, 483, 32, 1666);
INSERT INTO 'devicecapvalue' VALUES (30124, 483, 32, 1667);
INSERT INTO 'devicecapvalue' VALUES (30125, 483, 32, 1668);
INSERT INTO 'devicecapvalue' VALUES (30126, 483, 32, 1669);
INSERT INTO 'devicecapvalue' VALUES (30127, 483, 32, 1670);
INSERT INTO 'devicecapvalue' VALUES (30128, 483, 32, 1672);
INSERT INTO 'devicecapvalue' VALUES (30129, 483, 32, 1673);
INSERT INTO 'devicecapvalue' VALUES (30130, 483, 32, 1674);
INSERT INTO 'devicecapvalue' VALUES (30131, 483, 32, 1260);
INSERT INTO 'devicecapvalue' VALUES (30132, 483, 32, 1471);
INSERT INTO 'devicecapvalue' VALUES (30133, 483, 32, 1912);
INSERT INTO 'devicecapvalue' VALUES (30134, 483, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (30135, 483, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (30136, 483, 225, 1677);
INSERT INTO 'devicecapvalue' VALUES (30137, 483, 81, 45);
INSERT INTO 'devicecapvalue' VALUES (30138, 483, 35, 45);
INSERT INTO 'devicecapvalue' VALUES (30139, 483, 82, 45);
INSERT INTO 'devicecapvalue' VALUES (30140, 483, 152, 242);
INSERT INTO 'devicecapvalue' VALUES (30141, 483, 83, 242);
INSERT INTO 'devicecapvalue' VALUES (30142, 483, 84, 45);
INSERT INTO 'devicecapvalue' VALUES (30143, 483, 36, 1966);
INSERT INTO 'devicecapvalue' VALUES (30144, 483, 37, 47);
INSERT INTO 'devicecapvalue' VALUES (30145, 483, 226, 613);
INSERT INTO 'devicecapvalue' VALUES (30146, 483, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (30147, 483, 38, 1045);
INSERT INTO 'devicecapvalue' VALUES (30148, 483, 38, 616);
INSERT INTO 'devicecapvalue' VALUES (30149, 483, 38, 867);
INSERT INTO 'devicecapvalue' VALUES (30150, 483, 38, 1050);
INSERT INTO 'devicecapvalue' VALUES (30151, 483, 38, 1578);
INSERT INTO 'devicecapvalue' VALUES (30152, 483, 38, 51);
INSERT INTO 'devicecapvalue' VALUES (30153, 483, 38, 1004);
INSERT INTO 'devicecapvalue' VALUES (30154, 483, 38, 865);
INSERT INTO 'devicecapvalue' VALUES (30155, 483, 38, 1919);
INSERT INTO 'devicecapvalue' VALUES (30156, 483, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (30157, 483, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (30158, 483, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (30159, 483, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (30160, 483, 39, 1050);
INSERT INTO 'devicecapvalue' VALUES (30161, 483, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (30162, 483, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (30163, 483, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (30164, 483, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (30165, 483, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (30166, 483, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (30167, 483, 40, 125);
INSERT INTO 'devicecapvalue' VALUES (30168, 483, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (30169, 483, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (30170, 483, 40, 1580);
INSERT INTO 'devicecapvalue' VALUES (30171, 483, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (30172, 483, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (30173, 483, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (30174, 483, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (30175, 483, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (30176, 483, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (30177, 483, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (30178, 483, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (30179, 483, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (30180, 483, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (30181, 483, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (30182, 483, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (30183, 483, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (30184, 483, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (30185, 483, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (30186, 483, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (30187, 483, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (30188, 483, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (30189, 483, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (30190, 483, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (30191, 483, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (30192, 483, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (30193, 483, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (30194, 483, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (30195, 483, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (30196, 483, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (30197, 483, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (30198, 483, 41, 1584);
INSERT INTO 'devicecapvalue' VALUES (30199, 483, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (30200, 483, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (30201, 483, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (30202, 483, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (30203, 483, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (30204, 483, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (30205, 483, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (30206, 483, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (30207, 483, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (30208, 483, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (30209, 483, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (30210, 483, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (30211, 483, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (30212, 483, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (30213, 483, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (30214, 483, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (30215, 483, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (30216, 483, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (30217, 483, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (30218, 483, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (30219, 483, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (30220, 483, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (30221, 483, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (30222, 483, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (30223, 483, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (30224, 483, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (30225, 483, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (30226, 483, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (30227, 483, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (30228, 483, 42, 1584);
INSERT INTO 'devicecapvalue' VALUES (30229, 483, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (30230, 483, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (30231, 483, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (30232, 483, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (30233, 483, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (30234, 483, 45, 1051);
INSERT INTO 'devicecapvalue' VALUES (30235, 483, 45, 67);
INSERT INTO 'devicecapvalue' VALUES (30236, 483, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (30237, 483, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (30238, 483, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (30239, 483, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (30240, 483, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (30241, 483, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (30242, 483, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (30243, 483, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (30244, 483, 103, 1604);
INSERT INTO 'devicecapvalue' VALUES (30245, 483, 104, 944);
INSERT INTO 'devicecapvalue' VALUES (30246, 483, 105, 1967);
INSERT INTO 'devicecapvalue' VALUES (30247, 483, 106, 1607);
INSERT INTO 'devicecapvalue' VALUES (30248, 483, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (30249, 483, 108, 1609);
INSERT INTO 'devicecapvalue' VALUES (30250, 483, 109, 1928);
INSERT INTO 'devicecapvalue' VALUES (30251, 483, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (30252, 483, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (30253, 483, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (30254, 483, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (30255, 483, 137, 1396);
INSERT INTO 'devicecapvalue' VALUES (30256, 483, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (30257, 483, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (30258, 483, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (30259, 483, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (30260, 483, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (30261, 483, 137, 96);
INSERT INTO 'devicecapvalue' VALUES (30262, 483, 47, 56);
INSERT INTO 'devicecapvalue' VALUES (30263, 483, 47, 868);
INSERT INTO 'devicecapvalue' VALUES (30264, 483, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (30265, 483, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (30266, 483, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (30267, 483, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (30268, 483, 47, 1684);
INSERT INTO 'devicecapvalue' VALUES (30269, 483, 47, 986);
INSERT INTO 'devicecapvalue' VALUES (30270, 483, 47, 988);
INSERT INTO 'devicecapvalue' VALUES (30271, 483, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (30272, 483, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (30273, 483, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (30274, 483, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (30275, 483, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (30276, 483, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (30277, 483, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (30278, 483, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (30279, 483, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (30280, 483, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (30281, 483, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (30282, 483, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (30283, 483, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (30284, 483, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (30285, 483, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (30286, 483, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (30287, 483, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (30288, 483, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (30289, 483, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (30290, 483, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (30291, 483, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (30292, 483, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (30293, 483, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (30294, 483, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (30295, 483, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (30296, 483, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (30297, 483, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (30298, 483, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (30299, 483, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (30300, 483, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (30301, 483, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (30302, 483, 51, 1160);
INSERT INTO 'capvalue' VALUES (1970, '8589934592');
INSERT INTO 'devicecapvalue' VALUES (30303, 483, 52, 1970);
INSERT INTO 'devicecapvalue' VALUES (30304, 483, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (30305, 483, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (30306, 483, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (30307, 483, 157, 1968);
INSERT INTO 'devicecapvalue' VALUES (30308, 483, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (30309, 483, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (30310, 483, 157, 1117);
INSERT INTO 'devicecapvalue' VALUES (30311, 483, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (30312, 483, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (30313, 483, 53, 1969);
INSERT INTO 'devicecapvalue' VALUES (30314, 483, 53, 1799);
INSERT INTO 'devicecapvalue' VALUES (30315, 484, 1, 649);
INSERT INTO 'capvalue' VALUES (1971, '2592x1944');
INSERT INTO 'devicecapvalue' VALUES (30316, 484, 160, 1971);
INSERT INTO 'devicecapvalue' VALUES (30317, 484, 7, 1916);
INSERT INTO 'devicecapvalue' VALUES (30318, 484, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (30319, 484, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (30320, 484, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (30321, 484, 173, 1556);
INSERT INTO 'devicecapvalue' VALUES (30322, 484, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (30323, 484, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (30324, 484, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (30325, 484, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (30326, 484, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (30327, 484, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (30328, 484, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (30329, 484, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (30330, 484, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (30331, 484, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (30332, 484, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (30333, 484, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (30334, 484, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (30335, 484, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (30336, 484, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (30337, 484, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (30338, 484, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (30339, 484, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (30340, 484, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (30341, 484, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (30342, 484, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (30343, 484, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (30344, 484, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (30345, 484, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (30346, 484, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (30347, 484, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (30348, 484, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (30349, 484, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (30350, 484, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (30351, 484, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (30352, 484, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (30353, 484, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (30354, 484, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (30355, 484, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (30356, 484, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (30357, 484, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (30358, 484, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (30359, 484, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (30360, 484, 163, 1244);
INSERT INTO 'devicecapvalue' VALUES (30361, 484, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (30362, 484, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (30363, 484, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (30364, 484, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (30365, 484, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (30366, 484, 57, 30);
INSERT INTO 'devicecapvalue' VALUES (30367, 484, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (30368, 484, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (30369, 484, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (30370, 484, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (30371, 484, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (30372, 484, 38, 1045);
INSERT INTO 'devicecapvalue' VALUES (30373, 484, 38, 616);
INSERT INTO 'devicecapvalue' VALUES (30374, 484, 38, 867);
INSERT INTO 'devicecapvalue' VALUES (30375, 484, 38, 1050);
INSERT INTO 'devicecapvalue' VALUES (30376, 484, 38, 1578);
INSERT INTO 'devicecapvalue' VALUES (30377, 484, 38, 51);
INSERT INTO 'devicecapvalue' VALUES (30378, 484, 38, 1004);
INSERT INTO 'devicecapvalue' VALUES (30379, 484, 38, 865);
INSERT INTO 'devicecapvalue' VALUES (30380, 484, 38, 1919);
INSERT INTO 'devicecapvalue' VALUES (30381, 484, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (30382, 484, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (30383, 484, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (30384, 484, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (30385, 484, 39, 1050);
INSERT INTO 'devicecapvalue' VALUES (30386, 484, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (30387, 484, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (30388, 484, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (30389, 484, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (30390, 484, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (30391, 484, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (30392, 484, 40, 125);
INSERT INTO 'devicecapvalue' VALUES (30393, 484, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (30394, 484, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (30395, 484, 40, 1580);
INSERT INTO 'devicecapvalue' VALUES (30396, 484, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (30397, 484, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (30398, 484, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (30399, 484, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (30400, 484, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (30401, 484, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (30402, 484, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (30403, 484, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (30404, 484, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (30405, 484, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (30406, 484, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (30407, 484, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (30408, 484, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (30409, 484, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (30410, 484, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (30411, 484, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (30412, 484, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (30413, 484, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (30414, 484, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (30415, 484, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (30416, 484, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (30417, 484, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (30418, 484, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (30419, 484, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (30420, 484, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (30421, 484, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (30422, 484, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (30423, 484, 41, 1584);
INSERT INTO 'devicecapvalue' VALUES (30424, 484, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (30425, 484, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (30426, 484, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (30427, 484, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (30428, 484, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (30429, 484, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (30430, 484, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (30431, 484, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (30432, 484, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (30433, 484, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (30434, 484, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (30435, 484, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (30436, 484, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (30437, 484, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (30438, 484, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (30439, 484, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (30440, 484, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (30441, 484, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (30442, 484, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (30443, 484, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (30444, 484, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (30445, 484, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (30446, 484, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (30447, 484, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (30448, 484, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (30449, 484, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (30450, 484, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (30451, 484, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (30452, 484, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (30453, 484, 42, 1584);
INSERT INTO 'devicecapvalue' VALUES (30454, 484, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (30455, 484, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (30456, 484, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (30457, 484, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (30458, 484, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (30459, 484, 45, 1051);
INSERT INTO 'devicecapvalue' VALUES (30460, 484, 45, 67);
INSERT INTO 'devicecapvalue' VALUES (30461, 484, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (30462, 484, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (30463, 484, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (30464, 484, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (30465, 484, 88, 1534);
INSERT INTO 'capvalue' VALUES (1972, 'HSDPA');
INSERT INTO 'devicecapvalue' VALUES (30466, 484, 88, 1972);
INSERT INTO 'devicecapvalue' VALUES (30467, 484, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (30468, 484, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (30469, 484, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (30470, 484, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (30471, 484, 103, 1604);
INSERT INTO 'devicecapvalue' VALUES (30472, 484, 104, 944);
INSERT INTO 'capvalue' VALUES (1973, 'file:///c:/private/102033e6/midlets/[1013d162]/scratch/');
INSERT INTO 'devicecapvalue' VALUES (30473, 484, 105, 1973);
INSERT INTO 'devicecapvalue' VALUES (30474, 484, 106, 1607);
INSERT INTO 'devicecapvalue' VALUES (30475, 484, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (30476, 484, 108, 1609);
INSERT INTO 'devicecapvalue' VALUES (30477, 484, 109, 1928);
INSERT INTO 'devicecapvalue' VALUES (30478, 484, 114, 1911);
INSERT INTO 'devicecapvalue' VALUES (30479, 484, 114, 1611);
INSERT INTO 'devicecapvalue' VALUES (30480, 484, 114, 1612);
INSERT INTO 'devicecapvalue' VALUES (30481, 484, 114, 1613);
INSERT INTO 'devicecapvalue' VALUES (30482, 484, 114, 1614);
INSERT INTO 'devicecapvalue' VALUES (30483, 484, 114, 1615);
INSERT INTO 'devicecapvalue' VALUES (30484, 484, 114, 1616);
INSERT INTO 'devicecapvalue' VALUES (30485, 484, 114, 1617);
INSERT INTO 'devicecapvalue' VALUES (30486, 484, 114, 1618);
INSERT INTO 'devicecapvalue' VALUES (30487, 484, 114, 1619);
INSERT INTO 'devicecapvalue' VALUES (30488, 484, 114, 1620);
INSERT INTO 'devicecapvalue' VALUES (30489, 484, 114, 1621);
INSERT INTO 'devicecapvalue' VALUES (30490, 484, 114, 1622);
INSERT INTO 'devicecapvalue' VALUES (30491, 484, 114, 1623);
INSERT INTO 'devicecapvalue' VALUES (30492, 484, 114, 1624);
INSERT INTO 'devicecapvalue' VALUES (30493, 484, 114, 1625);
INSERT INTO 'devicecapvalue' VALUES (30494, 484, 114, 1626);
INSERT INTO 'devicecapvalue' VALUES (30495, 484, 114, 1627);
INSERT INTO 'devicecapvalue' VALUES (30496, 484, 114, 1628);
INSERT INTO 'devicecapvalue' VALUES (30497, 484, 114, 1629);
INSERT INTO 'devicecapvalue' VALUES (30498, 484, 114, 1630);
INSERT INTO 'devicecapvalue' VALUES (30499, 484, 114, 1631);
INSERT INTO 'devicecapvalue' VALUES (30500, 484, 114, 1632);
INSERT INTO 'devicecapvalue' VALUES (30501, 484, 114, 1633);
INSERT INTO 'devicecapvalue' VALUES (30502, 484, 114, 1634);
INSERT INTO 'devicecapvalue' VALUES (30503, 484, 114, 1635);
INSERT INTO 'devicecapvalue' VALUES (30504, 484, 114, 1636);
INSERT INTO 'devicecapvalue' VALUES (30505, 484, 114, 1637);
INSERT INTO 'devicecapvalue' VALUES (30506, 484, 114, 1638);
INSERT INTO 'devicecapvalue' VALUES (30507, 484, 114, 1639);
INSERT INTO 'devicecapvalue' VALUES (30508, 484, 114, 1640);
INSERT INTO 'devicecapvalue' VALUES (30509, 484, 114, 1641);
INSERT INTO 'devicecapvalue' VALUES (30510, 484, 114, 1642);
INSERT INTO 'devicecapvalue' VALUES (30511, 484, 114, 1643);
INSERT INTO 'devicecapvalue' VALUES (30512, 484, 114, 1644);
INSERT INTO 'devicecapvalue' VALUES (30513, 484, 114, 1645);
INSERT INTO 'devicecapvalue' VALUES (30514, 484, 114, 1646);
INSERT INTO 'devicecapvalue' VALUES (30515, 484, 114, 1647);
INSERT INTO 'devicecapvalue' VALUES (30516, 484, 114, 1648);
INSERT INTO 'devicecapvalue' VALUES (30517, 484, 114, 1649);
INSERT INTO 'devicecapvalue' VALUES (30518, 484, 114, 1650);
INSERT INTO 'devicecapvalue' VALUES (30519, 484, 114, 1651);
INSERT INTO 'devicecapvalue' VALUES (30520, 484, 114, 1652);
INSERT INTO 'devicecapvalue' VALUES (30521, 484, 114, 1653);
INSERT INTO 'devicecapvalue' VALUES (30522, 484, 114, 1654);
INSERT INTO 'devicecapvalue' VALUES (30523, 484, 114, 1655);
INSERT INTO 'devicecapvalue' VALUES (30524, 484, 114, 1656);
INSERT INTO 'devicecapvalue' VALUES (30525, 484, 114, 1657);
INSERT INTO 'devicecapvalue' VALUES (30526, 484, 114, 1658);
INSERT INTO 'devicecapvalue' VALUES (30527, 484, 114, 1659);
INSERT INTO 'devicecapvalue' VALUES (30528, 484, 114, 1660);
INSERT INTO 'devicecapvalue' VALUES (30529, 484, 114, 1661);
INSERT INTO 'devicecapvalue' VALUES (30530, 484, 114, 1662);
INSERT INTO 'devicecapvalue' VALUES (30531, 484, 114, 1663);
INSERT INTO 'devicecapvalue' VALUES (30532, 484, 114, 1664);
INSERT INTO 'devicecapvalue' VALUES (30533, 484, 114, 1665);
INSERT INTO 'devicecapvalue' VALUES (30534, 484, 114, 1666);
INSERT INTO 'devicecapvalue' VALUES (30535, 484, 114, 1667);
INSERT INTO 'devicecapvalue' VALUES (30536, 484, 114, 1668);
INSERT INTO 'devicecapvalue' VALUES (30537, 484, 114, 1669);
INSERT INTO 'devicecapvalue' VALUES (30538, 484, 114, 1670);
INSERT INTO 'devicecapvalue' VALUES (30539, 484, 114, 1672);
INSERT INTO 'devicecapvalue' VALUES (30540, 484, 114, 1673);
INSERT INTO 'devicecapvalue' VALUES (30541, 484, 114, 1674);
INSERT INTO 'devicecapvalue' VALUES (30542, 484, 114, 1260);
INSERT INTO 'devicecapvalue' VALUES (30543, 484, 114, 1471);
INSERT INTO 'devicecapvalue' VALUES (30544, 484, 114, 1912);
INSERT INTO 'devicecapvalue' VALUES (30545, 484, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (30546, 484, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (30547, 484, 204, 1677);
INSERT INTO 'devicecapvalue' VALUES (30548, 484, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (30549, 484, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (30550, 484, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (30551, 484, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (30552, 484, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (30553, 484, 67, 45);
INSERT INTO 'capvalue' VALUES (1974, 'NokiaN82/10.0.046');
INSERT INTO 'devicecapvalue' VALUES (30554, 484, 68, 1974);
INSERT INTO 'devicecapvalue' VALUES (30555, 484, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (30556, 484, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (30557, 484, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (30558, 484, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (30559, 484, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (30560, 484, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (30561, 484, 137, 1396);
INSERT INTO 'devicecapvalue' VALUES (30562, 484, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (30563, 484, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (30564, 484, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (30565, 484, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (30566, 484, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (30567, 484, 137, 96);
INSERT INTO 'devicecapvalue' VALUES (30568, 484, 47, 56);
INSERT INTO 'devicecapvalue' VALUES (30569, 484, 47, 868);
INSERT INTO 'devicecapvalue' VALUES (30570, 484, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (30571, 484, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (30572, 484, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (30573, 484, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (30574, 484, 47, 1684);
INSERT INTO 'devicecapvalue' VALUES (30575, 484, 47, 986);
INSERT INTO 'devicecapvalue' VALUES (30576, 484, 47, 988);
INSERT INTO 'devicecapvalue' VALUES (30577, 484, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (30578, 484, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (30579, 484, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (30580, 484, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (30581, 484, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (30582, 484, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (30583, 484, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (30584, 484, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (30585, 484, 156, 1025);
INSERT INTO 'devicecapvalue' VALUES (30586, 484, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (30587, 484, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (30588, 484, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (30589, 484, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (30590, 484, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (30591, 484, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (30592, 484, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (30593, 484, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (30594, 484, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (30595, 484, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (30596, 484, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (30597, 484, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (30598, 484, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (30599, 484, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (30600, 484, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (30601, 484, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (30602, 484, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (30603, 484, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (30604, 484, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (30605, 484, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (30606, 484, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (30607, 484, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (30608, 484, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (30609, 484, 51, 1160);
INSERT INTO 'capvalue' VALUES (1975, '104857600');
INSERT INTO 'devicecapvalue' VALUES (30610, 484, 52, 1975);
INSERT INTO 'devicecapvalue' VALUES (30611, 484, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (30612, 484, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (30613, 484, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (30614, 484, 157, 1968);
INSERT INTO 'devicecapvalue' VALUES (30615, 484, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (30616, 484, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (30617, 484, 157, 1117);
INSERT INTO 'devicecapvalue' VALUES (30618, 484, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (30619, 484, 157, 1504);
INSERT INTO 'capvalue' VALUES (1976, 'Mozilla/5.0(SymbianOS/9.2; U; Series60/3.1 NokiaN82/10.0.035; Profile/MIDP-2.0 Configuration/CLDC-1.1;) AppleWebKit/413(KHTML');
INSERT INTO 'devicecapvalue' VALUES (30620, 484, 53, 1976);
INSERT INTO 'devicecapvalue' VALUES (30621, 484, 53, 1874);
INSERT INTO 'devicecapvalue' VALUES (30622, 485, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (30623, 485, 192, 15);
INSERT INTO 'devicecapvalue' VALUES (30624, 485, 7, 1878);
INSERT INTO 'devicecapvalue' VALUES (30625, 485, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (30626, 485, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (30627, 485, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (30628, 485, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (30629, 485, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (30630, 485, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (30631, 485, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (30632, 485, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (30633, 485, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (30634, 485, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (30635, 485, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (30636, 485, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (30637, 485, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (30638, 485, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (30639, 485, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (30640, 485, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (30641, 485, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (30642, 485, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (30643, 485, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (30644, 485, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (30645, 485, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (30646, 485, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (30647, 485, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (30648, 485, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (30649, 485, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (30650, 485, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (30651, 485, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (30652, 485, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (30653, 485, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (30654, 485, 20, 1244);
INSERT INTO 'devicecapvalue' VALUES (30655, 485, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (30656, 485, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (30657, 485, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (30658, 485, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (30659, 485, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (30660, 485, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (30661, 485, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (30662, 485, 57, 28);
INSERT INTO 'devicecapvalue' VALUES (30663, 485, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (30664, 485, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (30665, 485, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (30666, 485, 31, 41);
INSERT INTO 'capvalue' VALUES (1977, '=gsm');
INSERT INTO 'devicecapvalue' VALUES (30667, 485, 38, 1977);
INSERT INTO 'devicecapvalue' VALUES (30668, 485, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (30669, 485, 38, 1045);
INSERT INTO 'devicecapvalue' VALUES (30670, 485, 38, 616);
INSERT INTO 'devicecapvalue' VALUES (30671, 485, 38, 867);
INSERT INTO 'devicecapvalue' VALUES (30672, 485, 38, 1050);
INSERT INTO 'devicecapvalue' VALUES (30673, 485, 38, 1578);
INSERT INTO 'devicecapvalue' VALUES (30674, 485, 38, 51);
INSERT INTO 'devicecapvalue' VALUES (30675, 485, 38, 865);
INSERT INTO 'devicecapvalue' VALUES (30676, 485, 38, 1919);
INSERT INTO 'devicecapvalue' VALUES (30677, 485, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (30678, 485, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (30679, 485, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (30680, 485, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (30681, 485, 39, 1050);
INSERT INTO 'devicecapvalue' VALUES (30682, 485, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (30683, 485, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (30684, 485, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (30685, 485, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (30686, 485, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (30687, 485, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (30688, 485, 40, 125);
INSERT INTO 'devicecapvalue' VALUES (30689, 485, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (30690, 485, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (30691, 485, 40, 1580);
INSERT INTO 'devicecapvalue' VALUES (30692, 485, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (30693, 485, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (30694, 485, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (30695, 485, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (30696, 485, 41, 1275);
INSERT INTO 'devicecapvalue' VALUES (30697, 485, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (30698, 485, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (30699, 485, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (30700, 485, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (30701, 485, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (30702, 485, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (30703, 485, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (30704, 485, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (30705, 485, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (30706, 485, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (30707, 485, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (30708, 485, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (30709, 485, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (30710, 485, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (30711, 485, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (30712, 485, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (30713, 485, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (30714, 485, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (30715, 485, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (30716, 485, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (30717, 485, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (30718, 485, 41, 1583);
INSERT INTO 'devicecapvalue' VALUES (30719, 485, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (30720, 485, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (30721, 485, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (30722, 485, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (30723, 485, 41, 1584);
INSERT INTO 'devicecapvalue' VALUES (30724, 485, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (30725, 485, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (30726, 485, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (30727, 485, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (30728, 485, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (30729, 485, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (30730, 485, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (30731, 485, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (30732, 485, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (30733, 485, 42, 1275);
INSERT INTO 'devicecapvalue' VALUES (30734, 485, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (30735, 485, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (30736, 485, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (30737, 485, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (30738, 485, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (30739, 485, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (30740, 485, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (30741, 485, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (30742, 485, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (30743, 485, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (30744, 485, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (30745, 485, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (30746, 485, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (30747, 485, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (30748, 485, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (30749, 485, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (30750, 485, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (30751, 485, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (30752, 485, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (30753, 485, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (30754, 485, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (30755, 485, 42, 1583);
INSERT INTO 'devicecapvalue' VALUES (30756, 485, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (30757, 485, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (30758, 485, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (30759, 485, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (30760, 485, 42, 1584);
INSERT INTO 'devicecapvalue' VALUES (30761, 485, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (30762, 485, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (30763, 485, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (30764, 485, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (30765, 485, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (30766, 485, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (30767, 485, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (30768, 485, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (30769, 485, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (30770, 485, 45, 1585);
INSERT INTO 'devicecapvalue' VALUES (30771, 485, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (30772, 485, 58, 42);
INSERT INTO 'devicecapvalue' VALUES (30773, 485, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (30774, 485, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (30775, 485, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (30776, 485, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (30777, 485, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (30778, 485, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (30779, 485, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (30780, 485, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (30781, 485, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (30782, 485, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (30783, 485, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (30784, 485, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (30785, 485, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (30786, 485, 46, 1586);
INSERT INTO 'devicecapvalue' VALUES (30787, 485, 46, 1587);
INSERT INTO 'devicecapvalue' VALUES (30788, 485, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (30789, 485, 46, 1588);
INSERT INTO 'devicecapvalue' VALUES (30790, 485, 46, 1589);
INSERT INTO 'devicecapvalue' VALUES (30791, 485, 46, 1590);
INSERT INTO 'devicecapvalue' VALUES (30792, 485, 46, 1591);
INSERT INTO 'devicecapvalue' VALUES (30793, 485, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (30794, 485, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (30795, 485, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (30796, 485, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (30797, 485, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (30798, 485, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (30799, 485, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (30800, 485, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (30801, 485, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (30802, 485, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (30803, 485, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (30804, 485, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (30805, 485, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (30806, 485, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (30807, 485, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (30808, 485, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (30809, 485, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (30810, 485, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (30811, 485, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (30812, 485, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (30813, 485, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (30814, 485, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (30815, 485, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (30816, 485, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (30817, 485, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (30818, 485, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (30819, 485, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (30820, 485, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (30821, 485, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (30822, 485, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (30823, 485, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (30824, 485, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (30825, 485, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (30826, 485, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (30827, 485, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (30828, 485, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (30829, 485, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (30830, 485, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (30831, 485, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (30832, 485, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (30833, 485, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (30834, 485, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (30835, 485, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (30836, 485, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (30837, 485, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (30838, 485, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (30839, 485, 115, 49);
INSERT INTO 'devicecapvalue' VALUES (30840, 485, 115, 1045);
INSERT INTO 'devicecapvalue' VALUES (30841, 485, 115, 616);
INSERT INTO 'devicecapvalue' VALUES (30842, 485, 115, 867);
INSERT INTO 'devicecapvalue' VALUES (30843, 485, 115, 1050);
INSERT INTO 'devicecapvalue' VALUES (30844, 485, 115, 1578);
INSERT INTO 'devicecapvalue' VALUES (30845, 485, 115, 51);
INSERT INTO 'devicecapvalue' VALUES (30846, 485, 115, 1004);
INSERT INTO 'devicecapvalue' VALUES (30847, 485, 115, 865);
INSERT INTO 'devicecapvalue' VALUES (30848, 485, 115, 1919);
INSERT INTO 'devicecapvalue' VALUES (30849, 485, 197, 1594);
INSERT INTO 'devicecapvalue' VALUES (30850, 485, 141, 238);
INSERT INTO 'devicecapvalue' VALUES (30851, 485, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (30852, 485, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (30853, 485, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (30854, 485, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (30855, 485, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (30856, 485, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (30857, 485, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (30858, 485, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (30859, 485, 125, 1595);
INSERT INTO 'devicecapvalue' VALUES (30860, 485, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (30861, 485, 198, 1939);
INSERT INTO 'capvalue' VALUES (1978, '425');
INSERT INTO 'devicecapvalue' VALUES (30862, 485, 199, 1978);
INSERT INTO 'devicecapvalue' VALUES (30863, 485, 183, 1922);
INSERT INTO 'capvalue' VALUES (1979, '355708023557902');
INSERT INTO 'devicecapvalue' VALUES (30864, 485, 200, 1979);
INSERT INTO 'devicecapvalue' VALUES (30865, 485, 201, 1599);
INSERT INTO 'capvalue' VALUES (1980, '01 (IL ORANGE)');
INSERT INTO 'devicecapvalue' VALUES (30866, 485, 202, 1980);
INSERT INTO 'capvalue' VALUES (1981, '6 (95 dBm)');
INSERT INTO 'devicecapvalue' VALUES (30867, 485, 203, 1981);
INSERT INTO 'devicecapvalue' VALUES (30868, 485, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (30869, 485, 185, 1602);
INSERT INTO 'devicecapvalue' VALUES (30870, 485, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (30871, 485, 101, 1469);
INSERT INTO 'capvalue' VALUES (1982, '????? ??????');
INSERT INTO 'devicecapvalue' VALUES (30872, 485, 102, 1982);
INSERT INTO 'devicecapvalue' VALUES (30873, 485, 103, 1604);
INSERT INTO 'capvalue' VALUES (1983, '??????');
INSERT INTO 'devicecapvalue' VALUES (30874, 485, 104, 1983);
INSERT INTO 'capvalue' VALUES (1984, 'file:///c:/private/102033e6/midlets/[1017f370]/scratch/');
INSERT INTO 'devicecapvalue' VALUES (30875, 485, 105, 1984);
INSERT INTO 'devicecapvalue' VALUES (30876, 485, 106, 1607);
INSERT INTO 'devicecapvalue' VALUES (30877, 485, 107, 1983);
INSERT INTO 'devicecapvalue' VALUES (30878, 485, 108, 1609);
INSERT INTO 'capvalue' VALUES (1985, '?????? ??????');
INSERT INTO 'devicecapvalue' VALUES (30879, 485, 109, 1985);
INSERT INTO 'devicecapvalue' VALUES (30880, 485, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (30881, 485, 114, 1611);
INSERT INTO 'devicecapvalue' VALUES (30882, 485, 114, 1612);
INSERT INTO 'devicecapvalue' VALUES (30883, 485, 114, 1613);
INSERT INTO 'devicecapvalue' VALUES (30884, 485, 114, 1614);
INSERT INTO 'devicecapvalue' VALUES (30885, 485, 114, 1615);
INSERT INTO 'devicecapvalue' VALUES (30886, 485, 114, 1616);
INSERT INTO 'devicecapvalue' VALUES (30887, 485, 114, 1617);
INSERT INTO 'devicecapvalue' VALUES (30888, 485, 114, 1618);
INSERT INTO 'devicecapvalue' VALUES (30889, 485, 114, 1619);
INSERT INTO 'devicecapvalue' VALUES (30890, 485, 114, 1620);
INSERT INTO 'devicecapvalue' VALUES (30891, 485, 114, 1621);
INSERT INTO 'devicecapvalue' VALUES (30892, 485, 114, 1622);
INSERT INTO 'devicecapvalue' VALUES (30893, 485, 114, 1623);
INSERT INTO 'devicecapvalue' VALUES (30894, 485, 114, 1624);
INSERT INTO 'devicecapvalue' VALUES (30895, 485, 114, 1625);
INSERT INTO 'devicecapvalue' VALUES (30896, 485, 114, 1626);
INSERT INTO 'devicecapvalue' VALUES (30897, 485, 114, 1627);
INSERT INTO 'devicecapvalue' VALUES (30898, 485, 114, 1628);
INSERT INTO 'devicecapvalue' VALUES (30899, 485, 114, 1629);
INSERT INTO 'devicecapvalue' VALUES (30900, 485, 114, 1630);
INSERT INTO 'devicecapvalue' VALUES (30901, 485, 114, 1631);
INSERT INTO 'devicecapvalue' VALUES (30902, 485, 114, 1632);
INSERT INTO 'devicecapvalue' VALUES (30903, 485, 114, 1633);
INSERT INTO 'devicecapvalue' VALUES (30904, 485, 114, 1634);
INSERT INTO 'devicecapvalue' VALUES (30905, 485, 114, 1635);
INSERT INTO 'devicecapvalue' VALUES (30906, 485, 114, 1636);
INSERT INTO 'devicecapvalue' VALUES (30907, 485, 114, 1637);
INSERT INTO 'devicecapvalue' VALUES (30908, 485, 114, 1638);
INSERT INTO 'devicecapvalue' VALUES (30909, 485, 114, 1639);
INSERT INTO 'devicecapvalue' VALUES (30910, 485, 114, 1640);
INSERT INTO 'devicecapvalue' VALUES (30911, 485, 114, 1641);
INSERT INTO 'devicecapvalue' VALUES (30912, 485, 114, 1642);
INSERT INTO 'devicecapvalue' VALUES (30913, 485, 114, 1643);
INSERT INTO 'devicecapvalue' VALUES (30914, 485, 114, 1644);
INSERT INTO 'devicecapvalue' VALUES (30915, 485, 114, 1645);
INSERT INTO 'devicecapvalue' VALUES (30916, 485, 114, 1646);
INSERT INTO 'devicecapvalue' VALUES (30917, 485, 114, 1647);
INSERT INTO 'devicecapvalue' VALUES (30918, 485, 114, 1648);
INSERT INTO 'devicecapvalue' VALUES (30919, 485, 114, 1649);
INSERT INTO 'devicecapvalue' VALUES (30920, 485, 114, 1650);
INSERT INTO 'devicecapvalue' VALUES (30921, 485, 114, 1651);
INSERT INTO 'devicecapvalue' VALUES (30922, 485, 114, 1652);
INSERT INTO 'devicecapvalue' VALUES (30923, 485, 114, 1653);
INSERT INTO 'devicecapvalue' VALUES (30924, 485, 114, 1654);
INSERT INTO 'devicecapvalue' VALUES (30925, 485, 114, 1655);
INSERT INTO 'devicecapvalue' VALUES (30926, 485, 114, 1656);
INSERT INTO 'devicecapvalue' VALUES (30927, 485, 114, 1657);
INSERT INTO 'devicecapvalue' VALUES (30928, 485, 114, 1658);
INSERT INTO 'devicecapvalue' VALUES (30929, 485, 114, 1659);
INSERT INTO 'devicecapvalue' VALUES (30930, 485, 114, 1660);
INSERT INTO 'devicecapvalue' VALUES (30931, 485, 114, 1661);
INSERT INTO 'devicecapvalue' VALUES (30932, 485, 114, 1662);
INSERT INTO 'devicecapvalue' VALUES (30933, 485, 114, 1663);
INSERT INTO 'devicecapvalue' VALUES (30934, 485, 114, 1664);
INSERT INTO 'devicecapvalue' VALUES (30935, 485, 114, 1665);
INSERT INTO 'devicecapvalue' VALUES (30936, 485, 114, 1666);
INSERT INTO 'devicecapvalue' VALUES (30937, 485, 114, 1667);
INSERT INTO 'devicecapvalue' VALUES (30938, 485, 114, 1668);
INSERT INTO 'devicecapvalue' VALUES (30939, 485, 114, 1669);
INSERT INTO 'devicecapvalue' VALUES (30940, 485, 114, 1670);
INSERT INTO 'devicecapvalue' VALUES (30941, 485, 114, 1671);
INSERT INTO 'devicecapvalue' VALUES (30942, 485, 114, 1672);
INSERT INTO 'devicecapvalue' VALUES (30943, 485, 114, 1673);
INSERT INTO 'devicecapvalue' VALUES (30944, 485, 114, 1674);
INSERT INTO 'devicecapvalue' VALUES (30945, 485, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (30946, 485, 114, 1675);
INSERT INTO 'devicecapvalue' VALUES (30947, 485, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (30948, 485, 114, 1676);
INSERT INTO 'devicecapvalue' VALUES (30949, 485, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (30950, 485, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (30951, 485, 204, 1677);
INSERT INTO 'devicecapvalue' VALUES (30952, 485, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (30953, 485, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (30954, 485, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (30955, 485, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (30956, 485, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (30957, 485, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (30958, 485, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (30959, 485, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (30960, 485, 131, 922);
INSERT INTO 'devicecapvalue' VALUES (30961, 485, 67, 45);
INSERT INTO 'capvalue' VALUES (1986, 'NokiaN85-1/.047/sw_platform=S60;sw_platform_version=3.2;java_build_version=74701');
INSERT INTO 'devicecapvalue' VALUES (30962, 485, 68, 1986);
INSERT INTO 'devicecapvalue' VALUES (30963, 485, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (30964, 485, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (30965, 485, 205, 45);
INSERT INTO 'devicecapvalue' VALUES (30966, 485, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (30967, 485, 132, 1577);
INSERT INTO 'devicecapvalue' VALUES (30968, 485, 133, 1585);
INSERT INTO 'devicecapvalue' VALUES (30969, 485, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (30970, 485, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (30971, 485, 149, 1680);
INSERT INTO 'devicecapvalue' VALUES (30972, 485, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (30973, 485, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (30974, 485, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (30975, 485, 136, 1585);
INSERT INTO 'devicecapvalue' VALUES (30976, 485, 137, 1396);
INSERT INTO 'devicecapvalue' VALUES (30977, 485, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (30978, 485, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (30979, 485, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (30980, 485, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (30981, 485, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (30982, 485, 137, 96);
INSERT INTO 'capvalue' VALUES (1987, 'http://192.168.220.15/servlets/mms');
INSERT INTO 'devicecapvalue' VALUES (30983, 485, 138, 1987);
INSERT INTO 'capvalue' VALUES (1988, '+97254120032');
INSERT INTO 'devicecapvalue' VALUES (30984, 485, 72, 1988);
INSERT INTO 'devicecapvalue' VALUES (30985, 485, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (30986, 485, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (30987, 485, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (30988, 485, 47, 56);
INSERT INTO 'devicecapvalue' VALUES (30989, 485, 47, 868);
INSERT INTO 'devicecapvalue' VALUES (30990, 485, 47, 1275);
INSERT INTO 'devicecapvalue' VALUES (30991, 485, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (30992, 485, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (30993, 485, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (30994, 485, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (30995, 485, 47, 1684);
INSERT INTO 'devicecapvalue' VALUES (30996, 485, 47, 986);
INSERT INTO 'devicecapvalue' VALUES (30997, 485, 47, 988);
INSERT INTO 'devicecapvalue' VALUES (30998, 485, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (30999, 485, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (31000, 485, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (31001, 485, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (31002, 485, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (31003, 485, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (31004, 485, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (31005, 485, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (31006, 485, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (31007, 485, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (31008, 485, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (31009, 485, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (31010, 485, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (31011, 485, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (31012, 485, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (31013, 485, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (31014, 485, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (31015, 485, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (31016, 485, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (31017, 485, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (31018, 485, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (31019, 485, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (31020, 485, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (31021, 485, 48, 824);
INSERT INTO 'devicecapvalue' VALUES (31022, 485, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (31023, 485, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (31024, 485, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (31025, 485, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (31026, 485, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (31027, 485, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (31028, 485, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (31029, 485, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (31030, 485, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (31031, 485, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (31032, 485, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (31033, 485, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (31034, 485, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (31035, 485, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (31036, 485, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (31037, 485, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (31038, 485, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (31039, 485, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (31040, 485, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (31041, 485, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (31042, 485, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (31043, 485, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (31044, 485, 48, 1685);
INSERT INTO 'devicecapvalue' VALUES (31045, 485, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (31046, 485, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (31047, 485, 48, 1686);
INSERT INTO 'devicecapvalue' VALUES (31048, 485, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (31049, 485, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (31050, 485, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (31051, 485, 48, 830);
INSERT INTO 'capvalue' VALUES (1989, '344320');
INSERT INTO 'devicecapvalue' VALUES (31052, 485, 49, 1989);
INSERT INTO 'devicecapvalue' VALUES (31053, 485, 53, 1263);
INSERT INTO 'capvalue' VALUES (1990, 'like Gecko) Chrome/1.0.154.48 Safari/525.19');
INSERT INTO 'devicecapvalue' VALUES (31054, 485, 53, 1990);
INSERT INTO 'devicecapvalue' VALUES (31055, 486, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (31056, 486, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (31057, 486, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (31058, 487, 158, 1951);
INSERT INTO 'devicecapvalue' VALUES (31059, 487, 1, 106);
INSERT INTO 'capvalue' VALUES (1991, 'sizeChangedReportsWrongHeight');
INSERT INTO 'devicecapvalue' VALUES (31060, 487, 74, 1991);
INSERT INTO 'devicecapvalue' VALUES (31061, 487, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (31062, 487, 162, 603);
INSERT INTO 'devicecapvalue' VALUES (31063, 487, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (31064, 487, 187, 1);
INSERT INTO 'devicecapvalue' VALUES (31065, 487, 167, 1330);
INSERT INTO 'devicecapvalue' VALUES (31066, 487, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (31067, 487, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (31068, 487, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (31069, 487, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (31070, 487, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (31071, 487, 13, 1885);
INSERT INTO 'devicecapvalue' VALUES (31072, 487, 76, 593);
INSERT INTO 'capvalue' VALUES (1992, '76');
INSERT INTO 'devicecapvalue' VALUES (31073, 487, 77, 1992);
INSERT INTO 'devicecapvalue' VALUES (31074, 487, 78, 1992);
INSERT INTO 'devicecapvalue' VALUES (31075, 487, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (31076, 487, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (31077, 487, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (31078, 487, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (31079, 487, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (31080, 487, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (31081, 487, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (31082, 487, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (31083, 487, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (31084, 487, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (31085, 487, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (31086, 487, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (31087, 487, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (31088, 487, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (31089, 487, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (31090, 487, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (31091, 487, 3, 1952);
INSERT INTO 'devicecapvalue' VALUES (31092, 487, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (31093, 487, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (31094, 487, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (31095, 487, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (31096, 487, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (31097, 487, 4, 671);
INSERT INTO 'devicecapvalue' VALUES (31098, 487, 5, 672);
INSERT INTO 'devicecapvalue' VALUES (31099, 487, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (31100, 487, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (31101, 487, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (31102, 487, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (31103, 487, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (31104, 487, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (31105, 487, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (31106, 487, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (31107, 487, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (31108, 487, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (31109, 487, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (31110, 487, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (31111, 487, 52, 1511);
INSERT INTO 'devicecapvalue' VALUES (31112, 487, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (31113, 487, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (31114, 487, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (31115, 487, 157, 1504);
INSERT INTO 'capvalue' VALUES (1993, 'NokiaN90-1');
INSERT INTO 'devicecapvalue' VALUES (31116, 487, 53, 1993);
INSERT INTO 'devicecapvalue' VALUES (31117, 488, 158, 1960);
INSERT INTO 'devicecapvalue' VALUES (31118, 488, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (31119, 488, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (31120, 488, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (31121, 488, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (31122, 488, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (31123, 488, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (31124, 488, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (31125, 488, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (31126, 488, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (31127, 488, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (31128, 488, 13, 1950);
INSERT INTO 'devicecapvalue' VALUES (31129, 488, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (31130, 488, 77, 842);
INSERT INTO 'devicecapvalue' VALUES (31131, 488, 78, 842);
INSERT INTO 'devicecapvalue' VALUES (31132, 488, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (31133, 488, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (31134, 488, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (31135, 488, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (31136, 488, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (31137, 488, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (31138, 488, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (31139, 488, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (31140, 488, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (31141, 488, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (31142, 488, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (31143, 488, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (31144, 488, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (31145, 488, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (31146, 488, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (31147, 488, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (31148, 488, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (31149, 488, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (31150, 488, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (31151, 488, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (31152, 488, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (31153, 488, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (31154, 488, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (31155, 488, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (31156, 488, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (31157, 488, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (31158, 488, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (31159, 488, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (31160, 488, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (31161, 488, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (31162, 488, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (31163, 488, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (31164, 488, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (31165, 488, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (31166, 488, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (31167, 488, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (31168, 488, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (31169, 488, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (31170, 488, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (31171, 488, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (31172, 488, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (31173, 488, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (31174, 488, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (31175, 488, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (31176, 488, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (31177, 488, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (31178, 488, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (31179, 488, 51, 1041);
INSERT INTO 'capvalue' VALUES (1994, 'xfm');
INSERT INTO 'devicecapvalue' VALUES (31180, 488, 51, 1994);
INSERT INTO 'devicecapvalue' VALUES (31181, 488, 52, 1970);
INSERT INTO 'devicecapvalue' VALUES (31182, 488, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (31183, 488, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (31184, 488, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (31185, 488, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (31186, 488, 157, 1504);
INSERT INTO 'capvalue' VALUES (1995, 'NokiaN91-1/3.0 (1.10.030) SymbianOS/9.1 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (31187, 488, 53, 1995);
INSERT INTO 'devicecapvalue' VALUES (31188, 489, 158, 1960);
INSERT INTO 'devicecapvalue' VALUES (31189, 489, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (31190, 489, 160, 1510);
INSERT INTO 'devicecapvalue' VALUES (31191, 489, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (31192, 489, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (31193, 489, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (31194, 489, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (31195, 489, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (31196, 489, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (31197, 489, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (31198, 489, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (31199, 489, 13, 1950);
INSERT INTO 'devicecapvalue' VALUES (31200, 489, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (31201, 489, 77, 842);
INSERT INTO 'devicecapvalue' VALUES (31202, 489, 78, 842);
INSERT INTO 'devicecapvalue' VALUES (31203, 489, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (31204, 489, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (31205, 489, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (31206, 489, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (31207, 489, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (31208, 489, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (31209, 489, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (31210, 489, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (31211, 489, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (31212, 489, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (31213, 489, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (31214, 489, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (31215, 489, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (31216, 489, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (31217, 489, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (31218, 489, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (31219, 489, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (31220, 489, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (31221, 489, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (31222, 489, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (31223, 489, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (31224, 489, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (31225, 489, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (31226, 489, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (31227, 489, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (31228, 489, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (31229, 489, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (31230, 489, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (31231, 489, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (31232, 489, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (31233, 489, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (31234, 489, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (31235, 489, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (31236, 489, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (31237, 489, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (31238, 489, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (31239, 489, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (31240, 489, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (31241, 489, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (31242, 489, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (31243, 489, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (31244, 489, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (31245, 489, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (31246, 489, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (31247, 489, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (31248, 489, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (31249, 489, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (31250, 489, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (31251, 489, 51, 1994);
INSERT INTO 'devicecapvalue' VALUES (31252, 489, 52, 1970);
INSERT INTO 'devicecapvalue' VALUES (31253, 489, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (31254, 489, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (31255, 489, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (31256, 489, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (31257, 489, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (31258, 489, 53, 1995);
INSERT INTO 'devicecapvalue' VALUES (31259, 490, 158, 1954);
INSERT INTO 'devicecapvalue' VALUES (31260, 490, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (31261, 490, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (31262, 490, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (31263, 490, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (31264, 490, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (31265, 490, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (31266, 490, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (31267, 490, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (31268, 490, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (31269, 490, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (31270, 490, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (31271, 490, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (31272, 490, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (31273, 490, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (31274, 490, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (31275, 490, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (31276, 490, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (31277, 490, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (31278, 490, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (31279, 490, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (31280, 490, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (31281, 490, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (31282, 490, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (31283, 490, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (31284, 490, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (31285, 490, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (31286, 490, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (31287, 490, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (31288, 490, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (31289, 490, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (31290, 490, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (31291, 490, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (31292, 490, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (31293, 490, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (31294, 490, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (31295, 490, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (31296, 490, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (31297, 490, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (31298, 490, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (31299, 490, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (31300, 490, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (31301, 490, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (31302, 490, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (31303, 490, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (31304, 490, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (31305, 490, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (31306, 490, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (31307, 490, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (31308, 490, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (31309, 490, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (31310, 490, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (31311, 490, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (31312, 490, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (31313, 490, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (31314, 490, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (31315, 490, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (31316, 490, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (31317, 490, 157, 1504);
INSERT INTO 'capvalue' VALUES (1996, 'NokiaN92-1/2.0 (2.0637.0.0.3) S60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (31318, 490, 53, 1996);
INSERT INTO 'devicecapvalue' VALUES (31319, 491, 158, 1956);
INSERT INTO 'devicecapvalue' VALUES (31320, 491, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (31321, 491, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (31322, 491, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (31323, 491, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (31324, 491, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (31325, 491, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (31326, 491, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (31327, 491, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (31328, 491, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (31329, 491, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (31330, 491, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (31331, 491, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (31332, 491, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (31333, 491, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (31334, 491, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (31335, 491, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (31336, 491, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (31337, 491, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (31338, 491, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (31339, 491, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (31340, 491, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (31341, 491, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (31342, 491, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (31343, 491, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (31344, 491, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (31345, 491, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (31346, 491, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (31347, 491, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (31348, 491, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (31349, 491, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (31350, 491, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (31351, 491, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (31352, 491, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (31353, 491, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (31354, 491, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (31355, 491, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (31356, 491, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (31357, 491, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (31358, 491, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (31359, 491, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (31360, 491, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (31361, 491, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (31362, 491, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (31363, 491, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (31364, 491, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (31365, 491, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (31366, 491, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (31367, 491, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (31368, 491, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (31369, 491, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (31370, 491, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (31371, 491, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (31372, 491, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (31373, 491, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (31374, 491, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (31375, 491, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (31376, 491, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (31377, 491, 52, 1086);
INSERT INTO 'devicecapvalue' VALUES (31378, 491, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (31379, 491, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (31380, 491, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (31381, 491, 157, 1504);
INSERT INTO 'capvalue' VALUES (1997, 'NokiaN93-1/10.0.025 SymbianOS/9.1 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (31382, 491, 53, 1997);
INSERT INTO 'devicecapvalue' VALUES (31383, 492, 158, 1725);
INSERT INTO 'devicecapvalue' VALUES (31384, 492, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (31385, 492, 160, 1477);
INSERT INTO 'devicecapvalue' VALUES (31386, 492, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (31387, 492, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (31388, 492, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (31389, 492, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (31390, 492, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (31391, 492, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (31392, 492, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (31393, 492, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (31394, 492, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (31395, 492, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (31396, 492, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (31397, 492, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (31398, 492, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (31399, 492, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (31400, 492, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (31401, 492, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (31402, 492, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (31403, 492, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (31404, 492, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (31405, 492, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (31406, 492, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (31407, 492, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (31408, 492, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (31409, 492, 3, 1551);
INSERT INTO 'devicecapvalue' VALUES (31410, 492, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (31411, 492, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (31412, 492, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (31413, 492, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (31414, 492, 156, 1464);
INSERT INTO 'devicecapvalue' VALUES (31415, 492, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (31416, 492, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (31417, 492, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (31418, 492, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (31419, 492, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (31420, 492, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (31421, 492, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (31422, 492, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (31423, 492, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (31424, 492, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (31425, 492, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (31426, 492, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (31427, 492, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (31428, 492, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (31429, 492, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (31430, 492, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (31431, 492, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (31432, 492, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (31433, 492, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (31434, 492, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (31435, 492, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (31436, 492, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (31437, 492, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (31438, 492, 52, 1086);
INSERT INTO 'devicecapvalue' VALUES (31439, 492, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (31440, 492, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (31441, 492, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (31442, 492, 157, 1504);
INSERT INTO 'capvalue' VALUES (1998, 'NokiaN93i-1/11.0.009 SymbianOS/9.1 Series60/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (31443, 492, 53, 1998);
INSERT INTO 'devicecapvalue' VALUES (31444, 493, 158, 1960);
INSERT INTO 'devicecapvalue' VALUES (31445, 493, 1, 649);
INSERT INTO 'cap' VALUES (227, 'build.Emulator.Skin', 1);
INSERT INTO 'capvalue' VALUES (1999, 'S60_3rd_FP2_SDK');
INSERT INTO 'devicecapvalue' VALUES (31446, 493, 227, 1999);
INSERT INTO 'capvalue' VALUES (2000, '2582x1944');
INSERT INTO 'devicecapvalue' VALUES (31447, 493, 160, 2000);
INSERT INTO 'devicecapvalue' VALUES (31448, 493, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (31449, 493, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (31450, 493, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (31451, 493, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (31452, 493, 9, 109);
INSERT INTO 'devicecapvalue' VALUES (31453, 493, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (31454, 493, 11, 109);
INSERT INTO 'devicecapvalue' VALUES (31455, 493, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (31456, 493, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (31457, 493, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (31458, 493, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (31459, 493, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (31460, 493, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (31461, 493, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (31462, 493, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (31463, 493, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (31464, 493, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (31465, 493, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (31466, 493, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (31467, 493, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (31468, 493, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (31469, 493, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (31470, 493, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (31471, 493, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (31472, 493, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (31473, 493, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (31474, 493, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (31475, 493, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (31476, 493, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (31477, 493, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (31478, 493, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (31479, 493, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (31480, 493, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (31481, 493, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (31482, 493, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (31483, 493, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (31484, 493, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (31485, 493, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (31486, 493, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (31487, 493, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (31488, 493, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (31489, 493, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (31490, 493, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (31491, 493, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (31492, 493, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (31493, 493, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (31494, 493, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (31495, 493, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (31496, 493, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (31497, 493, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (31498, 493, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (31499, 493, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (31500, 493, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (31501, 493, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (31502, 493, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (31503, 493, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (31504, 493, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (31505, 493, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (31506, 493, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (31507, 493, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (31508, 493, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (31509, 493, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (31510, 493, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (31511, 493, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (31512, 493, 51, 1041);
INSERT INTO 'capvalue' VALUES (2001, '167772160');
INSERT INTO 'devicecapvalue' VALUES (31513, 493, 52, 2001);
INSERT INTO 'devicecapvalue' VALUES (31514, 493, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (31515, 493, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (31516, 493, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (31517, 493, 157, 1504);
INSERT INTO 'capvalue' VALUES (2002, 'Mozilla/5.0 (SymbianOS/9.2; U; Series60/3.1 NokiaN95/20.0.015; Profile/MIDP-2.0 Configuration/CLDC-1.1 ) AppleWebKit/413 (KHTML');
INSERT INTO 'devicecapvalue' VALUES (31518, 493, 53, 2002);
INSERT INTO 'devicecapvalue' VALUES (31519, 493, 53, 1799);
INSERT INTO 'devicecapvalue' VALUES (31520, 494, 158, 1960);
INSERT INTO 'devicecapvalue' VALUES (31521, 494, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (31522, 494, 227, 1999);
INSERT INTO 'devicecapvalue' VALUES (31523, 494, 160, 2000);
INSERT INTO 'devicecapvalue' VALUES (31524, 494, 173, 1410);
INSERT INTO 'devicecapvalue' VALUES (31525, 494, 173, 1411);
INSERT INTO 'devicecapvalue' VALUES (31526, 494, 173, 1478);
INSERT INTO 'devicecapvalue' VALUES (31527, 494, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (31528, 494, 9, 109);
INSERT INTO 'devicecapvalue' VALUES (31529, 494, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (31530, 494, 11, 109);
INSERT INTO 'devicecapvalue' VALUES (31531, 494, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (31532, 494, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (31533, 494, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (31534, 494, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (31535, 494, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (31536, 494, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (31537, 494, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (31538, 494, 77, 638);
INSERT INTO 'devicecapvalue' VALUES (31539, 494, 78, 638);
INSERT INTO 'devicecapvalue' VALUES (31540, 494, 77, 33);
INSERT INTO 'devicecapvalue' VALUES (31541, 494, 78, 33);
INSERT INTO 'devicecapvalue' VALUES (31542, 494, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (31543, 494, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (31544, 494, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (31545, 494, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (31546, 494, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (31547, 494, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (31548, 494, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (31549, 494, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (31550, 494, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (31551, 494, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (31552, 494, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (31553, 494, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (31554, 494, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (31555, 494, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (31556, 494, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (31557, 494, 88, 1495);
INSERT INTO 'devicecapvalue' VALUES (31558, 494, 88, 1500);
INSERT INTO 'devicecapvalue' VALUES (31559, 494, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (31560, 494, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (31561, 494, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (31562, 494, 88, 1550);
INSERT INTO 'devicecapvalue' VALUES (31563, 494, 3, 1558);
INSERT INTO 'devicecapvalue' VALUES (31564, 494, 156, 1023);
INSERT INTO 'devicecapvalue' VALUES (31565, 494, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (31566, 494, 182, 1559);
INSERT INTO 'devicecapvalue' VALUES (31567, 494, 182, 1560);
INSERT INTO 'devicecapvalue' VALUES (31568, 494, 182, 1561);
INSERT INTO 'devicecapvalue' VALUES (31569, 494, 182, 1562);
INSERT INTO 'devicecapvalue' VALUES (31570, 494, 182, 1421);
INSERT INTO 'devicecapvalue' VALUES (31571, 494, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (31572, 494, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (31573, 494, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (31574, 494, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (31575, 494, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (31576, 494, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (31577, 494, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (31578, 494, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (31579, 494, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (31580, 494, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (31581, 494, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (31582, 494, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (31583, 494, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (31584, 494, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (31585, 494, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (31586, 494, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (31587, 494, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (31588, 494, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (31589, 494, 52, 1970);
INSERT INTO 'devicecapvalue' VALUES (31590, 494, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (31591, 494, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (31592, 494, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (31593, 494, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (31594, 494, 53, 2002);
INSERT INTO 'devicecapvalue' VALUES (31595, 494, 53, 1799);
INSERT INTO 'devicecapvalue' VALUES (31596, 495, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (31597, 495, 74, 1567);
INSERT INTO 'devicecapvalue' VALUES (31598, 495, 74, 1889);
INSERT INTO 'devicecapvalue' VALUES (31599, 495, 193, 1568);
INSERT INTO 'devicecapvalue' VALUES (31600, 495, 193, 1569);
INSERT INTO 'devicecapvalue' VALUES (31601, 495, 193, 1570);
INSERT INTO 'capvalue' VALUES (2003, '\devices\Nokia_N97_SDK_v1.0');
INSERT INTO 'devicecapvalue' VALUES (31602, 495, 227, 2003);
INSERT INTO 'capvalue' VALUES (2004, 'jtwi');
INSERT INTO 'devicecapvalue' VALUES (31603, 495, 194, 2004);
INSERT INTO 'devicecapvalue' VALUES (31604, 495, 79, 15);
INSERT INTO 'capvalue' VALUES (2005, '502x288');
INSERT INTO 'devicecapvalue' VALUES (31605, 495, 7, 2005);
INSERT INTO 'devicecapvalue' VALUES (31606, 495, 195, 1573);
INSERT INTO 'devicecapvalue' VALUES (31607, 495, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (31608, 495, 9, 604);
INSERT INTO 'devicecapvalue' VALUES (31609, 495, 10, 1575);
INSERT INTO 'devicecapvalue' VALUES (31610, 495, 11, 604);
INSERT INTO 'devicecapvalue' VALUES (31611, 495, 12, 649);
INSERT INTO 'capvalue' VALUES (2006, '580x360');
INSERT INTO 'devicecapvalue' VALUES (31612, 495, 13, 2006);
INSERT INTO 'cap' VALUES (228, 'haspointerevents', 1);
INSERT INTO 'devicecapvalue' VALUES (31613, 495, 228, 15);
INSERT INTO 'devicecapvalue' VALUES (31614, 495, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (31615, 495, 221, 16);
INSERT INTO 'devicecapvalue' VALUES (31616, 495, 221, 17);
INSERT INTO 'devicecapvalue' VALUES (31617, 495, 221, 18);
INSERT INTO 'devicecapvalue' VALUES (31618, 495, 221, 19);
INSERT INTO 'devicecapvalue' VALUES (31619, 495, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (31620, 495, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (31621, 495, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (31622, 495, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (31623, 495, 17, 1482);
INSERT INTO 'devicecapvalue' VALUES (31624, 495, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (31625, 495, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (31626, 495, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (31627, 495, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (31628, 495, 17, 24);
INSERT INTO 'capvalue' VALUES (2007, 'sensor');
INSERT INTO 'devicecapvalue' VALUES (31629, 495, 17, 2007);
INSERT INTO 'devicecapvalue' VALUES (31630, 495, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (31631, 495, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (31632, 495, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (31633, 495, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (31634, 495, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (31635, 495, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (31636, 495, 196, 745);
INSERT INTO 'devicecapvalue' VALUES (31637, 495, 178, 237);
INSERT INTO 'devicecapvalue' VALUES (31638, 495, 18, 625);
INSERT INTO 'devicecapvalue' VALUES (31639, 495, 19, 29);
INSERT INTO 'capvalue' VALUES (2008, '106');
INSERT INTO 'devicecapvalue' VALUES (31640, 495, 20, 2008);
INSERT INTO 'capvalue' VALUES (2009, '117');
INSERT INTO 'devicecapvalue' VALUES (31641, 495, 21, 2009);
INSERT INTO 'capvalue' VALUES (2010, '105');
INSERT INTO 'devicecapvalue' VALUES (31642, 495, 22, 2010);
INSERT INTO 'devicecapvalue' VALUES (31643, 495, 23, 609);
INSERT INTO 'devicecapvalue' VALUES (31644, 495, 24, 610);
INSERT INTO 'devicecapvalue' VALUES (31645, 495, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (31646, 495, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (31647, 495, 90, 15);
INSERT INTO 'devicecapvalue' VALUES (31648, 495, 57, 693);
INSERT INTO 'devicecapvalue' VALUES (31649, 495, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (31650, 495, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (31651, 495, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (31652, 495, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (31653, 495, 92, 668);
INSERT INTO 'devicecapvalue' VALUES (31654, 495, 32, 1611);
INSERT INTO 'devicecapvalue' VALUES (31655, 495, 32, 1612);
INSERT INTO 'devicecapvalue' VALUES (31656, 495, 32, 1613);
INSERT INTO 'devicecapvalue' VALUES (31657, 495, 32, 1614);
INSERT INTO 'devicecapvalue' VALUES (31658, 495, 32, 1615);
INSERT INTO 'devicecapvalue' VALUES (31659, 495, 32, 1616);
INSERT INTO 'devicecapvalue' VALUES (31660, 495, 32, 1617);
INSERT INTO 'devicecapvalue' VALUES (31661, 495, 32, 1618);
INSERT INTO 'devicecapvalue' VALUES (31662, 495, 32, 1619);
INSERT INTO 'devicecapvalue' VALUES (31663, 495, 32, 1620);
INSERT INTO 'devicecapvalue' VALUES (31664, 495, 32, 1621);
INSERT INTO 'devicecapvalue' VALUES (31665, 495, 32, 1622);
INSERT INTO 'devicecapvalue' VALUES (31666, 495, 32, 1623);
INSERT INTO 'devicecapvalue' VALUES (31667, 495, 32, 1624);
INSERT INTO 'devicecapvalue' VALUES (31668, 495, 32, 1625);
INSERT INTO 'devicecapvalue' VALUES (31669, 495, 32, 1626);
INSERT INTO 'devicecapvalue' VALUES (31670, 495, 32, 1627);
INSERT INTO 'devicecapvalue' VALUES (31671, 495, 32, 1628);
INSERT INTO 'devicecapvalue' VALUES (31672, 495, 32, 1629);
INSERT INTO 'devicecapvalue' VALUES (31673, 495, 32, 1630);
INSERT INTO 'devicecapvalue' VALUES (31674, 495, 32, 1631);
INSERT INTO 'devicecapvalue' VALUES (31675, 495, 32, 1632);
INSERT INTO 'devicecapvalue' VALUES (31676, 495, 32, 1633);
INSERT INTO 'devicecapvalue' VALUES (31677, 495, 32, 1634);
INSERT INTO 'devicecapvalue' VALUES (31678, 495, 32, 1635);
INSERT INTO 'devicecapvalue' VALUES (31679, 495, 32, 1636);
INSERT INTO 'devicecapvalue' VALUES (31680, 495, 32, 1637);
INSERT INTO 'devicecapvalue' VALUES (31681, 495, 32, 1638);
INSERT INTO 'devicecapvalue' VALUES (31682, 495, 32, 1639);
INSERT INTO 'devicecapvalue' VALUES (31683, 495, 32, 1640);
INSERT INTO 'devicecapvalue' VALUES (31684, 495, 32, 1641);
INSERT INTO 'devicecapvalue' VALUES (31685, 495, 32, 1642);
INSERT INTO 'devicecapvalue' VALUES (31686, 495, 32, 1643);
INSERT INTO 'devicecapvalue' VALUES (31687, 495, 32, 1644);
INSERT INTO 'devicecapvalue' VALUES (31688, 495, 32, 1645);
INSERT INTO 'devicecapvalue' VALUES (31689, 495, 32, 1646);
INSERT INTO 'devicecapvalue' VALUES (31690, 495, 32, 1647);
INSERT INTO 'devicecapvalue' VALUES (31691, 495, 32, 1648);
INSERT INTO 'devicecapvalue' VALUES (31692, 495, 32, 1649);
INSERT INTO 'devicecapvalue' VALUES (31693, 495, 32, 1650);
INSERT INTO 'devicecapvalue' VALUES (31694, 495, 32, 1651);
INSERT INTO 'devicecapvalue' VALUES (31695, 495, 32, 1652);
INSERT INTO 'devicecapvalue' VALUES (31696, 495, 32, 1653);
INSERT INTO 'devicecapvalue' VALUES (31697, 495, 32, 1654);
INSERT INTO 'devicecapvalue' VALUES (31698, 495, 32, 1655);
INSERT INTO 'devicecapvalue' VALUES (31699, 495, 32, 1656);
INSERT INTO 'devicecapvalue' VALUES (31700, 495, 32, 1657);
INSERT INTO 'devicecapvalue' VALUES (31701, 495, 32, 1658);
INSERT INTO 'devicecapvalue' VALUES (31702, 495, 32, 1659);
INSERT INTO 'devicecapvalue' VALUES (31703, 495, 32, 1660);
INSERT INTO 'devicecapvalue' VALUES (31704, 495, 32, 1661);
INSERT INTO 'devicecapvalue' VALUES (31705, 495, 32, 1662);
INSERT INTO 'devicecapvalue' VALUES (31706, 495, 32, 1663);
INSERT INTO 'devicecapvalue' VALUES (31707, 495, 32, 1664);
INSERT INTO 'devicecapvalue' VALUES (31708, 495, 32, 1665);
INSERT INTO 'devicecapvalue' VALUES (31709, 495, 32, 1666);
INSERT INTO 'devicecapvalue' VALUES (31710, 495, 32, 1667);
INSERT INTO 'devicecapvalue' VALUES (31711, 495, 32, 1668);
INSERT INTO 'devicecapvalue' VALUES (31712, 495, 32, 1669);
INSERT INTO 'devicecapvalue' VALUES (31713, 495, 32, 1670);
INSERT INTO 'devicecapvalue' VALUES (31714, 495, 32, 1671);
INSERT INTO 'devicecapvalue' VALUES (31715, 495, 32, 1672);
INSERT INTO 'devicecapvalue' VALUES (31716, 495, 32, 1673);
INSERT INTO 'devicecapvalue' VALUES (31717, 495, 32, 1674);
INSERT INTO 'devicecapvalue' VALUES (31718, 495, 32, 852);
INSERT INTO 'devicecapvalue' VALUES (31719, 495, 32, 1675);
INSERT INTO 'devicecapvalue' VALUES (31720, 495, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (31721, 495, 32, 1676);
INSERT INTO 'devicecapvalue' VALUES (31722, 495, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (31723, 495, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (31724, 495, 35, 45);
INSERT INTO 'capvalue' VALUES (2011, 'NokiaN97-1/10.0.012/sw_platform=S60;sw_platform_version=5.0;java_build_version=1.4.11');
INSERT INTO 'devicecapvalue' VALUES (31725, 495, 36, 2011);
INSERT INTO 'devicecapvalue' VALUES (31726, 495, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (31727, 495, 38, 1577);
INSERT INTO 'devicecapvalue' VALUES (31728, 495, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (31729, 495, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (31730, 495, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (31731, 495, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (31732, 495, 39, 1050);
INSERT INTO 'devicecapvalue' VALUES (31733, 495, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (31734, 495, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (31735, 495, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (31736, 495, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (31737, 495, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (31738, 495, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (31739, 495, 40, 125);
INSERT INTO 'devicecapvalue' VALUES (31740, 495, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (31741, 495, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (31742, 495, 40, 1580);
INSERT INTO 'devicecapvalue' VALUES (31743, 495, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (31744, 495, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (31745, 495, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (31746, 495, 41, 868);
INSERT INTO 'capvalue' VALUES (2012, 'application/x-pn-avi-plugin');
INSERT INTO 'devicecapvalue' VALUES (31747, 495, 41, 2012);
INSERT INTO 'devicecapvalue' VALUES (31748, 495, 41, 1275);
INSERT INTO 'devicecapvalue' VALUES (31749, 495, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (31750, 495, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (31751, 495, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (31752, 495, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (31753, 495, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (31754, 495, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (31755, 495, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (31756, 495, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (31757, 495, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (31758, 495, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (31759, 495, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (31760, 495, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (31761, 495, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (31762, 495, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (31763, 495, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (31764, 495, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (31765, 495, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (31766, 495, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (31767, 495, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (31768, 495, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (31769, 495, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (31770, 495, 41, 1583);
INSERT INTO 'devicecapvalue' VALUES (31771, 495, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (31772, 495, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (31773, 495, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (31774, 495, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (31775, 495, 41, 1584);
INSERT INTO 'devicecapvalue' VALUES (31776, 495, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (31777, 495, 41, 1051);
INSERT INTO 'capvalue' VALUES (2013, 'video/avi');
INSERT INTO 'devicecapvalue' VALUES (31778, 495, 41, 2013);
INSERT INTO 'devicecapvalue' VALUES (31779, 495, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (31780, 495, 41, 888);
INSERT INTO 'capvalue' VALUES (2014, 'video/msvideo');
INSERT INTO 'devicecapvalue' VALUES (31781, 495, 41, 2014);
INSERT INTO 'devicecapvalue' VALUES (31782, 495, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (31783, 495, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (31784, 495, 41, 624);
INSERT INTO 'devicecapvalue' VALUES (31785, 495, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (31786, 495, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (31787, 495, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (31788, 495, 42, 2012);
INSERT INTO 'devicecapvalue' VALUES (31789, 495, 42, 1275);
INSERT INTO 'devicecapvalue' VALUES (31790, 495, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (31791, 495, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (31792, 495, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (31793, 495, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (31794, 495, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (31795, 495, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (31796, 495, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (31797, 495, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (31798, 495, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (31799, 495, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (31800, 495, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (31801, 495, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (31802, 495, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (31803, 495, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (31804, 495, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (31805, 495, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (31806, 495, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (31807, 495, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (31808, 495, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (31809, 495, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (31810, 495, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (31811, 495, 42, 1583);
INSERT INTO 'devicecapvalue' VALUES (31812, 495, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (31813, 495, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (31814, 495, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (31815, 495, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (31816, 495, 42, 1584);
INSERT INTO 'devicecapvalue' VALUES (31817, 495, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (31818, 495, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (31819, 495, 42, 2013);
INSERT INTO 'devicecapvalue' VALUES (31820, 495, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (31821, 495, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (31822, 495, 42, 2014);
INSERT INTO 'devicecapvalue' VALUES (31823, 495, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (31824, 495, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (31825, 495, 42, 624);
INSERT INTO 'devicecapvalue' VALUES (31826, 495, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (31827, 495, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (31828, 495, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (31829, 495, 45, 1585);
INSERT INTO 'devicecapvalue' VALUES (31830, 495, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (31831, 495, 58, 42);
INSERT INTO 'devicecapvalue' VALUES (31832, 495, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (31833, 495, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (31834, 495, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (31835, 495, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (31836, 495, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (31837, 495, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (31838, 495, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (31839, 495, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (31840, 495, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (31841, 495, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (31842, 495, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (31843, 495, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (31844, 495, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (31845, 495, 46, 1586);
INSERT INTO 'devicecapvalue' VALUES (31846, 495, 46, 1404);
INSERT INTO 'devicecapvalue' VALUES (31847, 495, 46, 1588);
INSERT INTO 'devicecapvalue' VALUES (31848, 495, 46, 1589);
INSERT INTO 'devicecapvalue' VALUES (31849, 495, 46, 1590);
INSERT INTO 'devicecapvalue' VALUES (31850, 495, 46, 1405);
INSERT INTO 'devicecapvalue' VALUES (31851, 495, 46, 1406);
INSERT INTO 'devicecapvalue' VALUES (31852, 495, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (31853, 495, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (31854, 495, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (31855, 495, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (31856, 495, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (31857, 495, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (31858, 495, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (31859, 495, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (31860, 495, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (31861, 495, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (31862, 495, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (31863, 495, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (31864, 495, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (31865, 495, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (31866, 495, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (31867, 495, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (31868, 495, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (31869, 495, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (31870, 495, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (31871, 495, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (31872, 495, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (31873, 495, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (31874, 495, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (31875, 495, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (31876, 495, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (31877, 495, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (31878, 495, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (31879, 495, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (31880, 495, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (31881, 495, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (31882, 495, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (31883, 495, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (31884, 495, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (31885, 495, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (31886, 495, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (31887, 495, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (31888, 495, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (31889, 495, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (31890, 495, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (31891, 495, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (31892, 495, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (31893, 495, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (31894, 495, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (31895, 495, 115, 1577);
INSERT INTO 'devicecapvalue' VALUES (31896, 495, 197, 1594);
INSERT INTO 'devicecapvalue' VALUES (31897, 495, 141, 238);
INSERT INTO 'devicecapvalue' VALUES (31898, 495, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (31899, 495, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (31900, 495, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (31901, 495, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (31902, 495, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (31903, 495, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (31904, 495, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (31905, 495, 124, 244);
INSERT INTO 'devicecapvalue' VALUES (31906, 495, 125, 1595);
INSERT INTO 'devicecapvalue' VALUES (31907, 495, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (31908, 495, 198, 1939);
INSERT INTO 'devicecapvalue' VALUES (31909, 495, 183, 1922);
INSERT INTO 'capvalue' VALUES (2015, '354225032683364');
INSERT INTO 'devicecapvalue' VALUES (31910, 495, 200, 2015);
INSERT INTO 'devicecapvalue' VALUES (31911, 495, 201, 1908);
INSERT INTO 'devicecapvalue' VALUES (31912, 495, 202, 1909);
INSERT INTO 'devicecapvalue' VALUES (31913, 495, 184, 1424);
INSERT INTO 'devicecapvalue' VALUES (31914, 495, 185, 1602);
INSERT INTO 'devicecapvalue' VALUES (31915, 495, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (31916, 495, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (31917, 495, 102, 1926);
INSERT INTO 'devicecapvalue' VALUES (31918, 495, 103, 1604);
INSERT INTO 'devicecapvalue' VALUES (31919, 495, 104, 944);
INSERT INTO 'capvalue' VALUES (2016, 'file:///c:/private/102033e6/midlets/[1010b2fd]/scratch/');
INSERT INTO 'devicecapvalue' VALUES (31920, 495, 105, 2016);
INSERT INTO 'devicecapvalue' VALUES (31921, 495, 106, 1607);
INSERT INTO 'devicecapvalue' VALUES (31922, 495, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (31923, 495, 108, 1609);
INSERT INTO 'devicecapvalue' VALUES (31924, 495, 109, 1928);
INSERT INTO 'devicecapvalue' VALUES (31925, 495, 144, 242);
INSERT INTO 'devicecapvalue' VALUES (31926, 495, 114, 1611);
INSERT INTO 'devicecapvalue' VALUES (31927, 495, 114, 1612);
INSERT INTO 'devicecapvalue' VALUES (31928, 495, 114, 1613);
INSERT INTO 'devicecapvalue' VALUES (31929, 495, 114, 1614);
INSERT INTO 'devicecapvalue' VALUES (31930, 495, 114, 1615);
INSERT INTO 'devicecapvalue' VALUES (31931, 495, 114, 1616);
INSERT INTO 'devicecapvalue' VALUES (31932, 495, 114, 1617);
INSERT INTO 'devicecapvalue' VALUES (31933, 495, 114, 1618);
INSERT INTO 'devicecapvalue' VALUES (31934, 495, 114, 1619);
INSERT INTO 'devicecapvalue' VALUES (31935, 495, 114, 1620);
INSERT INTO 'devicecapvalue' VALUES (31936, 495, 114, 1621);
INSERT INTO 'devicecapvalue' VALUES (31937, 495, 114, 1622);
INSERT INTO 'devicecapvalue' VALUES (31938, 495, 114, 1623);
INSERT INTO 'devicecapvalue' VALUES (31939, 495, 114, 1624);
INSERT INTO 'devicecapvalue' VALUES (31940, 495, 114, 1625);
INSERT INTO 'devicecapvalue' VALUES (31941, 495, 114, 1626);
INSERT INTO 'devicecapvalue' VALUES (31942, 495, 114, 1627);
INSERT INTO 'devicecapvalue' VALUES (31943, 495, 114, 1628);
INSERT INTO 'devicecapvalue' VALUES (31944, 495, 114, 1629);
INSERT INTO 'devicecapvalue' VALUES (31945, 495, 114, 1630);
INSERT INTO 'devicecapvalue' VALUES (31946, 495, 114, 1631);
INSERT INTO 'devicecapvalue' VALUES (31947, 495, 114, 1632);
INSERT INTO 'devicecapvalue' VALUES (31948, 495, 114, 1633);
INSERT INTO 'devicecapvalue' VALUES (31949, 495, 114, 1634);
INSERT INTO 'devicecapvalue' VALUES (31950, 495, 114, 1635);
INSERT INTO 'devicecapvalue' VALUES (31951, 495, 114, 1636);
INSERT INTO 'devicecapvalue' VALUES (31952, 495, 114, 1637);
INSERT INTO 'devicecapvalue' VALUES (31953, 495, 114, 1638);
INSERT INTO 'devicecapvalue' VALUES (31954, 495, 114, 1639);
INSERT INTO 'devicecapvalue' VALUES (31955, 495, 114, 1640);
INSERT INTO 'devicecapvalue' VALUES (31956, 495, 114, 1641);
INSERT INTO 'devicecapvalue' VALUES (31957, 495, 114, 1642);
INSERT INTO 'devicecapvalue' VALUES (31958, 495, 114, 1643);
INSERT INTO 'devicecapvalue' VALUES (31959, 495, 114, 1644);
INSERT INTO 'devicecapvalue' VALUES (31960, 495, 114, 1645);
INSERT INTO 'devicecapvalue' VALUES (31961, 495, 114, 1646);
INSERT INTO 'devicecapvalue' VALUES (31962, 495, 114, 1647);
INSERT INTO 'devicecapvalue' VALUES (31963, 495, 114, 1648);
INSERT INTO 'devicecapvalue' VALUES (31964, 495, 114, 1649);
INSERT INTO 'devicecapvalue' VALUES (31965, 495, 114, 1650);
INSERT INTO 'devicecapvalue' VALUES (31966, 495, 114, 1651);
INSERT INTO 'devicecapvalue' VALUES (31967, 495, 114, 1652);
INSERT INTO 'devicecapvalue' VALUES (31968, 495, 114, 1653);
INSERT INTO 'devicecapvalue' VALUES (31969, 495, 114, 1654);
INSERT INTO 'devicecapvalue' VALUES (31970, 495, 114, 1655);
INSERT INTO 'devicecapvalue' VALUES (31971, 495, 114, 1656);
INSERT INTO 'devicecapvalue' VALUES (31972, 495, 114, 1657);
INSERT INTO 'devicecapvalue' VALUES (31973, 495, 114, 1658);
INSERT INTO 'devicecapvalue' VALUES (31974, 495, 114, 1659);
INSERT INTO 'devicecapvalue' VALUES (31975, 495, 114, 1660);
INSERT INTO 'devicecapvalue' VALUES (31976, 495, 114, 1661);
INSERT INTO 'devicecapvalue' VALUES (31977, 495, 114, 1662);
INSERT INTO 'devicecapvalue' VALUES (31978, 495, 114, 1663);
INSERT INTO 'devicecapvalue' VALUES (31979, 495, 114, 1664);
INSERT INTO 'devicecapvalue' VALUES (31980, 495, 114, 1665);
INSERT INTO 'devicecapvalue' VALUES (31981, 495, 114, 1666);
INSERT INTO 'devicecapvalue' VALUES (31982, 495, 114, 1667);
INSERT INTO 'devicecapvalue' VALUES (31983, 495, 114, 1668);
INSERT INTO 'devicecapvalue' VALUES (31984, 495, 114, 1669);
INSERT INTO 'devicecapvalue' VALUES (31985, 495, 114, 1670);
INSERT INTO 'devicecapvalue' VALUES (31986, 495, 114, 1671);
INSERT INTO 'devicecapvalue' VALUES (31987, 495, 114, 1672);
INSERT INTO 'devicecapvalue' VALUES (31988, 495, 114, 1673);
INSERT INTO 'devicecapvalue' VALUES (31989, 495, 114, 1674);
INSERT INTO 'devicecapvalue' VALUES (31990, 495, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (31991, 495, 114, 1675);
INSERT INTO 'devicecapvalue' VALUES (31992, 495, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (31993, 495, 114, 1676);
INSERT INTO 'devicecapvalue' VALUES (31994, 495, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (31995, 495, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (31996, 495, 204, 1677);
INSERT INTO 'devicecapvalue' VALUES (31997, 495, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (31998, 495, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (31999, 495, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (32000, 495, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (32001, 495, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (32002, 495, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (32003, 495, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (32004, 495, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (32005, 495, 131, 922);
INSERT INTO 'devicecapvalue' VALUES (32006, 495, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (32007, 495, 68, 2011);
INSERT INTO 'devicecapvalue' VALUES (32008, 495, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (32009, 495, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (32010, 495, 205, 45);
INSERT INTO 'devicecapvalue' VALUES (32011, 495, 147, 1678);
INSERT INTO 'devicecapvalue' VALUES (32012, 495, 132, 1577);
INSERT INTO 'devicecapvalue' VALUES (32013, 495, 133, 1585);
INSERT INTO 'devicecapvalue' VALUES (32014, 495, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (32015, 495, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (32016, 495, 149, 1680);
INSERT INTO 'devicecapvalue' VALUES (32017, 495, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (32018, 495, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (32019, 495, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (32020, 495, 136, 1585);
INSERT INTO 'devicecapvalue' VALUES (32021, 495, 137, 1396);
INSERT INTO 'devicecapvalue' VALUES (32022, 495, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (32023, 495, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (32024, 495, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (32025, 495, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (32026, 495, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (32027, 495, 137, 96);
INSERT INTO 'devicecapvalue' VALUES (32028, 495, 72, 1454);
INSERT INTO 'devicecapvalue' VALUES (32029, 495, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (32030, 495, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (32031, 495, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (32032, 495, 47, 1683);
INSERT INTO 'devicecapvalue' VALUES (32033, 495, 207, 56);
INSERT INTO 'devicecapvalue' VALUES (32034, 495, 207, 868);
INSERT INTO 'devicecapvalue' VALUES (32035, 495, 207, 1275);
INSERT INTO 'devicecapvalue' VALUES (32036, 495, 207, 57);
INSERT INTO 'devicecapvalue' VALUES (32037, 495, 207, 1582);
INSERT INTO 'devicecapvalue' VALUES (32038, 495, 207, 49);
INSERT INTO 'devicecapvalue' VALUES (32039, 495, 207, 62);
INSERT INTO 'devicecapvalue' VALUES (32040, 495, 207, 1684);
INSERT INTO 'devicecapvalue' VALUES (32041, 495, 207, 986);
INSERT INTO 'devicecapvalue' VALUES (32042, 495, 207, 988);
INSERT INTO 'devicecapvalue' VALUES (32043, 495, 207, 53);
INSERT INTO 'devicecapvalue' VALUES (32044, 495, 207, 1051);
INSERT INTO 'devicecapvalue' VALUES (32045, 495, 207, 67);
INSERT INTO 'devicecapvalue' VALUES (32046, 495, 208, 15);
INSERT INTO 'devicecapvalue' VALUES (32047, 495, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (32048, 495, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (32049, 495, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (32050, 495, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (32051, 495, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (32052, 495, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (32053, 495, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (32054, 495, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (32055, 495, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (32056, 495, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (32057, 495, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (32058, 495, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (32059, 495, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (32060, 495, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (32061, 495, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (32062, 495, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (32063, 495, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (32064, 495, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (32065, 495, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (32066, 495, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (32067, 495, 48, 824);
INSERT INTO 'devicecapvalue' VALUES (32068, 495, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (32069, 495, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (32070, 495, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (32071, 495, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (32072, 495, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (32073, 495, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (32074, 495, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (32075, 495, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (32076, 495, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (32077, 495, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (32078, 495, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (32079, 495, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (32080, 495, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (32081, 495, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (32082, 495, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (32083, 495, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (32084, 495, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (32085, 495, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (32086, 495, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (32087, 495, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (32088, 495, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (32089, 495, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (32090, 495, 48, 1685);
INSERT INTO 'devicecapvalue' VALUES (32091, 495, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (32092, 495, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (32093, 495, 48, 1686);
INSERT INTO 'devicecapvalue' VALUES (32094, 495, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (32095, 495, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (32096, 495, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (32097, 495, 48, 830);
INSERT INTO 'capvalue' VALUES (2017, '351744');
INSERT INTO 'devicecapvalue' VALUES (32098, 495, 49, 2017);
INSERT INTO 'devicecapvalue' VALUES (32099, 496, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (32100, 497, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (32101, 498, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (32102, 499, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (32103, 500, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (32104, 501, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (32105, 502, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (32106, 503, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (32107, 504, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (32108, 505, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (32109, 505, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (32110, 505, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (32111, 505, 5, 646);
INSERT INTO 'devicecapvalue' VALUES (32112, 506, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (32113, 506, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (32114, 506, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (32115, 506, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32116, 506, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32117, 506, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (32118, 506, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (32119, 506, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (32120, 507, 7, 708);
INSERT INTO 'devicecapvalue' VALUES (32121, 507, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (32122, 507, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (32123, 507, 9, 1);
INSERT INTO 'devicecapvalue' VALUES (32124, 507, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (32125, 507, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (32126, 507, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (32127, 507, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (32128, 507, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (32129, 507, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (32130, 507, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (32131, 507, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32132, 507, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (32133, 507, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (32134, 507, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (32135, 507, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (32136, 507, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (32137, 507, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (32138, 507, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (32139, 507, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32140, 507, 18, 36);
INSERT INTO 'devicecapvalue' VALUES (32141, 507, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (32142, 507, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (32143, 507, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (32144, 507, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (32145, 507, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (32146, 507, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (32147, 507, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (32148, 507, 26, 35);
INSERT INTO 'devicecapvalue' VALUES (32149, 507, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (32150, 507, 28, 36);
INSERT INTO 'devicecapvalue' VALUES (32151, 507, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (32152, 507, 30, 39);
INSERT INTO 'devicecapvalue' VALUES (32153, 507, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (32154, 507, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (32155, 507, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (32156, 507, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (32157, 507, 35, 45);
INSERT INTO 'capvalue' VALUES (2018, 'CotullaCode XDA Flame');
INSERT INTO 'devicecapvalue' VALUES (32158, 507, 36, 2018);
INSERT INTO 'devicecapvalue' VALUES (32159, 507, 37, 47);
INSERT INTO 'devicecapvalue' VALUES (32160, 507, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (32161, 507, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (32162, 507, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (32163, 507, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (32164, 507, 41, 58);
INSERT INTO 'capvalue' VALUES (2019, 'audio/aac+');
INSERT INTO 'devicecapvalue' VALUES (32165, 507, 41, 2019);
INSERT INTO 'devicecapvalue' VALUES (32166, 507, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (32167, 507, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (32168, 507, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (32169, 507, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (32170, 507, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (32171, 507, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (32172, 507, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (32173, 507, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (32174, 507, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (32175, 507, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (32176, 507, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (32177, 507, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (32178, 507, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (32179, 507, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (32180, 507, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (32181, 507, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (32182, 507, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (32183, 507, 42, 2019);
INSERT INTO 'devicecapvalue' VALUES (32184, 507, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (32185, 507, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (32186, 507, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (32187, 507, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (32188, 507, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (32189, 507, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (32190, 507, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (32191, 507, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (32192, 507, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (32193, 507, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (32194, 507, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (32195, 507, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (32196, 507, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (32197, 507, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (32198, 507, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (32199, 507, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (32200, 507, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (32201, 507, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (32202, 507, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (32203, 507, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (32204, 507, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (32205, 507, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (32206, 507, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (32207, 507, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (32208, 507, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (32209, 507, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (32210, 507, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (32211, 507, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (32212, 507, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (32213, 507, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (32214, 507, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (32215, 507, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (32216, 507, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (32217, 507, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (32218, 507, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (32219, 507, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (32220, 507, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (32221, 507, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (32222, 507, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (32223, 507, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (32224, 507, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (32225, 507, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (32226, 507, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (32227, 507, 49, 733);
INSERT INTO 'capvalue' VALUES (2020, 'Mozilla/4.0 (compatible; MSIE 6.0; Windows CE; IEMobile 8.12; MSIEMobile 6.0)');
INSERT INTO 'devicecapvalue' VALUES (32228, 507, 53, 2020);
INSERT INTO 'devicecapvalue' VALUES (32229, 508, 56, 233);
INSERT INTO 'devicecapvalue' VALUES (32230, 508, 79, 244);
INSERT INTO 'capvalue' VALUES (2021, '320x416');
INSERT INTO 'devicecapvalue' VALUES (32231, 508, 7, 2021);
INSERT INTO 'devicecapvalue' VALUES (32232, 508, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (32233, 508, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (32234, 508, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (32235, 508, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (32236, 508, 12, 12);
INSERT INTO 'devicecapvalue' VALUES (32237, 508, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (32238, 508, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32239, 508, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (32240, 508, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (32241, 508, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (32242, 508, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32243, 508, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (32244, 508, 20, 30);
INSERT INTO 'capvalue' VALUES (2022, '65');
INSERT INTO 'devicecapvalue' VALUES (32245, 508, 21, 2022);
INSERT INTO 'capvalue' VALUES (2023, '66');
INSERT INTO 'devicecapvalue' VALUES (32246, 508, 22, 2023);
INSERT INTO 'capvalue' VALUES (2024, '67');
INSERT INTO 'devicecapvalue' VALUES (32247, 508, 23, 2024);
INSERT INTO 'capvalue' VALUES (2025, '68');
INSERT INTO 'devicecapvalue' VALUES (32248, 508, 24, 2025);
INSERT INTO 'devicecapvalue' VALUES (32249, 508, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (32250, 508, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (32251, 508, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (32252, 508, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (32253, 508, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (32254, 508, 58, 42);
INSERT INTO 'devicecapvalue' VALUES (32255, 508, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (32256, 508, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (32257, 508, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (32258, 508, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (32259, 508, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (32260, 508, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (32261, 508, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (32262, 508, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (32263, 508, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (32264, 508, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (32265, 508, 59, 602);
INSERT INTO 'capvalue' VALUES (2026, 'ircm');
INSERT INTO 'devicecapvalue' VALUES (32266, 508, 114, 2026);
INSERT INTO 'capvalue' VALUES (2027, 'rfcm');
INSERT INTO 'devicecapvalue' VALUES (32267, 508, 114, 2027);
INSERT INTO 'capvalue' VALUES (2028, 'ser0');
INSERT INTO 'devicecapvalue' VALUES (32268, 508, 114, 2028);
INSERT INTO 'capvalue' VALUES (2029, 'ser2');
INSERT INTO 'devicecapvalue' VALUES (32269, 508, 114, 2029);
INSERT INTO 'capvalue' VALUES (2030, 'sir0');
INSERT INTO 'devicecapvalue' VALUES (32270, 508, 114, 2030);
INSERT INTO 'capvalue' VALUES (2031, 'usbc');
INSERT INTO 'devicecapvalue' VALUES (32271, 508, 114, 2031);
INSERT INTO 'capvalue' VALUES (2032, 'usbd');
INSERT INTO 'devicecapvalue' VALUES (32272, 508, 114, 2032);
INSERT INTO 'devicecapvalue' VALUES (32273, 508, 60, 43);
INSERT INTO 'capvalue' VALUES (2033, 'CP1252');
INSERT INTO 'devicecapvalue' VALUES (32274, 508, 62, 2033);
INSERT INTO 'capvalue' VALUES (2034, '127.0.0.1');
INSERT INTO 'devicecapvalue' VALUES (32275, 508, 204, 2034);
INSERT INTO 'devicecapvalue' VALUES (32276, 508, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (32277, 508, 67, 45);
INSERT INTO 'capvalue' VALUES (2035, 'Palm OS');
INSERT INTO 'devicecapvalue' VALUES (32278, 508, 68, 2035);
INSERT INTO 'devicecapvalue' VALUES (32279, 508, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (32280, 508, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (32281, 508, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (32282, 508, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (32283, 508, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (32284, 508, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (32285, 508, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (32286, 508, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (32287, 508, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (32288, 508, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (32289, 508, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (32290, 508, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (32291, 508, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (32292, 508, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (32293, 508, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (32294, 508, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (32295, 508, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (32296, 508, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (32297, 508, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (32298, 508, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (32299, 508, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (32300, 508, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (32301, 508, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (32302, 508, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (32303, 508, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (32304, 508, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (32305, 508, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (32306, 508, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (32307, 508, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (32308, 508, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (32309, 508, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (32310, 508, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (32311, 508, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (32312, 508, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (32313, 508, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (32314, 508, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (32315, 508, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (32316, 508, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (32317, 508, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (32318, 508, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (32319, 508, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (32320, 508, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (32321, 508, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (32322, 508, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (32323, 508, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (32324, 508, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (32325, 508, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (32326, 508, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (32327, 508, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (32328, 508, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (32329, 508, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (32330, 508, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (32331, 508, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (32332, 508, 48, 830);
INSERT INTO 'capvalue' VALUES (2036, '180224');
INSERT INTO 'devicecapvalue' VALUES (32333, 508, 49, 2036);
INSERT INTO 'capvalue' VALUES (2037, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; pt-BR; rv:1.8.1.16) Gecko/20080702 Firefox/2.0.0.16');
INSERT INTO 'devicecapvalue' VALUES (32334, 508, 53, 2037);
INSERT INTO 'devicecapvalue' VALUES (32335, 509, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (32336, 509, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (32337, 509, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (32338, 509, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (32339, 509, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (32340, 509, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (32341, 509, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (32342, 509, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32343, 509, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (32344, 509, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (32345, 509, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (32346, 509, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (32347, 509, 154, 1078);
INSERT INTO 'capvalue' VALUES (2038, 'PalmOS');
INSERT INTO 'devicecapvalue' VALUES (32348, 509, 3, 2038);
INSERT INTO 'cap' VALUES (229, 'RMS.MaxRecordSize', 1);
INSERT INTO 'devicecapvalue' VALUES (32349, 509, 229, 1067);
INSERT INTO 'devicecapvalue' VALUES (32350, 509, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (32351, 509, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (32352, 509, 51, 669);
INSERT INTO 'capvalue' VALUES (2039, '53477376');
INSERT INTO 'devicecapvalue' VALUES (32353, 509, 52, 2039);
INSERT INTO 'capvalue' VALUES (2040, '160x144');
INSERT INTO 'devicecapvalue' VALUES (32354, 510, 7, 2040);
INSERT INTO 'devicecapvalue' VALUES (32355, 510, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (32356, 510, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (32357, 510, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (32358, 510, 2, 1384);
INSERT INTO 'capvalue' VALUES (2041, '160x160');
INSERT INTO 'devicecapvalue' VALUES (32359, 510, 13, 2041);
INSERT INTO 'devicecapvalue' VALUES (32360, 510, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32361, 510, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32362, 510, 3, 2038);
INSERT INTO 'devicecapvalue' VALUES (32363, 510, 4, 107);
INSERT INTO 'devicecapvalue' VALUES (32364, 510, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (32365, 511, 7, 2041);
INSERT INTO 'devicecapvalue' VALUES (32366, 511, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (32367, 511, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (32368, 511, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (32369, 511, 2, 1384);
INSERT INTO 'capvalue' VALUES (2042, '320x320');
INSERT INTO 'devicecapvalue' VALUES (32370, 511, 13, 2042);
INSERT INTO 'devicecapvalue' VALUES (32371, 511, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32372, 511, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32373, 511, 3, 2038);
INSERT INTO 'devicecapvalue' VALUES (32374, 511, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (32375, 511, 5, 601);
INSERT INTO 'cap' VALUES (230, 'build.Finalizer', 1);
INSERT INTO 'capvalue' VALUES (2043, '240x200');
INSERT INTO 'devicecapvalue' VALUES (32376, 512, 7, 2043);
INSERT INTO 'devicecapvalue' VALUES (32377, 512, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (32378, 512, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (32379, 512, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (32380, 512, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (32381, 512, 13, 2043);
INSERT INTO 'devicecapvalue' VALUES (32382, 512, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32383, 512, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32384, 512, 3, 740);
INSERT INTO 'devicecapvalue' VALUES (32385, 512, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (32386, 512, 5, 1008);
INSERT INTO 'devicecapvalue' VALUES (32387, 513, 7, 2043);
INSERT INTO 'devicecapvalue' VALUES (32388, 513, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (32389, 513, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (32390, 513, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (32391, 513, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (32392, 513, 13, 2043);
INSERT INTO 'devicecapvalue' VALUES (32393, 513, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32394, 513, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32395, 513, 3, 740);
INSERT INTO 'devicecapvalue' VALUES (32396, 513, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (32397, 513, 5, 1008);
INSERT INTO 'devicecapvalue' VALUES (32398, 514, 7, 2043);
INSERT INTO 'devicecapvalue' VALUES (32399, 514, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (32400, 514, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (32401, 514, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (32402, 514, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (32403, 514, 13, 2043);
INSERT INTO 'devicecapvalue' VALUES (32404, 514, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32405, 514, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32406, 514, 3, 740);
INSERT INTO 'devicecapvalue' VALUES (32407, 514, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (32408, 514, 5, 1008);
INSERT INTO 'devicecapvalue' VALUES (32409, 515, 7, 2041);
INSERT INTO 'devicecapvalue' VALUES (32410, 515, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (32411, 515, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (32412, 515, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (32413, 515, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (32414, 515, 13, 2042);
INSERT INTO 'devicecapvalue' VALUES (32415, 515, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32416, 515, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32417, 515, 3, 2038);
INSERT INTO 'devicecapvalue' VALUES (32418, 515, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (32419, 515, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (32420, 516, 7, 2040);
INSERT INTO 'devicecapvalue' VALUES (32421, 516, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (32422, 516, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (32423, 516, 9, 743);
INSERT INTO 'devicecapvalue' VALUES (32424, 516, 10, 743);
INSERT INTO 'devicecapvalue' VALUES (32425, 516, 11, 743);
INSERT INTO 'devicecapvalue' VALUES (32426, 516, 12, 743);
INSERT INTO 'devicecapvalue' VALUES (32427, 516, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (32428, 516, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32429, 516, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (32430, 516, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (32431, 516, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (32432, 516, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32433, 516, 18, 30);
INSERT INTO 'devicecapvalue' VALUES (32434, 516, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (32435, 516, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (32436, 516, 21, 2022);
INSERT INTO 'devicecapvalue' VALUES (32437, 516, 22, 2023);
INSERT INTO 'devicecapvalue' VALUES (32438, 516, 23, 2024);
INSERT INTO 'devicecapvalue' VALUES (32439, 516, 24, 2025);
INSERT INTO 'devicecapvalue' VALUES (32440, 516, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (32441, 516, 26, 35);
INSERT INTO 'capvalue' VALUES (2044, '63');
INSERT INTO 'devicecapvalue' VALUES (32442, 516, 27, 2044);
INSERT INTO 'devicecapvalue' VALUES (32443, 516, 28, 693);
INSERT INTO 'devicecapvalue' VALUES (32444, 516, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (32445, 516, 30, 39);
INSERT INTO 'devicecapvalue' VALUES (32446, 516, 54, 2044);
INSERT INTO 'devicecapvalue' VALUES (32447, 516, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (32448, 516, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (32449, 516, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (32450, 516, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (32451, 516, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (32452, 516, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (32453, 516, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (32454, 516, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (32455, 516, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (32456, 516, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (32457, 516, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (32458, 516, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (32459, 516, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (32460, 516, 59, 602);
INSERT INTO 'capvalue' VALUES (2045, 'FakM');
INSERT INTO 'devicecapvalue' VALUES (32461, 516, 114, 2045);
INSERT INTO 'capvalue' VALUES (2046, 'htaD');
INSERT INTO 'devicecapvalue' VALUES (32462, 516, 114, 2046);
INSERT INTO 'devicecapvalue' VALUES (32463, 516, 114, 2026);
INSERT INTO 'devicecapvalue' VALUES (32464, 516, 114, 2027);
INSERT INTO 'devicecapvalue' VALUES (32465, 516, 114, 2028);
INSERT INTO 'capvalue' VALUES (2047, 'ser1');
INSERT INTO 'devicecapvalue' VALUES (32466, 516, 114, 2047);
INSERT INTO 'devicecapvalue' VALUES (32467, 516, 114, 2030);
INSERT INTO 'devicecapvalue' VALUES (32468, 516, 114, 2031);
INSERT INTO 'devicecapvalue' VALUES (32469, 516, 114, 2032);
INSERT INTO 'devicecapvalue' VALUES (32470, 516, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (32471, 516, 62, 2033);
INSERT INTO 'capvalue' VALUES (2048, '25.209.154.248');
INSERT INTO 'devicecapvalue' VALUES (32472, 516, 204, 2048);
INSERT INTO 'devicecapvalue' VALUES (32473, 516, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (32474, 516, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (32475, 516, 68, 2035);
INSERT INTO 'devicecapvalue' VALUES (32476, 516, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (32477, 516, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (32478, 516, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (32479, 516, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (32480, 516, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (32481, 516, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (32482, 516, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (32483, 516, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (32484, 516, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (32485, 516, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (32486, 516, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (32487, 516, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (32488, 516, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (32489, 516, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (32490, 516, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (32491, 516, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (32492, 516, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (32493, 516, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (32494, 516, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (32495, 516, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (32496, 516, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (32497, 516, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (32498, 516, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (32499, 516, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (32500, 516, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (32501, 516, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (32502, 516, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (32503, 516, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (32504, 516, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (32505, 516, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (32506, 516, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (32507, 516, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (32508, 516, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (32509, 516, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (32510, 516, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (32511, 516, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (32512, 516, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (32513, 516, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (32514, 516, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (32515, 516, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (32516, 516, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (32517, 516, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (32518, 516, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (32519, 516, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (32520, 516, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (32521, 516, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (32522, 516, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (32523, 516, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (32524, 516, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (32525, 516, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (32526, 516, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (32527, 516, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (32528, 516, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (32529, 516, 48, 830);
INSERT INTO 'capvalue' VALUES (2049, '311296');
INSERT INTO 'devicecapvalue' VALUES (32530, 516, 49, 2049);
INSERT INTO 'capvalue' VALUES (2050, 'Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.1) Gecko/20090624 Firefox/3.5 (.NET CLR 3.5.30729)');
INSERT INTO 'devicecapvalue' VALUES (32531, 516, 53, 2050);
INSERT INTO 'devicecapvalue' VALUES (32532, 517, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (32533, 517, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (32534, 517, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (32535, 517, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (32536, 517, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (32537, 517, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (32538, 517, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (32539, 517, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32540, 517, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (32541, 517, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (32542, 517, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (32543, 517, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (32544, 517, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (32545, 517, 3, 2038);
INSERT INTO 'devicecapvalue' VALUES (32546, 517, 229, 1067);
INSERT INTO 'capvalue' VALUES (2051, '300');
INSERT INTO 'devicecapvalue' VALUES (32547, 517, 4, 2051);
INSERT INTO 'devicecapvalue' VALUES (32548, 517, 5, 2051);
INSERT INTO 'devicecapvalue' VALUES (32549, 517, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (32550, 517, 52, 2039);
INSERT INTO 'devicecapvalue' VALUES (32551, 518, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (32552, 518, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (32553, 518, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (32554, 518, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (32555, 518, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (32556, 518, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (32557, 518, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (32558, 518, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32559, 518, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (32560, 518, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (32561, 518, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (32562, 518, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (32563, 518, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (32564, 518, 3, 2038);
INSERT INTO 'devicecapvalue' VALUES (32565, 518, 229, 1067);
INSERT INTO 'devicecapvalue' VALUES (32566, 518, 4, 2051);
INSERT INTO 'devicecapvalue' VALUES (32567, 518, 5, 2051);
INSERT INTO 'devicecapvalue' VALUES (32568, 518, 51, 669);
INSERT INTO 'capvalue' VALUES (2052, '27262976');
INSERT INTO 'devicecapvalue' VALUES (32569, 518, 52, 2052);
INSERT INTO 'devicecapvalue' VALUES (32570, 519, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (32571, 519, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (32572, 519, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (32573, 519, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (32574, 519, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (32575, 519, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (32576, 519, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (32577, 519, 13, 234);
INSERT INTO 'devicecapvalue' VALUES (32578, 519, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32579, 519, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32580, 519, 18, 604);
INSERT INTO 'devicecapvalue' VALUES (32581, 519, 26, 664);
INSERT INTO 'devicecapvalue' VALUES (32582, 519, 30, 667);
INSERT INTO 'devicecapvalue' VALUES (32583, 519, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (32584, 519, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (32585, 519, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (32586, 519, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (32587, 519, 113, 616);
INSERT INTO 'devicecapvalue' VALUES (32588, 519, 113, 54);
INSERT INTO 'devicecapvalue' VALUES (32589, 519, 113, 51);
INSERT INTO 'devicecapvalue' VALUES (32590, 519, 3, 850);
INSERT INTO 'devicecapvalue' VALUES (32591, 519, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (32592, 519, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (32593, 519, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (32594, 520, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (32595, 520, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (32596, 520, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (32597, 520, 9, 1);
INSERT INTO 'devicecapvalue' VALUES (32598, 520, 10, 663);
INSERT INTO 'devicecapvalue' VALUES (32599, 520, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (32600, 520, 12, 743);
INSERT INTO 'devicecapvalue' VALUES (32601, 520, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (32602, 520, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (32603, 520, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (32604, 520, 19, 744);
INSERT INTO 'devicecapvalue' VALUES (32605, 520, 20, 711);
INSERT INTO 'devicecapvalue' VALUES (32606, 520, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (32607, 520, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (32608, 520, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (32609, 520, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (32610, 520, 25, 746);
INSERT INTO 'devicecapvalue' VALUES (32611, 520, 29, 747);
INSERT INTO 'devicecapvalue' VALUES (32612, 520, 31, 748);
INSERT INTO 'devicecapvalue' VALUES (32613, 520, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (32614, 520, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (32615, 520, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (32616, 520, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (32617, 520, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (32618, 520, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (32619, 520, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (32620, 520, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (32621, 520, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (32622, 520, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (32623, 520, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (32624, 520, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (32625, 520, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (32626, 520, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (32627, 520, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (32628, 520, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (32629, 520, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (32630, 520, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (32631, 520, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (32632, 520, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (32633, 520, 48, 750);
INSERT INTO 'devicecapvalue' VALUES (32634, 520, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (32635, 520, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (32636, 520, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (32637, 520, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (32638, 520, 48, 751);
INSERT INTO 'devicecapvalue' VALUES (32639, 520, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (32640, 520, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (32641, 520, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (32642, 520, 48, 752);
INSERT INTO 'devicecapvalue' VALUES (32643, 520, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (32644, 520, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (32645, 520, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (32646, 520, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (32647, 520, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (32648, 520, 48, 753);
INSERT INTO 'devicecapvalue' VALUES (32649, 520, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (32650, 520, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (32651, 520, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (32652, 520, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (32653, 520, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (32654, 520, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (32655, 520, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (32656, 520, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (32657, 520, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (32658, 520, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (32659, 520, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (32660, 520, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (32661, 520, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (32662, 520, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (32663, 520, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (32664, 520, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (32665, 520, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (32666, 520, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (32667, 520, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (32668, 520, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (32669, 520, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (32670, 520, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (32671, 520, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (32672, 520, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (32673, 520, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (32674, 520, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (32675, 520, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (32676, 520, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (32677, 520, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (32678, 520, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (32679, 520, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (32680, 520, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (32681, 520, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (32682, 520, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (32683, 520, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (32684, 520, 48, 754);
INSERT INTO 'devicecapvalue' VALUES (32685, 520, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (32686, 520, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (32687, 520, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (32688, 520, 48, 755);
INSERT INTO 'devicecapvalue' VALUES (32689, 520, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (32690, 520, 48, 756);
INSERT INTO 'devicecapvalue' VALUES (32691, 520, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (32692, 520, 48, 757);
INSERT INTO 'devicecapvalue' VALUES (32693, 520, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (32694, 520, 48, 758);
INSERT INTO 'devicecapvalue' VALUES (32695, 520, 48, 759);
INSERT INTO 'devicecapvalue' VALUES (32696, 520, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (32697, 520, 48, 760);
INSERT INTO 'devicecapvalue' VALUES (32698, 520, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (32699, 520, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (32700, 520, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (32701, 520, 48, 761);
INSERT INTO 'devicecapvalue' VALUES (32702, 520, 48, 762);
INSERT INTO 'devicecapvalue' VALUES (32703, 520, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (32704, 520, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (32705, 520, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (32706, 520, 48, 763);
INSERT INTO 'devicecapvalue' VALUES (32707, 520, 48, 764);
INSERT INTO 'devicecapvalue' VALUES (32708, 520, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (32709, 520, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (32710, 520, 48, 765);
INSERT INTO 'devicecapvalue' VALUES (32711, 520, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (32712, 520, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (32713, 520, 48, 766);
INSERT INTO 'devicecapvalue' VALUES (32714, 520, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (32715, 520, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (32716, 520, 48, 767);
INSERT INTO 'devicecapvalue' VALUES (32717, 520, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (32718, 520, 48, 768);
INSERT INTO 'devicecapvalue' VALUES (32719, 520, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (32720, 520, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (32721, 520, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (32722, 520, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (32723, 520, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (32724, 520, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (32725, 520, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (32726, 520, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (32727, 520, 48, 769);
INSERT INTO 'devicecapvalue' VALUES (32728, 520, 48, 770);
INSERT INTO 'devicecapvalue' VALUES (32729, 520, 48, 771);
INSERT INTO 'devicecapvalue' VALUES (32730, 520, 48, 772);
INSERT INTO 'devicecapvalue' VALUES (32731, 520, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (32732, 520, 48, 773);
INSERT INTO 'devicecapvalue' VALUES (32733, 520, 48, 774);
INSERT INTO 'devicecapvalue' VALUES (32734, 520, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (32735, 520, 48, 775);
INSERT INTO 'devicecapvalue' VALUES (32736, 520, 48, 776);
INSERT INTO 'devicecapvalue' VALUES (32737, 520, 48, 777);
INSERT INTO 'devicecapvalue' VALUES (32738, 520, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (32739, 520, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (32740, 520, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (32741, 520, 48, 778);
INSERT INTO 'devicecapvalue' VALUES (32742, 520, 48, 779);
INSERT INTO 'devicecapvalue' VALUES (32743, 520, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (32744, 520, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (32745, 520, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (32746, 520, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (32747, 520, 48, 780);
INSERT INTO 'devicecapvalue' VALUES (32748, 520, 48, 781);
INSERT INTO 'devicecapvalue' VALUES (32749, 520, 48, 782);
INSERT INTO 'devicecapvalue' VALUES (32750, 520, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (32751, 520, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (32752, 520, 48, 783);
INSERT INTO 'devicecapvalue' VALUES (32753, 520, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (32754, 520, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (32755, 520, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (32756, 520, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (32757, 520, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (32758, 520, 48, 784);
INSERT INTO 'devicecapvalue' VALUES (32759, 520, 48, 785);
INSERT INTO 'devicecapvalue' VALUES (32760, 520, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (32761, 520, 48, 786);
INSERT INTO 'devicecapvalue' VALUES (32762, 520, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (32763, 520, 48, 787);
INSERT INTO 'devicecapvalue' VALUES (32764, 520, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (32765, 520, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (32766, 520, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (32767, 520, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (32768, 520, 48, 788);
INSERT INTO 'devicecapvalue' VALUES (32769, 520, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (32770, 520, 48, 789);
INSERT INTO 'devicecapvalue' VALUES (32771, 520, 48, 790);
INSERT INTO 'devicecapvalue' VALUES (32772, 520, 48, 791);
INSERT INTO 'devicecapvalue' VALUES (32773, 520, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (32774, 520, 48, 792);
INSERT INTO 'devicecapvalue' VALUES (32775, 520, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (32776, 520, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (32777, 520, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (32778, 520, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (32779, 520, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (32780, 520, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (32781, 520, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (32782, 520, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (32783, 520, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (32784, 520, 48, 793);
INSERT INTO 'devicecapvalue' VALUES (32785, 520, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (32786, 520, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (32787, 520, 48, 794);
INSERT INTO 'devicecapvalue' VALUES (32788, 520, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (32789, 520, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (32790, 520, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (32791, 520, 48, 795);
INSERT INTO 'devicecapvalue' VALUES (32792, 520, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (32793, 520, 48, 796);
INSERT INTO 'devicecapvalue' VALUES (32794, 520, 48, 797);
INSERT INTO 'devicecapvalue' VALUES (32795, 520, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (32796, 520, 48, 798);
INSERT INTO 'devicecapvalue' VALUES (32797, 520, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (32798, 520, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (32799, 520, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (32800, 520, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (32801, 520, 48, 799);
INSERT INTO 'devicecapvalue' VALUES (32802, 520, 48, 800);
INSERT INTO 'devicecapvalue' VALUES (32803, 520, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (32804, 520, 48, 629);
INSERT INTO 'devicecapvalue' VALUES (32805, 520, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (32806, 520, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (32807, 520, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (32808, 520, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (32809, 520, 48, 801);
INSERT INTO 'devicecapvalue' VALUES (32810, 520, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (32811, 520, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (32812, 520, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (32813, 520, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (32814, 520, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (32815, 520, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (32816, 520, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (32817, 520, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (32818, 520, 48, 802);
INSERT INTO 'devicecapvalue' VALUES (32819, 520, 48, 803);
INSERT INTO 'devicecapvalue' VALUES (32820, 520, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (32821, 520, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (32822, 520, 48, 630);
INSERT INTO 'devicecapvalue' VALUES (32823, 520, 48, 804);
INSERT INTO 'devicecapvalue' VALUES (32824, 520, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (32825, 520, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (32826, 520, 48, 805);
INSERT INTO 'devicecapvalue' VALUES (32827, 520, 48, 806);
INSERT INTO 'devicecapvalue' VALUES (32828, 520, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (32829, 520, 48, 807);
INSERT INTO 'devicecapvalue' VALUES (32830, 520, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (32831, 520, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (32832, 520, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (32833, 520, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (32834, 520, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (32835, 520, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (32836, 520, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (32837, 520, 48, 808);
INSERT INTO 'devicecapvalue' VALUES (32838, 520, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (32839, 520, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (32840, 520, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (32841, 520, 48, 809);
INSERT INTO 'devicecapvalue' VALUES (32842, 520, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (32843, 520, 48, 810);
INSERT INTO 'devicecapvalue' VALUES (32844, 520, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (32845, 520, 48, 811);
INSERT INTO 'devicecapvalue' VALUES (32846, 520, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (32847, 520, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (32848, 520, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (32849, 520, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (32850, 520, 48, 812);
INSERT INTO 'devicecapvalue' VALUES (32851, 520, 48, 813);
INSERT INTO 'devicecapvalue' VALUES (32852, 520, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (32853, 520, 48, 814);
INSERT INTO 'devicecapvalue' VALUES (32854, 520, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (32855, 520, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (32856, 520, 48, 815);
INSERT INTO 'devicecapvalue' VALUES (32857, 520, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (32858, 520, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (32859, 520, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (32860, 520, 48, 816);
INSERT INTO 'devicecapvalue' VALUES (32861, 520, 48, 817);
INSERT INTO 'devicecapvalue' VALUES (32862, 520, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (32863, 520, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (32864, 520, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (32865, 520, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (32866, 520, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (32867, 520, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (32868, 520, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (32869, 520, 48, 818);
INSERT INTO 'devicecapvalue' VALUES (32870, 520, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (32871, 520, 48, 819);
INSERT INTO 'devicecapvalue' VALUES (32872, 520, 48, 820);
INSERT INTO 'devicecapvalue' VALUES (32873, 520, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (32874, 520, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (32875, 520, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (32876, 520, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (32877, 520, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (32878, 520, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (32879, 520, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (32880, 520, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (32881, 520, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (32882, 520, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (32883, 520, 48, 821);
INSERT INTO 'devicecapvalue' VALUES (32884, 520, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (32885, 520, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (32886, 520, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (32887, 520, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (32888, 520, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (32889, 520, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (32890, 520, 48, 822);
INSERT INTO 'devicecapvalue' VALUES (32891, 520, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (32892, 520, 48, 631);
INSERT INTO 'devicecapvalue' VALUES (32893, 520, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (32894, 520, 48, 823);
INSERT INTO 'devicecapvalue' VALUES (32895, 520, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (32896, 520, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (32897, 520, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (32898, 520, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (32899, 520, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (32900, 520, 48, 824);
INSERT INTO 'devicecapvalue' VALUES (32901, 520, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (32902, 520, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (32903, 520, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (32904, 520, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (32905, 520, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (32906, 520, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (32907, 520, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (32908, 520, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (32909, 520, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (32910, 520, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (32911, 520, 48, 825);
INSERT INTO 'devicecapvalue' VALUES (32912, 520, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (32913, 520, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (32914, 520, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (32915, 520, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (32916, 520, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (32917, 520, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (32918, 520, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (32919, 520, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (32920, 520, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (32921, 520, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (32922, 520, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (32923, 520, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (32924, 520, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (32925, 520, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (32926, 520, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (32927, 520, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (32928, 520, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (32929, 520, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (32930, 520, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (32931, 520, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (32932, 520, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (32933, 520, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (32934, 520, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (32935, 520, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (32936, 520, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (32937, 520, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (32938, 520, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (32939, 520, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (32940, 520, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (32941, 520, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (32942, 520, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (32943, 520, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (32944, 520, 48, 826);
INSERT INTO 'devicecapvalue' VALUES (32945, 520, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (32946, 520, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (32947, 520, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (32948, 520, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (32949, 520, 48, 827);
INSERT INTO 'devicecapvalue' VALUES (32950, 520, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (32951, 520, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (32952, 520, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (32953, 520, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (32954, 520, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (32955, 520, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (32956, 520, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (32957, 520, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (32958, 520, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (32959, 520, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (32960, 520, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (32961, 520, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (32962, 520, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (32963, 520, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (32964, 520, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (32965, 520, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (32966, 520, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (32967, 520, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (32968, 520, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (32969, 520, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (32970, 520, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (32971, 520, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (32972, 520, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (32973, 520, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (32974, 520, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (32975, 520, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (32976, 520, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (32977, 520, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (32978, 520, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (32979, 520, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (32980, 520, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (32981, 520, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (32982, 520, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (32983, 520, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (32984, 520, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (32985, 520, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (32986, 520, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (32987, 520, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (32988, 520, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (32989, 520, 48, 828);
INSERT INTO 'devicecapvalue' VALUES (32990, 520, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (32991, 520, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (32992, 520, 48, 633);
INSERT INTO 'devicecapvalue' VALUES (32993, 520, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (32994, 520, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (32995, 520, 48, 634);
INSERT INTO 'devicecapvalue' VALUES (32996, 520, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (32997, 520, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (32998, 520, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (32999, 520, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (33000, 520, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (33001, 520, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (33002, 520, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (33003, 520, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (33004, 520, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (33005, 520, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (33006, 520, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (33007, 520, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (33008, 520, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (33009, 520, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (33010, 520, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (33011, 520, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (33012, 520, 48, 829);
INSERT INTO 'devicecapvalue' VALUES (33013, 520, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (33014, 520, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (33015, 520, 48, 830);
INSERT INTO 'devicecapvalue' VALUES (33016, 520, 49, 739);
INSERT INTO 'devicecapvalue' VALUES (33017, 520, 53, 840);
INSERT INTO 'devicecapvalue' VALUES (33018, 521, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33019, 521, 74, 853);
INSERT INTO 'devicecapvalue' VALUES (33020, 521, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (33021, 521, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (33022, 521, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (33023, 521, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (33024, 521, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (33025, 521, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (33026, 521, 13, 234);
INSERT INTO 'devicecapvalue' VALUES (33027, 521, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33028, 521, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33029, 521, 26, 664);
INSERT INTO 'devicecapvalue' VALUES (33030, 521, 30, 667);
INSERT INTO 'devicecapvalue' VALUES (33031, 521, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (33032, 521, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (33033, 521, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (33034, 521, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (33035, 521, 113, 616);
INSERT INTO 'devicecapvalue' VALUES (33036, 521, 113, 54);
INSERT INTO 'devicecapvalue' VALUES (33037, 521, 113, 51);
INSERT INTO 'devicecapvalue' VALUES (33038, 521, 3, 850);
INSERT INTO 'devicecapvalue' VALUES (33039, 521, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (33040, 521, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (33041, 521, 5, 601);
INSERT INTO 'capvalue' VALUES (2053, 'Qtek9100');
INSERT INTO 'devicecapvalue' VALUES (33042, 521, 53, 2053);
INSERT INTO 'devicecapvalue' VALUES (33043, 522, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33044, 522, 173, 1313);
INSERT INTO 'devicecapvalue' VALUES (33045, 522, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (33046, 522, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (33047, 522, 76, 1226);
INSERT INTO 'devicecapvalue' VALUES (33048, 522, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (33049, 522, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (33050, 522, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33051, 522, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33052, 522, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33053, 522, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33054, 522, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (33055, 522, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (33056, 522, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (33057, 523, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33058, 523, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33059, 523, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33060, 523, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33061, 523, 15, 17);
INSERT INTO 'capvalue' VALUES (2054, 'gif87');
INSERT INTO 'devicecapvalue' VALUES (33062, 523, 15, 2054);
INSERT INTO 'capvalue' VALUES (2055, 'gif89');
INSERT INTO 'devicecapvalue' VALUES (33063, 523, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33064, 523, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33065, 523, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33066, 523, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33067, 523, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33068, 523, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33069, 523, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (33070, 523, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33071, 523, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33072, 523, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33073, 523, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33074, 523, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (33075, 524, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33076, 524, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (33077, 524, 2, 236);
INSERT INTO 'capvalue' VALUES (2056, '128x142');
INSERT INTO 'devicecapvalue' VALUES (33078, 524, 13, 2056);
INSERT INTO 'devicecapvalue' VALUES (33079, 524, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33080, 524, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33081, 524, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33082, 524, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33083, 524, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33084, 524, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33085, 524, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33086, 524, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33087, 524, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33088, 524, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33089, 524, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (33090, 524, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33091, 524, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33092, 524, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33093, 524, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33094, 524, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (33095, 525, 1, 1);
INSERT INTO 'capvalue' VALUES (2057, '176x176');
INSERT INTO 'devicecapvalue' VALUES (33096, 525, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (33097, 525, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33098, 525, 2, 1001);
INSERT INTO 'capvalue' VALUES (2058, 'hasCommandKeys');
INSERT INTO 'devicecapvalue' VALUES (33099, 525, 2, 2058);
INSERT INTO 'devicecapvalue' VALUES (33100, 525, 2, 1338);
INSERT INTO 'capvalue' VALUES (2059, '176x195');
INSERT INTO 'devicecapvalue' VALUES (33101, 525, 13, 2059);
INSERT INTO 'devicecapvalue' VALUES (33102, 525, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33103, 525, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33104, 525, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33105, 525, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33106, 525, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33107, 525, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33108, 525, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33109, 525, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33110, 525, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33111, 525, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (33112, 525, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33113, 525, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (33114, 525, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33115, 525, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33116, 525, 6, 27);
INSERT INTO 'cap' VALUES (231, 'PolyphonicVoices', 1);
INSERT INTO 'capvalue' VALUES (2060, '40');
INSERT INTO 'devicecapvalue' VALUES (33117, 525, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (33118, 525, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (33119, 525, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (33120, 525, 51, 1191);
INSERT INTO 'devicecapvalue' VALUES (33121, 525, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (33122, 526, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33123, 526, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33124, 526, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33125, 526, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33126, 526, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33127, 526, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33128, 526, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33129, 526, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33130, 526, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33131, 526, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33132, 526, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33133, 526, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33134, 526, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (33135, 526, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33136, 526, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33137, 526, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33138, 526, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33139, 526, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (33140, 527, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33141, 527, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (33142, 527, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33143, 527, 13, 2056);
INSERT INTO 'devicecapvalue' VALUES (33144, 527, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33145, 527, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33146, 527, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33147, 527, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33148, 527, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33149, 527, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33150, 527, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33151, 527, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33152, 527, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33153, 527, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33154, 527, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (33155, 527, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33156, 527, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33157, 527, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33158, 527, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33159, 527, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (33160, 528, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33161, 528, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (33162, 528, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (33163, 528, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33164, 528, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (33165, 528, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (33166, 528, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (33167, 528, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (33168, 528, 13, 2056);
INSERT INTO 'devicecapvalue' VALUES (33169, 528, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33170, 528, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33171, 528, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33172, 528, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33173, 528, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33174, 528, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33175, 528, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33176, 528, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33177, 528, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (33178, 528, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33179, 528, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33180, 528, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33181, 528, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33182, 528, 26, 40);
INSERT INTO 'devicecapvalue' VALUES (33183, 528, 30, 36);
INSERT INTO 'devicecapvalue' VALUES (33184, 528, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (33185, 528, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (33186, 528, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33187, 528, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (33188, 529, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33189, 529, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (33190, 529, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (33191, 529, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33192, 529, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (33193, 529, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (33194, 529, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (33195, 529, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (33196, 529, 13, 2056);
INSERT INTO 'devicecapvalue' VALUES (33197, 529, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33198, 529, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33199, 529, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33200, 529, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33201, 529, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33202, 529, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33203, 529, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33204, 529, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33205, 529, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (33206, 529, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33207, 529, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33208, 529, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33209, 529, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33210, 529, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (33211, 529, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (33212, 529, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33213, 529, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (33214, 530, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33215, 530, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (33216, 530, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33217, 530, 13, 2056);
INSERT INTO 'devicecapvalue' VALUES (33218, 530, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33219, 530, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33220, 530, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33221, 530, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33222, 530, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33223, 530, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33224, 530, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33225, 530, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33226, 530, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (33227, 530, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33228, 530, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33229, 530, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33230, 530, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33231, 530, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33232, 530, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (33233, 531, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33234, 531, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (33235, 531, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33236, 531, 2, 2058);
INSERT INTO 'devicecapvalue' VALUES (33237, 531, 13, 2059);
INSERT INTO 'devicecapvalue' VALUES (33238, 531, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33239, 531, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33240, 531, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33241, 531, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33242, 531, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33243, 531, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33244, 531, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33245, 531, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33246, 531, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33247, 531, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (33248, 531, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33249, 531, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33250, 531, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33251, 531, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33252, 531, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (33253, 531, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (33254, 531, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (33255, 531, 51, 1191);
INSERT INTO 'devicecapvalue' VALUES (33256, 531, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (33257, 532, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33258, 532, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (33259, 532, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33260, 532, 13, 2056);
INSERT INTO 'devicecapvalue' VALUES (33261, 532, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33262, 532, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33263, 532, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33264, 532, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33265, 532, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33266, 532, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33267, 532, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33268, 532, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33269, 532, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33270, 532, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33271, 532, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (33272, 532, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33273, 532, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33274, 532, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33275, 532, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33276, 532, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (33277, 533, 1, 106);
INSERT INTO 'capvalue' VALUES (2061, '1.4 MP');
INSERT INTO 'devicecapvalue' VALUES (33278, 533, 160, 2061);
INSERT INTO 'devicecapvalue' VALUES (33279, 533, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (33280, 533, 7, 587);
INSERT INTO 'devicecapvalue' VALUES (33281, 533, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33282, 533, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (33283, 533, 2, 1338);
INSERT INTO 'capvalue' VALUES (2062, '240x285');
INSERT INTO 'devicecapvalue' VALUES (33284, 533, 13, 2062);
INSERT INTO 'devicecapvalue' VALUES (33285, 533, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33286, 533, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33287, 533, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33288, 533, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33289, 533, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33290, 533, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33291, 533, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33292, 533, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33293, 533, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (33294, 533, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33295, 533, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33296, 533, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33297, 533, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33298, 533, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (33299, 533, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (33300, 533, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (33301, 534, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33302, 534, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (33303, 534, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (33304, 534, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (33305, 534, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33306, 534, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (33307, 534, 13, 2056);
INSERT INTO 'devicecapvalue' VALUES (33308, 534, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33309, 534, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33310, 534, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33311, 534, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33312, 534, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33313, 534, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33314, 534, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33315, 534, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33316, 534, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (33317, 534, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33318, 534, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33319, 534, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33320, 534, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33321, 534, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (33322, 534, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33323, 534, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (33324, 535, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33325, 535, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (33326, 535, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (33327, 535, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (33328, 535, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33329, 535, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (33330, 535, 13, 2056);
INSERT INTO 'devicecapvalue' VALUES (33331, 535, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33332, 535, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33333, 535, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33334, 535, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33335, 535, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33336, 535, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33337, 535, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33338, 535, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33339, 535, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (33340, 535, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33341, 535, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33342, 535, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33343, 535, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (33344, 535, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (33345, 536, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33346, 536, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (33347, 536, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33348, 536, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (33349, 536, 13, 2056);
INSERT INTO 'devicecapvalue' VALUES (33350, 536, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33351, 536, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33352, 536, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33353, 536, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33354, 536, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33355, 536, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33356, 536, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33357, 536, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33358, 536, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33359, 536, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (33360, 536, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33361, 536, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33362, 536, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33363, 536, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (33364, 536, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (33365, 537, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33366, 537, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (33367, 537, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33368, 537, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (33369, 537, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (33370, 537, 13, 2056);
INSERT INTO 'devicecapvalue' VALUES (33371, 537, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33372, 537, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33373, 537, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33374, 537, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33375, 537, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33376, 537, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33377, 537, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33378, 537, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33379, 537, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (33380, 537, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33381, 537, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33382, 537, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33383, 537, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (33384, 537, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (33385, 538, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (33386, 538, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (33387, 538, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33388, 538, 13, 2056);
INSERT INTO 'devicecapvalue' VALUES (33389, 538, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (33390, 538, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33391, 538, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33392, 538, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (33393, 538, 15, 2055);
INSERT INTO 'devicecapvalue' VALUES (33394, 538, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33395, 538, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (33396, 538, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (33397, 538, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33398, 538, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33399, 538, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (33400, 538, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33401, 538, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33402, 538, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33403, 538, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (33404, 538, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (33405, 539, 7, 2056);
INSERT INTO 'devicecapvalue' VALUES (33406, 539, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (33407, 539, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (33408, 539, 9, 743);
INSERT INTO 'devicecapvalue' VALUES (33409, 539, 10, 709);
INSERT INTO 'devicecapvalue' VALUES (33410, 539, 11, 711);
INSERT INTO 'devicecapvalue' VALUES (33411, 539, 12, 743);
INSERT INTO 'devicecapvalue' VALUES (33412, 539, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33413, 539, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (33414, 539, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (33415, 539, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33416, 539, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (33417, 539, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (33418, 539, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33419, 539, 6, 26);
INSERT INTO 'capvalue' VALUES (2063, 'MIDP/1.0');
INSERT INTO 'devicecapvalue' VALUES (33420, 539, 6, 2063);
INSERT INTO 'devicecapvalue' VALUES (33421, 539, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33422, 539, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (33423, 539, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (33424, 539, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (33425, 539, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (33426, 539, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (33427, 539, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (33428, 539, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (33429, 539, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (33430, 539, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (33431, 539, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (33432, 539, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (33433, 539, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (33434, 539, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (33435, 539, 38, 865);
INSERT INTO 'capvalue' VALUES (2064, 'audio/micro');
INSERT INTO 'devicecapvalue' VALUES (33436, 539, 39, 2064);
INSERT INTO 'devicecapvalue' VALUES (33437, 539, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (33438, 539, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (33439, 539, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (33440, 539, 41, 49);
INSERT INTO 'capvalue' VALUES (2065, 'audio/awb');
INSERT INTO 'devicecapvalue' VALUES (33441, 539, 41, 2065);
INSERT INTO 'devicecapvalue' VALUES (33442, 539, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (33443, 539, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (33444, 539, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (33445, 539, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (33446, 539, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (33447, 539, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (33448, 539, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (33449, 539, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (33450, 539, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (33451, 539, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (33452, 539, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (33453, 539, 42, 2065);
INSERT INTO 'devicecapvalue' VALUES (33454, 539, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (33455, 539, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (33456, 539, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (33457, 539, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (33458, 539, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (33459, 539, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (33460, 539, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (33461, 539, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (33462, 539, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (33463, 539, 44, 15);
INSERT INTO 'capvalue' VALUES (2066, 'width=128&height=160');
INSERT INTO 'devicecapvalue' VALUES (33464, 539, 45, 2066);
INSERT INTO 'devicecapvalue' VALUES (33465, 539, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (33466, 539, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (33467, 539, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (33468, 539, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (33469, 539, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (33470, 539, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (33471, 539, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (33472, 539, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (33473, 539, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (33474, 539, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (33475, 539, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (33476, 539, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (33477, 539, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (33478, 539, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (33479, 539, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (33480, 539, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (33481, 539, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (33482, 539, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (33483, 539, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (33484, 539, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (33485, 539, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (33486, 539, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (33487, 539, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (33488, 539, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (33489, 539, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (33490, 539, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (33491, 539, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (33492, 539, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (33493, 539, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (33494, 539, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (33495, 539, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (33496, 539, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (33497, 539, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (33498, 539, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (33499, 539, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (33500, 539, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (33501, 539, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (33502, 539, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (33503, 539, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (33504, 539, 73, 2065);
INSERT INTO 'devicecapvalue' VALUES (33505, 539, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (33506, 539, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (33507, 539, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (33508, 539, 73, 618);
INSERT INTO 'devicecapvalue' VALUES (33509, 539, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (33510, 539, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (33511, 539, 73, 53);
INSERT INTO 'devicecapvalue' VALUES (33512, 539, 73, 1444);
INSERT INTO 'devicecapvalue' VALUES (33513, 539, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (33514, 539, 48, 92);
INSERT INTO 'capvalue' VALUES (2067, '1024000');
INSERT INTO 'devicecapvalue' VALUES (33515, 539, 49, 2067);
INSERT INTO 'capvalue' VALUES (2068, 'SAMSUNG-B2100/B2100XXIC8 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (33516, 539, 53, 2068);
INSERT INTO 'devicecapvalue' VALUES (33517, 540, 56, 707);
INSERT INTO 'capvalue' VALUES (2069, '176x185');
INSERT INTO 'devicecapvalue' VALUES (33518, 540, 7, 2069);
INSERT INTO 'devicecapvalue' VALUES (33519, 540, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (33520, 540, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (33521, 540, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (33522, 540, 10, 864);
INSERT INTO 'devicecapvalue' VALUES (33523, 540, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (33524, 540, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (33525, 540, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (33526, 540, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33527, 540, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33528, 540, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33529, 540, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33530, 540, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (33531, 540, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (33532, 540, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (33533, 540, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (33534, 540, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33535, 540, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (33536, 540, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (33537, 540, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (33538, 540, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33539, 540, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33540, 540, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33541, 540, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33542, 540, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (33543, 540, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (33544, 540, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (33545, 540, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (33546, 540, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (33547, 540, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (33548, 540, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (33549, 540, 26, 30);
INSERT INTO 'devicecapvalue' VALUES (33550, 540, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (33551, 540, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (33552, 540, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (33553, 540, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (33554, 540, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (33555, 540, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (33556, 540, 39, 1049);
INSERT INTO 'devicecapvalue' VALUES (33557, 540, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (33558, 540, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (33559, 540, 40, 55);
INSERT INTO 'capvalue' VALUES (2070, 'application/ram');
INSERT INTO 'devicecapvalue' VALUES (33560, 540, 41, 2070);
INSERT INTO 'devicecapvalue' VALUES (33561, 540, 41, 56);
INSERT INTO 'capvalue' VALUES (2071, 'application/vnd.oma.drm.dcf');
INSERT INTO 'devicecapvalue' VALUES (33562, 540, 41, 2071);
INSERT INTO 'capvalue' VALUES (2072, 'application/vnd.oma.drm.roap-trigger+xml');
INSERT INTO 'devicecapvalue' VALUES (33563, 540, 41, 2072);
INSERT INTO 'devicecapvalue' VALUES (33564, 540, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (33565, 540, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (33566, 540, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (33567, 540, 41, 58);
INSERT INTO 'capvalue' VALUES (2073, 'audio/adpcm');
INSERT INTO 'devicecapvalue' VALUES (33568, 540, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (33569, 540, 41, 49);
INSERT INTO 'capvalue' VALUES (2074, 'audio/apl');
INSERT INTO 'devicecapvalue' VALUES (33570, 540, 41, 2074);
INSERT INTO 'devicecapvalue' VALUES (33571, 540, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (33572, 540, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (33573, 540, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (33574, 540, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (33575, 540, 41, 62);
INSERT INTO 'capvalue' VALUES (2075, 'audio/mp4a-latm');
INSERT INTO 'devicecapvalue' VALUES (33576, 540, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (33577, 540, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (33578, 540, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (33579, 540, 41, 986);
INSERT INTO 'capvalue' VALUES (2076, 'audio/smaf');
INSERT INTO 'devicecapvalue' VALUES (33580, 540, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (33581, 540, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (33582, 540, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (33583, 540, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (33584, 540, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (33585, 540, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (33586, 540, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (33587, 540, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (33588, 540, 41, 132);
INSERT INTO 'capvalue' VALUES (2077, 'audio/x-mmf');
INSERT INTO 'devicecapvalue' VALUES (33589, 540, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (33590, 540, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (33591, 540, 41, 618);
INSERT INTO 'capvalue' VALUES (2078, 'audio/x-pn-multirate-realaudio');
INSERT INTO 'devicecapvalue' VALUES (33592, 540, 41, 2078);
INSERT INTO 'capvalue' VALUES (2079, 'audio/x-pn-multirate-realaudio-live');
INSERT INTO 'devicecapvalue' VALUES (33593, 540, 41, 2079);
INSERT INTO 'devicecapvalue' VALUES (33594, 540, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (33595, 540, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (33596, 540, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (33597, 540, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (33598, 540, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (33599, 540, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (33600, 540, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (33601, 540, 41, 136);
INSERT INTO 'capvalue' VALUES (2080, 'video/H264');
INSERT INTO 'devicecapvalue' VALUES (33602, 540, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (33603, 540, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (33604, 540, 41, 1444);
INSERT INTO 'capvalue' VALUES (2081, 'video/vnd.rn-realmedia');
INSERT INTO 'devicecapvalue' VALUES (33605, 540, 41, 2081);
INSERT INTO 'devicecapvalue' VALUES (33606, 540, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (33607, 540, 41, 622);
INSERT INTO 'capvalue' VALUES (2082, 'video/x-pn-multimrate-realvideo');
INSERT INTO 'devicecapvalue' VALUES (33608, 540, 41, 2082);
INSERT INTO 'devicecapvalue' VALUES (33609, 540, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (33610, 540, 42, 2070);
INSERT INTO 'devicecapvalue' VALUES (33611, 540, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (33612, 540, 42, 2071);
INSERT INTO 'devicecapvalue' VALUES (33613, 540, 42, 2072);
INSERT INTO 'devicecapvalue' VALUES (33614, 540, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (33615, 540, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (33616, 540, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (33617, 540, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (33618, 540, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (33619, 540, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (33620, 540, 42, 2074);
INSERT INTO 'devicecapvalue' VALUES (33621, 540, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (33622, 540, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (33623, 540, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (33624, 540, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (33625, 540, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (33626, 540, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (33627, 540, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (33628, 540, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (33629, 540, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (33630, 540, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (33631, 540, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (33632, 540, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (33633, 540, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (33634, 540, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (33635, 540, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (33636, 540, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (33637, 540, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (33638, 540, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (33639, 540, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (33640, 540, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (33641, 540, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (33642, 540, 42, 2078);
INSERT INTO 'devicecapvalue' VALUES (33643, 540, 42, 2079);
INSERT INTO 'devicecapvalue' VALUES (33644, 540, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (33645, 540, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (33646, 540, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (33647, 540, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (33648, 540, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (33649, 540, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (33650, 540, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (33651, 540, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (33652, 540, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (33653, 540, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (33654, 540, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (33655, 540, 42, 2081);
INSERT INTO 'devicecapvalue' VALUES (33656, 540, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (33657, 540, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (33658, 540, 42, 2082);
INSERT INTO 'devicecapvalue' VALUES (33659, 540, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (33660, 540, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (33661, 540, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (33662, 540, 45, 18);
INSERT INTO 'devicecapvalue' VALUES (33663, 540, 58, 238);
INSERT INTO 'devicecapvalue' VALUES (33664, 540, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (33665, 540, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (33666, 540, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (33667, 540, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (33668, 540, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (33669, 540, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (33670, 540, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (33671, 540, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (33672, 540, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (33673, 540, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (33674, 540, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (33675, 540, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (33676, 540, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (33677, 540, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (33678, 540, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (33679, 540, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (33680, 540, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (33681, 540, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (33682, 540, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (33683, 540, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (33684, 540, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (33685, 540, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (33686, 540, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (33687, 540, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (33688, 540, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (33689, 540, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (33690, 540, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (33691, 540, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (33692, 540, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (33693, 540, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (33694, 540, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (33695, 540, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (33696, 540, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (33697, 540, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (33698, 540, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (33699, 540, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (33700, 540, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (33701, 540, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (33702, 540, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (33703, 540, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (33704, 540, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (33705, 540, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (33706, 540, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (33707, 540, 46, 910);
INSERT INTO 'capvalue' VALUES (2083, 'encoding=audio/amr ');
INSERT INTO 'devicecapvalue' VALUES (33708, 540, 115, 2083);
INSERT INTO 'devicecapvalue' VALUES (33709, 540, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (33710, 540, 118, 238);
INSERT INTO 'devicecapvalue' VALUES (33711, 540, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (33712, 540, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (33713, 540, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (33714, 540, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (33715, 540, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (33716, 540, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (33717, 540, 125, 1);
INSERT INTO 'devicecapvalue' VALUES (33718, 540, 126, 612);
INSERT INTO 'capvalue' VALUES (2084, 'file:///Photo/');
INSERT INTO 'devicecapvalue' VALUES (33719, 540, 103, 2084);
INSERT INTO 'capvalue' VALUES (2085, 'My Photo');
INSERT INTO 'devicecapvalue' VALUES (33720, 540, 104, 2085);
INSERT INTO 'capvalue' VALUES (2086, 'file:///filesystem/');
INSERT INTO 'devicecapvalue' VALUES (33721, 540, 105, 2086);
INSERT INTO 'devicecapvalue' VALUES (33722, 540, 106, 727);
INSERT INTO 'capvalue' VALUES (2087, 'My Tones');
INSERT INTO 'devicecapvalue' VALUES (33723, 540, 107, 2087);
INSERT INTO 'capvalue' VALUES (2088, 'file:///Video/');
INSERT INTO 'devicecapvalue' VALUES (33724, 540, 108, 2088);
INSERT INTO 'capvalue' VALUES (2089, 'My Video');
INSERT INTO 'devicecapvalue' VALUES (33725, 540, 109, 2089);
INSERT INTO 'devicecapvalue' VALUES (33726, 540, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (33727, 540, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (33728, 540, 62, 44);
INSERT INTO 'devicecapvalue' VALUES (33729, 540, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (33730, 540, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (33731, 540, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (33732, 540, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (33733, 540, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (33734, 540, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (33735, 540, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (33736, 540, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (33737, 540, 68, 243);
INSERT INTO 'devicecapvalue' VALUES (33738, 540, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (33739, 540, 132, 2083);
INSERT INTO 'capvalue' VALUES (2090, 'encoding=jpeg');
INSERT INTO 'devicecapvalue' VALUES (33740, 540, 133, 2090);
INSERT INTO 'devicecapvalue' VALUES (33741, 540, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (33742, 540, 116, 1444);
INSERT INTO 'devicecapvalue' VALUES (33743, 540, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (33744, 540, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (33745, 540, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (33746, 540, 136, 2090);
INSERT INTO 'devicecapvalue' VALUES (33747, 540, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (33748, 540, 72, 1682);
INSERT INTO 'devicecapvalue' VALUES (33749, 540, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (33750, 540, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (33751, 540, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (33752, 540, 47, 2070);
INSERT INTO 'devicecapvalue' VALUES (33753, 540, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (33754, 540, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (33755, 540, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (33756, 540, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (33757, 540, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (33758, 540, 47, 2074);
INSERT INTO 'devicecapvalue' VALUES (33759, 540, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (33760, 540, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (33761, 540, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (33762, 540, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (33763, 540, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (33764, 540, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (33765, 540, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (33766, 540, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (33767, 540, 47, 1049);
INSERT INTO 'devicecapvalue' VALUES (33768, 540, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (33769, 540, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (33770, 540, 47, 2078);
INSERT INTO 'devicecapvalue' VALUES (33771, 540, 47, 2079);
INSERT INTO 'devicecapvalue' VALUES (33772, 540, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (33773, 540, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (33774, 540, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (33775, 540, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (33776, 540, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (33777, 540, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (33778, 540, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (33779, 540, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (33780, 540, 47, 2081);
INSERT INTO 'devicecapvalue' VALUES (33781, 540, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (33782, 540, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (33783, 540, 47, 2082);
INSERT INTO 'devicecapvalue' VALUES (33784, 540, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (33785, 540, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (33786, 540, 48, 92);
INSERT INTO 'capvalue' VALUES (2091, '2119936');
INSERT INTO 'devicecapvalue' VALUES (33787, 540, 49, 2091);
INSERT INTO 'capvalue' VALUES (2092, 'SAMSUNG-B2700/XXHI6 SHP/VPP/R5 NetFront/3.4 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (33788, 540, 53, 2092);
INSERT INTO 'devicecapvalue' VALUES (33789, 541, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (33790, 541, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (33791, 541, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (33792, 541, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (33793, 541, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (33794, 542, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (33795, 542, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (33796, 542, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (33797, 542, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33798, 542, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (33799, 542, 26, 664);
INSERT INTO 'devicecapvalue' VALUES (33800, 542, 30, 667);
INSERT INTO 'devicecapvalue' VALUES (33801, 542, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (33802, 542, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (33803, 542, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (33804, 542, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (33805, 542, 113, 616);
INSERT INTO 'devicecapvalue' VALUES (33806, 542, 113, 54);
INSERT INTO 'devicecapvalue' VALUES (33807, 542, 113, 51);
INSERT INTO 'devicecapvalue' VALUES (33808, 542, 3, 740);
INSERT INTO 'devicecapvalue' VALUES (33809, 542, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (33810, 542, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (33811, 542, 5, 5);
INSERT INTO 'capvalue' VALUES (2093, '240x204');
INSERT INTO 'devicecapvalue' VALUES (33812, 543, 7, 2093);
INSERT INTO 'devicecapvalue' VALUES (33813, 543, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (33814, 543, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (33815, 543, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (33816, 543, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (33817, 543, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (33818, 543, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (33819, 543, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (33820, 543, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (33821, 543, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (33822, 543, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (33823, 543, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (33824, 543, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (33825, 543, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (33826, 543, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (33827, 543, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (33828, 543, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (33829, 543, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (33830, 543, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (33831, 543, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (33832, 543, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (33833, 543, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33834, 543, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (33835, 543, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (33836, 543, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (33837, 543, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (33838, 543, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (33839, 543, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (33840, 543, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (33841, 543, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (33842, 543, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (33843, 543, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (33844, 543, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (33845, 543, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (33846, 543, 32, 852);
INSERT INTO 'capvalue' VALUES (2094, 'USB');
INSERT INTO 'devicecapvalue' VALUES (33847, 543, 32, 2094);
INSERT INTO 'devicecapvalue' VALUES (33848, 543, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (33849, 543, 34, 44);
INSERT INTO 'devicecapvalue' VALUES (33850, 543, 35, 45);
INSERT INTO 'capvalue' VALUES (2095, 'SAMSUNG-GT-S3650/S3650BVII5');
INSERT INTO 'devicecapvalue' VALUES (33851, 543, 36, 2095);
INSERT INTO 'devicecapvalue' VALUES (33852, 543, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (33853, 543, 38, 2083);
INSERT INTO 'devicecapvalue' VALUES (33854, 543, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (33855, 543, 39, 1049);
INSERT INTO 'devicecapvalue' VALUES (33856, 543, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (33857, 543, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (33858, 543, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (33859, 543, 41, 2070);
INSERT INTO 'devicecapvalue' VALUES (33860, 543, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (33861, 543, 41, 2071);
INSERT INTO 'devicecapvalue' VALUES (33862, 543, 41, 2072);
INSERT INTO 'devicecapvalue' VALUES (33863, 543, 41, 965);
INSERT INTO 'devicecapvalue' VALUES (33864, 543, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (33865, 543, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (33866, 543, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (33867, 543, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (33868, 543, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (33869, 543, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (33870, 543, 41, 2074);
INSERT INTO 'devicecapvalue' VALUES (33871, 543, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (33872, 543, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (33873, 543, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (33874, 543, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (33875, 543, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (33876, 543, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (33877, 543, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (33878, 543, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (33879, 543, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (33880, 543, 41, 986);
INSERT INTO 'devicecapvalue' VALUES (33881, 543, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (33882, 543, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (33883, 543, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (33884, 543, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (33885, 543, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (33886, 543, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (33887, 543, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (33888, 543, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (33889, 543, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (33890, 543, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (33891, 543, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (33892, 543, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (33893, 543, 41, 2078);
INSERT INTO 'devicecapvalue' VALUES (33894, 543, 41, 2079);
INSERT INTO 'devicecapvalue' VALUES (33895, 543, 41, 1280);
INSERT INTO 'capvalue' VALUES (2096, 'audio/x-smaf');
INSERT INTO 'devicecapvalue' VALUES (33896, 543, 41, 2096);
INSERT INTO 'devicecapvalue' VALUES (33897, 543, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (33898, 543, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (33899, 543, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (33900, 543, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (33901, 543, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (33902, 543, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (33903, 543, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (33904, 543, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (33905, 543, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (33906, 543, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (33907, 543, 41, 2081);
INSERT INTO 'devicecapvalue' VALUES (33908, 543, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (33909, 543, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (33910, 543, 41, 2082);
INSERT INTO 'devicecapvalue' VALUES (33911, 543, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (33912, 543, 42, 2070);
INSERT INTO 'devicecapvalue' VALUES (33913, 543, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (33914, 543, 42, 2071);
INSERT INTO 'devicecapvalue' VALUES (33915, 543, 42, 2072);
INSERT INTO 'devicecapvalue' VALUES (33916, 543, 42, 965);
INSERT INTO 'devicecapvalue' VALUES (33917, 543, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (33918, 543, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (33919, 543, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (33920, 543, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (33921, 543, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (33922, 543, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (33923, 543, 42, 2074);
INSERT INTO 'devicecapvalue' VALUES (33924, 543, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (33925, 543, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (33926, 543, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (33927, 543, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (33928, 543, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (33929, 543, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (33930, 543, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (33931, 543, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (33932, 543, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (33933, 543, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (33934, 543, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (33935, 543, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (33936, 543, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (33937, 543, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (33938, 543, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (33939, 543, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (33940, 543, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (33941, 543, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (33942, 543, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (33943, 543, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (33944, 543, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (33945, 543, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (33946, 543, 42, 2078);
INSERT INTO 'devicecapvalue' VALUES (33947, 543, 42, 2079);
INSERT INTO 'devicecapvalue' VALUES (33948, 543, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (33949, 543, 42, 2096);
INSERT INTO 'devicecapvalue' VALUES (33950, 543, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (33951, 543, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (33952, 543, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (33953, 543, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (33954, 543, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (33955, 543, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (33956, 543, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (33957, 543, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (33958, 543, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (33959, 543, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (33960, 543, 42, 2081);
INSERT INTO 'devicecapvalue' VALUES (33961, 543, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (33962, 543, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (33963, 543, 42, 2082);
INSERT INTO 'devicecapvalue' VALUES (33964, 543, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (33965, 543, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (33966, 543, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (33967, 543, 45, 2090);
INSERT INTO 'devicecapvalue' VALUES (33968, 543, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (33969, 543, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (33970, 543, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (33971, 543, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (33972, 543, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (33973, 543, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (33974, 543, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (33975, 543, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (33976, 543, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (33977, 543, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (33978, 543, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (33979, 543, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (33980, 543, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (33981, 543, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (33982, 543, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (33983, 543, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (33984, 543, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (33985, 543, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (33986, 543, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (33987, 543, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (33988, 543, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (33989, 543, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (33990, 543, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (33991, 543, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (33992, 543, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (33993, 543, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (33994, 543, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (33995, 543, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (33996, 543, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (33997, 543, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (33998, 543, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (33999, 543, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (34000, 543, 46, 906);
INSERT INTO 'capvalue' VALUES (2097, 'microedition.payment.version');
INSERT INTO 'devicecapvalue' VALUES (34001, 543, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (34002, 543, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (34003, 543, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (34004, 543, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (34005, 543, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (34006, 543, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (34007, 543, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (34008, 543, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (34009, 543, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (34010, 543, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (34011, 543, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (34012, 543, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (34013, 543, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (34014, 543, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (34015, 543, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (34016, 543, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (34017, 543, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (34018, 543, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (34019, 543, 47, 2070);
INSERT INTO 'devicecapvalue' VALUES (34020, 543, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (34021, 543, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (34022, 543, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (34023, 543, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (34024, 543, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (34025, 543, 47, 2074);
INSERT INTO 'devicecapvalue' VALUES (34026, 543, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (34027, 543, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (34028, 543, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (34029, 543, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (34030, 543, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (34031, 543, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (34032, 543, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (34033, 543, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (34034, 543, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (34035, 543, 47, 1049);
INSERT INTO 'devicecapvalue' VALUES (34036, 543, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (34037, 543, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (34038, 543, 47, 2078);
INSERT INTO 'devicecapvalue' VALUES (34039, 543, 47, 2079);
INSERT INTO 'devicecapvalue' VALUES (34040, 543, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (34041, 543, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (34042, 543, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (34043, 543, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (34044, 543, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (34045, 543, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (34046, 543, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (34047, 543, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (34048, 543, 47, 2081);
INSERT INTO 'devicecapvalue' VALUES (34049, 543, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (34050, 543, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (34051, 543, 47, 2082);
INSERT INTO 'devicecapvalue' VALUES (34052, 543, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (34053, 543, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (34054, 543, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (34055, 543, 49, 1031);
INSERT INTO 'capvalue' VALUES (2098, 'SAMSUNG-GT-S3650-ORANGE/S3650BVII5 SHP/VPP/R5 Jasmine/1.0 Ne');
INSERT INTO 'devicecapvalue' VALUES (34056, 543, 53, 2098);
INSERT INTO 'devicecapvalue' VALUES (34057, 544, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (34058, 544, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (34059, 544, 7, 1150);
INSERT INTO 'devicecapvalue' VALUES (34060, 544, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34061, 544, 13, 859);
INSERT INTO 'capvalue' VALUES (2099, '262144');
INSERT INTO 'devicecapvalue' VALUES (34062, 544, 76, 2099);
INSERT INTO 'devicecapvalue' VALUES (34063, 544, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34064, 544, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (34065, 544, 6, 27);
INSERT INTO 'capvalue' VALUES (2100, '174080');
INSERT INTO 'devicecapvalue' VALUES (34066, 544, 50, 2100);
INSERT INTO 'cap' VALUES (232, 'MenuBarHeight', 1);
INSERT INTO 'devicecapvalue' VALUES (34067, 544, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34068, 544, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34069, 544, 231, 1341);
INSERT INTO 'capvalue' VALUES (2101, 'CIS');
INSERT INTO 'devicecapvalue' VALUES (34070, 544, 156, 2101);
INSERT INTO 'devicecapvalue' VALUES (34071, 544, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (34072, 544, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (34073, 544, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (34074, 544, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (34075, 544, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (34076, 545, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (34077, 545, 7, 1150);
INSERT INTO 'devicecapvalue' VALUES (34078, 545, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34079, 545, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (34080, 545, 76, 2099);
INSERT INTO 'devicecapvalue' VALUES (34081, 545, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34082, 545, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (34083, 545, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34084, 545, 50, 2100);
INSERT INTO 'devicecapvalue' VALUES (34085, 545, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34086, 545, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34087, 545, 231, 1341);
INSERT INTO 'devicecapvalue' VALUES (34088, 545, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (34089, 545, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (34090, 545, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (34091, 545, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (34092, 545, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (34093, 546, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (34094, 546, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (34095, 546, 7, 1150);
INSERT INTO 'devicecapvalue' VALUES (34096, 546, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34097, 546, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (34098, 546, 76, 2099);
INSERT INTO 'devicecapvalue' VALUES (34099, 546, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34100, 546, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (34101, 546, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34102, 546, 50, 2100);
INSERT INTO 'devicecapvalue' VALUES (34103, 546, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34104, 546, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34105, 546, 231, 1341);
INSERT INTO 'devicecapvalue' VALUES (34106, 546, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (34107, 546, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (34108, 546, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (34109, 546, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (34110, 546, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (34111, 547, 1, 1);
INSERT INTO 'capvalue' VALUES (2102, 'inaccessibleFirstRow');
INSERT INTO 'devicecapvalue' VALUES (34112, 547, 74, 2102);
INSERT INTO 'capvalue' VALUES (2103, '128x140');
INSERT INTO 'devicecapvalue' VALUES (34113, 547, 7, 2103);
INSERT INTO 'devicecapvalue' VALUES (34114, 547, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34115, 547, 13, 1100);
INSERT INTO 'capvalue' VALUES (2104, '184320');
INSERT INTO 'devicecapvalue' VALUES (34116, 547, 76, 2104);
INSERT INTO 'devicecapvalue' VALUES (34117, 547, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34118, 547, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (34119, 547, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34120, 547, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (34121, 547, 232, 603);
INSERT INTO 'devicecapvalue' VALUES (34122, 547, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34123, 547, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (34124, 547, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (34125, 547, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (34126, 547, 5, 107);
INSERT INTO 'capvalue' VALUES (2105, 'ma3');
INSERT INTO 'devicecapvalue' VALUES (34127, 547, 51, 2105);
INSERT INTO 'capvalue' VALUES (2106, 'SEC-SGHE105-E15UVWH3-NW.Browser3.01');
INSERT INTO 'devicecapvalue' VALUES (34128, 547, 53, 2106);
INSERT INTO 'devicecapvalue' VALUES (34129, 548, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34130, 548, 74, 653);
INSERT INTO 'capvalue' VALUES (2107, '128x144');
INSERT INTO 'devicecapvalue' VALUES (34131, 548, 7, 2107);
INSERT INTO 'devicecapvalue' VALUES (34132, 548, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34133, 548, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (34134, 548, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (34135, 548, 15, 96);
INSERT INTO 'capvalue' VALUES (2108, 'CLDC/1.0.4');
INSERT INTO 'devicecapvalue' VALUES (34136, 548, 16, 2108);
INSERT INTO 'devicecapvalue' VALUES (34137, 548, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34138, 548, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (34139, 548, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34140, 548, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34141, 548, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (34142, 548, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (34143, 548, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (34144, 548, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (34145, 548, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (34146, 548, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (34147, 549, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34148, 549, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (34149, 549, 7, 2107);
INSERT INTO 'devicecapvalue' VALUES (34150, 549, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34151, 549, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (34152, 549, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (34153, 549, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34154, 549, 16, 2108);
INSERT INTO 'devicecapvalue' VALUES (34155, 549, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34156, 549, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (34157, 549, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34158, 549, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34159, 549, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (34160, 549, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (34161, 549, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (34162, 549, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (34163, 549, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (34164, 549, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (34165, 550, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34166, 550, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (34167, 550, 7, 2107);
INSERT INTO 'devicecapvalue' VALUES (34168, 550, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34169, 550, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (34170, 550, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (34171, 550, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34172, 550, 16, 2108);
INSERT INTO 'devicecapvalue' VALUES (34173, 550, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34174, 550, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (34175, 550, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34176, 550, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34177, 550, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (34178, 550, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (34179, 550, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (34180, 550, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (34181, 550, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (34182, 550, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (34183, 551, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34184, 551, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (34185, 551, 7, 1150);
INSERT INTO 'devicecapvalue' VALUES (34186, 551, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34187, 551, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (34188, 551, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (34189, 551, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34190, 551, 16, 2108);
INSERT INTO 'devicecapvalue' VALUES (34191, 551, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34192, 551, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (34193, 551, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34194, 551, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34195, 551, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (34196, 551, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (34197, 551, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (34198, 551, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (34199, 551, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (34200, 551, 51, 1496);
INSERT INTO 'capvalue' VALUES (2109, 'SAMSUNG-SGH-E380/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (34201, 551, 53, 2109);
INSERT INTO 'devicecapvalue' VALUES (34202, 552, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34203, 552, 74, 653);
INSERT INTO 'capvalue' VALUES (2110, '128x112');
INSERT INTO 'devicecapvalue' VALUES (34204, 552, 7, 2110);
INSERT INTO 'devicecapvalue' VALUES (34205, 552, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34206, 552, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (34207, 552, 76, 2099);
INSERT INTO 'devicecapvalue' VALUES (34208, 552, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34209, 552, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (34210, 552, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34211, 552, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (34212, 552, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34213, 552, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34214, 552, 231, 1341);
INSERT INTO 'devicecapvalue' VALUES (34215, 552, 156, 2101);
INSERT INTO 'devicecapvalue' VALUES (34216, 552, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (34217, 552, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (34218, 552, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (34219, 552, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (34220, 552, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (34221, 553, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34222, 553, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (34223, 553, 74, 2102);
INSERT INTO 'devicecapvalue' VALUES (34224, 553, 7, 2107);
INSERT INTO 'devicecapvalue' VALUES (34225, 553, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34226, 553, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (34227, 553, 76, 2099);
INSERT INTO 'devicecapvalue' VALUES (34228, 553, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34229, 553, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (34230, 553, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34231, 553, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (34232, 553, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34233, 553, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34234, 553, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (34235, 553, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (34236, 553, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (34237, 553, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (34238, 553, 51, 2105);
INSERT INTO 'devicecapvalue' VALUES (34239, 554, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34240, 554, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (34241, 554, 74, 2102);
INSERT INTO 'devicecapvalue' VALUES (34242, 554, 7, 2107);
INSERT INTO 'devicecapvalue' VALUES (34243, 554, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34244, 554, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (34245, 554, 76, 2099);
INSERT INTO 'devicecapvalue' VALUES (34246, 554, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34247, 554, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (34248, 554, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34249, 554, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (34250, 554, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34251, 554, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34252, 554, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (34253, 554, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (34254, 554, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (34255, 554, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (34256, 554, 51, 2105);
INSERT INTO 'capvalue' VALUES (2111, 'SEC-SGHE715');
INSERT INTO 'devicecapvalue' VALUES (34257, 554, 53, 2111);
INSERT INTO 'devicecapvalue' VALUES (34258, 555, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34259, 555, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (34260, 555, 7, 2107);
INSERT INTO 'devicecapvalue' VALUES (34261, 555, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34262, 555, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (34263, 555, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (34264, 555, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34265, 555, 16, 2108);
INSERT INTO 'devicecapvalue' VALUES (34266, 555, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34267, 555, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (34268, 555, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34269, 555, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34270, 555, 231, 1341);
INSERT INTO 'devicecapvalue' VALUES (34271, 555, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (34272, 555, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (34273, 555, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (34274, 555, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (34275, 555, 51, 1349);
INSERT INTO 'capvalue' VALUES (2112, '240x279');
INSERT INTO 'devicecapvalue' VALUES (34276, 556, 7, 2112);
INSERT INTO 'devicecapvalue' VALUES (34277, 556, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (34278, 556, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (34279, 556, 9, 864);
INSERT INTO 'devicecapvalue' VALUES (34280, 556, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (34281, 556, 11, 864);
INSERT INTO 'devicecapvalue' VALUES (34282, 556, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (34283, 556, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (34284, 556, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (34285, 556, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (34286, 556, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (34287, 556, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (34288, 556, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (34289, 556, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (34290, 556, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (34291, 556, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (34292, 556, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (34293, 556, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (34294, 556, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (34295, 556, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (34296, 556, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (34297, 556, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34298, 556, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (34299, 556, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (34300, 556, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (34301, 556, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (34302, 556, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (34303, 556, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (34304, 556, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (34305, 556, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (34306, 556, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (34307, 556, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (34308, 556, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (34309, 556, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (34310, 556, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (34311, 556, 32, 612);
INSERT INTO 'devicecapvalue' VALUES (34312, 556, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (34313, 556, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (34314, 556, 35, 45);
INSERT INTO 'devicecapvalue' VALUES (34315, 556, 36, 243);
INSERT INTO 'devicecapvalue' VALUES (34316, 556, 37, 47);
INSERT INTO 'devicecapvalue' VALUES (34317, 556, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (34318, 556, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (34319, 556, 39, 136);
INSERT INTO 'devicecapvalue' VALUES (34320, 556, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (34321, 556, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (34322, 556, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (34323, 556, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (34324, 556, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (34325, 556, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (34326, 556, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (34327, 556, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (34328, 556, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (34329, 556, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (34330, 556, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (34331, 556, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (34332, 556, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (34333, 556, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (34334, 556, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (34335, 556, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (34336, 556, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (34337, 556, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (34338, 556, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (34339, 556, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (34340, 556, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (34341, 556, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (34342, 556, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (34343, 556, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (34344, 556, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (34345, 556, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (34346, 556, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (34347, 556, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (34348, 556, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (34349, 556, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (34350, 556, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (34351, 556, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (34352, 556, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (34353, 556, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (34354, 556, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (34355, 556, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (34356, 556, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (34357, 556, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (34358, 556, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (34359, 556, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (34360, 556, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (34361, 556, 44, 15);
INSERT INTO 'capvalue' VALUES (2113, 'encoding=video/H263');
INSERT INTO 'devicecapvalue' VALUES (34362, 556, 45, 2113);
INSERT INTO 'devicecapvalue' VALUES (34363, 556, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (34364, 556, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (34365, 556, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (34366, 556, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (34367, 556, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (34368, 556, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (34369, 556, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (34370, 556, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (34371, 556, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (34372, 556, 49, 1031);
INSERT INTO 'capvalue' VALUES (2114, 'SAMSUNG-SGH-F330/F330PMHB1 SHP/VPP/R5 NetFront/3.4 SMM-MMS/1');
INSERT INTO 'devicecapvalue' VALUES (34373, 556, 53, 2114);
INSERT INTO 'devicecapvalue' VALUES (34374, 557, 7, 2112);
INSERT INTO 'devicecapvalue' VALUES (34375, 557, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (34376, 557, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (34377, 557, 9, 864);
INSERT INTO 'devicecapvalue' VALUES (34378, 557, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (34379, 557, 11, 864);
INSERT INTO 'devicecapvalue' VALUES (34380, 557, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (34381, 557, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (34382, 557, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (34383, 557, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (34384, 557, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (34385, 557, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (34386, 557, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (34387, 557, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (34388, 557, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (34389, 557, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (34390, 557, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (34391, 557, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (34392, 557, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (34393, 557, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (34394, 557, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (34395, 557, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (34396, 557, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34397, 557, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (34398, 557, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (34399, 557, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (34400, 557, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (34401, 557, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (34402, 557, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (34403, 557, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (34404, 557, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (34405, 557, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (34406, 557, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (34407, 557, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (34408, 557, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (34409, 557, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (34410, 557, 32, 612);
INSERT INTO 'devicecapvalue' VALUES (34411, 557, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (34412, 557, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (34413, 557, 35, 45);
INSERT INTO 'capvalue' VALUES (2115, 'SAMSUNG-SGH-F400');
INSERT INTO 'devicecapvalue' VALUES (34414, 557, 36, 2115);
INSERT INTO 'devicecapvalue' VALUES (34415, 557, 37, 47);
INSERT INTO 'devicecapvalue' VALUES (34416, 557, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (34417, 557, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (34418, 557, 39, 136);
INSERT INTO 'devicecapvalue' VALUES (34419, 557, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (34420, 557, 41, 965);
INSERT INTO 'devicecapvalue' VALUES (34421, 557, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (34422, 557, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (34423, 557, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (34424, 557, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (34425, 557, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (34426, 557, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (34427, 557, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (34428, 557, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (34429, 557, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (34430, 557, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (34431, 557, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (34432, 557, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (34433, 557, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (34434, 557, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (34435, 557, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (34436, 557, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (34437, 557, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (34438, 557, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (34439, 557, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (34440, 557, 42, 965);
INSERT INTO 'devicecapvalue' VALUES (34441, 557, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (34442, 557, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (34443, 557, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (34444, 557, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (34445, 557, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (34446, 557, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (34447, 557, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (34448, 557, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (34449, 557, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (34450, 557, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (34451, 557, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (34452, 557, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (34453, 557, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (34454, 557, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (34455, 557, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (34456, 557, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (34457, 557, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (34458, 557, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (34459, 557, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (34460, 557, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (34461, 557, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (34462, 557, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (34463, 557, 45, 2113);
INSERT INTO 'devicecapvalue' VALUES (34464, 557, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (34465, 557, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (34466, 557, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (34467, 557, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (34468, 557, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (34469, 557, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (34470, 557, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (34471, 557, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (34472, 557, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (34473, 557, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (34474, 557, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (34475, 557, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (34476, 557, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (34477, 557, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (34478, 557, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (34479, 557, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (34480, 557, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (34481, 557, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (34482, 557, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (34483, 557, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (34484, 557, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (34485, 557, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (34486, 557, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (34487, 557, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (34488, 557, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (34489, 557, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (34490, 557, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (34491, 557, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (34492, 557, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (34493, 557, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (34494, 557, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (34495, 557, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (34496, 557, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (34497, 557, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (34498, 557, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (34499, 557, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (34500, 557, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (34501, 557, 49, 1031);
INSERT INTO 'capvalue' VALUES (2116, 'SAMSUNG-SGH-F400/1.0 SHP/VPP/R5 NetFront/3.4 SMM-MMS/1.2.0 p');
INSERT INTO 'devicecapvalue' VALUES (34502, 557, 53, 2116);
INSERT INTO 'devicecapvalue' VALUES (34503, 558, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34504, 558, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (34505, 558, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (34506, 558, 4, 8);
INSERT INTO 'devicecapvalue' VALUES (34507, 558, 5, 7);
INSERT INTO 'capvalue' VALUES (2117, '240x262');
INSERT INTO 'devicecapvalue' VALUES (34508, 559, 7, 2117);
INSERT INTO 'devicecapvalue' VALUES (34509, 559, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (34510, 559, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (34511, 559, 9, 603);
INSERT INTO 'devicecapvalue' VALUES (34512, 559, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (34513, 559, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (34514, 559, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (34515, 559, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (34516, 559, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (34517, 559, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (34518, 559, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (34519, 559, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (34520, 559, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (34521, 559, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (34522, 559, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (34523, 559, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (34524, 559, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (34525, 559, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (34526, 559, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (34527, 559, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (34528, 559, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (34529, 559, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (34530, 559, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (34531, 559, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (34532, 559, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (34533, 559, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (34534, 559, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (34535, 559, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (34536, 559, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (34537, 559, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (34538, 559, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (34539, 559, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (34540, 559, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (34541, 559, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (34542, 559, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (34543, 559, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (34544, 559, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (34545, 559, 32, 852);
INSERT INTO 'devicecapvalue' VALUES (34546, 559, 32, 2094);
INSERT INTO 'devicecapvalue' VALUES (34547, 559, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (34548, 559, 34, 44);
INSERT INTO 'devicecapvalue' VALUES (34549, 559, 35, 45);
INSERT INTO 'capvalue' VALUES (2118, 'GT-S5230C/S5230ZHIF4');
INSERT INTO 'devicecapvalue' VALUES (34550, 559, 36, 2118);
INSERT INTO 'devicecapvalue' VALUES (34551, 559, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (34552, 559, 38, 2083);
INSERT INTO 'devicecapvalue' VALUES (34553, 559, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (34554, 559, 39, 1049);
INSERT INTO 'devicecapvalue' VALUES (34555, 559, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (34556, 559, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (34557, 559, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (34558, 559, 41, 2070);
INSERT INTO 'devicecapvalue' VALUES (34559, 559, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (34560, 559, 41, 2071);
INSERT INTO 'devicecapvalue' VALUES (34561, 559, 41, 2072);
INSERT INTO 'devicecapvalue' VALUES (34562, 559, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (34563, 559, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (34564, 559, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (34565, 559, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (34566, 559, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (34567, 559, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (34568, 559, 41, 2074);
INSERT INTO 'devicecapvalue' VALUES (34569, 559, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (34570, 559, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (34571, 559, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (34572, 559, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (34573, 559, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (34574, 559, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (34575, 559, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (34576, 559, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (34577, 559, 41, 986);
INSERT INTO 'devicecapvalue' VALUES (34578, 559, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (34579, 559, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (34580, 559, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (34581, 559, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (34582, 559, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (34583, 559, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (34584, 559, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (34585, 559, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (34586, 559, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (34587, 559, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (34588, 559, 41, 2078);
INSERT INTO 'devicecapvalue' VALUES (34589, 559, 41, 2079);
INSERT INTO 'devicecapvalue' VALUES (34590, 559, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (34591, 559, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (34592, 559, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (34593, 559, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (34594, 559, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (34595, 559, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (34596, 559, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (34597, 559, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (34598, 559, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (34599, 559, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (34600, 559, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (34601, 559, 41, 2081);
INSERT INTO 'devicecapvalue' VALUES (34602, 559, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (34603, 559, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (34604, 559, 41, 2082);
INSERT INTO 'devicecapvalue' VALUES (34605, 559, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (34606, 559, 42, 2070);
INSERT INTO 'devicecapvalue' VALUES (34607, 559, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (34608, 559, 42, 2071);
INSERT INTO 'devicecapvalue' VALUES (34609, 559, 42, 2072);
INSERT INTO 'devicecapvalue' VALUES (34610, 559, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (34611, 559, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (34612, 559, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (34613, 559, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (34614, 559, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (34615, 559, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (34616, 559, 42, 2074);
INSERT INTO 'devicecapvalue' VALUES (34617, 559, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (34618, 559, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (34619, 559, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (34620, 559, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (34621, 559, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (34622, 559, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (34623, 559, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (34624, 559, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (34625, 559, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (34626, 559, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (34627, 559, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (34628, 559, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (34629, 559, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (34630, 559, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (34631, 559, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (34632, 559, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (34633, 559, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (34634, 559, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (34635, 559, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (34636, 559, 42, 2078);
INSERT INTO 'devicecapvalue' VALUES (34637, 559, 42, 2079);
INSERT INTO 'devicecapvalue' VALUES (34638, 559, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (34639, 559, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (34640, 559, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (34641, 559, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (34642, 559, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (34643, 559, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (34644, 559, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (34645, 559, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (34646, 559, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (34647, 559, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (34648, 559, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (34649, 559, 42, 2081);
INSERT INTO 'devicecapvalue' VALUES (34650, 559, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (34651, 559, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (34652, 559, 42, 2082);
INSERT INTO 'devicecapvalue' VALUES (34653, 559, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (34654, 559, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (34655, 559, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (34656, 559, 45, 2090);
INSERT INTO 'devicecapvalue' VALUES (34657, 559, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (34658, 559, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (34659, 559, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (34660, 559, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (34661, 559, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (34662, 559, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (34663, 559, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (34664, 559, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (34665, 559, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (34666, 559, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (34667, 559, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (34668, 559, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (34669, 559, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (34670, 559, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (34671, 559, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (34672, 559, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (34673, 559, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (34674, 559, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (34675, 559, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (34676, 559, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (34677, 559, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (34678, 559, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (34679, 559, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (34680, 559, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (34681, 559, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (34682, 559, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (34683, 559, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (34684, 559, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (34685, 559, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (34686, 559, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (34687, 559, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (34688, 559, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (34689, 559, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (34690, 559, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (34691, 559, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (34692, 559, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (34693, 559, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (34694, 559, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (34695, 559, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (34696, 559, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (34697, 559, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (34698, 559, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (34699, 559, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (34700, 559, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (34701, 559, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (34702, 559, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (34703, 559, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (34704, 559, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (34705, 559, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (34706, 559, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (34707, 559, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (34708, 559, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (34709, 559, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (34710, 559, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (34711, 559, 47, 2070);
INSERT INTO 'devicecapvalue' VALUES (34712, 559, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (34713, 559, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (34714, 559, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (34715, 559, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (34716, 559, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (34717, 559, 47, 2074);
INSERT INTO 'devicecapvalue' VALUES (34718, 559, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (34719, 559, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (34720, 559, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (34721, 559, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (34722, 559, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (34723, 559, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (34724, 559, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (34725, 559, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (34726, 559, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (34727, 559, 47, 1049);
INSERT INTO 'devicecapvalue' VALUES (34728, 559, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (34729, 559, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (34730, 559, 47, 2078);
INSERT INTO 'devicecapvalue' VALUES (34731, 559, 47, 2079);
INSERT INTO 'devicecapvalue' VALUES (34732, 559, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (34733, 559, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (34734, 559, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (34735, 559, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (34736, 559, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (34737, 559, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (34738, 559, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (34739, 559, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (34740, 559, 47, 2081);
INSERT INTO 'devicecapvalue' VALUES (34741, 559, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (34742, 559, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (34743, 559, 47, 2082);
INSERT INTO 'devicecapvalue' VALUES (34744, 559, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (34745, 559, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (34746, 559, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (34747, 559, 49, 1031);
INSERT INTO 'capvalue' VALUES (2119, 'SAMSUNG-GT-S5230C/1.0 SHP/R5 Release/02.01.2009 Browser/NetF');
INSERT INTO 'devicecapvalue' VALUES (34748, 559, 53, 2119);
INSERT INTO 'devicecapvalue' VALUES (34749, 560, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34750, 560, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (34751, 560, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (34752, 560, 4, 7);
INSERT INTO 'devicecapvalue' VALUES (34753, 560, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (34754, 561, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34755, 561, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (34756, 561, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (34757, 561, 5, 646);
INSERT INTO 'devicecapvalue' VALUES (34758, 562, 7, 863);
INSERT INTO 'devicecapvalue' VALUES (34759, 562, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (34760, 562, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (34761, 562, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (34762, 562, 10, 864);
INSERT INTO 'devicecapvalue' VALUES (34763, 562, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (34764, 562, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (34765, 562, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (34766, 562, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (34767, 562, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (34768, 562, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (34769, 562, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (34770, 562, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (34771, 562, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (34772, 562, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (34773, 562, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (34774, 562, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (34775, 562, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (34776, 562, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (34777, 562, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (34778, 562, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (34779, 562, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34780, 562, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (34781, 562, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (34782, 562, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (34783, 562, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (34784, 562, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (34785, 562, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (34786, 562, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (34787, 562, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (34788, 562, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (34789, 562, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (34790, 562, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (34791, 562, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (34792, 562, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (34793, 562, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (34794, 562, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (34795, 562, 39, 136);
INSERT INTO 'devicecapvalue' VALUES (34796, 562, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (34797, 562, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (34798, 562, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (34799, 562, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (34800, 562, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (34801, 562, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (34802, 562, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (34803, 562, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (34804, 562, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (34805, 562, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (34806, 562, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (34807, 562, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (34808, 562, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (34809, 562, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (34810, 562, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (34811, 562, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (34812, 562, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (34813, 562, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (34814, 562, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (34815, 562, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (34816, 562, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (34817, 562, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (34818, 562, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (34819, 562, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (34820, 562, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (34821, 562, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (34822, 562, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (34823, 562, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (34824, 562, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (34825, 562, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (34826, 562, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (34827, 562, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (34828, 562, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (34829, 562, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (34830, 562, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (34831, 562, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (34832, 562, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (34833, 562, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (34834, 562, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (34835, 562, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (34836, 562, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (34837, 562, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (34838, 562, 45, 2113);
INSERT INTO 'devicecapvalue' VALUES (34839, 562, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (34840, 562, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (34841, 562, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (34842, 562, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (34843, 562, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (34844, 562, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (34845, 562, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (34846, 562, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (34847, 562, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (34848, 562, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (34849, 562, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (34850, 562, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (34851, 562, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (34852, 562, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (34853, 562, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (34854, 562, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (34855, 562, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (34856, 562, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (34857, 562, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (34858, 562, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (34859, 562, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (34860, 562, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (34861, 562, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (34862, 562, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (34863, 562, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (34864, 562, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (34865, 562, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (34866, 562, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (34867, 562, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (34868, 562, 49, 1031);
INSERT INTO 'capvalue' VALUES (2120, 'SAMSUNG-SGH-L760/BKHD1 SHP/VPP/R5 NetFront/3.4 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (34869, 562, 53, 2120);
INSERT INTO 'devicecapvalue' VALUES (34870, 563, 1, 625);
INSERT INTO 'devicecapvalue' VALUES (34871, 563, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (34872, 563, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (34873, 563, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (34874, 563, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (34875, 564, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (34876, 564, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (34877, 564, 74, 2102);
INSERT INTO 'devicecapvalue' VALUES (34878, 564, 7, 2107);
INSERT INTO 'devicecapvalue' VALUES (34879, 564, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34880, 564, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (34881, 564, 76, 2104);
INSERT INTO 'devicecapvalue' VALUES (34882, 564, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34883, 564, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (34884, 564, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34885, 564, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (34886, 564, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (34887, 564, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34888, 564, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (34889, 564, 156, 2101);
INSERT INTO 'devicecapvalue' VALUES (34890, 564, 156, 1024);
INSERT INTO 'capvalue' VALUES (2121, 'South East Asia');
INSERT INTO 'devicecapvalue' VALUES (34891, 564, 156, 2121);
INSERT INTO 'devicecapvalue' VALUES (34892, 564, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (34893, 564, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (34894, 564, 51, 2105);
INSERT INTO 'devicecapvalue' VALUES (34895, 565, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (34896, 565, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (34897, 565, 7, 2059);
INSERT INTO 'devicecapvalue' VALUES (34898, 565, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34899, 565, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (34900, 565, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (34901, 565, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34902, 565, 16, 2108);
INSERT INTO 'devicecapvalue' VALUES (34903, 565, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34904, 565, 50, 2100);
INSERT INTO 'devicecapvalue' VALUES (34905, 565, 232, 955);
INSERT INTO 'devicecapvalue' VALUES (34906, 565, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34907, 565, 231, 1341);
INSERT INTO 'devicecapvalue' VALUES (34908, 565, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (34909, 565, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (34910, 565, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (34911, 565, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (34912, 565, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (34913, 566, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (34914, 566, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (34915, 566, 7, 2059);
INSERT INTO 'devicecapvalue' VALUES (34916, 566, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (34917, 566, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (34918, 566, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (34919, 566, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (34920, 566, 16, 2108);
INSERT INTO 'devicecapvalue' VALUES (34921, 566, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (34922, 566, 50, 2100);
INSERT INTO 'devicecapvalue' VALUES (34923, 566, 232, 955);
INSERT INTO 'devicecapvalue' VALUES (34924, 566, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (34925, 566, 231, 1341);
INSERT INTO 'devicecapvalue' VALUES (34926, 566, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (34927, 566, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (34928, 566, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (34929, 566, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (34930, 566, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (34931, 567, 7, 2093);
INSERT INTO 'devicecapvalue' VALUES (34932, 567, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (34933, 567, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (34934, 567, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (34935, 567, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (34936, 567, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (34937, 567, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (34938, 567, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (34939, 567, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (34940, 567, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (34941, 567, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (34942, 567, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (34943, 567, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (34944, 567, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (34945, 567, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (34946, 567, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (34947, 567, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (34948, 567, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (34949, 567, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (34950, 567, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (34951, 567, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (34952, 567, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (34953, 567, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (34954, 567, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (34955, 567, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (34956, 567, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (34957, 567, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (34958, 567, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (34959, 567, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (34960, 567, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (34961, 567, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (34962, 567, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (34963, 567, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (34964, 567, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (34965, 567, 32, 852);
INSERT INTO 'devicecapvalue' VALUES (34966, 567, 32, 2094);
INSERT INTO 'devicecapvalue' VALUES (34967, 567, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (34968, 567, 34, 44);
INSERT INTO 'devicecapvalue' VALUES (34969, 567, 35, 45);
INSERT INTO 'devicecapvalue' VALUES (34970, 567, 36, 2095);
INSERT INTO 'devicecapvalue' VALUES (34971, 567, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (34972, 567, 38, 2083);
INSERT INTO 'devicecapvalue' VALUES (34973, 567, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (34974, 567, 39, 1049);
INSERT INTO 'devicecapvalue' VALUES (34975, 567, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (34976, 567, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (34977, 567, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (34978, 567, 41, 2070);
INSERT INTO 'devicecapvalue' VALUES (34979, 567, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (34980, 567, 41, 2071);
INSERT INTO 'devicecapvalue' VALUES (34981, 567, 41, 2072);
INSERT INTO 'devicecapvalue' VALUES (34982, 567, 41, 965);
INSERT INTO 'devicecapvalue' VALUES (34983, 567, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (34984, 567, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (34985, 567, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (34986, 567, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (34987, 567, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (34988, 567, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (34989, 567, 41, 2074);
INSERT INTO 'devicecapvalue' VALUES (34990, 567, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (34991, 567, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (34992, 567, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (34993, 567, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (34994, 567, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (34995, 567, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (34996, 567, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (34997, 567, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (34998, 567, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (34999, 567, 41, 986);
INSERT INTO 'devicecapvalue' VALUES (35000, 567, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (35001, 567, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (35002, 567, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (35003, 567, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (35004, 567, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (35005, 567, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (35006, 567, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (35007, 567, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (35008, 567, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (35009, 567, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (35010, 567, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (35011, 567, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (35012, 567, 41, 2078);
INSERT INTO 'devicecapvalue' VALUES (35013, 567, 41, 2079);
INSERT INTO 'devicecapvalue' VALUES (35014, 567, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (35015, 567, 41, 2096);
INSERT INTO 'devicecapvalue' VALUES (35016, 567, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (35017, 567, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (35018, 567, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (35019, 567, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (35020, 567, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (35021, 567, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (35022, 567, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (35023, 567, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (35024, 567, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (35025, 567, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (35026, 567, 41, 2081);
INSERT INTO 'devicecapvalue' VALUES (35027, 567, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (35028, 567, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (35029, 567, 41, 2082);
INSERT INTO 'devicecapvalue' VALUES (35030, 567, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (35031, 567, 42, 2070);
INSERT INTO 'devicecapvalue' VALUES (35032, 567, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (35033, 567, 42, 2071);
INSERT INTO 'devicecapvalue' VALUES (35034, 567, 42, 2072);
INSERT INTO 'devicecapvalue' VALUES (35035, 567, 42, 965);
INSERT INTO 'devicecapvalue' VALUES (35036, 567, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (35037, 567, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (35038, 567, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (35039, 567, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (35040, 567, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (35041, 567, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (35042, 567, 42, 2074);
INSERT INTO 'devicecapvalue' VALUES (35043, 567, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (35044, 567, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (35045, 567, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (35046, 567, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (35047, 567, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (35048, 567, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (35049, 567, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (35050, 567, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (35051, 567, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (35052, 567, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (35053, 567, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (35054, 567, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (35055, 567, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (35056, 567, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (35057, 567, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (35058, 567, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (35059, 567, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (35060, 567, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (35061, 567, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (35062, 567, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (35063, 567, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (35064, 567, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (35065, 567, 42, 2078);
INSERT INTO 'devicecapvalue' VALUES (35066, 567, 42, 2079);
INSERT INTO 'devicecapvalue' VALUES (35067, 567, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (35068, 567, 42, 2096);
INSERT INTO 'devicecapvalue' VALUES (35069, 567, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (35070, 567, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (35071, 567, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (35072, 567, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (35073, 567, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (35074, 567, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (35075, 567, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (35076, 567, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (35077, 567, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (35078, 567, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (35079, 567, 42, 2081);
INSERT INTO 'devicecapvalue' VALUES (35080, 567, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (35081, 567, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (35082, 567, 42, 2082);
INSERT INTO 'devicecapvalue' VALUES (35083, 567, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (35084, 567, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (35085, 567, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (35086, 567, 45, 2090);
INSERT INTO 'devicecapvalue' VALUES (35087, 567, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (35088, 567, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (35089, 567, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (35090, 567, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (35091, 567, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (35092, 567, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (35093, 567, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (35094, 567, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (35095, 567, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (35096, 567, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (35097, 567, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (35098, 567, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (35099, 567, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (35100, 567, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (35101, 567, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (35102, 567, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (35103, 567, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (35104, 567, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (35105, 567, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (35106, 567, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (35107, 567, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (35108, 567, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (35109, 567, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (35110, 567, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (35111, 567, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (35112, 567, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (35113, 567, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (35114, 567, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (35115, 567, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (35116, 567, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (35117, 567, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (35118, 567, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (35119, 567, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (35120, 567, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (35121, 567, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (35122, 567, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (35123, 567, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (35124, 567, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (35125, 567, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (35126, 567, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (35127, 567, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (35128, 567, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (35129, 567, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (35130, 567, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (35131, 567, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (35132, 567, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (35133, 567, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (35134, 567, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (35135, 567, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (35136, 567, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (35137, 567, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (35138, 567, 47, 2070);
INSERT INTO 'devicecapvalue' VALUES (35139, 567, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (35140, 567, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (35141, 567, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (35142, 567, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (35143, 567, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (35144, 567, 47, 2074);
INSERT INTO 'devicecapvalue' VALUES (35145, 567, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (35146, 567, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (35147, 567, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (35148, 567, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (35149, 567, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (35150, 567, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (35151, 567, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (35152, 567, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (35153, 567, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (35154, 567, 47, 1049);
INSERT INTO 'devicecapvalue' VALUES (35155, 567, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (35156, 567, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (35157, 567, 47, 2078);
INSERT INTO 'devicecapvalue' VALUES (35158, 567, 47, 2079);
INSERT INTO 'devicecapvalue' VALUES (35159, 567, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (35160, 567, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (35161, 567, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (35162, 567, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (35163, 567, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (35164, 567, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (35165, 567, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (35166, 567, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (35167, 567, 47, 2081);
INSERT INTO 'devicecapvalue' VALUES (35168, 567, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (35169, 567, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (35170, 567, 47, 2082);
INSERT INTO 'devicecapvalue' VALUES (35171, 567, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (35172, 567, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (35173, 567, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (35174, 567, 49, 1031);
INSERT INTO 'devicecapvalue' VALUES (35175, 567, 53, 2098);
INSERT INTO 'devicecapvalue' VALUES (35176, 568, 7, 2117);
INSERT INTO 'devicecapvalue' VALUES (35177, 568, 8, 10);
INSERT INTO 'cap' VALUES (233, 'device.model', 1);
INSERT INTO 'capvalue' VALUES (2122, 'GT-S5230');
INSERT INTO 'devicecapvalue' VALUES (35178, 568, 233, 2122);
INSERT INTO 'devicecapvalue' VALUES (35179, 568, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (35180, 568, 9, 603);
INSERT INTO 'devicecapvalue' VALUES (35181, 568, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (35182, 568, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (35183, 568, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (35184, 568, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (35185, 568, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (35186, 568, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (35187, 568, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (35188, 568, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (35189, 568, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (35190, 568, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (35191, 568, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (35192, 568, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (35193, 568, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (35194, 568, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (35195, 568, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (35196, 568, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (35197, 568, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (35198, 568, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (35199, 568, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (35200, 568, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (35201, 568, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (35202, 568, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (35203, 568, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (35204, 568, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (35205, 568, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (35206, 568, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (35207, 568, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (35208, 568, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (35209, 568, 26, 35);
INSERT INTO 'devicecapvalue' VALUES (35210, 568, 28, 40);
INSERT INTO 'devicecapvalue' VALUES (35211, 568, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (35212, 568, 30, 39);
INSERT INTO 'devicecapvalue' VALUES (35213, 568, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (35214, 568, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (35215, 568, 32, 852);
INSERT INTO 'devicecapvalue' VALUES (35216, 568, 32, 2094);
INSERT INTO 'devicecapvalue' VALUES (35217, 568, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (35218, 568, 34, 44);
INSERT INTO 'devicecapvalue' VALUES (35219, 568, 35, 45);
INSERT INTO 'capvalue' VALUES (2123, 'GT-S5230/S5230WMID2');
INSERT INTO 'devicecapvalue' VALUES (35220, 568, 36, 2123);
INSERT INTO 'devicecapvalue' VALUES (35221, 568, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (35222, 568, 38, 2083);
INSERT INTO 'devicecapvalue' VALUES (35223, 568, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (35224, 568, 39, 1049);
INSERT INTO 'devicecapvalue' VALUES (35225, 568, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (35226, 568, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (35227, 568, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (35228, 568, 41, 2070);
INSERT INTO 'devicecapvalue' VALUES (35229, 568, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (35230, 568, 41, 2071);
INSERT INTO 'devicecapvalue' VALUES (35231, 568, 41, 2072);
INSERT INTO 'devicecapvalue' VALUES (35232, 568, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (35233, 568, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (35234, 568, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (35235, 568, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (35236, 568, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (35237, 568, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (35238, 568, 41, 2074);
INSERT INTO 'devicecapvalue' VALUES (35239, 568, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (35240, 568, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (35241, 568, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (35242, 568, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (35243, 568, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (35244, 568, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (35245, 568, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (35246, 568, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (35247, 568, 41, 986);
INSERT INTO 'devicecapvalue' VALUES (35248, 568, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (35249, 568, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (35250, 568, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (35251, 568, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (35252, 568, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (35253, 568, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (35254, 568, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (35255, 568, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (35256, 568, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (35257, 568, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (35258, 568, 41, 2078);
INSERT INTO 'devicecapvalue' VALUES (35259, 568, 41, 2079);
INSERT INTO 'devicecapvalue' VALUES (35260, 568, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (35261, 568, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (35262, 568, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (35263, 568, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (35264, 568, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (35265, 568, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (35266, 568, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (35267, 568, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (35268, 568, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (35269, 568, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (35270, 568, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (35271, 568, 41, 2081);
INSERT INTO 'devicecapvalue' VALUES (35272, 568, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (35273, 568, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (35274, 568, 41, 2082);
INSERT INTO 'devicecapvalue' VALUES (35275, 568, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (35276, 568, 42, 2070);
INSERT INTO 'devicecapvalue' VALUES (35277, 568, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (35278, 568, 42, 2071);
INSERT INTO 'devicecapvalue' VALUES (35279, 568, 42, 2072);
INSERT INTO 'devicecapvalue' VALUES (35280, 568, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (35281, 568, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (35282, 568, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (35283, 568, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (35284, 568, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (35285, 568, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (35286, 568, 42, 2074);
INSERT INTO 'devicecapvalue' VALUES (35287, 568, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (35288, 568, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (35289, 568, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (35290, 568, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (35291, 568, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (35292, 568, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (35293, 568, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (35294, 568, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (35295, 568, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (35296, 568, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (35297, 568, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (35298, 568, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (35299, 568, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (35300, 568, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (35301, 568, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (35302, 568, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (35303, 568, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (35304, 568, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (35305, 568, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (35306, 568, 42, 2078);
INSERT INTO 'devicecapvalue' VALUES (35307, 568, 42, 2079);
INSERT INTO 'devicecapvalue' VALUES (35308, 568, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (35309, 568, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (35310, 568, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (35311, 568, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (35312, 568, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (35313, 568, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (35314, 568, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (35315, 568, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (35316, 568, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (35317, 568, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (35318, 568, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (35319, 568, 42, 2081);
INSERT INTO 'devicecapvalue' VALUES (35320, 568, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (35321, 568, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (35322, 568, 42, 2082);
INSERT INTO 'devicecapvalue' VALUES (35323, 568, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (35324, 568, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (35325, 568, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (35326, 568, 45, 2090);
INSERT INTO 'devicecapvalue' VALUES (35327, 568, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (35328, 568, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (35329, 568, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (35330, 568, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (35331, 568, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (35332, 568, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (35333, 568, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (35334, 568, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (35335, 568, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (35336, 568, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (35337, 568, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (35338, 568, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (35339, 568, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (35340, 568, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (35341, 568, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (35342, 568, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (35343, 568, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (35344, 568, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (35345, 568, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (35346, 568, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (35347, 568, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (35348, 568, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (35349, 568, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (35350, 568, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (35351, 568, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (35352, 568, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (35353, 568, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (35354, 568, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (35355, 568, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (35356, 568, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (35357, 568, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (35358, 568, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (35359, 568, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (35360, 568, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (35361, 568, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (35362, 568, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (35363, 568, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (35364, 568, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (35365, 568, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (35366, 568, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (35367, 568, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (35368, 568, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (35369, 568, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (35370, 568, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (35371, 568, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (35372, 568, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (35373, 568, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (35374, 568, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (35375, 568, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (35376, 568, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (35377, 568, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (35378, 568, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (35379, 568, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (35380, 568, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (35381, 568, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (35382, 568, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (35383, 568, 47, 2070);
INSERT INTO 'devicecapvalue' VALUES (35384, 568, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (35385, 568, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (35386, 568, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (35387, 568, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (35388, 568, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (35389, 568, 47, 2074);
INSERT INTO 'devicecapvalue' VALUES (35390, 568, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (35391, 568, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (35392, 568, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (35393, 568, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (35394, 568, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (35395, 568, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (35396, 568, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (35397, 568, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (35398, 568, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (35399, 568, 47, 1049);
INSERT INTO 'devicecapvalue' VALUES (35400, 568, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (35401, 568, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (35402, 568, 47, 2078);
INSERT INTO 'devicecapvalue' VALUES (35403, 568, 47, 2079);
INSERT INTO 'devicecapvalue' VALUES (35404, 568, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (35405, 568, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (35406, 568, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (35407, 568, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (35408, 568, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (35409, 568, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (35410, 568, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (35411, 568, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (35412, 568, 47, 2081);
INSERT INTO 'devicecapvalue' VALUES (35413, 568, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (35414, 568, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (35415, 568, 47, 2082);
INSERT INTO 'devicecapvalue' VALUES (35416, 568, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (35417, 568, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (35418, 568, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (35419, 568, 49, 1031);
INSERT INTO 'capvalue' VALUES (2124, 'SAMSUNG-GT-S5230/1.0 SHP/VPP/R5 Jasmine/0.8 NexPlayer/2.12 S');
INSERT INTO 'devicecapvalue' VALUES (35420, 568, 53, 2124);
INSERT INTO 'capvalue' VALUES (2125, '480x540');
INSERT INTO 'devicecapvalue' VALUES (35421, 569, 7, 2125);
INSERT INTO 'devicecapvalue' VALUES (35422, 569, 8, 10);
INSERT INTO 'capvalue' VALUES (2126, 'S8000');
INSERT INTO 'devicecapvalue' VALUES (35423, 569, 233, 2126);
INSERT INTO 'devicecapvalue' VALUES (35424, 569, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (35425, 569, 9, 603);
INSERT INTO 'devicecapvalue' VALUES (35426, 569, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (35427, 569, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (35428, 569, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (35429, 569, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (35430, 569, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (35431, 569, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (35432, 569, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (35433, 569, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (35434, 569, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (35435, 569, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (35436, 569, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (35437, 569, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (35438, 569, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (35439, 569, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (35440, 569, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (35441, 569, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (35442, 569, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (35443, 569, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (35444, 569, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (35445, 569, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (35446, 569, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (35447, 569, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (35448, 569, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (35449, 569, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (35450, 569, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (35451, 569, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (35452, 569, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (35453, 569, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (35454, 569, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (35455, 569, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (35456, 569, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (35457, 569, 32, 852);
INSERT INTO 'devicecapvalue' VALUES (35458, 569, 32, 2094);
INSERT INTO 'devicecapvalue' VALUES (35459, 569, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (35460, 569, 34, 44);
INSERT INTO 'devicecapvalue' VALUES (35461, 569, 35, 45);
INSERT INTO 'capvalue' VALUES (2127, 'S8000/S8000XEII2');
INSERT INTO 'devicecapvalue' VALUES (35462, 569, 36, 2127);
INSERT INTO 'devicecapvalue' VALUES (35463, 569, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (35464, 569, 38, 2083);
INSERT INTO 'devicecapvalue' VALUES (35465, 569, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (35466, 569, 39, 1049);
INSERT INTO 'devicecapvalue' VALUES (35467, 569, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (35468, 569, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (35469, 569, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (35470, 569, 41, 2070);
INSERT INTO 'devicecapvalue' VALUES (35471, 569, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (35472, 569, 41, 2071);
INSERT INTO 'devicecapvalue' VALUES (35473, 569, 41, 2072);
INSERT INTO 'devicecapvalue' VALUES (35474, 569, 41, 965);
INSERT INTO 'devicecapvalue' VALUES (35475, 569, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (35476, 569, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (35477, 569, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (35478, 569, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (35479, 569, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (35480, 569, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (35481, 569, 41, 2074);
INSERT INTO 'devicecapvalue' VALUES (35482, 569, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (35483, 569, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (35484, 569, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (35485, 569, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (35486, 569, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (35487, 569, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (35488, 569, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (35489, 569, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (35490, 569, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (35491, 569, 41, 986);
INSERT INTO 'devicecapvalue' VALUES (35492, 569, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (35493, 569, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (35494, 569, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (35495, 569, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (35496, 569, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (35497, 569, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (35498, 569, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (35499, 569, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (35500, 569, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (35501, 569, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (35502, 569, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (35503, 569, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (35504, 569, 41, 2078);
INSERT INTO 'devicecapvalue' VALUES (35505, 569, 41, 2079);
INSERT INTO 'devicecapvalue' VALUES (35506, 569, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (35507, 569, 41, 2096);
INSERT INTO 'devicecapvalue' VALUES (35508, 569, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (35509, 569, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (35510, 569, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (35511, 569, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (35512, 569, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (35513, 569, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (35514, 569, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (35515, 569, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (35516, 569, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (35517, 569, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (35518, 569, 41, 2081);
INSERT INTO 'devicecapvalue' VALUES (35519, 569, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (35520, 569, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (35521, 569, 41, 2082);
INSERT INTO 'devicecapvalue' VALUES (35522, 569, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (35523, 569, 42, 2070);
INSERT INTO 'devicecapvalue' VALUES (35524, 569, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (35525, 569, 42, 2071);
INSERT INTO 'devicecapvalue' VALUES (35526, 569, 42, 2072);
INSERT INTO 'devicecapvalue' VALUES (35527, 569, 42, 965);
INSERT INTO 'devicecapvalue' VALUES (35528, 569, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (35529, 569, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (35530, 569, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (35531, 569, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (35532, 569, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (35533, 569, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (35534, 569, 42, 2074);
INSERT INTO 'devicecapvalue' VALUES (35535, 569, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (35536, 569, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (35537, 569, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (35538, 569, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (35539, 569, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (35540, 569, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (35541, 569, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (35542, 569, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (35543, 569, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (35544, 569, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (35545, 569, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (35546, 569, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (35547, 569, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (35548, 569, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (35549, 569, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (35550, 569, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (35551, 569, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (35552, 569, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (35553, 569, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (35554, 569, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (35555, 569, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (35556, 569, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (35557, 569, 42, 2078);
INSERT INTO 'devicecapvalue' VALUES (35558, 569, 42, 2079);
INSERT INTO 'devicecapvalue' VALUES (35559, 569, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (35560, 569, 42, 2096);
INSERT INTO 'devicecapvalue' VALUES (35561, 569, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (35562, 569, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (35563, 569, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (35564, 569, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (35565, 569, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (35566, 569, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (35567, 569, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (35568, 569, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (35569, 569, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (35570, 569, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (35571, 569, 42, 2081);
INSERT INTO 'devicecapvalue' VALUES (35572, 569, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (35573, 569, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (35574, 569, 42, 2082);
INSERT INTO 'devicecapvalue' VALUES (35575, 569, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (35576, 569, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (35577, 569, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (35578, 569, 45, 2090);
INSERT INTO 'devicecapvalue' VALUES (35579, 569, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (35580, 569, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (35581, 569, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (35582, 569, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (35583, 569, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (35584, 569, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (35585, 569, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (35586, 569, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (35587, 569, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (35588, 569, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (35589, 569, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (35590, 569, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (35591, 569, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (35592, 569, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (35593, 569, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (35594, 569, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (35595, 569, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (35596, 569, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (35597, 569, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (35598, 569, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (35599, 569, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (35600, 569, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (35601, 569, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (35602, 569, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (35603, 569, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (35604, 569, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (35605, 569, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (35606, 569, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (35607, 569, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (35608, 569, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (35609, 569, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (35610, 569, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (35611, 569, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (35612, 569, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (35613, 569, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (35614, 569, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (35615, 569, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (35616, 569, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (35617, 569, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (35618, 569, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (35619, 569, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (35620, 569, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (35621, 569, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (35622, 569, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (35623, 569, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (35624, 569, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (35625, 569, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (35626, 569, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (35627, 569, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (35628, 569, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (35629, 569, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (35630, 569, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (35631, 569, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (35632, 569, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (35633, 569, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (35634, 569, 46, 87);
INSERT INTO 'capvalue' VALUES (2128, 'tuner.modulations');
INSERT INTO 'devicecapvalue' VALUES (35635, 569, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (35636, 569, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (35637, 569, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (35638, 569, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (35639, 569, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (35640, 569, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (35641, 569, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (35642, 569, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (35643, 569, 47, 2070);
INSERT INTO 'devicecapvalue' VALUES (35644, 569, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (35645, 569, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (35646, 569, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (35647, 569, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (35648, 569, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (35649, 569, 47, 2074);
INSERT INTO 'devicecapvalue' VALUES (35650, 569, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (35651, 569, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (35652, 569, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (35653, 569, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (35654, 569, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (35655, 569, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (35656, 569, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (35657, 569, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (35658, 569, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (35659, 569, 47, 1049);
INSERT INTO 'devicecapvalue' VALUES (35660, 569, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (35661, 569, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (35662, 569, 47, 2078);
INSERT INTO 'devicecapvalue' VALUES (35663, 569, 47, 2079);
INSERT INTO 'devicecapvalue' VALUES (35664, 569, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (35665, 569, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (35666, 569, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (35667, 569, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (35668, 569, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (35669, 569, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (35670, 569, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (35671, 569, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (35672, 569, 47, 2081);
INSERT INTO 'devicecapvalue' VALUES (35673, 569, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (35674, 569, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (35675, 569, 47, 2082);
INSERT INTO 'devicecapvalue' VALUES (35676, 569, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (35677, 569, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (35678, 569, 48, 92);
INSERT INTO 'capvalue' VALUES (2129, '19922432');
INSERT INTO 'devicecapvalue' VALUES (35679, 569, 49, 2129);
INSERT INTO 'capvalue' VALUES (2130, 'SAMSUNG-S8000/S8000XEII2 SHP/VPP/R5 Jasmine/1.0 Nextreaming');
INSERT INTO 'devicecapvalue' VALUES (35680, 569, 53, 2130);
INSERT INTO 'devicecapvalue' VALUES (35681, 570, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (35682, 570, 7, 2117);
INSERT INTO 'devicecapvalue' VALUES (35683, 570, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (35684, 570, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (35685, 570, 9, 603);
INSERT INTO 'devicecapvalue' VALUES (35686, 570, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (35687, 570, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (35688, 570, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (35689, 570, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (35690, 570, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (35691, 570, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (35692, 570, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (35693, 570, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (35694, 570, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (35695, 570, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (35696, 570, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (35697, 570, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (35698, 570, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (35699, 570, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (35700, 570, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (35701, 570, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (35702, 570, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (35703, 570, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (35704, 570, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (35705, 570, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (35706, 570, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (35707, 570, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (35708, 570, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (35709, 570, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (35710, 570, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (35711, 570, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (35712, 570, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (35713, 570, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (35714, 570, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (35715, 570, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (35716, 570, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (35717, 570, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (35718, 570, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (35719, 570, 57, 40);
INSERT INTO 'devicecapvalue' VALUES (35720, 570, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (35721, 570, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (35722, 570, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (35723, 570, 31, 41);
INSERT INTO 'capvalue' VALUES (2131, 'audio/amr ');
INSERT INTO 'devicecapvalue' VALUES (35724, 570, 38, 2131);
INSERT INTO 'devicecapvalue' VALUES (35725, 570, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (35726, 570, 39, 1049);
INSERT INTO 'devicecapvalue' VALUES (35727, 570, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (35728, 570, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (35729, 570, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (35730, 570, 41, 2070);
INSERT INTO 'devicecapvalue' VALUES (35731, 570, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (35732, 570, 41, 2071);
INSERT INTO 'devicecapvalue' VALUES (35733, 570, 41, 2072);
INSERT INTO 'devicecapvalue' VALUES (35734, 570, 41, 965);
INSERT INTO 'devicecapvalue' VALUES (35735, 570, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (35736, 570, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (35737, 570, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (35738, 570, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (35739, 570, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (35740, 570, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (35741, 570, 41, 2074);
INSERT INTO 'devicecapvalue' VALUES (35742, 570, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (35743, 570, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (35744, 570, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (35745, 570, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (35746, 570, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (35747, 570, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (35748, 570, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (35749, 570, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (35750, 570, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (35751, 570, 41, 986);
INSERT INTO 'devicecapvalue' VALUES (35752, 570, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (35753, 570, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (35754, 570, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (35755, 570, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (35756, 570, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (35757, 570, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (35758, 570, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (35759, 570, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (35760, 570, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (35761, 570, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (35762, 570, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (35763, 570, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (35764, 570, 41, 2078);
INSERT INTO 'devicecapvalue' VALUES (35765, 570, 41, 2079);
INSERT INTO 'devicecapvalue' VALUES (35766, 570, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (35767, 570, 41, 2096);
INSERT INTO 'devicecapvalue' VALUES (35768, 570, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (35769, 570, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (35770, 570, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (35771, 570, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (35772, 570, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (35773, 570, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (35774, 570, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (35775, 570, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (35776, 570, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (35777, 570, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (35778, 570, 41, 2081);
INSERT INTO 'devicecapvalue' VALUES (35779, 570, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (35780, 570, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (35781, 570, 41, 2082);
INSERT INTO 'devicecapvalue' VALUES (35782, 570, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (35783, 570, 42, 2070);
INSERT INTO 'devicecapvalue' VALUES (35784, 570, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (35785, 570, 42, 2071);
INSERT INTO 'devicecapvalue' VALUES (35786, 570, 42, 2072);
INSERT INTO 'devicecapvalue' VALUES (35787, 570, 42, 965);
INSERT INTO 'devicecapvalue' VALUES (35788, 570, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (35789, 570, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (35790, 570, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (35791, 570, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (35792, 570, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (35793, 570, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (35794, 570, 42, 2074);
INSERT INTO 'devicecapvalue' VALUES (35795, 570, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (35796, 570, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (35797, 570, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (35798, 570, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (35799, 570, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (35800, 570, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (35801, 570, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (35802, 570, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (35803, 570, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (35804, 570, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (35805, 570, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (35806, 570, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (35807, 570, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (35808, 570, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (35809, 570, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (35810, 570, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (35811, 570, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (35812, 570, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (35813, 570, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (35814, 570, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (35815, 570, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (35816, 570, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (35817, 570, 42, 2078);
INSERT INTO 'devicecapvalue' VALUES (35818, 570, 42, 2079);
INSERT INTO 'devicecapvalue' VALUES (35819, 570, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (35820, 570, 42, 2096);
INSERT INTO 'devicecapvalue' VALUES (35821, 570, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (35822, 570, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (35823, 570, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (35824, 570, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (35825, 570, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (35826, 570, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (35827, 570, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (35828, 570, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (35829, 570, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (35830, 570, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (35831, 570, 42, 2081);
INSERT INTO 'devicecapvalue' VALUES (35832, 570, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (35833, 570, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (35834, 570, 42, 2082);
INSERT INTO 'devicecapvalue' VALUES (35835, 570, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (35836, 570, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (35837, 570, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (35838, 570, 45, 18);
INSERT INTO 'devicecapvalue' VALUES (35839, 570, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (35840, 570, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (35841, 570, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (35842, 570, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (35843, 570, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (35844, 570, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (35845, 570, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (35846, 570, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (35847, 570, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (35848, 570, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (35849, 570, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (35850, 570, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (35851, 570, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (35852, 570, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (35853, 570, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (35854, 570, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (35855, 570, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (35856, 570, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (35857, 570, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (35858, 570, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (35859, 570, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (35860, 570, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (35861, 570, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (35862, 570, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (35863, 570, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (35864, 570, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (35865, 570, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (35866, 570, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (35867, 570, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (35868, 570, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (35869, 570, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (35870, 570, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (35871, 570, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (35872, 570, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (35873, 570, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (35874, 570, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (35875, 570, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (35876, 570, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (35877, 570, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (35878, 570, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (35879, 570, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (35880, 570, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (35881, 570, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (35882, 570, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (35883, 570, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (35884, 570, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (35885, 570, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (35886, 570, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (35887, 570, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (35888, 570, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (35889, 570, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (35890, 570, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (35891, 570, 115, 2083);
INSERT INTO 'devicecapvalue' VALUES (35892, 570, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (35893, 570, 118, 238);
INSERT INTO 'devicecapvalue' VALUES (35894, 570, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (35895, 570, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (35896, 570, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (35897, 570, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (35898, 570, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (35899, 570, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (35900, 570, 125, 1);
INSERT INTO 'devicecapvalue' VALUES (35901, 570, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (35902, 570, 59, 602);
INSERT INTO 'capvalue' VALUES (2132, 'file:///Mmc/');
INSERT INTO 'devicecapvalue' VALUES (35903, 570, 101, 2132);
INSERT INTO 'devicecapvalue' VALUES (35904, 570, 103, 2084);
INSERT INTO 'devicecapvalue' VALUES (35905, 570, 104, 2085);
INSERT INTO 'devicecapvalue' VALUES (35906, 570, 105, 2086);
INSERT INTO 'devicecapvalue' VALUES (35907, 570, 106, 727);
INSERT INTO 'devicecapvalue' VALUES (35908, 570, 107, 2087);
INSERT INTO 'devicecapvalue' VALUES (35909, 570, 108, 2088);
INSERT INTO 'devicecapvalue' VALUES (35910, 570, 109, 2089);
INSERT INTO 'devicecapvalue' VALUES (35911, 570, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (35912, 570, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (35913, 570, 114, 2094);
INSERT INTO 'devicecapvalue' VALUES (35914, 570, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (35915, 570, 62, 44);
INSERT INTO 'devicecapvalue' VALUES (35916, 570, 145, 45);
INSERT INTO 'devicecapvalue' VALUES (35917, 570, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (35918, 570, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (35919, 570, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (35920, 570, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (35921, 570, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (35922, 570, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (35923, 570, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (35924, 570, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (35925, 570, 131, 922);
INSERT INTO 'devicecapvalue' VALUES (35926, 570, 67, 45);
INSERT INTO 'capvalue' VALUES (2133, 'S8300/S8300XXIC2');
INSERT INTO 'devicecapvalue' VALUES (35927, 570, 68, 2133);
INSERT INTO 'devicecapvalue' VALUES (35928, 570, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (35929, 570, 147, 242);
INSERT INTO 'devicecapvalue' VALUES (35930, 570, 132, 2083);
INSERT INTO 'devicecapvalue' VALUES (35931, 570, 133, 2090);
INSERT INTO 'devicecapvalue' VALUES (35932, 570, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (35933, 570, 116, 1444);
INSERT INTO 'devicecapvalue' VALUES (35934, 570, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (35935, 570, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (35936, 570, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (35937, 570, 136, 2090);
INSERT INTO 'devicecapvalue' VALUES (35938, 570, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (35939, 570, 138, 1681);
INSERT INTO 'devicecapvalue' VALUES (35940, 570, 72, 1682);
INSERT INTO 'devicecapvalue' VALUES (35941, 570, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (35942, 570, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (35943, 570, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (35944, 570, 47, 2070);
INSERT INTO 'devicecapvalue' VALUES (35945, 570, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (35946, 570, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (35947, 570, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (35948, 570, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (35949, 570, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (35950, 570, 47, 2074);
INSERT INTO 'devicecapvalue' VALUES (35951, 570, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (35952, 570, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (35953, 570, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (35954, 570, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (35955, 570, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (35956, 570, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (35957, 570, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (35958, 570, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (35959, 570, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (35960, 570, 47, 1049);
INSERT INTO 'devicecapvalue' VALUES (35961, 570, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (35962, 570, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (35963, 570, 47, 2078);
INSERT INTO 'devicecapvalue' VALUES (35964, 570, 47, 2079);
INSERT INTO 'devicecapvalue' VALUES (35965, 570, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (35966, 570, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (35967, 570, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (35968, 570, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (35969, 570, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (35970, 570, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (35971, 570, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (35972, 570, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (35973, 570, 47, 2081);
INSERT INTO 'devicecapvalue' VALUES (35974, 570, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (35975, 570, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (35976, 570, 47, 2082);
INSERT INTO 'devicecapvalue' VALUES (35977, 570, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (35978, 570, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (35979, 570, 5, 4);
INSERT INTO 'devicecapvalue' VALUES (35980, 570, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (35981, 570, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (35982, 570, 49, 104);
INSERT INTO 'capvalue' VALUES (2134, 'SAMSUNG-S8300/S8300XXIC2 SHP/VPP/R5 NetFront/3.5 NexPlayer/2.9.1 SMM-MMS/1.2.0 profile/MIDP-2.1 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (35983, 570, 53, 2134);
INSERT INTO 'devicecapvalue' VALUES (35984, 571, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (35985, 571, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (35986, 571, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (35987, 571, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (35988, 571, 6, 27);
INSERT INTO 'capvalue' VALUES (2135, '178');
INSERT INTO 'devicecapvalue' VALUES (35989, 571, 4, 2135);
INSERT INTO 'devicecapvalue' VALUES (35990, 571, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (35991, 571, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (35992, 571, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (35993, 571, 51, 1458);
INSERT INTO 'devicecapvalue' VALUES (35994, 571, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (35995, 571, 157, 1968);
INSERT INTO 'devicecapvalue' VALUES (35996, 571, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (35997, 571, 157, 1026);
INSERT INTO 'capvalue' VALUES (2136, 'real-video');
INSERT INTO 'devicecapvalue' VALUES (35998, 571, 157, 2136);
INSERT INTO 'devicecapvalue' VALUES (35999, 572, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (36000, 572, 7, 2069);
INSERT INTO 'devicecapvalue' VALUES (36001, 572, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (36002, 572, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (36003, 572, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (36004, 572, 10, 864);
INSERT INTO 'devicecapvalue' VALUES (36005, 572, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (36006, 572, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (36007, 572, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (36008, 572, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (36009, 572, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (36010, 572, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (36011, 572, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36012, 572, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (36013, 572, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (36014, 572, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (36015, 572, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (36016, 572, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36017, 572, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (36018, 572, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (36019, 572, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (36020, 572, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36021, 572, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36022, 572, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (36023, 572, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36024, 572, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (36025, 572, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (36026, 572, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (36027, 572, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (36028, 572, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (36029, 572, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (36030, 572, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (36031, 572, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (36032, 572, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (36033, 572, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (36034, 572, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (36035, 572, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (36036, 572, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (36037, 572, 38, 2131);
INSERT INTO 'devicecapvalue' VALUES (36038, 572, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (36039, 572, 39, 1049);
INSERT INTO 'devicecapvalue' VALUES (36040, 572, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (36041, 572, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (36042, 572, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (36043, 572, 41, 2070);
INSERT INTO 'devicecapvalue' VALUES (36044, 572, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (36045, 572, 41, 2071);
INSERT INTO 'devicecapvalue' VALUES (36046, 572, 41, 2072);
INSERT INTO 'devicecapvalue' VALUES (36047, 572, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (36048, 572, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (36049, 572, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (36050, 572, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (36051, 572, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (36052, 572, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (36053, 572, 41, 2074);
INSERT INTO 'devicecapvalue' VALUES (36054, 572, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (36055, 572, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (36056, 572, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (36057, 572, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (36058, 572, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (36059, 572, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (36060, 572, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (36061, 572, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (36062, 572, 41, 986);
INSERT INTO 'devicecapvalue' VALUES (36063, 572, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (36064, 572, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (36065, 572, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (36066, 572, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (36067, 572, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (36068, 572, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (36069, 572, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (36070, 572, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (36071, 572, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (36072, 572, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (36073, 572, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (36074, 572, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (36075, 572, 41, 2078);
INSERT INTO 'devicecapvalue' VALUES (36076, 572, 41, 2079);
INSERT INTO 'devicecapvalue' VALUES (36077, 572, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (36078, 572, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (36079, 572, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (36080, 572, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (36081, 572, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (36082, 572, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (36083, 572, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (36084, 572, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (36085, 572, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (36086, 572, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (36087, 572, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (36088, 572, 41, 2081);
INSERT INTO 'devicecapvalue' VALUES (36089, 572, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (36090, 572, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (36091, 572, 41, 2082);
INSERT INTO 'devicecapvalue' VALUES (36092, 572, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (36093, 572, 42, 2070);
INSERT INTO 'devicecapvalue' VALUES (36094, 572, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (36095, 572, 42, 2071);
INSERT INTO 'devicecapvalue' VALUES (36096, 572, 42, 2072);
INSERT INTO 'devicecapvalue' VALUES (36097, 572, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (36098, 572, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (36099, 572, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (36100, 572, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (36101, 572, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (36102, 572, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (36103, 572, 42, 2074);
INSERT INTO 'devicecapvalue' VALUES (36104, 572, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (36105, 572, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (36106, 572, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (36107, 572, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (36108, 572, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (36109, 572, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (36110, 572, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (36111, 572, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (36112, 572, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (36113, 572, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (36114, 572, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (36115, 572, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (36116, 572, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (36117, 572, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (36118, 572, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (36119, 572, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (36120, 572, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (36121, 572, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (36122, 572, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (36123, 572, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (36124, 572, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (36125, 572, 42, 2078);
INSERT INTO 'devicecapvalue' VALUES (36126, 572, 42, 2079);
INSERT INTO 'devicecapvalue' VALUES (36127, 572, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (36128, 572, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (36129, 572, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (36130, 572, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (36131, 572, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (36132, 572, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (36133, 572, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (36134, 572, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (36135, 572, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (36136, 572, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (36137, 572, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (36138, 572, 42, 2081);
INSERT INTO 'devicecapvalue' VALUES (36139, 572, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (36140, 572, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (36141, 572, 42, 2082);
INSERT INTO 'devicecapvalue' VALUES (36142, 572, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (36143, 572, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (36144, 572, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (36145, 572, 45, 2090);
INSERT INTO 'devicecapvalue' VALUES (36146, 572, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (36147, 572, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (36148, 572, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (36149, 572, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (36150, 572, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (36151, 572, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (36152, 572, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (36153, 572, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (36154, 572, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (36155, 572, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (36156, 572, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (36157, 572, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (36158, 572, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (36159, 572, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (36160, 572, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (36161, 572, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (36162, 572, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (36163, 572, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (36164, 572, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (36165, 572, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (36166, 572, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (36167, 572, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (36168, 572, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (36169, 572, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (36170, 572, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (36171, 572, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (36172, 572, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (36173, 572, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (36174, 572, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (36175, 572, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (36176, 572, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (36177, 572, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (36178, 572, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (36179, 572, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (36180, 572, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (36181, 572, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (36182, 572, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (36183, 572, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (36184, 572, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (36185, 572, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (36186, 572, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (36187, 572, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (36188, 572, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (36189, 572, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (36190, 572, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (36191, 572, 115, 2083);
INSERT INTO 'devicecapvalue' VALUES (36192, 572, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (36193, 572, 118, 238);
INSERT INTO 'devicecapvalue' VALUES (36194, 572, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (36195, 572, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (36196, 572, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (36197, 572, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (36198, 572, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (36199, 572, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (36200, 572, 125, 1);
INSERT INTO 'devicecapvalue' VALUES (36201, 572, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (36202, 572, 101, 2132);
INSERT INTO 'devicecapvalue' VALUES (36203, 572, 103, 2084);
INSERT INTO 'devicecapvalue' VALUES (36204, 572, 104, 2085);
INSERT INTO 'devicecapvalue' VALUES (36205, 572, 105, 2086);
INSERT INTO 'devicecapvalue' VALUES (36206, 572, 106, 727);
INSERT INTO 'devicecapvalue' VALUES (36207, 572, 107, 2087);
INSERT INTO 'devicecapvalue' VALUES (36208, 572, 108, 2088);
INSERT INTO 'devicecapvalue' VALUES (36209, 572, 109, 2089);
INSERT INTO 'devicecapvalue' VALUES (36210, 572, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (36211, 572, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (36212, 572, 62, 44);
INSERT INTO 'devicecapvalue' VALUES (36213, 572, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (36214, 572, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (36215, 572, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (36216, 572, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (36217, 572, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (36218, 572, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (36219, 572, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (36220, 572, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (36221, 572, 68, 243);
INSERT INTO 'devicecapvalue' VALUES (36222, 572, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (36223, 572, 132, 2083);
INSERT INTO 'devicecapvalue' VALUES (36224, 572, 133, 2090);
INSERT INTO 'devicecapvalue' VALUES (36225, 572, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (36226, 572, 116, 1444);
INSERT INTO 'devicecapvalue' VALUES (36227, 572, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (36228, 572, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (36229, 572, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (36230, 572, 136, 2090);
INSERT INTO 'devicecapvalue' VALUES (36231, 572, 137, 18);
INSERT INTO 'capvalue' VALUES (2137, '+48501200777');
INSERT INTO 'devicecapvalue' VALUES (36232, 572, 72, 2137);
INSERT INTO 'devicecapvalue' VALUES (36233, 572, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (36234, 572, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (36235, 572, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (36236, 572, 47, 2070);
INSERT INTO 'devicecapvalue' VALUES (36237, 572, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (36238, 572, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (36239, 572, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (36240, 572, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (36241, 572, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (36242, 572, 47, 2074);
INSERT INTO 'devicecapvalue' VALUES (36243, 572, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (36244, 572, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (36245, 572, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (36246, 572, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (36247, 572, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (36248, 572, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (36249, 572, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (36250, 572, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (36251, 572, 47, 1049);
INSERT INTO 'devicecapvalue' VALUES (36252, 572, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (36253, 572, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (36254, 572, 47, 2078);
INSERT INTO 'devicecapvalue' VALUES (36255, 572, 47, 2079);
INSERT INTO 'devicecapvalue' VALUES (36256, 572, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (36257, 572, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (36258, 572, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (36259, 572, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (36260, 572, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (36261, 572, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (36262, 572, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (36263, 572, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (36264, 572, 47, 2081);
INSERT INTO 'devicecapvalue' VALUES (36265, 572, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (36266, 572, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (36267, 572, 47, 2082);
INSERT INTO 'devicecapvalue' VALUES (36268, 572, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (36269, 572, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (36270, 572, 48, 92);
INSERT INTO 'capvalue' VALUES (2138, '2263296');
INSERT INTO 'devicecapvalue' VALUES (36271, 572, 49, 2138);
INSERT INTO 'capvalue' VALUES (2139, 'SAMSUNG-B2700/XXHK1 SHP/VPP/R5 NetFront/3.4 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (36272, 572, 53, 2139);
INSERT INTO 'capvalue' VALUES (2140, '2006-12-06');
INSERT INTO 'devicecapvalue' VALUES (36273, 573, 158, 2140);
INSERT INTO 'devicecapvalue' VALUES (36274, 573, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (36275, 573, 74, 653);
INSERT INTO 'capvalue' VALUES (2141, '128x111');
INSERT INTO 'devicecapvalue' VALUES (36276, 573, 7, 2141);
INSERT INTO 'devicecapvalue' VALUES (36277, 573, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36278, 573, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (36279, 573, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (36280, 573, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (36281, 573, 13, 1330);
INSERT INTO 'capvalue' VALUES (2142, '358400');
INSERT INTO 'devicecapvalue' VALUES (36282, 573, 76, 2142);
INSERT INTO 'devicecapvalue' VALUES (36283, 573, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36284, 573, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (36285, 573, 17, 22);
INSERT INTO 'capvalue' VALUES (2143, 'samsung');
INSERT INTO 'devicecapvalue' VALUES (36286, 573, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36287, 573, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36288, 573, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36289, 573, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36290, 573, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36291, 573, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36292, 573, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36293, 573, 50, 1066);
INSERT INTO 'capvalue' VALUES (2144, '25 KB');
INSERT INTO 'devicecapvalue' VALUES (36294, 573, 155, 2144);
INSERT INTO 'devicecapvalue' VALUES (36295, 573, 232, 709);
INSERT INTO 'cap' VALUES (234, 'mmapi.AudioPlayback', 1);
INSERT INTO 'devicecapvalue' VALUES (36296, 573, 234, 15);
INSERT INTO 'cap' VALUES (235, 'mmapi.AudioStreaming', 1);
INSERT INTO 'devicecapvalue' VALUES (36297, 573, 235, 244);
INSERT INTO 'cap' VALUES (236, 'mmapi.VideoCapture', 1);
INSERT INTO 'devicecapvalue' VALUES (36298, 573, 236, 244);
INSERT INTO 'cap' VALUES (237, 'mmapi.VideoPlayback', 1);
INSERT INTO 'devicecapvalue' VALUES (36299, 573, 237, 244);
INSERT INTO 'cap' VALUES (238, 'mmapi.VideoPositioning', 1);
INSERT INTO 'devicecapvalue' VALUES (36300, 573, 238, 244);
INSERT INTO 'cap' VALUES (239, 'mmapi.VideoResizing', 1);
INSERT INTO 'devicecapvalue' VALUES (36301, 573, 239, 244);
INSERT INTO 'cap' VALUES (240, 'mmapi.VideoStreaming', 1);
INSERT INTO 'devicecapvalue' VALUES (36302, 573, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36303, 573, 156, 1415);
INSERT INTO 'capvalue' VALUES (2145, 'Asia Pacific');
INSERT INTO 'devicecapvalue' VALUES (36304, 573, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (36305, 573, 156, 1024);
INSERT INTO 'cap' VALUES (241, 'SamsungSoundFormat', 1);
INSERT INTO 'devicecapvalue' VALUES (36306, 573, 241, 102);
INSERT INTO 'capvalue' VALUES (2146, 'mmf');
INSERT INTO 'devicecapvalue' VALUES (36307, 573, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (36308, 573, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (36309, 573, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (36310, 573, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36311, 573, 52, 1412);
INSERT INTO 'capvalue' VALUES (2147, '170 KB');
INSERT INTO 'devicecapvalue' VALUES (36312, 573, 191, 2147);
INSERT INTO 'capvalue' VALUES (2148, 'SEC-SGHC130/1.0');
INSERT INTO 'devicecapvalue' VALUES (36313, 573, 53, 2148);
INSERT INTO 'capvalue' VALUES (2149, '2007-01-15');
INSERT INTO 'devicecapvalue' VALUES (36314, 574, 158, 2149);
INSERT INTO 'devicecapvalue' VALUES (36315, 574, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36316, 574, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36317, 574, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (36318, 574, 160, 1080);
INSERT INTO 'capvalue' VALUES (2150, '176x196');
INSERT INTO 'devicecapvalue' VALUES (36319, 574, 7, 2150);
INSERT INTO 'devicecapvalue' VALUES (36320, 574, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (36321, 574, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36322, 574, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (36323, 574, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (36324, 574, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (36325, 574, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (36326, 574, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (36327, 574, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (36328, 574, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (36329, 574, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (36330, 574, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36331, 574, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36332, 574, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36333, 574, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36334, 574, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36335, 574, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36336, 574, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36337, 574, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36338, 574, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36339, 574, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36340, 574, 18, 28);
INSERT INTO 'capvalue' VALUES (2151, '307200');
INSERT INTO 'devicecapvalue' VALUES (36341, 574, 50, 2151);
INSERT INTO 'capvalue' VALUES (2152, '4 MB');
INSERT INTO 'devicecapvalue' VALUES (36342, 574, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (36343, 574, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (36344, 574, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36345, 574, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36346, 574, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36347, 574, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36348, 574, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36349, 574, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36350, 574, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36351, 574, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (36352, 574, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (36353, 574, 231, 1341);
INSERT INTO 'devicecapvalue' VALUES (36354, 574, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (36355, 574, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (36356, 574, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36357, 574, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (36358, 574, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (36359, 574, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (36360, 574, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36361, 574, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (36362, 574, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (36363, 574, 52, 1124);
INSERT INTO 'cap' VALUES (242, 'TotalStorageSize', 1);
INSERT INTO 'capvalue' VALUES (2153, '80 MB');
INSERT INTO 'devicecapvalue' VALUES (36364, 574, 242, 2153);
INSERT INTO 'capvalue' VALUES (2154, '540 kb');
INSERT INTO 'devicecapvalue' VALUES (36365, 574, 191, 2154);
INSERT INTO 'capvalue' VALUES (2155, 'SAMSUNG-SGH-D500/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (36366, 574, 53, 2155);
INSERT INTO 'capvalue' VALUES (2156, '2006-10-25');
INSERT INTO 'devicecapvalue' VALUES (36367, 575, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (36368, 575, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36369, 575, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36370, 575, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (36371, 575, 7, 2150);
INSERT INTO 'devicecapvalue' VALUES (36372, 575, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36373, 575, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (36374, 575, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (36375, 575, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (36376, 575, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (36377, 575, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (36378, 575, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36379, 575, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36380, 575, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36381, 575, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36382, 575, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36383, 575, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36384, 575, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36385, 575, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36386, 575, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36387, 575, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36388, 575, 18, 28);
INSERT INTO 'capvalue' VALUES (2157, '716800');
INSERT INTO 'devicecapvalue' VALUES (36389, 575, 50, 2157);
INSERT INTO 'capvalue' VALUES (2158, '256 KB');
INSERT INTO 'devicecapvalue' VALUES (36390, 575, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (36391, 575, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36392, 575, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36393, 575, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36394, 575, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36395, 575, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36396, 575, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36397, 575, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36398, 575, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (36399, 575, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (36400, 575, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36401, 575, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (36402, 575, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (36403, 575, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (36404, 575, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (36405, 575, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36406, 575, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (36407, 575, 157, 1118);
INSERT INTO 'capvalue' VALUES (2159, 'SAMSUNG-SGH-D520');
INSERT INTO 'devicecapvalue' VALUES (36408, 575, 53, 2159);
INSERT INTO 'devicecapvalue' VALUES (36409, 576, 158, 2149);
INSERT INTO 'devicecapvalue' VALUES (36410, 576, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36411, 576, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36412, 576, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (36413, 576, 160, 1080);
INSERT INTO 'capvalue' VALUES (2160, '240x286');
INSERT INTO 'devicecapvalue' VALUES (36414, 576, 7, 2160);
INSERT INTO 'devicecapvalue' VALUES (36415, 576, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (36416, 576, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36417, 576, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (36418, 576, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (36419, 576, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (36420, 576, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (36421, 576, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (36422, 576, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (36423, 576, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (36424, 576, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (36425, 576, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (36426, 576, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (36427, 576, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36428, 576, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36429, 576, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36430, 576, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36431, 576, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36432, 576, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36433, 576, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36434, 576, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36435, 576, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36436, 576, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36437, 576, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36438, 576, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (36439, 576, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (36440, 576, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (36441, 576, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36442, 576, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36443, 576, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36444, 576, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36445, 576, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36446, 576, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36447, 576, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36448, 576, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (36449, 576, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (36450, 576, 231, 1341);
INSERT INTO 'devicecapvalue' VALUES (36451, 576, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (36452, 576, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (36453, 576, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36454, 576, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (36455, 576, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (36456, 576, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36457, 576, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (36458, 576, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (36459, 576, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (36460, 576, 52, 1124);
INSERT INTO 'capvalue' VALUES (2161, '1.3 MB');
INSERT INTO 'devicecapvalue' VALUES (36461, 576, 191, 2161);
INSERT INTO 'capvalue' VALUES (2162, 'SAMSUNG-SGH-D600E/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (36462, 576, 53, 2162);
INSERT INTO 'capvalue' VALUES (2163, '2007-01-26');
INSERT INTO 'devicecapvalue' VALUES (36463, 577, 158, 2163);
INSERT INTO 'devicecapvalue' VALUES (36464, 577, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36465, 577, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36466, 577, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (36467, 577, 7, 2160);
INSERT INTO 'devicecapvalue' VALUES (36468, 577, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36469, 577, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (36470, 577, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (36471, 577, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (36472, 577, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (36473, 577, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (36474, 577, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36475, 577, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36476, 577, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36477, 577, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36478, 577, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36479, 577, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36480, 577, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36481, 577, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36482, 577, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36483, 577, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36484, 577, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36485, 577, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (36486, 577, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (36487, 577, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36488, 577, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36489, 577, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36490, 577, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36491, 577, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36492, 577, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36493, 577, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36494, 577, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (36495, 577, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (36496, 577, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (36497, 577, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (36498, 577, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36499, 577, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (36500, 577, 191, 2161);
INSERT INTO 'capvalue' VALUES (2164, 'SAMSUNG-SGH-D608/1.0/WAP2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1/*MzU3MTEzMDAwMjI5MzY5 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (36501, 577, 53, 2164);
INSERT INTO 'capvalue' VALUES (2165, '2006-10-27');
INSERT INTO 'devicecapvalue' VALUES (36502, 578, 158, 2165);
INSERT INTO 'devicecapvalue' VALUES (36503, 578, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36504, 578, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36505, 578, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (36506, 578, 7, 2160);
INSERT INTO 'devicecapvalue' VALUES (36507, 578, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36508, 578, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (36509, 578, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (36510, 578, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (36511, 578, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (36512, 578, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (36513, 578, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36514, 578, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36515, 578, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36516, 578, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36517, 578, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36518, 578, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36519, 578, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36520, 578, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36521, 578, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36522, 578, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36523, 578, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36524, 578, 50, 2157);
INSERT INTO 'devicecapvalue' VALUES (36525, 578, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (36526, 578, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (36527, 578, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36528, 578, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36529, 578, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36530, 578, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36531, 578, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36532, 578, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36533, 578, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36534, 578, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (36535, 578, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (36536, 578, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36537, 578, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (36538, 578, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (36539, 578, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36540, 578, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (36541, 578, 52, 1124);
INSERT INTO 'capvalue' VALUES (2166, '0 KB');
INSERT INTO 'devicecapvalue' VALUES (36542, 578, 191, 2166);
INSERT INTO 'capvalue' VALUES (2167, 'SEC-SGHD800/1.0 NetFront/3.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (36543, 578, 53, 2167);
INSERT INTO 'devicecapvalue' VALUES (36544, 579, 158, 2149);
INSERT INTO 'devicecapvalue' VALUES (36545, 579, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36546, 579, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36547, 579, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (36548, 579, 7, 2160);
INSERT INTO 'devicecapvalue' VALUES (36549, 579, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36550, 579, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (36551, 579, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (36552, 579, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (36553, 579, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (36554, 579, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (36555, 579, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36556, 579, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36557, 579, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36558, 579, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36559, 579, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36560, 579, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36561, 579, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36562, 579, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36563, 579, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36564, 579, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36565, 579, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36566, 579, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (36567, 579, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (36568, 579, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (36569, 579, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36570, 579, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36571, 579, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36572, 579, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36573, 579, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36574, 579, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36575, 579, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36576, 579, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (36577, 579, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36578, 579, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (36579, 579, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (36580, 579, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (36581, 579, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (36582, 579, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36583, 579, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (36584, 579, 191, 2161);
INSERT INTO 'capvalue' VALUES (2168, 'SAMSUNG-SGH-D820/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (36585, 579, 53, 2168);
INSERT INTO 'devicecapvalue' VALUES (36586, 580, 158, 2163);
INSERT INTO 'devicecapvalue' VALUES (36587, 580, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36588, 580, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36589, 580, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (36590, 580, 7, 2160);
INSERT INTO 'devicecapvalue' VALUES (36591, 580, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36592, 580, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (36593, 580, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (36594, 580, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (36595, 580, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (36596, 580, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (36597, 580, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36598, 580, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36599, 580, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36600, 580, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36601, 580, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36602, 580, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36603, 580, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36604, 580, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36605, 580, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36606, 580, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36607, 580, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36608, 580, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (36609, 580, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (36610, 580, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (36611, 580, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36612, 580, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36613, 580, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36614, 580, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36615, 580, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36616, 580, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36617, 580, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36618, 580, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (36619, 580, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (36620, 580, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (36621, 580, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (36622, 580, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36623, 580, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (36624, 580, 191, 2161);
INSERT INTO 'capvalue' VALUES (2169, '2007-01-17');
INSERT INTO 'devicecapvalue' VALUES (36625, 581, 158, 2169);
INSERT INTO 'devicecapvalue' VALUES (36626, 581, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36627, 581, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (36628, 581, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36629, 581, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (36630, 581, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (36631, 581, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (36632, 581, 162, 238);
INSERT INTO 'capvalue' VALUES (2170, '240x284');
INSERT INTO 'devicecapvalue' VALUES (36633, 581, 7, 2170);
INSERT INTO 'devicecapvalue' VALUES (36634, 581, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (36635, 581, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (36636, 581, 173, 143);
INSERT INTO 'devicecapvalue' VALUES (36637, 581, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36638, 581, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (36639, 581, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (36640, 581, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (36641, 581, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (36642, 581, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (36643, 581, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (36644, 581, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (36645, 581, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (36646, 581, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36647, 581, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36648, 581, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (36649, 581, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36650, 581, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (36651, 581, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36652, 581, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36653, 581, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36654, 581, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36655, 581, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36656, 581, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36657, 581, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36658, 581, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36659, 581, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (36660, 581, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (36661, 581, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (36662, 581, 232, 595);
INSERT INTO 'devicecapvalue' VALUES (36663, 581, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36664, 581, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36665, 581, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36666, 581, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36667, 581, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36668, 581, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36669, 581, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36670, 581, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (36671, 581, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (36672, 581, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (36673, 581, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (36674, 581, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (36675, 581, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (36676, 581, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36677, 581, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (36678, 581, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (36679, 581, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (36680, 581, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (36681, 581, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (36682, 581, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (36683, 581, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (36684, 581, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36685, 581, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (36686, 581, 51, 1187);
INSERT INTO 'devicecapvalue' VALUES (36687, 581, 51, 1191);
INSERT INTO 'devicecapvalue' VALUES (36688, 581, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (36689, 581, 191, 2161);
INSERT INTO 'capvalue' VALUES (2171, 'SAMSUNG-SEC-SGHD900/1.0 NetFront/3.2');
INSERT INTO 'devicecapvalue' VALUES (36690, 581, 53, 2171);
INSERT INTO 'devicecapvalue' VALUES (36691, 582, 158, 2163);
INSERT INTO 'devicecapvalue' VALUES (36692, 582, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36693, 582, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36694, 582, 74, 656);
INSERT INTO 'devicecapvalue' VALUES (36695, 582, 7, 2170);
INSERT INTO 'devicecapvalue' VALUES (36696, 582, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36697, 582, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (36698, 582, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (36699, 582, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (36700, 582, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (36701, 582, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (36702, 582, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36703, 582, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36704, 582, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36705, 582, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36706, 582, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36707, 582, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36708, 582, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36709, 582, 154, 1014);
INSERT INTO 'capvalue' VALUES (2172, 'secure-socket');
INSERT INTO 'devicecapvalue' VALUES (36710, 582, 154, 2172);
INSERT INTO 'devicecapvalue' VALUES (36711, 582, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36712, 582, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36713, 582, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (36714, 582, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (36715, 582, 232, 595);
INSERT INTO 'devicecapvalue' VALUES (36716, 582, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36717, 582, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36718, 582, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36719, 582, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36720, 582, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36721, 582, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36722, 582, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36723, 582, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (36724, 582, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (36725, 582, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (36726, 582, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (36727, 582, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36728, 582, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (36729, 582, 191, 2161);
INSERT INTO 'devicecapvalue' VALUES (36730, 583, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (36731, 583, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36732, 583, 7, 2107);
INSERT INTO 'devicecapvalue' VALUES (36733, 583, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36734, 583, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (36735, 583, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (36736, 583, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36737, 583, 16, 2108);
INSERT INTO 'devicecapvalue' VALUES (36738, 583, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36739, 583, 50, 1103);
INSERT INTO 'devicecapvalue' VALUES (36740, 583, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (36741, 583, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (36742, 583, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (36743, 583, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36744, 583, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (36745, 583, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (36746, 583, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36747, 583, 51, 1496);
INSERT INTO 'capvalue' VALUES (2173, 'SAMSUNG-SGH-E250/E250BOGA3 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (36748, 583, 53, 2173);
INSERT INTO 'devicecapvalue' VALUES (36749, 584, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (36750, 584, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (36751, 584, 74, 653);
INSERT INTO 'capvalue' VALUES (2174, '176x197');
INSERT INTO 'devicecapvalue' VALUES (36752, 584, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (36753, 584, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36754, 584, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (36755, 584, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (36756, 584, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (36757, 584, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (36758, 584, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (36759, 584, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36760, 584, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36761, 584, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (36762, 584, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36763, 584, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (36764, 584, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36765, 584, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36766, 584, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36767, 584, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36768, 584, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36769, 584, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36770, 584, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36771, 584, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36772, 584, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (36773, 584, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (36774, 584, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (36775, 584, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36776, 584, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36777, 584, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36778, 584, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36779, 584, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36780, 584, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36781, 584, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36782, 584, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (36783, 584, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (36784, 584, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36785, 584, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (36786, 584, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (36787, 584, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (36788, 584, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36789, 584, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (36790, 584, 157, 1118);
INSERT INTO 'capvalue' VALUES (2175, '600 KB');
INSERT INTO 'devicecapvalue' VALUES (36791, 584, 191, 2175);
INSERT INTO 'devicecapvalue' VALUES (36792, 585, 158, 2163);
INSERT INTO 'devicecapvalue' VALUES (36793, 585, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (36794, 585, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36795, 585, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (36796, 585, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36797, 585, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (36798, 585, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (36799, 585, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (36800, 585, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (36801, 585, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (36802, 585, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36803, 585, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36804, 585, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (36805, 585, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36806, 585, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (36807, 585, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36808, 585, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36809, 585, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36810, 585, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36811, 585, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36812, 585, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36813, 585, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36814, 585, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36815, 585, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (36816, 585, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (36817, 585, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (36818, 585, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36819, 585, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36820, 585, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36821, 585, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36822, 585, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36823, 585, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36824, 585, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36825, 585, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (36826, 585, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (36827, 585, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (36828, 585, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (36829, 585, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36830, 585, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (36831, 585, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (36832, 585, 191, 2175);
INSERT INTO 'devicecapvalue' VALUES (36833, 586, 158, 2140);
INSERT INTO 'devicecapvalue' VALUES (36834, 586, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36835, 586, 74, 653);
INSERT INTO 'capvalue' VALUES (2176, '176x202');
INSERT INTO 'devicecapvalue' VALUES (36836, 586, 7, 2176);
INSERT INTO 'devicecapvalue' VALUES (36837, 586, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36838, 586, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (36839, 586, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (36840, 586, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (36841, 586, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (36842, 586, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (36843, 586, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36844, 586, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36845, 586, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (36846, 586, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36847, 586, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (36848, 586, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36849, 586, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36850, 586, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36851, 586, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36852, 586, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36853, 586, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36854, 586, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36855, 586, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36856, 586, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (36857, 586, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (36858, 586, 232, 106);
INSERT INTO 'devicecapvalue' VALUES (36859, 586, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36860, 586, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36861, 586, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36862, 586, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36863, 586, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36864, 586, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36865, 586, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36866, 586, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (36867, 586, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (36868, 586, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36869, 586, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (36870, 586, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (36871, 586, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (36872, 586, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36873, 586, 52, 1124);
INSERT INTO 'capvalue' VALUES (2177, '3ggp');
INSERT INTO 'devicecapvalue' VALUES (36874, 586, 157, 2177);
INSERT INTO 'devicecapvalue' VALUES (36875, 586, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (36876, 586, 191, 2161);
INSERT INTO 'capvalue' VALUES (2178, 'SAMSUNG-SGH-E390');
INSERT INTO 'devicecapvalue' VALUES (36877, 586, 53, 2178);
INSERT INTO 'capvalue' VALUES (2179, '2007-01-25');
INSERT INTO 'devicecapvalue' VALUES (36878, 587, 158, 2179);
INSERT INTO 'devicecapvalue' VALUES (36879, 587, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36880, 587, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36881, 587, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (36882, 587, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36883, 587, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (36884, 587, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (36885, 587, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (36886, 587, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (36887, 587, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (36888, 587, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36889, 587, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36890, 587, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (36891, 587, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36892, 587, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (36893, 587, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36894, 587, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36895, 587, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36896, 587, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36897, 587, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36898, 587, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36899, 587, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36900, 587, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (36901, 587, 155, 593);
INSERT INTO 'devicecapvalue' VALUES (36902, 587, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (36903, 587, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36904, 587, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36905, 587, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36906, 587, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36907, 587, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36908, 587, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36909, 587, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36910, 587, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36911, 587, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (36912, 587, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (36913, 587, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (36914, 587, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (36915, 587, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (36916, 587, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36917, 587, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (36918, 587, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (36919, 587, 191, 2166);
INSERT INTO 'devicecapvalue' VALUES (36920, 588, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (36921, 588, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36922, 588, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36923, 588, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (36924, 588, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36925, 588, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (36926, 588, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (36927, 588, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (36928, 588, 13, 859);
INSERT INTO 'capvalue' VALUES (2180, '2202009');
INSERT INTO 'devicecapvalue' VALUES (36929, 588, 76, 2180);
INSERT INTO 'devicecapvalue' VALUES (36930, 588, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36931, 588, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (36932, 588, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (36933, 588, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36934, 588, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (36935, 588, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36936, 588, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36937, 588, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36938, 588, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36939, 588, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36940, 588, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36941, 588, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36942, 588, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36943, 588, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (36944, 588, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (36945, 588, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (36946, 588, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36947, 588, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36948, 588, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36949, 588, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36950, 588, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36951, 588, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36952, 588, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36953, 588, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (36954, 588, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (36955, 588, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36956, 588, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (36957, 588, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (36958, 588, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (36959, 588, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (36960, 588, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (36961, 588, 157, 1118);
INSERT INTO 'capvalue' VALUES (2181, '1.2 MB');
INSERT INTO 'devicecapvalue' VALUES (36962, 588, 191, 2181);
INSERT INTO 'capvalue' VALUES (2182, 'SAMSUNG-SGH-E500/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (36963, 588, 53, 2182);
INSERT INTO 'devicecapvalue' VALUES (36964, 589, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (36965, 589, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (36966, 589, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (36967, 589, 7, 1150);
INSERT INTO 'devicecapvalue' VALUES (36968, 589, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (36969, 589, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (36970, 589, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (36971, 589, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (36972, 589, 13, 859);
INSERT INTO 'capvalue' VALUES (2183, '933888');
INSERT INTO 'devicecapvalue' VALUES (36973, 589, 76, 2183);
INSERT INTO 'devicecapvalue' VALUES (36974, 589, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (36975, 589, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (36976, 589, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (36977, 589, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (36978, 589, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (36979, 589, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (36980, 589, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (36981, 589, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (36982, 589, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (36983, 589, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (36984, 589, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (36985, 589, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (36986, 589, 155, 2144);
INSERT INTO 'devicecapvalue' VALUES (36987, 589, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (36988, 589, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (36989, 589, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (36990, 589, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (36991, 589, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (36992, 589, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (36993, 589, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (36994, 589, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (36995, 589, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (36996, 589, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (36997, 589, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (36998, 589, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (36999, 589, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (37000, 589, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (37001, 589, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37002, 589, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37003, 589, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (37004, 589, 191, 2166);
INSERT INTO 'capvalue' VALUES (2184, 'SEC-SGHE530/1.0 TSS/2.5');
INSERT INTO 'devicecapvalue' VALUES (37005, 589, 53, 2184);
INSERT INTO 'capvalue' VALUES (2185, '2007-01-11');
INSERT INTO 'devicecapvalue' VALUES (37006, 590, 158, 2185);
INSERT INTO 'devicecapvalue' VALUES (37007, 590, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (37008, 590, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37009, 590, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (37010, 590, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37011, 590, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (37012, 590, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (37013, 590, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (37014, 590, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (37015, 590, 76, 659);
INSERT INTO 'devicecapvalue' VALUES (37016, 590, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37017, 590, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37018, 590, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (37019, 590, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37020, 590, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (37021, 590, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (37022, 590, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37023, 590, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37024, 590, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (37025, 590, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (37026, 590, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (37027, 590, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37028, 590, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (37029, 590, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (37030, 590, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (37031, 590, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (37032, 590, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (37033, 590, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (37034, 590, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (37035, 590, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (37036, 590, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (37037, 590, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (37038, 590, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (37039, 590, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (37040, 590, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (37041, 590, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (37042, 590, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (37043, 590, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (37044, 590, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (37045, 590, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37046, 590, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (37047, 590, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37048, 590, 191, 2166);
INSERT INTO 'capvalue' VALUES (2186, 'Vodafone/1.0/SamsungSGHE570V/E570AEGB1 Browser/NF/3.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (37049, 590, 53, 2186);
INSERT INTO 'devicecapvalue' VALUES (37050, 591, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (37051, 591, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37052, 591, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (37053, 591, 7, 2110);
INSERT INTO 'devicecapvalue' VALUES (37054, 591, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (37055, 591, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37056, 591, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (37057, 591, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (37058, 591, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (37059, 591, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (37060, 591, 76, 2099);
INSERT INTO 'devicecapvalue' VALUES (37061, 591, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (37062, 591, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37063, 591, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37064, 591, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (37065, 591, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (37066, 591, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (37067, 591, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (37068, 591, 231, 1341);
INSERT INTO 'devicecapvalue' VALUES (37069, 591, 156, 2101);
INSERT INTO 'devicecapvalue' VALUES (37070, 591, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (37071, 591, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (37072, 591, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (37073, 591, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37074, 591, 51, 2146);
INSERT INTO 'capvalue' VALUES (2187, 'SEC-SGHE608*MzUxOTgyODkwOTg5MDUw');
INSERT INTO 'devicecapvalue' VALUES (37075, 591, 53, 2187);
INSERT INTO 'devicecapvalue' VALUES (37076, 592, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (37077, 592, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (37078, 592, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37079, 592, 7, 2174);
INSERT INTO 'cap' VALUES (243, 'CompatibleDevice', 1);
INSERT INTO 'capvalue' VALUES (2188, 'Samsung/SGH-530');
INSERT INTO 'devicecapvalue' VALUES (37080, 592, 243, 2188);
INSERT INTO 'capvalue' VALUES (2189, 'Samsung/SGH-E880');
INSERT INTO 'devicecapvalue' VALUES (37081, 592, 243, 2189);
INSERT INTO 'devicecapvalue' VALUES (37082, 592, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37083, 592, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (37084, 592, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (37085, 592, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (37086, 592, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (37087, 592, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (37088, 592, 76, 2183);
INSERT INTO 'devicecapvalue' VALUES (37089, 592, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37090, 592, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (37091, 592, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37092, 592, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (37093, 592, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37094, 592, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37095, 592, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (37096, 592, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (37097, 592, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (37098, 592, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (37099, 592, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37100, 592, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (37101, 592, 155, 2144);
INSERT INTO 'devicecapvalue' VALUES (37102, 592, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (37103, 592, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (37104, 592, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (37105, 592, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (37106, 592, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (37107, 592, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (37108, 592, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (37109, 592, 240, 244);
INSERT INTO 'capvalue' VALUES (2190, 'Nucleus OS');
INSERT INTO 'devicecapvalue' VALUES (37110, 592, 3, 2190);
INSERT INTO 'devicecapvalue' VALUES (37111, 592, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (37112, 592, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (37113, 592, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (37114, 592, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (37115, 592, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (37116, 592, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (37117, 592, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37118, 592, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37119, 592, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (37120, 592, 191, 2166);
INSERT INTO 'devicecapvalue' VALUES (37121, 593, 158, 2149);
INSERT INTO 'devicecapvalue' VALUES (37122, 593, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (37123, 593, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37124, 593, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (37125, 593, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37126, 593, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (37127, 593, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (37128, 593, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (37129, 593, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (37130, 593, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (37131, 593, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37132, 593, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37133, 593, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37134, 593, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (37135, 593, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37136, 593, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37137, 593, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (37138, 593, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (37139, 593, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (37140, 593, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (37141, 593, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37142, 593, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (37143, 593, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (37144, 593, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (37145, 593, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (37146, 593, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (37147, 593, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (37148, 593, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (37149, 593, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (37150, 593, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (37151, 593, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (37152, 593, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (37153, 593, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (37154, 593, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (37155, 593, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (37156, 593, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (37157, 593, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (37158, 593, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37159, 593, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (37160, 593, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37161, 593, 191, 2154);
INSERT INTO 'capvalue' VALUES (2191, 'SAMSUNG-SGH-E730/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.102 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (37162, 593, 53, 2191);
INSERT INTO 'devicecapvalue' VALUES (37163, 594, 158, 2149);
INSERT INTO 'devicecapvalue' VALUES (37164, 594, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (37165, 594, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37166, 594, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (37167, 594, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37168, 594, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (37169, 594, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (37170, 594, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (37171, 594, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (37172, 594, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (37173, 594, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37174, 594, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37175, 594, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37176, 594, 17, 2143);
INSERT INTO 'capvalue' VALUES (2192, 'samsung-acceleration');
INSERT INTO 'devicecapvalue' VALUES (37177, 594, 17, 2192);
INSERT INTO 'devicecapvalue' VALUES (37178, 594, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37179, 594, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37180, 594, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (37181, 594, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (37182, 594, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (37183, 594, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (37184, 594, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37185, 594, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (37186, 594, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (37187, 594, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (37188, 594, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (37189, 594, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (37190, 594, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (37191, 594, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (37192, 594, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (37193, 594, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (37194, 594, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (37195, 594, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (37196, 594, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (37197, 594, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (37198, 594, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (37199, 594, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (37200, 594, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (37201, 594, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37202, 594, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (37203, 594, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37204, 594, 191, 2154);
INSERT INTO 'capvalue' VALUES (2193, 'SAMSUNG-SGH-E760/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (37205, 594, 53, 2193);
INSERT INTO 'devicecapvalue' VALUES (37206, 595, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (37207, 595, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (37208, 595, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37209, 595, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (37210, 595, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37211, 595, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (37212, 595, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (37213, 595, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (37214, 595, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (37215, 595, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (37216, 595, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37217, 595, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37218, 595, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37219, 595, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (37220, 595, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37221, 595, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37222, 595, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (37223, 595, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (37224, 595, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (37225, 595, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (37226, 595, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37227, 595, 50, 2157);
INSERT INTO 'devicecapvalue' VALUES (37228, 595, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (37229, 595, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (37230, 595, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (37231, 595, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (37232, 595, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (37233, 595, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (37234, 595, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (37235, 595, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (37236, 595, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (37237, 595, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (37238, 595, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (37239, 595, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (37240, 595, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (37241, 595, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (37242, 595, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (37243, 595, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (37244, 595, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37245, 595, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37246, 595, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (37247, 595, 191, 2166);
INSERT INTO 'devicecapvalue' VALUES (37248, 596, 158, 2163);
INSERT INTO 'devicecapvalue' VALUES (37249, 596, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (37250, 596, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37251, 596, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (37252, 596, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37253, 596, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (37254, 596, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (37255, 596, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (37256, 596, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (37257, 596, 76, 2180);
INSERT INTO 'devicecapvalue' VALUES (37258, 596, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37259, 596, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37260, 596, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (37261, 596, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37262, 596, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (37263, 596, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (37264, 596, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37265, 596, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37266, 596, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (37267, 596, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (37268, 596, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (37269, 596, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (37270, 596, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37271, 596, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (37272, 596, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (37273, 596, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (37274, 596, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (37275, 596, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (37276, 596, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (37277, 596, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (37278, 596, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (37279, 596, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (37280, 596, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (37281, 596, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (37282, 596, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (37283, 596, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (37284, 596, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (37285, 596, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (37286, 596, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (37287, 596, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37288, 596, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37289, 596, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (37290, 596, 191, 2161);
INSERT INTO 'capvalue' VALUES (2194, 'SAMSUNG-SGH-E780/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (37291, 596, 53, 2194);
INSERT INTO 'devicecapvalue' VALUES (37292, 597, 158, 2163);
INSERT INTO 'devicecapvalue' VALUES (37293, 597, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (37294, 597, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37295, 597, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (37296, 597, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37297, 597, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (37298, 597, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (37299, 597, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (37300, 597, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (37301, 597, 76, 2180);
INSERT INTO 'devicecapvalue' VALUES (37302, 597, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37303, 597, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37304, 597, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (37305, 597, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37306, 597, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (37307, 597, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (37308, 597, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37309, 597, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37310, 597, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (37311, 597, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (37312, 597, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (37313, 597, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (37314, 597, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37315, 597, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (37316, 597, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (37317, 597, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (37318, 597, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (37319, 597, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (37320, 597, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (37321, 597, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (37322, 597, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (37323, 597, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (37324, 597, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (37325, 597, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (37326, 597, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (37327, 597, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (37328, 597, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (37329, 597, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (37330, 597, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (37331, 597, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37332, 597, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37333, 597, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (37334, 597, 191, 2161);
INSERT INTO 'devicecapvalue' VALUES (37335, 598, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (37336, 598, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (37337, 598, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37338, 598, 7, 2174);
INSERT INTO 'capvalue' VALUES (2195, 'yes');
INSERT INTO 'devicecapvalue' VALUES (37339, 598, 173, 2195);
INSERT INTO 'devicecapvalue' VALUES (37340, 598, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37341, 598, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (37342, 598, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (37343, 598, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (37344, 598, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (37345, 598, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (37346, 598, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37347, 598, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37348, 598, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (37349, 598, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (37350, 598, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37351, 598, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (37352, 598, 17, 2192);
INSERT INTO 'devicecapvalue' VALUES (37353, 598, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37354, 598, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37355, 598, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37356, 598, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37357, 598, 50, 2157);
INSERT INTO 'devicecapvalue' VALUES (37358, 598, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (37359, 598, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (37360, 598, 234, 244);
INSERT INTO 'devicecapvalue' VALUES (37361, 598, 235, 15);
INSERT INTO 'devicecapvalue' VALUES (37362, 598, 236, 15);
INSERT INTO 'devicecapvalue' VALUES (37363, 598, 237, 15);
INSERT INTO 'devicecapvalue' VALUES (37364, 598, 238, 15);
INSERT INTO 'devicecapvalue' VALUES (37365, 598, 239, 15);
INSERT INTO 'devicecapvalue' VALUES (37366, 598, 240, 15);
INSERT INTO 'devicecapvalue' VALUES (37367, 598, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (37368, 598, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (37369, 598, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (37370, 598, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (37371, 598, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37372, 598, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37373, 598, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (37374, 598, 191, 2166);
INSERT INTO 'capvalue' VALUES (2196, 'SEC-SGHE810/1.0');
INSERT INTO 'devicecapvalue' VALUES (37375, 598, 53, 2196);
INSERT INTO 'devicecapvalue' VALUES (37376, 599, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (37377, 599, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (37378, 599, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37379, 599, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (37380, 599, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37381, 599, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (37382, 599, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (37383, 599, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (37384, 599, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (37385, 599, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (37386, 599, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37387, 599, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37388, 599, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37389, 599, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (37390, 599, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37391, 599, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37392, 599, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (37393, 599, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (37394, 599, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (37395, 599, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (37396, 599, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37397, 599, 50, 2157);
INSERT INTO 'devicecapvalue' VALUES (37398, 599, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (37399, 599, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (37400, 599, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (37401, 599, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (37402, 599, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (37403, 599, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (37404, 599, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (37405, 599, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (37406, 599, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (37407, 599, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (37408, 599, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (37409, 599, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (37410, 599, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (37411, 599, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (37412, 599, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (37413, 599, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (37414, 599, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (37415, 599, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37416, 599, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (37417, 599, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37418, 599, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (37419, 599, 191, 2166);
INSERT INTO 'devicecapvalue' VALUES (37420, 600, 158, 2163);
INSERT INTO 'devicecapvalue' VALUES (37421, 600, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (37422, 600, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37423, 600, 7, 2170);
INSERT INTO 'devicecapvalue' VALUES (37424, 600, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37425, 600, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (37426, 600, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (37427, 600, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (37428, 600, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (37429, 600, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (37430, 600, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37431, 600, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37432, 600, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (37433, 600, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37434, 600, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (37435, 600, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (37436, 600, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37437, 600, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37438, 600, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (37439, 600, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (37440, 600, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (37441, 600, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (37442, 600, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37443, 600, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (37444, 600, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (37445, 600, 232, 595);
INSERT INTO 'devicecapvalue' VALUES (37446, 600, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (37447, 600, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (37448, 600, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (37449, 600, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (37450, 600, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (37451, 600, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (37452, 600, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (37453, 600, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (37454, 600, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (37455, 600, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (37456, 600, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (37457, 600, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37458, 600, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37459, 600, 191, 2161);
INSERT INTO 'capvalue' VALUES (2197, '2007-01-16');
INSERT INTO 'devicecapvalue' VALUES (37460, 601, 158, 2197);
INSERT INTO 'devicecapvalue' VALUES (37461, 601, 1, 106);
INSERT INTO 'capvalue' VALUES (2198, 'ignoreTitleCall');
INSERT INTO 'devicecapvalue' VALUES (37462, 601, 74, 2198);
INSERT INTO 'devicecapvalue' VALUES (37463, 601, 7, 2160);
INSERT INTO 'devicecapvalue' VALUES (37464, 601, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (37465, 601, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (37466, 601, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (37467, 601, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (37468, 601, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (37469, 601, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (37470, 601, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37471, 601, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37472, 601, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37473, 601, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (37474, 601, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37475, 601, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (37476, 601, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (37477, 601, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (37478, 601, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (37479, 601, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (37480, 601, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37481, 601, 50, 2157);
INSERT INTO 'devicecapvalue' VALUES (37482, 601, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (37483, 601, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (37484, 601, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (37485, 601, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (37486, 601, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (37487, 601, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (37488, 601, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (37489, 601, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (37490, 601, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (37491, 601, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (37492, 601, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (37493, 601, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (37494, 601, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (37495, 601, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (37496, 601, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (37497, 601, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (37498, 601, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (37499, 601, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37500, 601, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (37501, 601, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (37502, 601, 191, 2166);
INSERT INTO 'capvalue' VALUES (2199, 'SEC-SGHE900/1.0 NetFront/3.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (37503, 601, 53, 2199);
INSERT INTO 'devicecapvalue' VALUES (37504, 602, 56, 707);
INSERT INTO 'capvalue' VALUES (2200, '240x202');
INSERT INTO 'devicecapvalue' VALUES (37505, 602, 7, 2200);
INSERT INTO 'devicecapvalue' VALUES (37506, 602, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (37507, 602, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (37508, 602, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (37509, 602, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (37510, 602, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (37511, 602, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (37512, 602, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (37513, 602, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (37514, 602, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (37515, 602, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (37516, 602, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (37517, 602, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37518, 602, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (37519, 602, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (37520, 602, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (37521, 602, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (37522, 602, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37523, 602, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (37524, 602, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (37525, 602, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (37526, 602, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37527, 602, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37528, 602, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (37529, 602, 6, 879);
INSERT INTO 'capvalue' VALUES (2201, '-45');
INSERT INTO 'devicecapvalue' VALUES (37530, 602, 18, 2201);
INSERT INTO 'devicecapvalue' VALUES (37531, 602, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (37532, 602, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (37533, 602, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (37534, 602, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (37535, 602, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (37536, 602, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (37537, 602, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (37538, 602, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (37539, 602, 27, 41);
INSERT INTO 'devicecapvalue' VALUES (37540, 602, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (37541, 602, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (37542, 602, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (37543, 602, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (37544, 602, 38, 2131);
INSERT INTO 'devicecapvalue' VALUES (37545, 602, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (37546, 602, 39, 1049);
INSERT INTO 'devicecapvalue' VALUES (37547, 602, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (37548, 602, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (37549, 602, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (37550, 602, 41, 2070);
INSERT INTO 'devicecapvalue' VALUES (37551, 602, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (37552, 602, 41, 2071);
INSERT INTO 'devicecapvalue' VALUES (37553, 602, 41, 2072);
INSERT INTO 'devicecapvalue' VALUES (37554, 602, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (37555, 602, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (37556, 602, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (37557, 602, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (37558, 602, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (37559, 602, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (37560, 602, 41, 2074);
INSERT INTO 'devicecapvalue' VALUES (37561, 602, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (37562, 602, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (37563, 602, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (37564, 602, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (37565, 602, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (37566, 602, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (37567, 602, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (37568, 602, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (37569, 602, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (37570, 602, 41, 986);
INSERT INTO 'devicecapvalue' VALUES (37571, 602, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (37572, 602, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (37573, 602, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (37574, 602, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (37575, 602, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (37576, 602, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (37577, 602, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (37578, 602, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (37579, 602, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (37580, 602, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (37581, 602, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (37582, 602, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (37583, 602, 41, 2078);
INSERT INTO 'devicecapvalue' VALUES (37584, 602, 41, 2079);
INSERT INTO 'devicecapvalue' VALUES (37585, 602, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (37586, 602, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (37587, 602, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (37588, 602, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (37589, 602, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (37590, 602, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (37591, 602, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (37592, 602, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (37593, 602, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (37594, 602, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (37595, 602, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (37596, 602, 41, 2081);
INSERT INTO 'devicecapvalue' VALUES (37597, 602, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (37598, 602, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (37599, 602, 41, 2082);
INSERT INTO 'devicecapvalue' VALUES (37600, 602, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (37601, 602, 42, 2070);
INSERT INTO 'devicecapvalue' VALUES (37602, 602, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (37603, 602, 42, 2071);
INSERT INTO 'devicecapvalue' VALUES (37604, 602, 42, 2072);
INSERT INTO 'devicecapvalue' VALUES (37605, 602, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (37606, 602, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (37607, 602, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (37608, 602, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (37609, 602, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (37610, 602, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (37611, 602, 42, 2074);
INSERT INTO 'devicecapvalue' VALUES (37612, 602, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (37613, 602, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (37614, 602, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (37615, 602, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (37616, 602, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (37617, 602, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (37618, 602, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (37619, 602, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (37620, 602, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (37621, 602, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (37622, 602, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (37623, 602, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (37624, 602, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (37625, 602, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (37626, 602, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (37627, 602, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (37628, 602, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (37629, 602, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (37630, 602, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (37631, 602, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (37632, 602, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (37633, 602, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (37634, 602, 42, 2078);
INSERT INTO 'devicecapvalue' VALUES (37635, 602, 42, 2079);
INSERT INTO 'devicecapvalue' VALUES (37636, 602, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (37637, 602, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (37638, 602, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (37639, 602, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (37640, 602, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (37641, 602, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (37642, 602, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (37643, 602, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (37644, 602, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (37645, 602, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (37646, 602, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (37647, 602, 42, 2081);
INSERT INTO 'devicecapvalue' VALUES (37648, 602, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (37649, 602, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (37650, 602, 42, 2082);
INSERT INTO 'devicecapvalue' VALUES (37651, 602, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (37652, 602, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (37653, 602, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (37654, 602, 45, 18);
INSERT INTO 'devicecapvalue' VALUES (37655, 602, 58, 238);
INSERT INTO 'devicecapvalue' VALUES (37656, 602, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (37657, 602, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (37658, 602, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (37659, 602, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (37660, 602, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (37661, 602, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (37662, 602, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (37663, 602, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (37664, 602, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (37665, 602, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (37666, 602, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (37667, 602, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (37668, 602, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (37669, 602, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (37670, 602, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (37671, 602, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (37672, 602, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (37673, 602, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (37674, 602, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (37675, 602, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (37676, 602, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (37677, 602, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (37678, 602, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (37679, 602, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (37680, 602, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (37681, 602, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (37682, 602, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (37683, 602, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (37684, 602, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (37685, 602, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (37686, 602, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (37687, 602, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (37688, 602, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (37689, 602, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (37690, 602, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (37691, 602, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (37692, 602, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (37693, 602, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (37694, 602, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (37695, 602, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (37696, 602, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (37697, 602, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (37698, 602, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (37699, 602, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (37700, 602, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (37701, 602, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (37702, 602, 115, 2083);
INSERT INTO 'devicecapvalue' VALUES (37703, 602, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (37704, 602, 118, 238);
INSERT INTO 'devicecapvalue' VALUES (37705, 602, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (37706, 602, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (37707, 602, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (37708, 602, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (37709, 602, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (37710, 602, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (37711, 602, 125, 1);
INSERT INTO 'devicecapvalue' VALUES (37712, 602, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (37713, 602, 101, 2132);
INSERT INTO 'devicecapvalue' VALUES (37714, 602, 103, 2084);
INSERT INTO 'devicecapvalue' VALUES (37715, 602, 104, 2085);
INSERT INTO 'devicecapvalue' VALUES (37716, 602, 105, 2086);
INSERT INTO 'devicecapvalue' VALUES (37717, 602, 106, 727);
INSERT INTO 'devicecapvalue' VALUES (37718, 602, 107, 2087);
INSERT INTO 'devicecapvalue' VALUES (37719, 602, 108, 2088);
INSERT INTO 'devicecapvalue' VALUES (37720, 602, 109, 2089);
INSERT INTO 'devicecapvalue' VALUES (37721, 602, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (37722, 602, 114, 2094);
INSERT INTO 'devicecapvalue' VALUES (37723, 602, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (37724, 602, 62, 44);
INSERT INTO 'devicecapvalue' VALUES (37725, 602, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (37726, 602, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (37727, 602, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (37728, 602, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (37729, 602, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (37730, 602, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (37731, 602, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (37732, 602, 131, 922);
INSERT INTO 'devicecapvalue' VALUES (37733, 602, 67, 45);
INSERT INTO 'capvalue' VALUES (2202, 'SGH-F480/F480XEHJ1');
INSERT INTO 'devicecapvalue' VALUES (37734, 602, 68, 2202);
INSERT INTO 'devicecapvalue' VALUES (37735, 602, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (37736, 602, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (37737, 602, 116, 1444);
INSERT INTO 'devicecapvalue' VALUES (37738, 602, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (37739, 602, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (37740, 602, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (37741, 602, 136, 2090);
INSERT INTO 'devicecapvalue' VALUES (37742, 602, 137, 18);
INSERT INTO 'capvalue' VALUES (2203, '+491760000443');
INSERT INTO 'devicecapvalue' VALUES (37743, 602, 72, 2203);
INSERT INTO 'devicecapvalue' VALUES (37744, 602, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (37745, 602, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (37746, 602, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (37747, 602, 47, 2070);
INSERT INTO 'devicecapvalue' VALUES (37748, 602, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (37749, 602, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (37750, 602, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (37751, 602, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (37752, 602, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (37753, 602, 47, 2074);
INSERT INTO 'devicecapvalue' VALUES (37754, 602, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (37755, 602, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (37756, 602, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (37757, 602, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (37758, 602, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (37759, 602, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (37760, 602, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (37761, 602, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (37762, 602, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (37763, 602, 47, 1049);
INSERT INTO 'devicecapvalue' VALUES (37764, 602, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (37765, 602, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (37766, 602, 47, 2078);
INSERT INTO 'devicecapvalue' VALUES (37767, 602, 47, 2079);
INSERT INTO 'devicecapvalue' VALUES (37768, 602, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (37769, 602, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (37770, 602, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (37771, 602, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (37772, 602, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (37773, 602, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (37774, 602, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (37775, 602, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (37776, 602, 47, 2081);
INSERT INTO 'devicecapvalue' VALUES (37777, 602, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (37778, 602, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (37779, 602, 47, 2082);
INSERT INTO 'devicecapvalue' VALUES (37780, 602, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (37781, 602, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (37782, 602, 48, 92);
INSERT INTO 'capvalue' VALUES (2204, '2339712');
INSERT INTO 'devicecapvalue' VALUES (37783, 602, 49, 2204);
INSERT INTO 'capvalue' VALUES (2205, 'SAMSUNG-SGH-F480/F480XEHJ1 SHP/VPP/R5 NetFront/3.4 Qtv5.3 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (37784, 602, 53, 2205);
INSERT INTO 'devicecapvalue' VALUES (37785, 603, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (37786, 603, 7, 688);
INSERT INTO 'devicecapvalue' VALUES (37787, 603, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (37788, 603, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (37789, 603, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (37790, 603, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (37791, 603, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (37792, 603, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (37793, 603, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (37794, 603, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (37795, 603, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (37796, 603, 76, 1074);
INSERT INTO 'devicecapvalue' VALUES (37797, 603, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (37798, 603, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37799, 603, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (37800, 603, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37801, 603, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37802, 603, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (37803, 603, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (37804, 603, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (37805, 603, 155, 1157);
INSERT INTO 'devicecapvalue' VALUES (37806, 603, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (37807, 603, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (37808, 603, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (37809, 603, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (37810, 603, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (37811, 603, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (37812, 603, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (37813, 603, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (37814, 603, 52, 1086);
INSERT INTO 'devicecapvalue' VALUES (37815, 603, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (37816, 603, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (37817, 603, 191, 2166);
INSERT INTO 'devicecapvalue' VALUES (37818, 604, 56, 707);
INSERT INTO 'capvalue' VALUES (2206, '183x432');
INSERT INTO 'devicecapvalue' VALUES (37819, 604, 7, 2206);
INSERT INTO 'devicecapvalue' VALUES (37820, 604, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (37821, 604, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (37822, 604, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (37823, 604, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (37824, 604, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (37825, 604, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (37826, 604, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (37827, 604, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (37828, 604, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (37829, 604, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (37830, 604, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (37831, 604, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (37832, 604, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (37833, 604, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (37834, 604, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (37835, 604, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (37836, 604, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (37837, 604, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (37838, 604, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (37839, 604, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (37840, 604, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37841, 604, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (37842, 604, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (37843, 604, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (37844, 604, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (37845, 604, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (37846, 604, 20, 30);
INSERT INTO 'capvalue' VALUES (2207, '-13');
INSERT INTO 'devicecapvalue' VALUES (37847, 604, 21, 2207);
INSERT INTO 'devicecapvalue' VALUES (37848, 604, 22, 1183);
INSERT INTO 'capvalue' VALUES (2208, '-15');
INSERT INTO 'devicecapvalue' VALUES (37849, 604, 23, 2208);
INSERT INTO 'devicecapvalue' VALUES (37850, 604, 24, 860);
INSERT INTO 'devicecapvalue' VALUES (37851, 604, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (37852, 604, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (37853, 604, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (37854, 604, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (37855, 604, 38, 2131);
INSERT INTO 'devicecapvalue' VALUES (37856, 604, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (37857, 604, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (37858, 604, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (37859, 604, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (37860, 604, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (37861, 604, 41, 2070);
INSERT INTO 'devicecapvalue' VALUES (37862, 604, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (37863, 604, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (37864, 604, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (37865, 604, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (37866, 604, 41, 2074);
INSERT INTO 'devicecapvalue' VALUES (37867, 604, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (37868, 604, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (37869, 604, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (37870, 604, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (37871, 604, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (37872, 604, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (37873, 604, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (37874, 604, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (37875, 604, 41, 986);
INSERT INTO 'devicecapvalue' VALUES (37876, 604, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (37877, 604, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (37878, 604, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (37879, 604, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (37880, 604, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (37881, 604, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (37882, 604, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (37883, 604, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (37884, 604, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (37885, 604, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (37886, 604, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (37887, 604, 41, 2078);
INSERT INTO 'devicecapvalue' VALUES (37888, 604, 41, 2079);
INSERT INTO 'devicecapvalue' VALUES (37889, 604, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (37890, 604, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (37891, 604, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (37892, 604, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (37893, 604, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (37894, 604, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (37895, 604, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (37896, 604, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (37897, 604, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (37898, 604, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (37899, 604, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (37900, 604, 41, 2081);
INSERT INTO 'devicecapvalue' VALUES (37901, 604, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (37902, 604, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (37903, 604, 41, 2082);
INSERT INTO 'devicecapvalue' VALUES (37904, 604, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (37905, 604, 42, 2070);
INSERT INTO 'devicecapvalue' VALUES (37906, 604, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (37907, 604, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (37908, 604, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (37909, 604, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (37910, 604, 42, 2074);
INSERT INTO 'devicecapvalue' VALUES (37911, 604, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (37912, 604, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (37913, 604, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (37914, 604, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (37915, 604, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (37916, 604, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (37917, 604, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (37918, 604, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (37919, 604, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (37920, 604, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (37921, 604, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (37922, 604, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (37923, 604, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (37924, 604, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (37925, 604, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (37926, 604, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (37927, 604, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (37928, 604, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (37929, 604, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (37930, 604, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (37931, 604, 42, 2078);
INSERT INTO 'devicecapvalue' VALUES (37932, 604, 42, 2079);
INSERT INTO 'devicecapvalue' VALUES (37933, 604, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (37934, 604, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (37935, 604, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (37936, 604, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (37937, 604, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (37938, 604, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (37939, 604, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (37940, 604, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (37941, 604, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (37942, 604, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (37943, 604, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (37944, 604, 42, 2081);
INSERT INTO 'devicecapvalue' VALUES (37945, 604, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (37946, 604, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (37947, 604, 42, 2082);
INSERT INTO 'devicecapvalue' VALUES (37948, 604, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (37949, 604, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (37950, 604, 58, 238);
INSERT INTO 'devicecapvalue' VALUES (37951, 604, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (37952, 604, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (37953, 604, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (37954, 604, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (37955, 604, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (37956, 604, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (37957, 604, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (37958, 604, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (37959, 604, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (37960, 604, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (37961, 604, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (37962, 604, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (37963, 604, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (37964, 604, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (37965, 604, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (37966, 604, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (37967, 604, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (37968, 604, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (37969, 604, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (37970, 604, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (37971, 604, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (37972, 604, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (37973, 604, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (37974, 604, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (37975, 604, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (37976, 604, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (37977, 604, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (37978, 604, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (37979, 604, 115, 2131);
INSERT INTO 'devicecapvalue' VALUES (37980, 604, 59, 612);
INSERT INTO 'devicecapvalue' VALUES (37981, 604, 103, 2084);
INSERT INTO 'devicecapvalue' VALUES (37982, 604, 104, 2085);
INSERT INTO 'devicecapvalue' VALUES (37983, 604, 105, 2086);
INSERT INTO 'devicecapvalue' VALUES (37984, 604, 106, 727);
INSERT INTO 'devicecapvalue' VALUES (37985, 604, 107, 2087);
INSERT INTO 'devicecapvalue' VALUES (37986, 604, 108, 2088);
INSERT INTO 'devicecapvalue' VALUES (37987, 604, 109, 2089);
INSERT INTO 'devicecapvalue' VALUES (37988, 604, 114, 852);
INSERT INTO 'devicecapvalue' VALUES (37989, 604, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (37990, 604, 62, 44);
INSERT INTO 'devicecapvalue' VALUES (37991, 604, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (37992, 604, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (37993, 604, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (37994, 604, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (37995, 604, 131, 922);
INSERT INTO 'devicecapvalue' VALUES (37996, 604, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (37997, 604, 68, 243);
INSERT INTO 'devicecapvalue' VALUES (37998, 604, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (37999, 604, 116, 1444);
INSERT INTO 'devicecapvalue' VALUES (38000, 604, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (38001, 604, 71, 15);
INSERT INTO 'capvalue' VALUES (2209, '+17815511212');
INSERT INTO 'devicecapvalue' VALUES (38002, 604, 138, 2209);
INSERT INTO 'devicecapvalue' VALUES (38003, 604, 72, 2209);
INSERT INTO 'devicecapvalue' VALUES (38004, 604, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (38005, 604, 47, 2070);
INSERT INTO 'devicecapvalue' VALUES (38006, 604, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (38007, 604, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (38008, 604, 47, 2074);
INSERT INTO 'devicecapvalue' VALUES (38009, 604, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (38010, 604, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (38011, 604, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (38012, 604, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (38013, 604, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (38014, 604, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (38015, 604, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (38016, 604, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (38017, 604, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (38018, 604, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (38019, 604, 47, 2078);
INSERT INTO 'devicecapvalue' VALUES (38020, 604, 47, 2079);
INSERT INTO 'devicecapvalue' VALUES (38021, 604, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (38022, 604, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (38023, 604, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (38024, 604, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (38025, 604, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (38026, 604, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (38027, 604, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (38028, 604, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (38029, 604, 47, 2081);
INSERT INTO 'devicecapvalue' VALUES (38030, 604, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (38031, 604, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (38032, 604, 47, 2082);
INSERT INTO 'devicecapvalue' VALUES (38033, 604, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (38034, 604, 4, 5);
INSERT INTO 'capvalue' VALUES (2210, '432');
INSERT INTO 'devicecapvalue' VALUES (38035, 604, 5, 2210);
INSERT INTO 'devicecapvalue' VALUES (38036, 604, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (38037, 604, 48, 92);
INSERT INTO 'capvalue' VALUES (2211, '2755456');
INSERT INTO 'devicecapvalue' VALUES (38038, 604, 49, 2211);
INSERT INTO 'devicecapvalue' VALUES (38039, 604, 53, 1475);
INSERT INTO 'devicecapvalue' VALUES (38040, 605, 7, 2112);
INSERT INTO 'devicecapvalue' VALUES (38041, 605, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (38042, 605, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (38043, 605, 9, 864);
INSERT INTO 'devicecapvalue' VALUES (38044, 605, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (38045, 605, 11, 864);
INSERT INTO 'devicecapvalue' VALUES (38046, 605, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (38047, 605, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (38048, 605, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (38049, 605, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (38050, 605, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (38051, 605, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (38052, 605, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (38053, 605, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (38054, 605, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (38055, 605, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (38056, 605, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (38057, 605, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (38058, 605, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (38059, 605, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (38060, 605, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (38061, 605, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (38062, 605, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (38063, 605, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (38064, 605, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (38065, 605, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (38066, 605, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (38067, 605, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (38068, 605, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (38069, 605, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (38070, 605, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (38071, 605, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (38072, 605, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (38073, 605, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (38074, 605, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (38075, 605, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (38076, 605, 32, 612);
INSERT INTO 'devicecapvalue' VALUES (38077, 605, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (38078, 605, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (38079, 605, 35, 45);
INSERT INTO 'devicecapvalue' VALUES (38080, 605, 36, 243);
INSERT INTO 'devicecapvalue' VALUES (38081, 605, 37, 47);
INSERT INTO 'devicecapvalue' VALUES (38082, 605, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (38083, 605, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (38084, 605, 39, 136);
INSERT INTO 'devicecapvalue' VALUES (38085, 605, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (38086, 605, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (38087, 605, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (38088, 605, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (38089, 605, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (38090, 605, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (38091, 605, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (38092, 605, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (38093, 605, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (38094, 605, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (38095, 605, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (38096, 605, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (38097, 605, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (38098, 605, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (38099, 605, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (38100, 605, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (38101, 605, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (38102, 605, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (38103, 605, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (38104, 605, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (38105, 605, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (38106, 605, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (38107, 605, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (38108, 605, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (38109, 605, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (38110, 605, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (38111, 605, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (38112, 605, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (38113, 605, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (38114, 605, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (38115, 605, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (38116, 605, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (38117, 605, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (38118, 605, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (38119, 605, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (38120, 605, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (38121, 605, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (38122, 605, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (38123, 605, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (38124, 605, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (38125, 605, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (38126, 605, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (38127, 605, 45, 2113);
INSERT INTO 'devicecapvalue' VALUES (38128, 605, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (38129, 605, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (38130, 605, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (38131, 605, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (38132, 605, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (38133, 605, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (38134, 605, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (38135, 605, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (38136, 605, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (38137, 605, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (38138, 605, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (38139, 605, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (38140, 605, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (38141, 605, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (38142, 605, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (38143, 605, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (38144, 605, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (38145, 605, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (38146, 605, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (38147, 605, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (38148, 605, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (38149, 605, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (38150, 605, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (38151, 605, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (38152, 605, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (38153, 605, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (38154, 605, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (38155, 605, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (38156, 605, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (38157, 605, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (38158, 605, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (38159, 605, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (38160, 605, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (38161, 605, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (38162, 605, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (38163, 605, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (38164, 605, 49, 1031);
INSERT INTO 'capvalue' VALUES (2212, 'SAMSUNG-SGH-G800/ADGJ1 SHP/VPP/R5 NetFront/3.4 SMM-MMS/1.2.0');
INSERT INTO 'devicecapvalue' VALUES (38165, 605, 53, 2212);
INSERT INTO 'devicecapvalue' VALUES (38166, 606, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (38167, 606, 79, 15);
INSERT INTO 'devicecapvalue' VALUES (38168, 606, 7, 1916);
INSERT INTO 'devicecapvalue' VALUES (38169, 606, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (38170, 606, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (38171, 606, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (38172, 606, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (38173, 606, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (38174, 606, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (38175, 606, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (38176, 606, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (38177, 606, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (38178, 606, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (38179, 606, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (38180, 606, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (38181, 606, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (38182, 606, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (38183, 606, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (38184, 606, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (38185, 606, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (38186, 606, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (38187, 606, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (38188, 606, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (38189, 606, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (38190, 606, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (38191, 606, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (38192, 606, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (38193, 606, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (38194, 606, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (38195, 606, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (38196, 606, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (38197, 606, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (38198, 606, 20, 1244);
INSERT INTO 'devicecapvalue' VALUES (38199, 606, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (38200, 606, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (38201, 606, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (38202, 606, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (38203, 606, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (38204, 606, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (38205, 606, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (38206, 606, 57, 28);
INSERT INTO 'devicecapvalue' VALUES (38207, 606, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (38208, 606, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (38209, 606, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (38210, 606, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (38211, 606, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (38212, 606, 38, 1045);
INSERT INTO 'devicecapvalue' VALUES (38213, 606, 38, 616);
INSERT INTO 'devicecapvalue' VALUES (38214, 606, 38, 867);
INSERT INTO 'devicecapvalue' VALUES (38215, 606, 38, 1050);
INSERT INTO 'devicecapvalue' VALUES (38216, 606, 38, 1578);
INSERT INTO 'devicecapvalue' VALUES (38217, 606, 38, 51);
INSERT INTO 'devicecapvalue' VALUES (38218, 606, 38, 1004);
INSERT INTO 'devicecapvalue' VALUES (38219, 606, 38, 865);
INSERT INTO 'devicecapvalue' VALUES (38220, 606, 38, 1919);
INSERT INTO 'devicecapvalue' VALUES (38221, 606, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (38222, 606, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (38223, 606, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (38224, 606, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (38225, 606, 39, 1050);
INSERT INTO 'devicecapvalue' VALUES (38226, 606, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (38227, 606, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (38228, 606, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (38229, 606, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (38230, 606, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (38231, 606, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (38232, 606, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (38233, 606, 40, 125);
INSERT INTO 'devicecapvalue' VALUES (38234, 606, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (38235, 606, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (38236, 606, 40, 1580);
INSERT INTO 'devicecapvalue' VALUES (38237, 606, 40, 131);
INSERT INTO 'devicecapvalue' VALUES (38238, 606, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (38239, 606, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (38240, 606, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (38241, 606, 40, 135);
INSERT INTO 'capvalue' VALUES (2213, 'audio/xmf0');
INSERT INTO 'devicecapvalue' VALUES (38242, 606, 40, 2213);
INSERT INTO 'capvalue' VALUES (2214, 'audio/xmf1');
INSERT INTO 'devicecapvalue' VALUES (38243, 606, 40, 2214);
INSERT INTO 'devicecapvalue' VALUES (38244, 606, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (38245, 606, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (38246, 606, 41, 964);
INSERT INTO 'capvalue' VALUES (2215, 'application/vnd.x-smaf');
INSERT INTO 'devicecapvalue' VALUES (38247, 606, 41, 2215);
INSERT INTO 'devicecapvalue' VALUES (38248, 606, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (38249, 606, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (38250, 606, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (38251, 606, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (38252, 606, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (38253, 606, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (38254, 606, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (38255, 606, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (38256, 606, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (38257, 606, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (38258, 606, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (38259, 606, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (38260, 606, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (38261, 606, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (38262, 606, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (38263, 606, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (38264, 606, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (38265, 606, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (38266, 606, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (38267, 606, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (38268, 606, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (38269, 606, 41, 128);
INSERT INTO 'devicecapvalue' VALUES (38270, 606, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (38271, 606, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (38272, 606, 41, 618);
INSERT INTO 'capvalue' VALUES (2216, 'audio/x-nokia-rng');
INSERT INTO 'devicecapvalue' VALUES (38273, 606, 41, 2216);
INSERT INTO 'devicecapvalue' VALUES (38274, 606, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (38275, 606, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (38276, 606, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (38277, 606, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (38278, 606, 41, 2213);
INSERT INTO 'devicecapvalue' VALUES (38279, 606, 41, 2214);
INSERT INTO 'devicecapvalue' VALUES (38280, 606, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (38281, 606, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (38282, 606, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (38283, 606, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (38284, 606, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (38285, 606, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (38286, 606, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (38287, 606, 42, 964);
INSERT INTO 'devicecapvalue' VALUES (38288, 606, 42, 2215);
INSERT INTO 'devicecapvalue' VALUES (38289, 606, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (38290, 606, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (38291, 606, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (38292, 606, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (38293, 606, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (38294, 606, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (38295, 606, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (38296, 606, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (38297, 606, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (38298, 606, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (38299, 606, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (38300, 606, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (38301, 606, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (38302, 606, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (38303, 606, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (38304, 606, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (38305, 606, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (38306, 606, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (38307, 606, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (38308, 606, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (38309, 606, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (38310, 606, 42, 128);
INSERT INTO 'devicecapvalue' VALUES (38311, 606, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (38312, 606, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (38313, 606, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (38314, 606, 42, 2216);
INSERT INTO 'devicecapvalue' VALUES (38315, 606, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (38316, 606, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (38317, 606, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (38318, 606, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (38319, 606, 42, 2213);
INSERT INTO 'devicecapvalue' VALUES (38320, 606, 42, 2214);
INSERT INTO 'devicecapvalue' VALUES (38321, 606, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (38322, 606, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (38323, 606, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (38324, 606, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (38325, 606, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (38326, 606, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (38327, 606, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (38328, 606, 45, 53);
INSERT INTO 'devicecapvalue' VALUES (38329, 606, 45, 1051);
INSERT INTO 'devicecapvalue' VALUES (38330, 606, 45, 67);
INSERT INTO 'devicecapvalue' VALUES (38331, 606, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (38332, 606, 58, 238);
INSERT INTO 'devicecapvalue' VALUES (38333, 606, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (38334, 606, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (38335, 606, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (38336, 606, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (38337, 606, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (38338, 606, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (38339, 606, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (38340, 606, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (38341, 606, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (38342, 606, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (38343, 606, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (38344, 606, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (38345, 606, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (38346, 606, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (38347, 606, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (38348, 606, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (38349, 606, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (38350, 606, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (38351, 606, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (38352, 606, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (38353, 606, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (38354, 606, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (38355, 606, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (38356, 606, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (38357, 606, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (38358, 606, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (38359, 606, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (38360, 606, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (38361, 606, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (38362, 606, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (38363, 606, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (38364, 606, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (38365, 606, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (38366, 606, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (38367, 606, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (38368, 606, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (38369, 606, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (38370, 606, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (38371, 606, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (38372, 606, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (38373, 606, 115, 1577);
INSERT INTO 'devicecapvalue' VALUES (38374, 606, 197, 1594);
INSERT INTO 'devicecapvalue' VALUES (38375, 606, 141, 238);
INSERT INTO 'devicecapvalue' VALUES (38376, 606, 117, 45);
INSERT INTO 'devicecapvalue' VALUES (38377, 606, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (38378, 606, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (38379, 606, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (38380, 606, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (38381, 606, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (38382, 606, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (38383, 606, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (38384, 606, 102, 1926);
INSERT INTO 'devicecapvalue' VALUES (38385, 606, 103, 1604);
INSERT INTO 'devicecapvalue' VALUES (38386, 606, 104, 944);
INSERT INTO 'capvalue' VALUES (2217, 'file:///c:/private/102033e6/midlets/[1015ee4f]/scratch/');
INSERT INTO 'devicecapvalue' VALUES (38387, 606, 105, 2217);
INSERT INTO 'devicecapvalue' VALUES (38388, 606, 106, 1607);
INSERT INTO 'devicecapvalue' VALUES (38389, 606, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (38390, 606, 108, 1609);
INSERT INTO 'devicecapvalue' VALUES (38391, 606, 109, 1928);
INSERT INTO 'devicecapvalue' VALUES (38392, 606, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (38393, 606, 114, 1911);
INSERT INTO 'devicecapvalue' VALUES (38394, 606, 114, 1611);
INSERT INTO 'devicecapvalue' VALUES (38395, 606, 114, 1612);
INSERT INTO 'devicecapvalue' VALUES (38396, 606, 114, 1613);
INSERT INTO 'devicecapvalue' VALUES (38397, 606, 114, 1614);
INSERT INTO 'devicecapvalue' VALUES (38398, 606, 114, 1615);
INSERT INTO 'devicecapvalue' VALUES (38399, 606, 114, 1616);
INSERT INTO 'devicecapvalue' VALUES (38400, 606, 114, 1617);
INSERT INTO 'devicecapvalue' VALUES (38401, 606, 114, 1618);
INSERT INTO 'devicecapvalue' VALUES (38402, 606, 114, 1619);
INSERT INTO 'devicecapvalue' VALUES (38403, 606, 114, 1620);
INSERT INTO 'devicecapvalue' VALUES (38404, 606, 114, 1621);
INSERT INTO 'devicecapvalue' VALUES (38405, 606, 114, 1622);
INSERT INTO 'devicecapvalue' VALUES (38406, 606, 114, 1623);
INSERT INTO 'devicecapvalue' VALUES (38407, 606, 114, 1624);
INSERT INTO 'devicecapvalue' VALUES (38408, 606, 114, 1625);
INSERT INTO 'devicecapvalue' VALUES (38409, 606, 114, 1626);
INSERT INTO 'devicecapvalue' VALUES (38410, 606, 114, 1627);
INSERT INTO 'devicecapvalue' VALUES (38411, 606, 114, 1628);
INSERT INTO 'devicecapvalue' VALUES (38412, 606, 114, 1629);
INSERT INTO 'devicecapvalue' VALUES (38413, 606, 114, 1630);
INSERT INTO 'devicecapvalue' VALUES (38414, 606, 114, 1631);
INSERT INTO 'devicecapvalue' VALUES (38415, 606, 114, 1632);
INSERT INTO 'devicecapvalue' VALUES (38416, 606, 114, 1633);
INSERT INTO 'devicecapvalue' VALUES (38417, 606, 114, 1634);
INSERT INTO 'devicecapvalue' VALUES (38418, 606, 114, 1635);
INSERT INTO 'devicecapvalue' VALUES (38419, 606, 114, 1636);
INSERT INTO 'devicecapvalue' VALUES (38420, 606, 114, 1637);
INSERT INTO 'devicecapvalue' VALUES (38421, 606, 114, 1638);
INSERT INTO 'devicecapvalue' VALUES (38422, 606, 114, 1639);
INSERT INTO 'devicecapvalue' VALUES (38423, 606, 114, 1640);
INSERT INTO 'devicecapvalue' VALUES (38424, 606, 114, 1641);
INSERT INTO 'devicecapvalue' VALUES (38425, 606, 114, 1642);
INSERT INTO 'devicecapvalue' VALUES (38426, 606, 114, 1643);
INSERT INTO 'devicecapvalue' VALUES (38427, 606, 114, 1644);
INSERT INTO 'devicecapvalue' VALUES (38428, 606, 114, 1645);
INSERT INTO 'devicecapvalue' VALUES (38429, 606, 114, 1646);
INSERT INTO 'devicecapvalue' VALUES (38430, 606, 114, 1647);
INSERT INTO 'devicecapvalue' VALUES (38431, 606, 114, 1648);
INSERT INTO 'devicecapvalue' VALUES (38432, 606, 114, 1649);
INSERT INTO 'devicecapvalue' VALUES (38433, 606, 114, 1650);
INSERT INTO 'devicecapvalue' VALUES (38434, 606, 114, 1651);
INSERT INTO 'devicecapvalue' VALUES (38435, 606, 114, 1652);
INSERT INTO 'devicecapvalue' VALUES (38436, 606, 114, 1653);
INSERT INTO 'devicecapvalue' VALUES (38437, 606, 114, 1654);
INSERT INTO 'devicecapvalue' VALUES (38438, 606, 114, 1655);
INSERT INTO 'devicecapvalue' VALUES (38439, 606, 114, 1656);
INSERT INTO 'devicecapvalue' VALUES (38440, 606, 114, 1657);
INSERT INTO 'devicecapvalue' VALUES (38441, 606, 114, 1658);
INSERT INTO 'devicecapvalue' VALUES (38442, 606, 114, 1659);
INSERT INTO 'devicecapvalue' VALUES (38443, 606, 114, 1660);
INSERT INTO 'devicecapvalue' VALUES (38444, 606, 114, 1661);
INSERT INTO 'devicecapvalue' VALUES (38445, 606, 114, 1662);
INSERT INTO 'devicecapvalue' VALUES (38446, 606, 114, 1663);
INSERT INTO 'devicecapvalue' VALUES (38447, 606, 114, 1664);
INSERT INTO 'devicecapvalue' VALUES (38448, 606, 114, 1665);
INSERT INTO 'devicecapvalue' VALUES (38449, 606, 114, 1666);
INSERT INTO 'devicecapvalue' VALUES (38450, 606, 114, 1667);
INSERT INTO 'devicecapvalue' VALUES (38451, 606, 114, 1668);
INSERT INTO 'devicecapvalue' VALUES (38452, 606, 114, 1669);
INSERT INTO 'devicecapvalue' VALUES (38453, 606, 114, 1670);
INSERT INTO 'devicecapvalue' VALUES (38454, 606, 114, 1672);
INSERT INTO 'devicecapvalue' VALUES (38455, 606, 114, 1673);
INSERT INTO 'devicecapvalue' VALUES (38456, 606, 114, 1674);
INSERT INTO 'devicecapvalue' VALUES (38457, 606, 114, 1260);
INSERT INTO 'devicecapvalue' VALUES (38458, 606, 114, 1912);
INSERT INTO 'devicecapvalue' VALUES (38459, 606, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (38460, 606, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (38461, 606, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (38462, 606, 204, 1677);
INSERT INTO 'devicecapvalue' VALUES (38463, 606, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (38464, 606, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (38465, 606, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (38466, 606, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (38467, 606, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (38468, 606, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (38469, 606, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (38470, 606, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (38471, 606, 67, 45);
INSERT INTO 'capvalue' VALUES (2218, 'Samsung/SGH-G810/10CEHE3');
INSERT INTO 'devicecapvalue' VALUES (38472, 606, 68, 2218);
INSERT INTO 'devicecapvalue' VALUES (38473, 606, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (38474, 606, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (38475, 606, 132, 1577);
INSERT INTO 'devicecapvalue' VALUES (38476, 606, 133, 1585);
INSERT INTO 'devicecapvalue' VALUES (38477, 606, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (38478, 606, 149, 1680);
INSERT INTO 'devicecapvalue' VALUES (38479, 606, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (38480, 606, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (38481, 606, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (38482, 606, 136, 1585);
INSERT INTO 'devicecapvalue' VALUES (38483, 606, 137, 1396);
INSERT INTO 'devicecapvalue' VALUES (38484, 606, 137, 66);
INSERT INTO 'devicecapvalue' VALUES (38485, 606, 137, 52);
INSERT INTO 'devicecapvalue' VALUES (38486, 606, 137, 1397);
INSERT INTO 'devicecapvalue' VALUES (38487, 606, 137, 1398);
INSERT INTO 'devicecapvalue' VALUES (38488, 606, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (38489, 606, 137, 96);
INSERT INTO 'devicecapvalue' VALUES (38490, 606, 138, 950);
INSERT INTO 'devicecapvalue' VALUES (38491, 606, 72, 951);
INSERT INTO 'devicecapvalue' VALUES (38492, 606, 47, 56);
INSERT INTO 'devicecapvalue' VALUES (38493, 606, 47, 868);
INSERT INTO 'devicecapvalue' VALUES (38494, 606, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (38495, 606, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (38496, 606, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (38497, 606, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (38498, 606, 47, 1684);
INSERT INTO 'devicecapvalue' VALUES (38499, 606, 47, 986);
INSERT INTO 'devicecapvalue' VALUES (38500, 606, 47, 988);
INSERT INTO 'devicecapvalue' VALUES (38501, 606, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (38502, 606, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (38503, 606, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (38504, 606, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (38505, 606, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (38506, 606, 49, 1457);
INSERT INTO 'devicecapvalue' VALUES (38507, 607, 56, 707);
INSERT INTO 'capvalue' VALUES (2219, '240x348');
INSERT INTO 'devicecapvalue' VALUES (38508, 607, 7, 2219);
INSERT INTO 'devicecapvalue' VALUES (38509, 607, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (38510, 607, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (38511, 607, 9, 603);
INSERT INTO 'devicecapvalue' VALUES (38512, 607, 10, 1871);
INSERT INTO 'devicecapvalue' VALUES (38513, 607, 11, 649);
INSERT INTO 'devicecapvalue' VALUES (38514, 607, 12, 603);
INSERT INTO 'devicecapvalue' VALUES (38515, 607, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (38516, 607, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (38517, 607, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (38518, 607, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (38519, 607, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (38520, 607, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (38521, 607, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (38522, 607, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (38523, 607, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (38524, 607, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (38525, 607, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (38526, 607, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (38527, 607, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (38528, 607, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (38529, 607, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (38530, 607, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (38531, 607, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (38532, 607, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (38533, 607, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (38534, 607, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (38535, 607, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (38536, 607, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (38537, 607, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (38538, 607, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (38539, 607, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (38540, 607, 38, 51);
INSERT INTO 'devicecapvalue' VALUES (38541, 607, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (38542, 607, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (38543, 607, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (38544, 607, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (38545, 607, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (38546, 607, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (38547, 607, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (38548, 607, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (38549, 607, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (38550, 607, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (38551, 607, 41, 1047);
INSERT INTO 'devicecapvalue' VALUES (38552, 607, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (38553, 607, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (38554, 607, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (38555, 607, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (38556, 607, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (38557, 607, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (38558, 607, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (38559, 607, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (38560, 607, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (38561, 607, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (38562, 607, 42, 1047);
INSERT INTO 'devicecapvalue' VALUES (38563, 607, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (38564, 607, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (38565, 607, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (38566, 607, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (38567, 607, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (38568, 607, 58, 238);
INSERT INTO 'devicecapvalue' VALUES (38569, 607, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (38570, 607, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (38571, 607, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (38572, 607, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (38573, 607, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (38574, 607, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (38575, 607, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (38576, 607, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (38577, 607, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (38578, 607, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (38579, 607, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (38580, 607, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (38581, 607, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (38582, 607, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (38583, 607, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (38584, 607, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (38585, 607, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (38586, 607, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (38587, 607, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (38588, 607, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (38589, 607, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (38590, 607, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (38591, 607, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (38592, 607, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (38593, 607, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (38594, 607, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (38595, 607, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (38596, 607, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (38597, 607, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (38598, 607, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (38599, 607, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (38600, 607, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (38601, 607, 115, 51);
INSERT INTO 'devicecapvalue' VALUES (38602, 607, 115, 1258);
INSERT INTO 'devicecapvalue' VALUES (38603, 607, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (38604, 607, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (38605, 607, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (38606, 607, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (38607, 607, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (38608, 607, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (38609, 607, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (38610, 607, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (38611, 607, 125, 13);
INSERT INTO 'devicecapvalue' VALUES (38612, 607, 126, 693);
INSERT INTO 'devicecapvalue' VALUES (38613, 607, 59, 240);
INSERT INTO 'devicecapvalue' VALUES (38614, 607, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (38615, 607, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (38616, 607, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (38617, 607, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (38618, 607, 128, 921);
INSERT INTO 'capvalue' VALUES (2220, '1.1+');
INSERT INTO 'devicecapvalue' VALUES (38619, 607, 129, 2220);
INSERT INTO 'devicecapvalue' VALUES (38620, 607, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (38621, 607, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (38622, 607, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (38623, 607, 67, 45);
INSERT INTO 'capvalue' VALUES (2221, 'SAMSUNG-SGH-i900/1.0 Opera 9.5');
INSERT INTO 'devicecapvalue' VALUES (38624, 607, 68, 2221);
INSERT INTO 'devicecapvalue' VALUES (38625, 607, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (38626, 607, 132, 51);
INSERT INTO 'devicecapvalue' VALUES (38627, 607, 132, 1258);
INSERT INTO 'devicecapvalue' VALUES (38628, 607, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (38629, 607, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (38630, 607, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (38631, 607, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (38632, 607, 72, 242);
INSERT INTO 'devicecapvalue' VALUES (38633, 607, 111, 45);
INSERT INTO 'devicecapvalue' VALUES (38634, 607, 73, 58);
INSERT INTO 'devicecapvalue' VALUES (38635, 607, 73, 49);
INSERT INTO 'devicecapvalue' VALUES (38636, 607, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (38637, 607, 73, 126);
INSERT INTO 'devicecapvalue' VALUES (38638, 607, 73, 63);
INSERT INTO 'devicecapvalue' VALUES (38639, 607, 73, 64);
INSERT INTO 'devicecapvalue' VALUES (38640, 607, 73, 867);
INSERT INTO 'devicecapvalue' VALUES (38641, 607, 73, 1047);
INSERT INTO 'devicecapvalue' VALUES (38642, 607, 73, 2077);
INSERT INTO 'devicecapvalue' VALUES (38643, 607, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (38644, 607, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (38645, 607, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (38646, 607, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (38647, 607, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (38648, 607, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (38649, 607, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (38650, 607, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (38651, 607, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (38652, 607, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (38653, 607, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (38654, 607, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (38655, 607, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (38656, 607, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (38657, 607, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (38658, 607, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (38659, 607, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (38660, 607, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (38661, 607, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (38662, 607, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (38663, 607, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (38664, 607, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (38665, 607, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (38666, 607, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (38667, 607, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (38668, 607, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (38669, 607, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (38670, 607, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (38671, 607, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (38672, 607, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (38673, 607, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (38674, 607, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (38675, 607, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (38676, 607, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (38677, 607, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (38678, 607, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (38679, 607, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (38680, 607, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (38681, 607, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (38682, 607, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (38683, 607, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (38684, 607, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (38685, 607, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (38686, 607, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (38687, 607, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (38688, 607, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (38689, 607, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (38690, 607, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (38691, 607, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (38692, 607, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (38693, 607, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (38694, 607, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (38695, 607, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (38696, 607, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (38697, 607, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (38698, 607, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (38699, 607, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (38700, 607, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (38701, 607, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (38702, 607, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (38703, 607, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (38704, 607, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (38705, 607, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (38706, 607, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (38707, 607, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (38708, 607, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (38709, 607, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (38710, 607, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (38711, 607, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (38712, 607, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (38713, 607, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (38714, 607, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (38715, 607, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (38716, 607, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (38717, 607, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (38718, 607, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (38719, 607, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (38720, 607, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (38721, 607, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (38722, 607, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (38723, 607, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (38724, 607, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (38725, 607, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (38726, 607, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (38727, 607, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (38728, 607, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (38729, 607, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (38730, 607, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (38731, 607, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (38732, 607, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (38733, 607, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (38734, 607, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (38735, 607, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (38736, 607, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (38737, 607, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (38738, 607, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (38739, 607, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (38740, 607, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (38741, 607, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (38742, 607, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (38743, 607, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (38744, 607, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (38745, 607, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (38746, 607, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (38747, 607, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (38748, 607, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (38749, 607, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (38750, 607, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (38751, 607, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (38752, 607, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (38753, 607, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (38754, 607, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (38755, 607, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (38756, 607, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (38757, 607, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (38758, 607, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (38759, 607, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (38760, 607, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (38761, 607, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (38762, 607, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (38763, 607, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (38764, 607, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (38765, 607, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (38766, 607, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (38767, 607, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (38768, 607, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (38769, 607, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (38770, 607, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (38771, 607, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (38772, 607, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (38773, 607, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (38774, 607, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (38775, 607, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (38776, 607, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (38777, 607, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (38778, 607, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (38779, 607, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (38780, 607, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (38781, 607, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (38782, 607, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (38783, 607, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (38784, 607, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (38785, 607, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (38786, 607, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (38787, 607, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (38788, 607, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (38789, 607, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (38790, 607, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (38791, 607, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (38792, 607, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (38793, 607, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (38794, 607, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (38795, 607, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (38796, 607, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (38797, 607, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (38798, 607, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (38799, 607, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (38800, 607, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (38801, 607, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (38802, 607, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (38803, 607, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (38804, 607, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (38805, 607, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (38806, 607, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (38807, 607, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (38808, 607, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (38809, 607, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (38810, 607, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (38811, 607, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (38812, 607, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (38813, 607, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (38814, 607, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (38815, 607, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (38816, 607, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (38817, 607, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (38818, 607, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (38819, 607, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (38820, 607, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (38821, 607, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (38822, 607, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (38823, 607, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (38824, 607, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (38825, 607, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (38826, 607, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (38827, 607, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (38828, 607, 48, 819);
INSERT INTO 'devicecapvalue' VALUES (38829, 607, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (38830, 607, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (38831, 607, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (38832, 607, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (38833, 607, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (38834, 607, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (38835, 607, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (38836, 607, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (38837, 607, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (38838, 607, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (38839, 607, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (38840, 607, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (38841, 607, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (38842, 607, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (38843, 607, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (38844, 607, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (38845, 607, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (38846, 607, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (38847, 607, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (38848, 607, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (38849, 607, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (38850, 607, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (38851, 607, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (38852, 607, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (38853, 607, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (38854, 607, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (38855, 607, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (38856, 607, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (38857, 607, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (38858, 607, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (38859, 607, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (38860, 607, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (38861, 607, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (38862, 607, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (38863, 607, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (38864, 607, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (38865, 607, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (38866, 607, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (38867, 607, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (38868, 607, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (38869, 607, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (38870, 607, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (38871, 607, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (38872, 607, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (38873, 607, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (38874, 607, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (38875, 607, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (38876, 607, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (38877, 607, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (38878, 607, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (38879, 607, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (38880, 607, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (38881, 607, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (38882, 607, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (38883, 607, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (38884, 607, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (38885, 607, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (38886, 607, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (38887, 607, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (38888, 607, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (38889, 607, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (38890, 607, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (38891, 607, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (38892, 607, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (38893, 607, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (38894, 607, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (38895, 607, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (38896, 607, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (38897, 607, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (38898, 607, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (38899, 607, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (38900, 607, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (38901, 607, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (38902, 607, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (38903, 607, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (38904, 607, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (38905, 607, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (38906, 607, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (38907, 607, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (38908, 607, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (38909, 607, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (38910, 607, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (38911, 607, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (38912, 607, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (38913, 607, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (38914, 607, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (38915, 607, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (38916, 607, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (38917, 607, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (38918, 607, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (38919, 607, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (38920, 607, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (38921, 607, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (38922, 607, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (38923, 607, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (38924, 607, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (38925, 607, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (38926, 607, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (38927, 607, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (38928, 607, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (38929, 607, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (38930, 607, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (38931, 607, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (38932, 607, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (38933, 607, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (38934, 607, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (38935, 607, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (38936, 607, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (38937, 607, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (38938, 607, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (38939, 607, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (38940, 607, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (38941, 607, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (38942, 607, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (38943, 607, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (38944, 607, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (38945, 607, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (38946, 607, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (38947, 607, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (38948, 607, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (38949, 607, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (38950, 607, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (38951, 607, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (38952, 607, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (38953, 607, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (38954, 607, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (38955, 607, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (38956, 607, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (38957, 607, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (38958, 607, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (38959, 607, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (38960, 607, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (38961, 607, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (38962, 607, 48, 562);
INSERT INTO 'capvalue' VALUES (2222, '5329536');
INSERT INTO 'devicecapvalue' VALUES (38963, 607, 49, 2222);
INSERT INTO 'devicecapvalue' VALUES (38964, 607, 53, 2221);
INSERT INTO 'devicecapvalue' VALUES (38965, 608, 7, 863);
INSERT INTO 'devicecapvalue' VALUES (38966, 608, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (38967, 608, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (38968, 608, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (38969, 608, 10, 864);
INSERT INTO 'devicecapvalue' VALUES (38970, 608, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (38971, 608, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (38972, 608, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (38973, 608, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (38974, 608, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (38975, 608, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (38976, 608, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (38977, 608, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (38978, 608, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (38979, 608, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (38980, 608, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (38981, 608, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (38982, 608, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (38983, 608, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (38984, 608, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (38985, 608, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (38986, 608, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (38987, 608, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (38988, 608, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (38989, 608, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (38990, 608, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (38991, 608, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (38992, 608, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (38993, 608, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (38994, 608, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (38995, 608, 26, 35);
INSERT INTO 'devicecapvalue' VALUES (38996, 608, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (38997, 608, 28, 40);
INSERT INTO 'devicecapvalue' VALUES (38998, 608, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (38999, 608, 30, 39);
INSERT INTO 'devicecapvalue' VALUES (39000, 608, 54, 36);
INSERT INTO 'devicecapvalue' VALUES (39001, 608, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (39002, 608, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (39003, 608, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (39004, 608, 39, 136);
INSERT INTO 'devicecapvalue' VALUES (39005, 608, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (39006, 608, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (39007, 608, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (39008, 608, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (39009, 608, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (39010, 608, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (39011, 608, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (39012, 608, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (39013, 608, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (39014, 608, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (39015, 608, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (39016, 608, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (39017, 608, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (39018, 608, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (39019, 608, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (39020, 608, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (39021, 608, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (39022, 608, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (39023, 608, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (39024, 608, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (39025, 608, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (39026, 608, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (39027, 608, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (39028, 608, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (39029, 608, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (39030, 608, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (39031, 608, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (39032, 608, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (39033, 608, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (39034, 608, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (39035, 608, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (39036, 608, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (39037, 608, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (39038, 608, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (39039, 608, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (39040, 608, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (39041, 608, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (39042, 608, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (39043, 608, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (39044, 608, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (39045, 608, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (39046, 608, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (39047, 608, 45, 2113);
INSERT INTO 'devicecapvalue' VALUES (39048, 608, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (39049, 608, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (39050, 608, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (39051, 608, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (39052, 608, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (39053, 608, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (39054, 608, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (39055, 608, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (39056, 608, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (39057, 608, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (39058, 608, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (39059, 608, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (39060, 608, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (39061, 608, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (39062, 608, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (39063, 608, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (39064, 608, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (39065, 608, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (39066, 608, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (39067, 608, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (39068, 608, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (39069, 608, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (39070, 608, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (39071, 608, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (39072, 608, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (39073, 608, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (39074, 608, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (39075, 608, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (39076, 608, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (39077, 608, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (39078, 608, 49, 1031);
INSERT INTO 'capvalue' VALUES (2223, 'SAMSUNG-SGH-J200/1.0 SHP/VPP/R5 NetFront/3.4 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (39079, 608, 53, 2223);
INSERT INTO 'devicecapvalue' VALUES (39080, 609, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (39081, 609, 7, 1150);
INSERT INTO 'devicecapvalue' VALUES (39082, 609, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (39083, 609, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (39084, 609, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (39085, 609, 10, 864);
INSERT INTO 'devicecapvalue' VALUES (39086, 609, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (39087, 609, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (39088, 609, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (39089, 609, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (39090, 609, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (39091, 609, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (39092, 609, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39093, 609, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (39094, 609, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39095, 609, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (39096, 609, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39097, 609, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39098, 609, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (39099, 609, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39100, 609, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39101, 609, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (39102, 609, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (39103, 609, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (39104, 609, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (39105, 609, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (39106, 609, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (39107, 609, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (39108, 609, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (39109, 609, 57, 36);
INSERT INTO 'devicecapvalue' VALUES (39110, 609, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (39111, 609, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (39112, 609, 54, 40);
INSERT INTO 'devicecapvalue' VALUES (39113, 609, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (39114, 609, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (39115, 609, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (39116, 609, 39, 136);
INSERT INTO 'devicecapvalue' VALUES (39117, 609, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (39118, 609, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (39119, 609, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (39120, 609, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (39121, 609, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (39122, 609, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (39123, 609, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (39124, 609, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (39125, 609, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (39126, 609, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (39127, 609, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (39128, 609, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (39129, 609, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (39130, 609, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (39131, 609, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (39132, 609, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (39133, 609, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (39134, 609, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (39135, 609, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (39136, 609, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (39137, 609, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (39138, 609, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (39139, 609, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (39140, 609, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (39141, 609, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (39142, 609, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (39143, 609, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (39144, 609, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (39145, 609, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (39146, 609, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (39147, 609, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (39148, 609, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (39149, 609, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (39150, 609, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (39151, 609, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (39152, 609, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (39153, 609, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (39154, 609, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (39155, 609, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (39156, 609, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (39157, 609, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (39158, 609, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (39159, 609, 45, 2113);
INSERT INTO 'devicecapvalue' VALUES (39160, 609, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (39161, 609, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (39162, 609, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (39163, 609, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (39164, 609, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (39165, 609, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (39166, 609, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (39167, 609, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (39168, 609, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (39169, 609, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (39170, 609, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (39171, 609, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (39172, 609, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (39173, 609, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (39174, 609, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (39175, 609, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (39176, 609, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (39177, 609, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (39178, 609, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (39179, 609, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (39180, 609, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (39181, 609, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (39182, 609, 115, 1258);
INSERT INTO 'devicecapvalue' VALUES (39183, 609, 114, 612);
INSERT INTO 'devicecapvalue' VALUES (39184, 609, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (39185, 609, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (39186, 609, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (39187, 609, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (39188, 609, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (39189, 609, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (39190, 609, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (39191, 609, 68, 243);
INSERT INTO 'devicecapvalue' VALUES (39192, 609, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (39193, 609, 132, 49);
INSERT INTO 'devicecapvalue' VALUES (39194, 609, 133, 136);
INSERT INTO 'devicecapvalue' VALUES (39195, 609, 116, 1444);
INSERT INTO 'devicecapvalue' VALUES (39196, 609, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (39197, 609, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (39198, 609, 136, 2113);
INSERT INTO 'devicecapvalue' VALUES (39199, 609, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (39200, 609, 137, 96);
INSERT INTO 'capvalue' VALUES (2224, 'http://mms.emt.ee/servlets/mms');
INSERT INTO 'devicecapvalue' VALUES (39201, 609, 138, 2224);
INSERT INTO 'capvalue' VALUES (2225, '+3725099000');
INSERT INTO 'devicecapvalue' VALUES (39202, 609, 72, 2225);
INSERT INTO 'devicecapvalue' VALUES (39203, 609, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (39204, 609, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (39205, 609, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (39206, 609, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (39207, 609, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (39208, 609, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (39209, 609, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (39210, 609, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (39211, 609, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (39212, 609, 49, 1031);
INSERT INTO 'capvalue' VALUES (2226, 'SAMSUNG-SGH-J750/1.0 SHP/VPP/R5 NetFront/3.4 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (39213, 609, 53, 2226);
INSERT INTO 'devicecapvalue' VALUES (39214, 610, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (39215, 610, 7, 863);
INSERT INTO 'devicecapvalue' VALUES (39216, 610, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (39217, 610, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (39218, 610, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (39219, 610, 10, 864);
INSERT INTO 'devicecapvalue' VALUES (39220, 610, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (39221, 610, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (39222, 610, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (39223, 610, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (39224, 610, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (39225, 610, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (39226, 610, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (39227, 610, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39228, 610, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (39229, 610, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (39230, 610, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (39231, 610, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39232, 610, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (39233, 610, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39234, 610, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39235, 610, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (39236, 610, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39237, 610, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (39238, 610, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (39239, 610, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (39240, 610, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (39241, 610, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (39242, 610, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (39243, 610, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (39244, 610, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (39245, 610, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (39246, 610, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (39247, 610, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (39248, 610, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (39249, 610, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (39250, 610, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (39251, 610, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (39252, 610, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (39253, 610, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (39254, 610, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (39255, 610, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (39256, 610, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (39257, 610, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (39258, 610, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (39259, 610, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (39260, 610, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (39261, 610, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (39262, 610, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (39263, 610, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (39264, 610, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (39265, 610, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (39266, 610, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (39267, 610, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (39268, 610, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (39269, 610, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (39270, 610, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (39271, 610, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (39272, 610, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (39273, 610, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (39274, 610, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (39275, 610, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (39276, 610, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (39277, 610, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (39278, 610, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (39279, 610, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (39280, 610, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (39281, 610, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (39282, 610, 103, 2084);
INSERT INTO 'devicecapvalue' VALUES (39283, 610, 105, 2086);
INSERT INTO 'devicecapvalue' VALUES (39284, 610, 114, 612);
INSERT INTO 'devicecapvalue' VALUES (39285, 610, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (39286, 610, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (39287, 610, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (39288, 610, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (39289, 610, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (39290, 610, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (39291, 610, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (39292, 610, 68, 243);
INSERT INTO 'devicecapvalue' VALUES (39293, 610, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (39294, 610, 116, 1444);
INSERT INTO 'devicecapvalue' VALUES (39295, 610, 71, 244);
INSERT INTO 'devicecapvalue' VALUES (39296, 610, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (39297, 610, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (39298, 610, 137, 96);
INSERT INTO 'capvalue' VALUES (2227, '+38641001333');
INSERT INTO 'devicecapvalue' VALUES (39299, 610, 72, 2227);
INSERT INTO 'devicecapvalue' VALUES (39300, 610, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (39301, 610, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (39302, 610, 49, 1031);
INSERT INTO 'capvalue' VALUES (2228, 'SAMSUNG-SGH-L700/PNHH2 SHP/VPP/R5 NetFront/3.4 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (39303, 610, 53, 2228);
INSERT INTO 'devicecapvalue' VALUES (39304, 611, 7, 863);
INSERT INTO 'devicecapvalue' VALUES (39305, 611, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (39306, 611, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (39307, 611, 9, 13);
INSERT INTO 'devicecapvalue' VALUES (39308, 611, 10, 864);
INSERT INTO 'devicecapvalue' VALUES (39309, 611, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (39310, 611, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (39311, 611, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (39312, 611, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (39313, 611, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (39314, 611, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (39315, 611, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (39316, 611, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39317, 611, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (39318, 611, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (39319, 611, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (39320, 611, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39321, 611, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (39322, 611, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39323, 611, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39324, 611, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (39325, 611, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39326, 611, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39327, 611, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (39328, 611, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (39329, 611, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (39330, 611, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (39331, 611, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (39332, 611, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (39333, 611, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (39334, 611, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (39335, 611, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (39336, 611, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (39337, 611, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (39338, 611, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (39339, 611, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (39340, 611, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (39341, 611, 39, 136);
INSERT INTO 'devicecapvalue' VALUES (39342, 611, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (39343, 611, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (39344, 611, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (39345, 611, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (39346, 611, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (39347, 611, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (39348, 611, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (39349, 611, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (39350, 611, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (39351, 611, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (39352, 611, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (39353, 611, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (39354, 611, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (39355, 611, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (39356, 611, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (39357, 611, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (39358, 611, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (39359, 611, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (39360, 611, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (39361, 611, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (39362, 611, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (39363, 611, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (39364, 611, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (39365, 611, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (39366, 611, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (39367, 611, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (39368, 611, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (39369, 611, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (39370, 611, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (39371, 611, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (39372, 611, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (39373, 611, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (39374, 611, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (39375, 611, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (39376, 611, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (39377, 611, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (39378, 611, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (39379, 611, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (39380, 611, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (39381, 611, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (39382, 611, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (39383, 611, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (39384, 611, 45, 2113);
INSERT INTO 'devicecapvalue' VALUES (39385, 611, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (39386, 611, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (39387, 611, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (39388, 611, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (39389, 611, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (39390, 611, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (39391, 611, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (39392, 611, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (39393, 611, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (39394, 611, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (39395, 611, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (39396, 611, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (39397, 611, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (39398, 611, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (39399, 611, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (39400, 611, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (39401, 611, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (39402, 611, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (39403, 611, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (39404, 611, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (39405, 611, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (39406, 611, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (39407, 611, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (39408, 611, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (39409, 611, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (39410, 611, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (39411, 611, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (39412, 611, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (39413, 611, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (39414, 611, 49, 1031);
INSERT INTO 'devicecapvalue' VALUES (39415, 611, 53, 2120);
INSERT INTO 'devicecapvalue' VALUES (39416, 612, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (39417, 612, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39418, 612, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (39419, 612, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39420, 612, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39421, 612, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (39422, 612, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (39423, 613, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (39424, 613, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (39425, 613, 74, 653);
INSERT INTO 'capvalue' VALUES (2229, '240x159');
INSERT INTO 'devicecapvalue' VALUES (39426, 613, 7, 2229);
INSERT INTO 'devicecapvalue' VALUES (39427, 613, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39428, 613, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (39429, 613, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (39430, 613, 12, 864);
INSERT INTO 'capvalue' VALUES (2230, '240x176');
INSERT INTO 'devicecapvalue' VALUES (39431, 613, 13, 2230);
INSERT INTO 'devicecapvalue' VALUES (39432, 613, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (39433, 613, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39434, 613, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39435, 613, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39436, 613, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (39437, 613, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39438, 613, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39439, 613, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (39440, 613, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (39441, 613, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (39442, 613, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (39443, 613, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39444, 613, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (39445, 613, 155, 2144);
INSERT INTO 'devicecapvalue' VALUES (39446, 613, 232, 709);
INSERT INTO 'devicecapvalue' VALUES (39447, 613, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (39448, 613, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (39449, 613, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (39450, 613, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (39451, 613, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (39452, 613, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (39453, 613, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (39454, 613, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (39455, 613, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (39456, 613, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (39457, 613, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (39458, 613, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (39459, 613, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (39460, 613, 5, 679);
INSERT INTO 'devicecapvalue' VALUES (39461, 613, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (39462, 613, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (39463, 613, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (39464, 613, 191, 2166);
INSERT INTO 'capvalue' VALUES (2231, '2006-11-16');
INSERT INTO 'devicecapvalue' VALUES (39465, 614, 158, 2231);
INSERT INTO 'devicecapvalue' VALUES (39466, 614, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (39467, 614, 74, 653);
INSERT INTO 'capvalue' VALUES (2232, '3200x208');
INSERT INTO 'devicecapvalue' VALUES (39468, 614, 7, 2232);
INSERT INTO 'devicecapvalue' VALUES (39469, 614, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39470, 614, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (39471, 614, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (39472, 614, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (39473, 614, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (39474, 614, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (39475, 614, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39476, 614, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39477, 614, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39478, 614, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (39479, 614, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39480, 614, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39481, 614, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (39482, 614, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (39483, 614, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (39484, 614, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (39485, 614, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39486, 614, 50, 2157);
INSERT INTO 'devicecapvalue' VALUES (39487, 614, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (39488, 614, 232, 606);
INSERT INTO 'devicecapvalue' VALUES (39489, 614, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (39490, 614, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (39491, 614, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (39492, 614, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (39493, 614, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (39494, 614, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (39495, 614, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (39496, 614, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (39497, 614, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (39498, 614, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (39499, 614, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (39500, 614, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (39501, 614, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (39502, 614, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (39503, 614, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (39504, 614, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (39505, 614, 52, 1124);
INSERT INTO 'capvalue' VALUES (2233, '0 MB');
INSERT INTO 'devicecapvalue' VALUES (39506, 614, 191, 2233);
INSERT INTO 'capvalue' VALUES (2234, 'SEC-SGHP310/1.0 NetFront/3.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (39507, 614, 53, 2234);
INSERT INTO 'devicecapvalue' VALUES (39508, 615, 158, 2163);
INSERT INTO 'devicecapvalue' VALUES (39509, 615, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (39510, 615, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (39511, 615, 7, 2160);
INSERT INTO 'devicecapvalue' VALUES (39512, 615, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39513, 615, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (39514, 615, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (39515, 615, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (39516, 615, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (39517, 615, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (39518, 615, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39519, 615, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39520, 615, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39521, 615, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (39522, 615, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39523, 615, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39524, 615, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (39525, 615, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (39526, 615, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (39527, 615, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (39528, 615, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39529, 615, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (39530, 615, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (39531, 615, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (39532, 615, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (39533, 615, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (39534, 615, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (39535, 615, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (39536, 615, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (39537, 615, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (39538, 615, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (39539, 615, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (39540, 615, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (39541, 615, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (39542, 615, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (39543, 615, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (39544, 615, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (39545, 615, 191, 2161);
INSERT INTO 'devicecapvalue' VALUES (39546, 616, 158, 2149);
INSERT INTO 'devicecapvalue' VALUES (39547, 616, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (39548, 616, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (39549, 616, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (39550, 616, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39551, 616, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (39552, 616, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (39553, 616, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (39554, 616, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (39555, 616, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (39556, 616, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39557, 616, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39558, 616, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39559, 616, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (39560, 616, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39561, 616, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39562, 616, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (39563, 616, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (39564, 616, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (39565, 616, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (39566, 616, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39567, 616, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (39568, 616, 155, 1162);
INSERT INTO 'devicecapvalue' VALUES (39569, 616, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (39570, 616, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (39571, 616, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (39572, 616, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (39573, 616, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (39574, 616, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (39575, 616, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (39576, 616, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (39577, 616, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (39578, 616, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (39579, 616, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (39580, 616, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (39581, 616, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (39582, 616, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (39583, 616, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (39584, 616, 191, 2161);
INSERT INTO 'devicecapvalue' VALUES (39585, 617, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (39586, 617, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (39587, 617, 74, 2198);
INSERT INTO 'capvalue' VALUES (2235, '176x186');
INSERT INTO 'devicecapvalue' VALUES (39588, 617, 7, 2235);
INSERT INTO 'devicecapvalue' VALUES (39589, 617, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39590, 617, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (39591, 617, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39592, 617, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39593, 617, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39594, 617, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (39595, 617, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39596, 617, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39597, 617, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (39598, 617, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (39599, 617, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (39600, 617, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (39601, 617, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39602, 617, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (39603, 617, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (39604, 617, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (39605, 617, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (39606, 617, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (39607, 617, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (39608, 617, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (39609, 618, 158, 2163);
INSERT INTO 'devicecapvalue' VALUES (39610, 618, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (39611, 618, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (39612, 618, 74, 2198);
INSERT INTO 'devicecapvalue' VALUES (39613, 618, 7, 2235);
INSERT INTO 'devicecapvalue' VALUES (39614, 618, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39615, 618, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (39616, 618, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (39617, 618, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (39618, 618, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (39619, 618, 76, 1107);
INSERT INTO 'devicecapvalue' VALUES (39620, 618, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39621, 618, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39622, 618, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39623, 618, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (39624, 618, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39625, 618, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39626, 618, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (39627, 618, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (39628, 618, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (39629, 618, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (39630, 618, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39631, 618, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (39632, 618, 155, 1162);
INSERT INTO 'devicecapvalue' VALUES (39633, 618, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (39634, 618, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (39635, 618, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (39636, 618, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (39637, 618, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (39638, 618, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (39639, 618, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (39640, 618, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (39641, 618, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (39642, 618, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (39643, 618, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (39644, 618, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (39645, 618, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (39646, 618, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (39647, 618, 157, 1087);
INSERT INTO 'capvalue' VALUES (2236, '900 KB');
INSERT INTO 'devicecapvalue' VALUES (39648, 618, 191, 2236);
INSERT INTO 'devicecapvalue' VALUES (39649, 619, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (39650, 619, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (39651, 619, 74, 2198);
INSERT INTO 'devicecapvalue' VALUES (39652, 619, 7, 2235);
INSERT INTO 'devicecapvalue' VALUES (39653, 619, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39654, 619, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (39655, 619, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39656, 619, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39657, 619, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39658, 619, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (39659, 619, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39660, 619, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39661, 619, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (39662, 619, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (39663, 619, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (39664, 619, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (39665, 619, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39666, 619, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (39667, 619, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (39668, 619, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (39669, 619, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (39670, 619, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (39671, 619, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (39672, 619, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (39673, 620, 158, 2163);
INSERT INTO 'devicecapvalue' VALUES (39674, 620, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (39675, 620, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (39676, 620, 7, 2235);
INSERT INTO 'devicecapvalue' VALUES (39677, 620, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39678, 620, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (39679, 620, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (39680, 620, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (39681, 620, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (39682, 620, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (39683, 620, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39684, 620, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39685, 620, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39686, 620, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (39687, 620, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39688, 620, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39689, 620, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (39690, 620, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (39691, 620, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (39692, 620, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (39693, 620, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39694, 620, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (39695, 620, 155, 1162);
INSERT INTO 'devicecapvalue' VALUES (39696, 620, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (39697, 620, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (39698, 620, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (39699, 620, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (39700, 620, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (39701, 620, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (39702, 620, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (39703, 620, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (39704, 620, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (39705, 620, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (39706, 620, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (39707, 620, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (39708, 620, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (39709, 620, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (39710, 620, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (39711, 620, 191, 2161);
INSERT INTO 'capvalue' VALUES (2237, '2007-xx-xx');
INSERT INTO 'devicecapvalue' VALUES (39712, 621, 158, 2237);
INSERT INTO 'devicecapvalue' VALUES (39713, 621, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (39714, 621, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (39715, 621, 7, 2160);
INSERT INTO 'devicecapvalue' VALUES (39716, 621, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39717, 621, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (39718, 621, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (39719, 621, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (39720, 621, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (39721, 621, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (39722, 621, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39723, 621, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39724, 621, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39725, 621, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (39726, 621, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39727, 621, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39728, 621, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (39729, 621, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (39730, 621, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (39731, 621, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (39732, 621, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39733, 621, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (39734, 621, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (39735, 621, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (39736, 621, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (39737, 621, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (39738, 621, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (39739, 621, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (39740, 621, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (39741, 621, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (39742, 621, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (39743, 621, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (39744, 621, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (39745, 621, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (39746, 621, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (39747, 621, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (39748, 621, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (39749, 621, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (39750, 621, 191, 2161);
INSERT INTO 'devicecapvalue' VALUES (39751, 622, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (39752, 622, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (39753, 622, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (39754, 622, 74, 2198);
INSERT INTO 'capvalue' VALUES (2238, '3.2 MP');
INSERT INTO 'devicecapvalue' VALUES (39755, 622, 160, 2238);
INSERT INTO 'devicecapvalue' VALUES (39756, 622, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (39757, 622, 7, 2160);
INSERT INTO 'devicecapvalue' VALUES (39758, 622, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (39759, 622, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (39760, 622, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (39761, 622, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (39762, 622, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39763, 622, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (39764, 622, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (39765, 622, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (39766, 622, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (39767, 622, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (39768, 622, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (39769, 622, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (39770, 622, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (39771, 622, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39772, 622, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39773, 622, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (39774, 622, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39775, 622, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (39776, 622, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39777, 622, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39778, 622, 50, 2157);
INSERT INTO 'devicecapvalue' VALUES (39779, 622, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (39780, 622, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (39781, 622, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (39782, 622, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (39783, 622, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (39784, 622, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (39785, 622, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (39786, 622, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (39787, 622, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (39788, 622, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (39789, 622, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (39790, 622, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (39791, 622, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (39792, 622, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (39793, 622, 51, 1187);
INSERT INTO 'devicecapvalue' VALUES (39794, 622, 51, 1191);
INSERT INTO 'devicecapvalue' VALUES (39795, 622, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (39796, 622, 191, 2166);
INSERT INTO 'capvalue' VALUES (2239, 'SEC-SGHU600-ORANGE/1.0 NetFront/3.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (39797, 622, 53, 2239);
INSERT INTO 'devicecapvalue' VALUES (39798, 623, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (39799, 623, 74, 653);
INSERT INTO 'capvalue' VALUES (2240, 'getTitleRequiresNull');
INSERT INTO 'devicecapvalue' VALUES (39800, 623, 74, 2240);
INSERT INTO 'devicecapvalue' VALUES (39801, 623, 160, 2238);
INSERT INTO 'devicecapvalue' VALUES (39802, 623, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (39803, 623, 7, 2112);
INSERT INTO 'devicecapvalue' VALUES (39804, 623, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (39805, 623, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (39806, 623, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (39807, 623, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (39808, 623, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39809, 623, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (39810, 623, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (39811, 623, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (39812, 623, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (39813, 623, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (39814, 623, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (39815, 623, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (39816, 623, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (39817, 623, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39818, 623, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39819, 623, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (39820, 623, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39821, 623, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (39822, 623, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39823, 623, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39824, 623, 50, 2157);
INSERT INTO 'devicecapvalue' VALUES (39825, 623, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (39826, 623, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (39827, 623, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (39828, 623, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (39829, 623, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (39830, 623, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (39831, 623, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (39832, 623, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (39833, 623, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (39834, 623, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (39835, 623, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (39836, 623, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (39837, 623, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (39838, 623, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (39839, 623, 51, 1187);
INSERT INTO 'devicecapvalue' VALUES (39840, 623, 51, 1191);
INSERT INTO 'devicecapvalue' VALUES (39841, 623, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (39842, 623, 191, 2166);
INSERT INTO 'capvalue' VALUES (2241, 'SAMSUNG-SGH-U700/AKGF1 SHP/VPP/R5 NetFront/3.4 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (39843, 623, 53, 2241);
INSERT INTO 'devicecapvalue' VALUES (39844, 624, 7, 2112);
INSERT INTO 'devicecapvalue' VALUES (39845, 624, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (39846, 624, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (39847, 624, 9, 864);
INSERT INTO 'devicecapvalue' VALUES (39848, 624, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (39849, 624, 11, 864);
INSERT INTO 'devicecapvalue' VALUES (39850, 624, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (39851, 624, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (39852, 624, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (39853, 624, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (39854, 624, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (39855, 624, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (39856, 624, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39857, 624, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (39858, 624, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (39859, 624, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (39860, 624, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (39861, 624, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39862, 624, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (39863, 624, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39864, 624, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39865, 624, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (39866, 624, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39867, 624, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (39868, 624, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (39869, 624, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (39870, 624, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (39871, 624, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (39872, 624, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (39873, 624, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (39874, 624, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (39875, 624, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (39876, 624, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (39877, 624, 28, 40);
INSERT INTO 'devicecapvalue' VALUES (39878, 624, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (39879, 624, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (39880, 624, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (39881, 624, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (39882, 624, 32, 612);
INSERT INTO 'devicecapvalue' VALUES (39883, 624, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (39884, 624, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (39885, 624, 35, 45);
INSERT INTO 'capvalue' VALUES (2242, 'SAMSUNG-SGH-U900');
INSERT INTO 'devicecapvalue' VALUES (39886, 624, 36, 2242);
INSERT INTO 'devicecapvalue' VALUES (39887, 624, 37, 47);
INSERT INTO 'devicecapvalue' VALUES (39888, 624, 38, 1258);
INSERT INTO 'devicecapvalue' VALUES (39889, 624, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (39890, 624, 39, 136);
INSERT INTO 'devicecapvalue' VALUES (39891, 624, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (39892, 624, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (39893, 624, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (39894, 624, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (39895, 624, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (39896, 624, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (39897, 624, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (39898, 624, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (39899, 624, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (39900, 624, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (39901, 624, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (39902, 624, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (39903, 624, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (39904, 624, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (39905, 624, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (39906, 624, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (39907, 624, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (39908, 624, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (39909, 624, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (39910, 624, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (39911, 624, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (39912, 624, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (39913, 624, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (39914, 624, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (39915, 624, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (39916, 624, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (39917, 624, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (39918, 624, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (39919, 624, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (39920, 624, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (39921, 624, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (39922, 624, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (39923, 624, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (39924, 624, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (39925, 624, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (39926, 624, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (39927, 624, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (39928, 624, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (39929, 624, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (39930, 624, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (39931, 624, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (39932, 624, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (39933, 624, 45, 2113);
INSERT INTO 'devicecapvalue' VALUES (39934, 624, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (39935, 624, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (39936, 624, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (39937, 624, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (39938, 624, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (39939, 624, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (39940, 624, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (39941, 624, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (39942, 624, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (39943, 624, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (39944, 624, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (39945, 624, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (39946, 624, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (39947, 624, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (39948, 624, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (39949, 624, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (39950, 624, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (39951, 624, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (39952, 624, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (39953, 624, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (39954, 624, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (39955, 624, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (39956, 624, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (39957, 624, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (39958, 624, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (39959, 624, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (39960, 624, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (39961, 624, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (39962, 624, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (39963, 624, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (39964, 624, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (39965, 624, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (39966, 624, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (39967, 624, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (39968, 624, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (39969, 624, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (39970, 624, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (39971, 624, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (39972, 624, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (39973, 624, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (39974, 624, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (39975, 624, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (39976, 624, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (39977, 624, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (39978, 624, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (39979, 624, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (39980, 624, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (39981, 624, 49, 1031);
INSERT INTO 'capvalue' VALUES (2243, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/');
INSERT INTO 'devicecapvalue' VALUES (39982, 624, 53, 2243);
INSERT INTO 'devicecapvalue' VALUES (39983, 625, 158, 2149);
INSERT INTO 'devicecapvalue' VALUES (39984, 625, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (39985, 625, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (39986, 625, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (39987, 625, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (39988, 625, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (39989, 625, 11, 709);
INSERT INTO 'devicecapvalue' VALUES (39990, 625, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (39991, 625, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (39992, 625, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (39993, 625, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (39994, 625, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (39995, 625, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (39996, 625, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (39997, 625, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (39998, 625, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (39999, 625, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (40000, 625, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (40001, 625, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (40002, 625, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (40003, 625, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (40004, 625, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (40005, 625, 155, 2152);
INSERT INTO 'devicecapvalue' VALUES (40006, 625, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (40007, 625, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (40008, 625, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (40009, 625, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (40010, 625, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (40011, 625, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (40012, 625, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (40013, 625, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (40014, 625, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (40015, 625, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (40016, 625, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (40017, 625, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (40018, 625, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (40019, 625, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (40020, 625, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (40021, 625, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (40022, 625, 191, 2154);
INSERT INTO 'capvalue' VALUES (2244, 'SAMSUNG-SGH-X700/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (40023, 625, 53, 2244);
INSERT INTO 'devicecapvalue' VALUES (40024, 626, 158, 2163);
INSERT INTO 'devicecapvalue' VALUES (40025, 626, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (40026, 626, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (40027, 626, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (40028, 626, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (40029, 626, 10, 710);
INSERT INTO 'devicecapvalue' VALUES (40030, 626, 11, 709);
INSERT INTO 'devicecapvalue' VALUES (40031, 626, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (40032, 626, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (40033, 626, 76, 1208);
INSERT INTO 'devicecapvalue' VALUES (40034, 626, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (40035, 626, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (40036, 626, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (40037, 626, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (40038, 626, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40039, 626, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (40040, 626, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (40041, 626, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (40042, 626, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (40043, 626, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (40044, 626, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (40045, 626, 50, 2151);
INSERT INTO 'capvalue' VALUES (2245, '4 KB');
INSERT INTO 'devicecapvalue' VALUES (40046, 626, 155, 2245);
INSERT INTO 'devicecapvalue' VALUES (40047, 626, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (40048, 626, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (40049, 626, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (40050, 626, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (40051, 626, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (40052, 626, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (40053, 626, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (40054, 626, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (40055, 626, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (40056, 626, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (40057, 626, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (40058, 626, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (40059, 626, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (40060, 626, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (40061, 626, 191, 2154);
INSERT INTO 'devicecapvalue' VALUES (40062, 627, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (40063, 627, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (40064, 627, 74, 653);
INSERT INTO 'capvalue' VALUES (2246, 'fullRepaintRequired');
INSERT INTO 'devicecapvalue' VALUES (40065, 627, 74, 2246);
INSERT INTO 'devicecapvalue' VALUES (40066, 627, 74, 2240);
INSERT INTO 'capvalue' VALUES (2247, '220x153');
INSERT INTO 'devicecapvalue' VALUES (40067, 627, 7, 2247);
INSERT INTO 'devicecapvalue' VALUES (40068, 627, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (40069, 627, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (40070, 627, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (40071, 627, 12, 864);
INSERT INTO 'capvalue' VALUES (2248, '220x176');
INSERT INTO 'devicecapvalue' VALUES (40072, 627, 13, 2248);
INSERT INTO 'devicecapvalue' VALUES (40073, 627, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (40074, 627, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (40075, 627, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (40076, 627, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (40077, 627, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (40078, 627, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40079, 627, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (40080, 627, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (40081, 627, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (40082, 627, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (40083, 627, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (40084, 627, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (40085, 627, 50, 2157);
INSERT INTO 'devicecapvalue' VALUES (40086, 627, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (40087, 627, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (40088, 627, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (40089, 627, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (40090, 627, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (40091, 627, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (40092, 627, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (40093, 627, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (40094, 627, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (40095, 627, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (40096, 627, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (40097, 627, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (40098, 627, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (40099, 627, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (40100, 627, 4, 681);
INSERT INTO 'devicecapvalue' VALUES (40101, 627, 5, 679);
INSERT INTO 'devicecapvalue' VALUES (40102, 627, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (40103, 627, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (40104, 627, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (40105, 627, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (40106, 627, 191, 2166);
INSERT INTO 'capvalue' VALUES (2249, 'SAMSUNG-SGH-X820');
INSERT INTO 'devicecapvalue' VALUES (40107, 627, 53, 2249);
INSERT INTO 'devicecapvalue' VALUES (40108, 628, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (40109, 628, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (40110, 628, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (40111, 628, 74, 2240);
INSERT INTO 'capvalue' VALUES (2250, '128x220');
INSERT INTO 'devicecapvalue' VALUES (40112, 628, 7, 2250);
INSERT INTO 'devicecapvalue' VALUES (40113, 628, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (40114, 628, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (40115, 628, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (40116, 628, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (40117, 628, 13, 2250);
INSERT INTO 'devicecapvalue' VALUES (40118, 628, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (40119, 628, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (40120, 628, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (40121, 628, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (40122, 628, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (40123, 628, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40124, 628, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (40125, 628, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (40126, 628, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (40127, 628, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (40128, 628, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (40129, 628, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (40130, 628, 50, 2157);
INSERT INTO 'devicecapvalue' VALUES (40131, 628, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (40132, 628, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (40133, 628, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (40134, 628, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (40135, 628, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (40136, 628, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (40137, 628, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (40138, 628, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (40139, 628, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (40140, 628, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (40141, 628, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (40142, 628, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (40143, 628, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (40144, 628, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (40145, 628, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (40146, 628, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (40147, 628, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (40148, 628, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (40149, 628, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (40150, 628, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (40151, 628, 191, 2166);
INSERT INTO 'devicecapvalue' VALUES (40152, 629, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (40153, 629, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (40154, 629, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (40155, 629, 7, 2112);
INSERT INTO 'devicecapvalue' VALUES (40156, 629, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (40157, 629, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (40158, 629, 11, 864);
INSERT INTO 'devicecapvalue' VALUES (40159, 629, 12, 13);
INSERT INTO 'capvalue' VALUES (2251, '240x297');
INSERT INTO 'devicecapvalue' VALUES (40160, 629, 13, 2251);
INSERT INTO 'devicecapvalue' VALUES (40161, 629, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (40162, 629, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (40163, 629, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (40164, 629, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (40165, 629, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (40166, 629, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40167, 629, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (40168, 629, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (40169, 629, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (40170, 629, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (40171, 629, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (40172, 629, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (40173, 629, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (40174, 629, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (40175, 629, 232, 106);
INSERT INTO 'devicecapvalue' VALUES (40176, 629, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (40177, 629, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (40178, 629, 236, 15);
INSERT INTO 'devicecapvalue' VALUES (40179, 629, 237, 15);
INSERT INTO 'devicecapvalue' VALUES (40180, 629, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (40181, 629, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (40182, 629, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (40183, 629, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (40184, 629, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (40185, 629, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (40186, 629, 4, 5);
INSERT INTO 'capvalue' VALUES (2252, '297');
INSERT INTO 'devicecapvalue' VALUES (40187, 629, 5, 2252);
INSERT INTO 'devicecapvalue' VALUES (40188, 629, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (40189, 629, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (40190, 629, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (40191, 629, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (40192, 629, 52, 1031);
INSERT INTO 'devicecapvalue' VALUES (40193, 629, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (40194, 629, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (40195, 629, 191, 2166);
INSERT INTO 'capvalue' VALUES (2253, 'SAMSUNG-SGH-Z400-Vodafone/1.0 SHP/VPP/R5 NetFront/3.3 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (40196, 629, 53, 2253);
INSERT INTO 'devicecapvalue' VALUES (40197, 630, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (40198, 630, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (40199, 630, 7, 863);
INSERT INTO 'devicecapvalue' VALUES (40200, 630, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (40201, 630, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (40202, 630, 10, 864);
INSERT INTO 'devicecapvalue' VALUES (40203, 630, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (40204, 630, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (40205, 630, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (40206, 630, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (40207, 630, 150, 959);
INSERT INTO 'capvalue' VALUES (2254, '176x205');
INSERT INTO 'devicecapvalue' VALUES (40208, 630, 13, 2254);
INSERT INTO 'devicecapvalue' VALUES (40209, 630, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (40210, 630, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (40211, 630, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (40212, 630, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (40213, 630, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (40214, 630, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40215, 630, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (40216, 630, 50, 2151);
INSERT INTO 'devicecapvalue' VALUES (40217, 630, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (40218, 630, 232, 106);
INSERT INTO 'devicecapvalue' VALUES (40219, 630, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (40220, 630, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (40221, 630, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (40222, 630, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (40223, 630, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (40224, 630, 4, 679);
INSERT INTO 'capvalue' VALUES (2255, '205');
INSERT INTO 'devicecapvalue' VALUES (40225, 630, 5, 2255);
INSERT INTO 'devicecapvalue' VALUES (40226, 630, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (40227, 630, 52, 1086);
INSERT INTO 'devicecapvalue' VALUES (40228, 630, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (40229, 630, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (40230, 630, 191, 2166);
INSERT INTO 'devicecapvalue' VALUES (40231, 631, 158, 2156);
INSERT INTO 'devicecapvalue' VALUES (40232, 631, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (40233, 631, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (40234, 631, 7, 2112);
INSERT INTO 'devicecapvalue' VALUES (40235, 631, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (40236, 631, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (40237, 631, 11, 864);
INSERT INTO 'devicecapvalue' VALUES (40238, 631, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (40239, 631, 13, 2251);
INSERT INTO 'devicecapvalue' VALUES (40240, 631, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (40241, 631, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (40242, 631, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (40243, 631, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (40244, 631, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (40245, 631, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40246, 631, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (40247, 631, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (40248, 631, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (40249, 631, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (40250, 631, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (40251, 631, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (40252, 631, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (40253, 631, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (40254, 631, 232, 106);
INSERT INTO 'devicecapvalue' VALUES (40255, 631, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (40256, 631, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (40257, 631, 236, 15);
INSERT INTO 'devicecapvalue' VALUES (40258, 631, 237, 15);
INSERT INTO 'devicecapvalue' VALUES (40259, 631, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (40260, 631, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (40261, 631, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (40262, 631, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (40263, 631, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (40264, 631, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (40265, 631, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (40266, 631, 5, 2252);
INSERT INTO 'devicecapvalue' VALUES (40267, 631, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (40268, 631, 52, 1031);
INSERT INTO 'devicecapvalue' VALUES (40269, 631, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (40270, 631, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (40271, 631, 191, 2166);
INSERT INTO 'devicecapvalue' VALUES (40272, 632, 158, 2165);
INSERT INTO 'devicecapvalue' VALUES (40273, 632, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (40274, 632, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (40275, 632, 7, 2112);
INSERT INTO 'devicecapvalue' VALUES (40276, 632, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (40277, 632, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (40278, 632, 11, 864);
INSERT INTO 'devicecapvalue' VALUES (40279, 632, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (40280, 632, 13, 2251);
INSERT INTO 'devicecapvalue' VALUES (40281, 632, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (40282, 632, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (40283, 632, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (40284, 632, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (40285, 632, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (40286, 632, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40287, 632, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (40288, 632, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (40289, 632, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (40290, 632, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (40291, 632, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (40292, 632, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (40293, 632, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (40294, 632, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (40295, 632, 232, 106);
INSERT INTO 'devicecapvalue' VALUES (40296, 632, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (40297, 632, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (40298, 632, 236, 15);
INSERT INTO 'devicecapvalue' VALUES (40299, 632, 237, 15);
INSERT INTO 'devicecapvalue' VALUES (40300, 632, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (40301, 632, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (40302, 632, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (40303, 632, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (40304, 632, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (40305, 632, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (40306, 632, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (40307, 632, 5, 2252);
INSERT INTO 'devicecapvalue' VALUES (40308, 632, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (40309, 632, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (40310, 632, 52, 1031);
INSERT INTO 'devicecapvalue' VALUES (40311, 632, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (40312, 632, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (40313, 632, 191, 2166);
INSERT INTO 'capvalue' VALUES (2256, 'SAMSUNG-SGH-Z560/1.0 SHP/VPP/R5 NetFront/3.3 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (40314, 632, 53, 2256);
INSERT INTO 'devicecapvalue' VALUES (40315, 633, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (40316, 633, 79, 15);
INSERT INTO 'devicecapvalue' VALUES (40317, 633, 7, 1242);
INSERT INTO 'devicecapvalue' VALUES (40318, 633, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (40319, 633, 9, 109);
INSERT INTO 'devicecapvalue' VALUES (40320, 633, 10, 709);
INSERT INTO 'devicecapvalue' VALUES (40321, 633, 11, 109);
INSERT INTO 'devicecapvalue' VALUES (40322, 633, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (40323, 633, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (40324, 633, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (40325, 633, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (40326, 633, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (40327, 633, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (40328, 633, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (40329, 633, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (40330, 633, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (40331, 633, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (40332, 633, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40333, 633, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40334, 633, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (40335, 633, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (40336, 633, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (40337, 633, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (40338, 633, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (40339, 633, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (40340, 633, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (40341, 633, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (40342, 633, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (40343, 633, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (40344, 633, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (40345, 633, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (40346, 633, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (40347, 633, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (40348, 633, 38, 986);
INSERT INTO 'devicecapvalue' VALUES (40349, 633, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (40350, 633, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (40351, 633, 41, 965);
INSERT INTO 'devicecapvalue' VALUES (40352, 633, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (40353, 633, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (40354, 633, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (40355, 633, 41, 884);
INSERT INTO 'devicecapvalue' VALUES (40356, 633, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (40357, 633, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (40358, 633, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (40359, 633, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (40360, 633, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (40361, 633, 42, 965);
INSERT INTO 'devicecapvalue' VALUES (40362, 633, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (40363, 633, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (40364, 633, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (40365, 633, 42, 884);
INSERT INTO 'devicecapvalue' VALUES (40366, 633, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (40367, 633, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (40368, 633, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (40369, 633, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (40370, 633, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (40371, 633, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (40372, 633, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (40373, 633, 45, 888);
INSERT INTO 'devicecapvalue' VALUES (40374, 633, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (40375, 633, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (40376, 633, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (40377, 633, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (40378, 633, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (40379, 633, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (40380, 633, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (40381, 633, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (40382, 633, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (40383, 633, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (40384, 633, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (40385, 633, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (40386, 633, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (40387, 633, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (40388, 633, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (40389, 633, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (40390, 633, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (40391, 633, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (40392, 633, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (40393, 633, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (40394, 633, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (40395, 633, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (40396, 633, 115, 985);
INSERT INTO 'devicecapvalue' VALUES (40397, 633, 59, 240);
INSERT INTO 'devicecapvalue' VALUES (40398, 633, 114, 1912);
INSERT INTO 'devicecapvalue' VALUES (40399, 633, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (40400, 633, 62, 44);
INSERT INTO 'capvalue' VALUES (2257, 'umts_java');
INSERT INTO 'devicecapvalue' VALUES (40401, 633, 204, 2257);
INSERT INTO 'devicecapvalue' VALUES (40402, 633, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (40403, 633, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (40404, 633, 65, 45);
INSERT INTO 'devicecapvalue' VALUES (40405, 633, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (40406, 633, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (40407, 633, 68, 243);
INSERT INTO 'devicecapvalue' VALUES (40408, 633, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (40409, 633, 132, 985);
INSERT INTO 'capvalue' VALUES (2258, 'encoding=mpeg4');
INSERT INTO 'devicecapvalue' VALUES (40410, 633, 133, 2258);
INSERT INTO 'devicecapvalue' VALUES (40411, 633, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (40412, 633, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (40413, 633, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (40414, 633, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (40415, 633, 136, 2258);
INSERT INTO 'devicecapvalue' VALUES (40416, 633, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (40417, 633, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (40418, 633, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (40419, 633, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (40420, 633, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (40421, 633, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (40422, 633, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (40423, 633, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (40424, 633, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (40425, 633, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (40426, 633, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (40427, 633, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (40428, 633, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (40429, 633, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (40430, 633, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (40431, 633, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (40432, 633, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (40433, 633, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (40434, 633, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (40435, 633, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (40436, 633, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (40437, 633, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (40438, 633, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (40439, 633, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (40440, 633, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (40441, 633, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (40442, 633, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (40443, 633, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (40444, 633, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (40445, 633, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (40446, 633, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (40447, 633, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (40448, 633, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (40449, 633, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (40450, 633, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (40451, 633, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (40452, 633, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (40453, 633, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (40454, 633, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (40455, 633, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (40456, 633, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (40457, 633, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (40458, 633, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (40459, 633, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (40460, 633, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (40461, 633, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (40462, 633, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (40463, 633, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (40464, 633, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (40465, 633, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (40466, 633, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (40467, 633, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (40468, 633, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (40469, 633, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (40470, 633, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (40471, 633, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (40472, 633, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (40473, 633, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (40474, 633, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (40475, 633, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (40476, 633, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (40477, 633, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (40478, 633, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (40479, 633, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (40480, 633, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (40481, 633, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (40482, 633, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (40483, 633, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (40484, 633, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (40485, 633, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (40486, 633, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (40487, 633, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (40488, 633, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (40489, 633, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (40490, 633, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (40491, 633, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (40492, 633, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (40493, 633, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (40494, 633, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (40495, 633, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (40496, 633, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (40497, 633, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (40498, 633, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (40499, 633, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (40500, 633, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (40501, 633, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (40502, 633, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (40503, 633, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (40504, 633, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (40505, 633, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (40506, 633, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (40507, 633, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (40508, 633, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (40509, 633, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (40510, 633, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (40511, 633, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (40512, 633, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (40513, 633, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (40514, 633, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (40515, 633, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (40516, 633, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (40517, 633, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (40518, 633, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (40519, 633, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (40520, 633, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (40521, 633, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (40522, 633, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (40523, 633, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (40524, 633, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (40525, 633, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (40526, 633, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (40527, 633, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (40528, 633, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (40529, 633, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (40530, 633, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (40531, 633, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (40532, 633, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (40533, 633, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (40534, 633, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (40535, 633, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (40536, 633, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (40537, 633, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (40538, 633, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (40539, 633, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (40540, 633, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (40541, 633, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (40542, 633, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (40543, 633, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (40544, 633, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (40545, 633, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (40546, 633, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (40547, 633, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (40548, 633, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (40549, 633, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (40550, 633, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (40551, 633, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (40552, 633, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (40553, 633, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (40554, 633, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (40555, 633, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (40556, 633, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (40557, 633, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (40558, 633, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (40559, 633, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (40560, 633, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (40561, 633, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (40562, 633, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (40563, 633, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (40564, 633, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (40565, 633, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (40566, 633, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (40567, 633, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (40568, 633, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (40569, 633, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (40570, 633, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (40571, 633, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (40572, 633, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (40573, 633, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (40574, 633, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (40575, 633, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (40576, 633, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (40577, 633, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (40578, 633, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (40579, 633, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (40580, 633, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (40581, 633, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (40582, 633, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (40583, 633, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (40584, 633, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (40585, 633, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (40586, 633, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (40587, 633, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (40588, 633, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (40589, 633, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (40590, 633, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (40591, 633, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (40592, 633, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (40593, 633, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (40594, 633, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (40595, 633, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (40596, 633, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (40597, 633, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (40598, 633, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (40599, 633, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (40600, 633, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (40601, 633, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (40602, 633, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (40603, 633, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (40604, 633, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (40605, 633, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (40606, 633, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (40607, 633, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (40608, 633, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (40609, 633, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (40610, 633, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (40611, 633, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (40612, 633, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (40613, 633, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (40614, 633, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (40615, 633, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (40616, 633, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (40617, 633, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (40618, 633, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (40619, 633, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (40620, 633, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (40621, 633, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (40622, 633, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (40623, 633, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (40624, 633, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (40625, 633, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (40626, 633, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (40627, 633, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (40628, 633, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (40629, 633, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (40630, 633, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (40631, 633, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (40632, 633, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (40633, 633, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (40634, 633, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (40635, 633, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (40636, 633, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (40637, 633, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (40638, 633, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (40639, 633, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (40640, 633, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (40641, 633, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (40642, 633, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (40643, 633, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (40644, 633, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (40645, 633, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (40646, 633, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (40647, 633, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (40648, 633, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (40649, 633, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (40650, 633, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (40651, 633, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (40652, 633, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (40653, 633, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (40654, 633, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (40655, 633, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (40656, 633, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (40657, 633, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (40658, 633, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (40659, 633, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (40660, 633, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (40661, 633, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (40662, 633, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (40663, 633, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (40664, 633, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (40665, 633, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (40666, 633, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (40667, 633, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (40668, 633, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (40669, 633, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (40670, 633, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (40671, 633, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (40672, 633, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (40673, 633, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (40674, 633, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (40675, 633, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (40676, 633, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (40677, 633, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (40678, 633, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (40679, 633, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (40680, 633, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (40681, 633, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (40682, 633, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (40683, 633, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (40684, 633, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (40685, 633, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (40686, 633, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (40687, 633, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (40688, 633, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (40689, 633, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (40690, 633, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (40691, 633, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (40692, 633, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (40693, 633, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (40694, 633, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (40695, 633, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (40696, 633, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (40697, 633, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (40698, 633, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (40699, 633, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (40700, 633, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (40701, 633, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (40702, 633, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (40703, 633, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (40704, 633, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (40705, 633, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (40706, 633, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (40707, 633, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (40708, 633, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (40709, 633, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (40710, 633, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (40711, 633, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (40712, 633, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (40713, 633, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (40714, 633, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (40715, 633, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (40716, 633, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (40717, 633, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (40718, 633, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (40719, 633, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (40720, 633, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (40721, 633, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (40722, 633, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (40723, 633, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (40724, 633, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (40725, 633, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (40726, 633, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (40727, 633, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (40728, 633, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (40729, 633, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (40730, 633, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (40731, 633, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (40732, 633, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (40733, 633, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (40734, 633, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (40735, 633, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (40736, 633, 48, 562);
INSERT INTO 'capvalue' VALUES (2259, '4194264');
INSERT INTO 'devicecapvalue' VALUES (40737, 633, 49, 2259);
INSERT INTO 'capvalue' VALUES (2260, 'SGH-Z630/1.0 NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (40738, 633, 53, 2260);
INSERT INTO 'capvalue' VALUES (2261, '2007-01-31');
INSERT INTO 'devicecapvalue' VALUES (40739, 634, 158, 2261);
INSERT INTO 'devicecapvalue' VALUES (40740, 634, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (40741, 634, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (40742, 634, 7, 2112);
INSERT INTO 'devicecapvalue' VALUES (40743, 634, 173, 2195);
INSERT INTO 'devicecapvalue' VALUES (40744, 634, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (40745, 634, 10, 1);
INSERT INTO 'devicecapvalue' VALUES (40746, 634, 11, 864);
INSERT INTO 'devicecapvalue' VALUES (40747, 634, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (40748, 634, 13, 2251);
INSERT INTO 'devicecapvalue' VALUES (40749, 634, 76, 1031);
INSERT INTO 'devicecapvalue' VALUES (40750, 634, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (40751, 634, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (40752, 634, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (40753, 634, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (40754, 634, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (40755, 634, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (40756, 634, 17, 2192);
INSERT INTO 'devicecapvalue' VALUES (40757, 634, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40758, 634, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40759, 634, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (40760, 634, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (40761, 634, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (40762, 634, 155, 1130);
INSERT INTO 'devicecapvalue' VALUES (40763, 634, 232, 106);
INSERT INTO 'devicecapvalue' VALUES (40764, 634, 234, 244);
INSERT INTO 'devicecapvalue' VALUES (40765, 634, 235, 15);
INSERT INTO 'devicecapvalue' VALUES (40766, 634, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (40767, 634, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (40768, 634, 238, 15);
INSERT INTO 'devicecapvalue' VALUES (40769, 634, 239, 15);
INSERT INTO 'devicecapvalue' VALUES (40770, 634, 240, 15);
INSERT INTO 'devicecapvalue' VALUES (40771, 634, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (40772, 634, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (40773, 634, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (40774, 634, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (40775, 634, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (40776, 634, 5, 2252);
INSERT INTO 'devicecapvalue' VALUES (40777, 634, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (40778, 634, 52, 1031);
INSERT INTO 'devicecapvalue' VALUES (40779, 634, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (40780, 634, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (40781, 634, 191, 2166);
INSERT INTO 'capvalue' VALUES (2262, 'SAMSUNG-SGH-Z720-Vodafone/1.0 SHP/VPP/R5 NetFront/3.3 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (40782, 634, 53, 2262);
INSERT INTO 'devicecapvalue' VALUES (40783, 635, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (40784, 635, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (40785, 635, 7, 863);
INSERT INTO 'cap' VALUES (244, 'Emulator.Control', 1);
INSERT INTO 'capvalue' VALUES (2263, 'SamsungZM60');
INSERT INTO 'devicecapvalue' VALUES (40786, 635, 244, 2263);
INSERT INTO 'devicecapvalue' VALUES (40787, 635, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (40788, 635, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (40789, 635, 10, 864);
INSERT INTO 'devicecapvalue' VALUES (40790, 635, 11, 13);
INSERT INTO 'devicecapvalue' VALUES (40791, 635, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (40792, 635, 13, 2254);
INSERT INTO 'devicecapvalue' VALUES (40793, 635, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (40794, 635, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (40795, 635, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (40796, 635, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (40797, 635, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (40798, 635, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (40799, 635, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (40800, 635, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (40801, 635, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (40802, 635, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40803, 635, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (40804, 635, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (40805, 635, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (40806, 635, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (40807, 635, 30, 40);
INSERT INTO 'capvalue' VALUES (2264, 'video/H.263');
INSERT INTO 'devicecapvalue' VALUES (40808, 635, 39, 2264);
INSERT INTO 'devicecapvalue' VALUES (40809, 635, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (40810, 635, 40, 55);
INSERT INTO 'capvalue' VALUES (2265, 'audio/x-wav audio/midi audio/x-midi audio/sp-midi audio/mmf audio/x-mmf audio/adpcm audio/amr audio/mpeg audio/x-mpeg audio/aac image/gif video/mpeg video/H.263 video/3gp');
INSERT INTO 'devicecapvalue' VALUES (40811, 635, 42, 2265);
INSERT INTO 'devicecapvalue' VALUES (40812, 635, 231, 1341);
INSERT INTO 'devicecapvalue' VALUES (40813, 635, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (40814, 635, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (40815, 635, 68, 243);
INSERT INTO 'devicecapvalue' VALUES (40816, 635, 86, 244);
INSERT INTO 'devicecapvalue' VALUES (40817, 635, 70, 244);
INSERT INTO 'devicecapvalue' VALUES (40818, 635, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (40819, 635, 136, 2264);
INSERT INTO 'devicecapvalue' VALUES (40820, 635, 137, 18);
INSERT INTO 'devicecapvalue' VALUES (40821, 635, 137, 96);
INSERT INTO 'devicecapvalue' VALUES (40822, 635, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (40823, 635, 5, 2255);
INSERT INTO 'devicecapvalue' VALUES (40824, 635, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (40825, 635, 51, 1355);
INSERT INTO 'devicecapvalue' VALUES (40826, 635, 51, 1185);
INSERT INTO 'devicecapvalue' VALUES (40827, 635, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (40828, 635, 51, 1349);
INSERT INTO 'capvalue' VALUES (2266, 'raw');
INSERT INTO 'devicecapvalue' VALUES (40829, 635, 51, 2266);
INSERT INTO 'devicecapvalue' VALUES (40830, 635, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (40831, 635, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (40832, 635, 51, 1191);
INSERT INTO 'devicecapvalue' VALUES (40833, 635, 51, 1192);
INSERT INTO 'devicecapvalue' VALUES (40834, 635, 52, 1086);
INSERT INTO 'devicecapvalue' VALUES (40835, 635, 157, 1087);
INSERT INTO 'capvalue' VALUES (2267, 'SGH-ZM60 SHP/VPP/R5 SMB3.1 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (40836, 635, 53, 2267);
INSERT INTO 'devicecapvalue' VALUES (40837, 636, 7, 1916);
INSERT INTO 'devicecapvalue' VALUES (40838, 636, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (40839, 636, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (40840, 636, 9, 663);
INSERT INTO 'devicecapvalue' VALUES (40841, 636, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (40842, 636, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (40843, 636, 12, 710);
INSERT INTO 'devicecapvalue' VALUES (40844, 636, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (40845, 636, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (40846, 636, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (40847, 636, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (40848, 636, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (40849, 636, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (40850, 636, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (40851, 636, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (40852, 636, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (40853, 636, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (40854, 636, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (40855, 636, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (40856, 636, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (40857, 636, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (40858, 636, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (40859, 636, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (40860, 636, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (40861, 636, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (40862, 636, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40863, 636, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (40864, 636, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (40865, 636, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (40866, 636, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (40867, 636, 20, 1244);
INSERT INTO 'devicecapvalue' VALUES (40868, 636, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (40869, 636, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (40870, 636, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (40871, 636, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (40872, 636, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (40873, 636, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (40874, 636, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (40875, 636, 38, 1577);
INSERT INTO 'devicecapvalue' VALUES (40876, 636, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (40877, 636, 39, 1045);
INSERT INTO 'devicecapvalue' VALUES (40878, 636, 39, 616);
INSERT INTO 'devicecapvalue' VALUES (40879, 636, 39, 867);
INSERT INTO 'devicecapvalue' VALUES (40880, 636, 39, 1050);
INSERT INTO 'devicecapvalue' VALUES (40881, 636, 39, 1578);
INSERT INTO 'devicecapvalue' VALUES (40882, 636, 39, 51);
INSERT INTO 'devicecapvalue' VALUES (40883, 636, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (40884, 636, 39, 1051);
INSERT INTO 'devicecapvalue' VALUES (40885, 636, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (40886, 636, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (40887, 636, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (40888, 636, 40, 125);
INSERT INTO 'devicecapvalue' VALUES (40889, 636, 40, 1579);
INSERT INTO 'devicecapvalue' VALUES (40890, 636, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (40891, 636, 40, 1580);
INSERT INTO 'devicecapvalue' VALUES (40892, 636, 40, 131);
INSERT INTO 'devicecapvalue' VALUES (40893, 636, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (40894, 636, 40, 1581);
INSERT INTO 'devicecapvalue' VALUES (40895, 636, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (40896, 636, 40, 135);
INSERT INTO 'devicecapvalue' VALUES (40897, 636, 40, 2213);
INSERT INTO 'devicecapvalue' VALUES (40898, 636, 40, 2214);
INSERT INTO 'devicecapvalue' VALUES (40899, 636, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (40900, 636, 41, 868);
INSERT INTO 'devicecapvalue' VALUES (40901, 636, 41, 964);
INSERT INTO 'devicecapvalue' VALUES (40902, 636, 41, 2215);
INSERT INTO 'devicecapvalue' VALUES (40903, 636, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (40904, 636, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (40905, 636, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (40906, 636, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (40907, 636, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (40908, 636, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (40909, 636, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (40910, 636, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (40911, 636, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (40912, 636, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (40913, 636, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (40914, 636, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (40915, 636, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (40916, 636, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (40917, 636, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (40918, 636, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (40919, 636, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (40920, 636, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (40921, 636, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (40922, 636, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (40923, 636, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (40924, 636, 41, 128);
INSERT INTO 'devicecapvalue' VALUES (40925, 636, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (40926, 636, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (40927, 636, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (40928, 636, 41, 2216);
INSERT INTO 'devicecapvalue' VALUES (40929, 636, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (40930, 636, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (40931, 636, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (40932, 636, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (40933, 636, 41, 2213);
INSERT INTO 'devicecapvalue' VALUES (40934, 636, 41, 2214);
INSERT INTO 'devicecapvalue' VALUES (40935, 636, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (40936, 636, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (40937, 636, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (40938, 636, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (40939, 636, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (40940, 636, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (40941, 636, 42, 868);
INSERT INTO 'devicecapvalue' VALUES (40942, 636, 42, 964);
INSERT INTO 'devicecapvalue' VALUES (40943, 636, 42, 2215);
INSERT INTO 'devicecapvalue' VALUES (40944, 636, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (40945, 636, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (40946, 636, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (40947, 636, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (40948, 636, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (40949, 636, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (40950, 636, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (40951, 636, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (40952, 636, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (40953, 636, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (40954, 636, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (40955, 636, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (40956, 636, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (40957, 636, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (40958, 636, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (40959, 636, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (40960, 636, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (40961, 636, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (40962, 636, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (40963, 636, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (40964, 636, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (40965, 636, 42, 128);
INSERT INTO 'devicecapvalue' VALUES (40966, 636, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (40967, 636, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (40968, 636, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (40969, 636, 42, 2216);
INSERT INTO 'devicecapvalue' VALUES (40970, 636, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (40971, 636, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (40972, 636, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (40973, 636, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (40974, 636, 42, 2213);
INSERT INTO 'devicecapvalue' VALUES (40975, 636, 42, 2214);
INSERT INTO 'devicecapvalue' VALUES (40976, 636, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (40977, 636, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (40978, 636, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (40979, 636, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (40980, 636, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (40981, 636, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (40982, 636, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (40983, 636, 45, 1585);
INSERT INTO 'devicecapvalue' VALUES (40984, 636, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (40985, 636, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (40986, 636, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (40987, 636, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (40988, 636, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (40989, 636, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (40990, 636, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (40991, 636, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (40992, 636, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (40993, 636, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (40994, 636, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (40995, 636, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (40996, 636, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (40997, 636, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (40998, 636, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (40999, 636, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (41000, 636, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (41001, 636, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (41002, 636, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (41003, 636, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (41004, 636, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (41005, 636, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (41006, 636, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (41007, 636, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (41008, 636, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (41009, 636, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (41010, 636, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (41011, 636, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (41012, 636, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (41013, 636, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (41014, 636, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (41015, 636, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (41016, 636, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (41017, 636, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (41018, 636, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (41019, 636, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (41020, 636, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (41021, 636, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (41022, 636, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (41023, 636, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (41024, 636, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (41025, 636, 47, 56);
INSERT INTO 'devicecapvalue' VALUES (41026, 636, 47, 868);
INSERT INTO 'devicecapvalue' VALUES (41027, 636, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (41028, 636, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (41029, 636, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (41030, 636, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (41031, 636, 47, 1684);
INSERT INTO 'devicecapvalue' VALUES (41032, 636, 47, 986);
INSERT INTO 'devicecapvalue' VALUES (41033, 636, 47, 988);
INSERT INTO 'devicecapvalue' VALUES (41034, 636, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (41035, 636, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (41036, 636, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (41037, 636, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (41038, 636, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (41039, 636, 49, 1457);
INSERT INTO 'capvalue' VALUES (2268, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; pl; rv:1.9.0.11) Gecko/2009060215 Firefox/3.0.11');
INSERT INTO 'devicecapvalue' VALUES (41040, 636, 53, 2268);
INSERT INTO 'devicecapvalue' VALUES (41041, 637, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (41042, 637, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (41043, 637, 7, 2160);
INSERT INTO 'devicecapvalue' VALUES (41044, 637, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (41045, 637, 10, 649);
INSERT INTO 'devicecapvalue' VALUES (41046, 637, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (41047, 637, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (41048, 637, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (41049, 637, 76, 1124);
INSERT INTO 'devicecapvalue' VALUES (41050, 637, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41051, 637, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (41052, 637, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (41053, 637, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (41054, 637, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (41055, 637, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41056, 637, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (41057, 637, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (41058, 637, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (41059, 637, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (41060, 637, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (41061, 637, 50, 2157);
INSERT INTO 'devicecapvalue' VALUES (41062, 637, 155, 2158);
INSERT INTO 'devicecapvalue' VALUES (41063, 637, 232, 1965);
INSERT INTO 'devicecapvalue' VALUES (41064, 637, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (41065, 637, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (41066, 637, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (41067, 637, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (41068, 637, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (41069, 637, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (41070, 637, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (41071, 637, 156, 1415);
INSERT INTO 'devicecapvalue' VALUES (41072, 637, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (41073, 637, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (41074, 637, 241, 102);
INSERT INTO 'devicecapvalue' VALUES (41075, 637, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (41076, 637, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (41077, 637, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (41078, 637, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (41079, 637, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (41080, 637, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (41081, 637, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (41082, 637, 191, 2166);
INSERT INTO 'devicecapvalue' VALUES (41083, 638, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (41084, 638, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (41085, 638, 7, 2174);
INSERT INTO 'devicecapvalue' VALUES (41086, 638, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (41087, 638, 10, 106);
INSERT INTO 'devicecapvalue' VALUES (41088, 638, 11, 1);
INSERT INTO 'devicecapvalue' VALUES (41089, 638, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (41090, 638, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (41091, 638, 76, 1348);
INSERT INTO 'devicecapvalue' VALUES (41092, 638, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41093, 638, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (41094, 638, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (41095, 638, 17, 2143);
INSERT INTO 'devicecapvalue' VALUES (41096, 638, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (41097, 638, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41098, 638, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (41099, 638, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (41100, 638, 154, 1073);
INSERT INTO 'devicecapvalue' VALUES (41101, 638, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (41102, 638, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (41103, 638, 50, 1457);
INSERT INTO 'devicecapvalue' VALUES (41104, 638, 155, 1162);
INSERT INTO 'devicecapvalue' VALUES (41105, 638, 232, 110);
INSERT INTO 'devicecapvalue' VALUES (41106, 638, 234, 15);
INSERT INTO 'devicecapvalue' VALUES (41107, 638, 235, 244);
INSERT INTO 'devicecapvalue' VALUES (41108, 638, 236, 244);
INSERT INTO 'devicecapvalue' VALUES (41109, 638, 237, 244);
INSERT INTO 'devicecapvalue' VALUES (41110, 638, 238, 244);
INSERT INTO 'devicecapvalue' VALUES (41111, 638, 239, 244);
INSERT INTO 'devicecapvalue' VALUES (41112, 638, 240, 244);
INSERT INTO 'devicecapvalue' VALUES (41113, 638, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (41114, 638, 241, 2146);
INSERT INTO 'devicecapvalue' VALUES (41115, 638, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (41116, 638, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (41117, 638, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (41118, 638, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (41119, 638, 52, 1124);
INSERT INTO 'devicecapvalue' VALUES (41120, 638, 191, 2161);
INSERT INTO 'devicecapvalue' VALUES (41121, 639, 7, 2117);
INSERT INTO 'devicecapvalue' VALUES (41122, 639, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (41123, 639, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (41124, 639, 9, 603);
INSERT INTO 'devicecapvalue' VALUES (41125, 639, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (41126, 639, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (41127, 639, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (41128, 639, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (41129, 639, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (41130, 639, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (41131, 639, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (41132, 639, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (41133, 639, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (41134, 639, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (41135, 639, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (41136, 639, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (41137, 639, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (41138, 639, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (41139, 639, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (41140, 639, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (41141, 639, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (41142, 639, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (41143, 639, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (41144, 639, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (41145, 639, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (41146, 639, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (41147, 639, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (41148, 639, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (41149, 639, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (41150, 639, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (41151, 639, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (41152, 639, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (41153, 639, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (41154, 639, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (41155, 639, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (41156, 639, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (41157, 639, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (41158, 639, 32, 852);
INSERT INTO 'devicecapvalue' VALUES (41159, 639, 32, 2094);
INSERT INTO 'devicecapvalue' VALUES (41160, 639, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (41161, 639, 34, 44);
INSERT INTO 'devicecapvalue' VALUES (41162, 639, 35, 45);
INSERT INTO 'devicecapvalue' VALUES (41163, 639, 36, 2118);
INSERT INTO 'devicecapvalue' VALUES (41164, 639, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (41165, 639, 38, 2083);
INSERT INTO 'devicecapvalue' VALUES (41166, 639, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (41167, 639, 39, 1049);
INSERT INTO 'devicecapvalue' VALUES (41168, 639, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (41169, 639, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (41170, 639, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (41171, 639, 41, 2070);
INSERT INTO 'devicecapvalue' VALUES (41172, 639, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (41173, 639, 41, 2071);
INSERT INTO 'devicecapvalue' VALUES (41174, 639, 41, 2072);
INSERT INTO 'devicecapvalue' VALUES (41175, 639, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (41176, 639, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (41177, 639, 41, 1582);
INSERT INTO 'devicecapvalue' VALUES (41178, 639, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (41179, 639, 41, 2073);
INSERT INTO 'devicecapvalue' VALUES (41180, 639, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (41181, 639, 41, 2074);
INSERT INTO 'devicecapvalue' VALUES (41182, 639, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (41183, 639, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (41184, 639, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (41185, 639, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (41186, 639, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (41187, 639, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (41188, 639, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (41189, 639, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (41190, 639, 41, 986);
INSERT INTO 'devicecapvalue' VALUES (41191, 639, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (41192, 639, 41, 988);
INSERT INTO 'devicecapvalue' VALUES (41193, 639, 41, 1278);
INSERT INTO 'devicecapvalue' VALUES (41194, 639, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (41195, 639, 41, 65);
INSERT INTO 'devicecapvalue' VALUES (41196, 639, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (41197, 639, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (41198, 639, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (41199, 639, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (41200, 639, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (41201, 639, 41, 2078);
INSERT INTO 'devicecapvalue' VALUES (41202, 639, 41, 2079);
INSERT INTO 'devicecapvalue' VALUES (41203, 639, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (41204, 639, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (41205, 639, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (41206, 639, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (41207, 639, 41, 122);
INSERT INTO 'devicecapvalue' VALUES (41208, 639, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (41209, 639, 41, 1051);
INSERT INTO 'devicecapvalue' VALUES (41210, 639, 41, 136);
INSERT INTO 'devicecapvalue' VALUES (41211, 639, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (41212, 639, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (41213, 639, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (41214, 639, 41, 2081);
INSERT INTO 'devicecapvalue' VALUES (41215, 639, 41, 1281);
INSERT INTO 'devicecapvalue' VALUES (41216, 639, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (41217, 639, 41, 2082);
INSERT INTO 'devicecapvalue' VALUES (41218, 639, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (41219, 639, 42, 2070);
INSERT INTO 'devicecapvalue' VALUES (41220, 639, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (41221, 639, 42, 2071);
INSERT INTO 'devicecapvalue' VALUES (41222, 639, 42, 2072);
INSERT INTO 'devicecapvalue' VALUES (41223, 639, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (41224, 639, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (41225, 639, 42, 1582);
INSERT INTO 'devicecapvalue' VALUES (41226, 639, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (41227, 639, 42, 2073);
INSERT INTO 'devicecapvalue' VALUES (41228, 639, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (41229, 639, 42, 2074);
INSERT INTO 'devicecapvalue' VALUES (41230, 639, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (41231, 639, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (41232, 639, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (41233, 639, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (41234, 639, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (41235, 639, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (41236, 639, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (41237, 639, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (41238, 639, 42, 986);
INSERT INTO 'devicecapvalue' VALUES (41239, 639, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (41240, 639, 42, 988);
INSERT INTO 'devicecapvalue' VALUES (41241, 639, 42, 1278);
INSERT INTO 'devicecapvalue' VALUES (41242, 639, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (41243, 639, 42, 65);
INSERT INTO 'devicecapvalue' VALUES (41244, 639, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (41245, 639, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (41246, 639, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (41247, 639, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (41248, 639, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (41249, 639, 42, 2078);
INSERT INTO 'devicecapvalue' VALUES (41250, 639, 42, 2079);
INSERT INTO 'devicecapvalue' VALUES (41251, 639, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (41252, 639, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (41253, 639, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (41254, 639, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (41255, 639, 42, 122);
INSERT INTO 'devicecapvalue' VALUES (41256, 639, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (41257, 639, 42, 1051);
INSERT INTO 'devicecapvalue' VALUES (41258, 639, 42, 136);
INSERT INTO 'devicecapvalue' VALUES (41259, 639, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (41260, 639, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (41261, 639, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (41262, 639, 42, 2081);
INSERT INTO 'devicecapvalue' VALUES (41263, 639, 42, 1281);
INSERT INTO 'devicecapvalue' VALUES (41264, 639, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (41265, 639, 42, 2082);
INSERT INTO 'devicecapvalue' VALUES (41266, 639, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (41267, 639, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (41268, 639, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (41269, 639, 45, 2090);
INSERT INTO 'devicecapvalue' VALUES (41270, 639, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (41271, 639, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (41272, 639, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (41273, 639, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (41274, 639, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (41275, 639, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (41276, 639, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (41277, 639, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (41278, 639, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (41279, 639, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (41280, 639, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (41281, 639, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (41282, 639, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (41283, 639, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (41284, 639, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (41285, 639, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (41286, 639, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (41287, 639, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (41288, 639, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (41289, 639, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (41290, 639, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (41291, 639, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (41292, 639, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (41293, 639, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (41294, 639, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (41295, 639, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (41296, 639, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (41297, 639, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (41298, 639, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (41299, 639, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (41300, 639, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (41301, 639, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (41302, 639, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (41303, 639, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (41304, 639, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (41305, 639, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (41306, 639, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (41307, 639, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (41308, 639, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (41309, 639, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (41310, 639, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (41311, 639, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (41312, 639, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (41313, 639, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (41314, 639, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (41315, 639, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (41316, 639, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (41317, 639, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (41318, 639, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (41319, 639, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (41320, 639, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (41321, 639, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (41322, 639, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (41323, 639, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (41324, 639, 47, 2070);
INSERT INTO 'devicecapvalue' VALUES (41325, 639, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (41326, 639, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (41327, 639, 47, 1582);
INSERT INTO 'devicecapvalue' VALUES (41328, 639, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (41329, 639, 47, 49);
INSERT INTO 'devicecapvalue' VALUES (41330, 639, 47, 2074);
INSERT INTO 'devicecapvalue' VALUES (41331, 639, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (41332, 639, 47, 126);
INSERT INTO 'devicecapvalue' VALUES (41333, 639, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (41334, 639, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (41335, 639, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (41336, 639, 47, 1252);
INSERT INTO 'devicecapvalue' VALUES (41337, 639, 47, 1278);
INSERT INTO 'devicecapvalue' VALUES (41338, 639, 47, 65);
INSERT INTO 'devicecapvalue' VALUES (41339, 639, 47, 127);
INSERT INTO 'devicecapvalue' VALUES (41340, 639, 47, 1049);
INSERT INTO 'devicecapvalue' VALUES (41341, 639, 47, 1256);
INSERT INTO 'devicecapvalue' VALUES (41342, 639, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (41343, 639, 47, 2078);
INSERT INTO 'devicecapvalue' VALUES (41344, 639, 47, 2079);
INSERT INTO 'devicecapvalue' VALUES (41345, 639, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (41346, 639, 47, 122);
INSERT INTO 'devicecapvalue' VALUES (41347, 639, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (41348, 639, 47, 1051);
INSERT INTO 'devicecapvalue' VALUES (41349, 639, 47, 136);
INSERT INTO 'devicecapvalue' VALUES (41350, 639, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (41351, 639, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (41352, 639, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (41353, 639, 47, 2081);
INSERT INTO 'devicecapvalue' VALUES (41354, 639, 47, 1281);
INSERT INTO 'devicecapvalue' VALUES (41355, 639, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (41356, 639, 47, 2082);
INSERT INTO 'devicecapvalue' VALUES (41357, 639, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (41358, 639, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (41359, 639, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (41360, 639, 49, 1031);
INSERT INTO 'devicecapvalue' VALUES (41361, 639, 53, 2119);
INSERT INTO 'devicecapvalue' VALUES (41362, 640, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (41363, 640, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (41364, 640, 7, 2110);
INSERT INTO 'devicecapvalue' VALUES (41365, 640, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (41366, 640, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (41367, 640, 76, 2104);
INSERT INTO 'devicecapvalue' VALUES (41368, 640, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41369, 640, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (41370, 640, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41371, 640, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (41372, 640, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (41373, 640, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (41374, 640, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (41375, 640, 156, 1116);
INSERT INTO 'devicecapvalue' VALUES (41376, 640, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (41377, 640, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (41378, 640, 51, 2105);
INSERT INTO 'capvalue' VALUES (2269, 'SEC-SGHX105-X105UVDB1-NW.Browser3.01');
INSERT INTO 'devicecapvalue' VALUES (41379, 640, 53, 2269);
INSERT INTO 'devicecapvalue' VALUES (41380, 641, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (41381, 641, 74, 653);
INSERT INTO 'capvalue' VALUES (2270, '128x143');
INSERT INTO 'devicecapvalue' VALUES (41382, 641, 7, 2270);
INSERT INTO 'devicecapvalue' VALUES (41383, 641, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (41384, 641, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (41385, 641, 76, 2104);
INSERT INTO 'devicecapvalue' VALUES (41386, 641, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41387, 641, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (41388, 641, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41389, 641, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (41390, 641, 232, 709);
INSERT INTO 'devicecapvalue' VALUES (41391, 641, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (41392, 641, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (41393, 641, 156, 2121);
INSERT INTO 'devicecapvalue' VALUES (41394, 641, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (41395, 641, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (41396, 641, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (41397, 641, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (41398, 642, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (41399, 642, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (41400, 642, 74, 2102);
INSERT INTO 'devicecapvalue' VALUES (41401, 642, 7, 2107);
INSERT INTO 'devicecapvalue' VALUES (41402, 642, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (41403, 642, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (41404, 642, 76, 2099);
INSERT INTO 'devicecapvalue' VALUES (41405, 642, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41406, 642, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (41407, 642, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41408, 642, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (41409, 642, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (41410, 642, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (41411, 642, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (41412, 642, 156, 2101);
INSERT INTO 'devicecapvalue' VALUES (41413, 642, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (41414, 642, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (41415, 642, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (41416, 642, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (41417, 642, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (41418, 643, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (41419, 643, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (41420, 643, 7, 2107);
INSERT INTO 'devicecapvalue' VALUES (41421, 643, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (41422, 643, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (41423, 643, 76, 2099);
INSERT INTO 'devicecapvalue' VALUES (41424, 643, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41425, 643, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (41426, 643, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41427, 643, 50, 1066);
INSERT INTO 'devicecapvalue' VALUES (41428, 643, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (41429, 643, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (41430, 643, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (41431, 643, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (41432, 643, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (41433, 643, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (41434, 643, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (41435, 643, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (41436, 644, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (41437, 644, 74, 653);
INSERT INTO 'capvalue' VALUES (2271, '176x161');
INSERT INTO 'devicecapvalue' VALUES (41438, 644, 7, 2271);
INSERT INTO 'devicecapvalue' VALUES (41439, 644, 2, 657);
INSERT INTO 'capvalue' VALUES (2272, '176x177');
INSERT INTO 'devicecapvalue' VALUES (41440, 644, 13, 2272);
INSERT INTO 'devicecapvalue' VALUES (41441, 644, 76, 2157);
INSERT INTO 'devicecapvalue' VALUES (41442, 644, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41443, 644, 16, 2108);
INSERT INTO 'devicecapvalue' VALUES (41444, 644, 6, 27);
INSERT INTO 'capvalue' VALUES (2273, '256000');
INSERT INTO 'devicecapvalue' VALUES (41445, 644, 50, 2273);
INSERT INTO 'devicecapvalue' VALUES (41446, 644, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (41447, 644, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (41448, 644, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (41449, 644, 156, 2101);
INSERT INTO 'devicecapvalue' VALUES (41450, 644, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (41451, 644, 4, 679);
INSERT INTO 'capvalue' VALUES (2274, '177');
INSERT INTO 'devicecapvalue' VALUES (41452, 644, 5, 2274);
INSERT INTO 'devicecapvalue' VALUES (41453, 644, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (41454, 644, 51, 1496);
INSERT INTO 'capvalue' VALUES (2275, 'SGH-Z107/1.0 SHP/VPP/R5 SMB3.1 SMM-MMS/1.2.0 profile/MIDP-2.0 configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (41455, 644, 53, 2275);
INSERT INTO 'devicecapvalue' VALUES (41456, 645, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (41457, 645, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (41458, 645, 7, 2271);
INSERT INTO 'devicecapvalue' VALUES (41459, 645, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (41460, 645, 13, 2272);
INSERT INTO 'devicecapvalue' VALUES (41461, 645, 76, 2157);
INSERT INTO 'devicecapvalue' VALUES (41462, 645, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41463, 645, 16, 2108);
INSERT INTO 'devicecapvalue' VALUES (41464, 645, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41465, 645, 50, 2273);
INSERT INTO 'devicecapvalue' VALUES (41466, 645, 232, 1);
INSERT INTO 'devicecapvalue' VALUES (41467, 645, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (41468, 645, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (41469, 645, 156, 2101);
INSERT INTO 'devicecapvalue' VALUES (41470, 645, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (41471, 645, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (41472, 645, 5, 2274);
INSERT INTO 'devicecapvalue' VALUES (41473, 645, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (41474, 645, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (41475, 645, 53, 2275);
INSERT INTO 'devicecapvalue' VALUES (41476, 646, 7, 742);
INSERT INTO 'devicecapvalue' VALUES (41477, 646, 8, 235);
INSERT INTO 'devicecapvalue' VALUES (41478, 646, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (41479, 646, 9, 864);
INSERT INTO 'devicecapvalue' VALUES (41480, 646, 10, 864);
INSERT INTO 'devicecapvalue' VALUES (41481, 646, 11, 864);
INSERT INTO 'devicecapvalue' VALUES (41482, 646, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (41483, 646, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (41484, 646, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (41485, 646, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (41486, 646, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (41487, 646, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (41488, 646, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (41489, 646, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (41490, 646, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (41491, 646, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (41492, 646, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (41493, 646, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (41494, 646, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (41495, 646, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (41496, 646, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41497, 646, 18, 40);
INSERT INTO 'devicecapvalue' VALUES (41498, 646, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (41499, 646, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (41500, 646, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (41501, 646, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (41502, 646, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (41503, 646, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (41504, 646, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (41505, 646, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (41506, 646, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (41507, 646, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (41508, 646, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (41509, 646, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (41510, 646, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (41511, 646, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (41512, 646, 41, 2077);
INSERT INTO 'devicecapvalue' VALUES (41513, 646, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (41514, 646, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (41515, 646, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (41516, 646, 42, 2077);
INSERT INTO 'devicecapvalue' VALUES (41517, 646, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (41518, 646, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (41519, 646, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (41520, 646, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (41521, 646, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (41522, 646, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (41523, 646, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (41524, 646, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (41525, 646, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (41526, 646, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (41527, 646, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (41528, 646, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (41529, 646, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (41530, 646, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (41531, 646, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (41532, 646, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (41533, 646, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (41534, 646, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (41535, 646, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (41536, 646, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (41537, 646, 59, 240);
INSERT INTO 'devicecapvalue' VALUES (41538, 646, 73, 54);
INSERT INTO 'devicecapvalue' VALUES (41539, 646, 73, 2077);
INSERT INTO 'devicecapvalue' VALUES (41540, 646, 73, 55);
INSERT INTO 'devicecapvalue' VALUES (41541, 646, 73, 51);
INSERT INTO 'devicecapvalue' VALUES (41542, 646, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (41543, 646, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (41544, 646, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (41545, 646, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (41546, 646, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (41547, 646, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (41548, 646, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (41549, 646, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (41550, 646, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (41551, 646, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (41552, 646, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (41553, 646, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (41554, 646, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (41555, 646, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (41556, 646, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (41557, 646, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (41558, 646, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (41559, 646, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (41560, 646, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (41561, 646, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (41562, 646, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (41563, 646, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (41564, 646, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (41565, 646, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (41566, 646, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (41567, 646, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (41568, 646, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (41569, 646, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (41570, 646, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (41571, 646, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (41572, 646, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (41573, 646, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (41574, 646, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (41575, 646, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (41576, 646, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (41577, 646, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (41578, 646, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (41579, 646, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (41580, 646, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (41581, 646, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (41582, 646, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (41583, 646, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (41584, 646, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (41585, 646, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (41586, 646, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (41587, 646, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (41588, 646, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (41589, 646, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (41590, 646, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (41591, 646, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (41592, 646, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (41593, 646, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (41594, 646, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (41595, 646, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (41596, 646, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (41597, 646, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (41598, 646, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (41599, 646, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (41600, 646, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (41601, 646, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (41602, 646, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (41603, 646, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (41604, 646, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (41605, 646, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (41606, 646, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (41607, 646, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (41608, 646, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (41609, 646, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (41610, 646, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (41611, 646, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (41612, 646, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (41613, 646, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (41614, 646, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (41615, 646, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (41616, 646, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (41617, 646, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (41618, 646, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (41619, 646, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (41620, 646, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (41621, 646, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (41622, 646, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (41623, 646, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (41624, 646, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (41625, 646, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (41626, 646, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (41627, 646, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (41628, 646, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (41629, 646, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (41630, 646, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (41631, 646, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (41632, 646, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (41633, 646, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (41634, 646, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (41635, 646, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (41636, 646, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (41637, 646, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (41638, 646, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (41639, 646, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (41640, 646, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (41641, 646, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (41642, 646, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (41643, 646, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (41644, 646, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (41645, 646, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (41646, 646, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (41647, 646, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (41648, 646, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (41649, 646, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (41650, 646, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (41651, 646, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (41652, 646, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (41653, 646, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (41654, 646, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (41655, 646, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (41656, 646, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (41657, 646, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (41658, 646, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (41659, 646, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (41660, 646, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (41661, 646, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (41662, 646, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (41663, 646, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (41664, 646, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (41665, 646, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (41666, 646, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (41667, 646, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (41668, 646, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (41669, 646, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (41670, 646, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (41671, 646, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (41672, 646, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (41673, 646, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (41674, 646, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (41675, 646, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (41676, 646, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (41677, 646, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (41678, 646, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (41679, 646, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (41680, 646, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (41681, 646, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (41682, 646, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (41683, 646, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (41684, 646, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (41685, 646, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (41686, 646, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (41687, 646, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (41688, 646, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (41689, 646, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (41690, 646, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (41691, 646, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (41692, 646, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (41693, 646, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (41694, 646, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (41695, 646, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (41696, 646, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (41697, 646, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (41698, 646, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (41699, 646, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (41700, 646, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (41701, 646, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (41702, 646, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (41703, 646, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (41704, 646, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (41705, 646, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (41706, 646, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (41707, 646, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (41708, 646, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (41709, 646, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (41710, 646, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (41711, 646, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (41712, 646, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (41713, 646, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (41714, 646, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (41715, 646, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (41716, 646, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (41717, 646, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (41718, 646, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (41719, 646, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (41720, 646, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (41721, 646, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (41722, 646, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (41723, 646, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (41724, 646, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (41725, 646, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (41726, 646, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (41727, 646, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (41728, 646, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (41729, 646, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (41730, 646, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (41731, 646, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (41732, 646, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (41733, 646, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (41734, 646, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (41735, 646, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (41736, 646, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (41737, 646, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (41738, 646, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (41739, 646, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (41740, 646, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (41741, 646, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (41742, 646, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (41743, 646, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (41744, 646, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (41745, 646, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (41746, 646, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (41747, 646, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (41748, 646, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (41749, 646, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (41750, 646, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (41751, 646, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (41752, 646, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (41753, 646, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (41754, 646, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (41755, 646, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (41756, 646, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (41757, 646, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (41758, 646, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (41759, 646, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (41760, 646, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (41761, 646, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (41762, 646, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (41763, 646, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (41764, 646, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (41765, 646, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (41766, 646, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (41767, 646, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (41768, 646, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (41769, 646, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (41770, 646, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (41771, 646, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (41772, 646, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (41773, 646, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (41774, 646, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (41775, 646, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (41776, 646, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (41777, 646, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (41778, 646, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (41779, 646, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (41780, 646, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (41781, 646, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (41782, 646, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (41783, 646, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (41784, 646, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (41785, 646, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (41786, 646, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (41787, 646, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (41788, 646, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (41789, 646, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (41790, 646, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (41791, 646, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (41792, 646, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (41793, 646, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (41794, 646, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (41795, 646, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (41796, 646, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (41797, 646, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (41798, 646, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (41799, 646, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (41800, 646, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (41801, 646, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (41802, 646, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (41803, 646, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (41804, 646, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (41805, 646, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (41806, 646, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (41807, 646, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (41808, 646, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (41809, 646, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (41810, 646, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (41811, 646, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (41812, 646, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (41813, 646, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (41814, 646, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (41815, 646, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (41816, 646, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (41817, 646, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (41818, 646, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (41819, 646, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (41820, 646, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (41821, 646, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (41822, 646, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (41823, 646, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (41824, 646, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (41825, 646, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (41826, 646, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (41827, 646, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (41828, 646, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (41829, 646, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (41830, 646, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (41831, 646, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (41832, 646, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (41833, 646, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (41834, 646, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (41835, 646, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (41836, 646, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (41837, 646, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (41838, 646, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (41839, 646, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (41840, 646, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (41841, 646, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (41842, 646, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (41843, 646, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (41844, 646, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (41845, 646, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (41846, 646, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (41847, 646, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (41848, 646, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (41849, 646, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (41850, 646, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (41851, 646, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (41852, 646, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (41853, 646, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (41854, 646, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (41855, 646, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (41856, 646, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (41857, 646, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (41858, 646, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (41859, 646, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (41860, 646, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (41861, 646, 48, 562);
INSERT INTO 'devicecapvalue' VALUES (41862, 646, 49, 563);
INSERT INTO 'capvalue' VALUES (2276, 'null');
INSERT INTO 'devicecapvalue' VALUES (41863, 646, 53, 2276);
INSERT INTO 'devicecapvalue' VALUES (41864, 647, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (41865, 647, 7, 587);
INSERT INTO 'devicecapvalue' VALUES (41866, 647, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (41867, 647, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (41868, 647, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (41869, 647, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (41870, 647, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (41871, 647, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (41872, 647, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (41873, 647, 15, 95);
INSERT INTO 'capvalue' VALUES (2277, 'nva');
INSERT INTO 'devicecapvalue' VALUES (41874, 647, 15, 2277);
INSERT INTO 'devicecapvalue' VALUES (41875, 647, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41876, 647, 15, 19);
INSERT INTO 'capvalue' VALUES (2278, 'wpng');
INSERT INTO 'devicecapvalue' VALUES (41877, 647, 15, 2278);
INSERT INTO 'devicecapvalue' VALUES (41878, 647, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (41879, 647, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (41880, 647, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41881, 647, 50, 1103);
INSERT INTO 'devicecapvalue' VALUES (41882, 647, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (41883, 647, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (41884, 647, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (41885, 647, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (41886, 647, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (41887, 647, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (41888, 647, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (41889, 647, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (41890, 647, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (41891, 647, 51, 1039);
INSERT INTO 'capvalue' VALUES (2279, 'smaf');
INSERT INTO 'devicecapvalue' VALUES (41892, 647, 51, 2279);
INSERT INTO 'devicecapvalue' VALUES (41893, 647, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (41894, 647, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (41895, 647, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (41896, 647, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (41897, 648, 1, 1);
INSERT INTO 'capvalue' VALUES (2280, 'needsGCinPaint');
INSERT INTO 'devicecapvalue' VALUES (41898, 648, 74, 2280);
INSERT INTO 'capvalue' VALUES (2281, '120x130');
INSERT INTO 'devicecapvalue' VALUES (41899, 648, 7, 2281);
INSERT INTO 'devicecapvalue' VALUES (41900, 648, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (41901, 648, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (41902, 648, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41903, 648, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (41904, 648, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41905, 648, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (41906, 648, 30, 666);
INSERT INTO 'cap' VALUES (245, 'MaxApplicationQuantity', 1);
INSERT INTO 'devicecapvalue' VALUES (41907, 648, 245, 32);
INSERT INTO 'capvalue' VALUES (2282, '81920');
INSERT INTO 'devicecapvalue' VALUES (41908, 648, 50, 2282);
INSERT INTO 'cap' VALUES (246, 'MaxJpegSize', 1);
INSERT INTO 'capvalue' VALUES (2283, '20 kb');
INSERT INTO 'devicecapvalue' VALUES (41909, 648, 246, 2283);
INSERT INTO 'cap' VALUES (247, 'MaxPngSize', 1);
INSERT INTO 'devicecapvalue' VALUES (41910, 648, 247, 2283);
INSERT INTO 'capvalue' VALUES (2284, '50 kb');
INSERT INTO 'devicecapvalue' VALUES (41911, 648, 155, 2284);
INSERT INTO 'cap' VALUES (248, 'MaxSmafSize', 1);
INSERT INTO 'devicecapvalue' VALUES (41912, 648, 248, 593);
INSERT INTO 'devicecapvalue' VALUES (41913, 648, 4, 1289);
INSERT INTO 'devicecapvalue' VALUES (41914, 648, 5, 107);
INSERT INTO 'capvalue' VALUES (2285, 'eva');
INSERT INTO 'devicecapvalue' VALUES (41915, 648, 51, 2285);
INSERT INTO 'devicecapvalue' VALUES (41916, 648, 51, 2279);
INSERT INTO 'devicecapvalue' VALUES (41917, 648, 52, 1457);
INSERT INTO 'devicecapvalue' VALUES (41918, 649, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (41919, 649, 74, 2280);
INSERT INTO 'devicecapvalue' VALUES (41920, 649, 7, 2281);
INSERT INTO 'devicecapvalue' VALUES (41921, 649, 76, 1412);
INSERT INTO 'devicecapvalue' VALUES (41922, 649, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (41923, 649, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41924, 649, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (41925, 649, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41926, 649, 26, 662);
INSERT INTO 'devicecapvalue' VALUES (41927, 649, 30, 666);
INSERT INTO 'devicecapvalue' VALUES (41928, 649, 245, 32);
INSERT INTO 'devicecapvalue' VALUES (41929, 649, 50, 2282);
INSERT INTO 'devicecapvalue' VALUES (41930, 649, 246, 2283);
INSERT INTO 'devicecapvalue' VALUES (41931, 649, 247, 2283);
INSERT INTO 'devicecapvalue' VALUES (41932, 649, 155, 2284);
INSERT INTO 'devicecapvalue' VALUES (41933, 649, 248, 593);
INSERT INTO 'devicecapvalue' VALUES (41934, 649, 4, 1289);
INSERT INTO 'devicecapvalue' VALUES (41935, 649, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (41936, 649, 51, 2285);
INSERT INTO 'devicecapvalue' VALUES (41937, 649, 51, 2279);
INSERT INTO 'devicecapvalue' VALUES (41938, 649, 52, 1457);
INSERT INTO 'devicecapvalue' VALUES (41939, 650, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (41940, 650, 7, 587);
INSERT INTO 'devicecapvalue' VALUES (41941, 650, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (41942, 650, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (41943, 650, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (41944, 650, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (41945, 650, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (41946, 650, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (41947, 650, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (41948, 650, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (41949, 650, 15, 2277);
INSERT INTO 'devicecapvalue' VALUES (41950, 650, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41951, 650, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (41952, 650, 15, 2278);
INSERT INTO 'devicecapvalue' VALUES (41953, 650, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (41954, 650, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (41955, 650, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41956, 650, 50, 1103);
INSERT INTO 'devicecapvalue' VALUES (41957, 650, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (41958, 650, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (41959, 650, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (41960, 650, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (41961, 650, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (41962, 650, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (41963, 650, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (41964, 650, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (41965, 650, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (41966, 650, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (41967, 650, 51, 2279);
INSERT INTO 'devicecapvalue' VALUES (41968, 650, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (41969, 650, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (41970, 650, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (41971, 650, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (41972, 651, 1, 106);
INSERT INTO 'capvalue' VALUES (2286, '2MP');
INSERT INTO 'devicecapvalue' VALUES (41973, 651, 160, 2286);
INSERT INTO 'devicecapvalue' VALUES (41974, 651, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (41975, 651, 7, 587);
INSERT INTO 'devicecapvalue' VALUES (41976, 651, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (41977, 651, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (41978, 651, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (41979, 651, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (41980, 651, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (41981, 651, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (41982, 651, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (41983, 651, 15, 95);
INSERT INTO 'devicecapvalue' VALUES (41984, 651, 15, 2277);
INSERT INTO 'devicecapvalue' VALUES (41985, 651, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (41986, 651, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (41987, 651, 15, 2278);
INSERT INTO 'devicecapvalue' VALUES (41988, 651, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (41989, 651, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (41990, 651, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (41991, 651, 26, 663);
INSERT INTO 'devicecapvalue' VALUES (41992, 651, 30, 12);
INSERT INTO 'devicecapvalue' VALUES (41993, 651, 50, 1103);
INSERT INTO 'devicecapvalue' VALUES (41994, 651, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (41995, 651, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (41996, 651, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (41997, 651, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (41998, 651, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (41999, 651, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (42000, 651, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (42001, 651, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (42002, 651, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (42003, 651, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (42004, 651, 51, 2279);
INSERT INTO 'devicecapvalue' VALUES (42005, 651, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (42006, 651, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (42007, 651, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (42008, 651, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (42009, 652, 1, 1);
INSERT INTO 'capvalue' VALUES (2287, 'layerManagerSetViewWindow');
INSERT INTO 'devicecapvalue' VALUES (42010, 652, 74, 2287);
INSERT INTO 'capvalue' VALUES (2288, 'Combined Delivery');
INSERT INTO 'devicecapvalue' VALUES (42011, 652, 173, 2288);
INSERT INTO 'capvalue' VALUES (2289, 'OMA-Forward Lock');
INSERT INTO 'devicecapvalue' VALUES (42012, 652, 173, 2289);
INSERT INTO 'capvalue' VALUES (2290, 'Separate Delivery');
INSERT INTO 'devicecapvalue' VALUES (42013, 652, 173, 2290);
INSERT INTO 'devicecapvalue' VALUES (42014, 652, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (42015, 652, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (42016, 652, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42017, 652, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (42018, 652, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42019, 652, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42020, 652, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (42021, 652, 50, 2142);
INSERT INTO 'devicecapvalue' VALUES (42022, 652, 4, 1336);
INSERT INTO 'devicecapvalue' VALUES (42023, 652, 5, 1336);
INSERT INTO 'devicecapvalue' VALUES (42024, 652, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (42025, 652, 51, 102);
INSERT INTO 'capvalue' VALUES (2291, 'midi-0');
INSERT INTO 'devicecapvalue' VALUES (42026, 652, 51, 2291);
INSERT INTO 'capvalue' VALUES (2292, 'midi-1');
INSERT INTO 'devicecapvalue' VALUES (42027, 652, 51, 2292);
INSERT INTO 'devicecapvalue' VALUES (42028, 652, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (42029, 652, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (42030, 652, 52, 1350);
INSERT INTO 'capvalue' VALUES (2293, 'SIE-C65/25');
INSERT INTO 'devicecapvalue' VALUES (42031, 652, 53, 2293);
INSERT INTO 'devicecapvalue' VALUES (42032, 653, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (42033, 653, 74, 2287);
INSERT INTO 'devicecapvalue' VALUES (42034, 653, 173, 2288);
INSERT INTO 'devicecapvalue' VALUES (42035, 653, 173, 2289);
INSERT INTO 'devicecapvalue' VALUES (42036, 653, 173, 2290);
INSERT INTO 'capvalue' VALUES (2294, 'CX65');
INSERT INTO 'devicecapvalue' VALUES (42037, 653, 75, 2294);
INSERT INTO 'devicecapvalue' VALUES (42038, 653, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (42039, 653, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (42040, 653, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42041, 653, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (42042, 653, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (42043, 653, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42044, 653, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42045, 653, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (42046, 653, 26, 41);
INSERT INTO 'devicecapvalue' VALUES (42047, 653, 30, 39);
INSERT INTO 'devicecapvalue' VALUES (42048, 653, 50, 2142);
INSERT INTO 'capvalue' VALUES (2295, '132');
INSERT INTO 'devicecapvalue' VALUES (42049, 653, 4, 2295);
INSERT INTO 'devicecapvalue' VALUES (42050, 653, 5, 679);
INSERT INTO 'devicecapvalue' VALUES (42051, 653, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (42052, 653, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (42053, 653, 51, 2291);
INSERT INTO 'devicecapvalue' VALUES (42054, 653, 51, 2292);
INSERT INTO 'devicecapvalue' VALUES (42055, 653, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (42056, 653, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (42057, 653, 52, 1350);
INSERT INTO 'capvalue' VALUES (2296, 'h263');
INSERT INTO 'devicecapvalue' VALUES (42058, 653, 157, 2296);
INSERT INTO 'capvalue' VALUES (2297, 'SIE-CX6V/50 UP.Browser/7.0.2.2.d.3(GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (42059, 653, 53, 2297);
INSERT INTO 'devicecapvalue' VALUES (42060, 654, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (42061, 654, 74, 2287);
INSERT INTO 'devicecapvalue' VALUES (42062, 654, 7, 1240);
INSERT INTO 'devicecapvalue' VALUES (42063, 654, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (42064, 654, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (42065, 654, 10, 595);
INSERT INTO 'devicecapvalue' VALUES (42066, 654, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (42067, 654, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (42068, 654, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (42069, 654, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42070, 654, 17, 22);
INSERT INTO 'capvalue' VALUES (2298, 'siemens-color-game-api');
INSERT INTO 'devicecapvalue' VALUES (42071, 654, 17, 2298);
INSERT INTO 'devicecapvalue' VALUES (42072, 654, 17, 114);
INSERT INTO 'devicecapvalue' VALUES (42073, 654, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42074, 654, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42075, 654, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (42076, 654, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (42077, 654, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (42078, 654, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (42079, 654, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (42080, 654, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (42081, 654, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (42082, 654, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (42083, 654, 51, 2291);
INSERT INTO 'devicecapvalue' VALUES (42084, 654, 51, 2292);
INSERT INTO 'devicecapvalue' VALUES (42085, 654, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (42086, 654, 51, 669);
INSERT INTO 'capvalue' VALUES (2299, 'SIE-EF81/12 UP.Browser/7.0.0.1.181 (GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 Browser/UP.Browser/7.1.1.3.h (GUI) MMP/2.0');
INSERT INTO 'devicecapvalue' VALUES (42087, 654, 53, 2299);
INSERT INTO 'devicecapvalue' VALUES (42088, 655, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (42089, 655, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (42090, 655, 74, 2287);
INSERT INTO 'devicecapvalue' VALUES (42091, 655, 7, 1240);
INSERT INTO 'devicecapvalue' VALUES (42092, 655, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (42093, 655, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (42094, 655, 10, 595);
INSERT INTO 'devicecapvalue' VALUES (42095, 655, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (42096, 655, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (42097, 655, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (42098, 655, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42099, 655, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (42100, 655, 17, 2298);
INSERT INTO 'devicecapvalue' VALUES (42101, 655, 17, 114);
INSERT INTO 'devicecapvalue' VALUES (42102, 655, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42103, 655, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42104, 655, 6, 27);
INSERT INTO 'capvalue' VALUES (2300, '-12');
INSERT INTO 'devicecapvalue' VALUES (42105, 655, 18, 2300);
INSERT INTO 'devicecapvalue' VALUES (42106, 655, 28, 2300);
INSERT INTO 'devicecapvalue' VALUES (42107, 655, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (42108, 655, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (42109, 655, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (42110, 655, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (42111, 655, 51, 2291);
INSERT INTO 'devicecapvalue' VALUES (42112, 655, 51, 2292);
INSERT INTO 'devicecapvalue' VALUES (42113, 655, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (42114, 655, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (42115, 656, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (42116, 656, 173, 2288);
INSERT INTO 'devicecapvalue' VALUES (42117, 656, 173, 2289);
INSERT INTO 'devicecapvalue' VALUES (42118, 656, 173, 2290);
INSERT INTO 'devicecapvalue' VALUES (42119, 656, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (42120, 656, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (42121, 656, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42122, 656, 17, 2298);
INSERT INTO 'devicecapvalue' VALUES (42123, 656, 17, 114);
INSERT INTO 'capvalue' VALUES (2301, 'siemens-game-api');
INSERT INTO 'devicecapvalue' VALUES (42124, 656, 17, 2301);
INSERT INTO 'capvalue' VALUES (2302, 'siemens-m55-led-api');
INSERT INTO 'devicecapvalue' VALUES (42125, 656, 17, 2302);
INSERT INTO 'devicecapvalue' VALUES (42126, 656, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42127, 656, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (42128, 656, 26, 41);
INSERT INTO 'devicecapvalue' VALUES (42129, 656, 30, 39);
INSERT INTO 'devicecapvalue' VALUES (42130, 656, 50, 2142);
INSERT INTO 'devicecapvalue' VALUES (42131, 656, 4, 2295);
INSERT INTO 'devicecapvalue' VALUES (42132, 656, 5, 679);
INSERT INTO 'devicecapvalue' VALUES (42133, 656, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (42134, 656, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (42135, 656, 51, 2291);
INSERT INTO 'devicecapvalue' VALUES (42136, 656, 51, 2292);
INSERT INTO 'devicecapvalue' VALUES (42137, 656, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (42138, 656, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (42139, 656, 52, 1350);
INSERT INTO 'devicecapvalue' VALUES (42140, 656, 157, 2296);
INSERT INTO 'capvalue' VALUES (2303, 'SIE-M6V/50 UP.Browser/7.0.2.2.d.3(GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (42141, 656, 53, 2303);
INSERT INTO 'devicecapvalue' VALUES (42142, 657, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (42143, 657, 160, 1724);
INSERT INTO 'devicecapvalue' VALUES (42144, 657, 7, 108);
INSERT INTO 'cap' VALUES (249, 'Capture', 1);
INSERT INTO 'devicecapvalue' VALUES (42145, 657, 249, 866);
INSERT INTO 'devicecapvalue' VALUES (42146, 657, 249, 1439);
INSERT INTO 'devicecapvalue' VALUES (42147, 657, 249, 920);
INSERT INTO 'devicecapvalue' VALUES (42148, 657, 173, 2288);
INSERT INTO 'devicecapvalue' VALUES (42149, 657, 173, 2289);
INSERT INTO 'devicecapvalue' VALUES (42150, 657, 173, 2290);
INSERT INTO 'devicecapvalue' VALUES (42151, 657, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (42152, 657, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (42153, 657, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (42154, 657, 10, 110);
INSERT INTO 'devicecapvalue' VALUES (42155, 657, 11, 109);
INSERT INTO 'devicecapvalue' VALUES (42156, 657, 12, 13);
INSERT INTO 'devicecapvalue' VALUES (42157, 657, 13, 108);
INSERT INTO 'devicecapvalue' VALUES (42158, 657, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (42159, 657, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42160, 657, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (42161, 657, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (42162, 657, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (42163, 657, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (42164, 657, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (42165, 657, 17, 2298);
INSERT INTO 'devicecapvalue' VALUES (42166, 657, 17, 114);
INSERT INTO 'devicecapvalue' VALUES (42167, 657, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42168, 657, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42169, 657, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (42170, 657, 18, 2300);
INSERT INTO 'devicecapvalue' VALUES (42171, 657, 26, 41);
INSERT INTO 'devicecapvalue' VALUES (42172, 657, 27, 117);
INSERT INTO 'devicecapvalue' VALUES (42173, 657, 28, 2300);
INSERT INTO 'devicecapvalue' VALUES (42174, 657, 30, 39);
INSERT INTO 'devicecapvalue' VALUES (42175, 657, 50, 2142);
INSERT INTO 'devicecapvalue' VALUES (42176, 657, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (42177, 657, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (42178, 657, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (42179, 657, 40, 55);
INSERT INTO 'capvalue' VALUES (2304, 'audio/32kadpcm');
INSERT INTO 'devicecapvalue' VALUES (42180, 657, 41, 2304);
INSERT INTO 'devicecapvalue' VALUES (42181, 657, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (42182, 657, 41, 49);
INSERT INTO 'capvalue' VALUES (2305, 'audio/x-imy audio/midi');
INSERT INTO 'devicecapvalue' VALUES (42183, 657, 41, 2305);
INSERT INTO 'devicecapvalue' VALUES (42184, 657, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (42185, 657, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (42186, 657, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (42187, 657, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (42188, 657, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (42189, 657, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (42190, 657, 42, 2304);
INSERT INTO 'devicecapvalue' VALUES (42191, 657, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (42192, 657, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (42193, 657, 42, 2305);
INSERT INTO 'devicecapvalue' VALUES (42194, 657, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (42195, 657, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (42196, 657, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (42197, 657, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (42198, 657, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (42199, 657, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (42200, 657, 113, 2304);
INSERT INTO 'devicecapvalue' VALUES (42201, 657, 113, 57);
INSERT INTO 'devicecapvalue' VALUES (42202, 657, 113, 49);
INSERT INTO 'devicecapvalue' VALUES (42203, 657, 113, 2305);
INSERT INTO 'devicecapvalue' VALUES (42204, 657, 113, 131);
INSERT INTO 'devicecapvalue' VALUES (42205, 657, 113, 132);
INSERT INTO 'devicecapvalue' VALUES (42206, 657, 113, 55);
INSERT INTO 'devicecapvalue' VALUES (42207, 657, 113, 51);
INSERT INTO 'devicecapvalue' VALUES (42208, 657, 113, 53);
INSERT INTO 'devicecapvalue' VALUES (42209, 657, 113, 888);
INSERT INTO 'devicecapvalue' VALUES (42210, 657, 4, 2295);
INSERT INTO 'devicecapvalue' VALUES (42211, 657, 5, 679);
INSERT INTO 'devicecapvalue' VALUES (42212, 657, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (42213, 657, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (42214, 657, 51, 2291);
INSERT INTO 'devicecapvalue' VALUES (42215, 657, 51, 2292);
INSERT INTO 'devicecapvalue' VALUES (42216, 657, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (42217, 657, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (42218, 657, 52, 1350);
INSERT INTO 'devicecapvalue' VALUES (42219, 657, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (42220, 657, 157, 1026);
INSERT INTO 'capvalue' VALUES (2306, 'SIE-S65');
INSERT INTO 'devicecapvalue' VALUES (42221, 657, 53, 2306);
INSERT INTO 'devicecapvalue' VALUES (42222, 658, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (42223, 658, 160, 1724);
INSERT INTO 'devicecapvalue' VALUES (42224, 658, 7, 108);
INSERT INTO 'devicecapvalue' VALUES (42225, 658, 173, 2288);
INSERT INTO 'devicecapvalue' VALUES (42226, 658, 173, 2289);
INSERT INTO 'devicecapvalue' VALUES (42227, 658, 173, 2290);
INSERT INTO 'devicecapvalue' VALUES (42228, 658, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (42229, 658, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (42230, 658, 13, 108);
INSERT INTO 'devicecapvalue' VALUES (42231, 658, 76, 93);
INSERT INTO 'devicecapvalue' VALUES (42232, 658, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42233, 658, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (42234, 658, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (42235, 658, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (42236, 658, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (42237, 658, 17, 2298);
INSERT INTO 'devicecapvalue' VALUES (42238, 658, 17, 114);
INSERT INTO 'devicecapvalue' VALUES (42239, 658, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42240, 658, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42241, 658, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (42242, 658, 26, 41);
INSERT INTO 'devicecapvalue' VALUES (42243, 658, 30, 39);
INSERT INTO 'devicecapvalue' VALUES (42244, 658, 50, 2142);
INSERT INTO 'devicecapvalue' VALUES (42245, 658, 4, 2295);
INSERT INTO 'devicecapvalue' VALUES (42246, 658, 5, 679);
INSERT INTO 'devicecapvalue' VALUES (42247, 658, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (42248, 658, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (42249, 658, 51, 2291);
INSERT INTO 'devicecapvalue' VALUES (42250, 658, 51, 2292);
INSERT INTO 'devicecapvalue' VALUES (42251, 658, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (42252, 658, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (42253, 658, 52, 1350);
INSERT INTO 'devicecapvalue' VALUES (42254, 658, 157, 1026);
INSERT INTO 'capvalue' VALUES (2307, 'SIE-SK6R/50 UP.Browser/7.0.2.2.d.3(GUI) MMP/2.0 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (42255, 658, 53, 2307);
INSERT INTO 'devicecapvalue' VALUES (42256, 659, 1, 13);
INSERT INTO 'devicecapvalue' VALUES (42257, 659, 74, 2287);
INSERT INTO 'devicecapvalue' VALUES (42258, 659, 7, 108);
INSERT INTO 'devicecapvalue' VALUES (42259, 659, 173, 2288);
INSERT INTO 'devicecapvalue' VALUES (42260, 659, 173, 2289);
INSERT INTO 'devicecapvalue' VALUES (42261, 659, 173, 2290);
INSERT INTO 'capvalue' VALUES (2308, 'SL75');
INSERT INTO 'devicecapvalue' VALUES (42262, 659, 75, 2308);
INSERT INTO 'devicecapvalue' VALUES (42263, 659, 13, 108);
INSERT INTO 'capvalue' VALUES (2309, '373760');
INSERT INTO 'devicecapvalue' VALUES (42264, 659, 76, 2309);
INSERT INTO 'devicecapvalue' VALUES (42265, 659, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42266, 659, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (42267, 659, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (42268, 659, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (42269, 659, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (42270, 659, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (42271, 659, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (42272, 659, 17, 114);
INSERT INTO 'devicecapvalue' VALUES (42273, 659, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (42274, 659, 6, 27);
INSERT INTO 'capvalue' VALUES (2310, '71680');
INSERT INTO 'devicecapvalue' VALUES (42275, 659, 50, 2310);
INSERT INTO 'cap' VALUES (250, 'MaxObjectSize', 1);
INSERT INTO 'capvalue' VALUES (2311, '16kb');
INSERT INTO 'devicecapvalue' VALUES (42276, 659, 250, 2311);
INSERT INTO 'devicecapvalue' VALUES (42277, 659, 4, 2295);
INSERT INTO 'devicecapvalue' VALUES (42278, 659, 5, 679);
INSERT INTO 'devicecapvalue' VALUES (42279, 659, 51, 55);
INSERT INTO 'capvalue' VALUES (2312, '1677721');
INSERT INTO 'devicecapvalue' VALUES (42280, 659, 52, 2312);
INSERT INTO 'capvalue' VALUES (2313, 'SIE-SL75 ObigoInternetBrowser/2.0');
INSERT INTO 'devicecapvalue' VALUES (42281, 659, 53, 2313);
INSERT INTO 'devicecapvalue' VALUES (42282, 660, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (42283, 660, 74, 2287);
INSERT INTO 'devicecapvalue' VALUES (42284, 660, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (42285, 660, 173, 2288);
INSERT INTO 'devicecapvalue' VALUES (42286, 660, 173, 2289);
INSERT INTO 'devicecapvalue' VALUES (42287, 660, 173, 2290);
INSERT INTO 'devicecapvalue' VALUES (42288, 660, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (42289, 660, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (42290, 660, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (42291, 660, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42292, 660, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (42293, 660, 26, 41);
INSERT INTO 'devicecapvalue' VALUES (42294, 660, 30, 39);
INSERT INTO 'devicecapvalue' VALUES (42295, 660, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (42296, 660, 4, 1289);
INSERT INTO 'devicecapvalue' VALUES (42297, 660, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (42298, 660, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (42299, 660, 51, 2291);
INSERT INTO 'devicecapvalue' VALUES (42300, 660, 51, 2292);
INSERT INTO 'devicecapvalue' VALUES (42301, 660, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (42302, 660, 51, 2279);
INSERT INTO 'devicecapvalue' VALUES (42303, 660, 52, 93);
INSERT INTO 'devicecapvalue' VALUES (42304, 660, 157, 2296);
INSERT INTO 'devicecapvalue' VALUES (42305, 660, 157, 1026);
INSERT INTO 'capvalue' VALUES (2314, 'SIE-ST60/1.0 UP.Browser/6.1.0.7.4 (GUI) MMP/1.0');
INSERT INTO 'devicecapvalue' VALUES (42306, 660, 53, 2314);
INSERT INTO 'devicecapvalue' VALUES (42307, 661, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (42308, 661, 74, 2287);
INSERT INTO 'devicecapvalue' VALUES (42309, 661, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (42310, 661, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (42311, 661, 2, 567);
INSERT INTO 'devicecapvalue' VALUES (42312, 661, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (42313, 661, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (42314, 661, 17, 2298);
INSERT INTO 'devicecapvalue' VALUES (42315, 661, 17, 114);
INSERT INTO 'devicecapvalue' VALUES (42316, 661, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42317, 661, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42318, 661, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (42319, 661, 18, 2300);
INSERT INTO 'devicecapvalue' VALUES (42320, 661, 26, 41);
INSERT INTO 'devicecapvalue' VALUES (42321, 661, 27, 117);
INSERT INTO 'devicecapvalue' VALUES (42322, 661, 28, 2300);
INSERT INTO 'devicecapvalue' VALUES (42323, 661, 30, 39);
INSERT INTO 'devicecapvalue' VALUES (42324, 661, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (42325, 661, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (42326, 661, 51, 2291);
INSERT INTO 'devicecapvalue' VALUES (42327, 661, 51, 2292);
INSERT INTO 'devicecapvalue' VALUES (42328, 661, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (42329, 661, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (42330, 662, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (42331, 662, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42332, 662, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (42333, 662, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (42334, 662, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (42335, 662, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (42336, 662, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (42337, 662, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (42338, 662, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42339, 662, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42340, 662, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (42341, 662, 4, 2210);
INSERT INTO 'devicecapvalue' VALUES (42342, 662, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (42343, 663, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (42344, 663, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (42345, 663, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (42346, 663, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (42347, 663, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (42348, 663, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (42349, 663, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (42350, 663, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (42351, 663, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (42352, 663, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (42353, 663, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (42354, 663, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (42355, 663, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (42356, 663, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42357, 663, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (42358, 663, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (42359, 663, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (42360, 663, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (42361, 663, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (42362, 663, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (42363, 663, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (42364, 663, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (42365, 663, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (42366, 663, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (42367, 663, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (42368, 663, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42369, 663, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42370, 663, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42371, 663, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (42372, 663, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (42373, 663, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (42374, 663, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (42375, 663, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (42376, 663, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (42377, 663, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (42378, 663, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (42379, 663, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (42380, 663, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (42381, 663, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (42382, 663, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (42383, 663, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (42384, 663, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (42385, 663, 31, 41);
INSERT INTO 'capvalue' VALUES (2315, 'encoding=amr encoding=amr-nb encoding=pcm');
INSERT INTO 'devicecapvalue' VALUES (42386, 663, 38, 2315);
INSERT INTO 'devicecapvalue' VALUES (42387, 663, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (42388, 663, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (42389, 663, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (42390, 663, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (42391, 663, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (42392, 663, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (42393, 663, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (42394, 663, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (42395, 663, 40, 64);
INSERT INTO 'capvalue' VALUES (2316, 'audio/tone');
INSERT INTO 'devicecapvalue' VALUES (42396, 663, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (42397, 663, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (42398, 663, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (42399, 663, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (42400, 663, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (42401, 663, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (42402, 663, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (42403, 663, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (42404, 663, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (42405, 663, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (42406, 663, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (42407, 663, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (42408, 663, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (42409, 663, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (42410, 663, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (42411, 663, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (42412, 663, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (42413, 663, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (42414, 663, 41, 1441);
INSERT INTO 'capvalue' VALUES (2317, 'audio/nokia_ringing_tones');
INSERT INTO 'devicecapvalue' VALUES (42415, 663, 41, 2317);
INSERT INTO 'capvalue' VALUES (2318, 'audio/pmr');
INSERT INTO 'devicecapvalue' VALUES (42416, 663, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (42417, 663, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (42418, 663, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (42419, 663, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (42420, 663, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (42421, 663, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (42422, 663, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (42423, 663, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (42424, 663, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (42425, 663, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (42426, 663, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (42427, 663, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (42428, 663, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (42429, 663, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (42430, 663, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (42431, 663, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (42432, 663, 41, 67);
INSERT INTO 'capvalue' VALUES (2319, 'video/mp4v-es');
INSERT INTO 'devicecapvalue' VALUES (42433, 663, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (42434, 663, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (42435, 663, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (42436, 663, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (42437, 663, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (42438, 663, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (42439, 663, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (42440, 663, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (42441, 663, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (42442, 663, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (42443, 663, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (42444, 663, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (42445, 663, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (42446, 663, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (42447, 663, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (42448, 663, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (42449, 663, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (42450, 663, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (42451, 663, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (42452, 663, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (42453, 663, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (42454, 663, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (42455, 663, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (42456, 663, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (42457, 663, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (42458, 663, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (42459, 663, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (42460, 663, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (42461, 663, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (42462, 663, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (42463, 663, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (42464, 663, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (42465, 663, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (42466, 663, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (42467, 663, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (42468, 663, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (42469, 663, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (42470, 663, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (42471, 663, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (42472, 663, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (42473, 663, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (42474, 663, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (42475, 663, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (42476, 663, 44, 15);
INSERT INTO 'capvalue' VALUES (2320, 'encoding=mpeg4&width=320&height=240');
INSERT INTO 'devicecapvalue' VALUES (42477, 663, 45, 2320);
INSERT INTO 'devicecapvalue' VALUES (42478, 663, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (42479, 663, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (42480, 663, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (42481, 663, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (42482, 663, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (42483, 663, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (42484, 663, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (42485, 663, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (42486, 663, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (42487, 663, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (42488, 663, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (42489, 663, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (42490, 663, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (42491, 663, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (42492, 663, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (42493, 663, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (42494, 663, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (42495, 663, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (42496, 663, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (42497, 663, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (42498, 663, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (42499, 663, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (42500, 663, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (42501, 663, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (42502, 663, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (42503, 663, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (42504, 663, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (42505, 663, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (42506, 663, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (42507, 663, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (42508, 663, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (42509, 663, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (42510, 663, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (42511, 663, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (42512, 663, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (42513, 663, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (42514, 663, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (42515, 663, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (42516, 663, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (42517, 663, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (42518, 663, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (42519, 663, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (42520, 663, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (42521, 663, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (42522, 663, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (42523, 663, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (42524, 663, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (42525, 663, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (42526, 663, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (42527, 663, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (42528, 663, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (42529, 663, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (42530, 663, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (42531, 663, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (42532, 663, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (42533, 663, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (42534, 663, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (42535, 663, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (42536, 663, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (42537, 663, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (42538, 663, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (42539, 663, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (42540, 663, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (42541, 663, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (42542, 663, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (42543, 663, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (42544, 663, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (42545, 663, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (42546, 663, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (42547, 663, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (42548, 663, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (42549, 663, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (42550, 663, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (42551, 663, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (42552, 663, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (42553, 663, 47, 618);
INSERT INTO 'capvalue' VALUES (2321, 'rtsp');
INSERT INTO 'devicecapvalue' VALUES (42554, 663, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (42555, 663, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (42556, 663, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (42557, 663, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (42558, 663, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (42559, 663, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (42560, 663, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (42561, 663, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (42562, 663, 48, 90);
INSERT INTO 'capvalue' VALUES (2322, 'GMT+00:00');
INSERT INTO 'devicecapvalue' VALUES (42563, 663, 48, 2322);
INSERT INTO 'devicecapvalue' VALUES (42564, 663, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (42565, 663, 49, 659);
INSERT INTO 'capvalue' VALUES (2323, 'SonyEricssonC510/R1DA Browser/NetFront/3.4 Profile/MIDP-2.1 Configuration/CLDC-1.1 JavaPlatform/JP-8.4.1');
INSERT INTO 'devicecapvalue' VALUES (42566, 663, 53, 2323);
INSERT INTO 'devicecapvalue' VALUES (42567, 664, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (42568, 664, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42569, 664, 17, 1479);
INSERT INTO 'devicecapvalue' VALUES (42570, 664, 17, 1480);
INSERT INTO 'devicecapvalue' VALUES (42571, 664, 17, 1481);
INSERT INTO 'devicecapvalue' VALUES (42572, 664, 17, 1482);
INSERT INTO 'devicecapvalue' VALUES (42573, 664, 17, 1555);
INSERT INTO 'devicecapvalue' VALUES (42574, 664, 17, 1917);
INSERT INTO 'devicecapvalue' VALUES (42575, 664, 17, 1483);
INSERT INTO 'devicecapvalue' VALUES (42576, 664, 17, 1484);
INSERT INTO 'devicecapvalue' VALUES (42577, 664, 17, 1485);
INSERT INTO 'devicecapvalue' VALUES (42578, 664, 17, 1486);
INSERT INTO 'capvalue' VALUES (2324, 'jsr229');
INSERT INTO 'devicecapvalue' VALUES (42579, 664, 17, 2324);
INSERT INTO 'devicecapvalue' VALUES (42580, 664, 17, 1487);
INSERT INTO 'capvalue' VALUES (2325, 'jsr238');
INSERT INTO 'devicecapvalue' VALUES (42581, 664, 17, 2325);
INSERT INTO 'capvalue' VALUES (2326, 'jsr239');
INSERT INTO 'devicecapvalue' VALUES (42582, 664, 17, 2326);
INSERT INTO 'capvalue' VALUES (2327, 'jsr248');
INSERT INTO 'devicecapvalue' VALUES (42583, 664, 17, 2327);
INSERT INTO 'devicecapvalue' VALUES (42584, 664, 17, 1488);
INSERT INTO 'devicecapvalue' VALUES (42585, 664, 17, 1489);
INSERT INTO 'capvalue' VALUES (2328, 'mascot');
INSERT INTO 'devicecapvalue' VALUES (42586, 664, 17, 2328);
INSERT INTO 'capvalue' VALUES (2329, 'vscl20');
INSERT INTO 'devicecapvalue' VALUES (42587, 664, 17, 2329);
INSERT INTO 'devicecapvalue' VALUES (42588, 664, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42589, 664, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (42590, 664, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (42591, 664, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (42592, 664, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (42593, 664, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (42594, 664, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (42595, 664, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (42596, 665, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (42597, 665, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (42598, 665, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (42599, 665, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (42600, 665, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (42601, 665, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (42602, 665, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (42603, 665, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (42604, 665, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (42605, 665, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (42606, 665, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (42607, 665, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (42608, 665, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (42609, 665, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42610, 665, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (42611, 665, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (42612, 665, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (42613, 665, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (42614, 665, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (42615, 665, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (42616, 665, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (42617, 665, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (42618, 665, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (42619, 665, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (42620, 665, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (42621, 665, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42622, 665, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (42623, 665, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42624, 665, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (42625, 665, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (42626, 665, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (42627, 665, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (42628, 665, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (42629, 665, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (42630, 665, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (42631, 665, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (42632, 665, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (42633, 665, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (42634, 665, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (42635, 665, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (42636, 665, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (42637, 665, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (42638, 665, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (42639, 665, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (42640, 665, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (42641, 665, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (42642, 665, 35, 45);
INSERT INTO 'capvalue' VALUES (2330, 'SonyEricssonC901/R1FA028');
INSERT INTO 'devicecapvalue' VALUES (42643, 665, 36, 2330);
INSERT INTO 'devicecapvalue' VALUES (42644, 665, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (42645, 665, 38, 2315);
INSERT INTO 'devicecapvalue' VALUES (42646, 665, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (42647, 665, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (42648, 665, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (42649, 665, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (42650, 665, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (42651, 665, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (42652, 665, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (42653, 665, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (42654, 665, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (42655, 665, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (42656, 665, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (42657, 665, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (42658, 665, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (42659, 665, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (42660, 665, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (42661, 665, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (42662, 665, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (42663, 665, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (42664, 665, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (42665, 665, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (42666, 665, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (42667, 665, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (42668, 665, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (42669, 665, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (42670, 665, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (42671, 665, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (42672, 665, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (42673, 665, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (42674, 665, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (42675, 665, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (42676, 665, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (42677, 665, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (42678, 665, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (42679, 665, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (42680, 665, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (42681, 665, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (42682, 665, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (42683, 665, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (42684, 665, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (42685, 665, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (42686, 665, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (42687, 665, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (42688, 665, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (42689, 665, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (42690, 665, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (42691, 665, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (42692, 665, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (42693, 665, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (42694, 665, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (42695, 665, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (42696, 665, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (42697, 665, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (42698, 665, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (42699, 665, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (42700, 665, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (42701, 665, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (42702, 665, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (42703, 665, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (42704, 665, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (42705, 665, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (42706, 665, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (42707, 665, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (42708, 665, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (42709, 665, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (42710, 665, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (42711, 665, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (42712, 665, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (42713, 665, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (42714, 665, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (42715, 665, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (42716, 665, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (42717, 665, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (42718, 665, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (42719, 665, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (42720, 665, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (42721, 665, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (42722, 665, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (42723, 665, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (42724, 665, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (42725, 665, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (42726, 665, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (42727, 665, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (42728, 665, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (42729, 665, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (42730, 665, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (42731, 665, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (42732, 665, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (42733, 665, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (42734, 665, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (42735, 665, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (42736, 665, 45, 2320);
INSERT INTO 'devicecapvalue' VALUES (42737, 665, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (42738, 665, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (42739, 665, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (42740, 665, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (42741, 665, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (42742, 665, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (42743, 665, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (42744, 665, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (42745, 665, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (42746, 665, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (42747, 665, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (42748, 665, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (42749, 665, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (42750, 665, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (42751, 665, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (42752, 665, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (42753, 665, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (42754, 665, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (42755, 665, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (42756, 665, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (42757, 665, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (42758, 665, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (42759, 665, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (42760, 665, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (42761, 665, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (42762, 665, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (42763, 665, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (42764, 665, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (42765, 665, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (42766, 665, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (42767, 665, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (42768, 665, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (42769, 665, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (42770, 665, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (42771, 665, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (42772, 665, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (42773, 665, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (42774, 665, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (42775, 665, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (42776, 665, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (42777, 665, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (42778, 665, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (42779, 665, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (42780, 665, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (42781, 665, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (42782, 665, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (42783, 665, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (42784, 665, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (42785, 665, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (42786, 665, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (42787, 665, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (42788, 665, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (42789, 665, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (42790, 665, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (42791, 665, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (42792, 665, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (42793, 665, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (42794, 665, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (42795, 665, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (42796, 665, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (42797, 665, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (42798, 665, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (42799, 665, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (42800, 665, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (42801, 665, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (42802, 665, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (42803, 665, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (42804, 665, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (42805, 665, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (42806, 665, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (42807, 665, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (42808, 665, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (42809, 665, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (42810, 665, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (42811, 665, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (42812, 665, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (42813, 665, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (42814, 665, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (42815, 665, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (42816, 665, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (42817, 665, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (42818, 665, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (42819, 665, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (42820, 665, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (42821, 665, 48, 144);
INSERT INTO 'devicecapvalue' VALUES (42822, 665, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (42823, 665, 49, 659);
INSERT INTO 'capvalue' VALUES (2331, 'SonyEricssonC901/R1FA Browser/NetFront/3.4 Profile/MIDP-2.1');
INSERT INTO 'devicecapvalue' VALUES (42824, 665, 53, 2331);
INSERT INTO 'devicecapvalue' VALUES (42825, 666, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (42826, 666, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (42827, 666, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (42828, 666, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (42829, 666, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (42830, 666, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (42831, 666, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (42832, 666, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (42833, 666, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (42834, 666, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (42835, 666, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (42836, 666, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (42837, 666, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (42838, 666, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (42839, 666, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (42840, 666, 17, 1479);
INSERT INTO 'devicecapvalue' VALUES (42841, 666, 17, 1480);
INSERT INTO 'devicecapvalue' VALUES (42842, 666, 17, 1481);
INSERT INTO 'devicecapvalue' VALUES (42843, 666, 17, 1482);
INSERT INTO 'devicecapvalue' VALUES (42844, 666, 17, 1555);
INSERT INTO 'devicecapvalue' VALUES (42845, 666, 17, 1917);
INSERT INTO 'devicecapvalue' VALUES (42846, 666, 17, 1483);
INSERT INTO 'devicecapvalue' VALUES (42847, 666, 17, 1484);
INSERT INTO 'devicecapvalue' VALUES (42848, 666, 17, 1485);
INSERT INTO 'devicecapvalue' VALUES (42849, 666, 17, 1486);
INSERT INTO 'devicecapvalue' VALUES (42850, 666, 17, 2324);
INSERT INTO 'devicecapvalue' VALUES (42851, 666, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (42852, 666, 17, 2325);
INSERT INTO 'devicecapvalue' VALUES (42853, 666, 17, 2326);
INSERT INTO 'devicecapvalue' VALUES (42854, 666, 17, 2327);
INSERT INTO 'capvalue' VALUES (2332, 'jsr256');
INSERT INTO 'devicecapvalue' VALUES (42855, 666, 17, 2332);
INSERT INTO 'devicecapvalue' VALUES (42856, 666, 17, 1488);
INSERT INTO 'devicecapvalue' VALUES (42857, 666, 17, 1489);
INSERT INTO 'devicecapvalue' VALUES (42858, 666, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (42859, 666, 17, 2329);
INSERT INTO 'devicecapvalue' VALUES (42860, 666, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (42861, 666, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (42862, 666, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (42863, 666, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (42864, 666, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (42865, 666, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (42866, 666, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (42867, 666, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (42868, 666, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (42869, 666, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (42870, 666, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (42871, 666, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (42872, 666, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (42873, 666, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (42874, 666, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (42875, 666, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (42876, 666, 38, 2131);
INSERT INTO 'capvalue' VALUES (2333, 'audio/amr-nb ');
INSERT INTO 'devicecapvalue' VALUES (42877, 666, 38, 2333);
INSERT INTO 'capvalue' VALUES (2334, 'audio/pcm');
INSERT INTO 'devicecapvalue' VALUES (42878, 666, 38, 2334);
INSERT INTO 'devicecapvalue' VALUES (42879, 666, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (42880, 666, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (42881, 666, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (42882, 666, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (42883, 666, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (42884, 666, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (42885, 666, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (42886, 666, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (42887, 666, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (42888, 666, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (42889, 666, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (42890, 666, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (42891, 666, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (42892, 666, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (42893, 666, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (42894, 666, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (42895, 666, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (42896, 666, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (42897, 666, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (42898, 666, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (42899, 666, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (42900, 666, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (42901, 666, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (42902, 666, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (42903, 666, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (42904, 666, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (42905, 666, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (42906, 666, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (42907, 666, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (42908, 666, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (42909, 666, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (42910, 666, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (42911, 666, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (42912, 666, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (42913, 666, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (42914, 666, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (42915, 666, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (42916, 666, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (42917, 666, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (42918, 666, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (42919, 666, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (42920, 666, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (42921, 666, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (42922, 666, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (42923, 666, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (42924, 666, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (42925, 666, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (42926, 666, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (42927, 666, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (42928, 666, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (42929, 666, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (42930, 666, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (42931, 666, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (42932, 666, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (42933, 666, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (42934, 666, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (42935, 666, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (42936, 666, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (42937, 666, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (42938, 666, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (42939, 666, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (42940, 666, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (42941, 666, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (42942, 666, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (42943, 666, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (42944, 666, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (42945, 666, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (42946, 666, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (42947, 666, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (42948, 666, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (42949, 666, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (42950, 666, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (42951, 666, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (42952, 666, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (42953, 666, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (42954, 666, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (42955, 666, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (42956, 666, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (42957, 666, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (42958, 666, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (42959, 666, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (42960, 666, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (42961, 666, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (42962, 666, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (42963, 666, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (42964, 666, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (42965, 666, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (42966, 666, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (42967, 666, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (42968, 666, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (42969, 666, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (42970, 666, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (42971, 666, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (42972, 666, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (42973, 666, 45, 888);
INSERT INTO 'devicecapvalue' VALUES (42974, 666, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (42975, 666, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (42976, 666, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (42977, 666, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (42978, 666, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (42979, 666, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (42980, 666, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (42981, 666, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (42982, 666, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (42983, 666, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (42984, 666, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (42985, 666, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (42986, 666, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (42987, 666, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (42988, 666, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (42989, 666, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (42990, 666, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (42991, 666, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (42992, 666, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (42993, 666, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (42994, 666, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (42995, 666, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (42996, 666, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (42997, 666, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (42998, 666, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (42999, 666, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (43000, 666, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (43001, 666, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (43002, 666, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (43003, 666, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (43004, 666, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (43005, 666, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (43006, 666, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (43007, 666, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (43008, 666, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (43009, 666, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (43010, 666, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (43011, 666, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (43012, 666, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (43013, 666, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (43014, 666, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (43015, 666, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (43016, 666, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (43017, 666, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (43018, 666, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (43019, 666, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (43020, 666, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (43021, 666, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (43022, 666, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (43023, 666, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (43024, 666, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (43025, 666, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (43026, 666, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (43027, 666, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (43028, 666, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (43029, 666, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (43030, 666, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (43031, 666, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (43032, 666, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (43033, 666, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (43034, 666, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (43035, 666, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (43036, 666, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (43037, 666, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (43038, 666, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (43039, 666, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (43040, 666, 115, 2315);
INSERT INTO 'capvalue' VALUES (2335, '22050');
INSERT INTO 'devicecapvalue' VALUES (43041, 666, 197, 2335);
INSERT INTO 'devicecapvalue' VALUES (43042, 666, 141, 1096);
INSERT INTO 'devicecapvalue' VALUES (43043, 666, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (43044, 666, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (43045, 666, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (43046, 666, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (43047, 666, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (43048, 666, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (43049, 666, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (43050, 666, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (43051, 666, 125, 707);
INSERT INTO 'devicecapvalue' VALUES (43052, 666, 126, 612);
INSERT INTO 'capvalue' VALUES (2336, 'devcam0:outwards');
INSERT INTO 'devicecapvalue' VALUES (43053, 666, 142, 2336);
INSERT INTO 'capvalue' VALUES (2337, 'devcam0:640x480 devcam0:1280x960 devcam0:1632x1224 devcam0:2048x1536 devcam0:2592x1944');
INSERT INTO 'devicecapvalue' VALUES (43054, 666, 143, 2337);
INSERT INTO 'devicecapvalue' VALUES (43055, 666, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (43056, 666, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (43057, 666, 102, 1926);
INSERT INTO 'capvalue' VALUES (2338, 'file:///c:/camera/');
INSERT INTO 'devicecapvalue' VALUES (43058, 666, 103, 2338);
INSERT INTO 'capvalue' VALUES (2339, 'Camera album');
INSERT INTO 'devicecapvalue' VALUES (43059, 666, 104, 2339);
INSERT INTO 'capvalue' VALUES (2340, 'file:///c:/system/9AF5345D20F947d8997111B01574A37F/j40e359b29cdd3c52c0407a8bbeed4813d2a1aa31/');
INSERT INTO 'devicecapvalue' VALUES (43060, 666, 105, 2340);
INSERT INTO 'capvalue' VALUES (2341, 'file:///c:/music/');
INSERT INTO 'devicecapvalue' VALUES (43061, 666, 106, 2341);
INSERT INTO 'capvalue' VALUES (2342, 'Ringtones');
INSERT INTO 'devicecapvalue' VALUES (43062, 666, 107, 2342);
INSERT INTO 'capvalue' VALUES (2343, 'file:///c:/videos/');
INSERT INTO 'devicecapvalue' VALUES (43063, 666, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (43064, 666, 109, 946);
INSERT INTO 'devicecapvalue' VALUES (43065, 666, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (43066, 666, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (43067, 666, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (43068, 666, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (43069, 666, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (43070, 666, 145, 45);
INSERT INTO 'devicecapvalue' VALUES (43071, 666, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (43072, 666, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (43073, 666, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (43074, 666, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (43075, 666, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (43076, 666, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (43077, 666, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (43078, 666, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (43079, 666, 131, 45);
INSERT INTO 'cap' VALUES (251, 'property.microedition.payment.version', 1);
INSERT INTO 'devicecapvalue' VALUES (43080, 666, 251, 242);
INSERT INTO 'devicecapvalue' VALUES (43081, 666, 67, 45);
INSERT INTO 'capvalue' VALUES (2344, 'SonyEricssonC902/R3CA033');
INSERT INTO 'devicecapvalue' VALUES (43082, 666, 68, 2344);
INSERT INTO 'devicecapvalue' VALUES (43083, 666, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (43084, 666, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (43085, 666, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (43086, 666, 205, 45);
INSERT INTO 'devicecapvalue' VALUES (43087, 666, 147, 242);
INSERT INTO 'devicecapvalue' VALUES (43088, 666, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (43089, 666, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (43090, 666, 132, 2315);
INSERT INTO 'devicecapvalue' VALUES (43091, 666, 133, 2320);
INSERT INTO 'devicecapvalue' VALUES (43092, 666, 134, 242);
INSERT INTO 'capvalue' VALUES (2345, 'audio/x-pn-realaudio video/x-pn-realvideo audio/mp4a-latm video/mp4v-es video/h263-2000');
INSERT INTO 'devicecapvalue' VALUES (43093, 666, 116, 2345);
INSERT INTO 'devicecapvalue' VALUES (43094, 666, 86, 15);
INSERT INTO 'capvalue' VALUES (2346, 'camera tuner audio3d music imageencoding imagepostprocessing');
INSERT INTO 'devicecapvalue' VALUES (43095, 666, 149, 2346);
INSERT INTO 'devicecapvalue' VALUES (43096, 666, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (43097, 666, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (43098, 666, 135, 15);
INSERT INTO 'cap' VALUES (252, 'property.tuner.modulations', 1);
INSERT INTO 'capvalue' VALUES (2347, 'fm');
INSERT INTO 'devicecapvalue' VALUES (43099, 666, 252, 2347);
INSERT INTO 'devicecapvalue' VALUES (43100, 666, 136, 2320);
INSERT INTO 'capvalue' VALUES (2348, 'jpeg&width=1280&height=960');
INSERT INTO 'devicecapvalue' VALUES (43101, 666, 137, 2348);
INSERT INTO 'capvalue' VALUES (2349, 'jpeg&width=1632&height=1224');
INSERT INTO 'devicecapvalue' VALUES (43102, 666, 137, 2349);
INSERT INTO 'capvalue' VALUES (2350, 'jpeg&width=2048&height=1536');
INSERT INTO 'devicecapvalue' VALUES (43103, 666, 137, 2350);
INSERT INTO 'capvalue' VALUES (2351, 'jpeg&width=2592&height=1944');
INSERT INTO 'devicecapvalue' VALUES (43104, 666, 137, 2351);
INSERT INTO 'capvalue' VALUES (2352, 'jpeg&width=640&height=480');
INSERT INTO 'devicecapvalue' VALUES (43105, 666, 137, 2352);
INSERT INTO 'capvalue' VALUES (2353, '+447973100973');
INSERT INTO 'devicecapvalue' VALUES (43106, 666, 72, 2353);
INSERT INTO 'devicecapvalue' VALUES (43107, 666, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (43108, 666, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (43109, 666, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (43110, 666, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (43111, 666, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (43112, 666, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (43113, 666, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (43114, 666, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (43115, 666, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (43116, 666, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (43117, 666, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (43118, 666, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (43119, 666, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (43120, 666, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (43121, 666, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (43122, 666, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (43123, 666, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (43124, 666, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (43125, 666, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (43126, 666, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (43127, 666, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (43128, 666, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (43129, 666, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (43130, 666, 156, 2145);
INSERT INTO 'devicecapvalue' VALUES (43131, 666, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (43132, 666, 156, 1024);
INSERT INTO 'devicecapvalue' VALUES (43133, 666, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (43134, 666, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (43135, 666, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (43136, 666, 48, 2322);
INSERT INTO 'devicecapvalue' VALUES (43137, 666, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (43138, 666, 49, 659);
INSERT INTO 'devicecapvalue' VALUES (43139, 667, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (43140, 667, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (43141, 667, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (43142, 667, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (43143, 667, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (43144, 667, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (43145, 667, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (43146, 667, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (43147, 667, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (43148, 667, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (43149, 667, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (43150, 667, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (43151, 667, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (43152, 668, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (43153, 668, 192, 15);
INSERT INTO 'devicecapvalue' VALUES (43154, 668, 74, 1567);
INSERT INTO 'capvalue' VALUES (2354, 'TransparencyNotWorkingInDrawPolygon');
INSERT INTO 'devicecapvalue' VALUES (43155, 668, 74, 2354);
INSERT INTO 'capvalue' VALUES (2355, 'unknownSystemPropertiesThrowExceptions');
INSERT INTO 'devicecapvalue' VALUES (43156, 668, 74, 2355);
INSERT INTO 'devicecapvalue' VALUES (43157, 668, 193, 1568);
INSERT INTO 'devicecapvalue' VALUES (43158, 668, 193, 1569);
INSERT INTO 'devicecapvalue' VALUES (43159, 668, 193, 1570);
INSERT INTO 'capvalue' VALUES (2356, 'midp21');
INSERT INTO 'devicecapvalue' VALUES (43160, 668, 194, 2356);
INSERT INTO 'devicecapvalue' VALUES (43161, 668, 79, 15);
INSERT INTO 'devicecapvalue' VALUES (43162, 668, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (43163, 668, 195, 1573);
INSERT INTO 'devicecapvalue' VALUES (43164, 668, 8, 10);
INSERT INTO 'cap' VALUES (253, 'command.options', 1);
INSERT INTO 'capvalue' VALUES (2357, 'Menu');
INSERT INTO 'devicecapvalue' VALUES (43165, 668, 253, 2357);
INSERT INTO 'capvalue' VALUES (2358, 'SonyEricssonEmulator');
INSERT INTO 'devicecapvalue' VALUES (43166, 668, 93, 2358);
INSERT INTO 'devicecapvalue' VALUES (43167, 668, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (43168, 668, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (43169, 668, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (43170, 668, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (43171, 668, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (43172, 668, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (43173, 668, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (43174, 668, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (43175, 668, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (43176, 668, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (43177, 668, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (43178, 668, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (43179, 668, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (43180, 668, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (43181, 668, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (43182, 668, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (43183, 668, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (43184, 668, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (43185, 668, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (43186, 668, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (43187, 668, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (43188, 668, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (43189, 668, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (43190, 668, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (43191, 668, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (43192, 668, 178, 745);
INSERT INTO 'devicecapvalue' VALUES (43193, 668, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (43194, 668, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (43195, 668, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (43196, 668, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (43197, 668, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (43198, 668, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (43199, 668, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (43200, 668, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (43201, 668, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (43202, 668, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (43203, 668, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (43204, 668, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (43205, 668, 54, 30);
INSERT INTO 'cap' VALUES (254, 'key.TopLeftSoftKey', 1);
INSERT INTO 'devicecapvalue' VALUES (43206, 668, 254, 2207);
INSERT INTO 'cap' VALUES (255, 'key.TopRightSoftKey', 1);
INSERT INTO 'devicecapvalue' VALUES (43207, 668, 255, 1183);
INSERT INTO 'devicecapvalue' VALUES (43208, 668, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (43209, 668, 98, 668);
INSERT INTO 'devicecapvalue' VALUES (43210, 668, 92, 686);
INSERT INTO 'devicecapvalue' VALUES (43211, 668, 38, 2315);
INSERT INTO 'devicecapvalue' VALUES (43212, 668, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (43213, 668, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (43214, 668, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (43215, 668, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (43216, 668, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (43217, 668, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (43218, 668, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (43219, 668, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (43220, 668, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (43221, 668, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (43222, 668, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (43223, 668, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (43224, 668, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (43225, 668, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (43226, 668, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (43227, 668, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (43228, 668, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (43229, 668, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (43230, 668, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (43231, 668, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (43232, 668, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (43233, 668, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (43234, 668, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (43235, 668, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (43236, 668, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (43237, 668, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (43238, 668, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (43239, 668, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (43240, 668, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (43241, 668, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (43242, 668, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (43243, 668, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (43244, 668, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (43245, 668, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (43246, 668, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (43247, 668, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (43248, 668, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (43249, 668, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (43250, 668, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (43251, 668, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (43252, 668, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (43253, 668, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (43254, 668, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (43255, 668, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (43256, 668, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (43257, 668, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (43258, 668, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (43259, 668, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (43260, 668, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (43261, 668, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (43262, 668, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (43263, 668, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (43264, 668, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (43265, 668, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (43266, 668, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (43267, 668, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (43268, 668, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (43269, 668, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (43270, 668, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (43271, 668, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (43272, 668, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (43273, 668, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (43274, 668, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (43275, 668, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (43276, 668, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (43277, 668, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (43278, 668, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (43279, 668, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (43280, 668, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (43281, 668, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (43282, 668, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (43283, 668, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (43284, 668, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (43285, 668, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (43286, 668, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (43287, 668, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (43288, 668, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (43289, 668, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (43290, 668, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (43291, 668, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (43292, 668, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (43293, 668, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (43294, 668, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (43295, 668, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (43296, 668, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (43297, 668, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (43298, 668, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (43299, 668, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (43300, 668, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (43301, 668, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (43302, 668, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (43303, 668, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (43304, 668, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (43305, 668, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (43306, 668, 45, 2320);
INSERT INTO 'devicecapvalue' VALUES (43307, 668, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (43308, 668, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (43309, 668, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (43310, 668, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (43311, 668, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (43312, 668, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (43313, 668, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (43314, 668, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (43315, 668, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (43316, 668, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (43317, 668, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (43318, 668, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (43319, 668, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (43320, 668, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (43321, 668, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (43322, 668, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (43323, 668, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (43324, 668, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (43325, 668, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (43326, 668, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (43327, 668, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (43328, 668, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (43329, 668, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (43330, 668, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (43331, 668, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (43332, 668, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (43333, 668, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (43334, 668, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (43335, 668, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (43336, 668, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (43337, 668, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (43338, 668, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (43339, 668, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (43340, 668, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (43341, 668, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (43342, 668, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (43343, 668, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (43344, 668, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (43345, 668, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (43346, 668, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (43347, 668, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (43348, 668, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (43349, 668, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (43350, 668, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (43351, 668, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (43352, 668, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (43353, 668, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (43354, 668, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (43355, 668, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (43356, 668, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (43357, 668, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (43358, 668, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (43359, 668, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (43360, 668, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (43361, 668, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (43362, 668, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (43363, 668, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (43364, 668, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (43365, 668, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (43366, 668, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (43367, 668, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (43368, 668, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (43369, 668, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (43370, 668, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (43371, 668, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (43372, 668, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (43373, 668, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (43374, 668, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (43375, 668, 115, 2315);
INSERT INTO 'devicecapvalue' VALUES (43376, 668, 197, 2335);
INSERT INTO 'devicecapvalue' VALUES (43377, 668, 141, 1096);
INSERT INTO 'devicecapvalue' VALUES (43378, 668, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (43379, 668, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (43380, 668, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (43381, 668, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (43382, 668, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (43383, 668, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (43384, 668, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (43385, 668, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (43386, 668, 125, 707);
INSERT INTO 'devicecapvalue' VALUES (43387, 668, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (43388, 668, 142, 2336);
INSERT INTO 'capvalue' VALUES (2359, 'devcam0:640x480 devcam0:1280x960 devcam0:1632x1224 devcam0:2048x1536 devcam0:2592x1944 devcam0:3264x2448');
INSERT INTO 'devicecapvalue' VALUES (43389, 668, 143, 2359);
INSERT INTO 'devicecapvalue' VALUES (43390, 668, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (43391, 668, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (43392, 668, 102, 1926);
INSERT INTO 'devicecapvalue' VALUES (43393, 668, 103, 2338);
INSERT INTO 'devicecapvalue' VALUES (43394, 668, 104, 2339);
INSERT INTO 'devicecapvalue' VALUES (43395, 668, 105, 2340);
INSERT INTO 'devicecapvalue' VALUES (43396, 668, 106, 2341);
INSERT INTO 'devicecapvalue' VALUES (43397, 668, 107, 2342);
INSERT INTO 'devicecapvalue' VALUES (43398, 668, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (43399, 668, 109, 946);
INSERT INTO 'cap' VALUES (256, 'property.imei', 1);
INSERT INTO 'capvalue' VALUES (2360, 'com.sonyericsson.imei');
INSERT INTO 'devicecapvalue' VALUES (43400, 668, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (43401, 668, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (43402, 668, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (43403, 668, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (43404, 668, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (43405, 668, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (43406, 668, 145, 45);
INSERT INTO 'devicecapvalue' VALUES (43407, 668, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (43408, 668, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (43409, 668, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (43410, 668, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (43411, 668, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (43412, 668, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (43413, 668, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (43414, 668, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (43415, 668, 131, 45);
INSERT INTO 'devicecapvalue' VALUES (43416, 668, 251, 242);
INSERT INTO 'devicecapvalue' VALUES (43417, 668, 67, 45);
INSERT INTO 'capvalue' VALUES (2361, 'SonyEricssonC905/R1BA034');
INSERT INTO 'devicecapvalue' VALUES (43418, 668, 68, 2361);
INSERT INTO 'devicecapvalue' VALUES (43419, 668, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (43420, 668, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (43421, 668, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (43422, 668, 205, 45);
INSERT INTO 'devicecapvalue' VALUES (43423, 668, 147, 242);
INSERT INTO 'devicecapvalue' VALUES (43424, 668, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (43425, 668, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (43426, 668, 132, 2315);
INSERT INTO 'devicecapvalue' VALUES (43427, 668, 133, 2320);
INSERT INTO 'devicecapvalue' VALUES (43428, 668, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (43429, 668, 116, 2345);
INSERT INTO 'devicecapvalue' VALUES (43430, 668, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (43431, 668, 149, 2346);
INSERT INTO 'devicecapvalue' VALUES (43432, 668, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (43433, 668, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (43434, 668, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (43435, 668, 252, 2347);
INSERT INTO 'devicecapvalue' VALUES (43436, 668, 136, 2320);
INSERT INTO 'devicecapvalue' VALUES (43437, 668, 137, 2348);
INSERT INTO 'devicecapvalue' VALUES (43438, 668, 137, 2349);
INSERT INTO 'devicecapvalue' VALUES (43439, 668, 137, 2350);
INSERT INTO 'devicecapvalue' VALUES (43440, 668, 137, 2351);
INSERT INTO 'capvalue' VALUES (2362, 'jpeg&width=3264&height=2448');
INSERT INTO 'devicecapvalue' VALUES (43441, 668, 137, 2362);
INSERT INTO 'devicecapvalue' VALUES (43442, 668, 137, 2352);
INSERT INTO 'capvalue' VALUES (2363, 'http://mms.t-mobile.de/servlets/mms');
INSERT INTO 'devicecapvalue' VALUES (43443, 668, 138, 2363);
INSERT INTO 'devicecapvalue' VALUES (43444, 668, 72, 1682);
INSERT INTO 'devicecapvalue' VALUES (43445, 668, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (43446, 668, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (43447, 668, 140, 45);
INSERT INTO 'capvalue' VALUES (2364, 'video/mp4v-esvideo/mpeg video/h264 video/3gpp video/mpeg4 video/mp4 audio/mp4a-latm audio/3gp audio/mpeg4 audio/3gpp audio/m4a audio/mp4 audio/x-m4a video/x-pn-realvideo audio/x-pn-realaudio video/x-ms-wmv audio/x-ms-wma audio/aac rtsp ');
INSERT INTO 'devicecapvalue' VALUES (43448, 668, 206, 2364);
INSERT INTO 'devicecapvalue' VALUES (43449, 668, 207, 883);
INSERT INTO 'devicecapvalue' VALUES (43450, 668, 207, 57);
INSERT INTO 'devicecapvalue' VALUES (43451, 668, 207, 58);
INSERT INTO 'devicecapvalue' VALUES (43452, 668, 207, 60);
INSERT INTO 'devicecapvalue' VALUES (43453, 668, 207, 62);
INSERT INTO 'devicecapvalue' VALUES (43454, 668, 207, 2075);
INSERT INTO 'devicecapvalue' VALUES (43455, 668, 207, 886);
INSERT INTO 'devicecapvalue' VALUES (43456, 668, 207, 129);
INSERT INTO 'devicecapvalue' VALUES (43457, 668, 207, 618);
INSERT INTO 'devicecapvalue' VALUES (43458, 668, 207, 1280);
INSERT INTO 'devicecapvalue' VALUES (43459, 668, 207, 2321);
INSERT INTO 'devicecapvalue' VALUES (43460, 668, 207, 53);
INSERT INTO 'devicecapvalue' VALUES (43461, 668, 207, 2080);
INSERT INTO 'devicecapvalue' VALUES (43462, 668, 207, 67);
INSERT INTO 'devicecapvalue' VALUES (43463, 668, 207, 2319);
INSERT INTO 'devicecapvalue' VALUES (43464, 668, 207, 1444);
INSERT INTO 'devicecapvalue' VALUES (43465, 668, 207, 888);
INSERT INTO 'devicecapvalue' VALUES (43466, 668, 207, 622);
INSERT INTO 'devicecapvalue' VALUES (43467, 668, 207, 1283);
INSERT INTO 'devicecapvalue' VALUES (43468, 668, 208, 15);
INSERT INTO 'devicecapvalue' VALUES (43469, 668, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (43470, 668, 48, 2322);
INSERT INTO 'devicecapvalue' VALUES (43471, 668, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (43472, 668, 49, 659);
INSERT INTO 'cap' VALUES (257, 'vendor.alias', 1);
INSERT INTO 'capvalue' VALUES (2365, 'Sony Ericsson Mobile Communications');
INSERT INTO 'devicecapvalue' VALUES (43473, 668, 257, 2365);
INSERT INTO 'capvalue' VALUES (2366, 'SonyEricsson');
INSERT INTO 'devicecapvalue' VALUES (43474, 668, 257, 2366);
INSERT INTO 'capvalue' VALUES (2367, 'SonyEricssonC905/R1BA Browser/NetFront/3.4 Profile/MIDP-2.1 Configuration/CLDC-1.1 JavaPlatform/JP-8.4.0');
INSERT INTO 'devicecapvalue' VALUES (43475, 668, 53, 2367);
INSERT INTO 'devicecapvalue' VALUES (43476, 669, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (43477, 669, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (43478, 669, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (43479, 669, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (43480, 669, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (43481, 669, 173, 1688);
INSERT INTO 'capvalue' VALUES (2368, 'SonyEricsson_D7S0');
INSERT INTO 'devicecapvalue' VALUES (43482, 669, 75, 2368);
INSERT INTO 'devicecapvalue' VALUES (43483, 669, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (43484, 669, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (43485, 669, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (43486, 669, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (43487, 669, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (43488, 669, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (43489, 669, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (43490, 669, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (43491, 669, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (43492, 669, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (43493, 669, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (43494, 669, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (43495, 669, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (43496, 669, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (43497, 669, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (43498, 669, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (43499, 669, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (43500, 669, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (43501, 669, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (43502, 669, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (43503, 669, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (43504, 669, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (43505, 669, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (43506, 669, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (43507, 669, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (43508, 669, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (43509, 669, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (43510, 669, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (43511, 669, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (43512, 669, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (43513, 669, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (43514, 669, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (43515, 669, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (43516, 669, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (43517, 669, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (43518, 669, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (43519, 669, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (43520, 669, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (43521, 669, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (43522, 669, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (43523, 669, 51, 669);
INSERT INTO 'capvalue' VALUES (2369, '35651584');
INSERT INTO 'devicecapvalue' VALUES (43524, 669, 52, 2369);
INSERT INTO 'devicecapvalue' VALUES (43525, 669, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (43526, 669, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (43527, 669, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (43528, 669, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (43529, 670, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (43530, 670, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (43531, 670, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (43532, 670, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (43533, 670, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (43534, 670, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (43535, 670, 173, 1523);
INSERT INTO 'capvalue' VALUES (2370, 'SonyEricsson_F500i');
INSERT INTO 'devicecapvalue' VALUES (43536, 670, 75, 2370);
INSERT INTO 'devicecapvalue' VALUES (43537, 670, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (43538, 670, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (43539, 670, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (43540, 670, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (43541, 670, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (43542, 670, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (43543, 670, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (43544, 670, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (43545, 670, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (43546, 670, 15, 16);
INSERT INTO 'capvalue' VALUES (2371, 'bmp3');
INSERT INTO 'devicecapvalue' VALUES (43547, 670, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (43548, 670, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (43549, 670, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (43550, 670, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (43551, 670, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (43552, 670, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (43553, 670, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (43554, 670, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (43555, 670, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (43556, 670, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (43557, 670, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (43558, 670, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (43559, 670, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (43560, 670, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (43561, 670, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (43562, 670, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (43563, 670, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (43564, 670, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (43565, 670, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (43566, 670, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (43567, 670, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (43568, 670, 256, 2360);
INSERT INTO 'capvalue' VALUES (2372, 'AP');
INSERT INTO 'devicecapvalue' VALUES (43569, 670, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (43570, 670, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (43571, 670, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (43572, 670, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (43573, 670, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (43574, 670, 51, 101);
INSERT INTO 'capvalue' VALUES (2373, 'iMelody-1.2');
INSERT INTO 'devicecapvalue' VALUES (43575, 670, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (43576, 670, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (43577, 670, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (43578, 670, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (43579, 670, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (43580, 670, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (43581, 670, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (43582, 670, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (43583, 670, 191, 1372);
INSERT INTO 'capvalue' VALUES (2374, 'SonyEricssonF500i/R2E SEMC-Browser/4.0 Profile/MIDP-1.0 MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (43584, 670, 53, 2374);
INSERT INTO 'devicecapvalue' VALUES (43585, 671, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (43586, 671, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (43587, 671, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (43588, 671, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (43589, 671, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (43590, 671, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (43591, 671, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (43592, 671, 75, 2370);
INSERT INTO 'devicecapvalue' VALUES (43593, 671, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (43594, 671, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (43595, 671, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (43596, 671, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (43597, 671, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (43598, 671, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (43599, 671, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (43600, 671, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (43601, 671, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (43602, 671, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (43603, 671, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (43604, 671, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (43605, 671, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (43606, 671, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (43607, 671, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (43608, 671, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (43609, 671, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (43610, 671, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (43611, 671, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (43612, 671, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (43613, 671, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (43614, 671, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (43615, 671, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (43616, 671, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (43617, 671, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (43618, 671, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (43619, 671, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (43620, 671, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (43621, 671, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (43622, 671, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (43623, 671, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (43624, 671, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (43625, 671, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (43626, 671, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (43627, 671, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (43628, 671, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (43629, 671, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (43630, 671, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (43631, 671, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (43632, 671, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (43633, 671, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (43634, 671, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (43635, 671, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (43636, 671, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (43637, 671, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (43638, 671, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (43639, 671, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (43640, 671, 53, 2374);
INSERT INTO 'devicecapvalue' VALUES (43641, 672, 56, 707);
INSERT INTO 'capvalue' VALUES (2375, '240x250');
INSERT INTO 'devicecapvalue' VALUES (43642, 672, 7, 2375);
INSERT INTO 'devicecapvalue' VALUES (43643, 672, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (43644, 672, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (43645, 672, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (43646, 672, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (43647, 672, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (43648, 672, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (43649, 672, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (43650, 672, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (43651, 672, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (43652, 672, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (43653, 672, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (43654, 672, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (43655, 672, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (43656, 672, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (43657, 672, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (43658, 672, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (43659, 672, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (43660, 672, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (43661, 672, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (43662, 672, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (43663, 672, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (43664, 672, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (43665, 672, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (43666, 672, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (43667, 672, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (43668, 672, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (43669, 672, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (43670, 672, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (43671, 672, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (43672, 672, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (43673, 672, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (43674, 672, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (43675, 672, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (43676, 672, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (43677, 672, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (43678, 672, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (43679, 672, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (43680, 672, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (43681, 672, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (43682, 672, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (43683, 672, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (43684, 672, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (43685, 672, 38, 2315);
INSERT INTO 'devicecapvalue' VALUES (43686, 672, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (43687, 672, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (43688, 672, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (43689, 672, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (43690, 672, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (43691, 672, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (43692, 672, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (43693, 672, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (43694, 672, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (43695, 672, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (43696, 672, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (43697, 672, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (43698, 672, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (43699, 672, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (43700, 672, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (43701, 672, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (43702, 672, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (43703, 672, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (43704, 672, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (43705, 672, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (43706, 672, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (43707, 672, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (43708, 672, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (43709, 672, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (43710, 672, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (43711, 672, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (43712, 672, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (43713, 672, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (43714, 672, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (43715, 672, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (43716, 672, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (43717, 672, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (43718, 672, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (43719, 672, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (43720, 672, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (43721, 672, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (43722, 672, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (43723, 672, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (43724, 672, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (43725, 672, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (43726, 672, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (43727, 672, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (43728, 672, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (43729, 672, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (43730, 672, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (43731, 672, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (43732, 672, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (43733, 672, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (43734, 672, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (43735, 672, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (43736, 672, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (43737, 672, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (43738, 672, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (43739, 672, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (43740, 672, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (43741, 672, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (43742, 672, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (43743, 672, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (43744, 672, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (43745, 672, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (43746, 672, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (43747, 672, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (43748, 672, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (43749, 672, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (43750, 672, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (43751, 672, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (43752, 672, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (43753, 672, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (43754, 672, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (43755, 672, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (43756, 672, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (43757, 672, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (43758, 672, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (43759, 672, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (43760, 672, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (43761, 672, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (43762, 672, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (43763, 672, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (43764, 672, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (43765, 672, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (43766, 672, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (43767, 672, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (43768, 672, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (43769, 672, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (43770, 672, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (43771, 672, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (43772, 672, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (43773, 672, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (43774, 672, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (43775, 672, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (43776, 672, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (43777, 672, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (43778, 672, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (43779, 672, 44, 15);
INSERT INTO 'capvalue' VALUES (2376, 'encoding=h263&width=176&height=144 encoding=h264&width=320&height=240');
INSERT INTO 'devicecapvalue' VALUES (43780, 672, 45, 2376);
INSERT INTO 'devicecapvalue' VALUES (43781, 672, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (43782, 672, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (43783, 672, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (43784, 672, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (43785, 672, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (43786, 672, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (43787, 672, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (43788, 672, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (43789, 672, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (43790, 672, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (43791, 672, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (43792, 672, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (43793, 672, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (43794, 672, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (43795, 672, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (43796, 672, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (43797, 672, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (43798, 672, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (43799, 672, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (43800, 672, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (43801, 672, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (43802, 672, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (43803, 672, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (43804, 672, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (43805, 672, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (43806, 672, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (43807, 672, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (43808, 672, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (43809, 672, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (43810, 672, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (43811, 672, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (43812, 672, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (43813, 672, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (43814, 672, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (43815, 672, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (43816, 672, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (43817, 672, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (43818, 672, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (43819, 672, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (43820, 672, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (43821, 672, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (43822, 672, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (43823, 672, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (43824, 672, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (43825, 672, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (43826, 672, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (43827, 672, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (43828, 672, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (43829, 672, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (43830, 672, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (43831, 672, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (43832, 672, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (43833, 672, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (43834, 672, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (43835, 672, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (43836, 672, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (43837, 672, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (43838, 672, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (43839, 672, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (43840, 672, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (43841, 672, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (43842, 672, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (43843, 672, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (43844, 672, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (43845, 672, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (43846, 672, 115, 2315);
INSERT INTO 'devicecapvalue' VALUES (43847, 672, 197, 2335);
INSERT INTO 'devicecapvalue' VALUES (43848, 672, 141, 1096);
INSERT INTO 'devicecapvalue' VALUES (43849, 672, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (43850, 672, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (43851, 672, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (43852, 672, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (43853, 672, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (43854, 672, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (43855, 672, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (43856, 672, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (43857, 672, 125, 707);
INSERT INTO 'devicecapvalue' VALUES (43858, 672, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (43859, 672, 142, 2336);
INSERT INTO 'capvalue' VALUES (2377, 'devcam0:640x480 devcam0:1280x960 devcam0:1600x1200');
INSERT INTO 'devicecapvalue' VALUES (43860, 672, 143, 2377);
INSERT INTO 'devicecapvalue' VALUES (43861, 672, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (43862, 672, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (43863, 672, 102, 1603);
INSERT INTO 'devicecapvalue' VALUES (43864, 672, 103, 2338);
INSERT INTO 'capvalue' VALUES (2378, 'Album');
INSERT INTO 'devicecapvalue' VALUES (43865, 672, 104, 2378);
INSERT INTO 'devicecapvalue' VALUES (43866, 672, 105, 2340);
INSERT INTO 'devicecapvalue' VALUES (43867, 672, 106, 2341);
INSERT INTO 'capvalue' VALUES (2379, 'Ruft?ne');
INSERT INTO 'devicecapvalue' VALUES (43868, 672, 107, 2379);
INSERT INTO 'devicecapvalue' VALUES (43869, 672, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (43870, 672, 109, 946);
INSERT INTO 'devicecapvalue' VALUES (43871, 672, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (43872, 672, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (43873, 672, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (43874, 672, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (43875, 672, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (43876, 672, 145, 45);
INSERT INTO 'devicecapvalue' VALUES (43877, 672, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (43878, 672, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (43879, 672, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (43880, 672, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (43881, 672, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (43882, 672, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (43883, 672, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (43884, 672, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (43885, 672, 131, 45);
INSERT INTO 'devicecapvalue' VALUES (43886, 672, 251, 242);
INSERT INTO 'devicecapvalue' VALUES (43887, 672, 67, 45);
INSERT INTO 'capvalue' VALUES (2380, 'SonyEricssonG502/R1FA031');
INSERT INTO 'devicecapvalue' VALUES (43888, 672, 68, 2380);
INSERT INTO 'devicecapvalue' VALUES (43889, 672, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (43890, 672, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (43891, 672, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (43892, 672, 205, 45);
INSERT INTO 'devicecapvalue' VALUES (43893, 672, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (43894, 672, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (43895, 672, 132, 2315);
INSERT INTO 'devicecapvalue' VALUES (43896, 672, 133, 2376);
INSERT INTO 'devicecapvalue' VALUES (43897, 672, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (43898, 672, 116, 2345);
INSERT INTO 'devicecapvalue' VALUES (43899, 672, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (43900, 672, 149, 2346);
INSERT INTO 'devicecapvalue' VALUES (43901, 672, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (43902, 672, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (43903, 672, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (43904, 672, 252, 2347);
INSERT INTO 'devicecapvalue' VALUES (43905, 672, 136, 2376);
INSERT INTO 'devicecapvalue' VALUES (43906, 672, 137, 2348);
INSERT INTO 'capvalue' VALUES (2381, 'jpeg&width=1600&height=1200');
INSERT INTO 'devicecapvalue' VALUES (43907, 672, 137, 2381);
INSERT INTO 'devicecapvalue' VALUES (43908, 672, 137, 2352);
INSERT INTO 'capvalue' VALUES (2382, 'http://10.81.0.7:8002/');
INSERT INTO 'devicecapvalue' VALUES (43909, 672, 138, 2382);
INSERT INTO 'devicecapvalue' VALUES (43910, 672, 72, 2203);
INSERT INTO 'devicecapvalue' VALUES (43911, 672, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (43912, 672, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (43913, 672, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (43914, 672, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (43915, 672, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (43916, 672, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (43917, 672, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (43918, 672, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (43919, 672, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (43920, 672, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (43921, 672, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (43922, 672, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (43923, 672, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (43924, 672, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (43925, 672, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (43926, 672, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (43927, 672, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (43928, 672, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (43929, 672, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (43930, 672, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (43931, 672, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (43932, 672, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (43933, 672, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (43934, 672, 48, 144);
INSERT INTO 'devicecapvalue' VALUES (43935, 672, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (43936, 672, 49, 659);
INSERT INTO 'capvalue' VALUES (2383, 'SonyEricssonG502/R1FA Browser/NetFront/3.4 Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (43937, 672, 53, 2383);
INSERT INTO 'devicecapvalue' VALUES (43938, 673, 56, 707);
INSERT INTO 'capvalue' VALUES (2384, '240x220');
INSERT INTO 'devicecapvalue' VALUES (43939, 673, 7, 2384);
INSERT INTO 'devicecapvalue' VALUES (43940, 673, 8, 1005);
INSERT INTO 'devicecapvalue' VALUES (43941, 673, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (43942, 673, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (43943, 673, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (43944, 673, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (43945, 673, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (43946, 673, 13, 1950);
INSERT INTO 'devicecapvalue' VALUES (43947, 673, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (43948, 673, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (43949, 673, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (43950, 673, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (43951, 673, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (43952, 673, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (43953, 673, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (43954, 673, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (43955, 673, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (43956, 673, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (43957, 673, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (43958, 673, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (43959, 673, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (43960, 673, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (43961, 673, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (43962, 673, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (43963, 673, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (43964, 673, 6, 2063);
INSERT INTO 'devicecapvalue' VALUES (43965, 673, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (43966, 673, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (43967, 673, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (43968, 673, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (43969, 673, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (43970, 673, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (43971, 673, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (43972, 673, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (43973, 673, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (43974, 673, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (43975, 673, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (43976, 673, 57, 1245);
INSERT INTO 'devicecapvalue' VALUES (43977, 673, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (43978, 673, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (43979, 673, 54, 1245);
INSERT INTO 'devicecapvalue' VALUES (43980, 673, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (43981, 673, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (43982, 673, 40, 55);
INSERT INTO 'capvalue' VALUES (2385, 'application/mpeg4');
INSERT INTO 'devicecapvalue' VALUES (43983, 673, 41, 2385);
INSERT INTO 'devicecapvalue' VALUES (43984, 673, 41, 56);
INSERT INTO 'devicecapvalue' VALUES (43985, 673, 41, 964);
INSERT INTO 'devicecapvalue' VALUES (43986, 673, 41, 2215);
INSERT INTO 'devicecapvalue' VALUES (43987, 673, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (43988, 673, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (43989, 673, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (43990, 673, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (43991, 673, 41, 616);
INSERT INTO 'capvalue' VALUES (2386, 'audio/fmradio');
INSERT INTO 'devicecapvalue' VALUES (43992, 673, 41, 2386);
INSERT INTO 'devicecapvalue' VALUES (43993, 673, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (43994, 673, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (43995, 673, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (43996, 673, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (43997, 673, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (43998, 673, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (43999, 673, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (44000, 673, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (44001, 673, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (44002, 673, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (44003, 673, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (44004, 673, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (44005, 673, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (44006, 673, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (44007, 673, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (44008, 673, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (44009, 673, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (44010, 673, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (44011, 673, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (44012, 673, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (44013, 673, 41, 128);
INSERT INTO 'devicecapvalue' VALUES (44014, 673, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (44015, 673, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (44016, 673, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (44017, 673, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (44018, 673, 41, 1256);
INSERT INTO 'capvalue' VALUES (2387, 'audio/x-ms-asf');
INSERT INTO 'devicecapvalue' VALUES (44019, 673, 41, 2387);
INSERT INTO 'devicecapvalue' VALUES (44020, 673, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (44021, 673, 41, 2216);
INSERT INTO 'capvalue' VALUES (2388, 'audio/x-pv-aac');
INSERT INTO 'devicecapvalue' VALUES (44022, 673, 41, 2388);
INSERT INTO 'devicecapvalue' VALUES (44023, 673, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (44024, 673, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (44025, 673, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (44026, 673, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (44027, 673, 41, 2213);
INSERT INTO 'devicecapvalue' VALUES (44028, 673, 41, 2214);
INSERT INTO 'devicecapvalue' VALUES (44029, 673, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (44030, 673, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (44031, 673, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (44032, 673, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (44033, 673, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (44034, 673, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (44035, 673, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (44036, 673, 42, 2385);
INSERT INTO 'devicecapvalue' VALUES (44037, 673, 42, 56);
INSERT INTO 'devicecapvalue' VALUES (44038, 673, 42, 964);
INSERT INTO 'devicecapvalue' VALUES (44039, 673, 42, 2215);
INSERT INTO 'devicecapvalue' VALUES (44040, 673, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (44041, 673, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (44042, 673, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (44043, 673, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (44044, 673, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (44045, 673, 42, 2386);
INSERT INTO 'devicecapvalue' VALUES (44046, 673, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (44047, 673, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (44048, 673, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (44049, 673, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (44050, 673, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (44051, 673, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (44052, 673, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (44053, 673, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (44054, 673, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (44055, 673, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (44056, 673, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (44057, 673, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (44058, 673, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (44059, 673, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (44060, 673, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (44061, 673, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (44062, 673, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (44063, 673, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (44064, 673, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (44065, 673, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (44066, 673, 42, 128);
INSERT INTO 'devicecapvalue' VALUES (44067, 673, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (44068, 673, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (44069, 673, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (44070, 673, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (44071, 673, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (44072, 673, 42, 2387);
INSERT INTO 'devicecapvalue' VALUES (44073, 673, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (44074, 673, 42, 2216);
INSERT INTO 'devicecapvalue' VALUES (44075, 673, 42, 2388);
INSERT INTO 'devicecapvalue' VALUES (44076, 673, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (44077, 673, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (44078, 673, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (44079, 673, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (44080, 673, 42, 2213);
INSERT INTO 'devicecapvalue' VALUES (44081, 673, 42, 2214);
INSERT INTO 'devicecapvalue' VALUES (44082, 673, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (44083, 673, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (44084, 673, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (44085, 673, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (44086, 673, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (44087, 673, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (44088, 673, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (44089, 673, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (44090, 673, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (44091, 673, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (44092, 673, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (44093, 673, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (44094, 673, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (44095, 673, 46, 1592);
INSERT INTO 'devicecapvalue' VALUES (44096, 673, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (44097, 673, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (44098, 673, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (44099, 673, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (44100, 673, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (44101, 673, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (44102, 673, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (44103, 673, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (44104, 673, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (44105, 673, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (44106, 673, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (44107, 673, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (44108, 673, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (44109, 673, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (44110, 673, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (44111, 673, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (44112, 673, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (44113, 673, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (44114, 673, 117, 45);
INSERT INTO 'devicecapvalue' VALUES (44115, 673, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (44116, 673, 119, 244);
INSERT INTO 'devicecapvalue' VALUES (44117, 673, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (44118, 673, 121, 244);
INSERT INTO 'devicecapvalue' VALUES (44119, 673, 122, 244);
INSERT INTO 'devicecapvalue' VALUES (44120, 673, 59, 240);
INSERT INTO 'devicecapvalue' VALUES (44121, 673, 114, 1260);
INSERT INTO 'devicecapvalue' VALUES (44122, 673, 114, 1471);
INSERT INTO 'devicecapvalue' VALUES (44123, 673, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (44124, 673, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (44125, 673, 204, 1677);
INSERT INTO 'devicecapvalue' VALUES (44126, 673, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (44127, 673, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (44128, 673, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (44129, 673, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (44130, 673, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (44131, 673, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (44132, 673, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (44133, 673, 251, 242);
INSERT INTO 'devicecapvalue' VALUES (44134, 673, 67, 45);
INSERT INTO 'capvalue' VALUES (2389, 'SonyEricssonG700/R6H815');
INSERT INTO 'devicecapvalue' VALUES (44135, 673, 68, 2389);
INSERT INTO 'capvalue' VALUES (2390, 'MIDP-1.0 MIDP-2.0');
INSERT INTO 'devicecapvalue' VALUES (44136, 673, 69, 2390);
INSERT INTO 'devicecapvalue' VALUES (44137, 673, 71, 244);
INSERT INTO 'capvalue' VALUES (2391, 'http://mms.mobitel.com.kh/mmsc');
INSERT INTO 'devicecapvalue' VALUES (44138, 673, 138, 2391);
INSERT INTO 'capvalue' VALUES (2392, '+85512000024');
INSERT INTO 'devicecapvalue' VALUES (44139, 673, 72, 2392);
INSERT INTO 'devicecapvalue' VALUES (44140, 673, 47, 2385);
INSERT INTO 'devicecapvalue' VALUES (44141, 673, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (44142, 673, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (44143, 673, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (44144, 673, 47, 63);
INSERT INTO 'devicecapvalue' VALUES (44145, 673, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (44146, 673, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (44147, 673, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (44148, 673, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (44149, 673, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (44150, 673, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (44151, 673, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (44152, 673, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (44153, 673, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (44154, 673, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (44155, 673, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (44156, 673, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (44157, 673, 48, 824);
INSERT INTO 'devicecapvalue' VALUES (44158, 673, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (44159, 673, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (44160, 673, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (44161, 673, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (44162, 673, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (44163, 673, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (44164, 673, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (44165, 673, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (44166, 673, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (44167, 673, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (44168, 673, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (44169, 673, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (44170, 673, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (44171, 673, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (44172, 673, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (44173, 673, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (44174, 673, 48, 561);
INSERT INTO 'capvalue' VALUES (2393, 'UK/BST');
INSERT INTO 'devicecapvalue' VALUES (44175, 673, 48, 2393);
INSERT INTO 'capvalue' VALUES (2394, 'UK/GMT');
INSERT INTO 'devicecapvalue' VALUES (44176, 673, 48, 2394);
INSERT INTO 'devicecapvalue' VALUES (44177, 673, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (44178, 673, 48, 562);
INSERT INTO 'capvalue' VALUES (2395, '409600');
INSERT INTO 'devicecapvalue' VALUES (44179, 673, 49, 2395);
INSERT INTO 'devicecapvalue' VALUES (44180, 674, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (44181, 674, 8, 10);
INSERT INTO 'cap' VALUES (258, 'com.sonyericsson.java.platform', 1);
INSERT INTO 'capvalue' VALUES (2396, 'JP-8.4.3');
INSERT INTO 'devicecapvalue' VALUES (44182, 674, 258, 2396);
INSERT INTO 'devicecapvalue' VALUES (44183, 674, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (44184, 674, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (44185, 674, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (44186, 674, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (44187, 674, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (44188, 674, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (44189, 674, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (44190, 674, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (44191, 674, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (44192, 674, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (44193, 674, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (44194, 674, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (44195, 674, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (44196, 674, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (44197, 674, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (44198, 674, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (44199, 674, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (44200, 674, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (44201, 674, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (44202, 674, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (44203, 674, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (44204, 674, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (44205, 674, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (44206, 674, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (44207, 674, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (44208, 674, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (44209, 674, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (44210, 674, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (44211, 674, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (44212, 674, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (44213, 674, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (44214, 674, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (44215, 674, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (44216, 674, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (44217, 674, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (44218, 674, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (44219, 674, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (44220, 674, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (44221, 674, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (44222, 674, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (44223, 674, 35, 45);
INSERT INTO 'capvalue' VALUES (2397, 'SonyEricssonG705/R1FA035');
INSERT INTO 'devicecapvalue' VALUES (44224, 674, 36, 2397);
INSERT INTO 'devicecapvalue' VALUES (44225, 674, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (44226, 674, 38, 2315);
INSERT INTO 'devicecapvalue' VALUES (44227, 674, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (44228, 674, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (44229, 674, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (44230, 674, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (44231, 674, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (44232, 674, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (44233, 674, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (44234, 674, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (44235, 674, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (44236, 674, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (44237, 674, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (44238, 674, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (44239, 674, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (44240, 674, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (44241, 674, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (44242, 674, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (44243, 674, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (44244, 674, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (44245, 674, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (44246, 674, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (44247, 674, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (44248, 674, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (44249, 674, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (44250, 674, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (44251, 674, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (44252, 674, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (44253, 674, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (44254, 674, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (44255, 674, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (44256, 674, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (44257, 674, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (44258, 674, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (44259, 674, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (44260, 674, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (44261, 674, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (44262, 674, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (44263, 674, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (44264, 674, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (44265, 674, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (44266, 674, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (44267, 674, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (44268, 674, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (44269, 674, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (44270, 674, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (44271, 674, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (44272, 674, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (44273, 674, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (44274, 674, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (44275, 674, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (44276, 674, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (44277, 674, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (44278, 674, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (44279, 674, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (44280, 674, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (44281, 674, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (44282, 674, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (44283, 674, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (44284, 674, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (44285, 674, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (44286, 674, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (44287, 674, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (44288, 674, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (44289, 674, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (44290, 674, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (44291, 674, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (44292, 674, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (44293, 674, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (44294, 674, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (44295, 674, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (44296, 674, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (44297, 674, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (44298, 674, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (44299, 674, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (44300, 674, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (44301, 674, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (44302, 674, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (44303, 674, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (44304, 674, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (44305, 674, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (44306, 674, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (44307, 674, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (44308, 674, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (44309, 674, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (44310, 674, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (44311, 674, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (44312, 674, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (44313, 674, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (44314, 674, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (44315, 674, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (44316, 674, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (44317, 674, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (44318, 674, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (44319, 674, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (44320, 674, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (44321, 674, 45, 2320);
INSERT INTO 'devicecapvalue' VALUES (44322, 674, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (44323, 674, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (44324, 674, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (44325, 674, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (44326, 674, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (44327, 674, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (44328, 674, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (44329, 674, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (44330, 674, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (44331, 674, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (44332, 674, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (44333, 674, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (44334, 674, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (44335, 674, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (44336, 674, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (44337, 674, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (44338, 674, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (44339, 674, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (44340, 674, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (44341, 674, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (44342, 674, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (44343, 674, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (44344, 674, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (44345, 674, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (44346, 674, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (44347, 674, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (44348, 674, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (44349, 674, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (44350, 674, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (44351, 674, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (44352, 674, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (44353, 674, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (44354, 674, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (44355, 674, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (44356, 674, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (44357, 674, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (44358, 674, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (44359, 674, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (44360, 674, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (44361, 674, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (44362, 674, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (44363, 674, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (44364, 674, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (44365, 674, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (44366, 674, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (44367, 674, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (44368, 674, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (44369, 674, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (44370, 674, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (44371, 674, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (44372, 674, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (44373, 674, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (44374, 674, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (44375, 674, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (44376, 674, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (44377, 674, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (44378, 674, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (44379, 674, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (44380, 674, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (44381, 674, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (44382, 674, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (44383, 674, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (44384, 674, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (44385, 674, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (44386, 674, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (44387, 674, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (44388, 674, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (44389, 674, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (44390, 674, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (44391, 674, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (44392, 674, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (44393, 674, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (44394, 674, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (44395, 674, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (44396, 674, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (44397, 674, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (44398, 674, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (44399, 674, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (44400, 674, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (44401, 674, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (44402, 674, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (44403, 674, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (44404, 674, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (44405, 674, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (44406, 674, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (44407, 674, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (44408, 674, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (44409, 674, 48, 144);
INSERT INTO 'devicecapvalue' VALUES (44410, 674, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (44411, 674, 49, 659);
INSERT INTO 'capvalue' VALUES (2398, 'SonyEricssonG705/R1FA Browser/NetFront/3.4 Profile/MIDP-2.1');
INSERT INTO 'devicecapvalue' VALUES (44412, 674, 53, 2398);
INSERT INTO 'devicecapvalue' VALUES (44413, 675, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (44414, 675, 160, 856);
INSERT INTO 'capvalue' VALUES (2399, '4x');
INSERT INTO 'devicecapvalue' VALUES (44415, 675, 162, 2399);
INSERT INTO 'capvalue' VALUES (2400, '128x110');
INSERT INTO 'devicecapvalue' VALUES (44416, 675, 7, 2400);
INSERT INTO 'devicecapvalue' VALUES (44417, 675, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (44418, 675, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (44419, 675, 173, 1523);
INSERT INTO 'capvalue' VALUES (2401, 'SonyEricsson_J300');
INSERT INTO 'devicecapvalue' VALUES (44420, 675, 75, 2401);
INSERT INTO 'devicecapvalue' VALUES (44421, 675, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (44422, 675, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (44423, 675, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (44424, 675, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (44425, 675, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (44426, 675, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (44427, 675, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (44428, 675, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (44429, 675, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (44430, 675, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (44431, 675, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (44432, 675, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (44433, 675, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (44434, 675, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (44435, 675, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (44436, 675, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (44437, 675, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (44438, 675, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (44439, 675, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (44440, 675, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (44441, 675, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (44442, 675, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (44443, 675, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (44444, 675, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (44445, 675, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (44446, 675, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (44447, 675, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (44448, 675, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (44449, 675, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (44450, 675, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (44451, 675, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (44452, 675, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (44453, 675, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (44454, 675, 156, 1159);
INSERT INTO 'capvalue' VALUES (2402, 'LAM');
INSERT INTO 'devicecapvalue' VALUES (44455, 675, 156, 2402);
INSERT INTO 'capvalue' VALUES (2403, 'NAM');
INSERT INTO 'devicecapvalue' VALUES (44456, 675, 156, 2403);
INSERT INTO 'devicecapvalue' VALUES (44457, 675, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (44458, 675, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (44459, 675, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (44460, 675, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (44461, 675, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (44462, 675, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (44463, 675, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (44464, 675, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (44465, 675, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (44466, 675, 52, 1460);
INSERT INTO 'devicecapvalue' VALUES (44467, 675, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (44468, 675, 157, 1134);
INSERT INTO 'capvalue' VALUES (2404, 'svgt');
INSERT INTO 'devicecapvalue' VALUES (44469, 675, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (44470, 675, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (44471, 676, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (44472, 676, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (44473, 676, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (44474, 676, 7, 2400);
INSERT INTO 'devicecapvalue' VALUES (44475, 676, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (44476, 676, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (44477, 676, 173, 1523);
INSERT INTO 'capvalue' VALUES (2405, 'SonyEricsson_K300');
INSERT INTO 'devicecapvalue' VALUES (44478, 676, 75, 2405);
INSERT INTO 'devicecapvalue' VALUES (44479, 676, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (44480, 676, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (44481, 676, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (44482, 676, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (44483, 676, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (44484, 676, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (44485, 676, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (44486, 676, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (44487, 676, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (44488, 676, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (44489, 676, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (44490, 676, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (44491, 676, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (44492, 676, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (44493, 676, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (44494, 676, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (44495, 676, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (44496, 676, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (44497, 676, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (44498, 676, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (44499, 676, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (44500, 676, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (44501, 676, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (44502, 676, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (44503, 676, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (44504, 676, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (44505, 676, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (44506, 676, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (44507, 676, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (44508, 676, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (44509, 676, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (44510, 676, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (44511, 676, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (44512, 676, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (44513, 676, 156, 2402);
INSERT INTO 'devicecapvalue' VALUES (44514, 676, 156, 2403);
INSERT INTO 'devicecapvalue' VALUES (44515, 676, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (44516, 676, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (44517, 676, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (44518, 676, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (44519, 676, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (44520, 676, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (44521, 676, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (44522, 676, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (44523, 676, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (44524, 676, 52, 1460);
INSERT INTO 'devicecapvalue' VALUES (44525, 676, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (44526, 676, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (44527, 676, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (44528, 676, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (44529, 676, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (44530, 677, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (44531, 677, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (44532, 677, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (44533, 677, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (44534, 677, 7, 2400);
INSERT INTO 'devicecapvalue' VALUES (44535, 677, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (44536, 677, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (44537, 677, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (44538, 677, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (44539, 677, 75, 2405);
INSERT INTO 'devicecapvalue' VALUES (44540, 677, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (44541, 677, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (44542, 677, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (44543, 677, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (44544, 677, 9, 711);
INSERT INTO 'devicecapvalue' VALUES (44545, 677, 10, 109);
INSERT INTO 'devicecapvalue' VALUES (44546, 677, 11, 711);
INSERT INTO 'devicecapvalue' VALUES (44547, 677, 12, 1391);
INSERT INTO 'devicecapvalue' VALUES (44548, 677, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (44549, 677, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (44550, 677, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (44551, 677, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (44552, 677, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (44553, 677, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (44554, 677, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (44555, 677, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (44556, 677, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (44557, 677, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (44558, 677, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (44559, 677, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (44560, 677, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (44561, 677, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (44562, 677, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (44563, 677, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (44564, 677, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (44565, 677, 6, 2063);
INSERT INTO 'devicecapvalue' VALUES (44566, 677, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (44567, 677, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (44568, 677, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (44569, 677, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (44570, 677, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (44571, 677, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (44572, 677, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (44573, 677, 18, 39);
INSERT INTO 'devicecapvalue' VALUES (44574, 677, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (44575, 677, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (44576, 677, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (44577, 677, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (44578, 677, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (44579, 677, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (44580, 677, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (44581, 677, 26, 39);
INSERT INTO 'devicecapvalue' VALUES (44582, 677, 27, 39);
INSERT INTO 'devicecapvalue' VALUES (44583, 677, 57, 39);
INSERT INTO 'devicecapvalue' VALUES (44584, 677, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (44585, 677, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (44586, 677, 54, 39);
INSERT INTO 'devicecapvalue' VALUES (44587, 677, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (44588, 677, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (44589, 677, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (44590, 677, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (44591, 677, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (44592, 677, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (44593, 677, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (44594, 677, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (44595, 677, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (44596, 677, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (44597, 677, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (44598, 677, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (44599, 677, 42, 52);
INSERT INTO 'devicecapvalue' VALUES (44600, 677, 42, 123);
INSERT INTO 'devicecapvalue' VALUES (44601, 677, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (44602, 677, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (44603, 677, 44, 15);
INSERT INTO 'capvalue' VALUES (2406, 'encoding=JPEG&width=176&height=182');
INSERT INTO 'devicecapvalue' VALUES (44604, 677, 45, 2406);
INSERT INTO 'capvalue' VALUES (2407, 'encoding=JPEG&width=176&height=220');
INSERT INTO 'devicecapvalue' VALUES (44605, 677, 45, 2407);
INSERT INTO 'devicecapvalue' VALUES (44606, 677, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (44607, 677, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (44608, 677, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (44609, 677, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (44610, 677, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (44611, 677, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (44612, 677, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (44613, 677, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (44614, 677, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (44615, 677, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (44616, 677, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (44617, 677, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (44618, 677, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (44619, 677, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (44620, 677, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (44621, 677, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (44622, 677, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (44623, 677, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (44624, 677, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (44625, 677, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (44626, 677, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (44627, 677, 62, 832);
INSERT INTO 'devicecapvalue' VALUES (44628, 677, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (44629, 677, 65, 45);
INSERT INTO 'devicecapvalue' VALUES (44630, 677, 66, 242);
INSERT INTO 'capvalue' VALUES (2408, 'SonyEricssonK300i/R2BA010');
INSERT INTO 'devicecapvalue' VALUES (44631, 677, 68, 2408);
INSERT INTO 'devicecapvalue' VALUES (44632, 677, 69, 2390);
INSERT INTO 'devicecapvalue' VALUES (44633, 677, 133, 2406);
INSERT INTO 'devicecapvalue' VALUES (44634, 677, 133, 2407);
INSERT INTO 'devicecapvalue' VALUES (44635, 677, 71, 244);
INSERT INTO 'devicecapvalue' VALUES (44636, 677, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (44637, 677, 136, 2406);
INSERT INTO 'devicecapvalue' VALUES (44638, 677, 136, 2407);
INSERT INTO 'devicecapvalue' VALUES (44639, 677, 137, 18);
INSERT INTO 'capvalue' VALUES (2409, '+38761125522');
INSERT INTO 'devicecapvalue' VALUES (44640, 677, 72, 2409);
INSERT INTO 'capvalue' VALUES (2410, 'WMA 1.1');
INSERT INTO 'devicecapvalue' VALUES (44641, 677, 111, 2410);
INSERT INTO 'devicecapvalue' VALUES (44642, 677, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (44643, 677, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (44644, 677, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (44645, 677, 156, 2402);
INSERT INTO 'devicecapvalue' VALUES (44646, 677, 156, 2403);
INSERT INTO 'devicecapvalue' VALUES (44647, 677, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (44648, 677, 5, 99);
INSERT INTO 'devicecapvalue' VALUES (44649, 677, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (44650, 677, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (44651, 677, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (44652, 677, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (44653, 677, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (44654, 677, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (44655, 677, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (44656, 677, 52, 1460);
INSERT INTO 'devicecapvalue' VALUES (44657, 677, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (44658, 677, 48, 144);
INSERT INTO 'devicecapvalue' VALUES (44659, 677, 48, 92);
INSERT INTO 'capvalue' VALUES (2411, '524284');
INSERT INTO 'devicecapvalue' VALUES (44660, 677, 49, 2411);
INSERT INTO 'devicecapvalue' VALUES (44661, 677, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (44662, 677, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (44663, 677, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (44664, 677, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (44665, 677, 191, 1372);
INSERT INTO 'capvalue' VALUES (2412, 'SonyEricssonK300i/R2BA SEMC-Browser/4.0.3 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (44666, 677, 53, 2412);
INSERT INTO 'devicecapvalue' VALUES (44667, 678, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (44668, 678, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (44669, 678, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (44670, 678, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (44671, 678, 7, 2056);
INSERT INTO 'devicecapvalue' VALUES (44672, 678, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (44673, 678, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (44674, 678, 173, 1523);
INSERT INTO 'capvalue' VALUES (2413, 'SonyEricsson_K310');
INSERT INTO 'devicecapvalue' VALUES (44675, 678, 75, 2413);
INSERT INTO 'devicecapvalue' VALUES (44676, 678, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (44677, 678, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (44678, 678, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (44679, 678, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (44680, 678, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (44681, 678, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (44682, 678, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (44683, 678, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (44684, 678, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (44685, 678, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (44686, 678, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (44687, 678, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (44688, 678, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (44689, 678, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (44690, 678, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (44691, 678, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (44692, 678, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (44693, 678, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (44694, 678, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (44695, 678, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (44696, 678, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (44697, 678, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (44698, 678, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (44699, 678, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (44700, 678, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (44701, 678, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (44702, 678, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (44703, 678, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (44704, 678, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (44705, 678, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (44706, 678, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (44707, 678, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (44708, 678, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (44709, 678, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (44710, 678, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (44711, 678, 156, 2402);
INSERT INTO 'devicecapvalue' VALUES (44712, 678, 156, 2403);
INSERT INTO 'devicecapvalue' VALUES (44713, 678, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (44714, 678, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (44715, 678, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (44716, 678, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (44717, 678, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (44718, 678, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (44719, 678, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (44720, 678, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (44721, 678, 51, 669);
INSERT INTO 'capvalue' VALUES (2414, '15728640');
INSERT INTO 'devicecapvalue' VALUES (44722, 678, 52, 2414);
INSERT INTO 'devicecapvalue' VALUES (44723, 678, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (44724, 678, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (44725, 678, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (44726, 678, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (44727, 678, 191, 1372);
INSERT INTO 'capvalue' VALUES (2415, 'SonyEricssonK310i');
INSERT INTO 'devicecapvalue' VALUES (44728, 678, 53, 2415);
INSERT INTO 'devicecapvalue' VALUES (44729, 679, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (44730, 679, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (44731, 679, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (44732, 679, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (44733, 679, 7, 2056);
INSERT INTO 'devicecapvalue' VALUES (44734, 679, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (44735, 679, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (44736, 679, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (44737, 679, 75, 2413);
INSERT INTO 'devicecapvalue' VALUES (44738, 679, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (44739, 679, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (44740, 679, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (44741, 679, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (44742, 679, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (44743, 679, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (44744, 679, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (44745, 679, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (44746, 679, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (44747, 679, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (44748, 679, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (44749, 679, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (44750, 679, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (44751, 679, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (44752, 679, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (44753, 679, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (44754, 679, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (44755, 679, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (44756, 679, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (44757, 679, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (44758, 679, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (44759, 679, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (44760, 679, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (44761, 679, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (44762, 679, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (44763, 679, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (44764, 679, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (44765, 679, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (44766, 679, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (44767, 679, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (44768, 679, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (44769, 679, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (44770, 679, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (44771, 679, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (44772, 679, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (44773, 679, 156, 2402);
INSERT INTO 'devicecapvalue' VALUES (44774, 679, 156, 2403);
INSERT INTO 'devicecapvalue' VALUES (44775, 679, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (44776, 679, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (44777, 679, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (44778, 679, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (44779, 679, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (44780, 679, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (44781, 679, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (44782, 679, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (44783, 679, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (44784, 679, 52, 2414);
INSERT INTO 'devicecapvalue' VALUES (44785, 679, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (44786, 679, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (44787, 679, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (44788, 679, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (44789, 679, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (44790, 679, 53, 2415);
INSERT INTO 'devicecapvalue' VALUES (44791, 680, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (44792, 680, 74, 1029);
INSERT INTO 'capvalue' VALUES (2416, 'vga');
INSERT INTO 'devicecapvalue' VALUES (44793, 680, 160, 2416);
INSERT INTO 'devicecapvalue' VALUES (44794, 680, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (44795, 680, 7, 1100);
INSERT INTO 'devicecapvalue' VALUES (44796, 680, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (44797, 680, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (44798, 680, 173, 1523);
INSERT INTO 'capvalue' VALUES (2417, 'SonyEricsson_K320');
INSERT INTO 'devicecapvalue' VALUES (44799, 680, 75, 2417);
INSERT INTO 'devicecapvalue' VALUES (44800, 680, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (44801, 680, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (44802, 680, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (44803, 680, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (44804, 680, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (44805, 680, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (44806, 680, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (44807, 680, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (44808, 680, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (44809, 680, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (44810, 680, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (44811, 680, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (44812, 680, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (44813, 680, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (44814, 680, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (44815, 680, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (44816, 680, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (44817, 680, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (44818, 680, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (44819, 680, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (44820, 680, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (44821, 680, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (44822, 680, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (44823, 680, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (44824, 680, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (44825, 680, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (44826, 680, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (44827, 680, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (44828, 680, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (44829, 680, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (44830, 680, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (44831, 680, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (44832, 680, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (44833, 680, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (44834, 680, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (44835, 680, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (44836, 680, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (44837, 680, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (44838, 680, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (44839, 680, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (44840, 680, 156, 2402);
INSERT INTO 'devicecapvalue' VALUES (44841, 680, 156, 2403);
INSERT INTO 'devicecapvalue' VALUES (44842, 680, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (44843, 680, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (44844, 680, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (44845, 680, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (44846, 680, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (44847, 680, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (44848, 680, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (44849, 680, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (44850, 680, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (44851, 680, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (44852, 680, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (44853, 680, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (44854, 680, 191, 1372);
INSERT INTO 'capvalue' VALUES (2418, 'SonyEricssonK320i/R4EA Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (44855, 680, 53, 2418);
INSERT INTO 'devicecapvalue' VALUES (44856, 681, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (44857, 681, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (44858, 681, 160, 2416);
INSERT INTO 'devicecapvalue' VALUES (44859, 681, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (44860, 681, 7, 1100);
INSERT INTO 'devicecapvalue' VALUES (44861, 681, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (44862, 681, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (44863, 681, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (44864, 681, 75, 2417);
INSERT INTO 'devicecapvalue' VALUES (44865, 681, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (44866, 681, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (44867, 681, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (44868, 681, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (44869, 681, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (44870, 681, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (44871, 681, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (44872, 681, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (44873, 681, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (44874, 681, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (44875, 681, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (44876, 681, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (44877, 681, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (44878, 681, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (44879, 681, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (44880, 681, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (44881, 681, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (44882, 681, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (44883, 681, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (44884, 681, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (44885, 681, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (44886, 681, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (44887, 681, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (44888, 681, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (44889, 681, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (44890, 681, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (44891, 681, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (44892, 681, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (44893, 681, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (44894, 681, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (44895, 681, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (44896, 681, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (44897, 681, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (44898, 681, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (44899, 681, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (44900, 681, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (44901, 681, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (44902, 681, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (44903, 681, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (44904, 681, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (44905, 681, 156, 2402);
INSERT INTO 'devicecapvalue' VALUES (44906, 681, 156, 2403);
INSERT INTO 'devicecapvalue' VALUES (44907, 681, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (44908, 681, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (44909, 681, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (44910, 681, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (44911, 681, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (44912, 681, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (44913, 681, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (44914, 681, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (44915, 681, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (44916, 681, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (44917, 681, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (44918, 681, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (44919, 681, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (44920, 681, 53, 2418);
INSERT INTO 'devicecapvalue' VALUES (44921, 682, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (44922, 682, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (44923, 682, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (44924, 682, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (44925, 682, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (44926, 682, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (44927, 682, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (44928, 682, 75, 2370);
INSERT INTO 'devicecapvalue' VALUES (44929, 682, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (44930, 682, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (44931, 682, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (44932, 682, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (44933, 682, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (44934, 682, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (44935, 682, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (44936, 682, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (44937, 682, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (44938, 682, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (44939, 682, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (44940, 682, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (44941, 682, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (44942, 682, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (44943, 682, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (44944, 682, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (44945, 682, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (44946, 682, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (44947, 682, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (44948, 682, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (44949, 682, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (44950, 682, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (44951, 682, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (44952, 682, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (44953, 682, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (44954, 682, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (44955, 682, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (44956, 682, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (44957, 682, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (44958, 682, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (44959, 682, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (44960, 682, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (44961, 682, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (44962, 682, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (44963, 682, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (44964, 682, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (44965, 682, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (44966, 682, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (44967, 682, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (44968, 682, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (44969, 682, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (44970, 682, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (44971, 682, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (44972, 682, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (44973, 682, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (44974, 682, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (44975, 682, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (44976, 682, 53, 2374);
INSERT INTO 'devicecapvalue' VALUES (44977, 683, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (44978, 683, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (44979, 683, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (44980, 683, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (44981, 683, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (44982, 683, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (44983, 683, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (44984, 683, 75, 2370);
INSERT INTO 'devicecapvalue' VALUES (44985, 683, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (44986, 683, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (44987, 683, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (44988, 683, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (44989, 683, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (44990, 683, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (44991, 683, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (44992, 683, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (44993, 683, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (44994, 683, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (44995, 683, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (44996, 683, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (44997, 683, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (44998, 683, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (44999, 683, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45000, 683, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45001, 683, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45002, 683, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45003, 683, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45004, 683, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45005, 683, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45006, 683, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45007, 683, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45008, 683, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (45009, 683, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (45010, 683, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (45011, 683, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (45012, 683, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (45013, 683, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (45014, 683, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (45015, 683, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (45016, 683, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (45017, 683, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (45018, 683, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (45019, 683, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (45020, 683, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (45021, 683, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (45022, 683, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (45023, 683, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45024, 683, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (45025, 683, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45026, 683, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (45027, 683, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45028, 683, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45029, 683, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45030, 683, 191, 1372);
INSERT INTO 'capvalue' VALUES (2419, 'SonyEricssonK500c/R2L SEMC-Browser/4.0.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (45031, 683, 53, 2419);
INSERT INTO 'devicecapvalue' VALUES (45032, 684, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (45033, 684, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (45034, 684, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (45035, 684, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (45036, 684, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (45037, 684, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (45038, 684, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (45039, 684, 75, 2370);
INSERT INTO 'devicecapvalue' VALUES (45040, 684, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45041, 684, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45042, 684, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45043, 684, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45044, 684, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45045, 684, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45046, 684, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (45047, 684, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (45048, 684, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (45049, 684, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45050, 684, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (45051, 684, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45052, 684, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45053, 684, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45054, 684, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45055, 684, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45056, 684, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45057, 684, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45058, 684, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45059, 684, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45060, 684, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45061, 684, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45062, 684, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45063, 684, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (45064, 684, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (45065, 684, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (45066, 684, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (45067, 684, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (45068, 684, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (45069, 684, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (45070, 684, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (45071, 684, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (45072, 684, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (45073, 684, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (45074, 684, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (45075, 684, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (45076, 684, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (45077, 684, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (45078, 684, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (45079, 684, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45080, 684, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (45081, 684, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45082, 684, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (45083, 684, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45084, 684, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45085, 684, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45086, 684, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (45087, 684, 53, 2374);
INSERT INTO 'devicecapvalue' VALUES (45088, 685, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (45089, 685, 74, 1029);
INSERT INTO 'capvalue' VALUES (2420, '1.3');
INSERT INTO 'devicecapvalue' VALUES (45090, 685, 160, 2420);
INSERT INTO 'devicecapvalue' VALUES (45091, 685, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (45092, 685, 7, 1100);
INSERT INTO 'devicecapvalue' VALUES (45093, 685, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (45094, 685, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (45095, 685, 173, 1523);
INSERT INTO 'capvalue' VALUES (2421, 'SonyEricsson_K510');
INSERT INTO 'devicecapvalue' VALUES (45096, 685, 75, 2421);
INSERT INTO 'cap' VALUES (259, 'Emulator.Skin2', 1);
INSERT INTO 'capvalue' VALUES (2422, 'SonyEricsson_K510i');
INSERT INTO 'devicecapvalue' VALUES (45097, 685, 259, 2422);
INSERT INTO 'devicecapvalue' VALUES (45098, 685, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45099, 685, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45100, 685, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45101, 685, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45102, 685, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45103, 685, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45104, 685, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (45105, 685, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (45106, 685, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (45107, 685, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45108, 685, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (45109, 685, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45110, 685, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45111, 685, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45112, 685, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45113, 685, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45114, 685, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45115, 685, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45116, 685, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45117, 685, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45118, 685, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (45119, 685, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45120, 685, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45121, 685, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (45122, 685, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45123, 685, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45124, 685, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45125, 685, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (45126, 685, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (45127, 685, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (45128, 685, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (45129, 685, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (45130, 685, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (45131, 685, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (45132, 685, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (45133, 685, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (45134, 685, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (45135, 685, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (45136, 685, 156, 2402);
INSERT INTO 'devicecapvalue' VALUES (45137, 685, 156, 2403);
INSERT INTO 'devicecapvalue' VALUES (45138, 685, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (45139, 685, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (45140, 685, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (45141, 685, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45142, 685, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (45143, 685, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (45144, 685, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (45145, 685, 51, 1117);
INSERT INTO 'capvalue' VALUES (2423, 'mpeg-3');
INSERT INTO 'devicecapvalue' VALUES (45146, 685, 51, 2423);
INSERT INTO 'capvalue' VALUES (2424, 'rhz');
INSERT INTO 'devicecapvalue' VALUES (45147, 685, 51, 2424);
INSERT INTO 'devicecapvalue' VALUES (45148, 685, 51, 669);
INSERT INTO 'capvalue' VALUES (2425, 'wave');
INSERT INTO 'devicecapvalue' VALUES (45149, 685, 51, 2425);
INSERT INTO 'devicecapvalue' VALUES (45150, 685, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (45151, 685, 52, 2414);
INSERT INTO 'devicecapvalue' VALUES (45152, 685, 157, 975);
INSERT INTO 'devicecapvalue' VALUES (45153, 685, 157, 1117);
INSERT INTO 'devicecapvalue' VALUES (45154, 685, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (45155, 686, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (45156, 686, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (45157, 686, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45158, 686, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45159, 686, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45160, 686, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45161, 686, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45162, 686, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45163, 686, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (45164, 686, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (45165, 686, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (45166, 686, 76, 1337);
INSERT INTO 'devicecapvalue' VALUES (45167, 686, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45168, 686, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45169, 686, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45170, 686, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45171, 686, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (45172, 686, 15, 1181);
INSERT INTO 'devicecapvalue' VALUES (45173, 686, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45174, 686, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45175, 686, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (45176, 686, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45177, 686, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45178, 686, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45179, 686, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45180, 686, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45181, 686, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45182, 686, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (45183, 686, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (45184, 686, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45185, 686, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45186, 686, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45187, 686, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (45188, 686, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45189, 686, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45190, 686, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (45191, 686, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45192, 686, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (45193, 686, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (45194, 686, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (45195, 686, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45196, 686, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (45197, 686, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45198, 686, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (45199, 686, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (45200, 686, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (45201, 686, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (45202, 686, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (45203, 686, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (45204, 686, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (45205, 686, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (45206, 686, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (45207, 686, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45208, 686, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45209, 686, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (45210, 686, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45211, 686, 157, 1504);
INSERT INTO 'capvalue' VALUES (2426, 'wmv');
INSERT INTO 'devicecapvalue' VALUES (45212, 686, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (45213, 687, 1, 106);
INSERT INTO 'capvalue' VALUES (2427, 'OMA DRM 2.0');
INSERT INTO 'devicecapvalue' VALUES (45214, 687, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (45215, 687, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45216, 687, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45217, 687, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45218, 687, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45219, 687, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45220, 687, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45221, 687, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (45222, 687, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (45223, 687, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45224, 687, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45225, 687, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45226, 687, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45227, 687, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (45228, 687, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45229, 687, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45230, 687, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (45231, 687, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45232, 687, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45233, 687, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45234, 687, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (45235, 687, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45236, 687, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (45237, 687, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45238, 687, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (45239, 687, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45240, 687, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (45241, 687, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45242, 687, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45243, 687, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45244, 687, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45245, 687, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45246, 687, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (45247, 687, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45248, 687, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (45249, 687, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (45250, 687, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (45251, 687, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (45252, 687, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45253, 687, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (45254, 687, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45255, 687, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (45256, 687, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (45257, 687, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (45258, 687, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (45259, 687, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (45260, 687, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (45261, 687, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (45262, 687, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45263, 687, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45264, 687, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (45265, 687, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45266, 687, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (45267, 687, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (45268, 688, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (45269, 688, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (45270, 688, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45271, 688, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45272, 688, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45273, 688, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45274, 688, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45275, 688, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45276, 688, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (45277, 688, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (45278, 688, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (45279, 688, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45280, 688, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45281, 688, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45282, 688, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45283, 688, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (45284, 688, 15, 1181);
INSERT INTO 'devicecapvalue' VALUES (45285, 688, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45286, 688, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45287, 688, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45288, 688, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45289, 688, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45290, 688, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45291, 688, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45292, 688, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (45293, 688, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45294, 688, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (45295, 688, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (45296, 688, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (45297, 688, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45298, 688, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (45299, 688, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45300, 688, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (45301, 688, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (45302, 688, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (45303, 688, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (45304, 688, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (45305, 688, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (45306, 688, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (45307, 688, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (45308, 688, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45309, 688, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45310, 688, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (45311, 688, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45312, 688, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (45313, 688, 157, 2426);
INSERT INTO 'capvalue' VALUES (2428, 'portalmmm/2.0 K550im(c100;TJ)');
INSERT INTO 'devicecapvalue' VALUES (45314, 688, 53, 2428);
INSERT INTO 'devicecapvalue' VALUES (45315, 689, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (45316, 689, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (45317, 689, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (45318, 689, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (45319, 689, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (45320, 689, 173, 1523);
INSERT INTO 'capvalue' VALUES (2429, 'SonyEricsson_K600');
INSERT INTO 'devicecapvalue' VALUES (45321, 689, 75, 2429);
INSERT INTO 'devicecapvalue' VALUES (45322, 689, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45323, 689, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45324, 689, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45325, 689, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45326, 689, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45327, 689, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45328, 689, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (45329, 689, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (45330, 689, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45331, 689, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (45332, 689, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45333, 689, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45334, 689, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45335, 689, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45336, 689, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45337, 689, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45338, 689, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45339, 689, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45340, 689, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45341, 689, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45342, 689, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45343, 689, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45344, 689, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45345, 689, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45346, 689, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (45347, 689, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (45348, 689, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (45349, 689, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (45350, 689, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (45351, 689, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (45352, 689, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (45353, 689, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (45354, 689, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (45355, 689, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (45356, 689, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45357, 689, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45358, 689, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45359, 689, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (45360, 689, 51, 102);
INSERT INTO 'capvalue' VALUES (2430, 'midi72');
INSERT INTO 'devicecapvalue' VALUES (45361, 689, 51, 2430);
INSERT INTO 'devicecapvalue' VALUES (45362, 689, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45363, 689, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (45364, 689, 51, 669);
INSERT INTO 'capvalue' VALUES (2431, '38797312');
INSERT INTO 'devicecapvalue' VALUES (45365, 689, 52, 2431);
INSERT INTO 'devicecapvalue' VALUES (45366, 689, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45367, 689, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45368, 689, 157, 1026);
INSERT INTO 'capvalue' VALUES (2432, 'real8');
INSERT INTO 'devicecapvalue' VALUES (45369, 689, 157, 2432);
INSERT INTO 'devicecapvalue' VALUES (45370, 689, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (45371, 689, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (45372, 689, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (45373, 689, 191, 1372);
INSERT INTO 'capvalue' VALUES (2433, 'SonyEricssonK600/1.0 (05.02) Profile/MIDP-1.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (45374, 689, 53, 2433);
INSERT INTO 'devicecapvalue' VALUES (45375, 690, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (45376, 690, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (45377, 690, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (45378, 690, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (45379, 690, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (45380, 690, 173, 1688);
INSERT INTO 'capvalue' VALUES (2434, 'SonyEricsson_K608');
INSERT INTO 'devicecapvalue' VALUES (45381, 690, 75, 2434);
INSERT INTO 'devicecapvalue' VALUES (45382, 690, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45383, 690, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45384, 690, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45385, 690, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45386, 690, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45387, 690, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (45388, 690, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (45389, 690, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45390, 690, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45391, 690, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (45392, 690, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45393, 690, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45394, 690, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45395, 690, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45396, 690, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45397, 690, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45398, 690, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (45399, 690, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45400, 690, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45401, 690, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45402, 690, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45403, 690, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (45404, 690, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (45405, 690, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (45406, 690, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (45407, 690, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (45408, 690, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (45409, 690, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (45410, 690, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (45411, 690, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (45412, 690, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (45413, 690, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (45414, 690, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45415, 690, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45416, 690, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45417, 690, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (45418, 690, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (45419, 690, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45420, 690, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (45421, 690, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45422, 690, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (45423, 690, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (45424, 690, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (45425, 690, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45426, 690, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45427, 690, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45428, 690, 191, 1372);
INSERT INTO 'capvalue' VALUES (2435, 'SonyEricssonK608i/R301 Profile/MIDP-1.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (45429, 690, 53, 2435);
INSERT INTO 'devicecapvalue' VALUES (45430, 691, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (45431, 691, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (45432, 691, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (45433, 691, 75, 2429);
INSERT INTO 'devicecapvalue' VALUES (45434, 691, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45435, 691, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (45436, 691, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45437, 691, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45438, 691, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45439, 691, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45440, 691, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (45441, 691, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45442, 691, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (45443, 691, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45444, 691, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45445, 691, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (45446, 691, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45447, 691, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (45448, 691, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45449, 691, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (45450, 691, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45451, 691, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (45452, 691, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45453, 691, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (45454, 691, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45455, 691, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45456, 691, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45457, 691, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45458, 691, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45459, 691, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45460, 691, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (45461, 691, 51, 1040);
INSERT INTO 'devicecapvalue' VALUES (45462, 691, 51, 100);
INSERT INTO 'capvalue' VALUES (2436, 'eMelody');
INSERT INTO 'devicecapvalue' VALUES (45463, 691, 51, 2436);
INSERT INTO 'devicecapvalue' VALUES (45464, 691, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (45465, 691, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (45466, 691, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45467, 691, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45468, 691, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (45469, 691, 51, 2424);
INSERT INTO 'devicecapvalue' VALUES (45470, 691, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (45471, 691, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (45472, 691, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (45473, 691, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (45474, 691, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45475, 691, 157, 1026);
INSERT INTO 'capvalue' VALUES (2437, 'realvideo8');
INSERT INTO 'devicecapvalue' VALUES (45476, 691, 157, 2437);
INSERT INTO 'devicecapvalue' VALUES (45477, 691, 157, 2426);
INSERT INTO 'capvalue' VALUES (2438, 'SonyEricssonK610i/R1AA Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (45478, 691, 53, 2438);
INSERT INTO 'devicecapvalue' VALUES (45479, 692, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (45480, 692, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (45481, 692, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45482, 692, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45483, 692, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45484, 692, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45485, 692, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45486, 692, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45487, 692, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (45488, 692, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (45489, 692, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45490, 692, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45491, 692, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45492, 692, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45493, 692, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (45494, 692, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45495, 692, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45496, 692, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (45497, 692, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45498, 692, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45499, 692, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45500, 692, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45501, 692, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45502, 692, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45503, 692, 17, 1197);
INSERT INTO 'devicecapvalue' VALUES (45504, 692, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (45505, 692, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45506, 692, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45507, 692, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45508, 692, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45509, 692, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45510, 692, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (45511, 692, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45512, 692, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (45513, 692, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (45514, 692, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (45515, 692, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (45516, 692, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45517, 692, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (45518, 692, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45519, 692, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (45520, 692, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (45521, 692, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (45522, 692, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (45523, 692, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (45524, 692, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (45525, 692, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (45526, 692, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (45527, 692, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45528, 692, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45529, 692, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45530, 692, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (45531, 692, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (45532, 693, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (45533, 693, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (45534, 693, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45535, 693, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45536, 693, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45537, 693, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45538, 693, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45539, 693, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45540, 693, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (45541, 693, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (45542, 693, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (45543, 693, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45544, 693, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45545, 693, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45546, 693, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45547, 693, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (45548, 693, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45549, 693, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45550, 693, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (45551, 693, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45552, 693, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45553, 693, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45554, 693, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (45555, 693, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (45556, 693, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (45557, 693, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45558, 693, 17, 22);
INSERT INTO 'capvalue' VALUES (2439, 'msa');
INSERT INTO 'devicecapvalue' VALUES (45559, 693, 17, 2439);
INSERT INTO 'devicecapvalue' VALUES (45560, 693, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (45561, 693, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45562, 693, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (45563, 693, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (45564, 693, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (45565, 693, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (45566, 693, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45567, 693, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45568, 693, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (45569, 693, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (45570, 693, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45571, 693, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45572, 693, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (45573, 693, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45574, 693, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (45575, 693, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (45576, 693, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (45577, 693, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (45578, 693, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45579, 693, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (45580, 693, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45581, 693, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (45582, 693, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (45583, 693, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (45584, 693, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (45585, 693, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (45586, 693, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (45587, 693, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (45588, 693, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45589, 693, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45590, 693, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (45591, 693, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45592, 693, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (45593, 694, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (45594, 694, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (45595, 694, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45596, 694, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45597, 694, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45598, 694, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45599, 694, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45600, 694, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45601, 694, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (45602, 694, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (45603, 694, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (45604, 694, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (45605, 694, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45606, 694, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45607, 694, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45608, 694, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45609, 694, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (45610, 694, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45611, 694, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45612, 694, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (45613, 694, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45614, 694, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45615, 694, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45616, 694, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (45617, 694, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (45618, 694, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (45619, 694, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45620, 694, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45621, 694, 17, 2439);
INSERT INTO 'devicecapvalue' VALUES (45622, 694, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (45623, 694, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45624, 694, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (45625, 694, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (45626, 694, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (45627, 694, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (45628, 694, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45629, 694, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45630, 694, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (45631, 694, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (45632, 694, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45633, 694, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45634, 694, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (45635, 694, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45636, 694, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (45637, 694, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (45638, 694, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (45639, 694, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (45640, 694, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45641, 694, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (45642, 694, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45643, 694, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (45644, 694, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (45645, 694, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (45646, 694, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (45647, 694, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (45648, 694, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (45649, 694, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (45650, 694, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (45651, 694, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45652, 694, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45653, 694, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (45654, 694, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45655, 694, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (45656, 694, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (45657, 695, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (45658, 695, 74, 1519);
INSERT INTO 'capvalue' VALUES (2440, 'VersionNumberMustNotExceed99');
INSERT INTO 'devicecapvalue' VALUES (45659, 695, 74, 2440);
INSERT INTO 'devicecapvalue' VALUES (45660, 695, 74, 1520);
INSERT INTO 'capvalue' VALUES (2441, 'getHeightReturnsCompleteScreenHeight');
INSERT INTO 'devicecapvalue' VALUES (45661, 695, 74, 2441);
INSERT INTO 'devicecapvalue' VALUES (45662, 695, 74, 1521);
INSERT INTO 'capvalue' VALUES (2442, 'setClipForFullScreenNeeded');
INSERT INTO 'devicecapvalue' VALUES (45663, 695, 74, 2442);
INSERT INTO 'devicecapvalue' VALUES (45664, 695, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (45665, 695, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (45666, 695, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (45667, 695, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (45668, 695, 173, 1523);
INSERT INTO 'capvalue' VALUES (2443, 'SonyEricsson_K700');
INSERT INTO 'devicecapvalue' VALUES (45669, 695, 75, 2443);
INSERT INTO 'devicecapvalue' VALUES (45670, 695, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45671, 695, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45672, 695, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45673, 695, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (45674, 695, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (45675, 695, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (45676, 695, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (45677, 695, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (45678, 695, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45679, 695, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (45680, 695, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45681, 695, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45682, 695, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45683, 695, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45684, 695, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45685, 695, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45686, 695, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45687, 695, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45688, 695, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45689, 695, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45690, 695, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45691, 695, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45692, 695, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (45693, 695, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (45694, 695, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (45695, 695, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (45696, 695, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (45697, 695, 154, 1018);
INSERT INTO 'cap' VALUES (260, 'NokiaFullCanvasSize', 1);
INSERT INTO 'devicecapvalue' VALUES (45698, 695, 260, 1950);
INSERT INTO 'devicecapvalue' VALUES (45699, 695, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45700, 695, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45701, 695, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45702, 695, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (45703, 695, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (45704, 695, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (45705, 695, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45706, 695, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (45707, 695, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45708, 695, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (45709, 695, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45710, 695, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45711, 695, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45712, 695, 191, 1372);
INSERT INTO 'capvalue' VALUES (2444, 'SonyEricssonK700c/R2A SEMC-Browser/4.0 Profile/MIDP-1.0 MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (45713, 695, 53, 2444);
INSERT INTO 'devicecapvalue' VALUES (45714, 696, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (45715, 696, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (45716, 696, 74, 2440);
INSERT INTO 'devicecapvalue' VALUES (45717, 696, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (45718, 696, 74, 2441);
INSERT INTO 'devicecapvalue' VALUES (45719, 696, 74, 1521);
INSERT INTO 'devicecapvalue' VALUES (45720, 696, 74, 2442);
INSERT INTO 'devicecapvalue' VALUES (45721, 696, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (45722, 696, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (45723, 696, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (45724, 696, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (45725, 696, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (45726, 696, 75, 2443);
INSERT INTO 'devicecapvalue' VALUES (45727, 696, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45728, 696, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45729, 696, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45730, 696, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (45731, 696, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (45732, 696, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (45733, 696, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (45734, 696, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (45735, 696, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45736, 696, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (45737, 696, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45738, 696, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45739, 696, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45740, 696, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45741, 696, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45742, 696, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45743, 696, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45744, 696, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45745, 696, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45746, 696, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45747, 696, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45748, 696, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45749, 696, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (45750, 696, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (45751, 696, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (45752, 696, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (45753, 696, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (45754, 696, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (45755, 696, 260, 1950);
INSERT INTO 'devicecapvalue' VALUES (45756, 696, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45757, 696, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45758, 696, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45759, 696, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (45760, 696, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (45761, 696, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (45762, 696, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45763, 696, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (45764, 696, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45765, 696, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (45766, 696, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45767, 696, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45768, 696, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45769, 696, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (45770, 696, 53, 2444);
INSERT INTO 'devicecapvalue' VALUES (45771, 697, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (45772, 697, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (45773, 697, 74, 2440);
INSERT INTO 'devicecapvalue' VALUES (45774, 697, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (45775, 697, 74, 2441);
INSERT INTO 'devicecapvalue' VALUES (45776, 697, 74, 1521);
INSERT INTO 'devicecapvalue' VALUES (45777, 697, 74, 2442);
INSERT INTO 'devicecapvalue' VALUES (45778, 697, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (45779, 697, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (45780, 697, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (45781, 697, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (45782, 697, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (45783, 697, 75, 2443);
INSERT INTO 'devicecapvalue' VALUES (45784, 697, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45785, 697, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45786, 697, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45787, 697, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (45788, 697, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (45789, 697, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (45790, 697, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (45791, 697, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (45792, 697, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45793, 697, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (45794, 697, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45795, 697, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45796, 697, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45797, 697, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45798, 697, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45799, 697, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45800, 697, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45801, 697, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45802, 697, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45803, 697, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45804, 697, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45805, 697, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45806, 697, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (45807, 697, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (45808, 697, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (45809, 697, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (45810, 697, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (45811, 697, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (45812, 697, 260, 1950);
INSERT INTO 'devicecapvalue' VALUES (45813, 697, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45814, 697, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45815, 697, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45816, 697, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (45817, 697, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (45818, 697, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (45819, 697, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45820, 697, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (45821, 697, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45822, 697, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (45823, 697, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45824, 697, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45825, 697, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45826, 697, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (45827, 697, 53, 2444);
INSERT INTO 'devicecapvalue' VALUES (45828, 698, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (45829, 698, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (45830, 698, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (45831, 698, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (45832, 698, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (45833, 698, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (45834, 698, 173, 1523);
INSERT INTO 'capvalue' VALUES (2445, 'SonyEricsson_K750');
INSERT INTO 'devicecapvalue' VALUES (45835, 698, 75, 2445);
INSERT INTO 'devicecapvalue' VALUES (45836, 698, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45837, 698, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45838, 698, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45839, 698, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45840, 698, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45841, 698, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45842, 698, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (45843, 698, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (45844, 698, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45845, 698, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (45846, 698, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45847, 698, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45848, 698, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45849, 698, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45850, 698, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45851, 698, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45852, 698, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45853, 698, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45854, 698, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45855, 698, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45856, 698, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45857, 698, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45858, 698, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45859, 698, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45860, 698, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (45861, 698, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (45862, 698, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (45863, 698, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (45864, 698, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (45865, 698, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (45866, 698, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (45867, 698, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (45868, 698, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (45869, 698, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (45870, 698, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (45871, 698, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (45872, 698, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45873, 698, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45874, 698, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45875, 698, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (45876, 698, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45877, 698, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (45878, 698, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45879, 698, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (45880, 698, 51, 669);
INSERT INTO 'capvalue' VALUES (2446, '39845888');
INSERT INTO 'devicecapvalue' VALUES (45881, 698, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (45882, 698, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45883, 698, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45884, 698, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45885, 698, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (45886, 698, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (45887, 698, 191, 1372);
INSERT INTO 'capvalue' VALUES (2447, 'SonyEricssonK750i/R1CA Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (45888, 698, 53, 2447);
INSERT INTO 'devicecapvalue' VALUES (45889, 699, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (45890, 699, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (45891, 699, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (45892, 699, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (45893, 699, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (45894, 699, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (45895, 699, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (45896, 699, 75, 2445);
INSERT INTO 'devicecapvalue' VALUES (45897, 699, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45898, 699, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45899, 699, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45900, 699, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45901, 699, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45902, 699, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45903, 699, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (45904, 699, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (45905, 699, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45906, 699, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (45907, 699, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45908, 699, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45909, 699, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45910, 699, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45911, 699, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45912, 699, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45913, 699, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45914, 699, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45915, 699, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45916, 699, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45917, 699, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45918, 699, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45919, 699, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (45920, 699, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45921, 699, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (45922, 699, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (45923, 699, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (45924, 699, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (45925, 699, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (45926, 699, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (45927, 699, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (45928, 699, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (45929, 699, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (45930, 699, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (45931, 699, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (45932, 699, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (45933, 699, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (45934, 699, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (45935, 699, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (45936, 699, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (45937, 699, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (45938, 699, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (45939, 699, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (45940, 699, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (45941, 699, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (45942, 699, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (45943, 699, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (45944, 699, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (45945, 699, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (45946, 699, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (45947, 699, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (45948, 699, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (45949, 699, 53, 2447);
INSERT INTO 'devicecapvalue' VALUES (45950, 700, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (45951, 700, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (45952, 700, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (45953, 700, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (45954, 700, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (45955, 700, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (45956, 700, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (45957, 700, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (45958, 700, 9, 649);
INSERT INTO 'devicecapvalue' VALUES (45959, 700, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (45960, 700, 11, 649);
INSERT INTO 'devicecapvalue' VALUES (45961, 700, 12, 603);
INSERT INTO 'devicecapvalue' VALUES (45962, 700, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (45963, 700, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (45964, 700, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (45965, 700, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (45966, 700, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (45967, 700, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (45968, 700, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (45969, 700, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (45970, 700, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (45971, 700, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (45972, 700, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (45973, 700, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (45974, 700, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (45975, 700, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (45976, 700, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (45977, 700, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (45978, 700, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (45979, 700, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (45980, 700, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (45981, 700, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (45982, 700, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (45983, 700, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (45984, 700, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (45985, 700, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (45986, 700, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (45987, 700, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (45988, 700, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (45989, 700, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (45990, 700, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (45991, 700, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (45992, 700, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (45993, 700, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (45994, 700, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (45995, 700, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (45996, 700, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (45997, 700, 57, 1245);
INSERT INTO 'devicecapvalue' VALUES (45998, 700, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (45999, 700, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (46000, 700, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (46001, 700, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (46002, 700, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (46003, 700, 38, 100);
INSERT INTO 'devicecapvalue' VALUES (46004, 700, 38, 880);
INSERT INTO 'devicecapvalue' VALUES (46005, 700, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (46006, 700, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (46007, 700, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (46008, 700, 39, 123);
INSERT INTO 'devicecapvalue' VALUES (46009, 700, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (46010, 700, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (46011, 700, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (46012, 700, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (46013, 700, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (46014, 700, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (46015, 700, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (46016, 700, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (46017, 700, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (46018, 700, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (46019, 700, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (46020, 700, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (46021, 700, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (46022, 700, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (46023, 700, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (46024, 700, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (46025, 700, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (46026, 700, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (46027, 700, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (46028, 700, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (46029, 700, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (46030, 700, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (46031, 700, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (46032, 700, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (46033, 700, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (46034, 700, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (46035, 700, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (46036, 700, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (46037, 700, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (46038, 700, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (46039, 700, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (46040, 700, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (46041, 700, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (46042, 700, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (46043, 700, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (46044, 700, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (46045, 700, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (46046, 700, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (46047, 700, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (46048, 700, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (46049, 700, 41, 123);
INSERT INTO 'devicecapvalue' VALUES (46050, 700, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (46051, 700, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (46052, 700, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (46053, 700, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (46054, 700, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (46055, 700, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (46056, 700, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (46057, 700, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (46058, 700, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (46059, 700, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (46060, 700, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (46061, 700, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (46062, 700, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (46063, 700, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (46064, 700, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (46065, 700, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (46066, 700, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (46067, 700, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (46068, 700, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (46069, 700, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (46070, 700, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (46071, 700, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (46072, 700, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (46073, 700, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (46074, 700, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (46075, 700, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (46076, 700, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (46077, 700, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (46078, 700, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (46079, 700, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (46080, 700, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (46081, 700, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (46082, 700, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (46083, 700, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (46084, 700, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (46085, 700, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (46086, 700, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (46087, 700, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (46088, 700, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (46089, 700, 42, 123);
INSERT INTO 'devicecapvalue' VALUES (46090, 700, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (46091, 700, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (46092, 700, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (46093, 700, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (46094, 700, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (46095, 700, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (46096, 700, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (46097, 700, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (46098, 700, 44, 15);
INSERT INTO 'capvalue' VALUES (2448, 'encoding=h263&width=176&height=144');
INSERT INTO 'devicecapvalue' VALUES (46099, 700, 45, 2448);
INSERT INTO 'devicecapvalue' VALUES (46100, 700, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (46101, 700, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (46102, 700, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (46103, 700, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (46104, 700, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (46105, 700, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (46106, 700, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (46107, 700, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (46108, 700, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (46109, 700, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (46110, 700, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (46111, 700, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (46112, 700, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (46113, 700, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (46114, 700, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (46115, 700, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (46116, 700, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (46117, 700, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (46118, 700, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (46119, 700, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (46120, 700, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (46121, 700, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (46122, 700, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (46123, 700, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (46124, 700, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (46125, 700, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (46126, 700, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (46127, 700, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (46128, 700, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (46129, 700, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (46130, 700, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (46131, 700, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (46132, 700, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (46133, 700, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (46134, 700, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (46135, 700, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (46136, 700, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (46137, 700, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (46138, 700, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (46139, 700, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (46140, 700, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (46141, 700, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (46142, 700, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (46143, 700, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (46144, 700, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (46145, 700, 46, 721);
INSERT INTO 'capvalue' VALUES (2449, 'encoding=amr encoding=amr-nb');
INSERT INTO 'devicecapvalue' VALUES (46146, 700, 115, 2449);
INSERT INTO 'devicecapvalue' VALUES (46147, 700, 141, 42);
INSERT INTO 'devicecapvalue' VALUES (46148, 700, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (46149, 700, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (46150, 700, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (46151, 700, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (46152, 700, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (46153, 700, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (46154, 700, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (46155, 700, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (46156, 700, 125, 707);
INSERT INTO 'devicecapvalue' VALUES (46157, 700, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (46158, 700, 142, 2336);
INSERT INTO 'capvalue' VALUES (2450, 'devcam0:2048x1536');
INSERT INTO 'devicecapvalue' VALUES (46159, 700, 143, 2450);
INSERT INTO 'devicecapvalue' VALUES (46160, 700, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (46161, 700, 101, 1469);
INSERT INTO 'capvalue' VALUES (2451, 'Memory Stick');
INSERT INTO 'devicecapvalue' VALUES (46162, 700, 102, 2451);
INSERT INTO 'devicecapvalue' VALUES (46163, 700, 103, 2338);
INSERT INTO 'devicecapvalue' VALUES (46164, 700, 104, 2339);
INSERT INTO 'devicecapvalue' VALUES (46165, 700, 106, 2341);
INSERT INTO 'devicecapvalue' VALUES (46166, 700, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (46167, 700, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (46168, 700, 109, 946);
INSERT INTO 'devicecapvalue' VALUES (46169, 700, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (46170, 700, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (46171, 700, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (46172, 700, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (46173, 700, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (46174, 700, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (46175, 700, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (46176, 700, 67, 45);
INSERT INTO 'capvalue' VALUES (2452, 'SonyEricssonK770i/R8BC004');
INSERT INTO 'devicecapvalue' VALUES (46177, 700, 68, 2452);
INSERT INTO 'devicecapvalue' VALUES (46178, 700, 69, 2390);
INSERT INTO 'devicecapvalue' VALUES (46179, 700, 132, 2449);
INSERT INTO 'devicecapvalue' VALUES (46180, 700, 133, 2448);
INSERT INTO 'devicecapvalue' VALUES (46181, 700, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (46182, 700, 116, 2345);
INSERT INTO 'devicecapvalue' VALUES (46183, 700, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (46184, 700, 149, 949);
INSERT INTO 'devicecapvalue' VALUES (46185, 700, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (46186, 700, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (46187, 700, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (46188, 700, 136, 2448);
INSERT INTO 'capvalue' VALUES (2453, 'jpeg&width=480&height=640');
INSERT INTO 'devicecapvalue' VALUES (46189, 700, 137, 2453);
INSERT INTO 'capvalue' VALUES (2454, 'http://mms.ke.celtel.com/servlets/mms');
INSERT INTO 'devicecapvalue' VALUES (46190, 700, 138, 2454);
INSERT INTO 'capvalue' VALUES (2455, '+254733000810');
INSERT INTO 'devicecapvalue' VALUES (46191, 700, 72, 2455);
INSERT INTO 'devicecapvalue' VALUES (46192, 700, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (46193, 700, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (46194, 700, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (46195, 700, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (46196, 700, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (46197, 700, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (46198, 700, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (46199, 700, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (46200, 700, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (46201, 700, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (46202, 700, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (46203, 700, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (46204, 700, 47, 123);
INSERT INTO 'devicecapvalue' VALUES (46205, 700, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (46206, 700, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (46207, 700, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (46208, 700, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (46209, 700, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (46210, 700, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (46211, 700, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (46212, 700, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (46213, 700, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (46214, 700, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (46215, 700, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (46216, 700, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (46217, 700, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (46218, 700, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (46219, 700, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (46220, 700, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (46221, 700, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (46222, 700, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (46223, 700, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (46224, 700, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (46225, 700, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (46226, 700, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (46227, 700, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (46228, 700, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (46229, 700, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (46230, 700, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (46231, 700, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (46232, 700, 48, 155);
INSERT INTO 'devicecapvalue' VALUES (46233, 700, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (46234, 700, 49, 659);
INSERT INTO 'devicecapvalue' VALUES (46235, 700, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (46236, 700, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (46237, 700, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (46238, 700, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (46239, 700, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (46240, 700, 157, 2426);
INSERT INTO 'capvalue' VALUES (2456, 'SonyEricssonK770i/R8BC Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (46241, 700, 53, 2456);
INSERT INTO 'devicecapvalue' VALUES (46242, 701, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (46243, 701, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (46244, 701, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (46245, 701, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (46246, 701, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (46247, 701, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (46248, 701, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (46249, 701, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (46250, 701, 9, 649);
INSERT INTO 'devicecapvalue' VALUES (46251, 701, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (46252, 701, 11, 649);
INSERT INTO 'devicecapvalue' VALUES (46253, 701, 12, 603);
INSERT INTO 'devicecapvalue' VALUES (46254, 701, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (46255, 701, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (46256, 701, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (46257, 701, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (46258, 701, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (46259, 701, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (46260, 701, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (46261, 701, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (46262, 701, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (46263, 701, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (46264, 701, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (46265, 701, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (46266, 701, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (46267, 701, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (46268, 701, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (46269, 701, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (46270, 701, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (46271, 701, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (46272, 701, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (46273, 701, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (46274, 701, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (46275, 701, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (46276, 701, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (46277, 701, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (46278, 701, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (46279, 701, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (46280, 701, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (46281, 701, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (46282, 701, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (46283, 701, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (46284, 701, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (46285, 701, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (46286, 701, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (46287, 701, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (46288, 701, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (46289, 701, 57, 1245);
INSERT INTO 'devicecapvalue' VALUES (46290, 701, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (46291, 701, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (46292, 701, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (46293, 701, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (46294, 701, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (46295, 701, 38, 100);
INSERT INTO 'devicecapvalue' VALUES (46296, 701, 38, 880);
INSERT INTO 'devicecapvalue' VALUES (46297, 701, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (46298, 701, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (46299, 701, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (46300, 701, 39, 123);
INSERT INTO 'devicecapvalue' VALUES (46301, 701, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (46302, 701, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (46303, 701, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (46304, 701, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (46305, 701, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (46306, 701, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (46307, 701, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (46308, 701, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (46309, 701, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (46310, 701, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (46311, 701, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (46312, 701, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (46313, 701, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (46314, 701, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (46315, 701, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (46316, 701, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (46317, 701, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (46318, 701, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (46319, 701, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (46320, 701, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (46321, 701, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (46322, 701, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (46323, 701, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (46324, 701, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (46325, 701, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (46326, 701, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (46327, 701, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (46328, 701, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (46329, 701, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (46330, 701, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (46331, 701, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (46332, 701, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (46333, 701, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (46334, 701, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (46335, 701, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (46336, 701, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (46337, 701, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (46338, 701, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (46339, 701, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (46340, 701, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (46341, 701, 41, 123);
INSERT INTO 'devicecapvalue' VALUES (46342, 701, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (46343, 701, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (46344, 701, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (46345, 701, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (46346, 701, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (46347, 701, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (46348, 701, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (46349, 701, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (46350, 701, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (46351, 701, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (46352, 701, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (46353, 701, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (46354, 701, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (46355, 701, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (46356, 701, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (46357, 701, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (46358, 701, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (46359, 701, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (46360, 701, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (46361, 701, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (46362, 701, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (46363, 701, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (46364, 701, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (46365, 701, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (46366, 701, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (46367, 701, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (46368, 701, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (46369, 701, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (46370, 701, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (46371, 701, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (46372, 701, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (46373, 701, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (46374, 701, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (46375, 701, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (46376, 701, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (46377, 701, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (46378, 701, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (46379, 701, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (46380, 701, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (46381, 701, 42, 123);
INSERT INTO 'devicecapvalue' VALUES (46382, 701, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (46383, 701, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (46384, 701, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (46385, 701, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (46386, 701, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (46387, 701, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (46388, 701, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (46389, 701, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (46390, 701, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (46391, 701, 45, 2448);
INSERT INTO 'devicecapvalue' VALUES (46392, 701, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (46393, 701, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (46394, 701, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (46395, 701, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (46396, 701, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (46397, 701, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (46398, 701, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (46399, 701, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (46400, 701, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (46401, 701, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (46402, 701, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (46403, 701, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (46404, 701, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (46405, 701, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (46406, 701, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (46407, 701, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (46408, 701, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (46409, 701, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (46410, 701, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (46411, 701, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (46412, 701, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (46413, 701, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (46414, 701, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (46415, 701, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (46416, 701, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (46417, 701, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (46418, 701, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (46419, 701, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (46420, 701, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (46421, 701, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (46422, 701, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (46423, 701, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (46424, 701, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (46425, 701, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (46426, 701, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (46427, 701, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (46428, 701, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (46429, 701, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (46430, 701, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (46431, 701, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (46432, 701, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (46433, 701, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (46434, 701, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (46435, 701, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (46436, 701, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (46437, 701, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (46438, 701, 115, 2449);
INSERT INTO 'devicecapvalue' VALUES (46439, 701, 141, 42);
INSERT INTO 'devicecapvalue' VALUES (46440, 701, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (46441, 701, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (46442, 701, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (46443, 701, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (46444, 701, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (46445, 701, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (46446, 701, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (46447, 701, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (46448, 701, 125, 707);
INSERT INTO 'devicecapvalue' VALUES (46449, 701, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (46450, 701, 142, 2336);
INSERT INTO 'devicecapvalue' VALUES (46451, 701, 143, 2450);
INSERT INTO 'devicecapvalue' VALUES (46452, 701, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (46453, 701, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (46454, 701, 102, 2451);
INSERT INTO 'devicecapvalue' VALUES (46455, 701, 103, 2338);
INSERT INTO 'devicecapvalue' VALUES (46456, 701, 104, 2339);
INSERT INTO 'devicecapvalue' VALUES (46457, 701, 106, 2341);
INSERT INTO 'devicecapvalue' VALUES (46458, 701, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (46459, 701, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (46460, 701, 109, 946);
INSERT INTO 'devicecapvalue' VALUES (46461, 701, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (46462, 701, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (46463, 701, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (46464, 701, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (46465, 701, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (46466, 701, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (46467, 701, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (46468, 701, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (46469, 701, 68, 2452);
INSERT INTO 'devicecapvalue' VALUES (46470, 701, 69, 2390);
INSERT INTO 'devicecapvalue' VALUES (46471, 701, 132, 2449);
INSERT INTO 'devicecapvalue' VALUES (46472, 701, 133, 2448);
INSERT INTO 'devicecapvalue' VALUES (46473, 701, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (46474, 701, 116, 2345);
INSERT INTO 'devicecapvalue' VALUES (46475, 701, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (46476, 701, 149, 949);
INSERT INTO 'devicecapvalue' VALUES (46477, 701, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (46478, 701, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (46479, 701, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (46480, 701, 136, 2448);
INSERT INTO 'devicecapvalue' VALUES (46481, 701, 137, 2453);
INSERT INTO 'devicecapvalue' VALUES (46482, 701, 138, 2454);
INSERT INTO 'devicecapvalue' VALUES (46483, 701, 72, 2455);
INSERT INTO 'devicecapvalue' VALUES (46484, 701, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (46485, 701, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (46486, 701, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (46487, 701, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (46488, 701, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (46489, 701, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (46490, 701, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (46491, 701, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (46492, 701, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (46493, 701, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (46494, 701, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (46495, 701, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (46496, 701, 47, 123);
INSERT INTO 'devicecapvalue' VALUES (46497, 701, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (46498, 701, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (46499, 701, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (46500, 701, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (46501, 701, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (46502, 701, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (46503, 701, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (46504, 701, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (46505, 701, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (46506, 701, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (46507, 701, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (46508, 701, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (46509, 701, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (46510, 701, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (46511, 701, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (46512, 701, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (46513, 701, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (46514, 701, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (46515, 701, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (46516, 701, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (46517, 701, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (46518, 701, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (46519, 701, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (46520, 701, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (46521, 701, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (46522, 701, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (46523, 701, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (46524, 701, 48, 155);
INSERT INTO 'devicecapvalue' VALUES (46525, 701, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (46526, 701, 49, 659);
INSERT INTO 'devicecapvalue' VALUES (46527, 701, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (46528, 701, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (46529, 701, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (46530, 701, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (46531, 701, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (46532, 701, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (46533, 701, 53, 2456);
INSERT INTO 'devicecapvalue' VALUES (46534, 702, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (46535, 702, 160, 2238);
INSERT INTO 'capvalue' VALUES (2457, '16x');
INSERT INTO 'devicecapvalue' VALUES (46536, 702, 162, 2457);
INSERT INTO 'devicecapvalue' VALUES (46537, 702, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (46538, 702, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (46539, 702, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (46540, 702, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (46541, 702, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (46542, 702, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (46543, 702, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (46544, 702, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (46545, 702, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (46546, 702, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (46547, 702, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (46548, 702, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (46549, 702, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (46550, 702, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (46551, 702, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (46552, 702, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (46553, 702, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (46554, 702, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (46555, 702, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (46556, 702, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (46557, 702, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (46558, 702, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (46559, 702, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (46560, 702, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (46561, 702, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (46562, 702, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (46563, 702, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (46564, 702, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (46565, 702, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (46566, 702, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (46567, 702, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (46568, 702, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (46569, 702, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (46570, 702, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (46571, 702, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (46572, 702, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (46573, 702, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (46574, 702, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (46575, 702, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (46576, 702, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (46577, 702, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (46578, 702, 51, 2436);
INSERT INTO 'devicecapvalue' VALUES (46579, 702, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (46580, 702, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (46581, 702, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (46582, 702, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (46583, 702, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (46584, 702, 51, 1117);
INSERT INTO 'capvalue' VALUES (2458, 'realaudio8');
INSERT INTO 'devicecapvalue' VALUES (46585, 702, 51, 2458);
INSERT INTO 'devicecapvalue' VALUES (46586, 702, 51, 2424);
INSERT INTO 'devicecapvalue' VALUES (46587, 702, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (46588, 702, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (46589, 702, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (46590, 702, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (46591, 702, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (46592, 702, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (46593, 702, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (46594, 702, 157, 2437);
INSERT INTO 'devicecapvalue' VALUES (46595, 702, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (46596, 703, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (46597, 703, 74, 1519);
INSERT INTO 'capvalue' VALUES (2459, 'NoPermanentBacklight');
INSERT INTO 'devicecapvalue' VALUES (46598, 703, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (46599, 703, 74, 1520);
INSERT INTO 'capvalue' VALUES (2460, '3 MP');
INSERT INTO 'devicecapvalue' VALUES (46600, 703, 160, 2460);
INSERT INTO 'devicecapvalue' VALUES (46601, 703, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (46602, 703, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (46603, 703, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (46604, 703, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (46605, 703, 173, 1688);
INSERT INTO 'capvalue' VALUES (2461, 'SonyEricsson_K800');
INSERT INTO 'devicecapvalue' VALUES (46606, 703, 75, 2461);
INSERT INTO 'cap' VALUES (261, 'Emulator.Skin.2', 1);
INSERT INTO 'capvalue' VALUES (2462, 'SonyEricsson_K800i');
INSERT INTO 'devicecapvalue' VALUES (46607, 703, 261, 2462);
INSERT INTO 'devicecapvalue' VALUES (46608, 703, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (46609, 703, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (46610, 703, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (46611, 703, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (46612, 703, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (46613, 703, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (46614, 703, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (46615, 703, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (46616, 703, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (46617, 703, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (46618, 703, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (46619, 703, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (46620, 703, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (46621, 703, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (46622, 703, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (46623, 703, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (46624, 703, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (46625, 703, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (46626, 703, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (46627, 703, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (46628, 703, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (46629, 703, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (46630, 703, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (46631, 703, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (46632, 703, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (46633, 703, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (46634, 703, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (46635, 703, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (46636, 703, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (46637, 703, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (46638, 703, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (46639, 703, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (46640, 703, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (46641, 703, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (46642, 703, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (46643, 703, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (46644, 703, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (46645, 703, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (46646, 703, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (46647, 703, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (46648, 703, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (46649, 703, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (46650, 703, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (46651, 703, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (46652, 703, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (46653, 703, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (46654, 703, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (46655, 703, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (46656, 703, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (46657, 703, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (46658, 703, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (46659, 703, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (46660, 703, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (46661, 703, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (46662, 703, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (46663, 703, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (46664, 703, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (46665, 703, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (46666, 703, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (46667, 703, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (46668, 703, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (46669, 703, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (46670, 703, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (46671, 703, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (46672, 703, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (46673, 703, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (46674, 703, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (46675, 703, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (46676, 703, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (46677, 703, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (46678, 703, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (46679, 703, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (46680, 703, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (46681, 703, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (46682, 703, 191, 1372);
INSERT INTO 'capvalue' VALUES (2463, 'SonyEricssonK800iv/R1ED Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (46683, 703, 53, 2463);
INSERT INTO 'devicecapvalue' VALUES (46684, 704, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (46685, 704, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (46686, 704, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (46687, 704, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (46688, 704, 160, 2460);
INSERT INTO 'devicecapvalue' VALUES (46689, 704, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (46690, 704, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (46691, 704, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (46692, 704, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (46693, 704, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (46694, 704, 75, 2461);
INSERT INTO 'devicecapvalue' VALUES (46695, 704, 261, 2462);
INSERT INTO 'devicecapvalue' VALUES (46696, 704, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (46697, 704, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (46698, 704, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (46699, 704, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (46700, 704, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (46701, 704, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (46702, 704, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (46703, 704, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (46704, 704, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (46705, 704, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (46706, 704, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (46707, 704, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (46708, 704, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (46709, 704, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (46710, 704, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (46711, 704, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (46712, 704, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (46713, 704, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (46714, 704, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (46715, 704, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (46716, 704, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (46717, 704, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (46718, 704, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (46719, 704, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (46720, 704, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (46721, 704, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (46722, 704, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (46723, 704, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (46724, 704, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (46725, 704, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (46726, 704, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (46727, 704, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (46728, 704, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (46729, 704, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (46730, 704, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (46731, 704, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (46732, 704, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (46733, 704, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (46734, 704, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (46735, 704, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (46736, 704, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (46737, 704, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (46738, 704, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (46739, 704, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (46740, 704, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (46741, 704, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (46742, 704, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (46743, 704, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (46744, 704, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (46745, 704, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (46746, 704, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (46747, 704, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (46748, 704, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (46749, 704, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (46750, 704, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (46751, 704, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (46752, 704, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (46753, 704, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (46754, 704, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (46755, 704, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (46756, 704, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (46757, 704, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (46758, 704, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (46759, 704, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (46760, 704, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (46761, 704, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (46762, 704, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (46763, 704, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (46764, 704, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (46765, 704, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (46766, 704, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (46767, 704, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (46768, 704, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (46769, 704, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (46770, 704, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (46771, 704, 53, 2463);
INSERT INTO 'devicecapvalue' VALUES (46772, 705, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (46773, 705, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (46774, 705, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (46775, 705, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (46776, 705, 160, 2460);
INSERT INTO 'devicecapvalue' VALUES (46777, 705, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (46778, 705, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (46779, 705, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (46780, 705, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (46781, 705, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (46782, 705, 75, 2461);
INSERT INTO 'devicecapvalue' VALUES (46783, 705, 261, 2462);
INSERT INTO 'devicecapvalue' VALUES (46784, 705, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (46785, 705, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (46786, 705, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (46787, 705, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (46788, 705, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (46789, 705, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (46790, 705, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (46791, 705, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (46792, 705, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (46793, 705, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (46794, 705, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (46795, 705, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (46796, 705, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (46797, 705, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (46798, 705, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (46799, 705, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (46800, 705, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (46801, 705, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (46802, 705, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (46803, 705, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (46804, 705, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (46805, 705, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (46806, 705, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (46807, 705, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (46808, 705, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (46809, 705, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (46810, 705, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (46811, 705, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (46812, 705, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (46813, 705, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (46814, 705, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (46815, 705, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (46816, 705, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (46817, 705, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (46818, 705, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (46819, 705, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (46820, 705, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (46821, 705, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (46822, 705, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (46823, 705, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (46824, 705, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (46825, 705, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (46826, 705, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (46827, 705, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (46828, 705, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (46829, 705, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (46830, 705, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (46831, 705, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (46832, 705, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (46833, 705, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (46834, 705, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (46835, 705, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (46836, 705, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (46837, 705, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (46838, 705, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (46839, 705, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (46840, 705, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (46841, 705, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (46842, 705, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (46843, 705, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (46844, 705, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (46845, 705, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (46846, 705, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (46847, 705, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (46848, 705, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (46849, 705, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (46850, 705, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (46851, 705, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (46852, 705, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (46853, 705, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (46854, 705, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (46855, 705, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (46856, 705, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (46857, 705, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (46858, 705, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (46859, 705, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (46860, 705, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (46861, 705, 191, 1372);
INSERT INTO 'capvalue' VALUES (2464, 'SonyEricssonK810i/R1JC Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (46862, 705, 53, 2464);
INSERT INTO 'devicecapvalue' VALUES (46863, 706, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (46864, 706, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (46865, 706, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (46866, 706, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (46867, 706, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (46868, 706, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (46869, 706, 173, 2427);
INSERT INTO 'capvalue' VALUES (2465, 'SonyEricsson_K850');
INSERT INTO 'devicecapvalue' VALUES (46870, 706, 75, 2465);
INSERT INTO 'capvalue' VALUES (2466, 'SonyEricsson_K850i');
INSERT INTO 'devicecapvalue' VALUES (46871, 706, 261, 2466);
INSERT INTO 'devicecapvalue' VALUES (46872, 706, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (46873, 706, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (46874, 706, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (46875, 706, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (46876, 706, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (46877, 706, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (46878, 706, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (46879, 706, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (46880, 706, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (46881, 706, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (46882, 706, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (46883, 706, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (46884, 706, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (46885, 706, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (46886, 706, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (46887, 706, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (46888, 706, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (46889, 706, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (46890, 706, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (46891, 706, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (46892, 706, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (46893, 706, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (46894, 706, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (46895, 706, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (46896, 706, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (46897, 706, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (46898, 706, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (46899, 706, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (46900, 706, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (46901, 706, 17, 2007);
INSERT INTO 'devicecapvalue' VALUES (46902, 706, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (46903, 706, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (46904, 706, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (46905, 706, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (46906, 706, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (46907, 706, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (46908, 706, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (46909, 706, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (46910, 706, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (46911, 706, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (46912, 706, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (46913, 706, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (46914, 706, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (46915, 706, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (46916, 706, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (46917, 706, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (46918, 706, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (46919, 706, 5, 601);
INSERT INTO 'cap' VALUES (262, 'softkey-vibrate', 1);
INSERT INTO 'devicecapvalue' VALUES (46920, 706, 262, 15);
INSERT INTO 'devicecapvalue' VALUES (46921, 706, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (46922, 706, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (46923, 706, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (46924, 706, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (46925, 706, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (46926, 706, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (46927, 706, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (46928, 706, 52, 593);
INSERT INTO 'devicecapvalue' VALUES (46929, 706, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (46930, 706, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (46931, 706, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (46932, 706, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (46933, 706, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (46934, 706, 191, 1372);
INSERT INTO 'capvalue' VALUES (2467, 'SonyEricssonK850i/R1BA Browser/NetFront/3.4 Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (46935, 706, 53, 2467);
INSERT INTO 'devicecapvalue' VALUES (46936, 707, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (46937, 707, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (46938, 707, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (46939, 707, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (46940, 707, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (46941, 707, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (46942, 707, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (46943, 707, 75, 2465);
INSERT INTO 'devicecapvalue' VALUES (46944, 707, 261, 2466);
INSERT INTO 'devicecapvalue' VALUES (46945, 707, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (46946, 707, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (46947, 707, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (46948, 707, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (46949, 707, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (46950, 707, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (46951, 707, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (46952, 707, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (46953, 707, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (46954, 707, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (46955, 707, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (46956, 707, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (46957, 707, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (46958, 707, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (46959, 707, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (46960, 707, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (46961, 707, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (46962, 707, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (46963, 707, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (46964, 707, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (46965, 707, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (46966, 707, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (46967, 707, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (46968, 707, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (46969, 707, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (46970, 707, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (46971, 707, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (46972, 707, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (46973, 707, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (46974, 707, 17, 2007);
INSERT INTO 'devicecapvalue' VALUES (46975, 707, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (46976, 707, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (46977, 707, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (46978, 707, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (46979, 707, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (46980, 707, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (46981, 707, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (46982, 707, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (46983, 707, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (46984, 707, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (46985, 707, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (46986, 707, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (46987, 707, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (46988, 707, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (46989, 707, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (46990, 707, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (46991, 707, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (46992, 707, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (46993, 707, 262, 15);
INSERT INTO 'devicecapvalue' VALUES (46994, 707, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (46995, 707, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (46996, 707, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (46997, 707, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (46998, 707, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (46999, 707, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (47000, 707, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (47001, 707, 52, 593);
INSERT INTO 'devicecapvalue' VALUES (47002, 707, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47003, 707, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (47004, 707, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (47005, 707, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (47006, 707, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (47007, 707, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (47008, 707, 53, 2467);
INSERT INTO 'devicecapvalue' VALUES (47009, 708, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (47010, 708, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (47011, 708, 74, 1520);
INSERT INTO 'capvalue' VALUES (2468, 'fullScreenInPaint');
INSERT INTO 'devicecapvalue' VALUES (47012, 708, 74, 2468);
INSERT INTO 'devicecapvalue' VALUES (47013, 708, 7, 688);
INSERT INTO 'cap' VALUES (263, 'ClosedFlipScreenSize', 1);
INSERT INTO 'devicecapvalue' VALUES (47014, 708, 263, 688);
INSERT INTO 'devicecapvalue' VALUES (47015, 708, 173, 2289);
INSERT INTO 'capvalue' VALUES (2469, 'SonyEricsson_M600');
INSERT INTO 'devicecapvalue' VALUES (47016, 708, 75, 2469);
INSERT INTO 'devicecapvalue' VALUES (47017, 708, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47018, 708, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47019, 708, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (47020, 708, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (47021, 708, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47022, 708, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (47023, 708, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (47024, 708, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (47025, 708, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (47026, 708, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (47027, 708, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (47028, 708, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (47029, 708, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (47030, 708, 76, 1005);
INSERT INTO 'devicecapvalue' VALUES (47031, 708, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (47032, 708, 15, 17);
INSERT INTO 'capvalue' VALUES (2470, 'gifa');
INSERT INTO 'devicecapvalue' VALUES (47033, 708, 15, 2470);
INSERT INTO 'devicecapvalue' VALUES (47034, 708, 15, 18);
INSERT INTO 'capvalue' VALUES (2471, 'mbm');
INSERT INTO 'devicecapvalue' VALUES (47035, 708, 15, 2471);
INSERT INTO 'devicecapvalue' VALUES (47036, 708, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (47037, 708, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (47038, 708, 16, 1857);
INSERT INTO 'devicecapvalue' VALUES (47039, 708, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (47040, 708, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47041, 708, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (47042, 708, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47043, 708, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (47044, 708, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (47045, 708, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (47046, 708, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47047, 708, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47048, 708, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47049, 708, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (47050, 708, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (47051, 708, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (47052, 708, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (47053, 708, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (47054, 708, 26, 40);
INSERT INTO 'devicecapvalue' VALUES (47055, 708, 30, 36);
INSERT INTO 'devicecapvalue' VALUES (47056, 708, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (47057, 708, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (47058, 708, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (47059, 708, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (47060, 708, 3, 1334);
INSERT INTO 'devicecapvalue' VALUES (47061, 708, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (47062, 708, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (47063, 708, 51, 1036);
INSERT INTO 'capvalue' VALUES (2472, 'aac-lc');
INSERT INTO 'devicecapvalue' VALUES (47064, 708, 51, 2472);
INSERT INTO 'devicecapvalue' VALUES (47065, 708, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (47066, 708, 51, 880);
INSERT INTO 'devicecapvalue' VALUES (47067, 708, 51, 1266);
INSERT INTO 'capvalue' VALUES (2473, 'dls');
INSERT INTO 'devicecapvalue' VALUES (47068, 708, 51, 2473);
INSERT INTO 'devicecapvalue' VALUES (47069, 708, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (47070, 708, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (47071, 708, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (47072, 708, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (47073, 708, 51, 1160);
INSERT INTO 'cap' VALUES (264, 'usePolishTitle', 1);
INSERT INTO 'devicecapvalue' VALUES (47074, 708, 264, 15);
INSERT INTO 'devicecapvalue' VALUES (47075, 708, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47076, 708, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (47077, 708, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (47078, 709, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (47079, 709, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (47080, 709, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (47081, 709, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (47082, 709, 160, 2460);
INSERT INTO 'devicecapvalue' VALUES (47083, 709, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (47084, 709, 7, 14);
INSERT INTO 'devicecapvalue' VALUES (47085, 709, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (47086, 709, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (47087, 709, 173, 1688);
INSERT INTO 'capvalue' VALUES (2474, 'SonyEricsson_JP7_240x320');
INSERT INTO 'devicecapvalue' VALUES (47088, 709, 75, 2474);
INSERT INTO 'devicecapvalue' VALUES (47089, 709, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (47090, 709, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47091, 709, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47092, 709, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47093, 709, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (47094, 709, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (47095, 709, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (47096, 709, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (47097, 709, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (47098, 709, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (47099, 709, 13, 14);
INSERT INTO 'devicecapvalue' VALUES (47100, 709, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (47101, 709, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (47102, 709, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (47103, 709, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (47104, 709, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (47105, 709, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (47106, 709, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (47107, 709, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (47108, 709, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (47109, 709, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47110, 709, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (47111, 709, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (47112, 709, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47113, 709, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (47114, 709, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (47115, 709, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (47116, 709, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47117, 709, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47118, 709, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47119, 709, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (47120, 709, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (47121, 709, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (47122, 709, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (47123, 709, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (47124, 709, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (47125, 709, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (47126, 709, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (47127, 709, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (47128, 709, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (47129, 709, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (47130, 709, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (47131, 709, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (47132, 709, 5, 5);
INSERT INTO 'capvalue' VALUES (2475, 'ATRAC');
INSERT INTO 'devicecapvalue' VALUES (47133, 709, 51, 2475);
INSERT INTO 'devicecapvalue' VALUES (47134, 709, 51, 1039);
INSERT INTO 'capvalue' VALUES (2476, 'WMA ');
INSERT INTO 'devicecapvalue' VALUES (47135, 709, 51, 2476);
INSERT INTO 'devicecapvalue' VALUES (47136, 709, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (47137, 709, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (47138, 709, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (47139, 710, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (47140, 710, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (47141, 710, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47142, 710, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (47143, 710, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47144, 710, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (47145, 710, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (47146, 710, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (47147, 710, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47148, 710, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47149, 710, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (47150, 710, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (47151, 710, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (47152, 711, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (47153, 711, 74, 654);
INSERT INTO 'capvalue' VALUES (2477, 'OMA DRM 1.0');
INSERT INTO 'devicecapvalue' VALUES (47154, 711, 173, 2477);
INSERT INTO 'devicecapvalue' VALUES (47155, 711, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (47156, 711, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47157, 711, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47158, 711, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (47159, 711, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47160, 711, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (47161, 711, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (47162, 711, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (47163, 711, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (47164, 711, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (47165, 711, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (47166, 711, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (47167, 711, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (47168, 711, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (47169, 711, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (47170, 711, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (47171, 711, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (47172, 711, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (47173, 711, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (47174, 711, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (47175, 711, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47176, 711, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (47177, 711, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47178, 711, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (47179, 711, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (47180, 711, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (47181, 711, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47182, 711, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47183, 711, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47184, 711, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (47185, 711, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (47186, 711, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (47187, 711, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (47188, 711, 41, 2385);
INSERT INTO 'devicecapvalue' VALUES (47189, 711, 41, 964);
INSERT INTO 'devicecapvalue' VALUES (47190, 711, 41, 2215);
INSERT INTO 'devicecapvalue' VALUES (47191, 711, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (47192, 711, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (47193, 711, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (47194, 711, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (47195, 711, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (47196, 711, 41, 2386);
INSERT INTO 'devicecapvalue' VALUES (47197, 711, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (47198, 711, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (47199, 711, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (47200, 711, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (47201, 711, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (47202, 711, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (47203, 711, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (47204, 711, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (47205, 711, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (47206, 711, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (47207, 711, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (47208, 711, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (47209, 711, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (47210, 711, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (47211, 711, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (47212, 711, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (47213, 711, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (47214, 711, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (47215, 711, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (47216, 711, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (47217, 711, 41, 128);
INSERT INTO 'devicecapvalue' VALUES (47218, 711, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (47219, 711, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (47220, 711, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (47221, 711, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (47222, 711, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (47223, 711, 41, 2387);
INSERT INTO 'devicecapvalue' VALUES (47224, 711, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (47225, 711, 41, 2216);
INSERT INTO 'devicecapvalue' VALUES (47226, 711, 41, 2388);
INSERT INTO 'devicecapvalue' VALUES (47227, 711, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (47228, 711, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (47229, 711, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (47230, 711, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (47231, 711, 41, 2213);
INSERT INTO 'devicecapvalue' VALUES (47232, 711, 41, 2214);
INSERT INTO 'devicecapvalue' VALUES (47233, 711, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (47234, 711, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (47235, 711, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (47236, 711, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (47237, 711, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (47238, 711, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (47239, 711, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (47240, 711, 42, 2385);
INSERT INTO 'devicecapvalue' VALUES (47241, 711, 42, 964);
INSERT INTO 'devicecapvalue' VALUES (47242, 711, 42, 2215);
INSERT INTO 'devicecapvalue' VALUES (47243, 711, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (47244, 711, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (47245, 711, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (47246, 711, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (47247, 711, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (47248, 711, 42, 2386);
INSERT INTO 'devicecapvalue' VALUES (47249, 711, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (47250, 711, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (47251, 711, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (47252, 711, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (47253, 711, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (47254, 711, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (47255, 711, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (47256, 711, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (47257, 711, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (47258, 711, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (47259, 711, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (47260, 711, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (47261, 711, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (47262, 711, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (47263, 711, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (47264, 711, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (47265, 711, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (47266, 711, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (47267, 711, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (47268, 711, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (47269, 711, 42, 128);
INSERT INTO 'devicecapvalue' VALUES (47270, 711, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (47271, 711, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (47272, 711, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (47273, 711, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (47274, 711, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (47275, 711, 42, 2387);
INSERT INTO 'devicecapvalue' VALUES (47276, 711, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (47277, 711, 42, 2216);
INSERT INTO 'devicecapvalue' VALUES (47278, 711, 42, 2388);
INSERT INTO 'devicecapvalue' VALUES (47279, 711, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (47280, 711, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (47281, 711, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (47282, 711, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (47283, 711, 42, 2213);
INSERT INTO 'devicecapvalue' VALUES (47284, 711, 42, 2214);
INSERT INTO 'devicecapvalue' VALUES (47285, 711, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (47286, 711, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (47287, 711, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (47288, 711, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (47289, 711, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (47290, 711, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (47291, 711, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (47292, 711, 3, 1334);
INSERT INTO 'capvalue' VALUES (2478, 'er');
INSERT INTO 'devicecapvalue' VALUES (47293, 711, 212, 2478);
INSERT INTO 'capvalue' VALUES (2479, 'tyz');
INSERT INTO 'devicecapvalue' VALUES (47294, 711, 213, 2479);
INSERT INTO 'capvalue' VALUES (2480, 'ui');
INSERT INTO 'devicecapvalue' VALUES (47295, 711, 214, 2480);
INSERT INTO 'capvalue' VALUES (2481, 'df');
INSERT INTO 'devicecapvalue' VALUES (47296, 711, 215, 2481);
INSERT INTO 'capvalue' VALUES (2482, 'gh');
INSERT INTO 'devicecapvalue' VALUES (47297, 711, 216, 2482);
INSERT INTO 'capvalue' VALUES (2483, 'jk');
INSERT INTO 'devicecapvalue' VALUES (47298, 711, 217, 2483);
INSERT INTO 'capvalue' VALUES (2484, 'xc');
INSERT INTO 'devicecapvalue' VALUES (47299, 711, 218, 2484);
INSERT INTO 'capvalue' VALUES (2485, 'vb');
INSERT INTO 'devicecapvalue' VALUES (47300, 711, 219, 2485);
INSERT INTO 'capvalue' VALUES (2486, 'nm');
INSERT INTO 'devicecapvalue' VALUES (47301, 711, 220, 2486);
INSERT INTO 'devicecapvalue' VALUES (47302, 711, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (47303, 711, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (47304, 711, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (47305, 711, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (47306, 711, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (47307, 711, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (47308, 711, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (47309, 711, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (47310, 711, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (47311, 711, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (47312, 711, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (47313, 711, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (47314, 711, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (47315, 711, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (47316, 711, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (47317, 711, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (47318, 711, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (47319, 711, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (47320, 711, 52, 593);
INSERT INTO 'devicecapvalue' VALUES (47321, 711, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47322, 711, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (47323, 711, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (47324, 711, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (47325, 711, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (47326, 711, 157, 2426);
INSERT INTO 'capvalue' VALUES (2487, 'SonyEricssonP1i/R100 Mozilla/4.0 (compatible; MSIE 6.0; Symbian OS; 598) Opera 8.65 [de] UP.Link/6.3.0.0.0');
INSERT INTO 'devicecapvalue' VALUES (47327, 711, 53, 2487);
INSERT INTO 'devicecapvalue' VALUES (47328, 712, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (47329, 712, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (47330, 712, 173, 2477);
INSERT INTO 'devicecapvalue' VALUES (47331, 712, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (47332, 712, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47333, 712, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47334, 712, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (47335, 712, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47336, 712, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (47337, 712, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (47338, 712, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (47339, 712, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (47340, 712, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (47341, 712, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (47342, 712, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (47343, 712, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (47344, 712, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (47345, 712, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (47346, 712, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (47347, 712, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (47348, 712, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (47349, 712, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (47350, 712, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (47351, 712, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47352, 712, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (47353, 712, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47354, 712, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (47355, 712, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (47356, 712, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (47357, 712, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47358, 712, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47359, 712, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47360, 712, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (47361, 712, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (47362, 712, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (47363, 712, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (47364, 712, 41, 2385);
INSERT INTO 'devicecapvalue' VALUES (47365, 712, 41, 964);
INSERT INTO 'devicecapvalue' VALUES (47366, 712, 41, 2215);
INSERT INTO 'devicecapvalue' VALUES (47367, 712, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (47368, 712, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (47369, 712, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (47370, 712, 41, 1045);
INSERT INTO 'devicecapvalue' VALUES (47371, 712, 41, 616);
INSERT INTO 'devicecapvalue' VALUES (47372, 712, 41, 2386);
INSERT INTO 'devicecapvalue' VALUES (47373, 712, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (47374, 712, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (47375, 712, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (47376, 712, 41, 125);
INSERT INTO 'devicecapvalue' VALUES (47377, 712, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (47378, 712, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (47379, 712, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (47380, 712, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (47381, 712, 41, 869);
INSERT INTO 'devicecapvalue' VALUES (47382, 712, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (47383, 712, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (47384, 712, 41, 1579);
INSERT INTO 'devicecapvalue' VALUES (47385, 712, 41, 2076);
INSERT INTO 'devicecapvalue' VALUES (47386, 712, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (47387, 712, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (47388, 712, 41, 127);
INSERT INTO 'devicecapvalue' VALUES (47389, 712, 41, 1049);
INSERT INTO 'devicecapvalue' VALUES (47390, 712, 41, 1050);
INSERT INTO 'devicecapvalue' VALUES (47391, 712, 41, 1578);
INSERT INTO 'devicecapvalue' VALUES (47392, 712, 41, 1580);
INSERT INTO 'devicecapvalue' VALUES (47393, 712, 41, 128);
INSERT INTO 'devicecapvalue' VALUES (47394, 712, 41, 131);
INSERT INTO 'devicecapvalue' VALUES (47395, 712, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (47396, 712, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (47397, 712, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (47398, 712, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (47399, 712, 41, 2387);
INSERT INTO 'devicecapvalue' VALUES (47400, 712, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (47401, 712, 41, 2216);
INSERT INTO 'devicecapvalue' VALUES (47402, 712, 41, 2388);
INSERT INTO 'devicecapvalue' VALUES (47403, 712, 41, 1581);
INSERT INTO 'devicecapvalue' VALUES (47404, 712, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (47405, 712, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (47406, 712, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (47407, 712, 41, 2213);
INSERT INTO 'devicecapvalue' VALUES (47408, 712, 41, 2214);
INSERT INTO 'devicecapvalue' VALUES (47409, 712, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (47410, 712, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (47411, 712, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (47412, 712, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (47413, 712, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (47414, 712, 41, 620);
INSERT INTO 'devicecapvalue' VALUES (47415, 712, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (47416, 712, 42, 2385);
INSERT INTO 'devicecapvalue' VALUES (47417, 712, 42, 964);
INSERT INTO 'devicecapvalue' VALUES (47418, 712, 42, 2215);
INSERT INTO 'devicecapvalue' VALUES (47419, 712, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (47420, 712, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (47421, 712, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (47422, 712, 42, 1045);
INSERT INTO 'devicecapvalue' VALUES (47423, 712, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (47424, 712, 42, 2386);
INSERT INTO 'devicecapvalue' VALUES (47425, 712, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (47426, 712, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (47427, 712, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (47428, 712, 42, 125);
INSERT INTO 'devicecapvalue' VALUES (47429, 712, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (47430, 712, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (47431, 712, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (47432, 712, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (47433, 712, 42, 869);
INSERT INTO 'devicecapvalue' VALUES (47434, 712, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (47435, 712, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (47436, 712, 42, 1579);
INSERT INTO 'devicecapvalue' VALUES (47437, 712, 42, 2076);
INSERT INTO 'devicecapvalue' VALUES (47438, 712, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (47439, 712, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (47440, 712, 42, 127);
INSERT INTO 'devicecapvalue' VALUES (47441, 712, 42, 1049);
INSERT INTO 'devicecapvalue' VALUES (47442, 712, 42, 1050);
INSERT INTO 'devicecapvalue' VALUES (47443, 712, 42, 1578);
INSERT INTO 'devicecapvalue' VALUES (47444, 712, 42, 1580);
INSERT INTO 'devicecapvalue' VALUES (47445, 712, 42, 128);
INSERT INTO 'devicecapvalue' VALUES (47446, 712, 42, 131);
INSERT INTO 'devicecapvalue' VALUES (47447, 712, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (47448, 712, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (47449, 712, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (47450, 712, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (47451, 712, 42, 2387);
INSERT INTO 'devicecapvalue' VALUES (47452, 712, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (47453, 712, 42, 2216);
INSERT INTO 'devicecapvalue' VALUES (47454, 712, 42, 2388);
INSERT INTO 'devicecapvalue' VALUES (47455, 712, 42, 1581);
INSERT INTO 'devicecapvalue' VALUES (47456, 712, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (47457, 712, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (47458, 712, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (47459, 712, 42, 2213);
INSERT INTO 'devicecapvalue' VALUES (47460, 712, 42, 2214);
INSERT INTO 'devicecapvalue' VALUES (47461, 712, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (47462, 712, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (47463, 712, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (47464, 712, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (47465, 712, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (47466, 712, 42, 620);
INSERT INTO 'devicecapvalue' VALUES (47467, 712, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (47468, 712, 3, 1334);
INSERT INTO 'devicecapvalue' VALUES (47469, 712, 212, 2478);
INSERT INTO 'devicecapvalue' VALUES (47470, 712, 213, 2479);
INSERT INTO 'devicecapvalue' VALUES (47471, 712, 214, 2480);
INSERT INTO 'devicecapvalue' VALUES (47472, 712, 215, 2481);
INSERT INTO 'devicecapvalue' VALUES (47473, 712, 216, 2482);
INSERT INTO 'devicecapvalue' VALUES (47474, 712, 217, 2483);
INSERT INTO 'devicecapvalue' VALUES (47475, 712, 218, 2484);
INSERT INTO 'devicecapvalue' VALUES (47476, 712, 219, 2485);
INSERT INTO 'devicecapvalue' VALUES (47477, 712, 220, 2486);
INSERT INTO 'devicecapvalue' VALUES (47478, 712, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (47479, 712, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (47480, 712, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (47481, 712, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (47482, 712, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (47483, 712, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (47484, 712, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (47485, 712, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (47486, 712, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (47487, 712, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (47488, 712, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (47489, 712, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (47490, 712, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (47491, 712, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (47492, 712, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (47493, 712, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (47494, 712, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (47495, 712, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (47496, 712, 52, 593);
INSERT INTO 'devicecapvalue' VALUES (47497, 712, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47498, 712, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (47499, 712, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (47500, 712, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (47501, 712, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (47502, 712, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (47503, 712, 53, 2487);
INSERT INTO 'devicecapvalue' VALUES (47504, 713, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (47505, 713, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (47506, 713, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (47507, 713, 74, 2468);
INSERT INTO 'devicecapvalue' VALUES (47508, 713, 160, 856);
INSERT INTO 'capvalue' VALUES (2488, '208x253');
INSERT INTO 'devicecapvalue' VALUES (47509, 713, 7, 2488);
INSERT INTO 'devicecapvalue' VALUES (47510, 713, 173, 2289);
INSERT INTO 'capvalue' VALUES (2489, 'SonyEricsson_P900');
INSERT INTO 'devicecapvalue' VALUES (47511, 713, 75, 2489);
INSERT INTO 'devicecapvalue' VALUES (47512, 713, 167, 1548);
INSERT INTO 'devicecapvalue' VALUES (47513, 713, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47514, 713, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47515, 713, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (47516, 713, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (47517, 713, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47518, 713, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (47519, 713, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (47520, 713, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (47521, 713, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (47522, 713, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (47523, 713, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (47524, 713, 76, 1005);
INSERT INTO 'devicecapvalue' VALUES (47525, 713, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (47526, 713, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47527, 713, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47528, 713, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47529, 713, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47530, 713, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47531, 713, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (47532, 713, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (47533, 713, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (47534, 713, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (47535, 713, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (47536, 713, 26, 40);
INSERT INTO 'devicecapvalue' VALUES (47537, 713, 30, 36);
INSERT INTO 'devicecapvalue' VALUES (47538, 713, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (47539, 713, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (47540, 713, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (47541, 713, 3, 1174);
INSERT INTO 'devicecapvalue' VALUES (47542, 713, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (47543, 713, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (47544, 713, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (47545, 713, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (47546, 713, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (47547, 713, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (47548, 713, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (47549, 713, 51, 1039);
INSERT INTO 'capvalue' VALUES (2490, 'rmf');
INSERT INTO 'devicecapvalue' VALUES (47550, 713, 51, 2490);
INSERT INTO 'devicecapvalue' VALUES (47551, 713, 264, 15);
INSERT INTO 'devicecapvalue' VALUES (47552, 713, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47553, 713, 157, 1026);
INSERT INTO 'capvalue' VALUES (2491, 'Mozilla/4.0 (compatible; MSIE 5.0; Symbian OS; SonyEricsson P900; 316) Opera 6.31 [sv]');
INSERT INTO 'devicecapvalue' VALUES (47554, 713, 53, 2491);
INSERT INTO 'devicecapvalue' VALUES (47555, 714, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (47556, 714, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (47557, 714, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (47558, 714, 74, 2468);
INSERT INTO 'devicecapvalue' VALUES (47559, 714, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (47560, 714, 7, 2488);
INSERT INTO 'devicecapvalue' VALUES (47561, 714, 173, 2289);
INSERT INTO 'devicecapvalue' VALUES (47562, 714, 75, 2489);
INSERT INTO 'devicecapvalue' VALUES (47563, 714, 167, 1548);
INSERT INTO 'devicecapvalue' VALUES (47564, 714, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47565, 714, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47566, 714, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (47567, 714, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (47568, 714, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47569, 714, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (47570, 714, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (47571, 714, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (47572, 714, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (47573, 714, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (47574, 714, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (47575, 714, 76, 1005);
INSERT INTO 'devicecapvalue' VALUES (47576, 714, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (47577, 714, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47578, 714, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47579, 714, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47580, 714, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47581, 714, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47582, 714, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (47583, 714, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (47584, 714, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (47585, 714, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (47586, 714, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (47587, 714, 26, 40);
INSERT INTO 'devicecapvalue' VALUES (47588, 714, 30, 36);
INSERT INTO 'devicecapvalue' VALUES (47589, 714, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (47590, 714, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (47591, 714, 88, 1534);
INSERT INTO 'devicecapvalue' VALUES (47592, 714, 3, 1174);
INSERT INTO 'devicecapvalue' VALUES (47593, 714, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (47594, 714, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (47595, 714, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (47596, 714, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (47597, 714, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (47598, 714, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (47599, 714, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (47600, 714, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (47601, 714, 51, 2490);
INSERT INTO 'devicecapvalue' VALUES (47602, 714, 264, 15);
INSERT INTO 'devicecapvalue' VALUES (47603, 714, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47604, 714, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (47605, 714, 53, 2491);
INSERT INTO 'devicecapvalue' VALUES (47606, 715, 1, 106);
INSERT INTO 'capvalue' VALUES (2492, 'DisplayGetColor');
INSERT INTO 'devicecapvalue' VALUES (47607, 715, 74, 2492);
INSERT INTO 'capvalue' VALUES (2493, 'NoSpriteRotation');
INSERT INTO 'devicecapvalue' VALUES (47608, 715, 74, 2493);
INSERT INTO 'devicecapvalue' VALUES (47609, 715, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (47610, 715, 74, 2468);
INSERT INTO 'devicecapvalue' VALUES (47611, 715, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (47612, 715, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (47613, 715, 173, 1313);
INSERT INTO 'capvalue' VALUES (2494, 'SonyEricsson_P910');
INSERT INTO 'devicecapvalue' VALUES (47614, 715, 75, 2494);
INSERT INTO 'devicecapvalue' VALUES (47615, 715, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47616, 715, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47617, 715, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (47618, 715, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47619, 715, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (47620, 715, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (47621, 715, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (47622, 715, 13, 1012);
INSERT INTO 'devicecapvalue' VALUES (47623, 715, 76, 1226);
INSERT INTO 'devicecapvalue' VALUES (47624, 715, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (47625, 715, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47626, 715, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47627, 715, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47628, 715, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47629, 715, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47630, 715, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (47631, 715, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (47632, 715, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (47633, 715, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (47634, 715, 51, 1355);
INSERT INTO 'devicecapvalue' VALUES (47635, 715, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (47636, 715, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (47637, 715, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (47638, 715, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (47639, 715, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (47640, 715, 51, 2490);
INSERT INTO 'devicecapvalue' VALUES (47641, 715, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (47642, 715, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47643, 715, 157, 1026);
INSERT INTO 'capvalue' VALUES (2495, 'SonyEricssonP910a/R4A SEMC-Browser/Symbian/3.0 Profile/MIDP-2.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (47644, 715, 53, 2495);
INSERT INTO 'devicecapvalue' VALUES (47645, 716, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (47646, 716, 74, 2492);
INSERT INTO 'devicecapvalue' VALUES (47647, 716, 74, 2493);
INSERT INTO 'devicecapvalue' VALUES (47648, 716, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (47649, 716, 74, 2468);
INSERT INTO 'devicecapvalue' VALUES (47650, 716, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (47651, 716, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (47652, 716, 173, 1313);
INSERT INTO 'devicecapvalue' VALUES (47653, 716, 75, 2494);
INSERT INTO 'devicecapvalue' VALUES (47654, 716, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47655, 716, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47656, 716, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (47657, 716, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47658, 716, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (47659, 716, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (47660, 716, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (47661, 716, 13, 1012);
INSERT INTO 'devicecapvalue' VALUES (47662, 716, 76, 1226);
INSERT INTO 'devicecapvalue' VALUES (47663, 716, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (47664, 716, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47665, 716, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47666, 716, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47667, 716, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47668, 716, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47669, 716, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (47670, 716, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (47671, 716, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (47672, 716, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (47673, 716, 51, 1355);
INSERT INTO 'devicecapvalue' VALUES (47674, 716, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (47675, 716, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (47676, 716, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (47677, 716, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (47678, 716, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (47679, 716, 51, 2490);
INSERT INTO 'devicecapvalue' VALUES (47680, 716, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (47681, 716, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47682, 716, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (47683, 716, 53, 2495);
INSERT INTO 'devicecapvalue' VALUES (47684, 717, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (47685, 717, 74, 2492);
INSERT INTO 'devicecapvalue' VALUES (47686, 717, 74, 2493);
INSERT INTO 'devicecapvalue' VALUES (47687, 717, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (47688, 717, 74, 2468);
INSERT INTO 'devicecapvalue' VALUES (47689, 717, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (47690, 717, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (47691, 717, 173, 1313);
INSERT INTO 'devicecapvalue' VALUES (47692, 717, 75, 2494);
INSERT INTO 'devicecapvalue' VALUES (47693, 717, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47694, 717, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47695, 717, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (47696, 717, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47697, 717, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (47698, 717, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (47699, 717, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (47700, 717, 13, 1012);
INSERT INTO 'devicecapvalue' VALUES (47701, 717, 76, 1226);
INSERT INTO 'devicecapvalue' VALUES (47702, 717, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (47703, 717, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47704, 717, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47705, 717, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47706, 717, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47707, 717, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47708, 717, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (47709, 717, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (47710, 717, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (47711, 717, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (47712, 717, 51, 1355);
INSERT INTO 'devicecapvalue' VALUES (47713, 717, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (47714, 717, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (47715, 717, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (47716, 717, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (47717, 717, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (47718, 717, 51, 2490);
INSERT INTO 'devicecapvalue' VALUES (47719, 717, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (47720, 717, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47721, 717, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (47722, 717, 53, 2495);
INSERT INTO 'devicecapvalue' VALUES (47723, 718, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (47724, 718, 74, 2492);
INSERT INTO 'devicecapvalue' VALUES (47725, 718, 74, 2493);
INSERT INTO 'devicecapvalue' VALUES (47726, 718, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (47727, 718, 74, 2468);
INSERT INTO 'devicecapvalue' VALUES (47728, 718, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (47729, 718, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (47730, 718, 173, 1313);
INSERT INTO 'devicecapvalue' VALUES (47731, 718, 75, 2494);
INSERT INTO 'devicecapvalue' VALUES (47732, 718, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47733, 718, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47734, 718, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (47735, 718, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47736, 718, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (47737, 718, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (47738, 718, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (47739, 718, 13, 1012);
INSERT INTO 'devicecapvalue' VALUES (47740, 718, 76, 1226);
INSERT INTO 'devicecapvalue' VALUES (47741, 718, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (47742, 718, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47743, 718, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47744, 718, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47745, 718, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47746, 718, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47747, 718, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (47748, 718, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (47749, 718, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (47750, 718, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (47751, 718, 51, 1355);
INSERT INTO 'devicecapvalue' VALUES (47752, 718, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (47753, 718, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (47754, 718, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (47755, 718, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (47756, 718, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (47757, 718, 51, 2490);
INSERT INTO 'devicecapvalue' VALUES (47758, 718, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (47759, 718, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47760, 718, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (47761, 718, 53, 2495);
INSERT INTO 'devicecapvalue' VALUES (47762, 719, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (47763, 719, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (47764, 719, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (47765, 719, 74, 2468);
INSERT INTO 'devicecapvalue' VALUES (47766, 719, 7, 688);
INSERT INTO 'devicecapvalue' VALUES (47767, 719, 263, 688);
INSERT INTO 'devicecapvalue' VALUES (47768, 719, 173, 2289);
INSERT INTO 'devicecapvalue' VALUES (47769, 719, 75, 2489);
INSERT INTO 'devicecapvalue' VALUES (47770, 719, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47771, 719, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47772, 719, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (47773, 719, 2, 1384);
INSERT INTO 'devicecapvalue' VALUES (47774, 719, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47775, 719, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (47776, 719, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (47777, 719, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (47778, 719, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (47779, 719, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (47780, 719, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (47781, 719, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (47782, 719, 76, 1005);
INSERT INTO 'devicecapvalue' VALUES (47783, 719, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (47784, 719, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (47785, 719, 15, 2470);
INSERT INTO 'devicecapvalue' VALUES (47786, 719, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (47787, 719, 15, 2471);
INSERT INTO 'devicecapvalue' VALUES (47788, 719, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (47789, 719, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (47790, 719, 16, 1857);
INSERT INTO 'devicecapvalue' VALUES (47791, 719, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (47792, 719, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47793, 719, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (47794, 719, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47795, 719, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (47796, 719, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (47797, 719, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (47798, 719, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47799, 719, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47800, 719, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47801, 719, 154, 1221);
INSERT INTO 'devicecapvalue' VALUES (47802, 719, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (47803, 719, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (47804, 719, 154, 1017);
INSERT INTO 'devicecapvalue' VALUES (47805, 719, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (47806, 719, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (47807, 719, 30, 40);
INSERT INTO 'cap' VALUES (265, 'MoSyncBugs', 1);
INSERT INTO 'devicecapvalue' VALUES (47808, 719, 265, 1058);
INSERT INTO 'devicecapvalue' VALUES (47809, 719, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (47810, 719, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (47811, 719, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (47812, 719, 3, 1334);
INSERT INTO 'devicecapvalue' VALUES (47813, 719, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (47814, 719, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (47815, 719, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (47816, 719, 51, 1876);
INSERT INTO 'devicecapvalue' VALUES (47817, 719, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (47818, 719, 51, 1355);
INSERT INTO 'devicecapvalue' VALUES (47819, 719, 51, 2473);
INSERT INTO 'devicecapvalue' VALUES (47820, 719, 51, 1706);
INSERT INTO 'devicecapvalue' VALUES (47821, 719, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (47822, 719, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (47823, 719, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (47824, 719, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (47825, 719, 51, 2490);
INSERT INTO 'devicecapvalue' VALUES (47826, 719, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (47827, 719, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (47828, 719, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (47829, 719, 264, 15);
INSERT INTO 'devicecapvalue' VALUES (47830, 719, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47831, 719, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (47832, 719, 157, 1504);
INSERT INTO 'capvalue' VALUES (2496, 'SonyEricssonP990i');
INSERT INTO 'devicecapvalue' VALUES (47833, 719, 53, 2496);
INSERT INTO 'devicecapvalue' VALUES (47834, 720, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (47835, 720, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (47836, 720, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (47837, 720, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47838, 720, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47839, 720, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47840, 720, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (47841, 720, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (47842, 720, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (47843, 720, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (47844, 720, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (47845, 720, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (47846, 720, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (47847, 720, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (47848, 720, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (47849, 720, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (47850, 720, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (47851, 720, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (47852, 720, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (47853, 720, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (47854, 720, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (47855, 720, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (47856, 720, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47857, 720, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (47858, 720, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47859, 720, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (47860, 720, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (47861, 720, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47862, 720, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47863, 720, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (47864, 720, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (47865, 720, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (47866, 720, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (47867, 720, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (47868, 720, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (47869, 720, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (47870, 720, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (47871, 720, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (47872, 720, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (47873, 720, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (47874, 720, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (47875, 720, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (47876, 720, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (47877, 720, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (47878, 720, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (47879, 720, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (47880, 720, 52, 1460);
INSERT INTO 'devicecapvalue' VALUES (47881, 720, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (47882, 720, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (47883, 720, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (47884, 720, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (47885, 720, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (47886, 721, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (47887, 721, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (47888, 721, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (47889, 721, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (47890, 721, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (47891, 721, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (47892, 721, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (47893, 721, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (47894, 721, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (47895, 721, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (47896, 721, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (47897, 721, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (47898, 721, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (47899, 721, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (47900, 721, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (47901, 721, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (47902, 721, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (47903, 721, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (47904, 721, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (47905, 721, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (47906, 721, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (47907, 721, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (47908, 721, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (47909, 721, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (47910, 721, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (47911, 721, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (47912, 721, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (47913, 721, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (47914, 721, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (47915, 721, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (47916, 721, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (47917, 721, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (47918, 721, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (47919, 721, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47920, 721, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (47921, 721, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (47922, 721, 6, 2063);
INSERT INTO 'devicecapvalue' VALUES (47923, 721, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (47924, 721, 18, 1245);
INSERT INTO 'devicecapvalue' VALUES (47925, 721, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (47926, 721, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (47927, 721, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (47928, 721, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (47929, 721, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (47930, 721, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (47931, 721, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (47932, 721, 26, 1245);
INSERT INTO 'devicecapvalue' VALUES (47933, 721, 27, 1245);
INSERT INTO 'devicecapvalue' VALUES (47934, 721, 57, 1245);
INSERT INTO 'devicecapvalue' VALUES (47935, 721, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (47936, 721, 30, 1245);
INSERT INTO 'devicecapvalue' VALUES (47937, 721, 54, 1245);
INSERT INTO 'devicecapvalue' VALUES (47938, 721, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (47939, 721, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (47940, 721, 38, 100);
INSERT INTO 'devicecapvalue' VALUES (47941, 721, 38, 880);
INSERT INTO 'devicecapvalue' VALUES (47942, 721, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (47943, 721, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (47944, 721, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (47945, 721, 39, 123);
INSERT INTO 'devicecapvalue' VALUES (47946, 721, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (47947, 721, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (47948, 721, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (47949, 721, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (47950, 721, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (47951, 721, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (47952, 721, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (47953, 721, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (47954, 721, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (47955, 721, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (47956, 721, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (47957, 721, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (47958, 721, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (47959, 721, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (47960, 721, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (47961, 721, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (47962, 721, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (47963, 721, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (47964, 721, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (47965, 721, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (47966, 721, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (47967, 721, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (47968, 721, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (47969, 721, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (47970, 721, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (47971, 721, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (47972, 721, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (47973, 721, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (47974, 721, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (47975, 721, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (47976, 721, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (47977, 721, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (47978, 721, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (47979, 721, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (47980, 721, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (47981, 721, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (47982, 721, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (47983, 721, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (47984, 721, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (47985, 721, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (47986, 721, 41, 123);
INSERT INTO 'devicecapvalue' VALUES (47987, 721, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (47988, 721, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (47989, 721, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (47990, 721, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (47991, 721, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (47992, 721, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (47993, 721, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (47994, 721, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (47995, 721, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (47996, 721, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (47997, 721, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (47998, 721, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (47999, 721, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (48000, 721, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (48001, 721, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (48002, 721, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (48003, 721, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (48004, 721, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (48005, 721, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (48006, 721, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (48007, 721, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (48008, 721, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (48009, 721, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (48010, 721, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (48011, 721, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (48012, 721, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (48013, 721, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (48014, 721, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (48015, 721, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (48016, 721, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (48017, 721, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (48018, 721, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (48019, 721, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (48020, 721, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (48021, 721, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (48022, 721, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (48023, 721, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (48024, 721, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (48025, 721, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (48026, 721, 42, 123);
INSERT INTO 'devicecapvalue' VALUES (48027, 721, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (48028, 721, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (48029, 721, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (48030, 721, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (48031, 721, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (48032, 721, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (48033, 721, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (48034, 721, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (48035, 721, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (48036, 721, 45, 2448);
INSERT INTO 'devicecapvalue' VALUES (48037, 721, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (48038, 721, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (48039, 721, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (48040, 721, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (48041, 721, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (48042, 721, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (48043, 721, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (48044, 721, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (48045, 721, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (48046, 721, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (48047, 721, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (48048, 721, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (48049, 721, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (48050, 721, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (48051, 721, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (48052, 721, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (48053, 721, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (48054, 721, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (48055, 721, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (48056, 721, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (48057, 721, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (48058, 721, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (48059, 721, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (48060, 721, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (48061, 721, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (48062, 721, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (48063, 721, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (48064, 721, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (48065, 721, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (48066, 721, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (48067, 721, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (48068, 721, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (48069, 721, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (48070, 721, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (48071, 721, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (48072, 721, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (48073, 721, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (48074, 721, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (48075, 721, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (48076, 721, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (48077, 721, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (48078, 721, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (48079, 721, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (48080, 721, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (48081, 721, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (48082, 721, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (48083, 721, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (48084, 721, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (48085, 721, 115, 2449);
INSERT INTO 'devicecapvalue' VALUES (48086, 721, 141, 42);
INSERT INTO 'devicecapvalue' VALUES (48087, 721, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (48088, 721, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (48089, 721, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (48090, 721, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (48091, 721, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (48092, 721, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (48093, 721, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (48094, 721, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (48095, 721, 125, 707);
INSERT INTO 'devicecapvalue' VALUES (48096, 721, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (48097, 721, 142, 2336);
INSERT INTO 'capvalue' VALUES (2497, 'devcam0:1600x1200');
INSERT INTO 'devicecapvalue' VALUES (48098, 721, 143, 2497);
INSERT INTO 'devicecapvalue' VALUES (48099, 721, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (48100, 721, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (48101, 721, 102, 2451);
INSERT INTO 'devicecapvalue' VALUES (48102, 721, 103, 2338);
INSERT INTO 'devicecapvalue' VALUES (48103, 721, 104, 2339);
INSERT INTO 'devicecapvalue' VALUES (48104, 721, 106, 2341);
INSERT INTO 'devicecapvalue' VALUES (48105, 721, 107, 728);
INSERT INTO 'devicecapvalue' VALUES (48106, 721, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (48107, 721, 109, 946);
INSERT INTO 'devicecapvalue' VALUES (48108, 721, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (48109, 721, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (48110, 721, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (48111, 721, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (48112, 721, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (48113, 721, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (48114, 721, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (48115, 721, 67, 45);
INSERT INTO 'capvalue' VALUES (2498, 'SonyEricssonS500i/R8BE001');
INSERT INTO 'devicecapvalue' VALUES (48116, 721, 68, 2498);
INSERT INTO 'devicecapvalue' VALUES (48117, 721, 69, 2390);
INSERT INTO 'devicecapvalue' VALUES (48118, 721, 132, 2449);
INSERT INTO 'devicecapvalue' VALUES (48119, 721, 133, 2448);
INSERT INTO 'devicecapvalue' VALUES (48120, 721, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (48121, 721, 116, 2075);
INSERT INTO 'devicecapvalue' VALUES (48122, 721, 116, 1280);
INSERT INTO 'devicecapvalue' VALUES (48123, 721, 116, 123);
INSERT INTO 'devicecapvalue' VALUES (48124, 721, 116, 2319);
INSERT INTO 'devicecapvalue' VALUES (48125, 721, 116, 1283);
INSERT INTO 'devicecapvalue' VALUES (48126, 721, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (48127, 721, 149, 949);
INSERT INTO 'devicecapvalue' VALUES (48128, 721, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (48129, 721, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (48130, 721, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (48131, 721, 136, 2448);
INSERT INTO 'devicecapvalue' VALUES (48132, 721, 137, 2352);
INSERT INTO 'capvalue' VALUES (2499, 'http://mms.heyah.pl/servlets/mms');
INSERT INTO 'devicecapvalue' VALUES (48133, 721, 138, 2499);
INSERT INTO 'devicecapvalue' VALUES (48134, 721, 72, 732);
INSERT INTO 'devicecapvalue' VALUES (48135, 721, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (48136, 721, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (48137, 721, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (48138, 721, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (48139, 721, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (48140, 721, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (48141, 721, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (48142, 721, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (48143, 721, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (48144, 721, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (48145, 721, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (48146, 721, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (48147, 721, 47, 123);
INSERT INTO 'devicecapvalue' VALUES (48148, 721, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (48149, 721, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (48150, 721, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (48151, 721, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (48152, 721, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (48153, 721, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (48154, 721, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (48155, 721, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (48156, 721, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (48157, 721, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (48158, 721, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (48159, 721, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (48160, 721, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (48161, 721, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (48162, 721, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (48163, 721, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (48164, 721, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (48165, 721, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (48166, 721, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (48167, 721, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (48168, 721, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (48169, 721, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (48170, 721, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (48171, 721, 52, 1460);
INSERT INTO 'devicecapvalue' VALUES (48172, 721, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (48173, 721, 48, 2322);
INSERT INTO 'devicecapvalue' VALUES (48174, 721, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (48175, 721, 49, 659);
INSERT INTO 'devicecapvalue' VALUES (48176, 721, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (48177, 721, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (48178, 721, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (48179, 721, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (48180, 721, 157, 1504);
INSERT INTO 'capvalue' VALUES (2500, 'SonyEricssonS500i/R8BE Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (48181, 721, 53, 2500);
INSERT INTO 'devicecapvalue' VALUES (48182, 722, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (48183, 722, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (48184, 722, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (48185, 722, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (48186, 722, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (48187, 722, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (48188, 722, 173, 1523);
INSERT INTO 'capvalue' VALUES (2501, 'SonyEricsson_S700');
INSERT INTO 'devicecapvalue' VALUES (48189, 722, 75, 2501);
INSERT INTO 'devicecapvalue' VALUES (48190, 722, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (48191, 722, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (48192, 722, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (48193, 722, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (48194, 722, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (48195, 722, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (48196, 722, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (48197, 722, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (48198, 722, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (48199, 722, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (48200, 722, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (48201, 722, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (48202, 722, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (48203, 722, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (48204, 722, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (48205, 722, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (48206, 722, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (48207, 722, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (48208, 722, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (48209, 722, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (48210, 722, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (48211, 722, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (48212, 722, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (48213, 722, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (48214, 722, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (48215, 722, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (48216, 722, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (48217, 722, 51, 1084);
INSERT INTO 'devicecapvalue' VALUES (48218, 722, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (48219, 722, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (48220, 722, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (48221, 722, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (48222, 722, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (48223, 722, 191, 1372);
INSERT INTO 'capvalue' VALUES (2502, 'SonyEricssonS700');
INSERT INTO 'devicecapvalue' VALUES (48224, 722, 53, 2502);
INSERT INTO 'devicecapvalue' VALUES (48225, 723, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (48226, 723, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (48227, 723, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (48228, 723, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (48229, 723, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (48230, 723, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (48231, 723, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (48232, 723, 75, 2501);
INSERT INTO 'devicecapvalue' VALUES (48233, 723, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (48234, 723, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (48235, 723, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (48236, 723, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (48237, 723, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (48238, 723, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (48239, 723, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (48240, 723, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (48241, 723, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (48242, 723, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (48243, 723, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (48244, 723, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (48245, 723, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (48246, 723, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (48247, 723, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (48248, 723, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (48249, 723, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (48250, 723, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (48251, 723, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (48252, 723, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (48253, 723, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (48254, 723, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (48255, 723, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (48256, 723, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (48257, 723, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (48258, 723, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (48259, 723, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (48260, 723, 51, 1084);
INSERT INTO 'devicecapvalue' VALUES (48261, 723, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (48262, 723, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (48263, 723, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (48264, 723, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (48265, 723, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (48266, 723, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (48267, 723, 53, 2502);
INSERT INTO 'devicecapvalue' VALUES (48268, 724, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (48269, 724, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (48270, 724, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (48271, 724, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (48272, 724, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (48273, 724, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (48274, 724, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (48275, 724, 75, 2501);
INSERT INTO 'devicecapvalue' VALUES (48276, 724, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (48277, 724, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (48278, 724, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (48279, 724, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (48280, 724, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (48281, 724, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (48282, 724, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (48283, 724, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (48284, 724, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (48285, 724, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (48286, 724, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (48287, 724, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (48288, 724, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (48289, 724, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (48290, 724, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (48291, 724, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (48292, 724, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (48293, 724, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (48294, 724, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (48295, 724, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (48296, 724, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (48297, 724, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (48298, 724, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (48299, 724, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (48300, 724, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (48301, 724, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (48302, 724, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (48303, 724, 51, 1084);
INSERT INTO 'devicecapvalue' VALUES (48304, 724, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (48305, 724, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (48306, 724, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (48307, 724, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (48308, 724, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (48309, 724, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (48310, 724, 53, 2502);
INSERT INTO 'devicecapvalue' VALUES (48311, 725, 1, 606);
INSERT INTO 'devicecapvalue' VALUES (48312, 725, 4, 646);
INSERT INTO 'devicecapvalue' VALUES (48313, 725, 5, 857);
INSERT INTO 'devicecapvalue' VALUES (48314, 726, 56, 233);
INSERT INTO 'devicecapvalue' VALUES (48315, 726, 7, 2103);
INSERT INTO 'devicecapvalue' VALUES (48316, 726, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (48317, 726, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (48318, 726, 9, 864);
INSERT INTO 'devicecapvalue' VALUES (48319, 726, 10, 864);
INSERT INTO 'devicecapvalue' VALUES (48320, 726, 11, 864);
INSERT INTO 'devicecapvalue' VALUES (48321, 726, 12, 864);
INSERT INTO 'devicecapvalue' VALUES (48322, 726, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (48323, 726, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (48324, 726, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (48325, 726, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (48326, 726, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (48327, 726, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (48328, 726, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (48329, 726, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (48330, 726, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (48331, 726, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (48332, 726, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (48333, 726, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (48334, 726, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (48335, 726, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (48336, 726, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (48337, 726, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (48338, 726, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (48339, 726, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (48340, 726, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (48341, 726, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (48342, 726, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (48343, 726, 30, 1244);
INSERT INTO 'devicecapvalue' VALUES (48344, 726, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (48345, 726, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (48346, 726, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (48347, 726, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (48348, 726, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (48349, 726, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (48350, 726, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (48351, 726, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (48352, 726, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (48353, 726, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (48354, 726, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (48355, 726, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (48356, 726, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (48357, 726, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (48358, 726, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (48359, 726, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (48360, 726, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (48361, 726, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (48362, 726, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (48363, 726, 58, 13);
INSERT INTO 'devicecapvalue' VALUES (48364, 726, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (48365, 726, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (48366, 726, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (48367, 726, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (48368, 726, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (48369, 726, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (48370, 726, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (48371, 726, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (48372, 726, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (48373, 726, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (48374, 726, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (48375, 726, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (48376, 726, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (48377, 726, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (48378, 726, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (48379, 726, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (48380, 726, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (48381, 726, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (48382, 726, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (48383, 726, 115, 1258);
INSERT INTO 'devicecapvalue' VALUES (48384, 726, 59, 240);
INSERT INTO 'capvalue' VALUES (2503, 'file:///realRoot/picture/mypic/');
INSERT INTO 'devicecapvalue' VALUES (48385, 726, 103, 2503);
INSERT INTO 'capvalue' VALUES (2504, 'mypic/');
INSERT INTO 'devicecapvalue' VALUES (48386, 726, 104, 2504);
INSERT INTO 'capvalue' VALUES (2505, 'file:///realRoot/melody/');
INSERT INTO 'devicecapvalue' VALUES (48387, 726, 106, 2505);
INSERT INTO 'capvalue' VALUES (2506, 'melody/');
INSERT INTO 'devicecapvalue' VALUES (48388, 726, 107, 2506);
INSERT INTO 'devicecapvalue' VALUES (48389, 726, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (48390, 726, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (48391, 726, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (48392, 726, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (48393, 726, 66, 242);
INSERT INTO 'capvalue' VALUES (2507, 'SonyEricssonT303/R2CC001 TelecaBrowser/Q04C1-1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (48394, 726, 68, 2507);
INSERT INTO 'devicecapvalue' VALUES (48395, 726, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (48396, 726, 132, 1258);
INSERT INTO 'devicecapvalue' VALUES (48397, 726, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (48398, 726, 71, 15);
INSERT INTO 'capvalue' VALUES (2508, '+37069950115');
INSERT INTO 'devicecapvalue' VALUES (48399, 726, 72, 2508);
INSERT INTO 'devicecapvalue' VALUES (48400, 726, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (48401, 726, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (48402, 726, 48, 245);
INSERT INTO 'devicecapvalue' VALUES (48403, 726, 48, 246);
INSERT INTO 'devicecapvalue' VALUES (48404, 726, 48, 247);
INSERT INTO 'devicecapvalue' VALUES (48405, 726, 48, 248);
INSERT INTO 'devicecapvalue' VALUES (48406, 726, 48, 249);
INSERT INTO 'devicecapvalue' VALUES (48407, 726, 48, 250);
INSERT INTO 'devicecapvalue' VALUES (48408, 726, 48, 251);
INSERT INTO 'devicecapvalue' VALUES (48409, 726, 48, 252);
INSERT INTO 'devicecapvalue' VALUES (48410, 726, 48, 253);
INSERT INTO 'devicecapvalue' VALUES (48411, 726, 48, 254);
INSERT INTO 'devicecapvalue' VALUES (48412, 726, 48, 255);
INSERT INTO 'devicecapvalue' VALUES (48413, 726, 48, 256);
INSERT INTO 'devicecapvalue' VALUES (48414, 726, 48, 257);
INSERT INTO 'devicecapvalue' VALUES (48415, 726, 48, 258);
INSERT INTO 'devicecapvalue' VALUES (48416, 726, 48, 259);
INSERT INTO 'devicecapvalue' VALUES (48417, 726, 48, 260);
INSERT INTO 'devicecapvalue' VALUES (48418, 726, 48, 261);
INSERT INTO 'devicecapvalue' VALUES (48419, 726, 48, 262);
INSERT INTO 'devicecapvalue' VALUES (48420, 726, 48, 263);
INSERT INTO 'devicecapvalue' VALUES (48421, 726, 48, 264);
INSERT INTO 'devicecapvalue' VALUES (48422, 726, 48, 265);
INSERT INTO 'devicecapvalue' VALUES (48423, 726, 48, 266);
INSERT INTO 'devicecapvalue' VALUES (48424, 726, 48, 267);
INSERT INTO 'devicecapvalue' VALUES (48425, 726, 48, 268);
INSERT INTO 'devicecapvalue' VALUES (48426, 726, 48, 269);
INSERT INTO 'devicecapvalue' VALUES (48427, 726, 48, 270);
INSERT INTO 'devicecapvalue' VALUES (48428, 726, 48, 271);
INSERT INTO 'devicecapvalue' VALUES (48429, 726, 48, 272);
INSERT INTO 'devicecapvalue' VALUES (48430, 726, 48, 273);
INSERT INTO 'devicecapvalue' VALUES (48431, 726, 48, 274);
INSERT INTO 'devicecapvalue' VALUES (48432, 726, 48, 275);
INSERT INTO 'devicecapvalue' VALUES (48433, 726, 48, 276);
INSERT INTO 'devicecapvalue' VALUES (48434, 726, 48, 277);
INSERT INTO 'devicecapvalue' VALUES (48435, 726, 48, 278);
INSERT INTO 'devicecapvalue' VALUES (48436, 726, 48, 279);
INSERT INTO 'devicecapvalue' VALUES (48437, 726, 48, 280);
INSERT INTO 'devicecapvalue' VALUES (48438, 726, 48, 281);
INSERT INTO 'devicecapvalue' VALUES (48439, 726, 48, 282);
INSERT INTO 'devicecapvalue' VALUES (48440, 726, 48, 283);
INSERT INTO 'devicecapvalue' VALUES (48441, 726, 48, 284);
INSERT INTO 'devicecapvalue' VALUES (48442, 726, 48, 285);
INSERT INTO 'devicecapvalue' VALUES (48443, 726, 48, 286);
INSERT INTO 'devicecapvalue' VALUES (48444, 726, 48, 287);
INSERT INTO 'devicecapvalue' VALUES (48445, 726, 48, 288);
INSERT INTO 'devicecapvalue' VALUES (48446, 726, 48, 289);
INSERT INTO 'devicecapvalue' VALUES (48447, 726, 48, 290);
INSERT INTO 'devicecapvalue' VALUES (48448, 726, 48, 291);
INSERT INTO 'devicecapvalue' VALUES (48449, 726, 48, 292);
INSERT INTO 'devicecapvalue' VALUES (48450, 726, 48, 293);
INSERT INTO 'devicecapvalue' VALUES (48451, 726, 48, 294);
INSERT INTO 'devicecapvalue' VALUES (48452, 726, 48, 295);
INSERT INTO 'devicecapvalue' VALUES (48453, 726, 48, 296);
INSERT INTO 'devicecapvalue' VALUES (48454, 726, 48, 297);
INSERT INTO 'devicecapvalue' VALUES (48455, 726, 48, 298);
INSERT INTO 'devicecapvalue' VALUES (48456, 726, 48, 299);
INSERT INTO 'devicecapvalue' VALUES (48457, 726, 48, 300);
INSERT INTO 'devicecapvalue' VALUES (48458, 726, 48, 301);
INSERT INTO 'devicecapvalue' VALUES (48459, 726, 48, 302);
INSERT INTO 'devicecapvalue' VALUES (48460, 726, 48, 303);
INSERT INTO 'devicecapvalue' VALUES (48461, 726, 48, 304);
INSERT INTO 'devicecapvalue' VALUES (48462, 726, 48, 305);
INSERT INTO 'devicecapvalue' VALUES (48463, 726, 48, 306);
INSERT INTO 'devicecapvalue' VALUES (48464, 726, 48, 307);
INSERT INTO 'devicecapvalue' VALUES (48465, 726, 48, 308);
INSERT INTO 'devicecapvalue' VALUES (48466, 726, 48, 309);
INSERT INTO 'devicecapvalue' VALUES (48467, 726, 48, 310);
INSERT INTO 'devicecapvalue' VALUES (48468, 726, 48, 311);
INSERT INTO 'devicecapvalue' VALUES (48469, 726, 48, 312);
INSERT INTO 'devicecapvalue' VALUES (48470, 726, 48, 313);
INSERT INTO 'devicecapvalue' VALUES (48471, 726, 48, 314);
INSERT INTO 'devicecapvalue' VALUES (48472, 726, 48, 315);
INSERT INTO 'devicecapvalue' VALUES (48473, 726, 48, 316);
INSERT INTO 'devicecapvalue' VALUES (48474, 726, 48, 317);
INSERT INTO 'devicecapvalue' VALUES (48475, 726, 48, 318);
INSERT INTO 'devicecapvalue' VALUES (48476, 726, 48, 319);
INSERT INTO 'devicecapvalue' VALUES (48477, 726, 48, 320);
INSERT INTO 'devicecapvalue' VALUES (48478, 726, 48, 321);
INSERT INTO 'devicecapvalue' VALUES (48479, 726, 48, 322);
INSERT INTO 'devicecapvalue' VALUES (48480, 726, 48, 323);
INSERT INTO 'devicecapvalue' VALUES (48481, 726, 48, 324);
INSERT INTO 'devicecapvalue' VALUES (48482, 726, 48, 325);
INSERT INTO 'devicecapvalue' VALUES (48483, 726, 48, 326);
INSERT INTO 'devicecapvalue' VALUES (48484, 726, 48, 327);
INSERT INTO 'devicecapvalue' VALUES (48485, 726, 48, 328);
INSERT INTO 'devicecapvalue' VALUES (48486, 726, 48, 329);
INSERT INTO 'devicecapvalue' VALUES (48487, 726, 48, 330);
INSERT INTO 'devicecapvalue' VALUES (48488, 726, 48, 331);
INSERT INTO 'devicecapvalue' VALUES (48489, 726, 48, 332);
INSERT INTO 'devicecapvalue' VALUES (48490, 726, 48, 333);
INSERT INTO 'devicecapvalue' VALUES (48491, 726, 48, 334);
INSERT INTO 'devicecapvalue' VALUES (48492, 726, 48, 335);
INSERT INTO 'devicecapvalue' VALUES (48493, 726, 48, 336);
INSERT INTO 'devicecapvalue' VALUES (48494, 726, 48, 337);
INSERT INTO 'devicecapvalue' VALUES (48495, 726, 48, 338);
INSERT INTO 'devicecapvalue' VALUES (48496, 726, 48, 339);
INSERT INTO 'devicecapvalue' VALUES (48497, 726, 48, 340);
INSERT INTO 'devicecapvalue' VALUES (48498, 726, 48, 341);
INSERT INTO 'devicecapvalue' VALUES (48499, 726, 48, 342);
INSERT INTO 'devicecapvalue' VALUES (48500, 726, 48, 343);
INSERT INTO 'devicecapvalue' VALUES (48501, 726, 48, 344);
INSERT INTO 'devicecapvalue' VALUES (48502, 726, 48, 345);
INSERT INTO 'devicecapvalue' VALUES (48503, 726, 48, 346);
INSERT INTO 'devicecapvalue' VALUES (48504, 726, 48, 347);
INSERT INTO 'devicecapvalue' VALUES (48505, 726, 48, 348);
INSERT INTO 'devicecapvalue' VALUES (48506, 726, 48, 349);
INSERT INTO 'devicecapvalue' VALUES (48507, 726, 48, 350);
INSERT INTO 'devicecapvalue' VALUES (48508, 726, 48, 351);
INSERT INTO 'devicecapvalue' VALUES (48509, 726, 48, 352);
INSERT INTO 'devicecapvalue' VALUES (48510, 726, 48, 353);
INSERT INTO 'devicecapvalue' VALUES (48511, 726, 48, 354);
INSERT INTO 'devicecapvalue' VALUES (48512, 726, 48, 355);
INSERT INTO 'devicecapvalue' VALUES (48513, 726, 48, 356);
INSERT INTO 'devicecapvalue' VALUES (48514, 726, 48, 357);
INSERT INTO 'devicecapvalue' VALUES (48515, 726, 48, 358);
INSERT INTO 'devicecapvalue' VALUES (48516, 726, 48, 359);
INSERT INTO 'devicecapvalue' VALUES (48517, 726, 48, 360);
INSERT INTO 'devicecapvalue' VALUES (48518, 726, 48, 361);
INSERT INTO 'devicecapvalue' VALUES (48519, 726, 48, 362);
INSERT INTO 'devicecapvalue' VALUES (48520, 726, 48, 363);
INSERT INTO 'devicecapvalue' VALUES (48521, 726, 48, 364);
INSERT INTO 'devicecapvalue' VALUES (48522, 726, 48, 365);
INSERT INTO 'devicecapvalue' VALUES (48523, 726, 48, 366);
INSERT INTO 'devicecapvalue' VALUES (48524, 726, 48, 367);
INSERT INTO 'devicecapvalue' VALUES (48525, 726, 48, 368);
INSERT INTO 'devicecapvalue' VALUES (48526, 726, 48, 369);
INSERT INTO 'devicecapvalue' VALUES (48527, 726, 48, 370);
INSERT INTO 'devicecapvalue' VALUES (48528, 726, 48, 371);
INSERT INTO 'devicecapvalue' VALUES (48529, 726, 48, 372);
INSERT INTO 'devicecapvalue' VALUES (48530, 726, 48, 373);
INSERT INTO 'devicecapvalue' VALUES (48531, 726, 48, 374);
INSERT INTO 'devicecapvalue' VALUES (48532, 726, 48, 375);
INSERT INTO 'devicecapvalue' VALUES (48533, 726, 48, 376);
INSERT INTO 'devicecapvalue' VALUES (48534, 726, 48, 377);
INSERT INTO 'devicecapvalue' VALUES (48535, 726, 48, 378);
INSERT INTO 'devicecapvalue' VALUES (48536, 726, 48, 379);
INSERT INTO 'devicecapvalue' VALUES (48537, 726, 48, 380);
INSERT INTO 'devicecapvalue' VALUES (48538, 726, 48, 381);
INSERT INTO 'devicecapvalue' VALUES (48539, 726, 48, 382);
INSERT INTO 'devicecapvalue' VALUES (48540, 726, 48, 383);
INSERT INTO 'devicecapvalue' VALUES (48541, 726, 48, 384);
INSERT INTO 'devicecapvalue' VALUES (48542, 726, 48, 385);
INSERT INTO 'devicecapvalue' VALUES (48543, 726, 48, 386);
INSERT INTO 'devicecapvalue' VALUES (48544, 726, 48, 387);
INSERT INTO 'devicecapvalue' VALUES (48545, 726, 48, 388);
INSERT INTO 'devicecapvalue' VALUES (48546, 726, 48, 389);
INSERT INTO 'devicecapvalue' VALUES (48547, 726, 48, 390);
INSERT INTO 'devicecapvalue' VALUES (48548, 726, 48, 391);
INSERT INTO 'devicecapvalue' VALUES (48549, 726, 48, 392);
INSERT INTO 'devicecapvalue' VALUES (48550, 726, 48, 393);
INSERT INTO 'devicecapvalue' VALUES (48551, 726, 48, 394);
INSERT INTO 'devicecapvalue' VALUES (48552, 726, 48, 395);
INSERT INTO 'devicecapvalue' VALUES (48553, 726, 48, 396);
INSERT INTO 'devicecapvalue' VALUES (48554, 726, 48, 397);
INSERT INTO 'devicecapvalue' VALUES (48555, 726, 48, 398);
INSERT INTO 'devicecapvalue' VALUES (48556, 726, 48, 399);
INSERT INTO 'devicecapvalue' VALUES (48557, 726, 48, 400);
INSERT INTO 'devicecapvalue' VALUES (48558, 726, 48, 401);
INSERT INTO 'devicecapvalue' VALUES (48559, 726, 48, 402);
INSERT INTO 'devicecapvalue' VALUES (48560, 726, 48, 403);
INSERT INTO 'devicecapvalue' VALUES (48561, 726, 48, 404);
INSERT INTO 'devicecapvalue' VALUES (48562, 726, 48, 405);
INSERT INTO 'devicecapvalue' VALUES (48563, 726, 48, 406);
INSERT INTO 'devicecapvalue' VALUES (48564, 726, 48, 407);
INSERT INTO 'devicecapvalue' VALUES (48565, 726, 48, 408);
INSERT INTO 'devicecapvalue' VALUES (48566, 726, 48, 409);
INSERT INTO 'devicecapvalue' VALUES (48567, 726, 48, 410);
INSERT INTO 'devicecapvalue' VALUES (48568, 726, 48, 411);
INSERT INTO 'devicecapvalue' VALUES (48569, 726, 48, 412);
INSERT INTO 'devicecapvalue' VALUES (48570, 726, 48, 413);
INSERT INTO 'devicecapvalue' VALUES (48571, 726, 48, 414);
INSERT INTO 'devicecapvalue' VALUES (48572, 726, 48, 415);
INSERT INTO 'devicecapvalue' VALUES (48573, 726, 48, 416);
INSERT INTO 'devicecapvalue' VALUES (48574, 726, 48, 417);
INSERT INTO 'devicecapvalue' VALUES (48575, 726, 48, 418);
INSERT INTO 'devicecapvalue' VALUES (48576, 726, 48, 419);
INSERT INTO 'devicecapvalue' VALUES (48577, 726, 48, 420);
INSERT INTO 'devicecapvalue' VALUES (48578, 726, 48, 421);
INSERT INTO 'devicecapvalue' VALUES (48579, 726, 48, 422);
INSERT INTO 'devicecapvalue' VALUES (48580, 726, 48, 423);
INSERT INTO 'devicecapvalue' VALUES (48581, 726, 48, 424);
INSERT INTO 'devicecapvalue' VALUES (48582, 726, 48, 425);
INSERT INTO 'devicecapvalue' VALUES (48583, 726, 48, 426);
INSERT INTO 'devicecapvalue' VALUES (48584, 726, 48, 427);
INSERT INTO 'devicecapvalue' VALUES (48585, 726, 48, 428);
INSERT INTO 'devicecapvalue' VALUES (48586, 726, 48, 429);
INSERT INTO 'devicecapvalue' VALUES (48587, 726, 48, 430);
INSERT INTO 'devicecapvalue' VALUES (48588, 726, 48, 431);
INSERT INTO 'devicecapvalue' VALUES (48589, 726, 48, 432);
INSERT INTO 'devicecapvalue' VALUES (48590, 726, 48, 433);
INSERT INTO 'devicecapvalue' VALUES (48591, 726, 48, 434);
INSERT INTO 'devicecapvalue' VALUES (48592, 726, 48, 435);
INSERT INTO 'devicecapvalue' VALUES (48593, 726, 48, 436);
INSERT INTO 'devicecapvalue' VALUES (48594, 726, 48, 437);
INSERT INTO 'devicecapvalue' VALUES (48595, 726, 48, 438);
INSERT INTO 'devicecapvalue' VALUES (48596, 726, 48, 439);
INSERT INTO 'devicecapvalue' VALUES (48597, 726, 48, 440);
INSERT INTO 'devicecapvalue' VALUES (48598, 726, 48, 441);
INSERT INTO 'devicecapvalue' VALUES (48599, 726, 48, 442);
INSERT INTO 'devicecapvalue' VALUES (48600, 726, 48, 443);
INSERT INTO 'devicecapvalue' VALUES (48601, 726, 48, 444);
INSERT INTO 'devicecapvalue' VALUES (48602, 726, 48, 445);
INSERT INTO 'devicecapvalue' VALUES (48603, 726, 48, 446);
INSERT INTO 'devicecapvalue' VALUES (48604, 726, 48, 447);
INSERT INTO 'devicecapvalue' VALUES (48605, 726, 48, 448);
INSERT INTO 'devicecapvalue' VALUES (48606, 726, 48, 449);
INSERT INTO 'devicecapvalue' VALUES (48607, 726, 48, 450);
INSERT INTO 'devicecapvalue' VALUES (48608, 726, 48, 451);
INSERT INTO 'devicecapvalue' VALUES (48609, 726, 48, 452);
INSERT INTO 'devicecapvalue' VALUES (48610, 726, 48, 453);
INSERT INTO 'devicecapvalue' VALUES (48611, 726, 48, 454);
INSERT INTO 'devicecapvalue' VALUES (48612, 726, 48, 455);
INSERT INTO 'devicecapvalue' VALUES (48613, 726, 48, 456);
INSERT INTO 'devicecapvalue' VALUES (48614, 726, 48, 457);
INSERT INTO 'devicecapvalue' VALUES (48615, 726, 48, 458);
INSERT INTO 'devicecapvalue' VALUES (48616, 726, 48, 459);
INSERT INTO 'devicecapvalue' VALUES (48617, 726, 48, 460);
INSERT INTO 'devicecapvalue' VALUES (48618, 726, 48, 461);
INSERT INTO 'devicecapvalue' VALUES (48619, 726, 48, 462);
INSERT INTO 'devicecapvalue' VALUES (48620, 726, 48, 463);
INSERT INTO 'devicecapvalue' VALUES (48621, 726, 48, 464);
INSERT INTO 'devicecapvalue' VALUES (48622, 726, 48, 465);
INSERT INTO 'devicecapvalue' VALUES (48623, 726, 48, 466);
INSERT INTO 'devicecapvalue' VALUES (48624, 726, 48, 467);
INSERT INTO 'devicecapvalue' VALUES (48625, 726, 48, 468);
INSERT INTO 'devicecapvalue' VALUES (48626, 726, 48, 469);
INSERT INTO 'devicecapvalue' VALUES (48627, 726, 48, 470);
INSERT INTO 'devicecapvalue' VALUES (48628, 726, 48, 471);
INSERT INTO 'devicecapvalue' VALUES (48629, 726, 48, 472);
INSERT INTO 'devicecapvalue' VALUES (48630, 726, 48, 473);
INSERT INTO 'devicecapvalue' VALUES (48631, 726, 48, 474);
INSERT INTO 'devicecapvalue' VALUES (48632, 726, 48, 475);
INSERT INTO 'devicecapvalue' VALUES (48633, 726, 48, 476);
INSERT INTO 'devicecapvalue' VALUES (48634, 726, 48, 477);
INSERT INTO 'devicecapvalue' VALUES (48635, 726, 48, 478);
INSERT INTO 'devicecapvalue' VALUES (48636, 726, 48, 479);
INSERT INTO 'devicecapvalue' VALUES (48637, 726, 48, 480);
INSERT INTO 'devicecapvalue' VALUES (48638, 726, 48, 481);
INSERT INTO 'devicecapvalue' VALUES (48639, 726, 48, 482);
INSERT INTO 'devicecapvalue' VALUES (48640, 726, 48, 483);
INSERT INTO 'devicecapvalue' VALUES (48641, 726, 48, 484);
INSERT INTO 'devicecapvalue' VALUES (48642, 726, 48, 485);
INSERT INTO 'devicecapvalue' VALUES (48643, 726, 48, 486);
INSERT INTO 'devicecapvalue' VALUES (48644, 726, 48, 487);
INSERT INTO 'devicecapvalue' VALUES (48645, 726, 48, 488);
INSERT INTO 'devicecapvalue' VALUES (48646, 726, 48, 489);
INSERT INTO 'devicecapvalue' VALUES (48647, 726, 48, 490);
INSERT INTO 'devicecapvalue' VALUES (48648, 726, 48, 491);
INSERT INTO 'devicecapvalue' VALUES (48649, 726, 48, 492);
INSERT INTO 'devicecapvalue' VALUES (48650, 726, 48, 493);
INSERT INTO 'devicecapvalue' VALUES (48651, 726, 48, 494);
INSERT INTO 'devicecapvalue' VALUES (48652, 726, 48, 495);
INSERT INTO 'devicecapvalue' VALUES (48653, 726, 48, 496);
INSERT INTO 'devicecapvalue' VALUES (48654, 726, 48, 497);
INSERT INTO 'devicecapvalue' VALUES (48655, 726, 48, 498);
INSERT INTO 'devicecapvalue' VALUES (48656, 726, 48, 499);
INSERT INTO 'devicecapvalue' VALUES (48657, 726, 48, 500);
INSERT INTO 'devicecapvalue' VALUES (48658, 726, 48, 501);
INSERT INTO 'devicecapvalue' VALUES (48659, 726, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (48660, 726, 48, 502);
INSERT INTO 'devicecapvalue' VALUES (48661, 726, 48, 503);
INSERT INTO 'devicecapvalue' VALUES (48662, 726, 48, 504);
INSERT INTO 'devicecapvalue' VALUES (48663, 726, 48, 505);
INSERT INTO 'devicecapvalue' VALUES (48664, 726, 48, 506);
INSERT INTO 'devicecapvalue' VALUES (48665, 726, 48, 507);
INSERT INTO 'devicecapvalue' VALUES (48666, 726, 48, 508);
INSERT INTO 'devicecapvalue' VALUES (48667, 726, 48, 509);
INSERT INTO 'devicecapvalue' VALUES (48668, 726, 48, 510);
INSERT INTO 'devicecapvalue' VALUES (48669, 726, 48, 511);
INSERT INTO 'devicecapvalue' VALUES (48670, 726, 48, 512);
INSERT INTO 'devicecapvalue' VALUES (48671, 726, 48, 513);
INSERT INTO 'devicecapvalue' VALUES (48672, 726, 48, 514);
INSERT INTO 'devicecapvalue' VALUES (48673, 726, 48, 515);
INSERT INTO 'devicecapvalue' VALUES (48674, 726, 48, 516);
INSERT INTO 'devicecapvalue' VALUES (48675, 726, 48, 517);
INSERT INTO 'devicecapvalue' VALUES (48676, 726, 48, 518);
INSERT INTO 'devicecapvalue' VALUES (48677, 726, 48, 519);
INSERT INTO 'devicecapvalue' VALUES (48678, 726, 48, 520);
INSERT INTO 'devicecapvalue' VALUES (48679, 726, 48, 521);
INSERT INTO 'devicecapvalue' VALUES (48680, 726, 48, 522);
INSERT INTO 'devicecapvalue' VALUES (48681, 726, 48, 523);
INSERT INTO 'devicecapvalue' VALUES (48682, 726, 48, 524);
INSERT INTO 'devicecapvalue' VALUES (48683, 726, 48, 525);
INSERT INTO 'devicecapvalue' VALUES (48684, 726, 48, 526);
INSERT INTO 'devicecapvalue' VALUES (48685, 726, 48, 527);
INSERT INTO 'devicecapvalue' VALUES (48686, 726, 48, 528);
INSERT INTO 'devicecapvalue' VALUES (48687, 726, 48, 529);
INSERT INTO 'devicecapvalue' VALUES (48688, 726, 48, 530);
INSERT INTO 'devicecapvalue' VALUES (48689, 726, 48, 531);
INSERT INTO 'devicecapvalue' VALUES (48690, 726, 48, 532);
INSERT INTO 'devicecapvalue' VALUES (48691, 726, 48, 533);
INSERT INTO 'devicecapvalue' VALUES (48692, 726, 48, 534);
INSERT INTO 'devicecapvalue' VALUES (48693, 726, 48, 535);
INSERT INTO 'devicecapvalue' VALUES (48694, 726, 48, 536);
INSERT INTO 'devicecapvalue' VALUES (48695, 726, 48, 537);
INSERT INTO 'devicecapvalue' VALUES (48696, 726, 48, 538);
INSERT INTO 'devicecapvalue' VALUES (48697, 726, 48, 539);
INSERT INTO 'devicecapvalue' VALUES (48698, 726, 48, 540);
INSERT INTO 'devicecapvalue' VALUES (48699, 726, 48, 541);
INSERT INTO 'devicecapvalue' VALUES (48700, 726, 48, 542);
INSERT INTO 'devicecapvalue' VALUES (48701, 726, 48, 543);
INSERT INTO 'devicecapvalue' VALUES (48702, 726, 48, 544);
INSERT INTO 'devicecapvalue' VALUES (48703, 726, 48, 545);
INSERT INTO 'devicecapvalue' VALUES (48704, 726, 48, 546);
INSERT INTO 'devicecapvalue' VALUES (48705, 726, 48, 547);
INSERT INTO 'devicecapvalue' VALUES (48706, 726, 48, 548);
INSERT INTO 'devicecapvalue' VALUES (48707, 726, 48, 549);
INSERT INTO 'devicecapvalue' VALUES (48708, 726, 48, 550);
INSERT INTO 'devicecapvalue' VALUES (48709, 726, 48, 551);
INSERT INTO 'devicecapvalue' VALUES (48710, 726, 48, 552);
INSERT INTO 'devicecapvalue' VALUES (48711, 726, 48, 553);
INSERT INTO 'devicecapvalue' VALUES (48712, 726, 48, 554);
INSERT INTO 'devicecapvalue' VALUES (48713, 726, 48, 555);
INSERT INTO 'devicecapvalue' VALUES (48714, 726, 48, 556);
INSERT INTO 'devicecapvalue' VALUES (48715, 726, 48, 557);
INSERT INTO 'devicecapvalue' VALUES (48716, 726, 48, 558);
INSERT INTO 'devicecapvalue' VALUES (48717, 726, 48, 559);
INSERT INTO 'devicecapvalue' VALUES (48718, 726, 48, 560);
INSERT INTO 'devicecapvalue' VALUES (48719, 726, 48, 561);
INSERT INTO 'devicecapvalue' VALUES (48720, 726, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (48721, 726, 48, 562);
INSERT INTO 'capvalue' VALUES (2509, '2097112');
INSERT INTO 'devicecapvalue' VALUES (48722, 726, 49, 2509);
INSERT INTO 'devicecapvalue' VALUES (48723, 726, 53, 2507);
INSERT INTO 'devicecapvalue' VALUES (48724, 727, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (48725, 727, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (48726, 727, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (48727, 727, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (48728, 727, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (48729, 727, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (48730, 727, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (48731, 727, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (48732, 727, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (48733, 727, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (48734, 727, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (48735, 727, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (48736, 727, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (48737, 727, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (48738, 727, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (48739, 727, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (48740, 727, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (48741, 727, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (48742, 727, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (48743, 727, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (48744, 727, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (48745, 727, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (48746, 727, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (48747, 727, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (48748, 727, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (48749, 727, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (48750, 727, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (48751, 727, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (48752, 727, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (48753, 727, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (48754, 727, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (48755, 727, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (48756, 727, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (48757, 727, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (48758, 727, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (48759, 727, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (48760, 727, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (48761, 727, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (48762, 727, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (48763, 727, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (48764, 727, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (48765, 727, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (48766, 727, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (48767, 727, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (48768, 727, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (48769, 727, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (48770, 727, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (48771, 727, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (48772, 727, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (48773, 727, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (48774, 727, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (48775, 727, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (48776, 728, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (48777, 728, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (48778, 728, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (48779, 728, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (48780, 728, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (48781, 728, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (48782, 728, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (48783, 728, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (48784, 728, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (48785, 728, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (48786, 728, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (48787, 728, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (48788, 728, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (48789, 729, 1, 649);
INSERT INTO 'devicecapvalue' VALUES (48790, 729, 4, 857);
INSERT INTO 'devicecapvalue' VALUES (48791, 729, 5, 646);
INSERT INTO 'devicecapvalue' VALUES (48792, 730, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (48793, 730, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (48794, 730, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (48795, 730, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (48796, 730, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (48797, 730, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (48798, 730, 75, 2429);
INSERT INTO 'devicecapvalue' VALUES (48799, 730, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (48800, 730, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (48801, 730, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (48802, 730, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (48803, 730, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (48804, 730, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (48805, 730, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (48806, 730, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (48807, 730, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (48808, 730, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (48809, 730, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (48810, 730, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (48811, 730, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (48812, 730, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (48813, 730, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (48814, 730, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (48815, 730, 16, 20);
INSERT INTO 'capvalue' VALUES (2510, 'vscl2.0');
INSERT INTO 'devicecapvalue' VALUES (48816, 730, 17, 2510);
INSERT INTO 'devicecapvalue' VALUES (48817, 730, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (48818, 730, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (48819, 730, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (48820, 730, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (48821, 730, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (48822, 730, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (48823, 730, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (48824, 730, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (48825, 730, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (48826, 730, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (48827, 730, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (48828, 730, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (48829, 730, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (48830, 730, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (48831, 730, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (48832, 730, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (48833, 730, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (48834, 730, 51, 2430);
INSERT INTO 'devicecapvalue' VALUES (48835, 730, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (48836, 730, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (48837, 730, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (48838, 730, 52, 2431);
INSERT INTO 'devicecapvalue' VALUES (48839, 730, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (48840, 730, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (48841, 730, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (48842, 730, 157, 2432);
INSERT INTO 'devicecapvalue' VALUES (48843, 730, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (48844, 730, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (48845, 730, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (48846, 730, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (48847, 730, 53, 2433);
INSERT INTO 'devicecapvalue' VALUES (48848, 731, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (48849, 731, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (48850, 731, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (48851, 731, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (48852, 731, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (48853, 731, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (48854, 731, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (48855, 731, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (48856, 731, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (48857, 731, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (48858, 731, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (48859, 731, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (48860, 731, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (48861, 731, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (48862, 731, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (48863, 731, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (48864, 731, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (48865, 731, 51, 1040);
INSERT INTO 'devicecapvalue' VALUES (48866, 731, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (48867, 731, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (48868, 731, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (48869, 731, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (48870, 731, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (48871, 731, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (48872, 731, 51, 102);
INSERT INTO 'capvalue' VALUES (2511, 'midi32');
INSERT INTO 'devicecapvalue' VALUES (48873, 731, 51, 2511);
INSERT INTO 'devicecapvalue' VALUES (48874, 731, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (48875, 731, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (48876, 731, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (48877, 731, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (48878, 731, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (48879, 731, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (48880, 732, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (48881, 732, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (48882, 732, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (48883, 732, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (48884, 732, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (48885, 732, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (48886, 732, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (48887, 732, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (48888, 732, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (48889, 732, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (48890, 732, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (48891, 732, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (48892, 732, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (48893, 732, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (48894, 732, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (48895, 732, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (48896, 732, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (48897, 732, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (48898, 732, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (48899, 732, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (48900, 732, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (48901, 732, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (48902, 732, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (48903, 732, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (48904, 732, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (48905, 732, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (48906, 732, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (48907, 732, 17, 2439);
INSERT INTO 'devicecapvalue' VALUES (48908, 732, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (48909, 732, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (48910, 732, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (48911, 732, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (48912, 732, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (48913, 732, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (48914, 732, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (48915, 732, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (48916, 732, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (48917, 732, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (48918, 732, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (48919, 732, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (48920, 732, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (48921, 732, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (48922, 732, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (48923, 732, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (48924, 732, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (48925, 732, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (48926, 732, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (48927, 732, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (48928, 732, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (48929, 732, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (48930, 732, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (48931, 732, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (48932, 732, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (48933, 732, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (48934, 732, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (48935, 732, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (48936, 732, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (48937, 732, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (48938, 732, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (48939, 732, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (48940, 732, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (48941, 733, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (48942, 733, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (48943, 733, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (48944, 733, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (48945, 733, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (48946, 733, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (48947, 733, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (48948, 733, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (48949, 733, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (48950, 733, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (48951, 733, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (48952, 733, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (48953, 733, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (48954, 733, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (48955, 733, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (48956, 733, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (48957, 733, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (48958, 733, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (48959, 733, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (48960, 733, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (48961, 733, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (48962, 733, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (48963, 733, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (48964, 733, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (48965, 733, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (48966, 733, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (48967, 733, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (48968, 733, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (48969, 733, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (48970, 733, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (48971, 733, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (48972, 733, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (48973, 733, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (48974, 733, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (48975, 733, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (48976, 733, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (48977, 733, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (48978, 733, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (48979, 733, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (48980, 733, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (48981, 733, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (48982, 733, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (48983, 733, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (48984, 733, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (48985, 733, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (48986, 733, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (48987, 733, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (48988, 733, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (48989, 733, 57, 745);
INSERT INTO 'devicecapvalue' VALUES (48990, 733, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (48991, 733, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (48992, 733, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (48993, 733, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (48994, 733, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (48995, 733, 38, 100);
INSERT INTO 'devicecapvalue' VALUES (48996, 733, 38, 880);
INSERT INTO 'devicecapvalue' VALUES (48997, 733, 38, 865);
INSERT INTO 'devicecapvalue' VALUES (48998, 733, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (48999, 733, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (49000, 733, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (49001, 733, 39, 123);
INSERT INTO 'devicecapvalue' VALUES (49002, 733, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (49003, 733, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (49004, 733, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (49005, 733, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (49006, 733, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (49007, 733, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (49008, 733, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (49009, 733, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (49010, 733, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (49011, 733, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (49012, 733, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (49013, 733, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (49014, 733, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (49015, 733, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (49016, 733, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (49017, 733, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (49018, 733, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (49019, 733, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (49020, 733, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (49021, 733, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (49022, 733, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (49023, 733, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (49024, 733, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (49025, 733, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (49026, 733, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (49027, 733, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (49028, 733, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (49029, 733, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (49030, 733, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (49031, 733, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (49032, 733, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (49033, 733, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (49034, 733, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (49035, 733, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (49036, 733, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (49037, 733, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (49038, 733, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (49039, 733, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (49040, 733, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (49041, 733, 41, 123);
INSERT INTO 'devicecapvalue' VALUES (49042, 733, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (49043, 733, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (49044, 733, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (49045, 733, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (49046, 733, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (49047, 733, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (49048, 733, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (49049, 733, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (49050, 733, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (49051, 733, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (49052, 733, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (49053, 733, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (49054, 733, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (49055, 733, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (49056, 733, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (49057, 733, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (49058, 733, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (49059, 733, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (49060, 733, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (49061, 733, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (49062, 733, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (49063, 733, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (49064, 733, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (49065, 733, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (49066, 733, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (49067, 733, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (49068, 733, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (49069, 733, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (49070, 733, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (49071, 733, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (49072, 733, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (49073, 733, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (49074, 733, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (49075, 733, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (49076, 733, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (49077, 733, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (49078, 733, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (49079, 733, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (49080, 733, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (49081, 733, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (49082, 733, 42, 123);
INSERT INTO 'devicecapvalue' VALUES (49083, 733, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (49084, 733, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (49085, 733, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (49086, 733, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (49087, 733, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (49088, 733, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (49089, 733, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (49090, 733, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (49091, 733, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (49092, 733, 45, 2448);
INSERT INTO 'devicecapvalue' VALUES (49093, 733, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (49094, 733, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (49095, 733, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (49096, 733, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (49097, 733, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (49098, 733, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (49099, 733, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (49100, 733, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (49101, 733, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (49102, 733, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (49103, 733, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (49104, 733, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (49105, 733, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (49106, 733, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (49107, 733, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (49108, 733, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (49109, 733, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (49110, 733, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (49111, 733, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (49112, 733, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (49113, 733, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (49114, 733, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (49115, 733, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (49116, 733, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (49117, 733, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (49118, 733, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (49119, 733, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (49120, 733, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (49121, 733, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (49122, 733, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (49123, 733, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (49124, 733, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (49125, 733, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (49126, 733, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (49127, 733, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (49128, 733, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (49129, 733, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (49130, 733, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (49131, 733, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (49132, 733, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (49133, 733, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (49134, 733, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (49135, 733, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (49136, 733, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (49137, 733, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (49138, 733, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (49139, 733, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (49140, 733, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (49141, 733, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (49142, 733, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (49143, 733, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (49144, 733, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (49145, 733, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (49146, 733, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (49147, 733, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (49148, 733, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (49149, 733, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (49150, 733, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (49151, 733, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (49152, 733, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (49153, 733, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (49154, 733, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (49155, 733, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (49156, 733, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (49157, 733, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (49158, 733, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (49159, 733, 115, 100);
INSERT INTO 'devicecapvalue' VALUES (49160, 733, 115, 880);
INSERT INTO 'devicecapvalue' VALUES (49161, 733, 115, 865);
INSERT INTO 'devicecapvalue' VALUES (49162, 733, 197, 2335);
INSERT INTO 'devicecapvalue' VALUES (49163, 733, 141, 1096);
INSERT INTO 'devicecapvalue' VALUES (49164, 733, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (49165, 733, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (49166, 733, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (49167, 733, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (49168, 733, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (49169, 733, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (49170, 733, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (49171, 733, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (49172, 733, 125, 707);
INSERT INTO 'devicecapvalue' VALUES (49173, 733, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (49174, 733, 142, 2336);
INSERT INTO 'devicecapvalue' VALUES (49175, 733, 143, 2497);
INSERT INTO 'devicecapvalue' VALUES (49176, 733, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (49177, 733, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (49178, 733, 102, 1926);
INSERT INTO 'devicecapvalue' VALUES (49179, 733, 103, 2338);
INSERT INTO 'devicecapvalue' VALUES (49180, 733, 104, 2339);
INSERT INTO 'capvalue' VALUES (2512, 'file:///c:/system/ams_app/j40e359b29cdd3c52c0407a8bbeed4813d2a1aa31/');
INSERT INTO 'devicecapvalue' VALUES (49181, 733, 105, 2512);
INSERT INTO 'devicecapvalue' VALUES (49182, 733, 106, 2341);
INSERT INTO 'devicecapvalue' VALUES (49183, 733, 107, 2342);
INSERT INTO 'devicecapvalue' VALUES (49184, 733, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (49185, 733, 109, 946);
INSERT INTO 'devicecapvalue' VALUES (49186, 733, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (49187, 733, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (49188, 733, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (49189, 733, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (49190, 733, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (49191, 733, 145, 45);
INSERT INTO 'devicecapvalue' VALUES (49192, 733, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (49193, 733, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (49194, 733, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (49195, 733, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (49196, 733, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (49197, 733, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (49198, 733, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (49199, 733, 131, 45);
INSERT INTO 'devicecapvalue' VALUES (49200, 733, 251, 242);
INSERT INTO 'devicecapvalue' VALUES (49201, 733, 67, 45);
INSERT INTO 'capvalue' VALUES (2513, 'SonyEricssonV640i/R1CA029');
INSERT INTO 'devicecapvalue' VALUES (49202, 733, 68, 2513);
INSERT INTO 'devicecapvalue' VALUES (49203, 733, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (49204, 733, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (49205, 733, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (49206, 733, 205, 45);
INSERT INTO 'devicecapvalue' VALUES (49207, 733, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (49208, 733, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (49209, 733, 132, 100);
INSERT INTO 'devicecapvalue' VALUES (49210, 733, 132, 880);
INSERT INTO 'devicecapvalue' VALUES (49211, 733, 132, 865);
INSERT INTO 'devicecapvalue' VALUES (49212, 733, 133, 2448);
INSERT INTO 'devicecapvalue' VALUES (49213, 733, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (49214, 733, 116, 2075);
INSERT INTO 'devicecapvalue' VALUES (49215, 733, 116, 1280);
INSERT INTO 'devicecapvalue' VALUES (49216, 733, 116, 123);
INSERT INTO 'devicecapvalue' VALUES (49217, 733, 116, 2319);
INSERT INTO 'devicecapvalue' VALUES (49218, 733, 116, 1283);
INSERT INTO 'devicecapvalue' VALUES (49219, 733, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (49220, 733, 149, 1751);
INSERT INTO 'devicecapvalue' VALUES (49221, 733, 149, 949);
INSERT INTO 'capvalue' VALUES (2514, 'imageencoding');
INSERT INTO 'devicecapvalue' VALUES (49222, 733, 149, 2514);
INSERT INTO 'capvalue' VALUES (2515, 'imagepostprocessing');
INSERT INTO 'devicecapvalue' VALUES (49223, 733, 149, 2515);
INSERT INTO 'devicecapvalue' VALUES (49224, 733, 149, 1752);
INSERT INTO 'capvalue' VALUES (2516, 'tuner');
INSERT INTO 'devicecapvalue' VALUES (49225, 733, 149, 2516);
INSERT INTO 'devicecapvalue' VALUES (49226, 733, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (49227, 733, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (49228, 733, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (49229, 733, 252, 2347);
INSERT INTO 'devicecapvalue' VALUES (49230, 733, 136, 2448);
INSERT INTO 'devicecapvalue' VALUES (49231, 733, 137, 2352);
INSERT INTO 'capvalue' VALUES (2517, 'http://mms.sonofon.dk');
INSERT INTO 'devicecapvalue' VALUES (49232, 733, 138, 2517);
INSERT INTO 'capvalue' VALUES (2518, '+4540590000');
INSERT INTO 'devicecapvalue' VALUES (49233, 733, 72, 2518);
INSERT INTO 'devicecapvalue' VALUES (49234, 733, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (49235, 733, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (49236, 733, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (49237, 733, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (49238, 733, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (49239, 733, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (49240, 733, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (49241, 733, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (49242, 733, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (49243, 733, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (49244, 733, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (49245, 733, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (49246, 733, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (49247, 733, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (49248, 733, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (49249, 733, 47, 123);
INSERT INTO 'devicecapvalue' VALUES (49250, 733, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (49251, 733, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (49252, 733, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (49253, 733, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (49254, 733, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (49255, 733, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (49256, 733, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (49257, 733, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (49258, 733, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (49259, 733, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (49260, 733, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (49261, 733, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (49262, 733, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (49263, 733, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (49264, 733, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (49265, 733, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (49266, 733, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (49267, 733, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (49268, 733, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (49269, 733, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (49270, 733, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (49271, 733, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (49272, 733, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (49273, 733, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (49274, 733, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (49275, 733, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (49276, 733, 48, 144);
INSERT INTO 'devicecapvalue' VALUES (49277, 733, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (49278, 733, 49, 659);
INSERT INTO 'devicecapvalue' VALUES (49279, 733, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (49280, 733, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (49281, 733, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (49282, 733, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (49283, 733, 157, 2426);
INSERT INTO 'capvalue' VALUES (2519, 'Mozilla/4.0 SonyEricssonV640iv/R1CA Browser/NetFront/3.4 Profile/MIDP-2.1 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (49284, 733, 53, 2519);
INSERT INTO 'devicecapvalue' VALUES (49285, 734, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (49286, 734, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (49287, 734, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (49288, 734, 7, 1304);
INSERT INTO 'devicecapvalue' VALUES (49289, 734, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (49290, 734, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (49291, 734, 173, 1523);
INSERT INTO 'capvalue' VALUES (2520, 'SonyEricsson_V800');
INSERT INTO 'devicecapvalue' VALUES (49292, 734, 75, 2520);
INSERT INTO 'devicecapvalue' VALUES (49293, 734, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (49294, 734, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (49295, 734, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (49296, 734, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (49297, 734, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (49298, 734, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (49299, 734, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (49300, 734, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (49301, 734, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (49302, 734, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (49303, 734, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (49304, 734, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (49305, 734, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (49306, 734, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (49307, 734, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (49308, 734, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (49309, 734, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (49310, 734, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (49311, 734, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49312, 734, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (49313, 734, 17, 2510);
INSERT INTO 'devicecapvalue' VALUES (49314, 734, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49315, 734, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (49316, 734, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (49317, 734, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (49318, 734, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (49319, 734, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (49320, 734, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (49321, 734, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (49322, 734, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (49323, 734, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (49324, 734, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (49325, 734, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (49326, 734, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (49327, 734, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (49328, 734, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (49329, 734, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (49330, 734, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (49331, 734, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (49332, 734, 51, 2430);
INSERT INTO 'devicecapvalue' VALUES (49333, 734, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (49334, 734, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (49335, 734, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (49336, 734, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (49337, 734, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (49338, 734, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (49339, 734, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (49340, 734, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (49341, 734, 191, 1372);
INSERT INTO 'capvalue' VALUES (2521, 'Vodafone/SonyEricssonV800_opera');
INSERT INTO 'devicecapvalue' VALUES (49342, 734, 53, 2521);
INSERT INTO 'devicecapvalue' VALUES (49343, 735, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (49344, 735, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (49345, 735, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (49346, 735, 7, 1304);
INSERT INTO 'devicecapvalue' VALUES (49347, 735, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (49348, 735, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (49349, 735, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (49350, 735, 75, 2520);
INSERT INTO 'devicecapvalue' VALUES (49351, 735, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (49352, 735, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (49353, 735, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (49354, 735, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (49355, 735, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (49356, 735, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (49357, 735, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (49358, 735, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (49359, 735, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (49360, 735, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (49361, 735, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (49362, 735, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (49363, 735, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (49364, 735, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (49365, 735, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (49366, 735, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (49367, 735, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (49368, 735, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (49369, 735, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49370, 735, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (49371, 735, 17, 2510);
INSERT INTO 'devicecapvalue' VALUES (49372, 735, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49373, 735, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (49374, 735, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (49375, 735, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (49376, 735, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (49377, 735, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (49378, 735, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (49379, 735, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (49380, 735, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (49381, 735, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (49382, 735, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (49383, 735, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (49384, 735, 156, 1176);
INSERT INTO 'devicecapvalue' VALUES (49385, 735, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (49386, 735, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (49387, 735, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (49388, 735, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (49389, 735, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (49390, 735, 51, 2430);
INSERT INTO 'devicecapvalue' VALUES (49391, 735, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (49392, 735, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (49393, 735, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (49394, 735, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (49395, 735, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (49396, 735, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (49397, 735, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (49398, 735, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (49399, 735, 191, 1372);
INSERT INTO 'capvalue' VALUES (2522, 'Vodafone/R4.5/SEMC_V800/EU_1 SonyEricssonVodafone-802SE/R1A Browser/SEMC-Browser/4.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (49400, 735, 53, 2522);
INSERT INTO 'devicecapvalue' VALUES (49401, 736, 1, 625);
INSERT INTO 'devicecapvalue' VALUES (49402, 736, 173, 2477);
INSERT INTO 'devicecapvalue' VALUES (49403, 736, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (49404, 736, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (49405, 736, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (49406, 736, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (49407, 736, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (49408, 736, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (49409, 736, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (49410, 736, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (49411, 736, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (49412, 736, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (49413, 736, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (49414, 736, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (49415, 736, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (49416, 736, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (49417, 736, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (49418, 736, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (49419, 736, 15, 706);
INSERT INTO 'capvalue' VALUES (2523, 'swfg');
INSERT INTO 'devicecapvalue' VALUES (49420, 736, 15, 2523);
INSERT INTO 'devicecapvalue' VALUES (49421, 736, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (49422, 736, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (49423, 736, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49424, 736, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (49425, 736, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (49426, 736, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (49427, 736, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49428, 736, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (49429, 736, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (49430, 736, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (49431, 736, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (49432, 736, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (49433, 736, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (49434, 736, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (49435, 736, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (49436, 736, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (49437, 736, 51, 669);
INSERT INTO 'capvalue' VALUES (2524, '28311552');
INSERT INTO 'devicecapvalue' VALUES (49438, 736, 52, 2524);
INSERT INTO 'devicecapvalue' VALUES (49439, 736, 157, 975);
INSERT INTO 'devicecapvalue' VALUES (49440, 736, 157, 1026);
INSERT INTO 'capvalue' VALUES (2525, '128x96');
INSERT INTO 'devicecapvalue' VALUES (49441, 737, 7, 2525);
INSERT INTO 'devicecapvalue' VALUES (49442, 737, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (49443, 737, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (49444, 737, 9, 109);
INSERT INTO 'devicecapvalue' VALUES (49445, 737, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (49446, 737, 11, 109);
INSERT INTO 'devicecapvalue' VALUES (49447, 737, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (49448, 737, 13, 1330);
INSERT INTO 'devicecapvalue' VALUES (49449, 737, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (49450, 737, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (49451, 737, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (49452, 737, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (49453, 737, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (49454, 737, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (49455, 737, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49456, 737, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (49457, 737, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49458, 737, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (49459, 737, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (49460, 737, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (49461, 737, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (49462, 737, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49463, 737, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49464, 737, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (49465, 737, 6, 2063);
INSERT INTO 'devicecapvalue' VALUES (49466, 737, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (49467, 737, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (49468, 737, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (49469, 737, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (49470, 737, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (49471, 737, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (49472, 737, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (49473, 737, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (49474, 737, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (49475, 737, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (49476, 737, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (49477, 737, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (49478, 737, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (49479, 737, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (49480, 737, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (49481, 737, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (49482, 737, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (49483, 737, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (49484, 737, 35, 45);
INSERT INTO 'capvalue' VALUES (2526, 'SonyEricssonW200i/R4JA011');
INSERT INTO 'devicecapvalue' VALUES (49485, 737, 36, 2526);
INSERT INTO 'devicecapvalue' VALUES (49486, 737, 37, 2390);
INSERT INTO 'devicecapvalue' VALUES (49487, 737, 38, 2449);
INSERT INTO 'devicecapvalue' VALUES (49488, 737, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (49489, 737, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (49490, 737, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (49491, 737, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (49492, 737, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (49493, 737, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (49494, 737, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (49495, 737, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (49496, 737, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (49497, 737, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (49498, 737, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (49499, 737, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (49500, 737, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (49501, 737, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (49502, 737, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (49503, 737, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (49504, 737, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (49505, 737, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (49506, 737, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (49507, 737, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (49508, 737, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (49509, 737, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (49510, 737, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (49511, 737, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (49512, 737, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (49513, 737, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (49514, 737, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (49515, 737, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (49516, 737, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (49517, 737, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (49518, 737, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (49519, 737, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (49520, 737, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (49521, 737, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (49522, 737, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (49523, 737, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (49524, 737, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (49525, 737, 41, 123);
INSERT INTO 'devicecapvalue' VALUES (49526, 737, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (49527, 737, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (49528, 737, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (49529, 737, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (49530, 737, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (49531, 737, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (49532, 737, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (49533, 737, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (49534, 737, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (49535, 737, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (49536, 737, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (49537, 737, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (49538, 737, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (49539, 737, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (49540, 737, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (49541, 737, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (49542, 737, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (49543, 737, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (49544, 737, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (49545, 737, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (49546, 737, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (49547, 737, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (49548, 737, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (49549, 737, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (49550, 737, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (49551, 737, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (49552, 737, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (49553, 737, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (49554, 737, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (49555, 737, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (49556, 737, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (49557, 737, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (49558, 737, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (49559, 737, 42, 123);
INSERT INTO 'devicecapvalue' VALUES (49560, 737, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (49561, 737, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (49562, 737, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (49563, 737, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (49564, 737, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (49565, 737, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (49566, 737, 45, 2090);
INSERT INTO 'devicecapvalue' VALUES (49567, 737, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (49568, 737, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (49569, 737, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (49570, 737, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (49571, 737, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (49572, 737, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (49573, 737, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (49574, 737, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (49575, 737, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (49576, 737, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (49577, 737, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (49578, 737, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (49579, 737, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (49580, 737, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (49581, 737, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (49582, 737, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (49583, 737, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (49584, 737, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (49585, 737, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (49586, 737, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (49587, 737, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (49588, 737, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (49589, 737, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (49590, 737, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (49591, 737, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (49592, 737, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (49593, 737, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (49594, 737, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (49595, 737, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (49596, 737, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (49597, 737, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (49598, 737, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (49599, 737, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (49600, 737, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (49601, 737, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (49602, 737, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (49603, 737, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (49604, 737, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (49605, 737, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (49606, 737, 47, 123);
INSERT INTO 'devicecapvalue' VALUES (49607, 737, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (49608, 737, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (49609, 737, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (49610, 737, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (49611, 737, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (49612, 737, 48, 167);
INSERT INTO 'devicecapvalue' VALUES (49613, 737, 48, 92);
INSERT INTO 'capvalue' VALUES (2527, '1048544');
INSERT INTO 'devicecapvalue' VALUES (49614, 737, 49, 2527);
INSERT INTO 'capvalue' VALUES (2528, 'SonyEricssonW200i/R4JA Browser/NetFront/3.3 Profile/MIDP-2.0');
INSERT INTO 'devicecapvalue' VALUES (49615, 737, 53, 2528);
INSERT INTO 'devicecapvalue' VALUES (49616, 738, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (49617, 738, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (49618, 738, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (49619, 738, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (49620, 738, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (49621, 738, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (49622, 738, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (49623, 738, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (49624, 738, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (49625, 738, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (49626, 738, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (49627, 738, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (49628, 738, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (49629, 738, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (49630, 738, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (49631, 738, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (49632, 738, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49633, 738, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (49634, 738, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (49635, 738, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (49636, 738, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (49637, 738, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49638, 738, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49639, 738, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (49640, 738, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (49641, 738, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (49642, 738, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (49643, 738, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (49644, 738, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (49645, 738, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (49646, 738, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (49647, 738, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (49648, 738, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (49649, 738, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (49650, 738, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (49651, 738, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (49652, 738, 51, 2436);
INSERT INTO 'devicecapvalue' VALUES (49653, 738, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (49654, 738, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (49655, 738, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (49656, 738, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (49657, 738, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (49658, 738, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (49659, 738, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (49660, 738, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (49661, 738, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (49662, 738, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (49663, 738, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (49664, 738, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (49665, 738, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (49666, 739, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (49667, 739, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (49668, 739, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (49669, 739, 79, 15);
INSERT INTO 'devicecapvalue' VALUES (49670, 739, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (49671, 739, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (49672, 739, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (49673, 739, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (49674, 739, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (49675, 739, 80, 602);
INSERT INTO 'cap' VALUES (266, 'fileconn.dir.memorycard', 1);
INSERT INTO 'devicecapvalue' VALUES (49676, 739, 266, 1469);
INSERT INTO 'cap' VALUES (267, 'fileconn.dir.photos', 1);
INSERT INTO 'capvalue' VALUES (2529, 'file:///c:/pictures/camera_semc/');
INSERT INTO 'devicecapvalue' VALUES (49677, 739, 267, 2529);
INSERT INTO 'cap' VALUES (268, 'fileconn.dir.photos.name', 1);
INSERT INTO 'capvalue' VALUES (2530, 'camera_semc/');
INSERT INTO 'devicecapvalue' VALUES (49678, 739, 268, 2530);
INSERT INTO 'cap' VALUES (269, 'fileconn.dir.tones', 1);
INSERT INTO 'capvalue' VALUES (2531, 'file:///c:/sounds/');
INSERT INTO 'devicecapvalue' VALUES (49679, 739, 269, 2531);
INSERT INTO 'cap' VALUES (270, 'fileconn.dir.tones.name', 1);
INSERT INTO 'capvalue' VALUES (2532, 'sounds/');
INSERT INTO 'devicecapvalue' VALUES (49680, 739, 270, 2532);
INSERT INTO 'cap' VALUES (271, 'fileconn.dir.videos', 1);
INSERT INTO 'devicecapvalue' VALUES (49681, 739, 271, 2343);
INSERT INTO 'cap' VALUES (272, 'fileconn.dir.videos.name', 1);
INSERT INTO 'capvalue' VALUES (2533, 'videos/');
INSERT INTO 'devicecapvalue' VALUES (49682, 739, 272, 2533);
INSERT INTO 'devicecapvalue' VALUES (49683, 739, 9, 109);
INSERT INTO 'devicecapvalue' VALUES (49684, 739, 10, 603);
INSERT INTO 'devicecapvalue' VALUES (49685, 739, 11, 109);
INSERT INTO 'devicecapvalue' VALUES (49686, 739, 12, 711);
INSERT INTO 'devicecapvalue' VALUES (49687, 739, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (49688, 739, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (49689, 739, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (49690, 739, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (49691, 739, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (49692, 739, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (49693, 739, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (49694, 739, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49695, 739, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (49696, 739, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (49697, 739, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49698, 739, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (49699, 739, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (49700, 739, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (49701, 739, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (49702, 739, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49703, 739, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49704, 739, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (49705, 739, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (49706, 739, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (49707, 739, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (49708, 739, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (49709, 739, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (49710, 739, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (49711, 739, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (49712, 739, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (49713, 739, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (49714, 739, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (49715, 739, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (49716, 739, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (49717, 739, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (49718, 739, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (49719, 739, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (49720, 739, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (49721, 739, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (49722, 739, 57, 1245);
INSERT INTO 'devicecapvalue' VALUES (49723, 739, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (49724, 739, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (49725, 739, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (49726, 739, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (49727, 739, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (49728, 739, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (49729, 739, 81, 45);
INSERT INTO 'devicecapvalue' VALUES (49730, 739, 35, 45);
INSERT INTO 'devicecapvalue' VALUES (49731, 739, 152, 45);
INSERT INTO 'devicecapvalue' VALUES (49732, 739, 83, 242);
INSERT INTO 'devicecapvalue' VALUES (49733, 739, 84, 45);
INSERT INTO 'capvalue' VALUES (2534, 'SonyEricssonW300i/R4EA031');
INSERT INTO 'devicecapvalue' VALUES (49734, 739, 36, 2534);
INSERT INTO 'devicecapvalue' VALUES (49735, 739, 37, 2390);
INSERT INTO 'devicecapvalue' VALUES (49736, 739, 38, 49);
INSERT INTO 'capvalue' VALUES (2535, 'audio/amr-nb');
INSERT INTO 'devicecapvalue' VALUES (49737, 739, 38, 2535);
INSERT INTO 'devicecapvalue' VALUES (49738, 739, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (49739, 739, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (49740, 739, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (49741, 739, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (49742, 739, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (49743, 739, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (49744, 739, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (49745, 739, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (49746, 739, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (49747, 739, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (49748, 739, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (49749, 739, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (49750, 739, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (49751, 739, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (49752, 739, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (49753, 739, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (49754, 739, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (49755, 739, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (49756, 739, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (49757, 739, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (49758, 739, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (49759, 739, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (49760, 739, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (49761, 739, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (49762, 739, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (49763, 739, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (49764, 739, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (49765, 739, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (49766, 739, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (49767, 739, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (49768, 739, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (49769, 739, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (49770, 739, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (49771, 739, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (49772, 739, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (49773, 739, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (49774, 739, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (49775, 739, 41, 123);
INSERT INTO 'devicecapvalue' VALUES (49776, 739, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (49777, 739, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (49778, 739, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (49779, 739, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (49780, 739, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (49781, 739, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (49782, 739, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (49783, 739, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (49784, 739, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (49785, 739, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (49786, 739, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (49787, 739, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (49788, 739, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (49789, 739, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (49790, 739, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (49791, 739, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (49792, 739, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (49793, 739, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (49794, 739, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (49795, 739, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (49796, 739, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (49797, 739, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (49798, 739, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (49799, 739, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (49800, 739, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (49801, 739, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (49802, 739, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (49803, 739, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (49804, 739, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (49805, 739, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (49806, 739, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (49807, 739, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (49808, 739, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (49809, 739, 42, 123);
INSERT INTO 'devicecapvalue' VALUES (49810, 739, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (49811, 739, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (49812, 739, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (49813, 739, 42, 888);
INSERT INTO 'capvalue' VALUES (2536, 'video/jpeg');
INSERT INTO 'devicecapvalue' VALUES (49814, 739, 45, 2536);
INSERT INTO 'devicecapvalue' VALUES (49815, 739, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (49816, 739, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (49817, 739, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (49818, 739, 135, 15);
INSERT INTO 'capvalue' VALUES (2537, 'jpeg&width=120&height=160');
INSERT INTO 'devicecapvalue' VALUES (49819, 739, 137, 2537);
INSERT INTO 'capvalue' VALUES (2538, 'jpeg&width=240&height=320');
INSERT INTO 'devicecapvalue' VALUES (49820, 739, 137, 2538);
INSERT INTO 'devicecapvalue' VALUES (49821, 739, 137, 2453);
INSERT INTO 'devicecapvalue' VALUES (49822, 739, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (49823, 739, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (49824, 739, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (49825, 739, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (49826, 739, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (49827, 739, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (49828, 739, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (49829, 739, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (49830, 739, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (49831, 739, 47, 123);
INSERT INTO 'devicecapvalue' VALUES (49832, 739, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (49833, 739, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (49834, 739, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (49835, 739, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (49836, 739, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (49837, 739, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (49838, 739, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (49839, 739, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (49840, 739, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (49841, 739, 51, 2436);
INSERT INTO 'devicecapvalue' VALUES (49842, 739, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (49843, 739, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (49844, 739, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (49845, 739, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (49846, 739, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (49847, 739, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (49848, 739, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (49849, 739, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (49850, 739, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (49851, 739, 52, 683);
INSERT INTO 'devicecapvalue' VALUES (49852, 739, 87, 15);
INSERT INTO 'devicecapvalue' VALUES (49853, 739, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (49854, 739, 48, 144);
INSERT INTO 'devicecapvalue' VALUES (49855, 739, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (49856, 739, 49, 2527);
INSERT INTO 'devicecapvalue' VALUES (49857, 739, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (49858, 739, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (49859, 739, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (49860, 739, 53, 998);
INSERT INTO 'cap' VALUES (273, 'wireless.messaging.mms.mmsc', 1);
INSERT INTO 'capvalue' VALUES (2539, 'http://mms.tim.it/servlets/mms');
INSERT INTO 'devicecapvalue' VALUES (49861, 739, 273, 2539);
INSERT INTO 'cap' VALUES (274, 'wireless.messaging.sms.smsc', 1);
INSERT INTO 'capvalue' VALUES (2540, '+393359609600');
INSERT INTO 'devicecapvalue' VALUES (49862, 739, 274, 2540);
INSERT INTO 'devicecapvalue' VALUES (49863, 740, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (49864, 740, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (49865, 740, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (49866, 740, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (49867, 740, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (49868, 740, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (49869, 740, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (49870, 740, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (49871, 740, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (49872, 740, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (49873, 740, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (49874, 740, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (49875, 740, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (49876, 740, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (49877, 740, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (49878, 740, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (49879, 740, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (49880, 740, 15, 706);
INSERT INTO 'capvalue' VALUES (2541, 'swf');
INSERT INTO 'devicecapvalue' VALUES (49881, 740, 15, 2541);
INSERT INTO 'devicecapvalue' VALUES (49882, 740, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (49883, 740, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (49884, 740, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49885, 740, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (49886, 740, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (49887, 740, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (49888, 740, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49889, 740, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (49890, 740, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (49891, 740, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (49892, 740, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (49893, 740, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (49894, 740, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (49895, 740, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (49896, 740, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (49897, 740, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (49898, 740, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (49899, 740, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (49900, 740, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (49901, 740, 52, 1738);
INSERT INTO 'devicecapvalue' VALUES (49902, 741, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (49903, 741, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (49904, 741, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (49905, 741, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (49906, 741, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (49907, 741, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (49908, 741, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (49909, 741, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (49910, 741, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (49911, 741, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (49912, 741, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (49913, 741, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (49914, 741, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (49915, 741, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (49916, 741, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (49917, 741, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (49918, 741, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (49919, 741, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (49920, 741, 15, 2541);
INSERT INTO 'devicecapvalue' VALUES (49921, 741, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (49922, 741, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (49923, 741, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49924, 741, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (49925, 741, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (49926, 741, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (49927, 741, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49928, 741, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (49929, 741, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (49930, 741, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (49931, 741, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (49932, 741, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (49933, 741, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (49934, 741, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (49935, 741, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (49936, 741, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (49937, 741, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (49938, 741, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (49939, 741, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (49940, 741, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (49941, 741, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (49942, 741, 52, 1738);
INSERT INTO 'devicecapvalue' VALUES (49943, 742, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (49944, 742, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (49945, 742, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (49946, 742, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (49947, 742, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (49948, 742, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (49949, 742, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (49950, 742, 13, 1950);
INSERT INTO 'devicecapvalue' VALUES (49951, 742, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (49952, 742, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (49953, 742, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (49954, 742, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (49955, 742, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (49956, 742, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (49957, 742, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49958, 742, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (49959, 742, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (49960, 742, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (49961, 742, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (49962, 742, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (49963, 742, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (49964, 742, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49965, 742, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (49966, 742, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (49967, 742, 6, 2063);
INSERT INTO 'devicecapvalue' VALUES (49968, 742, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (49969, 742, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (49970, 742, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (49971, 742, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (49972, 742, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (49973, 742, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (49974, 742, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (49975, 742, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (49976, 742, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (49977, 742, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (49978, 742, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (49979, 742, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (49980, 742, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (49981, 742, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (49982, 742, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (49983, 742, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (49984, 742, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (49985, 742, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (49986, 742, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (49987, 742, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (49988, 742, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (49989, 742, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (49990, 742, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (49991, 742, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (49992, 742, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (49993, 742, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (49994, 742, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (49995, 742, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (49996, 742, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (49997, 742, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (49998, 742, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (49999, 742, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (50000, 742, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (50001, 742, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (50002, 742, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (50003, 742, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (50004, 742, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (50005, 742, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (50006, 742, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (50007, 742, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (50008, 742, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (50009, 742, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (50010, 742, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (50011, 742, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (50012, 742, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (50013, 742, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (50014, 742, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (50015, 742, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (50016, 742, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (50017, 742, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (50018, 742, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (50019, 742, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (50020, 742, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (50021, 742, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (50022, 742, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (50023, 742, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (50024, 742, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (50025, 742, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (50026, 742, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (50027, 742, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (50028, 742, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (50029, 742, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (50030, 742, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (50031, 742, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (50032, 742, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (50033, 742, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (50034, 742, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (50035, 742, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (50036, 742, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (50037, 742, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (50038, 742, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (50039, 742, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (50040, 742, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (50041, 742, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (50042, 742, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (50043, 742, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (50044, 742, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (50045, 742, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (50046, 742, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (50047, 742, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (50048, 742, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (50049, 742, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (50050, 742, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (50051, 742, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (50052, 742, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (50053, 742, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (50054, 742, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (50055, 742, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (50056, 742, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (50057, 742, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (50058, 742, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (50059, 742, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (50060, 742, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (50061, 742, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (50062, 742, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (50063, 742, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (50064, 742, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (50065, 742, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (50066, 742, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (50067, 742, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (50068, 742, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (50069, 742, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (50070, 742, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (50071, 742, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (50072, 742, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (50073, 742, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (50074, 742, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (50075, 742, 48, 174);
INSERT INTO 'devicecapvalue' VALUES (50076, 742, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (50077, 742, 49, 659);
INSERT INTO 'devicecapvalue' VALUES (50078, 743, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (50079, 743, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (50080, 743, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (50081, 743, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (50082, 743, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (50083, 743, 173, 1688);
INSERT INTO 'capvalue' VALUES (2542, 'SonyEricsson_W600');
INSERT INTO 'devicecapvalue' VALUES (50084, 743, 75, 2542);
INSERT INTO 'devicecapvalue' VALUES (50085, 743, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (50086, 743, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (50087, 743, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (50088, 743, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (50089, 743, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (50090, 743, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (50091, 743, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (50092, 743, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (50093, 743, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (50094, 743, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (50095, 743, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (50096, 743, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (50097, 743, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (50098, 743, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (50099, 743, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50100, 743, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (50101, 743, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (50102, 743, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (50103, 743, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (50104, 743, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50105, 743, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (50106, 743, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (50107, 743, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (50108, 743, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (50109, 743, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (50110, 743, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (50111, 743, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (50112, 743, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (50113, 743, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (50114, 743, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (50115, 743, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (50116, 743, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (50117, 743, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (50118, 743, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (50119, 743, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (50120, 743, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (50121, 743, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (50122, 743, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (50123, 743, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (50124, 743, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (50125, 743, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (50126, 743, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (50127, 743, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (50128, 743, 51, 669);
INSERT INTO 'capvalue' VALUES (2543, '268435456');
INSERT INTO 'devicecapvalue' VALUES (50129, 743, 52, 2543);
INSERT INTO 'devicecapvalue' VALUES (50130, 743, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (50131, 743, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (50132, 743, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (50133, 743, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (50134, 744, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (50135, 744, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (50136, 744, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (50137, 744, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (50138, 744, 160, 2460);
INSERT INTO 'devicecapvalue' VALUES (50139, 744, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (50140, 744, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (50141, 744, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (50142, 744, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (50143, 744, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (50144, 744, 75, 2461);
INSERT INTO 'devicecapvalue' VALUES (50145, 744, 261, 2462);
INSERT INTO 'devicecapvalue' VALUES (50146, 744, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (50147, 744, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (50148, 744, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (50149, 744, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (50150, 744, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (50151, 744, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (50152, 744, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (50153, 744, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (50154, 744, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (50155, 744, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (50156, 744, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (50157, 744, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (50158, 744, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (50159, 744, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (50160, 744, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (50161, 744, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (50162, 744, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (50163, 744, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (50164, 744, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (50165, 744, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (50166, 744, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (50167, 744, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (50168, 744, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (50169, 744, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (50170, 744, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (50171, 744, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (50172, 744, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (50173, 744, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50174, 744, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (50175, 744, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (50176, 744, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (50177, 744, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (50178, 744, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (50179, 744, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50180, 744, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (50181, 744, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (50182, 744, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (50183, 744, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (50184, 744, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (50185, 744, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (50186, 744, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (50187, 744, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (50188, 744, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (50189, 744, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (50190, 744, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (50191, 744, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (50192, 744, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (50193, 744, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (50194, 744, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (50195, 744, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (50196, 744, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (50197, 744, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (50198, 744, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (50199, 744, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (50200, 744, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (50201, 744, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (50202, 744, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (50203, 744, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (50204, 744, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (50205, 744, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (50206, 744, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (50207, 744, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (50208, 744, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (50209, 744, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (50210, 744, 191, 1372);
INSERT INTO 'capvalue' VALUES (2544, 'SonyEricssonW580/1.0 (05.02) Profile/MIDP-1.0 Configuration/CLDC-1.0');
INSERT INTO 'devicecapvalue' VALUES (50211, 744, 53, 2544);
INSERT INTO 'devicecapvalue' VALUES (50212, 745, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (50213, 745, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (50214, 745, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (50215, 745, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (50216, 745, 160, 2460);
INSERT INTO 'devicecapvalue' VALUES (50217, 745, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (50218, 745, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (50219, 745, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (50220, 745, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (50221, 745, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (50222, 745, 75, 2461);
INSERT INTO 'devicecapvalue' VALUES (50223, 745, 261, 2462);
INSERT INTO 'devicecapvalue' VALUES (50224, 745, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (50225, 745, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (50226, 745, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (50227, 745, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (50228, 745, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (50229, 745, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (50230, 745, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (50231, 745, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (50232, 745, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (50233, 745, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (50234, 745, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (50235, 745, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (50236, 745, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (50237, 745, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (50238, 745, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (50239, 745, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (50240, 745, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (50241, 745, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (50242, 745, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (50243, 745, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (50244, 745, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (50245, 745, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (50246, 745, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (50247, 745, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (50248, 745, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (50249, 745, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (50250, 745, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (50251, 745, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50252, 745, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (50253, 745, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (50254, 745, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (50255, 745, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (50256, 745, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (50257, 745, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50258, 745, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (50259, 745, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (50260, 745, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (50261, 745, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (50262, 745, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (50263, 745, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (50264, 745, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (50265, 745, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (50266, 745, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (50267, 745, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (50268, 745, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (50269, 745, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (50270, 745, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (50271, 745, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (50272, 745, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (50273, 745, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (50274, 745, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (50275, 745, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (50276, 745, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (50277, 745, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (50278, 745, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (50279, 745, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (50280, 745, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (50281, 745, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (50282, 745, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (50283, 745, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (50284, 745, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (50285, 745, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (50286, 745, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (50287, 745, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (50288, 745, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (50289, 745, 53, 2544);
INSERT INTO 'devicecapvalue' VALUES (50290, 746, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (50291, 746, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (50292, 746, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (50293, 746, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (50294, 746, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (50295, 746, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (50296, 746, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (50297, 746, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (50298, 746, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (50299, 746, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (50300, 746, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (50301, 746, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (50302, 746, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (50303, 746, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (50304, 746, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (50305, 746, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50306, 746, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (50307, 746, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (50308, 746, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (50309, 746, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50310, 746, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (50311, 746, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (50312, 746, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (50313, 746, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (50314, 746, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (50315, 746, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (50316, 746, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50317, 746, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50318, 746, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (50319, 746, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (50320, 746, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (50321, 746, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (50322, 746, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (50323, 746, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (50324, 746, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (50325, 746, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (50326, 746, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (50327, 746, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (50328, 746, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (50329, 746, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (50330, 746, 57, 40);
INSERT INTO 'devicecapvalue' VALUES (50331, 746, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (50332, 746, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (50333, 746, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (50334, 746, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (50335, 746, 38, 100);
INSERT INTO 'devicecapvalue' VALUES (50336, 746, 38, 880);
INSERT INTO 'devicecapvalue' VALUES (50337, 746, 38, 865);
INSERT INTO 'devicecapvalue' VALUES (50338, 746, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (50339, 746, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (50340, 746, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (50341, 746, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (50342, 746, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (50343, 746, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (50344, 746, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (50345, 746, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (50346, 746, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (50347, 746, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (50348, 746, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (50349, 746, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (50350, 746, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (50351, 746, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (50352, 746, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (50353, 746, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (50354, 746, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (50355, 746, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (50356, 746, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (50357, 746, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (50358, 746, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (50359, 746, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (50360, 746, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (50361, 746, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (50362, 746, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (50363, 746, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (50364, 746, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (50365, 746, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (50366, 746, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (50367, 746, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (50368, 746, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (50369, 746, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (50370, 746, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (50371, 746, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (50372, 746, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (50373, 746, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (50374, 746, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (50375, 746, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (50376, 746, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (50377, 746, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (50378, 746, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (50379, 746, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (50380, 746, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (50381, 746, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (50382, 746, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (50383, 746, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (50384, 746, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (50385, 746, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (50386, 746, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (50387, 746, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (50388, 746, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (50389, 746, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (50390, 746, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (50391, 746, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (50392, 746, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (50393, 746, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (50394, 746, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (50395, 746, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (50396, 746, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (50397, 746, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (50398, 746, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (50399, 746, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (50400, 746, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (50401, 746, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (50402, 746, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (50403, 746, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (50404, 746, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (50405, 746, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (50406, 746, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (50407, 746, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (50408, 746, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (50409, 746, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (50410, 746, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (50411, 746, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (50412, 746, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (50413, 746, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (50414, 746, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (50415, 746, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (50416, 746, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (50417, 746, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (50418, 746, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (50419, 746, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (50420, 746, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (50421, 746, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (50422, 746, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (50423, 746, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (50424, 746, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (50425, 746, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (50426, 746, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (50427, 746, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (50428, 746, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (50429, 746, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (50430, 746, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (50431, 746, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (50432, 746, 45, 2320);
INSERT INTO 'devicecapvalue' VALUES (50433, 746, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (50434, 746, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (50435, 746, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (50436, 746, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (50437, 746, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (50438, 746, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (50439, 746, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (50440, 746, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (50441, 746, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (50442, 746, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (50443, 746, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (50444, 746, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (50445, 746, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (50446, 746, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (50447, 746, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (50448, 746, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (50449, 746, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (50450, 746, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (50451, 746, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (50452, 746, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (50453, 746, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (50454, 746, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (50455, 746, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (50456, 746, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (50457, 746, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (50458, 746, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (50459, 746, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (50460, 746, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (50461, 746, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (50462, 746, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (50463, 746, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (50464, 746, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (50465, 746, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (50466, 746, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (50467, 746, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (50468, 746, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (50469, 746, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (50470, 746, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (50471, 746, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (50472, 746, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (50473, 746, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (50474, 746, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (50475, 746, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (50476, 746, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (50477, 746, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (50478, 746, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (50479, 746, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (50480, 746, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (50481, 746, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (50482, 746, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (50483, 746, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (50484, 746, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (50485, 746, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (50486, 746, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (50487, 746, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (50488, 746, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (50489, 746, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (50490, 746, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (50491, 746, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (50492, 746, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (50493, 746, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (50494, 746, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (50495, 746, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (50496, 746, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (50497, 746, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (50498, 746, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (50499, 746, 115, 2315);
INSERT INTO 'devicecapvalue' VALUES (50500, 746, 197, 2335);
INSERT INTO 'devicecapvalue' VALUES (50501, 746, 141, 1096);
INSERT INTO 'devicecapvalue' VALUES (50502, 746, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (50503, 746, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (50504, 746, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (50505, 746, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (50506, 746, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (50507, 746, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (50508, 746, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (50509, 746, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (50510, 746, 125, 707);
INSERT INTO 'devicecapvalue' VALUES (50511, 746, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (50512, 746, 142, 2336);
INSERT INTO 'capvalue' VALUES (2545, 'devcam0:640x480 devcam0:1280x960 devcam0:1632x1224 devcam0:2048x1536');
INSERT INTO 'devicecapvalue' VALUES (50513, 746, 143, 2545);
INSERT INTO 'devicecapvalue' VALUES (50514, 746, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (50515, 746, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (50516, 746, 102, 1982);
INSERT INTO 'devicecapvalue' VALUES (50517, 746, 103, 2338);
INSERT INTO 'devicecapvalue' VALUES (50518, 746, 104, 1982);
INSERT INTO 'devicecapvalue' VALUES (50519, 746, 105, 2340);
INSERT INTO 'devicecapvalue' VALUES (50520, 746, 106, 2341);
INSERT INTO 'capvalue' VALUES (2546, '???????');
INSERT INTO 'devicecapvalue' VALUES (50521, 746, 107, 2546);
INSERT INTO 'devicecapvalue' VALUES (50522, 746, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (50523, 746, 109, 2546);
INSERT INTO 'devicecapvalue' VALUES (50524, 746, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (50525, 746, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (50526, 746, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (50527, 746, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (50528, 746, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (50529, 746, 145, 45);
INSERT INTO 'devicecapvalue' VALUES (50530, 746, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (50531, 746, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (50532, 746, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (50533, 746, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (50534, 746, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (50535, 746, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (50536, 746, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (50537, 746, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (50538, 746, 131, 45);
INSERT INTO 'devicecapvalue' VALUES (50539, 746, 251, 242);
INSERT INTO 'devicecapvalue' VALUES (50540, 746, 67, 45);
INSERT INTO 'capvalue' VALUES (2547, 'SonyEricssonW595/R3DA026');
INSERT INTO 'devicecapvalue' VALUES (50541, 746, 68, 2547);
INSERT INTO 'devicecapvalue' VALUES (50542, 746, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (50543, 746, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (50544, 746, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (50545, 746, 205, 45);
INSERT INTO 'devicecapvalue' VALUES (50546, 746, 147, 242);
INSERT INTO 'devicecapvalue' VALUES (50547, 746, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (50548, 746, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (50549, 746, 132, 2315);
INSERT INTO 'devicecapvalue' VALUES (50550, 746, 133, 2320);
INSERT INTO 'devicecapvalue' VALUES (50551, 746, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (50552, 746, 116, 2345);
INSERT INTO 'devicecapvalue' VALUES (50553, 746, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (50554, 746, 149, 2346);
INSERT INTO 'devicecapvalue' VALUES (50555, 746, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (50556, 746, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (50557, 746, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (50558, 746, 252, 2347);
INSERT INTO 'devicecapvalue' VALUES (50559, 746, 136, 2320);
INSERT INTO 'devicecapvalue' VALUES (50560, 746, 137, 2348);
INSERT INTO 'devicecapvalue' VALUES (50561, 746, 137, 2349);
INSERT INTO 'devicecapvalue' VALUES (50562, 746, 137, 2350);
INSERT INTO 'devicecapvalue' VALUES (50563, 746, 137, 2352);
INSERT INTO 'capvalue' VALUES (2548, 'mms.cellcom.co.il');
INSERT INTO 'devicecapvalue' VALUES (50564, 746, 138, 2548);
INSERT INTO 'capvalue' VALUES (2549, '+972521100059');
INSERT INTO 'devicecapvalue' VALUES (50565, 746, 72, 2549);
INSERT INTO 'devicecapvalue' VALUES (50566, 746, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (50567, 746, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (50568, 746, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (50569, 746, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (50570, 746, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (50571, 746, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (50572, 746, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (50573, 746, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (50574, 746, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (50575, 746, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (50576, 746, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (50577, 746, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (50578, 746, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (50579, 746, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (50580, 746, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (50581, 746, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (50582, 746, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (50583, 746, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (50584, 746, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (50585, 746, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (50586, 746, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (50587, 746, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (50588, 746, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (50589, 746, 48, 147);
INSERT INTO 'devicecapvalue' VALUES (50590, 746, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (50591, 746, 49, 659);
INSERT INTO 'devicecapvalue' VALUES (50592, 746, 53, 1263);
INSERT INTO 'devicecapvalue' VALUES (50593, 746, 53, 1990);
INSERT INTO 'devicecapvalue' VALUES (50594, 747, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (50595, 747, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (50596, 747, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (50597, 747, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (50598, 747, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (50599, 747, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (50600, 747, 75, 2542);
INSERT INTO 'devicecapvalue' VALUES (50601, 747, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (50602, 747, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (50603, 747, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (50604, 747, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (50605, 747, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (50606, 747, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (50607, 747, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (50608, 747, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (50609, 747, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (50610, 747, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (50611, 747, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (50612, 747, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (50613, 747, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (50614, 747, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (50615, 747, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50616, 747, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (50617, 747, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (50618, 747, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (50619, 747, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (50620, 747, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50621, 747, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (50622, 747, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (50623, 747, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (50624, 747, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (50625, 747, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (50626, 747, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (50627, 747, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (50628, 747, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (50629, 747, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (50630, 747, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (50631, 747, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (50632, 747, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (50633, 747, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (50634, 747, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (50635, 747, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (50636, 747, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (50637, 747, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (50638, 747, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (50639, 747, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (50640, 747, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (50641, 747, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (50642, 747, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (50643, 747, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (50644, 747, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (50645, 747, 52, 2543);
INSERT INTO 'devicecapvalue' VALUES (50646, 747, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (50647, 747, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (50648, 747, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (50649, 747, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (50650, 748, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (50651, 748, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (50652, 748, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (50653, 748, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (50654, 748, 160, 2460);
INSERT INTO 'devicecapvalue' VALUES (50655, 748, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (50656, 748, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (50657, 748, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (50658, 748, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (50659, 748, 173, 1688);
INSERT INTO 'capvalue' VALUES (2550, 'SonyEricsson_JP7_176x220');
INSERT INTO 'devicecapvalue' VALUES (50660, 748, 75, 2550);
INSERT INTO 'devicecapvalue' VALUES (50661, 748, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (50662, 748, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (50663, 748, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (50664, 748, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (50665, 748, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (50666, 748, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (50667, 748, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (50668, 748, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (50669, 748, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (50670, 748, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (50671, 748, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (50672, 748, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (50673, 748, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (50674, 748, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (50675, 748, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (50676, 748, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (50677, 748, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (50678, 748, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (50679, 748, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (50680, 748, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (50681, 748, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (50682, 748, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (50683, 748, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50684, 748, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (50685, 748, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (50686, 748, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (50687, 748, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (50688, 748, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (50689, 748, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50690, 748, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (50691, 748, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (50692, 748, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (50693, 748, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (50694, 748, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (50695, 748, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (50696, 748, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (50697, 748, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (50698, 748, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (50699, 748, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (50700, 748, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (50701, 748, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (50702, 748, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (50703, 748, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (50704, 748, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (50705, 748, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (50706, 748, 51, 2475);
INSERT INTO 'devicecapvalue' VALUES (50707, 748, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (50708, 748, 51, 2476);
INSERT INTO 'devicecapvalue' VALUES (50709, 748, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (50710, 748, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (50711, 748, 191, 1372);
INSERT INTO 'capvalue' VALUES (2551, 'SonyEricssonW610i');
INSERT INTO 'devicecapvalue' VALUES (50712, 748, 53, 2551);
INSERT INTO 'devicecapvalue' VALUES (50713, 749, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (50714, 749, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (50715, 749, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (50716, 749, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (50717, 749, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (50718, 749, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (50719, 749, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (50720, 749, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (50721, 749, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (50722, 749, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (50723, 749, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (50724, 749, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (50725, 749, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (50726, 749, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (50727, 749, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (50728, 749, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (50729, 749, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (50730, 749, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (50731, 749, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (50732, 749, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (50733, 749, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (50734, 749, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (50735, 749, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50736, 749, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (50737, 749, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (50738, 749, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50739, 749, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (50740, 749, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (50741, 749, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (50742, 749, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (50743, 749, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (50744, 749, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (50745, 749, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (50746, 749, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (50747, 749, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (50748, 749, 52, 2369);
INSERT INTO 'devicecapvalue' VALUES (50749, 749, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (50750, 749, 157, 1026);
INSERT INTO 'capvalue' VALUES (2552, 'SonyEricssonW700');
INSERT INTO 'devicecapvalue' VALUES (50751, 749, 53, 2552);
INSERT INTO 'devicecapvalue' VALUES (50752, 750, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (50753, 750, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (50754, 750, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (50755, 750, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (50756, 750, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (50757, 750, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (50758, 750, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (50759, 750, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (50760, 750, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (50761, 750, 173, 1523);
INSERT INTO 'capvalue' VALUES (2553, 'SonyEricsson_W710i');
INSERT INTO 'devicecapvalue' VALUES (50762, 750, 75, 2553);
INSERT INTO 'devicecapvalue' VALUES (50763, 750, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (50764, 750, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (50765, 750, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (50766, 750, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (50767, 750, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (50768, 750, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (50769, 750, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (50770, 750, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (50771, 750, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (50772, 750, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (50773, 750, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (50774, 750, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (50775, 750, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (50776, 750, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (50777, 750, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (50778, 750, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (50779, 750, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (50780, 750, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (50781, 750, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (50782, 750, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50783, 750, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (50784, 750, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (50785, 750, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (50786, 750, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (50787, 750, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50788, 750, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (50789, 750, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (50790, 750, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (50791, 750, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (50792, 750, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (50793, 750, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (50794, 750, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (50795, 750, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (50796, 750, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (50797, 750, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (50798, 750, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (50799, 750, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (50800, 750, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (50801, 750, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (50802, 750, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (50803, 750, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (50804, 750, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (50805, 750, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (50806, 750, 51, 100);
INSERT INTO 'capvalue' VALUES (2554, 'e-melody');
INSERT INTO 'devicecapvalue' VALUES (50807, 750, 51, 2554);
INSERT INTO 'capvalue' VALUES (2555, 'i-melody');
INSERT INTO 'devicecapvalue' VALUES (50808, 750, 51, 2555);
INSERT INTO 'devicecapvalue' VALUES (50809, 750, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (50810, 750, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (50811, 750, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (50812, 750, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (50813, 750, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (50814, 750, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (50815, 750, 51, 2425);
INSERT INTO 'devicecapvalue' VALUES (50816, 750, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (50817, 750, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (50818, 750, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (50819, 750, 157, 1026);
INSERT INTO 'capvalue' VALUES (2556, 'sdp');
INSERT INTO 'devicecapvalue' VALUES (50820, 750, 157, 2556);
INSERT INTO 'devicecapvalue' VALUES (50821, 750, 191, 1372);
INSERT INTO 'capvalue' VALUES (2557, 'SonyEricssonW710i');
INSERT INTO 'devicecapvalue' VALUES (50822, 750, 53, 2557);
INSERT INTO 'devicecapvalue' VALUES (50823, 751, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (50824, 751, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (50825, 751, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (50826, 751, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (50827, 751, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (50828, 751, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (50829, 751, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (50830, 751, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (50831, 751, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (50832, 751, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (50833, 751, 75, 2553);
INSERT INTO 'devicecapvalue' VALUES (50834, 751, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (50835, 751, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (50836, 751, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (50837, 751, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (50838, 751, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (50839, 751, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (50840, 751, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (50841, 751, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (50842, 751, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (50843, 751, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (50844, 751, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (50845, 751, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (50846, 751, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (50847, 751, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (50848, 751, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (50849, 751, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (50850, 751, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (50851, 751, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (50852, 751, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (50853, 751, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50854, 751, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (50855, 751, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (50856, 751, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (50857, 751, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (50858, 751, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50859, 751, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (50860, 751, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (50861, 751, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (50862, 751, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (50863, 751, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (50864, 751, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (50865, 751, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (50866, 751, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (50867, 751, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (50868, 751, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (50869, 751, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (50870, 751, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (50871, 751, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (50872, 751, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (50873, 751, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (50874, 751, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (50875, 751, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (50876, 751, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (50877, 751, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (50878, 751, 51, 2554);
INSERT INTO 'devicecapvalue' VALUES (50879, 751, 51, 2555);
INSERT INTO 'devicecapvalue' VALUES (50880, 751, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (50881, 751, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (50882, 751, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (50883, 751, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (50884, 751, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (50885, 751, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (50886, 751, 51, 2425);
INSERT INTO 'devicecapvalue' VALUES (50887, 751, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (50888, 751, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (50889, 751, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (50890, 751, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (50891, 751, 157, 2556);
INSERT INTO 'devicecapvalue' VALUES (50892, 751, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (50893, 751, 53, 2557);
INSERT INTO 'devicecapvalue' VALUES (50894, 752, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (50895, 752, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (50896, 752, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (50897, 752, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (50898, 752, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (50899, 752, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (50900, 752, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (50901, 752, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (50902, 752, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (50903, 752, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (50904, 752, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (50905, 752, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (50906, 752, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (50907, 752, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (50908, 752, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50909, 752, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (50910, 752, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (50911, 752, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (50912, 752, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (50913, 752, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (50914, 752, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (50915, 752, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (50916, 752, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (50917, 752, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (50918, 752, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (50919, 752, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50920, 752, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (50921, 752, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (50922, 752, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (50923, 752, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (50924, 752, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (50925, 752, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (50926, 752, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (50927, 752, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (50928, 752, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (50929, 752, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (50930, 752, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (50931, 752, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (50932, 752, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (50933, 752, 28, 40);
INSERT INTO 'devicecapvalue' VALUES (50934, 752, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (50935, 752, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (50936, 752, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (50937, 752, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (50938, 752, 38, 2315);
INSERT INTO 'devicecapvalue' VALUES (50939, 752, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (50940, 752, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (50941, 752, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (50942, 752, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (50943, 752, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (50944, 752, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (50945, 752, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (50946, 752, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (50947, 752, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (50948, 752, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (50949, 752, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (50950, 752, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (50951, 752, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (50952, 752, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (50953, 752, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (50954, 752, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (50955, 752, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (50956, 752, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (50957, 752, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (50958, 752, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (50959, 752, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (50960, 752, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (50961, 752, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (50962, 752, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (50963, 752, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (50964, 752, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (50965, 752, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (50966, 752, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (50967, 752, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (50968, 752, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (50969, 752, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (50970, 752, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (50971, 752, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (50972, 752, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (50973, 752, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (50974, 752, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (50975, 752, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (50976, 752, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (50977, 752, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (50978, 752, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (50979, 752, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (50980, 752, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (50981, 752, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (50982, 752, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (50983, 752, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (50984, 752, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (50985, 752, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (50986, 752, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (50987, 752, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (50988, 752, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (50989, 752, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (50990, 752, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (50991, 752, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (50992, 752, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (50993, 752, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (50994, 752, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (50995, 752, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (50996, 752, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (50997, 752, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (50998, 752, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (50999, 752, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (51000, 752, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (51001, 752, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (51002, 752, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (51003, 752, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (51004, 752, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (51005, 752, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (51006, 752, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (51007, 752, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (51008, 752, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (51009, 752, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (51010, 752, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (51011, 752, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (51012, 752, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (51013, 752, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (51014, 752, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (51015, 752, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (51016, 752, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (51017, 752, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (51018, 752, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (51019, 752, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (51020, 752, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (51021, 752, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (51022, 752, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (51023, 752, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (51024, 752, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (51025, 752, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (51026, 752, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (51027, 752, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (51028, 752, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (51029, 752, 45, 2320);
INSERT INTO 'devicecapvalue' VALUES (51030, 752, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (51031, 752, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (51032, 752, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (51033, 752, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (51034, 752, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (51035, 752, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (51036, 752, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (51037, 752, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (51038, 752, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (51039, 752, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (51040, 752, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (51041, 752, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (51042, 752, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (51043, 752, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (51044, 752, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (51045, 752, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (51046, 752, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (51047, 752, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (51048, 752, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (51049, 752, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (51050, 752, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (51051, 752, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (51052, 752, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (51053, 752, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (51054, 752, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (51055, 752, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (51056, 752, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (51057, 752, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (51058, 752, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (51059, 752, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (51060, 752, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (51061, 752, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (51062, 752, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (51063, 752, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (51064, 752, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (51065, 752, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (51066, 752, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (51067, 752, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (51068, 752, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (51069, 752, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (51070, 752, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (51071, 752, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (51072, 752, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (51073, 752, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (51074, 752, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (51075, 752, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (51076, 752, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (51077, 752, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (51078, 752, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (51079, 752, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (51080, 752, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (51081, 752, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (51082, 752, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (51083, 752, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (51084, 752, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (51085, 752, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (51086, 752, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (51087, 752, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (51088, 752, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (51089, 752, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (51090, 752, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (51091, 752, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (51092, 752, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (51093, 752, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (51094, 752, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (51095, 752, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (51096, 752, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (51097, 752, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (51098, 752, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (51099, 752, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (51100, 752, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (51101, 752, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (51102, 752, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (51103, 752, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (51104, 752, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (51105, 752, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (51106, 752, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (51107, 752, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (51108, 752, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (51109, 752, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (51110, 752, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (51111, 752, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (51112, 752, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (51113, 752, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (51114, 752, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (51115, 752, 48, 2322);
INSERT INTO 'devicecapvalue' VALUES (51116, 752, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (51117, 752, 49, 659);
INSERT INTO 'capvalue' VALUES (2558, 'Mozilla/4.0 SonyEricssonW715v/R1EA Browser/NetFront/3.4 Profile/MIDP-2.1 Configuration/CLDC-1.1 JavaPlatform/JP-8.4.2');
INSERT INTO 'devicecapvalue' VALUES (51118, 752, 53, 2558);
INSERT INTO 'devicecapvalue' VALUES (51119, 753, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (51120, 753, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (51121, 753, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (51122, 753, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (51123, 753, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (51124, 753, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (51125, 753, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (51126, 753, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (51127, 753, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (51128, 753, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (51129, 753, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (51130, 753, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (51131, 753, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (51132, 753, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (51133, 753, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (51134, 753, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (51135, 753, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (51136, 753, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (51137, 753, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (51138, 753, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (51139, 753, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (51140, 753, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (51141, 753, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (51142, 753, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (51143, 753, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (51144, 753, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (51145, 753, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (51146, 753, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (51147, 753, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (51148, 753, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (51149, 753, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (51150, 753, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (51151, 753, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (51152, 753, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (51153, 753, 17, 2439);
INSERT INTO 'devicecapvalue' VALUES (51154, 753, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (51155, 753, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (51156, 753, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (51157, 753, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (51158, 753, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (51159, 753, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (51160, 753, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (51161, 753, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (51162, 753, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (51163, 753, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (51164, 753, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (51165, 753, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (51166, 753, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (51167, 753, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (51168, 753, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (51169, 753, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (51170, 753, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (51171, 753, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (51172, 753, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (51173, 753, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (51174, 753, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (51175, 753, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (51176, 753, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (51177, 753, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (51178, 753, 38, 100);
INSERT INTO 'devicecapvalue' VALUES (51179, 753, 38, 880);
INSERT INTO 'devicecapvalue' VALUES (51180, 753, 38, 865);
INSERT INTO 'devicecapvalue' VALUES (51181, 753, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (51182, 753, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (51183, 753, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (51184, 753, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (51185, 753, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (51186, 753, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (51187, 753, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (51188, 753, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (51189, 753, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (51190, 753, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (51191, 753, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (51192, 753, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (51193, 753, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (51194, 753, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (51195, 753, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (51196, 753, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (51197, 753, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (51198, 753, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (51199, 753, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (51200, 753, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (51201, 753, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (51202, 753, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (51203, 753, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (51204, 753, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (51205, 753, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (51206, 753, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (51207, 753, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (51208, 753, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (51209, 753, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (51210, 753, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (51211, 753, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (51212, 753, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (51213, 753, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (51214, 753, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (51215, 753, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (51216, 753, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (51217, 753, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (51218, 753, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (51219, 753, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (51220, 753, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (51221, 753, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (51222, 753, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (51223, 753, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (51224, 753, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (51225, 753, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (51226, 753, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (51227, 753, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (51228, 753, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (51229, 753, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (51230, 753, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (51231, 753, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (51232, 753, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (51233, 753, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (51234, 753, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (51235, 753, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (51236, 753, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (51237, 753, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (51238, 753, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (51239, 753, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (51240, 753, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (51241, 753, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (51242, 753, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (51243, 753, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (51244, 753, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (51245, 753, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (51246, 753, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (51247, 753, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (51248, 753, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (51249, 753, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (51250, 753, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (51251, 753, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (51252, 753, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (51253, 753, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (51254, 753, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (51255, 753, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (51256, 753, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (51257, 753, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (51258, 753, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (51259, 753, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (51260, 753, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (51261, 753, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (51262, 753, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (51263, 753, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (51264, 753, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (51265, 753, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (51266, 753, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (51267, 753, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (51268, 753, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (51269, 753, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (51270, 753, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (51271, 753, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (51272, 753, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (51273, 753, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (51274, 753, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (51275, 753, 45, 2320);
INSERT INTO 'devicecapvalue' VALUES (51276, 753, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (51277, 753, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (51278, 753, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (51279, 753, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (51280, 753, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (51281, 753, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (51282, 753, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (51283, 753, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (51284, 753, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (51285, 753, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (51286, 753, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (51287, 753, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (51288, 753, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (51289, 753, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (51290, 753, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (51291, 753, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (51292, 753, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (51293, 753, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (51294, 753, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (51295, 753, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (51296, 753, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (51297, 753, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (51298, 753, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (51299, 753, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (51300, 753, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (51301, 753, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (51302, 753, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (51303, 753, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (51304, 753, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (51305, 753, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (51306, 753, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (51307, 753, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (51308, 753, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (51309, 753, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (51310, 753, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (51311, 753, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (51312, 753, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (51313, 753, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (51314, 753, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (51315, 753, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (51316, 753, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (51317, 753, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (51318, 753, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (51319, 753, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (51320, 753, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (51321, 753, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (51322, 753, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (51323, 753, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (51324, 753, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (51325, 753, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (51326, 753, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (51327, 753, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (51328, 753, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (51329, 753, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (51330, 753, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (51331, 753, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (51332, 753, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (51333, 753, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (51334, 753, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (51335, 753, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (51336, 753, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (51337, 753, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (51338, 753, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (51339, 753, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (51340, 753, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (51341, 753, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (51342, 753, 115, 2315);
INSERT INTO 'devicecapvalue' VALUES (51343, 753, 197, 2335);
INSERT INTO 'devicecapvalue' VALUES (51344, 753, 141, 1096);
INSERT INTO 'devicecapvalue' VALUES (51345, 753, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (51346, 753, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (51347, 753, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (51348, 753, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (51349, 753, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (51350, 753, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (51351, 753, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (51352, 753, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (51353, 753, 125, 707);
INSERT INTO 'devicecapvalue' VALUES (51354, 753, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (51355, 753, 142, 2336);
INSERT INTO 'devicecapvalue' VALUES (51356, 753, 143, 2545);
INSERT INTO 'devicecapvalue' VALUES (51357, 753, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (51358, 753, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (51359, 753, 102, 1926);
INSERT INTO 'devicecapvalue' VALUES (51360, 753, 103, 2338);
INSERT INTO 'devicecapvalue' VALUES (51361, 753, 104, 2339);
INSERT INTO 'devicecapvalue' VALUES (51362, 753, 105, 2340);
INSERT INTO 'devicecapvalue' VALUES (51363, 753, 106, 2341);
INSERT INTO 'devicecapvalue' VALUES (51364, 753, 107, 2342);
INSERT INTO 'devicecapvalue' VALUES (51365, 753, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (51366, 753, 109, 946);
INSERT INTO 'devicecapvalue' VALUES (51367, 753, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (51368, 753, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (51369, 753, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (51370, 753, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (51371, 753, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (51372, 753, 145, 45);
INSERT INTO 'devicecapvalue' VALUES (51373, 753, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (51374, 753, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (51375, 753, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (51376, 753, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (51377, 753, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (51378, 753, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (51379, 753, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (51380, 753, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (51381, 753, 131, 45);
INSERT INTO 'devicecapvalue' VALUES (51382, 753, 251, 242);
INSERT INTO 'devicecapvalue' VALUES (51383, 753, 67, 45);
INSERT INTO 'capvalue' VALUES (2559, 'SonyEricssonW760a/R3CC007');
INSERT INTO 'devicecapvalue' VALUES (51384, 753, 68, 2559);
INSERT INTO 'devicecapvalue' VALUES (51385, 753, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (51386, 753, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (51387, 753, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (51388, 753, 205, 45);
INSERT INTO 'devicecapvalue' VALUES (51389, 753, 147, 242);
INSERT INTO 'devicecapvalue' VALUES (51390, 753, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (51391, 753, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (51392, 753, 132, 2315);
INSERT INTO 'devicecapvalue' VALUES (51393, 753, 133, 2320);
INSERT INTO 'devicecapvalue' VALUES (51394, 753, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (51395, 753, 116, 2345);
INSERT INTO 'devicecapvalue' VALUES (51396, 753, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (51397, 753, 149, 2346);
INSERT INTO 'devicecapvalue' VALUES (51398, 753, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (51399, 753, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (51400, 753, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (51401, 753, 252, 2347);
INSERT INTO 'devicecapvalue' VALUES (51402, 753, 136, 2320);
INSERT INTO 'devicecapvalue' VALUES (51403, 753, 137, 2348);
INSERT INTO 'devicecapvalue' VALUES (51404, 753, 137, 2349);
INSERT INTO 'devicecapvalue' VALUES (51405, 753, 137, 2350);
INSERT INTO 'devicecapvalue' VALUES (51406, 753, 137, 2352);
INSERT INTO 'capvalue' VALUES (2560, 'http://mmsc.cingular.com');
INSERT INTO 'devicecapvalue' VALUES (51407, 753, 138, 2560);
INSERT INTO 'capvalue' VALUES (2561, '+13123149810');
INSERT INTO 'devicecapvalue' VALUES (51408, 753, 72, 2561);
INSERT INTO 'devicecapvalue' VALUES (51409, 753, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (51410, 753, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (51411, 753, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (51412, 753, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (51413, 753, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (51414, 753, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (51415, 753, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (51416, 753, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (51417, 753, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (51418, 753, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (51419, 753, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (51420, 753, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (51421, 753, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (51422, 753, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (51423, 753, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (51424, 753, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (51425, 753, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (51426, 753, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (51427, 753, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (51428, 753, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (51429, 753, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (51430, 753, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (51431, 753, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (51432, 753, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (51433, 753, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (51434, 753, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (51435, 753, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (51436, 753, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (51437, 753, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (51438, 753, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (51439, 753, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (51440, 753, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (51441, 753, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (51442, 753, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (51443, 753, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (51444, 753, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (51445, 753, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (51446, 753, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (51447, 753, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (51448, 753, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (51449, 753, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (51450, 753, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (51451, 753, 48, 212);
INSERT INTO 'devicecapvalue' VALUES (51452, 753, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (51453, 753, 49, 659);
INSERT INTO 'devicecapvalue' VALUES (51454, 753, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (51455, 753, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (51456, 753, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (51457, 753, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (51458, 753, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (51459, 753, 157, 2426);
INSERT INTO 'capvalue' VALUES (2562, 'SonyEricssonW760a/R3CC Browser/NetFront/3.4 Profile/MIDP-2.1 Configuration/CLDC-1.1 JavaPlatform/JP-8.3.1 UP.Link/6.3.0.0.0');
INSERT INTO 'devicecapvalue' VALUES (51460, 753, 53, 2562);
INSERT INTO 'devicecapvalue' VALUES (51461, 754, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (51462, 754, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (51463, 754, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (51464, 754, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (51465, 754, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (51466, 754, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (51467, 754, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (51468, 754, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (51469, 754, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (51470, 754, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (51471, 754, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (51472, 754, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (51473, 754, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (51474, 754, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (51475, 754, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (51476, 754, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (51477, 754, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (51478, 754, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (51479, 754, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (51480, 754, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (51481, 754, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (51482, 754, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (51483, 754, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (51484, 754, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (51485, 754, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (51486, 754, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (51487, 754, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (51488, 754, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (51489, 754, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (51490, 754, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (51491, 754, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (51492, 754, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (51493, 754, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (51494, 754, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (51495, 754, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (51496, 754, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (51497, 754, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (51498, 754, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (51499, 754, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (51500, 754, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (51501, 754, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (51502, 754, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (51503, 754, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (51504, 754, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (51505, 754, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (51506, 754, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (51507, 754, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (51508, 754, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (51509, 754, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (51510, 754, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (51511, 754, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (51512, 754, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (51513, 754, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (51514, 754, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (51515, 754, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (51516, 754, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (51517, 754, 38, 100);
INSERT INTO 'devicecapvalue' VALUES (51518, 754, 38, 880);
INSERT INTO 'devicecapvalue' VALUES (51519, 754, 38, 865);
INSERT INTO 'devicecapvalue' VALUES (51520, 754, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (51521, 754, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (51522, 754, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (51523, 754, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (51524, 754, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (51525, 754, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (51526, 754, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (51527, 754, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (51528, 754, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (51529, 754, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (51530, 754, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (51531, 754, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (51532, 754, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (51533, 754, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (51534, 754, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (51535, 754, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (51536, 754, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (51537, 754, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (51538, 754, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (51539, 754, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (51540, 754, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (51541, 754, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (51542, 754, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (51543, 754, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (51544, 754, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (51545, 754, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (51546, 754, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (51547, 754, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (51548, 754, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (51549, 754, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (51550, 754, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (51551, 754, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (51552, 754, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (51553, 754, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (51554, 754, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (51555, 754, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (51556, 754, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (51557, 754, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (51558, 754, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (51559, 754, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (51560, 754, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (51561, 754, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (51562, 754, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (51563, 754, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (51564, 754, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (51565, 754, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (51566, 754, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (51567, 754, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (51568, 754, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (51569, 754, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (51570, 754, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (51571, 754, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (51572, 754, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (51573, 754, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (51574, 754, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (51575, 754, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (51576, 754, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (51577, 754, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (51578, 754, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (51579, 754, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (51580, 754, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (51581, 754, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (51582, 754, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (51583, 754, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (51584, 754, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (51585, 754, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (51586, 754, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (51587, 754, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (51588, 754, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (51589, 754, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (51590, 754, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (51591, 754, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (51592, 754, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (51593, 754, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (51594, 754, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (51595, 754, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (51596, 754, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (51597, 754, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (51598, 754, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (51599, 754, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (51600, 754, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (51601, 754, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (51602, 754, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (51603, 754, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (51604, 754, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (51605, 754, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (51606, 754, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (51607, 754, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (51608, 754, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (51609, 754, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (51610, 754, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (51611, 754, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (51612, 754, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (51613, 754, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (51614, 754, 45, 2320);
INSERT INTO 'devicecapvalue' VALUES (51615, 754, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (51616, 754, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (51617, 754, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (51618, 754, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (51619, 754, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (51620, 754, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (51621, 754, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (51622, 754, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (51623, 754, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (51624, 754, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (51625, 754, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (51626, 754, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (51627, 754, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (51628, 754, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (51629, 754, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (51630, 754, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (51631, 754, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (51632, 754, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (51633, 754, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (51634, 754, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (51635, 754, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (51636, 754, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (51637, 754, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (51638, 754, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (51639, 754, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (51640, 754, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (51641, 754, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (51642, 754, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (51643, 754, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (51644, 754, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (51645, 754, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (51646, 754, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (51647, 754, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (51648, 754, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (51649, 754, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (51650, 754, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (51651, 754, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (51652, 754, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (51653, 754, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (51654, 754, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (51655, 754, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (51656, 754, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (51657, 754, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (51658, 754, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (51659, 754, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (51660, 754, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (51661, 754, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (51662, 754, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (51663, 754, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (51664, 754, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (51665, 754, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (51666, 754, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (51667, 754, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (51668, 754, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (51669, 754, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (51670, 754, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (51671, 754, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (51672, 754, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (51673, 754, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (51674, 754, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (51675, 754, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (51676, 754, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (51677, 754, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (51678, 754, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (51679, 754, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (51680, 754, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (51681, 754, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (51682, 754, 115, 100);
INSERT INTO 'devicecapvalue' VALUES (51683, 754, 115, 880);
INSERT INTO 'devicecapvalue' VALUES (51684, 754, 115, 865);
INSERT INTO 'devicecapvalue' VALUES (51685, 754, 197, 2335);
INSERT INTO 'devicecapvalue' VALUES (51686, 754, 141, 1096);
INSERT INTO 'devicecapvalue' VALUES (51687, 754, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (51688, 754, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (51689, 754, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (51690, 754, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (51691, 754, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (51692, 754, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (51693, 754, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (51694, 754, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (51695, 754, 125, 707);
INSERT INTO 'devicecapvalue' VALUES (51696, 754, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (51697, 754, 142, 2336);
INSERT INTO 'devicecapvalue' VALUES (51698, 754, 143, 2545);
INSERT INTO 'devicecapvalue' VALUES (51699, 754, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (51700, 754, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (51701, 754, 102, 1926);
INSERT INTO 'devicecapvalue' VALUES (51702, 754, 103, 2338);
INSERT INTO 'devicecapvalue' VALUES (51703, 754, 104, 2339);
INSERT INTO 'devicecapvalue' VALUES (51704, 754, 105, 2340);
INSERT INTO 'devicecapvalue' VALUES (51705, 754, 106, 2341);
INSERT INTO 'devicecapvalue' VALUES (51706, 754, 107, 2342);
INSERT INTO 'devicecapvalue' VALUES (51707, 754, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (51708, 754, 109, 946);
INSERT INTO 'devicecapvalue' VALUES (51709, 754, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (51710, 754, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (51711, 754, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (51712, 754, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (51713, 754, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (51714, 754, 145, 45);
INSERT INTO 'devicecapvalue' VALUES (51715, 754, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (51716, 754, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (51717, 754, 146, 45);
INSERT INTO 'devicecapvalue' VALUES (51718, 754, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (51719, 754, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (51720, 754, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (51721, 754, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (51722, 754, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (51723, 754, 131, 45);
INSERT INTO 'devicecapvalue' VALUES (51724, 754, 251, 242);
INSERT INTO 'devicecapvalue' VALUES (51725, 754, 67, 45);
INSERT INTO 'capvalue' VALUES (2563, 'SonyEricssonW760i/R3BA035');
INSERT INTO 'devicecapvalue' VALUES (51726, 754, 68, 2563);
INSERT INTO 'devicecapvalue' VALUES (51727, 754, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (51728, 754, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (51729, 754, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (51730, 754, 205, 45);
INSERT INTO 'devicecapvalue' VALUES (51731, 754, 147, 242);
INSERT INTO 'devicecapvalue' VALUES (51732, 754, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (51733, 754, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (51734, 754, 132, 100);
INSERT INTO 'devicecapvalue' VALUES (51735, 754, 132, 880);
INSERT INTO 'devicecapvalue' VALUES (51736, 754, 132, 865);
INSERT INTO 'devicecapvalue' VALUES (51737, 754, 133, 2320);
INSERT INTO 'devicecapvalue' VALUES (51738, 754, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (51739, 754, 116, 2075);
INSERT INTO 'devicecapvalue' VALUES (51740, 754, 116, 1280);
INSERT INTO 'devicecapvalue' VALUES (51741, 754, 116, 123);
INSERT INTO 'devicecapvalue' VALUES (51742, 754, 116, 2319);
INSERT INTO 'devicecapvalue' VALUES (51743, 754, 116, 1283);
INSERT INTO 'devicecapvalue' VALUES (51744, 754, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (51745, 754, 149, 1751);
INSERT INTO 'devicecapvalue' VALUES (51746, 754, 149, 949);
INSERT INTO 'devicecapvalue' VALUES (51747, 754, 149, 2514);
INSERT INTO 'devicecapvalue' VALUES (51748, 754, 149, 2515);
INSERT INTO 'devicecapvalue' VALUES (51749, 754, 149, 1752);
INSERT INTO 'devicecapvalue' VALUES (51750, 754, 149, 2516);
INSERT INTO 'devicecapvalue' VALUES (51751, 754, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (51752, 754, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (51753, 754, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (51754, 754, 252, 2347);
INSERT INTO 'devicecapvalue' VALUES (51755, 754, 136, 2320);
INSERT INTO 'devicecapvalue' VALUES (51756, 754, 137, 2348);
INSERT INTO 'devicecapvalue' VALUES (51757, 754, 137, 2349);
INSERT INTO 'devicecapvalue' VALUES (51758, 754, 137, 2350);
INSERT INTO 'devicecapvalue' VALUES (51759, 754, 137, 2352);
INSERT INTO 'devicecapvalue' VALUES (51760, 754, 138, 2560);
INSERT INTO 'devicecapvalue' VALUES (51761, 754, 72, 1682);
INSERT INTO 'devicecapvalue' VALUES (51762, 754, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (51763, 754, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (51764, 754, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (51765, 754, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (51766, 754, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (51767, 754, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (51768, 754, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (51769, 754, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (51770, 754, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (51771, 754, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (51772, 754, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (51773, 754, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (51774, 754, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (51775, 754, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (51776, 754, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (51777, 754, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (51778, 754, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (51779, 754, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (51780, 754, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (51781, 754, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (51782, 754, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (51783, 754, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (51784, 754, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (51785, 754, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (51786, 754, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (51787, 754, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (51788, 754, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (51789, 754, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (51790, 754, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (51791, 754, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (51792, 754, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (51793, 754, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (51794, 754, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (51795, 754, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (51796, 754, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (51797, 754, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (51798, 754, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (51799, 754, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (51800, 754, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (51801, 754, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (51802, 754, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (51803, 754, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (51804, 754, 48, 2322);
INSERT INTO 'devicecapvalue' VALUES (51805, 754, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (51806, 754, 49, 659);
INSERT INTO 'devicecapvalue' VALUES (51807, 754, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (51808, 754, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (51809, 754, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (51810, 754, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (51811, 754, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (51812, 754, 157, 2426);
INSERT INTO 'capvalue' VALUES (2564, 'SonyEricssonW760i/R3BA Browser/NetFront/3.4 Profile/MIDP-2.1 Configuration/CLDC-1.1 JavaPlatform/JP-8.3.0');
INSERT INTO 'devicecapvalue' VALUES (51813, 754, 53, 2564);
INSERT INTO 'devicecapvalue' VALUES (51814, 755, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (51815, 755, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (51816, 755, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (51817, 755, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (51818, 755, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (51819, 755, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (51820, 755, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (51821, 755, 173, 1688);
INSERT INTO 'capvalue' VALUES (2565, 'SonyEricsson_W800');
INSERT INTO 'devicecapvalue' VALUES (51822, 755, 75, 2565);
INSERT INTO 'devicecapvalue' VALUES (51823, 755, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (51824, 755, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (51825, 755, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (51826, 755, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (51827, 755, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (51828, 755, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (51829, 755, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (51830, 755, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (51831, 755, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (51832, 755, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (51833, 755, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (51834, 755, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (51835, 755, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (51836, 755, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (51837, 755, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (51838, 755, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (51839, 755, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (51840, 755, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (51841, 755, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (51842, 755, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (51843, 755, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (51844, 755, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (51845, 755, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (51846, 755, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (51847, 755, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (51848, 755, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (51849, 755, 154, 1018);
INSERT INTO 'cap' VALUES (275, 'key.predictive.ClearKey', 1);
INSERT INTO 'devicecapvalue' VALUES (51850, 755, 275, 28);
INSERT INTO 'cap' VALUES (276, 'key.predictive.NextKey', 1);
INSERT INTO 'devicecapvalue' VALUES (51851, 755, 276, 29);
INSERT INTO 'cap' VALUES (277, 'key.predictive.PrevKey', 1);
INSERT INTO 'devicecapvalue' VALUES (51852, 755, 277, 41);
INSERT INTO 'cap' VALUES (278, 'key.predictive.ShiftKey', 1);
INSERT INTO 'devicecapvalue' VALUES (51853, 755, 278, 745);
INSERT INTO 'devicecapvalue' VALUES (51854, 755, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (51855, 755, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (51856, 755, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (51857, 755, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (51858, 755, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (51859, 755, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (51860, 755, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (51861, 755, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (51862, 755, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (51863, 755, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (51864, 755, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (51865, 755, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (51866, 755, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (51867, 755, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (51868, 755, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (51869, 755, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (51870, 755, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (51871, 755, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (51872, 755, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (51873, 755, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (51874, 755, 191, 1372);
INSERT INTO 'capvalue' VALUES (2566, 'SonyEricssonW800');
INSERT INTO 'devicecapvalue' VALUES (51875, 755, 53, 2566);
INSERT INTO 'devicecapvalue' VALUES (51876, 756, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (51877, 756, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (51878, 756, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (51879, 756, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (51880, 756, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (51881, 756, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (51882, 756, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (51883, 756, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (51884, 756, 75, 2565);
INSERT INTO 'devicecapvalue' VALUES (51885, 756, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (51886, 756, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (51887, 756, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (51888, 756, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (51889, 756, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (51890, 756, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (51891, 756, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (51892, 756, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (51893, 756, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (51894, 756, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (51895, 756, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (51896, 756, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (51897, 756, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (51898, 756, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (51899, 756, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (51900, 756, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (51901, 756, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (51902, 756, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (51903, 756, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (51904, 756, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (51905, 756, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (51906, 756, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (51907, 756, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (51908, 756, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (51909, 756, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (51910, 756, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (51911, 756, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (51912, 756, 275, 28);
INSERT INTO 'devicecapvalue' VALUES (51913, 756, 276, 29);
INSERT INTO 'devicecapvalue' VALUES (51914, 756, 277, 41);
INSERT INTO 'devicecapvalue' VALUES (51915, 756, 278, 745);
INSERT INTO 'devicecapvalue' VALUES (51916, 756, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (51917, 756, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (51918, 756, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (51919, 756, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (51920, 756, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (51921, 756, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (51922, 756, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (51923, 756, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (51924, 756, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (51925, 756, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (51926, 756, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (51927, 756, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (51928, 756, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (51929, 756, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (51930, 756, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (51931, 756, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (51932, 756, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (51933, 756, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (51934, 756, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (51935, 756, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (51936, 756, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (51937, 756, 53, 2566);
INSERT INTO 'devicecapvalue' VALUES (51938, 757, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (51939, 757, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (51940, 757, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (51941, 757, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (51942, 757, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (51943, 757, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (51944, 757, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (51945, 757, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (51946, 757, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (51947, 757, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (51948, 757, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (51949, 757, 173, 1523);
INSERT INTO 'capvalue' VALUES (2567, 'SonyEricsson_W810');
INSERT INTO 'devicecapvalue' VALUES (51950, 757, 75, 2567);
INSERT INTO 'capvalue' VALUES (2568, 'SonyEricsson_W800i');
INSERT INTO 'devicecapvalue' VALUES (51951, 757, 261, 2568);
INSERT INTO 'devicecapvalue' VALUES (51952, 757, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (51953, 757, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (51954, 757, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (51955, 757, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (51956, 757, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (51957, 757, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (51958, 757, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (51959, 757, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (51960, 757, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (51961, 757, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (51962, 757, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (51963, 757, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (51964, 757, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (51965, 757, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (51966, 757, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (51967, 757, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (51968, 757, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (51969, 757, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (51970, 757, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (51971, 757, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (51972, 757, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (51973, 757, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (51974, 757, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (51975, 757, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (51976, 757, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (51977, 757, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (51978, 757, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (51979, 757, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (51980, 757, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (51981, 757, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (51982, 757, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (51983, 757, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (51984, 757, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (51985, 757, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (51986, 757, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (51987, 757, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (51988, 757, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (51989, 757, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (51990, 757, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (51991, 757, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (51992, 757, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (51993, 757, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (51994, 757, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (51995, 757, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (51996, 757, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (51997, 757, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (51998, 757, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (51999, 757, 57, 1245);
INSERT INTO 'devicecapvalue' VALUES (52000, 757, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (52001, 757, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (52002, 757, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (52003, 757, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (52004, 757, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (52005, 757, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (52006, 757, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (52007, 757, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (52008, 757, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (52009, 757, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (52010, 757, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (52011, 757, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (52012, 757, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (52013, 757, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (52014, 757, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (52015, 757, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (52016, 757, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (52017, 757, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (52018, 757, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (52019, 757, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (52020, 757, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (52021, 757, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (52022, 757, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (52023, 757, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (52024, 757, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (52025, 757, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (52026, 757, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (52027, 757, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (52028, 757, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (52029, 757, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (52030, 757, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (52031, 757, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (52032, 757, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (52033, 757, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (52034, 757, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (52035, 757, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (52036, 757, 115, 2449);
INSERT INTO 'capvalue' VALUES (2569, '1.0a');
INSERT INTO 'devicecapvalue' VALUES (52037, 757, 117, 2569);
INSERT INTO 'devicecapvalue' VALUES (52038, 757, 118, 1096);
INSERT INTO 'devicecapvalue' VALUES (52039, 757, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (52040, 757, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (52041, 757, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (52042, 757, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (52043, 757, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (52044, 757, 101, 1469);
INSERT INTO 'capvalue' VALUES (2570, 'e:/');
INSERT INTO 'devicecapvalue' VALUES (52045, 757, 102, 2570);
INSERT INTO 'devicecapvalue' VALUES (52046, 757, 103, 2529);
INSERT INTO 'devicecapvalue' VALUES (52047, 757, 104, 2530);
INSERT INTO 'devicecapvalue' VALUES (52048, 757, 106, 2531);
INSERT INTO 'devicecapvalue' VALUES (52049, 757, 107, 2532);
INSERT INTO 'devicecapvalue' VALUES (52050, 757, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (52051, 757, 109, 2533);
INSERT INTO 'devicecapvalue' VALUES (52052, 757, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (52053, 757, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (52054, 757, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (52055, 757, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (52056, 757, 65, 45);
INSERT INTO 'devicecapvalue' VALUES (52057, 757, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (52058, 757, 67, 45);
INSERT INTO 'capvalue' VALUES (2571, 'SonyEricssonW810i/R4EA031');
INSERT INTO 'devicecapvalue' VALUES (52059, 757, 68, 2571);
INSERT INTO 'devicecapvalue' VALUES (52060, 757, 69, 2390);
INSERT INTO 'devicecapvalue' VALUES (52061, 757, 132, 2449);
INSERT INTO 'devicecapvalue' VALUES (52062, 757, 133, 2090);
INSERT INTO 'capvalue' VALUES (2572, 'audio/mp4a-latm video/mp4v-es video/h263-2000');
INSERT INTO 'devicecapvalue' VALUES (52063, 757, 116, 2572);
INSERT INTO 'devicecapvalue' VALUES (52064, 757, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (52065, 757, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (52066, 757, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (52067, 757, 136, 2090);
INSERT INTO 'devicecapvalue' VALUES (52068, 757, 137, 2537);
INSERT INTO 'devicecapvalue' VALUES (52069, 757, 137, 2538);
INSERT INTO 'devicecapvalue' VALUES (52070, 757, 137, 2453);
INSERT INTO 'capvalue' VALUES (2573, 'jpeg&width=960&height=1280');
INSERT INTO 'devicecapvalue' VALUES (52071, 757, 137, 2573);
INSERT INTO 'capvalue' VALUES (2574, 'http://mms:8002');
INSERT INTO 'devicecapvalue' VALUES (52072, 757, 138, 2574);
INSERT INTO 'capvalue' VALUES (2575, '+989350001400');
INSERT INTO 'devicecapvalue' VALUES (52073, 757, 72, 2575);
INSERT INTO 'capvalue' VALUES (2576, 'WMA 2.0');
INSERT INTO 'devicecapvalue' VALUES (52074, 757, 111, 2576);
INSERT INTO 'devicecapvalue' VALUES (52075, 757, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (52076, 757, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (52077, 757, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (52078, 757, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (52079, 757, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (52080, 757, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (52081, 757, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (52082, 757, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (52083, 757, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (52084, 757, 47, 123);
INSERT INTO 'devicecapvalue' VALUES (52085, 757, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (52086, 757, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (52087, 757, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (52088, 757, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (52089, 757, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (52090, 757, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (52091, 757, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (52092, 757, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (52093, 757, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (52094, 757, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (52095, 757, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (52096, 757, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (52097, 757, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (52098, 757, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (52099, 757, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (52100, 757, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (52101, 757, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (52102, 757, 48, 158);
INSERT INTO 'devicecapvalue' VALUES (52103, 757, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (52104, 757, 49, 2527);
INSERT INTO 'devicecapvalue' VALUES (52105, 757, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (52106, 757, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (52107, 757, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (52108, 757, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (52109, 757, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (52110, 757, 191, 1372);
INSERT INTO 'capvalue' VALUES (2577, 'SonyEricssonW810');
INSERT INTO 'devicecapvalue' VALUES (52111, 757, 53, 2577);
INSERT INTO 'devicecapvalue' VALUES (52112, 758, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (52113, 758, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (52114, 758, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (52115, 758, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (52116, 758, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (52117, 758, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (52118, 758, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (52119, 758, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (52120, 758, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (52121, 758, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (52122, 758, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (52123, 758, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (52124, 758, 75, 2567);
INSERT INTO 'devicecapvalue' VALUES (52125, 758, 261, 2568);
INSERT INTO 'devicecapvalue' VALUES (52126, 758, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (52127, 758, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (52128, 758, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (52129, 758, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (52130, 758, 9, 106);
INSERT INTO 'devicecapvalue' VALUES (52131, 758, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (52132, 758, 11, 106);
INSERT INTO 'devicecapvalue' VALUES (52133, 758, 12, 109);
INSERT INTO 'devicecapvalue' VALUES (52134, 758, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (52135, 758, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (52136, 758, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (52137, 758, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (52138, 758, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (52139, 758, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (52140, 758, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (52141, 758, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (52142, 758, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (52143, 758, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (52144, 758, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (52145, 758, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (52146, 758, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (52147, 758, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (52148, 758, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (52149, 758, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (52150, 758, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (52151, 758, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (52152, 758, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (52153, 758, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (52154, 758, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (52155, 758, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (52156, 758, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (52157, 758, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (52158, 758, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (52159, 758, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (52160, 758, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (52161, 758, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (52162, 758, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (52163, 758, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (52164, 758, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (52165, 758, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (52166, 758, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (52167, 758, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (52168, 758, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (52169, 758, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (52170, 758, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (52171, 758, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (52172, 758, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (52173, 758, 57, 1245);
INSERT INTO 'devicecapvalue' VALUES (52174, 758, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (52175, 758, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (52176, 758, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (52177, 758, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (52178, 758, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (52179, 758, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (52180, 758, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (52181, 758, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (52182, 758, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (52183, 758, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (52184, 758, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (52185, 758, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (52186, 758, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (52187, 758, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (52188, 758, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (52189, 758, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (52190, 758, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (52191, 758, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (52192, 758, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (52193, 758, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (52194, 758, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (52195, 758, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (52196, 758, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (52197, 758, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (52198, 758, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (52199, 758, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (52200, 758, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (52201, 758, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (52202, 758, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (52203, 758, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (52204, 758, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (52205, 758, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (52206, 758, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (52207, 758, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (52208, 758, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (52209, 758, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (52210, 758, 115, 2449);
INSERT INTO 'devicecapvalue' VALUES (52211, 758, 117, 2569);
INSERT INTO 'devicecapvalue' VALUES (52212, 758, 118, 1096);
INSERT INTO 'devicecapvalue' VALUES (52213, 758, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (52214, 758, 120, 244);
INSERT INTO 'devicecapvalue' VALUES (52215, 758, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (52216, 758, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (52217, 758, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (52218, 758, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (52219, 758, 102, 2570);
INSERT INTO 'devicecapvalue' VALUES (52220, 758, 103, 2529);
INSERT INTO 'devicecapvalue' VALUES (52221, 758, 104, 2530);
INSERT INTO 'devicecapvalue' VALUES (52222, 758, 106, 2531);
INSERT INTO 'devicecapvalue' VALUES (52223, 758, 107, 2532);
INSERT INTO 'devicecapvalue' VALUES (52224, 758, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (52225, 758, 109, 2533);
INSERT INTO 'devicecapvalue' VALUES (52226, 758, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (52227, 758, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (52228, 758, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (52229, 758, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (52230, 758, 65, 45);
INSERT INTO 'devicecapvalue' VALUES (52231, 758, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (52232, 758, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (52233, 758, 68, 2571);
INSERT INTO 'devicecapvalue' VALUES (52234, 758, 69, 2390);
INSERT INTO 'devicecapvalue' VALUES (52235, 758, 132, 2449);
INSERT INTO 'devicecapvalue' VALUES (52236, 758, 133, 2090);
INSERT INTO 'devicecapvalue' VALUES (52237, 758, 116, 2572);
INSERT INTO 'devicecapvalue' VALUES (52238, 758, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (52239, 758, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (52240, 758, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (52241, 758, 136, 2090);
INSERT INTO 'devicecapvalue' VALUES (52242, 758, 137, 2537);
INSERT INTO 'devicecapvalue' VALUES (52243, 758, 137, 2538);
INSERT INTO 'devicecapvalue' VALUES (52244, 758, 137, 2453);
INSERT INTO 'devicecapvalue' VALUES (52245, 758, 137, 2573);
INSERT INTO 'devicecapvalue' VALUES (52246, 758, 138, 2574);
INSERT INTO 'devicecapvalue' VALUES (52247, 758, 72, 2575);
INSERT INTO 'devicecapvalue' VALUES (52248, 758, 111, 2576);
INSERT INTO 'devicecapvalue' VALUES (52249, 758, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (52250, 758, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (52251, 758, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (52252, 758, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (52253, 758, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (52254, 758, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (52255, 758, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (52256, 758, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (52257, 758, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (52258, 758, 47, 123);
INSERT INTO 'devicecapvalue' VALUES (52259, 758, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (52260, 758, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (52261, 758, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (52262, 758, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (52263, 758, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (52264, 758, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (52265, 758, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (52266, 758, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (52267, 758, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (52268, 758, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (52269, 758, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (52270, 758, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (52271, 758, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (52272, 758, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (52273, 758, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (52274, 758, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (52275, 758, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (52276, 758, 48, 158);
INSERT INTO 'devicecapvalue' VALUES (52277, 758, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (52278, 758, 49, 2527);
INSERT INTO 'devicecapvalue' VALUES (52279, 758, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (52280, 758, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (52281, 758, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (52282, 758, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (52283, 758, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (52284, 758, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (52285, 758, 53, 2577);
INSERT INTO 'devicecapvalue' VALUES (52286, 759, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (52287, 759, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (52288, 759, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (52289, 759, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (52290, 759, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (52291, 759, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (52292, 759, 7, 688);
INSERT INTO 'devicecapvalue' VALUES (52293, 759, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (52294, 759, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (52295, 759, 173, 1523);
INSERT INTO 'capvalue' VALUES (2578, 'SonyEricsson_W830');
INSERT INTO 'devicecapvalue' VALUES (52296, 759, 75, 2578);
INSERT INTO 'capvalue' VALUES (2579, 'SonyEricsson_W830i');
INSERT INTO 'devicecapvalue' VALUES (52297, 759, 261, 2579);
INSERT INTO 'devicecapvalue' VALUES (52298, 759, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (52299, 759, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (52300, 759, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (52301, 759, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (52302, 759, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (52303, 759, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (52304, 759, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (52305, 759, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (52306, 759, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (52307, 759, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (52308, 759, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (52309, 759, 15, 1525);
INSERT INTO 'capvalue' VALUES (2580, 'gif89a png');
INSERT INTO 'devicecapvalue' VALUES (52310, 759, 15, 2580);
INSERT INTO 'devicecapvalue' VALUES (52311, 759, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (52312, 759, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (52313, 759, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (52314, 759, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (52315, 759, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (52316, 759, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (52317, 759, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (52318, 759, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (52319, 759, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (52320, 759, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (52321, 759, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (52322, 759, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (52323, 759, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (52324, 759, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (52325, 759, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (52326, 759, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (52327, 759, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (52328, 759, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (52329, 759, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (52330, 759, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (52331, 759, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (52332, 759, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (52333, 759, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (52334, 759, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (52335, 759, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (52336, 759, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (52337, 759, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (52338, 759, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (52339, 759, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (52340, 759, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (52341, 759, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (52342, 759, 51, 100);
INSERT INTO 'capvalue' VALUES (2581, 'emy');
INSERT INTO 'devicecapvalue' VALUES (52343, 759, 51, 2581);
INSERT INTO 'capvalue' VALUES (2582, 'imy');
INSERT INTO 'devicecapvalue' VALUES (52344, 759, 51, 2582);
INSERT INTO 'devicecapvalue' VALUES (52345, 759, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (52346, 759, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (52347, 759, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (52348, 759, 51, 1117);
INSERT INTO 'capvalue' VALUES (2583, 'mp4a');
INSERT INTO 'devicecapvalue' VALUES (52349, 759, 51, 2583);
INSERT INTO 'devicecapvalue' VALUES (52350, 759, 51, 669);
INSERT INTO 'capvalue' VALUES (2584, 'wma10');
INSERT INTO 'devicecapvalue' VALUES (52351, 759, 51, 2584);
INSERT INTO 'devicecapvalue' VALUES (52352, 759, 51, 1042);
INSERT INTO 'devicecapvalue' VALUES (52353, 759, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (52354, 759, 157, 975);
INSERT INTO 'devicecapvalue' VALUES (52355, 759, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (52356, 759, 157, 1504);
INSERT INTO 'capvalue' VALUES (2585, 'rv8');
INSERT INTO 'devicecapvalue' VALUES (52357, 759, 157, 2585);
INSERT INTO 'devicecapvalue' VALUES (52358, 759, 157, 1041);
INSERT INTO 'devicecapvalue' VALUES (52359, 759, 191, 1372);
INSERT INTO 'capvalue' VALUES (2586, 'SonyEricssonW830i');
INSERT INTO 'devicecapvalue' VALUES (52360, 759, 53, 2586);
INSERT INTO 'devicecapvalue' VALUES (52361, 760, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (52362, 760, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (52363, 760, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (52364, 760, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (52365, 760, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (52366, 760, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (52367, 760, 7, 688);
INSERT INTO 'devicecapvalue' VALUES (52368, 760, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (52369, 760, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (52370, 760, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (52371, 760, 75, 2578);
INSERT INTO 'devicecapvalue' VALUES (52372, 760, 261, 2579);
INSERT INTO 'devicecapvalue' VALUES (52373, 760, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (52374, 760, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (52375, 760, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (52376, 760, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (52377, 760, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (52378, 760, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (52379, 760, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (52380, 760, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (52381, 760, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (52382, 760, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (52383, 760, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (52384, 760, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (52385, 760, 15, 2580);
INSERT INTO 'devicecapvalue' VALUES (52386, 760, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (52387, 760, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (52388, 760, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (52389, 760, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (52390, 760, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (52391, 760, 17, 675);
INSERT INTO 'devicecapvalue' VALUES (52392, 760, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (52393, 760, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (52394, 760, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (52395, 760, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (52396, 760, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (52397, 760, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (52398, 760, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (52399, 760, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (52400, 760, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (52401, 760, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (52402, 760, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (52403, 760, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (52404, 760, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (52405, 760, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (52406, 760, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (52407, 760, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (52408, 760, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (52409, 760, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (52410, 760, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (52411, 760, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (52412, 760, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (52413, 760, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (52414, 760, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (52415, 760, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (52416, 760, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (52417, 760, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (52418, 760, 51, 2581);
INSERT INTO 'devicecapvalue' VALUES (52419, 760, 51, 2582);
INSERT INTO 'devicecapvalue' VALUES (52420, 760, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (52421, 760, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (52422, 760, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (52423, 760, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (52424, 760, 51, 2583);
INSERT INTO 'devicecapvalue' VALUES (52425, 760, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (52426, 760, 51, 2584);
INSERT INTO 'devicecapvalue' VALUES (52427, 760, 51, 1042);
INSERT INTO 'devicecapvalue' VALUES (52428, 760, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (52429, 760, 157, 975);
INSERT INTO 'devicecapvalue' VALUES (52430, 760, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (52431, 760, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (52432, 760, 157, 2585);
INSERT INTO 'devicecapvalue' VALUES (52433, 760, 157, 1041);
INSERT INTO 'devicecapvalue' VALUES (52434, 760, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (52435, 760, 53, 2586);
INSERT INTO 'devicecapvalue' VALUES (52436, 761, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (52437, 761, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (52438, 761, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (52439, 761, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (52440, 761, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (52441, 761, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (52442, 761, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (52443, 761, 75, 2567);
INSERT INTO 'devicecapvalue' VALUES (52444, 761, 261, 2568);
INSERT INTO 'devicecapvalue' VALUES (52445, 761, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (52446, 761, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (52447, 761, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (52448, 761, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (52449, 761, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (52450, 761, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (52451, 761, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (52452, 761, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (52453, 761, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (52454, 761, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (52455, 761, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (52456, 761, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (52457, 761, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (52458, 761, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (52459, 761, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (52460, 761, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (52461, 761, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (52462, 761, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (52463, 761, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (52464, 761, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (52465, 761, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (52466, 761, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (52467, 761, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (52468, 761, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (52469, 761, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (52470, 761, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (52471, 761, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (52472, 761, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (52473, 761, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (52474, 761, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (52475, 761, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (52476, 761, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (52477, 761, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (52478, 761, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (52479, 761, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (52480, 761, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (52481, 761, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (52482, 761, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (52483, 761, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (52484, 761, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (52485, 761, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (52486, 761, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (52487, 761, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (52488, 761, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (52489, 761, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (52490, 761, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (52491, 761, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (52492, 761, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (52493, 761, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (52494, 761, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (52495, 761, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (52496, 761, 191, 1372);
INSERT INTO 'capvalue' VALUES (2587, 'SonyEricssonW850i/R1ED Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (52497, 761, 53, 2587);
INSERT INTO 'devicecapvalue' VALUES (52498, 762, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (52499, 762, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (52500, 762, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (52501, 762, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (52502, 762, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (52503, 762, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (52504, 762, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (52505, 762, 75, 2567);
INSERT INTO 'devicecapvalue' VALUES (52506, 762, 261, 2568);
INSERT INTO 'devicecapvalue' VALUES (52507, 762, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (52508, 762, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (52509, 762, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (52510, 762, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (52511, 762, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (52512, 762, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (52513, 762, 150, 1114);
INSERT INTO 'devicecapvalue' VALUES (52514, 762, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (52515, 762, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (52516, 762, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (52517, 762, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (52518, 762, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (52519, 762, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (52520, 762, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (52521, 762, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (52522, 762, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (52523, 762, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (52524, 762, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (52525, 762, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (52526, 762, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (52527, 762, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (52528, 762, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (52529, 762, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (52530, 762, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (52531, 762, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (52532, 762, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (52533, 762, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (52534, 762, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (52535, 762, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (52536, 762, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (52537, 762, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (52538, 762, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (52539, 762, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (52540, 762, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (52541, 762, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (52542, 762, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (52543, 762, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (52544, 762, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (52545, 762, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (52546, 762, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (52547, 762, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (52548, 762, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (52549, 762, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (52550, 762, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (52551, 762, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (52552, 762, 52, 1226);
INSERT INTO 'devicecapvalue' VALUES (52553, 762, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (52554, 762, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (52555, 762, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (52556, 762, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (52557, 762, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (52558, 762, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (52559, 762, 53, 2587);
INSERT INTO 'devicecapvalue' VALUES (52560, 763, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (52561, 763, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (52562, 763, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (52563, 763, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (52564, 763, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (52565, 763, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (52566, 763, 7, 2117);
INSERT INTO 'devicecapvalue' VALUES (52567, 763, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (52568, 763, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (52569, 763, 173, 1688);
INSERT INTO 'capvalue' VALUES (2588, 'SonyEricsson_W880');
INSERT INTO 'devicecapvalue' VALUES (52570, 763, 75, 2588);
INSERT INTO 'capvalue' VALUES (2589, 'SonyEricsson_W880i');
INSERT INTO 'devicecapvalue' VALUES (52571, 763, 261, 2589);
INSERT INTO 'devicecapvalue' VALUES (52572, 763, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (52573, 763, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (52574, 763, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (52575, 763, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (52576, 763, 10, 1871);
INSERT INTO 'devicecapvalue' VALUES (52577, 763, 11, 649);
INSERT INTO 'devicecapvalue' VALUES (52578, 763, 12, 603);
INSERT INTO 'devicecapvalue' VALUES (52579, 763, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (52580, 763, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (52581, 763, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (52582, 763, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (52583, 763, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (52584, 763, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (52585, 763, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (52586, 763, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (52587, 763, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (52588, 763, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (52589, 763, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (52590, 763, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (52591, 763, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (52592, 763, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (52593, 763, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (52594, 763, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (52595, 763, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (52596, 763, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (52597, 763, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (52598, 763, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (52599, 763, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (52600, 763, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (52601, 763, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (52602, 763, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (52603, 763, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (52604, 763, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (52605, 763, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (52606, 763, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (52607, 763, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (52608, 763, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (52609, 763, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (52610, 763, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (52611, 763, 154, 1018);
INSERT INTO 'cap' VALUES (279, 'key.CameraKey', 1);
INSERT INTO 'devicecapvalue' VALUES (52612, 763, 279, 117);
INSERT INTO 'devicecapvalue' VALUES (52613, 763, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (52614, 763, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (52615, 763, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (52616, 763, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (52617, 763, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (52618, 763, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (52619, 763, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (52620, 763, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (52621, 763, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (52622, 763, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (52623, 763, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (52624, 763, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (52625, 763, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (52626, 763, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (52627, 763, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (52628, 763, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (52629, 763, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (52630, 763, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (52631, 763, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (52632, 763, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (52633, 763, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (52634, 763, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (52635, 763, 191, 1372);
INSERT INTO 'capvalue' VALUES (2590, 'SonyEricssonW880i/R1JE');
INSERT INTO 'devicecapvalue' VALUES (52636, 763, 53, 2590);
INSERT INTO 'devicecapvalue' VALUES (52637, 764, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (52638, 764, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (52639, 764, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (52640, 764, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (52641, 764, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (52642, 764, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (52643, 764, 7, 2117);
INSERT INTO 'devicecapvalue' VALUES (52644, 764, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (52645, 764, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (52646, 764, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (52647, 764, 75, 2588);
INSERT INTO 'devicecapvalue' VALUES (52648, 764, 261, 2589);
INSERT INTO 'devicecapvalue' VALUES (52649, 764, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (52650, 764, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (52651, 764, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (52652, 764, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (52653, 764, 10, 1871);
INSERT INTO 'devicecapvalue' VALUES (52654, 764, 11, 649);
INSERT INTO 'devicecapvalue' VALUES (52655, 764, 12, 603);
INSERT INTO 'devicecapvalue' VALUES (52656, 764, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (52657, 764, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (52658, 764, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (52659, 764, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (52660, 764, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (52661, 764, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (52662, 764, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (52663, 764, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (52664, 764, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (52665, 764, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (52666, 764, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (52667, 764, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (52668, 764, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (52669, 764, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (52670, 764, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (52671, 764, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (52672, 764, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (52673, 764, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (52674, 764, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (52675, 764, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (52676, 764, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (52677, 764, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (52678, 764, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (52679, 764, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (52680, 764, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (52681, 764, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (52682, 764, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (52683, 764, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (52684, 764, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (52685, 764, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (52686, 764, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (52687, 764, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (52688, 764, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (52689, 764, 279, 117);
INSERT INTO 'devicecapvalue' VALUES (52690, 764, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (52691, 764, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (52692, 764, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (52693, 764, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (52694, 764, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (52695, 764, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (52696, 764, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (52697, 764, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (52698, 764, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (52699, 764, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (52700, 764, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (52701, 764, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (52702, 764, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (52703, 764, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (52704, 764, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (52705, 764, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (52706, 764, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (52707, 764, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (52708, 764, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (52709, 764, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (52710, 764, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (52711, 764, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (52712, 764, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (52713, 764, 53, 2590);
INSERT INTO 'devicecapvalue' VALUES (52714, 765, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (52715, 765, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (52716, 765, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (52717, 765, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (52718, 765, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (52719, 765, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (52720, 765, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (52721, 765, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (52722, 765, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (52723, 765, 173, 1688);
INSERT INTO 'capvalue' VALUES (2591, 'SonyEricsson_W900');
INSERT INTO 'devicecapvalue' VALUES (52724, 765, 75, 2591);
INSERT INTO 'capvalue' VALUES (2592, 'SonyEricsson_W900i');
INSERT INTO 'devicecapvalue' VALUES (52725, 765, 261, 2592);
INSERT INTO 'devicecapvalue' VALUES (52726, 765, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (52727, 765, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (52728, 765, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (52729, 765, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (52730, 765, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (52731, 765, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (52732, 765, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (52733, 765, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (52734, 765, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (52735, 765, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (52736, 765, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (52737, 765, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (52738, 765, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (52739, 765, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (52740, 765, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (52741, 765, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (52742, 765, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (52743, 765, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (52744, 765, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (52745, 765, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (52746, 765, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (52747, 765, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (52748, 765, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (52749, 765, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (52750, 765, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (52751, 765, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (52752, 765, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (52753, 765, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (52754, 765, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (52755, 765, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (52756, 765, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (52757, 765, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (52758, 765, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (52759, 765, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (52760, 765, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (52761, 765, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (52762, 765, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (52763, 765, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (52764, 765, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (52765, 765, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (52766, 765, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (52767, 765, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (52768, 765, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (52769, 765, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (52770, 765, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (52771, 765, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (52772, 765, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (52773, 765, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (52774, 765, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (52775, 765, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (52776, 765, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (52777, 765, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (52778, 765, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (52779, 765, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (52780, 765, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (52781, 765, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (52782, 765, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (52783, 765, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (52784, 765, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (52785, 765, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (52786, 765, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (52787, 765, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (52788, 765, 191, 1372);
INSERT INTO 'capvalue' VALUES (2593, 'SonyEricssonW900i/R5BC Browser/NetFront/3.3 Profile/MIDP-2.0 Configuration/CLDC-13G');
INSERT INTO 'devicecapvalue' VALUES (52789, 765, 53, 2593);
INSERT INTO 'devicecapvalue' VALUES (52790, 766, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (52791, 766, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (52792, 766, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (52793, 766, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (52794, 766, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (52795, 766, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (52796, 766, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (52797, 766, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (52798, 766, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (52799, 766, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (52800, 766, 75, 2591);
INSERT INTO 'devicecapvalue' VALUES (52801, 766, 261, 2592);
INSERT INTO 'devicecapvalue' VALUES (52802, 766, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (52803, 766, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (52804, 766, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (52805, 766, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (52806, 766, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (52807, 766, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (52808, 766, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (52809, 766, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (52810, 766, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (52811, 766, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (52812, 766, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (52813, 766, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (52814, 766, 77, 1);
INSERT INTO 'devicecapvalue' VALUES (52815, 766, 78, 1);
INSERT INTO 'devicecapvalue' VALUES (52816, 766, 77, 649);
INSERT INTO 'devicecapvalue' VALUES (52817, 766, 78, 649);
INSERT INTO 'devicecapvalue' VALUES (52818, 766, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (52819, 766, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (52820, 766, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (52821, 766, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (52822, 766, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (52823, 766, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (52824, 766, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (52825, 766, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (52826, 766, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (52827, 766, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (52828, 766, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (52829, 766, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (52830, 766, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (52831, 766, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (52832, 766, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (52833, 766, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (52834, 766, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (52835, 766, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (52836, 766, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (52837, 766, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (52838, 766, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (52839, 766, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (52840, 766, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (52841, 766, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (52842, 766, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (52843, 766, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (52844, 766, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (52845, 766, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (52846, 766, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (52847, 766, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (52848, 766, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (52849, 766, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (52850, 766, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (52851, 766, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (52852, 766, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (52853, 766, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (52854, 766, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (52855, 766, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (52856, 766, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (52857, 766, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (52858, 766, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (52859, 766, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (52860, 766, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (52861, 766, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (52862, 766, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (52863, 766, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (52864, 766, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (52865, 766, 53, 2593);
INSERT INTO 'devicecapvalue' VALUES (52866, 767, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (52867, 767, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (52868, 767, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (52869, 767, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (52870, 767, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (52871, 767, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (52872, 767, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (52873, 767, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (52874, 767, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (52875, 767, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (52876, 767, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (52877, 767, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (52878, 767, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (52879, 767, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (52880, 767, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (52881, 767, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (52882, 767, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (52883, 767, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (52884, 767, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (52885, 767, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (52886, 767, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (52887, 767, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (52888, 767, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (52889, 767, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (52890, 767, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (52891, 767, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (52892, 767, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (52893, 767, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (52894, 767, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (52895, 767, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (52896, 767, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (52897, 767, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (52898, 767, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (52899, 767, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (52900, 767, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (52901, 767, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (52902, 767, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (52903, 767, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (52904, 767, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (52905, 767, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (52906, 767, 54, 638);
INSERT INTO 'devicecapvalue' VALUES (52907, 767, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (52908, 767, 38, 2315);
INSERT INTO 'devicecapvalue' VALUES (52909, 767, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (52910, 767, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (52911, 767, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (52912, 767, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (52913, 767, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (52914, 767, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (52915, 767, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (52916, 767, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (52917, 767, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (52918, 767, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (52919, 767, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (52920, 767, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (52921, 767, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (52922, 767, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (52923, 767, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (52924, 767, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (52925, 767, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (52926, 767, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (52927, 767, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (52928, 767, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (52929, 767, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (52930, 767, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (52931, 767, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (52932, 767, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (52933, 767, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (52934, 767, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (52935, 767, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (52936, 767, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (52937, 767, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (52938, 767, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (52939, 767, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (52940, 767, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (52941, 767, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (52942, 767, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (52943, 767, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (52944, 767, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (52945, 767, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (52946, 767, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (52947, 767, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (52948, 767, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (52949, 767, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (52950, 767, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (52951, 767, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (52952, 767, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (52953, 767, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (52954, 767, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (52955, 767, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (52956, 767, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (52957, 767, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (52958, 767, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (52959, 767, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (52960, 767, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (52961, 767, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (52962, 767, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (52963, 767, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (52964, 767, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (52965, 767, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (52966, 767, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (52967, 767, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (52968, 767, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (52969, 767, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (52970, 767, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (52971, 767, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (52972, 767, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (52973, 767, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (52974, 767, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (52975, 767, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (52976, 767, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (52977, 767, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (52978, 767, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (52979, 767, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (52980, 767, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (52981, 767, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (52982, 767, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (52983, 767, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (52984, 767, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (52985, 767, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (52986, 767, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (52987, 767, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (52988, 767, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (52989, 767, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (52990, 767, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (52991, 767, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (52992, 767, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (52993, 767, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (52994, 767, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (52995, 767, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (52996, 767, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (52997, 767, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (52998, 767, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (52999, 767, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (53000, 767, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (53001, 767, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (53002, 767, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (53003, 767, 45, 2376);
INSERT INTO 'devicecapvalue' VALUES (53004, 767, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (53005, 767, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (53006, 767, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (53007, 767, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (53008, 767, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (53009, 767, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (53010, 767, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (53011, 767, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (53012, 767, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (53013, 767, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (53014, 767, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (53015, 767, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (53016, 767, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (53017, 767, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (53018, 767, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (53019, 767, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (53020, 767, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (53021, 767, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (53022, 767, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (53023, 767, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (53024, 767, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (53025, 767, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (53026, 767, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (53027, 767, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (53028, 767, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (53029, 767, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (53030, 767, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (53031, 767, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (53032, 767, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (53033, 767, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (53034, 767, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (53035, 767, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (53036, 767, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (53037, 767, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (53038, 767, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (53039, 767, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (53040, 767, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (53041, 767, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (53042, 767, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (53043, 767, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (53044, 767, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (53045, 767, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (53046, 767, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (53047, 767, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (53048, 767, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (53049, 767, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (53050, 767, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (53051, 767, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (53052, 767, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (53053, 767, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (53054, 767, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (53055, 767, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (53056, 767, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (53057, 767, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (53058, 767, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (53059, 767, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (53060, 767, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (53061, 767, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (53062, 767, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (53063, 767, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (53064, 767, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (53065, 767, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (53066, 767, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (53067, 767, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (53068, 767, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (53069, 767, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (53070, 767, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (53071, 767, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (53072, 767, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (53073, 767, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (53074, 767, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (53075, 767, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (53076, 767, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (53077, 767, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (53078, 767, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (53079, 767, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (53080, 767, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (53081, 767, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (53082, 767, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (53083, 767, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (53084, 767, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (53085, 767, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (53086, 767, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (53087, 767, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (53088, 767, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (53089, 767, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (53090, 767, 48, 174);
INSERT INTO 'devicecapvalue' VALUES (53091, 767, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (53092, 767, 49, 659);
INSERT INTO 'devicecapvalue' VALUES (53093, 768, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (53094, 768, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (53095, 768, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (53096, 768, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (53097, 768, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (53098, 768, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (53099, 768, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (53100, 768, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (53101, 768, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (53102, 768, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (53103, 768, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (53104, 768, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (53105, 768, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (53106, 768, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (53107, 768, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (53108, 768, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (53109, 768, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (53110, 768, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (53111, 768, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (53112, 768, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (53113, 768, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (53114, 768, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (53115, 768, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (53116, 768, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (53117, 768, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (53118, 768, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53119, 768, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (53120, 768, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (53121, 768, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (53122, 768, 17, 1487);
INSERT INTO 'devicecapvalue' VALUES (53123, 768, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (53124, 768, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (53125, 768, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53126, 768, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (53127, 768, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (53128, 768, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (53129, 768, 17, 2007);
INSERT INTO 'devicecapvalue' VALUES (53130, 768, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (53131, 768, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (53132, 768, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (53133, 768, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53134, 768, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (53135, 768, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (53136, 768, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (53137, 768, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (53138, 768, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (53139, 768, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (53140, 768, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (53141, 768, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (53142, 768, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (53143, 768, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (53144, 768, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (53145, 768, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (53146, 768, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (53147, 768, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (53148, 768, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (53149, 768, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (53150, 768, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (53151, 768, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (53152, 768, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (53153, 768, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (53154, 768, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (53155, 768, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (53156, 768, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (53157, 768, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (53158, 768, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (53159, 768, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (53160, 768, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (53161, 768, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (53162, 768, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (53163, 768, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (53164, 768, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (53165, 768, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (53166, 768, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (53167, 768, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (53168, 768, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (53169, 768, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (53170, 768, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (53171, 768, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (53172, 768, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (53173, 768, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (53174, 768, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (53175, 768, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (53176, 769, 56, 707);
INSERT INTO 'devicecapvalue' VALUES (53177, 769, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (53178, 769, 79, 15);
INSERT INTO 'devicecapvalue' VALUES (53179, 769, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (53180, 769, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (53181, 769, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (53182, 769, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (53183, 769, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (53184, 769, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (53185, 769, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (53186, 769, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (53187, 769, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (53188, 769, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (53189, 769, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (53190, 769, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (53191, 769, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (53192, 769, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (53193, 769, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (53194, 769, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (53195, 769, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (53196, 769, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (53197, 769, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (53198, 769, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (53199, 769, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (53200, 769, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (53201, 769, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53202, 769, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (53203, 769, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (53204, 769, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (53205, 769, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (53206, 769, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53207, 769, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (53208, 769, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (53209, 769, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (53210, 769, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (53211, 769, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (53212, 769, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53213, 769, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53214, 769, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (53215, 769, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (53216, 769, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (53217, 769, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (53218, 769, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (53219, 769, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (53220, 769, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (53221, 769, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (53222, 769, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (53223, 769, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (53224, 769, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (53225, 769, 26, 36);
INSERT INTO 'devicecapvalue' VALUES (53226, 769, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (53227, 769, 57, 30);
INSERT INTO 'devicecapvalue' VALUES (53228, 769, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (53229, 769, 30, 40);
INSERT INTO 'devicecapvalue' VALUES (53230, 769, 54, 30);
INSERT INTO 'devicecapvalue' VALUES (53231, 769, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (53232, 769, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (53233, 769, 38, 49);
INSERT INTO 'devicecapvalue' VALUES (53234, 769, 38, 2535);
INSERT INTO 'devicecapvalue' VALUES (53235, 769, 38, 2334);
INSERT INTO 'devicecapvalue' VALUES (53236, 769, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (53237, 769, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (53238, 769, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (53239, 769, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (53240, 769, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (53241, 769, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (53242, 769, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (53243, 769, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (53244, 769, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (53245, 769, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (53246, 769, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (53247, 769, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (53248, 769, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (53249, 769, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (53250, 769, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (53251, 769, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (53252, 769, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (53253, 769, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (53254, 769, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (53255, 769, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (53256, 769, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (53257, 769, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (53258, 769, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (53259, 769, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (53260, 769, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (53261, 769, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (53262, 769, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (53263, 769, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (53264, 769, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (53265, 769, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (53266, 769, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (53267, 769, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (53268, 769, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (53269, 769, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (53270, 769, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (53271, 769, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (53272, 769, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (53273, 769, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (53274, 769, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (53275, 769, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (53276, 769, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (53277, 769, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (53278, 769, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (53279, 769, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (53280, 769, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (53281, 769, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (53282, 769, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (53283, 769, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (53284, 769, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (53285, 769, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (53286, 769, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (53287, 769, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (53288, 769, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (53289, 769, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (53290, 769, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (53291, 769, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (53292, 769, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (53293, 769, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (53294, 769, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (53295, 769, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (53296, 769, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (53297, 769, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (53298, 769, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (53299, 769, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (53300, 769, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (53301, 769, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (53302, 769, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (53303, 769, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (53304, 769, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (53305, 769, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (53306, 769, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (53307, 769, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (53308, 769, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (53309, 769, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (53310, 769, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (53311, 769, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (53312, 769, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (53313, 769, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (53314, 769, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (53315, 769, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (53316, 769, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (53317, 769, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (53318, 769, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (53319, 769, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (53320, 769, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (53321, 769, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (53322, 769, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (53323, 769, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (53324, 769, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (53325, 769, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (53326, 769, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (53327, 769, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (53328, 769, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (53329, 769, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (53330, 769, 45, 136);
INSERT INTO 'devicecapvalue' VALUES (53331, 769, 45, 2080);
INSERT INTO 'devicecapvalue' VALUES (53332, 769, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (53333, 769, 58, 606);
INSERT INTO 'devicecapvalue' VALUES (53334, 769, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (53335, 769, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (53336, 769, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (53337, 769, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (53338, 769, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (53339, 769, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (53340, 769, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (53341, 769, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (53342, 769, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (53343, 769, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (53344, 769, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (53345, 769, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (53346, 769, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (53347, 769, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (53348, 769, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (53349, 769, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (53350, 769, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (53351, 769, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (53352, 769, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (53353, 769, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (53354, 769, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (53355, 769, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (53356, 769, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (53357, 769, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (53358, 769, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (53359, 769, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (53360, 769, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (53361, 769, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (53362, 769, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (53363, 769, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (53364, 769, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (53365, 769, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (53366, 769, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (53367, 769, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (53368, 769, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (53369, 769, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (53370, 769, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (53371, 769, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (53372, 769, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (53373, 769, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (53374, 769, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (53375, 769, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (53376, 769, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (53377, 769, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (53378, 769, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (53379, 769, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (53380, 769, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (53381, 769, 46, 938);
INSERT INTO 'devicecapvalue' VALUES (53382, 769, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (53383, 769, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (53384, 769, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (53385, 769, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (53386, 769, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (53387, 769, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (53388, 769, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (53389, 769, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (53390, 769, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (53391, 769, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (53392, 769, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (53393, 769, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (53394, 769, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (53395, 769, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (53396, 769, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (53397, 769, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (53398, 769, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (53399, 769, 115, 2315);
INSERT INTO 'devicecapvalue' VALUES (53400, 769, 197, 2335);
INSERT INTO 'devicecapvalue' VALUES (53401, 769, 141, 1096);
INSERT INTO 'devicecapvalue' VALUES (53402, 769, 117, 242);
INSERT INTO 'devicecapvalue' VALUES (53403, 769, 118, 1052);
INSERT INTO 'devicecapvalue' VALUES (53404, 769, 119, 15);
INSERT INTO 'devicecapvalue' VALUES (53405, 769, 120, 15);
INSERT INTO 'devicecapvalue' VALUES (53406, 769, 121, 15);
INSERT INTO 'devicecapvalue' VALUES (53407, 769, 122, 15);
INSERT INTO 'devicecapvalue' VALUES (53408, 769, 123, 912);
INSERT INTO 'devicecapvalue' VALUES (53409, 769, 124, 15);
INSERT INTO 'devicecapvalue' VALUES (53410, 769, 125, 707);
INSERT INTO 'devicecapvalue' VALUES (53411, 769, 126, 612);
INSERT INTO 'devicecapvalue' VALUES (53412, 769, 142, 2336);
INSERT INTO 'devicecapvalue' VALUES (53413, 769, 143, 2377);
INSERT INTO 'devicecapvalue' VALUES (53414, 769, 59, 602);
INSERT INTO 'devicecapvalue' VALUES (53415, 769, 101, 1469);
INSERT INTO 'devicecapvalue' VALUES (53416, 769, 102, 1926);
INSERT INTO 'devicecapvalue' VALUES (53417, 769, 103, 2338);
INSERT INTO 'devicecapvalue' VALUES (53418, 769, 104, 2339);
INSERT INTO 'devicecapvalue' VALUES (53419, 769, 105, 2340);
INSERT INTO 'devicecapvalue' VALUES (53420, 769, 106, 2341);
INSERT INTO 'devicecapvalue' VALUES (53421, 769, 107, 2342);
INSERT INTO 'devicecapvalue' VALUES (53422, 769, 108, 2343);
INSERT INTO 'devicecapvalue' VALUES (53423, 769, 109, 946);
INSERT INTO 'devicecapvalue' VALUES (53424, 769, 144, 45);
INSERT INTO 'devicecapvalue' VALUES (53425, 769, 127, 45);
INSERT INTO 'devicecapvalue' VALUES (53426, 769, 114, 983);
INSERT INTO 'devicecapvalue' VALUES (53427, 769, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (53428, 769, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (53429, 769, 145, 45);
INSERT INTO 'devicecapvalue' VALUES (53430, 769, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (53431, 769, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (53432, 769, 128, 921);
INSERT INTO 'devicecapvalue' VALUES (53433, 769, 129, 242);
INSERT INTO 'devicecapvalue' VALUES (53434, 769, 130, 242);
INSERT INTO 'devicecapvalue' VALUES (53435, 769, 65, 242);
INSERT INTO 'devicecapvalue' VALUES (53436, 769, 66, 1678);
INSERT INTO 'devicecapvalue' VALUES (53437, 769, 131, 45);
INSERT INTO 'devicecapvalue' VALUES (53438, 769, 251, 242);
INSERT INTO 'devicecapvalue' VALUES (53439, 769, 67, 45);
INSERT INTO 'capvalue' VALUES (2594, 'SonyEricssonW910i/R1EA033');
INSERT INTO 'devicecapvalue' VALUES (53440, 769, 68, 2594);
INSERT INTO 'devicecapvalue' VALUES (53441, 769, 69, 924);
INSERT INTO 'devicecapvalue' VALUES (53442, 769, 186, 45);
INSERT INTO 'devicecapvalue' VALUES (53443, 769, 188, 45);
INSERT INTO 'devicecapvalue' VALUES (53444, 769, 205, 45);
INSERT INTO 'devicecapvalue' VALUES (53445, 769, 147, 45);
INSERT INTO 'devicecapvalue' VALUES (53446, 769, 148, 613);
INSERT INTO 'devicecapvalue' VALUES (53447, 769, 110, 615);
INSERT INTO 'devicecapvalue' VALUES (53448, 769, 132, 2315);
INSERT INTO 'devicecapvalue' VALUES (53449, 769, 133, 2376);
INSERT INTO 'devicecapvalue' VALUES (53450, 769, 134, 242);
INSERT INTO 'devicecapvalue' VALUES (53451, 769, 116, 2345);
INSERT INTO 'devicecapvalue' VALUES (53452, 769, 86, 15);
INSERT INTO 'devicecapvalue' VALUES (53453, 769, 149, 2346);
INSERT INTO 'devicecapvalue' VALUES (53454, 769, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (53455, 769, 71, 15);
INSERT INTO 'devicecapvalue' VALUES (53456, 769, 135, 15);
INSERT INTO 'devicecapvalue' VALUES (53457, 769, 252, 2347);
INSERT INTO 'devicecapvalue' VALUES (53458, 769, 136, 2376);
INSERT INTO 'devicecapvalue' VALUES (53459, 769, 137, 2348);
INSERT INTO 'devicecapvalue' VALUES (53460, 769, 137, 2381);
INSERT INTO 'devicecapvalue' VALUES (53461, 769, 137, 2352);
INSERT INTO 'devicecapvalue' VALUES (53462, 769, 138, 1507);
INSERT INTO 'devicecapvalue' VALUES (53463, 769, 72, 1508);
INSERT INTO 'devicecapvalue' VALUES (53464, 769, 111, 927);
INSERT INTO 'devicecapvalue' VALUES (53465, 769, 139, 45);
INSERT INTO 'devicecapvalue' VALUES (53466, 769, 140, 45);
INSERT INTO 'devicecapvalue' VALUES (53467, 769, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (53468, 769, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (53469, 769, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (53470, 769, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (53471, 769, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (53472, 769, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (53473, 769, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (53474, 769, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (53475, 769, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (53476, 769, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (53477, 769, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (53478, 769, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (53479, 769, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (53480, 769, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (53481, 769, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (53482, 769, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (53483, 769, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (53484, 769, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (53485, 769, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (53486, 769, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (53487, 769, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (53488, 769, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (53489, 769, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (53490, 769, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (53491, 769, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (53492, 769, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (53493, 769, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (53494, 769, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (53495, 769, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (53496, 769, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (53497, 769, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (53498, 769, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (53499, 769, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (53500, 769, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (53501, 769, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (53502, 769, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (53503, 769, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (53504, 769, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (53505, 769, 52, 1715);
INSERT INTO 'devicecapvalue' VALUES (53506, 769, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (53507, 769, 48, 167);
INSERT INTO 'devicecapvalue' VALUES (53508, 769, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (53509, 769, 49, 659);
INSERT INTO 'devicecapvalue' VALUES (53510, 769, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (53511, 769, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (53512, 769, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (53513, 769, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (53514, 769, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (53515, 769, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (53516, 770, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (53517, 770, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (53518, 770, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (53519, 770, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (53520, 770, 7, 688);
INSERT INTO 'devicecapvalue' VALUES (53521, 770, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (53522, 770, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (53523, 770, 173, 1523);
INSERT INTO 'capvalue' VALUES (2595, 'SonyEricsson_W950');
INSERT INTO 'devicecapvalue' VALUES (53524, 770, 75, 2595);
INSERT INTO 'devicecapvalue' VALUES (53525, 770, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (53526, 770, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (53527, 770, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (53528, 770, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (53529, 770, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (53530, 770, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (53531, 770, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (53532, 770, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (53533, 770, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (53534, 770, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (53535, 770, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (53536, 770, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (53537, 770, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (53538, 770, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (53539, 770, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (53540, 770, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (53541, 770, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (53542, 770, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53543, 770, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (53544, 770, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (53545, 770, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53546, 770, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (53547, 770, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (53548, 770, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (53549, 770, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53550, 770, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (53551, 770, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (53552, 770, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (53553, 770, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (53554, 770, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (53555, 770, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (53556, 770, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (53557, 770, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (53558, 770, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (53559, 770, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (53560, 770, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (53561, 770, 3, 1334);
INSERT INTO 'devicecapvalue' VALUES (53562, 770, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (53563, 770, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (53564, 770, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (53565, 770, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (53566, 770, 5, 601);
INSERT INTO 'capvalue' VALUES (2596, '3ga');
INSERT INTO 'devicecapvalue' VALUES (53567, 770, 51, 2596);
INSERT INTO 'devicecapvalue' VALUES (53568, 770, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (53569, 770, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (53570, 770, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (53571, 770, 51, 1355);
INSERT INTO 'devicecapvalue' VALUES (53572, 770, 51, 2582);
INSERT INTO 'capvalue' VALUES (2597, 'jts');
INSERT INTO 'devicecapvalue' VALUES (53573, 770, 51, 2597);
INSERT INTO 'devicecapvalue' VALUES (53574, 770, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (53575, 770, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (53576, 770, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (53577, 770, 51, 2146);
INSERT INTO 'devicecapvalue' VALUES (53578, 770, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (53579, 770, 51, 1117);
INSERT INTO 'capvalue' VALUES (2598, 'mxmf');
INSERT INTO 'devicecapvalue' VALUES (53580, 770, 51, 2598);
INSERT INTO 'capvalue' VALUES (2599, 'ra');
INSERT INTO 'devicecapvalue' VALUES (53581, 770, 51, 2599);
INSERT INTO 'capvalue' VALUES (2600, 'ram');
INSERT INTO 'devicecapvalue' VALUES (53582, 770, 51, 2600);
INSERT INTO 'devicecapvalue' VALUES (53583, 770, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (53584, 770, 51, 2490);
INSERT INTO 'capvalue' VALUES (2601, 'rng');
INSERT INTO 'devicecapvalue' VALUES (53585, 770, 51, 2601);
INSERT INTO 'devicecapvalue' VALUES (53586, 770, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (53587, 770, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (53588, 770, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (53589, 770, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (53590, 770, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (53591, 770, 157, 1026);
INSERT INTO 'capvalue' VALUES (2602, 'pvx');
INSERT INTO 'devicecapvalue' VALUES (53592, 770, 157, 2602);
INSERT INTO 'devicecapvalue' VALUES (53593, 770, 157, 2600);
INSERT INTO 'devicecapvalue' VALUES (53594, 770, 157, 1504);
INSERT INTO 'capvalue' VALUES (2603, 'rm');
INSERT INTO 'devicecapvalue' VALUES (53595, 770, 157, 2603);
INSERT INTO 'devicecapvalue' VALUES (53596, 770, 157, 2556);
INSERT INTO 'devicecapvalue' VALUES (53597, 770, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (53598, 770, 191, 1372);
INSERT INTO 'capvalue' VALUES (2604, 'SonyEricssonW950i/R100 Mozilla/4.0 (compatible; MSIE 6.0; Symbian OS; 276) Opera 8.60 [fr]1');
INSERT INTO 'devicecapvalue' VALUES (53599, 770, 53, 2604);
INSERT INTO 'devicecapvalue' VALUES (53600, 771, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (53601, 771, 173, 2477);
INSERT INTO 'devicecapvalue' VALUES (53602, 771, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (53603, 771, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (53604, 771, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (53605, 771, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (53606, 771, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (53607, 771, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (53608, 771, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (53609, 771, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (53610, 771, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (53611, 771, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (53612, 771, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (53613, 771, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (53614, 771, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (53615, 771, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (53616, 771, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (53617, 771, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (53618, 771, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (53619, 771, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (53620, 771, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53621, 771, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (53622, 771, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (53623, 771, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53624, 771, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (53625, 771, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (53626, 771, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (53627, 771, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (53628, 771, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53629, 771, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (53630, 771, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (53631, 771, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (53632, 771, 3, 1334);
INSERT INTO 'devicecapvalue' VALUES (53633, 771, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (53634, 771, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (53635, 771, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (53636, 771, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (53637, 771, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (53638, 771, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (53639, 771, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (53640, 771, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (53641, 771, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (53642, 771, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (53643, 771, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (53644, 771, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (53645, 771, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (53646, 771, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (53647, 771, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (53648, 771, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (53649, 771, 52, 593);
INSERT INTO 'devicecapvalue' VALUES (53650, 771, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (53651, 771, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (53652, 771, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (53653, 771, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (53654, 771, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (53655, 771, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (53656, 772, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (53657, 772, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53658, 772, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (53659, 772, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (53660, 772, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53661, 772, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (53662, 772, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (53663, 772, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (53664, 772, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53665, 772, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (53666, 772, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (53667, 772, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (53668, 772, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (53669, 773, 56, 707);
INSERT INTO 'capvalue' VALUES (2605, '800x376');
INSERT INTO 'devicecapvalue' VALUES (53670, 773, 7, 2605);
INSERT INTO 'devicecapvalue' VALUES (53671, 773, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (53672, 773, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (53673, 773, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (53674, 773, 9, 1273);
INSERT INTO 'devicecapvalue' VALUES (53675, 773, 10, 595);
INSERT INTO 'devicecapvalue' VALUES (53676, 773, 11, 1273);
INSERT INTO 'devicecapvalue' VALUES (53677, 773, 12, 663);
INSERT INTO 'capvalue' VALUES (2606, '800x480');
INSERT INTO 'devicecapvalue' VALUES (53678, 773, 13, 2606);
INSERT INTO 'devicecapvalue' VALUES (53679, 773, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (53680, 773, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (53681, 773, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (53682, 773, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (53683, 773, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53684, 773, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (53685, 773, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53686, 773, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (53687, 773, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (53688, 773, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53689, 773, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (53690, 773, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (53691, 773, 112, 28);
INSERT INTO 'devicecapvalue' VALUES (53692, 773, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (53693, 773, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (53694, 773, 21, 31);
INSERT INTO 'devicecapvalue' VALUES (53695, 773, 22, 32);
INSERT INTO 'devicecapvalue' VALUES (53696, 773, 23, 33);
INSERT INTO 'devicecapvalue' VALUES (53697, 773, 24, 34);
INSERT INTO 'devicecapvalue' VALUES (53698, 773, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (53699, 773, 26, 29);
INSERT INTO 'devicecapvalue' VALUES (53700, 773, 27, 30);
INSERT INTO 'devicecapvalue' VALUES (53701, 773, 57, 40);
INSERT INTO 'devicecapvalue' VALUES (53702, 773, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (53703, 773, 30, 41);
INSERT INTO 'devicecapvalue' VALUES (53704, 773, 54, 36);
INSERT INTO 'devicecapvalue' VALUES (53705, 773, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (53706, 773, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (53707, 773, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (53708, 773, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (53709, 773, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (53710, 773, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (53711, 773, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (53712, 773, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (53713, 773, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (53714, 773, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (53715, 773, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (53716, 773, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (53717, 773, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (53718, 773, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (53719, 773, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (53720, 773, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (53721, 773, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (53722, 773, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (53723, 773, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (53724, 773, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (53725, 773, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (53726, 773, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (53727, 773, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (53728, 773, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (53729, 773, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (53730, 773, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (53731, 773, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (53732, 773, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (53733, 773, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (53734, 773, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (53735, 773, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (53736, 773, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (53737, 773, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (53738, 773, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (53739, 773, 59, 240);
INSERT INTO 'devicecapvalue' VALUES (53740, 773, 60, 43);
INSERT INTO 'devicecapvalue' VALUES (53741, 773, 62, 241);
INSERT INTO 'devicecapvalue' VALUES (53742, 773, 63, 45);
INSERT INTO 'devicecapvalue' VALUES (53743, 773, 64, 45);
INSERT INTO 'devicecapvalue' VALUES (53744, 773, 66, 242);
INSERT INTO 'devicecapvalue' VALUES (53745, 773, 67, 45);
INSERT INTO 'devicecapvalue' VALUES (53746, 773, 68, 838);
INSERT INTO 'devicecapvalue' VALUES (53747, 773, 69, 47);
INSERT INTO 'devicecapvalue' VALUES (53748, 773, 70, 15);
INSERT INTO 'devicecapvalue' VALUES (53749, 773, 71, 244);
INSERT INTO 'devicecapvalue' VALUES (53750, 773, 111, 242);
INSERT INTO 'devicecapvalue' VALUES (53751, 773, 48, 90);
INSERT INTO 'capvalue' VALUES (2607, '6291392');
INSERT INTO 'devicecapvalue' VALUES (53752, 773, 49, 2607);
INSERT INTO 'capvalue' VALUES (2608, 'SEMC-VENUS Mozilla/4.0 (compatible; MSIE 6.0; Windows CE; IEMobile 7.11)');
INSERT INTO 'devicecapvalue' VALUES (53753, 773, 53, 2608);
INSERT INTO 'devicecapvalue' VALUES (53754, 774, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (53755, 774, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (53756, 774, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (53757, 774, 4, 651);
INSERT INTO 'devicecapvalue' VALUES (53758, 774, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (53759, 775, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (53760, 775, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (53761, 775, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (53762, 775, 4, 8);
INSERT INTO 'devicecapvalue' VALUES (53763, 775, 5, 7);
INSERT INTO 'devicecapvalue' VALUES (53764, 776, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (53765, 776, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53766, 776, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (53767, 776, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (53768, 776, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53769, 776, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (53770, 776, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (53771, 776, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (53772, 776, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53773, 776, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (53774, 776, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (53775, 776, 4, 601);
INSERT INTO 'devicecapvalue' VALUES (53776, 776, 5, 5);
INSERT INTO 'devicecapvalue' VALUES (53777, 777, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (53778, 777, 74, 1520);
INSERT INTO 'devicecapvalue' VALUES (53779, 777, 74, 2468);
INSERT INTO 'devicecapvalue' VALUES (53780, 777, 7, 1304);
INSERT INTO 'devicecapvalue' VALUES (53781, 777, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (53782, 777, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (53783, 777, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (53784, 777, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (53785, 777, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (53786, 777, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (53787, 777, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53788, 777, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53789, 777, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53790, 777, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (53791, 777, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (53792, 777, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (53793, 777, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (53794, 777, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (53795, 777, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (53796, 777, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (53797, 777, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (53798, 777, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (53799, 777, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (53800, 777, 52, 1731);
INSERT INTO 'devicecapvalue' VALUES (53801, 777, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (53802, 777, 157, 1026);
INSERT INTO 'capvalue' VALUES (2609, '3GSonyEricssonZ1010/R1H SEMC-Browser/4.0.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (53803, 777, 53, 2609);
INSERT INTO 'devicecapvalue' VALUES (53804, 778, 1, 625);
INSERT INTO 'devicecapvalue' VALUES (53805, 778, 173, 2477);
INSERT INTO 'devicecapvalue' VALUES (53806, 778, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (53807, 778, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (53808, 778, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (53809, 778, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (53810, 778, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (53811, 778, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (53812, 778, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (53813, 778, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (53814, 778, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (53815, 778, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (53816, 778, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (53817, 778, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (53818, 778, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (53819, 778, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (53820, 778, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (53821, 778, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (53822, 778, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53823, 778, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53824, 778, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (53825, 778, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (53826, 778, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53827, 778, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53828, 778, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (53829, 778, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (53830, 778, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (53831, 778, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (53832, 778, 51, 1036);
INSERT INTO 'capvalue' VALUES (2610, 'g-midi');
INSERT INTO 'devicecapvalue' VALUES (53833, 778, 51, 2610);
INSERT INTO 'devicecapvalue' VALUES (53834, 778, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (53835, 778, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (53836, 779, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (53837, 779, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (53838, 779, 160, 2416);
INSERT INTO 'devicecapvalue' VALUES (53839, 779, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (53840, 779, 7, 2056);
INSERT INTO 'devicecapvalue' VALUES (53841, 779, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (53842, 779, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (53843, 779, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (53844, 779, 75, 2413);
INSERT INTO 'devicecapvalue' VALUES (53845, 779, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (53846, 779, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (53847, 779, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (53848, 779, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (53849, 779, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (53850, 779, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (53851, 779, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (53852, 779, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (53853, 779, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (53854, 779, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (53855, 779, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (53856, 779, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (53857, 779, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (53858, 779, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (53859, 779, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (53860, 779, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (53861, 779, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (53862, 779, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53863, 779, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (53864, 779, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53865, 779, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (53866, 779, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53867, 779, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (53868, 779, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (53869, 779, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (53870, 779, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (53871, 779, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (53872, 779, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (53873, 779, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (53874, 779, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (53875, 779, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (53876, 779, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (53877, 779, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (53878, 779, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (53879, 779, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (53880, 779, 156, 2402);
INSERT INTO 'devicecapvalue' VALUES (53881, 779, 156, 2403);
INSERT INTO 'devicecapvalue' VALUES (53882, 779, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (53883, 779, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (53884, 779, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (53885, 779, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (53886, 779, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (53887, 779, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (53888, 779, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (53889, 779, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (53890, 779, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (53891, 779, 52, 2414);
INSERT INTO 'devicecapvalue' VALUES (53892, 779, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (53893, 779, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (53894, 779, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (53895, 779, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (53896, 779, 191, 1372);
INSERT INTO 'capvalue' VALUES (2611, 'SonyEricssonZ300a/R3G/TelecaBrowser/4.08');
INSERT INTO 'devicecapvalue' VALUES (53897, 779, 53, 2611);
INSERT INTO 'devicecapvalue' VALUES (53898, 780, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (53899, 780, 74, 1029);
INSERT INTO 'devicecapvalue' VALUES (53900, 780, 160, 2416);
INSERT INTO 'devicecapvalue' VALUES (53901, 780, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (53902, 780, 7, 2056);
INSERT INTO 'devicecapvalue' VALUES (53903, 780, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (53904, 780, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (53905, 780, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (53906, 780, 75, 2413);
INSERT INTO 'devicecapvalue' VALUES (53907, 780, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (53908, 780, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (53909, 780, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (53910, 780, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (53911, 780, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (53912, 780, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (53913, 780, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (53914, 780, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (53915, 780, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (53916, 780, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (53917, 780, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (53918, 780, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (53919, 780, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (53920, 780, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (53921, 780, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (53922, 780, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (53923, 780, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (53924, 780, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53925, 780, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (53926, 780, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53927, 780, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (53928, 780, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53929, 780, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (53930, 780, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (53931, 780, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (53932, 780, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (53933, 780, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (53934, 780, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (53935, 780, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (53936, 780, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (53937, 780, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (53938, 780, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (53939, 780, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (53940, 780, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (53941, 780, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (53942, 780, 156, 2402);
INSERT INTO 'devicecapvalue' VALUES (53943, 780, 156, 2403);
INSERT INTO 'devicecapvalue' VALUES (53944, 780, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (53945, 780, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (53946, 780, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (53947, 780, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (53948, 780, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (53949, 780, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (53950, 780, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (53951, 780, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (53952, 780, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (53953, 780, 52, 2414);
INSERT INTO 'devicecapvalue' VALUES (53954, 780, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (53955, 780, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (53956, 780, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (53957, 780, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (53958, 780, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (53959, 780, 53, 2611);
INSERT INTO 'devicecapvalue' VALUES (53960, 781, 1, 625);
INSERT INTO 'devicecapvalue' VALUES (53961, 781, 173, 2477);
INSERT INTO 'devicecapvalue' VALUES (53962, 781, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (53963, 781, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (53964, 781, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (53965, 781, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (53966, 781, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (53967, 781, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (53968, 781, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (53969, 781, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (53970, 781, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (53971, 781, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (53972, 781, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (53973, 781, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (53974, 781, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (53975, 781, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (53976, 781, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (53977, 781, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (53978, 781, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (53979, 781, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (53980, 781, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53981, 781, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (53982, 781, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (53983, 781, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (53984, 781, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (53985, 781, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (53986, 781, 51, 2610);
INSERT INTO 'devicecapvalue' VALUES (53987, 781, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (53988, 781, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (53989, 781, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (53990, 781, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (53991, 781, 52, 1738);
INSERT INTO 'devicecapvalue' VALUES (53992, 782, 1, 625);
INSERT INTO 'devicecapvalue' VALUES (53993, 782, 173, 2477);
INSERT INTO 'devicecapvalue' VALUES (53994, 782, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (53995, 782, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (53996, 782, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (53997, 782, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (53998, 782, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (53999, 782, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (54000, 782, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (54001, 782, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (54002, 782, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54003, 782, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54004, 782, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54005, 782, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54006, 782, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54007, 782, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (54008, 782, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54009, 782, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54010, 782, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54011, 782, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54012, 782, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (54013, 782, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54014, 782, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54015, 782, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54016, 782, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (54017, 782, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (54018, 782, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (54019, 782, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54020, 782, 51, 2610);
INSERT INTO 'devicecapvalue' VALUES (54021, 782, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54022, 782, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (54023, 783, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (54024, 783, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (54025, 783, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (54026, 783, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (54027, 783, 173, 1523);
INSERT INTO 'capvalue' VALUES (2612, 'SonyEricsson_Z500');
INSERT INTO 'devicecapvalue' VALUES (54028, 783, 75, 2612);
INSERT INTO 'devicecapvalue' VALUES (54029, 783, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54030, 783, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54031, 783, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (54032, 783, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (54033, 783, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (54034, 783, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54035, 783, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (54036, 783, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54037, 783, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54038, 783, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54039, 783, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54040, 783, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (54041, 783, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54042, 783, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54043, 783, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54044, 783, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54045, 783, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54046, 783, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54047, 783, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (54048, 783, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (54049, 783, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (54050, 783, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54051, 783, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (54052, 783, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (54053, 783, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (54054, 783, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54055, 783, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (54056, 783, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54057, 783, 51, 1084);
INSERT INTO 'devicecapvalue' VALUES (54058, 783, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (54059, 783, 52, 1503);
INSERT INTO 'devicecapvalue' VALUES (54060, 783, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (54061, 783, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (54062, 783, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (54063, 783, 191, 1372);
INSERT INTO 'capvalue' VALUES (2613, 'SonyEricssonZ500a/R1A SEMC-Browser/4.0.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (54064, 783, 53, 2613);
INSERT INTO 'devicecapvalue' VALUES (54065, 784, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (54066, 784, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (54067, 784, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (54068, 784, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (54069, 784, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (54070, 784, 75, 2612);
INSERT INTO 'devicecapvalue' VALUES (54071, 784, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54072, 784, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54073, 784, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (54074, 784, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (54075, 784, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (54076, 784, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54077, 784, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (54078, 784, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54079, 784, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54080, 784, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54081, 784, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54082, 784, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (54083, 784, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54084, 784, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54085, 784, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54086, 784, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54087, 784, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54088, 784, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54089, 784, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (54090, 784, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (54091, 784, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (54092, 784, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54093, 784, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (54094, 784, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (54095, 784, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (54096, 784, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54097, 784, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (54098, 784, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54099, 784, 51, 1084);
INSERT INTO 'devicecapvalue' VALUES (54100, 784, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (54101, 784, 52, 1503);
INSERT INTO 'devicecapvalue' VALUES (54102, 784, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (54103, 784, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (54104, 784, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (54105, 784, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (54106, 784, 53, 2613);
INSERT INTO 'devicecapvalue' VALUES (54107, 785, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (54108, 785, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (54109, 785, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (54110, 785, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (54111, 785, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (54112, 785, 75, 2612);
INSERT INTO 'devicecapvalue' VALUES (54113, 785, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54114, 785, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54115, 785, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (54116, 785, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (54117, 785, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (54118, 785, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54119, 785, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (54120, 785, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54121, 785, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54122, 785, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54123, 785, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54124, 785, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (54125, 785, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54126, 785, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54127, 785, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54128, 785, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54129, 785, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54130, 785, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54131, 785, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (54132, 785, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (54133, 785, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (54134, 785, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54135, 785, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (54136, 785, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (54137, 785, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (54138, 785, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54139, 785, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (54140, 785, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54141, 785, 51, 1084);
INSERT INTO 'devicecapvalue' VALUES (54142, 785, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (54143, 785, 52, 1503);
INSERT INTO 'devicecapvalue' VALUES (54144, 785, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (54145, 785, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (54146, 785, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (54147, 785, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (54148, 785, 53, 2613);
INSERT INTO 'devicecapvalue' VALUES (54149, 786, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (54150, 786, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (54151, 786, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (54152, 786, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (54153, 786, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (54154, 786, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (54155, 786, 173, 1688);
INSERT INTO 'capvalue' VALUES (2614, 'SonyEricsson_Z520');
INSERT INTO 'devicecapvalue' VALUES (54156, 786, 75, 2614);
INSERT INTO 'devicecapvalue' VALUES (54157, 786, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (54158, 786, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54159, 786, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54160, 786, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (54161, 786, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (54162, 786, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (54163, 786, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (54164, 786, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (54165, 786, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54166, 786, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54167, 786, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54168, 786, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54169, 786, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54170, 786, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54171, 786, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (54172, 786, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54173, 786, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54174, 786, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (54175, 786, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54176, 786, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54177, 786, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (54178, 786, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54179, 786, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (54180, 786, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (54181, 786, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (54182, 786, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (54183, 786, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (54184, 786, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (54185, 786, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (54186, 786, 88, 1004);
INSERT INTO 'capvalue' VALUES (2615, 'APAC');
INSERT INTO 'devicecapvalue' VALUES (54187, 786, 156, 2615);
INSERT INTO 'devicecapvalue' VALUES (54188, 786, 156, 1022);
INSERT INTO 'devicecapvalue' VALUES (54189, 786, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (54190, 786, 156, 1159);
INSERT INTO 'capvalue' VALUES (2616, 'HK');
INSERT INTO 'devicecapvalue' VALUES (54191, 786, 156, 2616);
INSERT INTO 'devicecapvalue' VALUES (54192, 786, 156, 2402);
INSERT INTO 'devicecapvalue' VALUES (54193, 786, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (54194, 786, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (54195, 786, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54196, 786, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (54197, 786, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (54198, 786, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54199, 786, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (54200, 786, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54201, 786, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (54202, 786, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (54203, 786, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (54204, 786, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (54205, 786, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (54206, 786, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (54207, 786, 191, 1372);
INSERT INTO 'capvalue' VALUES (2617, 'SonyEricssonZ520i/R3C Browser/SEMC-Browser/4.2 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (54208, 786, 53, 2617);
INSERT INTO 'devicecapvalue' VALUES (54209, 787, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (54210, 787, 160, 856);
INSERT INTO 'capvalue' VALUES (2618, '2x');
INSERT INTO 'devicecapvalue' VALUES (54211, 787, 162, 2618);
INSERT INTO 'devicecapvalue' VALUES (54212, 787, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54213, 787, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (54214, 787, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (54215, 787, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54216, 787, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54217, 787, 15, 2054);
INSERT INTO 'devicecapvalue' VALUES (54218, 787, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54219, 787, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54220, 787, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54221, 787, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (54222, 787, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54223, 787, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54224, 787, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (54225, 787, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54226, 787, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (54227, 787, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54228, 787, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54229, 787, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54230, 787, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (54231, 787, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (54232, 787, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (54233, 787, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54234, 787, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (54235, 787, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (54236, 787, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54237, 787, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (54238, 787, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54239, 787, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (54240, 787, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (54241, 787, 157, 975);
INSERT INTO 'devicecapvalue' VALUES (54242, 787, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (54243, 787, 157, 1026);
INSERT INTO 'capvalue' VALUES (2619, 'SonyEricssonZ525');
INSERT INTO 'devicecapvalue' VALUES (54244, 787, 53, 2619);
INSERT INTO 'devicecapvalue' VALUES (54245, 788, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (54246, 788, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (54247, 788, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (54248, 788, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54249, 788, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (54250, 788, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (54251, 788, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54252, 788, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54253, 788, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54254, 788, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54255, 788, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54256, 788, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54257, 788, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54258, 788, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54259, 788, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (54260, 788, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54261, 788, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (54262, 788, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54263, 788, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54264, 788, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (54265, 788, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54266, 788, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54267, 788, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (54268, 788, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54269, 788, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (54270, 788, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (54271, 788, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (54272, 788, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54273, 788, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (54274, 788, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (54275, 788, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54276, 788, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (54277, 788, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54278, 788, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (54279, 788, 51, 669);
INSERT INTO 'capvalue' VALUES (2620, '29360128');
INSERT INTO 'devicecapvalue' VALUES (54280, 788, 52, 2620);
INSERT INTO 'devicecapvalue' VALUES (54281, 788, 157, 975);
INSERT INTO 'devicecapvalue' VALUES (54282, 788, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (54283, 788, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (54284, 789, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (54285, 789, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (54286, 789, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (54287, 789, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (54288, 789, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (54289, 789, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (54290, 789, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (54291, 789, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (54292, 789, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (54293, 789, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (54294, 789, 75, 2553);
INSERT INTO 'devicecapvalue' VALUES (54295, 789, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (54296, 789, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54297, 789, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54298, 789, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (54299, 789, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (54300, 789, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (54301, 789, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (54302, 789, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (54303, 789, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (54304, 789, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54305, 789, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54306, 789, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54307, 789, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54308, 789, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54309, 789, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54310, 789, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (54311, 789, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54312, 789, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54313, 789, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (54314, 789, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54315, 789, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (54316, 789, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54317, 789, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54318, 789, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (54319, 789, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54320, 789, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (54321, 789, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54322, 789, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (54323, 789, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (54324, 789, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (54325, 789, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (54326, 789, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (54327, 789, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (54328, 789, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (54329, 789, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (54330, 789, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (54331, 789, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (54332, 789, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (54333, 789, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (54334, 789, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (54335, 789, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (54336, 789, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (54337, 789, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54338, 789, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (54339, 789, 51, 2554);
INSERT INTO 'devicecapvalue' VALUES (54340, 789, 51, 2555);
INSERT INTO 'devicecapvalue' VALUES (54341, 789, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (54342, 789, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54343, 789, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (54344, 789, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54345, 789, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (54346, 789, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (54347, 789, 51, 2425);
INSERT INTO 'devicecapvalue' VALUES (54348, 789, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (54349, 789, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (54350, 789, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (54351, 789, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (54352, 789, 157, 2556);
INSERT INTO 'devicecapvalue' VALUES (54353, 789, 191, 1372);
INSERT INTO 'capvalue' VALUES (2621, 'SonyEricssonZ550i');
INSERT INTO 'devicecapvalue' VALUES (54354, 789, 53, 2621);
INSERT INTO 'devicecapvalue' VALUES (54355, 790, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (54356, 790, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (54357, 790, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (54358, 790, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (54359, 790, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (54360, 790, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (54361, 790, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (54362, 790, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (54363, 790, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (54364, 790, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (54365, 790, 75, 2553);
INSERT INTO 'devicecapvalue' VALUES (54366, 790, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (54367, 790, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54368, 790, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54369, 790, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (54370, 790, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (54371, 790, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (54372, 790, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (54373, 790, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (54374, 790, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (54375, 790, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54376, 790, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54377, 790, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54378, 790, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54379, 790, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54380, 790, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54381, 790, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (54382, 790, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54383, 790, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54384, 790, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (54385, 790, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54386, 790, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (54387, 790, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54388, 790, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54389, 790, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (54390, 790, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54391, 790, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (54392, 790, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54393, 790, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (54394, 790, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (54395, 790, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (54396, 790, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (54397, 790, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (54398, 790, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (54399, 790, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (54400, 790, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (54401, 790, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (54402, 790, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (54403, 790, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (54404, 790, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (54405, 790, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (54406, 790, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (54407, 790, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (54408, 790, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54409, 790, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (54410, 790, 51, 2554);
INSERT INTO 'devicecapvalue' VALUES (54411, 790, 51, 2555);
INSERT INTO 'devicecapvalue' VALUES (54412, 790, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (54413, 790, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54414, 790, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (54415, 790, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54416, 790, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (54417, 790, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (54418, 790, 51, 2425);
INSERT INTO 'devicecapvalue' VALUES (54419, 790, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (54420, 790, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (54421, 790, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (54422, 790, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (54423, 790, 157, 2556);
INSERT INTO 'devicecapvalue' VALUES (54424, 790, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (54425, 790, 53, 2621);
INSERT INTO 'devicecapvalue' VALUES (54426, 791, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (54427, 791, 173, 2477);
INSERT INTO 'devicecapvalue' VALUES (54428, 791, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (54429, 791, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54430, 791, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54431, 791, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (54432, 791, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (54433, 791, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (54434, 791, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (54435, 791, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (54436, 791, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54437, 791, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54438, 791, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54439, 791, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54440, 791, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54441, 791, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (54442, 791, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (54443, 791, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54444, 791, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54445, 791, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54446, 791, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (54447, 791, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54448, 791, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54449, 791, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54450, 791, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (54451, 791, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (54452, 791, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (54453, 791, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (54454, 791, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54455, 791, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54456, 791, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (54457, 791, 52, 1460);
INSERT INTO 'devicecapvalue' VALUES (54458, 792, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (54459, 792, 173, 2477);
INSERT INTO 'devicecapvalue' VALUES (54460, 792, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (54461, 792, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54462, 792, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54463, 792, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (54464, 792, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (54465, 792, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (54466, 792, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (54467, 792, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (54468, 792, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54469, 792, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54470, 792, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54471, 792, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54472, 792, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54473, 792, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54474, 792, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (54475, 792, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (54476, 792, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54477, 792, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54478, 792, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54479, 792, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54480, 792, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54481, 792, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (54482, 792, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54483, 792, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54484, 792, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54485, 792, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (54486, 792, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (54487, 792, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (54488, 792, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (54489, 792, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (54490, 792, 51, 2610);
INSERT INTO 'devicecapvalue' VALUES (54491, 792, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (54492, 792, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54493, 792, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (54494, 792, 51, 669);
INSERT INTO 'capvalue' VALUES (2622, '18874368');
INSERT INTO 'devicecapvalue' VALUES (54495, 792, 52, 2622);
INSERT INTO 'devicecapvalue' VALUES (54496, 793, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (54497, 793, 173, 2477);
INSERT INTO 'devicecapvalue' VALUES (54498, 793, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (54499, 793, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54500, 793, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54501, 793, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (54502, 793, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (54503, 793, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (54504, 793, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (54505, 793, 76, 593);
INSERT INTO 'devicecapvalue' VALUES (54506, 793, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54507, 793, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54508, 793, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54509, 793, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54510, 793, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54511, 793, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54512, 793, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (54513, 793, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (54514, 793, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54515, 793, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54516, 793, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (54517, 793, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54518, 793, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54519, 793, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54520, 793, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (54521, 793, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54522, 793, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54523, 793, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54524, 793, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (54525, 793, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (54526, 793, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (54527, 793, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (54528, 793, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54529, 793, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (54530, 793, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (54531, 793, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (54532, 793, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54533, 793, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (54534, 793, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54535, 793, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (54536, 793, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (54537, 793, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (54538, 793, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (54539, 793, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (54540, 793, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (54541, 793, 52, 1005);
INSERT INTO 'devicecapvalue' VALUES (54542, 793, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (54543, 793, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (54544, 793, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (54545, 793, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (54546, 793, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (54547, 793, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (54548, 794, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (54549, 794, 74, 1519);
INSERT INTO 'devicecapvalue' VALUES (54550, 794, 74, 2459);
INSERT INTO 'devicecapvalue' VALUES (54551, 794, 74, 654);
INSERT INTO 'devicecapvalue' VALUES (54552, 794, 160, 1154);
INSERT INTO 'devicecapvalue' VALUES (54553, 794, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (54554, 794, 7, 2057);
INSERT INTO 'devicecapvalue' VALUES (54555, 794, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (54556, 794, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (54557, 794, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (54558, 794, 75, 2553);
INSERT INTO 'devicecapvalue' VALUES (54559, 794, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (54560, 794, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54561, 794, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54562, 794, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (54563, 794, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (54564, 794, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (54565, 794, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (54566, 794, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (54567, 794, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (54568, 794, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54569, 794, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54570, 794, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54571, 794, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54572, 794, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54573, 794, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54574, 794, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (54575, 794, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54576, 794, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54577, 794, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (54578, 794, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54579, 794, 17, 2328);
INSERT INTO 'devicecapvalue' VALUES (54580, 794, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54581, 794, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54582, 794, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (54583, 794, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54584, 794, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54585, 794, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (54586, 794, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (54587, 794, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (54588, 794, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (54589, 794, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (54590, 794, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (54591, 794, 28, 1245);
INSERT INTO 'devicecapvalue' VALUES (54592, 794, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (54593, 794, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (54594, 794, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (54595, 794, 156, 1416);
INSERT INTO 'devicecapvalue' VALUES (54596, 794, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (54597, 794, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (54598, 794, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (54599, 794, 51, 975);
INSERT INTO 'devicecapvalue' VALUES (54600, 794, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54601, 794, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (54602, 794, 51, 2554);
INSERT INTO 'devicecapvalue' VALUES (54603, 794, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (54604, 794, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54605, 794, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (54606, 794, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54607, 794, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (54608, 794, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (54609, 794, 51, 2425);
INSERT INTO 'devicecapvalue' VALUES (54610, 794, 51, 1160);
INSERT INTO 'devicecapvalue' VALUES (54611, 794, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (54612, 794, 157, 975);
INSERT INTO 'devicecapvalue' VALUES (54613, 794, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (54614, 794, 191, 1372);
INSERT INTO 'capvalue' VALUES (2623, 'SonyEricssonZ710c');
INSERT INTO 'devicecapvalue' VALUES (54615, 794, 53, 2623);
INSERT INTO 'devicecapvalue' VALUES (54616, 795, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (54617, 795, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (54618, 795, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (54619, 795, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54620, 795, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54621, 795, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (54622, 795, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (54623, 795, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (54624, 795, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (54625, 795, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (54626, 795, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (54627, 795, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (54628, 795, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54629, 795, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54630, 795, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54631, 795, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54632, 795, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54633, 795, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54634, 795, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (54635, 795, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (54636, 795, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54637, 795, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54638, 795, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (54639, 795, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (54640, 795, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (54641, 795, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (54642, 795, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54643, 795, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54644, 795, 17, 2439);
INSERT INTO 'devicecapvalue' VALUES (54645, 795, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (54646, 795, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54647, 795, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (54648, 795, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (54649, 795, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (54650, 795, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (54651, 795, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54652, 795, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54653, 795, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (54654, 795, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (54655, 795, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (54656, 795, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (54657, 795, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (54658, 795, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54659, 795, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (54660, 795, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (54661, 795, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (54662, 795, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (54663, 795, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54664, 795, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (54665, 795, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54666, 795, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (54667, 795, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (54668, 795, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (54669, 795, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (54670, 795, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (54671, 795, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (54672, 795, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (54673, 795, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (54674, 795, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (54675, 795, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (54676, 795, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (54677, 795, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (54678, 795, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (54679, 795, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (54680, 796, 7, 2375);
INSERT INTO 'devicecapvalue' VALUES (54681, 796, 8, 10);
INSERT INTO 'devicecapvalue' VALUES (54682, 796, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (54683, 796, 9, 12);
INSERT INTO 'devicecapvalue' VALUES (54684, 796, 10, 963);
INSERT INTO 'devicecapvalue' VALUES (54685, 796, 11, 12);
INSERT INTO 'devicecapvalue' VALUES (54686, 796, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (54687, 796, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (54688, 796, 14, 15);
INSERT INTO 'devicecapvalue' VALUES (54689, 796, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54690, 796, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54691, 796, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54692, 796, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54693, 796, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54694, 796, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54695, 796, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (54696, 796, 17, 21);
INSERT INTO 'devicecapvalue' VALUES (54697, 796, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (54698, 796, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54699, 796, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54700, 796, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (54701, 796, 17, 24);
INSERT INTO 'devicecapvalue' VALUES (54702, 796, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (54703, 796, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (54704, 796, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (54705, 796, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54706, 796, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54707, 796, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (54708, 796, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (54709, 796, 18, 28);
INSERT INTO 'devicecapvalue' VALUES (54710, 796, 19, 29);
INSERT INTO 'devicecapvalue' VALUES (54711, 796, 20, 30);
INSERT INTO 'devicecapvalue' VALUES (54712, 796, 21, 33);
INSERT INTO 'devicecapvalue' VALUES (54713, 796, 22, 34);
INSERT INTO 'devicecapvalue' VALUES (54714, 796, 23, 745);
INSERT INTO 'devicecapvalue' VALUES (54715, 796, 24, 237);
INSERT INTO 'devicecapvalue' VALUES (54716, 796, 25, 35);
INSERT INTO 'devicecapvalue' VALUES (54717, 796, 29, 39);
INSERT INTO 'devicecapvalue' VALUES (54718, 796, 31, 41);
INSERT INTO 'devicecapvalue' VALUES (54719, 796, 32, 983);
INSERT INTO 'devicecapvalue' VALUES (54720, 796, 33, 43);
INSERT INTO 'devicecapvalue' VALUES (54721, 796, 34, 241);
INSERT INTO 'devicecapvalue' VALUES (54722, 796, 35, 45);
INSERT INTO 'capvalue' VALUES (2624, 'SonyEricssonZ750i/R1FA030');
INSERT INTO 'devicecapvalue' VALUES (54723, 796, 36, 2624);
INSERT INTO 'devicecapvalue' VALUES (54724, 796, 37, 924);
INSERT INTO 'devicecapvalue' VALUES (54725, 796, 38, 2315);
INSERT INTO 'devicecapvalue' VALUES (54726, 796, 39, 49);
INSERT INTO 'devicecapvalue' VALUES (54727, 796, 39, 52);
INSERT INTO 'devicecapvalue' VALUES (54728, 796, 39, 1468);
INSERT INTO 'devicecapvalue' VALUES (54729, 796, 39, 53);
INSERT INTO 'devicecapvalue' VALUES (54730, 796, 39, 67);
INSERT INTO 'devicecapvalue' VALUES (54731, 796, 39, 888);
INSERT INTO 'devicecapvalue' VALUES (54732, 796, 40, 124);
INSERT INTO 'devicecapvalue' VALUES (54733, 796, 40, 54);
INSERT INTO 'devicecapvalue' VALUES (54734, 796, 40, 64);
INSERT INTO 'devicecapvalue' VALUES (54735, 796, 40, 2316);
INSERT INTO 'devicecapvalue' VALUES (54736, 796, 40, 132);
INSERT INTO 'devicecapvalue' VALUES (54737, 796, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (54738, 796, 41, 883);
INSERT INTO 'devicecapvalue' VALUES (54739, 796, 41, 57);
INSERT INTO 'devicecapvalue' VALUES (54740, 796, 41, 58);
INSERT INTO 'devicecapvalue' VALUES (54741, 796, 41, 49);
INSERT INTO 'devicecapvalue' VALUES (54742, 796, 41, 50);
INSERT INTO 'devicecapvalue' VALUES (54743, 796, 41, 59);
INSERT INTO 'devicecapvalue' VALUES (54744, 796, 41, 60);
INSERT INTO 'devicecapvalue' VALUES (54745, 796, 41, 124);
INSERT INTO 'devicecapvalue' VALUES (54746, 796, 41, 54);
INSERT INTO 'devicecapvalue' VALUES (54747, 796, 41, 126);
INSERT INTO 'devicecapvalue' VALUES (54748, 796, 41, 62);
INSERT INTO 'devicecapvalue' VALUES (54749, 796, 41, 2075);
INSERT INTO 'devicecapvalue' VALUES (54750, 796, 41, 63);
INSERT INTO 'devicecapvalue' VALUES (54751, 796, 41, 886);
INSERT INTO 'devicecapvalue' VALUES (54752, 796, 41, 1252);
INSERT INTO 'devicecapvalue' VALUES (54753, 796, 41, 1441);
INSERT INTO 'devicecapvalue' VALUES (54754, 796, 41, 2317);
INSERT INTO 'devicecapvalue' VALUES (54755, 796, 41, 2318);
INSERT INTO 'devicecapvalue' VALUES (54756, 796, 41, 64);
INSERT INTO 'devicecapvalue' VALUES (54757, 796, 41, 2316);
INSERT INTO 'devicecapvalue' VALUES (54758, 796, 41, 867);
INSERT INTO 'devicecapvalue' VALUES (54759, 796, 41, 129);
INSERT INTO 'devicecapvalue' VALUES (54760, 796, 41, 132);
INSERT INTO 'devicecapvalue' VALUES (54761, 796, 41, 870);
INSERT INTO 'devicecapvalue' VALUES (54762, 796, 41, 1255);
INSERT INTO 'devicecapvalue' VALUES (54763, 796, 41, 1256);
INSERT INTO 'devicecapvalue' VALUES (54764, 796, 41, 618);
INSERT INTO 'devicecapvalue' VALUES (54765, 796, 41, 1280);
INSERT INTO 'devicecapvalue' VALUES (54766, 796, 41, 55);
INSERT INTO 'devicecapvalue' VALUES (54767, 796, 41, 51);
INSERT INTO 'devicecapvalue' VALUES (54768, 796, 41, 135);
INSERT INTO 'devicecapvalue' VALUES (54769, 796, 41, 66);
INSERT INTO 'devicecapvalue' VALUES (54770, 796, 41, 53);
INSERT INTO 'devicecapvalue' VALUES (54771, 796, 41, 2080);
INSERT INTO 'devicecapvalue' VALUES (54772, 796, 41, 67);
INSERT INTO 'devicecapvalue' VALUES (54773, 796, 41, 2319);
INSERT INTO 'devicecapvalue' VALUES (54774, 796, 41, 1444);
INSERT INTO 'devicecapvalue' VALUES (54775, 796, 41, 888);
INSERT INTO 'devicecapvalue' VALUES (54776, 796, 41, 622);
INSERT INTO 'devicecapvalue' VALUES (54777, 796, 41, 1283);
INSERT INTO 'devicecapvalue' VALUES (54778, 796, 42, 883);
INSERT INTO 'devicecapvalue' VALUES (54779, 796, 42, 57);
INSERT INTO 'devicecapvalue' VALUES (54780, 796, 42, 58);
INSERT INTO 'devicecapvalue' VALUES (54781, 796, 42, 49);
INSERT INTO 'devicecapvalue' VALUES (54782, 796, 42, 50);
INSERT INTO 'devicecapvalue' VALUES (54783, 796, 42, 59);
INSERT INTO 'devicecapvalue' VALUES (54784, 796, 42, 60);
INSERT INTO 'devicecapvalue' VALUES (54785, 796, 42, 124);
INSERT INTO 'devicecapvalue' VALUES (54786, 796, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (54787, 796, 42, 126);
INSERT INTO 'devicecapvalue' VALUES (54788, 796, 42, 62);
INSERT INTO 'devicecapvalue' VALUES (54789, 796, 42, 2075);
INSERT INTO 'devicecapvalue' VALUES (54790, 796, 42, 63);
INSERT INTO 'devicecapvalue' VALUES (54791, 796, 42, 886);
INSERT INTO 'devicecapvalue' VALUES (54792, 796, 42, 1252);
INSERT INTO 'devicecapvalue' VALUES (54793, 796, 42, 1441);
INSERT INTO 'devicecapvalue' VALUES (54794, 796, 42, 2317);
INSERT INTO 'devicecapvalue' VALUES (54795, 796, 42, 2318);
INSERT INTO 'devicecapvalue' VALUES (54796, 796, 42, 64);
INSERT INTO 'devicecapvalue' VALUES (54797, 796, 42, 2316);
INSERT INTO 'devicecapvalue' VALUES (54798, 796, 42, 867);
INSERT INTO 'devicecapvalue' VALUES (54799, 796, 42, 129);
INSERT INTO 'devicecapvalue' VALUES (54800, 796, 42, 132);
INSERT INTO 'devicecapvalue' VALUES (54801, 796, 42, 870);
INSERT INTO 'devicecapvalue' VALUES (54802, 796, 42, 1255);
INSERT INTO 'devicecapvalue' VALUES (54803, 796, 42, 1256);
INSERT INTO 'devicecapvalue' VALUES (54804, 796, 42, 618);
INSERT INTO 'devicecapvalue' VALUES (54805, 796, 42, 1280);
INSERT INTO 'devicecapvalue' VALUES (54806, 796, 42, 55);
INSERT INTO 'devicecapvalue' VALUES (54807, 796, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (54808, 796, 42, 135);
INSERT INTO 'devicecapvalue' VALUES (54809, 796, 42, 66);
INSERT INTO 'devicecapvalue' VALUES (54810, 796, 42, 53);
INSERT INTO 'devicecapvalue' VALUES (54811, 796, 42, 2080);
INSERT INTO 'devicecapvalue' VALUES (54812, 796, 42, 67);
INSERT INTO 'devicecapvalue' VALUES (54813, 796, 42, 2319);
INSERT INTO 'devicecapvalue' VALUES (54814, 796, 42, 1444);
INSERT INTO 'devicecapvalue' VALUES (54815, 796, 42, 888);
INSERT INTO 'devicecapvalue' VALUES (54816, 796, 42, 622);
INSERT INTO 'devicecapvalue' VALUES (54817, 796, 42, 1283);
INSERT INTO 'devicecapvalue' VALUES (54818, 796, 43, 15);
INSERT INTO 'devicecapvalue' VALUES (54819, 796, 44, 15);
INSERT INTO 'devicecapvalue' VALUES (54820, 796, 45, 2376);
INSERT INTO 'devicecapvalue' VALUES (54821, 796, 100, 15);
INSERT INTO 'devicecapvalue' VALUES (54822, 796, 46, 69);
INSERT INTO 'devicecapvalue' VALUES (54823, 796, 46, 1445);
INSERT INTO 'devicecapvalue' VALUES (54824, 796, 46, 933);
INSERT INTO 'devicecapvalue' VALUES (54825, 796, 46, 892);
INSERT INTO 'devicecapvalue' VALUES (54826, 796, 46, 893);
INSERT INTO 'devicecapvalue' VALUES (54827, 796, 46, 894);
INSERT INTO 'devicecapvalue' VALUES (54828, 796, 46, 895);
INSERT INTO 'devicecapvalue' VALUES (54829, 796, 46, 896);
INSERT INTO 'devicecapvalue' VALUES (54830, 796, 46, 897);
INSERT INTO 'devicecapvalue' VALUES (54831, 796, 46, 898);
INSERT INTO 'devicecapvalue' VALUES (54832, 796, 46, 899);
INSERT INTO 'devicecapvalue' VALUES (54833, 796, 46, 900);
INSERT INTO 'devicecapvalue' VALUES (54834, 796, 46, 901);
INSERT INTO 'devicecapvalue' VALUES (54835, 796, 46, 934);
INSERT INTO 'devicecapvalue' VALUES (54836, 796, 46, 935);
INSERT INTO 'devicecapvalue' VALUES (54837, 796, 46, 70);
INSERT INTO 'devicecapvalue' VALUES (54838, 796, 46, 71);
INSERT INTO 'devicecapvalue' VALUES (54839, 796, 46, 713);
INSERT INTO 'devicecapvalue' VALUES (54840, 796, 46, 72);
INSERT INTO 'devicecapvalue' VALUES (54841, 796, 46, 714);
INSERT INTO 'devicecapvalue' VALUES (54842, 796, 46, 715);
INSERT INTO 'devicecapvalue' VALUES (54843, 796, 46, 716);
INSERT INTO 'devicecapvalue' VALUES (54844, 796, 46, 717);
INSERT INTO 'devicecapvalue' VALUES (54845, 796, 46, 718);
INSERT INTO 'devicecapvalue' VALUES (54846, 796, 46, 719);
INSERT INTO 'devicecapvalue' VALUES (54847, 796, 46, 936);
INSERT INTO 'devicecapvalue' VALUES (54848, 796, 46, 902);
INSERT INTO 'devicecapvalue' VALUES (54849, 796, 46, 73);
INSERT INTO 'devicecapvalue' VALUES (54850, 796, 46, 74);
INSERT INTO 'devicecapvalue' VALUES (54851, 796, 46, 75);
INSERT INTO 'devicecapvalue' VALUES (54852, 796, 46, 937);
INSERT INTO 'devicecapvalue' VALUES (54853, 796, 46, 76);
INSERT INTO 'devicecapvalue' VALUES (54854, 796, 46, 77);
INSERT INTO 'devicecapvalue' VALUES (54855, 796, 46, 78);
INSERT INTO 'devicecapvalue' VALUES (54856, 796, 46, 141);
INSERT INTO 'devicecapvalue' VALUES (54857, 796, 46, 903);
INSERT INTO 'devicecapvalue' VALUES (54858, 796, 46, 904);
INSERT INTO 'devicecapvalue' VALUES (54859, 796, 46, 905);
INSERT INTO 'devicecapvalue' VALUES (54860, 796, 46, 79);
INSERT INTO 'devicecapvalue' VALUES (54861, 796, 46, 80);
INSERT INTO 'devicecapvalue' VALUES (54862, 796, 46, 906);
INSERT INTO 'devicecapvalue' VALUES (54863, 796, 46, 2097);
INSERT INTO 'devicecapvalue' VALUES (54864, 796, 46, 81);
INSERT INTO 'devicecapvalue' VALUES (54865, 796, 46, 82);
INSERT INTO 'devicecapvalue' VALUES (54866, 796, 46, 83);
INSERT INTO 'devicecapvalue' VALUES (54867, 796, 46, 1407);
INSERT INTO 'devicecapvalue' VALUES (54868, 796, 46, 990);
INSERT INTO 'devicecapvalue' VALUES (54869, 796, 46, 1593);
INSERT INTO 'devicecapvalue' VALUES (54870, 796, 46, 939);
INSERT INTO 'devicecapvalue' VALUES (54871, 796, 46, 720);
INSERT INTO 'devicecapvalue' VALUES (54872, 796, 46, 907);
INSERT INTO 'devicecapvalue' VALUES (54873, 796, 46, 872);
INSERT INTO 'devicecapvalue' VALUES (54874, 796, 46, 84);
INSERT INTO 'devicecapvalue' VALUES (54875, 796, 46, 940);
INSERT INTO 'devicecapvalue' VALUES (54876, 796, 46, 85);
INSERT INTO 'devicecapvalue' VALUES (54877, 796, 46, 86);
INSERT INTO 'devicecapvalue' VALUES (54878, 796, 46, 87);
INSERT INTO 'devicecapvalue' VALUES (54879, 796, 46, 2128);
INSERT INTO 'devicecapvalue' VALUES (54880, 796, 46, 88);
INSERT INTO 'devicecapvalue' VALUES (54881, 796, 46, 89);
INSERT INTO 'devicecapvalue' VALUES (54882, 796, 46, 908);
INSERT INTO 'devicecapvalue' VALUES (54883, 796, 46, 142);
INSERT INTO 'devicecapvalue' VALUES (54884, 796, 46, 721);
INSERT INTO 'devicecapvalue' VALUES (54885, 796, 46, 909);
INSERT INTO 'devicecapvalue' VALUES (54886, 796, 46, 910);
INSERT INTO 'devicecapvalue' VALUES (54887, 796, 47, 883);
INSERT INTO 'devicecapvalue' VALUES (54888, 796, 47, 57);
INSERT INTO 'devicecapvalue' VALUES (54889, 796, 47, 58);
INSERT INTO 'devicecapvalue' VALUES (54890, 796, 47, 60);
INSERT INTO 'devicecapvalue' VALUES (54891, 796, 47, 62);
INSERT INTO 'devicecapvalue' VALUES (54892, 796, 47, 2075);
INSERT INTO 'devicecapvalue' VALUES (54893, 796, 47, 886);
INSERT INTO 'devicecapvalue' VALUES (54894, 796, 47, 129);
INSERT INTO 'devicecapvalue' VALUES (54895, 796, 47, 618);
INSERT INTO 'devicecapvalue' VALUES (54896, 796, 47, 1280);
INSERT INTO 'devicecapvalue' VALUES (54897, 796, 47, 2321);
INSERT INTO 'devicecapvalue' VALUES (54898, 796, 47, 53);
INSERT INTO 'devicecapvalue' VALUES (54899, 796, 47, 2080);
INSERT INTO 'devicecapvalue' VALUES (54900, 796, 47, 67);
INSERT INTO 'devicecapvalue' VALUES (54901, 796, 47, 2319);
INSERT INTO 'devicecapvalue' VALUES (54902, 796, 47, 1444);
INSERT INTO 'devicecapvalue' VALUES (54903, 796, 47, 888);
INSERT INTO 'devicecapvalue' VALUES (54904, 796, 47, 622);
INSERT INTO 'devicecapvalue' VALUES (54905, 796, 47, 1283);
INSERT INTO 'devicecapvalue' VALUES (54906, 796, 48, 90);
INSERT INTO 'devicecapvalue' VALUES (54907, 796, 48, 160);
INSERT INTO 'devicecapvalue' VALUES (54908, 796, 48, 92);
INSERT INTO 'devicecapvalue' VALUES (54909, 796, 49, 659);
INSERT INTO 'capvalue' VALUES (2625, 'SonyEricssonZ750i/R1FA Browser/NetFront/3.4 Profile/MIDP-2.1');
INSERT INTO 'devicecapvalue' VALUES (54910, 796, 53, 2625);
INSERT INTO 'devicecapvalue' VALUES (54911, 797, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (54912, 797, 173, 2427);
INSERT INTO 'devicecapvalue' VALUES (54913, 797, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (54914, 797, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54915, 797, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54916, 797, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (54917, 797, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (54918, 797, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (54919, 797, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (54920, 797, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (54921, 797, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (54922, 797, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (54923, 797, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54924, 797, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54925, 797, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54926, 797, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54927, 797, 15, 18);
INSERT INTO 'devicecapvalue' VALUES (54928, 797, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54929, 797, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (54930, 797, 15, 706);
INSERT INTO 'devicecapvalue' VALUES (54931, 797, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (54932, 797, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (54933, 797, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (54934, 797, 17, 576);
INSERT INTO 'devicecapvalue' VALUES (54935, 797, 17, 676);
INSERT INTO 'devicecapvalue' VALUES (54936, 797, 17, 113);
INSERT INTO 'devicecapvalue' VALUES (54937, 797, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (54938, 797, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (54939, 797, 17, 2439);
INSERT INTO 'devicecapvalue' VALUES (54940, 797, 17, 23);
INSERT INTO 'devicecapvalue' VALUES (54941, 797, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (54942, 797, 17, 673);
INSERT INTO 'devicecapvalue' VALUES (54943, 797, 17, 674);
INSERT INTO 'devicecapvalue' VALUES (54944, 797, 17, 706);
INSERT INTO 'devicecapvalue' VALUES (54945, 797, 17, 115);
INSERT INTO 'devicecapvalue' VALUES (54946, 797, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (54947, 797, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (54948, 797, 6, 660);
INSERT INTO 'devicecapvalue' VALUES (54949, 797, 50, 593);
INSERT INTO 'devicecapvalue' VALUES (54950, 797, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (54951, 797, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (54952, 797, 51, 1087);
INSERT INTO 'devicecapvalue' VALUES (54953, 797, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (54954, 797, 51, 1037);
INSERT INTO 'devicecapvalue' VALUES (54955, 797, 51, 1465);
INSERT INTO 'devicecapvalue' VALUES (54956, 797, 51, 1097);
INSERT INTO 'devicecapvalue' VALUES (54957, 797, 51, 1563);
INSERT INTO 'devicecapvalue' VALUES (54958, 797, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (54959, 797, 51, 1349);
INSERT INTO 'devicecapvalue' VALUES (54960, 797, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (54961, 797, 51, 569);
INSERT INTO 'devicecapvalue' VALUES (54962, 797, 51, 1098);
INSERT INTO 'devicecapvalue' VALUES (54963, 797, 51, 103);
INSERT INTO 'devicecapvalue' VALUES (54964, 797, 51, 1459);
INSERT INTO 'devicecapvalue' VALUES (54965, 797, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (54966, 797, 51, 1085);
INSERT INTO 'devicecapvalue' VALUES (54967, 797, 51, 1041);
INSERT INTO 'devicecapvalue' VALUES (54968, 797, 52, 1140);
INSERT INTO 'devicecapvalue' VALUES (54969, 797, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (54970, 797, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (54971, 797, 157, 1461);
INSERT INTO 'devicecapvalue' VALUES (54972, 797, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (54973, 797, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (54974, 797, 157, 2426);
INSERT INTO 'devicecapvalue' VALUES (54975, 798, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (54976, 798, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (54977, 798, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (54978, 798, 7, 1304);
INSERT INTO 'devicecapvalue' VALUES (54979, 798, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (54980, 798, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (54981, 798, 173, 1523);
INSERT INTO 'capvalue' VALUES (2626, 'SonyEricsson_Z800');
INSERT INTO 'devicecapvalue' VALUES (54982, 798, 75, 2626);
INSERT INTO 'devicecapvalue' VALUES (54983, 798, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (54984, 798, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (54985, 798, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (54986, 798, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (54987, 798, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (54988, 798, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (54989, 798, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (54990, 798, 13, 859);
INSERT INTO 'devicecapvalue' VALUES (54991, 798, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (54992, 798, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (54993, 798, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (54994, 798, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (54995, 798, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (54996, 798, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (54997, 798, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (54998, 798, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (54999, 798, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (55000, 798, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (55001, 798, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (55002, 798, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (55003, 798, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (55004, 798, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (55005, 798, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (55006, 798, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (55007, 798, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (55008, 798, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (55009, 798, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (55010, 798, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (55011, 798, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (55012, 798, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (55013, 798, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (55014, 798, 156, 2615);
INSERT INTO 'devicecapvalue' VALUES (55015, 798, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (55016, 798, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (55017, 798, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (55018, 798, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (55019, 798, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (55020, 798, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (55021, 798, 51, 2430);
INSERT INTO 'devicecapvalue' VALUES (55022, 798, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (55023, 798, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (55024, 798, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (55025, 798, 52, 2446);
INSERT INTO 'devicecapvalue' VALUES (55026, 798, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (55027, 798, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (55028, 798, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (55029, 798, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (55030, 798, 191, 1372);
INSERT INTO 'capvalue' VALUES (2627, 'SonyEricssonZ800i/R1AB Browser/SEMC-Browser/4.1 Profile/MIDP-2.0 Configuration/CLDC-1.1');
INSERT INTO 'devicecapvalue' VALUES (55031, 798, 53, 2627);
INSERT INTO 'devicecapvalue' VALUES (55032, 799, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (55033, 799, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (55034, 799, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (55035, 799, 13, 735);
INSERT INTO 'devicecapvalue' VALUES (55036, 799, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (55037, 799, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (55038, 799, 3, 736);
INSERT INTO 'capvalue' VALUES (2628, 'Mozilla/4.0 (compatible; MSIE 6.0; Windows CE; IEMobile 6.12) T-Mobile Dash');
INSERT INTO 'devicecapvalue' VALUES (55039, 799, 53, 2628);
INSERT INTO 'devicecapvalue' VALUES (55040, 800, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (55041, 800, 74, 853);
INSERT INTO 'devicecapvalue' VALUES (55042, 800, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (55043, 800, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (55044, 800, 2, 11);
INSERT INTO 'devicecapvalue' VALUES (55045, 800, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (55046, 800, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (55047, 800, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (55048, 800, 13, 234);
INSERT INTO 'devicecapvalue' VALUES (55049, 800, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (55050, 800, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (55051, 800, 26, 664);
INSERT INTO 'devicecapvalue' VALUES (55052, 800, 30, 667);
INSERT INTO 'devicecapvalue' VALUES (55053, 800, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (55054, 800, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (55055, 800, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (55056, 800, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (55057, 800, 113, 616);
INSERT INTO 'devicecapvalue' VALUES (55058, 800, 113, 54);
INSERT INTO 'devicecapvalue' VALUES (55059, 800, 113, 51);
INSERT INTO 'devicecapvalue' VALUES (55060, 800, 3, 850);
INSERT INTO 'devicecapvalue' VALUES (55061, 800, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (55062, 800, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (55063, 800, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (55064, 800, 53, 854);
INSERT INTO 'devicecapvalue' VALUES (55065, 801, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (55066, 801, 160, 1724);
INSERT INTO 'devicecapvalue' VALUES (55067, 801, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (55068, 801, 7, 1878);
INSERT INTO 'devicecapvalue' VALUES (55069, 801, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (55070, 801, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (55071, 801, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (55072, 801, 13, 742);
INSERT INTO 'devicecapvalue' VALUES (55073, 801, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (55074, 801, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (55075, 801, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (55076, 801, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (55077, 801, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (55078, 802, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (55079, 802, 160, 1724);
INSERT INTO 'devicecapvalue' VALUES (55080, 802, 162, 625);
INSERT INTO 'devicecapvalue' VALUES (55081, 802, 7, 1878);
INSERT INTO 'devicecapvalue' VALUES (55082, 802, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (55083, 802, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (55084, 802, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (55085, 802, 13, 742);
INSERT INTO 'devicecapvalue' VALUES (55086, 802, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (55087, 802, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (55088, 802, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (55089, 802, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (55090, 802, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (55091, 803, 1, 1);
INSERT INTO 'capvalue' VALUES (2629, 'needsAbsoluteUrlToJar');
INSERT INTO 'devicecapvalue' VALUES (55092, 803, 74, 2629);
INSERT INTO 'devicecapvalue' VALUES (55093, 803, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (55094, 803, 162, 42);
INSERT INTO 'devicecapvalue' VALUES (55095, 803, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (55096, 803, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (55097, 803, 16, 97);
INSERT INTO 'devicecapvalue' VALUES (55098, 803, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (55099, 803, 3, 736);
INSERT INTO 'devicecapvalue' VALUES (55100, 803, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (55101, 803, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (55102, 804, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (55103, 804, 7, 234);
INSERT INTO 'devicecapvalue' VALUES (55104, 804, 10, 604);
INSERT INTO 'devicecapvalue' VALUES (55105, 804, 11, 663);
INSERT INTO 'devicecapvalue' VALUES (55106, 804, 12, 1);
INSERT INTO 'devicecapvalue' VALUES (55107, 804, 13, 234);
INSERT INTO 'devicecapvalue' VALUES (55108, 804, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (55109, 804, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (55110, 804, 26, 664);
INSERT INTO 'devicecapvalue' VALUES (55111, 804, 30, 667);
INSERT INTO 'devicecapvalue' VALUES (55112, 804, 40, 55);
INSERT INTO 'devicecapvalue' VALUES (55113, 804, 42, 616);
INSERT INTO 'devicecapvalue' VALUES (55114, 804, 42, 54);
INSERT INTO 'devicecapvalue' VALUES (55115, 804, 42, 51);
INSERT INTO 'devicecapvalue' VALUES (55116, 804, 113, 616);
INSERT INTO 'devicecapvalue' VALUES (55117, 804, 113, 54);
INSERT INTO 'devicecapvalue' VALUES (55118, 804, 113, 51);
INSERT INTO 'devicecapvalue' VALUES (55119, 804, 3, 3);
INSERT INTO 'devicecapvalue' VALUES (55120, 804, 68, 749);
INSERT INTO 'devicecapvalue' VALUES (55121, 804, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (55122, 804, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (55123, 805, 13, 1548);
INSERT INTO 'devicecapvalue' VALUES (55124, 805, 77, 1542);
INSERT INTO 'devicecapvalue' VALUES (55125, 805, 78, 1542);
INSERT INTO 'devicecapvalue' VALUES (55126, 805, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (55127, 805, 17, 112);
INSERT INTO 'devicecapvalue' VALUES (55128, 805, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (55129, 805, 17, 684);
INSERT INTO 'devicecapvalue' VALUES (55130, 805, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (55131, 805, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (55132, 805, 4, 680);
INSERT INTO 'devicecapvalue' VALUES (55133, 805, 5, 680);
INSERT INTO 'devicecapvalue' VALUES (55134, 806, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (55135, 806, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (55136, 806, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (55137, 806, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (55138, 806, 5, 4);
INSERT INTO 'devicecapvalue' VALUES (55139, 807, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (55140, 807, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (55141, 807, 6, 650);
INSERT INTO 'devicecapvalue' VALUES (55142, 807, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (55143, 807, 5, 4);
INSERT INTO 'devicecapvalue' VALUES (55144, 808, 74, 653);
INSERT INTO 'devicecapvalue' VALUES (55145, 808, 7, 688);
INSERT INTO 'devicecapvalue' VALUES (55146, 808, 173, 1688);
INSERT INTO 'devicecapvalue' VALUES (55147, 808, 2, 2);
INSERT INTO 'devicecapvalue' VALUES (55148, 808, 10, 12);
INSERT INTO 'devicecapvalue' VALUES (55149, 808, 11, 603);
INSERT INTO 'devicecapvalue' VALUES (55150, 808, 12, 106);
INSERT INTO 'devicecapvalue' VALUES (55151, 808, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (55152, 808, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (55153, 808, 150, 959);
INSERT INTO 'devicecapvalue' VALUES (55154, 808, 13, 688);
INSERT INTO 'devicecapvalue' VALUES (55155, 808, 76, 1074);
INSERT INTO 'devicecapvalue' VALUES (55156, 808, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (55157, 808, 16, 20);
INSERT INTO 'capvalue' VALUES (2630, 'VSCL-1.0');
INSERT INTO 'devicecapvalue' VALUES (55158, 808, 17, 2630);
INSERT INTO 'devicecapvalue' VALUES (55159, 808, 6, 879);
INSERT INTO 'devicecapvalue' VALUES (55160, 808, 97, 15);
INSERT INTO 'devicecapvalue' VALUES (55161, 808, 50, 659);
INSERT INTO 'devicecapvalue' VALUES (55162, 808, 155, 1157);
INSERT INTO 'devicecapvalue' VALUES (55163, 808, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (55164, 808, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (55165, 808, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (55166, 808, 231, 2060);
INSERT INTO 'devicecapvalue' VALUES (55167, 808, 156, 1035);
INSERT INTO 'devicecapvalue' VALUES (55168, 808, 4, 5);
INSERT INTO 'devicecapvalue' VALUES (55169, 808, 5, 601);
INSERT INTO 'devicecapvalue' VALUES (55170, 808, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (55171, 808, 52, 1086);
INSERT INTO 'devicecapvalue' VALUES (55172, 808, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (55173, 808, 157, 1118);
INSERT INTO 'devicecapvalue' VALUES (55174, 808, 191, 2166);
INSERT INTO 'devicecapvalue' VALUES (55175, 809, 1, 1);
INSERT INTO 'devicecapvalue' VALUES (55176, 809, 160, 856);
INSERT INTO 'devicecapvalue' VALUES (55177, 809, 162, 238);
INSERT INTO 'devicecapvalue' VALUES (55178, 809, 7, 1330);
INSERT INTO 'devicecapvalue' VALUES (55179, 809, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (55180, 809, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (55181, 809, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (55182, 809, 75, 2370);
INSERT INTO 'devicecapvalue' VALUES (55183, 809, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (55184, 809, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (55185, 809, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (55186, 809, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (55187, 809, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (55188, 809, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (55189, 809, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (55190, 809, 13, 1100);
INSERT INTO 'devicecapvalue' VALUES (55191, 809, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (55192, 809, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (55193, 809, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (55194, 809, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (55195, 809, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (55196, 809, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (55197, 809, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (55198, 809, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (55199, 809, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (55200, 809, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (55201, 809, 17, 111);
INSERT INTO 'devicecapvalue' VALUES (55202, 809, 17, 22);
INSERT INTO 'devicecapvalue' VALUES (55203, 809, 17, 25);
INSERT INTO 'devicecapvalue' VALUES (55204, 809, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (55205, 809, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (55206, 809, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (55207, 809, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (55208, 809, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (55209, 809, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (55210, 809, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (55211, 809, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (55212, 809, 88, 1003);
INSERT INTO 'devicecapvalue' VALUES (55213, 809, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (55214, 809, 256, 2360);
INSERT INTO 'devicecapvalue' VALUES (55215, 809, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (55216, 809, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (55217, 809, 4, 99);
INSERT INTO 'devicecapvalue' VALUES (55218, 809, 5, 107);
INSERT INTO 'devicecapvalue' VALUES (55219, 809, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (55220, 809, 51, 101);
INSERT INTO 'devicecapvalue' VALUES (55221, 809, 51, 2373);
INSERT INTO 'devicecapvalue' VALUES (55222, 809, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (55223, 809, 51, 1496);
INSERT INTO 'devicecapvalue' VALUES (55224, 809, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (55225, 809, 52, 1074);
INSERT INTO 'devicecapvalue' VALUES (55226, 809, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (55227, 809, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (55228, 809, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (55229, 809, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (55230, 809, 53, 2374);
INSERT INTO 'devicecapvalue' VALUES (55231, 810, 1, 106);
INSERT INTO 'devicecapvalue' VALUES (55232, 810, 160, 1080);
INSERT INTO 'devicecapvalue' VALUES (55233, 810, 162, 2399);
INSERT INTO 'devicecapvalue' VALUES (55234, 810, 189, 18);
INSERT INTO 'devicecapvalue' VALUES (55235, 810, 190, 1522);
INSERT INTO 'devicecapvalue' VALUES (55236, 810, 173, 1523);
INSERT INTO 'devicecapvalue' VALUES (55237, 810, 75, 2429);
INSERT INTO 'devicecapvalue' VALUES (55238, 810, 2, 236);
INSERT INTO 'devicecapvalue' VALUES (55239, 810, 2, 1001);
INSERT INTO 'devicecapvalue' VALUES (55240, 810, 2, 657);
INSERT INTO 'devicecapvalue' VALUES (55241, 810, 2, 1338);
INSERT INTO 'devicecapvalue' VALUES (55242, 810, 150, 956);
INSERT INTO 'devicecapvalue' VALUES (55243, 810, 150, 957);
INSERT INTO 'devicecapvalue' VALUES (55244, 810, 150, 958);
INSERT INTO 'devicecapvalue' VALUES (55245, 810, 76, 104);
INSERT INTO 'devicecapvalue' VALUES (55246, 810, 15, 16);
INSERT INTO 'devicecapvalue' VALUES (55247, 810, 15, 2371);
INSERT INTO 'devicecapvalue' VALUES (55248, 810, 15, 17);
INSERT INTO 'devicecapvalue' VALUES (55249, 810, 15, 1525);
INSERT INTO 'devicecapvalue' VALUES (55250, 810, 15, 1526);
INSERT INTO 'devicecapvalue' VALUES (55251, 810, 15, 96);
INSERT INTO 'devicecapvalue' VALUES (55252, 810, 15, 1347);
INSERT INTO 'devicecapvalue' VALUES (55253, 810, 15, 19);
INSERT INTO 'devicecapvalue' VALUES (55254, 810, 16, 20);
INSERT INTO 'devicecapvalue' VALUES (55255, 810, 17, 2510);
INSERT INTO 'devicecapvalue' VALUES (55256, 810, 6, 26);
INSERT INTO 'devicecapvalue' VALUES (55257, 810, 6, 27);
INSERT INTO 'devicecapvalue' VALUES (55258, 810, 154, 1013);
INSERT INTO 'devicecapvalue' VALUES (55259, 810, 154, 1014);
INSERT INTO 'devicecapvalue' VALUES (55260, 810, 154, 1078);
INSERT INTO 'devicecapvalue' VALUES (55261, 810, 154, 1123);
INSERT INTO 'devicecapvalue' VALUES (55262, 810, 154, 1527);
INSERT INTO 'devicecapvalue' VALUES (55263, 810, 154, 1018);
INSERT INTO 'devicecapvalue' VALUES (55264, 810, 88, 1004);
INSERT INTO 'devicecapvalue' VALUES (55265, 810, 88, 640);
INSERT INTO 'devicecapvalue' VALUES (55266, 810, 156, 2372);
INSERT INTO 'devicecapvalue' VALUES (55267, 810, 156, 1159);
INSERT INTO 'devicecapvalue' VALUES (55268, 810, 4, 679);
INSERT INTO 'devicecapvalue' VALUES (55269, 810, 5, 681);
INSERT INTO 'devicecapvalue' VALUES (55270, 810, 51, 1036);
INSERT INTO 'devicecapvalue' VALUES (55271, 810, 51, 100);
INSERT INTO 'devicecapvalue' VALUES (55272, 810, 51, 102);
INSERT INTO 'devicecapvalue' VALUES (55273, 810, 51, 2430);
INSERT INTO 'devicecapvalue' VALUES (55274, 810, 51, 1039);
INSERT INTO 'devicecapvalue' VALUES (55275, 810, 51, 1117);
INSERT INTO 'devicecapvalue' VALUES (55276, 810, 51, 669);
INSERT INTO 'devicecapvalue' VALUES (55277, 810, 52, 2431);
INSERT INTO 'devicecapvalue' VALUES (55278, 810, 157, 1087);
INSERT INTO 'devicecapvalue' VALUES (55279, 810, 157, 1134);
INSERT INTO 'devicecapvalue' VALUES (55280, 810, 157, 1026);
INSERT INTO 'devicecapvalue' VALUES (55281, 810, 157, 2432);
INSERT INTO 'devicecapvalue' VALUES (55282, 810, 157, 1504);
INSERT INTO 'devicecapvalue' VALUES (55283, 810, 157, 2404);
INSERT INTO 'devicecapvalue' VALUES (55284, 810, 157, 1160);
INSERT INTO 'devicecapvalue' VALUES (55285, 810, 191, 1372);
INSERT INTO 'devicecapvalue' VALUES (55286, 810, 53, 2433);
COMMIT;
